//IFOX$    JOB (SYS),'LOAD IFOX SRC',CLASS=S,MSGCLASS=X,COND=(0,NE)     00001000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00002000
//* This job builds the MVS 3.8j assembler (usually referred to as the  00003000
//* XF assembler) from source prepared by Paul Gorlinsky. This job:     00004000
//*                                                                     00005000
//*     1: Reloads Source/Macros to temporary datasets                  00006000
//*     2: Assembles all objects                                        00007000
//*     3: Links to target library                                      00008000
//*                                                                     00009000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00010000
//SOURCE  EXEC PGM=IEBUPDTE,REGION=1024K,PARM=NEW                       00011000
//SYSUT2   DD  DISP=(NEW,PASS),DSN=&&ISRC,                              00012000
//             UNIT=SYSDA,SPACE=(3120,(700,,2)),                        00013000
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=3120)                     00014000
//SYSPRINT DD  SYSOUT=*                                                 00015000
//SYSIN    DD  *                                                        00016000
./ ADD NAME=IFNX1A                                                      00017000
         JHEAD 'EDIT PHASE',                                           X00018000
               PHASEID=X1A,                                            X00019000
               LEVEL=10                                                 00020000
*                                                                       00021000
*FUNCTION/OPERATION-                                                    00022000
*   THIS PHASE TRANSLATES, SCANS AND EDITS SOURCE STATEMENTS, COPY      00023000
*   CODE, AND SYSTEM MACROS INTO EDITED TEXT.                           00024000
*                                                                       00025000
*   IT CALLS DIRECTORY ROUTINES, 'DRUTENT', TO BUILD MACRO NAME         00026000
*   DIRECTORY, VARIABLE SYMBOL DIRECTORIES, SEQUENCE SYMBOL DIRECTORIES 00027000
*   AND OPEN CODE ORDINARY SYMBOL DIRECTORY. ON ABNORMAL RETURN         00028000
*   FROM DIRECTORY ROUTINES, 'CONCODE' IS SET TO A NON-ZERO VALUE       00029000
*   SIGNIFYING THE TYPE OF ERROR DETECTED. THE VALUE IS THEN USED       00030000
*   TO BRANCH TO THE APPROPRIATE ERROR ROUTINE TO LOG THE ERROR.        00031000
*   (SEE DIRECTORY ROUTINE PROLOG FOR FURTHER EXPLANATION.)             00032000
*                                                                       00033000
*   INPUT CONTROL ROUTINE, 'RDSRC', IS CALLED AT APPROPRIATE TIME TO    00034000
*   BRING IN SOURCE RECORDS FROM SYSTEM INPUT, OR FROM MACRO LIBRARY    00035000
*   IF IN COPY CODE OR SYSTEM MACRO EDITING.                            00036000
*                                                                       00037000
*   'PROCNXT' ROUTINE EDITS NAME FIELD AND OPERATION FIELD, CLASSIFIES  00038000
*   THE TYPE OF THE INPUT RECORD, PREPARING TO PASS CONTROL TO THE      00039000
*   APPROPRIATE ROUTINES FOR FURTHER PROCESSING OF THE RECORD BASED     00040000
*   ON THE OPERATION CODE.                                              00041000
*                                                                       00042000
*   WHEN A MACRO PROTOTYPE RECORD IS ENCOUNTERED,  CONTROL IS           00043000
*   PASSED TO PROTOTYPE SCANNER, 'PROSCN', WHICH MAKES SYNTAX CHECKS    00044000
*   ON ALL SYMBOLIC PARAMETERS.                                         00045000
*                                                                       00046000
*   AS END OF OPERAND OR STATEMENT IS DETECTED,  'WRAPFLD' ROUTINE      00047000
*   IS CALLED TO WRAP UP THE BUILDING OF THE EDITED TEXT RECORD.        00048000
*   CONTROL IS THEN PASSED BACK TO THE CALLER IF END OF OPERAND,        00049000
*   OR IT EXITS TO 'READNEXT' IF END OF STATEMENT.                      00050000
*                                                                       00051000
*                                                                       00052000
*ENTRY POINT-                                                           00053000
*        EDITENT                                                        00054000
*                                                                       00055000
*                                                                       00056000
*INPUT-                                                                 00057000
*   SYSTEM INPUT - SOURCE STATEMENTS.                                   00058000
*                                                                       00059000
*   MACRO LIBRARY - COPY CODE AND SYSTEM MACRO DEFINITIONS.             00060000
*                                                                       00061000
*   INPUT RECORDS ARE OBTAINED THROUGH INPUT CONTROL ROUTINE IN         00062000
*   80-BYTE CARD FORMAT WITH REGISTER 'RETADR' POINTS TO THE FIRST      00063000
*   BYTE OF THE RECORD OBTAINED. THE RECORD IS THEN MOVED TO WORK       00064000
*   BUFFER FOR PROCESSING. THE ADDRESS OF THE WORK BUFFER IS SAVED      00065000
*   IN 'INPUT'.                                                         00066000
*                                                                       00067000
*                                                                       00068000
*OUTPUT-                                                                00069000
*   FILE 1 - SOURCE STATEMENT EDITED TEXT AND ASSOCIATED ERROR RECORDS, 00070000
*   AND MACRO DEFINITION EDITED TEXT AND ASSOCIATED ERROR RECORDS.      00071000
*                                                                       00072000
*   FILE 2 - TEXT SEGMENT DICTIONARY FILE FOR EACH MACRO DEFINITION.    00073000
*            TEXT SEGMENT DICTIONARY FILE FOR OPEN CODE                 00074000
*                                                                       00075000
*   FILE 3 - DEFINITION FILE AND MACRO DEFINITION DIRECTORY             00076000
*   (SEE DIRECTORY ROUTINE PROLOG FOR FURTHER DETAILS.)                 00077000
*                                                                       00078000
*                                                                       00079000
*EXTERNAL ROUTINES-                                                     00080000
*   DRUTENT - CALLED TO BUILD VARIOUS DIRECTORIES.                      00081000
*             AT ENTRY. 'DINDEX' (R9) HAS DIRECTORY ROUTINE INDEX.      00082000
*             IN THE CASE OF SYMBOL ENTRY.                              00083000
*                       'PARM' (R10) POINTS TO THE SYMBOL TO BE ENTERED 00084000
*                       OR SEARCHED, AND                                00085000
*                       'PARAM2' (R11) CONTAINS THE MOVE LENGTH OF THE  00086000
*                       SYMBOL TO BE ENTERED OR SEARCHED.               00087000
*                                                                       00088000
*              LINKAGE IS...                                            00089000
*              LA    DINDEX,XXX  WHERE XXX IS DIRECTORY ROUTINE INDEX   00090000
*              .     .     .     .                                      00091000
*              L     LINK,DENTRY                                        00092000
*              BAL   RETURN,D0(DINDEX,LINK)                             00093000
*                                                                       00094000
*   PFIXRI -  CALLED TO INITIALIZE POSTFIXER ROUTINE.                   00095000
*                                                                       00096000
*              LINKAGE IS...                                            00097000
*              L     PARAM2,ADPINIT                                     00098000
*              BALR  RETURN,PARAM2                                      00099000
*                                                                       00100000
*                                                                       00101000
*   PFIXRN -  CALLED TO PLACE ALL OPERATORS IN AN EXPRESSION INTO       00102000
*             APPROPRIATE ARRANGEMENT IN A META TEXT FIELD              00103000
*             AT ENTRY, 'PARM' (R10) CONTAINS THE OPERATOR TO BE        00104000
*                       ENTERED.                                        00105000
*                                                                       00106000
*              LINKAGE IS...                                            00107000
*              L     PARAM2,ADPSTR                                      00108000
*              BALR  RETURN,PARAM2                                      00109000
*                                                                       00110000
*                                                                       00111000
*EXITS, NORMAL-                                                         00112000
*   EXIT TO CONTROLLER WITH ZERO VALUE IN REGISTER 10.                  00113000
*                                                                       00114000
*EXITS, ERROR-                                                          00115000
*   EXIT TO CONTROLLER WITH NON-ZERO VALUE IN REGISTER 10.              00116000
*                                                                       00117000
*                                                                       00118000
*TABLE/WORK AREAS-                                                      00119000
*   INPUT/OUTPUT BUFFERS ARE DYNAMICALLY LOCATED ABOVE THE EXECUTABLE   00120000
*   CODE OF THE EDIT PHASE WITH REGISTER 'RETADR' POINTS TO THE NEXT    00121000
*   INPUT RECORD TO BE PROCESSED, OR TO THE NEXT AVAILABLE OUTPUT       00122000
*   BUFFER LOCATION AT RETURN FROM INPUT/OUTPUT CONTROL ROUTINE.        00123000
*                                                                       00124000
*   A 264-BYTE INPUT WORK BUFFER, POINTED TO BY ADDRESS CONSTANT        00125000
*   'INPUT', CONTAINS THE RECORD TO BE EDITED. THE WORK BUFFER MAY      00126000
*   CONTAIN UP TO TWO CONTINUATION CARDS WITH THEIR PRE-BEGIN(POST-END  00127000
*   STRINGS STRIPPED AND COLLECTED AT THE TAILEND PORTION OF THE WORK   00128000
*   BUFFER. ADDRESS CONSTANT 'DSTGBGN' POINTS TO THE BEGINNING OF THE   00129000
*   STRING COLLECTION AREA.                                             00130000
*                                                                       00131000
*                                                                       00132000
*ATTRIBUTES-                                                            00133000
*   REFRESHABLE                                                         00134000
*                                                                       00135000
*                                                                       00136000
*NOTES- N/A                                                             00137000
*                                                                       00138000
         SPACE 5                                                        00139000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   00140000
         COPY JCOMMON                                                   00141000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  00142000
         COPY  JERMSGCD                                                 00143000
         PRINT ON                       WE'LL PRINT THE REST            00144000
         EJECT                                                          00145000
         COPY  EDSECT                                                   00146000
         EJECT                                                          00147000
*************************                                               00148000
*   INPUT WORK BUFFER   *                                               00149000
*************************                                               00150000
INPFMT   DSECT                          ADDRESSED BY REG. 'INPTR'       00151000
         USING INPFMT,INPTR                                             00152000
INPNAME  EQU   *                        NAME FIELD                      00153000
         ORG   INPNAME                                                  00154000
INPOP    EQU   *                        OPERATION FIELD                 00155000
         ORG   INPNAME                                                  00156000
INPOPR   EQU   *                        OPERAND FIELD                   00157000
         ORG   INPNAME                                                  00158000
INPCOMM  EQU   *                        COMMENTS FIELD                  00159000
         ORG   INPNAME                                                  00160000
INPCTFLG EQU   *                        CONTINUATION FLAG               00161000
POSTEND  EQU   INPCTFLG                 POST-END STRING                 00162000
         ORG   INPNAME                                                  00163000
PREBGN   EQU   *                        PRE-BEGIN STRING                00164000
         ORG   INPNAME                                                  00165000
INPCNT   EQU   *                        CONTINUATION FIELD              00166000
ENDIPT   EQU   PREBGN+79                                                00167000
******************************                                          00168000
*   STRING COLLECTION AREA   *                                          00169000
******************************                                          00170000
STGAREA  DSECT ,                        STRING COLLECTION AREA          00171000
         USING STGAREA,DSTGPTR                                          00172000
SCCNT    EQU   *                        STRING COUNT                    00173000
         ORG   SCCNT                                                    00174000
SOPTR    EQU   *                        STRING OUTPUT LOCATION          00175000
SOLEN    EQU   SOPTR+1                  STRING LENGTH                   00176000
SDATA    EQU   SOLEN+1                  STRING                          00177000
***********************************************                         00178000
*   RSTACK-RECURSIVE STACK USED BY SCANNERS   *                         00179000
***********************************************                         00180000
DRSTK    DSECT                                                          00181000
         USING DRSTK,R14                                                00182000
BDRSTK   EQU   *                        RSTACK BEGIN                    00183000
RSTKRTN  DS    CL2                      RETURN ADDRESS                  00184000
RSTKATR  DS    X                        ATTRSV SAVED                    00185000
RSTKFLG  DS    X                        MCALL SAVED                     00186000
RSTKSTP  DS    CL4                      MTBLNDX SAVED                   00187000
RSTKVST  EQU   RSTKSTP                  FLGBYT SAVED                    00188000
EDRSTK   EQU   *                                                        00189000
***********************************************                         00190000
*   CSTK-RECURSIVE STACK USED BY INNER COPY   *                         00191000
***********************************************                         00192000
DCSTK    DSECT                                                          00193000
         USING DCSTK,PARM                                               00194000
CSTKNOTE DS    CL(L'JNOTEVAL)           NOTED ADDRESS                   00195000
CSTKSW   DS    C                        SWITCH1 SAVE AREA               00196000
CSTKMEM  DS    CL8                      NOTED MEMBER                    00197000
EDCSTK   EQU   *                                                        00198000
***********************************                                     00199000
*   EDITED TEXT RECORD FORMAT 1   *                                     00200000
***********************************                                     00201000
         USING JTEXT,INDEXO                                             00202000
         USING JTEXTA,INDEXP                                            00203000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     00204000
         COPY JTEXT                                                     00205000
         PRINT ON                       DON'T PRINT JTEXT COPY CODE     00206000
         SPACE 3                                                        00207000
******************************************                              00208000
*        PARAMETER RECORD FORMATS        *                              00209000
******************************************                              00210000
MPROTO   DSECT                                                          00211000
         USING MPROTO,INDEXP                                            00212000
HDF      DSW   MPSB,                    SUBOPERAND                     H00213000
               MPSBL,                   LAST SUBOPERAND                H00214000
               MPSBF,                   FIRST SUBOPERAND               H00215000
               OPNDPRM,                 PASSED PARAMETER               H00216000
               OPNDOMT,                 OMITTED OPERAND                H00217000
               OPNDORD,                 ORDINARY SYMBOL                H00218000
               OPNDTRM,                 SELF-DEFINING TERM             H00219000
               OPNDSTR                  CHARCTER STRING                 00220000
*   HEADER DATA AREA FORMAT                                             00221000
         ORG   HDF                      .                               00222000
MPHFLG   DS    C                        HEADER DATA FLAG                00223000
MPHP     DS    CL4                      VALUE/POINTER AREA              00224000
         ORG   MPHP                     .                               00225000
MPOSRP   DS    CL3                      ORDINARY SYMBOL REF POINTER     00226000
         ORG   MPHP                     .                               00227000
MPSDTV   DS    CL4                      SDT BINARY VALUE                00228000
         ORG                                                            00229000
MPHDL    EQU   *-MPHFLG                 *****                           00230000
         SPACE 3                                                        00231000
*   META TEXT FORMAT                                                    00232000
MPMT     DSECT                                                          00233000
         USING MPMT,R14                                                 00234000
MPMCFLG  DS    C                        CHAR STG FLAG (SEE JTMFLG)      00235000
MPMCLNG  DS    C                        CHAR STG LENGTH                 00236000
MPMCSTG  EQU   *                        CHAR STRING                     00237000
         ORG   MPMCFLG                  .                               00238000
MPVSRP   DS    CL6                      VARIABLE SYM REF PTR ETC        00239000
         ORG   MPMCFLG                  .                               00240000
MPKEYF   DS    C                        KEYWORD PARAM OPERATOR (=)      00241000
         ORG   MPMCFLG                  .                               00242000
MPEMT    DS    C                        STATEMENT TERMINATOR FLAG       00243000
         DROP  INDEXP,R14                                               00244000
         SPACE 3                                                        00245000
*******************************                                         00246000
*   META TEXT FIELD FORMATS   *                                         00247000
*******************************                                         00248000
         COPY  JTMTXT                                                   00249000
         EJECT                                                          00250000
         COPY  JERRCD                                                   00251000
JERRHL   EQU   JEDATA-JERECL                                            00252000
STACKREC DSECT                                                          00253000
LAST     DS    0H                       LAST STACK ENTRY                00254000
LASTOP   DS    C                        OPERATOR                        00255000
LASTBIND DS    C                        BINDING FACTOR                  00256000
         EJECT                                                          00257000
**********************                                                  00258000
*   SYMBOL EQUATES   *                                                  00259000
**********************                                                  00260000
*                                                                       00261000
BASE1    EQU   8                        PRIMARY BASE REGISTER           00262000
BASE2    EQU   7                        SECONDARY BASE REGISTER         00263000
BASE3    EQU   7                        THIRD BASE REGISTER             00264000
BASE4    EQU   7                                                        00265000
COMR     EQU   13                       COMMON AREA BASE REGISTER       00266000
MODCOMM  EQU   2                        MODULE COMMON AREA BASE         00267000
TRTN     EQU   0                        SCRATCH REGISTER                00268000
RCNT     EQU   0                                                        00269000
STGLOC   EQU   TRTN                     STRING LOCATION CONVEYER        00270000
TLINK    EQU   1                        LOCAL LINKAGE                   00271000
CGOTO    EQU   1                        GO-TO REGISTER                  00272000
WORK2    EQU   3                                                        00273000
GSPTR    EQU   3                                                        00274000
SLNREG   EQU   3                        SOURCE LENGTH REGISTER          00275000
BEGREG   EQU   4                        BEGIN COLUMN REGISTER           00276000
INDEXP   EQU   4                        VARIABLE PORTION O/P BUF INDEX  00277000
INDEXO   EQU   5                        FIXED PORTION O/P BUF INDEX     00278000
CNTREG   EQU   5                        CONTINUATION CHAR. COLUMN REG.  00279000
INPTR    EQU   6                        INPUT WORK BUFFER POINTER       00280000
RETURN   EQU   9                        RETURN LINKAGE REGISTER         00281000
DSTGPTR  EQU   9                        DESTINATION POINTER             00282000
SEQREG   EQU   9                        SEQ FIELD BEGIN REGISTER        00283000
DINDEX   EQU   9                        INDEX REG FOR D ENTRY ROUTINE   00284000
PARAM1   EQU   10                       PARAMETER REGISTER              00285000
PARM     EQU   PARAM1                   INDEX TO DIRECOTY ROUTINES      00286000
SQLREG   EQU   10                       SEQ FIELD LENGTH REGISTER       00287000
SRCPTR   EQU   10                       SOURCE RECORD POINTER           00288000
PARAM2   EQU   11                       PARAMETER REGISTER              00289000
RETADR   EQU   PARAM2                   TEMPORARY RETURN LINKAGE        00290000
LINK     EQU   12                       TARGET LINKAGE REGISTER         00291000
CBGREG   EQU   12                       CONT FIELD BEGIN REGISTER       00292000
SRCEND   EQU   12                       SOURCE RECORD END POS. CONVEYER 00293000
TWKREG1  EQU   14                                                       00294000
TWKREG2  EQU   15                                                       00295000
MTBLNDX  EQU   5                        MTABLE INDEX REGISTER           00296000
MTBLENT  EQU   12                       ABSOLUTE ROUTINE ADDRESS PTR    00297000
*                                                                       00298000
ALLOFF   EQU   X'00'                                                    00299000
LBITS    EQU   JF                       LENGTH BITS MASK                00300000
BNE      EQU   7                                                        00301000
BHI      EQU   2                                                        00302000
BLO      EQU   4                                                        00303000
BZ       EQU   8                                                        00304000
BEQ      EQU   8                                                        00305000
BMX      EQU   4                                                        00306000
BONE     EQU   1                                                        00307000
LICTL    EQU   66                                                       00308000
SEVENTY  EQU   70                                                       00309000
CRDLN    EQU   80                       SOURCE RECORD LENGTH            00310000
SLTLEN   EQU   3                                                        00311000
INVALV   EQU   31                                                       00312000
SPECHAR  EQU   JTBLTRT+JALFAMAX+1       SPECIAL CHARACTER START         00313000
JTBLALFA EQU   JTBLTRT+JA                                               00314000
HICHR    EQU   JPERIOD                  HIGHEST ASSEMBLER CHARACTER     00315000
XSDT     EQU   JTMSDT+0                 X TYPE SDT TYPE NUMBER          00316000
BSDT     EQU   JTMSDT+1                 B TYPE SDT TYPE NUMBER          00317000
CSDT     EQU   JTMSDT+2                 C TYPE SDT TYPE NUMBER          00318000
DSDT     EQU   JTMSDT+3                 D TYPE SDT TYPE NUMBER          00319000
DENTLNG  EQU   6                        MT TERM/POINTER LENGTH          00320000
STMASK   EQU   X'C0'                    MCALL STAUS MASK                00321000
DMCHIN   EQU   X'40'                    IOCID MASK FOR V.S.OP OCDE      00322000
XDMSLS   EQU   VTYP2+VSLS+VSNS          MASK FOR UNSUBSCRIPTED SYSLIST  00323000
RFLGLOC  EQU   (EDRSTK-BDRSTK)*2        INDEX TO 2ND LEVEL IN RSTACK    00324000
MISTGL   EQU   30                       MI STRING LENGTH  (STANDARD)    00325000
STSTGL   EQU   71                       ST STRING LENGTH  (STANDARD)    00326000
MISTGP   EQU   5+1                      MI STG POINTER LENGTH           00327000
STSTGP   EQU   5*3+1                    ST STG POINTER LENGTH           00328000
MAXCNTL  EQU   79                       1ST CARD MAX DATA AREA W/ CONT. 00329000
MAXCNT   EQU   255                                                      00330000
PRMLEN   EQU   3                        PARAMETER POINTER LENGTH        00331000
MTHDLEN  EQU   9                        MT HEADER DATA LENGTH           00332000
SZMI     EQU   562                      MI/PROTO SIZE **TEMP**          00333000
SZCNT    EQU   784                      STATEMENT W/ CONTIN    @AY11229 00334000
SZNORM   EQU   296                      STATEMENT W/O CONTINUATIONS     00335000
SZCMT    EQU   116                      COMMENTS STATEMENT SIZE         00336000
TSRCLN2  EQU   TSRCLN+2                 TRUE SSOURCE DATA LENGTH        00337000
TCNTLN2  EQU   TCNTLN+2                 TRUE CONTINUATION DATA LENGTH   00338000
RTNSV1   EQU   OCPTRSV                  RETURN POINTER SAVE AREA        00339000
RLAST    EQU   R15                                                      00340000
HIBIND   EQU   13                       UNLUCKY 13                      00341000
         EJECT                                                          00342000
*******************************                                         00343000
*   DIRECTORY ROUTINE INDEX   *                                         00344000
*******************************                                         00345000
PHASENT  EQU   0                                                        00346000
MACRENT  EQU   2                                                        00347000
MACREND  EQU   4                                                        00348000
OPENENT  EQU   6                                                        00349000
OPENEND  EQU   8                                                        00350000
VARBSYMR EQU   10                                                       00351000
SEQSYMBR EQU   12                                                       00352000
SEQSYMBD EQU   14                                                       00353000
ORDSYMBR EQU   16                                                       00354000
ORDSYMBD EQU   18                                                       00355000
VARBSYMD EQU   20                                                       00356000
OPERCODE EQU   22                                                       00357000
OPSYNBLD EQU   24                                                       00358000
         USING JTEXTA,INDEXP                                            00359000
         USING DRSTK,R14                                                00360000
         EJECT                                                          00361000
         JCSECT (X1A00=CS0)                                             00362000
* VS1 RELEASE 2 CHANGES                                                 00363000
*A883100-883120                                                 OX00217 00364000
* VS1 RELEASE 2.6 CHANGES                                               00365000
*C173100                                                        OX00224 00366000
*A457500                                                        OX00224 00367000
*A843900-843920                                                 OX00225 00368000
*C891200                                                        OX00225 00369000
*A301970-301994                                                 OX00403 00370000
*C302000                                                        OX00403 00371000
*C333400                                                        OX00404 00372000
*A674500                                                        OX00405 00373000
*A345900-345920,500100                                          OX00406 00374000
*D521600                                                        OX00406 00375000
*A847300                                                        OX00409 00376000
*C274800                                                        OX00410 00377000
*A457520-457540,459700-459740                                   OX00411 00378000
*D737600                                                        OX00081 00379000
*A741900                                                        OX00081 00380000
* VS1 RELEASE 3 CHANGES                                                 00381000
*A169700                                                        OX00095 00382000
*D170600                                                        OX00095 00383000
*C978500                                                        OX00095 00384000
*A978700-978760,979920                                          OX00095 00385000
* VS1 RELEASE 3.1 CHANGES                                               00386000
*D872600                                                        OX01771 00387000
*A835100,868900,872500-872700,875700-875760                     OX01771 00388000
*A644924                                                        OY01713 00389000
*D644960                                                        OY01713 00390000
*A131500-131560                                                 OX02266 00391000
*D847300                                                        OX02973 00392000
*A848300                                                        OX02973 00393000
*A334700-334740                                                 OX02957 00394000
*A142220-142260                                                 OX02976 00395000
*A128900-128980                                                 OX04102 00396000
*D131500-131560                                                 OX04102 00397000
*A866300,868500,868820,868920,876260-876796                     OX04106 00398000
*C876800                                                        OX04106 00399000
*D875800-876600                                                 OX04106 00400000
*C458400,558400,558600                                          OX05801 00401000
*A459620,558500,558520                                          OX05801 00402000
*A335100-335180                                                 OY04852 00403000
*C453800                                                        OY06129 00404000
*D335100-335180                                                 OY06129 00405000
*A453700,453720                                                 OY06129 00406000
* VS1 RELEASE 040 CHANGES                                               00407000
*A993620                                                       @XA04142 00408000
*A676925,676926                                                @XA05837 00409000
*A843300-843340,843820                                         @OZ01697 00410000
*A461920-461980,173150,173820-173996                           @OX06626 00411000
*C458800,460200,558400,558600                                  @OX06626 00412000
*D558500-558520                                                @OX06626 00413000
*A093700,174900                                                @OX07247 00414000
*A075700,076300,076900,077300,263900,266700,646100-646160      @OX07230 00415000
*A423100-423188                                                @OY04864 00416000
*A423700                                                       @OX07300 00417000
*C423800                                                       @OX07300 00418000
*A088500-088540                                                @OY08021 00419000
*A301954-301968                                                @OX08858 00420000
*D301970                                                       @OX08858 00421000
*A098500,299540                                                @OY08060 00422000
*A806500-806560                                                @OX07290 00423000
*A093620,093640,093720                                         @OX01364 00424000
*A829700,831900,826600,827300-827360,975685,975687             @OZ06551 00425000
*C827400,976586                                                @OZ06551 00426000
*A335100                                                       @OX10953 00427000
*D142000                                                       @AX11012 00428000
*A141820                                                       @AX11012 00429000
*C827300,975686,826050,827340,827360                           @AX12896 00430000
*A827220                                                       @AX12896 00431000
*D826700                                                       @AX12896 00432000
*C063000                                                       @AY11229 00433000
*A911620-911755,903900-903980                                  @AY11215 00434000
*C674600                                                       @AX12923 00435000
*A093660,093680                                                @AZ10910 00436000
*A071700                                                       @AY14007 00437000
*A122900                                                       @AX16038 00438000
*A559100-559140,558900,129220,879900                           @AZ13722 00439000
*C558400,558600                                                @AZ13722 00440000
*A826070,826104,826108,827240,827260                           @AY14037 00441000
*C827200,827220                                                @AY14037 00442000
*A421700,421720                                                @AX16943 00443000
*D088500-088520                                                @AY16252 00444000
*A173200                                                       @AY16256 00445000
*C173500                                                       @AY16256 00446000
*C826104                                                       @AZ19665 00447000
*A826110,826113                                                @AZ19665 00448000
*A301910                                                       @AY19080 00449000
*D838660,838720                                                @AZ24557 00450000
*C911620,911705                                                @AZ24557 00451000
*A911900-911930                                                @AZ24557 00452000
*C173820,173900,173960,173984                                  @AZ26008 00453000
*A173981                                                       @AZ26008 00454000
*C828600                                                       @AX19887 00455000
*A828700-828740                                                @AX19887 00456000
         JMODID                                                         00457000
         SPACE 3                                                        00458000
****************************                                            00459000
*   PHASE INITIALIZATION   *                                            00460000
****************************                                            00461000
EDITENT  JSAVE  BASE=NO                                                 00462000
         JENTRY (X1A01=EDITENT)                                         00463000
         BALR  BASE2,D0                 SET BASE VALUE                  00464000
         USING *,BASE2                                                  00465000
         LA    PARAM1,(ENDEDSCT-EDSCTGO+7)/8 GET EDSECT SIZE            00466000
         JGETCORE DBL=(R10)             GET CORE FOR MOD COMMON AREA    00467000
         LR    MODCOMM,PARAM1           SET UP MOD COMMON AREA BASE     00468000
         XC    VSFLG(SEQSVT+40-VSFLG),VSFLG  CLEAR EDSECT CONSTANTS     00469000
         XC    EDSCTGO(BITFF),EDSCTGO                                   00470000
         MVC   TBGLN(L'TBGLN*6),STDPARM                                 00471000
         XC    PARML,PARML              INITT AREA WITH ZEROS  @AY14007 00472000
         LA    TWKREG1,RSTACK-(EDRSTK-BDRSTK)                           00473000
         ST    TWKREG1,RAVSP            POINTER                         00474000
         LA    TWKREG1,CSTK             CSTK POINTERS INITIALIZATION    00475000
         ST    TWKREG1,NRSTK                                            00476000
         ST    TWKREG1,BCSTK                                            00477000
         ST    TWKREG1,CSTKADR                                          00478000
         LA    TWKREG1,CSTKX                                            00479000
         ST    TWKREG1,NCSTK                                            00480000
         XC    ERRCNT(D5),ERRCNT                                        00481000
         LA    TWKREG1,ERRSTK           INITIALIZE ERROR MSG            00482000
         ST    TWKREG1,AERRSTK          STACK ADDRESS AND               00483000
         ST    TWKREG1,ESTKNDX          INDEX                           00484000
         MVC   DNTERR(ENDDNTL),SEVERR   INIT DSECT TO LOG ERRORS        00485000
         MVI   DERRCD,D0                INITIALIZE ERROR CODE TO ZERO   00486000
*                                                                       00487000
         JGETCORE DBL=63                                                00488000
         ST    PARAM1,DSTGBGN           SET STRING AREA POINTER         00489000
         LA    TWKREG1,MISTGL(,PARAM1)  GET STRING AREA LENGTH          00490000
         ST    TWKREG1,MINPUT           COMPUTEMI DATA POINTER          00491000
         ST    TWKREG1,MINPSTD          AND SAVE                        00492000
         ST    TWKREG1,MINPADJ          SAVE FOR ICTL          @OX07230 00493000
         LA    TWKREG2,STSTGL(,PARAM1)  COMPUTE OTHER DATA POINTER      00494000
         ST    TWKREG2,INPUT            AND                             00495000
         ST    TWKREG2,STNPSTD              SAVE                        00496000
         ST    TWKREG2,STNPADJ          SAVE FOR ICTL          @OX07230 00497000
         SR    TWKREG2,TWKREG1          COMPUTE DIFFERENCE              00498000
         STH   TWKREG2,MINDIF           BETWEEN MINPUT AND INPUT        00499000
         STH   TWKREG2,SVMINDIF         SAVE STANDARD BUFF DIF          00500000
         STH   TWKREG2,MINDFADJ         SAVE FOR ICTL          @OX07230 00501000
         LA    PARAM2,D0(PARAM1,PARAM2)                                 00502000
         ST    PARAM2,SVENDWKA          SAVE STANDARD WORK AREA END     00503000
         ST    PARAM2,ENDWKADJ          SAVE FOR ICTL          @OX07230 00504000
         ST    PARAM2,ENDWKA            END OF DATA AREA PLUS 1         00505000
         XC    JTBLTRT(L'JTBLTRT),JTBLTRT ZERO OUT TRT TABLE            00506000
         LM    BASE2,BASE1,USEBAS                                       00507000
         USING SETBAS,BASE1                                             00508000
SETBAS   EQU   *                                                        00509000
         JEXTRN (X1J01=DRUTENT)                                         00510000
         LA    RLAST,STACK              GET ADDR OF OPERATOR STACK      00511000
         ST    RLAST,SVLAST             AND SAVE IN MOVEABLE POINTER    00512000
         ST    RLAST,ALAST              AND ALSO AS STOPPER             00513000
         USING STACKREC,RLAST                                           00514000
         MVI   LASTOP,JTMSTRM           PUT EXPRESSION TERMINATOR WITH  00515000
         MVI   LASTBIND,HIBIND          BINDING FACTOR INTO STACK       00516000
         DROP  RLAST                                                    00517000
         SET   SFSTCD,ON                INDICATE FIRST CARD             00518000
         SET   SPGRMD,ON                INDICATE PROC'G PRG'R MACRO     00519000
         B     READNEXT                 GO TO READ NEXT STATEMENT       00520000
         USING IFNX1A30,BASE4                                           00521000
SEVERR   EQU   *                        MOVED TO COMMON FOR X1J ERRORS  00522000
         BAL   TLINK,NSNAPERR           LOG ERROR WITH SNAP SHOT        00523000
         DC    AL2(2)                   PADDING TO CALCULATE RETURN     00524000
         DC    AL1(SEV0)                SEVERITY CODE                   00525000
         DC    AL1(ERR0)                ERROR CODE                      00526000
         BR    RETURN                   RETURN TO CALLER                00527000
         USING CS2,BASE2                                                00528000
USEBAS   DC    A(CS2,SETBAS)                                            00529000
STDPARM  DC    A(0,71,56,0-1,8)         STANDARD ICTL PARAMS            00530000
F70      DC    A(70)                    COLUMN 71 DISPLACEMENT          00531000
         EJECT                                                          00532000
*********************************************************************** 00533000
*   READNEXT ROUTINE IS ENTERED EACH TIME A NEW STATEMENT IS TO BE      00534000
*   READ. ITS FUNCTION IS TO PROVIDE A LINKAGE TO INPUT CONTROL         00535000
*   ROUTINE.                                                            00536000
*********************************************************************** 00537000
READNEXT L     LINK,ARDSRC              POINT TO RDSRC                  00538000
         BALR  RETURN,LINK              LINK TO READ SOURCE ROUTINE     00539000
         DC    AL2(RFSTCRD-RFSTCRD)     READ FIRST CARD OF STATEMENT    00540000
         SET  SMISCN,OFF     RESET NO V.T. OUTPUT SWITCH                00541000
         GOIF  SINEOF,OFF=PROCIN        PROCEED IF NOT END OF FILE      00542000
         GOIF  SFSTCD,OFF=EOFRTN                                        00543000
NODATA   EQU   *                                                        00544000
         MVI   DDNDX1,PHASENT           SET UP INDEX FOR BR TO DIR RTN  00545000
         BAL   R3,DIR10                 ISSUE MESSAGES                  00546000
         L     BASE4,CS4ADDR            CHANGE BASE FOR CSECT 4         00547000
         L     LINK,APGRMAC             GET ADDR OF PGRMAC              00548000
         BR    LINK                     BR TO CLOSE FILES               00549000
PROCIN0  XC    JTRLI,JTRLI              CANCEL REC W/NO V.T.            00550000
PROCIN   EQU   *                                                        00551000
         BAL   RETURN,PUTLSIZ           GET O/P BUFFER                  00552000
         BAL   RETURN,HDINIT            INITIALIZE HEADER               00553000
         GOIF SMISCN,ON=PNXT12         GO PUT OUT PR ONLY RECORD        00554000
         EJECT                                                          00555000
*********************************************************************** 00556000
*   PROCNXT ROUTINE IS ENTERED EACH TIME A NEW STATEMENT IN THE         00557000
*   INPUT WORK BUFFER IS TO BE EDITED. IT CALLS GSCAN TO EDIT NAME      00558000
*   AND OPERATION FIELDS INTO OUTPUT BUFFER. IT THEN FANS OUT TO        00559000
*   OPERAND PROCESSORS BASED ON THE TYPES OF OPERATION CODE.            00560000
*   (THERE ARE THREE DISTINCTIVE GROUPINGS OF OPERATION CODES. THEY     00561000
*   ARE PROTOTYPE, MACRO INSTRUCTIONS, AND MACHINE/ASSEMBLER OPERATION  00562000
*   CODES.) COMMENTS STATEMENTS ARE EDITED AS COMMENTS FIELD IN         00563000
*   ASSEMBLER OP STATEMENTS.                                            00564000
*********************************************************************** 00565000
         SPACE 3                                                        00566000
PROCNXT  EQU   *                                                        00567000
PROCN01  EQU   *                                               @OY08021 00568000
         CLI   INPNAME,JBLANK           TEST IF THERE IS NAME FIELD     00569000
         BNE   PROCN10                  YES, THERE IS A NAME            00570000
PROCN02  EQU   *                                                        00571000
         BAL   TLINK,SKPBLK             GO FIND OP CODE                 00572000
         GOIF  SFSTCD,OFF=PNXT299       BR IF NOT FIRST CARD            00573000
PROCN05  EQU   *                                                        00574000
         GOIF  SNOFND,ON=NOICTL         BR IF OP CODE NOT FOUND         00575000
         CLC   D0(L'ICTLX,INPTR),ICTLX  TEST IF ICTL STATEMENT          00576000
         BNE   NOICTL                   BRANCH IF NOT ICTL              00577000
         GOIF  SNMFND,OFF=PROCN07       PROC ICTL IF NO NAME            00578000
         BAL   RETURN,NAMERR            NAME DISALLOWED ON ICTL         00579000
         B     PROCN07                  CONT TO PROCESS ICTL OPERAND    00580000
NOICTL   GOIF  SNMFND,ON=PNXT299        BR IF OP CODE NOT ICTL ON 1ST   00581000
         B     PNXT29                   NO NAME ON FIRST CARD, NON-ICTL 00582000
PROCN07  EQU   *                                                        00583000
         LA    INPTR,L'ICTLX(,INPTR)    BUMP OVER ICTL                  00584000
         ST    INPTR,FPTRSV             DUMMY UP SCAN RESULTS           00585000
         ST    INDEXP,OFPTRSV                                           00586000
         MVI   IOCID,IOCTYP+BIT1                                        00587000
         MVI   OCSAVE,JTICTL                                            00588000
         SET   JPSOP,ON                                                 00589000
         SET   SICTL,ON                 INDICATE ICTL STATEMENT         00590000
         B     TBLOPS                   GO PROCESS OPERAND              00591000
ICTLX    DS    0CL5                                                     00592000
         DC    AL1(JI,JC,JT,JL,JBLANK)  INTERNAL ICTL OP                00593000
         DS    0H                                                       00594000
PROCN10  EQU   *                                                        00595000
         CLI   INPNAME,JASTER           COMMENTS QUERY         @OX10364 00596000
         BE    PROCN15                  BR IF COMMENT CARD     @OX10364 00597000
         CLC   DOTSTAR,INPNAME          HIDENT COMMENT QUERY   @AZ10910 00598000
         BE    PROCN15                  BR IF SO               @AZ10910 00599000
         GOIF  SXMCRO,ON=SSEQ46         BR IF ERR IFO085       @OX07247 00600000
PROCN15  EQU   *                                               @OX10364 00601000
         GOIF  SFSTCD,OFF=PROCN20                                       00602000
         MVI   DDNDX1,PHASENT           SET UP INDEX FOR BR TO DIR RTN  00603000
         BAL   R3,DIR10                 INITIALIZE DIRECTORIES          00604000
PROCN20  EQU   *                                                        00605000
         CLI   INPNAME,JASTER           COULD IT BE COMMENTS STMT       00606000
         BE    PNXT11                   BRANCH IF YES                   00607000
         CLC   INPNAME(L'DOTSTAR),DOTSTAR                               00608000
         BNE   PNXT20                   BRANCH IF NOT COMMENTS AT ALL   00609000
         EJECT                                                          00610000
*****************************************                               00611000
*        EDIT COMMENTS STATEMENT        *                               00612000
*****************************************                               00613000
PNXT10   EQU   *                                                        00614000
         MVI   OCSAVE,JTHCMNT           VIRTUAL TEXT SUPPRESSION CTRL   00615000
         SET   SDTCMT,ON                INDICATE '.*' TYPE COMMENTS     00616000
         B     PNXT13                   BYPASS NEXT                     00617000
PNXT12   SET   SMISCN,OFF               RESET NO V.T. OUTPUT SWITCH     00618000
PNXT11   SET   STRCMT,ON                INDICATE '*' TYPE COMMENTS      00619000
         MVI   OCSAVE,JTCMNT            VIRTUAL TEXT SUPPRESSION CTRL   00620000
PNXT13   EQU   *                                                        00621000
         L     INPTR,ENDATA                                             00622000
         L     LINK,ARDSRC05            POINT TO RDSRC05                00623000
         BALR  RETURN,LINK              READ ALL CONTINUATIONS          00624000
         DC    AL2(RALLCNT-RFSTCRD)     READ ALL VALID CONTINUATIONS    00625000
         L     INPTR,INPUT                                              00626000
PNXT15   EQU   *                                               @OY08060 00627000
         MVC   JTFLGA(D4),PUTFLG        INSERT COMMENTS FLAGS AND IOC   00628000
         GOIF  SXPRTO,ON=BADPRTO        LOG ERROR IF EXPECTING PROTO    00629000
         CLI   OCSAVE,JTHCMNT           TEST IF .* TYPE COMMENT         00630000
         BNE   WRAPFLD                  BRANCH IF NOT                   00631000
         MVI   JTIOP1,JTHCMNT           INDICATE HIDDEN COMMENTS        00632000
         SET   JPRONLY,OFF              .* TYPE CMNT, RESET PRINT ONLY  00633000
         B     WRAPFLD                 CONTINUE                FX0000   00634000
         EJECT                                                          00635000
PNXT20   EQU   *                                                        00636000
         SET   SNMFND,ON                INDICATE NAME FOUND             00637000
         SET   SENAME,ON                                                00638000
         SET   SKPNAME,ON               INDICATE SKIPPING NAME FIELD    00639000
         BAL   RETURN,GSCAN             SKIP NAME FIELD                 00640000
         SET   SKPNAME,OFF                                              00641000
         SET   SENAME,OFF                                               00642000
         B     PROCN02                  1ST CD HAS NAME, CK IF ICTL     00643000
         SPACE 3                                                        00644000
PNXT29   EQU   *                                                        00645000
         MVI   DDNDX1,PHASENT           SET UP INDEX FOR BR TO DIR RTN  00646000
         BAL   R3,DIR10                 INITIALIZE DIRECTORIES          00647000
         SPACE 3                                                        00648000
PNXT299  EQU   *                                                        00649000
         CLI   INPOP,JAMPER             IS OP CODE FIELD A V. S.        00650000
         BNE   PNXT30                   BR IF NOT VARIABLE SYMBOL       00651000
         GOIF  SPGRMD,OFF=PNXT30        BR IF NOT IN PRGR MACS          00652000
         GOIF  SMDEF,ON=PNXT30          BR IF IN MACRO DEF              00653000
         MVI   DDNDX1,OPENENT           SET TO INITIALIZE OPEN CODE     00654000
         BAL   R3,DIR10                 GO DO IT                        00655000
         SET   (SPGRMD,SOPNCD),FLIP     OUT OF PRGMR MACS, NOW OPEN CD  00656000
         EJECT                                                          00657000
*****************************************                               00658000
*        PROCESS OPERATION FIELD        *                               00659000
*****************************************                               00660000
PNXT30   EQU   *                                                        00661000
         SET   SEOPCD,ON                INDICATE EDITING OP CODE        00662000
         GOIF  SNOFND,ON=NOPCD          OP FIELD NOT FOUND, LOG ERROR   00663000
         BAL   RETURN,GSCAN             SCAN OPERATION FIELD            00664000
         LCR   TWKREG1,INDEXO           GET OUTPUT ABSOLUTE ADDRESS     00665000
         A     TWKREG1,OFPTRSV          COMPUTE RELATIVE ADDRESS        00666000
         STH   TWKREG1,JTOCP            INSERT OP CODE FIELD REL ADDR   00667000
         ST    INPTR,OPNDPTR            REMEMBER WHERE TO COME BACK     00668000
         C     R1,ENDATA                OP CODE MUST BE FOLLOWED BY BLK 00669000
         BNL   INVOP                    BR FOR ERROR IF NOT             00670000
         GOIF  (ROSYM,RVSYM),NONE=INVOP LOG ERROR IF INVALID            00671000
         GOIF  RVSYM,ON=PUTOC10         BRANCH IF OP CODE A V.S.        00672000
         TM    DERRCD,BITFF             TEST IF ERROR FOUND IN D RTN    00673000
         BZ    PUTOC20                  BRANCH IF NOT                   00674000
         MVI   OCSAVE,INVALV            ELSE, DUMMY UP INTERNAL OP      00675000
         SET   JPRONLY,ON               AND INDICATE PRINTONLY          00676000
         B     PUTOC40                  EDIT AS MACHINE OP              00677000
PUTOC10  EQU   *                                                        00678000
         MVI   IOCID,DMCHIN             DUMMY UP OP CODE ID AND         00679000
         B     PUTOC40                  EDIT AS MACHINE OP              00680000
PUTOC20  EQU   *                                                        00681000
         TM    IOCID,BIT0+BIT1          TEST IF MACRO CALL/PROTO        00682000
         BNZ   PUTOC25                  BRANCH IF NOT                   00683000
         SET   PROTOCAL,ON              ELSE, SO INDICATE               00684000
         B     PUTOC40                  AND BRANCH                      00685000
PUTOC25  EQU   *                                                        00686000
         L     PARAM2,OCPTRSV           RESTORE IOC POINTER             00687000
         MVC   JTFLGA,D0(PARAM2)        INSERT FLAGA BYTE FOR OP CODE   00688000
         IC    PARM,D1(,PARAM2)         PICK UP OP CODE BYTE ONE        00689000
         SLL   PARM,D8                  SHIFT TO 3RD BYTE IN PARM       00690000
         BM    PUTOC30                  BRANCH IF 1 BYTE OPCODE         00691000
         IC    PARM,D2(,PARAM2)         PICK UP OP CODE BYTE TWO        00692000
PUTOC30  EQU   *                                                        00693000
PUTOC35  EQU   *                                                        00694000
         STH   PARM,JTIOP               INSERT INTO E.T.                00695000
         GOIF  SXPRTO,OFF=PUTOC40       CAN'T BE PROTOTYPE IF HERE      00696000
         L     INPTR,INPUT              BACK UP TO BEGINNING OF FIELD   00697000
         BAL   RETURN,RESETPTR          RESET TEXT POINTERS             00698000
         B     BDPTO                    NOW, GO LOG ERROR               00699000
PUTOC40  EQU   *                                                        00700000
         SET   SEOPCD,OFF                                               00701000
         GOIF  SNMFND,ON=PNAME          EDIT NAME IF FOUND ONE          00702000
         MVI   GSUMRY,D0                ZERO OUT OP CODE FLAGS          00703000
         B     TBLOPS                   ELSE, EDIT OPERAND              00704000
         EJECT                                                          00705000
************************************                                    00706000
*        PROCESS NAME FIELD        *                                    00707000
************************************                                    00708000
PNAME    EQU   *                                                        00709000
         L     INPTR,INPUT              BACK TO EDIT NAME FIELD         00710000
         GOIF  (SKPMND,SKPEND),ANY=PNAME1    BYPASS NAME PROC ON ABORT  00711000
         SET   SENAME,ON                INDICATE EDITING NAME FIELD     00712000
         BAL   RETURN,GSCAN             YES, SCAN NAME FIELD            00713000
         ST    R15,NAML1                SAVE NAME FIELD LENGTH          00714000
         MVC   VSTAT(L'FLGBYT),FLGBYT   SAVE NAME FIELD V.S. STATUS     00715000
         LCR   TWKREG1,INDEXO           COMPUTE NAME FIELD POINTER      00716000
         A     TWKREG1,OFPTRSV                                          00717000
         STH   TWKREG1,JTNMP            AND ENTER IT                    00718000
         MVC   NAMBYT,GSUMRY            SAVE NAME STATUS IN CASE SS     00719000
         L     INPTR,OPNDPTR            RESTORE OPERAND POINTER         00720000
PNAME1   EQU   *                                                        00721000
         ST    INPTR,FPTRSV             AND SAVE                        00722000
         SET   SENAME,OFF                                               00723000
         B     TBLOPS                   GO EDIT OPERAND FIELD           00724000
         EJECT                                                          00725000
*********************************************************************** 00726000
*   MACINST ROUTINE IS ENTERED WHEN A 'MACRO INSTRUCTION' OR A PROTO-   00727000
*   TYPE STATEMENT IS ENCOUNTERED. (ANY OP CODE THAT CAN NOT BE FOUND   00728000
*   IN THE OP CODE TABLE IS ASSUMED A 'MACRO INSTRUCTION'.) THIS        00729000
*   ROUTINE IS ALSO CALLED BY THE PROTOTYPE SCANNER TO PROCESS KEYWORD  00730000
*   PARAMETER WITH A NORMAL VALUE. IT MAKES SYNTACTICAL SCANNING OF     00731000
*   OPERAND FIELDS, BUILDS EDITED TEXT RECORDS, OBTAINS THE NOTE/POINT  00732000
*   DATA OF THE ASSOCIATED MACRO DEFINITION EDITED TEXT, MAKES MACRO    00733000
*   NAME ENTRIES INTO MACRO NAME TABLE IS NOT PREVIOUSLY ENTERED,       00734000
*   AND MAKES OPERAND ENTRIES INTO ORDINARY SYMBOL REFERENCE DIRECTORY. 00735000
*********************************************************************** 00736000
         SPACE 3                                                        00737000
MACINST  EQU   *                                                        00738000
         SET   SEOPCD,OFF                                               00739000
         SET   SEOPND,ON                                                00740000
         MVI   GSUMRY,D0                ZERO OUT OP CODE FLAGS          00741000
         BAL   RETURN,STMTDSQ           STATEMENT SEQUENCING            00742000
         SET   JPSOP,ON                 INDICATE ASSEMBLER OP           00743000
         LA    R0,D1                    SET COLCTR AND CRDCTR           00744000
         ST    R0,COLCTR                TO 0 AND 1 RESPECTIVELY         00745000
         MVC   DTLENG(L'DTLENG),TSRCLN2 SET DATA LENGTH                 00746000
         XC    PRNLVL,PRNLVL            RESET PAREN LEVEL COUNT TO ZERO 00747000
         MVI   SWITCH6,D0               RESET SWITCHES                  00748000
         L     LINK,AMIPRTO             GET LINKAGE                     00749000
         BALR  RETURN,LINK              EDIT PROTO/M CALL               00750000
         SET   SMI,OFF                  SET OFF MI SWITCH               00751000
         SET   SEOPND,OFF                                               00752000
         SET   SMISCN,OFF               RESET NO V.T. SW.      @AX16038 00753000
         NI    JHWORD2+1,BITFF-(DMIENT) RESET SECOND DMIENT SW @AZ13722 00754000
         B     WRAPCNT                  THEN EXIT                       00755000
AMIPRTO  DC    A(MIPRTOIN)              ADDRESS OF MIPRTOIN             00756000
H1       DC    H'1'                     .                               00757000
H2       DC    H'2'                     .                               00758000
H3       DC    H'3'                     .                               00759000
H6       DC    H'6'                     .                               00760000
         DS    0F                                                       00761000
F7       DC    H'0'                     .                               00762000
H7       DC    H'7'                     .                               00763000
H63      DC    H'63'                    STD DBLE-WORD SIZE OF WORK AREA 00764000
H8       DC    H'8'                     .                               00765000
H10      DC    H'10'                    .                               00766000
H255     DC    H'255'                   .                               00767000
         EJECT                                                          00768000
*********************************************************************** 00769000
*   WRAPFLD ROUTINE IS ENTERED TO WRAP UP THE EDITING OF A STATEMENT    00770000
*   OR OPERAND WHEN END OF STATEMENT OR OPERAND IS REACHED. IT EDITS    00771000
*   COMMENTS FIELD, COMPUTES EDITED TEXT RECORD LENGTH, AND, IF NOT     00772000
*   SUPPRESSED, MAKES THE REMAINING DIRECTORY ENTRIES.                  00773000
*   CARDS, WITHIN A STATEMENT THAT ARE TO BE FLUSHED ARE FLUSHED, AND   00774000
*   ERROR RECORD BUILT FOR THE STATEMENT IS OUTPUT.                     00775000
*********************************************************************** 00776000
         SPACE 3                                                        00777000
WPOPND   EQU   *                                                        00778000
         MVI   D0(INDEXP),JBLANK        INSERT A BLANK FOR ASS SCANNER  00779000
         LA    INDEXP,D1(,INDEXP)       WHICH IS NOT INCLUDED IN THE   X00780000
                                        LENGTH COUNT IN JTOCP           00781000
WRAPFLD  EQU   *                                                        00782000
         L     RCNT,INPUT               BEGIN OF FIELD                  00783000
WRAPF1   EQU   *                                                        00784000
         TM    SWITCH4,(SPGRMD+SOPNCD)  IF PGMMAC OR OPEN CODE  OX04102 00785000
         BZ    EDTSTG1                  IF NOT- BRANCH          OX04102 00786000
         GOIF  SINCPY,ON=EDTSTG1        FLAG IS OFF THEN CHK    OX04102 00787000
         SET   JPRGICTL,ON              FOR COPY. USE PGM ICTL  OX04102 00788000
EDTSTG1  EQU   *                                                OX04102 00789000
         BAL   TLINK,SKPBLK             GO FIND COMMENTS FIELD          00790000
         GOIF  SNOFND,ON=EDTSTG         NO COMMENTS                     00791000
         ST    INPTR,FPTRSV             SAVE INPTR                      00792000
EDTCMT   EQU   *                        COMMENTS FIELD FOUND            00793000
         L     TWKREG2,ENDATA           UPPER LIMIT OF SCAN             00794000
EDTCMT1  EQU   *                                                        00795000
         BCTR  TWKREG2,0                ELIMINATE BLANKS FROM LAST COL. 00796000
         CLI   D0(TWKREG2),JBLANK       TO FIND END OF COMMENTS FIELD   00797000
         BE    EDTCMT1                  LOOP TO END OF COMMENTS         00798000
         LA    INPTR,D1(,TWKREG2)       SIMULATE SCAN RESULTS           00799000
         LCR   TWKREG1,INDEXO           COMPUTE RELATIVE ADDRESS OF     00800000
         AR    TWKREG1,INDEXP           COMMENTS FIELD IN TEXT          00801000
         STH   TWKREG1,JTCPR            STORE IN COMMENTS POINTER       00802000
         ST    BASE2,JFWORD2            SAVE CS3 BASE                   00803000
         L     BASE2,USEBAS             LOAD CS2 BASE                   00804000
         BAL   R12,VTPUT                EDIT COMMENTS FIELD             00805000
         L     BASE2,JFWORD2            RESTORE PREVIOUS BASE           00806000
EDTSTG   EQU   *                                                        00807000
         L     GSPTR,DSTGBGN            POINT TO BEGIN OF STRING AREA   00808000
         CLI   D0(GSPTR),D0             TEST IF NO STRING               00809000
         BE    EDTLEN                   BRANCH IF NO STRING             00810000
         LCR   TWKREG1,INDEXO           COMPUTE RELATIVE ADDRESS OF     00811000
         AR    TWKREG1,INDEXP           STRING FIELD                    00812000
         STH   TWKREG1,JTSPR            AND ENTER IT IN E.T.            00813000
         L     DSTGPTR,DSTGNDX          POINT TO END OF STRING AREA     00814000
         MVI   SCCNT,D0                 INDICATE END OF STRING          00815000
         SR    DSTGPTR,GSPTR            COMPUTE STRING AREA MOVE LENGTH 00816000
         BCTR  INDEXP,0                 BACK UP JTEXTA PTR              00817000
         EX    DSTGPTR,ETMOV            MOVE STRING TO TEXT             00818000
         LA    INDEXP,D2(DSTGPTR,INDEXP) BUMP POINTER                   00819000
*                                                                       00820000
EDTLEN   EQU   *                                                        00821000
         LR    TWKREG1,INDEXP           COMPUTE O/P TEXT LENGTH         00822000
         SR    TWKREG1,INDEXO                                           00823000
         STH   TWKREG1,JTRLI            STORE TRUE LENGTH IN TEXT       00824000
*        TO MAKE DEFINITION DIRECTORY ENTRY                             00825000
         CLI   SDENTR,D0                TEST IF TO MAKE DIR ENTRY       00826000
         BE    EDTLEN3                  NO                              00827000
         GOIF SMISCN,OFF=EDTLEN2        GO PUT OUT DIR ENTRY            00828000
         CLI   ERRCNT1,D0               NO V.T. TO BE OUTPUTTED SO      00829000
         BNE   WRRTN                     IF ERRORS, THEN NO DIR ENTRY   00830000
EDTLEN2  EQU   *                                                        00831000
         MVC   DDNDX1(D1),SDENTR        EST INDEX FOR BR INTO DIR RTN   00832000
         LM    PARM,PARAM2,NAMP         GET POINTERS                    00833000
         BAL   R3,DIRENT                MAKE D ENTRY                    00834000
         MVI   SDENTR,D0                SET OFF DEFINITION D-ENTRY SW   00835000
EDTLEN3  CLI   SDENTR1,D0               CHECK IF WXTRN/EXTRN OPERAND    00836000
         BE    WRRTN                    NO, THEN NO DIR ENTRY REQ       00837000
         MVC   DDNDX1(D1),SDENTR1       GET DIR ENTRY INDEX             00838000
         L     PARM,NAMP1               GET PTR TO OPERAND              00839000
         BAL   R3,DIRENT                GO MAKE O/SYMBOL DEFINITION     00840000
         MVI   SDENTR1,D0               CLEAR DIR INDEX BYTE            00841000
*                                                                       00842000
WRRTN    EQU   *                                                        00843000
         GOIF  SCTLRTN,ON=WRETURN       RETURN IF SO INDICATED          00844000
*                                                                       00845000
*                                                                       00846000
WRAPCNT  EQU   *                                                        00847000
         BAL   RETURN,WRAPERR           WRITE ERROR RECORD              00848000
         GOIF  SPRVCT,OFF=WREXIT        EXIT IF NO MORE CONT'N CARDS    00849000
         GOIF  SINEOF,ON=UNXPEOF        LOG ERROR IF END OF FILE        00850000
         LA    R11,SZCMT                GET BUFFER SIZE                 00851000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  00852000
         L     LINK,ARDSRC              POINT TO RDSRC                  00853000
         BALR  RETURN,LINK              BYPASS ALL CONTINUATION CARDS   00854000
         DC    AL2(RBYPCNT-RFSTCRD)     BYPASS ONE CONTINUATION CARD    00855000
         GOIF  SINEOF,ON=UNXPEOF        LOG ERROR IF END OF FILE        00856000
         MVC   JTRLI(L'FXDHD),FXDHD     MOVE IN FIXED HEAD              00857000
         LA    INDEXP,D2(,INDEXP)       AND POINT OVER DUMMY FIELD      00858000
         SET   JNOCNT,ON                DO NOT ASSIGN STATEMENT NUMBER  00859000
         B     WRAPFLD                  GO PROCESS CONTINUED STATEMENT  00860000
*                                                                       00861000
WRAPERR  EQU   *                                                        00862000
         CLI   ERRCNT1,D0               TEST IF THERE ARE ERRORS        00863000
         BCR   BEQ,RETURN               RETURN IF NO                    00864000
         L     INDEXO,OUTADR            SET BASE               @AX11012 00865000
         GOIF SMISCN,ON=PROCIN0         PR ONLY RECORD TO BE FORCED     00866000
         SET   JERR,ON                  ELSE, INDIACTE MSG FOLLOWS      00867000
         CLI   JTIOP,JTEND              CHECK FOR GEN END       OX02976 00868000
         BNE   WRAPERR1                                         OX02976 00869000
         SET   (JDEF,JREF),ON                                   OX02976 00870000
WRAPERR1 EQU   *                                                        00871000
         ST    RETURN,EDTSVZ                                            00872000
         L     R4,AERRSTK               SET ADDRESSABILITY              00873000
         ST    R4,ESTKNDX               RESET INDEX                     00874000
         USING ERRMESS,R4                                               00875000
         LH    R3,ERRCNT                                                00876000
WERRLP   SR    R5,R5                                                    00877000
         IC    R5,ENTRYLNG              PICK UP ENTRY LENGTH            00878000
         LA    R11,JERRHL(R5)           COMPUTE LENGTH                  00879000
         JPUTL FILE=FILE1,BUFREQ=(R11)  GET O/P BUFFER                  00880000
         USING JERRCD,R11                                               00881000
         MVC   JEFLGA(L'ERRHDR),ERRHDR  MOVE HEADER                     00882000
         LA    R10,JERRHL(,R5)          COMPUTE RECORD LENGTH           00883000
         STH   R10,JERECL                                               00884000
         LA    R5,EMSGHL(,R5)                                           00885000
         EX    R5,MVERR                 MOVE MSG ENTRIES                00886000
         LA    R4,ERMEND(,R4)           BUMP DSECT BASE TO NEXT ERR MSG 00887000
         BCT   R3,WERRLP                DUMP NEXT ERROR MSG             00888000
         STH   R3,ERRCNT                CLEAR ERROR COUNT               00889000
         MVI   ERRSTK+2,D0                                              00890000
         L     RETURN,EDTSVZ                                            00891000
         BR    RETURN                   RETURN TO CALLER                00892000
MVERR    MVC   JESEV(0),EMSGSVTY        OFF-THE-LINE MOVE               00893000
         DROP  R4,R11                                                   00894000
         USING JTEXTA,INDEXP                                            00895000
ERRHDR   DS    0CL6                     ERROR RECORD HEADER             00896000
         DC    AL1(JPSOP)               ASSEMBLER OP                    00897000
         DC    AL1(JNOCNT)              DON'T COUNT STMT NUMBER         00898000
         DC    AL1(JTERROR)             INTERNAL OP                     00899000
         DC    AL1(0,0,0)               .                               00900000
EERRHDR  EQU   *                                                        00901000
         DS    0H                                                       00902000
         SPACE                                                          00903000
WREXIT   SET   (SFSTCD,SUPDNT),OFF      RESET SWITCHES                  00904000
         SET   (SNMFND,SNOFND,SDTCMT,STRCMT),OFF                        00905000
         SET   (SBYCNT,SBYONE),OFF      RESET SWITCHES                  00906000
         GOIF  SNOPND,OFF=READNEXT      BRANCH IF NO RETURN             00907000
         SPACE                                                          00908000
WRETURN  SET   (SNOPND,SCTLRTN),OFF                                     00909000
         L     RETURN,RTNSV             RESTORE RETURN POINT            00910000
         BR    RETURN                   RETURN TO CALLER                00911000
         EJECT                                                          00912000
         USING DCSTK,PARM                                               00913000
NOPCD    EQU   *                                                        00914000
         GOIF  SXMCRO,ON=SSEQ46         CLOSE M DEF IF EXP MAC  OX00095 00915000
         L     INPTR,INPUT              BACK UP TO BEGIN OF FIELD       00916000
         BAL   TLINK,ABSERR             OP CODE NOT FOUND IN 1ST CARD   00917000
         DC    AL1(SEV53)               .                               00918000
         DC    AL1(ERR53)               OP CODE NOT FOUND IN 1ST CARD   00919000
         B     WRAPFLD                  WRAP UP STMT                    00920000
RENTFULL EQU   *                                                        00921000
         BAL   TLINK,ABSERR             RSTACK FULL                     00922000
         DC    AL1(5*16+SEV46)          CLEANUP                         00923000
         DC    AL1(ERR46)               STMT COMPLEXITY EXCEEDED        00924000
ILGVS    EQU   *                                                        00925000
         L     INPTR,TPSAVE             BACK TO BEGIN OF FIELD FOR SNAP 00926000
         LA    R15,D1(,R15)             INCREASE LENGTH FOR &           00927000
         LR    R0,R1                    SAVE LENGTH                     00928000
         BAL   TLINK,SNAPERR            TAKE A SNAP SHOT                00929000
         DC    AL2(2)                   .                               00930000
         DC    AL1(4*16+SEV39)          CLN0                            00931000
         DC    AL1(ERR39)               TRY TO CONTINUE EDITING         00932000
INVSUBS  EQU   *                                                        00933000
         L     INPTR,TPSAVE1            BACK TO BEG OF SNAPFIEL OX00224 00934000
         BCTR  INPTR,D0                 BEGIN SNAP WITH LEFT PAREN      00935000
         GOIF  DMIENT,ON=INVSUBS1       ERROR FROM MI          @OX06626 00936000
         LR    R0,R1                    SAVE R1                @OY16256 00937000
         BAL   TLINK,SNAPERRL           TAKE A SNAP SHOT                00938000
         DC    AL2(2)                   .                               00939000
         DC    AL1(4*16+SEV37)                                 @OY16256 00940000
         DC    AL1(ERR37)               SUBSCRIPT ERROR                 00941000
INVSUBS1 GOIF  SUBLST,ON=INVSUBS2       BR IF ERROR IN SUBLIST @OZ26008 00942000
         LR    R0,R1                    SAVE R1                @OZ26008 00943000
         BAL   TLINK,SNAPERRL           TAKE A SNAPSHOT...     @OX06626 00944000
         DC    AL2(2)                   AND RETURN TO CLN0...  @OX06626 00945000
         DC    AL1(4*16+SEV37)          AFTER LOGGING...       @OZ26008 00946000
         DC    AL1(ERR37)               SUBSCRIPT ERROR        @OX06626 00947000
INVSUBS2 L     BASE3,AMIPRTO            RESTORE BASE REG       @OZ26008 00948000
         BAL   TLINK,SNAPERRL             SUBSCRIPT ERROR      @OZ26008 00949000
         DC    AL2(2)                                          @OX06626 00950000
         DC    AL1(10*16+SEV37)                                @OX06626 00951000
         DC    AL1(ERR37)                                      @OX06626 00952000
BADPRTO  EQU   *                                                        00953000
         BAL   TLINK,ABSERR             COMMENTS STMT FOUND             00954000
         DC    AL1(6*16+SEV87)          WHILE                           00955000
         DC    AL1(ERR87)               EXPECTING PROTOTYPE             00956000
INVOP    EQU    *                                                       00957000
         GOIF  SXMCRO,ON=SSEQ46         BR IF ERR IFO085       @OX07247 00958000
         L     INPTR,INPUT              GET END OF SCAN POINT           00959000
         BAL   RETURN,RESETPTR          RESET POINTERS                  00960000
         GOIF  SXPRTO,ON=BDPTO          BRANCH IF EXPECTING PROTO       00961000
         BAL   TLINK,ABSERR             LOG HARD ERROR                  00962000
         DC    AL1(6*16+SEV54)          WRAPFLD                         00963000
         DC    AL1(ERR54)               OP OCDE NOT O-SYM OR V-SYM      00964000
CSTKFULL EQU   *                                                        00965000
         BAL   TLINK,ABSERR             MORE THAN 5 LEVELS OF COPY CODE 00966000
         DC    AL1(2*16+SEV61)          AOPPTR                          00967000
         DC    AL1(ERR61)               CURRENT LIMIT IS 5 LEVELS       00968000
GLXERRZ  ST    INPTR,OPNDPTR                                            00969000
GLXE1    LA    INPTR,D1(,INPTR)                                         00970000
GLXERR   CLI   D0(INPTR),JCOMMA                                         00971000
         BE    GLXE2                    LOG ERROR WHEN FIND A COMMA     00972000
         CLI   D0(INPTR),JBLANK         OR A BLANK                      00973000
         BNE   GLXE1                    ELSE, KEEP LOOKING              00974000
GLXE2    LR    R15,INPTR                                                00975000
         LR    R0,INPTR                                                 00976000
         L     INPTR,OPNDPTR                                            00977000
         SR    R15,INPTR                                                00978000
         BNP   GLXE3                    MAKE SURE YOU GET A POS. VALUE  00979000
         BCTR  R15,0                    BACK UP 1                       00980000
GLXE3    BAL   TLINK,SNAPERR            LOG ERROR NOW                   00981000
         DC    AL2(1)                   .                               00982000
         DC    AL1(SEV29)               BAD DECLARATION                 00983000
         DC    AL1(ERR29)               BAD DECLARATION                 00984000
         LR    INPTR,R0                                                 00985000
         B     GLX10                    CHECK NEXT SYMBOL               00986000
NOPNDER  DS    0H                                              FX0000   00987000
         SET   SEOPND,OFF               SET EDITING OPND OFF   FX0000   00988000
         BAL   TLINK,ABSERR             THIS STMT SHOULD HAVE OFX0000   00989000
         DC    AL1(7*16+SEV62)          BUT -                           00990000
         DC    AL1(ERR62)               MISSING                         00991000
BDPTO    BAL   TLINK,ABSERR             THIS PROTOTYPE STMT             00992000
         DC    AL1(6*16+SEV43)          HAS AN ILLEGAL OP CODE          00993000
         DC    AL1(ERR43)               FORMAT                          00994000
ILDIM    ST    INPTR,OPNDPTR            SAVE THE BEGIN POINT            00995000
ILDIM1   LA    INPTR,D1(,INPTR)         BUMP UP TO THE NEXT CHARACTER   00996000
         CLI   D0(INPTR),JCOMMA         IS IT A COMMA                   00997000
         BE    ILDIM2                   YES, GO LOG ERR FOR THIS OPND   00998000
         CLI   D0(INPTR),JBLANK         WHAT ABOUT A BLANK              00999000
         BNE   ILDIM1                   NO, LOOP UNTIL FIND TERMINATOR  01000000
ILDIM2   LR    R15,INPTR                GET THE END POINT               01001000
         LR    INPTR,TRTN               GET THE BEGIN POINT             01002000
         LR    TRTN,R15                 SAVE FOR CLEANUP ROUTINE        01003000
         SR    R15,INPTR                CALCULATE LENGTH OF THIS OPND   01004000
         BCTR  INPTR,D0                 BEGIN SNAP WITH LEFT PAREN      01005000
         BAL   TLINK,SNAPERR            TAKE A SNAP SHOT                01006000
         DC    AL2(2)                   .                               01007000
         DC    AL1(4*16+SEV30)          (CLN0)  OR                      01008000
         DC    AL1(ERR30)               EXCEEDS 10 DSDT DIGITS          01009000
HIDIM    XR    INPTR,TRTN               SAVE INPTR AND BACK UP          01010000
         XR    TRTN,INPTR               TO THE LOCATION AT TRTN         01011000
         XR    INPTR,TRTN                                               01012000
         LR    R3,PARM                  SAVE WHERE SYMBOL STARTS        01013000
         STH   PARAM2,JHWORD1           SAVE SYMBOL LENGTH              01014000
         BCTR  TWKREG2,D0               ADJUST MOVE LENGTH OF DIMENSION 01015000
         BAL   TLINK,SNAPERR            TAKE A SNAP OF DIMENSION        01016000
         DC    AL2(2)                   ERROR--                         01017000
         DC    AL1(SEV30)               DIMENSION                       01018000
         DC    AL1(ERR30)               TOO LARGE                       01019000
         LR    PARM,R3                  RESTORE -WHERE IT'S AT-         01020000
         LH    PARAM2,JHWORD1           RESTORE SYMBOL LENGTH           01021000
         MVC   JHWORD1(L'H32K),H32K                                     01022000
         LR    INPTR,TRTN                                               01023000
         B     VSDNDX                   CONTINUE EDITING                01024000
ILGLXP   EQU   *                                                        01025000
         BAL   TLINK,SNAPERR            TAKE A SNAP SHOT                01026000
         DC    AL2(1)                   .                               01027000
         DC    AL1(5*16+SEV33)          CLEANUP                         01028000
         DC    AL1(ERR33)               IN SET STATEMENT                01029000
ILSETA   BAL   TLINK,ABSERR             BOOLEAN EXPRESSION              01030000
         DC    AL1(5*16+SEV59)          NOT ALLOWED IN                  01031000
         DC    AL1(ERR59)               SETA EXPRESSION                 01032000
ILUNARY  EQU   *                                                        01033000
         BAL   TLINK,ABSERR             INVALID UNARY OPERATOR          01034000
         DC    AL1(5*16+SEV52)          CLEANUP                         01035000
         DC    AL1(ERR52)               UNARY OPERATOR NOT + OR -       01036000
INVDUP   EQU   *                                                        01037000
         BAL   TLINK,SNAPERRL           GO PUT OUT SNAP SHOT            01038000
         DC    AL2(1)                   PADDING TO CALCULATE RETURN     01039000
         DC    AL1(5*16+SEV57)          NOT TERMINATED BY               01040000
         DC    AL1(ERR57)               RIGHT PAREN                     01041000
INVSUB   BAL   TLINK,ABSERR             INVALID SUBSTRING NOTATION      01042000
         DC    AL1(5*16+SEV70)          CLEANUP                         01043000
         DC    AL1(ERR70)               NOT TERMINATED BY , AND )       01044000
NOQUOTE  BAL   TLINK,ABSERR             SETC EXPRESSION                 01045000
         DC    AL1(5*16+SEV58)          CLEANUP                         01046000
         DC    AL1(ERR58)               TERMINATED BY A QUOTE           01047000
INVFM    EQU   *                                                        01048000
         BAL   TLINK,SNAPERRL           TAKE 8 CHAR SNAP SHOT           01049000
         DC    AL2(1)                   .                               01050000
         DC    AL1(5*16+SEV32)          CLEANUP                         01051000
         DC    AL1(ERR32)               .                               01052000
ILATTR   L     INPTR,TPSAVE             BACK TO BEGIN PT FOR SNAP SHOT  01053000
         MVI   ATTRSV,D0                RESET ATTRIBUTE INDICATOR       01054000
         BAL   TLINK,SNAPERRL           TAKE A SNAP SHOT                01055000
         DC    AL2(1)                   TO CALCULATE BR TO ABSOLUTE ERR 01056000
         DC    AL1(5*16+SEV36)          CLEANUP                         01057000
         DC    AL1(ERR36)               .                               01058000
ILSETX   EQU   INVFM                                                    01059000
ILSETNM  BAL   TLINK,ABSERR             ILLEGAL NAME IN SET STMT        01060000
         DC    AL1(SEV31)               .                               01061000
         DC    AL1(ERR31)               NOT V-SYM OR V-SYM WRONG TYPE   01062000
         B     AOPXIT                   STOP EDIT ON THIS ERROR         01063000
NAMERR   EQU   *                                                        01064000
         BAL   TLINK,WRNERR             INVALID NAME DETECTED           01065000
         DC    AL1(SEV16)               GO LOG ERROR AND RETURN TO      01066000
         DC    AL1(ERR16)               CONTINUE PROC STATEMENT         01067000
         SET   JSUBNAME,OFF             SUB NOT REQ'D IF NAME WAS V.S.  01068000
         SET   JNMERR,ON                INDICATE NAME ERROR             01069000
         MVI   SDENTR,D0                INSURE NO DIR ENTRY ON NAME ERR 01070000
         BR    RETURN                   RETURN TO CALLER                01071000
ILBXP    BAL   TLINK,ABSERR             INVALID EXPRESSION IN SETB      01072000
         DC    AL1(5*16+SEV21)          STATEMENT                       01073000
         DC    AL1(ERR21)               .                               01074000
ILSDT    EQU   *                                                        01075000
         SR    R15,INPTR                SET LENGTH FOR SNAP             01076000
         L     INPTR,TPSAVE             BACK TO BEGIN PT FOR SNAP SHOT  01077000
         LR    R15,INPTR                GET TERMINATOR ADDR             01078000
         BAL   TLINK,SNAPERR            TAKE A SNAP SHOT                01079000
         DC    AL2(1)                   .                               01080000
         DC    AL1(5*16+SEV38)          CLEANUP                         01081000
         DC    AL1(ERR38)               .                               01082000
         EJECT                                                          01083000
*********************************************************************** 01084000
*                                                                       01085000
* CHANGE BASE REGISTER BEFORE ENTERING THE FOURTH CSECT                 01086000
*                                                                       01087000
*********************************************************************** 01088000
SNAPERRL LA    R15,D7                   SET UP TO DUMP 8 BYTES          01089000
SNAPERR  L     LINK,ASNAPERR            GET ROUTINE ADDR                01090000
         B     SAVOLD                   SAVE OLD FIRST                  01091000
*                                                                       01092000
ABSERR   L     LINK,AABSERR             GET ROUTINE ADDR                01093000
         B     SAVOLD                   SAVE OLD FIRST                  01094000
*                                                                       01095000
WRNERR   L     LINK,AWRNERR             GET ROUTINE ADDR                01096000
         B     SAVOLD                   SAVE OLD FIRST                  01097000
*                                                                       01098000
UNXPEOF  L     LINK,AUNXPEOF            GET ROUTINE ADDR                01099000
         B     GOCSECT4                 GO CHANGE BASE                  01100000
*                                                                       01101000
EOFRTN   L     LINK,AEOFRTN             GET ROUTINE ADDR                01102000
         B     GOCSECT4                 GO CHANGE BASE                  01103000
*                                                                       01104000
DIR10    L     LINK,ADIR10              GET ROUTINE ADDR                01105000
         B     SAVOLD                   SAVE OLD FIRST                  01106000
*                                                                       01107000
DIRENT   L     LINK,ADIRENT             GET ROUTINE ADDR                01108000
*                                                                       01109000
SAVOLD   ST    BASE2,REGSAVE3           SAVE OLD BASE                   01110000
GOCSECT4 L     BASE4,CS4ADDR            CHANGE BASE FOR CSECT4          01111000
         BR    LINK                     NOW ENTER ROUTINE               01112000
         SPACE 3                                                        01113000
***************                                                         01114000
         DS    0F                                                       01115000
CS2ADDR  DC    A(CS2)                   ADDR OF CSECT 2                 01116000
CS4ADDR  DC    A(CS4)                   ADDR OF CSECT 4                 01117000
ADIRENT  DC    A(NDIRENT)               ADDR OF DIRENT                  01118000
ADIR10   DC    A(NDIR10)                ADDR OF DIR10                   01119000
AUNXPEOF DC    A(NUNXPEOF)              ADDR OF UNXPEOF                 01120000
AEOFRTN  DC    A(NEOFRTN)               ADDR OF EOFRTN                  01121000
AESYSMAC DC    A(ESYSMAC)               ADDR OF ESYSMAC                 01122000
APGRMAC  DC    A(PGRMAC)                ADDR OF PGRMAC                  01123000
ASVCTLFM DC    A(SVCTLFM)               ADDR OF SVCTLFM                 01124000
ACSTKEXT DC    A(CSTKEXT)               ADDR OF CSTKEXT                 01125000
ASNAPERR DC    A(NSNAPERR)              ADDR OF SNAPERR                 01126000
AABSERR  DC    A(NABSERR)               ADDR OF ABSERR                  01127000
AWRNERR  DC    A(NWRNERR)               ADDR OF WRNERR                  01128000
         EJECT                                                          01129000
****************************************                                01130000
*   POSTFIXER ENTRY ROUTINE                                             01131000
*   AT ENTRY REG 10 (PARM) CONTAINS THE OPERATOR TO BE LOGGED           01132000
*   LINKAGE IS    BAL   R3,PFXRENT                                      01133000
*                 BAL   R3,PFXRE2                                       01134000
****************************************                                01135000
         SPACE 3                                                        01136000
         JEXTRN (X1S01=PFIXRN)                                          01137000
PFXRENT  EQU   *                                                        01138000
         LH    PARM,D0(,R3)             GET OPERATOR                    01139000
         AH    R3,H2                    ADJUST RETURN ADDRESS           01140000
PFXRE2   STM   R15,R3,EDTSVZ            SAVE REGISTERS                  01141000
         L     LINK,ADPSTR              LOCATE P-FXR ENTRY POINT        01142000
         BALR  RETURN,LINK              MAKE ENTRY                      01143000
         B     RENTFULL                 STACK OVERFLOW IF RETURN HERE   01144000
         LA    INPTR,D1(,INPTR)         UPDATE POINTER                  01145000
         LM    R15,R3,EDTSVZ            RESTORE REGISTERS               01146000
         BR    R3                       RETURN TO CALLER                01147000
ADPSTR   DC    A(PFIXRN)                POSTFIXER ENTRY POINT           01148000
         EJECT                                                          01149000
*   SYMSCN EDITS ORDINARY SYMBOLS INTO EDITED TEXT                      01150000
*   LINKAGE IS     BAL LINK,SYMSCN                                      01151000
*   NORMAL EXIT IS     B    D4(,LINK)                                   01152000
*   ERROR EXIT IS      BR   LINK                                        01153000
         SPACE 3                                                        01154000
SYMSCN   EQU   *                                                        01155000
         ST    LINK,EDTSVY              SAVE RETURN LINKAGE             01156000
         L     LINK,ATRTEST             PT TO TRTEST                    01157000
         BALR  RETURN,LINK              GO TRT SYMBOL                   01158000
         L     LINK,EDTSVY                                              01159000
         BCTR  R3,LINK                  ERROR IF NOT O-SYM              01160000
SYMSCN1  EQU   *                                                        01161000
         ST    LINK,EDTSVY              MAKE SURE RTN LNKAGE IS SAVED   01162000
         CH    R15,H7                   AND LENGTH MUST BE LE 8         01163000
         BCR   BHI,LINK                 RETURN IF GT 8 - ERROR          01164000
         TM    ATTRSV,ATK               N' OR K' FOLLOWED BY O-SYM      01165000
         BCR   BONE,LINK                IS ERROR                        01166000
         MVI   DDNDX1,ORDSYMBR          ORDINARY SYMBOL REF INDEX       01167000
         LR    PARM,INPTR               POINT TO SYMBOL                 01168000
         LR    PARAM2,TWKREG2           GET ITS LENGTH                  01169000
         BAL   R3,DIRENT                LOG ORDINARY SYMBOL             01170000
         L     LINK,EDTSVY              RESTORE RETURN LINKAGE          01171000
         LR    INPTR,R1                 BUMP POINTER                    01172000
         B     D4(,LINK)                RETURN TO CALLER                01173000
         EJECT                                                          01174000
****************************************                                01175000
*   PAREN COUNT - INCREMENTAL - MAX HALF WORD                           01176000
*   LINKAGE IS    BAL   R12,APARCT                                      01177000
****************************************                                01178000
APARCT   EQU   *                                                        01179000
         LH    RCNT,PRNLVL              GET CURRENT COUNT               01180000
         AH    RCNT,H1                  ADD ONE                         01181000
         STH   RCNT,PRNLVL              AND SAVE                        01182000
         BR    R12                      RETURN TO CALLER                01183000
         SPACE 3                                                        01184000
****************************************                                01185000
*   PAREN COUNT - DECREMENTAL -                                         01186000
*   LINKAGE IS    BAL   R12,DPARCT                                      01187000
****************************************                                01188000
DPARCT   EQU   *                                                        01189000
         LH    RCNT,PRNLVL              GET CURRENT COUNT               01190000
         SH    RCNT,H1                  SUBTRACT ONE                    01191000
         STH   RCNT,PRNLVL              AND SAVE                        01192000
         BR    R12                      RETURN TO CALLER                01193000
         EJECT                                                          01194000
*********************************************************************** 01195000
*   TBLOPS  ROUTINE IS ENTERED  WHEN A STATEMENT OTHER THAN MACRO       01196000
*   INSTRUCTION OR PROTOTYPE IS READ. THIS ROUTINE FURTHER CLASSIFIES   01197000
*   ASSEMBLER OP STATEMENTS FROM MACHINE OP STATEMENTS. ALL MACHINE     01198000
*   OP STATEMENTS ARE UNIQUELY EDITED BY ONE SUBROUTINE, WHILE          01199000
*   ASSEMBLER OP STATEMENTS ARE FANNED OUT TO THE APPROPRIATE           01200000
*   SUBROUTINES BASED ON OP CODES. EDITED TEXT RECORDS ARE PARTIALLY    01201000
*   BUILT, AND POSSIBLE DIRECTORY ENTRIES ARE MADE. IN MOST CASES,      01202000
*   PROCESS GOES TO 'WRAPFLD' ROUTINE WHERE THE BUILDING OF THE         01203000
*   EDITED TEXT RECORD IS COMPLETED. AT END OF EDITING A MACRO          01204000
*   DEFINITION, DIRECTORY ROUTINE, 'MACREND', IS CALLED TO CLOSE OUT    01205000
*   SOME DIRECTORIES. AT THE END OF EDITING OPEN CODE, DIRECTORY        01206000
*   ROUTINE, 'OPENEND', IS  CALLED TO CLOSE OUT SOME DIRECTORIES, AND   01207000
*   TO INITIALIZE THE PHASE FOR SYSTEM MACRO EDITING. WHEN ALL          01208000
*   SYSTEM MACROS ENCOUNTERED ARE EDITED. DIRECTORY ROUTINE, 'PHASEND', 01209000
*   IS CALLED. ALL DIRECTORIES THAT HAVE NOT BEEN CLOSED ARE CLOSED.    01210000
*   CONTROL RETURNS TO CONTROLLER.                                      01211000
*********************************************************************** 01212000
*        PROCESS OPERAND FIELD        *                                 01213000
***************************************                                 01214000
         SPACE 3                                                        01215000
TBLOPS   EQU   *                        EDIT OPERAND FIELD              01216000
         TM    IOCID,BIT0+BIT1          TEST IF MACRO CALL/PROTO        01217000
         BZ    MACINST                  EDIT PARAM IF YES               01218000
         SET   SEOPND,ON                                                01219000
         L     INPTR,ENDATA             GET END OF DATA FIELD           01220000
         L     LINK,ARDSRC05            PT TO RDSRC05                   01221000
         BALR  RETURN,LINK              READ ALL CONTINUATIONS          01222000
         DC    AL2(RALLCNT-RFSTCRD)     READ ALL VALID CONTINUATIONS    01223000
         L     INPTR,FPTRSV             BUMP POINTER                    01224000
         BAL   TLINK,SKPBLK             GO FIND OPERAND FIELD           01225000
         TM    IOCID,IOCTYP             TEST IF ASSEMBLER OP            01226000
         BNO   MCHINS                   BRANCH IF MACHINE OP            01227000
         SR    TWKREG1,TWKREG1                                          01228000
         IC    TWKREG1,OCSAVE           GET INTERNAL OP BEFORE YOU GO   01229000
         BAL   RETURN,STMTSEQ           STATEMENT SEQUENCING            01230000
         GOIF  JPRONLY,ON=INVALID       BRANCH IF SEQ'G ERROR FOUND     01231000
ASSMOP   EQU   *                                                        01232000
         SR    CGOTO,CGOTO                                              01233000
         IC    CGOTO,OCSAVE             GET OP CODE                     01234000
         AR    CGOTO,CGOTO              DOUBLE THE VALUE                01235000
         LH    CGOTO,AOPTBL(CGOTO)      COMPUTE BRANCH ADDRESS          01236000
         B     SETBAS(CGOTO)            GO TO PROCESS ASSEMBLER OP      01237000
AOPPTRS  ST    RETURN,RTNSV             SAVE RETURN LINKAGE             01238000
AOPPTR   LCR   R14,INDEXO               COMPUTE FIELD POINTER           01239000
         A     R14,OFPTRSV                                              01240000
         STH   R14,JTOPP                AND SAVE                        01241000
         SET   SEOPND,OFF                                               01242000
         B     WPOPND                   GO EDIT COMMENTS                01243000
SAVPTR   ST    RETURN,RTNSV             SAVE RETURN ADDRESS             01244000
AOPXIT   SET   SEOPND,OFF                                               01245000
         B     WRAPFLD                  GO EDIT COMMENTS                01246000
         EJECT                                                          01247000
*******************************************                             01248000
*        ASSEMBLER OP BRANCH TABLE        *                             01249000
*******************************************                             01250000
         TBLGEN (ICTL,                                                 X01251000
               ISEQ,                                                   X01252000
               COPY,                                                   X01253000
               OPSYN,                                                  X01254000
               ANOP,                                                   X01255000
               GBLA,                                                   X01256000
               GBLB,                                                   X01257000
               GBLC,                                                   X01258000
               LCLA,                                                   X01259000
               LCLB,                                                   X01260000
               LCLC,                                                   X01261000
               MACRO,                                                  X01262000
               ACTR,                                                   X01263000
               AGO,                                                    X01264000
               AIF,                                                    X01265000
               SETA,                                                   X01266000
               SETB,                                                   X01267000
               SETC,                                                   X01268000
               MEXIT,                                                  X01269000
               MEND,                                                   X01270000
               END,                                                    X01271000
               DXD,                                                    X01272000
               EQU,                                                    X01273000
               ORG,                                                    X01274000
               CNOP,                                                   X01275000
               CCW,                                                    X01276000
               DC,                                                     X01277000
               DS,                                                     X01278000
               START,                                                  X01279000
               CSECT,                                                  X01280000
               DSECT,                                                  X01281000
               COM,                                                    X01282000
               ENTRY,                                                  X01283000
               EXTRN,                                                  X01284000
               WXTRN,                                                  X01285000
               CXD,                                                    X01286000
               LTORG,                                                  X01287000
               PUNCH,                                                  X01288000
               REPRO,                                                  X01289000
               PUSH,                                                   X01290000
               POP,                                                    X01291000
               PRINT,                                                  X01292000
               USING,                                                  X01293000
               DROP,                                                   X01294000
               SPACE,                                                  X01295000
               EJECT,                                                  X01296000
               TITLE,                                                  X01297000
               MNOTE,                                                  X01298000
               INVALID),,                                              X01299000
               AOPTBL,,2,SETBAS                                         01300000
         EJECT                                                          01301000
ICTL     EQU   *                                                        01302000
****                                    OPERAND EDITED AS COMMENTS      01303000
         SET   SICTL,OFF                                                01304000
         SET   JPRONLY,ON               INDICATE PRINT ONLY             01305000
         ST    INPTR,OPNDPTR                                            01306000
         L     INPTR,INPUT              RESET POINTER                   01307000
         SET   SCTLRTN,ON               ELSE, INDICATE TO RETURN        01308000
         GOIF  SNOFND,ON=BADI           LOG ERROR IF NO OPERAND         01309000
         BAL   RETURN,SAVPTR            SAVE RET ADDR AND WRAP UP STMT  01310000
         L     INPTR,OPNDPTR            GET OPERAND POINTER             01311000
         SET   SFSTCD,OFF               ICTL NO LONGER ALLOWED          01312000
*                                                                       01313000
         BAL   RETURN,DSCAN             SCAN FIRST OPERAND              01314000
         B     BADICTL                  INVALID OPERAND FOUND           01315000
         LTR   TWKREG1,TWKREG1          TEST IF VALUE BETWEEN 1 AND 40  01316000
         BNH   BADICTL                  VALUE EQ 0 - ERROR              01317000
         CH    TWKREG1,H40                                              01318000
         BH    BADICTL                  VALUE GT 40 - ERROR             01319000
         BCTR  TWKREG1,0                BACK UP 1                       01320000
         ST    TWKREG1,TBGLN            SAVE NEW STRING LENGTH          01321000
         ST    TWKREG1,JBEGCL           SAVE NEW BEGIN COLUMN - 1       01322000
         BCTR  TWKREG1,0                BACK UP 1                       01323000
         ST    TWKREG1,PBGLEN           SAVE PRE-BEGIN LENGTH - 1       01324000
         CLI   D0(INPTR),JCOMMA         TEST IF MORE OPERAND            01325000
         BE    CTL10                    YES.                            01326000
         L     TWKREG1,CONTCHR          NO, INSERT STD END COLUMN       01327000
         B     CTL15                    CONTINUE                        01328000
CTL10    EQU   *                                                        01329000
         BAL   RETURN,DSCAN1            SCAN SECOND OPERAND             01330000
         B     BADICTL                  INVALID OPERAND FOUND           01331000
         CH    TWKREG1,H40              TEST VALUE BETEEEN 41 AND 80    01332000
         BNH   BADICTL                  VALUE LESS THEN 41. ERROR       01333000
         CH    TWKREG1,H80                                              01334000
         BH    BADICTL                  VALUE GREATER THAN 80. ERROR    01335000
         BL    CTL15                    BRANCH IF ALLOW CONT'N          01336000
         SET   SNOCNT,ON                ELSE, SAY NO CONT'N             01337000
CTL15    EQU   *                                                        01338000
         ST    TWKREG1,JCTCHR           SAVE CONT. CHR. COLUMN          01339000
         LA    WORK2,CRDLN-1            COMPUTE POSTEND STRING LENGTH-1 01340000
         SR    WORK2,TWKREG1                                            01341000
         ST    WORK2,PNDLEN                                             01342000
         BCTR  TWKREG1,0                BACK UP 1                       01343000
         ST    TWKREG1,ENDCOL           SAVE NEW END COLUMN             01344000
CTL20    S     TWKREG1,PBGLEN           COMPUTE SOURCE LENGTH WHICH     01345000
         CH    TWKREG1,H6               MUST BE GE 5 TO BE ABLE TO      01346000
         BL    BADICTL                  HOLD GENERATED ' END  '         01347000
         ST    TWKREG1,TSRCLN           STORE NEW SOURCE LENGTH         01348000
         LR    WORK2,TWKREG1            SAVE LENGTH                     01349000
         BCTR  TWKREG1,0                DECR BY 1                       01350000
         ST    TWKREG1,JSRCLN           STORE NEW SRC LENGTH MINUS 1    01351000
         CLI   D0(INPTR),JCOMMA         TEST IF MORE OPERAND            01352000
         BNE   CTL40                    BRANCH IF NO MORE OPERAND       01353000
         GOIF  SNOCNT,ON=BADICTL        BRANCH IF NO CONT'N ALLOWED     01354000
         BAL   RETURN,DSCAN1            SCAN THIRD OPERAND              01355000
         B     BADICTL                  INVALID OPERAND FOUND           01356000
         CH    TWKREG1,H40                                              01357000
         BH    BADICTL                  VALUE MUST BE                   01358000
         BCTR  TWKREG1,0                BETWEEN BEGCOL+1 AND 40         01359000
         C     TWKREG1,JBEGCL           ELSE ....                       01360000
         BNH   BADICTL                  ERROR                           01361000
CTL30    EQU   *                                                        01362000
         ST    TWKREG1,JCTBGN           SAVE CONTINUATION BEGIN         01363000
         BCTR  TWKREG1,0                BACK UP 1                       01364000
         LCR   TWKREG1,TWKREG1                                          01365000
         A     TWKREG1,ENDCOL                                           01366000
         ST    TWKREG1,TCNTLN           STORE CONTINUATION LENGTH       01367000
         BCTR  TWKREG1,0                DECR BY 1                       01368000
         ST    TWKREG1,JCTLN            STORE CONT. LENGTH MINUS 1      01369000
         CLI   D0(INPTR),JBLANK         BLANK IS GOOD TERMINATOR        01370000
          BE    CTLX                    IT IS.                          01371000
         C     INPTR,ENDATA             ELSE, ENDATA MUST TERMINATE     01372000
         BL    BADICTL                  BAD TERMINATOR                  01373000
CTLX     SR    PARAM1,PARAM1                                            01374000
         LA    PARAM2,MAXCNT                                            01375000
         DR    PARAM1,TWKREG1                                           01376000
         MR    PARAM1,TWKREG1                                           01377000
         LA    PARAM1,D1(WORK2,PARAM2)                                  01378000
         LA    TWKREG2,CRDLN                                            01379000
         SR    TWKREG2,TWKREG1                                          01380000
         LA    PARAM2,D6+D7(TWKREG2,PARAM1)                             01381000
         SR    PARAM1,PARAM1                                            01382000
         LA    TWKREG1,D8                                               01383000
         DR    PARAM1,TWKREG1                                           01384000
         L     PARAM1,DSTGBGN                                           01385000
         LR    INPTR,PARAM2                                             01386000
         CH    PARAM2,H63               ACTUAL DATA AREA SIZE W/STD     01387000
         BNL   FRECORE                  IF GE STD, ASSIGN ACTUAL DW VAL 01388000
         LH    INPTR,H63                ASSIGN STANDARD SIZE IF LOWER   01389000
FRECORE  EQU   *                                                        01390000
         JFRECORE  ADDR=(PARAM1)                                        01391000
GETCORE  EQU   *                                                        01392000
         JGETCORE DBL=(INPTR)                                           01393000
         ST    PARAM1,DSTGBGN                                           01394000
         LA    TWKREG1,D0(PARAM1,PARAM2)                                01395000
         ST    TWKREG1,ENDWKA           SAVE END OF BUFFER POINTER      01396000
         ST    TWKREG1,ENDWKADJ         SAVE 'ENDWKA'          @OX07230 01397000
         LA    PARAM2,CRDLN             CARD LENGTH MINUS               01398000
         S     PARAM2,TCNTLN            CONTINUATION DATA LENGTH        01399000
         LA    TWKREG1,MISTGP(PARAM1,PARAM2) ONE CARD STG AREA LENGTH   01400000
         ST    TWKREG1,MINPADJ                                          01401000
         ST    TWKREG1,MINPUT                                           01402000
         SLL   PARAM2,D1                COMPUTE NORMAL STRING AREA      01403000
         LA    TWKREG2,CRDLN            COMPUTE INPUT POINTER           01404000
         S     TWKREG2,TSRCLN                                           01405000
         LA    TWKREG2,STSTGP(TWKREG2,PARAM2)                           01406000
         LA    TWKREG2,D0(TWKREG2,PARAM1)                               01407000
         ST    TWKREG2,STNPADJ                                          01408000
         ST    TWKREG2,INPUT                                            01409000
         SR    TWKREG2,TWKREG1          COMPUTE DIF B/                  01410000
         STH   TWKREG2,MINDIF           MINPUT AND INPUT                01411000
         STH   TWKREG2,MINDFADJ         SAVE 'MINDIF'          @OX07230 01412000
ICTLOUT  EQU   *                                                        01413000
         MVI   DDNDX1,PHASENT           SET UP INDEX FOR BR TO DIR RTN  01414000
         BAL   R3,DIR10                 INITIALIZE DIRECTORIES          01415000
         B     WRAPCNT                  EDIT COMMENTS                   01416000
*                                                                       01417000
BADI     EQU   *                                                        01418000
         BAL   RETURN,SAVPTR            OUTPUT PRINT-ONLY RECORD        01419000
         BAL   TLINK,ABSERR             LOG ERROR                       01420000
         DC    AL1(SEV48)               .                               01421000
         DC    AL1(ERR48)               ICTL OPERAND NOT FOUND          01422000
BADIX    EQU   *                                                        01423000
         MVI   DDNDX1,PHASENT           SET UP INDEX FOR BR TO DIR RTN  01424000
         BAL   R3,DIR10                 INITIALIZE DIRECTORIES          01425000
         SET   (SPGRMD,SOPNCD,SKPEND),FLIP                              01426000
         MVI   DDNDX1,OPENENT           SET UP INDEX FOR BR TO DIR RTN  01427000
         BAL   R3,DIR10                 INITIALIZE OPEN CODE            01428000
         B     WRAPCNT                  THEN CLOSE                      01429000
*                                                                       01430000
CTL40    EQU   *                                                        01431000
         L     TWKREG1,F15              STD CONT'N COL                  01432000
         SET   SNOCNT,ON                CONTINUATION NOT ALLOWED        01433000
         B     CTL30                    WRAP UP ICTL STMT               01434000
BADICTL  EQU   *                                                        01435000
         LR    INPTR,TRTN               BACK UP                         01436000
         MVC   TBGLN(L'TBGLN*6),STDPARM RESTORE STANDARD ICTL PARAMS    01437000
         MVC   JSRCLN(L'JSRCLN*7),SRCLEN                                01438000
         BAL   TLINK,WRNERR             BAD ICTL STATEMENT              01439000
         DC    AL1(1*16+SEV19)          GO TO BADIX RTN THRU WRNERR     01440000
         DC    AL1(ERR19)               DEFAULT TO STD ICTL VALUES      01441000
         SPACE 3                                                        01442000
ISEQ     EQU   *                                                        01443000
****                                    OPERAND EDITED AS COMMENTS      01444000
         SET   SISEQ,OFF                ASSUME NO SEQUENCE CHECK        01445000
* PARAMETER ERROR IN ISEQ STATEMENT IS TREATED AS ISEQ WITHOUT OPERAND, 01446000
* WHICH CAUSES SEQUENCE CHECKING TO BE DISCONTINUED.                    01447000
         SET   JPRONLY,ON               INDICATE PRINT ONLY             01448000
         GOIF  SNMFND,OFF=ISEQ05        LOG ERROR IF THERE IS A NAME    01449000
         BAL   RETURN,NAMERR             LOG ERROR                      01450000
ISEQ05   EQU   *                                                        01451000
         GOIF  SNOFND,ON=AOPXIT         BRANCH IF NO OPERAND            01452000
         CLC   INPOPR(L'CMABLK+1),CMABLK  TEST OMIT OPER FIELD  OX00410 01453000
         BE    AOPXIT                   WRAP UP STMT                    01454000
         ST    INPTR,FPTRSV             SAVE INPTR                      01455000
         BAL   RETURN,DSCAN             SCAN FIRST OPERAND              01456000
         B     ISEQERR                  ERROR FOUND. LOG ERROR          01457000
         CLI   D0(INPTR),JCOMMA         TERMINATE MUST BE A COMMA       01458000
         BNE   ISEQERR                  NOT A COMMA, LOG ERROR          01459000
         LTR   TWKREG1,TWKREG1          VALUE MUST BE GREATER THAN ZERO 01460000
         BNH   ISEQERR                  GO LOG ERROR                    01461000
         BCTR  TWKREG1,0                DECR BY 1                       01462000
         ST    TWKREG1,JSEQCL           STORE BEGIN COLUMN              01463000
         BAL   RETURN,DSCAN1            SCAN SECON OPERAND              01464000
         B     ISEQERR                  ERROR FOUND. LOG ERROR          01465000
         CLI   D0(INPTR),JBLANK         TEST IF BLANK AS TERMINATOR     01466000
         BE    ISEQ10                   BRANCH IF YES                   01467000
         CR    INPTR,R12                TEST IF END COLUMN TERMINATES   01468000
         BL    ISEQERR                  NO, LOG ERROR                   01469000
ISEQ10   EQU   *                                                        01470000
         CH    TWKREG1,H80              VALUE MUST NOT BE GT 80         01471000
         BH    ISEQERR                  LOG ERROR                       01472000
         BCTR  TWKREG1,0                MINUS 1                         01473000
         CLC   JSEQCL(L'JSEQCL),JCTCHR  SEQUENCE FIELD MUST NOT BE      01474000
         BNL   ISEQ20                   BETWEEN BEGIN AND ENDING        01475000
         C     TWKREG1,JBEGCL           COLUMN, ELSE                    01476000
         BNL   ISEQERR                  ERROR                           01477000
ISEQ20   EQU   *                                                        01478000
         S     TWKREG1,JSEQCL           COMPUTE SEQUENCE FIELD LENGTH   01479000
         BM    ISEQERR                  RIGHTMOST COLUMN MUST BE EQ OR X01480000
                                        GT LEFTMOST COLUMN, ELSE ERROR  01481000
         ST    TWKREG1,JSEQLN           STORE MOVE LENGTH               01482000
         SET   SISEQ,ON                 INDICATE SEQUENCE CHECK         01483000
         XC    SEQSV(L'SEQSV),SEQSV     CLEAR SEQUENCE VALUE AREA       01484000
ISEQXIT  EQU   *                                                        01485000
         L     INPTR,FPTRSV             RESET POINTER                   01486000
         B     AOPXIT                   WRAP UP STATEMENT               01487000
ISEQERR  EQU   *                                                        01488000
         BAL   TLINK,ABSERR             LOG ERROR                       01489000
         DC    AL1(SEV19)               .                               01490000
         DC    AL1(ERR19)               ILLEGAL ISEQ STATEMENT          01491000
         B     ISEQXIT                  EXIT                            01492000
         SPACE 3                                                        01493000
*                                                                       01494000
*        ROUTINE TO SCAN A DECIMAL FIELD.                               01495000
*        IF FIELD IS VALID RETURN TO D4(,RETURN)                        01496000
*        OTHERWISE, RETURN TO RETURN                                    01497000
*                                                                       01498000
DSCAN1   EQU   *                                                        01499000
         LA    INPTR,D1(,INPTR)                                         01500000
DSCAN    EQU   *                                                        01501000
         LR    TRTN,INPTR               SAVE STARTING POINT             01502000
         L     R12,ENDATA                                               01503000
         SR    TWKREG1,TWKREG1                                          01504000
         SR    TWKREG2,TWKREG2                                          01505000
DSC10    EQU   *                                                        01506000
         CR    INPTR,R12                TEST IF END OF DATA             01507000
         BNL   DSC20                    BRANCH IF YES                   01508000
         CLI   D0(INPTR),J9             TEST IF A DIGIT                 01509000
         BH    DSC20                    NO, ASSUME END OF FIELD         01510000
         IC    TWKREG2,D0(,INPTR)                                       01511000
         MH    TWKREG1,H10              MULTIPLY PARTIAL SUM BY 10      01512000
         AR    TWKREG1,TWKREG2          ADD IN CURRENT DIGIT            01513000
         LA    INPTR,D1(,INPTR)         INCREMENT POINTER BY 1          01514000
         B     DSC10                    TEST NEXT DIGIT                 01515000
DSC20    EQU   *                                                        01516000
         LR    TWKREG2,INPTR            TEST FIELD LENGTH               01517000
         SR    TWKREG2,TRTN             WHICH MUST BE LESS THAN         01518000
         CH    TWKREG2,H10              OR EQUAL TO 10 DIGITS           01519000
         BCR   BHI,RETURN               IF HI, RETURN                   01520000
         CH    TWKREG2,H1               BUT NOT LESS THAN 1             01521000
         BCR   BLO,RETURN               ELSE, LOG ERROR                 01522000
         B     D4(,RETURN)              GOOD, WITHIN LIMITS             01523000
         SPACE 3                                                        01524000
COPY     EQU   *                                                        01525000
****                                    OPERAND EDITED AS COMMENTS      01526000
         BAL   TLINK,CHKNM              NAME MUST BE BLANK              01527000
COPY15   EQU   *                                                        01528000
         GOIF  SNOFND,OFF=COPY17        BRANCH IF THERE IS OPERAND      01529000
         BAL   TLINK,ABSERR             ELSE LOG ERROR                  01530000
         DC    AL1(8*16+SEV50)          GO TO INVALID RTN THRU ABSERR   01531000
         DC    AL1(ERR50)               COPY STMT NO OPERAND            01532000
COPY17   EQU   *                                                        01533000
         SET   SCOPY,ON                 EDITING COPY STMT               01534000
         BAL   RETURN,GSCAN             SCAN OPERAND FIELD              01535000
         GOIF  ROSYM,OFF=BADCPY         BRANCH IF COPY CODE NOT O-SYM   01536000
         SET   SCOPY,OFF                                                01537000
         BAL   R3,CSTKENT               RECURSIVE ENTRY                 01538000
         SET   SNOPND,ON                INDICATE TO RETURN              01539000
         BAL   RETURN,AOPPTRS           GO PUT OUT THIS STATEMENT       01540000
COPY20   EQU   *                                                        01541000
         LA    INPTR,COPYCODE           GET COPY CODE LOC               01542000
         JFIND ADDR=(INPTR)             GO FIND IT IN THE LIB.          01543000
         BP    COPY25                   GET MEMBER NAME                 01544000
         BAL   TLINK,SNAPERRL           TAKE A SNAP SHOT                01545000
         DC    AL2(1)                   OF COPY CODE NOT FOUND          01546000
         DC    AL1(SEV68)               IN MACRO LIBRARY                01547000
         DC    AL1(ERR68)               AND PREPARE TO EXIT             01548000
         BAL   R3,CSTKEXT               RECURSIVE EXIT                  01549000
         B     WRAPCNT                  READ NEXT STATEMENT             01550000
BADCPY   BAL   TLINK,ABSERR             BAD COPY CODE                   01551000
         DC    AL1(2*16+SEV49)          GO TO AOPPTR RTN THRU ABSERR    01552000
         DC    AL1(ERR49)               COPY CODE NOT O-SYM             01553000
COPY25   MVC   LASTFIND(L'LASTFIND),COPYCODE SAVE MEMBER NAME           01554000
         BP    READNEXT                 READ NEXT RECORD                01555000
         SPACE 3                                                        01556000
OPSYN    EQU   *                                                        01557000
         GOIF  SNMFND,OFF=ILOPSYN       ERROR IF NO NAME                01558000
         GOIF  ROSYM,OFF=ILOPSYN        OR NAME NOT ORDINARY SYMBOL     01559000
         MVI   SDENTR,OPSYNBLD          CHANGE ENTRY INDEX              01560000
         GOIF  SNOFND,ON=OPSYN1         EXIT IF NO OPERAND              01561000
         CLC   INPOPR(L'CMABLK),CMABLK  IS IT ',BLANK' IN OPERAND FIELD 01562000
         BE    OPSYN1                   IF YES,PROCESS AS VALID COMMENT 01563000
         BAL   RETURN,GSCAN             ELSE, EDIT OPERAND FIELD        01564000
         MVI   OCSAVE,D0                CLEAR OPSYN OP CODE             01565000
         GOIF  ROSYM,ON=AOPPTR          OK IF OPERAND AN ORD SYM        01566000
         LCR   R14,INDEXO               COMPUTE THE OPERAND             01567000
         A     R14,OFPTRSV              FIELD POINTER                   01568000
         STH   R14,JTOPP                AND SAVE                        01569000
ILOPSYN  EQU   *                                                        01570000
         BAL   TLINK,ABSERR             ERROR, SUPPRESS D ENTRY         01571000
         DC    AL1(SEV13)               OPSYN NAME NOT ORD SYMBOL       01572000
         DC    AL1(ERR13)               OPERAND NOT O-SYM/BLANK         01573000
         SET   JNMERR,ON                INDICATE NAME ERROR             01574000
         MVI   OCSAVE,D0                CLEAR OPSYN OP CODE             01575000
         MVI   SDENTR,D0                INSURE NO DIRECTORY ENTRY       01576000
         B     AOPXIT                   STOP EDIT ON THIS ERROR         01577000
OPSYN1   MVI   OCSAVE,D0                CLEAR OPSYN OP CODE             01578000
         B     AOPXIT                   GO WRAP UP STATEMENT            01579000
         SPACE 3                                                        01580000
MACRO    EQU   *                                                        01581000
         SET   (SMDEF,SXPRTO),ON        INDICATE IN MD, XPCT PROTOTYPE  01582000
         MVI   SDENTR,MACRENT           SAVE INDEX                      01583000
         SET   SDENT,ON                 POINT OF DEFINITION             01584000
         BAL   TLINK,CHKNM              NAME MUST BE BLANK              01585000
         GOIF  SPGRMD,OFF=AOPXIT        CHECK IF PROGRAMMER MACRO       01586000
         SET   JPRGMAC,ON               INDICATE PROGRAMMER MACRO       01587000
         GOIF  JNMERR,ON=PNXT15        NAME FIELD PRESENT,ERR  @OY08060 01588000
         B     AOPXIT                   WRAP UP STATEMENT               01589000
         SPACE 3                                                        01590000
MEND     EQU   *                                                        01591000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR NOT USED     01592000
MENDZ    EQU   *                                                        01593000
         SET   SNOPND,ON                INDICATE TO RETURN              01594000
         BAL   RETURN,SAVPTR            WRAP UP STATEMENT               01595000
         B     MEND1                    CLOSE MACRO DEFINITION          01596000
MEND0    EQU   *                                                        01597000
         GOIF  SINCPY,OFF=MEND1         BRANCH IF NOT IN COPY CODE      01598000
         SET   SMAC,OFF                 CORRESPONDING MEND GENERATED    01599000
         BAL   R3,CSTKEXT               RECURSIVE EXIT                  01600000
         GOIF  SOPNCD,OFF=MEND1         BR IF GERERATED MEND IS OK HERE 01601000
         BAL   TLINK,ABSERR             LOG ERROR IF NOT                01602000
         DC    AL1(SEV23)               MEND CAN'T BE IN OPEN CODE      01603000
         DC    AL1(ERR23)                                               01604000
         BAL   RETURN,WRAPERR           WRITE THIS ERROR RECORD         01605000
         B     READNEXT                 CONTINUE READING SOURCE         01606000
MEND1    EQU   *                                                        01607000
         GOIF  SSYSMD,OFF=MEND2         BR IF NOT IN SYSMAC             01608000
         GOIF  SINCPY,ON=READNEXT       READ REST OF COPY BOOK          01609000
         GOIF  SMDEF,OFF=MEND25         BR IF NO MACRO DEFINIT @AY19080 01610000
MEND2    EQU   *                                                        01611000
         GOIF  SXPRTO,OFF=MEND3         FOUND MACRO JET        @OX08858 01612000
         GOIF  SINEOF,OFF=MEND25        ONLY MACRO FOUND       @OX08858 01613000
         BAL   TLINK,WRNERR             LOG ERROR              @OX08858 01614000
         DC    AL1(SEV43)               EOF OCCURS BEFORE-     @OX08858 01615000
         DC    AL1(ERR43)               PROTOTYPE STMT         @OX08858 01616000
MEND25   EQU   *                                               @OX08858 01617000
         SET   SNOSMCRO,ON              NO, SET FLG,NOMACRO STM OX00403 01618000
         SET   SKPMND,ON                SET FLG FOR SKIPTO MEND OX00403 01619000
MEND3    SET   (SMDEF),OFF              CLOSE MACRO DEFINITION  OX00403 01620000
         MVI   DDNDX1,MACREND           SET UP INDEX FOR BR TO DIR RTN  01621000
         BAL   R3,DIR10                 GO CLOSE MACRO DEFINITION       01622000
         SET   SKPMND,OFF               ELSE, RESET SWITCH              01623000
         SET   (SNOSMCRO,SBDPROTO),OFF                                  01624000
         GOIF  SPGRMD,ON=READNEXT       RD NEXT STMT IF IN PGR MACRO    01625000
         L     BASE4,CS4ADDR            CHANGE BASE FOR CSECT 4         01626000
         L     LINK,AESYSMAC            GET ROUTINE ADDR                01627000
         BR    LINK                     NOW ENTER ROUTINE               01628000
         SPACE 3                                                        01629000
REPRO    GOIF  SNMFND,OFF=REPRO10       BRANCH IF THERE IS NO NAME      01630000
         GOIF  RSSYM,ON=REPRO10         BRANCH IF NAME A S.S.           01631000
         BAL   RETURN,NAMERR            ELSE, LOG ERROR                 01632000
REPRO10  SET   JPRONLY,ON               INDICATE PRINT ONLY             01633000
         SET   SNOPND,ON                INDICATE TO RETURN              01634000
         BAL   RETURN,SAVPTR            DON'T FORGET TO COME BACK       01635000
         JINPUT  ,                      READ A CARD                     01636000
         BNP   UNXPEOF                  UNEXPECTED END OF FILE          01637000
         LR    INPTR,RETADR             SAVE CARD POINTER               01638000
         LA    R11,D10*D10              RECORD LENGTH                   01639000
         BAL   RETURN,OPUTL             GET BUFFER                      01640000
         MVC   JTRLI(L'REPRO30),REPRO30 RECORD HEADER                   01641000
         MVC   JTRLI+L'REPRO30(D10*D8),D0(INPTR)  CARD IMAGE AS COMMENT 01642000
         SET   SNOPND,OFF               INSURE NO RETURN TO HERE        01643000
         B     WREXIT                   GO RESET SW AND READ NEXT CARD  01644000
REPRO30  DC    0CL20' ',H'100'          RECORD HEADER                   01645000
         DC    AL1(JPSOP+JDEF,0,JTREPRO),3H'16',H'18,16',AL1(0,0,1,80)  01646000
         SPACE 3                                                        01647000
AGO      EQU   *                                                        01648000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR NOT USED     01649000
         BAL   RETURN,GSCAN             SCAN OPERAND FIELD FOR SS       01650000
AGO1     EQU   *                                                        01651000
         GOIF  RSSYM,ON=AOPPTR          EDIT COMMENTS IF SS IN OPERAND  01652000
         BAL   TLINK,ABSERR             INVALID OPERAND FORMAT          01653000
         DC    AL1(2*16+SEV73)          GO TO AOPPTR VIA ABSERR         01654000
         DC    AL1(ERR73)               OPERAND NOT SEQUENCE SYMBOL     01655000
         SPACE 3                                                        01656000
*        NAME = SS OR BLANK                                             01657000
*        OPERAND = NOT USED                                             01658000
*                                                                       01659000
MEXIT    EQU   *                                                        01660000
EJECT    EQU   *                                                        01661000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR NOT USED     01662000
         B     AOPXIT                   WRAP UP STATEMENT               01663000
*                                                                       01664000
*        NAME = SS ONLY                                                 01665000
*        OPERAND = NOT USED                                             01666000
*                                                                       01667000
ANOP     EQU   *                                                        01668000
         GOIF  RSSYM,ON=AOPXIT          BRANCH IF NAME A S.S.           01669000
         GOIF  SNMFND,OFF=AOPXIT        ALLOW BLANK NAME                01670000
         BAL   RETURN,NAMERR            LOG ERROR MESSAGE               01671000
         B     AOPXIT                   END PROCESSING OF THIS STMT     01672000
*                                                                       01673000
*        NAME = ANY SYMBOL OR NOT USED                                  01674000
*        OPERAND = NOT USED                                             01675000
*                                                                       01676000
COM      LA    TLINK,AOPXIT             GET RETURN POINT                01677000
         B     CKANYSYM                 CHECK NAME                      01678000
CSECT    EQU   COM                                                      01679000
CXD      EQU   COM                                                      01680000
LTORG    EQU   COM                                                      01681000
*                                                                       01682000
*        NAME = SS OR NOT USED                                          01683000
*        OPERAND = REL. EXP., OR BLANK                                  01684000
*                                                                       01685000
END      EQU   *                                                        01686000
         GOIF  SOPNCD,OFF=SPACE         BRANCH IF NOT IN OPEN CODE      01687000
         SET   SENDST,ON                ELSE, INDICATE END STMT READ    01688000
SPACE    EQU   *                                                        01689000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR NOT USED     01690000
         B     MCHIN15                  EDIT AS MACHINE OP              01691000
*                                                                       01692000
*        NAME = SS OR NOT USED                                          01693000
*        OPERAND = EXP., SYMBOL, CHAR. STRING OR SDT                    01694000
*                                                                       01695000
MNOTE    EQU   SPACE                                                    01696000
ENTRY    EQU   MNOTE                                                    01697000
PUSH     EQU   MNOTE                                                    01698000
POP      EQU   MNOTE                                                    01699000
PUNCH    EQU   MNOTE                                                    01700000
PRINT    EQU   MNOTE                                                    01701000
USING    EQU   MNOTE                                                    01702000
DROP     EQU   MNOTE                                                    01703000
*                                                                       01704000
*        NAME = SS OR NOT USED                                          01705000
*        OPERAND = RELOCATABLE SYMBOLS SEPARATED BY COMMAS              01706000
*                                                                       01707000
EXTRN    EQU   *                                                        01708000
WXTRN    EQU   *                                                        01709000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR NOT USED     01710000
         GOIF  SNOFND,ON=AOPXIT         BRANCH IF NO OPERAND            01711000
         BAL   RETURN,GSCAN             ELSE, SCAN IT                   01712000
         MVI   SDENTR1,ORDSYMBD         EST DIR ENTRY INDEX             01713000
         ST    INDEXO,NAMP1             SAVE PTR TO OPND FOR DIR ENTRY  01714000
         SET   SDENT,ON                 POINT OF DEFINITION             01715000
         B     AOPPTR                   LOG OPERAND POINTER             01716000
*                                                                       01717000
MCHINS   EQU   *                                                        01718000
         BAL   RETURN,STMTDSQ           STATEMENT SEQUENCING            01719000
MCHIN10  EQU   *                                                        01720000
         BAL   TLINK,CKANYSYM           CHECK NAME                      01721000
MCHIN15  EQU   *                                                        01722000
         GOIF  SNOFND,ON=AOPXIT         BRANCH IF NO OPERAND            01723000
         BAL   RETURN,GSCAN             ELSE SCAN IT                    01724000
         B     AOPPTR                   LOG OPERAND POINTER             01725000
*                                                                       01726000
*        NAME = ANY SYMBOL OR NOT USED                                  01727000
*        OPERAND = EXP., STRING, SYMBOL OR SDT                          01728000
*                                                                       01729000
START    EQU   MCHIN10                  EDIT AS MACHINE OP              01730000
CNOP     EQU   START                                                    01731000
ORG      EQU   START                                                    01732000
DXD      EQU   START                                                    01733000
CCW      EQU   START                                                    01734000
DC       EQU   START                                                    01735000
DS       EQU   START                                                    01736000
TITLE    EQU   MCHIN15                                                  01737000
*                                                                       01738000
*        NAME = OS OR VS                                                01739000
*        OPERAND = NOT USED                                             01740000
*   LET ASSEMBLY PHASE CATCH SS OR BLANK IN NAME FIELD                  01741000
*                                                                       01742000
DSECT    EQU   CSECT                                                    01743000
         SPACE 3                                                        01744000
GBLA     MVI   FLAGBT,GAFLG             INDICATE GBLA                   01745000
         B     GLX                      CHECK NAME FIELD                01746000
GBLB     MVI   FLAGBT,GBFLG             INDICATE GBLB                   01747000
         B     GLX                      CHECK NAME FIELD                01748000
GBLC     MVI   FLAGBT,GCFLG             INDICATE GBLC                   01749000
         B     GLX                      CHECK NAME FIELD                01750000
LCLA     MVI   FLAGBT,LAFLG             INDICATE LCLA                   01751000
         B     GLX                      CHECK NAME FIELD                01752000
LCLB     MVI   FLAGBT,LBFLG             INDICATE LCLB                   01753000
         B     GLX                      CHECK NAME FIELD                01754000
LCLC     MVI   FLAGBT,LCFLG             INDICATE LCLC                   01755000
GLX      EQU   *                                                        01756000
         ST    INDEXP,OFPTRSV                                           01757000
         BAL   TLINK,CHKNM              NAME MUST BE BLANK              01758000
         GOIF  SNOFND,ON=NOPNDER        LOG ERROR IF NO OPERAND FOUND   01759000
         SET   SGBLCL,ON                INDICATE EDITING DECLARATION    01760000
         ST    INPTR,FPTRSV             SAVE BEGIN OF OPERAND           01761000
GLX05    ST    INPTR,OPNDPTR            INCASE OF BACK UP               01762000
         CLI   D0(INPTR),JAMPER         TEST IF AMPERSAND               01763000
         BNE   GLXERR                   COULDN'T BE V-SYM. ERROR        01764000
         BAL   RETURN,VARSYM            POSSIBLY.                       01765000
         LR    INPTR,R1                 RESTORE POINTER                 01766000
         TM    DERRCD,BITFF             TEST IF ANY ERROR IN DICT RTN   01767000
         BZ    GLX10                    CONTINUE IF NO ERROR            01768000
         SET   JPRONLY,ON               SET TO PRINT THIS STMT          01769000
         CLI   DERRCD,ERR9              SEE IF ERR WAS DICT OVERLAP     01770000
         BE    GLX20                    STOP SCANNING STMT IF YES       01771000
GLX10    CLI   D0(INPTR),JCOMMA         TERMINATOR MUST BE A COMMA      01772000
         BNE   GLX15                    OR A BLANK                      01773000
         LA    INPTR,D1(,INPTR)         YES, A COMMA                    01774000
         B     GLX05                    EDIT NEXT DECLARATION           01775000
GLX15    CLI   D0(INPTR),JBLANK                                         01776000
         BNE   GLXERRZ                  LOG ERROR IF NEITHER            01777000
GLX20    BAL   R12,VTPUT0               A BLANK MEANS END OF STMT       01778000
         SET   SGBLCL,OFF                                               01779000
         GOIF  SKPEND,OFF=AOPPTR        BR IF NO DICT OVERLAP (NO ERR9) 01780000
         L     INDEXO,OUTADR            RESTORE AFTER ERR9 CLEANUP WORK 01781000
         B     AOPPTR                   LOG OPERAND POINTER             01782000
         SPACE 3                                                        01783000
ACTR     EQU   *                                                        01784000
         BAL   TLINK,CHKSSNM            SEQ SYM OR BLANK        OX00404 01785000
         MVI   MCALL,MCLA               PROCESS LIKE A SETA STMT        01786000
         B     SETX05                   GO PROCESS                      01787000
SETX     EQU   *                                                        01788000
SETA     EQU   SETX                                                     01789000
SETB     EQU   SETX                                                     01790000
SETC     EQU   SETX                                                     01791000
         L     R14,RAVSP               CLEAR                    OX02957 01792000
         LA    R14,RFLGLOC(,R14)        EXPRESSION              OX02957 01793000
         MVI   RSTKVST,X'00'            STATUS                  OX02957 01794000
         CLI   NAMBYT,RVSYM             TEST IF NAME A V. S.            01795000
         BNE   ILSETNM                  LOG ERROR IF NOT                01796000
         MVI   NAMBYT,J0                RESET FOR NEXT STMT    @OX10953 01797000
         SR    R14,R14                                                  01798000
         IC    R14,OCSAVE                                               01799000
         SR    R15,15                                                   01800000
         IC    R15,NAMABC-JTSETA(R14)   GET CORRESPONDING V.S.FLAG      01801000
         NI    VSTAT,X'13'                                              01802000
         CH    R15,VSFLG                TEST SET VAR FOR RIGHT TYPE     01803000
         BNE   ILSETNM                  LOG ERROR IF NOT                01804000
         IC    R14,SENTVAL-JTSETA(R14)  PICK UP METASCAN ENTRY CODE     01805000
         STC   R14,MCALL                AND SAVE IN MCALL               01806000
SETX05   EQU   *                                                        01807000
         GOIF  SNOFND,ON=NOPNDER        OPERAND IS REQUIRED             01808000
         ST    INPTR,FPTRSV                                             01809000
         ST    INDEXP,OFPTRSV                                           01810000
         TM    MCALL,MCLA+MCLC          TEST IF SETB STATEMENT          01811000
         BZ    SETB05                   BRANCH IF YES                   01812000
         BAL   RETURN,METASCAN          GO EDIT SETA/SETC OPERAND       01813000
         CLI   D0(INPTR),JBLANK         BLANK IS A GOOD TERMINATOR      01814000
         BE    SETX10                   IT IS                           01815000
         C     INPTR,ENDATA             IF NOT, ENDATA MUST.            01816000
         BL    ILSETX                   LOG ERROR IF IT DOESN'T         01817000
         BCTR  INPTR,0                  MINUS 1                         01818000
SETX10   EQU   *                                                        01819000
         BAL   R12,VTENT15              WRAP UP OPERAND                 01820000
         B     AOPPTR                   COMPUTE FIELD POINTER           01821000
SETB05   EQU   *                                                        01822000
         MVC   D0(L'SBDSDT,INDEXP),SBDSDT TREAT 0,1,(0),(1) AS DSDT     01823000
         CLI   D1(INPTR),JBLANK         IF 0 OR 1 DOES NOT STAND ALONE  01824000
         BNE   SETB20                   EVALUATE AS EXPR                01825000
         CLI   D0(INPTR),D1             TEST IF VALUE 0 OR 1            01826000
         BH    SETB20                   BR IF NOT                       01827000
         BL    SETB16                   ZERO                            01828000
SETB15   MVI   D4(INDEXP),D1            MAKE DSDT 1                     01829000
SETB16   LA    INPTR,D1(,INPTR)                                         01830000
         LA    INDEXP,L'SBDSDT(,INDEXP) BUMP POINTER                    01831000
         BAL   R12,VTPUT0               BUILD V.T.                      01832000
         B     AOPPTR                   LOG OPERAND POINTER             01833000
AIF      EQU   *                                                        01834000
         MVI   MCALL,D0                 INDICATE EDITING SETB           01835000
         BAL   TLINK,CHKSSNM            NAME MUST BE SS OR BLANK        01836000
         ST    INPTR,FPTRSV                                             01837000
         ST    INDEXP,OFPTRSV                                           01838000
         GOIF  SNOFND,ON=NOPNDER        GO LOG ERROR ON MISSING OPERAND 01839000
SETB20   EQU   *                                                        01840000
         CLI   D0(INPTR),JLPARN         EXPRESSION MUST BE W/N ( )      01841000
         BNE   ILGLXP1                  LOG ERR IF NOT                  01842000
         BAL   R3,PFXRENT               ENTER L-PAREN                   01843000
         DC    AL2(JTMLPAR)             INTO POSTER                     01844000
         BAL   RETURN,METASCAN          SCAN IT                         01845000
         CLI   D0(INPTR),JRPARN         TERMINATOR MUST BE A R-PAREN    01846000
         BNE   ILGLXP1                  GO TO LOG EITHER ERR24 OR ERR32 01847000
         LR    R0,R3                    SAVE EXIT CODE                  01848000
         BAL   R3,PFXRENT               ENTER R-PAREN                   01849000
         DC    AL2(JTMRPAR)             INTO POSTER                     01850000
         LR    R3,R0                    RESTORE EXIT CODE               01851000
         CH    R3,H2                    DO NOT ALLOW SETC STATS OX00406 01852000
         BE    SETX30                   ALLOW SETA EXPRESSION   OX00406 01853000
         CH    R3,H1                    EXPRESSION MUST BE COMPLEX OR   01854000
         BH    ILBXP                    SIMPLE. ELSE, ERROR             01855000
         BE    SETX30                   OK IF COMPLEX                   01856000
         L     R14,RAVSP                                                01857000
         LA    R14,RFLGLOC(,R14)        CHECK EXPRESSION STATUS         01858000
         TM    RSTKVST,VSLS             SIMPLE BOOLEAN  ...             01859000
         BO    ILBXP                    DOESN'T TOLERATE SYSLIST        01860000
SETX30   EQU   *                                                        01861000
         CLI   OCSAVE,JTAIF             TEST IF AIF STATEMENT           01862000
         BE    AIF1                     BR IF THIS IS AIF               01863000
         CLI   D0(INPTR),JBLANK         MUST HAVE BLANK TERMINATOR      01864000
         BE    SETX10                   SETB OPERAND TERMINATOR IS OK   01865000
         B     INVFM                    LOG ERR32, SNAP INVALID TEXT    01866000
         SPACE 3                                                        01867000
AIF1     EQU   *                                                        01868000
         BAL   R3,PFXRENT               LOG END STMT FLAG               01869000
         DC    AL2(JTMSTRM)             FLAG                            01870000
         BCTR  INPTR,D0                 DON'T GET CARRIED AWAY          01871000
         SET   GAIF,ON                  INDICATE AIF STATEMENT          01872000
         BAL   RETURN,GSCAN1            GO SCAN SEQ SYMBOL              01873000
         SET   GAIF,OFF                                                 01874000
         B     AGO1                     WRAP UP LIKE AGO STMT           01875000
         SPACE 3                                                        01876000
SBDSDT   DS    0CL9                     M.T. FORMAT FOR 0 OR (0) SDT    01877000
         DC    AL1(JTMSDT,0,0,0,0,0,JTMSTRM,0,7) M.T. INT'L FORMAT      01878000
SENTVAL  DC    AL1(MCLA,0,MCLC)         METASCAN ENTRY CODE FOR SETX    01879000
NAMABC   DC    AL1(0,1,3)               SET VARIABLE VALUE IN FLGBYT    01880000
         DS    0H                                                       01881000
         SPACE 3                                                        01882000
*                                                                       01883000
*        NAME = OS OR VS                                                01884000
*        OPERAND = EXPRESSION                                           01885000
*                                                                       01886000
*   LET ASSEMBLY PHASE CATCH SS OR BLANK IN NAME FIELD                  01887000
EQU      EQU   MCHIN10                                                  01888000
         SPACE 3                                                        01889000
INVALID  EQU   AOPXIT                                                   01890000
         EJECT                                                          01891000
*********************************************************************** 01892000
*        SKIP BLANKS BETWEEN FIELDS                                   * 01893000
*        AT ENTRY INPTR POINTS TO BEGIN OF FIELD                      * 01894000
*********************************************************************** 01895000
SKPBLK   EQU   *                                                        01896000
         L     TWKREG2,ENDATA           GET END OF DATA ADDRESS         01897000
SKPBLK0  EQU   *                                                        01898000
         SET   SNOFND,OFF                                               01899000
         LA    TWKREG1,1                THE INCREMENT IS ONE BYTE       01900000
         BCTR  TWKREG2,0                SET BXLE LOOP UPPER LIMIT       01901000
         BCT   INPTR,SKPBLK2            AND BEGIN ADDRESS - 1           01902000
SKPBLK1  EQU   *                                                        01903000
         CLI   D0(INPTR),JBLANK         TEST IF BLANK                   01904000
         BCR   7,TLINK                  EXIT IF NOT                     01905000
SKPBLK2  EQU   *                                                        01906000
         BXLE  INPTR,TWKREG1,SKPBLK1    ELSE, LOOK UP NEXT COLUMN       01907000
         SET   SNOFND,ON                UNTIL ENDATA                    01908000
         BR    TLINK                    RETURN TO CALLER                01909000
         EJECT                                                          01910000
*****************************************                               01911000
*        SET O/P BUFFER LOCATION        *                               01912000
*****************************************                               01913000
OPUTL    EQU   *                                                        01914000
         ST    RETURN,EDTSVX                                            01915000
         JPUTL FILE=FILE1,BUFREQ=(R11) GET NEXT OUTPUT BUFFER           01916000
         L     RETURN,EDTSVX                                            01917000
         ST    RETADR,OUTADR            SAVE BEGIN ADDRESS              01918000
         LR    INDEXO,RETADR            JTEXT BASE                      01919000
         LA    INDEXP,JTHDRLN(,INDEXO)  JTEXT BASE 2                    01920000
         BR    RETURN                   RETURN TO CALLER                01921000
         SPACE 3                                                        01922000
*********************************************                           01923000
*        EDITED TEXT INITIALIZATION         *                           01924000
*********************************************                           01925000
HDINIT   EQU   *                                                        01926000
         LCR   TWKREG1,INDEXO           LET ALL FIELD POINTERS          01927000
         AR    TWKREG1,INDEXP           POINT TO THE DUMMY FIELD        01928000
         XC    JTRLI(JTHDRLN+2),JTRLI   CLEAR HEADER                    01929000
         STH   TWKREG1,JTNMP                                            01930000
         LA    INDEXP,D2(,INDEXP)       BUMP OVER DUMMY FIELD           01931000
RESETPTR EQU   *                                                        01932000
         MVC   JTOCP(JTSYMCNT-JTOCP),JTNMP                              01933000
         BR    RETURN                   RETURN TO CALLER                01934000
         EJECT                                                          01935000
*******************************                                         01936000
******     CONSTANTS     ******                                         01937000
*******************************                                         01938000
         PRINT DATA                                                     01939000
ETMOV    MVC   D1(*-*,INDEXP),D0(GSPTR) OFF-THE-LINE MOVE               01940000
ARDSRC   DC    A(RDSRC)                 RDSRC ENTRY POINT               01941000
ARDSRC05 DC    A(RDSRC05)               RDSRC05 ENTRY POINT             01942000
ATRTEST  DC    A(TRTEST)                TRTEST ENTRY POINT              01943000
ATRT01   DC    A(TRT01)                 TRT01 ENTRY POINT               01944000
ATRT02   DC    A(TRT02)                 TRT02 ENTRY POINT               01945000
SRCLEN   DC    F'70'                    DATA PORTION MOVE LENGTH        01946000
BEGCOL   DC    F'0'                     BEGIN COLUMN MINUS 1            01947000
CONTCHR  DC    F'71'                    CONT CHR COLUMN MINUS 1         01948000
SEQCOL   DC    F'72'                    SEQ FLD BEGIN COL MINUS 1       01949000
SEQLEN   DC    F'7'                     SEQ FLD MOVE LENGTH             01950000
CONTBGN  DC    F'15'                    CONT COLUMN MINUS 1             01951000
CONLEN   DC    F'55'                    CONT FLD MOVE LENGTH            01952000
*                                                                       01953000
F15      DC    F'15'                    MASKING CONSTANTS               01954000
F31      DC    F'31'                    .                               01955000
RSTKLEN  DC    AL2(EDRSTK-BDRSTK)       RSTACK LENGTH                   01956000
CSTKLEN  DC    AL2(EDCSTK-CSTKNOTE)     CSTACK LENGTH                   01957000
HATT     DC    AL2(JTMTAT-2)            ATTR FLAG CONV BASE V           01958000
H32K     DC    H'32767'                 MAXIMUM DIMENSION ALLOWED       01959000
H80      DC    H'80'                    STANDARD CARD LENGTH            01960000
H40      DC    H'40'                    STANDARD DATA LENGTH            01961000
DOTSTAR  DS    0CL2                                                     01962000
         DC    AL1(JPERIOD,JASTER)      GENERATED COMMENT STMT          01963000
CMABLK   DC    AL1(JCOMMA,JBLANK)       FIELD TERMINATOR                01964000
         DS    0H                       HALF WORD ALIGNMENT             01965000
FXDHD    DS    0CL20                                                    01966000
         DC    AL2(0)                   RECORD LENGTH                   01967000
PUTFLG   DC    AL1(JPSOP,JPRONLY)       ASSEMBLER OP / PRINT ONLY       01968000
         DC    AL1(JTCMNT,J0)           INTERNAL OP CODE                01969000
         DC    5AL2(COMIT-FXDHD)        DUMMY POINTERS                  01970000
         DC    2X'00'                   TWO FIELDS                      01971000
COMIT    DC    2X'00'                   DUMMY FIELD                     01972000
COMDTA   EQU   *                        END OF FXDHD                    01973000
         DS    0H                                                       01974000
*********************************************************************** 01975000
*  STANDARD CATEGORIES AND TYPES CORRESPONDING TO SPECIAL CHARACTERS  * 01976000
*                                                                     * 01977000
*  INTERNAL CODE MINUS 39.  0 1 2 3 4 5 6 7 8 9 1011                  * 01978000
*  SPECIAL CHARACTER        = ( + - * / ) ,   ' & .                   * 01979000
QMDTBL   DC            XL12'000000000000000003050200'  QUOTE MODE ARG * 01980000
STDTBL   DC            XL12'030406060606030303050203'  STANDARD CATEG * 01981000
*TRTSRC  DC            XL12'00040A0B080905022F000003'  TYPE NUMBER    * 01982000
TRTSRC   DS    0CL12                                                  * 01983000
         DC    AL1(JEQUAL,JTMLPAR,JTMADD,JTMSUB,JTMMULT,JTMDIV)       * 01984000
         DC    AL1(JTMRPAR,JTMCOM,JBLANK,JTMSCM,JAMPER,JTMPER)        * 01985000
*********************************************************************** 01986000
         PRINT NODATA                                                   01987000
         SPACE 3                                                        01988000
         JPATCH  X1A00,FEE                                              01989000
         EJECT                                                          01990000
         JCSECT (X1A10=CS2)                                             01991000
**************************************                                  01992000
*        VIRTUAL TEXT BUILDER        *                                  01993000
**************************************                                  01994000
VTENT    EQU   *                                                        01995000
         GOIF  METSW,ON=VTENT10         BRANCH IF GOOD M.T. EXISTS      01996000
VTENT05  EQU   *                                                        01997000
         L     INDEXP,OFPTRSV           ELSE, WIPE OFF MT SO FAR BUILT  01998000
         B     VTPUT0                   BUILD V.T.                      01999000
VTENT10  EQU   *                                                        02000000
         GOIF  GAIF,ON=VTENT20          BRANCH IF AIF STATEMENT         02001000
         GOIF  GSUBS,OFF=VTENT20        BRANCH IF NO SUBSTITUTION       02002000
         BAL   RETURN,MTENT10          ELSE, WRAP UP MT                 02003000
         LR    INPTR,R1                 KEEP INPTR CURRENT              02004000
         OC    JTFLGB,SWITCH8           AND INDICATE SUBSTITUTION       02005000
VTENT15  EQU   *                                                        02006000
         LR    R0,R12                   SAVE RETURN POINT               02007000
         BAL   R3,PFXRENT               END OF M.T.                     02008000
         DC    AL2(JTMSTRM)             STATEMENT TERMINATOR            02009000
         BCTR  INPTR,D0                 BACK UP                         02010000
         LR    R12,R0                   RESTORE RETURN POINT            02011000
VTENT20  SET   (GSUBS,METSW),OFF                                        02012000
         LR    R14,INDEXP               COMPUTE MT LENGTH               02013000
         S     R14,OFPTRSV                                              02014000
         STH   R14,JHWORD1              ENTER MT LENGTH                 02015000
         MVC   D0(L'JHWORD1,INDEXP),JHWORD1                             02016000
         LA    INDEXP,D2(,INDEXP)                                       02017000
VTPUT0   EQU   *                                                        02018000
         L     RCNT,INPUT                                               02019000
VTPUT    EQU   *                                                        02020000
         ST    INDEXP,OFPTRSV           SAVE VT BEGIN LOC FOR PTR CALC  02021000
         GOIF  JPSOP,OFF=VTPUT02        SUPPRESS VT ON PSEUDO OPS       02022000
         CLI   OCSAVE,JTPEND            LOOK ONLY AT GENERATOR OPS,     02023000
         BH    VTPUT02                  THOSE BETWEEN ANOP AND PEND     02024000
         CLI   OCSAVE,JTANOP            IF NON-GENERATOR OP, PUT        02025000
         BL    VTPUT02                  OUT VIRTUAL TEXT EVERY TIME     02026000
         GOIF  SPGRMD,ON=VTPUT02        PUT V.T. FOR PRGMR MACRO DEF    02027000
         GOIF  SSYSMD,OFF=VTPUT40       BRANCH IF IN OPEN CODE          02028000
         GOIF  SXPRTO,OFF=VTPUT50       BRANCH IF INNER CALL STMT       02029000
         GOIF  (JMLOGIC,JSYSMAC),NONE=VTPUT60 PUT VT IF MACRO COND'T'NL 02030000
VTPUT02  EQU   *                        ASSEMBLY TO BE PRINTED          02031000
         L     GSPTR,FPTRSV             RESTORE INPUT FIELD BEGIN ADDR  02032000
VTPUT05  EQU   *                                                        02033000
         LM    R9,R11,TBGLN                                             02034000
         LA    R14,D1(,GSPTR)           COMPUTE RELATIVE FIELD LOCATION 02035000
         SR    R14,RCNT                 IN INPUT WORK BUFFER            02036000
         LH    TRTN,H1                  AND TAKE CARE OF CARD COUNTER   02037000
VTPUT10  CR    R14,R10                  ARE WE IN THE RIGHT CARD        02038000
         BNH   VTPUT20                  YES                             02039000
         SR    R14,R11                  NO. SUBTRACT COUNT LENGTH       02040000
         AH    TRTN,H1                  INCREMENT CARD COUNT BY 1       02041000
         B     VTPUT10                  CHECK NEXT CARD                 02042000
VTPUT20  AR    R14,R9                   ADD PRE-BEGIN STRING LENGTH     02043000
         CH    TRTN,H1                  DID WE STOP IN THE 1ST CARD     02044000
         BE    VTPUT30                  DON'T ENTER CARD POINTER IF YES 02045000
         STC   TRTN,D0(,INDEXP)         ELSE, A ONE-BYTE CARD POINTER   02046000
         OI    D0(INDEXP),BIT0          PRECEDING COLUMN POINTER        02047000
         LA    INDEXP,D1(,INDEXP)                                       02048000
VTPUT30  STC   R14,D0(,INDEXP)          ENTER COLUMN POINTER            02049000
         LA    INDEXP,D1(,INDEXP)                                       02050000
         LR    R15,INPTR                COMPUTE STRING LENGTH           02051000
         SR    R15,GSPTR                                                02052000
         STC   R15,D0(,INDEXP)          AND ENTER IT                    02053000
         BCTR  R15,0                    DECR LENGTH BY 1                02054000
         EX    R15,ETMOV                MOVE VT TO OUTPUT BUFFER        02055000
         LA    INDEXP,D2(R15,INDEXP)    BUMP TO NEXT AVAILABLE LOCATION 02056000
         BR    R12                      EXIT VT RTN                     02057000
VTPUT40  CLI   OCSAVE,JTMACRO           LOOK ONLY AT OPEN CODE SUBSET   02058000
         BE    VTPUT02                  OF GENERATOR OPS                02059000
         CLI   OCSAVE,JTSETC            IF NOT IN THAT RANGE, PUT       02060000
         BH    VTPUT02                  OUT VIRTUAL TEXT EVERY TIME     02061000
         GOIF  JALOGIC,ON=VTPUT02       ALWAYS PUT V.T. IF ASM LOGIC ON 02062000
         GOIF  JSYSMAC,OFF=VTPUT60      NO V.T. IF SYS MACS NOT PRINTED 02063000
         B     VTPUT02                  PUT V.T. INCASE GENERATED END   02064000
VTPUT50  GOIF  (JCALLS,JMLOGIC,JSYSMAC),ANY=VTPUT02 PUT VT IF INNERS TO 02065000
VTPUT60  SET   SMISCN,ON                INDICATE NO V.T. OUTPUT         02066000
         BR    R12                      BE PRINTED, ELSE, EXIT          02067000
         EJECT                                                          02068000
*********************************************************************** 02069000
*  GSCAN SCANS AND CLASSIFIES ALL INPUT SOURCE STATEMENTS EXCEPT      * 02070000
*  OPERANDS ON AIF, AGO, SETX, MACRO INSTRUCTION, AND PROTOTYPE       * 02071000
*  STATEMENTS. SCAN RESULTS ARE RETURNED IN LOCATION GSUMRY. THE      * 02072000
*  FIELD SCANNED IS EDITED INTO VIRTUAL TEXT AND, IF NECESSARY, META  * 02073000
*  TEXT FORMATS IN OUTPUT BUFFER.                                     * 02074000
*  AT ENTRY GQST IS SET TO ZERO TO START QUOTE STATUS CHECKING        * 02075000
*                0 = EVEN NUMBER OF QUOTE FOUND AT EXIT               * 02076000
*                1 = ODD NUMBER OF QUOTE FOUND AT EXIT                * 02077000
*  GMET IS SET ON WHEN A META TEXT IS BUILT FOR A FIELD               * 02078000
*  RESULTS RETURNED FROM TRT ARE                                      * 02079000
*                R1 = TERMINATING CHARACTER ADDRESS                   * 02080000
*                R3 = CATEGORY NUMBER OF THE TERMINATING CHARACTER    * 02081000
*                R10= TYPE FLAG NUMBER OF THE TERMINATING CHARACTER   * 02082000
*                R15= STRING/SYMBOL MOVE LENGTH                       * 02083000
*                                                                     * 02084000
*  LINKAGE IS  BAL  RETURN,GSCAN                                      * 02085000
*********************************************************************** 02086000
         SPACE 3                                                        02087000
GSCAN    EQU   *                                                        02088000
         ST    INPTR,FPTRSV             SAVE BEGIN ADDRESS FOR V.T.     02089000
         ST    INDEXP,OFPTRSV                                           02090000
GSCAN1   EQU   *                                                        02091000
         ST    INPTR,MEZZOPTR           SAVE MEZZO POINTER              02092000
         ST    RETURN,EDTSVX            SAVE RETURN POINT               02093000
         MVI   GSUMRY,D0                CLEAR SCAN RESULT BYTE          02094000
GSCNMOP  EQU   *                                                        02095000
         GOIF  GQST,ON=GSCQMD           BRANCH IF IN QUOTE MODE         02096000
         L     LINK,ATRTEST             POINT TO TRTEST                 02097000
         BALR  RETURN,LINK              GO TO TRTEST                    02098000
GSCFAN   AR    R3,R3                    DOUBLE THE CATEG NUMBER         02099000
         LH    R14,GSCTBL(R3)           PICK UP REL ENTRY               02100000
         B     GSCTBL(R14)              AND FAN OUT                     02101000
GSCQMD   MVC   SPECHAR(L'QMDTBL),QMDTBL STOP ON QT, &, BLANK, ENDATA    02102000
         LA    PARM,D2                  DON'T DO SYN STG SEARCH         02103000
         LA    RETURN,GSCFAN            GET RETURN POINT                02104000
         L     LINK,ATRT02              POINT TO TRT02                  02105000
         BR    LINK                     GO TRT                          02106000
         EJECT                                                          02107000
GSCTBL   EQU   *                        CATEGORIES                      02108000
         DC    AL2(GSADV-GSCTBL)        0 = DECIMAL                     02109000
         DC    AL2(GSALFA-GSCTBL)       1 = ALPHAMERIC                  02110000
         DC    AL2(GSAMPR-GSCTBL)       2 = AMPERSAND                   02111000
         DC    AL2(GBLK-GSCTBL)         3 = ,=.) OR BLANK               02112000
         DC    AL2(GSCIMP-GSCTBL)       4 = (                           02113000
         DC    AL2(GQOTS-GSCTBL)        5 = QUOTE                       02114000
         DC    AL2(GSCIMP-GSCTBL)       6 = +-*/                        02115000
         DC    AL2(LTRLQT-GSCTBL)       7 = L' I' S' K' N'              02116000
         DC    AL2(LTRQT-GSCTBL)        8 = X' B' C' SDT                02117000
         DC    AL2(LTRQTIN-GSCTBL)      9 = T'                          02118000
         DC    AL2(GSALFA-GSCTBL)       10 = BOOLEAN OPERATOR           02119000
         DC    AL2(GSALFA-GSCTBL)       11 = RELATIONAL OPERATOR        02120000
         DC    AL2(GENDT-GSCTBL)        12 = NON-ASSEMBLER              02121000
         EJECT                                                          02122000
         SPACE 3                                                        02123000
GENDT    EQU   *                                                        02124000
         C     INPTR,ENDATA             HAVE WE PAST ENDATA             02125000
         BNL   GSVTENT                  YES, WRAP UP VT                 02126000
GSCIMP   OI    GSUMRY,RMPURE            INDICATE IMPURITY               02127000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    02128000
         B     GSCNMOP                  AND PLOD ONWARD                 02129000
GSS10    LR    INPTR,R1                 PLOD ONWARD                     02130000
         B     GSCIMP                                                   02131000
*                                                                       02132000
GBLK     EQU   *                                                        02133000
         CLI   D0(INPTR),JBLANK         TEST IF BLANK TERMINATES        02134000
         BE    GBLK10                   YES                             02135000
         CLI   D0(INPTR),JPERIOD        DID PERIOD TERMINATE            02136000
         BNE   GSCIMP                   BRANCH IF NOT                   02137000
*                                       ELSE PRAY FOR A S.S.            02138000
GSSSYM   EQU   *                                                        02139000
         TM    GSUMRY,BITFF             HAS ANYTHING BEEN DONE          02140000
         BNZ   GSCIMP                   BRANCH IF YES                   02141000
         GOIF  SKPNAME,ON=GSCIMP        BRANCH IF SKIPPING TO OP CODE   02142000
         LA    INPTR,D1(,INPTR)         FORGET THE DOT FOR A WHILE      02143000
         LA    PARM,D2                  GO TRT THE TRAILING STRING      02144000
         L     LINK,ATRT02              POINT TO TRT02                  02145000
         BALR  RETURN,LINK              W/O SYNTACTIC STRING SEARCH     02146000
         BCT   R3,GSS10                 CONTINUE IF NOT AN STRING       02147000
         CLI   D0(INPTR),JA             AND DIGIT HEAD IS               02148000
         BL    GSS10                    UNDESIRABLE. EDIT AS C STRING   02149000
         CLI   D0(R1),JBLANK            AND TERMINATOR MUST BE A BLANK  02150000
         BNE   GSS10                    ELSE EDIT AS C STRING           02151000
         GOIF  SENAME,ON=GSS20          BRANCH IF EDITING NAME FIELD    02152000
         GOIF  SEOPND,OFF=GSS10         BRANCH IF NOT EDITING OPERAND   02153000
         CLI   OCSAVE,JTAGO                                             02154000
         BE    GSS20                    BRANCH IF AGO STATEMENT         02155000
         CLI   OCSAVE,JTAIF                                             02156000
         BNE   GSS10                    BRANCH IF NOT AIF STMT          02157000
GSS20    EQU   *                                                        02158000
         BCTR  INPTR,0                  REMEMBER THE FORGOTTEN DOT      02159000
         LA    R15,D1(,R15)             AND ITS LENGTH                  02160000
         CH    R15,H8                   TEST IF LENGTH LE 8             02161000
         BNL   GSS10                    EDIT AS C STRING IF GE 8        02162000
         MVI   GSUMRY,RSSYM             SET ON SS INDICATOR             02163000
         BAL   RETURN,MTENT             GO MAKE D ENTRY                 02164000
GSADV    AR    INPTR,R15                                                02165000
         B     GSCIMP                   ADVANCE POINTER                 02166000
GSALFA   EQU   *                                                        02167000
         CLI   D0(R1),JBLANK            TEST IF TERMINATOR A BLANK      02168000
         BNE   GSADV                    ADVANCE POINTER AND CONT SCAN   02169000
         GOIF  SKPNAME,ON=GSA05         BRANCH IF SKIPPING NAME FIELD   02170000
* CHARACTER STRING WILL NOT BE BUILT IN MT UNTILL ENCOUNTERED           02171000
* A TRAILING BLANK OR AMPERSAND                                         02172000
         TM    GSUMRY,BITFF             ANYTHING DONE YET               02173000
         BNE   GSA10                    BRANCH IF YES                   02174000
         CH    R15,H8                   IT'S AN OS. HOW ABOUT LENGTH    02175000
         BNL   GSA10                    LONGER THAN 8 IS EDITED AS STG  02176000
         MVI   GSUMRY,ROSYM             A GOOD OS                       02177000
         BAL   RETURN,MTENT             GO MAKE D ENTRY                 02178000
GSA05    LR    INPTR,R1                 BUMP TO THE TERMINATOR          02179000
         B     GBLK10                   WHICH IS A BLANK                02180000
GSA10    GOIF  METSW,OFF=GSA05          BRANCH IF THUS FAR NO MT BUILT  02181000
         GOIF  GQST,ON=GSADV            TOO EARLY TO BUILD MT IF IN QT  02182000
         BAL   RETURN,MTENT10           ELSE FINISH BUILDING MT         02183000
         B     GSA05                    GO TO FIELD TERMINATOR          02184000
GSAMPR   EQU   *                                                        02185000
         CLI   D1(INPTR),JAMPER         TEST IF DOUBLE AMPERSAND        02186000
         BNE   GSM10                    BRANCH IF NOT                   02187000
         LA    INPTR,D1(,INPTR)         ELSE, EDIT AS C STRING          02188000
         B     GSCIMP                   '&&' EDITED AS CHARACTER STRING 02189000
GSM10    EQU   *                                                        02190000
         GOIF  (SKPNAME,PROTOCAL),ANY=GSCIMP BR IF SKIPPING TO OP CODE  02191000
         CLI   OCSAVE,JTOPSYN           VAR SYM IN NAME/OPND OF OPSYN   02192000
         BNE   GSM15                    NO, GO TO DIR ROUTINE           02193000
         GOIF  SNMFND,OFF=ILOPSYN       VAR SYM IN OPND FIELD OF OPSYN  02194000
* VAR SYMBOL IN NAME FIELD OF OPSYN IS DISALLOWED--IT'S SCANNED AND     02195000
*  ENTERED INTO THE TEXT, BUT THE DIRECTORY ROUTINE IS BYPASSED--       02196000
*  THE ERROR ITSELF WILL BE DETECTED IN THE OPSYN ROUTINE               02197000
         SET   RVSYM,ON                 ERR-VAR SYM IN OPSYN NAME FIELD 02198000
         LA    INPTR,D1(,INPTR)         BUMP OVER '&' AND SCAN TO END   02199000
         LA    R10,D2                   OF VAR SYM, NO SYNTACTIC SCAN   02200000
         L     LINK,ATRT01              POINT TO TRT01                  02201000
         BALR  RETURN,LINK              SCAN THRU END OF SYM, ISOLATE   02202000
         B     GSA05                    NOW, GO PUT OUT THE ISOLATED SY 02203000
GSM15    EQU   *                                                        02204000
         BAL   RETURN,MTENT10           GO OUTPUT PRIOR MT              02205000
         LR    INPTR,R1                 UPDATE INPTR                    02206000
         BAL   RETURN,VARSYM            SCAN V.S. AND BUILD MT          02207000
* VARSYM ROUTINE SHOULD INDICATE RVSYM AND SET ON METSW, MAKE D ENTRY   02208000
* AND BUILD MT. AFTER RETURN, UPDATE INPTR TO NEXT SCAN LOCATION.     * 02209000
         LR    INPTR,R1                 POINT TO NEXT SCAN LOCATION     02210000
GSM20    EQU   *                                                        02211000
         MVI   ATTRSV,D0                RESET SYSLIST FLAGS             02212000
         CLI   D0(INPTR),JPERIOD        TEST IF TERMINATOR A DOT        02213000
         BNE   GSCNMOP                  BRANCH IF NOT                   02214000
         LA    INPTR,D1(,INPTR)         YES, IT IS A CONCATENATION      02215000
         ST    INPTR,MEZZOPTR           UPDATE POINTERS AND             02216000
         B     GSCNMOP                  CONTINUE SCANNING               02217000
GBLK10   EQU   *                                                        02218000
         GOIF  GQST,OFF=GSQXT           THAT'S END OF FLD IF NOT QT MD  02219000
         B     GQOTLP                   ELSE KEEP SCANNING              02220000
         SPACE                                                          02221000
LTRLQT   CLI   D0(INPTR),JL             TEST IF L' TYPE                 02222000
         BNE   LTRQTIN                  NOT WANTED IF NOT               02223000
         CLI   D2(INPTR),JA             LOOK AHEAD FOR ....             02224000
         BL    LTRQT                    POSSIBLE LONG FORM              02225000
         CLI   D2(INPTR),JAT            IF FOLLOWED BY ALPHA            02226000
         BNH   GSS10                    FORGET IT                       02227000
         CLI   D2(INPTR),JASTER                                         02228000
         BE    GSS10                    INCLUDING L'*                   02229000
         CLI   D2(INPTR),JAMPER         IF FOLLOWED BY AMPER   @AX16943 02230000
         BE    GSS10                    PROCEED CHECKING       @AX16943 02231000
LTRQTIN  GOIF  (SKPNAME,PROTOCAL),ANY=GSS10                             02232000
         SPACE                                                          02233000
LTRQT    OI    GSUMRY,RMPURE            IMPURITY                        02234000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    02235000
         SPACE                                                          02236000
GQOTS    SET   GQST,FLIP                FLIP THE ODD QUOTE CHECKER      02237000
         OI    GSUMRY,RQTSTG            INDICATE IN QUOTE MODE          02238000
         GOIF  SEOPCD,OFF=GQOTLP        BR IF NOT OPCODE       @OY04864 02239000
         GOIF  GQST,OFF=GQOTLP          BR IF NOT ODD QOUTE MD @OY04864 02240000
         CLI   D1(INPTR),JAMPER         ONLY '& VALID FOR-     @OY04864 02241000
         BE    GQOTLP                   QOUTE IN OPCODE        @OY04864 02242000
         SET   GQST,OFF                 RESET ODD QOUTE CHK    @OY04864 02243000
         GOIF  SKPNAME,ON=GQOTERR       BR IF NO NAME FIELD    @OY04864 02244000
         BAL   R12,VTENT                ELSE, LOG VT           @OY04864 02245000
GQOTERR  B     INVOP                    LOG HARD ERROR         @OY04864 02246000
GQOTLP   LA    INPTR,D1(,INPTR)         BUMP POINTER                    02247000
         B     GSCNMOP                  KEEP SCANNING                   02248000
         SPACE                                                          02249000
GSVTENT  L     INPTR,ENDATA             BE SURE PNT TO END     @OX07300 02250000
         GOIF  GQST,ON=ODDQT            ERR IF NO ENDING QUOTE @OX07300 02251000
         SPACE                                                          02252000
GSQXT    GOIF  SKPNAME,ON=GSQXT1        BRANCH IF SKIPPING NAME FIELD   02253000
         BAL   R12,VTENT                ELSE, LOG VT                    02254000
         SPACE                                                          02255000
GSQXT1   ST    INPTR,FPTRSV             SAVE NEXT LOC TO BE EDITED      02256000
         L     RETURN,EDTSVX            RESTORE RETURN POINT            02257000
         BR    RETURN                   RETURN                          02258000
         SPACE                                                          02259000
ODDQT    LR    R0,R1                                                    02260000
         BAL   TLINK,ABSERR             LOG ERROR                       02261000
         DC    AL1(SEV35)               .                               02262000
         DC    AL1(ERR35)               NO TERMINATING QUOTE            02263000
         LR    R1,R0                                                    02264000
         SET   GQST,OFF                                                 02265000
         B     GSQXT                    GO LOG VT                       02266000
         EJECT                                                          02267000
*********************************************************************** 02268000
* MTENT ROUTINE ONLY ENTERS ORDINARY SYMBOLS, SEQUENCE SYMBOLS AND      02269000
* CHARACTER STRINGS. VARIABLE SYMBOLS ARE ENTERED IN VARSYM ROUTINE.    02270000
* ORDINARY SYMBOL DEFINITION AND SEQUENCE SYMBOL DEFINITION ARE ENTERED 02271000
* INTO DIRECTORY AFTER THE EDITED TEXT FOR THE STATEMENT HAS BEEN       02272000
* COMPLETELY BUILT. SWITCH SDENT IS DESIGNED FOR SUCH PURPOSE.          02273000
* THE REST OF THE SYMBOLS ARE ENTERED INTO DIRECTORY AS SOON AS A       02274000
* SYMBOL IS RECOGNIZED AND FOUND TO BE A VALID ONE.                     02275000
*********************************************************************** 02276000
         SPACE 3                                                        02277000
MTENT    ST    RETURN,EDTSVY                                            02278000
         TM    GSUMRY,ROSYM             TEST IF O.S.                    02279000
         BO    MTTOS                    BRANCH IF YES                   02280000
         TM    GSUMRY,RSSYM             TEST IF S.S.                    02281000
         BNO   MTCSTG                   ASSUME C STRING IF NOT S.S.     02282000
         SPACE                                                          02283000
MTTSS    GOIF  SENAME,OFF=SSRTEMP  ******** T ********                  02284000
         MVI   SDENTR,SEQSYMBD          SAVE SS DEFINITION INDEX        02285000
         ST    R15,NAML                 SAVE NAME FIELD MOVE LENGTH     02286000
         ST    INPTR,NAMP               AND POINTER FOR                 02287000
MTSVPTR  SET   SDENT,ON                 POINT OF DEFINITION             02288000
         SPACE                                                          02289000
MTSVRTN  L     RETURN,EDTSVY            RESTORE POINTER                 02290000
         BR    RETURN                   THEN RETURN                     02291000
*********************************************************************** 02292000
         SPACE                                                          02293000
SSRTEMP  GOIF  SEOPND,OFF=MTCSTG        BRANCH IF NOT IN OPERAND        02294000
         MVI   DDNDX1,SEQSYMBR          SET UP INDEX FOR BR TO DIR RTN  02295000
         LR    PARM,INPTR               POINT TO THE SYMBOL             02296000
         LR    PARAM2,TWKREG2           AND THE LENGTH                  02297000
         BAL   R3,DIRENT                LOG SS REFERENCE                02298000
         MVC   D0(D4,INDEXP),D0(R11)    BUILD MT                        02299000
         LA    INDEXP,DENTLNG(,INDEXP)  BUMP 2 EXTRA BYTES FOR GEN'TOR  02300000
         B     METON                    GO SET METSW ON                 02301000
*********************************************************************** 02302000
MTTOS    GOIF  SENAME,OFF=MTTOS10       BRANCH IF NOT NAME FIELD        02303000
         GOIF  SMDEF,ON=GSA05           NO D ENTRY IF IN MACRO DEF.     02304000
         MVI   SDENTR,ORDSYMBD          SAVE OS DEF INDEX               02305000
         ST    INDEXO,NAMP              AND BEGIN POINT OF ET           02306000
         B     MTSVPTR                  GO TO RETURN                    02307000
         SPACE                                                          02308000
MTTOS10  GOIF  SEOPCD,OFF=MTCPY         BRANCH IF IN OPERAND            02309000
* MAKE IOC AND FLAGA ENTRY AFTER RETURN TO MAINLINE LOGIC               02310000
         LR    PARM,INPTR               GET OP CODE FIELD ADDRESS       02311000
         LR    PARAM2,TWKREG2           AND ITS MOVE LENGTH             02312000
         MVI   DDNDX1,OPERCODE          INDICATE OP CODE SEARCH         02313000
         BAL   R3,DIR10                 GO                              02314000
         ST    PARAM2,OCPTRSV           SAVE IOC POINTER                02315000
         MVI   OCSAVE,D0                ZERO IN CASE OF MACRO CALL      02316000
         TM    IOCID,BIT0+BIT1          TEST IF MACRO CALL              02317000
         BZ    MTTOS11                  BRANCH IF MACRO CALL/NAME       02318000
         BO    MTSVRTN                  BRANCH IF TWO BYTE OP CODE      02319000
         MVC   OCSAVE,D1(PARAM2)        PRESERVE ASSEMBLER OP CODE      02320000
         B     MTSVRTN                  GO TO EXIT                      02321000
         SPACE                                                          02322000
MTTOS11  GOIF  SXPRTO,ON=MTSVRTN        PROTOTYPE IS NOT WANTED         02323000
         MVC   D0(D3,INDEXP),D0(PARAM2) MAKE MT ENTRY IF MACRO CALL     02324000
         LA    INDEXP,D3(,INDEXP)       AND ADVANCE POINTER             02325000
METON    SET   METSW,ON                 INDICATE META TEXT BUILT        02326000
         B     MTSVRTN                  GO TO RETURN                    02327000
         SPACE                                                          02328000
MTCPY    GOIF  SCOPY,OFF=MTCSTG         BRANCH IF NOT EDITING COPY STMT 02329000
         MVI   COPYCODE,JBLANK          YES. CLEAR COPY CODE SAVE AREA  02330000
         MVC   COPYCODE+1(L'COPYCODE-1),COPYCODE                        02331000
         EX    TWKREG2,MVCOPY           AND SAVE COPY CODE              02332000
         BR    RETURN                   DO NOT BUILD MT                 02333000
MTCSTG   EQU   *                        BUILD C STRING IN MT            02334000
MTENT10  L     INPTR,MEZZOPTR                                           02335000
         LR    R14,R1                                                   02336000
         SR    R14,INPTR                TEST IF ANYTHING TO BE PUT      02337000
         BCR   BZ,RETURN                BRANCH IF NO                    02338000
         MVI   D0(INDEXP),JTMCS         ENTER FLAG                      02339000
         STC   R14,D1(,INDEXP)          AND ENTER IT                    02340000
         LA    INDEXP,D2(,INDEXP)       BUMP POINTER                    02341000
         BCTR  R14,0                    MAKE IT MOVE LENGTH             02342000
         EX    R14,MTXTMV               MOVE STRING TO MT               02343000
MTEXIT   LA    INDEXP,D1(R14,INDEXP)    BUMP TO NEXT AVAILABLE LOCATION 02344000
         ST    R1,MEZZOPTR              UPDATE MEZZOPTR                 02345000
         BR    RETURN                   RETURN                          02346000
MTXTMV   MVC   D0(1,INDEXP),D0(INPTR)   OFF-THE-LINE MOVE               02347000
MVCOPY   MVC   COPYCODE(0),INPOPR       OFF-THE-LINE MOVE               02348000
         EJECT                                                          02349000
*********************************************************************** 02350000
*  RECURSIVE ROUTINE TO SCAN VARIABLE SYMBOLS                           02351000
*  THE LINKAGE IS BAL RETURN,VARSYM                                     02352000
*********************************************************************** 02353000
         SPACE 3                                                        02354000
VARSYM   BAL   R12,RENTSTK              MAKE RECURSION STACK ENTRY      02355000
*BUMP THE POINTER PAST THE '&' FOR THE DIRECTORY ROUTINE                02356000
         ST    INPTR,TPSAVE             SAVE BEGIN PT FOR SNAP          02357000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    02358000
         LA    R10,D2                   NO SYNTACTIC STRING SEARCH      02359000
         L     LINK,ATRT01              POINT TO TRT01                  02360000
         BALR  RETURN,LINK              GO ISOLATE V.S. TRAILER WHICH   02361000
         CH    R3,H1                    MUST BE A/N STRING              02362000
         BNE   ILGVS                    ELSE, LOG ERROR                 02363000
         CH    R15,H6                   AND LENGTH MUST BE LE 8         02364000
         BH    ILGVS                    ELSE, LOG ERROR                 02365000
* MAKE DIRECTORY ENTRY FOR VS - DISTINGUISH DEF FROM REF FIRST          02366000
* AT ENTRY R11 CONTAINS THE MOVE LENGTH (INCL. &) OF THE SYMBOL         02367000
*          R10 POINTS TO THE SYMBOL  /&NAME/(/D/)/ WHERE DIMENSION      02368000
*              IS OPTIONAL                                              02369000
* ON RETURN  XIJ TELLS X1A THROUGH FLGBYT WHETHER THE SYMBOL IS A       02370000
* SYSTEM VARIABL, DIMENSIONED AND WHETHER IT IS SYSLIST                 02371000
*          R11 POINTS TO A 6-BYTE LOCATION CONTAINING /F/PTR/DM/        02372000
* IF ERROR FOUND IN D ROUTINE ON THE V.S. ENTERED  CONCODE WILL TELL.   02373000
*                                                                       02374000
*          SYSECT/SYSNDX/SYSLIST IN OPEN CODE IS RETURNED WITH ERROR    02375000
*          CODE IN CONCODE (ERROR #6- VS NOT PREVIOUSLY DEFINED.)       02376000
         LR    PARAM2,TWKREG2           GET SYMBOL LENGTH               02377000
         LR    PARM,INPTR               POINT TO THE SYMBOL             02378000
         MVI   DDNDX1,VARBSYMR          SET UP INDEX FOR BR TO DIR RTN  02379000
         GOIF  SGBLCL,OFF=VSDENT        BRANCH IF YES                   02380000
         MVC   FLGBYT(L'FLGBYT),FLAGBT  REDEFINE FLGBYT                 02381000
         LR    INPTR,R1                 SKIP OVER V.S.                  02382000
         CLI   D0(INPTR),JLPARN         TEST IF LEFT PAREN FOLLOWS      02383000
         BNE   VSDNDX                   NO, UNDIMENSIONED               02384000
         BAL   RETURN,DSCAN1            YES, GO SCAN DSDT               02385000
         B     ILDIM                    ILLEGAL DIMENSION               02386000
         LTR   TWKREG1,TWKREG1          DIMENSION OF 0 IS NOT ALLOWED   02387000
         BNP   ILDIM                    ILLEGAL DIMENSION               02388000
         CLI   D0(INPTR),JRPARN         TEST DELIMITER FOR RIGHT PAREN  02389000
         BNE   ILDIM                    ERROR IF NOT                    02390000
         SET   VDIM,ON                  INDICATE DIMENSIONED            02391000
         LA    INPTR,D1(,INPTR)         BUMP OVER R-PAREN               02392000
         CH    TWKREG1,H32K             NOR CAN IT BE GT 32K            02393000
         BH    HIDIM                    ERROR, MAX DIMENSION EXCEEDED   02394000
         STH   TWKREG1,JHWORD1          TELL IT TO DIRECTORY ROUTINE    02395000
VSDNDX   EQU   *                                                        02396000
         LR    R1,INPTR                 UPDATE POINTER                  02397000
         L     INPTR,OPNDPTR            IN CASE OF BACK UP              02398000
         MVI   DDNDX1,VARBSYMD          INDICATE DEFINITION             02399000
VSDENT   BAL   R3,DIRENT                WHATEVER IT IS GO MAKE D ENTRY  02400000
         TM    DERRCD,BITFF             TEST IF ERROR FOUND             02401000
         BNZ   CLEANUP                  WRAP UP STATEMENT               02402000
         MVI   GSUMRY,RVSYM             INDICATE V.S.           OY06129 02403000
         GOIF  SGBLCL,ON=REXSTK         EXIT IF IT WAS DEFINITION       02404000
         L     R14,RAVSP                                                02405000
         MVC   RSTKVST(L'FLGBYT),FLGBYT SAVE FLGBYT                     02406000
         NI    ATTRSV,D0                CLEAN UP ATTRSV                 02407000
         MVC   D0(D6,INDEXP),D0(R11)    ENTER VS REF MT                 02408000
         CLI   FLGBYT,XDMSLS            TEST IF UNSUBSCRIPTED SYSLIST   02409000
         BNE   VS20                     BRANCH IF NOT                   02410000
         XC    D4(D2,INDEXP),D4(INDEXP) DUMMY UP DIMENSION BYTES        02411000
VS20     EQU   *                                                        02412000
         LA    INDEXP,DENTLNG(,INDEXP)  BUMP POINTER                    02413000
         GOIF  VDIM,OFF=VSXIT           EXIT IF NOT DIMENSIONED         02414000
         LA    INPTR,D0(R15,INPTR)      BUMP POINTER                    02415000
         BAL   R3,PFXRENT               TELL POSTFIXER                  02416000
         DC    AL2(JTMDIM)              IT IS DIMENSIONED               02417000
         BAL   R3,PFXRENT               LOG L-PAREN                     02418000
         DC    AL2(JTMLPAR)             LEFT PAREN                      02419000
         BAL   R12,APARCT               UP PAREN COUNT                  02420000
         MVI   MCALL,MCLA               INDICATE SCAN AS SETA           02421000
         ST    INPTR,TPSAVE1            SAVE FOR SNAP           OX00224 02422000
         MVC   JHWORD2(L'PARMSTAT),PARMSTAT SAVE DMIENT         OX00411 02423000
         SET   DMIENT,OFF               CLEAR DMIENT            OX00411 02424000
         BAL   RETURN,METASCAN          SCAN FIRST SUBSCRIPT            02425000
         L     R14,RAVSP                                                02426000
         OI    RSTKATR,AT1              ASSUME SINGLE SUBSCRIPT         02427000
         CLI   D0(INPTR),JCOMMA         IS TERMINATOR A COMMA           02428000
         BNE   VS25                     BRANCH IF NOT           OX05801 02429000
         TM    RSTKVST,VSLS             ONLY SYSLIST MAY HAVE DOUBLE    02430000
         BZ    VS32                     SUBSCRIPT, ELSE ERROR  @OX06626 02431000
         OI    RSTKATR,ATSUBS           OK, GOOD DOUBLE SUBSCRIPT       02432000
         BAL   R3,PFXRENT               PUT COMMA IN POSTFIXER STACK    02433000
         DC    AL2(JTMCOM)              COMMA                           02434000
         BAL   RETURN,METASCAN          SCAN SECOND SUBSCRIPT           02435000
VS25     EQU   *                                                OX05801 02436000
         TM    JHWORD2,DMIENT           ENTRY FROM MIPROTO      OX00411 02437000
         BZ    VS30                     BR IF NOT               OX00411 02438000
         SET   DMIENT,ON                SET DMIENT              OX00411 02439000
VS30     EQU   *                                                        02440000
         CLI   D0(INPTR),JRPARN         TEST IF RIGHT PAREN TERMINATES  02441000
         BNE   VS32                     LOG ERROR IF NOT       @0X06626 02442000
         BAL   R3,PFXRENT               LOG R-PAREN                     02443000
         DC    AL2(JTMRPAR)             RIGHT PAREN                     02444000
         BAL   R12,DPARCT               AND DECREMENT PAREN COUNT       02445000
         LR    R1,INPTR                 UPDATE POINTER                  02446000
VSXIT    EQU   *                                                        02447000
         SET   (METSW,GSUBS),ON         INDICATE SUBSTITUTION/MT BUILT  02448000
         ST    R1,MEZZOPTR              UPDATE MEZZO POINTER            02449000
         B     REXSTK                   GO TO RECURSIVE EXIT            02450000
VS32     EQU   *                                                        02451000
         TM    JHWORD2,DMIENT           ENTRY FROM MIPROTO     @OX06626 02452000
         BZ    INVSUBS                  SUBSCRIPT ERROR        @OX06626 02453000
         SET   DMIENT,ON                                       @OX06626 02454000
         B     INVSUBS                  ERROR FROM MI          @OX06626 02455000
         EJECT                                                          02456000
*   METASCAN DOES SYNTACTIC SCAN FOR SETA, SETB, SETC, AIF AND ACTR     02457000
*   OPERANDS.  ACTR OPERAND IS SCANNED AS SETA OPERAND, AND             02458000
*   AIF OPERAND IS SCANNED AS SETB OPERAND.                             02459000
*   AT ENTRY, REGISTERS 5,9,11,12,14 ARE AVAILABLE.                     02460000
*   REGISTER  5 IS USED AS MTABLE INDEX. TRANPARENT THROUGH ALL         02461000
*               RECURSIVE CALLS.                                        02462000
*   REGISTER 9 IS USED FOR RETURN LINKAGE ON EACH RECURSIVE CALL.       02463000
*   REGISTER 12 POINTS TO CURRENT ENTRY IN MTABLE.                      02464000
*   REGISTERS 11 AND 14 ARE SCRATCH REGISTERS.                          02465000
*   ENTRY CODE MCALL INDICATES THE TYPE OF SCAN TO BE MADE: SETA,       02466000
*               SECT, OR OTHERS.                                        02467000
*   EXIT CODE IN REG 3 AS FOLLOWS                                       02468000
*                0 = SIMPLE STATE                                       02469000
*                1 = COMPLEX STATE                                      02470000
*                2 = SETA EXPRESSION                                    02471000
*                3 = SETC EXPRESSION                                    02472000
*                                                                       02473000
*   LINKAGE IS BAL  RETURN,METASCAN                                     02474000
         SPACE 3                                                        02475000
METASCAN EQU   *                                                        02476000
         BAL   R12,RENTSTK              ENTER VIA RECURSIVE ENTRY       02477000
         SET   METSW,ON                 ASSUME THERE WILL BE M.T.       02478000
         SR    MTBLNDX,MTBLNDX          INIT. INDEX OF ZERO             02479000
         B     MSCVRT                   GO TEST FLAG                    02480000
*        TRANSITION TO NEW STATE                                        02481000
*        ***********************                                        02482000
MSADV    LA    MTBLNDX,D1(MTBLNDX)      ADVANCE INDEX                   02483000
MSCVRT   LA    MTBLENT,MTABLE(MTBLNDX)  CONVERT TO ABSOLUTE ADDRESS     02484000
         TM    D0(MTBLENT),EXNXNT       TEST TYPE OF FLAG IN MTABLE     02485000
         BO    MEXFR                    EXECUTE THE LIST THAT FOLLOWS   02486000
         BM    MCATEG                   MATCH TRT CATEG W/ THAT IN TBL  02487000
         L     LINK,ATRTEST             POINT TO TRTEST                 02488000
         BALR  RETURN,LINK              TRT STRING AT INPTR             02489000
         B     MSADV                    GO FIND OUT WHAT TO DO NEXT     02490000
*   MATCH TRT CATEG AGAINST CATEG IN MTABLE FOR RIGHT PATH              02491000
*   ******************************************************              02492000
MCATEG   IC    TWKREG1,D0(,MTBLENT)     OBTAIN CURRENT LIST CATEG ENTRY 02493000
         N     TWKREG1,F15              MASK OUT UNWANTED BITS          02494000
         CR    TWKREG1,R3               COMPARE AGAINST TRT CATEGORY    02495000
         BE    MEXFR                    TRANSFER INTO ACTION IF MATCH   02496000
         IC    TWKREG1,D0(,MTBLENT)     ELSE, TRY NEXT LIST             02497000
         SRL   TWKREG1,D4               ISOLATE LENGTH OF CURRENT LIST  02498000
         LA    MTBLNDX,D0(TWKREG1,MTBLNDX) COMPUTE NEXT LIST ADDRESS    02499000
         B     MSCVRT                   GO CONVERT INTO ABSOLUTE ADDR   02500000
*        EXECUTE CURRENT LIST AT MTBLNDX                                02501000
*        *******************************                                02502000
MEXFR    LA    MTBLNDX,D1(MTBLNDX)      ADVANCE POINTER                 02503000
MEXFR1   IC    TWKREG1,MTABLE(MTBLNDX)  PICK UP ROUTINE NUMBER FOR      02504000
         N     TWKREG1,F31              COMPUTED GO TO BY MASK OUT      02505000
         AR    TWKREG1,TWKREG1          UNWANTED BITS THEN DOUBLE IT    02506000
         LH    TWKREG1,MBRTBL-D2(TWKREG1) PICK UP REL ADDRESS           02507000
         B     MBRTBL(TWKREG1)          FAN OUT TO ABSOLUTE ROUTINE ADR 02508000
         EJECT                                                          02509000
*   METASCAN BRANCH TABLE                                               02510000
         SPACE 3                                                        02511000
MBRTBL   EQU   *                                                        02512000
MBTA     DC    AL2(ESETA-MBRTBL)        .                               02513000
MBTC     DC    AL2(ESETC-MBRTBL)        .                               02514000
MBTBLK   DC    AL2(EBLANK-MBRTBL)       .                               02515000
MBTBOP   DC    AL2(DBLOP-MBRTBL)        .                               02516000
MBTARE   DC    AL2(ARENT-MBRTBL)        .                               02517000
MBTARE1  DC    AL2(ARENT10-MBRTBL)      .                               02518000
MBTSTC   DC    AL2(DSETC-MBRTBL)        .                               02519000
MBTVBOP  DC    AL2(DVBLOP-MBRTBL)       .                               02520000
MBTAOP   DC    AL2(DAROP-MBRTBL)        .                               02521000
MBTROP   DC    AL2(DRELOP-MBRTBL)       .                               02522000
MBTATM   DC    AL2(ARTERM-MBRTBL)       .                               02523000
MBTDUP   DC    AL2(DUPC-MBRTBL)         .                               02524000
MBTATR   DC    AL2(DATTR-MBRTBL)        .                               02525000
MBTVSM   DC    AL2(EVSYM-MBRTBL)        .                               02526000
MBTXSA   DC    AL2(XSA-MBRTBL)          .                               02527000
MBTXSB   DC    AL2(XSB-MBRTBL)          .                               02528000
MBTXSC   DC    AL2(XSC-MBRTBL)          .                               02529000
MBTXSX   DC    AL2(XSX-MBRTBL)          .                               02530000
MBTINV   DC    AL2(ILGLXP1-MBRTBL)      .                               02531000
MBTILG   DC    AL2(ILGLXPBR-MBRTBL)       .                             02532000
MBTCPR   DC    AL2(DCPR-MBRTBL)         .                               02533000
MBTDSDT  DC    AL2(BDSDT-MBRTBL)        .                               02534000
DCPR     EQU   MSADV                                                    02535000
         SPACE 3                                                        02536000
*   BRANCH TABLE ENTRY SEQUENCE EQUATED                                 02537000
ETSETA   EQU   (MBTA-MBRTBL)/2+1        TEST SETA ENTRY                 02538000
ETSETC   EQU   (MBTC-MBRTBL)/2+1        TEST SETC ENTRY                 02539000
ETBLANK  EQU   (MBTBLK-MBRTBL)/2+1      TEST IF BLANK                   02540000
ETBOOL   EQU   (MBTBOP-MBRTBL)/2+1      TEST IF BOOLEAN OPERATOR        02541000
EPSETA   EQU   (MBTARE-MBRTBL)/2+1      L-PAREN RECURSIVE CALL          02542000
EPSETBE  EQU   (MBTARE1-MBRTBL)/2+1     L-PAREN RECURSIVE CALL          02543000
EPSETC   EQU   (MBTSTC-MBRTBL)/2+1      PROCESS SETC EXPR               02544000
EPMBOOL  EQU   (MBTVBOP-MBRTBL)/2+1     PROCESS BOOLEAN OPERATOR        02545000
EPAROP   EQU   (MBTAOP-MBRTBL)/2+1      PROCESS ARITHMETIC OPERATOR     02546000
EPRELOP  EQU   (MBTROP-MBRTBL)/2+1      PROCESS RELATIONAL OPE-ATOR     02547000
EPTRMA   EQU   (MBTATM-MBRTBL)/2+1      PROCESS ARITHMETIC TERM         02548000
EPDUPE   EQU   (MBTDUP-MBRTBL)/2+1      PROCESS DUPLICATION FACTOR-SETC 02549000
EPATTR   EQU   (MBTATR-MBRTBL)/2+1      PROCESS ATTRIBUTE NOTATION      02550000
EPVSYM   EQU   (MBTVSM-MBRTBL)/2+1      PROCESS VARIABLE SYMBOL         02551000
EXITA    EQU   (MBTXSA-MBRTBL)/2+1      ARITHMETIC EXIT                 02552000
EXITB    EQU   (MBTXSB-MBRTBL)/2+1      BOOLEAN(COMPLEX) EXIT           02553000
EXITC    EQU   (MBTXSC-MBRTBL)/2+1      SETC EXIT                       02554000
EXITX    EQU   (MBTXSX-MBRTBL)/2+1      UNCATEGORIZED EXIT              02555000
EPDSDT   EQU   (MBTDSDT-MBRTBL)/2+1     DSDT IN SETB OPND PAREN'D       02556000
EPINVLD  EQU   (MBTINV-MBRTBL)/2+1      INVALID OPERAND FORMAT          02557000
EPILXP   EQU   (MBTILG-MBRTBL)/2+1      ILEGAL LOGICAL OPERATOR         02558000
EXCPR    EQU   (MBTCPR-MBRTBL)/2+1      EXECUTE COMPARISON              02559000
*                                                                       02560000
EXTRT    EQU   0                        EXECUTE TRANSLATE&TEST          02561000
EXNXNT   EQU   255                      EXECUTE NEXT ENTRY              02562000
         EJECT                                                          02563000
*        TRANSITION TABLE WHICH DRIVES METASCAN                         02564000
         SPACE 3                                                        02565000
MTABLE   EQU   *                                                        02566000
STATE0   EQU   *                                                        02567000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02568000
         DC    AL1(EXNXNT)              EXECUTE NEXT ENTRY              02569000
         DC    AL1(ETSETA)            1 TEST IF SETA ENTRY              02570000
         DC    AL1(SSTXA)               BRANCH IF YES                   02571000
         DC    AL1(ETSETC)            2 TEST IF SETC ENTRY              02572000
         DC    AL1(SSTXC)               BRANCH IF YES                   02573000
         DC    AL1(ETBLANK)           3 TEST IF BLANK-SCAVENGE IF YES   02574000
         DC    AL1(SSTATE0)             THEN START ALL OVER             02575000
*             ... ELSE, ASSUME SETB ENTRY ...                           02576000
         DC    AL1(EXCPR)             4 CPR NEXT ENTRY VS TRT'D CATEG   02577000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02578000
         DC    AL1(128+ETBOOL)          YES-BUT HAS TO BE 'NOT'         02579000
         DC    AL1(SSTATE0)             YES. GO TRT NEXT TERM           02580000
         DC    AL1(5*16+0)              IS IT PAREN'D DSDT              02581000
         DC    AL1(EPDSDT)              POSSIBLY, LOOK INTO IT          02582000
         DC    AL1(SSTBOPY)             SURE IT IS                      02583000
         DC    AL1(SSTMOP)              NO, TRY ARITH EXPR              02584000
*   IF NOT 'NOT', LOG ERROR, NO RETURN, GIVE UP SCANNING.               02585000
STATE1   DC    AL1(EXTRT)               TRANSLATE&TEST                  02586000
*                                                                       02587000
STXA     EQU   *                        SETA EXPRESSION                 02588000
         DC    AL1(7*16+4)              TEST IF L-PAREN                 02589000
         DC    AL1(EPSETBE)             EDIT IF YES, THEN...            02590000
         DC    AL1(SSTOP)               RETURN HERE IF SIMPLE (V.S.)    02591000
         DC    AL1(SSTBOP)              RETURN HERE IF COMPLEX (BOOL)   02592000
         DC    AL1(SSTMOP)              RETURN HERE IF SETA EXPR        02593000
         DC    AL1(SSTERR1)             RETURN HERE IF SETC EXPR(ERROR) 02594000
         DC    AL1(SSTDUP)              RETURN HERE IF DUP FACTOR      X02595000
                                        FOUND IN COMPLEX EXPRESSION     02596000
*                                                                       02597000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02598000
         DC    AL1(ETSETA)              TEST IF SETA ENTRY              02599000
         DC    AL1(SSTMA)               BRANCH IF SETA ENTRY            02600000
         DC    AL1(EXCPR)               ELSE, COMPARE NEXT ENTRY        02601000
         DC    AL1(3*16+2)              TEST IF AMPERSAND               02602000
         DC    AL1(EPVSYM)              BRANCH IF YES...                02603000
         DC    AL1(SSTOP)               THEN TRT NEXT OPERATOR          02604000
************************************************************            02605000
STXC     EQU   *                        SETC EXPRESSION                 02606000
         DC    AL1(3*16+9)              TEST IF T' NOTATION             02607000
         DC    AL1(EPATTR)              EDIT IT YES                     02608000
         DC    AL1(SSTIF)               THEN TRY TO GET OUT             02609000
*                                                                       02610000
         DC    AL1(4*16+4)              TEST IF L-PAREN (DUP FACTOR)    02611000
         DC    AL1(EPDUPE)              EDIT IF YES (LINK TO EPSETC)    02612000
         DC    AL1(SSTIF)               THEN TRY TO EXIT                02613000
*                                                                       02614000
STDUP    EQU   *                                                        02615000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02616000
         DC    AL1(3*16+5)              TEST IF QUOTE (C-EXPR)          02617000
         DC    AL1(EPSETC)              EDIT IF YES                     02618000
         DC    AL1(SSTIF)               THEN TRY TO EXIT                02619000
*                                                                       02620000
         DC    AL1(EXNXNT)              IF NONE OF THE ABOVE...         02621000
         DC    AL1(ETSETC)              TEST IF SETC ENTRY              02622000
         DC    AL1(SSTERR1)             LOG ERROR IF YES                02623000
         DC    AL1(EPTRMA)              NO. PROCESS AS ARITH TERM       02624000
         DC    AL1(SSTMOP)              THEN GET NEXT OPERATOR          02625000
*********************************************                           02626000
STOP     EQU   *                        OPERATOR EVALUATION             02627000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02628000
         DC    AL1(3*16+11)             TEST IF RELATIONAL OPERATOR     02629000
         DC    AL1(EPRELOP)             EDIT IF YES                     02630000
         DC    AL1(SSTMOP1)             THEN GO LOOK FOR NEXT TERM      02631000
*                                                                       02632000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02633000
         DC    AL1(64+EPMBOOL)          YES-BUT HAS TO BE AND/OR        02634000
         DC    AL1(SSTATE0)             CHECK. GO PROCESS NEXT TERM     02635000
*                                                                       02636000
         DC    AL1(3*16+6)              COULD IT BE ARITH OPERATOR      02637000
         DC    AL1(EPAROP)              EDIT IF YES                     02638000
         DC    AL1(SSTMA1)              THEN CHECK NEXT TERM            02639000
*                                                                       02640000
         DC    AL1(4*16+3)              TEST IF TERMINATING CHARACTER   02641000
         DC    AL1(ETBLANK)             YES, SCAVENGE IF BLANK(S)       02642000
         DC    AL1(SSTOPX)              NOW ONLY REL OP & BOOL OP      X02643000
                                        ALLOWED FOLLOWING BLANKS        02644000
         DC    AL1(EXITX)               NOT BLANK. CHECK CURRENT STATUS 02645000
*                                                                       02646000
STBOPY   EQU   *                                                OX00406 02647000
         DC    AL1(EXNXNT)              IF NONE OF THE ABOVE ...        02648000
         DC    AL1(EXITX)               GO CHECK CURRENT STATUS         02649000
*                                                                       02650000
STOPX    EQU   *                        WRAP UP THE MESS LEFT BY SST7   02651000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02652000
         DC    AL1(3*16+11)             TEST IF RELATIONAL OPERATOR     02653000
         DC    AL1(EPRELOP)             EDIT IF YES                     02654000
         DC    AL1(SSTMOP1)             THEN GO TO NEXT TERM            02655000
*                                                                       02656000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02657000
         DC    AL1(64+EPMBOOL)          YES, BUT HAS TO BE 'AND'/'OR'   02658000
         DC    AL1(SSTATE0)             CHECK. PROCESS NEXT TERM        02659000
*                                                                       02660000
         DC    AL1(EXNXNT)              IF NEITHER ...                  02661000
         DC    AL1(EXITX)               CHECK CURRENT STATUS            02662000
**********************************************                          02663000
STMA     EQU   *                        ARITH TERM SCAN                 02664000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02665000
         DC    AL1(EPTRMA)              GO CLASSIFY ARITH TERM          02666000
         DC    AL1(SSTMOP)              THEN GO CHECK FOR ARITH OP      02667000
STUNE    EQU   *-1                      POST-UNARY RE-ENTRY BECAUSE OF  02668000
         DC    AL1(SSTMA1)              L-PAREN                         02669000
STMA1    EQU   *                   CHECK THE TERM FOLLOWING ARITH OP    02670000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02671000
         DC    AL1(7*16+4)              TEST IF L-PAREN                 02672000
         DC    AL1(EPSETA)              EDIT IF YES (ARITH EXPR),THEN.. 02673000
         DC    AL1(SSTMOP)              RETURN HERE IF SIMPLE           02674000
         DC    AL1(SSTERR2)             RETURN HERE IF COMPLEX (ERROR)  02675000
         DC    AL1(SSTMOP)              RETURN HERE IF SETA EXPR        02676000
         DC    AL1(SSTERR2)             RETURN HERE IF SETC EXPR(ERROR) 02677000
         DC    AL1(SSTERR2)             AND HERE IF DUP'D SETC (ERROR)  02678000
*                                                                       02679000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02680000
         DC    AL1(EPTRMA)              MUST BE ARITMETIC TERM. PROCESS 02681000
         DC    AL1(SSTMOP)              THEN GO TO NEXT OPERATOR        02682000
*                                                                       02683000
STMOP    EQU   *                   CHK NEXT TERM/OP FOLLOWING ARITH TRM 02684000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02685000
         DC    AL1(3*16+6)              TEST IF ARITH OPERATOR          02686000
         DC    AL1(EPAROP)              EDIT IF YES                     02687000
         DC    AL1(SSTMA1)              THEN CHECK NEXT TERM            02688000
*                                                                       02689000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02690000
         DC    AL1(ETSETA)              TEST IF SETA ENTRY              02691000
         DC    AL1(SSTXITA)             EXIT IF YES                     02692000
*                                                                       02693000
         DC    AL1(EXCPR)               ELSE, MAKE COMPARISON           02694000
         DC    AL1(3*16+11)             TEST IF RELATIONAL OPERATOR     02695000
         DC    AL1(EPRELOP)             EDIT IF YES, THEN               02696000
         DC    AL1(SSTMOP1)             LOOK FOR NEXT TERM              02697000
*                                                                       02698000
         DC    AL1(4*16+3)              TEST FOR TERMINATING CHAR       02699000
         DC    AL1(ETBLANK)             YES, SCAVENGE IF BLANK(S), THEN 02700000
         DC    AL1(SSTRO)               PRAY FOR REL OP TO FOLLOW.      02701000
         DC    AL1(EXITA)               NOT BLANK. LET'S GET OUT        02702000
*                                                                       02703000
STXITA   DC    AL1(EXNXNT)              NONE OF THE ABOVE...            02704000
         DC    AL1(EXITA)               LET'S GET OUT                   02705000
STRO     EQU   *                        EXPECTING REL OP TO FOLLOW      02706000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02707000
         DC    AL1(3*16+11)             IS IT RELATIONAL OPERATOR       02708000
         DC    AL1(EPRELOP)             EDIT IF YES                     02709000
         DC    AL1(SSTMOP1)             THEN GO ONE MORE STEP FURTHER   02710000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02711000
         DC    AL1(64+EPMBOOL)          YES-BUT HAS TO BE AND/OR        02712000
         DC    AL1(SSTATE0)             CHECK. GO PROCESS NEXT TERM     02713000
*                                                                       02714000
STERR1   DC    AL1(EXNXNT)              ELSE, EXEC NEXT ENTRY           02715000
         DC    AL1(EPINVLD)             INVALID OPERAND FIELD FORMAT    02716000
*                                                                       02717000
STMOP1   EQU   *                        TERM/OP FOLLOWING REL/ARITH OP  02718000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02719000
         DC    AL1(7*16+4)              TEST IF L-PAREN                 02720000
         DC    AL1(EPSETA)              EDIT IF YES (ARITH EXPR) THEN   02721000
         DC    AL1(SSTAOP)              RETURN HERE IF SUMPLE           02722000
         DC    AL1(SSTERR2)             RETURN HERE IF COMPLEX (ERROR)  02723000
         DC    AL1(SSTAOP)              RETURN HERE IF SETA EXPR        02724000
         DC    AL1(SSTERR2)             RETURN HERE IF SETC EXPR(ERROR) 02725000
         DC    AL1(SSTERR2)             AND HERE IF DUP'D SETC (ERROR)  02726000
*                                                                       02727000
         DC    AL1(EXNXNT)              ELSE, EXEC NEXT ENTRY..         02728000
         DC    AL1(EPTRMA)              HAS TO BE ARITH TERM. PROCESS   02729000
         DC    AL1(SSTAOP)              THEN LOOK FOR NEXT ARITH OP     02730000
*                                                                       02731000
STAOP    EQU   *                        ARITH OP FOLLOWING ARITH TERM   02732000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02733000
         DC    AL1(4*16+6)              TEST IF ARITH OP                02734000
         DC    AL1(EPAROP)              EDIT IF YES                     02735000
         DC    AL1(SSTMOP1)             CHECK NEXT TERM/OP              02736000
*        LINK TO STBOP                                                  02737000
STBOP    EQU   *                        BOOLEAN 'AND' OR 'OR'           02738000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02739000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02740000
         DC    AL1(64+ETBOOL)           YES, BUT HAS TO BE AND/OR       02741000
         DC    AL1(SSTATE0)             CHECK. PROCESS NEXT TERM        02742000
*                                                                       02743000
         DC    AL1(4*16+3)              TEST IF TERMINATING CHAR        02744000
         DC    AL1(ETBLANK)             YES, SCAVENGE IF BLANKS, THEN   02745000
         DC    AL1(SSTBOPX)             GO TEST BOOLEAN OPERATOR AGAIN  02746000
         DC    AL1(EXITB)               GET OUT IF NOT BLANK            02747000
*                                                                       02748000
         DC    AL1(EXNXNT)              IF NEITHER ABOVE...             02749000
         DC    AL1(EXITB)               GET OUT OF HERE                 02750000
*                                                                       02751000
STBOPX   EQU   *                        WRAP UP THE MESS LEFT BY STBOP  02752000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02753000
         DC    AL1(3*16+10)             TEST IF BOOLEAN OPERATOR        02754000
         DC    AL1(64+ETBOOL)           YES, BUT HAS TO BE AND/OR       02755000
         DC    AL1(SSTATE0)             CHECK. NEXT                     02756000
*                                                                       02757000
         DC    AL1(EXNXNT)              IF NOT BOOLEAN OP...            02758000
         DC    AL1(EXITB)               GET OUT OF HERE                 02759000
**********************************************                          02760000
STIF     EQU   *                                                        02761000
         DC    AL1(EXNXNT)              EXECUTE NEXT ENTRY              02762000
         DC    AL1(ETSETC)              TEST IF SETC ENTRY              02763000
         DC    AL1(SSTXITC)             TRY TO EXIT IF YES              02764000
         DC    AL1(EXCPR)               ELSE, MAKE COMPARISON           02765000
         DC    AL1(EXTRT)               BUT TRANSLATE&TEST FIRST        02766000
         DC    AL1(3*16+11)             TEST IF REL OP                  02767000
         DC    AL1(EPRELOP)             EDIT IF YES                     02768000
         DC    AL1(SSTMIF)              THEN CHECK NEXT TERM            02769000
*                                                                       02770000
         DC    AL1(4*16+3)              IF NOT REL OP, CHECK IF BLANKS  02771000
         DC    AL1(ETBLANK)             SCAVENGE IF YES                 02772000
         DC    AL1(SSTIFX)              THEN TEST IF REL OP AGAIN.      02773000
         DC    AL1(EXITC)               EXIT IF NOT BLANK               02774000
*                                                                       02775000
STXITC   DC    AL1(EXNXNT)              IF NEITHER ABOVE                02776000
         DC    AL1(EXITC)               CHECK CURRENT STATUS            02777000
*                                                                       02778000
STIFX    EQU   *                        WRAP UP THE MESS LEFT BY STIF   02779000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02780000
         DC    AL1(3*16+11)             TEST IF REL OP                  02781000
         DC    AL1(EPRELOP)             EDIT IF YES-THEN                02782000
         DC    AL1(SSTMIF)              CHECK NEXT TERM                 02783000
*                                                                       02784000
         DC    AL1(EXNXNT)              ELSE, LOG INVALID OPERAND FMT   02785000
         DC    AL1(EPINVLD)             (EXPECTING REL OP.)             02786000
*                                                                       02787000
STMIF    EQU   *                        TERM FOLLOWS REL OP IN AIF      02788000
         DC    AL1(EXTRT)               TRANSLATE&TEST                  02789000
         DC    AL1(3*16+9)              TEST IF TYPE ATTR NOTATION      02790000
         DC    AL1(EPATTR)              EDIT IF YES                     02791000
         DC    AL1(SSTBOP)              GO CHECK NEXT OP (BOOLEAN OP)   02792000
*                                                                       02793000
         DC    AL1(3*16+4)              TEST IF L-PAREN (DUP FACTOR)    02794000
         DC    AL1(EPDUPE)              EDIT IF YES (LINK TO EPSETC)    02795000
         DC    AL1(SSTBOP)              THEN CHECK NEXT OP (BOOL OP)    02796000
*                                                                       02797000
         DC    AL1(3*16+5)              TEST IF QUOTE (C-EXPR)          02798000
         DC    AL1(EPSETC)              EDIT IF YES                     02799000
         DC    AL1(SSTBOP)              THEN CHECK NEXT OP (BOOL OP)    02800000
*                                                                       02801000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02802000
         DC    AL1(EPINVLD)             GO LOG ERR32                    02803000
*                                                                       02804000
STERR2   EQU   *                        LOG ILGL OPERAND FIELD FORMAT   02805000
         DC    AL1(EXNXNT)              EXEC NEXT ENTRY                 02806000
         DC    AL1(EPILXP)                                              02807000
         DS    0H                                                       02808000
         SPACE 3                                                        02809000
*   TRANSITION TABLE ROUTINE ENTRY RELATIVE ADDRESS EQUATED             02810000
         SPACE 3                                                        02811000
*                                                                       02812000
SSTATE0  EQU   STATE0-STATE0                                            02813000
SSTUNE   EQU   STUNE-STATE0                                             02814000
SSTATE1  EQU   STATE1-STATE0                                            02815000
SSTXA    EQU   STXA-STATE0                                              02816000
SSTXC    EQU   STXC-STATE0                                              02817000
SSTDUP   EQU   STDUP-STATE0                                             02818000
SSTMA    EQU   STMA-STATE0                                              02819000
SSTOP    EQU   STOP-STATE0                                              02820000
SSTOPX   EQU   STOPX-STATE0                                             02821000
SSTMA1   EQU   STMA1-STATE0                                             02822000
SSTMOP   EQU   STMOP-STATE0                                             02823000
SSTRO    EQU   STRO-STATE0                                              02824000
SSTERR1  EQU   STERR1-STATE0                                            02825000
SSTMOP1  EQU   STMOP1-STATE0                                            02826000
SSTAOP   EQU   STAOP-STATE0                                             02827000
SSTBOP   EQU   STBOP-STATE0                                             02828000
SSTBOPX  EQU   STBOPX-STATE0                                            02829000
SSTIF    EQU   STIF-STATE0                                              02830000
SSTXITA  EQU   STXITA-STATE0                                            02831000
SSTXITC  EQU   STXITC-STATE0                                            02832000
SSTIFX   EQU   STIFX-STATE0                                             02833000
SSTMIF   EQU   STMIF-STATE0                                             02834000
SSTBOPY  EQU   STBOPY-STATE0            .                               02835000
SSTERR2  EQU   STERR2-STATE0                                            02836000
         EJECT                                                          02837000
*   ENTRIES TO RESPECTIVE DETAIL PROCESSING ROUTINES                    02838000
         SPACE 3                                                        02839000
ILGLXPBR B     ILGLXP                   GO TO ILGLXP IN CS0             02840000
         SPACE 3                                                        02841000
ESETA    EQU   *                                                        02842000
         L     R14,RAVSP                                                02843000
         TM    D3(R14),MCLA             TEST IF SETA ENTRY              02844000
         B     BRIDGE1                  .....                           02845000
ESETC    EQU   *                                                        02846000
         L     R14,RAVSP                                                02847000
         TM    D3(R14),MCLC             TEST IF SETC ENTRY              02848000
BRIDGE1  BO    TRNSFER                  ..DO CURRENT STATE ENTRY IF YES 02849000
BRIDGE2  LA    MTBLNDX,D2(MTBLNDX)      ELSE, STEP ACROSS CURRENT ENTRY 02850000
         B     MEXFR1                   TO EXECUTE NEXT STATE ENTRY     02851000
EBLANK   EQU   *                        TEST IF BLANK AT INPTR          02852000
         CLI   D0(INPTR),JBLANK                                         02853000
         BNE   BRIDGE2                  BRANCH IF NOT BLANK             02854000
DBLANK   EQU   *                        ELSE GOBBLE UP BLANKS           02855000
         L     R14,RAVSP                                                02856000
         OI    RSTKFLG,MCMPLX           INDICATE COMPLEX STATE          02857000
         BAL   TLINK,SKPBLK             BUMP OVER BLANKS                02858000
         GOIF  SNOFND,ON=ILGLXP2        INVALID FORMAT                  02859000
TRNSFER  EQU   *                        TRANSITION TO NEW STATE         02860000
         IC    MTBLNDX,STATE0+D1(MTBLNDX) PICK UP NEW STATE REL ADDRESS 02861000
         B     MSCVRT                   BACK TO THE OLD GRINDER         02862000
         SPACE 3                                                        02863000
*   RECURSIVE CALL TO METASCAN FORCED BY LEFT PARENTHESIS WHILE         02864000
*   PROCESSING ARITHMETIC EXPRESSION OR BOOLEAN EXPRESSION              02865000
ARENT    EQU   *                                                        02866000
         MVI   MCALL,MCLA               RESET TO ARITHMETIC ENTRY CODE  02867000
         B     ARENT20                  UP PAREN COUNT AND PUT IN STACK 02868000
ARENT10  L     R14,RAVSP                SET ENTRY CODE SAME AS CURRENT  02869000
         MVC   MCALL(D1),RSTKFLG        STATE                           02870000
         NI    MCALL,STMASK             MASK OUT UNWANTED STATUS        02871000
ARENT20  BAL   R12,APARCT               INCREMENT PAREN COUNT           02872000
         BAL   R3,PFXRENT               LOG L-PAREN IN REGISTER PARM    02873000
         DC    AL2(JTMLPAR)             LOG L-PAREN                     02874000
         BAL   RETURN,METASCAN          SCAN                            02875000
         CLI   D0(INPTR),JRPARN         TERMINATOR MUST BE R-PAREN      02876000
         BNE   ILGLXP1                  ELSE, LOG ERROR                 02877000
         BAL   R12,DPARCT               DECREMENT PAREN COUNT           02878000
         LR    R0,R3                    SAVE EXIT CODE                  02879000
         BAL   R3,PFXRENT               LOG R-PAREN IN REGISTER PARM    02880000
         DC    AL2(JTMRPAR)             LOG R-PAREN                     02881000
         LR    R3,R0                    RESTORE EXIT CODE               02882000
         CLI   D0(INPTR),JQUOTE         TEST IF DUP FACTOR              02883000
         BNE   ARENT30                  BRANCH IF NOT                   02884000
         BAL   R3,PFXRENT               ASSUME DUP FACTOR               02885000
         DC    AL2(JTMDUP)              AND SO INDICATE                 02886000
         BCTR  INPTR,0                  BUT DON'T GET CARRIED AWAY      02887000
         LA    R3,D4                    EXIT CODE IS 4                  02888000
ARENT30  EQU   *                                                        02889000
         AR    MTBLNDX,R3               TRANSITION TO ANY OF THE FOUR   02890000
         B     TRNSFER                  STATES DEPENDING ON EXIT CODE   02891000
ILGLXP0  L     INPTR,TPSAVE             BACK UP FOR SNAP                02892000
ILGLXP1  C     INPTR,ENDATA             DID END DATA TERMINATE          02893000
         BNL   ILGLXP2                  IF SO LOG ERR24                 02894000
         CLI   D0(INPTR),JBLANK         IS THE TERMINATOR A BLANK       02895000
         BNE   INVFM                    FLAG ERR32, SNAP INVALID TEXT   02896000
ILGLXP2  BAL   TLINK,ABSERR             EITHER UNPAIRED PARENS          02897000
         DC    AL1(5*16+SEV24)          OR                              02898000
         DC    AL1(ERR24)               BLANK APPEARED INSIDE           02899000
         SPACE 3                                                        02900000
*   EXITS FROM RESPECTIVE DETAIL PROCESSING ROUTINES                    02901000
XSX      EQU   *                        CHECK CURRENT STATUS            02902000
         SR    R3,R3                    LET'S ASSUME SIMPLE STATE       02903000
         L     R14,RAVSP                WE'LL SOON FIND OUT             02904000
         TM    RSTKFLG,MCMPLX           TEST IF COMPLEX STATE           02905000
         BZ    XSB1                     EXIT IF SIMPLE STATE            02906000
XSB      EQU   *                                                        02907000
         LA    R3,1                     SET BOOLEAN COMPLEX EXIT CODE   02908000
XSB1     L     INDEXO,OUTADR            RESTORE OUTPUT BUFFER POINTER   02909000
         B     REXSTK                   GO TO RECURSIVE EXIT            02910000
XSA      EQU   *                                                        02911000
         LA    R3,2                     SET SETA TYPE EXIT CODE         02912000
         B     REXSTKL                  GO GET STACK BASE               02913000
XSC      EQU   *                                                        02914000
         LA    R3,3                     SET SETC TYPE EXIT CODE         02915000
REXSTKL  EQU   *                                                        02916000
         L     R14,RAVSP                GET STACK-BASE                  02917000
         TM    RSTKFLG,MCMPLX           TEST IF COMPLEX STATE           02918000
         BO    ILSETA                   LOG ERROR                       02919000
         L     INDEXO,OUTADR            RESTORE OUTPUT BUFFER POINTER   02920000
         B     REXSTK1                  GO TO RECURSIVE EXIT            02921000
         SPACE 3                                                        02922000
*   CLEANUP ROUTINE CLEAN UP THE STATEMENT OR THE OPERAND WHERE ERROR   02923000
*   IS FOUND. IT THEN RETURN TO CALLER IF PROCESSING MULTI-OPERAND      02924000
*   STATEMENTS. ELSE, GO TO READ NEXT STATEMENT.                        02925000
*   STATEMENTS THAT HAVE MULTI-OPERAND ARE:                             02926000
*        MACRO CALL,                                                    02927000
*        PROTOTYPE WITH KEYWORD PARAMETER,                              02928000
*        GBLX/LCLX, AND                                                 02929000
*        EQU                                                            02930000
*                                                                       02931000
CLN0     LR    R1,R0                                                    02932000
CLEANUP  EQU   *                                                        02933000
         LA    TWKREG1,STACK            CLEAN UP WHAT'S LEFT IN         02934000
         ST    TWKREG1,SVLAST           POSTFIXER STACK                 02935000
         L     INPTR,FPTRSV             BACK UP TO BEGIN OF FIELD       02936000
         L     INDEXP,OFPTRSV           ON BOTH I/O BUFFERS             02937000
         L     INDEXO,OUTADR            RESTORE POINTER                 02938000
         GOIF  SEOPCD,ON=REXSTK         RETURN IF EDITING OP CODE       02939000
         GOIF  SENAME,OFF=CLN1                                          02940000
         BAL   RETURN,RESETPTR          INSURE NO OVERLAP               02941000
CLN1     MVI   SWITCH8,D0               RESET SWITCH                    02942000
         SET   (METSW,GSUBS),OFF                                        02943000
         LA    TWKREG1,RSTACK-(EDRSTK-BDRSTK)                           02944000
         ST    TWKREG1,RAVSP            AND RSTACK                      02945000
         L     INDEXO,OUTADR            RESTORE POINTER                 02946000
         SET   JPRONLY,ON                                               02947000
         GOIF  SGBLCL,ON=CLN2                                           02948000
         SET GQST,OFF                                                   02949000
         GOIF  DMIENT,OFF=CLN3                                 @AZ13722 02950000
         SET   DMIENT,OFF                                      @AZ13722 02951000
CLN2     LA    R14,EDRSTK-BDRSTK(,R14)                                  02952000
         NI    JHWORD2+1,BITFF-(DMIENT) RESET SECOND DMIENT SW @AZ13722 02953000
         B     REXSTK1                  WRAP UP STATEMENT               02954000
CLN3     TM    JHWORD2+1,DMIENT         TEST FOR PREV PROC-    @AZ13722 02955000
         BZ    WRAPFLD                  ESS IN MIPROTO         @AZ13722 02956000
         B     CLN2                     RETURN OVER REX        @AZ13722 02957000
         EJECT                                                          02958000
*   PROCESS ARITHMETIC OPERATOR                                         02959000
DAROP    EQU   *                                                        02960000
         BAL   R3,PFXRE2                MAKE POSTER ENTRY               02961000
         B     TRNSFER                  GO FOR TRANSITION               02962000
         SPACE 3                                                        02963000
*   PROCESS VARIABLE SYMBOL                                             02964000
EVSYM    EQU   *                                                        02965000
         BAL   RETURN,VARSYM            SCAN V.S. AND BUILD MT          02966000
         LR    INPTR,R1                 BUMP TO NEXT SCAN LOCATION      02967000
         B     TRNSFER                  NEXT TERM/OPERATOR              02968000
         SPACE 3                                                        02969000
*   PROCESS BOOLEAN (LOGICAL) OPERATOR                                  02970000
DVBLOP   EQU   *                        SCREEN SYSLIST                  02971000
         L     R14,RAVSP                                                02972000
         TM    FLGBYT,VSLS              TEST IF SYSLIST PROCESSED       02973000
         BO    ILBXP                    LOG ERROR IF YES                02974000
         OI    RSTKFLG,MCMPLX           ELSE INDICATE IN COMPLEX STATE  02975000
DBLOP    EQU   *                                                        02976000
         IC    TWKREG1,BOP10-JTMNOT(R10) PICK UP ACCEPTANCE MASKS       02977000
         LA    R1,MTABLE(MTBLNDX)       AND TEST IF CORRESPOND TO       02978000
         EX    TWKREG1,BOPTM            CALLING SEQUENCE                02979000
         BNO   ILGLXP                   ILLEGAL EXPRESSION              02980000
*   ENTER RELATIONAL OPERATOR                                           02981000
DRELOP   EQU   *                                                        02982000
         BAL   R3,PFXRE2                MAKE POSTER ENTRY               02983000
         LA    INPTR,D0(R15,INPTR)      BUMP INPTR                      02984000
         B     DBLANK                   GO TAKE CARE OF BLANKS          02985000
BOPTM    TM    D0(R1),0                                                 02986000
BOP10    DC    X'804040'                NOT/AND/OR ACCEPTANCE MASKS     02987000
         DS    0H                                                       02988000
         SPACE 3                                                        02989000
DATTR    EQU   *                                                        02990000
         ST    INPTR,TPSAVE                                             02991000
         LA    INPTR,D1(R15,INPTR)      UPDATE POINTER                  02992000
         LR    TWKREG1,PARM             CONVERT ATTR FLAG               02993000
         SH    TWKREG1,HATT                                             02994000
         STC   TWKREG1,ATTRSV           AND SAVE                        02995000
         BAL   R3,PFXRE2                LOG ATTR FLAG                   02996000
         CLI   D0(INPTR),JAMPER         TEST IF FOLLOWED BY A V.S.      02997000
         BNE   ATTROS                   BRANCH IF NOT                   02998000
         BAL   RETURN,VARSYM            GO PROCESS VS                   02999000
         LR    INPTR,R1                 UPDATE POINTER                  03000000
         GOIF  RMPURE,ON=ILATTR         EXIT IF BAD V.S.                03001000
         TM    FLGBYT,VTYP1+VSLS        TEST IF A PARAM OR A SYSLIST    03002000
         BM    ATTRSYP                  BRANCH IF EITHER                03003000
         TM    ATTRSV,ATT               ELSE, MUST BE SET SYM PRECEDED  03004000
         BNO   ILATTR                   BY ...                          03005000
         TM    ATTRSV,AT7               K' OR T'                        03006000
         BO    ILATTR                   ELSE, ERROR                     03007000
         B     ATTX1                    EXIT IF ALL'S WELL              03008000
ATTRSYP  EQU   *                                                        03009000
         GOIF  SMDEF,OFF=ILATTR         LOG ERROR IF NOT IN MACRO       03010000
         TM    ATTRSV,ATN               TEST IF N'                      03011000
         BNO   ATTX1                    EXIT IF NOT N'                  03012000
         TM    ATTRSV,ATSUBS                                            03013000
         BO    ILATTR                   ERROR IF DOUBLY SUBS'D SYSLIST  03014000
         BZ    ATTX1                    OK IF NON-SUBSCRIPTED V.S.      03015000
          TM    FLGBYT,VSLS             ELSE, TEST IF SYSLIST AT ALL    03016000
         BO    ATTX1                    OK IF YES                       03017000
         B     ILATTR                   ELSE, ERROR                     03018000
ATTROS   EQU   *                                                        03019000
         BAL   LINK,SYMSCN              TEST IF ORDINARY SYMBOL         03020000
         B     ILATTR                   ERROR IF RETURN TO HERE         03021000
         MVC   D0(D4,INDEXP),D0(R11)    ENTER O-SYM POINTER             03022000
         LA    INDEXP,DENTLNG(,INDEXP)  BUMP 2 EXTRA BYTES FOR GEN'R    03023000
ATTX1    EQU   *                                                        03024000
         MVI   ATTRSV,D0                RESET ATTRIBUTE FLAGS           03025000
         B     TRNSFER                  MAKE TRANSITION                 03026000
ATTX2    EQU   *                                                        03027000
         MVI   ATTRSV,D0                RESET ATTRIBUTE FLAGS           03028000
         B     REXSTK                   POP UP                          03029000
         SPACE 3                                                        03030000
*   PROCESS SETC CHARACTER EXPRESSION                                   03031000
*   STARTING WITH A QUOTE (DUPLICATION FACTOR IS CHECKED BY TRANSE      03032000
*   OR AN EXTRA TABLE ENTRY PRECEEDING CSETC ENTRY                      03033000
*                                                                       03034000
DUPC     EQU   *                                                        03035000
         ST    INPTR,TPSAVE             SAVE FOR POSSIBLE ERROR SNAP    03036000
         BAL   R3,PFXRENT               TELL POSTER                     03037000
         DC    AL2(JTMLPAR)             IT IS A LEFT PAREN              03038000
         BAL   R12,APARCT               UP PAREN COUNT                  03039000
         MVI   MCALL,MCLA               SCAN DUP FACTOR AS SETA EXPR.   03040000
         BAL   RETURN,METASCAN          SCAN                            03041000
         CLI   D0(INPTR),JRPARN         TERMINATOR MUST BE R-PAREN      03042000
         BNE   INVDUP                   ELSE LOG ERROR                  03043000
         BAL   R3,PFXRENT               LOG RIGHT PAREN                 03044000
         DC    AL2(JTMRPAR)             RIGHT PAREN                     03045000
         BAL   R12,DPARCT               DECR PAREN COUNT                03046000
         CLI   D0(INPTR),JQUOTE         QUOTE MUST FOLLOW DUP FACTOR    03047000
         BNE   ILGLXP0                  GO FLAG ERROR 32                03048000
         BAL   R3,PFXRENT               MAKE DUP FACTOR ENTRY           03049000
         DC    AL2(JTMDUP)              DUPLICATION OPERATOR            03050000
         BCTR  INPTR,0                  DON'T GET CARRIED AWAY          03051000
         L     R14,RAVSP                                                03052000
         MVC   MCALL(L'MCALL),RSTKFLG   BACK TO CURRENT STATE           03053000
DSETC    EQU   *                                                        03054000
         BAL   R3,PFXRENT               INDICATE START CHAR MODE        03055000
         DC    AL2(JTMSCM)              START CHARACTER MODE            03056000
CSC05    L     TWKREG2,ENDATA           SET END OF DATA AREA            03057000
         BCTR  TWKREG2,D0               SET END OF DATA AREA            03058000
         LA    TWKREG1,D1               SET INCREMENT FACTOR            03059000
         LR    R1,INDEXP                REMEMBER WHERE M.T. STARTS      03060000
         SR    R0,R0                    CLEAR STRING COUNT              03061000
         LA    INDEXP,D2(,INDEXP)       BUMP POINTER                    03062000
CSC10    LA    R3,D2                                                    03063000
         CLI   D0(INPTR),JQUOTE         TEST IF QUOTE                   03064000
         BNE   CSC20                    BRANCH IF NOT                   03065000
         CLI   D1(INPTR),JQUOTE                                         03066000
         BNE   CSC50                    SINGLE - END OF C-STRING        03067000
         BCT   R3,CSC30                 DOUBLE QT - SQUASH TO SINGLE    03068000
CSC20    CLI   D0(INPTR),JAMPER         TEST IF AMPERSAND               03069000
         BNE   CSC40                    NO. C-STRING                    03070000
         CLI   D1(INPTR),JAMPER                                         03071000
         BNE   CSCVSYM                  SINGLE & - ASSUME V.S.          03072000
CSC30    EQU   *                                                        03073000
         AR    INPTR,TWKREG1            ADVANCE POINTER                 03074000
CSC35    EQU   *                                                        03075000
         MVC   D0(D1,INDEXP),D0(INPTR)  MOVE 1 CHAR TO O/P              03076000
         AR    INDEXP,TWKREG1           BUMP O/P POINTER                03077000
         AR    R0,TWKREG1               INCREMENT STRING COUNT BY 1     03078000
CSC40    BCT   R3,CSC35                 ITERATE ON COUNT                03079000
         BXLE  INPTR,TWKREG1,CSC10      PROCESS NEXT CHAR               03080000
         B     NOQUOTE                  ERR, UNBALANCED QUOTES IN SETC  03081000
CSCVSYM  EQU   *                                                        03082000
         BAL   R3,CSTGCHK               CHECK IF STRING COLLECTED       03083000
         BAL   RETURN,VARSYM            EDIT VS INTO MT                 03084000
         LR    INPTR,R1                 UPDATE POINTER                  03085000
         CLI   D0(INPTR),JPERIOD        IGNORE THE DOT                  03086000
         BNE   CSC05                    (BRANCH IF NOT A DOT)           03087000
         LA    INPTR,D1(,INPTR)         IF THERE IS ONE                 03088000
         B     CSC05                    THEN CONTINUE C-EXPR PROCESSING 03089000
CSC50    EQU   *                                                        03090000
         BAL   R3,CSTGCHK               CHECK IF STRING COLLECTED       03091000
         BAL   R3,PFXRENT               INDICATE END CHARACTER MODE     03092000
         DC    AL2(JTMECM)                                              03093000
         CLI   D0(INPTR),JLPARN         ANY SUBSTRING NOTATION          03094000
         BNE   CSC60                    BRANCH IF NOT                   03095000
         BAL   R12,APARCT               ADVANCE PAREN COUNT             03096000
         BAL   R3,PFXRENT               ENTER SUBSTRING OPERATOR        03097000
         DC    AL2(JTMSTR)              STRING OPERATOR                 03098000
         BCTR  INPTR,0                  DON'T GET CARRIED AWAY          03099000
         BAL   R3,PFXRENT               LOG L-PAREN                     03100000
         DC    AL2(JTMLPAR)             LEFT PAREN                      03101000
         MVI   MCALL,MCLA               INDICATE TO SCAN AS SETA EXPR.  03102000
         BAL   RETURN,METASCAN          SCAN SUBSCRIPT 1                03103000
         CLI   D0(INPTR),JCOMMA         TERMINATOR MUST BE A COMMA      03104000
         BNE   INVSUB                   ELSE, LOG ERROR                 03105000
         BAL   R3,PFXRENT               A COMMA                         03106000
         DC    AL2(JTMCOM)              STACK IT IN                     03107000
         BAL   RETURN,METASCAN          SCAN SUBSCRIPT 2                03108000
         CLI   D0(INPTR),JRPARN         TERMINATOR MUST BE R-PAREN      03109000
         BNE   INVSUB                   ELSE, LOG ERROR                 03110000
         BAL   R3,PFXRENT               LOG R-PAREN                     03111000
         DC    AL2(JTMRPAR)             RIGHT PAREN                     03112000
         BAL   R12,DPARCT               DECREMENT PAREN COUNT           03113000
         L     R14,RAVSP                                                03114000
         MVC   MCALL(L'MCALL),RSTKFLG   BACK TO CURRENT STATE           03115000
         CLI   D0(INPTR),JLPARN         TEST IF IMPLIED CONCATENATION   03116000
         BNE   CSC55                    BRANCH IF NOT FOLLOWED BY (     03117000
         BAL   R3,PFXRENT               YES, DUP FACTOR FOLLOWS         03118000
         DC    AL2(JTMPER)              INDICATE CONCATENATION FIRST    03119000
         BCT   INPTR,DUPC               THEN RE-ENTER DUPC              03120000
CSC55    EQU   *                                                        03121000
         CLI   D0(INPTR),JQUOTE         TEST IF IMPLIED CONCATENATION   03122000
         BNE   CSC60                    BRANCH IF NOT                   03123000
         BAL   R3,PFXRENT               ENTER CONCATENATION OPERATOR    03124000
         DC    AL2(JTMPER)              PERIOD                          03125000
         BCT   INPTR,DSETC              RE-ENTER CSETC                  03126000
CSC60    CLI   D0(INPTR),JPERIOD        TEST IF EXPLICIT CONCATENATION  03127000
         BNE   TRNSFER                  NO - END OF C-EXPRESSION        03128000
         BAL   R3,PFXRENT               TELL IT TO POSTER               03129000
         DC    AL2(JTMPER)              PERIOD                          03130000
         CLI   D0(INPTR),JLPARN         TEST IF DUPLICATION FACTOR      03131000
         BE    DUPC                     YES, RE-ENTER DSECT             03132000
         CLI   D0(INPTR),JQUOTE         TEST IF DOT FOLLOWED BY QUOTE   03133000
         BE    DSETC                    RE-ENTER DSETC                  03134000
         B     TRNSFER                  GO TO NEXT TABLE ENTRY          03135000
CSTGCHK  EQU   *                                                        03136000
         LTR   R0,R0                    TEST IF ANY STRING COLLECTED    03137000
         BNZ   CSTGC10                  BRANCH IF YES                   03138000
         SH    INDEXP,H2                ELSE, BACK UP                   03139000
         BR    R3                       AND RETURN                      03140000
CSTGC10  EQU   *                                                        03141000
         MVI   D0(R1),JTMCS             ELSE, FILL IN FLAG              03142000
         STC   R0,D1(,R1)               AND STRING LENGTH               03143000
         BR    R3                       RETURN                          03144000
         EJECT                                                          03145000
*   PROCESS UNARY OPERATOR - LINK TO ARITHMETIC TERM PROCESSOR OR       03146000
*   MAKE RECURSIVE ENTRY BECAUSE OF LEFT PAREN                          03147000
*                                                                       03148000
*   UNARY OPERATOR FOLLOWS                                              03149000
*                  L-PAREN,                                             03150000
*                  ARITH OPERATOR,                                      03151000
*                  UNARY OPERATOR,                                      03152000
*                  OR BLANK.                                            03153000
*                                                                       03154000
CUNARY   EQU   *                                                        03155000
         IC    PARM,UNARYOP-JTMMULT(PARM) PICK UP UNARY OPERATOR        03156000
         LTR   PARM,PARM                TEST IF PLUS OR MINUS           03157000
         BZ    ILUNARY                  UNARY OPERATOR ERROR            03158000
         BAL   R3,PFXRE2                LOG UNARY OPERATOR              03159000
         CLI   D0(INPTR),JLPARN         TEST IF L-PAREN FOLLOWS         03160000
         BNE   ARTERMX                  CLASSIFY ARITH TERM IF NOT      03161000
         LA    MTBLNDX,SSTUNE           ELSE, MAKE RECURSIVE ENTRY      03162000
         B     TRNSFER                  TO METASCAN                     03163000
UNARYOP  DC    AL1(0,0,JTMPLUS,JTMMIN)  UNARY OP INTERNAL VALUE         03164000
         SPACE 3                                                        03165000
*   PROCESS ARITHMETIC TERM WHICH MAY BE IN THE FOLLOWING FORMATS.      03166000
*   1) V.S.                                                             03167000
*   2) ATTRIBUTE NOTATION                                               03168000
*   3) SELF DEFINING TERM (B, C, D, X)                                  03169000
*                                                                       03170000
ARTERMX  L     LINK,ATRTEST             POINT TO TRTEST                 03171000
         BALR  RETURN,LINK              FIND OUT NEXT TERM/OPERATOR     03172000
ARTERM   EQU   *                                                        03173000
         ST    INPTR,TPSAVE             SAVE BEGIN PT FOR SNAP          03174000
         BAL   RETURN,AEXPR             GO PROCESS THE TERM             03175000
         B     ILSDT                    RETURN HERE IF ERROR FOUND      03176000
         B     TRNSFER                  NORMAL RETURN                   03177000
         SPACE 3                                                        03178000
*   ENTRY TO APPROPRIATE ROUTINES                                       03179000
AEXPR    EQU   *                        TEST TRT RESULT                 03180000
         CH    R3,H2                                                    03181000
         BE    EVSYM                    BRANCH IF VARIABLE SYMBOL       03182000
         CH    R3,H6                    TEST POSSIBLE UNARY OPERATOR    03183000
         BE    CUNARY                   BRANCH IF ARITH OPERATOR        03184000
         CH    R3,H7                                                    03185000
         BE    DATTR                    ATTRIBUTE NOTATION              03186000
         CH    R3,H8                                                    03187000
         BE    XBCSDT                   X-, B-, C-TYPE SDT              03188000
         CH    R3,H3                    OPERAND TERMINATOR              03189000
         BE    ILGLXP2                  LOG ERROR IF NOTHING FOUND      03190000
         LTR   R3,R3                                                    03191000
         BNZ   ILSDT                    LOG ERROR IF NOT DSDT           03192000
         SPACE 3                                                        03193000
*   SELF DEFINING TERM PROCESSING ROUTINES.                             03194000
*   CALLED BY METASCAN ARITHMETIC TERM PROCESSING ROUTINE, BY           03195000
*   PROTOTYPE PARAMETER PROCESSING ROUTINE, AND BY MACRO INSTRUCTION    03196000
*   KEYWORD PROCESSING ROUTINE.                                         03197000
*                                                                       03198000
DSDTIN   EQU   *                                                        03199000
         ST    INPTR,TPSAVE                                             03200000
         LR    SCNLREG,R1               SCAN UP TO TRT TERMINATING CHAR 03201000
         LA    PARM,DSDT                GWT DSDT TYPE NUMBER            03202000
         BCT   SCNLREG,SDTLMT           AND GO                          03203000
*                                                                       03204000
XBCSDT   EQU   *                        X-, B-, C-TYPE SDT ENTRY        03205000
         ST    INPTR,TPSAVE                                             03206000
         LA    INPTR,D2(,INPTR)         BUMP OVER SDT HEAD              03207000
         L     SCNLREG,ENDATA           SET SCAN LIMIT                  03208000
*                                                                       03209000
SDTLMT   EQU   *                                                        03210000
         IC    R3,SDTMAXC-JTMSDT(PARM) SET SDT CHAR MAX COUNT           03211000
         STH   R3,HICCNT                                                03212000
         IC    R3,SDTCVAL-JTMSDT(PARM) SET SDT HIGH CHAR VALUE          03213000
         STH   R3,HICVAL                                                03214000
         IC    R1,SDTSHFT-JTMSDT(PARM)  SET CONVERSION SHIFT VALUE      03215000
*                                                                       03216000
         LA    INCREG,D1                BXLE INCREMENT IS 1             03217000
         SR    KNTREG,KNTREG            SET COUNT REG = 0               03218000
         LR    MAXVREG,KNTREG           SET RESULT REGISTER             03219000
*                                                                       03220000
SDTPR    EQU   *                                                        03221000
         SR    R14,R14                                                  03222000
         IC    R14,D0(,INPTR)           SET ONE BYTE AT INPTR           03223000
         CLI   D0(INPTR),JQUOTE         TEST IF QUOTE                   03224000
         BNE   SDTPR05                  GO TEST CHAR VALUE              03225000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    03226000
         CLI   HICVAL1,CHARV            TEST IF CHARACTER SDT           03227000
         BNE   SDTEND                   TERMINATE IF NOT                03228000
         CLI   D0(INPTR),JQUOTE         IS IT DOUBLE QUOTE              03229000
         BNE   SDTEND                   NO. TERMINATE                   03230000
SDTPR05  CH    R14,HICVAL               TEST IF CHAR VALUE IN RANGE     03231000
         BCR   BHI,RETURN               ERROR IF HIGH                   03232000
         CLI   D0(INPTR),JAMPER         IS THE CHAR AN AMPERSAND        03233000
         BNE   SDTPR15                  BRANCH IF NOT                   03234000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    03235000
         CLI   D0(INPTR),JAMPER         IT BETTER BE DOUBLE             03236000
         BCR   BNE,RETURN               ELSE, LOG ERROR                 03237000
SDTPR15  CLI   HICVAL1,J9               TEST IF DSDT                    03238000
         BNE   SDTPR25                  BRANCH IF NOT                   03239000
         ALR   R14,MAXVREG              INITIALIZE CONVERSION TO BINARY 03240000
         ALR   R14,MAXVREG                                              03241000
SDTPR25  EQU   *                                                        03242000
         SLL   MAXVREG,D0(R1)           SHIFT PARTIAL RESULT            03243000
         ALR   MAXVREG,R14              ADD IN THE ADJUSTED BYTE        03244000
         AR    KNTREG,INCREG            ADD 1 TO CHARACTER COUNT        03245000
         BXLE  INPTR,INCREG,SDTPR       GET NEXT BYTE                   03246000
         CLI   HICVAL1,J9               WOOPS, FALL THRU                03247000
         BE    SDTPR35                  BETTER BE DSDT,  YES, GREAT     03248000
         BR    RETURN                   ELSE, ERROR - RETURN            03249000
*                                                                       03250000
SDTPR35  EQU   *                                                        03251000
         CL    MAXVREG,SDTMAXV          HAS DSDT HIT MAX VALUE          03252000
         BCR   BHI,RETURN               TOO HIGH. LOG ERROR             03253000
SDTEND   LTR   KNTREG,KNTREG            CHAR COUNT MUST WITHIN RANGE    03254000
         BCR   BZ,RETURN                TOO LOW                         03255000
         CH    KNTREG,HICCNT                                            03256000
         BCR   BHI,RETURN               TOO HIGH                        03257000
         ST    MAXVREG,JFWORD2          OK. SAVE IT                     03258000
         CLI   HICVAL1,CHARV            TEST IF CSDT                    03259000
         BNE   SDTOUT                   BRANCH IF NOT                   03260000
         LCR   R14,KNTREG               NEGATE CHAR COUNT               03261000
         LA    TRBASE,JFWORD2+D4(R14)   ADJUST OFF-THE-LINE TR BASE REG 03262000
         LR    TRLENG,KNTREG                                            03263000
         BCTR  TRLENG,0                 ADJUST TR LENGTH                03264000
         EX    TRLENG,CSDTTR            TR TO EXTERNAL CHAR VALUE       03265000
SDTOUT   EQU   *                                                        03266000
         MVC   D1(L'JFWORD2,INDEXP),JFWORD2 ENTER VALUE INTO TEXT       03267000
         LA    R12,D1                   VALID SDT EXIT CODE FOR DMIENT  03268000
         GOIF  DMIENT,OFF=SDTOUT1       DID WE ENTER FROM MIPROTIN      03269000
         GOIF  VDIM,OFF=D4(,RETURN)     RETURN IF DIMENSIONED           03270000
SDTOUT1  EQU   *                                                        03271000
         MVI   D0(INDEXP),JTMSDT        NO                              03272000
         LA    INDEXP,SDTLENG(,INDEXP)  BUMP OVER ONE EXTRA BYTE       X03273000
                                        FOR GENERATOR'S CONVENIENCE     03274000
         B     D4(,RETURN)              AND RETURN                      03275000
CSDTTR   TR    D0(0,TRBASE),JTRTABLE    OFF-THE-LINE TRANSLATE          03276000
         SPACE 3                                                        03277000
         DS    0F                                                       03278000
* SDT TYPE ----> X B C D                                                03279000
SDTMAXC  DC    X'0820040A'              MAX CHAR COUNT ALLOWED IN SDT   03280000
SDTCVAL  DC    X'0F01FF09'              MAX CHAR VALUE ALLOWED IN SDT   03281000
SDTSHFT  DC    X'04010803'              SHIFT VALUE IN BITS             03282000
*                                                                       03283000
SDTMAXV  DC    X'7FFFFFFF'              MAX DSDT VALUE (2**32)-1        03284000
*                                                                       03285000
KNTREG   EQU   0                        CHAR COUNT REG                  03286000
MAXVREG  EQU   3                        MAX VALUE REG                   03287000
INCREG   EQU   10                       BXLE INCREMENT REG              03288000
SCNLREG  EQU   11                       SDT SCAN LIMIT REG              03289000
TRLENG   EQU   12                       OFF-THE-LINE TR LENGTH REG      03290000
TRBASE   EQU   14                       OFF-THE-LINE TR BASE REG        03291000
CHARV    EQU   255                      CHAR VALUE                      03292000
SDTLENG  EQU   L'JFWORD2+2              SDT ENTRY LENGTH (ONE EXTRA    X03293000
                                        BYTE FOR GEN'TOR'S CONVENIENCE  03294000
         DS    0H                                                       03295000
         SPACE 3                                                        03296000
BDSDT    BAL   RETURN,DSDTIN            EDIT AS DSDT                    03297000
         B     ILSDT                    INV SDT IF RETURN TO HERE       03298000
         CLI   D0(INPTR),JRPARN         DSDT MUST BE PARENTHESIZED      03299000
         BE    TRNSFER                  YES                             03300000
         AR    MTBLNDX,R12              NOT DSDT                        03301000
         B     TRNSFER                  TRY ARITH EXPR                  03302000
         EJECT                                                          03303000
*********************************************************************** 03304000
* RECURSIVE ENTRY FOR SCANNERS                                          03305000
* FORMAT = VMMMRRAF      WHERE                                          03306000
*          V  = FLGBYT SAVED                                            03307000
*          MMM = MTABLE INDEX (MTBLNDX)                                 03308000
*          RR = RETURN ADDRESS (RELATIVE TO BASE1)                      03309000
*          A  = ATTRSV SAVED                                            03310000
*          F  = MCALL SAVED                                             03311000
* RAVSP MUST BE INITIALIZED TO A(RSTACK) AT PHASE ENTRY                 03312000
* LINKAGE      BAL  R12,RENTSTK                                         03313000
*********************************************************************** 03314000
         SPACE 3                                                        03315000
RENTSTK  EQU   *                                                        03316000
         ST    INDEXP,INTERMET          SAVE INTERMEDIATE MT POINTER    03317000
         L     R14,RAVSP                GET AVAILABLE LOCATION IN RSTAC 03318000
         LA    R14,EDRSTK-BDRSTK(,R14)  COMPUTE NEXT AVAILABLE LOCATION 03319000
         C     R14,NRSTK                TEST IF END OF STACK            03320000
         BNL   RENTFULL                 LOG ERROR IF END OF STACK       03321000
         ST    MTBLNDX,RSTKSTP          SAVE                            03322000
         LA    RETURN,D0(,RETURN)       CLEAN UP BAL MESS               03323000
         SR    RETURN,BASE1             MAKE RETURN ADDRESS RELATIVE    03324000
         STH   RETURN,RSTKRTN           AND SAVE                        03325000
         MVC   RSTKATR(L'ATTRSV+L'MCALL+L'FLGBYT),ATTRSV SAVE FLAGS     03326000
         ST    R14,RAVSP                AND SAVE IT                     03327000
         BR    R12                      RETURN TO CALLER                03328000
         SPACE 3                                                        03329000
*********************************************************************** 03330000
* RECURSIVE EXIT FOR SCANNERS                                           03331000
* LINKAGE      B    REXSTK                                              03332000
*********************************************************************** 03333000
         SPACE 3                                                        03334000
REXSTKP  EQU   *                        ERROR-CONDITION EXIT            03335000
         L     INDEXP,INTERMET          WIPE OFF BAD META TEXT ENTRY    03336000
REXSTK   EQU   *                        NORMAL EXIT                     03337000
         L     R14,RAVSP                                                03338000
REXSTK1  EQU   *                                                        03339000
         LH    RETURN,RSTKRTN           RESTORE RETURN ADDRESS          03340000
         AR    RETURN,BASE1             AND MAKE IT ABSOLUTE            03341000
         MVC   ATTRSV(L'ATTRSV+L'MCALL+L'FLGBYT),RSTKATR RESTORE FLAGS  03342000
         L     MTBLNDX,RSTKSTP          RESTORE                         03343000
         SH    R14,RSTKLEN              BACK UP ENTRY POINT             03344000
         ST    R14,RAVSP                RESET AVAILABLE LOCATION POINTR 03345000
         BR    RETURN                   RETURN                          03346000
         EJECT                                                          03347000
*********************************************************************** 03348000
*   CSTK IS A RECURSIVE STACK FOR NESTED COPY CODE. A COPY CODE MAY   * 03349000
*   BE IMBEDDED IN A COPY CODE UP TO MAXIMUM OF FIVE LEVELS INCLUSIVE.* 03350000
*   A COPY CODE MAY COPY ITSELF. IT MAY COPY A MACRO DEFINITION AS A  * 03351000
*   PROGRAMMER MACRO. THUS, A COPY STATEMENT IS ALLOWED TO BE BETWEEN * 03352000
*   PROGRAMMER MACROS.                                                * 03353000
*                                                                     * 03354000
*   FORMAT OF CSTK IS NNNNS     WHERE                                 * 03355000
*                     NNNN = NOTED VALUE OF THE DISCONTINUED          * 03356000
*                            SOURCE STREAM.                           * 03357000
*                     S = SWITCH1 SAVED FOR CURRENT LEVEL OF COPY     * 03358000
*                           STREAM.                                   * 03359000
*                                                                     * 03360000
*   LINKAGE IS  BAL   R3,CSTKENT - FOR ENTRY                          * 03361000
*               BAL   R3,CSTKEXT - FOR EXIT                           * 03362000
*                                                                     * 03363000
*********************************************************************** 03364000
CSTKENT  EQU   *                                                        03365000
         L     PARM,CSTKADR             GET NEXT AVAILABLE LOCATION     03366000
         C     PARM,NCSTK               TEST IF THE STACK FULL          03367000
         BNL   CSTKFULL                 BRANCH IF YES                   03368000
         XC    CSTKMEM(L'CSTKMEM),CSTKMEM CLEAR MEMBER NAME             03369000
         GOIF  JINLIB,OFF=CSTK20        BRANCH IF NOT IN LIBRARY MODE   03370000
         JNOTELB                                                        03371000
         L     PARM,CSTKADR             RESTORE NEXT AVAILABLE LOCATION 03372000
         MVC   CSTKNOTE(L'CSTKNOTE),JNOTEVAL AND SAVE NOTED ADDRESS     03373000
         MVC   CSTKMEM(L'CSTKMEM),LASTFIND SAVE MEMBER NAME IN STACK    03374000
CSTK10   EQU   *                                                        03375000
         MVC   CSTKSW(L'SWITCH9),SWITCH9 SAVE SWITCH9 STATUS            03376000
         MVI   SWITCH9,J0               CLEAR SWITCH AT OLD LEVEL       03377000
         SET   SINCPY,ON                INDICATE IN COPY CODE           03378000
         LA    PARM,EDCSTK-CSTKNOTE(,PARM) COMPUTE NEXT SLOT ADDRESS    03379000
         ST    PARM,CSTKADR             AND SAVE                        03380000
         BR    R3                       RETURN                          03381000
         SPACE                                                          03382000
CSTK20   L     LINK,ASVCTLFM            GET ROUTINE ADDR                03383000
         BALR  TLINK,LINK               GO RESTORE STD I/P CTL FORMATS  03384000
         L     BASE2,CS2ADDR            RESTORE BASE FOR SECOND CSECT   03385000
         B     CSTK10                                                   03386000
*                                                                       03387000
CSTKEXT  EQU   *                                                        03388000
         L     PARM,CSTKADR             POP UP TO NEXT HIGHER LEVEL     03389000
         SH    PARM,CSTKLEN                                             03390000
         ST    PARM,CSTKADR                                             03391000
         MVC   SWITCH9(L'SWITCH9),CSTKSW RESTORE SWITCH9 STATUS         03392000
         C     PARM,BCSTK               TEST IF UP ON HIGHEST LEVEL     03393000
         BNH   CSTKEX2                  BRANCH IF YES                   03394000
CSTKEX1  EQU   *                                                        03395000
         LA    PARM,CSTKMEM             GET MEMBER NAME ADDRESS         03396000
         JFIND ADDR=(PARM)              FIND DISCONTINUED MEMBER        03397000
         L     PARM,CSTKADR             GET STACK ADDRESS       OY01713 03398000
         MVC   LASTFIND(L'LASTFIND),CSTKMEM MOVE MEMBER NAME            03399000
         JPOINTLB ADDR=(PARM)           POINT TO DISCONTINUED STREAM    03400000
         BR    R3                       RETURN                          03401000
CSTKEX2  EQU   *                                                        03402000
         GOIF  SSYSMD,ON=CSTKEX1        BRANCH IF EDITING SYS MACRO     03403000
         MVC   JSRCLN(L'JSRCLN*7),COPYSV3 RESTORE I/P CTL FORMATS       03404000
         MVC   TBGLN(L'TBGLN*6),COPYSV4                                 03405000
         MVC   INPUT,STNPADJ            RESTORE OLD STD-       @OX07230 03406000
         MVC   MINPUT,MINPADJ           OR ICTL I/P-CTL FORMS- @OX07230 03407000
         MVC   MINDIF,MINDFADJ          WHEN NOT IN-           @OX07230 03408000
         MVC   ENDWKA,ENDWKADJ          COPY ANYMORE.          @OX07230 03409000
         SET   JINLIB,OFF               INDICATE OUT OF LIBRARY MODE    03410000
         BR    R3                       RETURN                          03411000
         EJECT                                                          03412000
*********************************************************************** 03413000
*   STMTSEQ ROUTINE IS CALLED EACH TIME A NEW STATEMENT IS BEING        03414000
*   EDITED. ITS FUNCTION IS TO CHECK THE SEQUENCE OF A STATEMENT        03415000
*   RELATIVE TO ITS ENVIRONMENT IN THE INPUT SOURCE STREAM.             03416000
*   (IT HAS NO CONCERN WITH THE SEQUENCE CHECK ACTIVATED BY A           03417000
*   'ISEQ' STATEMENT PROCESSED.)                                        03418000
*        LINKAGES ARE                                                   03419000
*        BAL   RETURN,STMTDSQ                                           03420000
*        BAL   RETURN,STMTSEQ                                           03421000
*********************************************************************** 03422000
         SPACE 3                                                        03423000
STMTDSQ  EQU   *                                                        03424000
         LA    TWKREG1,DMMY-AOTSEQ      DUMMY UP SWITCH BYTE            03425000
STMTSEQ  EQU   *                                                        03426000
         IC    TRTN,AOTSEQ(TWKREG1)     INIT. SEQUENCING SWITCH         03427000
         STC   TRTN,AOTSW                                               03428000
         GOIF  (SKPMND,SKPEND),NONE=SSEQ20 IF NOT SKIP TO MEND/END      03429000
         L     INPTR,INPUT              RESET POINTER                   03430000
         GOIF  SKPMND,ON=SSEQ10         BRANCH IF SKIP TO MEND          03431000
         TM    AOTSW,AOEND              TEST IF END STATEMENT           03432000
         BNO   ABTRTN                   CONTINUE TO FLUSH TO END        03433000
         L     INPTR,FPTRSV             RESET POINTER                   03434000
         B     END                      GO PROCESS THE END STMT         03435000
SSEQ10   EQU   *                                                        03436000
         TM    AOTSW,AOMEND             TEST IF MEND STATEMENT          03437000
         BNO   ABTRTN                   CONTINUE FLUSH TO MEND STMT     03438000
         BAL   RETURN,RESETPTR          REINIT E/T REC FOR PRNT OX00405 03439000
         L     INPTR,INPUT              RESET POINTER          @AX12923 03440000
         SET   SMAC,OFF                 CORRESPONDING MEND FOUND        03441000
         B     MENDZ                    GO PROCESS MEND STATEMENT       03442000
SSEQ20   EQU   *                                                        03443000
         GOIF  AOPSYN,OFF=SSEQ22        BRANCH IF NOT OPSYN STATEMENT   03444000
         GOIF  SNOPSYN,OFF=(RETURN)     RETURN IF OPSYN ALLOWED         03445000
         MVI   OCSAVE,D0                CLEAR OPSYN OP CODE             03446000
         BAL   TLINK,ABSERR             ELSE, LOG ERROR                 03447000
         DC    AL1(8*16+SEV12)          GO TO INVALID RTN THRU ABSERR   03448000
         DC    AL1(ERR12)               SUPPRESS D ENTRY                03449000
SSEQ22   EQU   *                                                        03450000
         CLI   OCSAVE,JTCOPY            DOES THIS STMT INHIBIT OPSYS    03451000
         BNH   SSEQ25                   BR IF ICTL/ISEQ/OPSYN/COPY STMT 03452000
         CLI   OCSAVE,JTPRINT           CHECK IF PRINT STMT    @XA05837 03453000
         BE    SSEQ25                   OPSYN STILL OK         @XA05837 03454000
         CLI   OCSAVE,JTSPACE           CHECK IF IN COPY-SPACE RANGE    03455000
         BL    SSEQ24                   THESE INHIBIT FURTHER OPSYN     03456000
         CLI   OCSAVE,JTTITLE           CHECK IF IN RANGE ABOVE TITLE   03457000
         BNH   SSEQ25                   OPSYN STILL OK,SPACE/EJECT/TITL 03458000
SSEQ24   SET   SNOPSYN,ON               OPSYN NO LONGER ALLOWED         03459000
SSEQ25   EQU   *                                                        03460000
         GOIF  SINCPY,OFF=SSEQ30        BRANCH IF NOT IN COPY CODE      03461000
         TM    AOTSW,AOMEND             TEST IF MEND STMT               03462000
         BO    SSEQ29                   GO TO SET SMAC OFF              03463000
         CLI   OCSAVE,JTMACRO           CHECK IF MACRO STMT             03464000
         BNE   SSEQ27                   BRANCH IF NOT                   03465000
         SET   SMAC,ON                  MACRO STMT COPIED AT THIS LEVEL 03466000
SSEQ27   EQU   *                                                        03467000
         GOIF  AOCOPYX,OFF=SSEQ30       BRANCH IF LEGAL IN COPY CODE    03468000
         BAL   TLINK,ABSERR             THIS STMT ILLEGAL IN COPY CODE  03469000
         DC    AL1(8*16+SEV22)          GO TO INVALID RTN THRU ABSERR   03470000
         DC    AL1(ERR22)               SUBROUTINE                      03471000
SSEQ29   EQU   *                                                        03472000
         SET   SMAC,OFF                 CORRESPONDING MEND FOUND        03473000
SSEQ30   EQU   *                                                        03474000
         GOIF  SMDEF,OFF=SSEQ40         BRANCH IF NOT IN MACRO DEF.     03475000
         GOIF  SXPRTO,OFF=SSEQ35        BRANCH IF NOT EXPECTING PROTO   03476000
         TM    IOCID,BIT0+BIT1                                          03477000
         BNZ   BDPTO                    BRANCH IF ILLEGAL PROTO OP CODE 03478000
SSEQ35   EQU   *                                                        03479000
         TM    AOTSW,AOMACROX           TEST IF LEGAL IN MACRO DEF      03480000
         BCR   BZ,RETURN                BRANCH IF LEGAL                 03481000
         BAL   TLINK,ABSERR             ELSE, LOG ERROR                 03482000
         DC    AL1(8*16+SEV27)          GO TO INVALID RTN THRU ABSERR   03483000
         DC    AL1(ERR27)               THIS STMT ILLEGAL IN MACRO      03484000
SSEQ40   EQU   *                                                        03485000
         GOIF  SPGRMD,OFF=SSEQ45        BRANCH IF NOT EDIT'G PRG'R MAC  03486000
         GOIF  AOKBTNPM,OFF=SSEQ50      BRANCH IF ILLEGAL B/ PGR M DEF  03487000
         BR    RETURN                   RETURN                          03488000
SSEQ45   EQU   *                                                        03489000
         GOIF  SXMCRO,OFF=SSEQ47        BR IF NOT EXP'G MACRO STMT      03490000
         SET   SXMCRO,OFF                                               03491000
         CLI   OCSAVE,JTMACRO           YES, MUST BE SYSTEM MACRO DEF   03492000
         BCR   BEQ,RETURN               BRANCH IF THIS IS MACRO DEF     03493000
*        FIRST CARD IN THIS SYSTEM MACRO DEFINITION IS NOT A 'MACRO'.   03494000
*        LET GENERATOR LOG THE ERROR IN LINE. DEFINITION DISCARRED.     03495000
SSEQ46   EQU   *                                                        03496000
         SET   SKPMND,ON               DUMMY SKIP                       03497000
         SET   SNOSMCRO,ON              1ST STMT IN SYS M DEF NOT MACRO 03498000
         B     MEND1                    GET NEXT SYSTEM MACRO DEF       03499000
SSEQ47   EQU   *                        WE ARE IN OPEN CODE             03500000
         TM    AOTSW,AOPENCDX           TEST IF ALLOWED IN OPEN CODE    03501000
         BCR   BZ,RETURN                BRANCH IF YES                   03502000
         TM    AOTSW,AICOPY             IS THIS AN ICTL STMT            03503000
         BZ    SSEQ48                   BR IF MACRO,MEXIT,MEND          03504000
         BAL   TLINK,ABSERR             LOG ERROR FOR ICTL              03505000
         DC    AL1(8*16+SEV12)          GO TO INVALID RTN VIA ABSERR    03506000
         DC    AL1(ERR12)               ICTL OCCURS AFTER FIRST STMT    03507000
SSEQ48   BAL   TLINK,ABSERR             LOG ERR FOR MACRO,MEXIT,MEND    03508000
         DC    AL1(8*16+SEV23)          GO TO INVALID RTN THRU ABSERR   03509000
         DC    AL1(ERR23)               STMT ILLEGAL IN OPEN CODE       03510000
*        OPEN CODE INITIALIZATION                                       03511000
SSEQ50   EQU   *                                                        03512000
         GOIF  SICTL,ON=(RETURN)        OK IF VALID ICTL                03513000
         SET   (SPGRMD,SOPNCD),FLIP     OUT OF PRGMR MACS, NOW OPEN CD  03514000
         ST    RETURN,EDTSVX            SAVE RETURN POINT               03515000
         MVI   DDNDX1,OPENENT           SET UP INDEX FOR BR TO DIR RTN  03516000
         BAL   R3,DIR10                 INITIALIZE OPEN CODE            03517000
         L     RETURN,EDTSVX            RESTORE RETURN POINT            03518000
         B     SSEQ45                   CHECK SEQ OF FIRST CARD         03519000
         EJECT                                                          03520000
********************************************                            03521000
*        STATEMENT SEQUENCING TABLE        *                            03522000
********************************************                            03523000
         TBLGEN (ICTL,                                                 X03524000
               ISEQ,                                                   X03525000
               OPSYN,                                                  X03526000
               COPY,                                                   X03527000
               ANOP,                                                   X03528000
               GBLA,                                                   X03529000
               GBLB,                                                   X03530000
               GBLC,                                                   X03531000
               LCLA,                                                   X03532000
               LCLB,                                                   X03533000
               LCLC,                                                   X03534000
               MACRO,                                                  X03535000
               ACTR,                                                   X03536000
               AGO,                                                    X03537000
               AIF,                                                    X03538000
               SETA,                                                   X03539000
               SETB,                                                   X03540000
               SETC,                                                   X03541000
               MEXIT,                                                  X03542000
               MEND,                                                   X03543000
               END,                                                    X03544000
               DXD,                                                    X03545000
               EQU,                                                    X03546000
               ORG,                                                    X03547000
               CNOP,                                                   X03548000
               CCW,                                                    X03549000
               DC,                                                     X03550000
               DS,                                                     X03551000
               START,                                                  X03552000
               CSECT,                                                  X03553000
               DSECT,                                                  X03554000
               COM,                                                    X03555000
               ENTRY,                                                  X03556000
               EXTRN,                                                  X03557000
               WXTRN,                                                  X03558000
               CXD,                                                    X03559000
               LTORG,                                                  X03560000
               PUNCH,                                                  X03561000
               REPRO,                                                  X03562000
               PUSH,                                                   X03563000
               POP,                                                    X03564000
               PRINT,                                                  X03565000
               USING,                                                  X03566000
               DROP,                                                   X03567000
               SPACE,                                                  X03568000
               EJECT,                                                  X03569000
               TITLE,                                                  X03570000
               MNOTE,                                                  X03571000
               INVALID),                                               X03572000
               (46,                     ICTL                           X03573000
               5,                       ISEQ                           X03574000
               22,                      OPSYN                          X03575000
               33,                      COPY                           X03576000
               0,                       ANOP                           X03577000
               0,                       GBLA                           X03578000
               0,                       GBLB                           X03579000
               0,                       GBLC                           X03580000
               0,                       LCLA                           X03581000
               0,                       LCLB                           X03582000
               0,                       LCLC                           X03583000
               7,                       MACRO                          X03584000
               0,                       ACTR                           X03585000
               0,                       AGO                            X03586000
               0,                       AIF                            X03587000
               0,                       SETA                           X03588000
               0,                       SETB                           X03589000
               0,                       SETC                           X03590000
               2,                       MEXIT                          X03591000
               66,                      MEND                           X03592000
               128,                     END                            X03593000
               0,                       DXD                            X03594000
               0,                       EQU                            X03595000
               0,                       ORG                            X03596000
               0,                       CNOP                           X03597000
               0,                       CCW                            X03598000
               0,                       DC                             X03599000
               0,                       DS                             X03600000
               0,                       START                          X03601000
               0,                       CSECT                          X03602000
               0,                       DSECT                          X03603000
               0,                       COM                            X03604000
               0,                       ENTRY                          X03605000
               0,                       EXTRN                          X03606000
               0,                       WXTRN                          X03607000
               0,                       CXD                            X03608000
               0,                       LTORG                          X03609000
               0,                       PUNCH                          X03610000
               0,                       REPRO                          X03611000
               0,                       PUSH                           X03612000
               0,                       POP                            X03613000
               1,                       PRINT                          X03614000
               0,                       USING                          X03615000
               0,                       DROP                           X03616000
               1,                       SPACE                          X03617000
               1,                       EJECT                          X03618000
               1,                       TITLE                          X03619000
               0,                       MNOTE                          X03620000
               0),                      INVALID                        X03621000
               AOTSEQ,SEQT,1                                            03622000
         EJECT                                                          03623000
*********************************************************************** 03624000
*   PUTLSIZ ROUTINE IS CALLED EACH TIME BEFORE JPUTL IS ISSUED TO       03625000
*   DETERMINE THE LOGICAL OUTPUT BUFFER SIZE NEEDED FOR A PARTICULAR    03626000
*   STATEMENT.                                                          03627000
*   (AN EDITED TEXT RECORD IS BUILT DIRECTLY INTO BUFFER, SO AS TO      03628000
*   SAVE A MOVE OF THE EDITED TEXT RECORD FROM A WORK AREA TO OUTPUT    03629000
*   BUFFER, AND TO SAVE 1/2K CORE THAT, OTHERWISE, WOULD HAVE TO BE     03630000
*   PROVIDED TO THE WORK BUFFER.) THE RESULT FROM THE CALCULATION IS    03631000
*   RETURNED IN REGISTER R11.                                           03632000
*        BAL   TLINK,PUTLSIZ                                            03633000
*********************************************************************** 03634000
         SPACE 3                                                        03635000
*****************************************                               03636000
*        COMPUTE O/P BUFFER SIZE        *                               03637000
*****************************************                               03638000
PUTLSIZ  EQU   *                                                        03639000
         GOIF  (SDTCMT,STRCMT),MIX=CMTSIZ COMMENTS STATEMENT SIZE       03640000
*        GOIF  SMIPRTO,ON=MISIZ         MACRO INSTR. OR PROTOTYPE       03641000
         GOIF  SPRVCT,ON=CNTSIZ         WITH CONTINUATION CARDS         03642000
         LA    R11,SZNORM               ELSE, MUST BE NORMAL SIZE       03643000
         B     OPUTL                    GO GET BUFFER ADDRESS           03644000
CMTSIZ   EQU   *                                                        03645000
         LA    R11,SZCMT                GET BUFFER SIZE                 03646000
         B     OPUTL                    GO GET BUFFER ADDRESS           03647000
MISIZ    EQU   *                                                        03648000
         LA    R11,SZMI                 LOAD MI/PROTO SIZE              03649000
         B     OPUTL                    GO GET BUFFER ADDRESS           03650000
CNTSIZ   EQU   *                                                        03651000
         LA    R11,SZCNT                LOAD CONTINUATION SIZE          03652000
         B     OPUTL                    GO GET BUFFER ADDRESS           03653000
         EJECT                                                          03654000
*********************************************************************** 03655000
*   ABTRTN IS CALLED WHEN A MACRO DEFINITION IS TO BE FLUSHED.          03656000
*********************************************************************** 03657000
ABTRTN   EQU   *                                                        03658000
         BAL   RETURN,RESETPTR          REINIT E/T REC FOR PRINT ONLY   03659000
         LA    INDEXP,JTHDRLN+2(,INDEXO)  RESET TEXT POINTER            03660000
         SET   SNOPND,ON                INDICATE TO RETURN              03661000
         SET JPRONLY,ON                                                 03662000
         BAL   RETURN,SAVPTR            EDIT AS COMMENTS FIELD          03663000
         L     LINK,ARDSRC              POINT TO RDSRC                  03664000
         BALR  RETURN,LINK              READ ONE CARD                   03665000
         DC    AL2(RBYPONE-RFSTCRD)     BYPASS ONE CARD                 03666000
         GOIF  SINEOF,ON=EOFRTN         BRANCH IF END OF FILE           03667000
         LA    R11,SZCNT                NO, SO....                      03668000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  03669000
         BAL   RETURN,HDINIT            INITIALIZE HEADER               03670000
         SET   SUPDNT,ON                SUPPRESS DIRECTORY ENTRY        03671000
         B     PROCNXT                  GO PROCESS AS NORMAL            03672000
         EJECT                                                          03673000
*********************************************************************** 03674000
*        CHECK NAME FOR SEQUENCE SYMBOL OR BLANK                      * 03675000
CKANYSYM EQU   *                                                        03676000
         GOIF  (ROSYM,RVSYM)            RETURN IF NAME A                03677000
         BCR   7,TLINK                  VS OR OS                        03678000
CHKSSNM  EQU   *                                                        03679000
         GOIF  RSSYM,ON=(TLINK)         RETURN IF NAME A S.S.           03680000
CHKNM    EQU   *                                                        03681000
         GOIF  SNMFND,OFF=(TLINK)       RETURN IF NO NAME               03682000
         ST    TLINK,EDTSVX             SAVE RETURN POINT               03683000
         BAL   RETURN,NAMERR            ELSE, LOG ERROR                 03684000
         L     TLINK,EDTSVX             RESTORE RETURN POINT            03685000
         BR    TLINK                    RETURN TO CALLER                03686000
         SPACE 3                                                        03687000
         JPATCH  X1A10,E70                                              03688000
         EJECT                                                          03689000
         JCSECT (X1A20=CS3)                                             03690000
*********************************************************************** 03691000
*                                                                     * 03692000
* RDSRC - THIS ROUTINE IS CALLED WHEN A NEW STATEMENT OR A CONTINUATION 03693000
*   RECORD IS TO BE READ. IT CALLS 'JINPUT' MACRO TO READ A RECORD      03694000
*   FROM SYSTEM INPUT, OR FROM MACRO LIBRARY IF 'JINLIB' BIT IN         03695000
*   'JINFLAG' BYTE IS ON.  IT SEQUENCE CHECKS THE RECORD WHEN ISEQ      03696000
*   SWITCH (SWITCH1 BIT 0) IS ON. FINALLY, IT MOVES THE RECORD TO       03697000
*   INPUT WORK BUFFER.                                                  03698000
*        BAL   RETURN,RDSRC                                             03699000
*        BAL   RETURN,RDSRC05                                           03700000
*                                                                       03701000
*********************************************************************** 03702000
*                                                                     * 03703000
*   RFSTCRD = READ FIRST CARD OF A STATEMENT - ALWAYS FROM READNEXT   * 03704000
*   RALLCNT = READ ALL CONTINUATIONS - FOR MACHINE/ASSEMBLER OPS      * 03705000
*   RONECNT = READ ONE CONTINUATION - FOR MACRO CALLS/PROTOTYPE STMTS * 03706000
*   RBYPCNT = BYPASS ALL CONTINUATIONS - FOR STMTS WITH HARD ERRORS   * 03707000
*   RONECRD = READ ONE CARD - FOR REPRO STATEMENT                     * 03708000
*   RBYPONE = BYPASS ONE CARD IN EDITED FORMAT - FOR DATA FLUSHING    * 03709000
*                                                                     * 03710000
*********************************************************************** 03711000
RDSRC    EQU   *                                                        03712000
         L     INPTR,INPUT              UPDATE INPTR                    03713000
RDSRC05  EQU   *                                                        03714000
         STM   R12,R9,SAVMALL           SAVE REGISTERS                  03715000
         BALR  BASE3,0                  REDEFINE BASE REGISTER          03716000
         USING *,BASE3                                                  03717000
         LH    TWKREG1,D0(,RETURN)      GET BRANCH POINT                03718000
         B     RFSTCRD(TWKREG1)         AND FAN OUT                     03719000
RFSTCRD  EQU   *                        READ FIRST CARD                 03720000
         SET   (SNXTCT,SPRVCT),OFF      RESET SWITCHES                  03721000
RDSRC10  EQU   *                                                        03722000
         NI    CNTCTR,ALLOFF                                            03723000
RDSRC20  EQU   *                                                        03724000
         L     TWKREG1,DSTGBGN          INITIALIZE STRING AREA POINTER  03725000
         ST    TWKREG1,DSTGADJ          TO ORIGINAL POINT               03726000
         ST    TWKREG1,DSTGNDX                                          03727000
         MVI   D0(TWKREG1),D0           RESET STRING COUNT              03728000
         B     RCONT                    READ CONTINUATIONS IF ANY       03729000
RONECRD  EQU   *                        READ ONE CARD                   03730000
         SET   SONECD,ON                                                03731000
         B     RFSTCRD                  GO                              03732000
RBYPONE  EQU   *                        BYPASS ONE CARD IN EDITED FORM  03733000
         SET   SBYONE,ON                INDICATE READ ONE CARD          03734000
         B     RFSTCRD                  GO                              03735000
RBYPCNT  EQU   *                        BYPASS ALL CONTINUATIONS        03736000
         SET   SBYCNT,ON                                                03737000
         B     RDSRC10                  FLUSH THROUGH CONTINUATION      03738000
RONECNT  EQU   *                        READ ONE CONTINUATION CARD      03739000
         SET   SONECT,ON                                                03740000
         B     RDSRC20                  GO GET ONE CARD                 03741000
RALLCNT  EQU   *                                                        03742000
         SET   SALLCT,ON                                                03743000
RCONT    EQU   *                                                        03744000
         GOIF  (SBYCNT,SONECT,SALLCT),NONE=RINPT BR IF NO CONTINUATION  03745000
RCNTLP   EQU   *                                                        03746000
         GOIF  SPRVCT,OFF=REXIT         RETURN IF NOT TO BE CONT'D      03747000
RINPT    EQU   *                                                        03748000
         JINPUT                         GET INPUT BUFFER POINTER        03749000
         BNP   REOFX                    GO TO END OF FILE ROUTINE       03750000
         ST    RETADR,IPTRSV            SAVE INPUT POINTER              03751000
RINIT    EQU   *                                                        03752000
         LM    R3,R5,JSRCLN             REGISTER INITIALIZATION         03753000
         IC    TWKREG1,CNTCTR           INCREMENT CARD COUNT            03754000
         LA    TWKREG1,D1(,TWKREG1)                                     03755000
         STC   TWKREG1,CNTCTR                                           03756000
         BAL   RETURN,MVSRC             MOVE RECORD TO INPUT WK BUF     03757000
*                                       SEPARATE STRINGS FROM DATA      03758000
         ST    INPTR,ENDATA                                             03759000
         MVI   D0(INPTR),JBLANK         PATCH A BLANK FOR SCANNER       03760000
         GOIF  SONECD,ON=REXIT          RETURN TO CALLER IF RONECD      03761000
         LM    SEQREG,SQLREG,JSEQCL                                     03762000
*                                                                       03763000
         GOIF  SNOCNT,ON=RSEQCHK        BRANCH IF CONT'N NOT ALLOWED    03764000
         LA    TWKREG1,D0(CNTREG,RETADR)                                03765000
         CLI   D0(TWKREG1),JBLANK       TEST IF ANY CONTINUATION        03766000
         BE    RSEQCHK                  NO, GO CHECK SEQUENCE           03767000
         SET   SNXTCT,ON                INDICATE TO BE CONTINUED        03768000
RSEQCHK  EQU   *                                                        03769000
         GOIF  SISEQ,OFF=RFCCHK         BRANCH IF NOT TO SEQ CHK        03770000
         LA    TWKREG1,D0(SEQREG,RETADR)                                03771000
         EX    SQLREG,SEQMV             MOVE SEQ FIELD TO TR AREA       03772000
         EX    SQLREG,SEQTR             TRANSLATE                       03773000
         EX    SQLREG,SEQCPR            SEQUENCE CHECK                  03774000
         EX    SQLREG,SEQSAVE           SAVE NEW SEQ VALUE              03775000
         BH    RFCCHK                   SEQUENCE OK                     03776000
         BAL   TLINK,WRNERR             GO LOG SEQUENCE ERROR           03777000
         DC    AL1(SEV25)               .                               03778000
         DC    AL1(ERR25)               INPUT SEQUENCE ERROR            03779000
*                                                                       03780000
RFCCHK   EQU   *                                                        03781000
         GOIF  (SONECD,SBYCNT,SONECT,SALLCT),NONE=RMORCNT IF RFSTCRD    03782000
         GOIF  SPRVCT,OFF=REXCS         IF THIS CD NOT CONT OF PREV CD  03783000
         L     CBGREG,JCTBGN                                    OX00081 03784000
         LA    INPTR,D0(BEGREG,RETADR)  PREPARE TO GO CHECK BLANKS      03785000
         LA    TWKREG2,D0(CBGREG,RETADR)                                03786000
         BAL   TLINK,SKPBLK0            SKIP BLANKS                     03787000
         L     INPTR,ENDATA             RESTORE INPTR                   03788000
         GOIF  SNOFND,ON=REXCS          O.K. IF BLANK                   03789000
         BAL   TLINK,WRNERR             GO LOG CONTINUATION ERROR       03790000
         DC    AL1(SEV26)               CONTINUATION CARD STARTS        03791000
         DC    AL1(ERR26)               BEFORE CONTINUATION COLUMN      03792000
*                                                                       03793000
REXCS    EQU   *                                                        03794000
         GOIF  SALLCT,OFF=RMORCNT       BRANCH IF NOT RALLCNT           03795000
         CLI   CNTCTR,J3                CHECK CARD COUNT                03796000
         BL    RMORCNT                  GO GET CONTINUATIONS            03797000
         BH    REXCS10                  TOO MANY CONTINUATIONS, ERROR   03798000
         GOIF  SNXTCT,ON=REXCS10        MORE CONT'NS IS ERROR           03799000
         SET   SPRVCT,OFF               RESET CONTINUATION BIT          03800000
         B     RAXIT                    EXIT                            03801000
REXCS10  EQU   *                                                        03802000
         BAL   TLINK,WRNERR             GO LOG CONTINUATION ERROR       03803000
         DC    AL1(SEV69)               MORE THAN 2 CONTINUATION        03804000
         DC    AL1(ERR69)               CARDS IN THIS STMT              03805000
         SET   SBYCNT,ON                BYPASS ALL CONTINUATIONS        03806000
         SET   SALLCT,OFF                                               03807000
*                                                                       03808000
RMORCNT  EQU   *                                                        03809000
         SET   SPRVCT,OFF               RESET CONTINUATION SWITCH       03810000
         GOIF  SNXTCT,OFF=RAXIT         BRANCH IF NO MORE CONT'NS       03811000
         SET   SPRVCT,ON                INDICATE TO BE CONTINUED        03812000
         SET   SNXTCT,OFF               PREPARE FOR NEXT CARD           03813000
*                                                                       03814000
RAXIT    EQU   *                                                        03815000
         GOIF  SALLCT,ON=RCNTLP         READ NEXT CARD IF RALLCNT       03816000
REXIT    EQU   *                        RETURN TO CALLER                03817000
         SET   (SONECD,SONECT,SALLCT),OFF                               03818000
*        RBYPCNT BIT WILL BE SET OFF AT WRAPFLD WHEN ALL CARDS TO BE    03819000
*        BYPASSED ARE READ.                                             03820000
*                                                                       03821000
         LM    R12,R9,SAVMALL           RESTORE REGISTERS               03822000
         B     D2(,RETURN)              RETURN TO CALLER                03823000
REOFX    EQU   *                                                        03824000
         SET   SINEOF,ON                INDICATE END OF FILE            03825000
         B     REXIT                    RETURN TO CALLER                03826000
*                                                                       03827000
MVSRC    EQU   *                                                        03828000
         ST    RETURN,EDTSVX            SAVE RETURN POINTER             03829000
         LR    SRCPTR,RETADR            SET SOURCE RECORD POINTER       03830000
         LA    SRCEND,CRDLN(,SRCPTR)    END RECORD POSITION PLUS 1      03831000
         L     DSTGPTR,DSTGNDX          RESERVE SPACE FOR STRING COUNT  03832000
         LA    DSTGPTR,D1(,DSTGPTR)                                     03833000
         ST    DSTGPTR,DSTGNDX                                          03834000
         NI    STGCNT,ALLOFF            ZERO OUT STRING COUNT           03835000
         LA    STGLOC,D1                GET STRING LOCATION             03836000
         GOIF  SBYCNT,ON=MVSRC1         EDIT AS NON-CONT'N IF TO BYPASS 03837000
         GOIF  SPRVCT,ON=MVPBSTG        BRANCH IF A CONT'N CARD         03838000
MVSRC1   EQU   *                                                        03839000
         LTR   BEGREG,BEGREG            IF NO PRE-BEGIN STRING          03840000
         BZ    MVDATA                   GO MOVE DATA                    03841000
         L     TWKREG2,PBGLEN           GET PRE-BEGIN STRING LENGTH -1  03842000
MVSTRING EQU   *                                                        03843000
         LA    R1,D1(TWKREG2,SRCPTR)    GET UPPER LIMIT OF SCAN         03844000
         LR    TWKREG1,SRCPTR           GET BEGIN ADDRESS TO BE SCANNED 03845000
         B     MVSTR20                  GO TEST FOR END OF STRING       03846000
MVSTR10  EQU   *                                                        03847000
         LA    TWKREG1,D1(,TWKREG1)     STEP TO NEXT COLUMN             03848000
MVSTR20  EQU   *                                                        03849000
         CR    TWKREG1,R1               TEST IF END OF STRING           03850000
         BE    MVNONE                   YES, BLANK STRING               03851000
         CLI   D0(TWKREG1),JBLANK       IS IT A BLANK                   03852000
         BE    MVSTR10                  YES, GO CHECK NEXT COLUMN       03853000
         STC   STGLOC,SOPTR             MOVE IN STRING OUTPUT POINTER   03854000
         EX    TWKREG2,MVSTRG           MOVE STRING                     03855000
         LA    TWKREG2,D1(,TWKREG2)     MAKE IT TRUE LENGTH             03856000
         STC   TWKREG2,SOLEN            MOVE IN STRING TRUE LENGTH      03857000
         LA    SRCPTR,D0(TWKREG2,SRCPTR) POINT TO NEXT FIELD            03858000
         IC    TWKREG1,STGCNT           UPDATE STRING COUNT             03859000
         LA    TWKREG1,D1(,TWKREG1)     BY ONE                          03860000
         STC   TWKREG1,STGCNT                                           03861000
         LA    TWKREG1,D2(TWKREG2,DSTGPTR) UPDATE STRING INDEX          03862000
         ST    TWKREG1,DSTGNDX                                          03863000
MVSTR30  EQU   *                                                        03864000
         CR    SRCPTR,SRCEND            TEST IF END OF RECORD           03865000
         BL    MVDATA                   NO, GO MOVE DATA                03866000
MVRTN    EQU   *                                                        03867000
         L     DSTGPTR,DSTGADJ          BACK UP TO STRING POINTER TO    03868000
         IC    TLINK,STGCNT             INSERT STRING COUNT INTO        03869000
         STC   TLINK,SCCNT              EDITED TEXT                     03870000
         L     TLINK,DSTGNDX            UPDATE ADJUSTED POINTER         03871000
         ST    TLINK,DSTGADJ                                            03872000
         L     RETURN,EDTSVX            YES, RETURN TO CALLER           03873000
         BR    RETURN                   RETURN                          03874000
MVNONE   EQU   *                                                        03875000
         LR    SRCPTR,TWKREG1           POINT TO NEXT FIELD             03876000
         B     MVSTR30                  GO TEST FOR END OF RECORD       03877000
MVPBSTG  EQU   *                                                        03878000
         L     TWKREG2,JCTBGN           PREPARE TO SCAN TO CONT'N BEG.  03879000
         BCTR  TWKREG2,0                BACK UP 1                       03880000
         B     MVSTRING                 GO SCAN TO END OF STRING        03881000
*                                                                       03882000
MVDATA   EQU   *                                                        03883000
         LR    TWKREG2,SLNREG           GET SOURCE LENGTH               03884000
         GOIF  SPRVCT,OFF=MVDEX         BRANCH IF NOT CONT'D            03885000
         GOIF  SBYCNT,ON=MVDEX          BRANCH IF TO BYPASS ONE CARD    03886000
         L     TWKREG2,JCTLN            ELSE, GET CONT'N LENGTH         03887000
MVDEX    EQU   *                                                        03888000
         LR    DSTGPTR,INPTR            SET UP DESTINATION  POINTER     03889000
         EX    TWKREG2,MVSEGT                                           03890000
         LA    INPTR,D1(TWKREG2,INPTR)  BUMP WORK AREA POINTER          03891000
         LA    SRCPTR,D1(TWKREG2,SRCPTR) POINT TO NEXT FIELD            03892000
         CR    SRCPTR,SRCEND            TEST IF END OF DATA             03893000
         BNL   MVRTN                    YES, EXIT                       03894000
         L     TWKREG2,PNDLEN           LOAD POST-END STRING LENGTH     03895000
         LA    STGLOC,D1(,CNTREG)       SET UP POST-END STRING LOCATION 03896000
         L     DSTGPTR,DSTGNDX          SET UP DESTINATION POINTER      03897000
         B     MVSTRING                 GO SCAN TO END OF STRING        03898000
MVSEGT   MVC   D0(0,DSTGPTR),D0(SRCPTR) OFF-THE-LINE MOVE               03899000
MVSTRG   MVC   SDATA(0),D0(SRCPTR)      OFF-THE-LINE MOVE               03900000
SEQMV    MVC   SEQSVT(0),D0(TWKREG1)    MOVE SEQ FIELD TO TR AREA       03901000
SEQTR    TR    SEQSVT(0),JTRTABLE       TRANSLATE                       03902000
SEQCPR   CLC   SEQSVT(0),SEQSV          COMPARE SEQ FIELD               03903000
SEQSAVE  MVC   SEQSV(0),SEQSVT          SAVE NEW SEQ VALUE              03904000
         DROP  INDEXP,R14                                               03905000
         EJECT                                                          03906000
*********************************************************               03907000
*        PROTOTYPE STATEMENT PARAMETER PROCESSOR        *               03908000
*********************************************************               03909000
         USING MPROTO,INDEXP                                            03910000
         USING MPMT,R14                                                 03911000
MIPRTOIN JSAVE BASE=NO                                                  03912000
         LR    BASE3,LINK               REDEFINE BASE REGISTER          03913000
         USING MIPRTOIN,BASE3                                           03914000
         GOIF  SXPRTO,OFF=MCALLIN       BRANCH IF MCARO CALL            03915000
PROTOIN  EQU   *                        PROTOTYPE PROCESSOR             03916000
         SET   SDENT,OFF                INSURE SS DEF IS NOT ENTERED    03917000
         SET   JTPROTO                  INDICATE PROTO                  03918000
         BAL   RETURN,DTADJ             MAKE DATA ADJUSTMENT            03919000
         B     STEND                    END STATEMENT IF RETURN HERE    03920000
         GOIF  SNMFND,ON=PRTX           BRANCH IF THERE IS A NAME       03921000
* IF NO NAME, INDICATE THAT A NULL PARAMETER EXISTS FOR MACRO EXPANSION 03922000
         L     R3,GTPVALOC              GET POS PARM COUNTER INDICATOR  03923000
         LA    R3,D3(,R3)               BUMP POS PARM CTR BY 3 BYTES    03924000
         ST    R3,GTPVALOC              SAVE FOR MACRO GENERATOR        03925000
PRTX     EQU   *                                                        03926000
         LA    R11,SZMI                                                 03927000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  03928000
         BAL   RETURN,HDINIT            INITIALIZE HEADER               03929000
         ST    INPTR,FPTRSV             SAVE POINTERS                   03930000
         ST    INDEXP,OFPTRSV                                           03931000
         SET   JTPPKEY                  ASSUME KEYWORD PARAMETER        03932000
         SET   JPSOP,ON                                                 03933000
PRTX10   EQU   *                                                        03934000
         CLI   D0(INPTR),JAMPER         TEST IF AMPERSAND               03935000
         BNE   PRTCMA                   BRANCH IF NOT                   03936000
*BUMP THE POINTER PAST THE '&' FOR THE DIRECTORY ROUTINE                03937000
         LA    INPTR,D1(,INPTR)         BUMP OVER V SYM HEAD            03938000
         BAL   RETURN,TRT01             TRT V SYMBOL                    03939000
         BCT   R3,BADPARM               ERROR IF NOT A/N STRING         03940000
         MVI   FLGBYT,PARMFLG           ASSUME POSITIONAL PARAMETER     03941000
         GOIF  SNMFND,OFF=PRTX40        MUST BE OPERAND IF NOT NAME     03942000
         CLI   D0(R1),JBLANK            TERMINATOR MUST BE A BLANK      03943000
         BNE   BADPARM                  ELSE,ERROR                      03944000
PRTX15   CH    R15,H7                   LENGTH MUST BE RIGHT            03945000
         BNL   BADPARM                  ELSE, LOG ERROR                 03946000
         LR    PARAM2,TWKREG2           GET MOVE LENGTH OF SYMBOL       03947000
         LR    PARM,INPTR               GET THE POINTER                 03948000
         MVI   DDNDX1,VARBSYMD          INDICATE VAR SYM DEFINITION     03949000
         BAL   R3,DIRENT                MAKE DIRECTORY ENTRY            03950000
         GOIF  SNMFND,OFF=PRTX20        GO FIND NEXT OPERAND            03951000
PRTX16   BAL   RETURN,ADJ20             MAKE DATA ADJUSTMENT            03952000
         B     STEND                    END STATEMENT IF RETURN HERE    03953000
         B     PRTX                     EDIT OPERAND                    03954000
PRTX20   EQU   *                                                        03955000
         TM    DERRCD,BITFF             SEE IF ERROR RETURNED FROM DIR  03956000
         BNZ   SKMNDST                  FLUSH MACRO IF ERROR FOUND      03957000
         LR    INPTR,R1                 UPDATE POINTER                  03958000
         CLI   D0(INPTR),JEQUAL         TEST IF KWD PARAM               03959000
         BNE   PRTX30                   BRANCH IF NOT                   03960000
         MVC   VECPTR,D1(R11)           SAVE VECTOR POINTER             03961000
         LA    R14,MPHDL(,INDEXP)       GET HDR RECORD LENGTH           03962000
PRTX25   ST    R14,MTXTP                SAVE MT POINTER                 03963000
         LR    R15,R14                  SAVE HDF BASE REGISTER          03964000
         SR    R15,INDEXO               COMPUTE OPERAND POINTER         03965000
         STH   R15,JTOPP                                                03966000
         BAL   RETURN,BLDPMT            BUILD PARAM MT                  03967000
         BAL   RETURN,NEXTPM            EDIT KWD OPERAND                03968000
         SET   (DSDTX,DECMA,DEEQL,DLPRN),OFF RESET INDICATORS           03969000
         BAL   RETURN,WRAPOPND          WRAP UP OPERAND                 03970000
PRTX30   EQU   *                                                        03971000
         CLI   D0(INPTR),JRPARN         TEST IF END OF SUBLIST          03972000
         BNE   PRTX35                   BRANCH IF NOT                   03973000
         LA    INPTR,D1(,INPTR)         YES, BUMP OVER R PAREN          03974000
         BAL   R12,DPARCT               DECREMENT PAREN COUNT           03975000
         BL    UNBAL                    LOG ERROR IF UNBAL PARENS       03976000
PRTX35   EQU   *                                                        03977000
         CLI   D0(INPTR),JCOMMA         OR IS IT A COMMA                03978000
         BE    PRTX50                   BRANCH IF YES                   03979000
         CLI   D0(INPTR),JBLANK         OR IS IT A BLANK                03980000
         BE    STEND                    END STATEMENT                   03981000
         B     BADPARM1                 BAD PARAMETER                   03982000
PRTX40   EQU   *                                                        03983000
         CLI   D0(R1),JEQUAL            IS IT KEYWORD                   03984000
         BNE   PRTX15                   BRANCH IF NOT                   03985000
         MVI   FLGBYT,PARMFLG+VPTYP     ELSE, SO INDICATE               03986000
         SET   SKWPRM,ON                INDICATE PROCESSING KWD         03987000
         B     PRTX15                   CONTINUE CHECKING               03988000
PRTX50   EQU   *                                                        03989000
         LA    INPTR,D1(,INPTR)                                         03990000
         L     PARAM1,MINPUT                                            03991000
         BAL   TLINK,SHFTDTA            SHUFFLE DATA A LITTLE           03992000
         CLI   D0(INPTR),JBLANK         IS COMMA FOLLOWED BY A BLANK    03993000
         BNE   PRTX                     EDIT NEXT PARAMETER             03994000
         GOIF  SNOCNT,ON=STEND          END STMT IF NO CONT'N ALLOWED   03995000
         BAL   RETURN,BUMPD             BUMP OVER COMMENTS              03996000
*                                                                       03997000
PRTX70   EQU   *                                                        03998000
         L     PARAM1,MINPUT                                            03999000
         BAL   TLINK,SHFTDTA            SHUFFLE, SHUFFLE                04000000
         B     PRTX                     EDIT NEXT PARAMETER             04001000
PRTCMA   EQU   *                                                        04002000
         CLI   D0(INPTR),JCOMMA         TEST IF AN OMITTED PARAMETER    04003000
         BNE   PRTBLK                   BRANCH IF NOT                   04004000
         GOIF  SNMFND,ON=BADPARM        BAD PARAMETER                   04005000
*NOW WE KNOW IT'S A NULL PARAMETER, UP THE PARM COUNTER FOR GENERATOR   04006000
         L     R3,GTPVALOC              GET POS PARM COUNTER INDICATOR  04007000
         LA    R3,D3(,R3)               BUMP POS PARM CTR BY 3 BYTES    04008000
         ST    R3,GTPVALOC              SAVE FOR MACRO GENERATOR        04009000
         B     PRTX50                   SHIFT DATA IF YES               04010000
PRTBLK   CLI   D0(INPTR),JBLANK         TEST IF END OF STATEMENT        04011000
         BNE   BADPARM                  LOG ERROR IF NOT                04012000
         B     STEND                    ELSE, WRAP UP STATEMENT         04013000
         SPACE 3                                                        04014000
*        LINKAGES ARE                                                   04015000
*              BAL   RETURN,DTADJ                                       04016000
*              BAL   RETURN,ADJ20                                       04017000
DTADJ    EQU   *                                                        04018000
         ST    RETURN,ADJSV             SAVE RETURN POINT               04019000
         L     RCNT,INPUT               BEGIN OF FIELD                  04020000
         BAL   RETURN,PRESUB1           OUTPUT PRE-SUBSTITUTION RECORD  04021000
         GOIF  SNMFND,OFF=ADJ25         BRANCH IF NO NAME               04022000
         L     INPTR,INPUT              POINT TO NAME                   04023000
         GOIF  SXPRTO,ON=ADJOUT         LET GO IF PROTO                 04024000
         GOIF  NSSYM,ON=ADJ25           IGNORE NAME IF SS               04025000
ADJOUT   EQU   *                                                        04026000
         L     RETURN,ADJSV             RESTORE POINTER                 04027000
         B     D4(,RETURN)              RETURN                          04028000
ADJ20    EQU   *                                                        04029000
         ST    RETURN,ADJSV             SAVE RETURN POINTER             04030000
ADJ25    EQU   *                                                        04031000
         SET   SNMFND,OFF               INDICATE IN OPERAND             04032000
         L     INPTR,OPNDPTR            BUMP TO OPERAND FIELD           04033000
ADJ30    BAL   TLINK,SKPBLK             GO FIND NEXT PARAMETER          04034000
         GOIF  SNOFND,ON=ADJ40          BRANCH IF NOT FOUND YET         04035000
         L     TWKREG1,ENDATA           MAKE ENDATA ADJUSTMENT          04036000
         SH    TWKREG1,MINDIF           FOR 1ST CARD IN STATEMENT       04037000
         ST    TWKREG1,ENDATA           BEFORE SHIFTING                 04038000
         L     PARAM1,INPUT                                             04039000
         BAL   TLINK,SHFTDTA            SHIFT DATA                      04040000
         B     ADJOUT                   RETURN                          04041000
ADJ40    EQU   *                                                        04042000
         MVC   DTLENG(L'DTLENG),TCNTLN2                                 04043000
ADJ45    EQU   *                                                        04044000
         GOIF  SPRVCT,OFF=ADJOUT2       ELSE,CHECK IF TO BE CONTINUED   04045000
         L     INPTR,MINPUT                                             04046000
         BAL   RETURN,READATA           READ NEXT CARD                  04047000
         L     INPTR,MINPUT                                             04048000
         BAL   TLINK,SKPBLK             CHECK IF PARAM STARTS HERE      04049000
         GOIF  SNOFND,ON=ADJ45          IF NOT, NEXT CARD               04050000
         L     INPTR,ENDATA                                             04051000
         BAL   TLINK,GETDNT            YES, READ IN BUFFER FULL         04052000
         B     ADJOUT                   GO EDIT THEM                    04053000
ADJOUT2  EQU   *                                                        04054000
         L     RETURN,ADJSV             RESTORE POINTER                 04055000
         BR    RETURN                   RETURN TO CALLER                04056000
BUMPD    EQU   *                                                        04057000
         LH    RCNT,DTLENG              GET DATA LENGTH                 04058000
         SH    RCNT,COLCTR              MINUS CURRENT LENGTH            04059000
         AR    INPTR,RCNT               ADD INTO INPTR                  04060000
         BR    RETURN                   RETURN TO CALLER                04061000
SHFTDTA  EQU   *                                                        04062000
         L     TWKREG1,MINPUT           GET BEGIN OF BUFFER             04063000
         L     TWKREG2,ENDWKA           COMPUTE DATA MOVE LENGTH        04064000
         SR    TWKREG2,INPTR                                            04065000
         LR    PARAM2,INPTR                                             04066000
         CH    TWKREG2,H255             DO WE SHIFT MORE THAN 255       04067000
         BNH   SHIFT                    MOVE IF NOT OVER 255 CHAR       04068000
         MVC   D0(MAXCNT,TWKREG1),D0(PARAM2) ELSE, MOVE 255 FIRST       04069000
         SH    TWKREG2,H255             MAKE ADJUSTMENT                 04070000
         AH    TWKREG1,H255             TO MOVE THE REMAINING           04071000
         AH    PARAM2,H255              NUMBER OF BYTES                 04072000
         BCTR  TWKREG2,0                REDUCE MOVE LENGTH BY 1         04073000
SHIFT    EX    TWKREG2,SHMOVE           GO SHIFT DATA INTO WORK AREA    04074000
         SR    INPTR,PARAM1             NUMBER OF BYTES SHIFTED         04075000
         LH    RCNT,CRDCTR              GET CARD NUMBER                 04076000
         LH    TWKREG2,COLCTR           GET ACCUMULATED NUM OF COL      04077000
         AR    TWKREG2,INPTR            ADD ADDITIONAL NUM OF COLUMNS   04078000
COUNT    CH    TWKREG2,DTLENG           STILL IN THE SAME CARD OR NOT   04079000
         BL    COUNTX                   YES.                            04080000
         SH    TWKREG2,DTLENG                                           04081000
         AH    RCNT,H1                                                  04082000
         MVC   DTLENG(L'DTLENG),TCNTLN2 SET DATA LENGTH                 04083000
         B     COUNT                    LOOP UNTIL END OF FIELD         04084000
COUNTX   EQU   *                                                        04085000
         STH   TWKREG2,COLCTR           SAVE COUNTERS                   04086000
         STH   RCNT,CRDCTR                                              04087000
         L     TWKREG1,ENDATA                                           04088000
         SR    TWKREG1,INPTR            FIND OUT ENDATA AFTER SHIFTING  04089000
         ST    TWKREG1,ENDATA           WHICH IS NEXT AVAILABLE LOC     04090000
         LR    INPTR,TWKREG1            FOR NEXT CARD                   04091000
GETDNT   ST    TLINK,RTNSV1             SAVE RETURN POINT               04092000
GETDTA   EQU   *                                                        04093000
         GOIF  SPRVCT,OFF=GETDX         EXIT IF NOT CONTINUED           04094000
GETD10   L     TWKREG2,ENDWKA           ELSE, CHECK IF STILL HAVE ROOM  04095000
         SR    TWKREG2,INPTR            FOR ONE MORE CARD               04096000
         CH    TWKREG2,DTLENG                                           04097000
         BNH   GETDX                    NO MORE ROOM, EXIT.             04098000
         BAL   RETURN,READATA           GET ONE CARD                    04099000
         L     INPTR,ENDATA                                             04100000
         B     GETDTA                   GET NEXT CARD                   04101000
         SPACE                                                          04102000
R9SAVE   EQU   OPCDPTR                                                  04103000
READATA  ST    RETURN,R9SAVE                                            04104000
         L     RETURN,ARDSRC05          GET BRANCH ADDRESS              04105000
         BALR  RETURN,RETURN            READ IT IN                      04106000
         DC    AL2(RONECNT-RFSTCRD)     .                               04107000
         GOIF  SINEOF,OFF=READATA5      EOF NOT ALLOWED        @OX07290 04108000
         LA    R10,ERR263               LOAD ERR MSG NR        @OX07290 04109000
         B     JABORT                   GEN ERR MSG, TERMINATE @OX07290 04110000
READATA5 EQU   *                                               @OX07290 04111000
         LA    R11,SZCMT                                                04112000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  04113000
         BAL   RETURN,HDINIT            INITIALIZE HEADER               04114000
         SET   JPSOP,ON                 INDICATE ASSEMBLER OP           04115000
         SET   JNOCNT,ON                PRINT-ONLY, NO STMT NUMBER      04116000
         SET   JTPROTO                  INDICATE PROTO                  04117000
         GOIF  SMI,OFF=GETD20           BRANCH IF NOT MI                04118000
         SET   JTCALL                   ELSE, RESET IOC                 04119000
GETD20   EQU   *                                                        04120000
         BAL   RETURN,PRESUB            OUTPUT PRE-SUB RECORD           04121000
         L     RETURN,R9SAVE                                            04122000
         BR    RETURN                   RETURN                          04123000
GETDX    EQU   *                                                        04124000
         L     INPTR,MINPUT             RESTORE INPTR                   04125000
         L     TLINK,RTNSV1             RESTORE RETURN POINT            04126000
         BR    TLINK                    RETURN TO CALLER                04127000
SHMOVE   MVC   D0(0,TWKREG1),D0(PARAM2) OFF-THE-LINE MOVE               04128000
PRESUB   EQU   *                                                        04129000
         L     TWKREG1,JCTBGN           COMPUTE DIF B/ BEGIN COL AND    04130000
         S     TWKREG1,JBEGCL           CONT'N COL TO DETERMINE PRE-SUB 04131000
         LR    RCNT,INPTR               RECORD BEGIN LOCATION           04132000
         SR    RCNT,TWKREG1                                             04133000
PRESUB1  EQU   *                                                        04134000
         ST    RETURN,RTNSV                                             04135000
         SET   SCTLRTN,ON                                               04136000
         B     WRAPF1                   OUTPUT PRE-SUB RECORD           04137000
RECLN    EQU   *                                                        04138000
         LR    TWKREG1,INDEXP                                           04139000
         SR    TWKREG1,INDEXO           CALCULATE AND                   04140000
         STH   TWKREG1,JTRLI            SAVE RECORD LENGTH              04141000
         BR    RETURN                   RETURN TO CALLER                04142000
*                                                                       04143000
SKMNDST  SET   SKPMND,ON                FLUSH MACRO DEFINITION          04144000
         SET   SBDPROTO,ON              BAD PROTO                       04145000
STEND    EQU   *                                                        04146000
         SET   SXPRTO,OFF                                               04147000
         MVI  PARMSTAT,D0                                               04148000
CNTFLSH  L     INPTR,INPUT                                              04149000
         BAL   TLINK,GETDNT             FLUSH A BUFFER FULL OF CONS     04150000
         GOIF  SPRVCT,ON=CNTFLSH        BRANCH IF STILL MORE TO FLUSH   04151000
         LA    R11,D8                   LESE, ...                       04152000
         BAL   RETURN,OPUTL             GET O/P BUFFER FOR              04153000
         MVC   JTRLI(L'PPHD),PPHD       END-OF-PARAM RECORD             04154000
PROTOUT  JRETURN                        RETURN TO CALLER                04155000
*                                                                       04156000
PPHD     DS    0CL8                     PARAM END RECORD                04157000
         DC    AL2(D8)                  RECORD LENGTH                   04158000
         DC    AL1(JPSOP,D0)            FLAGS                           04159000
         DC    AL1(JTPEND,D0)           OP CODE                         04160000
         DC    AL1(D0,D0)               NOT USED                        04161000
         DS    0F                                                       04162000
BLDPMT   EQU   *                                                        04163000
         BAL   R12,MTENTRY1             BUILD MT                        04164000
         LA    INPTR,D1(,INPTR)                                         04165000
         ST    INPTR,FPTRSV             UPDATE POINTER                  04166000
         SET   (DECMA,DEEQL),ON                                         04167000
         BR    RETURN                   RETURN TO CALLER                04168000
         SPACE 3                                                        04169000
         EJECT                                                          04170000
MCALLIN  EQU   *                                                        04171000
         SET   JTCALL                   INDICATE MACRO CALL             04172000
         SET   SMI,ON                                                   04173000
MACPRM   BAL   RETURN,DTADJ             MAKE DATA ADJUSTMENT            04174000
         B     PRESTEND                 END STMT IF RETURN HERE         04175000
         GOIF  SNMFND,OFF=MACPRM0       BRANCH IF NO NAME               04176000
         BAL   RETURN,MPOPND            EDIT THE NAME PARAMETER         04177000
         GOIF  JSUBOPND,ON=MACPRM2      NAME WAS VARIABLE SYMBOL        04178000
         GOIF  NMPURE,ON=BADNAME        BR IF NAME SCAN HAD IMPURITY    04179000
         B     MACPRM2                  GO ON TO DO OPERAND             04180000
MACPRM0  EQU   *                                                        04181000
         LA    R11,SZMI                 PREPARE TO OUTPUT               04182000
         BAL   RETURN,OPUTL             OMITTED OPERAND                 04183000
         MVC   D0(L'OMTNM,INDEXO),OMTNM FOR MACRO CALL NAME             04184000
MACPRM1  BAL   RETURN,MPOPND            EDIT NEXT OPERAND               04185000
MACPRM2  GOIF  SUBLST,ON=MACPRM1        NEXT PARAM IF IN SUBL           04186000
         GOIF  SNMFND,OFF=MACPRM1       OR IN OPERAND FIELD             04187000
         BAL   RETURN,ADJ20             ELSE ONE MORE DATA ADJUSTMENT   04188000
         B     STEND                    END STATEMENT IF RETURN TO HERE 04189000
         B     MACPRM1                  NEXT OPERAND IF RETURN TO HERE  04190000
PRESTEND LA    R11,SZMI                 PREPARE TO OUTPUT               04191000
         BAL   RETURN,OPUTL             OMMITTED OPERAND                04192000
         MVC   D0(L'OMTNM,INDEXO),OMTNM FOR MACRO CALL NAME             04193000
         B     STEND                    NOW FLUSH                       04194000
         SPACE 3                                                        04195000
MPOPND   EQU   *                                                        04196000
         ST    RETURN,MPOPSV            SAVE RETURN LINKAGE             04197000
MIX      LA    R11,SZMI                                                 04198000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  04199000
         BAL   RETURN,HDINIT            INITIALIZE HEADER               04200000
         ST    INPTR,FPTRSV             SAVE INPTR                      04201000
         ST    INDEXP,OFPTRSV           SAVE HEADER DATA POINTER        04202000
         LA    R14,MPHDL(,INDEXP)       GET HDR RECORD LENGTH           04203000
         ST    R14,MTXTP                SAVE META TEXT POINTER          04204000
         SR    R14,INDEXO               COMPUTE OPERAND POINTER         04205000
         STH   R14,JTOPP                AND SAVE                        04206000
         SET   POSSUBL,OFF              INIT SUBLIST 1ST SCAN SWITCH    04207000
         SET   JTCPPOS                  ASSUME POSITIONAL CALL          04208000
         SET   JPSOP,ON                                                 04209000
*                                                                       04210000
         BAL   RETURN,NEXTPARM          EDIT ONE PARAMETER              04211000
MIX5     EQU   *                                                        04212000
         CLI   MSERR,D0                 TEST FOR ERRORS                 04213000
         BE    MIX7                     KEEP GOING IF NONE              04214000
         GOIF  MXRPRN,ON=UNBAL1         BR IF PAREN NOT PAIRED @AX12896 04215000
         CLI   JTIOP,JTCPKEY            KEYWORD CALL PARM?     @AY14037 04216000
         MVC   D0(L'OMTNM,INDEXO),OMTNM OMITTED PARM RECORD             04217000
         BNE   MIX6                     NOT KW DONT CH OPCODE  @AZ19665 04218000
         MVI   JTIOP,JTCPKEY            THIS WAS A KW OPERAND  @AY14037 04219000
MIX6     GOIF  SUBLST,OFF=MIX8          IN SUBLIST ?           @AZ19665 04220000
         SET   MPSB,ON                  YES MARK IT            @AZ19665 04221000
         B     MIX8                     THE RECORD IS PERFECT AS IS     04222000
MIX7     EQU   *                                                        04223000
         BAL   RETURN,WRAPOPND          ELSE WRAP UP OPERAND            04224000
MIX8     CLI   D0(INPTR),JRPARN         BRANCH IF ....                  04225000
         BNE   MPX10                    BRANCH IF NOT                   04226000
         BAL   R12,DPARCT               END OF SUBLIST                  04227000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    04228000
         BH    MPX10                    GO ON IF HIGH          @AY14037 04229000
         BL    UNBAL                    GO TEST DELIM          @AY14037 04230000
         SET   (MPSB,MPSBL),ON          MARK LAST SUBL REC     @AY14037 04231000
         B     MPX10                    GO ON MAY BEE MORE     @AY14037 04232000
UNBAL1   GOIF  (ALTERN),OFF=UNBAL       BR: NOT ALTERNATE      @OX12896 04233000
         SET   SUBLERR,ON               IND ERR IN SUBL        @OZ06551 04234000
         SET   (ALTERN),OFF             RESET SW               @AX12896 04235000
UNBAL    EQU   *                                               @AX12896 04236000
         BAL   TLINK,ABSERR             LOG ERROR ON UNP PARENS@OZ06551 04237000
         DC    AL1(10*16+SEV24)         GO TO SKMNDST RTN VIA ABSERR    04238000
         DC    AL1(ERR24)               UNBALANCED PAREN                04239000
MPX10    CLI   D0(INPTR),JCOMMA                                         04240000
         BE    MPCMA                    COMMA                           04241000
         CLI   D0(INPTR),JBLANK         OR BLANK                        04242000
         BE    MPBLK                    BLANK MEANS END OF STMT@OX19887 04243000
         LA    R11,SZCMT                ROOM FOR NEXT RECORD   @OX19887 04244000
         BAL   RETURN,OPUTL             PUT OUT PREVIOUS REC   @OX19887 04245000
         BAL   TLINK,ABSERR             LOG THE ERROR AND...   @OX19887 04246000
         DC    AL1(9*16+SEV24)          RETURN TO STEND AFTER..@OX19887 04247000
         DC    AL1(ERR24)               PARENTHESIS ERROR      @OX19887 04248000
MPBLK    EQU   *                                                        04249000
         GOIF  SNMFND,ON=MPOPOUT        EXIT IF EDITING NAME FIELD      04250000
         B     STEND                    ELSE, WRAP UP STATEMENT         04251000
         SPACE 3                                                        04252000
MPCMA    EQU   *                                                        04253000
         SET   (ALTERN,ENDSUBL),OFF     RESET SW               @OZ06551 04254000
         SET   DECMA,ON                 INDICATE END OPND COMMA PASSED  04255000
         LA    INPTR,D1(,INPTR)         BUMP OVER COMMA                 04256000
         GOIF  SNMFND,OFF=MPCMA1        GO ON IF NOT NAME FIELD         04257000
         GOIF  SUBLST,ON=MPOPOUT        OK IF IN SUBLIST                04258000
         BCT   INPTR,BADNAME            OR GO TO LOG ERROR              04259000
MPCMA1   EQU   *                                                        04260000
         L     PARAM1,MINPUT                                            04261000
         BAL   TLINK,SHFTDTA            SHIFT DATA                      04262000
         CLI   D0(INPTR),JBLANK         IS IT AN ALTERNATE FORMAT       04263000
         BNE   MPOPOUT                  BRANCH IF NOT                   04264000
         GOIF  SNOCNT,ON=MPOPOUT        OMITTED  IF NO CONT'N ALLOWED   04265000
         SET   ALTERN,ON                IND ALTENATE FORM      @OZ06551 04266000
         BAL   RETURN,BUMPD             BUMP OVER COMMENTS              04267000
         L     PARAM1,MINPUT                                            04268000
         BAL   TLINK,SHFTDTA            SHIFT DATA                      04269000
         SPACE 3                                                        04270000
MPOPOUT  EQU   *                                                        04271000
         SET   (DSDTX,DECMA,DEEQL,DLPRN),OFF RESET INDICATORS           04272000
         L     RETURN,MPOPSV                                            04273000
         BR    RETURN                   RETURN TO CALLER                04274000
         SPACE 3                                                        04275000
NEXTPARM EQU   *                        EDIT NEXT OPERAND               04276000
         MVI   FLGBYT,PARMFLG           ASSUME POSITIONAL PARAM         04277000
         SET   SKWPRM,OFF          RESET KWD INDICATOR                  04278000
NEXTPM   EQU   *                                                        04279000
         ST    RETURN,NEXPSV            SAVE RETURN LINKAGE             04280000
         ST    INPTR,FSTGL              SAVE BEGIN OF STRING            04281000
NEXTPM1  EQU   *                                                OX01771 04282000
         MVI   HDF,D0                   INIT. FLAG BYTE                 04283000
NEXTT    EQU   *                                                        04284000
         SET   SCNCAT,OFF               RESET INDICATOR                 04285000
         MVI   MSERR,D0                                                 04286000
         GOIF  SUBLST,ON=PTSUBL5        BRANCH IF EDITING SUBLIST       04287000
         CLI   D0(INPTR),JLPARN         TEST IF SUBLIST                 04288000
         BNE   NEXTP                    BRANCH IF NOT                   04289000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    04290000
         GOIF  POSSUBL,ON=PTSUBL        GO EDIT IF GOOD SUBLIST         04291000
         SET   POSSUBL,ON               INIDCATE POSS SUBL CANDIDATE    04292000
         BAL   R12,APARCT               UP PAREN COUNT FOR L-PAREN      04293000
         B     PCSTGIN                  PROC FIRST PASS AS C-STRING     04294000
NEXTP1   EQU   *                                                        04295000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    04296000
NEXTP    L     LINK,ATRTEST             POINT TO TRTEST                 04297000
         BALR  RETURN,LINK              TRT STRING                      04298000
         AR    R3,R3                                                    04299000
         LH    R14,PRMTBL(R3)           PREPARE TO BRANCH TO ITS        04300000
         B     D0(R14,BASE3)            CORRESPONDING ROUTINE           04301000
*                                                                       04302000
NEXRTN   L     RETURN,NEXPSV            RESTORE RETURN POINT            04303000
         BR    RETURN                   RETURN TO CALLER                04304000
         SPACE 3                                                        04305000
PRMTBL   EQU   *                        CATEGORIES                      04306000
         DC    AL2(PDSDT-MIPRTOIN)      0 = DECIMAL                     04307000
         DC    AL2(POSYM-MIPRTOIN)      1 = ALPHAMERIC                  04308000
         DC    AL2(PAMPR-MIPRTOIN)      2 = &                           04309000
         DC    AL2(PTERM-MIPRTOIN)      3 = ,=.) OR BLANK               04310000
         DC    AL2(PLPAR-MIPRTOIN)      4 = (                           04311000
         DC    AL2(PQTMD-MIPRTOIN)      5 = '                           04312000
         DC    AL2(PCSTG-MIPRTOIN)      6 = +-*/                        04313000
         DC    AL2(PLATR-MIPRTOIN)      7 = L' I' S' K' N'              04314000
         DC    AL2(PXBCT-MIPRTOIN)      8 = C' B' X'                    04315000
         DC    AL2(PTATR-MIPRTOIN)      9 = T'                          04316000
         DC    AL2(PDSYM-MIPRTOIN)      10= AND OR NOT                  04317000
         DC    AL2(PDSYM-MIPRTOIN)      11= EQ NE LT LE GT GE           04318000
         DC    AL2(PEDTA-MIPRTOIN)      12= NON ASSEMBLER               04319000
DQTMD    LA    INPTR,D1(,INPTR)                                         04320000
PQTMD    EQU   *                                                        04321000
         GOIF  POSSUBL,OFF=PQTMD3       ENDING ' ?             @OZ01697 04322000
         GOIF  DQUOT,ON=PQTMD7          BEEN HERE BEFORE       @OZ01697 04323000
PQTMD3   EQU   *                                               @OZ01697 04324000
         SET   DQUOT,ON                 ENTER QUOTE MODE                04325000
         SET   OPNDSTR,ON               SET C STG FLAG                  04326000
PQTMD5   LA    INPTR,D1(,INPTR)                                         04327000
PQTMD7   EQU   *                                               @OZ01697 04328000
         C     INPTR,ENDATA             SEE IF PAST END OF DATA OX00225 04329000
         BNL   PEDTA1                   BRANCH IF YES           OX00225 04330000
         CLI   D0(INPTR),JQUOTE         TEST IF ENDING QUOTE            04331000
         BNE   PQTMD15                  BRANCH IF NOT                   04332000
         CLI   D1(INPTR),JQUOTE         POSSIBLY, IF NOT DOUBLE QUOTE   04333000
         LA    INPTR,D1(,INPTR)                                         04334000
         BE    PQTMD5                   TOO BAD, DOUBLE QUOTE           04335000
         BCTR  INPTR,0                  BACK UP                         04336000
PQTMDEX  EQU   *                                                        04337000
         SET   DQUOT,OFF                PAIRED QUOTE                    04338000
PQTMD10  EQU   *                                                        04339000
         LA    INPTR,D1(,INPTR)         UPDATE POINTER                  04340000
         SET   DSDTX,ON                 INDICATE DISALLOW SDT           04341000
         BAL   RETURN,TENDOP            TEST END OF OPERAND             04342000
         B     NEXTP                    CONTINUE EDITING                04343000
         B     PXBCOUT                  WRAP UP OPERAND                 04344000
PQTMD15  EQU   *                                                        04345000
         CLI   D0(INPTR),JAMPER         LOOK FOR NEXT AMPERSAND         04346000
         BNE   PQTMD5                   BRANCH IF NOT                   04347000
         CLI   D1(INPTR),JAMPER         TEST IF DOUBLE AMPERSAND        04348000
         BNE   VSRTENT                  SINGLE AMPERSAND - ASSUME V SYM 04349000
         LA    INPTR,D1(,INPTR)         BUMP POINTER                    04350000
         B     PQTMD5                   EDIT AS C STG                   04351000
VSRTENT  EQU   *                        ASSUME VARIABLE SYMBOL          04352000
         GOIF  POSSUBL,ON=PCSTG         OMIT ON 1ST SUBL SCAN   OX02973 04353000
         ST    INPTR,MEZZOPTR           SAVE ENDING POINTER             04354000
         BAL   R12,MTENTRY              PUT OUT PREVIOUS TEXT           04355000
         BAL   RETURN,VSRTN             EDIT V SYM                      04356000
         BCT   INPTR,PQTMD5             CONTINUE CODE MODE              04357000
*                                                                       04358000
PXBCT    EQU   *                                                        04359000
         GOIF  DSDTX,ON=DQTMD           EDIT AS QT MODE IF DISALLOW SDT 04360000
         L     LINK,AXBCIN              GET LINK ADDRESS                04361000
PESDT    EQU   *                                                        04362000
         SET   DMIENT,ON                                                04363000
         BAL   RETURN,RTNXFR            BRANCH OUT                      04364000
         L     BASE3,AMIPRTO            NEED TWO FOR SAFTY              04365000
         L     BASE3,AMIPRTO            RESTORE BASE3                   04366000
         BCT   R12,INVSDTP              OR GO LOG ERROR                 04367000
PXBCT1   EQU   *                                                        04368000
         SET   OPNDTRM,ON               SDT FLAG                        04369000
         BAL   RETURN,TENDOP            TEST END OPERAND                04370000
         B     PXBCT2                   ON RETURN HERE, KEEP SCANNING   04371000
PXBCOUT  EQU   *                                                        04372000
         BAL   R12,MTENTRY              BUILD M.T.                      04373000
         B     NEXRTN                   RETURN TO POINT OF ORIGIN       04374000
PXBCT2   SET   OPNDSTR,ON                                               04375000
         SET   DSDTX,ON                 DISALLOW SDT                    04376000
         B     NEXTP                    CONTINUE TO SCAN FIELD          04377000
         SPACE 3                                                        04378000
MTENTRY  EQU   *                                                        04379000
         C     INPTR,FPTRSV                                             04380000
         BCR   BEQ,R12                  RETURN IF NOTHING TO PUT OUT    04381000
         SET   SCNCAT,ON                ELSE, MEANING CONCATENATION     04382000
MTENTRY1 EQU   *                                                        04383000
         L     R14,MTXTP                GET BUFFER LOCATION             04384000
         MVI   MPMCFLG,JTMCS            ENTER C STG FLAG                04385000
         L     GSPTR,FPTRSV                                             04386000
         LR    R15,INPTR                COMPUTE STRING LENGTH           04387000
         SR    R15,GSPTR                                                04388000
         STC   R15,MPMCLNG              AND SAVE                        04389000
         BCTR  R15,0                    MAKE IT MOVE LENGTH             04390000
         EX    R15,STGMV                MOVE STG TO BUFFER              04391000
         LA    R14,D3(R15,R14)          UPDATE POINTER AND              04392000
         ST    R14,MTXTP                SAVE                            04393000
         BR    R12                      RETURN TO CALLER                04394000
*                                                                       04395000
STGMV    MVC   MPMCSTG(0),D0(GSPTR)     OFF-THE-LINE MOVE               04396000
         SPACE 3                                                        04397000
TENDOP   EQU   *                                                        04398000
         GOIF  (SUBLST,POSSUBL),NONE=TENDOP0 BYPASS ON NO POSS SUBLIST  04399000
         CLI   D0(INPTR),JEQUAL         TERMINATOR EQUAL SIGN           04400000
         BNE   TENDOP0                  NO, GO CHECK FOR COMMA          04401000
         BR    RETURN                   PROC '=' IN ()'S AS CHAR STRING 04402000
TENDOP0  EQU   *                                                        04403000
         CLI   D0(INPTR),JCOMMA         RETURN TO HERE IF GOOD SDT BUT  04404000
         BE    TENDOP2                  TERMINATOR MUST BE A COMMA      04405000
         CLI   D0(INPTR),JBLANK         OR --                           04406000
         BE    TENDOP1                  A BLANK,                        04407000
         CLI   D0(INPTR),JRPARN         R PAREN IS GOOD TERMINATOR TOO  04408000
         BCR   BNE,RETURN               RETURN IF NOT                   04409000
TENDOP3  EQU   *                                                        04410000
         GOIF  POSSUBL,ON=VALSUBL       CHECK VALID SUBLIST TERMINATOR  04411000
         GOIF  SUBLST,OFF=(RETURN)      RETURN IF NOT EDITING SUBLIST   04412000
         CLI   PRNLVL1,D1               TEST IF END OF SUBOPERAND       04413000
         BCR   BHI,RETURN               NO, PART OF C STG               04414000
         BE    TENDOPZ                  BRANCH IF EQUAL                 04415000
         SET   MXRPRN,ON                ELSE, EXCESS RIGHT PARENS       04416000
TENDOPZ  EQU   *                                                        04417000
         MVC   MPOPSV(L'MPOPSV+L'NEXPSV),SUBSAVE RESTORE RTN LINKAGES   04418000
         SET   MPSBL,ON                 INDICATE LAST SUBOPND           04419000
         SET   SUBLST,OFF                                               04420000
         B     D4(,RETURN)              AND RETURN                      04421000
TENDOP1  CLI   PRNLVL1,D0               TEST IF BLANK AT ZERO LEVEL     04422000
         BE    D4(,RETURN)              YES, A TERMINATOR               04423000
         GOIF  POSSUBL,ON=GOODSUBL      ALTR FORMAT, ASSUME VALID SUBL  04424000
         B     BLKERR                   NO BLANK AT ANY PAREN LEVEL     04425000
TENDOP2  CLI   PRNLVL1,D1               AND COMMA MUST BE QUALIFIED     04426000
         BCR   BHI,RETURN               PART OF C-STG                   04427000
         BL    D4(,RETURN)              A TERMINATOR AT ZERO-PAREN LVL  04428000
         GOIF  SUBLST,OFF=(RETURN)      IN SUBLST IF AT ONE-PRN LVL     04429000
         B     D4(,RETURN)              IT IS                           04430000
         SPACE 3                                                        04431000
VALSUBL  CLI   PRNLVL1,D1               END OF LAST SUBOPERAND          04432000
         BCR   BHI,RETURN               NO, CONTINUE IN C-STRING MODE   04433000
         BE    VALSUBL1                 YES, TEST IF VALID SUBLIST      04434000
         SET   AMPER1,OFF               RESET FOR NEXT CHAR     OX04106 04435000
         B     UNBAL                    OTHERWISE, ERR ON UNBAL PARENS  04436000
VALSUBL1 CLI   D1(INPTR),JCOMMA         R-PAREN FOLL'D BY COMMA         04437000
         BE    GOODSUBL                 YES, PROC AS GOOD SUBL          04438000
         CLI   D1(INPTR),JBLANK         R-PAREN FOLL'D BY BLANK         04439000
         BNE   BADSUBL                  NO, PUT OUT BAD SUBL AS C-STG   04440000
GOODSUBL L     INPTR,FSTGL              BACK UP TO BEGIN POINT OF SUBL  04441000
         GOIF  SKWPRM,OFF=GOODSUB       CONTINUE ON NO KEYWORD          04442000
         L     INPTR,FPTRSV             BACK TO L-PAREN AFTER '=' SIGN  04443000
GOODSUB  SET   OPNDSTR,OFF              NO LONGER C-STRING              04444000
         SET   DSDTX,OFF                PREPARE TO START OVER           04445000
         MVI   PRNLVL1,D0               RESET PAREN COUNT TO ZERO       04446000
         SET   AMPER1,OFF               RESET FOR NEXT CHAR     OX04106 04447000
         B     NEXTT                    NOW, PROCESS GOOD SUBLIST       04448000
BADSUBL  SET   POSSUBL,OFF              RESET SUBLIST SCAN SWITCH       04449000
         GOIF  AMPER1,OFF=BADSUBL1      DO NOT USE AMPER SW     OX04106 04450000
         SET   AMPER,ON                 INDICATE VARSYM         OX01771 04451000
BADSUBL1 SET   AMPER1,OFF               RESET FOR NEXT CHAR     OX04106 04452000
         BR    RETURN                   PUT INVALID SUBL OUT AS C-STG   04453000
         SPACE 3                                                        04454000
PLPAR    EQU   *                                                        04455000
         BAL   R12,APARCT               UP PAREN COUNT                  04456000
         SET   DLPRN,ON                                                 04457000
         B     PCSTG                    PART OF C STG                   04458000
         SPACE 3                                                        04459000
PTERM    EQU   *                                                        04460000
         CLI   D0(INPTR),JCOMMA         TEST IF A COMMA                 04461000
         BE    PTERMC                   YES - TEST IF OMITTED OPERAND   04462000
         CLI   D0(INPTR),JBLANK         TEST IF A BLANK                 04463000
         BE    PTERMB                   YES - TEST IF OMITTED OPERAND   04464000
         CLI   D0(INPTR),JRPARN         TEST IF R PAREN                 04465000
         BNE   PCSTG                    EDIT AS C STG IF NONE ABOVE     04466000
         BAL   RETURN,TENDOP3           TEST IF END OF OPERAND          04467000
         B     PTERMP                   BRANCH IF NOT                   04468000
         B     OMITOP                   LOG OMITTED OPERAND             04469000
PTERMP   BAL   R12,DPARCT               TAKE CARE OF PAREN COUNT        04470000
         GOIF  AMPER,OFF=PCSTG          NO VARSYM               OX01771 04471000
         L     INPTR,FSTGL              POINT TO BEG OF STRING  OX01771 04472000
         B     NEXTPM1                  IT IS PART OF C STG     OX01771 04473000
PTERMC   EQU   *                                                        04474000
         CLI   PRNLVL1,D1               TEST PAREN STATUS               04475000
         BH    PCSTG                    PART OF C STG                   04476000
         BL    OMITOP                   OMITTED OPERAND                 04477000
         GOIF  SUBLST,OFF=PCSTG         PART OF C STG IF NOT IN SUBLIST 04478000
OMITOP   EQU   *                                                        04479000
         SET   OPNDOMT,ON               INDICATE OMITTED PARAM          04480000
         B     NEXRTN                   EXIT                            04481000
*                                                                       04482000
PTERMB   EQU   *                                                        04483000
         CLI   PRNLVL1,D0               BLANK MAY NOT APPEAR IN PAIRED  04484000
         BE    OMITOP                   MUST BE OMITTED OPERAND         04485000
         B     BLKERR                   BLANK DISALLOWED IN ()'S        04486000
         SPACE 3                                                        04487000
PAMPR    EQU   *                                                        04488000
         GOIF  AMPER,OFF=PAMPR05        NO BAD SUBL W VARSYM    OX01771 04489000
         SET   AMPER,OFF                RESET VARSYM FLAG       OX01771 04490000
         SET   POSSUBL,OFF              NO SUBL                 OX01771 04491000
PAMPR05  EQU   *                                                OX01771 04492000
         CLI   D1(INPTR),JAMPER         TEST FOR DOUBLE AMPERS  OX04106 04493000
         BE    PAMPR07                  GO BUMP POINTER         OX04106 04494000
         GOIF  POSSUBL,OFF=PAMPR08      CHAR STG ON 1 SUBL SCAN OX04106 04495000
         SET   AMPER1,ON                IND VARSYM IN POSSUBLST OXO4106 04496000
         B     PCSTG                    TREAT AS CHAR STG       OX04106 04497000
PAMPR07  LA    INPTR,D1(,INPTR)         BUMP POINTER            OX04106 04498000
         B     PCSTG                    TREAT AS CHAR STG       OX04106 04499000
PAMPR08  BAL   R12,MTENTRY              ELSE, PUT OUT C STG     OX04106 04500000
         ST    R1,FPTRSV                UPDATE STRING POINTER           04501000
         BAL   RETURN,VSRTN             EDIT VARIABLE SYMBOL            04502000
         BAL   RETURN,TENDOP            TRY TO WRAP UP OPND             04503000
         B     PAMPR1                   CANCEL PP FLAG                  04504000
         B     NEXRTN                   EXIT IF RETURN TO HERE          04505000
PAMPR1   SET   OPNDPRM,OFF              BAD PASSED PARAMETER            04506000
         B     NEXTP                    EDIT AS C STG                   04507000
*                                                                       04508000
VSRTN    EQU   *                                                        04509000
         ST    RETURN,VSRSV             SAVE REUTRN LINKAGE             04510000
         GOIF  SXPRTO,ON=ILPRTKY        PROTO KWD OPND MAY NOT BE V SYM 04511000
         SET   OPNDSTR,ON               ASSUME NOT PASSED PARAM         04512000
         ST    INDEXP,VSRSV1            SAVE HEADER DATA POINTER        04513000
         L     INDEXP,MTXTP             GET MT POINTER                  04514000
         SET   DMIENT,ON                                                04515000
         OI    JHWORD2+1,DMIENT         SET SECOND DMIENT SW   @AZ13722 04516000
         L     LINK,AVARSYM             GET VARSYM RTN ADDRESS          04517000
         BAL   RETURN,RTNXFR            TRANSFER                        04518000
         L     BASE3,AMIPRTO            RESTORE BASE REG                04519000
         GOIF  RMPURE,OFF=VSRTN3        CONTINUE IF NO ERROR            04520000
         SET   MXVS,ON                  FLAG TO OUTPUT OMITTED PARM     04521000
VSRTN3   EQU   *                                                        04522000
         BAL   R3,PFXRENT               FORCE OUT ALL OPERATORS STILL   04523000
         DC    AL2(JTMSTRM)             IN POSTER STACK                 04524000
         LR    INPTR,R1                 UPDATE POINTER                  04525000
         MVI   GSUMRY,D0                MASK OFF SWITCHES SET BY        04526000
         SET   (METSW,GSUBS),OFF        VARSYM ROUTINE BUT NOT WANTED   04527000
         SET   JSUBOPND,ON              OPERAND NEED SUBSTITUTION       04528000
         BCTR  INDEXP,0                 WIPE OFF END-STMT OPERATOR      04529000
         ST    INDEXP,MTXTP             SAVE MT POINTER                 04530000
         L     INDEXP,VSRSV1            RESET HEADER DATA POINTER       04531000
         L     RETURN,VSRSV             RESET RETURN LINKAGE            04532000
         GOIF  SCNCAT,ON=VSRTN5         BRANCH IF CONCATENATION         04533000
         SET   SCNCAT,ON                                                04534000
         TM    FLGBYT,VSLS                                      OX00217X04535000
               CONSIDER SYSLIST PASSED PARAM                    OX00217 04536000
         BO    VSRTN4                   BRANCH IF SYSLIST       OX00217 04537000
         TM    FLGBYT,PARMFLG           PASSED PARAM MAY NOT BE         04538000
         BNO   VSRTN5                   CONCATENATED. ANYTHING OTHER    04539000
VSRTN4   SET   (OPNDSTR,OPNDPRM),FLIP   GOOD PASSED PARAM               04540000
VSRTN5   EQU   *                                                        04541000
         CLI   D0(INPTR),JPERIOD        TEST IF CONCATENATED            04542000
         BNE   VSRTN20                  BRANCH IF NOT                   04543000
VSRTN10  EQU   *                                                        04544000
         SET   DSDTX,ON                 DISALLOW SDT                    04545000
         LA    INPTR,D1(,INPTR)         WITH C STG FLAG                 04546000
VSRTN20  EQU   *                                                        04547000
         ST    INPTR,FPTRSV             RESET POINTER, PREPARE TO       04548000
         BR    RETURN                   EDIT NEXT TERM                  04549000
*                                                                       04550000
PTATR    EQU   DQTMD                                                    04551000
*                                                                       04552000
PLATR    EQU   *                                                        04553000
         CLI   D0(INPTR),JL             TEST IF L'                      04554000
         LR    INPTR,R1                                                 04555000
         BNE   PQTMD                    BRANCH IF NOT                   04556000
         CLI   D1(INPTR),JA             TEST IF FOLLOWED BY ALPHA       04557000
         BL    PQTMD                    NO - EDIT AS QUOTED STG         04558000
         CLI   D1(INPTR),JAT                                            04559000
         BH    PQTMD                    EDIT AS QUOTED STG              04560000
*                                                                       04561000
         SPACE 3                                                        04562000
DCSTG    LR    INPTR,R1                 UPDATE POINTER                  04563000
PCSTG    EQU   *                                                        04564000
         LA    INPTR,D1(,INPTR)         BUMP OVER TERMINATOR            04565000
PCSTGIN  EQU   *                                                        04566000
         SET   OPNDSTR,ON               SET C STG FLAG                  04567000
         SET   DSDTX,ON                 DISALLOW SDT                    04568000
         BAL   RETURN,TENDOP            TEST IF END OF OPERAND          04569000
         B     NEXTP                    BRANCH IF NOT                   04570000
         B     PXBCOUT                  ELSE, BUILD MT THEN EXIT        04571000
         SPACE 3                                                        04572000
PEDTA    EQU   *                                                        04573000
         CLI   D0(INPTR),JBLANK         IF IT IS A BLANK, IT IS AN      04574000
         BE    PTERMB                   OMITTED OPERAND ENDING THE STMT 04575000
         C     INPTR,ENDATA             ELSE, TEST IF END DATA          04576000
         BL    PCSTG                    NO, IS A PART OF C STG          04577000
PEDTA1   BAL   TLINK,ABSERR             QUOTE MODE AND NO END   OX00225 04578000
         DC    AL1(9*16+SEV35)          QUOTE FOUND FOR AN ATTRIBUTE    04579000
         DC    AL1(ERR35)               END STMT VIA STEND RTN          04580000
*        LOG ERROR - OPERAND EXCEEDS 255 CHAR                           04581000
CSTGLERR BAL   TLINK,WRNERR             GO TO                           04582000
         DC    AL1(SEV42)               LOG WARNING MSG                 04583000
         DC    AL1(ERR42)               EXCEEDS 255 CHARACTERS          04584000
         AH    INPTR,H255               CHOP OFF FIRST 255 CHARACTERS   04585000
         ST    INPTR,FPTRSV             RESET STRING POINTER            04586000
         B     NEXTP                    CONTINUE WITH THIS MUCH         04587000
         SPACE 3                                                        04588000
SYMSDTCK EQU   *                                                        04589000
         GOIF  SCNCAT,ON=D4(,RETURN)    DSDT/SYM MUST STAND ALONE       04590000
         GOIF  DSDTX,OFF=(RETURN)       IF SDT ALLOWED O-SYM ALLOWED    04591000
         GOIF  DLPRN,ON=(RETURN)        DISALLOW SDT COULD STILL ALLOW  04592000
         C     INPTR,FPTRSV             O-SYM PROVIDED IT IS            04593000
         BR    RETURN                   FIRST ACTION                    04594000
         SPACE 3                                                        04595000
PDSDT    EQU   *                                                        04596000
         BAL   RETURN,SYMSDTCK          SYM/SDT MUST BE LEGITIMATE      04597000
         BE    PDSDT1                   YES, IT IS                      04598000
PDSDTX   LR    INPTR,R1                                                 04599000
         B     PCSTGIN                  EDIT AS C STG                   04600000
PDSDT1   CLI   D0(R1),JLPARN            ELIMINATE INVALID TERMINATORS   04601000
         BL    PDSDTX                   ZERO THRU EQUAL SIGN TERMINATE  04602000
         BE    PDSDTC1                  L-PAREN TERMINATES              04603000
         CLI   D0(R1),JRPARN            R-PAREN THRU SLASH              04604000
         BL    PDSDTC1                  PUT OUT SYM REF FOR + - * OR /  04605000
         BE    PDSDTC                   R-PAREN TERMINATES              04606000
         CLI   D0(R1),JBLANK            WHAT ABOUT COMMA OR BLANK       04607000
         BL    PDSDTC                   COMMA, CHECK PAREN LEVEL        04608000
         BE    PDSDTB                   BLANK, DELIMITS DSDT OR SYMBOL  04609000
         B     PDSDTX                   ANY OTHER TERMINATOR, C-STRING  04610000
PDSDTC   EQU   *                                                        04611000
         CLI   PRNLVL1,D1               COMMA IS INSIGNIFICANT IF       04612000
         BH    PQTMD10                  PAREN DON'T BALANCE             04613000
PDSDTC1  EQU   *                                                        04614000
         CH    R3,H2                    TEST IF O-SYM                   04615000
         BE    POSOSYM                  YES, POSITIONAL O-SYM           04616000
         L     LINK,ADSDTIN             GET DSDTIN ADDRESS              04617000
         B     PESDT                    GO EDIT DSDT                    04618000
         SPACE 3                                                        04619000
PDSDTB   EQU   *                        DSDT FOLLOWED BY BLANK          04620000
         CLI   PRNLVL1,D0               BLANK TERMINATOR MUST           04621000
         BE    PDSDTC1                  NOT APPEAR INSIDE PAIRED PAREN  04622000
         B     BLKERR                   ELSE ERROR, BLANK DISALLOWED    04623000
         SPACE 3                                                        04624000
POSOSYM  EQU   *                                                        04625000
         BAL   LINK,SYMSCN1             EDIT O-SYM                      04626000
         B     PCSTG                    BAD O-SYM EDIT AS C STG         04627000
         SET   OPNDORD,ON               ORDINARY SYM FLAG               04628000
         MVC   MPOSRP,D1(R11)           AND POINTER                     04629000
         BAL   RETURN,TENDOP            TRY TO WRAP UP OPERAND          04630000
         B     PCSTGIN                  CONTINUE EDIT IF NOT END OPND   04631000
         B     PXBCOUT                  ELSE, EXIT                      04632000
         SPACE 3                                                        04633000
PDSYM    LA    R3,D2                    DUMMY UP CATEGORY NUMBER        04634000
POSYM    EQU   *                                                        04635000
         CLI   D0(R1),JEQUAL            TEST IF MI KWD PARAM            04636000
         BNE   PDSDT                    EDIT AS DSDT IF NOT             04637000
         GOIF  (SUBLST,POSSUBL),ANY=DCSTG NO KWD PARM ALLOWED IN SUBL   04638000
         GOIF  OPNDSTR,ON=DCSTG         MUST BE O/SYM PRIOR TO '=' SIGN 04639000
         GOIF  SKWPRM,ON=DCSTG          BRANCH IF NOT KWD SIGN          04640000
         SET   VPTYP,ON                 INDICATE KEYWORD                04641000
         SET   JTCPKEY                  INDICATE KWD CALL               04642000
         SET   SKWPRM,ON                                                04643000
         LR    R12,R1                   DO NOT USE REG 1       @AY11215 04644000
         S     R12,FSTGL                COMPUTE KEW LEN        @AY11215 04645000
         LA    R12,D1(R12)              ADD 1 FOR EQUAL SIGN   @AY11215 04646000
         LNR   R12,R12                  MAKE IT NEGATIVE       @AY11215 04647000
         STH   R12,PARML                SAVE TOTAL LEN         @AY11215 04648000
         LR    INPTR,R1                 UPDATE POINTER                  04649000
         BAL   R12,MTENTRY1             BUILD MT                        04650000
         SET   (DECMA,DEEQL),ON                                         04651000
         LA    INPTR,D1(,INPTR)         BUMP OVER EQUAL SIGN            04652000
         ST    INPTR,FPTRSV             UPDATE POINTER                  04653000
         B     NEXTT                    EDIT KWD OPERAND                04654000
         SPACE 3                                                        04655000
PTSUBL   EQU   *                                                        04656000
         SET   POSSUBL,OFF              NOW IN SUBL,RESET SCAN SWITCH   04657000
         GOIF  SUBLST,ON=NEXTP          BEEN HERE BEFORE- PART OF C STG 04658000
         ST    INPTR,FPTRSV             THROW AWAY SUBLIST HEAD         04659000
         BAL   R12,APARCT               UP PAREN COUNT                  04660000
         SET   SUBLST,ON                INDICATE SUBLIST                04661000
         MVC   SUBSAVE(L'MPOPSV+L'NEXPSV),MPOPSV SAVE RETURN LINKAGES   04662000
         MVC   MPOPSV(L'MPOPSV+L'NEXPSV),AMIX5 ALTER RETURN LINKAGES    04663000
         MVC   OCSAVE(D1),JTIOP1        SAVE OP OCDE STATUS             04664000
         GOIF  SMI,OFF=PTSUBL1          BRANCH IF NOT FROM MI           04665000
         GOIF  SKWPRM,OFF=PTSUBL1       BRANCH IF M CALL POS SUBOPND    04666000
         MVC   JTIOP1(D1),OCSAVE        RESET OPCODE FOR SUBOPND        04667000
PTSUBL1  SET   (MPSB,MPSBF),ON          INDICATE FIRST SUBOPND          04668000
         B     NEXTP                    CONTINUE PROCESSING             04669000
PTSUBL5  EQU   *                                                        04670000
         GOIF  SXPRTO,OFF=PTSUBL6       BRANCH IF NOT PROTOTYPE         04671000
         LA    R14,MPHDL(,INDEXP)       GET HDR RECORD LENGTH           04672000
         ST    R14,MTXTP                AND SAVE                        04673000
         SR    R14,INDEXO               RESET OPERAND POINTER           04674000
         STH   R14,JTOPP                                                04675000
         MVI   HDF,D0                   INIT. FLAG BYTE                 04676000
PTSUBL6  EQU   *                                                        04677000
         MVC   JTIOP1(D1),OCSAVE        RESET OP CODE FOR SUBOPERAND    04678000
         SET   MPSB,ON                  INDICATE SUBLIST                04679000
         B     NEXTP                    EDIT SUBOPERAND                 04680000
         SPACE 3                                                        04681000
WRAPOPND EQU   *                                                        04682000
         L     R14,MTXTP                GET BASE                        04683000
         MVI   MPEMT,JTMSTRM            INSERT END STATEMENT FLAG       04684000
         LA    R14,D1(,R14)                                             04685000
         SR    R14,INDEXO               COMPUTE RECORD LENGTH           04686000
         STH   R14,JTRLI                ENTER TEXT LENGTH               04687000
         GOIF  (MPSBF,MPSB,MPSBL),OFF=TST255A B IF NOT SUB PARA@AZ24557 04688000
ADD255   LR    R14,INPTR                DO NOT USE REG 6       @AY11215 04689000
         S     R14,FSTGL                COMPUTE PARM LEN       @AY11215 04690000
         LA    R14,D1(R14)              ADD 1 FOR DELIMITER    @AY11215 04691000
         AH    R14,PARML                ADD TO PREV LEN        @AY11215 04692000
         STH   R14,PARML                SAVE TOTAL RESULT      @AY11215 04693000
         GOIF  MPSBL,OFF=END255         BR IFNOT LAST SUB PARM @AY11215 04694000
TST255   SH    R14,=H'255'              0 = 255 CHAR IN PARAM  @AZ24557 04695000
         BNP   END255A                  BR IF NOT EXEEDS 255 CH@AY11215 04696000
         BAL   TLINK,WRNERR             GEN ERR MSG 42: OPERA- @AY11215 04697000
         DC    AL1(SEV42)               ND EXEEDS 255 CHAR.    @AY11215 04698000
         DC    AL1(ERR42)                                      @AY11215 04699000
END255A  XC    PARML,PARML              CLEAR FOR MORE TESTS   @AY11215 04700000
END255   EQU   *                        END OF TEST            @AY11215 04701000
         BR    RETURN                   RETURN TO CALLER                04702000
TST255A  LR    R14,INPTR                DO NOT USE REG 6       @AZ24557 04703000
         S     R14,FSTGL                COMPUTE PARM LENGTH    @AZ24557 04704000
         AH    R14,PARML                ADD TO PREV LENGTH     @AZ24557 04705000
         B     TST255                   BR AND TEST FOR 255 CH @AZ24557 04706000
         SPACE 3                                                        04707000
         SPACE 3                                                        04708000
RTNXFR   EQU   *                                                        04709000
         L     BASE2,USEBAS             RESET BASE2 VALUE               04710000
         BR    LINK                     MAKE TRANSFER                   04711000
*                                                                       04712000
AVARSYM  DC    A(VARSYM)                VARSYM ADDRESS                  04713000
AXBCIN   DC    A(XBCSDT)                XBCSDT ADDRESS                  04714000
ADSDTIN  DC    A(DSDTIN)                DSDTIN ADDRESS                  04715000
AMIX5    DC    A(MACPRM2,MIX5)          ALTERNATE RETURN LINKAGES       04716000
         EJECT                                                          04717000
BADPARM  L     INPTR,FPTRSV             POINT BACK TO FIELD BEGIN       04718000
BADPARM1 BAL   TLINK,SNAPERRL           GO LOG ERROR- MOVE 8 CHARS      04719000
         DC    AL2(1)                   ABSOLUTE ERROR                  04720000
         DC    AL1(9*16+SEV39)          BAD PARAMETER                   04721000
         DC    AL1(ERR39)               GIVE UP STMT, NO RETURN         04722000
*                                                                       04723000
         SPACE 3                                                        04724000
BLKERR   EQU   *                                                        04725000
         GOIF  SUBLST,OFF=BLKERR1       BR IF NOT IN SUBLIST            04726000
         SET   (MPSB,MPSBL,OPNDOMT),ON  FLAG AS LAST SUBOP/OMITTED PARM 04727000
         BAL   RETURN,WRAPOPND          WRAP UP THIS PARM RECORD        04728000
         LA    R11,D8                   SIZE OF END-OF -PARM            04729000
         BAL   RETURN,OPUTL             FORCE LAST PARM RECORD          04730000
BLKERR1  EQU   *                                                        04731000
         BAL   TLINK,ABSERR             BLANK DELIMITS BUT PARENS UNBAL 04732000
         DC    AL1(9*16+SEV24)          OR BLANK DETECTED WITHIN PARENS 04733000
         DC    AL1(ERR24)               NO RETURN, TO STEND RTN         04734000
BADNAME  MVC   D0(L'OMTNM,INDEXO),OMTNM OMITTED PARM RECORD             04735000
         BAL   TLINK,WRNERR             GO LOG THE ERROR                04736000
         DC    AL1(SEV16)               INVALID CHARACTER DETECTED IN   04737000
         DC    AL1(ERR16)               THE NAME FIELD OF A MACRO INST  04738000
         B     MACPRM2                  CONTINUE WITH OPERAND           04739000
         SPACE 3                                                        04740000
ILPRTKY  EQU   *                                                        04741000
         BAL   TLINK,ABSERR             KW PARAMETER ERROR              04742000
         DC    AL1(9*16+SEV28)          NO RETURN, GO TO STEND RTN      04743000
         DC    AL1(ERR28)               VIA ABSERR                      04744000
INVSDTP  CLI   HICVAL1,J9               NOT A VALID SDT, SO ....        04745000
         BE    PCSTGIN                  C STG IF DSDT                   04746000
         L     INPTR,TPSAVE             ELSE, .....                     04747000
         B     DQTMD                    QUOTE MODE                      04748000
MPTCHA   DS    20C                      TEMPORARY PATCH AREA            04749000
         SPACE 3                                                        04750000
OMTNM    DS    0CL26                    MACRO CALL OMITTED NAME RECORD  04751000
         DC    AL2(L'OMTNM)             LENGTH                          04752000
         DC    AL1(X'80',0)             FLAG                            04753000
         DC    AL1(JTCPPOS,0)           IOC                             04754000
         DC    AL2(18,18,25,18,18)      POINTERS                        04755000
         DC    AL1(0,0,0,0,8)           HEADER DATA FLAG                04756000
         DC    AL1(0,0,0,0)             PADDING                         04757000
OMTMT    DC    AL1(JTMSTRM)             M.T. END STMT FLAG              04758000
         EJECT                                                          04759000
*********************************************************************** 04760000
*  TRANSLATE AND TEST RESULTS                                         * 04761000
*  R1 = TERMINATING CHARACTER ADDRESS                                 * 04762000
*  R3 = CATEGORY NUMBER                                               * 04763000
*       VALUE 0 = DECIMAL (1ST CHARACTER NUMERIC)                     * 04764000
*             1 = ALPH-NUMERIC (1ST CHARACTER ALPHA)                  * 04765000
*             2 = &                                                   * 04766000
*             3 = , = . ) BLANK (OPERAND TERMINATOR)                  * 04767000
*             4 = (                                                   * 04768000
*             5 = '                                                   * 04769000
*             6 = + - * /                                             * 04770000
*             7 = L' S' I' N' K'                                      * 04771000
*             8 = C' X' B'                                            * 04772000
*             9 = T'                                                  * 04773000
*            10 = AND OR NOT                                          * 04774000
*            11 = EQ NE LT LE GT GE                                   * 04775000
*            12 = NON-ASSEMBLER (1ST CHARACTER NON-ASSEMBLER)         * 04776000
*  R10 = TYPE NUMBER                                                  * 04777000
*  R15 = STRING LENGTH (MOVE LENGTH)                                  * 04778000
*********************************************************************** 04779000
*  AT ENTRY R10 HAS INDEX OF 1 OR 2                                   * 04780000
*        1 = DO SYNTACTIC STRING SEARCH                               * 04781000
*        2 = NO SYNTACTIC STRING SEARCH                               * 04782000
*                                                                     * 04783000
*  REGISTERS 1,2,3,10,11,12,14,15 MUST BE MADE AVAILABLE              * 04784000
*                                                                     * 04785000
*        LINKAGE IS ANY OF THE FOLLOWINGS                             * 04786000
*        BAL   RETURN,TRTEST                                          * 04787000
*        BAL   RETURN,TRT01                                           * 04788000
*        BAL   RETURN,TRT02                                           * 04789000
*                                                                     * 04790000
* STRING TO BE TRT'ED IS LIMITED TO 255 CHARACTERS  ******************* 04791000
*********************************************************************** 04792000
TRTEST   LA    PARM,1                   DO SYNTACTIC STRING SEARCH      04793000
TRT01    MVC   SPECHAR(L'STDTBL),STDTBL LOAD STANDARD TRT TABLE         04794000
TRT02    ST    BASE3,JFWORD2            SAVE BASE 3                     04795000
         BALR  BASE3,0                  REDEFINE BASE                   04796000
         USING *,BASE3                      REGISTER                    04797000
         SR    TWKREG2,TWKREG2          IN CASE PAST END                04798000
         L     TWKREG1,ENDATA           COMPUTE STRING LENGTH           04799000
         SR    TWKREG1,INPTR                                            04800000
         BNP   TRTOUT1                  EXIT IF PASSED END COLUMN       04801000
         BCTR  TWKREG1,0                MAKE IT MOVE LENGTH             04802000
         CH    TWKREG1,H255             ALLOW MAXIMUM OF 256 BYTES      04803000
         BNH   TRT10                    LENGTH OK                       04804000
         LH    TWKREG1,H255                                             04805000
         SPACE                                                          04806000
TRT10    ST    R2,JFWORD1               SAVE EDSECT BASE REG            04807000
         SR    R1,R1                    CLEAR REGISTERS FOR TRT RESULT  04808000
         LR    R2,R1                                                    04809000
         EX    TWKREG1,TRT00            TRT STRING INDICATED IN INPTR   04810000
         LR    R3,R2                    TRANSFER RESULT TO R3 SINCE     04811000
         L     R2,JFWORD1               R2 IS EDSECT BASE REGISTER      04812000
         BNE   MATCH                    BRANCH IF AN ENTRY MATCHES      04813000
*  NO HIT - SIMULATE ONE                                                04814000
         L     R1,ENDATA                                                04815000
         CLI   D0(INPTR),JA             SEPARATE AN STRING FROM N STG.  04816000
         BL    MATCH                    BRANCH IF NUMERIC               04817000
         LA    R3,1                     ELSE INDICATE AN STRING         04818000
*                                                                       04819000
MATCH    LR    TWKREG2,R1               COMPUTE STRING TRUE LENGTH      04820000
         SR    TWKREG2,INPTR                                            04821000
         BZ    TRTOUT                   EXIT IF 1ST CHAR TERMINATES     04822000
         BCT   TWKREG2,TRT20            BRANCH IF LENGTH GT ONE         04823000
         CLI   D1(INPTR),JQUOTE         ELSE, TEST IF ATTR. NOTATION    04824000
         BNE   TRTSTG                   BRANCH IF NOT                   04825000
*                                                                       04826000
TRT20    CH    TWKREG2,H2               BRANCH IF LENGTH GT 3           04827000
         BH    TRTSTG                                                   04828000
*  LENGTH LE 3 - COULD BE BOOLEAN, RELATIONAL OPS OR ATTR. NOTATION     04829000
         BCT   PARM,TRTSTG              BRANCH IF NOT TRTEST ENTRY      04830000
*  DO SYNTACTIC STRING SEARCH - PARM CONTAINS BXLE INCREMENT FACTOR     04831000
         LA    PARM,D3(,TWKREG2)                                        04832000
         SR    PARAM2,PARAM2                                            04833000
*  R12 POINTS TO TRTTYPE,TRTREL OR TRTOPTR FOR L OF 1, 2, OR 3          04834000
         IC    PARAM2,TRTNDX1(TWKREG2)                                  04835000
         LA    R12,TRTTYPE(PARAM2)      GET TO THE RIGHT TABLE          04836000
* PARAM2 POINTS TO UPPER LIMIT OF BXLE LOOP                             04837000
         IC    PARAM2,TRTNDX2(TWKREG2)                                  04838000
         AR    PARAM2,R12                                               04839000
         SPACE                                                          04840000
* NOW LOOK FOR A MATCH IN THE TABLE POINTED TO IN R12                   04841000
TRTLKUP  EX    TWKREG2,TRTCPR           COMPARE SYMBOL VS TABLE         04842000
         BE    TRTFND                   BRANCH IF FOUND IN TABLE        04843000
         BXLE  R12,PARM,TRTLKUP         ELSE KEEP LOOKING               04844000
         SPACE                                                          04845000
* STRING IS NOT IN THE TABLE POINTED TO IN R12 - ASSUME AN STRING       04846000
TRTSTG   LA    R3,D1                    INDICATE AN STRING              04847000
         CLI   D0(INPTR),J9                                             04848000
         BH    TRTRTN                   EXIT IF AN STRING               04849000
         BCTR  R3,0                     ELSE, INDICATE NUMERIC STRING   04850000
         B     TRTRTN                   THEN EXIT                       04851000
         SPACE                                                          04852000
* SYMBOL FOUND IN TABLE - PICK UP TYPE NUMBER AND RETURN                04853000
TRTFND   IC    PARM,D2(TWKREG2,R12)     GET TYPE NUMBER AND             04854000
         IC    R3,D1(TWKREG2,R12)       CATEGORY NUMBER FROM TABLE      04855000
         B     TRTRTN                   RETURN TO CALLER                04856000
         SPACE                                                          04857000
TRTOUT   CLI   D0(INPTR),HICHR          TEST 1ST CHARACTER              04858000
         BNH   TRTXIT                   BRANCH IF NOT NON-ASSEMBLER CHR 04859000
TRTOUT1  LA    R3,12                    INDICATE NON-ASSEMBLER          04860000
         LR    R1,INPTR                 INSURANCE, INSURANCE.           04861000
         B     TRTRTN                   RETURN TO CALLER                04862000
         SPACE                                                          04863000
TRTXIT   IC    PARM,D0(,INPTR)          GET TERMINATING CHARACTER       04864000
         IC    PARM,TRTSRC-(SPECHAR-JTBLTRT)(PARM) PICK UP TYPE NUMBER  04865000
TRTRTN   L     BASE3,JFWORD2            RESTORE BASE 3 VALUE            04866000
         BR    RETURN                   NOW RETURN TO CALLER            04867000
TRT00    TRT   D0(1,INPTR),JTBLTRT      OFF-THE-LINE TRT                04868000
TRTCPR   CLC   D0(1,INPTR),D0(R12)      OFF-THE-LINE COMPARE            04869000
*********************************************************************** 04870000
*  SYNTACTIC STRING TABLES                                            * 04871000
*        TRTTYPE USED IF TERMINATOR IS ' AND LENGTH = 1. FORMAT = SCT * 04872000
*        TRTREL USED IF LENG = 2 (ANY TERMINATOR)   FORMAT = SSCT     * 04873000
*        TRTOPTR USED IF LENGTH = 3 (ANY TERMINATOR) FORMAT = SSSCT   * 04874000
*        S = CHARACTER STRING (1, 2, OR 3 BYTES)                      * 04875000
*        C = CATEGORY NUMBER (1 BYTE)                                 * 04876000
*        T = TYPE NUMBER (1 BYTE)                                     * 04877000
*********************************************************************** 04878000
TRTTYPE  EQU   *                        ATTRIBUTE TABLE                 04879000
         DC    AL1(JT)                  T'                              04880000
         DC    AL1(09)                                                  04881000
         DC    AL1(JTMTAT)                                              04882000
         DC    AL1(JX)                  X'                              04883000
         DC    AL1(08)                                                  04884000
         DC    AL1(XSDT)                                                04885000
         DC    AL1(JB)                  B'                              04886000
         DC    AL1(08)                                                  04887000
         DC    AL1(BSDT)                                                04888000
         DC    AL1(JC)                  C'                              04889000
         DC    AL1(08)                                                  04890000
         DC    AL1(CSDT)                                                04891000
         DC    AL1(JL)                  L'                              04892000
         DC    AL1(07)                                                  04893000
         DC    AL1(JTMLAT)                                              04894000
         DC    AL1(JI)                  I'                              04895000
         DC    AL1(07)                                                  04896000
         DC    AL1(JTMIAT)                                              04897000
         DC    AL1(JS)                  S'                              04898000
         DC    AL1(07)                                                  04899000
         DC    AL1(JTMSAT)                                              04900000
         DC    AL1(JN)                  N'                              04901000
         DC    AL1(07)                                                  04902000
         DC    AL1(JTMNAT)                                              04903000
         DC    AL1(JK)                  K'                              04904000
         DC    AL1(07)                                                  04905000
         DC    AL1(JTMKAT)                                              04906000
*                                                                       04907000
TRTREL   EQU   *                        RELATIONAL OPERATOR TABLE 2 BYT 04908000
         DC    AL1(JE,JQ)               EQ                              04909000
         DC    AL1(11)                                                  04910000
         DC    AL1(JTMEQ)                                               04911000
         DC    AL1(JO,JR)               OR                              04912000
         DC    AL1(10)                                                  04913000
         DC    AL1(JTMOR)                                               04914000
         DC    AL1(JN,JE)               NE                              04915000
         DC    AL1(11)                                                  04916000
         DC    AL1(JTMNE)                                               04917000
         DC    AL1(JL,JT)               LT                              04918000
         DC    AL1(11)                                                  04919000
         DC    AL1(JTMLT)               LT                              04920000
         DC    AL1(JG,JT)               GT                              04921000
         DC    AL1(11)                                                  04922000
         DC    AL1(JTMGT)                                               04923000
         DC    AL1(JL,JE)               LE                              04924000
         DC    AL1(11)                                                  04925000
         DC    AL1(JTMLE)                                               04926000
         DC    AL1(JG,JE)               GE                              04927000
         DC    AL1(11)                                                  04928000
         DC    AL1(JTMGE)                                               04929000
*                                                                       04930000
TRTOPTR  EQU   *                        RELATIONAL OPERATOR TABLE 3 BYT 04931000
         DC    AL1(JA,JN,JD)            AND                             04932000
         DC    AL1(10)                                                  04933000
         DC    AL1(JTMAND)                                              04934000
         DC    AL1(JN,JO,JT)            NOT                             04935000
         DC    AL1(10)                                                  04936000
         DC    AL1(JTMNOT)                                              04937000
NSYNTBL  EQU   *                                                        04938000
*                                                                       04939000
TRTNDX1  EQU   *                                                        04940000
         DC    AL1(TRTTYPE-TRTTYPE)     INDEX FOR LENGTH = 1            04941000
         DC    AL1(TRTREL-TRTTYPE)      INDEX FOR LENGTH = 2            04942000
         DC    AL1(TRTOPTR-TRTTYPE)     INDEX FOR LENGTH = 3            04943000
TRTNDX2  EQU   *                                                        04944000
         DC    AL1(TRTREL-TRTTYPE-3)    END INDEX FOR LENGTH = 1        04945000
         DC    AL1(TRTOPTR-TRTREL-4)    END INDEX FOR LENGTH = 2        04946000
         DC    AL1(NSYNTBL-TRTOPTR-5)   END INDEX FOR LENGTH = 3        04947000
TRTNNDX  EQU   *                                                        04948000
         DS    0H                                                       04949000
*                                                                       04950000
         EJECT                                                          04951000
         JPATCH X1A20,DD4                                               04952000
         EJECT                                                          04953000
         JCSECT (X1A30=CS4)                                             04954000
         USING *,BASE4                                                  04955000
         USING JTEXTA,INDEXP                                            04956000
*                                                                       04957000
*********************************************************************** 04958000
* DIRECTORY ENTRY ROUTINE                                             * 04959000
* AT ENTRY R9  CONTAINS D ENTRY INDEX VALUE                             04960000
*          R10 POINTS TO THE SYMBOL TO BE ENTERED/SEARCHED              04961000
*          R11 CONTAINS THE MOVE LENGTH OF THE SYMBOL TO BE ENTERED     04962000
*              OR SEARCHED                                              04963000
* ON RETURN R11 POINTS TO A LOCATION CONTAINING THE VECTOR POINTER,     04964000
*              THE POINTER TO THE LOCATION IN GENERATION TIME DICT,     04965000
*              OR THE FLAGA, OF THE SYMBOL ENTERED.                     04966000
* LINKAGE IS BAL R3,DIRENT                                              04967000
*         OR BAL R3,DIR10                                               04968000
*********************************************************************** 04969000
         SPACE 3                                                        04970000
NDIRENT  GOIF  SUPDNT,OFF=NDIR10        GO IF ENTRY NOT SUPPRESSED      04971000
         SET   SUPDNT,OFF               ELSE SET OFF THE INDICATOR      04972000
         B     DIROUT                   AND RETURN                      04973000
NDIR10   MVI   DERRCD,D0                RESET ERROR CODE TO ZERO        04974000
         STM   R15,R1,EDTSVZ            SAVE LENGTH & TERMINATOR        04975000
         L     LINK,DENTRY              COMPUTE D ENTRY POINT           04976000
         BALR  RETURN,LINK              MAKE D ENTRY                    04977000
         TM    DERRCD,BITFF             TEST IF ANY ERROR               04978000
         BZ    DIR20                    RETURN IF NO                    04979000
         L     R15,EDTSVZ               GET SYMBOL LENGTH               04980000
         CLI   DERRCD,ERR11             TEST IF CALL MISMATCHES DEF     04981000
         BE    DIR30                    YES, BUT LET X3 FLAG IT IN LINE 04982000
         CLI   DERRCD,ERR10             PREV DEFINED PRGMR MACRO        04983000
         BE    DIR18                    LOG ERROR MESSAGE 10            04984000
         CLI   DERRCD,ERR7              TEST IF INCONSISTENT USAGE      04985000
         BNE   DIR15                    LOG ERROR                       04986000
         TM    FLGBYT,VDIM              YES, TEST IF DIMENSIONED        04987000
         BO    DIR15                    LOG ERROR IF YES                04988000
         TM    ATTRSV,ATN               TEST IF PRECEDED BY N'          04989000
         BNO   DIR15                    ERROR IF NOT                    04990000
         MVI   DERRCD,D0                ELSE, NOT ERROR                 04991000
         B     DIR20                    EXIT                            04992000
DIR15    LA    R15,1(,R15)              INCR LENGTH TO INCLUDE '&'      04993000
         GOIF  SGBLCL,OFF=DIR16         BACK UP IF ---                  04994000
         L     INPTR,OPNDPTR            FROM DECLARATION                04995000
         TM    FLGBYT,VDIM              TEST IF DIMENSIONED             04996000
         BNO   DIR18                    BRANCH IF NOT- MOVE LENGTH OK   04997000
         AR    R15,TRTN                 ADJUST MOVE LENGTH              04998000
         SR    R15,INPTR                FOR NO. OF CHARS IN V. S.       04999000
         BCTR  R15,D0                   MAKE INTO MOVE LENGTH           05000000
         B     DIR18                    GO LOG ERROR                    05001000
DIR16    EQU   *                        ELSE, DON'T                     05002000
         BCTR  INPTR,0                  BACK UP TO '&' FOR SNAP         05003000
DIR18    EQU   *                                                        05004000
         BAL   RETURN,DNTERR            LOG ERROR                       05005000
         L     BASE4,CS4ADDR            GET BACK TO THIS CSECT          05006000
         SET   RMPURE,ON               INDICATE IMPURITY                05007000
         L     R1,OUTADR                                                05008000
         OI    D3(R1),JPRONLY           PRINT ONLY                      05009000
DIR20    EQU   *                                                        05010000
         LM    R15,R1,EDTSVZ            RESTORE LENGTH AND TERMINATOR   05011000
         CLI   DERRCD,ERR14                                             05012000
         BE    DIROUT                   RETURN IF ERROR 14              05013000
         CLI   DERRCD,ERR9              TEST IF PREVIOUSLY DEFINED      05014000
         BL    DIROUT                   RETURN IF BELOW ERROR 9         05015000
         BH    DIR31                    BR IF ABOVE ERROR 9             05016000
         GOIF  SMDEF,ON=DIR31           BR- DICTIONARY OVERLAP IN MACRO 05017000
         SET   SKPEND,ON                FLUSH WHOLE SOURCE STREAM       05018000
DIROUT   L     BASE2,REGSAVE3           RESTORE OLD BASE                05019000
         BR    R3                       AND RETURN                      05020000
DIR30    EQU   *                                                        05021000
         L     R15,EDTSVZ               GET THE LENGTH                  05022000
DIR31    SET   SKPMND,ON                FLUSH MACRO                     05023000
         SET   SXPRTO,OFF                                               05024000
         L     INDEXP,OFPTRSV           RESTORE JTEXTA POINTER          05025000
         L     INPTR,FPTRSV             RESTORE FIELD POINTER           05026000
         L     BASE2,REGSAVE3           RESTORE OLD BASE                05027000
         B     WRAPFLD                  THROW AWAY THIS STATEMENT       05028000
         SPACE 3                                                        05029000
***************                                                         05030000
         DS    0F                                                       05031000
DENTRY   DC    A(DRUTENT)               DIRECTORY ROUTINE ENTRY POINT   05032000
*                                                                       05033000
SVCTLFM  EQU   *                                                        05034000
         MVC   COPYSV3(L'JSRCLN*7),JSRCLN SAVE CURRENT CTL FORMATS      05035000
         MVC   JSRCLN(L'JSRCLN*7),SRCLEN                                05036000
         MVC   COPYSV4(L'TBGLN*6),TBGLN                                 05037000
         MVC   TBGLN(L'TBGLN*6),STDPARM                                 05038000
         SET   JINLIB,ON                INDICATE IN LIBRARY MODE        05039000
         MVC   INPUT,STNPSTD            GET STD ICTL INPUT WORK BUF PTR 05040000
         MVC   MINPUT,MINPSTD           GET STD ICTL MINPUT WORK BUF PT 05041000
         MVC   MINDIF,SVMINDIF          RESTORE STD BUFF DIFFERENCE     05042000
         MVC   ENDWKA,SVENDWKA          RESTORE STD WORK BUFF END       05043000
         BR    TLINK                    RETURN TO CALLER                05044000
         EJECT                                                          05045000
****************************************                                05046000
*   SNAPERR - LINKAGE TO THIS ROUTINE IS                                05047000
*        DC    AL2(BR CODE)             IF BR CD=1, FINISH WITH ABSERR- 05048000
*        DC    AL1(X*16+SEVERITY CODE)  ELSE FINISH WITH WRNERR         05049000
*        DC    AL1(ERROR CODE)                                          05050000
****************************************                                05051000
         SPACE 3                                                        05052000
NSNAPERR EQU   *                                                        05053000
         LH    R11,D0(,TLINK)           SET UP BRANCH CODE              05054000
         LA    TLINK,D2(,TLINK)         ADJ RETURN POINT                05055000
         USING ERRMESS,R10                                              05056000
         L     R10,ESTKNDX              SET ADDRESSABILITY              05057000
         MVI   EMSGNTRY,JBLANK                                          05058000
         MVC   EMSGNTRY+1(L'EMSGNTRY-1),EMSGNTRY                        05059000
         CH    R15,H7                   DON'T DUMP MORE THAN 8 CHARS    05060000
         BNH   SNAPMOV                  SEVEN OR LESS IS OK             05061000
         LH    R15,H7                   DEFAULT TO 8 CHARS              05062000
SNAPMOV  EX    R15,MVSYM                MOVE DATA ITEM                  05063000
         LA    R14,D8                                                   05064000
         STC   R14,ENTRYLNG                                             05065000
         BCT   R11,NWRNERR              LOG ERROR CODE                  05066000
*                                                                       05067000
*********************************************************************** 05068000
*   ABSERR                                                              05069000
*   WRNERR -                                                            05070000
*   IT IS CALLER'S RESPONSIBILITY TO PLACE THE LENGTH AND ITS           05071000
*   ASSOCIATED DATA ITEM(S) IN THE ERROR MESSAGE STACK AT ESTKNDX       05072000
*   BEFORE ENTER INTO THIS ROUTINE.                                     05073000
*                                                                       05074000
*   CALLING SEQUENCE IS                                                 05075000
*        BAL   TLINK,ABSERR             LOG ERROR                       05076000
*        DC    AL1(X*16 + SEVERITY CODE)                                05077000
*        DC    AL1(ERROR CODE)                                          05078000
*        (RETURN TO HERE IF X=0, ELSE EXIT VIA ERTNTBL AT ENTRY X)      05079000
*********************************************************************** 05080000
         SPACE 3                                                        05081000
NABSERR  EQU   *                                                        05082000
         L     INDEXO,OUTADR            INSURE OUTPUT POINTER           05083000
         GOIF  SXPRTO,OFF=ABSE10        BRANCH IF NOT EXPECTING PROTO   05084000
         SET   SKPMND,ON                                                05085000
         SET   SBDPROTO,ON                                              05086000
         SET   SUBLST,OFF                                               05087000
         SET   SXPRTO,OFF                                               05088000
ABSE10   GOIF  SUBLERR,ON=ABSE11        NO PRONLY BIT IN REC   @OZ06551 05089000
         SET   JPRONLY,ON               PRINT ONLY STATEMENT   @OX12896 05090000
ABSE11   SET   SUBLERR,OFF              RESET SW               @OZ06551 05091000
         SET   SUPDNT,ON                AND SUPPRESS DIRECTORY ENTRY    05092000
NWRNERR  SET   RMPURE,ON                                                05093000
         L     R10,ESTKNDX              SET ADDRESSABILITY              05094000
         USING ERRMESS,R10                                              05095000
         MVC   EMSGSVTY(D2),D0(TLINK)                                   05096000
         NI    EMSGSVTY,X'0F'           MASK OFF RTN CODE               05097000
         CLC   EMSGSVTY(D1),JMSGL       TEST SEV CODE                   05098000
         BL    ERREXIT                  NO ERROR LOGGING SINCE LOW      05099000
         CLI   ERRCNT1,D5               TEST IF MSG STACK FULL          05100000
         BL    BMPNDX                   OK, REGISTER THIS ERROR         05101000
         MVC   EMSGSVTY(L'EROERS),EROERS MSG - MORE THAN 5 ERRORS       05102000
         BH    ERREXIT                  LOOP THRU AFTER 6TH ENTRY       05103000
         B     BMPCNT                   GO GUMP ERROR COUNT             05104000
BMPNDX   LA    R10,ERMEND(,R10)         BUMP INDEX                      05105000
         ST    R10,ESTKNDX              UP ERROR STACK INDEX            05106000
         MVI   ENTRYLNG,D0                                              05107000
BMPCNT   EQU   *                                                        05108000
         IC    R14,ERRCNT1                                              05109000
         LA    R14,D1(,R14)             BUMP ERROR COUNT                05110000
         STC   R14,ERRCNT1                                              05111000
ERREXIT  SR    R15,R15                                                  05112000
         CLC   EMSGSVTY(D1),JSEVER      IS THIS HIGHER                  05113000
         BNH   ERREXIT1                 BRANCH IF NOT                   05114000
         MVC   JSEVER(D1),EMSGSVTY      ENTER HIGH                      05115000
ERREXIT1 IC    R15,D0(,TLINK)           GET RETURN CODE                 05116000
         SRA   R15,D4                   MASK OFF SEVERITY CODE          05117000
         BNZ   ERROUT                   BR IF ERR RETURN SPECIFIED      05118000
         L     BASE2,REGSAVE3           RESTORE BASE ADDR               05119000
         B     D2(,TLINK)               RETURN TO PLACE OF CALL         05120000
ERROUT   SLA   R15,D2                   MULTIPLY BY 4                   05121000
         L     R1,ERTNTBL-D4(R15)       GET RETURN ADDRESS              05122000
         L     BASE2,REGSAVE3           RESTORE BASE ADDR               05123000
         BR    R1                       RETURN                          05124000
MVSYM    MVC   EMSGNTRY(0),D0(INPTR)    OFF-THE-LINE MOVE               05125000
         DS    0F                       ALIGNMENT INSURANCE             05126000
EROERS   DS    0CL3                                                     05127000
         DC    AL1(SEV18)               NO MORE ERROR LOGGING           05128000
         DC    AL1(ERR18)               MAX NUMBER OF 5 ERRORS ALLOWED  05129000
         DC    AL1(0)                   .                               05130000
EEROERS  DS    0H                                                       05131000
         SPACE 3                                                        05132000
ERTNTBL  DS    0CL40                    MAY NOT EXCEED 15 ENTRIES       05133000
         DC    A(BADIX)        1 FLUSH SOURCE                           05134000
         DC    A(AOPPTR)       2 WRAP UP STATEMENT                      05135000
         DC    A(NAMERR)       3 NAME IN ERROR                          05136000
         DC    A(CLN0)         4 CLEAN UP STATEMENT                     05137000
         DC    A(CLEANUP)      5 DITTO                                  05138000
         DC    A(WRAPFLD)      6 END OF OPND 'CAUSE OF ERROR            05139000
         DC    A(EDTSTG)       7 WRAP UP STRING FIELD                   05140000
         DC    A(INVALID)      8 INPUT SEQ ERROR                        05141000
         DC    A(STEND)        9 PARAMETER ERROR                        05142000
         DC    A(SKMNDST)      10 SKIP TO MEND STATEMENT                05143000
EERTNTBL EQU   *                        END OF TABLE                    05144000
         EJECT                                                          05145000
**************************************                                  05146000
*        END OF FILE ROUTINE         *                                  05147000
**************************************                                  05148000
NUNXPEOF EQU   *                                                        05149000
         GOIF  SOPNCD,OFF=NEOFRTN       LOG ERR LATER IF IN PROG MACRO  05150000
         BAL   TLINK,NABSERR            ERROR UNEXPECTED EOF            05151000
         DC    AL1(SEV47)               SEVERITY CODE                   05152000
         DC    AL1(ERR47)               ERROR CODE                      05153000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05154000
         SPACE 3                                                        05155000
NEOFRTN  SET   SINEOF,OFF               RESTORE EOF SWITCH              05156000
         GOIF  JINLIB,ON=EODLIB         BRANCH IF EOD ON SYS LIBRARY    05157000
         SET   SLSTCD,ON                INDICATE LAST CARD READ         05158000
         GOIF  SOPNCD,OFF=PGRMAC        BRANCH IF IN PROGRAMMER MACRO   05159000
         SET   SKPEND,OFF                                               05160000
GENEND   EQU   *                                                        05161000
         GOIF  SENDST,OFF=GENEND1       BRANCH IF NO ENDSTMT    OX00095 05162000
         CLI   ERRCNT1,D0               IS THERE AN ERROR       OX00095 05163000
         BE    EOPNCD                   BRANCH IF NO            OX00095 05164000
         B     GENEND2                  GO WRITE OUT ERR REC    OX00095 05165000
GENEND1  EQU   *                                                OX00095 05166000
         BAL   R3,GENMEND               GO GENERATE RECORD              05167000
         MVI   JTIOP,JTEND              INDICATE END STATEMENT          05168000
         MVC   JTOPCD(L'GEND),GEND      MOVE IN MNEMONIC                05169000
         BAL   TLINK,NWRNERR            LOG ERROR                       05170000
         DC    AL1(SEV60)               AND THEN GO TO                  05171000
         DC    AL1(ERR60)               GENERATE AN END STATEMENT       05172000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05173000
GENEND2  EQU   *                                                OX00095 05174000
         L     BASE2,CS2ADDR            TEMPORILY RESTORE BASE 2        05175000
         BAL   RETURN,WRAPERR           GO WRITE OUT ERROR RECORD       05176000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05177000
         SET   (SFSTCD,SUPDNT),OFF      RESET SWITCHES                  05178000
         SET   (SNMFND,SNOFND,SDTCMT,STRCMT),OFF                        05179000
         SET   (SBYCNT,SBYONE),OFF      RESET SWITCHES                  05180000
         SPACE                                                          05181000
EOPNCD   LA    R11,D8                   LENGTH                          05182000
         BAL   RETURN,OPUTL             GET BUFFER                      05183000
         MVC   JTRLI(L'EOFHD),EOFHD     EOF HEADER                      05184000
         MVI   JTIOP,JTEEOF             IOC                             05185000
         MVI   DDNDX1,OPENEND           SET UP INDEX FOR BR TO DIR RTN  05186000
         BAL   R3,NDIR10                CLOSE OPEN CODE                 05187000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05188000
         SET   SOPNCD,OFF               INDICATE OUT OF OPEN CODE       05189000
         SET   SSYSMD,ON                INDICATE EDITIONG SYSTEM MACRO  05190000
         BAL   TLINK,SVCTLFM            RESTORE STANDARD ICTL FORMATS   05191000
         SET   (SISEQ,SNOCNT),OFF                                       05192000
         B     ESYSMAC                  GO EDIT SYSTEM MACROS           05193000
*                                                                       05194000
EODLIB   EQU   *                                                        05195000
         GOIF  SINCPY,OFF=ELIB05        BRANCH IF NOT IN COPY CODE      05196000
         GOIF  SMAC,ON=ELIB05           GENERATE MEND IF MACRO COPIED   05197000
         L     BASE2,CS2ADDR            RESTORE BASE FOR SECOND CSECT   05198000
         L     LINK,ACSTKEXT            GET ROUTINE ADDR                05199000
         BALR  R3,LINK                 RECURSIVE EXIT                   05200000
         B     WREXIT                   ERROR EXIT                      05201000
ELIB05   EQU   *                                                        05202000
         BAL   TLINK,NWRNERR            GO LOG ERROR ON UNEXPECTED      05203000
         DC    AL1(SEV51)               EOD WHEN READING FROM THE       05204000
         DC    AL1(ERR51)               SYSTEM LIBRARY                  05205000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05206000
         L     BASE2,CS2ADDR            TEMPORILY RESTORE BASE 2        05207000
         BAL   RETURN,WRAPERR1          OUTPUT ERR REC- DON'T SET JERR  05208000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05209000
         BAL   R3,GENMEND               GENERATE RECORD                 05210000
         MVI   JTIOP,JTMEND             INDICATE MEND STMT              05211000
         MVC   JTOPCD(L'GMEND),GMEND    MOVE IN MNEMONIC                05212000
         L     BASE2,CS2ADDR            RESTORE BASE FOR SECOND CSECT   05213000
         B     MEND0                    GO CLOSE MACRO DEFINITION       05214000
*                                                                       05215000
PGRMAC   EQU   *                                                        05216000
         BAL   TLINK,NWRNERR            LOG ERROR                       05217000
         DC    AL1(SEV47)               .                               05218000
         DC    AL1(ERR47)               UNEXPECTED EOD ON SYS INPUT     05219000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05220000
         GOIF  SMDEF,OFF=OPOPEN         BRANCH IF NOT IN MACRO          05221000
         SET   SKPMND,ON                SIMULATE SKIP-TO-MEND CONDITION 05222000
         BAL   R3,GENMEND               GENERATE RECORD                 05223000
         MVI   JTIOP,JTMEND             INDICATE A MEND STATEMENT       05224000
         MVC   JTOPCD(L'GMEND),GMEND    MOVE IN MNEMONIC                05225000
         SET   (SMDEF),OFF              SIMULATE MEND CONDITION         05226000
         MVI   DDNDX1,MACREND           SET UP INDEX FOR BR TO DIR RTN  05227000
         BAL   R3,NDIR10                GO TO DIRECTORY ROUTINE         05228000
         L     BASE2,CS2ADDR            CHANGE TO CSECT 2               05229000
         BAL   RETURN,WRAPERR           GO WRITE OUT ERROR RECORD       05230000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05231000
         BAL   TLINK,NWRNERR            GO LOG ERROR FOR GEN MEND       05232000
         DC    AL1(SEV55)               ERROR PARAMETER                 05233000
         DC    AL1(ERR55)               ERROR PARAMETER                 05234000
         L     BASE2,CS2ADDR            CHANGE TO CSECT 2               05235000
         BAL   RETURN,WRAPERR           GO WRITE OUT ERROR RECORD       05236000
         L     BASE4,CS4ADDR            GET BACK TO CSECT 4             05237000
         SET   SKPMND,OFF                                               05238000
         SPACE                                                          05239000
OPOPEN   SET   (SPGRMD,SOPNCD),FLIP     OUT OF PRGMR MACS, NOW OPEN CD  05240000
         MVI   DDNDX1,OPENENT           SET UP INDEX FOR BR TO DIR RTN  05241000
         BAL   R3,NDIR10                OPEN UP OPEN CODE BEFORE        05242000
         L     BASE4,CS4ADDR                                            05243000
         B     GENEND                   GENERATE END STATEMENT          05244000
         SPACE 3                                                        05245000
ESYSMAC  GOIF  LSTSYSMS,ON=PHSEND       BRANCH IF SYS MACROS ALL EDITED 05246000
         SET   SNOSYSMD,OFF                                             05247000
* REGISTER 10 POINTER IS SUPPLIED BY DIRECTORY ROUTINE                  05248000
         ST    R10,JFWORD1              SAVE POINTER TO NAME            05249000
         JFIND ADDR=(R10)               GO FIND IT IN LIBRARY           05250000
         BP    ESMGO                    BRANCH IF MACRO FOUND           05251000
         SET   SKPMND,ON                ELSE, SIMULATE FLUSH CONDITION  05252000
         SET   SNOSYSMD,ON              SYSTEM M DEF NOT FOUND          05253000
         L     BASE2,CS2ADDR            RESTORE BASE FOR SECOND CSECT   05254000
         B     MEND1                    CLOSE MACRO STMT                05255000
ESMGO    SET   SXMCRO,ON                EXPECTING MACRO STMT            05256000
         SET   SXPRTO,OFF                                      @XA04142 05257000
         L     R9,JFWORD1               RESTORE POINTER TO NAME         05258000
         MVC   LASTFIND(L'LASTFIND),D0(R9) GET NAME OF MEMBER FOUND     05259000
         L     BASE2,CS2ADDR            RESTORE BASE FOR SECOND CSECT   05260000
         B     READNEXT                                                 05261000
SMNAMOV  MVC   SMACNAM(0),D1(R11)       OFF-THE-LINE MOVE               05262000
         SPACE                                                          05263000
PHSEND   MVC   JSRCLN(L'JSRCLN*7),COPYSV3 RESTORE ICTL FORMATS          05264000
         LA    R11,D8                   EOF RECORD SIZE                 05265000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  05266000
         MVC   JTRLI(L'EOFHD),EOFHD     MOVE IN EOF RECORD              05267000
*                                                                       05268000
         JTRUNC FILE=FILE1             TRUNCATE LAST BUFFER             05269000
*                                                                       05270000
         L     PARAM1,DSTGBGN                                           05271000
         JFRECORE ADDR=(R10)            FREE WORK BUFFER                05272000
         LR    PARAM1,MODCOMM                                           05273000
         JFRECORE ADDR=(R10)            FREE MODULE COMMON AREA         05274000
*                                                                       05275000
EDITXIT  JRETURN                        RETURN TO CONTROLLER            05276000
         SPACE 3                                                        05277000
*********************************************                           05278000
*        GENERATE MEND/END STATEMENT        *                           05279000
*********************************************                           05280000
GENMEND  EQU   *                                                        05281000
         LA    R11,L'FXDHD+L'GMEND      GET OUTPUT BUFFER               05282000
         BAL   RETURN,OPUTL             GET O/P BUFFER                  05283000
         MVC   JTRLI(L'FXDHD),FXDHD     MOVE IN HEADER                  05284000
         SET   JPRONLY,OFF              REMOVE PRINT ONLY SWITCH        05285000
         LA    TWKREG1,D2(,INDEXP)      COMPUTE FIELD POINTER           05286000
         SR    TWKREG1,INDEXO                                           05287000
         STH   TWKREG1,JTOCP            AND SAVE IN ET                  05288000
         LA    TWKREG1,D8(,INDEXP)      COMPUTE RECORD LENGTH           05289000
         SR    TWKREG1,INDEXO                                           05290000
         STH   TWKREG1,JTRLI            AND SAVE IN ET                  05291000
         BR    R3                       RETURN                          05292000
         SPACE 3                                                        05293000
GEND     DS    0CL5                     GENERATED END STATEMENT         05294000
         DC    AL1(JA,D3,JE,JN,JD)      GEN EDITED TEXT FOR END STMT    05295000
GMEND    DS    0CL6                     GENERATED MEND STATEMENT        05296000
         DC    AL1(JA,D4,JM,JE,JN,JD)   GEN EDITED TEXT FOR MEND STMT   05297000
EOFHD    DS    0CL8                                                     05298000
         DC    AL2(D8)                  RECORD LENGTH                   05299000
         DC    AL1(JPSOP,D0)            EOF FLAG                        05300000
         DC    AL1(JTEOF)               EOF INDICATOR                   05301000
         DC    AL1(X'EE',X'00',X'FF')   EOF                             05302000
         SPACE 3                                                        05303000
         JPATCH  X1A30,410                                              05304000
         SPACE 3                                                        05305000
         END   EDITENT                                                  05306000
./ ADD NAME=IFNX1K                                                      05307000
         GENOP PHASE=1,                                                X05308000
               LEVEL=1                                                  05309000
         END                                                            05310000
./ ADD NAME=IFNX2A                                                      05311000
         JHEAD 'DICTIONARY INTERLUDE PHASE',                           X05312000
               PHASEID=X2A,                                            X05313000
               LEVEL=10                                                 05314000
*FUNCTION/OPERATION-                                                  * 05315000
*   GENERALLY, THE DICTIONARY INTERLUDE PHASE BUILDS THE GENERATION   * 05316000
*   TIME DICTIONARIES REQUIRED IN THE GENERATE PHASE. SPECIFICALLY,   * 05317000
*   THIS PHASE -                                                      * 05318000
*        (1) BUILDS THE SEQUENCE SYMBOL REFERENCE DICTIONARY FOR      * 05319000
*            EACH MACRO DEFINITION AND FOR OPEN CODE FROM THE         * 05320000
*            SEQUENCE SYMBOL REFERENCES AND SEQUENCE SYMBOL DEFIN-    * 05321000
*            ITIONS IN THE TEXT SEGMENT DICTIONARY FILE FOR THE       * 05322000
*            RESPECTIVE MACRO DEFINITIONS AND OPEN CODE               * 05323000
*        (2) BUILDS THE ORDINARY SYMBOL REFERENCE DICTIONARY FROM     * 05324000
*            THE ORDINARY SYMBOL REFERENCES IN THE TEXT SEGMENT       * 05325000
*            DICTIONARY FILE AND THE ORDINARY SYMBOL DEFINITIONS      * 05326000
*            IN THE ORDINARY SYMBOL DEFINITION FILE                   * 05327000
*        (3) BUILDS THE GLOBAL VECTOR FOR EACH MACRO DEFINITION AND   * 05328000
*            FOR OPEN CODE FROM THE GLOBAL DEFINITIONS IN THE TEXT    * 05329000
*            SEGMENT DICTIONARY FILE FOR THE RESPECTIVE MACRO DEFIN-  * 05330000
*            ITIONS AND OPEN CODE                                     * 05331000
*        (4) BUILDS THE SKELETON DICTIONARY HEADER FOR EACH MACRO     * 05332000
*            DEFINITION AND FOR OPEN CODE FROM THE MACRO DEFINITION   * 05333000
*            DIRECTORY ENTRIES FOR THE RESPECTIVE MACRO DEFINITIONS   * 05334000
*            AND OPEN CODE                                            * 05335000
*        (5) BUILDS THE OPSYN TABLE FOR THE GENERATE PHASE FROM THE   * 05336000
*            OPSYN TABLE FOR THE EDIT PHASE                           * 05337000
*        (6) BUILDS THE MACRO DEFINITION VECTOR FOR THE GENERATE      * 05338000
*            PHASE                                                    * 05339000
*        (7) DETERMINES THE GLOBAL DICTIONARY ALLOCATION FOR THE      * 05340000
*            GENERATE PHASE FROM THE GLOBAL DEFINITIONS IN THE        * 05341000
*            TEXT SEGMENT DICTIONARY FILE                             * 05342000
*                                                                     * 05343000
*ENTRY POINT-                                                         * 05344000
*        INTRENTR                                                     * 05345000
*                                                                     * 05346000
*INPUT-                                                               * 05347000
*   FILE 2 - TEXT SEGMENT DICTIONARY FILE FOR EACH MACRO DEFINITION   * 05348000
*          - TEXT SEGMENT DICTIONARY FILE FOR OPEN CODE               * 05349000
*   FILE 3 - ORDINARY SYMBOL DEFINITION FILE                          * 05350000
*          - MACRO DEFINITION DIRECTORY/OPSYN TABLE                   * 05351000
*                                                                     * 05352000
*OUTPUT-                                                              * 05353000
*   FILE 1 - SKELETON DICTIONARY FOR EACH MACRO DEFINITION            * 05354000
*          - SKELETON DICTIONARY FOR OPEN CODE                        * 05355000
*          - ERROR RECORDS ORIGINATING IN THE INTERLUDE PHASE         * 05356000
*   FILE 2 - ORDINARY SYMBOL REFERENCE DICTIONARY                     * 05357000
*          - MACRO DEFINITION VECTOR                                  * 05358000
*          - OPSYN TABLE                                              * 05359000
*                                                                     * 05360000
*EXTERNAL ROUTINES-                                                   * 05361000
*                                                                     * 05362000
*                                                                     * 05363000
*                                                                     * 05364000
*EXITS,NORMAL-                                                        * 05365000
*   RETURN TO THE DRIVER WITH THE COMPLETION CODE SET TO A ZERO       * 05366000
*   VALUE.                                                            * 05367000
*                                                                     * 05368000
*EXITS,ERROR-                                                         * 05369000
*   RETURN TO THE DRIVER WITH THE COMPLETION CODE SET TO A NON-ZERO   * 05370000
*   VALUE, THE SPECIFIC VALUE INDICATING THE ACTION TO BE TAKEN BY    * 05371000
*   THE DRIVER.                                                       * 05372000
*                                                                     * 05373000
*TABLES/WORK AREAS-                                                   * 05374000
*   MACRO DEFINITION DIRECTORY - A CHAINED TABLE CONTAINING AN        * 05375000
*        ENTRY FOR EACH UNIQUE MACRO NAME ENCOUNTERED IN THE TEXT     * 05376000
*        OF ALL MACRO DEFINITIONS AND OPEN CODE, AND AN ENTRY FOR     * 05377000
*        OPEN CODE (MERGED WITH THE OPSYN TABLE).                     * 05378000
*   OPSYN TABLE - A CHAINED TABLE CONTAINING AN ENTRY FOR EACH        * 05379000
*        UNIQUE MNEMONIC AFFECTED BY AN OPSYN STATEMENT (MERGED       * 05380000
*        WITH THE MACRO DEFINITION DIRECTORY).                        * 05381000
*   SEQUENCE SYMBOL DEFINITION TABLE - A CHAINED TABLE CONTAINING     * 05382000
*        AN ENTRY FOR EACH UNIQUE SEQUENCE SYMBOL DEFINED IN A        * 05383000
*        MACRO DEFINITION OR OPEN CODE.                               * 05384000
*   ORDINARY SYMBOL REFERENCE TABLE - A CHAINED TABLE CONTAINING AN   * 05385000
*        ENTRY FOR EACH REFERENCE TO AN ORDINARY SYMBOL ENCOUNTERED   * 05386000
*        IN AN ATTRIBUTE REFERENCE OR IN A MACRO INSTRUCTION          * 05387000
*        OPERAND (MERGED WITH THE GLOBAL DIRECTORY).                  * 05388000
*   GLOBAL DIRECTORY - A CHAINED TABLE CONTAINING AN ENTRY FOR        * 05389000
*        EACH SYSTEM GLOBAL VARIABLE AND EACH UNIQUE VARIABLE SYMBOL  * 05390000
*        ENCOUNTERED ON A GBLX STATEMENT IN THE TEXT OF ALL MACRO     * 05391000
*        DEFINITIONS AND OPEN CODE (MERGED WITH THE ORDINARY          * 05392000
*        SYMBOL REFERENCE TABLE).                                     * 05393000
*   MACRO DEFINITION VECTOR - A SEQUENTIAL TABLE CONTAINING AN        * 05394000
*        ENTRY FOR EACH UNIQUE MACRO NAME ENCOUNTERED IN THE TEXT     * 05395000
*        OF ALL MACRO DEFINITIONS AND OPEN CODE, AND AN ENTRY FOR     * 05396000
*        OPEN CODE.                                                   * 05397000
*   ORDINARY SYMBOL REFERENCE DICTIONARY - A SEQUENTIAL TABLE         * 05398000
*        CONTAINING AN ENTRY FOR EACH ORDINARY SYMBOL ENCOUNTERED     * 05399000
*        IN AN ATTRIBUTE REFERENCE OR IN THE OPERAND OF A MACRO       * 05400000
*        INSTRUCTION.                                                 * 05401000
*   OPSYN TABLE - A SEQUENTIAL TABLE CONTAINING AN ENTRY FOR EACH     * 05402000
*        UNIQUE MNEMONIC AFFECTED BY AN OPSYN STATEMENT.              * 05403000
*   SKELETON DICTIONARY AREA - THE AREA IN WHICH THE SKELETON DICT-   * 05404000
*        IONARY FOR EACH MACRO DEFINITION AND OPEN CODE IS BUILT.     * 05405000
*        EACH SKELETON DICTIONARY CONSISTS OF A SKELETON DICTION-     * 05406000
*        ARY HEADER, A GLOBAL VECTOR, AND A SEQUENCE SYMBOL REFER-    * 05407000
*        ENCE DICTIONARY. THE SIZE OF THE SKELETON DICTIONARY AREA    * 05408000
*        VARIES ACCORDING TO THE REQUIREMENTS FOR THE SKELETON        * 05409000
*        DICTIONARY FOR EACH TEXT SEGMENT.                            * 05410000
*                                                                     * 05411000
*ATTRIBUTES-                                                          * 05412000
*   REFRESHABLE                                                       * 05413000
*                                                                     * 05414000
*NOTES-                                                               * 05415000
*                                                                     * 05416000
*                                                                     * 05417000
*                                                                     * 05418000
         EJECT                                                          05419000
         COPY  JCOMMON                                                  05420000
         EJECT                                                          05421000
INTRCOM  DSECT                                                          05422000
RECADDR  DS    F                        PTR TO LAST RECORD READ         05423000
COMSTRT  DS    F                        PTR TO PHASE COMMON AREA        05424000
MDDSTRT  DS    F                        PTR TO START OF MACRO DEF DIRCT 05425000
FREESTRT DS    F                        PTR TO LOW END OF WORK AREA     05426000
FREEEND  DS    F                        PTR TO HIGH END OF WORK AREA    05427000
GDSTRT   DS    F                        PTR TO START OF GBL DIRECTORY   05428000
OSRTSTRT EQU   GDSTRT                   PTR TO START OF ORD SYMB REF TB 05429000
GDEND    DS    F                        PTR TO CURRENT END OF GBL DIR   05430000
OSRTEND  EQU   GDEND                    PTR TO CURRENT END OF ORD SYMB  05431000
OSRDSTRT EQU   OSRTEND                  PTR TO START OF ORD SYMB REF DI 05432000
MDVSTRT  DS    F                        PTR TO START OF MACRO DEF VECTR 05433000
MDDND    DS    F                        PTR TO END OF MACRO DEF DIRECT  05434000
SSDTSTRT DS    F                        PTR TO START OF SEQ SYMB DEF TB 05435000
SSDTEND  DS    F                        PTR TO CURRENT END OF SEQ SYMB  05436000
SKDCSTRT DS    F                        PTR TO START OF SKEL DICT       05437000
GDALLOC  DS    F                        CURRENT SIZE OF GLOBAL DICTIONY 05438000
OREFCNT  DS    F                        COUNT OF ORD SYMB ATTR REFERS   05439000
MDVLNTH  DS    F                        LENGTH OF MACRO DEFIN VECTOR    05440000
OPSCHAIN DS    F                        MASTER LINK IN OPSYN CHAIN      05441000
ENDCOL   DS    F                        PTR TO END OF OPERAND           05442000
VECTSAVE EQU   ENDCOL                   TEMP FULLWORD WORK AREA         05443000
ERRBLK   DS    F                        PTR TO ERROR RECORD BUFFER      05444000
ERBLKPTR DS    F                        PTR TO NEXT SLOT IN ERROR BUF   05445000
LNGSK    DS    F                        LENGTH OF SKELETON DICTIONARY   05446000
GBLSK    DS    F                        PTR TO START OF GLOBAL VECTOR   05447000
SEQSK    DS    F                        PTR TO START OF SEQ,SYM REF DIC 05448000
ERRLNKSV DS    F                        SAVE AREA ERROR RTN LINK REG    05449000
HIBYTE0  DS    F                        FULL WORD WORK AREA             05450000
SHIFTAMT EQU   HIBYTE0+D3               ONE BYTE WORK AREA              05451000
*                                                                       05452000
* THIS IS THE ASCAN WORK AREA.                                          05453000
*                                                                       05454000
AWORK    DS    0F                                                       05455000
AFLAGS   DSW   ADCON1,                  ADDRESS CONSTANT (A,Y,V,S)     X05456000
               ADCON2,                  ADDRESS CONSTANT (Q)           X05457000
               CHCON,                   CHARACTER CONSTANT (C)         X05458000
               BXCON,                   HEX. OR BINARY CONSTANT (X,B)  X05459000
               DCCON,                   DECIMAL CONSTANT (P,Z)         X05460000
               FLCON,                   FLOATING-PT CONSTANT (D,E,L)   X05461000
               FXCON                    FIXED-PT CONSTANT (F,H)         05462000
ATYPEAT  DS    XL1                      TYPE ATTRIBUTE                  05463000
ALENGTH  DS    XL2                      LENGTH ATTRIBUTE                05464000
ASCALE   DS    XL2                      SCALE ATTRIBUTE                 05465000
ALENMAX  DS    XL2                      MAXIMUM LENGTH VALUE            05466000
ASCAMAX  DS    XL2                      MAXIMUM SCALE VALUE             05467000
ATYPALT  DS    XL1                      ALTERNATE TYPE ATTRIBUTE        05468000
         ORG   ATYPALT                  ORIGIN FOR ALTERNATIVE BYTE     05469000
ARFACT   DS    XL1                      ROUNDING FACTOR                 05470000
ASFACT   DS    XL1                      SHIFTING FACTOR                 05471000
ACHARLMT DS    XL1                      HIGH CHARACTER LIMIT            05472000
*                                                                       05473000
SWITCHA  DSW   ENDSW,                   END OF EXTRN OPERAND HIT       X05474000
               FNDFLG,                  MATHING TABLE ENTRY FOUND      X05475000
               QUOTESW,                 QUOTE MODE ENTERED             X05476000
               TRANSW,                  TRANSLATE SDT VALUE            X05477000
               ,,,                                                      05478000
SWITCHB  DSW   DSSW,                    DS (NOT DC) STATEMENT          X05479000
               EXLENFLG,                EXPLICIT LENGTH MODIFIER USED  X05480000
               NSCALSW,                 NEGATIVE SCALE MODIFIER USED   X05481000
               SCALEFLG,                SCALING DECIMAL POINT FOUND    X05482000
               SIGNFLG,                 CONSTANT SIGN PROCESSED        X05483000
               DEFLTL,                  DEFAULT LENGTH MODIFIER USED   X05484000
               ,                                                        05485000
DELIMIT  DS    X                        OPERAND DELIMITER SCANNED FOR   05486000
PIOPARMB DS    F                        INITIAL I/O LENGTH              05487000
PIOPARMA DS    F                        I/O AREA ADDRESS                05488000
PIOPARMC DS    H                        I/O AREA LENGTH                 05489000
SAVE3456 DS    5F                       REGISTER SAVE AREA              05490000
FSWITCH  DS    X                        FIRST-WRITE SWITCH              05491000
ERRHDR   DS    CL12                     ERROR RECORD HEADER AREA        05492000
ERRNAME  DS    CL8                      ERROR RECORD FIRST NAME AREA    05493000
ERROTHR  DS    CL16                     ERROR RECORD 2ND, 3RD NAMES     05494000
         DS    4F                       PATCH AREA                      05495000
ENDCOM   DS    0D                                                       05496000
         EJECT                                                          05497000
*                                                                       05498000
* THIS DSECT MAPS THE MACRO DEFINITION DIRECTORY ENTRY.                 05499000
*                                                                       05500000
MDDNTRY  DSECT                                                          05501000
MCHAIN   DS    XL3                      CHAIN PTR         3 BYTES       05502000
MFLAGS   DSW   TSEDIT,                  ON-SEGMENT EDITED              X05503000
               OCTS,                    ON-OPEN CODE ENTRY             X05504000
               FLUSH,,,                 ON-MACRO FLUSHED               X05505000
               MNL1,MNL2,MNL3           MACRO NAME LENGTH               05506000
MSYMBL   DS    XL8                      SYMBOL (PADDED)   8 BYTES       05507000
MVECTR   DS    XL3                      VECTOR POINTER    3 BYTES       05508000
MTXTNP   DS    XL8                      TEXT FILE N/P     8 BYTES       05509000
MTSDNP   DS    XL8                      DICT FILE N/P     8 BYTES       05510000
MGBLSZ   DS    XL3                      GBL VCTR SIZE     3 BYTES       05511000
MSEQSZ   DS    XL3                      SEQ SYM DICT SIZE 3 BYTES       05512000
MLCLSZ   DS    XL3                      LCL DICT SIZE     3 BYTES       05513000
MDDEND   EQU   *                                                        05514000
*                                                                       05515000
* THIS DSECT MAPS THE OPSYN TABLE ENTRY, AS PASSED FROM THE EDIT        05516000
*            PHASE.                                                     05517000
*                                                                       05518000
OPSYNTRY DSECT                                                          05519000
OPSYNCH  DS    XL3                      CHAIN POINTER     3 BYTES       05520000
OPSYNFLG DSW   ,,,,                     SPACE FOR OPCODE FLAGS         X05521000
               OMAC,                    OPSYN MACRO ENTRY              X05522000
               ODEL                     DELETED                         05523000
OPSYNATT DS    XL3                      ATTRIBUTES                      05524000
ONAMEL   DS    XL1                      NAME LENGTH                     05525000
ONAME    DS    XL8                      NAME                            05526000
OPSYND   EQU   *                                                        05527000
*                                                                       05528000
* THIS DSECT MAPS THE OPSYN TABLE ENTRY, AS PASSED TO THE GENERATE      05529000
*            PHASE.                                                     05530000
*                                                                       05531000
OPSTBL   DSECT                                                          05532000
OPSFLGS  DS    XL1                      FLAGS                           05533000
OPSTATTS DS    XL3                      ATTRIBUTES                      05534000
OPSTNL   DS    XL1                      NAME LENGTH                     05535000
OPSTNAM  DS    XL8                      NAME                            05536000
OPSTND   EQU   *                                                        05537000
*                                                                       05538000
* THIS DSECT MAPS THE MACRO DEFINITION VECTOR ENTRY.                    05539000
*                                                                       05540000
MDVNTRY  DSECT                                                          05541000
MNPTXT   DS    XL8                      TEXT FILE N/P     8 BYTES       05542000
MNPSD    DS    XL8                      SKEL DICTION N/P  8 BYTES       05543000
MSDL     DS    XL3                      SKEL DICT LENGTH  3 BYTES       05544000
MDVEND   EQU   *                                                        05545000
*                                                                       05546000
* THIS DSECT MAPS THE HEADER FOR THE SKELETON DICTIONARY.               05547000
*                                                                       05548000
SKDCTHDR DSECT                                                          05549000
SKSRDPT  DS    XL3                      DISPL SEQ SYM DIC 3 BYTES       05550000
SKLDADR  DS    XL3                      LCL DICT PTR      3 BYTES       05551000
SKLDLNG  DS    XL3                      LCL DICT LENGTH   3 BYTES       05552000
SKMPADR  DS    XL3                      MACRO PARAM PTR   3 BYTES       05553000
SKKVADR  DS    XL3                      KEYWD VECTR PTR   3 BYTES       05554000
SKADNLD  DS    XL4                      DICT ADR NXT LVL  4 BYTES       05555000
SKNPNLT  DS    XL8                      TEXT N/P NXT LVL  8 BYTES       05556000
SKACTRV  DS    XL4                      ACTR VALUE        4 BYTES       05557000
SKNOFSLS DS    XL2                      N'&SYSLIST        2 BYTES       05558000
SKHDREND EQU   *                                                        05559000
*                                                                       05560000
* THIS DSECT MAPS THE LOGICAL RECORD READ FROM THE TEXT SEGMENT         05561000
*            DICTIONARY FILE FOR A SEQUENCE SYMBOL DEFINITION.          05562000
*                                                                       05563000
SSDEF    DSECT                                                          05564000
SDEFRL   DS    XL2                      RECORD LENGTH     2 BYTES       05565000
SDEFRT   DS    X'04'                    RECORD TYPE       1 BYTE        05566000
SDEFNP   DS    XL8                      NOTE/POINT ADDR   8 BYTES       05567000
SDEFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        05568000
SDEFSS   EQU   *                        SEQUENCE SYMBOL 2-8 BYTES       05569000
*                                                                       05570000
* THIS DSECT MAPS THE SEQUENCE SYMBOL DEFINITION TABLE ENTRY.           05571000
*                                                                       05572000
SSDTNTRY DSECT                                                          05573000
SSDTCP   DS    XL3                      CHAIN POINTER     3 BYTES       05574000
SSDTNP   DS    XL8                      NOTE/POINT ADDR   8 BYTES       05575000
SSDTSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        05576000
SSDTSY   EQU   *                        SEQUENCE SYMBOL 2-8 BYTES       05577000
*                                                                       05578000
* THIS DSECT MAPS THE LOGICAL RECORD READ FROM THE TEXT SEGMENT         05579000
*            DICTIONARY FILE FOR A SEQUENCE SYMBOL REFERENCE.           05580000
*                                                                       05581000
SSREF    DSECT                                                          05582000
SREFRL   DS    XL2                      RECORD LENGTH     2 BYTES       05583000
SREFRT   DS    X'08'                    RECORD TYPE       1 BYTE        05584000
SREFDP   DS    XL3                      DICTIONARY PTR    3 BYTES       05585000
SREFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        05586000
SREFSS   EQU   *                        SEQUENCE SYMBOL 2-8 BYTES       05587000
*                                                                       05588000
* THIS DSECT MAPS THE LOGICAL RECORD READ FROM THE TEXT SEGMENT         05589000
*            DICTIONARY FILE FOR A GLOBAL DEFINITION.                   05590000
*                                                                       05591000
GBLDEFN  DSECT                                                          05592000
GDEFRL   DS    XL2                      RECORD LENGTH     2 BYTES       05593000
GDEFRT   DS    X'00'                    RECORD TYPE       1 BYTE        05594000
GDEFF    DS    X                        FLAGS             1 BYTE        05595000
GDEFSL   DS    X                        SYMBOL LENGTH     1 BYTE        05596000
GDEFVS   EQU   *                        VARIABLE SYMBOL 2-8 BYTES       05597000
         ORG   GBLDEFN                  ORIGIN ZERO                     05598000
GDEFTF   DS    X                        TEXT FLAG VALUE   1 BYTE        05599000
GDEFVP   DS    XL3                      VECTOR POINTER    3 BYTES       05600000
GDEFD    DS    XL2                      DIMENSION         2 BYTES       05601000
*                                                                       05602000
* THIS DSECT MAPS THE LOGICAL RECORD READ FROM THE TEXT SEGMENT         05603000
*            DICTIONARY FILE FOR AN ORDINARY SYMBOL REFERENCE.          05604000
*                                                                       05605000
OSREF    DSECT                                                          05606000
OREFRL   DS    XL2                      RECORD LENGTH     2 BYTES       05607000
OREFRT   DS    X'0C'                    RECORD TYPE       1 BYTE        05608000
OREFDP   DS    XL3                      DICTIONARY PTR    3 BYTES       05609000
OREFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        05610000
OREFOS   EQU   *                        ORDINARY SYMBOL 1-8 BYTES       05611000
*                                                                       05612000
* THIS DSECT MAPS THE END-OF-SEGMENT RECORD READ FROM THE TEXT          05613000
*            SEGMENT DICTIONARY FILE.                                   05614000
*                                                                       05615000
ENDSEG   DSECT                                                          05616000
ESEGRL   DS    XL2                      RECORD LENGTH     2 BYTES       05617000
ESEGRT   DS    X'10'                    RECORD TYPE       1 BYTE        05618000
*                                                                       05619000
* THIS DSECT MAPS THE END-OF-FILE RECORD READ FROM THE TEXT SEGMENT     05620000
*            DICTIONARY FILE AND THE ORDINARY SYMBOL DEFINITION FILE.   05621000
*                                                                       05622000
ENDFIL   DSECT                                                          05623000
EFILRL   DS    XL2                      RECORD LENGTH     2 BYTES       05624000
EFILRT   DS    X'FF'                    RECORD TYPE       1 BYTE        05625000
*                                                                       05626000
* THIS DSECT MAPS THE ORDINARY SYMBOL REFERENCE DICTIONARY ENTRY.       05627000
*                                                                       05628000
OSRDNTRY DSECT                                                          05629000
TATTRIB  DS    X                        TYPE ATTRIBUTE    1 BYTE        05630000
LATTRIB  DS    XL2                      LENGTH ATTRIBUTE  2 BYTES       05631000
SATTRIB  DS    XL2                      SCALE ATTRIBUTE   2 BYTES       05632000
ATTRIB   DSW   TDEFALT,                 TYPE ATTRIB IS DEFAULT VALUE   X05633000
               LDEFALT,                 LENGTH ATTRIB IS DEFAULT VALUE X05634000
               SDEFALT,                 SCALE ATTRIB IS DEFAULT VALUE  X05635000
               UDEFALT                  UNDEFINED SYMBOL ATTRIB REFED   05636000
*                                                                       05637000
* THIS DSECT MAPS THE GLOBAL DIRECTORY ENTRY.                           05638000
*                                                                       05639000
GDNTRY   DSECT                                                          05640000
GDCP     DS    XL3                      CHAIN POINTER     3 BYTES       05641000
GDFL     DSW   GTYP1,GTYP2,GPTYP,GSNS,GSLS,GDIM,GSTP1,GSTP2             05642000
GDSL     DS    X                        SYMBOL LENGTH     1 BYTE        05643000
GDSYM    EQU   *                        VARIABLE SYMBOL 2-8 BYTES       05644000
         ORG   GDNTRY                   ORIGIN ZERO                     05645000
GDTFV    DS    X                        TEXT FLAG VALUE   1 BYTE        05646000
GDDP     DS    XL3                      G.T. DICT. PTR    3 BYTES       05647000
GDDM     DS    XL2                      DIMENSION         2 BYTES       05648000
*                                                                       05649000
* THIS DSECT MAPS THE ORDINARY SYMBOL REFERENCE TABLE ENTRY.            05650000
*                                                                       05651000
OSRTNTRY DSECT                                                          05652000
OSRTCP   DS    XL3                      CHAIN POINTER     3 BYTES       05653000
OSRTDP   DS    XL3                      DICTIONARY PTR    3 BYTES       05654000
OSRTSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        05655000
OSRTOS   EQU   *                        ORDINARY SYMBOL 1-8 BYTES       05656000
*                                                                       05657000
* THIS DSECT MAPS THE LOGICAL RECORD READ FROM THE ORDINARY SYMBOL      05658000
*            DEFINITION FILE.                                           05659000
*                                                                       05660000
         COPY  JTEXT                                                    05661000
         COPY JERRCD                                                    05662000
         COPY  JERMSGCD                                                 05663000
         EJECT                                                          05664000
SAVMDDPT EQU   JDPASS                   SAVE AREA, MDD ADDRESS          05665000
SAVMDDLN EQU   JDPASS+D8                SAVE AREA, MDD LENGTH           05666000
SAVMDDCN EQU   JDPASS+D12               SAVE AREA, MDD ENTRY CHAIN      05667000
SAVMDDCT EQU   JDPASS+D16               SAVE AREA, MDD ENTRY COUNT      05668000
SAVOPSCN EQU   JDPASS+D20               SAVE AREA, OPSYN ENTRY CHAIN    05669000
LNGTHREG EQU   R12                      SYMBOL LENGTH REGISTER          05670000
WORK2    EQU   R15                      SCRATCH REGISTER                05671000
WORK3    EQU   R10                      SCRATCH REGISTER                05672000
MDDPTR   EQU   R3                       PTR TO MDD ENTRY BEING PROCD    05673000
SKDCTPTR EQU   R4                       PTR TO START OF SKELETON DICT   05674000
BRTBLPTR EQU   R5                       PTR TO BRANCH TABLE IN USE      05675000
SSDTBASE EQU   R6                       PTR TO START OF SEQ SYM DEF TBL 05676000
GDBASE   EQU   R6                       PTR TO START OF GBL DEF DIRECT  05677000
SSDTPTR  EQU   R7                       PTR TO SEQ SYM DEF TBL ENTRY    05678000
RTNLNK   EQU   R9                       RETURN LINKAGE REGISTER         05679000
PTR      EQU   R10                      PTR TO START OF SYMBOL FOR HASH 05680000
RCDPTR   EQU   R11                      PTR REGISTER, INPUT RCD BASE    05681000
WORK1    EQU   R14                      SCRATCH REGISTER                05682000
PAIRE    EQU   R0                       EVEN REGISTER OF PAIR           05683000
PAIRO    EQU   R1                       ODD REGISTER OF PAIR            05684000
EO1      EQU   R0                       EVEN REGISTER OF PAIR           05685000
EO2      EQU   R1                       ODD REGISTER OF PAIR            05686000
HASHSS   EQU   R1                       HASH VALUE FOR SEQ SYMBOL       05687000
HASHGS   EQU   R1                       HASH VALUE FOR GBL VARIABLE     05688000
D36      EQU   36                       LENGTH OF INTERLUDE ERROR RCD   05689000
D44      EQU   44                       DISPLACEMENT                    05690000
D48      EQU   48                       DISPLACEMENT                    05691000
SAVMDVNP EQU   JDPASS                   SAVE AREA, MDV ADDRESS          05692000
SAVMDVLN EQU   JDPASS+D8                SAVE AREA, MDV LENGTH           05693000
SAVGDLNT EQU   JDPASS+D12               SAVE AREA, GLOBAL DICT ALLOC    05694000
SAVOSDNP EQU   JDPASS+D16               SAVE AREA, OSRD ADDRESS         05695000
SAVOSDLN EQU   JDPASS+D24               SAVE AREA, OSRD LENGTH          05696000
SAVOVFPT EQU   JDPASS+D28               SAVE AREA, END OF FILE 1 ADDR   05697000
SAVOPTNP EQU   JDPASS+D36               SAVE AREA, OPSYN TABLE ADDRESS  05698000
SAVOPTLN EQU   JDPASS+D44               SAVE AREA, OPSYN TABLE LENGTH   05699000
SAVERRNP EQU   JDPASS+D48               SAVE AREA, ERROR BLOCK ADDRESS  05700000
GDEL     EQU   19                       MAX LENGTH,GBL DIRECT ENTRY     05701000
OSRTBASE EQU   R6                       PTR TO START OF ORD SYMB REF TB 05702000
HASHOS   EQU   R1                       HASH VALUE FOR ORD SYMBOL       05703000
OSRDPTR  EQU   R4                       PTR TO ORD SYM REF TBL ENTRY    05704000
REFCNT   EQU   R5                       COUNT OR ORD SYM REF TBL ENTRYS 05705000
ENDPTR   EQU   R0                       PTR TO END OF OPERAND           05706000
PARENCT  EQU   R0                       PARENTHESIS LEVEL COUNT         05707000
INPTR    EQU   R7                       PTR TO OPERAND BEING SCANNED    05708000
RX       EQU   R1                       SCRATCH REGISTER                05709000
RY       EQU   R5                       SCRATCH REGISTER                05710000
WORK5    EQU   R12                      SCRATCH REGISTER                05711000
RZ       EQU   R12                      SCRATCH REGISTER                05712000
ATYPE    EQU   JA                       TYPE ATTRIBUTE, A-CON           05713000
BTYPE    EQU   JB                       TYPE ATTRIBUTE, B-CON           05714000
CTYPE    EQU   JC                       TYPE ATTRIBUTE, C-CON           05715000
DTYPE    EQU   JD                       TYPE ATTRIBUTE, D-CON           05716000
WORK4    EQU   R1                       SCRATCH REGISTER                05717000
ETYPE    EQU   JE                       TYPE ATTRIBUTE, E-CON           05718000
FTYPE    EQU   JF                       TYPE ATTRIBUTE, F-CON           05719000
GTYPE    EQU   JG                       TYPE ATTRIBUTE, G-CON           05720000
HTYPE    EQU   JH                       TYPE ATTRIBUTE, H-CON           05721000
KTYPE    EQU   JK                       TYPE ATTRIBUTE, K-CON           05722000
LTYPE    EQU   JL                       TYPE ATTRIBUTE, L-CON           05723000
PTYPE    EQU   JP                       TYPE ATTRIBUTE, P-CON           05724000
QTYPE    EQU   JQ                       TYPE ATTRIBUTE, Q-CON           05725000
RTYPE    EQU   JR                       TYPE ATTRIBUTE, R-CON           05726000
STYPE    EQU   JS                       TYPE ATTRIBUTE, S-CON           05727000
VTYPE    EQU   JV                       TYPE ATTRIBUTE, V-CON           05728000
XTYPE    EQU   JX                       TYPE ATTRIBUTE, X-CON           05729000
YTYPE    EQU   JY                       TYPE ATTRIBUTE, Y-CON           05730000
ZTYPE    EQU   JZ                       TYPE ATTRIBUTE, Z-CON           05731000
OPSTLNT  EQU   OPSTND-OPSTBL            OPSYN ENTRY LENGTH              05732000
MINRECSZ EQU   18                       MINIMUM I/O LENGTH              05733000
VALUE    EQU   R0                       SDT VALUE REGISTER              05734000
TYPE     EQU   R15                      SDT TYPE REGISTER               05735000
COUNT    EQU   R14                      SDT CHARACTER COUNT REGISTER    05736000
D384     EQU   384                      LENGTH OF GBL DIRECT HASH TABLE 05737000
D256     EQU   256                      MOVE LIMIT                      05738000
D192     EQU   192                      LENGTH OF SSDT HASH TABLE       05739000
D255     EQU   255                      MOVE LIMIT LESS ONE             05740000
         EJECT                                                          05741000
         JCSECT (X2A00)                                                 05742000
* VS1 RELEASE 3 CHANGES                                                 05743000
*C886000,890500,912500,927500,935500                            OX00408 05744000
*C593000                                                       @AX14177 05745000
*A599100-599160                                                @AX14177 05746000
*C214500                                                       @AZ26254 05747000
*A779100-779170                                                @AY19671 05748000
         JMODID                                                         05749000
*INTERLUDE INITIALIZATION ROUTINE - THIS ROUTINE PERFORMS ALL THE     * 05750000
*   ONE-TIME INITIALIZATION FUNCTIONS FOR THE PHASE. ITS FUNCTION     * 05751000
*   IS-  (1) TO GET AND ALLOCATE THE SPACE REQUIRED FOR THE VARIOUS   * 05752000
*            COMMON, TABLE, AND WORK AREAS USED BY THE PHASE          * 05753000
*        (2) TO INITIALIZE COMMON FOR THE PHASE                       * 05754000
*        (3) TO FETCH THE MACRO DEFINITION DIRECTORY                  * 05755000
*        (4) TO INITIALIZE THE PERMANENT DICTIONARIES WITHIN THE      * 05756000
*            WORK AREA.                                               * 05757000
*                                                                     * 05758000
INTRENTR JSAVE BASE=YES                                                 05759000
         JENTRY (X2A01=INTRENTR)                                        05760000
         L     R11,=F'1310720'          SET MAX SPACE TO 10M   @AZ26254 05761000
         JGETCORE MINDBL=1625,MAXDBL=(R11) GET FREE SPACE               05762000
         AR    R11,R10                  DEVELOP END-OF-SPACE PTR        05763000
         LA    WORK1,(((ENDCOM-INTRCOM+D7)/D8)*D8) COMPUTE COMMON LEN   05764000
         SR    R11,WORK1                DEVELOP COMMON ADDRESS          05765000
         LR    R2,R11                   SET UP AS COMMON PTR            05766000
         USING INTRCOM,R2                                               05767000
         XC    INTRCOM(ENDCOM-INTRCOM),INTRCOM INITIALIZE ALL COMMON    05768000
         ST    R11,COMSTRT              SAVE IN COMMON ITSELF           05769000
         S     R11,=F'190'              ALLOW FOR ERROR RECORD BUFFER   05770000
         ST    R11,ERRBLK               SAVE PTR TO STRT OF BUFFER      05771000
         XC    D0(L'JNOTEVAL,R11),D0(R11) SET FIRST CHAIN LINK TO 0     05772000
         LA    WORK1,D8(,R11)           DEVELOP PTR WITHIN ERROR BUFF   05773000
         ST    WORK1,ERBLKPTR           AND SAVE FOR ERLOGER            05774000
         ST    R11,MDDND                MAKE IT END-OF-MDD ADDR ALSO    05775000
         ST    R10,FREESTRT             SAVE START-OF-SPACE PTR         05776000
         ST    R10,GDSTRT               MAKE IT GBL DIRECTORY BASE      05777000
         MVI   D0(R10),BITFF-BITFF      INSERT ZERO IN HASH TABLE       05778000
         MVC   D1(D256,R10),D0(R10)     PROPAGATE FIRST 256 BYTES       05779000
         LA    R10,D256(,R10)           BUMP THE POINTER AND            05780000
         MVC   D1(D384-D256,R10),D0(R10) PROPAGATE THRU REST OF TABLE   05781000
         LA    R10,D384-D256(,R10)      BUMP THE POINTER PAST HASH TBL  05782000
         ST    R10,GDEND                SAVE PTR TO GBL ENTRY SPACE     05783000
         MVC   PIOPARMB,SAVMDDLN        PICK UP MDD LENGTH FROM COMMON  05784000
         S     R11,PIOPARMB             DEVELOP MDD ADDRESS             05785000
         ST    R11,MDDSTRT              SAVE MDD PTR IN COMMON          05786000
         ST    R11,PIOPARMA             SET IT UP ALSO FOR MDD READ     05787000
         MVC   JFWORD1,SAVMDDCT         PICK UP MDD ENTRY COUNT         05788000
         L     EO2,JFWORD1              GET IT FOR MDV LENGTH CALC      05789000
         MH    EO2,=Y(MDVEND-MDVNTRY)   MULTIPLY BY MDV ENTRY LENGTH    05790000
         ST    EO2,MDVLNTH              SAVE LENGTH OF MDV FOR WRITE    05791000
         SR    R11,EO2                  DEVELOP MDV ADDRESS             05792000
         ST    R11,MDVSTRT              SAVE MDV PTR IN COMMON          05793000
         BCTR  R11,D0                   GET END-OF-FREE-SPACE PTR       05794000
         ST    R11,FREEEND              AND SAVE IT IN COMMON           05795000
         JPOINT FILE=FILE3,ADDR=SAVMDDPT,NEXT=READ POINT TO MDD         05796000
         LH    R5,JMAXRL3               SET UP MAXIMUM RECORD THIS FILE 05797000
         LA    R6,FILE3                 SET UP FILE POINTER             05798000
         BAL   R7,BUFREAD               GO GET MDD FROM FILE 3          05799000
         JPOINT FILE=FILE3,NEXT=START        REWIND THE FILE            05800000
         MVC   HIBYTE0,SAVMDDCN         PICK UP CHAIN PTR FOR FIRST     05801000
         MVC   OPSCHAIN,SAVOPSCN        PRESERVE OPSYN PTR FOR LATER    05802000
         MVC   ERRHDR+D1(D5),=AL1(D36,JEPSOP,JNOCNT,JEOPCOD)           X05803000
               SET UP STANDARD STUFF IN ERROR HEADER                    05804000
         EJECT                                                          05805000
*DRIVER FOR CONCURRENT RESOLUTION - THIS ROUTINE ATTEMPTS TO BUILD    * 05806000
*   THE SKELETON DICTIONARY FOR A TEXT SEGMENT IN THE MINIMUM         * 05807000
*   NUMBER OF PASSES (2) OVER THE TEXT SEGMENT DICTIONARY FILE        * 05808000
*   FOR THAT TEXT SEGMENT. THIS MEANS THAT, WHILE BUILDING            * 05809000
*   SKELETON DICTIONARIES, THE ENTIRE SKELETON DICTIONARY FOR         * 05810000
*   THE TEXT SEGMENT IS IN CORE, ALL UNIQUE GLOBAL DEFINITIONS        * 05811000
*   FROM ALL TEXT SEGMENTS UP TO THAT POINT ARE IN THE GLOBAL         * 05812000
*   DIRECTORY IN CORE, ALL ORDINARY SYMBOL REFERENCES                 * 05813000
*   FROM ALL TEXT SEGMENTS UP TO THAT POINT ARE IN THE ORDINARY       * 05814000
*   SYMBOL REFERENCE TABLE IN CORE, AND ALL THE SEQUENCE SYMBOL       * 05815000
*   DEFINITIONS FOR THE TEXT SEGMENT ARE IN THE SEQUENCE SYMBOL       * 05816000
*   DEFINITION TABLE IN CORE.                                         * 05817000
*                                                                     * 05818000
INITTSD  L     MDDPTR,MDDND             PICK UP TABLE BASE              05819000
         S     MDDPTR,HIBYTE0           DISPLACE TO NEXT ENTRY IN CHAIN 05820000
         C     MDDPTR,MDDND             SEE IF END OF CHAIN REACHED     05821000
         BE    INITOSR                  BRANCH IF YES                   05822000
         USING MDDNTRY,MDDPTR                                           05823000
         GOIF  FLUSH,ON=ENDSEGBX        BRANCH IF BYPASS FLAG ON        05824000
         GOIF  TSEDIT,OFF=OERR          OVERLAP IN X1A-DUMMY UP MDV REC 05825000
         MVC   HIBYTE0+(L'HIBYTE0-L'MSEQSZ)(L'MSEQSZ),MSEQSZ           X05826000
               PICK UP LENGTH OF SEQUENCE SYMBOL REFERENCE DIRECTORY    05827000
         L     WORK1,HIBYTE0            ACCUM FOR SKEL DICT SIZE        05828000
         MVC   HIBYTE0+(L'HIBYTE0-L'MGBLSZ)(L'MGBLSZ),MGBLSZ           X05829000
               PICK UP LENGTH OF GLOBAL VECTOR                          05830000
         A     WORK1,HIBYTE0            ADD TO SEQ SYMB REF DIR SIZE    05831000
         LA    WORK1,SKHDREND-SKDCTHDR(,WORK1) ADD IN HEADER LENGTH     05832000
         ST    WORK1,LNGSK              PRESERVE SKELETON LENGTH        05833000
         L     WORK2,FREEEND            GET PTR TO HI END OF WORKAREA   05834000
         SR    WORK2,WORK1              ALLOW FOR SKELETON DICT         05835000
         C     WORK2,GDEND              CHECK FOR OVERLAP               05836000
         BL    OERR                     GO FLAG THE CONDITION           05837000
         ST    WORK2,SKDCSTRT           SAVE SKEL DICT START ADDR       05838000
         LR    SKDCTPTR,WORK2           GET PTR TO SKEL DICT HEADER     05839000
         USING SKDCTHDR,SKDCTPTR                                        05840000
         BCTR  WORK2,D0                 BUMP PAST SKEL DICTIONARY       05841000
         ST    WORK2,SSDTSTRT           SET UP PTR TO SEQ SYMB DEF TBL  05842000
         SH    WORK2,=H'192'            ALLOW FOR HASH TABLE            05843000
         CL    WORK2,GDEND              CHECK FOR OVERLAP               05844000
         BL    OERR                     GO FLAG THE CONDITION           05845000
         ST    WORK2,SSDTEND            SAVE AS END OF SSDT PTR         05846000
         MVI   D1(WORK2),BITFF-BITFF    INSERT ZERO FOR PROPAGATION     05847000
         MVC   D2(D192-D1,WORK2),D1(WORK2) CLEAR HSH TBL BY PROPAGATION 05848000
         XC    SKDCTHDR(SKHDREND-SKDCTHDR),SKDCTHDR CLEAR IT FIRST      05849000
         MVC   SKSRDPT(L'MGBLSZ+L'MSEQSZ+L'MLCLSZ),MGBLSZ              X05850000
               FILL IN GBL, SEQ, AND LCL DICT SIZES                     05851000
         LA    WORK2,SKHDREND-SKDCTHDR(,SKDCTPTR) GET PTR TO GBL VECTR  05852000
         ST    WORK2,GBLSK              SAVE IT FOR LATER USE           05853000
         A     WORK2,HIBYTE0            DEVELOP PTR TO SEQ SYMB VECTOR  05854000
         ST    WORK2,SEQSK              SAVE IT FOR LATER USE           05855000
         LA    BRTBLPTR,BRTBLA          SET UP TO USE BRANCH TABLE A    05856000
RESCAN   JPOINT FILE=FILE2,ADDR=MTSDNP,NEXT=GET  POINT TO START OF      05857000
GETNXT   JGETL FILE=FILE2               TXT SEG DICT FILE AND READ      05858000
         ST    R11,RECADDR              PRESERVE RECORD PTR ONCE        05859000
         SR    WORK1,WORK1              CLEAR A REGISTER                05860000
         IC    WORK1,D2(,R11)           GET RECORD TYPE                 05861000
         L     WORK1,D0(WORK1,BRTBLPTR) BRANCH ON IT VIA                05862000
         BR    WORK1                    BRANCH TABLE                    05863000
*                                                                       05864000
*BRANCH TABLE A - USED IN THE FIRST PASS OVER THE TEXT SEGMENT          05865000
*                 DICTIONARY FILE FOR A TEXT SEGMENT                    05866000
*                                                                       05867000
BRTBLA   DC    A(GBLDEF)                RECORD TYPE 00                  05868000
         DC    A(SEQDEF)                RECORD TYPE 04                  05869000
         DC    A(GETNXT)                RECORD TYPE 08                  05870000
         DC    A(ORDREF)                RECORD TYPE 0C                  05871000
         DC    A(ENDSEGA)               RECORD TYPE 10                  05872000
*                                                                       05873000
*BRANCH TABLE B - USED IN THE SECOND PASS OVER THE TEXT SEGMENT         05874000
*                 DICTIONARY FILE FOR A TEXT SEGMENT                    05875000
*                                                                       05876000
BRTBLB   DC    A(GETNXT)                RECORD TYPE 00                  05877000
         DC    A(GETNXT)                RECORD TYPE 04                  05878000
         DC    A(SEQREF)                RECORD TYPE 08                  05879000
         DC    A(GETNXT)                RECORD TYPE 0C                  05880000
         DC    A(ENDSEGB)               RECORD TYPE 10                  05881000
         EJECT                                                          05882000
*GBLDEF - THIS ROUTINE PROCESSES GLOBAL DEFINITIONS DURING THE        * 05883000
*   FIRST PASS OVER THE TEXT SEGMENT DICTIONARY FILE FOR A TEXT       * 05884000
*   SEGMENT. ITS FUNCTION IS TO MAKE AN ENTRY FOR THE GLOBAL          * 05885000
*   VARIABLE IN THE GLOBAL DIRECTORY, IF IT HAS NOT ALREADY BEEN      * 05886000
*   ENTERED, TO INCREASE THE GENERATION TIME GLOBAL DICTIONARY        * 05887000
*   ALLOCATION AS NECESSARY, AND TO BUILD THE GLOBAL VECTOR IN        * 05888000
*   THE SKELETON DICTIONARY FOR EACH TEXT SEGMENT.                    * 05889000
*                                                                     * 05890000
GBLDEF   EQU   *                                                        05891000
         USING GBLDEFN,RCDPTR                                           05892000
         LA    PTR,GDEFSL               GET PTR TO LEN, NAME FOR SUBR   05893000
         BAL   RTNLNK,GSHASHER          GO LOOK FOR GBL VARB IN DIRECT  05894000
         GOIF  FNDFLG,ON=SYNCHEK        BRANCH IF SYNONYM FOUND         05895000
         L     WORK1,GDEND              GET PTR TO NEW ENTRY            05896000
         USING GDNTRY,WORK1                                             05897000
         LA    WORK2,GDEL(,WORK1)       ASSUME LONGEST GBL DIR ENTRY    05898000
         C     WORK2,SSDTEND            CHECK FOR OVERLAP               05899000
         BNL   OERR                     IF OVERLAP, BRANCH              05900000
         MVC   GDFL(L'GDEFF+L'GDEFSL),GDEFF PUT FLAGS AND LENGTH IN     05901000
         MVI   GDSYM,JAMPER             SUPPLY AMPERSAND LITERALLY      05902000
         SR    WORK2,WORK2              CLEAR WORK REGISTER             05903000
         IC    WORK2,GDEFSL             GET LENGTH OF GBL VARB SYMBOL   05904000
         LA    WORK3,L'GDEFTF+L'GDEFVP+L'GDEFD(,WORK2)                 X05905000
                   GET MOVE LENGTH FOR GLOBAL DEFINITION                05906000
         EX    WORK3,GNTRYMV            MOVE GBL DEFN INTO GBL DIRECT   05907000
         LA    WORK3,D7(WORK1,WORK3)    ALLOW FOR ADDED ENTRY IN DIRCT  05908000
         ST    WORK3,GDEND              PUT PTR BACK UPDATED            05909000
         A     HASHGS,GDSTRT            GET PTR TO HASH TBL ENTRY       05910000
         MVC   GDCP,D0(HASHGS)          PUT CHAIN LINK IN NEW ENTRY     05911000
         LR    WORK3,WORK1              SET UP NEW ENTRY ADDR           05912000
         S     WORK3,GDSTRT             GET DISPL FOR HSH TBL ENTRY     05913000
         ST    WORK3,JFWORD1            SAVE TEMPORARILY AND PUT IN     05914000
         MVC   D0(L'GDCP,HASHGS),JFWORD1+(L'JFWORD1-L'GDCP) HASH TABLE  05915000
         LA    WORK1,L'GDCP+L'GDFL+L'GDSL+D2(WORK2,WORK1) BUMP POINTER  05916000
         MVC   GDDP,GDALLOC+(L'GDALLOC-L'GDDP) INSERT GT PTR IN ENTRY   05917000
         SR    PAIRO,PAIRO              INITIALIZE FOR ALLOCATION       05918000
         LA    PAIRO,D1(,PAIRO)         ALLOC 1 BYTE FOR B TYPE         05919000
         TM    GDEFF,GSTP1+GSTP2        CHECK IF B-TYPE VARIABLE        05920000
         BM    DIMENCK                  BRANCH IF B-TYPE                05921000
         LA    PAIRO,D3(,PAIRO)         ALLOC 4 BYTES FOR A TYPE        05922000
         BZ    DIMENCK                  BRANCH IF A-TYPE                05923000
         LA    PAIRO,D5(,PAIRO)         ALLOC 9 BYTES FOR C TYPE        05924000
DIMENCK  TM    GDEFF,GDIM               CHECK IF VARIABLE DIMENSIONED   05925000
         BZ    ALLOC                    BRANCH IF NOT                   05926000
         MVC   JHWORD1,GDDM             PICK UP VARIABLE DIMENSION      05927000
         MH    PAIRO,JHWORD1           MULTIPLY BY SINGLE ELEMENT SIZE  05928000
         TM    GDEFF,GSTP1+GSTP2        CHECK IF B-TYPE VARIABLE        05929000
         BNM   ALLOC                    BRANCH IF NOT                   05930000
         LA    PAIRO,D7(,PAIRO)         ROUND VALUE TO NEXT BYTE        05931000
         SR    PAIRE,PAIRE              CLEAR EVEN REG FOR DIVIDE       05932000
         D     PAIRE,=F'8'              GET NUMBER OF BYTES FO B TYPE   05933000
ALLOC    A     PAIRO,GDALLOC            ADD ALLOCATION FOR NEW ENTRY    05934000
         ST    PAIRO,GDALLOC              TO CURRENT GT GBL DICT ALLOC  05935000
         LR    GDBASE,WORK1             PREPARE FOR BASE CHANGE         05936000
         LA    RCDPTR,L'GDEFRL+L'GDEFRT+L'GDEFF+L'GDEFSL+D1(LNGTHREG,RCX05937000
               DPTR) BUMP PTR TO GBL DEFN RCD PAST VARB SYMB            05938000
         B     ENTRSKEL                 GO TO FILL GBL VCTR SLOT        05939000
GNTRYMV  MVC   GDSYM+D1(D0),GDEFVS      EXECUTED GBL DEFN MOVE          05940000
         DROP  WORK1                                                    05941000
         USING GDNTRY,GDBASE                                            05942000
SYNCHEK  CLC   GDEFF,GDFL               COMPARE THE FLAG BYTES          05943000
         BNE   IERR1                    IF UNALIKE, AN ERROR            05944000
         SR    WORK3,WORK3              CLEAR WORK REGISTER             05945000
         IC    WORK3,GDSL               PICK UP SYMBOL LENGTH           05946000
         LA    GDBASE,L'GDCP+L'GDFL+L'GDSL+D2(WORK3,GDBASE)            X05947000
               BUMP GBL DIR ENTRY PTR PAST VARB SYMBOL                  05948000
         LA    WORK2,GDEFSL             GET PTR TO VARB SYM, IN CASE    05949000
         LA    RCDPTR,L'GDEFRL+L'GDEFRT+L'GDEFF+L'GDEFSL+D1(LNGTHREG,RCX05950000
               DPTR) BUMP PTR TO GBL DEFN RCD PAST VARB SYMB            05951000
         CLC   GDEFD,GDDM               COMPARE DIMENSIONING            05952000
         BNE   IERR2                    IF UNALIKE, AN ERROR            05953000
ENTRSKEL L     SKDCTPTR,GBLSK           GET PTR TO GLOBAL VECTOR        05954000
         MVC   HIBYTE0+(L'HIBYTE0-L'GDEFVP)(L'GDEFVP),GDEFVP           X05955000
               GET DISPL TO GBL VECTR SLOT FROM GBL DEFN RECORD         05956000
         A     SKDCTPTR,HIBYTE0         DEVELOP PTR TO GBL VCTR SLOT    05957000
         MVC   D0(L'GDDP,SKDCTPTR),GDDP INSERT POINTER TO GBL DICT      05958000
         B     GETNXT                   RETURN                          05959000
IERR     EQU   *                                                        05960000
IERR1    EQU   *                                                        05961000
         LA    WORK2,GDEFSL             GET PTR TO VARB SYMB            05962000
         LA    RCDPTR,L'GDEFRL+L'GDEFRT+L'GDEFF+L'GDEFSL+D1(LNGTHREG,RCX05963000
               DPTR) BUMP PTR TO GBL DEFN RCD PAST VARB SYMB            05964000
         MVC   VECTSAVE+D1(L'GDEFVP),GDEFVP                            X05965000
               PRESERVE VECTOR POINTER ACROSS ERROR PROCESS             05966000
         BAL   RTNLNK,ERLOGER           CALL ERROR LOGGING RTN          05967000
         DC    AL1(SEV67,ERR67)         ERROR PARAMETERS                05968000
IERR1A   LA    GDBASE,=X'00FFFFFE'       SET UP DEFAULT FLAGS           05969000
         LA    RCDPTR,VECTSAVE          DUMMY UP PTR TO VECTOR POINTER  05970000
         B     ENTRSKEL                 GO BUILD VECOTR ENTRY W/DEFAULT 05971000
IERR2    EQU   *                                                        05972000
         MVC   VECTSAVE+D1(L'GDEFVP),GDEFVP                            X05973000
               PRESERVE VECTOR POINTER ACROSS ERROR PROCESS             05974000
         BAL   RTNLNK,ERLOGER           CALL ERROR LOGGING RTN          05975000
         DC    AL1(SEV81,ERR81)         ERROR PARAMETERS                05976000
         B     IERR1A                   GO TO DEFAULT PROCESS           05977000
         DROP  GDBASE                                                   05978000
         DROP  RCDPTR                                                   05979000
         EJECT                                                          05980000
*SEQDEF - THIS ROUTINE PROCESSES SEQUENCE SYMBOL DEFINITIONS          * 05981000
*   DURING THE FIRST PASS OVER THE TEXT SEGMENT DICTIONARY FILE       * 05982000
*   FOR A TEXT SEGMENT. ITS FUNCTION IS TO MAKE AN ENTRY FOR THE      * 05983000
*   SEQUENCE SYMBOL DEFINITION IN THE SEQUENCE SYMBOL DEFINITION      * 05984000
*   TABLE.                                                            * 05985000
*                                                                     * 05986000
SEQDEF   EQU   *                                                        05987000
         USING SSDEF,RCDPTR                                             05988000
         LA    PTR,SDEFSL               GET PTR TO LEN, NAME FOR SUBR   05989000
         BAL   RTNLNK,SSHASHER          GO SEE IF SEQ SYMB ALREADY IN   05990000
         GOIF  FNDFLG,ON=DUPERR         IF YES, DUPLICATE DEFINITION    05991000
         L     WORK1,SSDTEND            GET PTR TO SPACE FOR ENTRY      05992000
         LA    WORK2,L'SSDTCP+L'SSDTNP+L'SSDTSL(,LNGTHREG) GET LENGTH   05993000
         SR    WORK1,WORK2              BUMP PTR FOR NRXT ENTRY         05994000
         C     WORK1,GDEND              CHECK FOR TABLE OVERLAP         05995000
         BNH   OERR                     BRANCH IF IT OCCURS             05996000
         ST    WORK1,SSDTEND            UPDATE POINTER                  05997000
         LA    WORK1,D1(,WORK1)         SET UP PTR TO THIS ENTRY        05998000
         USING SSDTNTRY,WORK1                                           05999000
         SR    WORK2,WORK2              CLEAR REGISTER                  06000000
         IC    WORK2,SDEFSL             GET SEQUENCE SYMBOL LENGTH      06001000
         LA    WORK2,L'SDEFNP+D1(,WORK2) GET ENTRY LENGTH - CHAIN PTR   06002000
         EX    WORK2,SSDTMOVE           PUT N/P, LEN, SYMBOL IN ENTRY   06003000
         LR    SSDTPTR,SSDTBASE         PICK UP HASH TABLE PTR          06004000
         SH    SSDTPTR,=H'2'            ADJUST IT                       06005000
         SR    SSDTPTR,HASHSS           GET PTR TO PROPER HSH TBL SLOT  06006000
         MVC   SSDTCP,D0(SSDTPTR)       PUT CHAIN PTR IN ENTRY          06007000
         SR    SSDTBASE,WORK1           GET DISPL TO NEW ENTRY          06008000
         ST    SSDTBASE,JFWORD1         PUT IT IN PROPER HASH TABLE     06009000
         MVC   D0(L'SSDTCP,SSDTPTR),JFWORD1+(L'JFWORD1-L'SSDTCP) SLOT   06010000
         B     GETNXT                   RETURN FOR NEXT RECORD          06011000
DUPERR   EQU   *                                                        06012000
         LA    R0,JPERIOD               INSERT PERIOD FOR SEQ SYNB      06013000
         LA    WORK2,SDEFSL             GET PTR TO SEQ SYMB             06014000
         BAL   RTNLNK,ERLOGERZ          CALL ERROR LOGGING RTN          06015000
         DC    AL1(SEV74,ERR74)         ERROR PARAMETERS                06016000
         B     GETNXT                   RETURN                          06017000
SSDTMOVE MVC   SSDTNP(D0),SDEFNP        EXECUTED SSDT ENTRY MOVE        06018000
         DROP  RCDPTR                                                   06019000
         DROP  WORK1                                                    06020000
         EJECT                                                          06021000
*SEQREF - THIS ROUTINE PROCESSES SEQUENCE SYMBOL REFERENCES           * 06022000
*   DURING THE SECOND PASS OVER THE TEXT SEGMENT DICTIONARY FILE      * 06023000
*   FOR A TEXT SEGMENT. ITS FUNCTION IS TO BUILD THE SEQUENCE         * 06024000
*   SYMBOL REFERENCE DICTIONARY IN THE SKELETON DICTIONARY FOR        * 06025000
*   EACH TEXT SEGMENT USING THE SEQUENCE SYMBOL DEFINITIONS IN        * 06026000
*   THE SEQUENCE SYMBOL DEFINITION TABLE.                             * 06027000
*                                                                     * 06028000
SEQREF   EQU   *                                                        06029000
         USING SSREF,RCDPTR                                             06030000
         LA    PTR,SREFSL               GET PTR TO LEN, NAME FOR SUBR   06031000
         BAL   RTNLNK,SSHASHER          GO SEE IF SEQ SYM ALREADY IN    06032000
         GOIF  FNDFLG,OFF=UNDERR        IF NO, UNDEFINED SEQ SYMB       06033000
SEQREFA  EQU   *                                                        06034000
         USING SSDTNTRY,SSDTPTR                                         06035000
         L     SKDCTPTR,SEQSK           GET PTR TO SEQ SYMB VECTOR      06036000
         MVC   HIBYTE0+(L'HIBYTE0-L'SREFDP)(L'SREFDP),SREFDP           X06037000
               GET DISPL TO SSRD SLOT FROM SEQ SYMB REF RECORD          06038000
         A     SKDCTPTR,HIBYTE0         DEVELOP PTR TO SSRD SLOT        06039000
         MVC   D0(L'SSDTNP,SKDCTPTR),SSDTNP  INSERT N/P ADDR IN SLOT    06040000
         B     GETNXT                   RETURN FOR NEXT RECORD          06041000
UNDERR   EQU   *                                                        06042000
         LA    R0,JPERIOD               INSERT PERIOD FOR SEQ SYMB      06043000
         LA    WORK2,SREFSL             GET PTR TO SEQ SYMB             06044000
         BAL   RTNLNK,ERLOGERZ          CALL ERROR LOGGING RTN          06045000
         DC    AL1(SEV76,ERR76)         ERROR PARAMETERS                06046000
         L     R11,RECADDR              RESTORE RECORD PTR              06047000
         LA    SSDTPTR,=XL11'00'        GIVE DUMMY TO CLEAR SSRD ENTRY  06048000
         B     SEQREFA                  GO BACK TO PROCESS AS NORMAL    06049000
         DROP  SSDTPTR                                                  06050000
         DROP  RCDPTR                                                   06051000
         EJECT                                                          06052000
*ORDREF - THIS ROUTINE PROCESSES ORDINARY SYMBOL REFERENCES           * 06053000
*   DURING THE FIRST PASS OVER THE TEXT SEGMENT DICTIONARY FILE       * 06054000
*   FOR A TEXT SEGMENT. ITS FUNCTION IS TO MAKE AN ENTRY FOR THE      * 06055000
*   ORDINARY SYMBOL REFERENCE IN THE ORDINARY SYMBOL REFERENCE        * 06056000
*   TABLE.                                                            * 06057000
*                                                                     * 06058000
ORDREF   EQU   *                                                        06059000
         USING OSREF,RCDPTR                                             06060000
         LH    WORK1,OREFRL             PICK UP LENGTH OF OS REF        06061000
         BCTR  WORK1,D0                 MAKE IT MOVE LENGTH FOR MOVE    06062000
         L     WORK3,OSRTEND            GET PTR TO NEXT SLOT IN OSRT    06063000
         LA    WORK2,D1(WORK1,WORK3)    DEVELOP PTR PAST POTENTIAL NTRY 06064000
         C     WORK2,SSDTEND            CHECK FOR TABLE OVERLAP         06065000
         BNL   OERR                     BRANCH IF IT OCCURS             06066000
         USING OSRTNTRY,WORK3                                           06067000
         EX    WORK1,OSREFMV            MOVE OS REF RCD INTO OSRT       06068000
         ST    WORK2,OSRTEND            SAVE NEXT SLOT POINTER          06069000
         L     WORK1,OREFCNT            GET CURRENT OS REF COUNT        06070000
         LA    WORK1,D1(,WORK1)         ADD 1                           06071000
         ST    WORK1,OREFCNT            SAVE NEW COUNT                  06072000
         XC    JDWORD,JDWORD            CLEAR WORK AREA FOR ORD SYMB    06073000
         SR    LNGTHREG,LNGTHREG        CLEAR REGISTER FOR ORD SYM LEN  06074000
         IC    LNGTHREG,OREFSL          GET LENGTH OF ORDINARY SYMBOL   06075000
         EX    LNGTHREG,OSMOVE          MOVE SYMBOL INTO WORK AREA      06076000
         LA    WORK1,OSPRIME            GET PTR TO HASH PARAMETERS      06077000
         BAL   WORK2,HASH               LINK TO HASHING RTN             06078000
         A     HASHOS,OSRTSTRT          DEVELOP HASH TABLE POINTER      06079000
         MVC   OSRTCP,D0(HASHOS)        MOVE CHAIN PTR TO NEW ENTRY     06080000
         S     WORK3,OSRTSTRT           DEVELOP CHAIN PTR FOR HSH TBL   06081000
         ST    WORK3,JFWORD1            STOE TEMPORARILY AND            06082000
         MVC   D0(L'OSRTCP,HASHOS),JFWORD1+(L'JFWORD1-L'OSRTCP)        X06083000
               INSERT INTO HASH TABLE SLOT                              06084000
         B     GETNXT                   RETURN                          06085000
OSMOVE   MVC   JDWORD(D0),OREFOS        EXECUTED ORD SYMB MOVE          06086000
OSREFMV  MVC   OSRTCP(D0),OREFRL        EXECUTED OS REF RCD MOVE        06087000
         DROP  RCDPTR                                                   06088000
         DROP  WORK3                                                    06089000
         EJECT                                                          06090000
*ENDSEGA - THIS ROUTINE HANDLES THE END-OF-SEGMENT CONDITION          * 06091000
*   THAT INDICATES THE END OF THE FIRST PASS OVER THE TEXT            * 06092000
*   SEGMENT DICTIONARY FILE FOR A TEXT SEGMENT. ITS FUNCTION          * 06093000
*   IS TO SET UP THE BRANCH TABLE FOR THE SECOND PASS AND TO          * 06094000
*   INITIATE THE SECOND PASS.                                         * 06095000
*                                                                     * 06096000
ENDSEGA  EQU   *                                                        06097000
         LA    BRTBLPTR,BRTBLB          SET UP PTR TO BRANCH TABLE B    06098000
         B     RESCAN                   GO START SECOND PASS            06099000
         EJECT                                                          06100000
*ENDSEGB - THIS ROUTINE HANDLES THE END-OF-SEGMENT CONDITION          * 06101000
*   THAT INDICATES THE END OF THE SECOND PASS OVER THE TEXT           * 06102000
*   SEGMENT DICTIONARY FILE FOR A TEXT SEGMENT. ITS FUNCTION          * 06103000
*   IS TO OUTPUT THE SKELETON DICTIONARY FOR THE TEXT SEGMENT,        * 06104000
*   TO BUILD THE MACRO DEFINITION VECTOR ENTRY FOR THE TEXT           * 06105000
*   SEGMENT, AND TO INITIATE THE FIRST PASS OVER THE TEXT SEGMENT     * 06106000
*   DICTIONARY FILE FOR THE NEXT TEXT SEGMENT.                        * 06107000
*                                                                     * 06108000
ENDSEGB  EQU   *                                                        06109000
         MVC   PIOPARMA,SKDCSTRT        SET UP PTR TO START OF DICT     06110000
         MVC   PIOPARMB,LNGSK           SET UP LNGTH OF DICT           X06111000
               SET UP LENGTH OF SKELETON DICTIONARY FOR WRITE           06112000
         STM   R3,R5,SAVE3456           SAVE REGISTERS USED BY SUBRTN   06113000
         LH    R5,JMAXRL1               SET UP MAXIMUM RECORD THIS FILE 06114000
         LA    R6,FILE1                 SET UP FILE POINTER             06115000
         BAL   R7,BUFRITE               GO PUT SKEL DICT TO FILE 1      06116000
         LM    R3,R5,SAVE3456           RESTORE NECESSARY REGISTERS     06117000
         L     WORK2,MDVSTRT            GET PTR TO START OF MDV         06118000
         MVC   HIBYTE0+(L'HIBYTE0-L'MVECTR)(L'MVECTR),MVECTR           X06119000
               GET DISPL INTO MDV FROM MOD ENTRY                        06120000
         A     WORK2,HIBYTE0            DEVELOP PTR TO MDV SLOT         06121000
         USING MDVNTRY,WORK2                                            06122000
         MVC   MNPSD,JNOTEVAL           INSERT SKEL DICT N/P ADDR       06123000
         MVC   MNPTXT,MTXTNP            INSERT TEXT START N/P ADDR      06124000
         MVC   MSDL,LNGSK+(L'LNGSK-L'MSDL) INSERT SKEL DICT LENGTH      06125000
ENDSEGXT MVC   HIBYTE0+(L'HIBYTE0-L'MCHAIN)(L'MCHAIN),MCHAIN           X06126000
               PICK UP PTR TO NEXT ENTRY IN CHAIN                       06127000
         B     INITTSD                  RETURN TO BUILD NEXT SKEL DICT  06128000
ENDSEGBX EQU   *                                                        06129000
         L     WORK2,MDVSTRT            GET PTR TO START OF MDV         06130000
         MVC   HIBYTE0+(L'HIBYTE0-L'MVECTR)(L'MVECTR),MVECTR           X06131000
               GET DISPL INTO MDV FROM MDD ENTRY                        06132000
         A     WORK2,HIBYTE0            DEVELOP PTR TO MDV SLOT         06133000
         USING MDVNTRY,WORK2                                            06134000
         XC    MNPTXT(MDVEND-MDVNTRY),MNPTXT    SET MDV SLOT ALL ZEROES 06135000
         MVC   MSDL+(L'MSDL-D1)(D1),MTSDNP+(L'MTSDNP-D1) SET ERROR FLAG 06136000
         B     ENDSEGXT                 GO TO RETURN                    06137000
OERR     EQU   *                                                        06138000
         L     WORK2,MDVSTRT            GET PTR TO START OF MDV         06139000
         MVC   HIBYTE0+(L'HIBYTE0-L'MVECTR)(L'MVECTR),MVECTR           X06140000
               GET DISPL INTO MDV FROM MDD ENTRY                        06141000
         A     WORK2,HIBYTE0            DEVELOP PTR TO MDV SLOT         06142000
         USING MDVNTRY,WORK2                                            06143000
         XC    MNPTXT(MDVEND-MDVNTRY),MNPTXT SET MDV ENTRY TO ZEROES    06144000
         MVI   MSDL+D2,D20              INSERT ERROR FLAG               06145000
         B     ENDSEGXT                 GO TO RETURN                    06146000
         DROP  WORK2                                                    06147000
         EJECT                                                          06148000
*                                                                       06149000
* THIS SUBROUTINE SCANS OFF A DECIMAL SELF-DEFINING TERM AND            06150000
*        CONVERTS IT TO BINARY. IT IS CALLED BY THE FOLLOWING           06151000
*        ROUTINES- EQUSCAN                                              06152000
*                                                                       06153000
DECBIN   EQU   *                                                        06154000
         SR    RX,RX                    CLEAR ACCUMULATED LENGTH REG    06155000
         LR    RY,RX                    CLEAR NEXT DIGIT REGISTER       06156000
DB1      CLI   D0(INPTR),J9             LOOK FOR NUMERIC CHARACTER      06157000
         BHR   RTNLNK                   EXIT IF NOT FOUND               06158000
         IC    RY,D0(INPTR)             PICK UP DIGIT                   06159000
         MH    RX,=H'10'                MULTIPLY ACCUMULATED LENGTH     06160000
         AR    RX,RY                    AND ADD IN NEXT DIGIT           06161000
         LA    INPTR,D1(,INPTR)         BUMP COLUMN POINTER TO NEXT     06162000
         B     DB1                      GO BACK TO GET MORE DIGITS      06163000
*                                                                       06164000
* THIS SUBROUTINE GETS A NAME FROM THE OPERAND OF AN EXTRN OR           06165000
*        WXTRN STATEMENT. IT IS CALLED BY THE FOLLOWING ROUTINES-       06166000
*        ESCAN                                                          06167000
*                                                                       06168000
GETXNAM  EQU   *                                                        06169000
         GOIF  ENDSW,OFF=GX1            GO ON IF END NOT REACHED        06170000
GX0      SET   ENDSW,ON                 INDICATE NO MORE NAMES          06171000
         B     D0(,RTNLNK)              RETURN ON NO NAME OR ERROR      06172000
GX1      CLI   D0(INPTR),JAT            LOOK FOR ALPHANUMERIC CHAR      06173000
         BH    GX5                      BRANCH IF NOT                   06174000
         CLI   D0(INPTR),JA             LOOK FOR ALPHA ONLY             06175000
         BL    GX0                      BRANCH IF NOT                   06176000
GX1A     EQU   *                                                        06177000
         LR    RX,INPTR                 SAVE PTR TO START OF NAME       06178000
GX2      LA    INPTR,D1(,INPTR)         BUMP TO NEXT CHARACTER          06179000
         CLI   D0(INPTR),JAT            LOOK FOR ALPHANUMERIC CHAR      06180000
         BNH   GX2                      BRANCH IF FOUND                 06181000
GX3      CLI   D0(INPTR),JCOMMA         LOOK FOR COMMA DELIMITER        06182000
         BE    GX4                      BRANCH IF FOUND                 06183000
         CLI   D0(INPTR),JBLANK         LOOK FOR BLANK DELIMITER        06184000
         BNE   GX0                      BRANCH IF NOT FOUND             06185000
         SET   ENDSW,ON                 INDICATE LAST OPERAND PROCESSED 06186000
GX4      LR    WORK3,INPTR              GET PTR TO END OF NAME +1       06187000
         SR    WORK3,RX                 GET LENGTH OF NAME              06188000
         BCTR  WORK3,D0                 GET MOVE LENGTH OF NAME         06189000
         C     WORK3,=F'7'              CHECK FOR VALID LENGTH          06190000
         BH    GX0                      BRANCH IF TOO LONG              06191000
         LA    INPTR,D1(,INPTR)         BUMP TO NEXT NAME               06192000
         B     D4(,RTNLNK)              RETURN WITH GOOD NAME           06193000
GX5      CLI   D0(INPTR),JAMPER         TEST FOR POSSIBLE VARIABLE SYM  06194000
         BNE   GX0                      BRANCH IF NOT FOUND             06195000
         B     GX1A                     ACCEPT IF FOUND                 06196000
*                                                                       06197000
* THIS SUBROUTINE SCANS PAST EXPRESSIONS IN THE OPERANDS OF EQU,        06198000
*        DC, AND DS STATEMENTS. IT IS CALLED BY THE FOLLOWING           06199000
*        ROUTINES- EQUSCAN, DCSCAN                                      06200000
*                                                                       06201000
OPNDSCAN EQU   *                                                        06202000
         SR    PARENCT,PARENCT          INITIALIZE PAREN COUNT TO 0     06203000
         SET   QUOTESW,OFF              INITIALIZE QUOTE MODE INDICATOR 06204000
OPS1     CLI   D0(INPTR),JBLANK         LOOK FOR BLANK DELIMITER        06205000
         BNE   OPS2                     BRANCH IF NOT FOUND             06206000
         GOIF  QUOTESW,ON=OPS6          IGNORE IF BLANK INSIDE QUOTES   06207000
OPS1A    B     D0(,RTNLNK)              RETURN ON ANY ERROR             06208000
OPS2     CLI   D0(INPTR),JCOMMA         LOOK FOR COMMA DELIMITER        06209000
         BNE   OPS3                     BRANCH IF NOT FOUND             06210000
         GOIF  QUOTESW,ON=OPS6          IGNORE IF COMMA INSIDE QUOTES   06211000
         CLI   DELIMIT,JCOMMA           SEE IF LOOKING FOR COMMA        06212000
         BNE   OPS1A                    ERROR IF NOT                    06213000
         LTR   PARENCT,PARENCT          CHECK PAREN COUNT FOR ZERO      06214000
         BNZ   OPS1A                    ERROR IF NOT ZERO               06215000
OPS2A    LA    INPTR,D1(,INPTR)         BUMP PTR PAST DELIMITER         06216000
         B     D4(,RTNLNK)              RETURN ON VALID SYNTAX          06217000
OPS3     CLI   D0(INPTR),JLPARN         LOOK FOR LEFT PAREN CHARACTER   06218000
         BNE   OPS4                     BRANCH IF NOT FOUND             06219000
         GOIF  QUOTESW,ON=OPS6          IGNORE IF PAREN INSIDE QUOTES   06220000
         LA    PARENCT,D1(,PARENCT)     INCREMENT PAREN COUNT BY 1      06221000
         B     OPS6                     GO ON TO NEXT CHARACTER         06222000
OPS4     CLI   D0(INPTR),JQUOTE         LOOK FOR QUOTE CHARACTER        06223000
         BNE   OPS5                     BRANCH IF NOT FOUND             06224000
         BCTR  INPTR,D0                 BACK UP TO PREVIOUS CHARACTER   06225000
         CLI   D0(INPTR),JL             LOOK FOR L ATTRIB NOTATION      06226000
         BNE   OPS41                    BRANCH IF NOT FOUND             06227000
         GOIF  QUOTESW,ON=OPS42,ELSE=OPS421 IGNORE QUOTE IF L ATTRIB    06228000
OPS41    CLI   D0(INPTR),JB             LOOK FOR BINARY SDT             06229000
         BE    OPS42                    BRANCH IF FOUND                 06230000
         CLI   D0(INPTR),JC             LOOK FOR CHARACTER SDT          06231000
         BE    OPS42                    BRANCH IF FOUND                 06232000
         CLI   D0(INPTR),JX             LOOK FOR HEX SDT                06233000
         BE    OPS42                    BRANCH IF FOUND                 06234000
         CLI   D0(INPTR),JQUOTE         LOOK FOR PAIRED QUOTES          06235000
         BE    OPS42                    BRANCH IF FOUND                 06236000
         GOIF  QUOTESW,ON=OPS42,ELSE=OPS1A END ON SPURIOUS QUOTE        06237000
OPS42    SET   QUOTESW,FLIP             START OR END QUOTE MODE         06238000
OPS421   LA    INPTR,D1(,INPTR)         REPOSITION POINTER              06239000
         B     OPS6                     GO ON TO NEXT CHARACTER         06240000
OPS5     CLI   D0(INPTR),JRPARN         LOOK FOR RIGHT PAREN DELIMITER  06241000
         BNE   OPS6                     BRANCH IF NOT FOUND             06242000
         GOIF  QUOTESW,ON=OPS6          IGNORE IF PAREN INSIDE QUOTES   06243000
         CLI   DELIMIT,JRPARN           SEE IF LOOKING FOR RIGHT PAREN  06244000
         BNE   OPS5A                    GO ON IF NOT                    06245000
         LTR   PARENCT,PARENCT          CHECK PAREN COUNT FOR ZERO      06246000
         BZ    OPS2A                    BRANCH IF ZERO                  06247000
         B     OPS1A                    ERROR IF NOT                    06248000
OPS5A    BCTR  PARENCT,D0               DECREMENT PAREN COUNT BY 1      06249000
OPS6     LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06250000
         CL    INPTR,ENDCOL             CHECK FOR OPERAND EXCEEDED      06251000
         BH    OPS1A                    BRANCH IF EXCEEDED              06252000
         B     OPS1                     GO HANDLE NEXT CHARACTER        06253000
*                                                                       06254000
* THIS SUBROUTINE PERFORMS A BUFFERED WRITE TO ANY FILE.                06255000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       06256000
*                   ENDSEGB                                             06257000
*                   INITOSR                                             06258000
*                   OSRDFINI                                            06259000
*                                                                       06260000
BUFRITE  EQU   *                                                        06261000
         MVI   FSWITCH,J0               CLEAR FIRST WRITE/NOTE SWITCH   06262000
         LM    R3,R4,PIOPARMB           PICK UP I/O PARAMETERS          06263000
BRT1     CLR   R3,R5                    SEE IF RECORD LESS THAN MAX     06264000
         BH    BRT4                     BRANCH IF NOT                   06265000
         L     WORK3,D8(GDBASE,R13)                            FX0000   06266000
         USING JTEXT,WORK3                                     FX0000   06267000
         GOIF  JPRGMAC,OFF=BRT11        PGMR MACRO ?           FX0000   06268000
         DROP  WORK3                                           FX0000   06269000
         CH    R3,=AL2(MINRECSZ)        SEE IF BLOCK OVER MINIMUM       06270000
         BNL   BRT11                    BRANCH IF MORE OR JUST ENUF     06271000
         LA    R3,MINRECSZ              IF NOT, USE MINIMUM SIZE        06272000
BRT11    STH   R3,PIOPARMC              SET UP RECORD LENGTH            06273000
         SR    R3,R3                    INDICATE LAST WRITE             06274000
BRT2     JWRITE FILE=(R6),PARM=PIOPARMA WRITE RECORD TO PROPER FILE     06275000
         JCHECK FILE=(R6)               CHECK THE WRITE                 06276000
         TS    FSWITCH                  TEST AND SET FIRST WRITE SW     06277000
         BNZ   BRT3                     BRANCH IF NOT FIRST WRITE       06278000
         JNOTE FILE=(R6)                NOTE FIRST BLOCK WRITTEN        06279000
BRT3     LTR   R3,R3                    SEE IF WRITE COMPLETE           06280000
         BZR   R7                       RETURN IF YES                   06281000
         AR    R4,R5                    DEVELOP PTR TO NEXT I/O AREA    06282000
         ST    R4,PIOPARMA              PUT PTR IN I/O CONTROL AREA     06283000
         B     BRT1                     GO SET UP NEW WRITE LENGTH      06284000
BRT4     STH   R5,PIOPARMC              SET UP MAXIMUM RECORD LENGTH    06285000
         SR    R3,R5                    ADJUST WRITE LENGTH             06286000
         B     BRT2                     GO WRITE NEXT RECORD            06287000
*                                                                       06288000
* THIS SUBROUTINE PERFORMS A BUFFERED READ FROM ANY FILE.               06289000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       06290000
*                   INTRENTR                                            06291000
*                                                                       06292000
BUFREAD  EQU   *                                                        06293000
         LM    R3,R4,PIOPARMB           PICK UP I/O PARAMETERS          06294000
BRD1     CLR   R3,R5                    SEE IF RECORD LESS THAN MAX     06295000
         BH    BRD4                     BRANCH IF NOT                   06296000
         L     WORK3,D8(GDBASE,R13)                            FX0000   06297000
         USING JTEXT,WORK3                                     FX0000   06298000
         GOIF  JPRGMAC,OFF=BRD11        PGMR MACRO ?           FX0000   06299000
         DROP  WORK3                                           FX0000   06300000
         CH    R3,=AL2(MINRECSZ)        SEE IF BLOCK OVER MINIMUM       06301000
         BNL   BRD11                    BRANCH IF MORE OR JUST ENUF     06302000
         LA    R3,MINRECSZ              IF NOT, USE MINIMUM SIZE        06303000
BRD11    STH   R3,PIOPARMC              SET UP RECORD LENGTH            06304000
         SR    R3,R3                    INDICATE LAST READ              06305000
BRD2     JREAD FILE=(R6),PARM=PIOPARMA  READ RECORD FROM PROPER FILE    06306000
         JCHECK FILE=(R6)               CHECK THE READ                  06307000
         LTR   R3,R3                    SEE IF READ COMPLETE            06308000
         BZR   R7                       RETURN IF YES                   06309000
         AR    R4,R5                    DEVELOP PTR TO NEXT I/O AREA    06310000
         ST    R4,PIOPARMA              PUT PTR IN I/O CONTROL AREA     06311000
         B     BRD1                     GO SET UP NEW READ LENGTH       06312000
BRD4     STH   R5,PIOPARMC              SET UP MAXIMUM RECORD LENGTH    06313000
         SR    R3,R5                    ADJUST READ LENGTH              06314000
         B     BRD2                     GO READ NEXT RECORD             06315000
*                                                                       06316000
* THIS SUBROUTINE SEARCHES THE SEQUENCE SYMBOL DEFINITION TABLE         06317000
*        FOR A SPECIFIED SEQUENCE SYMBOL.                               06318000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       06319000
*                   SEQDEF                                              06320000
*                   SEQREF                                              06321000
*                                                                       06322000
         USING SSDEF,RCDPTR                                             06323000
SSHASHER XC    JDWORD,JDWORD            CLEAR WORK AREA FOR SEQ SYMB    06324000
         SR    LNGTHREG,LNGTHREG        CLEAR REGISTER FOR SEQ SYM LEN  06325000
         IC    LNGTHREG,D0(,PTR)        GET LENGTH OF SEQ SYMB          06326000
         EX    LNGTHREG,SSDEFMOV        MOVE SYMBOL INTO WORK AREA      06327000
         LA    LNGTHREG,D1(,LNGTHREG)   GET SYMBOL TRUE LENGTH          06328000
         LA    WORK1,SSPRIME            SET UP PTR TO HASH PARAMETERS   06329000
         BAL   WORK2,HASH               LINK TO HASHING RTN             06330000
         L     SSDTBASE,SSDTSTRT        SET UP SSDT POINTER CONSTANT    06331000
         LR    SSDTPTR,SSDTBASE         SET UP SAME POINTER SCRATCH     06332000
         SH    SSDTPTR,=H'2'            ADJUST IT                       06333000
         SR    SSDTPTR,HASHSS           DEVELOP HASH TABLE POINTER      06334000
         USING SSDTNTRY,SSDTPTR                                         06335000
CHNLOOP  CLC   SSDTCP,=FL3'0'           CHECK FOR END OF CHAIN          06336000
         BZ    NTFND                    IF FOUND, BRANCH OUT            06337000
         MVC   HIBYTE0+(L'HIBYTE0-L'SSDTCP)(L'SSDTCP),SSDTCP           X06338000
               GET CHAIN POINTER FROM ENTRY                             06339000
         LR    SSDTPTR,SSDTBASE         RESTORE SSDT BASE ADDR          06340000
         S     SSDTPTR,HIBYTE0          GET CHAINED ENTRY ADDRESS       06341000
         EX    LNGTHREG,SSDEFCMP        COMPARE SEQUENCE SYMBOLS        06342000
         BNE   CHNLOOP                  BRANCH IF NOT IDENTICAL         06343000
         SET   FNDFLG,ON                INDICATE MATCH FOUND            06344000
         BR    RTNLNK                   RETURN                          06345000
NTFND    SET   FNDFLG,OFF               INDICATE NO MATCH FOUND         06346000
         BR    RTNLNK                   RETURN                          06347000
SSDEFMOV MVC   JDWORD(D0),D1(PTR)       EXECUTED SEQ SYMB MOVE          06348000
SSDEFCMP CLC   D0(D0,PTR),SSDTSL        EXECUTED SEQ SYMB COMPARE       06349000
         DROP  RCDPTR                                                   06350000
         DROP  SSDTPTR                                                  06351000
*                                                                       06352000
* THIS SUBROUTINE SEARCHES THE GLOBAL DIRECTORY FOR A SPECIFIED         06353000
*        VARIABLE SYMBOL.                                               06354000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       06355000
*                   GBLDEF                                              06356000
*                                                                       06357000
         USING GBLDEFN,RCDPTR                                           06358000
GSHASHER XC    JDWORD,JDWORD            CLEAR WORK AREA FOR VARB NAME   06359000
         SR    LNGTHREG,LNGTHREG        CLEAR REGISTER FOR VAR SYM LEN  06360000
         IC    LNGTHREG,D0(,PTR)        GET LENGTH OF VARIABLE SYMBOL   06361000
         EX    LNGTHREG,GSMOVE          MOVE NAME INTO WORK AREA        06362000
         LA    WORK1,GSPRIME            SET UP PTR TO HASH PARAMETERS   06363000
         BAL   WORK2,HASH               LINK TO HASHING RTN             06364000
         L     GDBASE,GDSTRT            GET GBL DIRECTORY BASEADDR      06365000
         AR    GDBASE,HASHGS            DEVELOP HASH TABLE POINTER      06366000
         USING GDNTRY,GDBASE                                            06367000
CHAINON  CLC   GDCP,=FL3'0'             CHECK FOR END OF CHAIN          06368000
         BZ    NTFOUND                  IF FOUND, BRANCH OUT            06369000
         MVC   HIBYTE0+(L'HIBYTE0-L'GDCP)(L'GDCP),GDCP                 X06370000
               GET CHAIN POINTER FROM ENTRY                             06371000
         L     GDBASE,HIBYTE0           PICK UP CHAIN PTR               06372000
         A     GDBASE,GDSTRT            ADD BASE ADDR OF TABLE          06373000
         SR    WORK2,WORK2              CLEAR LENGTH REGISTER           06374000
         IC    WORK2,GDSL               PICK UP ENTRY LENGTH            06375000
         CR    WORK2,LNGTHREG           CHECK FOR EQUAL LENGTHS         06376000
         BNE   CHAINON                  IF NOT, DONT BOTHER MORE        06377000
         EX    LNGTHREG,GSCMP           COMPARE GLOBAL VARIABLES        06378000
         BNE   CHAINON                  BRANCH IF NOT IDENTICAL         06379000
         SET   FNDFLG,ON                INDICATE MATCH FOUND            06380000
         BR    RTNLNK                   RETURN                          06381000
NTFOUND  SET   FNDFLG,OFF               INDICATE NO MATCH FOUND         06382000
         BR    RTNLNK                   RETURN                          06383000
GSMOVE   MVC   JDWORD(D0),D1(PTR)       EXECUTED VARB SYMB MOVE         06384000
GSCMP    CLC   JDWORD(D0),GDSYM+D1      EXECUTED VARB SYMB COMPARE      06385000
         DROP  RCDPTR                                                   06386000
         DROP  GDBASE                                                   06387000
*                                                                       06388000
* THIS SUBROUTINE CONVERTS A SYMBOL PASSED IN JDWORD TO A HASH          06389000
*            TABLE INDEX USING THE PARAMETERS POINTED TO BY WORK1.      06390000
*   IT IS CALLED BY THE FOLLOWING ROUTINES -                          * 06391000
*              ORDREF,ORDSYMBR,SSHASHER,GSHASHER                      * 06392000
*                                                                       06393000
HASH     EQU   *                                                        06394000
         L     PAIRO,JDWORD             PICK UP FIRST HALF OF NAME      06395000
         AL    PAIRO,JDWORD+D4          FOLD SECOND HALF OVER FIRST     06396000
         SR    PAIRE,PAIRE              SET UP REGISTER PAIR            06397000
         D     PAIRE,D0(,WORK1)         DIVIDE BY HASH VALUE            06398000
         N     PAIRE,D4(,WORK1)         APPLY MASK FOR HASH TABLE RANGE 06399000
         LR    PAIRO,PAIRE              SHIFT VALUE FOR MULTIPLY        06400000
         M     PAIRE,=F'3'              DEVELOP TABLE INDEX             06401000
         BR    WORK2                    RETURN                          06402000
*                                                                     * 06403000
* THIS SUBROUTINE GENERATES THE ERROR RECORDS ORIGINATING IN THE      * 06404000
*              INTERLUDE PHASE. IT IS CALLED FROM THE FOLLOWING       * 06405000
*              ROUTINES - GBLDEF, SEQDEF, SEQREF, INITOSR,            * 06406000
*              ORDSYMBR, OPSYNBLD                                     * 06407000
*                                                                     * 06408000
ERLOGER  EQU   *                                                        06409000
         LA    R0,JAMPER                INSERT AMPERSAND FOR VARB SYMB  06410000
ERLOGERZ SR    WORK1,WORK1              CLEAR LENGTH REGISTER           06411000
         IC    WORK1,D0(,WORK2)         PICK UP SYMBOL LENGTH           06412000
         STC   R0,D0(,WORK2)            INSERT AMPERSAND OR PERIOD      06413000
         LA    WORK1,D1(,WORK1)         IN SYMBOL AND ADJUST FOR IT     06414000
         GOIF  OCTS,OFF=MACROMSG        GO TO HANDLE SEPARATE MSGS      06415000
         MVC   ERROTHR,=AL1(JO,JP,JE,JN,JBLANK,JBLANK,JBLANK,JBLANK,JC,X06416000
               JO,JD,JE,JBLANK,JBLANK,JBLANK,JBLANK)                   X06417000
               PUT IN EXTRA STUFF FOR OPEN CODE ERROR                   06418000
         B     ERLOGERA                 PROCEED TO NAME INSERTION       06419000
MACROMSG MVC   ERROTHR,=AL1(JM,JA,JC,JR,JO,JBLANK,JBLANK,JBLANK,JBLANK,X06420000
               JBLANK,JBLANK,JBLANK,JBLANK,JBLANK,JBLANK,JBLANK)       X06421000
               PUT IN EXTRA STUFF AND PAD FOR MACRO DEFINITION ERROR    06422000
         IC    WORK5,MFLAGS             PICK UP MDD ENTRY FLAGS         06423000
         N     WORK5,=F'7'              GET MACRO NAME LENGTH           06424000
         EX    WORK5,MACRNMOV           PUT MACRO NAME IN MESSAGE       06425000
ERLOGERA EQU   *                                                        06426000
         MVC   ERRNAME,=8AL1(JBLANK)    FILL SYMBOL SLOT WITH PAD       06427000
         EX    WORK1,NAMEMVE            PUT ERROR SYMBOL IN BUFFER      06428000
ERLOGERB CLC   JMSGL,D0(RTNLNK)         SEE IF ERROR SHOULD BE LOGGED   06429000
         BH    D2(,RTNLNK)              RETURN DIRECTLY IF NOT          06430000
         CLC   D0(D1,RTNLNK),JSEVER     IS THIS HIGHER                  06431000
         BNH   ERLOGERD                 BRANCH IF NOT                   06432000
         MVC   JSEVER(D1),D0(RTNLNK)    ENTER HIGH                      06433000
ERLOGERD MVC   ERRHDR+D9(D2),D0(RTNLNK) PUT IN ERROR CODE               06434000
         L     WORK1,ERBLKPTR           GET PTR TO NEXT RCD SLOT        06435000
         LA    WORK2,D36(,WORK1)        ADJUST PTR FOR NEW ERROR        06436000
         C     WORK2,COMSTRT            CHECK FOR OVERLAP OF BUFFER     06437000
         BL    ERLOGERC                 BRANCH IF NO OVERLAP            06438000
         MVC   D0(D2,WORK1),=H'0'       PUT END OF BUFFER FLAG IN       06439000
         MVC   PIOPARMA,ERRBLK          SET UP WRITE PARAMETER- ADDRESS 06440000
         MVC   PIOPARMB,=F'190'         SET UP WRITE PARAMETER- LENGTH  06441000
         ST    RTNLNK,ERRLNKSV          PRESERVE RETURN ADDRESS         06442000
         STM   R3,R7,SAVE3456           SAVE CRUCIAL REGISTERS          06443000
         LH    R5,JMAXRL1               SET UP MAXIMUM RECORD LENGTH    06444000
         LA    R6,FILE1                 SET UP FILE POINTER             06445000
         BAL   R7,BUFRITE               LINK TO BUFFERED WRITE RTN      06446000
         LM    R3,R7,SAVE3456           RESTORE REGISTERS               06447000
         L     WORK1,ERRBLK             GET PTR TO ERROR BUFFER         06448000
         MVC   D0(L'JNOTEVAL,WORK1),JNOTEVAL SAVE N/P FOR LINK TO LAST  06449000
         LA    WORK1,D8(,WORK1)         GET OFFSET IN NEW ERROR BUFFER  06450000
         L     RTNLNK,ERRLNKSV          RESTORE RETURN REGISTER         06451000
ERLOGERC MVC   D0(D36,WORK1),ERRHDR     PUT ERROR MSG BUILT INTO BUF    06452000
         LA    WORK1,D36(,WORK1)        ADJUST BUFFER PTR FOR NEW MSG   06453000
         ST    WORK1,ERBLKPTR           SAVE NEW ERROR SLOT PTR         06454000
         B     D2(,RTNLNK)              RETURN TO CALLING RTN           06455000
NAMEMVE  MVC   ERRNAME(D0),D0(WORK2)    EXECUTED ERROR SYMBOL MOVE      06456000
MACRNMOV MVC   ERROTHR+D8(D0),MSYMBL    EXECUTED MACRO NAME MOVE        06457000
*                                                                       06458000
* THIS SUBROUTINE CONVERTS ANY SELF-DEFINING TERM TO A BINARY VALUE.    06459000
*                                                                       06460000
SDTCONV  SR    COUNT,COUNT              CLEAR REG FOR CHAR COUNT        06461000
         LR    RX,COUNT                 CLEAR REG FOR CHAR VALUE        06462000
         STC   TYPE,SHIFTAMT            SAVE SDT TYPE INDICATOR         06463000
SDT01    LA    RY,SDTAB1-D1(TYPE)       GET TTR TO SDT HI CHARACTER     06464000
         CLC   D0(D1,INPTR),D0(RY)      CHECK FOR NEXT CHAR IN RANGE    06465000
         BH    SDT08                    BRANCH IF NOT                   06466000
         IC    RX,D0(,INPTR)            PICK UP NEXT VALID CHAR         06467000
         LR    RY,VALUE                 PRESERVE CURRENT ACCUM VALUE    06468000
         CLI   SHIFTAMT,D8              CHECK FOR CHAR (C) TYPE SDT     06469000
         BNE   SDT04                    BRANCH IF NOT C TYPE            06470000
         CLI   D0(INPTR),JQUOTE         SEE IF CHARACTER A QUOTE        06471000
         BNE   SDT04                    PROCEED IF NOT                  06472000
         CLI   D1(INPTR),JQUOTE         LOOK AHEAD FOR PAIRED QUOTE     06473000
         BNE   SDT08A                   GO TO CHECK LENGTH AND EXIT     06474000
SDT03    LA    INPTR,D1(,INPTR)         BUMP PAST PARING QUOTE          06475000
SDT04    SLL   VALUE,D0(TYPE)           SHIFT ACCUM VALUE 1 PLACE       06476000
         CLI   SHIFTAMT,D3              CHECK FOR DECIMAL SDT           06477000
         BNE   SDT05                    BRANCH IF NOT DECIMAL           06478000
         ALR   VALUE,RY                 DO ADDITIONAL ADJUSTMENT        06479000
         ALR   VALUE,RY                 NECESSARY FOR DECIMAL SDT       06480000
SDT05    ALR   VALUE,RX                 ADD IN NEXT CHARACTER VALUE     06481000
         LA    COUNT,D1(,COUNT)         INCREMENT CHARACTER COUNT       06482000
         LA    INPTR,D1(,INPTR)         BUMP INPUT PTR TO NEXT CHAR     06483000
         CL    INPTR,ENDCOL             SEE IF OPERAND EXCEEDED         06484000
         BNH   SDT01                    GO ON IF STILL OK               06485000
SDT06    SR    COUNT,COUNT              SET COUNT TO NONE               06486000
SDT07    BR    RTNLNK                   RETURN TO CALLING RTN           06487000
SDT08    CLI   SHIFTAMT,D3              CHECK FOR DECIMAL SDT           06488000
         BE    SDT09                    GO TO CHECK LENGTH AND EXIT     06489000
         CLI   D0(INPTR),JQUOTE         LOOK FOR ENDING QUOTE           06490000
         BNE   SDT06                    TREAT AS ERROR IF NONE          06491000
SDT08A   LA    INPTR,D1(,INPTR)         BUMP PAST ENDING QUOTE          06492000
SDT09    IC    RX,SDTAB2-D1(TYPE)       PICK UP LENGTH LIMIT            06493000
         CR    COUNT,RX                 SEE IF SDT LENGTH IN RANGE      06494000
         BH    SDT06                    TREAT AS ERROR IF NOT           06495000
         CLI   SHIFTAMT,D8              CHECK FOR CHARACTER SDT         06496000
         BNER  RTNLNK                   BRANCH OUT IF NOT               06497000
         GOIF  TRANSW,OFF=(RTNLNK)      EXIT IF NO TRANSLATION          06498000
         ST    VALUE,JFWORD1            SET UP VALUE FOR TRANSLATE      06499000
         TR    JFWORD1,JTRTABLE         TRANSLATE IT                    06500000
         L     VALUE,JFWORD1            PICK IT UP FOR CALLER           06501000
         BR    RTNLNK                   RETURN WITH TRANSLATED VALUE    06502000
SDTAB1   DC    X'0100090F000000FF'      SELF-DEFINING TERM              06503000
SDTAB2   DC    X'20000A0800000004'      CONVERSION TABLES               06504000
         EJECT                                                          06505000
SSPRIME  DC    F'71'                    PRIME FOR HASHING SEQ SYMBOLS   06506000
SSHSHMSK DC    XL4'3F'                  MASK FOR HASHING SEQ SYMBOLS    06507000
GSPRIME  DC    F'201'                   PRIME FOR HASHING GBL VARIABLES 06508000
OSPRIME  EQU   GSPRIME                  PRIME FOR HASHING ORD SYMBOLS   06509000
GSHSHMSK DC    XL4'7F'                  MASK FOR HASHING GBL VARIABLES  06510000
OSHSHMSK EQU   GSHSHMSK                 MASK FOR HASHING ORD SYMBOLS    06511000
         EJECT                                                          06512000
*INITOSR - THIS ROUTINE OUTPUTS THE MACRO DEFINITION VECTOR AND       * 06513000
*   INITIALIZES FOR THE ORDINARY SYMBOL RESOLUTION.                   * 06514000
*                                                                     * 06515000
         DS    0H                                                       06516000
INITOSR  EQU   *                                                        06517000
         L     R3,=A(ORDSYMBR)          SET UP BASE FOR SECOND HALF     06518000
         USING ORDSYMBR,R3                                              06519000
         JPOINT FILE=FILE2,NEXT=START   REWIND BEFORE PUTTING MDV       06520000
         MVC   PIOPARMB,MDVLNTH         SET UP MDV LENGTH               06521000
         MVC   PIOPARMA,MDVSTRT         SET UP MDV ADDRESS              06522000
         ST    R3,SAVE3456              SAVE CRUCIAL REGISTER           06523000
         LH    R5,JMAXRL2               SET UP MAXIMUM RECORD THIS FILE 06524000
         LA    R6,FILE2                 SET UP FILE POINTER             06525000
         BAL   R7,BUFRITE               GO PUT MDV TO FILE2             06526000
         L     R3,SAVE3456              RESTORE CRUCIAL REGISTER        06527000
         MVC   SAVMDVNP(L'JNOTEVAL),JNOTEVAL SAVE N/P ADDR FOR GENER    06528000
         MVC   SAVMDVLN(L'MDVLNTH),MDVLNTH   SAVE LENGTH FOR GENERATOR  06529000
         MVC   SAVGDLNT(L'GDALLOC),GDALLOC   SAVE GLOBAL DICT SIZE      06530000
         L     REFCNT,OREFCNT           GET NUMBER OF REFERENCES        06531000
         LTR   REFCNT,REFCNT            TEST FOR ZERO                   06532000
         BNZ   OSRDALOC                 IF NOT ZERO, ENTER RESOLUTION   06533000
OSRDXT   XC    SAVOSDLN(D4),SAVOSDLN    INDICATE NO OSRD TO X3N         06534000
         B     OPSYNBLD                 AND SKIP TO OPSYN PROCESSING    06535000
OSRDALOC MH    REFCNT,=H'6'             GET SIZE OF OSRD                06536000
         ST    REFCNT,JFWORD1           SAVE TEMPORARILY AND PUT OSRD   06537000
         MVC   SAVOSDLN(L'JFWORD1),JFWORD1 LENGTH IN COMMON             06538000
         L     WORK2,OSRDSTRT           GET PTR TO DICT AREA            06539000
         LA    WORK3,D0(REFCNT,WORK2)   GET PTR PAST OSRD               06540000
         C     WORK3,MDDSTRT            CHECK FOR TABLE OVERLAP         06541000
         BNH   OSRDGO                   BRANCH IF NOT THE CASE          06542000
         BAL   RTNLNK,ERLOGERB          CALL ERROR LOGGING RTN          06543000
         DC    AL1(SEV64,ERR64)         ERROR PARAMETERS                06544000
         B     WTOMSG                   GO THRU BYPASS OF OSRD @AX14177 06545000
OSRDGO   EQU   *                                                        06546000
CLERLP1  CH    REFCNT,=H'256'           SEE IF ONE MOVE WILL CLEAR IT   06547000
         BH    CLERLP2                  BRANCH IF NOT                   06548000
         SH    REFCNT,=H'2'             ADJUST LENGTH FOR EXECUTED MOVE 06549000
         MVI   D0(WORK2),BITFF          INSERT F'S TO PROPAGATE         06550000
         EX    REFCNT,OSRDCLER          PROPAGATE THRU REST OF DICT     06551000
         B     ORDSYMBR                 GO ON TO RESOLUTION             06552000
CLERLP2  MVI   D0(WORK2),BITFF          INSERT F'S TO PROPAGATE         06553000
         MVC   D1(D255,WORK2),D0(WORK2) PROPAGATE THRU 256 BYTES        06554000
         SH    REFCNT,=H'256'           ADJUST REMAINING DICT LENGTH    06555000
         LA    WORK2,D256(,WORK2)       ADJUST PTR ALSO                 06556000
         B     CLERLP1                  GO BACK THRU TO CLEAR REST      06557000
WTOMSG   WTO   MF=(E,MSG064)                                   @AX14177 06558000
         B     OSRDXT                                          @AX14177 06559000
MSG064   WTO   'IFO064 INTERLUDE DICTIONARY SPACE EXHAUSTED',  @AX14177*06560000
               ROUTCDE=11,MF=L                                 @AX14177 06561000
         EJECT                                                          06562000
         JPATCH X2A00,A80               PATCH AREA             FX0000   06563000
         EJECT                                                          06564000
         JCSECT (X2A02)                                                 06565000
ORDSYMBR EQU   *                                                        06566000
         JGETL FILE=FILE3               OTHERWISE, READ NEXT DEF RECD   06567000
         USING ENDFIL,RCDPTR                                            06568000
         CLI   EFILRT,BITFF             CHECK FOR END-OF-FILE           06569000
         BE    OSRDFINI                 IF SO, FINISH UP                06570000
         USING JTEXT,RCDPTR                                             06571000
         GOIF  JPSOP,OFF=GETNAME        BRANCH IF NOT A PSEUDO-OP       06572000
         CLI   JTIOP1,JTEXTRN           SEE IF PSEUDO-OP IS EXTRN       06573000
         BE    ESCAN                    BRANCH IF IT IS, TO GET NAME    06574000
         CLI   JTIOP1,JTWXTRN           SEE IF PSEUDO-OP IS WXTRN       06575000
         BE    ESCAN                    BRANCH IF IT IS, TO GET NAME    06576000
GETNAME  LR    WORK1,RCDPTR             GET START OF TEXT ADDR          06577000
         AH    WORK1,JTNMP              GET START OF NAME FIELD ADDR    06578000
         SR    WORK3,WORK3              CLEAR REGISTER FOR LENGTH       06579000
         IC    WORK3,D1(,WORK1)         PICK UP NAME TRUE LENGTH        06580000
         BCTR  WORK3,D0                 MAKE IT MOVE LENGTH             06581000
         STH   WORK3,JHWORD2            SAVE LENGTH OF NAME             06582000
         XC    JDWORD,JDWORD            CLEAR NAME WORK AREA            06583000
         EX    WORK3,NAMEMV             MOVE NAME FOR HASHING           06584000
HASHNAME LA    WORK1,OSPRIME            GET PTR TO HASHING PARAMETERS   06585000
         BAL   WORK2,HASH               LINK TO SYMBOL HASHING RTN      06586000
         L     OSRTBASE,OSRTSTRT        GET OSRT BASE ADDRESS           06587000
         AR    OSRTBASE,HASHOS          DEVELOP HASH TABLE POINTER      06588000
         USING OSRTNTRY,OSRTBASE                                        06589000
OSLUKUP  CLC   OSRTCP,=FL3'0'           CHECK FOR END OF CHAIN          06590000
         BZ    ORDSYMBR                 IF FOUND, CONTINUE     FX0000   06591000
         MVC   HIBYTE0+(L'HIBYTE0-L'OSRTCP)(L'OSRTCP),OSRTCP           X06592000
               GET CHAIN POINTER FROM ENTRY                             06593000
         L     OSRTBASE,HIBYTE0         PICK UP CHAIN POINTER           06594000
         A     OSRTBASE,OSRTSTRT        DEVELOP PTR TO NEXT ENTRY       06595000
         SR    WORK1,WORK1              CLEAR REGISTER FOR LENGTH       06596000
         IC    WORK1,OSRTSL             PICK UP ENTRY SYMBOL LENGTH     06597000
         CLR   WORK1,WORK3              COMPARE MOVE LENGTHS            06598000
         BNE   OSLUKUP                  NO MATCH IF UNALIKE             06599000
         EX    WORK1,NAMECM             COMPARE NAMES                   06600000
         BNE   OSLUKUP                  SEARCH ON IF UNALIKE            06601000
         L     OSRDPTR,OSRDSTRT         PICK UP BASE ADDR OF OSRD       06602000
         MVC   HIBYTE0+(L'HIBYTE0-L'OSRTDP)(L'OSRTDP),OSRTDP           X06603000
               GET DICTIONARY POINTER                                   06604000
         A     OSRDPTR,HIBYTE0          DEVELOP PTR TO OSRD ENTRY       06605000
         USING OSRDNTRY,OSRDPTR                                         06606000
         CLC   TATTRIB(L'TATTRIB+L'LATTRIB+L'SATTRIB),=5X'FF'          X06607000
               SEE THAT ATTRIBUTES HAVE NOT ALREADY BEEN ASSIGNED       06608000
         BE    BRONTYP                  BRANCH IF NOT YET SET           06609000
         CLI   TATTRIB,JM               WAS OLD TYPE ATTRIBUTE M        06610000
         BNE   OLDNOTM                  BR IF ANYTHING ELSE             06611000
         GOIF  JTCALL,EQ=ORDSYMBR       ALLOW DUPLICATE NAME ON MI      06612000
CHNGU    MVI   TATTRIB,JU               DUPLICATE NAMES-- MAKE ATTRB U  06613000
         MVC   LATTRIB,=H'1'            AND                    FX0000   06614000
         SET   LDEFALT,ON                  SET                 FX0000   06615000
         MVC   SATTRIB,=H'0'                  DEFAULTS         FX0000   06616000
         SET   SDEFALT,ON                             ON       FX0000   06617000
         B     ORDSYMBR                 BACK TO CONTINUE                06618000
OLDNOTM  GOIF  JTCALL,EQ=CHNGU          MAKE ATTRB U IF THIS IS MI      06619000
CHKCST   GOIF  JTCSECT,LO=ERRORA        ERROR IF DUPLICATE NAME NOT ON  06620000
         GOIF  JTCOM,HI=ERRORA,ELSE=NGNAME CSECT, DSECT, OR COM STMT    06621000
BRONTYP  EQU   *                                                        06622000
         MVI   ATTRIB,J0                CLEAR ATTRIBUTE DEFAULT FLAGS   06623000
         GOIF  JSUBOPCD,ON=TYPEU1       HANDLE SUBSTITUTED OP CODE      06624000
         GOIF  JPSOP,OFF=TYPEI1         BRANCH IF MACHINE INSTRUCTION   06625000
         GOIF  JTDC,EQ=DCSCAN           BRANCH IF DC STATEMENT          06626000
         GOIF  JTEQU,EQ=EQUSCAN         BRANCH IF EQU STATEMENT         06627000
         GOIF  JTDS,EQ=DSSCAN           BRANCH IF DS STATEMENT          06628000
         GOIF  JTCALL,EQ=TYPEM          BRANCH IF MACRO INSTRUCTION     06629000
         GOIF  JTORG,EQ=TYPEU1          BRANCH IF ORG STATEMENT         06630000
         GOIF  JTEXTRN,EQ=TYPET         BRANCH IF EXTRN STATEMENT       06631000
         GOIF  JTWXTRN,EQ=TYPE$         BRANCH IF WXTRN STATEMENT       06632000
         GOIF  JTSTART,EQ=TYPEJ         BRANCH IF START STATEMENT       06633000
         GOIF  JTLTORG,EQ=TYPEU1        BRANCH IF LTORG STATEMENT       06634000
         GOIF  JTDSECT,EQ=TYPEJ         BRANCH IF DSECT STATEMENT       06635000
         GOIF  JTCSECT,EQ=TYPEJ         BRANCH IF CSECT STATEMENT       06636000
         GOIF  JTCNOP,EQ=TYPEI2         BRANCH IF CNOP STATEMENT        06637000
         GOIF  JTCCW,EQ=TYPEW           BRANCH IF CCW STATEMENT         06638000
         GOIF  JTCOM,EQ=TYPEJ           BRANCH IF COM STATEMENT         06639000
         GOIF  JTCXD,EQ=TYPEU2          BRANCH IF CXD STATEMENT         06640000
         GOIF  JTDXD,EQ=TYPEJ           BRANCH IF DXD STATEMENT         06641000
         B     TYPEU1                   OTHERWISE ASSIGN DEFAULT ATTRS  06642000
ERRORA   EQU   *                                                        06643000
         MVI   TATTRIB,JU               DUPLICATE NAMES-- MAKE ATTRB U  06644000
         MVC   LATTRIB,=H'1'            AND                    FX0000   06645000
         SET   LDEFALT,ON                  SET                 FX0000   06646000
         MVC   SATTRIB,=H'0'                  DEFAULTS         FX0000   06647000
         SET   SDEFALT,ON                             ON       FX0000   06648000
NGNAME   EQU   *                                                        06649000
         GOIF  JTEXTRN,EQ=ESCANA        GO GET NEXT EXTRN/WXTRN NAME    06650000
         GOIF  JTWXTRN,EQ=ESCANA,ELSE=ORDSYMBR OR NEXT STATEMENT        06651000
CHASER     EQU   *                                                      06652000
ENDCHK   NC    OSRTCP,OSRTCP            SEE IF END OF CHAIN REACHED     06653000
         BZ    NGNAME                   BRANCH IF YES                   06654000
         MVC   HIBYTE0+(L'HIBYTE0-L'OSRTCP)(L'OSRTCP),OSRTCP           X06655000
               GET CHAIN PTR FROM ENTRY                                 06656000
         L     OSRTBASE,HIBYTE0         PICK UP CHAIN POINTER           06657000
         A     OSRTBASE,OSRTSTRT        DEVELOP PTR TO NEXT ENTRY       06658000
         SR    WORK1,WORK1              CLEAR REGISTER FOR LENGTH       06659000
         IC    WORK1,OSRTSL             PICK UP ENTRY SYMBOL LENGTH     06660000
         CLR   WORK1,WORK3              COMPARE MOVE LENGTHS            06661000
         BNE   ENDCHK                   BRANCH IF UNALIKE               06662000
         EX    WORK1,NAMECM             COMPARE NAMES                   06663000
         BNE   ENDCHK                   BRANCH IF UNALIKE               06664000
         L     PAIRO,OSRDSTRT           PICK UP,OSRD BASE ADDRESS       06665000
         MVC   HIBYTE0+(L'HIBYTE0-L'OSRTDP)(L'OSRTDP),OSRTDP           X06666000
                   GET PTR TO OSRD ENTRY FOR DUPLICATE                  06667000
         A     PAIRO,HIBYTE0            DEVELOP DICTIONARY POINTER      06668000
         MVC  D0(L'TATTRIB+L'LATTRIB+L'SATTRIB+L'ATTRIB,PAIRO),TATTRIB X06669000
               PUT SAME ATTRIBUTES IN DUPLICATE ENTRY                   06670000
         B     CHASER                   LOOP BACK FOR MORE              06671000
         EJECT                                                          06672000
TYPEI1   EQU   *                                                        06673000
         MVI   TATTRIB,JI               SET TYPE TO I IN DICT ENTRY     06674000
         SR    PAIRO,PAIRO              CLEAR WORK REGISTER             06675000
         IC    PAIRO,JTFLGA             PICK UP FLAGA BYTE FROM TEXT    06676000
         N     PAIRO,=F'3'              ISOLATE LENGTH BITS             06677000
         LA    PAIRO,D1(,PAIRO)         ADD 1 AND                       06678000
         SLL   PAIRO,D1                 MULTIPLY BY 2 FOR LENGTH        06679000
         STH   PAIRO,JHWORD1            TEMPORARILY SAVE LENGTH AND     06680000
         MVC   LATTRIB,JHWORD1          INSERT INTO DICTIONARY ENTRY    06681000
         B     DEFALTC                  GO ASSIGN SCALE                 06682000
TYPEI2   EQU   *                                                        06683000
         MVI   TATTRIB,JI               SET TYPE TO I IN DICT ENTRY     06684000
DLENGTH  MVC   LATTRIB,=H'1'            PUT DEFAULT LENGTH IN ENTRY     06685000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENGTH       06686000
DEFALTC  MVC   SATTRIB,=H'0'            INSERT DEFAULT SCALE ATTRIB     06687000
         SET   SDEFALT,ON               INDICATE DEFAULTED SCALE        06688000
         B     CHASER                   RETURN FOR ADDITNL REFERENCES   06689000
ESCAN    EQU   *                                                        06690000
         SET   ENDSW,OFF                &NITIALIZE FOR NEW STATEMENT    06691000
ESCANB   LR    INPTR,RCDPTR             PICK UP PTR TO STATEMENT        06692000
         AH    INPTR,JTOPP              DEVELOP PTR TO OPERAND          06693000
         CLI   D0(INPTR),J0             LOOK FOR NULL OPERAND           06694000
         BE    ORDSYMBR                 BRANCH IF NO OPERAND            06695000
         TM    D0(INPTR),BIT0           LOOK FOR CARD POINTER           06696000
         BNO   ESCANC                   BRANCH IF NONE PRESENT          06697000
         LA    INPTR,D1(,INPTR)         BUMP PAST CARD POINTER          06698000
ESCANC   LA    INPTR,D2(,INPTR)         GET PTR TO NAME ITSELF          06699000
ESCANA   BAL   RTNLNK,GETXNAM           GO GET A NAME                   06700000
         B     ORDSYMBR                 BRANCH ON NO NAME OR ERROR      06701000
         XC    JDWORD,JDWORD            CLEAR NAME WORK AREA            06702000
         EX    WORK3,MVNAME             PICK UP NAME FOR HASHING        06703000
         B     HASHNAME                 GO HASH NAME                    06704000
DSSCAN   EQU   *                                                        06705000
         MVI   SWITCHB,J0               CLEAR OUT ALL SWITCHES          06706000
         SET   DSSW,ON                  INDICATE DS OPERAND             06707000
         B     DC0                      CONTINUE AS DC                  06708000
DCSCAN   EQU   *                                                        06709000
         MVI   SWITCHB,J0               CLEAR OUT ALL SWITCHES          06710000
         SET   DSSW,OFF                 INDICATE DC OPERAND             06711000
DC0      LH    INPTR,JTOPP              GET DISPL TO OPERAND IN TEXT    06712000
         AR    INPTR,RCDPTR             DEVELOP PTR TO OPERAND          06713000
         CLI   D0(INPTR),J0             CHECK FOR NO OPERAND            06714000
         BE    DEFALTD1                 BRANCH IF NONE                  06715000
         TM    D0(INPTR),BIT0           LOOK FOR CARD POINTER           06716000
         BNO   DC1                      BRANCH IF NONE                  06717000
         LA    INPTR,D1(,INPTR)         BUMP PAST CARD POINTER          06718000
DC1      LA    INPTR,D1(,INPTR)         BUMP PAST COLUMN POINTER        06719000
         SR    ENDPTR,ENDPTR            CLEAR REGISTER FOR END PTR      06720000
         IC    ENDPTR,D0(INPTR)         PICK UP OPERAND LENGTH          06721000
         AR    ENDPTR,INPTR             DEVELOP PTR TO END OF OPERAND   06722000
         AH    ENDPTR,=H'1'             ADJUST FOR BLANK DELIMITER      06723000
         ST    ENDPTR,ENDCOL            SAVE FOR USE IN SCAN LATER      06724000
         LA    INPTR,D1(,INPTR)         BUMP PAST OPERAND LENGTH        06725000
         SR    RZ,RZ                    INITIALIZE WORK REGISTER        06726000
         CLI   D0(INPTR),J9             LOOK FOR DECIMAL DUP FACTOR     06727000
         BH    DC2                      BRANCH IF EXPRESSION            06728000
         BAL   RTNLNK,DECBIN            COLLECT DUP FACTOR              06729000
         B     DC3                      BRANCH,IGNORING DUP FACTOR      06730000
DC2      CLI   D0(INPTR),JLPARN         LOOK FOR LEADING PARENTHESIS    06731000
         BNE   DC3                      BRANCH IF NOT FOUND             06732000
         LA    INPTR,D1(,INPTR)         BUMP PAST LEFT PAREN            06733000
         MVI   DELIMIT,JRPARN           INDICATE LOOKING FOR RIGHT PAR  06734000
         BAL   RTNLNK,OPNDSCAN          GO SCAN OVER EXPRESSION         06735000
         B     DEFALTD1                 BRANCH ON ERROR RETURN          06736000
DC3      CLI   D0(INPTR),JZ             LOOK FOR TYPE CHARACTER HIGH    06737000
         BH    DEFALTD1                 BRANCH IF INVALID TYPE          06738000
         CLI   D0(INPTR),JA             LOOK FOR TYPE CHARACTER LOW     06739000
         BL    DEFALTD1                 BRANCH IF INVALID TYPE          06740000
         IC    RZ,D0(,INPTR)            PICK UP TYPE AS INDEX TO CONTAB 06741000
         IC    RZ,CONTAB-JA(RZ)         PICK UP DISPL IN CONTAB         06742000
         LTR   RZ,RZ                    CHECK FOR ZERO DISPLACEMENT     06743000
         BZ    DEFALTD1                 BRANCH ON INVALID TYPE          06744000
         LA    RZ,CONTAB(RZ)            DEVELOP PTR TO CONSTANT DATA    06745000
         MVC   AWORK(ACHARLMT-AFLAGS+D1),D0(RZ) PUT IN WORK AREA        06746000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06747000
         CLI   D0(INPTR),JL             LOOK FOR LENGTH MODIFIER CHAR   06748000
         BNE   DC7                      BRANCH IF IMPLICIT LENGTH       06749000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06750000
         SET   EXLENFLG,ON              SET EXPLICIT LENGTH FLAG ON     06751000
         CLI   D0(INPTR),JPERIOD        LOOK FOR BIT LENGTH INDICATOR   06752000
         BNE   DC4                      BRANCH IF NOT BIT LENGTH        06753000
         CLI   ATYPEAT,STYPE            LOOK FOR STYPE WITH BIT LENGTH  06754000
         BE    DEFALTD2                 BRANCH IF FOUND                 06755000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06756000
         BAL   RTNLNK,DECBIN            COLLECT BIT LENGTH              06757000
         LTR   RX,RX                    CHECK FOR ZERO BIT LENGTH       06758000
         BZ    DEFALTD2                 BRANCH IF FOUND                 06759000
         LA    RX,D7(,RX)               ROUND BIT LENGTH UP             06760000
         SRL   RX,D3                    DIVIDE BY 8 FOR BYTE LENGTH     06761000
         B     DC6                      BRANCH TO SET LENGTH ATTR       06762000
DC4      CLI   D0(INPTR),J9             LOOK FOR DECIMAL LENGTH MODIF   06763000
         BH    DC8                      BRANCH IF EXPRESSION            06764000
         BAL   RTNLNK,DECBIN            COLLECT LENGTH MODIFIER         06765000
         LTR   RX,RX                    CHECK FOR ZERO LENGTH           06766000
         BZ    DEFALTD2                 BRANCH IF FOUND                 06767000
         CLI   ATYPEAT,STYPE            LOOK FOR S TYPE CONSTANT        06768000
         BNE   DC5                      BRANCH IF NOT FOUND             06769000
         CH    RX,=H'2'                 LOOK FOR EXACT LENGTH OF 2      06770000
         BNE   DEFALTD2                 BRANCH IF NOT FOUND             06771000
DC5      CL    RX,=F'65535'             CHECK FOR HIGH LENGTH LIMIT     06772000
         BH    DEFALTD2                 BRANCH IF EXCEEDED              06773000
         CH    RX,ALENMAX               CHECK IF CONSTANT LENGTH LESS   06774000
         BNH   DC6                      BRANCH ON LENGTH OK             06775000
         GOIF  DSSW,OFF=DEFALTD2        BRANCH IF NOT DS OPERAND        06776000
         GOIF  (CHCON,BXCON),OFF=DEFALTD2 BRANCH IF NOT C,X,B TYPE      06777000
         CLI   ATYPEAT,BTYPE            LOOK FOR B TYPE                 06778000
         BE    DEFALTD2                 BRANCH IF FOUND                 06779000
DC6      STH   RX,ALENGTH               STORE LENGTH                    06780000
         GOIF  (ADCON1,ADCON2,FLCON,FXCON),OFF=DC7                     X06781000
               BRANCH IF NOT A,Y,V,S,Q,D,E,L,F,H TYPE                   06782000
         MVC   ATYPEAT,ATYPALT          INSERT TYPE WITH EXPLICIT LENG  06783000
         GOIF  FLCON,OFF=DC7            BRANCH IF NOT D,E,L TYPE        06784000
         AR    RX,RX                    GET SCALE LIMIT WITH EXPL LENG  06785000
         SH    RX,=H'2'                 ALLOW FOR FIRST CHARACTERISTIC  06786000
         CL    RX,=F'16'                LOOK FOR L-CON, LENGTH OVER 8   06787000
         BNH   DC6A                     BRANCH IF NOT THE CASE          06788000
         SH    RX,=H'2'                 ALLOW FOR SECOND CHARACTERISTIC 06789000
DC6A     EQU   *                                                        06790000
         GOIF  DEFLTL,ON=DC7            KEEP STD SCALE MAX ON DEFAULT   06791000
         STH   RX,ASCAMAX               SET SCALE, (LENGTH-1)*2         06792000
DC7      CLI   D0(INPTR),JS             LOOK FOR SCALE MODIFIER CHAR    06793000
         BNE   DC11                     BRANCH IF NOT FOUND             06794000
         GOIF  (FLCON,FXCON),NONE=DEFALTD3 EXIT IF SCALE NOT ALLOWED    06795000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06796000
         CLI   D0(INPTR),JPLUS          LOOK FOR SCALE SIGN PLUS        06797000
         BE    DC7A                     SIMPLY IGNORE IF FOUND          06798000
         CLI   D0(INPTR),JMINUS         LOOK FOR SCALE SIGN MINUS       06799000
         BNE   DC9                      GO ON IF NO SIGN FOUND          06800000
         GOIF  FXCON,OFF=DEFALTD3       BR IF NEG SCALE ON FLCON        06801000
         SET   NSCALSW,ON               INDICATE SCALE NEGATIVE         06802000
DC7A     LA    INPTR,D1(,INPTR)         BUMP PTR PAST SCALE SIGN        06803000
DC9      CLI   D0(INPTR),J9             LOOK FOR DECIMAL SCALE          06804000
         BH    DEFALTD3                 BR IF NOT DECIMAL               06805000
         BAL   RTNLNK,DECBIN            GO COLLECT SCALE VALUE          06806000
         GOIF  NSCALSW,OFF=DC10         BRANCH IF SCALE POSITIVE        06807000
         LCR   RX,RX                    MAKE SCALE VALUE NEGATIVE       06808000
         CH    RX,=H'-187'              CHECK FOR NEGATIVE LIMIT        06809000
         BL    DEFALTD3                 BR IF EXCEEDED                  06810000
DC10     CH    RX,ASCAMAX               CHECK FOR POSITIVE LIMIT        06811000
         BH    DEFALTD3                 BR IF EXCEEDED                  06812000
         STH   RX,ASCALE                INSERT SCALE ATTRIBUTE          06813000
DC11     CLI   D0(INPTR),JE             LOOK FOR EXPONENT MODIFIER      06814000
         BNE   DC11A                    BRANCH IF NOT FOUND             06815000
         GOIF  (FXCON,FLCON),ANY=DCEXIT, TERMINATE FIXED AND FLOATING  X06816000
               ELSE=DEFALTD2            ERROR FOR ALL OTHER TYPES       06817000
DC11A    CLI   D0(INPTR),JQUOTE         LOOK FOR LEADING QUOTE          06818000
         BNE   DC19                     IF NOT FOUND, MAKE MORE CHECKS  06819000
         GOIF  (FXCON,FLCON),ANY=DCEXIT THRU WITH TYPES F,H,D,E,L       06820000
         GOIF  (ADCON1,ADCON2),ANY=DEFALTD2  ERROR IF TYPES A,S,V,Y,Q   06821000
         GOIF  DCCON,ON=DC13            CONTINUE ON ALL TYPES P,Z       06822000
         GOIF  EXLENFLG,ON=DCEXIT       THRU ON TYPES C,X,B - EXPL LEN  06823000
DC13     SR    RX,RX                    CLEAR LENGTH ACCUMULATOR        06824000
         LR    RY,RX                    CLEAR SCALE ACCUMULATOR         06825000
         LA    INPTR,D1(,INPTR)         BUMP TO FIRST CHARACTER         06826000
DC13A    CLI   D0(INPTR),JQUOTE         LOOK FOR ENDING QUOTE           06827000
         BNE   DC12                     BRANCH IF NOT IT                06828000
         GOIF  CHCON,OFF=DC14           THRU FOR ALL BUT TYPE C         06829000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06830000
         CLI   D0(INPTR),JQUOTE         LOOK FOR PAIRED QUOTE           06831000
         BNE   DC14                     THRU WITH TYPE C IF NOT FOUND   06832000
DC12     CLC   D0(D1,INPTR),ACHARLMT    CHECK FOR CHARACTER IN RANGE    06833000
         BNH   DC15                     BRANCH IF WITHIN RANGE          06834000
         GOIF  BXCON,ON=DEFALTD2        ERROR IF TYPES B,X              06835000
         CLI   D0(INPTR),JPLUS          LOOK FOR INTERNAL PLUS SIGN     06836000
         BE    DC17                     BRANCH IF FOUND                 06837000
         CLI   D0(INPTR),JMINUS         LOOK FOR INTERNAL MINUS SIGN    06838000
         BE    DC17                     BRANCH IF FOUND                 06839000
         CLI   D0(INPTR),JPERIOD        LOOK FOR INTERNAL DECIMAL PT    06840000
         BE    DC18                     BRANCH IF FOUND                 06841000
         CLI   D0(INPTR),JCOMMA         LOOK FOR MULTIPLE CONSTANT DEL  06842000
         BNE   DEFALTD2                 BRANCH IF NOT FOUND             06843000
DC14     STH   RY,ASCALE                INSERT ACCUMULATED SCALE        06844000
         GOIF  EXLENFLG,ON=DCEXIT       THRU IF EXPLICIT LENGTH         06845000
         SR    RY,RY                    CLEAR REGISTER                  06846000
         IC    RY,ARFACT                PICK UP ROUNDING FACTOR         06847000
         AR    RX,RY                    ADD TO ACCUMULATED LENGTH       06848000
         IC    RY,ASFACT                PICK UP SHIFTING FACTOR         06849000
         SRL   RX,D0(RY)                SHIFT TO GET CONSTANT LENGTH    06850000
         LTR   RX,RX                    CHECK FOR LENGTH OF ZERO        06851000
         BNP   DEFALTD2                 BRANCH IF LENGTH ZERO OR NEG    06852000
         CH    RX,ALENMAX               CHECK IF MAXIMUM LEN EXCEEDED   06853000
         BH    DEFALTD2                 BRANCH IF EXCEEDED              06854000
         STH   RX,ALENGTH               INSERT IMPLIED LENGTH           06855000
         B     DCEXIT                   GO COMPLETE ATTRIBUTE INSERTION 06856000
DC15     CLI   D0(INPTR),JAMPER         LOOK FOR AMPERSAND CHARACTER    06857000
         BNE   DC16                     BRANCH IF NOT FOUND             06858000
         CLI   D1(INPTR),JAMPER         LOOK FOR PAIRED AMPERSAND       06859000
         BNE   DEFALTD2                 BRANCH IF NOT FOUND             06860000
         LA    INPTR,D1(,INPTR)         IGNORE FIRST AMPERSAND          06861000
DC16     LA    RX,D1(,RX)               ADD 1 TO ACCUMULATED LENGTH     06862000
         GOIF  DCCON,OFF=DC16A          BRANCH ON ALL BUT TYPES P,Z     06863000
         GOIF  SCALEFLG,OFF=DC16A       BRANCH IF DEC PT NOT YET FOUND  06864000
         LA    RY,D1(,RY)               ADD 1 TO ACCUMULATED SCALE      06865000
DC16A    SET   SIGNFLG,ON               DISALLOW ANY FURTHER SIGNS      06866000
         LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT CHARACTER      06867000
         B     DC13A                    LOOP BACK FOR NEXT CHARACTER    06868000
DC17     GOIF  SIGNFLG,ON=DEFALTD2      BRANCH IF SIGN ALREADY FOUND    06869000
         B     DC16A                    CONTINUE OTHERWISE              06870000
DC18     GOIF  SCALEFLG,ON=DEFALTD2     BRANCH IF DEC PT ALREADY FOUND  06871000
         SET   SCALEFLG,ON              INDICATE DEC PT FOUND           06872000
         B     DC16A                    CONTINUE                        06873000
DC19     CLI   D0(INPTR),JLPARN         LOOK FOR LEF PAREN CHARACTER    06874000
         BNE   DC20                     BRANCH IF NOT FOUND             06875000
         GOIF  (ADCON1,ADCON2),ANY=DCEXIT THRU WITH TYPES A,S,V,Y,Q     06876000
         B     DEFALTD2                 ERROR ON ALL OTHER TYPES        06877000
DC20     CLI   D0(INPTR),JBLANK         LOOK FOR BLANK DELIMITER        06878000
         BE    DC21                     BRANCH IF FOUND                 06879000
         CLI   D0(INPTR),JCOMMA         LOOK FOR COMMA DELIMITER        06880000
         BNE   DEFALTD2                 BRANCH IF NOT FOUND             06881000
DC21     GOIF  DSSW,ON=DCEXIT,ELSE=DEFALTD2 ERROR EXCEPT ON DS STMT     06882000
DC8      CLI   D0(INPTR),JLPARN         LOOK FOR LEADING PARENTHESIS    06883000
         BNE   DEFALTD2                 BRANCH IF NOT FOUND             06884000
         LA    INPTR,D1(,INPTR)         BUMP PAST LEFT PAREN            06885000
         MVI   DELIMIT,JRPARN           INDICATE LOOKING FOR RIGHT PAR  06886000
         BAL   RTNLNK,OPNDSCAN          GO SCAN OVER EXPRESSION         06887000
         B     DEFALTD2                 BRANCH ON ERROR RETURN          06888000
         LH    RX,=H'1'                 SET UP DEFAULT LENGTH OF 1      06889000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENGTH       06890000
         SET   DEFLTL,ON                INDICATE LENGTH DEFAULTED       06891000
         B     DC6                      GO ON WITH DEFAULT LENGTH       06892000
DEFALTD1 MVI   ATYPEAT,JU               SET TYPE TO U                   06893000
DEFALTD2 MVC   ALENGTH,=H'1'            SET LENGTH ATTRIB TO 1          06894000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENGTH       06895000
DEFALTD3 MVC   ASCALE,=H'0'             SET SCALE ATTR TO 0             06896000
         SET   SDEFALT,ON               INDICATE DEFAULTED SCALE        06897000
DCEXIT   MVC   TATTRIB(L'TATTRIB+L'LATTRIB+L'SATTRIB),ATYPEAT          X06898000
               PUT ATTRIBUTES INTO OSRD ENTRY                           06899000
         GOIF  (DCCON,FLCON,FXCON),ANY=CHASER BR IF SCALE ALLOWED       06900000
         SET   SDEFALT,ON               INDICATE DEFAULTED SCALE        06901000
         B     CHASER                   GO SCAN FOR DUPLICATES          06902000
EQUSCAN  EQU   *                                                        06903000
         LH    INPTR,JTOPP              GET START OF RECORD ADDR        06904000
         AR    INPTR,RCDPTR             GET START OF OPERAND ADDR       06905000
         CLI   D0(INPTR),J0             SEE IF OPERAND PRESENT          06906000
         BE    DEFALTA                  BRANCH IF NOT                   06907000
         TM    D0(INPTR),BIT0           LOOK FOR CARD POINTER           06908000
         BNO   ES1                      BRANCH IF NONE FOUND            06909000
         LA    INPTR,D1(,INPTR)         BUMP BY CARD POINTER            06910000
ES1      LA    INPTR,D1(,INPTR)         BUMP PAST COLUMN POINTER        06911000
         SR    ENDPTR,ENDPTR            CLEAR REGISTER FOR END PTR      06912000
         IC    ENDPTR,D0(,INPTR)        PICK UP OPERAND LENGTH          06913000
         AR    ENDPTR,INPTR             DEVELOP PTR TO END OF OPERAND   06914000
         AH    ENDPTR,=H'1'             ADJUST FOR BLANK DELIMITER      06915000
         ST    ENDPTR,ENDCOL            SAVE FOR LATER OPERAND SCAN     06916000
         LA    INPTR,D1(,INPTR)         POINT TO START OF OPERAND       06917000
         MVI   DELIMIT,JCOMMA           INDICATE LOOKING FOR COMMA      06918000
         BAL   RTNLNK,OPNDSCAN          GO SCAN OVER FIRST OPERAND      06919000
         B     DEFALTA                  BRANCH ON ERROR                 06920000
         LA    TYPE,D8                  SET UP FOR CHARACTER SDT        06921000
         L     VALUE,=C'0000'           INITIALIZE VALUE REG FOR CHAR   06922000
         CLI   D0(INPTR),JC             SEE IF IT IS ONE                06923000
         BE    ES8                      BRANCH IF SO                    06924000
         SR    VALUE,VALUE              INITIALIZE VALUE REG FOR X,B,D  06925000
         LA    TYPE,D4                  SET UP FOR HEXADEC SDT          06926000
         CLI   D0(INPTR),JX             SEE IF IT IS ONE                06927000
         BE    ES8                      BRANCH IF SO                    06928000
         LA    TYPE,D1                  SET UP FOR BINARY SDT           06929000
         CLI   D0(INPTR),JB             SEE IF IT IS ONE                06930000
         BE    ES8                      BRANCH IF SO                    06931000
         LA    TYPE,D3                  SET UP FOR DECIMAL SDT          06932000
         CLI   D0(INPTR),J9             SEE IF IT IS ONE                06933000
         BH    ES9                      BRANCH IF NOT                   06934000
         B     ES8A                     GO TO CONVERT IT                06935000
ES8      CLI   D1(INPTR),JQUOTE         LOOK FOR LEADING QUOTE          06936000
         BNE   ES9                      BRANCH IF NOT FOUND             06937000
         LA    INPTR,D2(,INPTR)         BUMP TO START OF CONSTANT       06938000
ES8A     LR    RZ,INPTR                 PRESERVE INPUT PTR              06939000
         LR    R9,INPTR                 POINT TO LEADING CHAR  FX0000   06940000
         BCTR  R9,0                     POINT TO PRECEDING CHARFX0000   06941000
ES8C     LA    R9,D1(,R9)               LOOK FORWARD           FX0000   06942000
         CLI   D0(R9),JF                LOOK FOR HEX NUMBER    FX0000   06943000
         BNH   ES8C                     LESS THAN, KEEP LOOKINGFX0000   06944000
         CLI   D0(R9),JQUOTE            LOOK 4 TRAILING QUOTE  FX0000   06945000
         BE    ES8C                     ARE WE AT THE END?     FX0000   06946000
         CLI   D0(R9),JBLANK            LOOK 4 END OF INST     FX0000   06947000
         BE    ES8E                     YES, MOVE ON           FX0000   06948000
         CLI   D0(R9),JCOMMA            LOOK 4 END OF OPERAND  FX0000   06949000
         BE    ES8E                     YES, MOVE ON           FX0000   06950000
         B     ES9                      ALL DOWN               FX0000   06951000
ES8E     EQU   *                                               @AY19671 06952000
         SET   TRANSW,ON                INDICATE TRANSLATED VALUE REQD  06953000
         BAL   RTNLNK,SDTCONV           LINK TO CONVERT ROUTINE         06954000
         CLI   D0(INPTR),JCOMMA         LOOK FOR COMMA DELIMITER        06955000
         BE    ES2                      BRANCH IF FOUND                 06956000
         CLI   D0(INPTR),JBLANK         LOOK FOR BLANK DELIMITER        06957000
         BE    ES2A                     BRANCH IF FOUND                 06958000
         B     ES3A                     OTHERWISE DEFAULT SITUATION     06959000
ES9      MVI   DELIMIT,JCOMMA           INDICATE LOOKING FOR COMMA      06960000
         BAL   RTNLNK,OPNDSCAN          GO SCAN OVER SECOND OPERAND     06961000
         B     DEFALTA                  BRANCH ON ERROR                 06962000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENGTH       06963000
         B     ES3                      GO SET LENGTH 1                 06964000
ES2      LA    INPTR,D1(,INPTR)         BUMP PTR TO NEXT OPERAND        06965000
ES2A     LTR   COUNT,COUNT              SEE IF VALID VALUE GOTTEN       06966000
         BZ    ES3A                     GO WARN OF LENGTH DEFAULT TO 1  06967000
         CLI   SHIFTAMT,D3              CHECK FOR DECIMAL SDT           06968000
         BNE   ES2B                     BRANCH IF NOT DECIMAL           06969000
         CH    COUNT,=H'10'             CHECK FOR MAX LENGTH DEC SDT    06970000
         BNE   ES2B                     BRANCH IF NOT MAX LENGTH        06971000
         CLC   D0(D10,RZ),=X'00000000000605050305' CHECK FOR UPPER LMT  06972000
         BH    ES3A                     BRANCH IF VALUE OUT OF RANGE    06973000
ES2B     C     VALUE,=F'65535'          CHECK FOR LEGITIMATE VALUE      06974000
         BNH   ES4                      BRANCH IF ACCEPTABLE            06975000
ES3A     LA    WORK2,JDWORD             PT TO NAME FIELD OF EQU         06976000
         LH    WORK1,JHWORD2            SET NAME MOVE LENGTH            06977000
         BAL   RTNLNK,ERLOGERA          LOG ERROR                       06978000
         DC    AL1(SEV65,ERR65)         2ND OPERAND NOT IN RANGE        06979000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENGTH       06980000
ES3      LA    VALUE,D1                 ASSIGN DEFAULT LENGTH OF 1      06981000
ES4      STH   VALUE,JHWORD1            TEMPORARILY SAVE LENGTH         06982000
         MVC   LATTRIB,JHWORD1          INSERT INTO OSRD ENTRY          06983000
         CLI   D0(INPTR),JCOMMA         CHECK IF COMMA DELIMITER        06984000
         BNE   ES4A                     BR IF NOT                       06985000
         LA    INPTR,D1(,INPTR)         BUMP OVER COMMA                 06986000
ES4A     CLI   D0(INPTR),JBLANK         SEE IF THERE IS A THIRD         06987000
         BE    DEFALTB                  BR IF NOT                       06988000
         LA    TYPE,D8                  SET UP FOR CHARACTER SDT        06989000
         SR    VALUE,VALUE              INITIALIZE VALUE REG FOR X,B,D  06990000
         CLI   D0(INPTR),JC             SEE IF IT IS ONE                06991000
         BE    ES5                      BRANCH IF SO                    06992000
         LA    TYPE,D4                  SET UP FOR HEXADEC SDT          06993000
         CLI   D0(INPTR),JX             SEE IF IT IS ONE                06994000
         BE    ES5                      BRANCH IF SO                    06995000
         LA    TYPE,D1                  SET UP FOR BINARY SDT           06996000
         CLI   D0(INPTR),JB             SEE IF IT IS ONE                06997000
         BE    ES5                      BRANCH IF SO                    06998000
         LA    TYPE,D3                  SET UP FOR DECIMAL SDT          06999000
         B     ES6                      GO TO CONVERT IT                07000000
ES5      CLI   D1(INPTR),JQUOTE         LOOK FOR LEADING QUOTE          07001000
         BNE   DEFALTT                  BR IF NOT FOUND                 07002000
         LA    INPTR,D2(,INPTR)         BUMP TO START OF CONSTANT       07003000
ES6      LR    RZ,INPTR                 PRESERVE INPUT PTR              07004000
         SET   TRANSW,ON                INDICATE TRANSLATION            07005000
         BAL   RTNLNK,SDTCONV           LINK TO CONVERT ROUTINE         07006000
         ST    VALUE,JFWORD1            SET UP VALUE FOR TRANSLATE      07007000
         TR    JFWORD1,JTRTABLE         TRANSLATE IT                    07008000
         CLI   D0(INPTR),JBLANK         LOOK FOR BLANK DELIMITER        07009000
         BNE   DEFALTT                  BR IF NOT FOUND                 07010000
         LTR   COUNT,COUNT              SEE IF VALID VALUE GOTTEN       07011000
         BZ    ES7B                     BR IF NOT                       07012000
         CLI   SHIFTAMT,D3              CHECK FOR DECIMAL SDT           07013000
         BNE   ES7                      BRANCH IF NOT DECIMAL           07014000
         CH    COUNT,=H'10'             CHECK FOR MAX LENGTH DEC SDT    07015000
         BNE   ES7                      BRANCH IF NOT MAX LENGTH        07016000
         CLC   D0(D10,RZ),=X'00000000000000020505' CHECK FOR UPPER LMT  07017000
         BH    ES7B                     BRANCH IF VALUE OUT OF RANGE    07018000
ES7      CH    VALUE,=H'255'            CHECK FOR LEGITIMATE VALUE      07019000
         BH    ES7B                     BR IF OUT OF RANGE              07020000
ES7A     L     VALUE,JFWORD1            RESTORE IT TRANSLATED           07021000
         STC   VALUE,TATTRIB            ASSIGN TYPE ATTRIBUTE           07022000
         B     DEFALTC                  GO TO FINISH UP                 07023000
ES7B     LA    WORK2,JDWORD             PT TO NAME FIELD OF EQU         07024000
         LH    WORK1,JHWORD2            SET NAME MOVE LENGTH            07025000
         BAL   RTNLNK,ERLOGERA          LOG ERROR                       07026000
         DC    AL1(SEV66,ERR66)         3RD OPERAND NOT IN RANGE        07027000
DEFALTT  EQU   *                                                        07028000
         SET   TDEFALT,ON               INDICATE DEFAULTED TYPE         07029000
         B     DEFALTB                  GO SET TYPE TO U                07030000
DEFALTA  MVC   LATTRIB,=H'1'            SET DEFAULT LENGTH ATTR         07031000
         SET   LDEFALT,ON               INDICATE DEFAULTED LENDTH       07032000
DEFALTB  MVI   TATTRIB,JU               SET TYPE   ATTRIBUTE TO U       07033000
         B     DEFALTC                  GO ASSIGN SCALE                 07034000
TYPEM    EQU   *                                                        07035000
         MVI   TATTRIB,JM               SET TYPE TO M IN DICT ENTRY     07036000
         B     DLENGTH                  GO ASSIGN DEFAULT LENGTH        07037000
TYPEU1   EQU   *                                                        07038000
         MVI   TATTRIB,JU               SET TYPE TO U IN DICT ENTRY     07039000
         MVC   LATTRIB,=H'0'            ASSIGN DEFAULT LENGTH ATTR      07040000
         B     DEFALTC                  GO ASSIGN SCALE                 07041000
TYPEJ    EQU   *                                                        07042000
         MVI   TATTRIB,JJ               SET TYPE TO J IN DICT ENTRY     07043000
         B     DLENGTH                  GO ASSIGN DEFAULT LENGTH        07044000
TYPET    EQU   *                                                        07045000
         MVI   TATTRIB,JT               SET TYPE TO T IN DICT ENTRY     07046000
         B     DLENGTH                  GO ASSIGN DEFAULT LENGTH        07047000
TYPE$    EQU   *                                                        07048000
         MVI   TATTRIB,JDOLLAR          SET TYPE TO $ IN DICT ENTRY     07049000
         B     DLENGTH                  GO ASSIGN DEFAULT LENGTH        07050000
TYPEW    EQU   *                                                        07051000
         MVI   TATTRIB,JW               SET TYPE TO W IN DICT ENTRY     07052000
         MVC   LATTRIB,=X'0008'         PUT LENGTH ATTR IN ENTRY        07053000
         B     DEFALTC                  GO ASSIGN SCALE                 07054000
TYPEU2   EQU   *                                                        07055000
         MVI   TATTRIB,JA               SET TYPE TO A IN DICT ENTRY     07056000
         MVC   LATTRIB,=X'0004'         PUT LENGTH ATTR IN ENTRY        07057000
         B     DEFALTC                  GO ASSIGN SCALE                 07058000
         EJECT                                                          07059000
OSRDFINI MVC   PIOPARMA,OSRDSTRT        SET UP PTR TO OSRD FOR WRITE    07060000
         MVC   PIOPARMB,SAVOSDLN        SET UP OSRD LENGTH FOR WRITE    07061000
         L     WORK1,OSRDSTRT           GET PTR TO START OF TABLE       07062000
         LR    WORK2,WORK1              USE PTR FOR TABLE END CALCULA   07063000
         A     WORK2,PIOPARMB           GET PTR TO END OF TABLE         07064000
         SR    WORK3,WORK3              CLEAR TABLE INDEX INITIALLY     07065000
OSRDLP1  LA    WORK4,D0(WORK3,WORK1)    GET PTR TO NEXT TABLE ENTRY     07066000
         CLR   WORK4,WORK2              SEE IF ENTIRE TABLE SCANNED     07067000
         BNL   OSRDLP3                  BRANCH IF IT HAS BEEN           07068000
         CLC   D0(D5,WORK4),=5X'FF'     LOOK FOR UNPROCESSED ENTRY      07069000
         BNE   OSRDLP2                  BRANCH IF NOT FOUND             07070000
         MVC   D0(D6,WORK4),=AL1(JU,J0,J1,J0,J0,X'70') SET DEFALTS      07071000
OSRDLP2  LA    WORK3,D6(,WORK3)         BUMP INDEX TO NEXT ENTRY        07072000
         B     OSRDLP1                  GO BACK TO START OF LOOP        07073000
OSRDLP3  EQU   *                                                        07074000
         ST    R3,SAVE3456              SAVE NECESSARY REGISTER         07075000
         LH    R5,JMAXRL2               SET UP MAXIMUM RECORD THIS FILE 07076000
         LA    R6,FILE2                 SET UP FILE POINTER             07077000
         BAL   R7,BUFRITE               GO PUT OSRD TO FILE 2           07078000
         L     R3,SAVE3456              RESTORE CRUCIAL REGISTER        07079000
         MVC   SAVOSDNP(L'JNOTEVAL),JNOTEVAL SAVE N/P IN COMMON         07080000
         B     OPSYNBLD                 GO PROCESS ANY OPSYN ENTRIES    07081000
OSRDCLER MVC   D1(D0,WORK2),D0(WORK2)   EXECUTED MOVE TO CLEAR OSRD     07082000
NAMEMV   MVC   JDWORD(D0),D2(WORK1)     EXECUTED ORD SYMB MOVE          07083000
NAMECM   CLC   JDWORD(D0),OSRTOS        EXECUTED ORD SYMB COMPARE       07084000
MVNAME   MVC   JDWORD(D0),D0(RX)        EXECUTED NAME MOVE              07085000
         DROP  RCDPTR                                                   07086000
         DROP  OSRTBASE                                                 07087000
         DROP  OSRDPTR                                                  07088000
         EJECT                                                          07089000
OPSYNBLD EQU   *                                                        07090000
         JPOINT FILE=FILE3,NEXT=START   REWIND FILE 3                   07091000
         L     WORK1,FREESTRT           GET PTR TO SPACE FOR TABLE BLD  07092000
         ST    WORK1,PIOPARMA           SAVE ALSO FOR I/O ROUTINE       07093000
         SR    WORK2,WORK2              SET TABLE LENGTH TO ZERO        07094000
         MVC   HIBYTE0,OPSCHAIN         PICK UP OPSYN CHAIN POINTER     07095000
BLDLOP   L     WORK3,MDDND              GET PTR TO TABLE BASE           07096000
         S     WORK3,HIBYTE0            DISPLACE TO FIRST ENTRY         07097000
         C     WORK3,MDDND              SEE IF END OF CHAIN REACHED     07098000
         BE    PUTOPSYN                 BRANCH IF YES                   07099000
         USING OPSYNTRY,WORK3                                           07100000
         USING OPSTBL,WORK1                                             07101000
         GOIF  OMAC,ON=BLDOP1           BRANCH IF THIS IS A MACRO       07102000
         MVC   OPSFLGS(OPSTLNT),OPSYNFLG MOVE OPSYN DATA TO NEW ENTRY   07103000
         LA    WORK2,OPSTLNT(,WORK2)    INCREMENT TABLE LENGTH          07104000
         LA    WORK1,OPSTLNT(,WORK1)    INCREMENT TABLE POINTER         07105000
BLDOP1   EQU   *                                                        07106000
         MVC   HIBYTE0+(L'HIBYTE0-L'OPSYNCH)(L'OPSYNCH),OPSYNCH        X07107000
               PICK UP CHAIN PTR FROM ENTRY                             07108000
         B     BLDLOP                   GO BACK TO START OF SEARCH      07109000
PUTOPSYN LTR   WORK2,WORK2              SEE IF ANY TABLE TO PUT         07110000
         BZ    NOOPSYN                  BRANCH IF NOT                   07111000
         ST    WORK2,PIOPARMB           SET UP TABLE LENGTH FOR I/O     07112000
         MVC   SAVOPTLN(L'PIOPARMB),PIOPARMB SAVE ALSO FOR X3N          07113000
         ST    R3,SAVE3456              SAVE CRUCIAL REGISTER           07114000
         LH    R5,JMAXRL2               SET UP MAXIMUM RECORD LENGTH    07115000
         LA    R6,FILE2                 SET UP FILE INDICATOR           07116000
         BAL   R7,BUFRITE               GO TO PUT OPSYN TABLE OUT       07117000
         L     R3,SAVE3456              RESTORE CRUCIAL REGISTER        07118000
         MVC   SAVOPTNP(L'JNOTEVAL),JNOTEVAL SAVE NOTE VALUE FOR X3N    07119000
         B     INTREXIT                 GO EXIT THE PHASE               07120000
NOOPSYN  XC    SAVOPTLN(D4),SAVOPTLN    SET OPSYN TABLE LENGTH TO 0     07121000
         B     INTREXIT                 GO EXIT THE PHASE               07122000
         DROP  WORK3                                                    07123000
         DROP  WORK1                                                    07124000
         EJECT                                                          07125000
*INTREXIT - THIS ROUTINE RELEASES THE WORK SPACE USED BY THE          * 07126000
*   DICTIONARY INTERLUDE PHASE AND TERMINATES THE PHASE.              * 07127000
*                                                                     * 07128000
INTREXIT EQU   *                                                        07129000
         L     WORK3,ERRBLK             GET PTR TO ERROR BUFFER         07130000
         ST    WORK3,PIOPARMA           SET UP I/O AREA START PTR       07131000
         MVC   SAVERRNP(L'JNOTEVAL),D0(WORK3) SAVE LAST ERROR LINK      07132000
         LA    WORK3,D8(,WORK3)         GET PTR TO NEXT ERROR SLOT      07133000
         CL    WORK3,ERBLKPTR           SEE IF ANY ERRORS IN BUFFER     07134000
         BE    IEXIT1                   BRANCH IF NOT                   07135000
         L     WORK3,ERBLKPTR           PICK UP PTR TO NEXT ERROR SLOT  07136000
         MVC   D0(D2,WORK3),=H'0'       INSERT END OF ERRORS FLAG       07137000
         MVC   PIOPARMB,=F'190'         SET UP I/O AREA LENGTH          07138000
         LH    R5,JMAXRL1               SET UP RECORD LENGTH            07139000
         LA    R6,FILE1                 SET UP FILE INDICATOR           07140000
         BAL   R7,BUFRITE               GO TO WRITE BLOCK OF ERRORS     07141000
         MVC   SAVERRNP(L'JNOTEVAL),JNOTEVAL SAVE NEW LAST ERROR LINK   07142000
IEXIT1   EQU   *                                                        07143000
         JNOTE FILE=FILE1               NOTE END OF DICT FILE           07144000
         MVC   SAVOVFPT(L'JNOTEVAL),JNOTEVAL SAVE AS OVERFLOW PTR       07145000
         JFRECORE ADDR=FREESTRT         FREE UP ALL DICT WORK AREA      07146000
INTROUT  JRETURN                        RETURN TO THE DRIVER            07147000
         EJECT                                                          07148000
*                                                                       07149000
* THIS TABLE IS INDEXED INTO USING THE DC/DS TYPE CHARACTER. IF         07150000
*        THE BYTE INDEXED TO IS ZERO, THE TYPE IS INVALID. IF THE       07151000
*        BYTE INDEXED TO IS NON-ZERO, THE BYTE CONTAINS THE DISPLACE-   07152000
*        MENT TO THE TABLE INFORMATION FOR THAT TYPE.                   07153000
*                                                                       07154000
CONTAB   DC    AL1(ACON-CONTAB)         A                               07155000
         DC    AL1(BCON-CONTAB)         B                               07156000
         DC    AL1(CCON-CONTAB)         C                               07157000
         DC    AL1(DCON-CONTAB)         D                               07158000
         DC    AL1(ECON-CONTAB)         E                               07159000
         DC    AL1(FCON-CONTAB)         F                               07160000
         DC    AL1(0)                   G                               07161000
         DC    AL1(HCON-CONTAB)         H                               07162000
         DC    AL1(0)                   I                               07163000
         DC    AL1(0)                   J                               07164000
         DC    AL1(0)                   K                               07165000
         DC    AL1(LCON-CONTAB)         L                               07166000
         DC    AL1(0)                   M                               07167000
         DC    AL1(0)                   N                               07168000
         DC    AL1(0)                   O                               07169000
         DC    AL1(PCON-CONTAB)         P                               07170000
         DC    AL1(QCON-CONTAB)         Q                               07171000
         DC    AL1(0)                   R                               07172000
         DC    AL1(SCON-CONTAB)         S                               07173000
         DC    AL1(0)                   T                               07174000
         DC    AL1(0)                   U                               07175000
         DC    AL1(VCON-CONTAB)         V                               07176000
         DC    AL1(0)                   W                               07177000
         DC    AL1(XCON-CONTAB)         X                               07178000
         DC    AL1(YCON-CONTAB)         Y                               07179000
         DC    AL1(ZCON-CONTAB)         Z                               07180000
*                                                                       07181000
* THIS TABLE CONTAINS THE DATA FOR EACH DC/DS TYPE NECESSARY TO         07182000
*        COLLECT AND VERIFY THE TYPE, LENGTH, AND SCALE ATTRIBUTES.     07183000
*                                                                       07184000
ACON     DC    AL1(128)                 TYPE A  FLAGS                   07185000
         DC    AL1(ATYPE)                       TYPE ATTR               07186000
         DC    AL2(4)                           LENGTH ATTR             07187000
         DC    AL2(0)                           SCALE ATTR              07188000
         DC    AL2(4)                           LENGTH MAXIMUM          07189000
         DC    AL2(0)                           SCALE MAXIMUM           07190000
         DC    AL1(RTYPE)                       ALTERNATE TYPE ATTR     07191000
BCON     DC    AL1(16)                  TYPE B  FLAGS                   07192000
         DC    AL1(BTYPE)                       TYPE ATTR               07193000
         DC    AL2(1)                           LENGTH ATTR     OX00408 07194000
         DC    AL2(0)                           SCALE ATTR              07195000
         DC    AL2(256)                         LENGTH MAXIMUM          07196000
         DC    AL2(0)                           SCALE MAXIMUM           07197000
         DC    AL1(7)                           ROUNDING FACTOR         07198000
         DC    AL1(3)                           SHIFTING FACTOR         07199000
         DC    AL1(1)                           CHARACTER HIGH LIMIT    07200000
CCON     DC    AL1(32)                  TYPE C  FLAGS                   07201000
         DC    AL1(CTYPE)                       TYPE ATTR               07202000
         DC    AL2(1)                           LENGTH ATTR     OX00408 07203000
         DC    AL2(0)                           SCALE ATTR              07204000
         DC    AL2(256)                         LENGTH MAXIMUM          07205000
         DC    AL2(0)                           SCALE MAXIMUM           07206000
         DC    AL1(0)                           ROUNDING FACTOR         07207000
         DC    AL1(0)                           SHIFTING FACTOR         07208000
         DC    AL1(255)                         CHARACTER HIGH LIMIT    07209000
DCON     DC    AL1(4)                   TYPE D  FLAGS                   07210000
         DC    AL1(DTYPE)                       TYPE ATTR               07211000
         DC    AL2(8)                           LENGTH ATTR             07212000
         DC    AL2(0)                           SCALE ATTR              07213000
         DC    AL2(8)                           LENGTH MAXIMUM          07214000
         DC    AL2(14)                          SCALE MAXIMUM           07215000
         DC    AL1(KTYPE)                       ALTERNATE TYPE ATTR     07216000
ECON     DC    AL1(4)                   TYPE E  FLAGS                   07217000
         DC    AL1(ETYPE)                       TYPE ATTR               07218000
         DC    AL2(4)                           LENGTH ATTR             07219000
         DC    AL2(0)                           SCALE ATTR              07220000
         DC    AL2(8)                           LENGTH MAXIMUM          07221000
         DC    AL2(14)                          SCALE MAXIMUM           07222000
         DC    AL1(KTYPE)                       ALTERNATE TYPE ATTR     07223000
FCON     DC    AL1(2)                   TYPE F  FLAGS                   07224000
         DC    AL1(FTYPE)                       TYPE ATTR               07225000
         DC    AL2(4)                           LENGTH ATTR             07226000
         DC    AL2(0)                           SCALE ATTR              07227000
         DC    AL2(8)                           LENGTH MAXIMUM          07228000
         DC    AL2(346)                         SCALE MAXIMUM           07229000
         DC    AL1(GTYPE)                       ALTERNATE TYPE ATTR     07230000
HCON     DC    AL1(2)                   TYPE H  FLAGS                   07231000
         DC    AL1(HTYPE)                       TYPE ATTR               07232000
         DC    AL2(2)                           LENGTH ATTR             07233000
         DC    AL2(0)                           SCALE ATTR              07234000
         DC    AL2(8)                           LENGTH MAXIMUM          07235000
         DC    AL2(346)                         SCALE MAXIMUM           07236000
         DC    AL1(GTYPE)                       ALTERNATE TYPE ATTR     07237000
LCON     DC    AL1(4)                   TYPE L  FLAGS                   07238000
         DC    AL1(LTYPE)                       TYPE ATTR               07239000
         DC    AL2(16)                          LENGTH ATTR             07240000
         DC    AL2(0)                           SCALE ATTR              07241000
         DC    AL2(16)                          LENGTH MAXIMUM          07242000
         DC    AL2(28)                          SCALE MAXIMUM           07243000
         DC    AL1(KTYPE)                       ALTERNATE TYPE ATTR     07244000
PCON     DC    AL1(8)                   TYPE P FLAGS                    07245000
         DC    AL1(PTYPE)                       TYPE ATTR               07246000
         DC    AL2(1)                           LENGTH ATTR     OX00408 07247000
         DC    AL2(0)                           SCALE ATTR              07248000
         DC    AL2(16)                          LENGTH MAXIMUM          07249000
         DC    AL2(31)                          SCALE MAXIMUM           07250000
         DC    AL1(2)                           ROUNDING FACTOR         07251000
         DC    AL1(1)                           SHIFTING FACTOR         07252000
         DC    AL1(9)                           CHARACTER HIGH LIMIT    07253000
QCON     DC    AL1(64)                  TYPE Q FLAGS                    07254000
         DC    AL1(QTYPE)                       TYPE ATTR               07255000
         DC    AL2(4)                           LENGTH ATTR             07256000
         DC    AL2(0)                           SCALE ATTR              07257000
         DC    AL2(4)                           LENGTH MAXIMUM          07258000
         DC    AL2(0)                           SCALE MAXIMUM           07259000
         DC    AL1(RTYPE)                       ALTERNATE TYPE ATTR     07260000
SCON     DC    AL1(128)                 TYPE S  FLAGS                   07261000
         DC    AL1(STYPE)                       TYPE ATTR               07262000
         DC    AL2(2)                           LENGTH ATTR             07263000
         DC    AL2(0)                           SCALE ATTR              07264000
         DC    AL2(2)                           LENGTH MAXIMUM          07265000
         DC    AL2(0)                           SCALE MAXIMUM           07266000
         DC    AL1(RTYPE)                       ALTERNATE TYPE ATTR     07267000
VCON     DC    AL1(128)                 TYPE V  FLAGS                   07268000
         DC    AL1(VTYPE)                       TYPE ATTR               07269000
         DC    AL2(4)                           LENGTH ATTR             07270000
         DC    AL2(0)                           SCALE ATTR              07271000
         DC    AL2(4)                           LENGTH MAXIMUM          07272000
         DC    AL2(0)                           SCALE MAXIMUM           07273000
         DC    AL1(RTYPE)                       ALTERNATE TYPE ATTR     07274000
XCON     DC    AL1(16)                  TYPE X  FLAGS                   07275000
         DC    AL1(XTYPE)                       TYPE ATTR               07276000
         DC    AL2(1)                           LENGTH ATTR     OX00408 07277000
         DC    AL2(0)                           SCALE ATTR              07278000
         DC    AL2(256)                         LENGTH MAXIMUM          07279000
         DC    AL2(0)                           SCALE MAXIMUM           07280000
         DC    AL1(1)                           ROUNDING FACTOR         07281000
         DC    AL1(1)                           SHIFTING FACTOR         07282000
         DC    AL1(15)                          CHARACTER HIGH LIMIT    07283000
YCON     DC    AL1(128)                 TYPE Y  FLAGS                   07284000
         DC    AL1(YTYPE)                       TYPE ATTR               07285000
         DC    AL2(2)                           LENGTH ATTR             07286000
         DC    AL2(0)                           SCALE ATTR              07287000
         DC    AL2(2)                           LENGTH MAXIMUM          07288000
         DC    AL2(0)                           SCALE MAXIMUM           07289000
         DC    AL1(RTYPE)                       ALTERNATE TYPE ATTR     07290000
ZCON     DC    AL1(8)                   TYPE Z  FLAGS                   07291000
         DC    AL1(ZTYPE)                       TYPE ATTR               07292000
         DC    AL2(1)                           LENGTH ATTR     OX00408 07293000
         DC    AL2(0)                           SCALE ATTR              07294000
         DC    AL2(16)                          LENGTH MAXIMUM          07295000
         DC    AL2(16)                          SCALE MAXIMUM           07296000
         DC    AL1(0)                           ROUNDING FACTOR         07297000
         DC    AL1(0)                           SHIFTING FACTOR         07298000
         DC    AL1(9)                           CHARACTER HIGH LIMIT    07299000
         EJECT                                                          07300000
         JPATCH X2A02,A20                                               07301000
         END   INTRENTR                                                 07302000
./ ADD NAME=IFNX3A                                                      07303000
         MACRO                                                          07304000
&NAME    DICTCALL &ENTRY,&POINTER=DICTBASE                              07305000
&NAME    L     R12,&POINTER             SET UP DICT RTN ENTRY ADDR      07306000
         MVI   NDXVAL,&ENTRY            INDICATE ENTRY BEING MADE       07307000
         BALR  R9,R12                   LINK TO DICTIONARY ROUTINE      07308000
         MEND                                                           07309000
         SPACE 3                                                        07310000
         MACRO                                                          07311000
         GENOPS &OP                                                     07312000
         ORG   MOPTABLE+2*JT&OP         ORIGIN TO OP CODES SLOT IN TBL  07313000
         AIF   (K'&SYSLIST(2) EQ 0).STEP2                               07314000
         DC    Y(&SYSLIST(2)-MOPRTNS)   DUMMY ENTRY                     07315000
         MEXIT                                                          07316000
.STEP2   AIF   ('&OP'(1,1) EQ 'M').M                                    07317000
         DC    Y(M&OP-MOPRTNS)          OP CODES ENTRY IN BRANCH TABLE  07318000
         MEXIT                                                          07319000
.M       DC    Y(&OP-MOPRTNS)           OP CODE'S ENTRY IN BRANCH TABLE 07320000
         MEND                                                           07321000
         SPACE 3                                                        07322000
         MACRO                                                          07323000
         OPS   &OP                                                      07324000
         ORG   OPTAB+2*JTM&OP           ORIGIN TO OPERATOR SLOT IN TBL  07325000
         DC    Y(EVAL&OP-EVALOPS)        OPERATOR ENTRY IN BRANCH TABLE 07326000
         SPACE                                                          07327000
         MEND                                                           07328000
         EJECT                                                          07329000
         JHEAD 'XKE MACRO GENERATOR',                                  X07330000
               PHASEID=X3A,                                            X07331000
               LEVEL=10                                                 07332000
*                                                                     * 07333000
*FUNCTION/OPERATION-                                                  * 07334000
*   READS EDITED TEXT FOR MAINLINE CODE AND MACRO DEFINITIONS, WITH   * 07335000
*   THEIR DICTIONARIES, INTERPRETIVELY EXECUTES MACRO LANGUAGE PSEUDO-* 07336000
*   OPS TO PRODUCE LOGICAL SOURCE LANGUAGE FOR INPUT TO THE ASSEMBLY  * 07337000
*   PROCESS.  PERFORMS MACRO EXPANSION AND VARIABLE SYMBOL SUBSTITU-  * 07338000
*   TION.  MAPS TEXT INTO INTERNAL EVALUATION NOTATION FOR ASSEMBLY   * 07339000
*   PROCESS.  OUTPUTS TEXT AND SYMBOL RESOLUTION INFORMATION FOR ASSEM* 07340000
*   BLY PROCESSING.                                                   * 07341000
*                                                                     * 07342000
*ENTRY POINTS-                                                        * 07343000
*        MENTRY--ONLY ENTRY POINT                                     * 07344000
*                                                                     * 07345000
*INPUT-                                                               * 07346000
*        FILE1--EDITED TEXT FOR MAINLINE AND MACRO DEFINITIONS, WITH  * 07347000
*   CORRESPONDING DICTIONARIES.                                       * 07348000
*                                                                     * 07349000
*OUTPUT-                                                              * 07350000
*        FILE2--TEXT POST GENERATION                                  * 07351000
*        FILE3--SYMBOL DEFINITION AND SYMBOL REFERENCE INFORMATION    * 07352000
*                                                                     * 07353000
*EXTERNAL ROUTINES-                                                   * 07354000
*   USES ASSEMBLER SERVICES IN ROOT MODULE.                           * 07355000
*                                                                     * 07356000
*EXITS-                                                               * 07357000
*   NORMAL--JRETURN TO CONTROLLER WITH COMPLETION CODE OF X'00' IN    * 07358000
*   PARAMETER REGISTER R10.                                           * 07359000
*   ERROR--JRETURN TO CONTROLLER WITH COMPLETION CODE OF X'04' IN     * 07360000
*   PARAMETER REGISTER R10.                                           * 07361000
***********ALSO PROVIDE FOR NO TEXT AND NO SYMBOL CONDITIONS*********** 07362000
*                                                                     * 07363000
*TABLES/WORK AREAS-                                                   * 07364000
*        *********************** TO BE DOCUMENTED WHEN DEFINED********* 07365000
*                                                                     * 07366000
*        MOPTABLE--BRANCH TABLE FOR GENERATOR OPERATIONS              * 07367000
         EJECT                                                          07368000
         COPY  JCOMMON                  INCLUDES USING FOR COMMON       07369000
         EJECT                                                          07370000
         COPY  JTEXT                                                    07371000
         EJECT                                                          07372000
MTEXT    DSECT ,                        COPY OF JTEXT FOR OUTPUT        07373000
         SPACE                                                          07374000
MTRLI    DS    H                        RECORD LENGTH                   07375000
MTFLGA   DSW   MPSOP                    FLAGA PSEUDO-OP FLAG            07376000
MTFLGB   DSW   MPRONLY,                 FLAGB PRINT ONLY SWITCH        X07377000
               MERR,                    DEAD STATEMENT                 X07378000
               MNOCNT,                  DON'T COUNT                    X07379000
               MGEN,                    GENERATED                      X07380000
               MNMERR                   INVALID NAME FIELD              07381000
MTIOP    DS    0H                       OP CODE                         07382000
MTIOP1   DS    1X                       1ST BYTE                        07383000
MTIOP2   DS    X                        2ND BYTE                        07384000
MTNMP    DS    H                        NAME POINTER                    07385000
MTOCP    DS    H                        MNEMONIC POINTER                07386000
MTOPP    DS    H                        OPERAND POINTER                 07387000
MTCPR    DS    H                        COMMENTS POINTER                07388000
MTSPR    DS    H                        STRING POINTER                  07389000
MTFLGC   DS    C                        FLAG C                  OX00407 07390000
MTSYMCNT DS    C                        NUMBER OF OPERAND SYMBOLS       07391000
MTHDREND EQU   *                        END OF HEADER                   07392000
MTHDRLN  EQU   MTHDREND-MTEXT           LENGTH OF HEADER                07393000
         SPACE                                                          07394000
MTEXTA   DSECT ,                        VARIABLE PORTION--OUTPUT        07395000
         SPACE                                                          07396000
MTNMO    DSW   ,                        NAME CARD POINTER               07397000
MTNML    DS    C                        NAME LENGTH                     07398000
MTNAME   EQU   *                        NAME                            07399000
         ORG   MTNMO                    BACK TO START FOR RE-MAP        07400000
MTOCO    DSW   ,                        MNEMONIC CARD POINTER           07401000
MTOCL    DS    C                        MNEMONIC LENGTH                 07402000
MTOPCD   EQU   *                        MNEMONIC                        07403000
         ORG   MTNMO                    BACK AGAIN FOR RE-MAP           07404000
MTOPO    DSW   ,                        OPERAND CARD POINTER            07405000
MTOPL    DS    C                        OPERAND LENGTH                  07406000
MTOPND   EQU   *                        OPERAND                         07407000
         ORG   MTNMO                    BACK FOR RE-MAP                 07408000
MTCOP    DS    C                        COMMENT OUTPUT POINTER          07409000
MTCML    DS    C                        COMMENT LENGTH                  07410000
MTCMM    EQU   *                        COMMENT                         07411000
         ORG   MTNMO                    BACK AGAIN                      07412000
MTSTC    DS    C                        STRING COUNT                    07413000
MTSTO    DS    C                        STRING1 POINTER                 07414000
MTSTL    DS    C                        STRING1 LENGTH                  07415000
MTSTR    EQU   *                        STRING1                         07416000
         ORG   MTNMO                    ORG BACK FOR NEXT STRING        07417000
MTSTO2   DS    C                        STRING2 POINTER                 07418000
MTSTL2   DS    C                        STRING2 LENGTH                  07419000
MTSTR2   EQU   *                        STRING2                         07420000
         SPACE 3                                                        07421000
PARMTAB  DSECT ,                        MAP OF PARAMETER TABLE ENTRIES  07422000
         SPACE                                                          07423000
PFLAG    DSW   PSUB,                    SUB-OPERAND (ALL)              X07424000
               PSUBL,                   SUB-OPERAND (LAST)             X07425000
               PSUBF,                   SUB-OPERAND (FIRST)            X07426000
               PPASS,                   PASSED PARAMETER               X07427000
               POMIT,                   OMITTED OPERAND                X07428000
               POS,                     ORDINARY SYMBOL                X07429000
               PSDT,                    SELF-DEFINING TERM             X07430000
               PCHAR                    CHARACTER STRING                07431000
         SPACE                                                          07432000
PCS      EQU   *                        PARAMETER--CHARACTER STRING     07433000
PTAT     DS    C                        TYPE ATTRIBUTE                  07434000
PPAD     DS    4C                       PAD                             07435000
         DS    C                        DEFAULT BITS                    07436000
PKAT     DS    C                        COUNT ATTRIBUTE (LENGTH)        07437000
PSTRING  EQU   *                        STRING START                    07438000
         ORG   PCS                      RE-SET FOR NEXT MAP             07439000
*PSDT    EQU   *                        SELF DEFINING TERM              07440000
         DS    C                        TYPE ATTRIBUTE                  07441000
PVAL     DS    4C                       VALUE                           07442000
         ORG   PCS                      NEXT MAP                        07443000
*POS     EQU   *                        ORDINARY SYMBOL REFERENCE       07444000
         DS    C                        TYPE                            07445000
PLAT     DS    2C                       LENGTH ATTRIBUTE                07446000
PSAT     DS    2C                       SCALE ATTRIBUTE                 07447000
ATTRIB   DSW   TDEFALT,                 TYPE ATTRIBUTE IS DEFAULT VALUEX07448000
               LDEFALT,                 SAME FOR LENGTH                X07449000
               SDEFALT,                 SAME FOR SCALE                 X07450000
               UDEFALT                  UNDEFINED SYMBOL                07451000
         ORG   PCS                      NEXT MAP                        07452000
*POM     EQU   *                        OMITTED--SAME AS PCS            07453000
*PSUB    EQU   *                        SUBLIST HEADER                  07454000
         DS    C                        TYPE                            07455000
PLATSUB  DS    2C                       LENGTH ATTRIBUTE                07456000
PSATSUB  DS    2C                       SCALE ATTRIBUTE                 07457000
         ORG   PLATSUB                  ORIGIN TWO                      07458000
PVALSUB  DS    4C                       VALUE                           07459000
PNAT     DS    2C                       NUMBER ATTRIBUTE--COUNT OF     X07460000
                                          SUBOPERANDS                   07461000
PKATSUB  DS    2C                       TOTAL COUNT OF ALL CHARACTERS  X07462000
                                          LESS DELIMITING COMMAS AND   X07463000
                                          PARENS.                       07464000
PLIST    DS    3C                       VECTOR LIST POINTER.            07465000
         EJECT                                                          07466000
RSYMRCD  DSECT                                                          07467000
         COPY  RSYMRCD                  SYMBOL PHASE RECORD DSECT HERE  07468000
         EJECT                                                          07469000
         COPY  GENCOM                                                   07470000
GENCOMLN EQU   (GENCOM99-GENCOM+7)/8    MODULE COMMON LENGTH IN        X07471000
                                                       DOUBLE WORDS     07472000
         EJECT                                                          07473000
         COPY  JTMTXT                                                   07474000
*                                                                       07475000
*        OP CODE TABLE ENTRY MAP                                        07476000
*                                                                       07477000
         SPACE                                                          07478000
OPNTRY   DSECT                                                          07479000
OCHAIN   DS    XL2                      CHAIN POINTER                   07480000
OFLAGS   DS    X                        FLAGS                           07481000
OMNEM    EQU   *                        MNEMONIC                        07482000
         ORG   OPNTRY                   DUMMY FOR POST VARIABLE FIELD   07483000
OFLAGA   DS    X                        FLAGA                           07484000
OINTCD   DS    X                        INTERNAL OP CODE                07485000
OINTCD2  DS    X                        OP CODE BYTE 2                  07486000
OMASK    EQU   OINTCD2                  ESTENDED MNEMONIC MASK          07487000
         COPY  JERRCD                                                   07488000
ERRMESS  DSECT                                                          07489000
EMSGSVTY DS    C                        ERROR SEVERITY CODE             07490000
EMSGCODE DS    C                        ERROR NUMBER                    07491000
EMSGHL   EQU   *-EMSGSVTY               LENGTH FOR SEVERITY NUMBER      07492000
ENTRYLNG DS    C                        SNAPSHOT/DATA LENGTH            07493000
EMSGNTRY DS    CL8                      SNAPSHOT/DATA                   07494000
*                                                                       07495000
* THIS DSECT MAPS THE OPSYN TABLE ENTRY                                 07496000
*                                                                       07497000
OPSYNTRY DSECT                                                          07498000
OPSYNFLG DSW   ,,,,                     SPACE FOR OPCODE FLAGS         X07499000
               OMAC,                    OPSYN MACRO (NOT USED HERE)    X07500000
               ODEL                     DELETED                         07501000
OPSYNATT DS    XL3                      ATTRIBUTES                      07502000
ONAMEL   DS    XL1                      NAME LENGTH                     07503000
ONAME    DS    XL8                      NAME                            07504000
OPSYND   EQU   *                                                        07505000
         EJECT                                                          07506000
X3000    DSECT                                                          07507000
         SPACE 3                                                        07508000
*EQUATES TO BE USED IN SHIFT-MULTIPLY OPERATIONS                        07509000
         SPACE                                                          07510000
TIMES1   EQU   0                                                        07511000
TIMES2   EQU   1                                                        07512000
TIMES4   EQU   2                                                        07513000
TIMES8   EQU   3                                                        07514000
TIMES16  EQU   4                                                        07515000
TIMES32  EQU   5                                                        07516000
TIMES64  EQU   6                                                        07517000
TIMES128 EQU   7                                                        07518000
TIMES256 EQU   8                                                        07519000
         SPACE 3                                                        07520000
*        REGISTERS                                                      07521000
         SPACE                                                          07522000
INDEX1   EQU   R14                      SCRATCH USED AS TEMPORARY INDEX 07523000
INDEX2   EQU   R15                                                      07524000
RETURN   EQU   R9                       RETURN REGISTER AFTER LINK      07525000
SYMPTR   EQU   R11                      FIXED SYMBOL RECORD BASE        07526000
SYMPTR2  EQU   R4                       VARIABLE SYMBOL RECORD BASE     07527000
FLDPTR   EQU   R2                       MOVEABLE TEXT POINTER--LOCTR    07528000
FLDLN    EQU   R2                       LENGTH REGISTER--EVAL           07529000
RMOVE    EQU   R3                       EXECUTED MOVE REGISTER--KEEP   X07530000
                                          CLEAR.                        07531000
EVEN     EQU   R2                         EVEN--                        07532000
ODD      EQU   R3                             ODD PAIR                  07533000
RCOMP0   EQU   R0                       SCRATCH AS NEEDED               07534000
RCOMPX   EQU   R2                       NON-VOLATILE COMP REG           07535000
STACKPTR EQU   R5                       CURRENT EVAL STACK LEVEL        07536000
INPTR    EQU   R5                       JTEXT INPUT POINTER             07537000
RCOMP1   EQU   R1                       SCRATCH COMPUTATION REGISTER    07538000
RLOCTR   EQU   R6                       LOCATION COUNTER SEGMENT        07539000
VTXTPTR  EQU   R6                       VARIABLE PORTION OF TEXT        07540000
FTXTPTR  EQU   INPTR                    FIXED PORTION OF TEXT           07541000
SYMLEN   EQU   R4                       SYMBOL LENGTH                   07542000
FTXTIN   EQU   R5                                                       07543000
VTXTIN   EQU   R6                                                       07544000
FTXTOUT  EQU   R11                                                      07545000
VTXTOUT  EQU   R4                                                       07546000
HEDRPTR  EQU   FLDPTR                   PARAMETER HEADER                07547000
METAPTR  EQU   VTXTIN                   PARAMETER META TEXT             07548000
         SPACE                                                          07549000
*        LANGUAGE DEPENDENT VALUES                                      07550000
         SPACE                                                          07551000
MAXDEC   EQU   10                       MAXIMUM DIGITS CONVERTIBLE     X07552000
                                          CHARACTER TO BINARY.          07553000
MAXNAME  EQU   8                        MAXIMUM SYMBOL LENGTH           07554000
HIALPHA  EQU   JAT                      LAST ALPHABETIC CHARACTER       07555000
LOALPHA  EQU   JA                       FIRST ALPHABETIC CHARACTER      07556000
HINUM    EQU   J9                                                       07557000
LONUM    EQU   J0                                                       07558000
HIALNUM  EQU   HIALPHA                                                  07559000
LOALNUM  EQU   LONUM                                                    07560000
         SPACE                                                          07561000
*        SYSTEM TO GENERATOR TEXT FILE EQUATES                          07562000
         SPACE                                                          07563000
GTFILE   EQU   FILE2                    GENERATED TEXT FILE             07564000
PMTFILE  EQU   FILE1                    PROGRAMMER MACRO TEXT           07565000
SMTFILE  EQU   FILE1                    SYSTEM MACRO TEXT FILE          07566000
DFILE    EQU   FILE1                    DICTIONARY FILE                 07567000
SDFILE   EQU   FILE3                    SYMBOL DEFINITION FILE          07568000
SRFILE   EQU   FILE3                    SYMBOL REFERENCE FILE           07569000
         SPACE                                                          07570000
*        GENERATOR LIMITING EQUATES--MAY BE CHANGED TO INCREASE NON    X07571000
                                        LANGUAGE DEPENDENT LIMITS.      07572000
         SPACE                                                          07573000
MAXREC   EQU   256                      MAXIMUM RECORD SIZE             07574000
MAXSTRNG EQU   17                       MAXIMUM PRE-BEGIN POST-END SIZE 07575000
MAXSYM   EQU   MAXNAME                  MAXIMUM SYMBOL LENGTH           07576000
MAXCHAR  EQU   255                      MAXIMUM CHARACTER STRING        07577000
MAXGENLN EQU   298                                                      07578000
D256     EQU   256                      MAXIMUM MOVE LENGTH             07579000
D79      EQU   79                       ERR NO BOUNDARY        FX0000   07580000
         SPACE                                                          07581000
*        DICTIONARY ROUTINE ENTRY PARAMETERS                            07582000
         SPACE                                                          07583000
PHASENTR EQU   0                                                        07584000
MACRCALL EQU   2                                                        07585000
CALLEND  EQU   4                                                        07586000
MACRKWRD EQU   6                                                        07587000
MACRPOST EQU   8                                                        07588000
PROTOKWD EQU   10                                                       07589000
PROTOEND EQU   12                                                       07590000
GBLDICTR EQU   14                                                       07591000
GBLDICTS EQU   16                                                       07592000
LCLDICTR EQU   18                                                       07593000
LCLDICTS EQU   20                                                       07594000
PARMTBLR EQU   22                                                       07595000
SEQSYMBR EQU   24                                                       07596000
ORDSYMBR EQU   26                                                       07597000
MACRFINI EQU   28                                                       07598000
         EJECT                                                          07599000
         COPY  JERMSGCD                                                 07600000
         EJECT                                                          07601000
         JCSECT (X3A00)                                                 07602000
* VS1 RELEASE 3 CHANGES                                                 07603000
*A026200,192400-192867                                         @OX00407 07604000
*D192600                                                       @OX00407 07605000
* VS1 RELEASE 3.1 CHANGES                                               07606000
*A532600                                                       @YA03863 07607000
*A531100-531280                                                @OY06599 07608000
*D532600                                                       @OY06599 07609000
*D531100-531280                                                @OX09721 07610000
*A710500                                                       @OX09721 07611000
*A640000-640140                                                @AZ10934 07612000
         JMODID                                                         07613000
         SPACE 3                                                        07614000
MENTRY   JSAVE BASE=YES                                                 07615000
         SPACE                                                          07616000
         JENTRY (X3A01=MENTRY)          ENTRY POINT AS EXTERNAL NAME    07617000
         SPACE 3                                                        07618000
*        INITIALIZE THE GENERATOR                                       07619000
         SPACE                                                          07620000
MINIT    EQU   *                                                        07621000
         SPACE                                                          07622000
         SPACE                                                          07623000
*        GET CORE FOR MODULE COMMON                                     07624000
         SPACE                                                          07625000
         JGETCORE DBL=GENCOMLN                                          07626000
         SPACE                                                          07627000
         LR    R7,R10                   BASE FOR MODULE COMMON SET UP   07628000
         XC    GENCOM(GENSPEND-GENCOM),GENCOM CLEAR TO ZEROS            07629000
         SPACE                                                          07630000
*        PASS CONTROL TO DICTIONARY INITIALIZATION                      07631000
         SPACE                                                          07632000
         DICTCALL   PHASENTR                                            07633000
         SPACE                                                          07634000
*        PERMANENTLY CLEAR A REGISTER                                   07635000
         SPACE                                                          07636000
         SR    RMOVE,RMOVE              LOW BYTE ONLY TO BE USED        07637000
         SPM   RMOVE                    NO INTERRUPTS, PLEASE           07638000
         SPACE                                                          07639000
*        PREPARE EVAL WORK SPACE                                        07640000
         SPACE                                                          07641000
         LA    RCOMP1,ENDSTACK          LOCATE END OF STACK             07642000
         ST    RCOMP1,STACKEND          AND SAVE IT                     07643000
         LA    RCOMP1,STRING1           STRING BUFFER 1                 07644000
         ST    RCOMP1,STRPTR1             AND SAVE IT                   07645000
         LA    RCOMP0,STRING2           MASK FOR                        07646000
         XR    RCOMP0,RCOMP1              FLIPPING TO                   07647000
         ST    RCOMP0,STRPTR2           STRING BUFFER 2 AND BACK.       07648000
         LA    RCOMP0,ERRSTK            GET PTR TO START OF ERROR STK   07649000
         ST    RCOMP0,ESTKNDX           INITIALIZE MOVEABLE STACK PTR   07650000
         SPACE 3                                                        07651000
MINPUT   EQU   *                        INPUT SOURCE                    07652000
         SPACE                                                          07653000
         JGETL FILE=FILE1               GET NEXT INPUT TEXT RECORD      07654000
         SPACE                                                          07655000
         SPACE                                                          07656000
         LR    INPTR,R11                SET UP A BASE FOR               07657000
         USING JTEXT,INPTR                INPUT RECORD AND              07658000
         ST    INPTR,TXTIN              ALSO SAVE IT FOR LATER USE      07659000
         SR    RMOVE,RMOVE              CLEAR A REGISTER FOR LATER      07660000
         SPACE                                                          07661000
         GOIF  INMACRO,OFF=MINPUT12     NOT IN A MACRO, CONTINUE.       07662000
         SET   JGEN,ON                    ELSE INDICATE THAT THIS IS A X07663000
                                          GENERATED STATEMENT.          07664000
         SPACE                                                          07665000
MINPUT12 EQU   *                                                        07666000
         SPACE                                                          07667000
         GOIF  JPRONLY,ON=FLUSH90       ALREADY PRINT ONLY              07668000
         GOIF  INMACDEF,ON=MINPUT35     GO IF WITHIN MACRO DEFINITIONS  07669000
         GOIF  JPSOP,ON=MINPUT20        SEPARATE PSEUDO OPS             07670000
         GOIF  (FLUSH1,FLUSH2,FLUSH3),NONE=MFEVAL                       07671000
         GOIF  FLUSH3,ON=FLUSH05                                        07672000
         GOIF  FLUSH2,ON=FLUSH20                                        07673000
         GOIF  JSYSMAC,ON=FLUSH20       CONTINUE TO PRINT IF SYSMAC     07674000
         B     FLUSH25                  EXIT                            07675000
MINPUT20 GOIF  JTERROR,EQ=FLUSH84       ERROR RECORD                    07676000
         GOIF  JTEOF,EQ=MEXIT10         END OF FILE                     07677000
         GOIF  (FLUSH1,FLUSH2,FLUSH3),NONE=MINPUT22                     07678000
         GOIF  FLUSH1,ON=MINPUT25       BRANCH IF END FOUND             07679000
         GOIF  FLUSH3,ON=FLUSH05        BRANCH IF END TO BE GENERATED   07680000
         GOIF  JTEEOF,NE=FLUSH10                                        07681000
         GOIF  JSYSMAC,OFF=FLUSH25                                      07682000
         B     FLUSH30                                                  07683000
MINPUT22 GOIF  JTEEOF,NE=MINPUT50       BR IF NOT END OF SOURCE INPUT   07684000
FLUSH05  SET   FLUSH3,OFF               RESET                           07685000
         SET   FLUSH1,ON                INDICATE END CARD               07686000
         BAL   R3,DMYENDRT              GENERATE END CARD               07687000
         B     MINPUT12                 PROCESS AGAIN                   07688000
MINPUT25 GOIF  JSYSMAC,OFF=FLUSH25      EXIT IF NOSYSMAC                07689000
         GOIF  JTEEOF,EQ=FLUSH30        PRINT SYSTEM MACROS             07690000
         B     FLUSH10                  PRINT FROM SYSIN                07691000
MINPUT35 GOIF  JPSOP,OFF=FLUSH20        TEST IF PSEUDO OPS              07692000
         GOIF  JTERROR,EQ=FLUSH84       ERROR RECORD                    07693000
         GOIF  JTMEND,NE=FLUSH10        BRANCH IF NOT MEND              07694000
         SET   INMACDEF,OFF             INDICATE END OF DEFINITION      07695000
         B     FLUSH20                  PRINT MEND                      07696000
FLUSH10  GOIF  JTCPKEY,LO=FLUSH20       SIFT OUT THE PARAMETER          07697000
         GOIF  JTPEND,HI=FLUSH20,LO=FLUSH15   RECORDS                   07698000
         GOIF  JERR,OFF=MINPUT          CHECK PARAMETERS END RECORDS    07699000
         L     R1,TXTOUT                FOR ERROR FLAG TRANSFER         07700000
         USING MTEXT,R1                                                 07701000
         SET   MERR,ON                  ERROR FLAG TO LAST RECORD PUT   07702000
         DROP  R1                                                       07703000
         B     MINPUT                   NEXT RECORD                     07704000
FLUSH15  GOIF  JTPROTO,NE=MINPUT        DO NOT PASS THEM                07705000
FLUSH20  SET   JPRONLY,ON               SET PRINT ONLY                  07706000
         BAL   RETURN,PRINT90           PRINT THE RECORD                07707000
         SET   JPRONLY,OFF              CLEAN UP THE PRINT FLAGS        07708000
         B     MINPUT                   NEXT RECORD                     07709000
FLUSH25  LA    INPTR,=AL1(D0,D8,JPSOP,D0,JTEOF,D0) SET UP END OF FILE   07710000
         B     MEXIT10                  EXIT                            07711000
FLUSH30  JPUTM FILE=FILE2,ADDR==AL1(D0,D8,JPSOP,D0,JTSICTL,D0)         X07712000
               PUT OUT SPECIAL RCD FOR ICTL SWITCH FOR X51              07713000
         B     MINPUT                   READ NEXT RECORD                07714000
FLUSH84  EQU   *                                                        07715000
         L     R1,TXTOUT                PICK UP PTR TO LAST RCD PUT     07716000
         USING MTEXT,R1                                                 07717000
         GOIF  MTIOP,JTERROR,EQ=FLUSH85 CONT TOUCH AN ERROR RECORD      07718000
         SET   MERR,ON                  INDICATE ERROR TO BE FLAGGED    07719000
         GOIF  MPSOP,OFF=FLUSH85        BRANCH IF NOT PSEUDO-OP         07720000
         GOIF  MTIOP1,JTANOP,LO=FLUSH85 BRANCH IF NOT A GENERATOR-      07721000
         GOIF  MTIOP1,JTMEND,HI=FLUSH85 PROCESSED PSEUDO-OP             07722000
         L     R1,ACTRCNT               PICK UP CURRENT ACTR VALUE      07723000
         SRL   R1,D1                    HALVE IT ON EDITOR ERROR        07724000
         ST    R1,ACTRCNT               SAVE NEW ACTR VALUE             07725000
         DROP  R1                                                       07726000
FLUSH85  EQU   *                        PASS UNCHANGED                  07727000
         SPACE                                                          07728000
         BAL   RETURN,PRINT90           PRINT A COPY, PLEASE            07729000
         B     MINPUT                   GO BACK FOR ANOTHER ONE         07730000
FLUSH90  GOIF  FLUSH3,ON=FLUSH05        BRANCH IF END TO BE GENERATED   07731000
         GOIF  FLUSH1,OFF=FLUSH85       CHECK IF END STATEMENT FOUND    07732000
         GOIF  JSYSMAC,ON=FLUSH85       CHECK IF SYSMAC OPTION IS ON    07733000
         B     FLUSH25                                                  07734000
MEXIT10  LR    R2,INPTR                 PRESERVE EOF RCD POINTER        07735000
         JFRECORE ADDR=FREESTRT         FREE UP DICTIONARY SPACE        07736000
         JFRECORE ADDR=(R7)             RETURN MODULE COMMON TO SYSTEM  07737000
         SPACE                                                          07738000
         LA    R10,GTFILE               ELSE INDICATE GENERATED TEXT    07739000
         JPUTM FILE=(R10),ADDR=(R2)     AND MOVE EOF RECORD             07740000
         LA    R10,SDFILE               LIKEWISE SYMBOL FILE            07741000
         LA    R11,EOFSD                SYMBOL DEFINITION END-OF-FILE   07742000
         JPUTM FILE=(R10),ADDR=(R11)                                    07743000
         JPOINT FILE=FILE1,NEXT=START   REWIND FILE1                    07744000
         JPOINT FILE=FILE3,NEXT=START   REWIND FILE3                    07745000
         JTRUNC FILE=FILE2              TRUNCATE FILE2  TEXT FILE.  DO X07746000
                                        NOT REPOSITION BECAUSE NEXT    X07747000
                                        PHASE NEEDS END OF FILE.        07748000
MGET99   JRETURN ,                      AND EXIT FROM PHASE             07749000
         SPACE                                                          07750000
EOFSD    DC    H'8',AL1(0,0,JTEOFII,0)  SYMBOL DEFINITION END OF FILE   07751000
DMYENDRT JPUTM FILE=FILE2,ADDR=DUMYEND  PUT OUT DUMMY END STATEMENT     07752000
         ST    R3,GENREGS               PRESERVE RETURN REGISTER        07753000
         ST    R11,TXTOUT               PRESERVE TEXT RECORD POINTER    07754000
         L     R12,=A(X3B01)            SET UP TO CALL S.I. PREPROC.    07755000
         BALR  R9,R12                   CALL SYMBOL INTERLUDE PREPROC.  07756000
         L     INPTR,TXTIN              RESTORE PTR TO LAST TEXT RCD    07757000
         CLI   JMSGL,SEV60              CHECK MSGLEVEL                  07758000
         BH    DONTPUT                  DONT FLAG IF HIGH               07759000
         L     R3,TXTOUT                PUTPUT POINTER                  07760000
         USING MTEXT,R3                                                 07761000
         SET   MERR,ON                  FLAG ERROR                      07762000
         DROP  R3                                                       07763000
         JPUTM FILE=FILE2,ADDR==AL1(D0,D12,JPSOP,JNOCNT,JTERROR,D0,D0,DX07764000
               0,D0,SEV60,ERR60,D0) GENERATE GENERATED END DIAGNOSTIC   07765000
DONTPUT  L     R3,GENREGS               RESTORE RETURN REGISTER         07766000
         BR    R3                       RETURN TO CALLER                07767000
         SPACE                                                          07768000
         SPACE                                                          07769000
MINPUT50 EQU   *                                                        07770000
         SPACE                                                          07771000
         GOIF  HIGENOP,NOTLO=MFEVAL     TOO HIGH FOR GENERATOR OP, GO  X07772000
                                          PERFORM SUBSTITUTION.         07773000
         GOIF  LOGENOP,NOTLO=MLKUP      OK, LOOKUP GENERATOR OP AND    X07774000
                                          PROCESS IT.                   07775000
         GOIF  JTCOPY,LT=MFEVAL         LET ICTL,ISEQ,OPSYN GO THRU     07776000
*              ALL THAT REMAIN ARE ANOP,GBLX,LCLX,COPY                  07777000
         BAL   RETURN,PRINT10           PRINT IF OPTIONS ALLOW          07778000
         B     MINPUT                   GO BACK FOR NEXT RECORD         07779000
         SPACE                                                          07780000
         DROP  INPTR                                                    07781000
         SPACE 3                                                        07782000
MFEVAL   EQU   *                        SEND ALL MACHINE AND ASSEMBLER X07783000
                                        OPS OUT FOR FIELD EVALUATION.   07784000
         L     FTXTIN,TXTIN             GET INPUT TEXT POINTER          07785000
         USING JTEXT,FTXTIN               AND DECLARE AS BASE           07786000
         GOIF  JPSOP,OFF=FEVAL10        LOOK ONLY AT PSEUDO-OPS         07787000
         GOIF  JTHCMNT,NE=FEVAL10       ONLY LOOK AT HIDDEN COMMENTS    07788000
         BAL   RETURN,PRINT30           GO TO PRINT THEM IF REQ'D       07789000
         B     MINPUT                   GO BACK FOR NEXT STATEMENT      07790000
*        GET A WORK BUFFER AND SAVE THE POINTER TO IT                   07791000
         SPACE                                                          07792000
FEVAL10  EQU   *                                                        07793000
         SPACE                                                          07794000
         LA    R10,GTFILE               GENERATED TEXT FILE IS OUTPUT   07795000
         GOIF  (JSUBNAME,               ANY SUBSTITUTION,              X07796000
               JSUBOPCD,                                               X07797000
               JSUBOPND),                                              X07798000
               ANY=FEVAL22                GO PREPARE FOR FIELD EVAL.    07799000
         SPACE                                                          07800000
         BAL   RETURN,PRINT25           PUT OUT PRINT IMAGEIF REQD      07801000
         B     MLOCTR                   RETURN TO DRIVER                07802000
         SPACE                                                          07803000
MOVEOP   MVC   JFWORD1(D0),D0(R12)      EXECUTED MNEMONIC MOVE          07804000
         USING OPNTRY,R14               BASE FOR COMPARE                07805000
OPCOMP   CLC   JFWORD1(D0),OMNEM        REMOTE MNEMONIC COMPARE         07806000
         DROP  R14                                                      07807000
         SPACE 3                                                        07808000
         SPACE 3                                                        07809000
FEVAL22  EQU   *                        GET READY FOR SUBSTITUTION      07810000
         SPACE                                                          07811000
         SET   JPRONLY,ON               PUT PRINT ONLY COPY OF MODEL    07812000
         GOIF  JERR,OFF=NOERR           TEST IF ERROR STATEMENT         07813000
         SET   JERR,OFF                 DO NOT FLAG PRESUBST            07814000
         BAL   RETURN,PRINT10           PRINT IF OPTIONS ALLOW          07815000
         SET JERR,ON                    RESET MASTER COPY               07816000
         B     PRINTOFF                 GO ON                           07817000
NOERR    BAL   RETURN,PRINT10           PRINT PRE-SUBSTITUTION COPY     07818000
PRINTOFF SET   JPRONLY,OFF              CLEAN UP STMT MASTER COPY       07819000
         SPACE                                                          07820000
         SR    R11,R11                  SET UP BASE FOR CALC            07821000
         GOIF  JTCPR,HHDRLN,EQ=FEVAL23 BRANCH IF NO COMMENTS            07822000
         SH    R11,JTCPR                GET DISPL TO COMMENTS START     07823000
         B     FEVAL24                  GO CALC COMMENTS,STRNG LEN      07824000
FEVAL23  GOIF  JTSPR,HHDRLN,EQ=FEVAL25  BRANCH IF NO STRINGS            07825000
         SH    R11,JTSPR                GET DISPL TO STRINGS START      07826000
FEVAL24  AH    R11,JTRLI                CALC LENGTH OF COMMENTS,STRS    07827000
FEVAL25  LA    R11,MAXGENLN(,R11)       CALC LENGTH OF BUFFER NEEDED    07828000
         JPUTL FILE=(R10),BUFREQ=(R11)  REQUEST A BUFFER                07829000
         ST    R11,TXTOUT               AND SAVE ITS ADDRESS            07830000
         USING MTEXT,FTXTOUT              AND SET A BASE FOR IT.        07831000
         SPACE                                                          07832000
         MVC   MTEXT(MTHDRLN),JTEXT     MOVE RECORD HEADER TO OUTPUT    07833000
         SET   MGEN,ON                  INDICATE GENERATED STATEMENT    07834000
         SPACE                                                          07835000
*                             NAME FIELD                                07836000
         SPACE                                                          07837000
FEVAL30  EQU   *                                                        07838000
         LA    VTXTOUT,MTHDRLN          START OF VARIABLE OUTPUT FIELD  07839000
         STH   VTXTOUT,MTNMP            STORE NAME FIELD POINTER        07840000
         LH    VTXTIN,JTNMP             PICK UP NAME POINTER            07841000
         SPACE                                                          07842000
         GOIF  JSUBNAME                 SET CONDITION CODE              07843000
         SPACE                                                          07844000
         SPACE                                                          07845000
FEVAL32  BAL   RETURN,MOVEFLD           MOVE THE FIELD TO OUTPUT        07846000
         GOIF  JSUBNAME,OFF=FEVAL40     NO NAME SUBSTITUTION, SKIP      07847000
         L     R15,GENRTRN              PICK UP POINTER TO NAME LENGTH  07848000
         USING JTOPL,R15                DECLARE AS BASE                 07849000
         IC    RMOVE,JTOPL              PICK UP FIELD LENGTH            07850000
         GOIF  (RMOVE),ZERO=FEVAL40     ZERO LENGTH, SKIP AHEAD         07851000
FEVAL33  EQU   *                                                        07852000
         LR    R14,RMOVE                SET UP LOOP COUNT REGISTER      07853000
FEVAL34  LA    R1,D0(R14,R15)           GET PTR TO NEXT TRAILING CHAR   07854000
         CLI   D0(R1),JBLANK            LOOK FOR TRAILING BLANK         07855000
         BNE   FEVAL35                  BRANCH ON NON-BLANK             07856000
         BCT   R14,FEVAL34              LOOP THRU TRAILING BLANKS       07857000
FEVAL35  STC   R14,JTOPL                SAVE FINAL FIELD LENGTH         07858000
         GOIF  JTOPL,D8,LE=FEVAL40      SEE IF FIELD LENGTH ALRIGHT     07859000
         LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  07860000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          07861000
         DC    AL1(SEV129,ERR129)       ERROR PARAMETERS                07862000
         SET   MNMERR,ON                INDICATE BOGUS NAME             07863000
         MVI   JTOPL,D8                 GIVE BACK ONLY FIRST 8 CHARS    07864000
         SR    VTXTOUT,RMOVE            ADJUST TEXT OUTPUT PTR TO       07865000
         LA    VTXTOUT,D8(,VTXTOUT)     REFLECT TRUNCATED NAME          07866000
         DROP  R15                                                      07867000
         SPACE                                                          07868000
*                             OP CODE FIELD                             07869000
         SPACE                                                          07870000
FEVAL40  EQU   *                                                        07871000
         SPACE                                                          07872000
         LH    VTXTIN,JTOCP             PICK UP INPUT DISPLACEMENT      07873000
         STH   VTXTOUT,MTOCP            STORE OUTPUT DISPLACEMENT       07874000
         SPACE                                                          07875000
         GOIF  JSUBOPCD                 SET CONDITION CODE              07876000
         SPACE                                                          07877000
         SPACE                                                          07878000
FEVAL42  BAL   RETURN,MOVEFLD           MOVE THE FIELD TO OUTPUT        07879000
         GOIF  JSUBOPCD,OFF=FEVAL50     NO OP CODE SUBSTITUTION, SKIP.  07880000
         L     R15,GENRTRN              POINT TO MNEMONIC LENGTH AND    07881000
         USING JTOPL,R15                DECLARE AS BASE.                07882000
         IC    RMOVE,JTOPL              PICK UP OP CODE LENGTH          07883000
         CH    RMOVE,=H'8'              CHECK FOR VALID FIELD LENGTH    07884000
         BH    LOGER128                 BRANCH IF TOO MANY CHARACTERS   07885000
         GOIF  (RMOVE),ZERO=LOGER102    BRANCH IF NULL SUBSTITUTION     07886000
         XC    JFWORD1(L'JFWORD1+L'JFWORD2),JFWORD1 CLEAR NAME BUFFER   07887000
         LA    R1,JTOPND                SET UP STRING START PTR         07888000
         AR    R15,RMOVE                SET UP STRING END PTR           07889000
         LA    R14,D1                   SET UP BXLE INCREMENT           07890000
FEVAL43  CLI   D0(R1),JBLANK            LOOK FOR LEADING BLANK          07891000
         LR    R12,R1                   SAVE PTR IN CASE NON-BLANK      07892000
         BNE   FEVAL45                  BRANCH IF NON-BLANK             07893000
         BXLE  R1,R14,FEVAL43           LOOP THRU LEADING BLANKS        07894000
LOGER102 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  07895000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          07896000
         DC    AL1(SEV102,ERR102)       ERROR PARAMETERS                07897000
         B     FEVAL49                  GO FLAG STMT AS BAD             07898000
LOGER128 EQU   *                                                        07899000
         LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  07900000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          07901000
         DC    AL1(SEV128,ERR128)       ERROR PARAMETERS                07902000
         SET   MPRONLY,ON               INDICATE NO HOPE FOR THIS STMT  07903000
         L     R15,GENRTRN              RESTORE STARTING POINTER        07904000
         MVI   JTOPL,D8                 GIVE BACK ONLY FIRST 8 CHARS    07905000
         SR    VTXTOUT,RMOVE            ADJUST TEXT OUTPUT PTR TO       07906000
         LA    VTXTOUT,D8(,VTXTOUT)     REFLECT TRUNCATED OP CODE       07907000
         B     FEVAL50                  CONTINUE WITH OPERAND           07908000
         DROP  R15                                                      07909000
FEVAL46A CLI   D0(R1),JBLANK            LOOK FOR MORE TRAILING BLANKS   07910000
         BNE   LOGER101                 BRANCH IF NON-BLANK FOUND       07911000
FEVAL46B BXLE  R1,R14,FEVAL46A          LOOP THRU BLANK CHARACTERS      07912000
         LR    R1,R0                    RESTORE END POINTER             07913000
         B     FEVAL46                  GO HANDLE GOOD OP CODE          07914000
FEVAL44  CLI   D0(R1),JBLANK            LOOK FOR FIRST TRAILING BLANK   07915000
         LR    R0,R1                    PRESERVE END POINTER            07916000
         BE    FEVAL46B                 BRANCH IF FOUND                 07917000
FEVAL45  BXLE  R1,R14,FEVAL44           LOOP THRU NON-BLANK CHARS       07918000
FEVAL46  SR    R1,R12                   GET LENGTH OF NON-BLANK STRING  07919000
         STC   R1,JFWORD1-D1            SET UP LENGTH FOR OPSYN SCAN    07920000
         BCTR  R1,D0                    GET MOVE LENGTH OF OP CODE      07921000
         EX    R1,MOVEOP                INSERT OP CODE IN WORK AREA     07922000
         CLC   OPSNSTRT,=F'0'           SEE IF ANY OPSYN TABLE          07923000
         BZ    OPSC5                    BYPASS OPSYN LOOK UP IF NOT     07924000
OPSC1    L     R14,OPSNSTRT             POINT TO START OF TABLE         07925000
OPSC3    C     R14,GDSTRT               CHECK FOR END OF TABLE POINT    07926000
         BNL   OPSC5                    BRANCH IF ALL ENTRIES SCANNED   07927000
         USING OPSYNTRY,R14                                             07928000
         CLC   ONAMEL(L'ONAMEL+L'ONAME),JFWORD1-D1 LOOK FOR THE NAME    07929000
         BE    OPSC4                    BRANCH IF OPSYN FOUND           07930000
         LA    R14,OPSYND-OPSYNTRY(,R14) ADJUST PTR TO NEXT ENTRY       07931000
         B     OPSC3                    GO BACK FOR MORE SEARCHING      07932000
OPSC4    GOIF  ODEL,ON=LOGER102         DELETED OP CODE                 07933000
         LA    R14,OPSYNATT             POINT TO FLAGA AND INTERNAL OPS 07934000
         B     FEVAL46C                 SKIP AHEAD                      07935000
OPSC5    EQU   *                                                        07936000
         L     R15,JFWORD1              ADD TWO HALVES OF MNEMONIC      07937000
         AL    R15,JFWORD2              TO DEVELOP HASH VALUE           07938000
         SR    R14,R14                                                  07939000
         D     R14,=F'71'                 POINTER BY DIVIDING RESULT.   07940000
         AR    R14,R14                  DOUBLE REMAINDER AND            07941000
         A     R14,=A(OPBASE)             ADD IN OP CODE TABLE BASE.    07942000
         JEXTRN (X3K01=OPBASE)          DECLARE EXTERNAL                07943000
         USING OPNTRY,R14               R14 NOW IS BASE FOR OPTAB ENTRY 07944000
OPLOOP   CLC   OCHAIN,=F'0'             SEE IF SUBSTITUTED OP LEGAL     07945000
         BZ    LOGER101                 BRANCH IF NOT EVEN FOUND        07946000
         MVC   JHWORD1,OCHAIN           ALIGN CHAIN POINTER AND         07947000
         LH    R14,JHWORD1                                              07948000
         A     R14,=A(OPBASE)           ADD IN TABLE BASE (NEXT ENTRY)  07949000
         IC    RMOVE,OFLAGS             GET LENGTH OF MNEMONIC FROM     07950000
         N     RMOVE,=A(D7)             OP CODE TABLE ENTRY FLAGS       07951000
         GOIF  (R1),(RMOVE),NE=OPLOOP   NOT EQUAL TO INPUT, LOOP.       07952000
         EX    RMOVE,OPCOMP             ELSE COMPARE MNEMONIC ITSELF.   07953000
         BNE   OPLOOP                   NOT EQUAL, LOOP.                07954000
         LA    R14,D4(RMOVE,R14)        POINT TO FLAGA ENTRY            07955000
FEVAL46C EQU   *                                                        07956000
         MVC   MTFLGA,OFLAGA            FOUND IT--MOVE FLAGA            07957000
         MVC   MTIOP,OINTCD               AND INTERNAL OP TO TEXT.      07958000
         GOIF  MPSOP,ON=FEVAL47         BRANCH IF PSEUDO-OP             07959000
         TM    MTFLGA,BIT0+BIT1         CHECK TYPE OF MACHINE OP        07960000
         BNZ   FEVAL48                  BRANCH IF TWO BYTE OP CODE      07961000
FEVAL47  MVI   MTIOP2,J0                CLEAR 2ND BYTE FOR ALL OTHERS   07962000
FEVAL48  EQU   *                                                        07963000
         B     FEVAL50                  CONTINUE AT OPERAND             07964000
         DROP  R14                                                      07965000
         SPACE                                                          07966000
LOGER101 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  07967000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          07968000
         DC    AL1(SEV101,ERR101)       ERROR PARAMETERS                07969000
FEVAL49  SET   MPRONLY,ON               FLAG STMT AS BAD AND CONTINUE   07970000
         SPACE                                                          07971000
*                             OPERAND FIELD                             07972000
         SPACE                                                          07973000
FEVAL50  EQU   *                                                        07974000
         SPACE                                                          07975000
         LH    VTXTIN,JTOPP             OPERAND DISPLACEMENT INPUT      07976000
         STH   VTXTOUT,MTOPP            STORE OUTPUT                    07977000
         GOIF  JSUBOPND                 SET CONDITION CODE              07978000
         SPACE                                                          07979000
         SPACE                                                          07980000
FEVAL52  BAL   RETURN,MOVEFLD           MOVE THE FIELD TO OUTPUT        07981000
         L     R15,GENRTRN              POINT TO MNEM LENGTH    OX00407 07982000
         USING JTOPL,R15                AND DECLARE AS BASE     OX00407 07983000
         IC    RMOVE,JTOPL              PICK UP OPERAND LENGTH  OX00407 07984000
         LA    R1,JTOPND                SET UP START POINTER    OX00407 07985000
         AR    R15,RMOVE                SET UP END POINTER      OX00407 07986000
         SR    R3,R3                    CLEAR COUNTER           OX00407 07987000
         LA    R14,D1                   SET UP BXLE INCREMENT   OX00407 07988000
FEVAL53  CLI   D0(R1),JBLANK            LOOK FOR LEADING BLANK  OX00407 07989000
         BNE   FEVAL55                  BRANCH IF NON-BLANK     OX00407 07990000
         LA    R3,D1(R3)                COUNT BLANKS            OX00407 07991000
         BXLE  R1,R14,FEVAL53           LOOP THRU LEADING BLNKS OX00407 07992000
         B     FEVAL56                  ONLY BLANKS IN OPERAND  OX00407 07993000
FEVAL55  L     R15,GENRTRN              POINT TO CARD POINTER   OX00407 07994000
         BCTR  R15,R0                   FOR OPERAND             OX00407 07995000
         USING MTOCO,R15                AND USE AS BASE         OX00407 07996000
         IC    R1,MTOPO                 UPDATE OPERAND CARD     OX00407 07997000
         AR    R1,R3                    POINTER BY LEAVING OUT  OX00407 07998000
         STC   R1,MTOPO                 LEADING BLANKS          OX00407 07999000
         IC    R1,MTOPL                 UPDATE OPERAND LENGTH   OX00407 08000000
         SR    R1,R3                    BY DELETING             OX00407 08001000
         STC   R1,MTOPL                 LEADING BLANKS          OX00407 08002000
         L     R15,GENRTRN              POINT TO MNEMONIC AGAIN OX00407 08003000
         USING JTOPL,R15                AND DECLARE AS BASE     OX00407 08004000
         LA    R1,JTOPND                SET UP STRING POINTER   OX00407 08005000
         SR    R14,R14                  CLEAR REG FOR LENGTH    OX00407 08006000
         IC    R14,JTOPL                INSERT OPERAND LENGTH   OX00407 08007000
         SR    R14,R3                   CALC NEW OPERAND LENGTH OX00407 08008000
         SR    VTXTOUT,R3               STEP BACK IF BLANKS     OX00407 08009000
         LA    R3,D0(R1,R3)             SET UP STRING POINTER   OX00407 08010000
         EX    R14,MOVEOPND             GET RID OF BLANKS       OX00407 08011000
         SR    RMOVE,RMOVE              CLEAR FOR MOVEFLD       OX00407 08012000
         B     FEVAL56                  BRANCH OVER MOVE        OX00407 08013000
         DROP  R15                                              OX00407 08014000
MOVEOPND MVC   D0(D0,R1),D0(R3)         GET RID OF BLANKS       OX00407 08015000
         SPACE 2                                                OX00407 08016000
FEVAL56  AR    VTXTOUT,FTXTOUT          GET PTR TO OPERAND END  OX00407 08017000
         MVI   D0(VTXTOUT),JBLANK       SUPPLY TRAILING BLANK           08018000
         LA    VTXTOUT,D1(,VTXTOUT)     ADJUST OUTPUT POINTER           08019000
         SR    VTXTOUT,FTXTOUT          RE-CALC NEXT FIELD DISPLACEM'T  08020000
         SPACE                                                          08021000
*                             COMMENTS AND STRINGS                      08022000
         SPACE                                                          08023000
FEVAL60  EQU   *                                                        08024000
         SPACE                                                          08025000
         STH   VTXTOUT,MTCPR            COMMENT OUTPUT POINTER TO TEXT  08026000
         LH    VTXTIN,JTCPR             PICK UP COMMENT DISPLACEMENT    08027000
         BAL   RETURN,MOVEFLD           MVOE THE FIELD                  08028000
         SPACE                                                          08029000
*        STRINGS                                                        08030000
         SPACE                                                          08031000
         STH   VTXTOUT,MTSPR            STORE STRING POINTER--OUTPUT    08032000
         LH    VTXTIN,JTSPR             PICK UP POINTER--INPUT          08033000
         GOIF  JTSPR,HHDRLN,NE=FEVAL63  STRING POINTER POINTS TO END OFX08034000
                                          TEXT HEADER (NULL), BRANCH.   08035000
         LA    RCOMP1,L'JTSTC           JUST MOVE STRING COUNT          08036000
         B     FEVAL64                  AND SKIP AHEAD                  08037000
         SPACE                                                          08038000
FEVAL63  EQU   *                                                        08039000
         SPACE                                                          08040000
         LH    RCOMP1,JTRLI             LENGTH OF REMAINDER OF RECORD   08041000
         SR    RCOMP1,VTXTIN              IS LENGTH MINUS DISPLACEMENT  08042000
         BCTR  RCOMP1,D0                  OF STRINGS MINUS ONE          08043000
FEVAL64  AR    VTXTIN,FTXTIN            ABSOLUTE INPUT ADDRESS          08044000
         AR    VTXTOUT,FTXTOUT          ACTUAL OUTPUT ADDRESS           08045000
         EX    RCOMP1,MVCFLD10          MOVE THE REST OF THE RECORD     08046000
         SPACE                                                          08047000
FEVAL90  EQU   *                                                        08048000
         SPACE                                                          08049000
         LA    VTXTOUT,D1(RCOMP1,VTXTOUT) COMPUTE TOTAL RECORD LENGTH   08050000
         SR    VTXTOUT,FTXTOUT            AND STORE IN OUTPUT           08051000
         STH   VTXTOUT,MTRLI                                            08052000
         SPACE 3                                                        08053000
*        SYMBOL PROCESSING FOR ASSEMBLY PHASES                          08054000
         DROP  FTXTIN                                                   08055000
         SPACE                                                          08056000
MLOCTR   EQU   *                                                        08057000
         USING JTEXT,FTXTOUT                                            08058000
         GOIF  JPRONLY,ON=ERRDUMP       IGNORE ALL PRINT-ONLY STMTS     08059000
         GOIF  JPSOP,OFF=MLOCTR10       SKIP IF NOT PSEUDO-OP           08060000
         GOIF  JTIOP,JTCALL,EQ=MINPUT   GO NO FURTHER ON MACRO CALL     08061000
         GOIF  JTIOP,JTEND,NE=MLOCTR05  IF NOT SUBSTITUTED END, SKIP    08062000
         L     RCOMPX,MACROLVL          GET MACRO NEST COUNT            08063000
         GOIF  (RCOMPX),NOTPOS=MLOCTR02 BRANCH IF NO POP NECESSARY      08064000
         ST    FTXTOUT,GENREGS          PRESERVE OUTPUT TEXT POINTER    08065000
         SET   GENEND,ON                INDICATE END FROM INSIDE MACRO  08066000
MLOCTR01 EQU   *                                                        08067000
         DICTCALL MACRFINI              POP ONE LEVEL OF MACRO NEST     08068000
         BCT   RCOMPX,MLOCTR01          DECREMENT NEST COUNT            08069000
         L     FTXTOUT,GENREGS          RESTORE TEXT POINTER            08070000
MLOCTR02 EQU   *                                                        08071000
         SET   INMACRO,OFF              INDICATE OUT OF MACRO NEST      08072000
         SET   FLUSH1,ON                INDICATE TEXT TO BE FLUSHED     08073000
         B     MLOCTR10                 PROCEED                         08074000
MLOCTR05 EQU   *                                                        08075000
         GOIF  JTIOP,JTTITLE,NE=MLOCTR10 SEE IF PSEUDO-OP IS TITLE      08076000
         LH    EVEN,JTNMP               IF SO, GET NAME FIELD DISPL     08077000
         AR    EVEN,FTXTOUT             DEVELOP PTR TO NAME FIELD       08078000
         USING JTNMO,EVEN                                               08079000
         SR    ODD,ODD                  CLEAR LENGTH REGISTER           08080000
         IC    ODD,JTNML                PICK UP NAME LENGTH             08081000
         GOIF  (ODD),ZERO=ERRDUMP       SEE IF NAME IS PRESENT          08082000
         GOIF  JTNML,D8,HI=LOGER125     BRANCH IF NAME TOO LONG         08083000
         LA    R1,JTNAME(ODD)           GET PTR PAST END OF NAME FIELD  08084000
         BCTR  R1,D0                    POINT TO LAST CHARACTER         08085000
         BCT   ODD,TITLE200             CHECK IF LENGTH IS ONE          08086000
         B     TITLE300                 STRING IS ONE CHARACTER         08087000
TITLE100 BCTR  R1,D0                    NEXT CHARACTER                  08088000
TITLE200 CLI   D0(R1),JAT               CHECK IF ALPHANUMERIC           08089000
         BH    LOGER125                 ERROR IF NOT                    08090000
         BCT   ODD,TITLE100             CHECK NEXT                      08091000
         BCTR  R1,D0                    R1 NOW POINTS TO FIRST CHAR     08092000
         CLI   D0(R1),JPERIOD           CHECK IF SEQUENCE SYMBOL        08093000
         BE    TITLE400                 MAY BE SEQUENCE SYMBOL          08094000
TITLE300 CLI   D0(R1),JAT               MUST BE ALPHANUMERIC            08095000
         BH    LOGER125                 ERROR IF NOT                    08096000
         GOIF  FRSTTITL,ON=LOGER104     BRANCH IF NAMED TITLE NOT FIRST 08097000
         IC    ODD,JTNML                LENGTH OF NAME FIELD            08098000
         EX    ODD,TITLEMOV             MOVE DECK ID                    08099000
         SET   FRSTTITL,ON              INDICATE TITLE FOUND            08100000
         B     ERRDUMP                  GET NEXT RECORD                 08101000
TITLE400 CLI   D1(R1),JA                CHECK IF 2ND CHAR ALPHA         08102000
         BL    LOGER125                 ERROR IF NOT                    08103000
         B     MLOCTR11                 NAME FIELD IS SEQUENCE SYMBOL   08104000
LOGER104 LA    R12,LOGERR01             GET PTR TO ERROR ROUTINE        08105000
         BALR  R9,R12                   GO TO LOG THE ERROR             08106000
         DC    AL1(SEV104,ERR104)       ERROR PARAMETERS                08107000
         B     ERRDUMP                  GO TO FINISH UP STATEMENT       08108000
MLOCTR10 GOIF  JNMERR,ON=MLOCTR40       SKIP IF NAME ALREADY BAD        08109000
         LH    EVEN,JTNMP               IF NOT, GET NAME FIELD DISPL    08110000
         AR    EVEN,FTXTOUT             DEVELOP PTR TO NAME FIELD       08111000
         GOIF  JTNML,D0,EQ=MLOCTR30     BRANCH IF NAME NOT PRESENT      08112000
         GOIF  JTNAME,JPERIOD,NE=MLOCTR20 SEE IF NAME IS SEQ SYMBOL     08113000
MLOCTR11 EQU   *                                                        08114000
         GOIF  GENEND,ON=MLOCTR12       BRANCH IF END FROM MACRO        08115000
         GOIF  INMACRO,OFF=MLOCTR15     BRANCH IF IN OPEN CODE          08116000
MLOCTR12 EQU   *                                                        08117000
         GOIF  JMLOGIC,ON=MLOCTR40,     BRANCH IF SEQ SYMB NOT         X08118000
               ELSE=MLOCTR16            TO BE SUPPRESSED                08119000
MLOCTR15 GOIF  JALOGIC,ON=MLOCTR40      BRANCH IF SEQ SYMB NOT SUPRESD  08120000
MLOCTR16 EQU   *                                                        08121000
         MVI   JTNML,D0                 INDICATE NO NAME                08122000
         B     MLOCTR40                 PROCEED AS IF NO NAME           08123000
MLOCTR20 GOIF  JDEF,ON=MLOCTR25         CHECK IF NAME ALLOWED           08124000
         GOIF  JTIOP,JTOPSYN,EQ=MLOCTR25                                08125000
         LA    R12,LOGERR01             ILLEGAL NAME FIELD              08126000
         BALR  R9,R12                   LOG ERROR                       08127000
         DC    AL1(SEV16,ERR16)                                         08128000
         SET   JNMERR,ON                INDICATE INVALID NAME FIELD     08129000
MLOCTR25 GOIF  JTNML,D8,HI=LOGER125     BRANCH IF NAME TOO LONG         08130000
         SR    ODD,ODD                  CLEAR LENGTH REGISTER           08131000
         IC    ODD,JTNML                PICK UP NAME LENGTH             08132000
         LA    R1,JTNAME(ODD)           GET POINTER PAST NAME FIELD     08133000
MLOCTR27 BCTR  R1,D0                    BACK UP TO NEXT CHARACTER       08134000
         CLI   D0(R1),JAT               CHECK FOR NAME VALIDITY         08135000
         BH    LOGER125                 BRANCH IF OUT OF RANGE          08136000
         BCT   ODD,MLOCTR27             BRANCH UNTIL ALL CHARS CHECKED  08137000
         CLI   D0(R1),J9                CHECK FIRST CHAR FOR ALPHA ONLY 08138000
         BH    MLOCTR30                 BRANCH IF ALL CRITERIA MET      08139000
LOGER125 EQU   *                                                        08140000
         LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08141000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08142000
         DC    AL1(SEV125,ERR125)       ERROR PARAMETERS                08143000
         SET   JNMERR,ON                INDICATE BAD NAME               08144000
         B     MLOCTR40                 GO ON                           08145000
TITLEMOV MVC   JDECKIDL(D0),JTNML       EXECUTED DECK ID MOVE           08146000
SYSMOVE  MVC   SYSECT(D0),JTNML         EXECUTED SYSECT MOVE            08147000
MLOCTR30 GOIF  JPSOP,OFF=MLOCTR40       LOOK AT PSEUDO-OPS ONLY         08148000
         GOIF  JTIOP,JTCOM,GT=MLOCTR40  LOOK FOR PSEUDO-OPS CSECT,      08149000
         GOIF  JTIOP,JTSTART,LT=MLOCTR40 DSECT, START, AND COM          08150000
         IC    ODD,JTNML                PICK UP NAME LENGTH             08151000
         EX    ODD,SYSMOVE              ASSIGN NAME TO SYSECT           08152000
MLOCTR40 EQU   *                                                        08153000
         DROP  EVEN                                                     08154000
MLOCTR60 L     R12,=A(X3B01)            GET PTR TO SYMBOL PROCESSOR     08155000
         JEXTRN (X3B01=X3B01)                                           08156000
         BALR  R9,R12                   LINK TO SYMBOL INTER PREPROCESS 08157000
         DROP  R11                                                      08158000
         SPACE                                                          08159000
* PUT OUT ANY ERROR MESSAGES LOGGED AGAINST THE RECORD JUST             08160000
*        PROCESSED                                                      08161000
         SPACE                                                          08162000
ERRDUMP  EQU   *                                                        08163000
         LH    R3,ERRCNT                PICK UP ERROR COUNT             08164000
         LTR   R3,R3                    SEE IF ANY MESSAGES LOGGED      08165000
         BZ    MINPUT                   GO GET NEXT RECORD IF NOT       08166000
         L     R2,TXTOUT                GET PTR TO OUTPUT RECORD        08167000
         USING JTEXT,R2                                                 08168000
         SET   JERR,ON                  INDICATE ERROR FLAG FOR THIS    08169000
         DROP  R2                                                       08170000
         LCR   R6,R3                    GET NUMBER OF ERRORS - NEG      08171000
         AH    R6,=H'5'                 ADD MAX LOGGED ERRORS           08172000
         LTR   R6,R6                    SEE IF NUMBER LT OR EQ MAX      08173000
         BNM   ERRDUMP1                 BRANCH IF SO                    08174000
         MVC   ERRCNT,=H'2'             INSURE OK ERROR COUNT           08175000
         LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08176000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08177000
         DC    AL1(SEV126,ERR126)       ERROR PARAMETERS                08178000
         LA    R3,D6                    SET NUMBER OF ERROR LOGGED      08179000
ERRDUMP1 LA    R4,ERRSTK                GET PTR TO START OF ERROR STK   08180000
         ST    R4,ESTKNDX               REINPTIALIZE MOVEABLE STK PTR   08181000
ERRDUMP2 SR    R5,R5                    CLEAR LENGTH REGISTER           08182000
         USING ERRMESS,R4                                               08183000
         JPUTL FILE=FILE2,BUFREQ=D20   GET BUFFER FOR ERROR RECORD      08184000
         USING JERRCD,R11                                               08185000
         MVC   JERECL(D9),=AL1(D0,D20,JPSOP,JNOCNT,JTERROR,D0,D0,D0,D0)X08186000
                INSERT RECORD LENGTH, FLAGS, ETC. IN RECORD             08187000
         MVC   JESEV(D11),EMSGSVTY      INSERT SEVERITY, ERROR, DATA    08188000
         GOIF  ENTRYLNG,D0,EQ=ERRDUMP3  SKIP IF DATA LENGTH OF ZERO     08189000
         LA    R5,D8                    ALLOW FOR DATA ITEM             08190000
ERRDUMP3 LA    R4,D3(R5,R4)             BUMP TO NEXT ERROR STACK ITEM   08191000
         BCT   R3,ERRDUMP2              DECREMENT COUNT, BRANCH NON-0   08192000
         STH   R3,ERRCNT                REINITIALIZE ERROR COUNTER      08193000
         B     MINPUT                   READ NEXT STATEMENT             08194000
         DROP  R4                                                       08195000
         DROP  R11                                                      08196000
         EJECT                                                          08197000
*                                                                       08198000
* MOVERTN - THIS SUBROUTINE MOVES RECORDS BUFFER-TO-BUFFER.             08199000
*           IT ACCOMPLISHES THE FUNCTION OF A JPUTM, WHICH CANT         08200000
*           BE USED SINCE A POINTER TO THE OUTPUT RECORD MUST BE        08201000
*           GOTTEN AND SAVED.                                           08202000
*                                                                       08203000
MOVERTN1 MVC   D0(D256,INDEX1),D0(INDEX2) MOVE BLOCK OF 256 BYTES       08204000
         LA    INDEX1,D256(,INDEX1)     ADJUST DESTINATION POINTER      08205000
         LA    INDEX2,D256(,INDEX2)     ADJUST SOURCE POINTER           08206000
MOVERTN  SH    RCOMP1,=H'256'            SEE IF ONE MOVE WILL DO IT     08207000
         BP    MOVERTN1                  BRANCH IF NOT                  08208000
         AH    RCOMP1,=H'255'            GET MOVE LENGTH REMAINING      08209000
         EX    RCOMP1,MOVERTN2           MOVE REMAINING SEGMENT         08210000
         BR    RETURN                    RETURN                         08211000
MOVERTN2 MVC   D0(D0,INDEX1),D0(INDEX2) EXECUTED MOVE, 256 OR LESS      08212000
         EJECT                                                          08213000
MLKUP    EQU   *                        COMPUTE BRANCH ADDRESS FROM    X08214000
                                        TABLE                           08215000
*        BRANCH TABLE CONSISTS OF TWO BYTE ADDRESSES TO BE USED AS      08216000
*        INDICES FOR BRANCHES TO THE NAMED ROUTINES.  INTERNAL OP CODE  08217000
*        FROM TEXT IS MULTIPLIED BY TWO AND USED AS AN INDEX TO THE     08218000
*        TABLE.                                                         08219000
         SPACE 3                                                        08220000
         USING JTEXT,INPTR              BASE FOR INPUT TEXT             08221000
         SR    INDEX1,INDEX1            CLEAR A REGISTER                08222000
         IC    INDEX1,JTIOP             PICK UP INTERNAL OP CODE        08223000
         SLL   INDEX1,TIMES2            MULTIPLY BY 2                   08224000
         LH    INDEX1,MOPTABLE(INDEX1)  USE IT AS INDEX TO PICK UP     X08225000
                                        BRANCH DISPLACEMENT.            08226000
         B     MOPRTNS(INDEX1)          USE DISPLACEMENT AS INDEX       08227000
         DROP  INPTR                                                    08228000
         EJECT                                                          08229000
*TITLE-                                                               * 08230000
*   PRINT/PRINT LOGIC SELECTOR ROUTINE                                * 08231000
*                                                                     * 08232000
*FUNTION/OPERATION-                                                   * 08233000
*   DETERMINE IF OPTIONS REQUIRE A PRINTABLE RECORD OF A GENERATOR    * 08234000
*   LOGICAL STATEMENT TO BE PASSED FOR LISTING PURPOSES, AND PASS THE * 08235000
*   RECORD IF SO.                                                     * 08236000
*                                                                     * 08237000
*   AGO, AIF, MEXIT, ACTR, SETA, SETB, SETC, PROTO, PPARMS,MACRO, MEND* 08238000
*   ARE THE OPS HANDLED BY THIS ROUTINE.                              * 08239000
*                                                                     * 08240000
         SPACE                                                          08241000
PRINT10  EQU   *                        ENTRY FOR ALL BUT PROTO        X08242000
                                          MACRO, MEND.                  08243000
         SPACE                                                          08244000
         USING JTEXT,INPTR              INPUT TEXT BASE                 08245000
         GOIF  CALLING,OFF=PRINT20      PROCEED IF NOT MACRO CALL       08246000
PRINT15  GOIF  INMACRO,OFF=PRINT90      PRINT ALL OUTER MACRO CALLS     08247000
         GOIF  (JMLOGIC,JCALLS),NONE=MINPUT, PRINT INNER MACRO CALLS   X08248000
               ELSE=PRINT90             ONLY ON USERS OPTION            08249000
PRINT20  EQU   *                                                        08250000
         GOIF  INMACRO,ON=PRINT30       BRANCH IF EXPANDING A MACRO     08251000
         GOIF  JALOGIC,ON=PRINT90,      PRINT IF ALOGIC OPTION IS ON   X08252000
               ELSE=(RETURN)              OTHERWISE RETURN              08253000
PRINT25  EQU   *                                                        08254000
         GOIF  CALLING,OFF=PRINT90,ELSE=PRINT15 PRINT IF NOT CALL       08255000
PRINT30  EQU   *                        ENTRY FOR PROTO, MACRO, MEND    08256000
         GOIF  JERR,ON=PRINT90          PRINT ERRONEOUS STATEMENTS      08257000
         SPACE                                                          08258000
         GOIF  JMLOGIC,OFF=(RETURN)     EXIT IF MLOGIC OPTION IS NOT ON 08259000
         SPACE                                                          08260000
PRINT90  EQU   *                        ENTRY FOR UNCONDITIONAL PRINT   08261000
         SPACE                                                          08262000
         LR    FLDLN,RETURN             SAVE THE RETURN REGISTER        08263000
         LA    R10,GTFILE               OUTPUT TO GENERATED TEXT FILE   08264000
         LH    R11,JTRLI                PICK UP LENGTH OF INPUT RCD     08265000
         JPUTL FILE=(R10),BUFREQ=(R11)  GET OUTPUT BUFFER SPACE         08266000
         ST    R11,TXTOUT               SAVE PTR TO OUTPUT RECORD       08267000
         LH    RCOMP1,JTRLI             GET RCD LENGTH FOR MOVE         08268000
         LR    INDEX2,INPTR             SET UP SOURCE POINTER           08269000
         LR    INDEX1,FTXTOUT           SET UP DESTINATION PTR          08270000
         BAL   RETURN,MOVERTN           GO TO MOVE RCD BUF-TO-BUF       08271000
         BR    FLDLN                    RETURN VIA DUMMY RETURN         08272000
         DROP  INPTR                                                    08273000
         EJECT                                                          08274000
*                                                                       08275000
*        MOPTABLE                                                       08276000
*                                                                       08277000
*        THIS IS A BRANCH TABLE TO THE ROUTINES TO HANDLE GENERATOR     08278000
*        OP CODES.  EACH ENTRY IS A TWO BYTE INDEX TO THE ROUTINES      08279000
*        RELATIVE TO MOPRTNS, AND IS USED IN AN INDEXED BRANCH TO THAT  08280000
*        ROUTINE AFTER THE TABLE ENTRY IS SELECTED BY A COMPUTATION ON  08281000
*        THE INTERNAL OP CODE.                                          08282000
*                                                                       08283000
         SPACE 3                                                        08284000
         ORG   *-2*LOGENOP              SET TABLE START                 08285000
MOPTABLE EQU   *                        GIVE IT A NAME                  08286000
         ORG   ,                        AND RESET LOCATION COUNTER      08287000
         GENOPS MACRO,MACRO             MACRO HEADER                    08288000
         GENOPS ACTR .                  ACTR                            08289000
         GENOPS AGO,MBRANCH1 .          AGO                             08290000
         GENOPS AIF                     AIF                             08291000
         GENOPS SETA .                  SETA                            08292000
         GENOPS SETB .                  SETB                            08293000
         GENOPS SETC .                  SETC                            08294000
         GENOPS MEXIT,MEND1 .           MEXIT                           08295000
         GENOPS MEND,MEND1 .            MEND                            08296000
         GENOPS CALL                    MACRO CALL                      08297000
         GENOPS CPKEY                   CALL PARAMETER--KEYWORD         08298000
         GENOPS CPPOS                   CALL PARAMETER--POSITIONAL      08299000
         GENOPS PROTO                                                   08300000
         GENOPS PPKEY                   PROTOTYPE PARM--KEYWORD         08301000
         GENOPS PPPOS                   PROTOTYPE PARM--POSITIONAL      08302000
         GENOPS PEND                    PARAMETER LIST END--ALL         08303000
         ORG   ,                             END OF TABLE               08304000
         EJECT                                                          08305000
*TITLE-                                                               * 08306000
*        MOPRTNS/GENERATOR OPCODE ROUTINE BASE                        * 08307000
*                                                                     * 08308000
*FUNCTION/OPERATION-                                                  * 08309000
*        PROVIDE BASE FOR ALL GENERATOR OPCODE HANDLING ROUTINES.     * 08310000
*   THIS VALUE IS USED FOR COMPUTING INDEX FOR TABLE LOOKUP BY        * 08311000
*   STATEMENT TYPE TO SELECT THE APPROPRIATE ROUTINE.  ALSO INCLUDES  * 08312000
*   MERROR, WHICH IS THE EXIT FOR INVALID OPCODE TYPES (PROGRAM LOGIC * 08313000
*   ERROR).                                                           * 08314000
*                                                                     * 08315000
         SPACE 3                                                        08316000
MOPRTNS  EQU   *                        BASE ONLY--NOT AN ENTRY POINT   08317000
         EJECT                                                          08318000
*TITLE--                                                              * 08319000
*   MACRO/MACRO STATEMENT UTILITY ROUTINE                             * 08320000
*                                                                     * 08321000
*FUNCTION/OPERATION--                                                 * 08322000
*   A MACRO STATEMENT CAN OCCUR UNEXPECTEDLY, DENOTING THE BEGINNING  * 08323000
*   OF TEXT OF A PROGRAMMER MACRO DEFINITION, OR EXPECTED, DENOTING   * 08324000
*   THE FIRST TEXT RECORD OF A CALLED MACRO. THIS ROUTINE CONTROLS THE* 08325000
*   SWITCHES THAT KEEP THE TWO MODES STRAIGHT.                        * 08326000
*                                                                     * 08327000
*   IF OPEN CODE, THE ROUTINE TURNS ON SWITCH 'INMACDEF', WHICH STAYS * 08328000
*   ON UNTIL A MEND STATEMENT IS FOUND.  WHILE THIS SWITCH IS ON, ALL * 08329000
*   RECORDS ARE PASSED THROUGH AS PRINT ONLY, FOR LISTING PURPOSES    * 08330000
*   ONLY.                                                             * 08331000
*                                                                     * 08332000
*   WHEN A MACRO IS CALLED, MCALL TURNS ON SWITCH 'CALLING' INDICATING* 08333000
*   THAT A CALL IS IN PROGRESS.  IF THIS SWITCH IS ON, MACRO JUST     * 08334000
*   TURNS IT OFF, BYPASSING REFERENCE TO 'INMACDEF' SWITCH.           * 08335000
*                                                                     * 08336000
*INPUT--NONE                                                          * 08337000
*OUTPUT--NONE                                                         * 08338000
*ENTRY POINTS--MACRO                                                  * 08339000
*EXTERNAL ROUTINES--NONE                                              * 08340000
*EXITS--BR RETURN                                                     * 08341000
*TABLES/WORK AREAS--                                                  * 08342000
*   SWITCHES INMACDEF AND CALLING, LOCATED IN GENCOM.                 * 08343000
*                                                                     * 08344000
*ATTRIBUTES--REFRESHABLE                                              * 08345000
*NOTES--                                                                08346000
*   IF NESTED DEFINITIONS ARE EVER ALLOWED, SWITCH 'INMACDEF' WILL BE * 08347000
*   REPLACED WITH A COUNTER WHICH WILL BE DECREMENTED BY MEND STATE-  * 08348000
*   MENTS.                                                            * 08349000
         SPACE                                                          08350000
MACRO    EQU   *                                                        08351000
         SPACE                                                          08352000
         GOIF  CALLING,ON=MACRO20       IF ON, THIS IS PART OF A CALL   08353000
         SET   INMACDEF,ON              ELSE IT MUST BE LISTING ONLY    08354000
         USING JTEXT,INPTR                                              08355000
         DROP  INPTR                                                    08356000
         BAL   RETURN,PRINT90           PRINT A COPY                    08357000
         B     MINPUT                   GO BACK FOR NEXT STATEMENT      08358000
         SPACE 3                                                        08359000
MACRO20  EQU   *                                                        08360000
         SPACE                                                          08361000
         BAL   RETURN,PRINT30           PRINT IF MLOGIC OPTION IS ON    08362000
         SET   CALLING,OFF                                              08363000
         B     MINPUT                   GO BACK FOR NEXT STATEMENT      08364000
         EJECT                                                          08365000
*TITLE--                                                              * 08366000
*   MPROTO/MACRO PROTOTYPE HANDLER                                    * 08367000
*                                                                     * 08368000
*FUNCTION/OPERATION--                                                 * 08369000
*   UNDEFINED--MAY BE DICTIONARY                                      * 08370000
         SPACE                                                          08371000
MPROTO   EQU   *                                                        08372000
         BAL   RETURN,PRINT30           PRINT IF MLOGIC OPTION IS ON    08373000
         B     MINPUT                   GO BACK FOR NEXT STATEMENT      08374000
         EJECT                                                          08375000
*TITLE--                                                              * 08376000
*   MPARM/MACRO CALL AND PARAMETER ROUTINE                            * 08377000
         SPACE                                                          08378000
*FUNCTION/OPERATION--                                                 * 08379000
*   POINTS REG10 TO THE LENGTH PORTION OF THE OPERAND OF A PARAMETER  * 08380000
*   RECORD, AND CALLS THE APPROPRIATE DICTIONARY ROUTINE TO PLACE THE * 08381000
*   PARAMETER IN THE PARAMETER TABLE.                                 * 08382000
         SPACE                                                          08383000
*ENTRY POINTS--                                                       * 08384000
*   MCPKEY     CALL KEYWORD PARAMETER                                 * 08385000
*   MCPPOS     CALL POSITIONAL PARAMETER                              * 08386000
*   MPPKEY     PROTOTYPE KEYWORD PARAMETER                            * 08387000
*   MPEND      END OF PARAMETER LIST                                  * 08388000
*   MCALL      BEGIN MACRO CALLING SEQUENCE                           * 08389000
         SPACE                                                          08390000
*INPUT--                                                              * 08391000
*   TEXT RECORD POINTED TO BY INPTR                                   * 08392000
         SPACE                                                          08393000
*OUTPUT--NONE                                                         * 08394000
         SPACE                                                          08395000
*EXTERNAL ROUTINES--                                                  * 08396000
*        MACRKWRD   CALL KEYWORD        DICTIONARY ACCESS INTERFACE   * 08397000
*        MACRPOST   CALL POSITIONAL        ''        ''      ''       * 08398000
*        PROTOKWD   PROTOTYPE KEYWORD      ''        ''      ''       * 08399000
*        MACRCALL   INITIATE CALL          ''         ''       ''     * 08400000
*        CALLEND    CALL END               ''         ''       ''     * 08401000
*        PROTOEND   PROTOTYPE END          ''         ''       ''     * 08402000
         SPACE                                                          08403000
*EXITS--                                                              * 08404000
*   NORMAL--BRANCH TO MINPUT                                          * 08405000
         SPACE                                                          08406000
*TABLES/WORK AREAS--N/A                                               * 08407000
         SPACE 3                                                        08408000
MPPKEY   LA    RMOVE,PROTOKWD           PROTOTYPE KEYWORD               08409000
         B     MPARM                    GO TO PIVOT                     08410000
MCPKEY   LA    RMOVE,MACRKWRD           CALL KEYWORD                    08411000
         B     MPARM                      AND TAKE PIVOT                08412000
MCPPOS   LA    RMOVE,MACRPOST           CALL POSITIONAL                 08413000
MPARM    EQU   *                        COMMON PARAMETER PIVOT          08414000
         USING JTEXT,INPTR              TEXT BASE                       08415000
         GOIF  NOCALL,ON=MINPUT         ABORTED CALL, DON'T PROCESS.    08416000
         LR    METAPTR,INPTR            PICK UP TEXT BASE AND           08417000
         AH    METAPTR,JTOPP            DEVELOP OPERAND POINTER AND     08418000
         USING JTMFLG,METAPTR             DECLARE AS META TEXT BASE.    08419000
         LR    R10,METAPTR              TEMPORARY                       08420000
         SH    R10,=H'5'                BACK UP TO HDR DATA START       08421000
         ST    R10,GENRTRN              PRESERVE PTR TO HDR FLAGS       08422000
         USING PFLAG,R10                                                08423000
         SPACE                                                          08424000
         GOIF  JTCPKEY,EQ=MPARM9        CALL KEYWORD, BRANCH            08425000
         GOIF  JTPPKEY,NE=MPARM10       NOT PROTOTYPE KEYWORD, BRANCH   08426000
         SPACE                                                          08427000
*        KEYWORD PROCESSING--SKIP KEYWORD ON FIRST SUBELEMENT ONLY      08428000
         SPACE                                                          08429000
MPARM9   EQU   *                        KEYWORD HANDLING                08430000
         GOIF  (PSUB,PSUBF),MIX=MPARM10                                X08431000
               BRANCH IF NOT A SUBLIST OR IF NOT FIRST SUB-OPERAND      08432000
         SR    R1,R1                    ZERO LENGTH REGISTER            08433000
         IC    R1,JTMLNG                PICK UP KEYWORD LENGTH          08434000
         LA    METAPTR,JTMSTRNG(R1)     AND BUMP STRING POINTER OVER   X08435000
                                          FLAG, LENGTH, AND KEYWORD.    08436000
MPARM10  EQU   *                        METAPTR NOW POINTS TO FIRST FLAG08437000
                                          IN META TEXT DESCRIBING      X08438000
                                          THE PARAMETER.                08439000
         GOIF  JSUBOPND,ON=MPARM11      SKIP AHEAD IF WE HAVE SUBSTITU- 08440000
         LA    METAPTR,JTMLNG             TION, ELSE JUST POINT TO      08441000
         LR    R11,METAPTR                                              08442000
         B     MPARM30                    LENGTH AND PUT IN DICTIONARY. 08443000
         DROP  METAPTR                                                  08444000
         SPACE                                                          08445000
MPARM11  EQU   *                        PARAMETER IS TO BE DEVELOPED   X08446000
                                          FROM META TEXT.               08447000
         SPACE                                                          08448000
         GOIF  PPASS,OFF=MPARM20        NOT PASSED PARM, SUBSTITUTE     08449000
         SPACE                                                          08450000
MPARM12  BAL   RETURN,EVALINIT          EVALUATE THE PARM REFERENCE     08451000
*        REFERENCE IS NOW AT BOTTOM OF EVAL STACK.                      08452000
         LA    R10,STACK                POINT TO TERM IN STACK          08453000
         SET   CHARMODE,ON              INDICATE CHAR STRINGS WANTED    08454000
         JCALL RESOLVE                  AND RESOLVE IT.                 08455000
         SET   CHARMODE,OFF             CLEAN UP CHAR STRING FLAG       08456000
*        NOW R14 POINTS TO REFERENCED PARAMETER, R11 POINTS TO STRING.  08457000
         USING PFLAG,R14                TEMPORARY BASE FOR PARM ENTRY   08458000
         GOIF  PSUB,OFF=MPARM15         BRANCH IF PARAM NOT SUBLIST     08459000
         L     R10,GENRTRN              RESTORE PTR TO HDR FLAGS        08460000
         TM    D0(R10),BIT0             SEE IF SUBLIST A SUBOPERAND     08461000
         BO    MPARM20                  MAKE STRING OF IT IF SO         08462000
         DROP  R14                                                      08463000
MPARM15  EQU   *                                                        08464000
         LR    R11,R14                  ELSE PUT PARM POINTER IN R11    08465000
         SET   PASSPARM,ON              INDICATE PARM PASSED AS PRM     08466000
*        DICTIONARY ENTRY                                               08467000
MPARM30  L     R12,DICTBASE             DICTIONARY BASE                 08468000
         LR    R10,INPTR                TEXT BASE FOR DICTIONARY ENTRY  08469000
         STC   RMOVE,NDXVAL             SET UP PROPER ENTRY INDEX       08470000
         BALR  R9,R12                   LINK TO DICTIONARY ROUTINE      08471000
         B     ERRDUMP                  RETURN FOR NEXT RECORD          08472000
         SPACE                                                          08473000
MPARM20  LA    VTXTOUT,STRING1          POINT TO A BUFFER               08474000
         LA    RCOMP1,STACK-STKENTRY    INITIALIZE                      08475000
         ST    RCOMP1,STACKLVL            EVAL STACK.                   08476000
         MVI   STRING1,D0               SET TO NULL STRING              08477000
         JCALL GENSTRNG                 AND GENERATE THE STRING.        08478000
         LR    R11,VTXTOUT              STRING POINTER FOR DICTIONARY   08479000
         B     MPARM30                  GO ENTER IN THE DICTIONARY      08480000
         SPACE                                                          08481000
MPEND    EQU   *                                                        08482000
         GOIF  JERR,OFF=MPEND05         BRANCH IF NO PARAM ERRORS       08483000
         L     R1,TXTOUT                GET PTR TO PROTOTYPE OR CALL    08484000
         USING MTEXT,R1                                                 08485000
         SET   MERR,ON                  TRANSFER ERROR FLAG TO TEXT     08486000
         DROP  R1                                                       08487000
         L     R1,ACTRCNT               PICK UP CURRENT ACTR VALUE      08488000
         SRL   R1,D1                    HALVE IT ON EDITOR ERROR        08489000
         ST    R1,ACTRCNT               SAVE NEW ACTR VALUE             08490000
MPEND05  EQU   *                                                        08491000
         SPACE                                                          08492000
         GOIF  NOCALL,OFF=MPEND10       NOT ABORTED CALL, PROCEED.      08493000
         SET   NOCALL,OFF               ELSE TURN OFF SWITCH,           08494000
         B     ERRDUMP                  AND EXIT                        08495000
MPEND10  GOIF  CALLING,ON=MCALLEND      BRANCH IF MACRO CALL SEQUENCE   08496000
         DICTCALL PROTOEND                ELSE ASSUME PROTOTYPE END     08497000
         SPACE                                                          08498000
         B     ERRDUMP                  RETURN FOR NEXT RECORD          08499000
         SPACE                                                          08500000
MCALLEND EQU   *                                                        08501000
         JGETL FILE=FILE1               FETCH NEXT TEXT RECORD          08502000
         USING JTEXT,R11                                                08503000
         GOIF  JPSOP,OFF=MPEND15        PSEUDO-OP ?            FX0000   08504000
         GOIF  JTERROR,NE=MPEND15       PROCEED IF NOT ERROR RECORD     08505000
         JPUTM FILE=FILE2,ADDR=(R11)    FLUSH PAST ERROR RECORD(S)      08506000
         B     MCALLEND                 GO BACK FOR NEXT TEXT RECORD    08507000
         DROP  R11                                                      08508000
MPEND15  EQU   *                                                        08509000
         SPACE                                                          08510000
         SET   INMACRO,ON               INDICATE WE ARE NOW IN A MACRO  08511000
         DICTCALL CALLEND                                               08512000
         B     MINPUT                   RETURN FOR NEXT RECORD          08513000
         SPACE 3                                                        08514000
MCALL    EQU   *                        MACRO CALL                      08515000
         GOIF  (CALLING,NOCALL),ANY=MFEVAL RE-DIRECT CALL CONTINUATIONS 08516000
         SET   NOCALL,ON                ASSUME BAD INITIALLY            08517000
         SPACE                                                          08518000
         LA    R11,MACRCALL             SET ENTRY DISPLACEMENT          08519000
         LH    VTXTIN,JTOCP             GET OP CODE DISPLACEMENT        08520000
         AR    VTXTIN,INPTR             GET OP CODE POINTER             08521000
         BAL   RETURN,METAINIT          INITIALIZE META TEXT POINTER    08522000
         LR    R10,VTXTIN               SET UP FOR DICT ROUTINE         08523000
         SPACE                                                          08524000
         DICTCALL MACRCALL                                              08525000
         SPACE                                                          08526000
*        ON RETURN, R11 CONTAINS--                                      08527000
*              0    OK                                                * 08528000
*              4    MACRO NOT FOUND                    ERROR            08529000
*              8    INVALID PROTOTYPE                  ERROR          * 08530000
*              12   NO MACRO STATEMENT                 ERROR          * 08531000
*              16   BOOKNAME DOES NOT MATCH PROTOTYPE  ERROR          * 08532000
         SPACE                                                          08533000
*        SO WE'LL DO AN INDEXED BRANCH                                  08534000
         B     CALLTABL(R11)            DO INDEXED BRANCH               08535000
         SPACE                                                          08536000
CALLTABL EQU   *                        BRANCH TABLE ORIGIN             08537000
         SPACE                                                          08538000
         B     MCALL10                  WE MADE IT OK.                  08539000
         B     LOGERR78                 THAT'S                          08540000
         B     LOGERR87                   NOT                           08541000
         B     LOGERR85                    A                            08542000
         B     LOGERR88                    MACRO.                       08543000
         B     LOGER100                 NO DICTIONARY                   08544000
         SPACE                                                          08545000
MCALL10  SET   (CALLING,NOCALL),FLIP    CALLING ON, NOCALL OFF          08546000
         L     R1,MACROLVL              INCREMENT                       08547000
         LA    R1,D1(,R1)                    MACRO NEST DEPTH           08548000
         ST    R1,MACROLVL                        BY ONE                08549000
         L     RCOMP1,SYSNDX           PICK UP CURRENT SYSNDX           08550000
         LA    RCOMP1,D1(,RCOMP1)       INCREMENT IT BY 1 FOR CALL      08551000
         ST    RCOMP1,SYSNDX            PUT IT BACK, UPDATED            08552000
         B     MFEVAL                   LET FEVAL GENERATE IMAGES       08553000
         SPACE 10                                                       08554000
* DUMMY ROUTINE TO HANDLE PROTOTYPE PARAMETERS, POSITIONAL -            08555000
* SIMPLE RETURN FOR NEXT RECORD                                         08556000
MPPPOS   B     MINPUT                   RETURN FOR NEXT RECORD          08557000
         SPACE                                                          08558000
         EJECT                                                          08559000
LOGERR78 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08560000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08561000
         DC    AL1(SEV78,ERR78)         ERROR PARAMETERS                08562000
LOGCOMN  EQU   *                                                        08563000
         BAL   RETURN,PRINT90           PUT OUT COPY OF BOGUS MACRO     08564000
         B     ERRDUMP                  GO TERMINATE STATEMENT          08565000
LOGERR85 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08566000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08567000
         DC    AL1(SEV85,ERR85)         ERROR PARAMETERS                08568000
         B     LOGCOMN                  GO MAKE REAL ERROR ENTRY        08569000
LOGERR87 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08570000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08571000
         DC    AL1(SEV87,ERR87)         ERROR PARAMETERS                08572000
         B     LOGCOMN                  GO MAKE REAL ERROR ENTRY        08573000
LOGERR88 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08574000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08575000
         DC    AL1(SEV88,ERR88)         ERROR PARAMETERS                08576000
         B     LOGCOMN                  GO MAKE REAL ERROR ENTRY        08577000
LOGERR90 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08578000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08579000
         DC    AL1(SEV90,ERR90)         ERROR PARAMETERS                08580000
         B     ERRDUMP                  GO TERMINATE STATEMENT          08581000
LOGER100 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08582000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08583000
         DC    AL1(SEV100,ERR100)       ERROR PARAMETERS                08584000
         B     LOGCOMN                  GO MAKE REAL ERROR ENTRY        08585000
LOGER118 LA    R12,LOGERR01             GET BASE FOR ERROR LOGGING RTN  08586000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08587000
         DC    AL1(SEV118,ERR118)       ERROR PARAMETERS                08588000
         B     MEND11                   PROCEED ON ACTR OVERRUN         08589000
         EJECT                                                          08590000
*TITLE-                                                               * 08591000
*        MBRANCH/GENERATOR TEXT BRANCH ROUTINE                        * 08592000
*                                                                     * 08593000
*FUNCTION/OPERATION-                                                  * 08594000
*        HANDLES CONDITIONAL ASSEMBLY BRANCHING.  FOR AIF STATEMENTS, * 08595000
*    CALLS BEVAL TO DETERMINE IF BRANCH IS TO BE TAKEN.  FOR AGO      * 08596000
*    STATEMENTS, AND AIF STATEMENTS IF CONDITION IS YES, CALLS MPOINTR* 08597000
*    TO EFFECT THE BRANCH.                                            * 08598000
*                                                                     * 08599000
         SPACE 3                                                        08600000
MBRANCH1 EQU   *                        AGO ENTRY POINT                 08601000
         SPACE                                                          08602000
         BAL   RETURN,PRINT10           PRINT IF OPTIONS ARE ON         08603000
         USING JTEXT,INPTR              BASE FOR TEXT                   08604000
         LH    VTXTIN,JTOPP             GET OPERAND POINYER             08605000
         AR    VTXTIN,INPTR             MAKE ABSOLUTE                   08606000
         BAL   RETURN,METAINIT          GET PTP TO META TEXT START      08607000
         SPACE                                                          08608000
MBRANCH2 EQU   *                                                        08609000
         SPACE                                                          08610000
         L     RCOMP1,ACTRCNT           PICK UP ACTR COUNT              08611000
         GOIF  (RCOMP1),NOTPOS=LOGER118 ACTR RAN OUT, LOG THE MESSAGE   08612000
         BCTR  RCOMP1,D0                ELSE DECREMENT ACTR             08613000
         ST    RCOMP1,ACTRCNT           AND REPLACE                     08614000
         LR    R10,VTXTIN               SET UP META TEXT PTR FOR DICT   08615000
         SPACE                                                          08616000
         DICTCALL SEQSYMBR              BRANCH TO THE SEQUENCE SYMBOL   08617000
         SPACE                                                          08618000
         SPACE                                                          08619000
         BNZ   ERRDUMP                  GO GET NEXT RCD IF ALL OK       08620000
         B     LOGERR90                 GO DIAGNOSE SITUATION           08621000
         DROP  INPTR                                                    08622000
         EJECT                                                          08623000
*TITLE-                                                               * 08624000
*        MEND/GENERATOR MEND MEXIT END ROUTINE                        * 08625000
*                                                                     * 08626000
*FUNCTION/OPERATION-                                                  * 08627000
*        HANDLES END OF FILE PROCESSING FOR EACH TEXT SEGMENT.  RE-   * 08628000
*    CEIVES CONTROL EITHER UPON ENCOUNTERING AN END, MEND, OR MEXIT   * 08629000
*    STATEMENT IN THE TEXT STREAM.  END CAUSES TERMINATION OF PHASE.  * 08630000
*    MEND OR MEXIT CAUSE TERMINATION OF THE CURRENT MACRO, CALLS FOR  * 08631000
*    RESETTING TEXT TO POINT AT WHICH THE MACRO WAS CALLED, AND RE-   * 08632000
*    SETS DICTIONARY POINTERS TO THE LOCAL DICTIONARY OF THE CALLING  * 08633000
*    TEXT SEGMENT.                                                    * 08634000
*                                                                     * 08635000
*ENTRY POINTS-                                                        * 08636000
*        MEND1--MEND/MEXIT PROCESSING                                 * 08637000
*        MEND2--END PROCESSING                                        * 08638000
*                                                                     * 08639000
         SPACE 3                                                        08640000
MEND1    EQU   *                                                        08641000
         SPACE                                                          08642000
         BAL   RETURN,PRINT30           PRINT IF OPTIONS ARE ON         08643000
MEND11   EQU   *                                                        08644000
         L     RCOMP1,MACROLVL          PICK UP CURRENT MACRO NEST LVL  08645000
         GOIF  (RCOMP1),POS=MEND12      CHEK IF ACTR OVFLO IN OPEN CD   08646000
         SET   FLUSH3,ON                GENERATE END CARD               08647000
         B     ERRDUMP                  GO TO DIAGNOSE AND EXIT         08648000
MEND12   EQU   *                                                        08649000
         BCT   RCOMP1,MEND1A            ADJUST BY ONE. IF ZERO,         08650000
         SET   INMACRO,OFF                THEN TURN OFF SWITCH INMACRO. 08651000
MEND1A   ST    RCOMP1,MACROLVL          IN EITHER CASE, SAVE THE COUNT. 08652000
         DICTCALL MACRFINI              POP THE DICTIONARY LEVEL ALSO   08653000
         B     ERRDUMP                  RETURN TO GET NEXT RECORD       08654000
         SPACE 3                                                        08655000
         EJECT                                                          08656000
*TITLE-                                                               * 08657000
*   MSET/MACRO GENERATOR SET STATEMENT PROCESSOR                      * 08658000
         SPACE                                                          08659000
*FUNCTION/OPERATION-                                                  * 08660000
*   CALLS EVAL TO CONVERT OPERAND META TEXT TO CHARACTER OR ARITHMETIC* 08661000
*   FORM, THEN PASSES VALUE THROUGH DICTIONARY LINKAGE FOR ENTRY.    *  08662000
         SPACE                                                          08663000
MSETA    EQU   *                        SETA ENTRY                      08664000
MSETB    EQU   *                        SETB ENTRY                      08665000
MSETC    EQU   *                        SETC ENTRY                      08666000
MAIF     EQU   *                        AIF ENTRY                       08667000
MACTR    EQU   *                        ACTR ENTRY                      08668000
         SPACE                                                          08669000
*                                       MERCY--THEY'RE ALL THE SAME.    08670000
         SPACE                                                          08671000
         BAL   RETURN,PRINT10           PRINT IF OPTIONS ARE ON         08672000
         USING JTEXT,FTXTIN             FIXED INPUT BASE                08673000
         LH    VTXTIN,JTOPP               OPERAND DISPLACEMENT          08674000
         AR    VTXTIN,FTXTIN              MAKE ABSOLUTE                 08675000
         LA    VTXTOUT,STRING1          OUTPUT POINTER--A BUFFER        08676000
         SPACE                                                          08677000
         BAL   RETURN,METAINIT          GO INITIALIZE META TEXT         08678000
         BAL   RETURN,EVALINIT          GO INITIALIZE EVAL STACKS       08679000
         SPACE                                                          08680000
         GOIF  JTSETB,GT=MSETC10        IF SETC, GO DO IT               08681000
         SPACE                                                          08682000
         LR    VTXTIN,R10               RESTORE THE REAL TEXT POINTER   08683000
*        LAST ELEMENT IN STACK MAY NOT BE SELF DEFINING TERM.           08684000
         LA    R10,STACK                SO POINT TO IT,                 08685000
         JCALL RESOLVE                      AND RESOLVE IT.             08686000
*        NOW R11 CONTAINS THE VALUE.                                    08687000
         SPACE                                                          08688000
         GOIF  JTACTR,EQ=ACTR           IF ACTR, GO DO IT               08689000
         GOIF  JTAIFB,LE=AIF,ELSE=MSET20                               X08690000
                                        GO DO AIF, ELSE SKIP TO SETAB   08691000
         SPACE                                                          08692000
MSETC10  EQU   *                        SETC--CHARACTER STRING          08693000
         SPACE                                                          08694000
         LA    R11,STRING1              GET POINTER TO STRING           08695000
         SPACE                                                          08696000
MSET20   EQU   *                        NOW GET READY FOR DICTIONARY DO 08697000
         SPACE                                                          08698000
SET20    LH    VTXTIN,JTNMP             GET NAME FIELD POINTER          08699000
         AR    VTXTIN,FTXTIN            MAKE ABSOLUTE                   08700000
         DROP  FTXTIN                                                   08701000
         ST    R11,STRRTRN              STORE VALUE IN R11              08702000
         BAL   RETURN,METAINIT          INITIALIZE NAME FIELD META      08703000
         LA    RCOMP1,STACK-STKENTRY    POINT TO START OF EVAL STACK    08704000
         ST    RCOMP1,STACKLVL            AND SAVE AS STACK POINTER     08705000
         L     R12,=A(EVAL)             GO EVALUATE THE                 08706000
         BALR  RETURN,R12                 SET TARGET                    08707000
         L     R11,STRRTRN              RESTORE R11 TO SET VALUE        08708000
         LA    R10,STACK                POINT TO TERM--NOW IN STACK     08709000
         SPACE                                                          08710000
         USING JTMFLG,R10               BASE FOR SET SYMBOL             08711000
         GOIF  JTMGBL,ON=SET32          GLOBAL, GO DO GLOBAL SET        08712000
         DROP  R10                                                      08713000
         SPACE                                                          08714000
SET30    DICTCALL LCLDICTS              LOCAL SET                       08715000
         B     ERRDUMP                  RETURN TO GET NEXT RECORD       08716000
         SPACE                                                          08717000
SET32    DICTCALL GBLDICTS              GLOBAL SET                      08718000
         B     ERRDUMP                  RETURN TO GET NEXT RECORD       08719000
         SPACE 3                                                        08720000
AIF      EQU   *                        AIF ENTRY                       08721000
         SPACE                                                          08722000
         LR    R10,VTXTIN               TEXT POINTER IN R10 AS A PARAM-X08723000
                                          ETER--POINTS TO SEQUENCE SYM. 08724000
         GOIF  (R11),ZERO=ERRDUMP,ELSE=MBRANCH2                        X08725000
                                        RETURN IF ZERO ELSE POINT TEXT  08726000
         SPACE 3                                                        08727000
ACTR     EQU   *                                                        08728000
         SPACE                                                          08729000
*        NEW ACTR VALUE IS IN REG R11                                   08730000
         SPACE                                                          08731000
         ST    R11,ACTRCNT              STORE AS NEW ACTR               08732000
         B     ERRDUMP                  RETURN TO GET NEXT RECORD       08733000
         EJECT                                                          08734000
EVALINIT EQU   *                        INITIALIZE EVAL ROUTINE         08735000
         SPACE                                                          08736000
         SET   CCOMP,OFF                ASSUME ARITHMETIC COMPARES      08737000
         LA    RCOMP1,STACK-STKENTRY    NOTHING IN THE STACK            08738000
         ST    RCOMP1,STACKLVL          POINT TO START OF EVAL STACK    08739000
         LA    RCOMP1,STRING1           FIRST STRING BUFFER             08740000
         ST    RCOMP1,STRPTR1             AND SAVE IT                   08741000
         MVI   STRING1,D0               NULL STRING                     08742000
         MVI   STRING2,D0               NULL STRING                     08743000
         L     R12,=A(EVAL)             POINT TO EVAL ROUTINE           08744000
         BR    R12                        AND GO.  RETURN VIA R9.       08745000
         EJECT                                                          08746000
METAINIT EQU   *                        POINT TO START OF META TEXT     08747000
         SPACE                                                          08748000
         SH    VTXTIN,=H'2'             GET PTR TO META TEXT LENGTH     08749000
         MVC   JHWORD1,D0(VTXTIN)       ALIGN 2-BYTE META TEXT LENGTH   08750000
        SH    VTXTIN,JHWORD1            DEVELOP PTR TO META TEXT START  08751000
         BR    RETURN                   RETURN TO CALLER                08752000
         EJECT                                                          08753000
         DS    0H                                                       08754000
MOVEFLD  EQU   *                                                        08755000
         SPACE                                                          08756000
         USING JTEXT,FTXTIN                                             08757000
         USING MTEXT,FTXTOUT                                            08758000
         USING MTOCO,VTXTOUT            VARIABLE TEXT OUTPUT            08759000
         USING JTOCO,VTXTIN               AND INPUT BASES.              08760000
         SPACE                                                          08761000
         AR    VTXTIN,FTXTIN            VTXTIN CONTAINS DISPLACEMENT-- X08762000
                                          ADD TEXT POINTER TO GET FIELDX08763000
                                          POINTER FOR INPUT.            08764000
         LR    R0,VTXTIN                SAVE INPUT POINTER              08765000
         AR    VTXTOUT,FTXTOUT          ADD RECORD BASE FOR OUTPUT      08766000
         SPACE                                                          08767000
MOVFLD5  GOIF  JTOCOCD,OFF=MOVFLD10     NO CARD POINTER, SKIP.          08768000
         MVC   MTOCO,JTOCO                ELSE MOVE IT                  08769000
         LA    VTXTIN,JTOCL               AND ADJUST INPUT POINTER      08770000
         LA    VTXTOUT,MTOCL              AND OUTPUT POINTER.           08771000
         SPACE                                                          08772000
MOVFLD10 EQU   *                        MOVE THE COLUMN POINTER         08773000
         SPACE                                                          08774000
         MVC   MTOCO,JTOCO              MOVE 1 BYTE                     08775000
         LA    VTXTIN,JTOCL             ADJUST INPUT                    08776000
         LA    VTXTOUT,MTOCL              AND OUTPUT POINTERS           08777000
         ST    VTXTOUT,GENRTRN          SAVE POINTER TO LENGTH.         08778000
         SPACE                                                          08779000
         USING JTOCL,VTXTIN             NEW BASE IN                     08780000
         USING MTOCL,VTXTOUT            NEW BASE OUT                    08781000
         SPACE                                                          08782000
         MVI   MTOCL,D0                 INITIALLY A ZERO LENGTH STRING  08783000
         SPM   RETURN                   RECOVER ENTRY CONDITION CODE    08784000
         BO    GENFLD                     GO TO GENFLD IF SUBSTITUTION  08785000
         SPACE                                                          08786000
         IC    RMOVE,JTOCL              PICK UP LENGTH                  08787000
MOVFLD20 EX    RMOVE,MVCFLD10             AND EXECUTE FIELD MOVE OF    X08788000
                                          FIELD PLUS LENGTH.            08789000
         LA    VTXTOUT,D1(RMOVE,VTXTOUT)     ADJUST OUTPUT POINTER      08790000
         SR    VTXTOUT,FTXTOUT            AND REDUCE TO DISPLACEMENT.   08791000
         BR    RETURN                   RETURN TO CALLER                08792000
         SPACE                                                          08793000
MVCFLD10 MVC   MTOCL(D0),JTOCL          REMOTE FIELD MOVE               08794000
         SPACE                                                          08795000
         DROP  VTXTIN,VTXTOUT,FTXTIN,FTXTOUT                            08796000
         EJECT                                                          08797000
*TITLE--                                                                08798000
*   GENFLD/GENERATE A FIELD                                             08799000
         SPACE                                                          08800000
         DS    0H                                                       08801000
GENFLD   EQU   *                                                        08802000
         SPACE                                                          08803000
*        ON ENTRY, VTXTIN POINTS TO REAL START OF VIRTUAL TEXT          08804000
         SPACE                                                          08805000
         LR    VTXTIN,R0                RECOVER INPUT POINTER           08806000
         LR    FLDLN,RETURN             SAVE THE RETURN ADDRESS         08807000
         BAL   RETURN,METAINIT          GET PTR TO META TEXT START      08808000
         SPACE                                                          08809000
*        NOW VTXTIN POINTS TO START OF META TEXT.                       08810000
         SPACE                                                          08811000
         ST    FTXTOUT,OUTPTR           SAVE THE REAL OUTPUT POINTER    08812000
         LA    RCOMP1,STACK-STKENTRY    START OF STACK BECOMES          08813000
         ST    RCOMP1,STACKLVL            INTIAL STACK POINTER          08814000
         JCALL GENSTRNG                 GENERATE A CHARACTER STRING     08815000
         SPACE                                                          08816000
GENFLD90 EQU   *                        GENFLD EXIT ROUTINE             08817000
         SPACE                                                          08818000
         LR    VTXTOUT,R10              PICK UP NEW FIELD POINTER       08819000
         L     FTXTOUT,OUTPTR           RESTORE THE OUTPUT POINTER      08820000
         SR    VTXTOUT,FTXTOUT          REDUCE OUTPUT POINTER TO       X08821000
                                        DISPLACEMENT.                   08822000
         BR    FLDLN                    RETURN ON THE SAVED RETURN REG  08823000
         EJECT                                                          08824000
*        CONSTANTS FOR X3A                                              08825000
         SPACE                                                          08826000
DICTBASE DC    A(DICTENTR)              DICTIONARY INTERFACE BASE       08827000
DUMYEND  DC    AL2(24),AL1(JPSOP+JDEF+JREF,0,JTEND,0),AL2(17,19,17,17,1X08828000
               7),AL1(0),AL2(0),AL1(10,3,JE,JN,JD)                      08829000
         JEXTRN (X3N01=DICTENTR)          DECLARE IT EXTERNAL           08830000
CHKSYMLN DC    Y(MAXSYM)                HALFWORD CONSTANT TO CHECK SYM-X08831000
                                          BOL LENGTH OVERFLOW           08832000
HHDRLN   DC    Y(JTHDRLN)               TEXT RECORD HEADER LENGTH       08833000
         SPACE                                                          08834000
         DS    0H                                                       08835000
         SPACE 3                                                        08836000
* LOGERR - THIS SUBROUTINE MAKES AN ENTRY FOR A SINGLE ERROR IN THE     08837000
*          ERROR STACK AND INCREMENTS THE ERROR COUNT BY 1.             08838000
*                                                                       08839000
LOGERR01 EQU   *                                                        08840000
         JENTRY (X3A02=LOGERR01)                                        08841000
         USING LOGERR01,R12                                             08842000
         STM   R14,R15,GENREGS          SAVE WORK REGISTERS             08843000
         CLI   D0(R9),D4                LOOK FOR SEVERITY 4 MESSAGE     08844000
         BNH   LOGERR10                 BRANCH IF NOT GT 4     FX0000   08845000
         CLI   D1(R9),ERR78             UNDEFINED OPCD         FX0000   08846000
         BE    LOGERR10                 BRANCH IF EQUAL        FX0000   08847000
         L     R14,ACTRCNT              PICK UP CURRENT ACTR VALUE      08848000
         SRL   R14,D1                   HALVE IT ON GENERATE ERROR      08849000
         ST    R14,ACTRCNT              SAVE NEW ACTR VALUE             08850000
LOGERR10 CLC   JMSGL,D0(R9)             SEE IF MESSAGE SHOULD BFX0000   08851000
         BH    LOGERR99                 RETURN IF NOT          FX0000   08852000
         CLC   D0(D1,R9),JSEVER         IS THIS HIGHER                  08853000
         BNH   LOGERR20                 BRANCH IF NOT          FX0000   08854000
         MVC   JSEVER(D1),D0(R9)        ENTER HIGH                      08855000
LOGERR20 LH    R14,ERRCNT               PICK UP CURRENT ERROR CFX0000   08856000
         LA    R14,D1(,R14)             ADJUST FOR ERROR JUST ADDED     08857000
         STH   R14,ERRCNT               SAVE NEW ERROR COUNT            08858000
         CH    R14,=H'7'                SEVENTH ENTRY ?        FX0000   08859000
         BL    LOGERR30                 NOT YET                FX0000   08860000
         LA    R15,ERRSTK7+D1           END OF THE ERROR STACK FX0000   08861000
         ST    R15,ESTKNDX              POINTER TO NEXT ERROR  FX0000   08862000
         B     LOGERR99                                        FX0000   08863000
LOGERR30 DS    0H                                              FX0000   08864000
         L     R15,ESTKNDX              POINTER TO NEXT ERROR  FX0000   08865000
         MVC   D0(D2,R15),D0(R9)         INSERT SEV CODE ERR NUMBER     08866000
         MVI   D2(R15),J0                INSERT DATA LENGTH             08867000
         LA    R15,D3(,R15)             ADJUST STACK PTR FOR NEW ENTRY  08868000
         ST    R15,ESTKNDX              SAVE FOR NEXT ERROR ENTRY       08869000
LOGERR99 EQU   *                                               FX0000   08870000
         LM    R14,R15,GENREGS          RESTORE SAVED REGIS0ERS         08871000
         B     D2(,R9)                  RETURN TO CALLING RTN           08872000
         DROP  R12                                                      08873000
         SPACE 3                                                        08874000
         JPATCH  X3A00,E44              PATCH AREA                      08875000
         EJECT                                                          08876000
         JCSECT (X3A03)                                                 08877000
         SPACE                                                          08878000
*TITLE--                                                              * 08879000
*                                                                     * 08880000
*   RESOLVE/RESOLVE TERMS ROUTINE                                     * 08881000
*                                                                     * 08882000
*FUNCTION/OPERATION--                                                 * 08883000
*                                                                     * 08884000
*   PROCESSES ALL TERMS, LOOKING UP THOSE THAT ARE VARIABLE.  ON ENTRY* 08885000
*   R10 POINTS TO TERM.  ON OUTPUT, R11 CONTAINS VALUE OF THE TERM IF * 08886000
*   ARITHMETIC MODE, OR A POINTER TO L FIELD OF STRING IF CHARACTER.  * 08887000
*                                                                     * 08888000
         SPACE                                                          08889000
RESOLVE  EQU   *                                                        08890000
         SPACE                                                          08891000
RESOLV00 STM   R2,R9,RESOLVST           SAVE CALLERS REGISTERS          08892000
         LR    R8,R12                   ESTABLISH BASE FOR RTN          08893000
         USING RESOLV00,R8                                              08894000
         SPACE                                                          08895000
         USING JTMFLG,R10               DUMMY BASE                      08896000
         SET   CTYPE,OFF                INITIALLY ASSUME ARITHMETIC IN  08897000
         GOIF  JTMGBL,ON=RESOLV08       IF GLOBAL, GO SET SWITCH,       08898000
         SET   GLOBAL,OFF               ELSE MAKE SURE IT IS OFF        08899000
         B     RESOLV09                 AND CONTINUE AT COMMON POINT    08900000
RESOLV08 SET   GLOBAL,ON                MUST DO GLOBAL LOOKUP           08901000
RESOLV09 SET   JTMCSW,OFF               MAKE SURE FLAG IS CLEAN         08902000
         SPACE                                                          08903000
         GOIF  JTMSDT,EQ=RESOLV30       SELF DEFINING TERM              08904000
         GOIF  JTMSVC,EQ=RESOLV10,LT=RESOLV12     SET SYMBOL            08905000
         GOIF  JTMOSA,LT=RESOLV10,      GLOBAL SETC                    X08906000
               EQ=RESOLV80,             ORDINARY SYMBOL                X08907000
               ELSE=RESOLV70            PARAMETER OR SYSLIST            08908000
         DROP  R10                                                      08909000
         SPACE                                                          08910000
RESOLV10 EQU   *                        SET SYMBOL--SETC                08911000
         SET   CTYPE,ON                 INDICATE CHARACTER TYPE         08912000
RESOLV12 EQU   *                        SETA, SETB ENTRY                08913000
         GOIF  GLOBAL,OFF=RESOLV14      NOT GLOBAL, DO LOCAL LOOKUP     08914000
RESOLV13 DICTCALL GBLDICTR,POINTER==A(DICTENTR)   GLOBAL REFERENCE      08915000
         B     RESOLV15                 GO TO EXIT SEQUENCE             08916000
RESOLV14 DICTCALL LCLDICTR,POINTER==A(DICTENTR)   LOCAL REFERENCE       08917000
RESOLV15 GOIF  CTYPE,OFF=RESOLV17       NOT CHARACTER TYPE IN, BRANCH   08918000
RESOLV16 GOIF  CHARMODE,ON=RESOLV90,    CHARACTER IN, SAME OUT, EXIT   X08919000
               ELSE=ARTHCONV              ELSE CONVERT TO ARITHMETIC    08920000
RESOLV17 GOIF  CHARMODE,OFF=RESOLV90,   ARITH IN, ARITH OUT, EXIT      X08921000
               ELSE=CHARCONV              ELSE CONVERT TO CHARACTER     08922000
         SPACE 3                                                        08923000
RESOLV30 EQU   *                        SELF DEFINING TERM              08924000
         SPACE                                                          08925000
         USING STACK,R10                BASE FOR TERM                   08926000
         L     R11,STACKVAL             PICK UP VALUE                   08927000
         DROP  R10                                                      08928000
         B     RESOLV90                   AND RETURN                    08929000
         SPACE 3                                                        08930000
         SPACE                                                          08931000
RESOLV70 EQU   *                        SYSLIST OR PARAMETER            08932000
         SPACE                                                          08933000
         DICTCALL PARMTBLR,POINTER==A(DICTENTR)  DICTIONARY CALL        08934000
*        R11 NOW POINTS TO PARAMETER ENTRY HEADER.                      08935000
         SPACE                                                          08936000
         LR    R14,R11                  SAVE PARAMETER POINTER          08937000
         USING PARMTAB,R14              BASE FOR PARAMETER              08938000
         GOIF  PSUB,ON=RESOLV71         SUBLIST, SKIP AHEAD             08939000
         LA    R11,PKAT                 ELSE POINT TO CHARACTER STRING  08940000
         SET   SUBLIST,OFF              TURN SUBLIST FLAG OFF           08941000
         B     RESOLV72                 LENGTH AND EXIT.                08942000
RESOLV71 MVC   JHWORD1,PNAT             SUBLIST, ALIGN N ATTRIBUTE      08943000
         SET   SUBLIST,ON               AND TURN ON SUBLIST FLAG        08944000
         XC    JFWORD1,JFWORD1          CLEAR HOLDING AREA              08945000
         MVC   JFWORD1+D1(D3),PLIST     ALIGN SUBLIST VECTOR POINTER.   08946000
         SPACE                                                          08947000
RESOLV72 EQU   *                       GET PARAMETER BINARY VALUE.      08948000
         SPACE                                                          08949000
         GOIF  CHARMODE,YES=RESOLV90    CHARACTERS, RETURN.             08950000
         GOIF  PSUB,ON=LOGER113         ILLEGAL SUBLIST REFERENCE       08951000
         GOIF  PSDT,OFF=ARTHCONV        NOT SDT, GO CONVERT TO BINARY   08952000
         MVC   JFWORD1,PVAL             ALIGN THE VALUE                 08953000
         DROP  R14                                                      08954000
         L     R11,JFWORD1              AND PICK IT UP.                 08955000
         B     RESOLV90                 EXIT.                           08956000
         SPACE 3                                                        08957000
RESOLV80 EQU   *                        ORDINARY SYMBOL REFERENCE       08958000
         SPACE                                                          08959000
         DICTCALL ORDSYMBR,POINTER==A(DICTENTR) ORDINARY SYMBOL REF     08960000
         LR    R14,R11                  SAVE THE POINTER.               08961000
         B     RESOLV90                   AND RETURN.                   08962000
         SPACE 3                                                        08963000
LOGER113 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    08964000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08965000
         DC    AL1(SEV113,ERR113)       ERROR PARAMETERS                08966000
         SET   SUBLIST,OFF              CLEAN UP SUBLIST SWITCH         08967000
         SR    R11,R11                  SET UP DEFAULT VALUE TO RETURN  08968000
         B     RESOLV99                 PROCEED AS NORMAL               08969000
LOGER107 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    08970000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08971000
         DC    AL1(SEV107,ERR107)       ERROR PARAMETERS                08972000
         B     RESOLV98                 CONTINUE AT COMMON POINT        08973000
LOGER108 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    08974000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08975000
         DC    AL1(SEV108,ERR108)       ERROR PARAMETERS                08976000
         B     RESOLV98                 CONTINUE AT COMMON POINT        08977000
LOGER109 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    08978000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08979000
         DC    AL1(SEV109,ERR109)       ERROR PARAMETERS                08980000
         B     RESOLV98                 CONTINUE AT COMMON POINT        08981000
LOGER127 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    08982000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          08983000
         DC    AL1(SEV127,ERR127)       ERROR PARAMETERS                08984000
RESOLV98 EQU   *                                                        08985000
         SR    R11,R11                  SET UP DEFAULT VALUE TO RETURN  08986000
RESOLV90 EQU   *                        EXIT FROM ROUTINE               08987000
         SPACE                                                          08988000
RESOLV99 LM    R2,R9,RESOLVST           RESTORE CALLERS REGISTERS       08989000
         BR    R9                       RETURN TO CALLER                08990000
         EJECT                                                          08991000
*TITLE--                                                              * 08992000
*   ARTHCONV/CONVERT CHARACTER STRING TO ARITHMETIC VALUE             * 08993000
*                                                                     * 08994000
         SPACE                                                          08995000
*        ON ENTRY R11 POINTS TO L FIELD OF CHARACTER STRING             08996000
         SPACE                                                          08997000
ARTHCONV EQU   *                                                        08998000
         SPACE                                                          08999000
         USING JTMLNG,R11               BASE                            09000000
         GOIF  JTMLNG,MAXDEC,GT=LOGER107 TOO LONG TO CONVERT, ERROR     09001000
         SR    R1,R1                    CLEAR                           09002000
         IC    R1,JTMLNG                PICK UP STRING LENGTH           09003000
         DROP  R11                                                      09004000
         SPACE                                                          09005000
*        MAKE SURE WE HAVE ALL NUMERICS                                 09006000
         SPACE                                                          09007000
         GOIF  (R1),ZERO=LOGER109       NULL STRING, ERROR              09008000
         AR    R1,R11                   POINT PAST END OF STRING        09009000
ACONV10  EQU   *                                                        09010000
         USING JTMSTRNG,R1              NEW BASE                        09011000
         GOIF  JTMSTRNG,JNUMMAX,GT=LOGER108 NOT NUMERIC, ERROR          09012000
         BCTR  R1,D0                    COUNT BACK DOWN TO START        09013000
         GOIF  (R1),(R11),HI=ACONV10    MORE, ITERATE                   09014000
         SPACE                                                          09015000
*        NOW WE CAN CONVERT                                             09016000
         SPACE                                                          09017000
         USING JTMLNG,R1                                                09018000
         IC    R11,JTMLNG               PICK UP LENGTH OF CONVERT STRNG 09019000
         BCTR  R11,D0                   MAKE LENGTH L-1 FOR EXECUTE     09020000
         EX    R11,STRNGTRL             TRANSLATE STRING TO ZONED       09021000
         EX    R11,STRNGPCK             PACK ZONED TO PACKED            09022000
         EX    R11,STRNGTRL             TRANSLATE ZONED TO STRING       09023000
         OI    JDWORD+L'JDWORD-D1,JC    OR IN A PLUS FOR SIGN           09024000
         CLC   JDWORD,=PL8'2147483647'  CHECK FOR MAXIMUM ARITH VALUE   09025000
         BH    LOGER127                 TOO HIGH, ERROR                 09026000
         CVB   R11,JDWORD               AND CONVERT TO BINARY           09027000
         SPACE                                                          09028000
*        R11 CONTAINS RESULTANT VALUE                                   09029000
         SPACE                                                          09030000
         B     RESOLV90                 RETURN TO CALLER                09031000
STRNGTRL TR    JTMSTRNG(D0),JTRTABLE    EXECUTED STRING TRANSLATE       09032000
STRNGPCK PACK  JDWORD,JTMSTRNG          EXECUTED STRING PACK            09033000
         DROP  R1                                                       09034000
         EJECT                                                          09035000
*TITLE                                                                * 09036000
*   CHARCONV/CONVERT ARITHMETIC TO CHARACTER STRING                   * 09037000
*                                                                     * 09038000
         SPACE                                                          09039000
*        ON ENTRY R11 CONTAINS VALUE                                    09040000
         SPACE                                                          09041000
CHARCONV EQU   *                                                        09042000
         SPACE                                                          09043000
         CVD   R11,JDWORD               CONVERT TO P&CKED DECIMAL       09044000
         UNPK  UNPKBUF,JDWORD             AND UNPACK                    09045000
         NC    UNPKBUF,ZONEMASK         TRANSLATE TO INTERNAL           09046000
         GOIF  INMACRO,OFF=CCONV05      SYSNDX NOT IN OPEN CODE         09047000
         USING JTMFLG,R10                                               09048000
         GOIF  JTMSVA,GT=CCONV05        BRANCH IF NOT LOCAL SETA        09049000
         LA    R1,UNPKBUF+D12           SET UP PTR TO LEFT OF SYSNDX    09050000
         CLC   JTMPTR,=F'0'             SEE BY PTR IF SYSNDX            09051000
         BZ    CCONV10                  LEAVE ZEROS IF SYSNDX VALUE     09052000
         DROP  R10                                                      09053000
CCONV05  EQU   *                                                        09054000
         TRT   UNPKBUF,ZONEMASK         FIND FIRST SIGNIFICANT DIGIT    09055000
         BNZ   CCONV10                  EXIT POINTING                   09056000
         LA    R1,UNPKLAST              FAKE ONE IF NONE                09057000
         SPACE                                                          09058000
CCONV10  EQU   *                                                        09059000
         SPACE                                                          09060000
*        R1 CONTAINS ADDRESS OF FIRST NON-ZERO CHARACTER                09061000
         SPACE                                                          09062000
         LA    RCOMP0,UNPKEND           POINT TO ONE PAST END OF STRING 09063000
         SR    RCOMP0,R1                  AND COMPUTE STRING LENGTH     09064000
         BCTR  R1,D0                    BACK UP TO SPACE BEFORE THE     09065000
         LR    R11,R1                     STRING, USE R11 TO POINT TO   09066000
         USING JTMLNG,R11                 IT, AND STORE THE STRING      09067000
         STC   RCOMP0,JTMLNG              LENGTH IN IT.                 09068000
         DROP  R11                                                      09069000
         SPACE                                                          09070000
*        ON RETURN, R11 MUST POINT TO THE LENGTH FIELD OF THE STRING    09071000
         SPACE                                                          09072000
         B     RESOLV90                 EXIT                            09073000
         EJECT                                                          09074000
*TITLE--                                                              * 09075000
*   EVAL/GENERAL EVALUATION OF ALL META TEXT                          * 09076000
*                                                                     * 09077000
*FUNCTION/OPERATION--                                                 * 09078000
*   CONVERTS META TEXT FROM THE EDITOR INTO APPROPRIATE CHARACTER     * 09079000
*   STRINGS OR ARITHMETIC VALUES.  META TEXT IS AN ORDERED SEQUENCE   * 09080000
*   OF META TERMS AND OPERATORS.  TERMS ARE ENTERED IMMEDIATELY INTO  * 09081000
*   A PUSH DOWN STACK.  OPERATORS REMOVE TERMS FROM THE TOP OF THE    * 09082000
*   STACK AND RETURN VALUES TO THE STACK.  CHARACTER STRINGS ARE NOT  * 09083000
*   KEPT IN THE STACK, BUT ARE BUILT IN BUFFERS OR DIRECTLY IN TEXT.  * 09084000
*   THE FINAL RESULT OF EVALUATION IS A SINGLE TERM IN THE STACK,     * 09085000
*   WHOSE LOCATION IS KNOWN TO ALL CALLING ROUTINES.                  * 09086000
         SPACE 3                                                        09087000
EVAL     EQU   *                                                        09088000
         SPACE                                                          09089000
EVAL00   STM   R2,R9,EVALST             SAVE CALLERS REGISTERS          09090000
         LR    R8,R12                   ESTABLISH BASE FOR RTN          09091000
         USING EVAL00,R8                                                09092000
         SPACE                                                          09093000
         USING JTMOP,VTXTIN                                             09094000
         SPACE                                                          09095000
         L     STACKPTR,STACKLVL        GET STACK POINTER               09096000
EVAL10   GOIF  JTMHIOP,GT=EVAL80        TERMS GET PROCESSED OVER THERE  09097000
         SPACE                                                          09098000
*        BRANCH TABLE FOR OPERATORS                                     09099000
         SPACE                                                          09100000
         SR    INDEX1,INDEX1            CLEAR A REGISTER                09101000
         IC    INDEX1,JTMOP             PICK UP AN OPERATOR             09102000
         AR    INDEX1,INDEX1            DOUBLE IT                       09103000
         LH    INDEX1,OPTAB(INDEX1)     GET BRANCH DISPLACEMENT         09104000
         LA    VTXTIN,JTMPTR            BUMP PAST FLAG                  09105000
         B     EVALOPS(INDEX1)          BRANCH TO OP ROUTINE            09106000
         DROP  VTXTIN                                                   09107000
         SPACE                                                          09108000
OPTAB    DS    0H                       OPERATOR BRANCH TABLE           09109000
         SPACE                                                          09110000
         OPS   SCM                      START CHARACTER MODE            09111000
         OPS   PER                      PERIOD--CONCATENATION OPERATOR  09112000
         OPS   PLUS                     UNARY PLUS                      09113000
         OPS   MIN                      UNARY MINUS                     09114000
         OPS   MULT                     BINARY MULTIPLY                 09115000
         OPS   DIV                      BINARY DIVIDE                   09116000
         OPS   ADD                      BINARY ADD                      09117000
         OPS   SUB                      BINARY SUBTRACT                 09118000
         OPS   GT                       GREATER THAN                    09119000
         OPS   GE                       GREATER/EQUAL                   09120000
         OPS   LT                       LESS THAN                       09121000
         OPS   LE                       LESS/EQUAL                      09122000
         OPS   EQ                       EQUAL                           09123000
         OPS   NE                       NOT EQUAL                       09124000
         OPS   NOT                      NOT                             09125000
         OPS   AND                      AND                             09126000
         OPS   OR                       OR                              09127000
         OPS   STR                      SUB STRING OPERATION            09128000
         OPS   DUP                      DUPLICATION OPERATION           09129000
         OPS   DIM                      DIMENSION                       09130000
         OPS   DIM2                     SYSLIST(N,M) FIRST DIMENSION    09131000
         OPS   DIM3                     SYSLIST(N,M) SECOND DIMENSION   09132000
         OPS   STRM                     STATEMENT TERMINATOR            09133000
         OPS   TAT                      TYPE ATTRIBUTE                  09134000
         OPS   LAT                      LENGTH ATTRIBUTE                09135000
         OPS   SAT                      SCALE ATTRIBUTE                 09136000
         OPS   IAT                      INTERGER ATTRIBUTE              09137000
         OPS   KAT                      COUNT ATTRIBUTE                 09138000
         OPS   NAT                      NUMBER ATTRIBUTE                09139000
         SPACE                                                          09140000
EVALOPS  EQU   *                        ROOT FOR EVALUATION OPERATORS   09141000
         EJECT                                                          09142000
EVALDIM3 EQU   *                        APPLY SYSLIST(N,M) M TERM       09143000
         SPACE                                                          09144000
         USING JTMFLG,STACKPTR          BASE FOR TERM IN STACK          09145000
         SET   SUBSCR2,ON               INDICATE SECOND SUBSCRIPT       09146000
         SPACE                                                          09147000
EVALDIM  EQU   *                        DIMENSION OPERATOR              09148000
         SPACE                                                          09149000
*        DIMENSION IS THE LAST OPERATOR IN EVAL STACK, AND NEEDS TO BE  09150000
*        INSERTED INTO THE PRECEEDING ENTRY IF WITHIN RANGE.            09151000
         SPACE                                                          09152000
         BAL   RETURN,PREFXRES          RESOLVE LAST TERM               09153000
*        VALUE IS RETURNED IN EVEN REG.  STACKPTR IS NOT DECREMENTED.   09154000
         SH    STACKPTR,=Y(STKENTRY)    SO DECREMENT IT.                09155000
         GOIF  (EVEN),NEG=LOGER111      BRANCH IF SUBSCRIPT INVALID     09156000
         GOIF  JTMLSTO,EQ=DIM09         ACCEPT ZERO SUBSCRIPT IN BOTH   09157000
         CLI   JTMFLG,JTMLSTO+JTMCSW    SYSLIST CASES --                09158000
         BNE   DIM10                    SYSLIST(N) AND SYSLIST(N,M)     09159000
DIM09    GOIF  SUBSCR2,OFF=DIM11        BUT NOT IN M TERM OF (N,M)      09160000
DIM10    EQU   *                                                        09161000
         GOIF  (EVEN),POS=DIM11         ACCEPT ONLY POSITIVE OTHERWISE  09162000
LOGER111 EQU   *                                                        09163000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09164000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09165000
         DC    AL1(SEV111,ERR111)       ERROR PARAMETERS                09166000
         OI    JTMD,BIT0                INDICATE DEAD TERM              09167000
         SR    EVEN,EVEN                MAKE SURE DIMEN IS LOW VALUE    09168000
DIM11    EQU   *                                                        09169000
         STH   EVEN,JHWORD1             PUT IN STORAGE FOR SS USAGE     09170000
         GOIF  JTMCSW,OFF=DIM15         SKIP AHEAD IF NOT CHARACTER     09171000
         SET   JTMCSW,OFF               ELSE TURN OFF SWITCH IN TERM    09172000
         SET   CHARMODE,ON                AND ON FOR CHARACTER MODE.    09173000
DIM15    EQU   *                                                        09174000
         GOIF  SUBSCR2,ON=DIM19         BRANCH IF M OF SYSLIST(N,M)     09175000
         GOIF  JTMLSTO,EQ=DIM40,        BRANCH IF N OF SYSLIST(N)      X09176000
               GT=DIM20                 OR N OF PARAMETER(N)            09177000
         GOIF  JHWORD1,JTMD,LE=DIM20    GO ON WITH VALID DIMENSION      09178000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09179000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09180000
         DC    AL1(SEV112,ERR112)       ERROR PARAMETERS                09181000
         OI    JTMD,BIT0                INDICATE DEAD TERM              09182000
         B     DIM22                    CONTINUE WITH MAXIMUM DIMEN     09183000
DIM19    SET   SUBSCR2,OFF              CLEAN UP SECOND SUBSCRIPT FLAG  09184000
         MVI   JTMFLG,JTMPPAR           CONVERT SYSLIST TO PARAM REFER  09185000
DIM20    TM    JTMD,BIT0                SEE IF DEAD TERM FLAG ALREADY   09186000
         BO    DIM22                    BRANCH IF ON. OTHERWISE,        09187000
         MVC   JTMD,JHWORD1             APPLY THE DIMENSION             09188000
DIM22    GOIF  CHARMODE,OFF=EVAL10      EXIT IF NOT CHARACTER MODE      09189000
         L     FLDLN,RESRTRN            RESTORE LENGTH COUNTER          09190000
         LR    R10,STACKPTR             RESOLVE WANTS POINTER IN R10    09191000
         JCALL RESOLVE                  GET A CHARACTER STRING          09192000
         DROP  STACKPTR                                                 09193000
         L     R8,=A(GENSTRNG)          BASE FOR GENSTRNG ROUTINE       09194000
         USING GENSTRNG,R8                DECLARE--                     09195000
         B     GENSTR1X                 PASS RESULT TO GENSTRNG         09196000
         USING EVAL,R8                  RECOVER ROUTINE BASE            09197000
DIM40    EQU   *                                                        09198000
         USING JTMFLG,STACKPTR                                          09199000
         TM    JTMD,BIT0                SEE IF DEAD TERM FLAG ALREADY   09200000
         BO    DIM22                    BRANCH IF ON. OTHERWISE,        09201000
         MH    EVEN,=H'3'               CALCULATE SYSLIST VECTOR PTR    09202000
         ST    EVEN,JFWORD1             TEMPORARILY SAVE AND            09203000
         MVI   JTMFLG,JTMPPAR           CONVERT SYSLIST TO PARAM REFER  09204000
         MVC   JTMLSTN,JFWORD1+D1       INSERT INTO PTR FIELD OF TERM   09205000
         MVC   JTMLSTM,=H'0'            RESET DIMEN FLAG IN TERM        09206000
         B     DIM22                    GO BACK TO RESOLVE TERM         09207000
         DROP STACKPTR                                                  09208000
EVALDIM2 EQU   *                        APPLY SPECIAL SYSLIST DIMENSION 09209000
         SPACE                                                          09210000
         USING JTMFLG,STACKPTR          BASE FOR TERM IN STACK          09211000
         BAL   RETURN,PREFXRES          RESOLVE THE DIMENSION           09212000
         SH    STACKPTR,=Y(STKENTRY)      AND UPDATE THE STACK POINTER  09213000
         GOIF  (EVEN),NOTNEG=EDIM2A     OK FOR SYSLIST IF ZERO OR POS   09214000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09215000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09216000
         DC    AL1(SEV130,ERR130)       ERROR PARAMETERS                09217000
         OI    JTMD,BIT0                INDICATE DEAD TERM              09218000
         B     EVAL10                   AND CONTINUE                    09219000
EDIM2A   EQU   *                                                        09220000
         MH    EVEN,=H'3'               MAKE INTO A POINTER,            09221000
         ST    EVEN,JFWORD1             ALIGN,                          09222000
         MVC   JTMLSTN,JFWORD1+D1       AND MOVE INTO PTR IN TERM       09223000
         B     EVAL10                     AND CONTINUE.                 09224000
         DROP  STACKPTR                                                 09225000
         SPACE 3                                                        09226000
EVALSTR  EQU   *                                                        09227000
         SPACE                                                          09228000
*        LAST TWO STACK ENTRIES REPRESENT VALUES OF EXPRESSION 1 AND 2  09229000
*              OF SUBSTRING EXPRESSION.                                 09230000
         SPACE                                                          09231000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09232000
*        NOW EXPRESSION 1 VALUE IS IN EVEN REG AND EXPRESSION 2 IN      09233000
*              ODD REG.                                                 09234000
         SH    STACKPTR,=Y(STKENTRY)    DELETE XTRA TERM FROM STACK     09235000
         LA    R15,STRING2               POINT TO 2ND STRING            09236000
         GOIF  (R15),NEWSTRNG,LE=STR20  SKIP IF IN BUFFER 2             09237000
         LA    R15,STRING1              ELSE RESET TO FIRST STRING      09238000
         SPACE                                                          09239000
STR20    EQU   *                                                        09240000
         SPACE                                                          09241000
         USING JTMLNG,R15               BASE FOR STRING                 09242000
*        COMPUTE LENGTH OF CURRENT STRING--INITIAL STRING LENGTH MINUS  09243000
*              PREVIOUS STRING LENGTH.                                  09244000
         SPACE                                                          09245000
         SR    RCOMP1,RCOMP1            CLEAR A REGISTER                09246000
         IC    RCOMP1,JTMLNG            GET THE CURRENT LENGTH          09247000
         SH    RCOMP1,STRNGLN            SUBTRACT PREVIOUS LENGTH       09248000
         GOIF  (EVEN),POS=STR21         GO ON IF EXPRESSION 1 OK        09249000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09250000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09251000
         DC    AL1(SEV115,ERR115)       ERROR PARAMETERS                09252000
         SR    RCOMP1,RCOMP1            GIVE NULLSTRING                 09253000
         B     STR35                    FINISHED                        09254000
STR21    GOIF  (ODD),NOTNEG=STR22       GO ON IF EXPRESSION 2 OK        09255000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09256000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09257000
         DC    AL1(SEV116,ERR116)       ERROR PARAMETERS                09258000
         SR    RCOMP1,RCOMP1            GIVE NULLSTRING                 09259000
         B     STR35                    FINISHED                        09260000
STR22    GOIF  (RCOMP1),(EVEN),NOTLO=STR23 GO ON IF EXPR 1 OK WITH STR  09261000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09262000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09263000
         DC    AL1(SEV117,ERR117)       ERROR PARAMETERS                09264000
         SR    RCOMP1,RCOMP1            GIVE NULLSTRING                 09265000
         B     STR35                    FINISHED                        09266000
STR23    EQU   *                                                        09267000
         BCTR  EVEN,D0                  REDUCE TO ZERO ORIGIN           09268000
         SR    RCOMP1,EVEN              COMPUTE BALANCE OF STRING       09269000
         L     VTXTOUT,NEWSTRNG         START OF 'TO' FIELD             09270000
         A     EVEN,NEWSTRNG            START OF 'FROM' FIELD           09271000
         GOIF  (ODD),(RCOMP1),HIGH=STR30 ERROR IF EXPR 2 HIGH           09272000
         LR    RCOMP1,ODD               ELSE MOVE REQUESTED LENGTH      09273000
         B     STR32                    GO MOVE STRING                  09274000
         SPACE                                                          09275000
STR30    EQU   *                                                        09276000
         SPACE                                                          09277000
STR32    EX    RCOMP1,MOVESTR           REMOTE MOVE                     09278000
STR35    AH    RCOMP1,STRNGLN           ADD LENGTH OF REST OF TOTAL     09279000
         USING JTMLNG,R15               BASE FOR TOTAL STRING           09280000
         STC   RCOMP1,JTMLNG             STORE NEW LENGTH               09281000
         DROP  R15                                                      09282000
         B     EVAL10                   ITERATE                         09283000
MOVESTR  MVC   D0(D0,VTXTOUT),D0(EVEN)  REMOTE MOVE FOR STRING OPERATOR 09284000
         SPACE 3                                                        09285000
EVALDUP  EQU   *                        DUPLICATION FACTOR              09286000
         SPACE                                                          09287000
*        DUPLICATION FACTOR IS REPRESENTED BY LAST STACK ENTRY.         09288000
         SPACE                                                          09289000
         BAL   RETURN,PREFXRES          RESOLVE DUP FACTOR              09290000
         SPACE                                                          09291000
*        VALUE IS NOW IN EVEN REGISTER.                                 09292000
         SPACE                                                          09293000
         SH    STACKPTR,=Y(STKENTRY)    DELETE XTRA TERM FROM STACK     09294000
*        COMPUTE LENGTH OF CURRENT STRING AND GET POINTER TO STRING.    09295000
         SPACE                                                          09296000
         LA    R15,STRING2              POINT TO SECOND STRING          09297000
         GOIF  (R15),NEWSTRNG,LE=DUP20  SKIP IF IN BUFFER 2             09298000
         LA    R15,STRING1              ELSE POINT TO BUFFER 1          09299000
         SPACE                                                          09300000
DUP20    EQU   *                                                        09301000
         SPACE                                                          09302000
         LR    R0,R15                   SAVE STRING BUFFER POINTER      09303000
         USING JTMLNG,R15               BASE FOR STRING BUFFER          09304000
         SR    RCOMP1,RCOMP1            CLEAR A REGISTER                09305000
         IC    RCOMP1,JTMLNG            PICK UP THE STRING LENGTH       09306000
         DROP  R15                                                      09307000
         SH    RCOMP1,STRNGLN           SUBTRACT PRIOR STRING LENGTH    09308000
         LR    R14,RCOMP1               LENGTH OF STRING                09309000
         BCTR  R14,R0                   MACHINE LENGTH                  09310000
         USING STRING1,R15              DUMMY TEMPORARY BASE            09311000
         LA    R15,STRING2              COMPUTE A STOPPER               09312000
         SR    R15,RCOMP1                                               09313000
         DROP  R15                                                      09314000
         L     ODD,NEWSTRNG              START OF 'FROM' FIELD          09315000
         LR    VTXTOUT,ODD              START OF 'TO' FIELD             09316000
         SPACE                                                          09317000
*        START OF STRING IS IN 'ODD' AND LENGTH IS IN 'RCOMP1'          09318000
         SPACE                                                          09319000
         GOIF  (EVEN),ZERO=DUP90,POS=DUP30 PROCEED IF DUP FACTOR OK     09320000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09321000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09322000
         DC    AL1(SEV114,ERR114)       ERROR PARAMETERS                09323000
         B     DUP90                    GET OUT NOW WITH NULL           09324000
DUP30    EQU   *                        DUP LOOP (DOOP LUP)             09325000
         GOIF  (VTXTOUT),(R15),HIGH=DUP80    NOT ENOUGH ROOM, FAKE IT   09326000
DUP32    EX  R14,DUPMOVE                MOVE THE STRING                 09327000
DUP34    AR    VTXTOUT,RCOMP1           ADD LENGTH OF MOVED STRING      09328000
         BCT   EVEN,DUP30               LOOP CONTROL                    09329000
         SPACE                                                          09330000
*        DONE--BE SURE LENGTH IS UPDATED                                09331000
         SPACE                                                          09332000
DUP90    LR    R15,R0                   RESTORE STRING BUFFER BASE      09333000
         SR    VTXTOUT,R15              NEW LENGTH OF TOTAL STRING      09334000
         BCTR  VTXTOUT,D0               DONT COUNT LENGTH BYTE          09335000
         USING JTMSTRNG,R15                                             09336000
         STC   VTXTOUT,JTMSTRNG         STORE STRING LENGTH             09337000
         DROP  R15                                                      09338000
         B     EVAL10                   EXIT TO EVAL ITERATION POINT    09339000
DUPMOVE  MVC   D0(D0,VTXTOUT),D0(ODD)   REMOTE MOVE FOR DUP FACTOR      09340000
         SPACE 3                                                        09341000
DUP80    EQU   *                        MOVE A PARTIAL STRING           09342000
         SPACE                                                          09343000
         GOIF  ERR105SW,ON=DUP85        BYPASS IF ERROR ALREADY LOGGED  09344000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09345000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09346000
         DC    AL1(SEV105,ERR105)       ERROR PARAMETER                 09347000
         SET   ERR105SW,ON              INDICATE ERROR LOGGED ONCE      09348000
DUP85    AR    RCOMP1,R15               END OF BUFFER                   09349000
         SR    RCOMP1,VTXTOUT           REMAINING LENGTH                09350000
         LTR   R14,RCOMP1                                               09351000
         BZ    DUP90                    DONE IF NOTHING TO MOVE         09352000
         LA    EVEN,D1                  TO GET OUT OF LOOP              09353000
         B     DUP32                    GO MOVE                         09354000
         SPACE 3                                                        09355000
EVALSCM  EQU   *                        START CHARACTER MODE            09356000
         SPACE                                                          09357000
         SET   CCOMP,ON                 DO CHARACTER RELATIONALS        09358000
         L     VTXTOUT,STRPTR1            GET CURRENT CHARACTER BUFFER X09359000
                                          POINTER.                      09360000
         SPACE                                                          09361000
         ST    STACKPTR,STACKLVL        SAVE THE STACK POIN0ER          09362000
         L     R12,=A(GENSTRNG)         GENSTRING BASE                  09363000
         BALR  RETURN,R12                 AND LINK TO GENERATE A STRING 09364000
         LR    VTXTIN,R11               RECOVER META TEXT POINTER       09365000
EVALPER  EQU   *                                                        09366000
         SPACE                                                          09367000
         XC    STRPTR1,STRPTR2          FLIP BUFFERS                    09368000
         B     EVAL10                   DO SOME MORE.                   09369000
         SPACE 3                                                        09370000
         SPACE 3                                                        09371000
EVALSTRM EQU   *                        EXIT                            09372000
         SPACE                                                          09373000
         ST    STACKPTR,STACKLVL        SAVE THE STACK POINTER          09374000
         LR    R10,VTXTIN               META TEXT POINTER AS PARAMETER  09375000
EVAL99   LM    R2,R9,EVALST             RESTORE CALLERS REGISTERS       09376000
         BR    R9                       RETURN TO CALLER                09377000
         EJECT                                                          09378000
         USING STACK,STACKPTR           BASE FOR STACK OPERATIONS       09379000
         SPACE                                                          09380000
EVALADD  EQU   *                        ADD                             09381000
         SPACE                                                          09382000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09383000
         SPACE                                                          09384000
         AR    EVEN,ODD                 ADD                             09385000
         BNO   ADD80                    GO ON IF NO OVERFLOW            09386000
LOGER110 L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09387000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09388000
         DC    AL1(SEV110,ERR110)       ERROR PARAMETERS                09389000
         SR    EVEN,EVEN                SET UP DEFAULT VALUE            09390000
ADD80    ST    EVEN,STACKVAL            STORE THE VALUE                 09391000
         B     ARTHEXIT                   AND GO CLEAN UP               09392000
         SPACE 3                                                        09393000
EVALSUB  EQU   *                        SUBTRACT                        09394000
         SPACE                                                          09395000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09396000
         SPACE                                                          09397000
         SR    EVEN,ODD                 SUBTRACT                        09398000
         BO    LOGER110                 DIAGNOSE THE OVERFLOW           09399000
         B     ADD80                    OTHERWISE, FINISH UP NORMALLY   09400000
         SPACE 3                                                        09401000
EVALDIV  EQU   *                        DIVIDE                          09402000
         SPACE                                                          09403000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09404000
         GOIF  (ODD),ZERO=DIV80         SKIP DIVIDE ON ZERO DIVISOR     09405000
         LR    R0,ODD                   DIVISOR                         09406000
         SRDA  EVEN,D32                 SET UP DIVIDEND                 09407000
         DR    EVEN,R0                  DIVIDE                          09408000
DIV80    ST    ODD,STACKVAL             STORE DIVIDEND                  09409000
         B     ARTHEXIT                   AND GO CLEAN UP               09410000
         SPACE 3                                                        09411000
EVALMULT EQU   *                        MULTIPLY                        09412000
         SPACE                                                          09413000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09414000
         SPACE                                                          09415000
         MR    EVEN,EVEN                MULTIPLY                        09416000
         LTR   EVEN,EVEN                CHECK FOR OVERFLOW              09417000
         BNM   MULT79                   BRANCH IF NOT NEGATIVE SIGN     09418000
         LCR   EVEN,EVEN                CONVERT NEGATIVE TO POSITIVE    09419000
         BCTR  EVEN,D0                  DECREMENT. IF 1, WILL BE ZERO   09420000
         LTR   EVEN,EVEN                TEST FOR ZERO. IF NOT,          09421000
MULT79   EQU   *                                                        09422000
         BNZ   LOGER110                 GO TO PUT ERROR, SET DEFAULT    09423000
         ST    ODD,STACKVAL             RESULT GOES TO THE STACK        09424000
         B     ARTHEXIT                 AND GO CLEAN UP                 09425000
         DROP  STACKPTR                                                 09426000
         SPACE 3                                                        09427000
INFIXRES EQU   *                        RESOLVE FOR INFIX OPERATIONS    09428000
         SPACE                                                          09429000
         ST    RETURN,INFIXRTN          SAVE THE RETURN REGISTER        09430000
         LR    R10,STACKPTR             REGISTER FOR RESOLVE            09431000
         JCALL RESOLVE                  RESOLVE TO ARITHMETIC           09432000
         LR    ODD,R11                  PLACE VALUE IN COMP REGISTER    09433000
         SH    STACKPTR,=Y(STKENTRY)    BACK UP ONE TERM IN STACK       09434000
         SPACE                                                          09435000
INFIX50  EQU   *                        ENTRY FOR SINGLE TERM RESOLVE   09436000
         SPACE                                                          09437000
         LR    R10,STACKPTR             RESOLVE NEEDS IT IN R10         09438000
         JCALL RESOLVE                  RESOLVE TO ARITHMETIC           09439000
         LR    EVEN,R11                 PLACE VALUE IN OTHER COMP REG   09440000
         L     RETURN,INFIXRTN          RESTORE RETURN REGISTER         09441000
         BR    RETURN                     AND RETURN TO CALLER          09442000
         SPACE 3                                                        09443000
PREFXRES EQU   *                        RESOLVE FOR PREFIX OPERATIONS   09444000
         SPACE                                                          09445000
         ST    RETURN,INFIXRTN          SAVE THE RETURN REGISTER        09446000
         B     INFIX50                  AND RESOLVE ONE TERM            09447000
         SPACE 3                                                        09448000
RELATE   EQU   *                        ENTER IN THE STACK              09449000
         SPACE                                                          09450000
         USING JTMOP,VTXTIN             BASE FOR OPERATOR               09451000
         LA    VTXTIN,JTMPTR            SKIP UP TO NEXT OPERATOR/TERM   09452000
         DROP  VTXTIN                                                   09453000
         SPACE                                                          09454000
         USING STACK,STACKPTR           BASE FOR STACK ENTRY            09455000
         ST    EVEN,STACKVAL            STACK THE RESULT                09456000
         DROP  STACKPTR                                                 09457000
         B     RELTEXIT                 GO TO FINISH UP RELATIONALLY    09458000
         SPACE 3                                                        09459000
EVAL80   EQU   *                        ENTER ALL TERMS IN STACK        09460000
         SPACE                                                          09461000
         USING STACK,STACKPTR           BASE FOR STACK ENTRY            09462000
         USING JTMFLG,VTXTIN            BASE FOR TERM INPUT             09463000
         MVC   STACKNXT(TERMLNTH),JTMFLG  MOVE TERM TO STACK            09464000
         SET   JTMCSW,OFF               BE SURE TEXT SWITCHES ARE CLEAN 09465000
         LA    VTXTIN,JTMFLG+TERMLNTH   BUMP TEXT OVER TERM             09466000
         LA    STACKPTR,STACKNXT          AND OVER TERM IN STACK        09467000
         B     EVAL10                   GO BACK FOR MORE                09468000
         DROP  STACKPTR,VTXTIN                                          09469000
         SPACE 3                                                        09470000
EVALGT   EQU   *                        GENERAL                         09471000
EVALGE   EQU   *                          ENTRY                         09472000
EVALLT   EQU   *                            FOR                         09473000
EVALLE   EQU   *                              RELATIONAL                09474000
EVALEQ   EQU   *                                OPERATIONS              09475000
EVALNE   EQU   *                                  IS HERE.              09476000
         SPACE                                                          09477000
         BCTR  VTXTIN,D0                BACK UP TO RELATIONAL OPERATOR  09478000
         GOIF  CCOMP,ON=CHARREL         SWITCH ON, DO CHARACTER COMPARE 09479000
         SPACE                                                          09480000
ARTHREL  EQU   *                        ARITHMETIC RELATIONAL           09481000
         SPACE                                                          09482000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09483000
         GOIF  (EVEN),(ODD),MODE=A,HI=EVALHI,LO=EVALLO                 X09484000
                                        COMPARE AND BRANCH              09485000
         SPACE                                                          09486000
EVALEQU  EQU   *                        WE HAVE AN EQUAL COMPARE        09487000
         SPACE                                                          09488000
         USING JTMFLG,VTXTIN            BASE TO CHECK OPERATOR          09489000
         GOIF  JTMGE,LO=EVALNO          BRANCH IF OPERATOR IS GT        09490000
         GOIF  JTMLE,HI=EVALNO,         BRANCH IF OPERATOR IS LT, NE   X09491000
               ELSE=EVALYES             ELSE IT MUST BE GE, LE, EQ      09492000
         SPACE                                                          09493000
EVALHI   EQU   *                        HIGH COMPARE                    09494000
         SPACE                                                          09495000
         GOIF  JTMGE,LE=EVALYES         OPERATOR IS GE, GT              09496000
         GOIF  JTMNE,EQ=EVALYES,        OPERATOR IS NE                 X09497000
               ELSE=EVALNO              OPERATOR IS EQ, LE, LT          09498000
         SPACE                                                          09499000
EVALLO   EQU   *                        LOW COMPARE                     09500000
         SPACE                                                          09501000
         GOIF  JTMLE,GE=EVALYES,        OPERATOR IS LE, LT, NE         X09502000
               ELSE=EVALNO              OPERATOR IS GT, GE, EQ          09503000
         SPACE                                                          09504000
EVALYES  EQU   *                        YESS                            09505000
         SPACE                                                          09506000
         LA    EVEN,D1                  GIVE YES RESPONSE               09507000
         B     RELATE                     AND GO STORE IT               09508000
         SPACE                                                          09509000
EVALNO   EQU   *                        NO--                            09510000
         SPACE                                                          09511000
         SR    EVEN,EVEN                ZERO THE RESULT (NO)            09512000
         B     RELATE                     AND GO STORE IT               09513000
         DROP  VTXTIN                                                   09514000
         SPACE 3                                                        09515000
CHARREL  EQU   *                        CHARACTER RELATIONAL            09516000
         SPACE                                                          09517000
         SET   CCOMP,OFF                TURN OFF CHARACTER RELATIONAL  X09518000
                                          SWITCH.                       09519000
         USING STACK,STACKPTR           BASE FOR TERM STACK             09520000
         LA    STACKPTR,STACKNXT        A CHARACTER RELATIONAL CAUSES AX09521000
                                          NEW TERM TO BE ENTERED IN THEX09522000
                                          STACK--MAKE ROOM FOR IT.      09523000
         DROP  STACKPTR                                                 09524000
         CLC   STRING1(D1),STRING2      COMPARE STRING LENGTHS          09525000
         BH    EVALHI                   LONG                            09526000
         BL    EVALLO                   SHORT                           09527000
         IC    RMOVE,STRING1            ELSE COMPARE CHARACTERS--       09528000
         EX    RMOVE,TR1                BUFFER 1 TO EXTERNAL            09529000
         EX    RMOVE,TR2                BUFFER 2 TO EXTERNAL            09530000
         EX    RMOVE,COMP12             EXECUTED COMPARE                09531000
         EX    RMOVE,TR1                BUFFER 1 BACK AGAIN             09532000
         EX    RMOVE,TR2                BUFFER 2 BACK AGAIN             09533000
         BL    EVALLO                   LOW                             09534000
         BH    EVALHI                   HIGH                            09535000
         B     EVALEQU                  EQUAL                           09536000
         SPACE                                                          09537000
COMP12   CLC   STRING1(D0),STRING2      REMOTE COMPARE                  09538000
TR1      TR    STRING1(D0),JTRTABLE     REMOTE TRANSLATE STRING1        09539000
TR2      TR    STRING2(D0),JTRTABLE     LIKEWISE STRING2                09540000
         SPACE 3                                                        09541000
         USING STACK,STACKPTR           BASE FOR STACK OPERATIONS       09542000
         SPACE                                                          09543000
EVALOR   EQU   *                        OR                              09544000
         SPACE                                                          09545000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09546000
         OR    EVEN,ODD                 DO THE OR                       09547000
         ST    EVEN,STACKVAL            STORE THE RESULT                09548000
         B     ARTHEXIT                   AND EXIT.                     09549000
         SPACE                                                          09550000
EVALAND  EQU   *                        AND                             09551000
         SPACE                                                          09552000
         BAL   RETURN,INFIXRES          RESOLVE TWO TERMS               09553000
         NR    EVEN,ODD                 DO THE AND                      09554000
         ST    EVEN,STACKVAL            STORE THE RESULT                09555000
         B     ARTHEXIT                   AND EXIT                      09556000
         SPACE                                                          09557000
EVALNOT  EQU   *                        NOT                             09558000
         SPACE                                                          09559000
         BAL RETURN,PREFXRES            RESOLVE ONE TERM                09560000
         X     EVEN,=F'1'               REVERSE THE BIT                 09561000
         CL    EVEN,=F'1'               GT THAN ONE ?          @AZ10934 09562000
         BNH   EVALNOT5                 BR IF NOT, ELSE SET-   @AZ10934 09563000
         SR    EVEN,EVEN                TO ZERO                @AZ10934 09564000
EVALNOT5 EQU   *                                               @AZ10934 09565000
         ST    EVEN,STACKVAL            STORE THE RESULT                09566000
         B     ARTHEXIT                   AND EXIT                      09567000
         SPACE                                                          09568000
EVALMIN  EQU   *                        MINUS--UNARY                    09569000
         SPACE                                                          09570000
         BAL   RETURN,PREFXRES          RESOLVE ONE TERM                09571000
         LCR   EVEN,EVEN                COMPLEMENT                      09572000
         ST    EVEN,STACKVAL            STORE THE RESULT                09573000
         B     ARTHEXIT                   AND EXIT                      09574000
         DROP  STACKPTR                                                 09575000
         SPACE                                                          09576000
EVALPLUS EQU   *                        PLUS--UNARY                     09577000
         SPACE                                                          09578000
         B     EVAL10                   A NO-OP, EFFECTIVELY            09579000
RELTEXIT EQU   *                                                        09580000
         MVI   STRING1,D0               DROP STRING IF ANY              09581000
         MVI   STRING2,D0               DROP STRING IF ANY              09582000
ARTHEXIT EQU   *                        EXIT ROUTINE TO FOLLOW ARITH-  X09583000
                                          METIC OPERATIONS.             09584000
         USING STACK,STACKPTR                                           09585000
         MVI   STACKFLG,JTMSDT          NOW IT'S A SELF DEFINING TERM   09586000
         B     EVAL10                   AND RETURN TO EVAL MAINLINE     09587000
         DROP  STACKPTR                                                 09588000
         SPACE 3                                                        09589000
EVALTAT  EQU   *                        TYPE ATTRIBUTE                  09590000
         L     VTXTOUT,STRPTR1          SET UP PTR TO STRING BUFFER     09591000
         SPACE                                                          09592000
         SET   CCOMP,ON                 INDICATE CHARACTER COMPARES     09593000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09594000
         GOIF  JTMSVC,LT=TAT22          A OR B TYPE VARIABLE            09595000
         GOIF  JTMOSA,LT=TAT24          C TYPE VARIABLE                 09596000
         DROP  STACKPTR                                                 09597000
         LR    R10,STACKPTR             POINT TO TERM                   09598000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09599000
         JCALL RESOLVE                  RESOLVE IT                      09600000
         SET   CHARMODE,OFF                                             09601000
*        R14 POINTS TO HEADER                                           09602000
         USING PARMTAB,R14              BASE FOR ENTRY                  09603000
         GOIF  PTAT,JU,NE=TAT15         PICK UP TYPE IF NOT U           09604000
         GOIF  TDEFALT,ON=TAT23         DIAGNOSE IF U DEFAULTED         09605000
TAT15    IC    RMOVE,PTAT               PICK UP TYPE                    09606000
         DROP  R14                                                      09607000
         USING JTMLNG,VTXTOUT           BASE FOR OUTPUT                 09608000
TAT20    STC   RMOVE,JTMSTRNG           STORE TYPE                      09609000
         MVI   JTMLNG,D1                LENGTH OF 1                     09610000
         DROP  VTXTOUT                                                  09611000
         SH    STACKPTR,=Y(STKENTRY)    DELETE TERM FROM STACK          09612000
         XC    STRPTR1,STRPTR2          SWITCH BUFFERS.                 09613000
         B     EVAL10                   AND EXIT TO MAINLINE EVAL.      09614000
         SPACE                                                          09615000
TAT22    LA    RMOVE,JN                 TYPE N FOR A AND B VARIABLES    09616000
         B     TAT20                    CONTINUE                        09617000
TAT23    L     R12,=A(LOGERR01)         LOG ERROR 119                   09618000
         BALR  R9,R12                                                   09619000
         DC    AL1(SEV119,ERR119)                                       09620000
TAT24    LA    RMOVE,JU                 TYPE U FOR C VARIABLES          09621000
         B     TAT20                    CONTINUE                        09622000
         SPACE 3                                                        09623000
EVALSAT  EQU   *                        SCALE ATTRIBUTE                 09624000
         SPACE                                                          09625000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09626000
         GOIF  JTMLSTO,GT=SAT10         GO ON IF SCALE ATTR VALID       09627000
         GOIF  JTMOSA,EQ=SAT10          I.E., ORD SYMB OR PARAM         09628000
SAT05    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09629000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09630000
         DC    AL1(SEV123,ERR123)       ERROR PARAMETERS                09631000
         B     SAT07                    GET DEFAULT VALUE               09632000
SAT06    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09633000
         BALR  R9,R12                                                   09634000
         DC    AL1(SEV80,ERR80)         UNDEFINED SYMBOL                09635000
SAT07    SR    EVEN,EVEN                SET UP DEFAULT VALUE            09636000
         B     SAT20                    GO TO ASSIGN IT NORMALLY        09637000
SAT10    EQU   *                                                        09638000
         LR    R10,STACKPTR             POINTER FOR DICTIONARY CALL     09639000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09640000
         JCALL RESOLVE                  RESOLVE THE TERM                09641000
         SET   CHARMODE,OFF                                             09642000
         USING PARMTAB,R14              BASE FOR ATTRIBUTE REFERENCE    09643000
         GOIF  PTAT,JN,EQ=SAT05         LOOK FOR SELFDEFINING TERM      09644000
         GOIF  UDEFALT,ON=SAT06         REFERENCE TO UNDEFINED SYMBOL   09645000
         GOIF  SDEFALT,ON=SAT05         GOIF DEFAULTED VALUE            09646000
SAT15    EQU   *                                                        09647000
         XC    JFWORD1,JFWORD1          CLEAR                           09648000
         MVC   JFWORD1+D2(D2),PSAT      ALIGN                           09649000
         L     EVEN,JFWORD1             PICK UP                         09650000
         USING STACK,STACKPTR           BASE FOR NEW STACK ENTRY        09651000
SAT20    EQU   *                                                        09652000
         ST    EVEN,STACKVAL            AND STORE.                      09653000
         MVI   STACKFLG,JTMSDT          MAKE A SELF DEFINING TERM       09654000
         B     EVAL10                   BACK TO MAINLINE EVAL           09655000
         DROP  STACKPTR,R14                                             09656000
         SPACE 3                                                        09657000
EVALLAT  EQU   *                        LENGTH ATTRIBUTE                09658000
         SPACE                                                          09659000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09660000
         GOIF  JTMLSTO,GT=LAT10         GO ON IF LENGTH ATTR VALID      09661000
         GOIF  JTMOSA,EQ=LAT10          OR IF DIRECT ORD SYMB REFER     09662000
LAT05    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09663000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09664000
         DC    AL1(SEV120,ERR120)       ERROR PARAMETERS                09665000
         B     LAT07                    GET DEFAULT VALUE               09666000
LAT06    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09667000
         BALR  R9,R12                                                   09668000
         DC    AL1(SEV80,ERR80)         UNDEFINED SYMBOL                09669000
LAT07    L     EVEN,=F'1'               SET UP DEFAULT VALUE            09670000
         B     LAT20                    GO TO ASSIGN IT NORMALLY        09671000
LAT10    EQU   *                                                        09672000
         LR    R10,STACKPTR             POINTER FOR RESOLVE CALL        09673000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09674000
         JCALL RESOLVE                  RESOLVE THE TERM                09675000
         SET   CHARMODE,OFF                                             09676000
         USING PARMTAB,R14              BASE FOR REFERENCED ITEM        09677000
         GOIF  PTAT,JN,EQ=LAT05         CHECK IF SELFDEFINED TERM       09678000
         GOIF  UDEFALT,ON=LAT06         CHECK IF UNDEFINED SYMBOL       09679000
         GOIF  LDEFALT,ON=LAT05         CHECK IF DEFAULTED VALUE        09680000
         XC    JFWORD1,JFWORD1          CLEAR                           09681000
         MVC   JFWORD1+D2(D2),PLAT      ALIGN                           09682000
         L     EVEN,JFWORD1             PICK UP                         09683000
         USING STACK,STACKPTR           BASE FOR NEW STACK ENTRY        09684000
LAT20    EQU   *                                                        09685000
         ST    EVEN,STACKVAL            AND STORE.                      09686000
         MVI   STACKFLG,JTMSDT          MAKE INTO SELF DEFINING TERM    09687000
         B     EVAL10                   RETURN TO EVAL MAINLINE         09688000
         DROP  R14,STACKPTR                                             09689000
         SPACE 3                                                        09690000
EVALIAT  EQU   *                        INTEGER ATTRIBUTE               09691000
         SPACE                                                          09692000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09693000
         GOIF  JTMLSTO,GT=IAT10         GO ON IF INTEGER ATTR VALID     09694000
         GOIF  JTMOSA,NE=IAT15          I.E., ORD SYMB OR PARAM         09695000
IAT10    EQU   *                                                        09696000
         DROP  STACKPTR                                                 09697000
         LR    R10,STACKPTR             POINTER FOR RESOLVE             09698000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09699000
         JCALL RESOLVE                  RESOLVE THE TERM                09700000
         SET   CHARMODE,OFF                                             09701000
         USING PARMTAB,R14              BASE FOR REFERENCED ITEM        09702000
         GOIF  PTAT,JN,EQ=IAT15         CHECK IF SELFDEFINED TERM       09703000
         GOIF  UDEFALT,ON=IAT16         CHECK IF UNDEFINED SYMBOL       09704000
         GOIF  LDEFALT,ON=IAT17         CHECK IF LENGTH DEFAULTED       09705000
         XC    JFWORD1,JFWORD1          CLEAR                           09706000
         MVC   JFWORD1+D2(D2),PLAT      ALIGN                           09707000
         L     EVEN,JFWORD1             PICK UP                         09708000
IAT12    GOIF  SDEFALT,ON=IAT18         CHECK IF SCALE DEFAULTED        09709000
         XC    JFWORD1,JFWORD1          CLEAR                           09710000
         MVC   JFWORD1+D2(D2),PSAT      ALIGN                           09711000
         L     ODD,JFWORD1              PICK UP                         09712000
IAT13    LA    RCOMP1,PTAT              POINT TO TYPE ATTRIBUTE         09713000
         USING PTAT,RCOMP1              BASE FOR TYPE ATTRIBUTE         09714000
         GOIF  PTAT,JD,EQ=FLPIN         D IS FLOATING POINT             09715000
         GOIF  PTAT,JE,EQ=FLPIN         E IS TOO                        09716000
         GOIF  PTAT,JL,EQ=FLPIN         L IS ALSO                       09717000
         GOIF  PTAT,JK,EQ=FLPIN         K IS FLOATING PT, EXPLICIT LEN  09718000
         GOIF  PTAT,JP,EQ=PDECIN        P IS PACKED DECIMAL             09719000
         GOIF  PTAT,JZ,EQ=ZDECIN        Z IS ZONED DECIMAL              09720000
         GOIF  PTAT,JG,EQ=FXPIN         G IS FIXED PT, EXPLICIT LENGTH  09721000
         GOIF  PTAT,JF,EQ=FXPIN         F IS FIXED POINT                09722000
         GOIF  PTAT,JH,EQ=FXPIN         H LIKEWISE                      09723000
IAT15    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09724000
         BALR  R9,R12                                                   09725000
         DC    AL1(SEV124,ERR124)                                       09726000
         SR    EVEN,EVEN                DEFAULT VALUE                   09727000
         B     IAT20                    GO TO BUILD RESULTANT TERM      09728000
IAT16    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09729000
         BALR  R9,R12                                                   09730000
         DC    AL1(SEV80,ERR80)         UNDEFINED SYMBOL                09731000
         SR    EVEN,EVEN                SET UP DEFAULT VALUE            09732000
         B     IAT20                    STORE VALUE                     09733000
IAT17    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09734000
         BALR  R9,R12                                                   09735000
         DC    AL1(SEV120,ERR120)                                       09736000
         L     EVEN,=F'1'               DEFAULT VALUE                   09737000
         B     IAT12                    GET SCALE ATTRIBUTE             09738000
IAT18    L     R12,=A(LOGERR01)         ERROR ROUTINE                   09739000
         BALR  R9,R12                                                   09740000
         DC    AL1(SEV123,ERR123)                                       09741000
         SR    ODD,ODD                  DEFAULT SCALE ATTRIBUTE         09742000
         B     IAT13                    CALCULATE INTEGER ATTRIBUTE     09743000
         SPACE                                                          09744000
*INTEGER ATTRIBUTE IS COMPUTED AS FOLLOWS--                             09745000
*        FIXED POINT     I'=(L'*8)-1-S'                                 09746000
*        FLOATING POINT  I'=(L'-1)*2-S'      SHORT                      09747000
*                        I'=(L'-2)*2-S'      LONG                       09748000
*        PACKED DECIMAL  I'=(L'-2)-1-S'                                 09749000
*        ZONED DECIMAL   I'=L'-S'                                       09750000
         SPACE                                                          09751000
FXPIN    EQU   *                        FIXED POINT ENTRY               09752000
         SLL   EVEN,TIMES8              L' * 8                          09753000
         BCTR  EVEN,D0                  MINUS ONE                       09754000
         B     ZDECIN                   FIXED POINT CONTINUE            09755000
FLPIN    EQU   *                        FLOATING POINT ENTRY            09756000
         BCTR  EVEN,D0                  LENGTH ATTR MINUS ONE           09757000
         CH    EVEN,=H'7'               IF LENGTH IS M OR LESS,         09758000
         BNH   FLP2                     SKIP AROUND.                    09759000
         BCTR  EVEN,D0                  ELSE, MINUS ONE AGAIN           09760000
FLP2     AR    EVEN,EVEN                TIMES 2                         09761000
         B     ZDECIN                   FLOATING POINT CONTINUE         09762000
PDECIN   EQU   *                        PACKED DECIMAL ENTRY            09763000
         AR    EVEN,EVEN                L' * 2                          09764000
         BCTR  EVEN,D0                  MINUS ONE                       09765000
ZDECIN   EQU   *                        ZONED DECIMAL ENTRY             09766000
         SR    EVEN,ODD                 - S'                            09767000
         USING STACK,STACKPTR           STACK BASE                      09768000
IAT20    EQU   *                                                        09769000
         ST    EVEN,STACKVAL            STORE THE RESULT                09770000
         MVI   STACK,JTMSDT             AND MAKE IT A SELF DEFINING    X09771000
                                          TERM.                         09772000
         B     EVAL10                   BACK TO EVAL MAINLINE.          09773000
         DROP  STACKPTR,R14                                             09774000
         DROP  RCOMP1                                                   09775000
         SPACE 3                                                        09776000
EVALKAT  EQU   *                        COUNT ATTRIBUTE                 09777000
         SPACE                                                          09778000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09779000
         GOIF  JTMOSA,LT=KATT50         SET VARIABLE                    09780000
         GOIF  JTMLSTO,GT=KATT30        GO ON IF COUNT ATTR VALID       09781000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09782000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09783000
         DC    AL1(SEV121,ERR121)       ERROR PARAMETERS                09784000
         SR    EVEN,EVEN                SET UP DEFAULT VALUE            09785000
         B     KATT90                   GO TO ASSIGN IT NORMALLY        09786000
         SPACE                                                          09787000
KATT30   EQU   *                        PARAMETER COUNT ATTRIBUTE       09788000
         LR    R10,STACKPTR             TERM POINTER PASSED             09789000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09790000
         JCALL RESOLVE                  AND RESOLVE THE TERM.           09791000
         SET   CHARMODE,OFF                                             09792000
         USING PARMTAB,R14                                              09793000
         GOIF  PSUB,ON=KATT34           SUBLIST REFERENCE               09794000
         SR    EVEN,EVEN                CLEAR A REGISTER                09795000
         IC    EVEN,PKAT                AND PICK UP K ATTRIBUTE         09796000
         USING STACK,STACKPTR           BASE FOR NEW STACK ENTRY        09797000
KATT90   ST    EVEN,STACKVAL            STORE IN THE STACK              09798000
         MVI   STACKFLG,JTMSDT            AND MAKE IT AN SDT.           09799000
         B     EVAL10                   RETURN                          09800000
         SPACE                                                          09801000
KATT34   MVC   JHWORD1,PKATSUB          ALIGN SUBOPERAND K ATTRIBUTE    09802000
KATT35   LH    EVEN,JHWORD1             PICK UP VALUE                   09803000
         MVC   JHWORD1,PNAT             ALIGN AND                       09804000
         AH    EVEN,JHWORD1             ADD N ATTRIBUTE                 09805000
         LA    EVEN,D1(EVEN)            ADD 1--ACCOUNTS FOR COMMAS AND X09806000
                                          PARENS ADDED ON OUTPUT.       09807000
         B     KATT90                     AND CONTINUE                  09808000
         SPACE                                                          09809000
KATT50   EQU   *                        SET VARIABLE K ATTRIBUTE        09810000
         LR    R10,STACKPTR             TERM POINTER                    09811000
         SET   CHARMODE,ON                WE WANT CHARACTERS BACK       09812000
         JCALL RESOLVE                  RESOLVE THE TERM TO A STRING    09813000
         SET   CHARMODE,OFF             (SWITCH BACK OFF)               09814000
         USING JTMLNG,R11               BASE FOR STRING                 09815000
         SR    EVEN,EVEN                CLEAR A REGISTER                09816000
         IC    EVEN,JTMLNG              PICK UP LENGTH AS K ATTRIBUTE   09817000
         DROP  R11                                                      09818000
         B     KATT90                   CONTINUE                        09819000
         DROP  R14,STACKPTR                                             09820000
         SPACE 3                                                        09821000
EVALNAT  EQU   *                        NUMBER ATTRIBUTE                09822000
         SPACE                                                          09823000
         USING JTMFLG,STACKPTR          BASE FOR TERM                   09824000
         GOIF  JTMLSTO,EQ=NAT40,        BRANCH IF SYSLIST REFERENCE    X09825000
               GT=NAT10                 BRANCH IF PARAMETER REFER       09826000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    09827000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          09828000
         DC    AL1(SEV122,ERR122)       ERROR PARAMETERS                09829000
         SR    EVEN,EVEN                SET UP DEFAULT VALUE            09830000
         B     KATT90                   GO TO ASSIGN IT NORMALLY        09831000
NAT10    LR    R10,STACKPTR             TERM POINTER                    09832000
         SET   CHARMODE,ON              NO ARITHMETIC CONVERSION        09833000
         JCALL RESOLVE                  RESOLVE THE TERM                09834000
         SET   CHARMODE,OFF                                             09835000
         USING PARMTAB,R14              BASE FOR PARAMETER              09836000
         GOIF  PSUB,ON=NAT20            SUBLIST, SKIP AHEAD             09837000
         GOIF  POMIT,ON=NAT50           CHECK FOR OMITTED OPERAND       09838000
         LA    EVEN,D1                  ELSE N ATTRIBUTE IS 1           09839000
         B     KATT90                   EVIT                            09840000
NAT20    MVC   JHWORD1,PNAT             ALIGN                           09841000
         LH    EVEN,JHWORD1             PICK UP VALUE                   09842000
         SET   SUBLIST,OFF              CLEAR SUBLIST SWITCH   @OX09721 09843000
         B     KATT90                   AND EXIT                        09844000
         SPACE                                                          09845000
NAT40    EQU   *                        SYSLIST                         09846000
         TM    JTMLSTM,BIT0             LOOK FOR DEAD TERM              09847000
         BO    NAT50                    GIVE DEFAULT IF FOUND           09848000
         SPACE                                                          09849000
         LH    EVEN,NOFSYSLS            ELSE LOAD N'SYSLIST             09850000
         B     KATT90                   AND EXIT.                       09851000
NAT50    SR    EVEN,EVEN                SET N ATTRIBUTE TO ZERO         09852000
         B     KATT90                   AND EXIT                        09853000
         DROP  STACKPTR,R14                                             09854000
         EJECT                                                          09855000
*TITLE                                                                * 09856000
*   GENSTRING/GENERATE A CHARACTER STRING                             * 09857000
         SPACE                                                          09858000
*NOTES-                                                               * 09859000
*   REGISTERS--                                                       * 09860000
*                                                                     * 09861000
*   ENTRY--                                                           * 09862000
*                                                                     * 09863000
*   VTXTOUT    LENGTH FIELD OF CURRENT STRING                         * 09864000
*   VTXTIN     META TEXT                                              * 09865000
*                                                                     * 09866000
*   EXIT--                                                            * 09867000
*                                                                     * 09868000
*   R10        NEXT AVAILABLE OUTPUT POSITION                         * 09869000
*   R11        NEXT META FLAG                                         * 09870000
*        STACKPTR   CURRENT EVALUATION STACK ENTRY                      09871000
         SPACE                                                          09872000
GENSTRNG EQU   *                                                        09873000
GENSTR00 STM   R2,R9,GENSTRST           SAVE CALLERS REGISTERS          09874000
         LR    R8,R12                   ESTABLISH BASE FOR RTN          09875000
         USING GENSTR00,R8                                              09876000
         SPACE                                                          09877000
         USING JTOPL,VTXTOUT            DUMMY OUTPUT BASE               09878000
         ST    VTXTOUT,GENPTR           SAVE POINTER TO LENGTH          09879000
         SR    FLDLN,FLDLN              CLEAR A REGISTER                09880000
         IC    FLDLN,JTOPL              PICK UP CURRENT STRING LENGTH   09881000
         LA    VTXTOUT,JTOPND(FLDLN)      AND STEP TO END OF STRING.    09882000
         ST    VTXTOUT,NEWSTRNG         SAVE THIS STRING START          09883000
         STH   FLDLN,STRNGLN            AND PREVIOUS LENGTH             09884000
         USING JTOPND,VTXTOUT           RESET BASE                      09885000
         SET   CHARMODE,ON              WE WANT CHARACTERS BACK         09886000
         SET   ERR105SW,OFF             CLEAR ERROR LOGGED SWITCH       09887000
         SET   SUBLIST,OFF              CLEAR SUBLIST SWITCH            09888000
         SPACE                                                          09889000
GENSTR10 EQU   *                        ITERATION POINT                 09890000
         SPACE                                                          09891000
         USING JTMOP,VTXTIN             VTXTIN POINTS TO META OPERATOR  09892000
         GOIF  SUBLIST,ON=GENSTR32      IF SUBLIST SWITCH IS ON, MUST  X09893000
                                          MOVE ENTIRE SUBLIST.  REENTERX09894000
                                          AT GENSTR14 AFTER PREPARATION 09895000
         GOIF  JTMSTRM,EQ=GENSTR90      EXIT IF STATEMENT TERMINATOR    09896000
         GOIF  JTMECM,EQ=GENSTR80         OR END CHARACTER MODE.        09897000
         SPACE                                                          09898000
         GOIF  JTMCS,NE=GENSTR12        NOT CHARACTER STRING, SKIP      09899000
         SR    RMOVE,RMOVE              HAS GARBAGE ON RECURSION        09900000
         IC    RMOVE,JTMLNG               BEFORE PROCEEDING,            09901000
         LA    R11,JTMLNG               POINT R11 TO L FIELD OF STRING  09902000
         LA    VTXTIN,JTMSTRNG(RMOVE)   AND UPDATE THE META TEXT PTR    09903000
         B     GENSTR16                 SKIP AHEAD                      09904000
         SPACE                                                          09905000
GENSTR12 EQU   *                        PREPARE TO RESOLVE TERM         09906000
         SPACE                                                          09907000
         GOIF  JTMLSTO,EQ=GENSTR15      SYSLIST, GO GET DIMENSION       09908000
         GOIF  JTMD,FZERO,EQ=GENSTR13   NO DIMENSION, PROCEED           09909000
GENSTR15 SET   JTMCSW,ON                ELSE SET TEMPORARY CHARACTER   X09910000
                                          FLAG.                         09911000
         SET   CHARMODE,OFF             NO LONGER IN CHARACTER MODE     09912000
         ST    FLDLN,RESRTRN            SAVE STRING LENGTH COUNTER      09913000
         L     STACKPTR,STACKLVL        PICK UP CURRENT STACK POINTER   09914000
         L     R8,=A(EVAL)              BASE FOR EVAL ROUTINE           09915000
         USING EVAL,R8                    DECLARED--                    09916000
         B     EVAL80                   GO EVALUATE DIMENSION           09917000
         USING GENSTRNG,R8              RE-DECLARE ROUTINE BASE         09918000
         SPACE                                                          09919000
GENSTR13 EQU   *                                                        09920000
         SPACE                                                          09921000
         LR    R10,VTXTIN               R10 WANTS TERM POINTER          09922000
         LA    VTXTIN,JTMNEXT             AND VTXTIN NEEDS UPDATE       09923000
         JCALL RESOLVE                  RESOLVE PRODUCES A STRING       09924000
         DROP  VTXTIN                                                   09925000
         USING JTMLNG,R11               BASE                            09926000
GENSTR1X EQU   *                                                        09927000
         GOIF  SUBLIST,ON=GENSTR30      SUBLIST SWITCH ON, BRANCH       09928000
GENSTR14 SR    RMOVE,RMOVE              CLEAR A REGISTER                09929000
         IC    RMOVE,JTMLNG             PICK UP STRING LENGTH           09930000
GENSTR16 EQU   *                                                        09931000
         GOIF  (RMOVE),ZERO=GENSTR10    NULL STRING IF L=0              09932000
         DROP  R11                                                      09933000
         AR    FLDLN,RMOVE              INCREMENT LENGTH COUNTER        09934000
         GOIF  (FLDLN),HMAXCHAR,GT=LOGER105  GENERATED STRING TOO LONG  09935000
GENSTR18 EQU   *                                                        09936000
         BCTR  RMOVE,D0                 DECREMENT TO MOVE LENGTH        09937000
         EX    RMOVE,GENMOVE            EXECUTED MOVE                   09938000
         LA    VTXTOUT,D1(RMOVE,VTXTOUT)     INCREMENT OUTPUT POINTER  X09939000
                                               TO END OF STRING         09940000
         B     GENSTR10                 ITERATE                         09941000
         SPACE                                                          09942000
         USING JTMLNG,R11                                               09943000
GENMOVE  MVC   JTOPND,JTMSTRNG          REMOTE MOVE CHARACTER STRING TOX09944000
                                          OUTPUT.                       09945000
         DROP  R11,VTXTOUT                                              09946000
GENSTR80 EQU   *                        END CHARACTER MODE              09947000
GENSTR90 EQU   *                        END OF STATEMENT                09948000
         SPACE                                                          09949000
         L     INDEX1,GENPTR            PICK UP LENGTH POINTER          09950000
         USING JTMLNG,INDEX1              AND USE AS BASE               09951000
         STC   FLDLN,JTMLNG             STORE FIELD LENGTH              09952000
         DROP  INDEX1                                                   09953000
         LR    R10,VTXTOUT              SAVE THE OUTPUT POINTER         09954000
         SET   CHARMODE,OFF             INACTIVATE CHARACTER MODE SW    09955000
         USING JTMFLG,VTXTIN            BASE FOR INPUT                  09956000
         LA    R11,JTMPTR               BUMP TO NEXT POTENTIAL FLAG     09957000
         DROP  VTXTIN                                                   09958000
GENSTR99 LM    R2,R9,GENSTRST           RESTORE CALLERS REGISTERS       09959000
         BR    R9                       RETURN TO CALLER                09960000
         SPACE                                                          09961000
GENSTR30 EQU   *                        STRING IS ENTIRE SUBLIST        09962000
         SPACE                                                          09963000
         LR    R10,R14                  COMPUTE SUBLIST                 09964000
         A     R10,JFWORD1              VECTOR POINTER.                 09965000
         LA    FLDLN,D1(,FLDLN)         INCREMENT STRING COUNT          09966000
         GOIF  (FLDLN),HMAXCHAR,GT=LOG105X   GENERATED STRING TOO LONG  09967000
         USING JTOPND,VTXTOUT           BASE FOR OUTPUT                 09968000
         MVI   JTOPND,JLPARN            OUTPUT A LEFT PAREN             09969000
         DROP  VTXTOUT                                                  09970000
         LA    VTXTOUT,D1(VTXTOUT)      UPDATE THE OUTPUT POINTER       09971000
         B     GENSTR35                 AND SKIP AHEAD                  09972000
         SPACE                                                          09973000
GENSTR32 LH    R15,JHWORD1              DECREMENT                       09974000
         GOIF  (R15),ZERO=GENSTR33      EXIT ON SUBOPERANDS EXHAUSTED   09975000
         BCT   R15,GENSTR34               PARAMETER COUNT AND CONTINUE. 09976000
         STH   R15,JHWORD1              PRESERVE SUBOPERAND COUNT (0)   09977000
         LA    FLDLN,D1(,FLDLN)         BUMP OUTPUT COUNT               09978000
         GOIF  (FLDLN),HMAXCHAR,GT=LOG105X GENERATED STRING TOO LONG    09979000
         USING JTOPND,VTXTOUT                                           09980000
         MVI   JTOPND,JRPARN            OUTPUT TERMINATING RIGHT PAREN  09981000
         DROP  VTXTOUT                                                  09982000
         LA    VTXTOUT,D1(,VTXTOUT)     UPDATE THE OUTPUT PTR           09983000
GENSTR33 EQU   *                                                        09984000
         SET   SUBLIST,OFF              TURN OFF THE SUBLIST FLAG AND   09985000
         B     GENSTR10                 GO BACK FOR MORE STRINGING      09986000
         SPACE                                                          09987000
GENSTR34 STH   R15,JHWORD1              ELSE SAVE THE COUNT.            09988000
         LA    FLDLN,D1(FLDLN)          BUMPT OUTPUT COUNT.             09989000
         GOIF  (FLDLN),HMAXCHAR,GT=LOG105X   GENERATED STRING TOO LONG  09990000
         USING JTOPND,VTXTOUT           BASE FOR OUTPUT TEXT            09991000
         MVI   JTOPND,JCOMMA            MOVE COMMA TO TEXT              09992000
         DROP  VTXTOUT                                                  09993000
         LA    VTXTOUT,D1(VTXTOUT)        AND UPDATE OUTPUT POINTER.    09994000
GENSTR35 SH    R10,=H'3'                BACK UP TO NEXT SUBLIST VECTOR  09995000
         MVC   JFWORD1+D1(D3),D0(R10)   ALIGN THE VECTOR                09996000
         L     R11,JFWORD1              PICK UP THE VECTOR              09997000
         USING PFLAG,R14                BASE FOR SUBOPERAND FETCH       09998000
         LA    R11,PKAT(R11)            POINT TO SUBOPERAND.            09999000
         B     GENSTR14                 AND CONCATENATE IT TO STRING    10000000
         SPACE                                                          10001000
LOG105X  LA    RMOVE,D1                 SET UP COUNT ON OVERFLO CHAR    10002000
LOGER105 GOIF  ERR105SW,ON=GENSTR50     BYPASS IF ERROR ALREADY LOGGED  10003000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    10004000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          10005000
         DC    AL1(SEV105,ERR105)       ERROR PARAMETERS                10006000
         SET   ERR105SW,ON              INDICATE ERROR LOGGED ONCE      10007000
GENSTR50 EQU   *                                                        10008000
         SR    FLDLN,RMOVE              GET BASE STRING LENGTH          10009000
         LH    RMOVE,HMAXCHAR           SET UP MAXIMUM STRING LENGTH    10010000
         SR    RMOVE,FLDLN              COMPUTE ALLOWABLE INCREMENT     10011000
         LTR   RMOVE,RMOVE              SEE IF INCREMENT ZERO           10012000
         BZ    GENSTR10                 IF SO, DON'T BOTHER, ELSE       10013000
         AR    FLDLN,RMOVE              ADJUST LENGTH FOR FRAGMENT      10014000
         B     GENSTR18                 GO BACK TO ADD MAXIMUM POSSIB   10015000
         EJECT                                                          10016000
ZONEMASK DC    X'00',15X'0F'            MASK TO DROP LEADING ZEROS OR  X10017000
                                          MASK OUT ZONES AFTER UNPACK   10018000
HMAXCHAR DC    Y(MAXCHAR)               MAXIMUM STRING LENGTH           10019000
FZERO    DC    F'0'                     ZEROS FOR COMPARES              10020000
         SPACE 3                                                        10021000
         SPACE 3                                                        10022000
         JPATCH  X3A03,B4A              PATCH AREA                      10023000
         END   MENTRY                                                   10024000
./ ADD NAME=IFNX3K                                                      10025000
         GENOP PHASE=3,                                                X10026000
               LEVEL=1                                                  10027000
         END                                                            10028000
./ ADD NAME=IFNX4D                                                      10029000
X4D      XDCDS TESTRAN=NO                                               10030000
         JPATCH X4D00,646                                               10031000
         END                                                            10032000
./ ADD NAME=IFNX4E                                                      10033000
X4E      XDICT                                                          10034000
         JPATCH X4E00,7BE                                               10035000
         END                                                            10036000
./ ADD NAME=IFNX4M                                                      10037000
X4M      XFOUR TESTRAN=NO                                               10038000
         JPATCH X4M00,C0E                                               10039000
         END   I                                                        10040000
./ ADD NAME=IFNX4N                                                      10041000
X4N      XDCDS TESTRAN=YES                                              10042000
         JPATCH X4N00,896                                               10043000
         END                                                            10044000
./ ADD NAME=IFNX4S                                                      10045000
X4S      XSTBL                                                          10046000
         JPATCH X4S00,182                                               10047000
         END                                                            10048000
./ ADD NAME=IFNX4T                                                      10049000
X4T      XFOUR TESTRAN=YES                                              10050000
         JPATCH X4T00,D35                                               10051000
         END   I                                                        10052000
./ ADD NAME=IFNX4V                                                      10053000
X4V      XEVAL                                                          10054000
         JPATCH X4V00,592                                               10055000
         END                                                            10056000
./ ADD NAME=IFNX5A                                                      10057000
* /* START OF SPECIFICATIONS ****                                       10058000
*02* PROCESSOR = ASSEMBLER                                              10059000
**** END OF SPECIFICATIONS ***/                                         10060000
         GBLC  &COMPNM,&ASMID                                           10061000
         JHEAD 'ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE',          X10062000
               PHASEID=X5A,                                            X10063000
               LEVEL=13                                                 10064000
*FUNCTION/OPERATION-                                                  * 10065000
*   THIS SUBROUTINE IS CALLED FOR EACH ASSEMBLER OPCODE ENCOUNTERED   * 10066000
*   IN THE TEXT STREAM.  THIS ROUTINE IS CALLED BY MAINLINE CONTROL.  * 10067000
*   THE ONLY ASSEMBLER OPCODES THAT CAUSE PUNCH OR LINK OUTPUT IS DC'S* 10068000
*   CCW'S AND CNOP'S. ALL ASSEMBLER OPCODES CAUSE THE PRINT ROUTINE   * 10069000
*   TO BE CALLED. THE ASSEMBLER OPCODES ARE EVALUATED AND THE PROPER  * 10070000
*   TABLES ARE UPDATED OR THE PUNCH TEXT IS PREPARED THEN THE OUTPUT  * 10071000
*   ROUTINE IS CALLED. FOR DC'S THE OUTPUT ROUTINE WILL BE CALLED FOR * 10072000
*   EACH 8 BYTES, OR FRACTION THEREOF, OF PUNCHED OUTPUT.             * 10073000
*                                                                     * 10074000
*ENTRY POINT-                                                         * 10075000
*        AOP100                                                       * 10076000
*                                                                     * 10077000
*INPUT-                                                               * 10078000
*   INTERNAL TEXT RECORDS RETRIEVED IN MAINLINE CONTROL.              * 10079000
*   SYMBOL REFERENCE FILE.                                            * 10080000
*                                                                     * 10081000
*OUTUT-                                                               * 10082000
*   LISTING OF ASSEMBLER OPCODES.                                     * 10083000
*   PUNCH FILE OUTPUT FOR DC'S, CCW'S AND CNOP'S.                     * 10084000
*                                                                     * 10085000
*EXTERNAL ROUTINES-                                                   * 10086000
*        FORMATING, PRINT AND PUNCH ROUTINE                           * 10087000
*        EVAL - EXPRESSION EVALUATION.                                * 10088000
*        DCEVAL- DC EVALUATION ROUTINE                                * 10089000
*                                                                     * 10090000
*EXITS, NORMAL-                                                       * 10091000
*   EXITS TO MAINLINE CONTROL.                                        * 10092000
*                                                                     * 10093000
*EXITS, ERROR-                                                        * 10094000
*   NONE                                                              * 10095000
*                                                                     * 10096000
*TABLES/WORK AREAS-                                                   * 10097000
*   ASSEMBLY COMMON                                                   * 10098000
*   USING TABLE                                                       * 10099000
*                                                                     * 10100000
*ATTRIBUTES-                                                          * 10101000
*   REFRESHABLE                                                       * 10102000
*                                                                     * 10103000
*NOTES-                                                               * 10104000
*   NONE                                                              * 10105000
*                                                                     * 10106000
*                                                                     * 10107000
         SPACE 2                                                        10108000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10109000
               - COPY CODE '                                            10110000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   10111000
         COPY  JCOMMON                                                  10112000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     10113000
         COPY  JTEXT                                                    10114000
         PRINT OFF                      DON'T PRINT X5COM COPY CODE     10115000
         COPY  X5COM                                                    10116000
         PRINT ON                       PRINT RSYMRCD COPY CODE         10117000
DSECT10  DSECT ,                        DEFINE RESOLUTION DATA DSECT    10118000
         COPY  RSYMRCD                  COPY DSECT ITEMS                10119000
         PRINT OFF                      DON'T PRINT JRXLFMTS COPY CODE  10120000
         COPY  RXLFMTS                  POST PROCESSOR RECORD FORMATS   10121000
         PRINT OFF                      DON'T PRINT JERRMSGCD COPY CODE 10122000
         COPY  JERMSGCD                 DEFINE ERROR CODES AND SEVERITY 10123000
         PRINT OFF                      DON'T PRINT JERRCD COPY CODE    10124000
         COPY  JERRCD                   COPY ERR RECORD FORMAT          10125000
         PRINT ON                       THAT'S ALL THE COPY CODE        10126000
         SPACE 3                                                        10127000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10128000
               - INITIALIZATION '                                       10129000
         JCSECT (X5A00)                 START CSECT                     10130000
* VS1 RELEASE 2 CHANGES                                                 10131000
*D159320                                                        OX00216 10132000
*C133500                                                        OX00219 10133000
*C214900-215600                                                 OX00220 10134000
* VS1 RELEASE 2.6 CHANGES                                               10135000
*A484500,485000,485600-485780,514420                            OX00222 10136000
*C503300,513800                                                 OX00222 10137000
*D485100,486280-487900                                          OX00222 10138000
* VS1 RELEASE 3 CHANGES                                                 10139000
*D492800                                                        OX00086 10140000
*A493600,494000                                                 OX00086 10141000
*C158900,158920,159000                                          OX01760 10142000
* VS1 RELEASE 3.1 CHANGES                                               10143000
*D484500                                                        OY01863 10144000
*A485742                                                        OY01863 10145000
*C164500,903700,905100                                          OX02675 10146000
*A199900-200900                                                 OX05796 10147000
*C202300                                                        OX05796 10148000
*A208400-208520                                                 OX05796 10149000
*C208600                                                        OX05796 10150000
*A199500,199600,208000,208100                                   OY06130 10151000
*C199900,208400                                                 OY06130 10152000
* VS1 RELEASE 040 CHANGES                                               10153000
*A158300                                                       @OY06117 10154000
*C653800,654500,664300,665000,670600,702100,702800             @OX08876 10155000
*A658500,712400                                                @OX08876 10156000
*D684600,685300                                                @OX08876 10157000
*D870800,A885300                                               @OX11000 10158000
*A211000,213400-213932,214167-214191                           @AZ07356 10159000
*A056700                                                       @AY12907 10160000
         JMODID ,                       MODULE IDENTIFICATION           10161000
         USING JTEXT,R5                 FIXED TEXT PART                 10162000
         USING JTEXTA,R4                VARIABLE TEXT PART              10163000
         USING X5COM,R7                 PHASE COMMON AREA               10164000
         USING DSECT10,R11              RESOLVED SYMBOL DATA USING      10165000
         SPACE 2                                                        10166000
AOP100   JSAVE BASE=YES                 SAVE CALLING REGISTERS          10167000
         LA    R3,AOP100+4095           SET UP USING REGISTER           10168000
         LA    R3,D1(R3)                INCREMENT 1                     10169000
         USING AOP100+4096,R3           SET USING FOR OVER 4K SIZE      10170000
         JENTRY (X5A01=AOP100)          ENTRY POINT                     10171000
         GOIF  JTEND,LT=AOP400          JUST LIST GENERATOR OPS         10172000
         GOIF  JPRONLY,ON=AOP350        IS RECORD PRINT ONLY            10173000
         SR    R11,R11                  CLEAR FOR INSERT CHARACTER      10174000
         IC    R11,JTIOP                PICK UP OP-CODE                 10175000
         LA    R10,JTEND                LESS OP-CODES NOT IN TABLE WILL 10176000
         SR    R11,R10                  CALCULATE BRANCH TABLE OP-CODE  10177000
         AR    R11,R11                  DOUBLE FOR BRANCH TABLE INDEX   10178000
         LH    R11,AOP200(R11)          GET ROUTINE DISPLACEMENT        10179000
         XC    DUMSW,DUMSW              CLEAR DS SW            @AY12907 10180000
         B     AOP200(R11)              BRANCH TO ASSEMBLER OP ROUTINE  10181000
         SPACE 3                                                        10182000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10183000
               - BRANCH TABLE AND EXIT ROUTINES'                        10184000
*   BRANCH TABLE FOR ASSEMBLER OPCODES                                  10185000
AOP200   EQU   *                        BEGINNING OF BRANCH TABLE       10186000
         ORG   AOP200+2*(0-JTEND+JTEND)      BRANCH DISPLACEMENT END    10187000
         DC    AL2(END100-AOP200)            TABLE ENTRY FOR END        10188000
         ORG   AOP200+2*(0-JTEND+JTDXD)      BRANCH DISPLACEMENT DXD    10189000
         DC    AL2(DXD100-AOP200)            TABLE ENTRY FOR DXD        10190000
         ORG   AOP200+2*(0-JTEND+JTEQU)      BRANCH DISPLACEMENT EQU    10191000
         DC    AL2(EQU100-AOP200)            TABLE ENTRY FOR EQU        10192000
         ORG   AOP200+2*(0-JTEND+JTORG)      BRANCH DISPLACEMENT ORG    10193000
         DC    AL2(ORG100-AOP200)            TABLE ENTRY FOR ORG        10194000
         ORG   AOP200+2*(0-JTEND+JTCNOP)     BRANCH DISPLACEMENT CNOP   10195000
         DC    AL2(CNOP00-AOP200)            TABLE ENTRY FOR CNOP       10196000
         ORG   AOP200+2*(0-JTEND+JTCCW)      BRANCH DISPLACEMENT CCW    10197000
         DC    AL2(CCW100-AOP200)            TABLE ENTRY FOR CCW        10198000
         ORG   AOP200+2*(0-JTEND+JTDC)       BRANCH DISPLACEMENT DC     10199000
         DC    AL2(DC0100-AOP200)            TABLE ENTRY FOR DC         10200000
         ORG   AOP200+2*(0-JTEND+JTDS)       BRANCH DISPLACEMENT DS     10201000
         DC    AL2(DS0100-AOP200)            TABLE ENTRY FOR DS         10202000
         ORG   AOP200+2*(0-JTEND+JTSTART)    BRANCH DISPLACEMENT START  10203000
         DC    AL2(START0-AOP200)            TABLE ENTRY FOR START      10204000
         ORG   AOP200+2*(0-JTEND+JTCSECT)    BRANCH DISPLACEMENT CSECT  10205000
         DC    AL2(CSECT0-AOP200)            TABLE ENTRY FOR CSECT      10206000
         ORG   AOP200+2*(0-JTEND+JTDSECT)    BRANCH DISPLACEMENT DSECT  10207000
         DC    AL2(DSECT0-AOP200)            TABLE ENTRY FOR DSECT      10208000
         ORG   AOP200+2*(0-JTEND+JTCOM)      BRANCH DISPLACEMENT COM    10209000
         DC    AL2(COM100-AOP200)            TABLE ENTRY FOR COM        10210000
         ORG   AOP200+2*(0-JTEND+JTENTRY)    BRANCH DISPLACEMENT ENTRY  10211000
         DC    AL2(ENTRY0-AOP200)            TABLE ENTRY FOR ENTRY      10212000
         ORG   AOP200+2*(0-JTEND+JTEXTRN)    BRANCH DISPLACEMENT EXTRN  10213000
         DC    AL2(EXTRN0-AOP200)            TABLE ENTRY FOR EXTRN      10214000
         ORG   AOP200+2*(0-JTEND+JTWXTRN)  BRANCH DISPLACEMENT WXTRN    10215000
         DC    AL2(EXTRN0-AOP200)         TABLE ENTRY FOR WXTRN         10216000
         ORG   AOP200+2*(0-JTEND+JTCXD)      BRANCH DISPLACEMENT CXD    10217000
         DC    AL2(CXD100-AOP200)            TABLE ENTRY FOR CXD        10218000
         ORG   AOP200+2*(0-JTEND+JTLTORG)    BRANCH DISPLACEMENT LTORG  10219000
         DC    AL2(LTORG0-AOP200)            TABLE ENTRY FOR LTORG      10220000
         ORG   AOP200+2*(0-JTEND+JTLITR)     BRANCH DISPLACEMENT LITR   10221000
         DC    AL2(LITR00-AOP200)            TABLE ENTRY FOR LITERAL    10222000
         ORG   AOP200+2*(0-JTEND+JTSYMBL)    BRANCH DISPLACEMENT SYMBOL 10223000
         DC    AL2(AOP300-AOP200)            TABLE ENTRY FOR SYMBOL     10224000
         ORG   AOP200+2*(0-JTEND+JTPUNCH)    BRANCH DISPLACEMENT PUNCH  10225000
         DC    AL2(PUNCH0-AOP200)            TABLE ENTRY FOR PUNCH      10226000
         ORG   AOP200+2*(0-JTEND+JTREPRO)    BRANCH DISPLACEMENT REPRO  10227000
         DC    AL2(REPRO0-AOP200)            TABLE ENTRY FOR REPRO      10228000
         ORG   AOP200+2*(0-JTEND+JTPUSH)  ORG FOR PUSH BRANCH ADDRESS   10229000
         DC    AL2(PUSH00-AOP200)       DISPLACEMENT TO PUSH            10230000
         ORG   AOP200+2*(0-JTEND+JTPOP) ORG FOR POP BRANCH ADDRESS      10231000
         DC    AL2(POP100-AOP200)       DISPLACEMENT TO POP             10232000
         ORG   AOP200+2*(0-JTEND+JTPRINT)    BRANCH DISPLACEMENT PRINT  10233000
         DC    AL2(PRINT0-AOP200)            TABLE ENTRY FOR PRINT      10234000
         ORG   AOP200+2*(0-JTEND+JTUSING)    BRANCH DISPLACEMENT USING  10235000
         DC    AL2(USING0-AOP200)            TABLE ENTRY FOR USING      10236000
         ORG   AOP200+2*(0-JTEND+JTDROP)     BRANCH DISPLACEMENT DROP   10237000
         DC    AL2(DROP00-AOP200)            TABLE ENTRY FOR DROP       10238000
         ORG   AOP200+2*(0-JTEND+JTCMNT)     BRANCH DISPLACEMENT COMNT  10239000
         DC    AL2(AOP400-AOP200)            TABLE ENTRY FOR COMMENT    10240000
         ORG   AOP200+2*(0-JTEND+JTHCMNT)   BRANCH DISPLACEMENT HCMNT   10241000
         DC    AL2(AOP400-AOP200)       TABLE ENTRY FOR HIDDEN COMMENT  10242000
         ORG   AOP200+2*(0-JTEND+JTERROR)    BRANCH DISPLACEMENT ERROR  10243000
         DC    AL2(ERROR0-AOP200)            TABLE ENTRY FOR ERROR      10244000
         ORG   AOP200+2*(0-JTEND+JTSPACE)    BRANCH DISPLACEMENT SPACE  10245000
         DC    AL2(SPACE0-AOP200)            TABLE ENTRY FOR SPACE      10246000
         ORG   AOP200+2*(0-JTEND+JTEJECT)    BRANCH DISPLACEMENT EJECT  10247000
         DC    AL2(EJECT0-AOP200)            TABLE ENTRY FOR EJECT      10248000
         ORG   AOP200+2*(0-JTEND+JTTITLE)    BRANCH DISPLACEMENT TITLE  10249000
         DC    AL2(TITLE0-AOP200)            TABLE ENTRY FOR TITLE      10250000
         ORG   AOP200+2*(0-JTEND+JTMNOTE)    BRANCH DISPLACEMENT MNOTE  10251000
         DC    AL2(MNOTE0-AOP200)            TABLE ENTRY FOR MNOTE      10252000
         ORG   AOP200+2*(0-JTEND+JTSICTL)    RESTORE STANDARD           10253000
         DC    AL2(SICTL-AOP200)        ICTL                            10254000
         ORG   ,                        REORG TO THE END OF TABLE       10255000
         SPACE                                                          10256000
AOP300   GOIF  JERR,OFF=AOP310          IS THERE AN ERROR IN RECORD     10257000
         LA    R10,ERROUT               YES, LOAD PRINT INDEX           10258000
         JCALL OUTPUT                   GO PRINT ERROR FLAG IN TEXT     10259000
AOP310   JRETURN ,                      EXIT                            10260000
AOP350   GOIF  JTEND,NE=AOP375          IS THIS AN END STATEMENT        10261000
         MVC   ENDSTMNO,STMTN           YES, SAVE THE STATEMENT NUMBER  10262000
AOP375   GOIF  JTREPRO,NE=AOP400        IS THIS A REPRO CARD            10263000
         GOIF  JPSOP,OFF=AOP400         IS STMT A PSEUDO OP    @AY13962 10264000
         GOIF  REPCARD,ON=REPRO0        IS IT EXPECTED GO PRINT         10265000
         SET   REPCARD,ON               NEXT STATEMENT TO BE IN 1 LINE  10266000
AOP400   MVI   LHFLGS,DNTPLH            SET PRINT FLAGS                 10267000
AOP405   LA    R10,LSTOUT               LOAD PRINT INDEX                10268000
AOP410   JCALL OUTPUT                   GO PRINT                        10269000
         B     AOP300                   EXIT PHASE                      10270000
         JEXTRN (X5P01=OUTPUT)          PRINT PUNCH ENTRY POINT         10271000
AOP440   LA    R10,LSTOUT               GET BRANCH DISPLACEMENT PRINT   10272000
         OI    LHFLGS,DNTPLH            TURN ON DON'T PRINT LEFT HALF   10273000
AOP450   JCALL OUTPUT                   CALL OUT PUT ROUTINE            10274000
         BR    R6                       RETURN TO CALLING ROUTINE       10275000
         EJECT                                                          10276000
AOP500   L     R14,OPNADR               POINT TO OPERAND BEGINNING      10277000
         L     R15,OPNEND               POINT TO OPERAND END            10278000
         LA    R11,X5ATEMP              POINT BUILD AREA WORK REGISTER  10279000
         LR    R4,R11                   REMEMBER WHERE WE STARTED AT    10280000
         GOIF  D0(R14),JQUOTE,NE=AOP590 NO LEADING QUOTE                10281000
AOP540   LA    R14,D1(,R14)             STEP WORK REGISTER              10282000
         CR    R14,R15                  IS OPERAND COMPLETE             10283000
         BNL   AOP595                   YES, GO LOG ERROR               10284000
         GOIF  D0(R14),JQUOTE,EQ=AOP560   CHECK FOR QUOTE               10285000
         GOIF  D0(R14),JAMPER,EQ=AOP560   CHECK FOR AMPERSAND           10286000
AOP550   MVC   D0(D1,R11),D0(R14)       MOVE CHARACTER TO OUTPUT        10287000
         LA    R11,D1(,R11)             STEP OUTPUT POINTER             10288000
         B     AOP540                   GO STEP TO NEXT CHARACTER       10289000
AOP560   CLC   D0(D1,R14),D1(R14)       IS AMPERSAND OR QUOTE A DUPLICT 10290000
         LA    R14,D1(,R14)             INCREMENT POINTER               10291000
         BE    AOP550                   GO OUTPUT CHARACTER             10292000
         BCTR  R14,0                    DECREMENT POINTER               10293000
         GOIF  D0(R14),JAMPER,EQ=AOP580 UNPAIRES AMPERSAND              10294000
         CLI   D1(R14),JBLANK           DO BLANK FOLLOW TERM QUOTE      10295000
         BNE   AOP585                   IF NOT ERROR                    10296000
         SR    R11,R4                   GET LENGTH OF FIELD             10297000
         BR    R6                       RETURN TO CALLING ROUTINE       10298000
         JEXTRN (X5L01=LOGERR)                                          10299000
AOP580   SET   TPTEXT,ON                INDICATE BAD OPERAND            10300000
         ST    R14,ERRPTR               IT IS ALSO ERROR POINTER        10301000
         X5ERRL 176,CLMPTR              UNPAIRED AMPERSAND              10302000
         BR    R6                       RETURN TO CALLER                10303000
AOP585   LA    R14,D1(R14)              POINT TO CHR AFTER QUOT OX00219 10304000
         ST    R14,ERRPTR               SAVE POINTER FOR LOGGING        10305000
         SET   TPTEXT,ON                INDICATE BAD OPERAND            10306000
         X5ERRL 185,CLMPTR              BLANK DO NOT FOLLOW TERM QUOTE  10307000
         BR    R6                       RETURN TO CALLER                10308000
AOP590   X5ERRL 175,0                   NO LEADING QUOTE                10309000
         SET   TPTEXT,ON                INDICATE BAD OPERAND            10310000
         BR    R6                       RETURN TO CALLER                10311000
AOP595   X5ERRL 240,0                   ENDING QUOTE MISSING, LOG IT    10312000
         SET   TPTEXT,ON                INDICATE BAD OPERAND            10313000
         BR    R6                       RETURN TO CALLER                10314000
         SPACE 2                                                        10315000
*                                                                     * 10316000
*   COMMON CALL OF EVAL.                                              * 10317000
*                                                                     * 10318000
AOP600   JCALL EVAL                     GO EVALUATE EXPRESSION          10319000
         BR    R6                       RETURN TO CALLING LOCATION      10320000
         JEXTRN (X5V01=EVAL)            DEFINITION OF EVAL              10321000
         SPACE 4                                                        10322000
*                                                                       10323000
*   REPLACE THE USER ICTL WITH STANDARD ICTL IN CASE WE HAVE THE SYSMAC 10324000
*   OPTION AND ARE GOING TO PRINT OUT MACRO DEFINITIONS                 10325000
*                                                                       10326000
SICTL    MVC   JBGNCL(L'JBGNCL*3),=Y(1,16,71)    RESTORE STD ICTL       10327000
         B     AOP310                   RETURN TO GET NEXT RECORD       10328000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10329000
               - ''END'' STATEMENT PROCESSOR'                           10330000
*                                                                     * 10331000
*   END STATEMENT PROCESSING                                            10332000
*                                                                       10333000
END100   L     R10,OPNADR               GET OPERAND POINTER             10334000
         MVC   ENDSTMNO,STMTN           SAVE END STATEMENT NUMBER       10335000
         GOIF  OPNPRS,OFF=END450        OPERAND PRESENT ?               10336000
         GOIF  D0(R10),JCOMMA,EQ=END400 1ST OPERAND OMITTED ?           10337000
         SPACE                                                          10338000
END150   BAL   R6,AOP600                GO EVALUATE OPERAND             10339000
         BNH   END350                   ERROR IF NOT RELOCATABLE        10340000
         CH    R10,=H'4096'             IS ESDID VALID?                 10341000
         BNL   END350                   NO,GO LOG ERROR                 10342000
         ST    R11,LCTRSAV              PUT VALUE IN WORK AREA          10343000
         TM    LCTRSAV+D3,D1            IS IT EVEN                      10344000
         BNZ   END600                   ERROR IF NOT                    10345000
         ST    R11,LOCATN               STORE VALUE FOR PRINTING        10346000
         ST    R11,JENTRYPT             SAVE ENTRY POINT FOR END CARD   10347000
         STH   R10,JESDID               SAVE ENTRY POINT ESD            10348000
         NI    JESDID,X'F7'             CLEAR FLAGBIT 5        @YA06117 10349000
         SET   JESDCHK,ON               INDICATE ESD INF FOR END CARD   10350000
END200   GOIF  D0(R14),JBLANK,EQ=END250 WAS DELIMIT A BLANK-OK  OX01760 10351000
         GOIF  D1(R14),JLPARN,EQ=END210 IS DELIMITER A PAREN    OX01760 10352000
         GOIF  D1(R14),JBLANK,EQ=END250 2ND OPERAND OMITTED ?   OX01760 10353000
         B     END230                   ERROR IN 2ND IDR ITEM IF NONE   10354000
END210   MVI   JIDR,X'02'               INDICATE A 2ND IDR ITEM         10355000
         SR    R6,R6                                                    10356000
         AH    R14,=H'1'                                                10357000
END225   AH    R14,=H'1'               COUNT COLUMN POINTER             10358000
         GOIF  D0(R14),JCOMMA,EQ=END235 SUBITEMS DEL BY COMMA           10359000
         AH    R6,=H'1'                COUNT CHAR. IN PID ORDER NUMBER  10360000
         IC    R9,D0(R14)               MOVE CHAR TO IDR SAVE LOC       10361000
         STC   R9,JIDR+D19(R6)                                          10362000
         CH    R6,=H'10'                MAX 10 CHARACTERS ALLOWED       10363000
         BNH   END225                   GET NEXT CHAR IF MORE ALLOWED   10364000
END230   X5ERRL 254,CLMPTR              LOG ERR IN 2ND IDR ITEM         10365000
         CLI   JIDR,X'02'               IS FLAG BYTE SET TO 2           10366000
         BNE   END250                   BRANCH IF NOT                   10367000
         MVI   JIDR,X'01'               RESET IT TO ONE                 10368000
         MVI   JIDR+D20,X'2F'           RESET 2ND IDR PART OF JIDR      10369000
         MVC   JIDR+D21(D19),JIDR+D20     TO BLANKS                     10370000
         B     END250                                                   10371000
END235   CH    R6,=H'10'                WAS THERE 10 CHARACTERS         10372000
         BNL   END240                   YES                             10373000
         LA    R6,D1(R6)                STEP UP INDEX                   10374000
         IC    R9,=X'2F'                NO   - PAD WITH BLANKS          10375000
         STC   R9,JIDR+D19(R6)                                          10376000
         B     END235                   CHECK AGAIN                     10377000
END240   MVC   JIDR+D30(D4),D1(R14)     MOVE 2ND SUBITEM TO SAVE LOC    10378000
         MVC   JIDR+D31+D3(D5),D6(R14)  MOVE 3RD SUBITEM TO SAVE LOC    10379000
         GOIF  D11(R14),JRPARN,NE=END230  IS DELIM A PAREN              10380000
END250   SR    R10,R10                  SET PRINT ROUTINE INDEX         10381000
         BAL   R6,AOP450                GO PRINT END                    10382000
         GOIF  JERR,OFF=END300          IF NO ERROR,CHECK LITERALS      10383000
         LA    R10,ERROUT               YES, SET *** ERROR *** INDEX    10384000
         JCALL OUTPUT                   GO PRINT IT                     10385000
END300   LH    R1,LITPID                GET LITERAL POOL ID             10386000
         GOIF  JSYSGEN,OFF=AOP310       EXIT IF X4 NOT LOADED           10387000
         LA    R1,D1(R1)                INCREMENT BY 1                  10388000
         STH   R1,LITPID                SAVE IT                         10389000
         L     R1,SYMXRF                GET SYMBOL XREFED       OX02675 10390000
         SR    R2,R2                    CLEAR R2                        10391000
         IC    R2,SYMCNT                GET SYMBOL COUNT                10392000
         SR    R2,R1                    GET REMAINING SYMBOLS           10393000
         BNH   END345                   BRANCH IF NOT HIGH              10394000
END325   LH    R10,JINFILE              GET JINFILE INDEX               10395000
         JGETL FILE=(R10)               GET SYMBOL                      10396000
         BCT   R2,END325                FINISH FLUSHING?                10397000
         SPACE                                                          10398000
END345   MVI   SYMCNT,D0                ZEROED OUT SYMBOL COUNT         10399000
         B     LTO200                   GO CHECK LITERALS               10400000
END350   OI    LHFLGS,DNTPLH            TURN ON DON'T PRINT LEFT HALF   10401000
         X5ERRL 217,CLMPTR              RELOCATEBILITY ERROR            10402000
         B     END200                   GO CHECK 2ND OPERAND            10403000
END400   OI    LHFLGS,DNTPLH            TURN ON DON'T PRINT LEFT HALF   10404000
         LR    R14,R10                                                  10405000
         B     END200                   GO PRINT END                    10406000
END450   OI    LHFLGS,DNTPLH            SET DONT PRINT LEFT HALF        10407000
         B     END250                   GO PRINT END STATEMENT          10408000
END500   ST    R14,ERRPTR               SAVE COLUMN PTR FOR LOGGING     10409000
         X5ERRL 185,CLMPTR,END400       INVALID DELIMITER ERROR         10410000
         SPACE                                                          10411000
END600   X5ERRL 220,CLMPTR,END400       LOG ALIGNMENT ERROR             10412000
         SPACE 3                                                        10413000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10414000
               - ''DXD'' STATEMENT PROCESSOR'                           10415000
DXD100   SET   DXDSW,ON                 INDICATE DXD FOR DCEVAL         10416000
         BAL   R6,COMCALL               GO GET GOOD OPERAND NUMBER      10417000
         MVC   ELCTR+D4(4),ELCTR        SAVE CURR. LOCTR                10418000
         MVC   ELCTR+D8(2),EESDI        SAVE CURR. ESDID                10419000
         XC    ELCTR,ELCTR              CLEAR LOCTR                     10420000
         XC    EESDI,EESDI              CLEAR ESDID                     10421000
         L     R10,OPNADR               POINT TO OPERAND                10422000
         JCALL DCEVAL                   GO EVALUATE                     10423000
         SET   DCMOP,ON                 TURN ON MOP-UP SWITCH           10424000
         LA    R10,DC0OUT               SET PRINT INDEX                 10425000
         JCALL OUTPUT                   CALL OUTPUT                     10426000
         SET   DXDSW,OFF                TURN OF SWITCH                  10427000
         MVC   ELCTR,ELCTR+D4           RESTORE CURR. LOCTR             10428000
         MVC   EESDI,ELCTR+D8           RESTORE CURR. ESDID             10429000
         B     AOP300                   EXIT                            10430000
         SPACE                                                          10431000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10432000
               - COMMON ROUTINE FOR DC, DS AND DXD PROCESSORS'          10433000
COMCALL  L     R11,SYMDEF               GET SYMBOL FILE RECORD PTR      10434000
         GOIF  NAMPRS,ON=COMCALL2       SKIP IF NAME PRESENT            10435000
         GOIF  DXDSW,OFF=COMCALL1       NOT DXD - GET RECORD            10436000
         SR    R10,R10                  CLEAR REG                       10437000
         GOIF  JNMERR,ON=COMCALL3       DO NOT LOG NAME ERR AGAIN       10438000
         X5ERRL 163,0,COMCALL3          INVALID DXD NAME- NO NAME       10439000
COMCALL1 LH    R10,JINFILE              GET INPUT FILE NO               10440000
         JGETL FILE=(R10)               GET SYMBOL FILE RECORD          10441000
         SPACE                                                          10442000
COMCALL2 SR    R10,R10                  CLEAR REG                       10443000
         IC    R10,RFLGA                GET GOOD OPERAND COUNT          10444000
COMCALL3 STH   R10,LCTRSAV+D8           SAVE FOR DCEVAL USE             10445000
         SET   (DCSWH,DCCOMP,DCMOP,DCSTRT),OFF RESET DCFLGS FOR SAFE    10446000
         BR    R6                       RETURN TO CALLER                10447000
         SPACE 3                                                        10448000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10449000
               - ''EQU'' STATEMENT PROCESSOR'                           10450000
EQU100   LH    R12,JTNMP                COMPUTE ADDR TO         OY06130 10451000
         AR    R12,R5                   NAME FIELD              OY06130 10452000
         CLI   D0(R12),X'00'            TST FOR NO NAME         OY06130 10453000
         BNE   EQU150                                           OX05796 10454000
         X5ERRL 163,0,AOP400                                    OX05796 10455000
EQU150   L    R11,SYMDEF                GET NAME RECORD PTR     OX05796 10456000
         MVC   ADDRS2,RLCTR             MOVE SYMBOL VALUE               10457000
         SET   PRDEFREQ,ON              TURN PRIORDEF REQ BIT ON        10458000
         L     R10,OPNADR               GET OPERAND POINTER             10459000
         IC    R6,RFLGB                 SAVE FLAGS                      10460000
         GOIF  NAMPRS,ON=EQU250         ANY NAME                        10461000
         X5ERRL 163,0                   LOG MISSING NAME ERROR          10462000
         SPACE                                                          10463000
EQU250   LH    R12,JTOPP                COMPUTE ADDR TO         OY06130 10464000
         AR    R12,R5                   OPERAND FIELD           OY06130 10465000
         CLI   D0(R12),X'00'            TST FOR NO OPERAND      OY06130 10466000
         BNE   EQU275                                           OX05796 10467000
         SET   PRDEFREQ,OFF                                    FX0000   10468000
         X5ERRL 177,0,AOP400                                    OX05796 10469000
EQU275   JCALL EVAL                     GO EVALUATE             OX05796 10470000
         BC    CMPX,EQUER1              IS EQU COMPLEXLY RELOCATABLE    10471000
         BC    ERRX,EQU300              BRANCH IF SYNTAX ERROR          10472000
         GOIF  D0(R14),JBLANK,EQ=EQU225 OK IF BLANK                     10473000
         GOIF  D0(R14),JCOMMA,NE=EQUER3 ERROR IF NOT COMMA              10474000
         SET   EQUOPR,ON                MORE THAN 1 OPR IN EQU @AZ07356 10475000
EQU225   ST    R11,ADDRS2               SAVE VALUE IN LEFTHLF           10476000
EQU200   EX    R6,EQUCPR                CHECK FOR CIRCULAR DEFINTION    10477000
         BE    EQU300                   NO                              10478000
         X5ERRL 237,0                   CIRCULAR DEFINITION             10479000
EQU300   SET   PRDEFREQ,OFF             RESET PRIOR DEFINITION SWITCH   10480000
         SET   EOUBIT,ON                INDICATE EQU                    10481000
         GOIF  EQUOPR,OFF=AOP405        BR IF NO 2ND OPER      @AZ07356 10482000
         GOIF  D1(R14),JCOMMA,EQ=EQU800 BR IF 2ND OPER OMITTED @AZ07356 10483000
         LA    R10,D1(R14)              BUMP POINTER           @AZ07356 10484000
         JCALL EVAL                     GO EVAL 2ND OPER       @AZ07356 10485000
         BC    (X'F'-CMPX),EQU400       BR IF NOT COMPLEX RELO @AZ07356 10486000
         X5ERRL 213,CLMPTR              ERR: COMPLEXLY RELOC   @AZ07356 10487000
EQU400   GOIF  D0(R14),JBLANK,EQ=EQU650 BR IF 3RD OPER         @AZ07356 10488000
         GOIF  D0(R14),JCOMMA,NE=EQU650 BR IF 3RD OPER INVALID @AZ07356 10489000
         LA    R10,D1(R14)              BUMP POINTER           @AZ07356 10490000
EQU500   JCALL EVAL                     GO EVAL 3RD OPER       @AZ07356 10491000
         BC    (X'F'-CMPX),EQU600       BR IF NOT COMPLEX RELO @AZ07356 10492000
         X5ERRL 213,CLMPTR              ERR: COMPLEX RELOC     @AZ07356 10493000
EQU600   GOIF  D0(R14),JBLANK,NE=EQU650 BR IF INVALID DELIM    @AZ07356 10494000
EQU650   SET   EQUOPR,OFF               RESET FOR NEXT STMT    @AZ07356 10495000
         B     AOP405                   NO EXIT                         10496000
EQU800   LA    R10,D2(R14)              BUMP POINTER           @AZ07356 10497000
         GOIF  D2(R14),JBLANK,EQ=EQU650 BR IF 3RD OPER OMITTED @AZ07356 10498000
         B     EQU500                   GO EVAL 3RD OPER       @AZ07356 10499000
EQUER1   CLI   EVALSW1,D0               ANY SYNTACTIC ERROR?            10500000
         BNE   EQU300                   YES, EXIT               OX00220 10501000
         X5ERRL 213,CLMPTR,EQU300       COMPLEXLY RELOCATABLE   OX00220 10502000
EQUER3   X5ERRL 216,CLMPTR,EQU200       ILLEGAL OPERAND FORMAT          10503000
EQUCPR   CLI   EVALSW1,*-*              EXECUTED CIRCULAR DEF CHEK      10504000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10505000
               - ''ORG'' STATEMENT PROCESSOR'                           10506000
ORG100   L     R11,SYMDEF               GET SYMBOL DEFINITION POINTER   10507000
         GOIF  NAMPRS,OFF=ORG200        IS STATEMENT NAMED              10508000
         MVC   LOCATN,RLCTR             MOVE IN DEFINITION LOCATION     10509000
         B     ORG300                   GO GET ORG VALUE                10510000
ORG200   MVC   LOCATN,ELCTR              DATA, GET LOCATION COUNTER     10511000
ORG300   LH    R10,JINFILE              POINT TO INPUT FILE             10512000
         JGETL FILE=(R10)               GET ORG VALUE                   10513000
         MVC   ADDRS2(D4),RLCTR         MOVE ORGED VALUE TO PRINT       10514000
         GOIF  OPNPRS,OFF=ORG700        BRANCH IF OPERAND NOT PRESENT   10515000
         L     R10,OPNADR               GET OPERAND POINTER             10516000
         CLC   D0(2,R10),=AL1(JCOMMA,JBLANK) IS OPERAND MISSING?        10517000
         BE    ORG700                   BRANCH IF MISSING               10518000
         SET   PRDEFREQ,ON              TURN ON PRIORDEF REQ BIT        10519000
         MVC   DWORD2(1),RFLGB          SAVE FLAG BYTE                  10520000
         JCALL EVAL                     EVALUATE OPERAND FOR ERRORS     10521000
         BC    8,ORGERR1                ORG VALUE ABSOLUTE              10522000
         BC    4,ORG600                 IF ERROR BRANCH                 10523000
         BC    1,ORG400                 SYNTACTIC ERRORS                10524000
         CLI   D0(R14),JBLANK           IS DELIMITER BLANK?             10525000
         BNE   ORGERR2                  BRANCH IF NOT BLANK             10526000
         CH    R10,EESDI                SAME ESDID?                     10527000
         BNE   ORGERR3                  ESDID NOT ALIKE                 10528000
         GOIF  WRPFLG,ON=ORG500         DO NOT LOC OVERFLOW AGAIN       10529000
         C     R11,=A(X'FFFFFF')        DID LCTR WRAPPED?               10530000
         BH    ORGERR5                  YES, GO LOG ERROR               10531000
ORG500   TM    DWORD2,BIT0              ANY ERROR IN ORG OPERAND ?      10532000
         BNO   ORGERR4                  YES,GO LOG ERROR                10533000
ORG700   MVC   ELCTR,ADDRS2             PUT IN NEW LOCTR VALUE          10534000
ORG400   IC    R4,EESDI                 SAVE DSECT INDICATOR            10535000
         MVI   EESDI,BIT1+BIT2          INDICATE DSECT OR COM           10536000
         SR    R10,R10                  SET PRINT INDEX                 10537000
         SET   EOUBIT,ON                INDICATE ORG                    10538000
         BAL   R6,AOP450                GO PRINT RECORD                 10539000
         STC   R4,EESDI                 RESTORE ESD                     10540000
         SET   PRDEFREQ,OFF             RESET PRDEFREQ BIT              10541000
         B     AOP300                   EXIT                            10542000
ORGERR1  X5ERRL 174,0,ORG400            ORG VALUE ABSOLUTE              10543000
ORGERR2  X5ERRL 185,CLMPTR,ORG700       INCORRECT DELIMITER             10544000
ORGERR3  X5ERRL 173,0,ORG400            ESDID NOT ALIKE                 10545000
ORGERR4  X5ERRL 172,0,ORG400            ORG VALUE NEGATIVE              10546000
ORG600   CLI   EVALSW1,D0               ANY NON-SYSTACTIC ERROR?        10547000
         BNE   ORG400                   YES,BRANCH TO EXIT              10548000
         X5ERRL 213,CLMPTR,ORG400       LOG ERROR THEN EXIT             10549000
ORGERR5  SET   WRPFLG,ON                INDICATE WE LOGGED THE ERROR    10550000
         X5ERRL 246,0,ORG700            INVALID ORG OPERAND             10551000
         SPACE 3                                                        10552000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10553000
               - ''CNOP'' STATEMENT PROCESSOR'                          10554000
CNOP00   LA    R2,D1                    GET MAXIMUM ALIGNMENT           10555000
         EX    R2,ALNTST                IS ALIGNMENT NECESSARY          10556000
         BZ    CNP100                   NO, SKIP                        10557000
         JCALL ALIGN                    GO ALIGN CNOP                   10558000
         OI    LHFLGS,ENTALN+D1         SET OUTPUT LENGTH AND FLAGS     10559000
         SR    R10,R10                  SET OUTPUT INDEX                10560000
         JCALL OUTPUT                   GO PRINT ALIGNMENT              10561000
CNP100   GOIF  OPNPRS,OFF=CNPER7        ERROR IF NO OPERAND             10562000
         L     R10,OPNADR               POINT TO OPERAND                10563000
         MVC   LOCATN,ELCTR             MOVE LOCATION TO LEFT HALF      10564000
         SET   PRDEFREQ,ON              TURN ON PRIORDEF REQ BIT        10565000
         JCALL EVAL                     CALL EVALUATION ROUTINE         10566000
         BNZ   CNPER1                   MUST BE ABSOLUTE                10567000
         SET   PRDEFREQ,OFF             TURN OFF PRIOEDEF REQ BIT       10568000
         GOIF  (R11),NEG=CNPER5         ERROR IF NEGATIVE               10569000
         CH    R11,=H'8'                IS VALUE VALID?                 10570000
         BNL   CNPER5                   VALUE ERROR IN OPERAND 1        10571000
         EX    R11,BITTST               IS OPERAND VALUE ODD            10572000
         BNZ   CNPER5                   YES, GO LOG ERROR               10573000
CNP150   LR    R4,R11                   SAVE FIRST OPERAND VALUE        10574000
         GOIF  D0(R14),JCOMMA,NE=CNPER2 CHECK SYNTAX - MUST BE A COMMA  10575000
         LA    R10,D1(,R14)             INITIALIZE EVAL POINTER         10576000
         SET   PRDEFREQ,ON              TURN PRIORDEF REQ BIT           10577000
         JCALL EVAL                     GO EVALUATE SECOND OPERAND      10578000
         BNZ   CNPER8                   MUST BE ABSOLUTE                10579000
         SET   PRDEFREQ,OFF             TURN OFF PRIORDEF REQ BIT       10580000
         GOIF  D0(R14),JBLANK,NE=CNPER4 CHECK SYNTAX - MUST BE FX0000   10581000
         CH    R11,=H'8'                IS SECOND OPERAND AN 8          10582000
         BE    CNP200                   YES, GO CHECK FIRST OPERAND     10583000
         CH    R11,=H'4'                IS IT 4                         10584000
         BNE   CNPER4                   NO, GO LOG ERROR                10585000
CNP200   CR    R4,R11                   IS OPERAND 1 NOT LESS THAN 2ND  10586000
         BNL   CNPER6                   YES, GO LOG ERROR               10587000
         GOIF  INVCNOP,OFF=CNP250       DO ALIGN IF CNOP OPERAND OK     10588000
         SET   INVCNOP,OFF              RESET BAD OPERAN INDICATOR      10589000
         B     AOP400                                                   10590000
CNP250   LNR   R2,R11                   COMPLEMENT  2ND OPERAND VALUE   10591000
         L     R1,ELCTR                 GET LOCATION COUNTER            10592000
         NR    R1,R2                    ALIGN IT TO PREVIOUS BOUNDARY   10593000
         AR    R1,R4                    ADD FIRST OPERAND BOUNDRY       10594000
         C     R1,ELCTR                 HAS ALIGNMENT REQUESTED CORRECT 10595000
         BNL   CNP300                   YES, ALIGNMENT COMPLETE         10596000
         AR    R1,R11                   NO, ADD SECOND OPERAND VALUE    10597000
CNP300   S     R1,ELCTR                 CALCULATE CNOP LENGTH           10598000
         EX    R1,ORLEN                 INDICATE OUTPUT LENGTH          10599000
         ST    R1,LOCLEN                SAVE CNOP LENGTH                10600000
         JCALL LOCUPD                   GO UPDATE LOCATION COUNTER      10601000
         MVC   DCDATA(D6),=X'070007000700'  MOVE IN PAD BYTES           10602000
         SET   ENTDC,ON                 SET PRINT FLAG                  10603000
         LA    R10,DC0OUT               GET PRINT INDEX                 10604000
         JCALL OUTPUT                   CALL PRINT                      10605000
         SET   DCMOP,ON                 SET MOP-UP SWITCH ON            10606000
         LA    R10,DC0OUT               GET DCPRINT INDEX               10607000
         JCALL OUTPUT                   CALL PRINT                      10608000
         B     AOP300                   GO CHECK ERROR FLAG             10609000
         SPACE                                                          10610000
CNPER1   SET   PRDEFREQ,OFF             TURN PRIORDEF REQ BIT OFF       10611000
         SET   INVCNOP,ON               INDICATE ERROR IN CNOP OPERAND  10612000
         X5ERRL 179,CLMPTR,CNP150       OPERAND NOT ABSOLUTE            10613000
         SPACE                                                          10614000
CNPER2   ST    R14,ERRPTR               SET COLUMN POINTER              10615000
         SET   INVCNOP,OFF              RESET CNOP OPERAND ERROR IND    10616000
         X5ERRL 178,CLMPTR,AOP400       COMMA EXPECTED                  10617000
         SPACE                                                          10618000
CNPER4   SET   INVCNOP,ON               INDICATE ERROR IN CNOP OPERAND  10619000
         X5ERRL 180,CLMPTR,CNP200       VALUE ERROR- SHOULD BE 4 OR 8   10620000
         SPACE                                                          10621000
CNPER5   SET   INVCNOP,ON               INDICATE ERROR IN CNOP OPERAND  10622000
         X5ERRL 181,CLMPTR,CNP150       VALUE ERROR OPERAND IS ODD      10623000
         SPACE                                                          10624000
CNPER6   SET   INVCNOP,OFF              RESET CNOP OPERAND ERROR IND    10625000
         X5ERRL 182,0,AOP400            OPERAND 2 LARGER THAN 1         10626000
CNPER7   SET   INVCNOP,OFF              RESET CNOP OPERAND ERROR IND    10627000
         X5ERRL 177,0,AOP400            OPERAND REQUIRED                10628000
CNPER8   SET   PRDEFREQ,OFF             TURN PRIORDEF REQ BIT OFF       10629000
         X5ERRL 179,CLMPTR,AOP400       OPERAND NOT ABSOLUTE            10630000
BITTST   TM    =X'01',D0                EXECUTEC LOW BIT TEST           10631000
         SPACE 3                                                        10632000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10633000
               - ''CCW'' STATEMENT PROCESSOR'                           10634000
CCW100   LA    R2,D7                    GET ALIGNMENT CHECK BITS        10635000
         EX    R2,ALNTST                CHECK ALIGNMENT                 10636000
         BZ    CCW150                   NO ALIGNMENT REQUIRED           10637000
         JCALL ALIGN                    CALL ALIGNMENT ROUTINE          10638000
         L     R2,FULLWD                GET ALIGNMENT LENGTH            10639000
         EX    R2,ORLEN                 OR LENGTH INTO OUTPUT DATA      10640000
         SET   ENTALN,ON                TURN ON ALIGNMENT INDICATOR     10641000
         SR    R10,R10                  SET PRINT INDEX                 10642000
         JCALL OUTPUT                   GO PRINT LENGTH                 10643000
CCW150   MVC   LOCATN,ELCTR             MOVE IN ALIGNED LOCATION CTR    10644000
         XC    DCDATA(D8),DCDATA        CLEAR OBJECT CODE               10645000
         OI    LHFLGS,D8+ENTDC          INDICATE LENGTH                 10646000
         GOIF  OPNPRS,OFF=CCWER1        ERROR IF NO OPERAND             10647000
         L     R10,OPNADR               GET OPERAND POINTER             10648000
         JCALL EVAL                     EVALUATE OPERAND                10649000
         BNZ   CCWER2                   GO LOG ERROR IF OPERAND BAD     10650000
         CH    R11,=H'255'              IS VALUE TOO LARGE              10651000
         BH    CCWER3                   GO LOG ERROR IF IT IS           10652000
         LTR   R11,R11                  TEST FOR NEGATIVE VALUE         10653000
         BM    CCWER15                  ERROR IF NEGATIVE               10654000
CCW200   STC   R11,DCDATA               SAVE VALUE FOR OUTPUT           10655000
CCW225   GOIF  D0(R14),JCOMMA,NE=CCWER4 IS SYNTAX OK                    10656000
         LA    R10,D1(,R14)             STEP PAST COMMA                 10657000
         JCALL EVAL                     GO EVALUATE SECOND OPERAND      10658000
         ST    R11,DWORD2               SAVE VALUE                      10659000
         MVC   DCDATA+D1(D3),DWORD2+D1  MOVE VALUE TO OUTPUT AREA       10660000
         BC    ABSX,CCW250              SKIP RLD IF ABSOLUTE            10661000
         BC    ERRX,CCW250              SKIP RLD IF FATAL ERROR         10662000
         LR    R4,R14                   SAVE OPERAND SCAN POINTER       10663000
         L     R1,LOCATN                GET CCW LOCATION                10664000
         LA    R1,D1(,R1)               STEP FOR RLD LOCATION           10665000
         ST    R1,DWORD1                SAVE FOR RLD OUTPUT             10666000
         MVI   DWORD1,D0                SET RLD TYPE FLAG               10667000
         LA    R1,D3                    GET LENGTH                      10668000
         STH   R1,DWORD2                SAVE FOR RLD OUTPUT             10669000
         JCALL RLDOUT                   GO LOG RLD                      10670000
         LR    R14,R4                   RESTORE OPERAND SCAN POINTER    10671000
CCW250   L     R11,DWORD2               GET VALUE BACK                  10672000
         GOIF  (R11),NEG=CCWER14        ERROR IF NEGATIVE               10673000
         C     R11,=A(X'FFFFFF')        MAXIMUM VALUE                   10674000
         BH    CCWER14                  GO LOG ERROR                    10675000
CCW275   GOIF  D0(R14),JCOMMA,NE=CCWER6 COMMA EXPECTED                  10676000
         LA    R10,D1(,R14)             STEP PAST COMMA                 10677000
         JCALL EVAL                     GO EVALUATE THIRD OPERAND       10678000
         BNZ   CCWER7                   MUST BE ABSOLUTE                10679000
         CH    R11,=H'255'              IS VALUE TOO BIG                10680000
         BH    CCWER9                   YES, GO LOG ERROR               10681000
CCW300   STC   R11,DCDATA+D4            SAVE VALUE FOR OUTPUT           10682000
         TM    DCDATA+D4,BIT6+BIT7      IS BIT 38 AND 39 ZERO           10683000
         BNZ   CCWER8                   NO  - ERROR                     10684000
CCW325   GOIF  D0(R14),JCOMMA,NE=CCWER10 IS SYNTAX STILL OK             10685000
         LA    R10,D1(,R14)             STEP PAST COMMA                 10686000
         JCALL EVAL                     GO EMULATE FORUTH OPERAND       10687000
         BNZ   CCWER11                  MUST BE ABSOLUTE                10688000
         C     R11,=F'65535'            VALUE MUST FIT IN TWO BYTES     10689000
         BH    CCWER12                  LOG ERRER IF TOO LARGE          10690000
CCW400   STH   R11,DCDATA+D6            SAVE VALUE                      10691000
CCW425   GOIF  D0(R14),JBLANK,NE=CCWER13 IS SYSNTAX STILL OK            10692000
         SPACE                                                          10693000
CCW500   LA    R10,D8                   SET ALIGNMENT                   10694000
         ST    R10,LOCLEN               SAVE FOR LOCUPD                 10695000
         JCALL LOCUPD                   CALL LOCATION UPDATE            10696000
         LA    R10,DC0OUT               SET PRINT INDEX                 10697000
         JCALL OUTPUT                   CALL PRINT ROUTINE              10698000
         SET   DCMOP,ON                 INDICATE MOP-UP                 10699000
         LA    R10,DC0OUT               SET PRINT INDEX                 10700000
         B     AOP410                   GO DO DC MOP-UP PRINT CALL      10701000
ALNTST   TM    ELCTR+D3,D0              EXECUTED ALIGNMENT TEST         10702000
ORLEN    OI    LHFLGS,D0                EXECUTED OR OF ALIGNMENT LENGTH 10703000
CCWER1   MVC   ERRPTR,OPNADR            SET COLUMN POINTER              10704000
         X5ERRL 177,CLMPTR,CCW500       MISSING OPERAND                 10705000
CCWER2   X5ERRL 179,CLMPTR,CCW500       OPERAND NOT ABSOLUTE            10706000
CCWER3   X5ERRL 183,CLMPTR,CCW225       INVALID RANGE 255 MAXIMUM       10707000
CCWER4   X5ERRL 178,CLMPTR,CCW500       COMMA EXPECTED                  10708000
CCWER6   X5ERRL 178,CLMPTR,CCW500       COMMA EXPECTED                  10709000
CCWER7   X5ERRL 179,CLMPTR,CCW325       OPERAND NOT ABSOLUTE            10710000
CCWER8   X5ERRL 244,CLMPTR,CCW325       BIT 38 AND 39 NOT SERP          10711000
CCWER9   X5ERRL 183,CLMPTR,CCW325       INVALID RANGE 255 MAXIMUM       10712000
CCWER10  X5ERRL 178,CLMPTR,CCW500       COMMA EXPECTED                  10713000
CCWER11  X5ERRL  179,CLMPTR,CCW425      OPERAND NOT ABSOLUTE            10714000
CCWER12  X5ERRL 184,CLMPTR,CCW425       INVALID RANGE 65535 MAXIMUM     10715000
CCWER13  X5ERRL 185,CLMPTR,CCW500       INVALID DELIMITER               10716000
CCWER14  X5ERRL 241,CLMPTR,CCW275       INVALID RANGE X'FFFFFF' MAX     10717000
CCWER15  X5ERRL 243,CLMPTR,CCW500       CCW OPCODE NEGATIVE             10718000
         SPACE 3                                                        10719000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10720000
               - ''DC && DS'' STATEMENT - CALL DC EVAL'                 10721000
*                                                                       10722000
*   DC STATEMENT - CALL DC EVAL                                         10723000
*                                                                       10724000
DC0100   BAL   R6,COMCALL               GO GET GOOD OPERAND COUNT       10725000
         L     R10,OPNADR               GET OPERAND ADDRESS             10726000
         JCALL DCEVAL                   CALL DC EVALUATION              10727000
         SET   DCMOP,ON                 TURN MOP-UP SWITCH              10728000
         LA    R10,DC0OUT               SET PRINT INDEX                 10729000
         JCALL OUTPUT                   GO COMPLETE DC OUTPUT           10730000
         JEXTRN (X5D01=DCEVAL)          DEFINE EXTERNAL SYMBOL          10731000
         B     AOP300                   EXIT TO MAINLINE                10732000
         SPACE 5                                                        10733000
*                                                                       10734000
*   DS STATEMENT - CALL DC EVAL                                         10735000
*                                                                       10736000
DS0100   SET   DSSW,ON                  INDICATE ENTRY IS A DS          10737000
         BAL   R6,COMCALL               GO GET GOOD OPERAND COUNT       10738000
         L     R10,OPNADR               POINT TO OPERAND                10739000
         JCALL DCEVAL                   CALL DC EVALUATION              10740000
         SET   DCMOP,ON                 SET MOP UP SWITCH ON            10741000
         LA    R10,DC0OUT               LOAD PRINT INDEX                10742000
         JCALL OUTPUT                   GO MOP UP DS                    10743000
         SET   DSSW,OFF                 TURN OFF DS SWITCH              10744000
         B     AOP300                   EXIT                            10745000
         SPACE 3                                                        10746000
      TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR- ASSEMBLY PHASE-10747000
               - ''START, CSECT, DSECT && COM'' STATEMENT PROCESSOR'    10748000
START0   L     R11,SYMDEF               GET DATA POINTER                10749000
DSECT0   EQU   START0                   DEFINE DSECT ENTRY POINT        10750000
COM100   EQU   START0                   DEFINE COM ENTRY POINT          10751000
CSECT0   EQU   START0                   DEFINE CSECT ENTRY POINT        10752000
         GOIF  NAMPRS,ON=STR100         IS CONTROL SECTOIN NAMED        10753000
         LH    R10,JINFILE              GET INPUT FILE NUMBER           10754000
         JGETL FILE=(R10)               GET RESOLUTION DATA             10755000
         SPACE                                                          10756000
STR100   GOIF  JTSTART,NE=STR110        ARE WE PROCESSING START CARD?   10757000
         TM    RFLGB,BIT0               IS IT VALID?                    10758000
         BO    STR110                   BRANCH AROUND IF YES            10759000
         X5ERRL 164,0                   INVALID START CARD              10760000
         SPACE                                                          10761000
STR110   MVC   ELCTR,RLCTR              START LOCATION COUNTER          10762000
         MVC   EESDI,RESDI              INITIALIZE ESD FOR THIS CSECT   10763000
         MVC   LOCATN,RLCTR             MOVE VALUE TO LEFT HALF PRINT   10764000
         CLC   ELCTR,=A(X'FFFFFF')      IS CSECT START LOC BELOW LIMIT  10765000
         BNH   AOP405                   YES , GO PRINT AND EXIT         10766000
         GOIF  WRPFLG,ON=AOP405         GO PRINT IF ALREADY LOGGED      10767000
         SET   WRPFLG,ON                INDICATE ERROR LOGGED           10768000
         X5ERRL 246,0                   LOG LOCATION COUNTER ERROR      10769000
         B     AOP405                   GO PRINT AND EXIT               10770000
         SPACE 3                                                        10771000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10772000
               - ''ENTRY && EXTRN'' STATEMENT PROCESSOR'                10773000
ENTRY0   GOIF  OPNPRS,OFF=ENXER1        IS OPERAND BLANK                10774000
EXTRN0   EQU   ENTRY0                   DEFINE EXTRN ERTRY POINT        10775000
         L     R4,OPNADR                POINT TO THE OPERAND            10776000
ENX100   LR    R1,R4                    INITIALIZE SCAN REGISTER        10777000
         ST    R1,ERRPTR                SAVE OPERAND PTR FOR LOGGING    10778000
         GOIF  D0(R1),JALFAMIN,LT=ENXER2 FIRST CHARACTER NON-NUMERIC    10779000
ENX200   GOIF  D0(R1),JALFAMAX,GT=ENX300 IS CHARACTER LEGAL IN SYMBOL   10780000
         LA    R1,D1(,R1)               STEP TO NEXT CHARACTER          10781000
         B     ENX200                   CONTINUE SCAN                   10782000
ENX300   GOIF  D0(R1),JBLANK,EQ=ENX325  WAS DELIMITER A BLANK           10783000
         GOIF  D0(R1),JCOMMA,NE=ENXER2  NO, WAS DELIMITER A COMMA       10784000
ENX325   SR    R1,R4                    GET LENGTH OF SYMBOL            10785000
         BZ    ENXER2                   SHOULD NOT BE ZERO              10786000
         CH    R1,=H'8'                 IS SYMBOL 8 CHARACTERS OR LESS  10787000
         BH    ENXER4                   NO, GO LOG ERROR                10788000
         AR    R4,R1                    POINT TO DELIMITER              10789000
         LH    R10,JINFILE              POINT TO INPUT FILE             10790000
         JGETL FILE=(R10)               GET NEXT RECORD                 10791000
         GOIF  JTENTRY,EQ=ENX400        IS ENTRY AN ENTRY               10792000
         LA    R2,BASE                  INDICATE BASE FOR XREF          10793000
         GOIF  PRIORDEF,OFF=ENX350      IF NOT DUPLICATE BRANCH AROUND  10794000
         ST    R11,ERRPTR               STORE OPERAND POINTER           10795000
         X5ERRL 196,DTAPTR              LOG DUPLICATE NAME ERROR        10796000
         LA    R2,DUPL                  INDICATE DUP FOR XREF           10797000
         SPACE                                                          10798000
ENX350   JCALL XREF                     GO MAKE XREF                    10799000
         B     ENX500                   SKIP ENTRY ERROR CHECKING       10800000
ENX400   LA    R2,REF                   INDICATE REFERENCE FOR XREF     10801000
         JCALL XREF                     GO MAKE XREF FOR ENTRY          10802000
         TM    RFLGB,BIT2               VALID ENTRY?                    10803000
         BZ    ENXER6                   BRANCH IF ENTRY INVALID         10804000
ENX500   GOIF  D0(R4),JBLANK,EQ=AOP400  WAS DELIMITER A BLANK           10805000
         LA    R4,D1(,R4)               YES, STEP PAST COMMA            10806000
         B     ENX100                   CONTINUE SCAN                   10807000
         SPACE                                                          10808000
ENXER1   X5ERRL 177,0,AOP400            MISSING OPERAND                 10809000
         SPACE                                                          10810000
ENXER2   X5ERRL 186,CLMPTR,AOP400       INVALID SYMBOL                  10811000
         SPACE                                                          10812000
ENXER4   X5ERRL 187,CLMPTR,AOP400       INVALID SYMBOL - TOO LONG       10813000
         SPACE                                                          10814000
ENXER6   X5ERRL 189,0,ENX500            LOG ENTRY ERROR                 10815000
         SPACE                                                          10816000
         SPACE 3                                                        10817000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10818000
               - ''CXD'' STATEMENT PROCESSOR'                           10819000
CXD100   LA    R2,D3                    GET MAXIMUM ALIGNMENT           10820000
         EX    R2,ALNTST                DO WE NEED TO ALIGN LOCATION    10821000
         BZ    CXD200                   NO, CONTINUE CXD PROCESSING     10822000
         GOIF  JALGN,OFF=CXD200         DON'T ALIGN IF NOALIGN OPTION   10823000
         JCALL ALIGN                    GO DETERMINE ALIGNMENT          10824000
         L     R2,FULLWD                SAVE ALIGNMENT LENGTH           10825000
         EX    R2,ORLEN                 INDICATE OUTPUT LENGTH          10826000
         SET   ENTALN,ON                INDICATE ALIGNMENT              10827000
         SR    R10,R10                  LOAD OUTPUT INDEX               10828000
         JCALL OUTPUT                   GO OUTPUT ALIGNMENT             10829000
CXD200   OI    LHFLGS,ENTDC+D4          SET LENGTH AND PRINT FLAGS      10830000
         MVC   LOCATN,ELCTR             MOVE LOCATION COUNTER TO PRINT  10831000
         LA    R1,D4                    GET LENGTH OF DXD               10832000
         ST    R1,LOCLEN                SAVE LENGTH                     10833000
         STH   R1,DWORD2                SAVE CXD LENGTH                 10834000
         JCALL LOCUPD                   UPDATE LOCATION COUNTER         10835000
         TM    EESDI,BIT1+BIT2+BIT3     ARE WE IN DSECT OR COMMON       10836000
         BNZ   AOP405                   BRANCH IF YES                   10837000
         MVC   DWORD1+D1(D3),LOCATN+D1  MOVE CXD LOCATION FOR OUTPUT    10838000
         MVI   DWORD1,BIT2+BIT3         SET CXD FLAGS                   10839000
         MVC   RLIST,EESDI              POSITION AND RELOCATION ID SAME 10840000
         MVI   RELOCTR,D1               INDICATE ONLY 1 ESDID.          10841000
         JCALL RLDOUT                   GO MAKE RLD ENTRY               10842000
         XC    D8(D2,R11),D8(R11)       SET RELID TO ZERO               10843000
         B     AOP405                   GO PRINT AND EXIT               10844000
         SPACE 3                                                        10845000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10846000
               - ''LTORG'' STATEMENT PROCESSOR'                         10847000
LTORG0   LH    R1,LITPID                GET POOL ID                     10848000
         LA    R1,D1(,R1)               ADD 1                           10849000
         STH   R1,LITPID                STORE NEW POOL ID               10850000
LTO050   LA    R2,D7                    GET ALIGNMENT FACTOR            10851000
         EX    R2,ALNTST                IS ALIGNMENT NECESSARY          10852000
         BZ    LTO100                   NO, SKIP ALIGNMENT              10853000
         GOIF  JALGN,OFF=LTO100         DON'T ALIGN IF NOALIGN OPTION   10854000
         JCALL ALIGN                    YES, GO ALIGN LOCATION CTR      10855000
         SPACE                                                          10856000
LTO100   MVC   LOCATN,ELCTR             MOVE LOCATION FOR PRINTING      10857000
         GOIF  JTLTORG,NE=LTO200        IS IT A LTORG STATEMENT?        10858000
         SR    R10,R10                  SET PRINT INDEX                 10859000
         JCALL OUTPUT                   GO PRINT RECORD                 10860000
         GOIF  JERR,OFF=LTO200          ANY ERROR IN LTORG STMNT        10861000
         LA    R10,ERROUT               YES  LOAD PRINT INDEX           10862000
         JCALL OUTPUT                   GO PRINT ERROR FLAG             10863000
LTO200   L   R2,ELCTR                   IS LOCATION COUNTER GREATHER    10864000
         C     R2,=A(X'FFFFFF')         THAN MAXIMUM                    10865000
         BNH   LTO210                                                   10866000
         GOIF  WRPFLG,ON=LTO210         FORGET ERROR IF ALREADY LOGGED  10867000
         SET   WRPFLG,ON                INDICATE LCTR ERROR LOGGED      10868000
         X5ERRL  246,0                  LOG - LOCATION COUNTER ERROR    10869000
         LA    R10,ERROUT                                               10870000
         JCALL OUTPUT                   PRINT *** ERROR ***             10871000
LTO210   LH    R10,JINFILE              POINT TO SYMBOL DATA FILE       10872000
         JGETL FILE=(R10)               GET NEXT RECORD                 10873000
         GOIF  JTEND,EQ=LTO300          ARE WE PROCESSING END CARD?     10874000
         LR    R5,R11                   SAVE TEXT POINTER               10875000
         GOIF  JTADJII,EQ=LITR00        IS ENTRY A LITERAL DC           10876000
         GOIF  JTLTEND,EQ=AOP310        NO, IS IT END OF LITERAL POOL   10877000
         X5ERRL 167,0,AOP310            SYMBOL FILE OUT OF SYNC         10878000
         SPACE                                                          10879000
LTO300   CLI  RTYPE,JTLTEND             IF LITERAL END, THEN EXIT       10880000
         BC    8,AOP310                 YES,EXIT                        10881000
         MVC   ELCTR,RLCTR              RESUMED LOCATION COUNTER        10882000
         MVC   EESDI,RESDI              RESUME ESDID                    10883000
         MVI   JTIOP1,X'00'             ZEROED OUT OPCODE               10884000
         B     LTO050                   GO CHECK ALIGNMENT              10885000
         SPACE 3                                                        10886000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10887000
               - ''LITR'' STATEMENT PROCESSOR'                          10888000
LITR00   L     R1,STMTN                 GET STATEMENT NUMBER            10889000
         LA    R1,1(,R1)                INCREMENT 1                     10890000
         C     R1,=F'65535'             IS IT THE LIMIT ?               10891000
         BNH   LITR05                   NO,BRANCH AROUND                10892000
         SR    R1,R1                    YES START FROM ZERO             10893000
         SPACE                                                          10894000
LITR05   ST    R1,STMTN                 SAVE IT                         10895000
         MVC   LITRSD,JTNMP             SAVE LITR * LOCATION            10896000
         MVC   LITRLC,JTOCP             SAVE LITR * ESD                 10897000
         MVI   SYMCNT,D0                ZERO NUMBER OF SYMBOLS THIS REC 10898000
         SET   LITRSW,ON                INDICATE A LITR FOR DCEVAL      10899000
         SR    R2,R2                    CLEAR REGISTER                  10900000
         LH    R2,RRCDL                 GET RECORD LENGTH               10901000
         BCTR  R2,0                     MAKE IT MOVE LENGTH             10902000
         CH    R2,=H'255'               LONGER THAN MAX MOVE LENGTH     10903000
         BNH   LITR10                  NO MOVE WILL WORK                10904000
         SH    R2,=H'256'               COMPUTE REMAINDER               10905000
         EX    R2,LITMOV2               MOVE REMAINDER                  10906000
         LH    R2,=H'255'               MOVE FIRST 256 BYTES            10907000
LITR10   EQU   *                                                        10908000
         EX    R2,LITMOV                MOVE LITERAL TO X5ATEMP         10909000
         SR    R2,R2                    CLEAR REGISTER                  10910000
         IC    R2,RLNGA                 GET MACHINE LENGTH OF LITERAL   10911000
         LA    R5,X5ALIT                TREAT IT AS TEXT FILE RECORD    10912000
         EX    R2,LITMVX                MOVE LITERAL IN RECORD  OX00222 10913000
         MVC   JTRLI(D23),=AL1(0,0,0,0,X'2C',0,0,18,0,18,0,20,0,18,0,18*10914000
               ,0,0,0,0,16,0,JEQUAL)    BUILT TEXT REC FOR LIT  OX00222 10915000
         MVC   JTFLGA(D1),RFLGA         MOVE IN FLAG A          OX00222 10916000
         LA    R2,D1(R2)                INCREMENT BY 1          OY01863 10917000
         STC   R2,D21(R5)               INSERT LIT TRUE LENGTH  OX00222 10918000
         LA    R1,D23(R2)               COMPUTE REC LENGTH      OX00222 10919000
         STH   R1,JTRLI                 PUT IN REC LENGTH       OX00222 10920000
         LH    R10,JOUTFILE             POINT TO OUTPUT FILE            10921000
         JPUTL FILE=(R10),BUFREQ=(R1)   LOCATE NEXT BUFFER              10922000
         USING XRFIN,R11                XREF RECORD USING               10923000
         LA    R1,D20(R2)               COMPUTE LENGTH                  10924000
         STH   R1,XRECLN                PUT IN DEFINITION RECORD        10925000
         MVC   XFLAG(4),=AL2(0,LITTYPE*256)  XREF RECORD HEADER         10926000
         STC   R2,LITDTL                PUT IN LITERAL LENGTH           10927000
         BCTR  R2,0                     GIVE TRUE LENGTH        OX00086 10928000
         EX    R2,LITRMV                MOVE LITERAL TO RECORD  OX00086 10929000
         MVC   XRFSYM(D4),ELCTR         MOVE LOCATION TO XREF RECORD    10930000
         MVC   XRFSYM+D4(D2),EESDI      MOVE ESD TO XREF RECORD         10931000
         MVC   XRFSYM+6(1),LITPID+1     MOVE LITPOOL ID TO XREF RECORD  10932000
         MVI   XRFSYM+7,X'00'           ZEROED OUT BYTE                 10933000
         MVI   XRFFLG,BASE              INDICATE BASE REFERENCE         10934000
         MVC   XRFSTM,STMTN+D2          STATEMENT NUMBER TO RECORD      10935000
         SR    R10,R10                  CLEAR REGISTER                  10936000
         IC    R10,JTFLGA               GET LENTH ATTRIBUTE             10937000
         LA    R10,D1(,R10)             INCREMENT BY 1                  10938000
         STH   R10,LCTRSAV              SAVE FOR MOVING                 10939000
         MVC   XRFLEN,LCTRSAV           MOVE TO XREF RECORD             10940000
         SPACE                                                          10941000
         LH    R1,JTRLI                 GET RECORD LENGTH               10942000
         LA    R10,D23(R5)              POINT AT EXPRESSION     OX00222 10943000
         ST    R10,OPNADR               SAVE OPERAND ADDRESS            10944000
         ST    R5,TXTPTR                SAVE LITERAL TEXT PTR           10945000
         AR    R1,R5                    ADD RECORD LENGTH TO RECORD PTR 10946000
         ST    R1,OPNEND                SAVE OPERAND END                10947000
         SET   (DCSWH,DCCOMP,DCMOP,DCSTRT),OFF TURN OFF ALL DC FLAGS    10948000
         JCALL DCEVAL                   GO TO DC EVALUATION ROUTINE     10949000
         SET   LITRSW,OFF               TURN OFF LITERAL SWITCH         10950000
         SET   DCMOP,ON                 TURN MOP-UP SWITCH ON           10951000
         LA    R10,DC0OUT               GET DC PRINT INDEX              10952000
         JCALL OUTPUT                   CALL OUTPUT                     10953000
         GOIF  JERR,OFF=LTO200          ANY ERRORS FLAGGED?             10954000
         LA    R10,ERROUT               LOAD ERROR FLAG INDEX           10955000
         SET   PERR,OFF                 TURN PRINT ERROR FLAG  OFF      10956000
         JCALL OUTPUT                   GO PRINT ERROR FLAG             10957000
         B     LTO200                   GO SEE IF THERE IS MORE LITR'S  10958000
LITRMV   MVC   LITDTA(0),D22(R5)        MOVE LITERAL            OX00222 10959000
LITMOV   MVC   X5ALIT(0),D0(R11)        MOVE LITERAL RECORD TO X5ALIT   10960000
LITMOV2  MVC   X5ALIT+256(0),256(R11)   MOVE FIRST 256 IF TOO LONG      10961000
LITMVX   MVC   D23(0,R5),D13(R11)       REBUILT LIT REC         OX00222 10962000
         SPACE 3                                                        10963000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10964000
               - ''PUNCH'' && ''REPRO'' STATEMENT PROCESSOR'            10965000
*                                                                       10966000
*   PUNCH STATEMENT PROCESSING                                          10967000
*                                                                       10968000
PUNCH0   BAL   R6,AOP440                GO PRINT PUNCH STATEMENT        10969000
         BAL   R6,AOP500                GO CLEAR DUPLICATE QUOTES       10970000
         GOIF  TPTEXT,ON=PUNCH3         FORGET PUNCH IF OPERAND ERROR   10971000
         CH    R11,=H'80'               IS LENGTH > 80?                 10972000
         BNH   PUNCH1                   BRANCH AROUND IF NOT HIGH       10973000
PUNER1   X5ERRL 165,0,AOP300            LOG PUNCH OPERAND ERROR         10974000
         SPACE                                                          10975000
PUNCH1   LTR   R11,R11                  IS LENGTH =0?                   10976000
         BZ    PUNER1                   IF YES GO LOG ERROR             10977000
         GOIF  JSYSGEN,OFF=PUNCH2       NEED TO CHECK? NO,BRANCH        10978000
         GOIF  JPRESD,ON=AOP300         RECORD PUNCHED ALREADY?         10979000
         SPACE                                                          10980000
PUNCH2   LA    R10,PUNOUT               LOAD PUNCH INDEX                10981000
         B     AOP410                   GO PUNCH STATEMENT              10982000
         SPACE                                                          10983000
PUNCH3   SET   TPTEXT,OFF               RESET BAD OPERAND INDICATOR     10984000
         B     AOP300                   GET OUT                         10985000
         SPACE 3                                                        10986000
*                                                                       10987000
*   REPRO STATEMENT PROCESSING                                          10988000
*                                                                       10989000
REPRO0   LA    R10,RPOOUT               LOAD INDEX FOR REPRO CARD       10990000
         B     AOP410                   GO PUNCH AND PRINT              10991000
         SPACE 3                                                        10992000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -10993000
               - ''PUSH'' STATEMENT PROCESSOR'                          10994000
PUSH00   GOIF  OPNPRS,OFF=PUSHR1        ERROR NO OPERAND                10995000
         L     R4,OPNADR                POINT TO OPERAND                10996000
PSH100   CLC   D0(D5,R4),PSPOUS         PUSH USING                      10997000
         ST    R4,ERRPTR                SAVE COLUMN PTR                 10998000
         BE    PSH400                   YES, GO PUSH USING DOWN LEVEL   10999000
         CLC   D0(D5,R4),PSPOPR         PUSH PRINT                      11000000
         BNE   PUSHR2                   NO - REQUEST INVALID            11001000
         LH    R1,PRPU                  GET PRINT PUSH COUNT            11002000
         CH    R1,=AL2(PUPOLV)          DOES REQUEST EXCEED LEVEL       11003000
         BNL   PUSHR3                   YES, GO LOG ERROR               11004000
         LA    R2,PRPU+D2(R1)           POINT TO PUSH PRINT SAVE AREA   11005000
         MVC   D0(D1,R2),PRINTSW        SAVE PRINT SWITCHES             11006000
         LA    R1,D1(,R1)               STEP COUNT BY 1                 11007000
         STH   R1,PRPU                  SAVE NEW LEVEL COUNT            11008000
         GOIF  PSTMT,ON=PSH200          IF PRINT ON OK                  11009000
         SET   PRPP,ON                  ELSE FORCE PRINT OF PUSH        11010000
PSH200   GOIF  D5(R4),JBLANK,EQ=AOP400  OPERAND FOLLOWED BY A BLANK     11011000
         GOIF  D5(R4),JCOMMA,NE=PUSHR4  NO, IS COMMA FOLLOWING          11012000
         LA    R4,D6(,R4)               YES, STEP TO NEXT OPERAND       11013000
         B     PSH100                   CONTINUE SCAN                   11014000
PSH400   LH    R1,USPHL                 GET USING PUSH DOWN LEVEL       11015000
         CH    R1,=AL2(PUPOLV)          IN MAX. LEVEL EXCEEDED          11016000
         BNL   PUSHR3                   YES,ERROR                       11017000
         LA    R1,D1(,R1)               STEP LEVEL COUNT                11018000
         STH   R1,USPHL                 SAVE NEW COUNT                  11019000
         MH    R1,=AL2(USTL)            POINT TO SPACE TO PUSH          11020000
         LA    R1,USINGT(R1)             USING TABLE                    11021000
         MVC   D0(USTL,R1),USINGT       SAVE USING TABLE                11022000
         B     PSH200                   CONTINUE SCAN                   11023000
         SPACE                                                          11024000
PUSHR1   MVC   ERRPTR,OPNADR            SET COLUMN PTR                  11025000
         X5ERRL 177,CLMPTR,AOP400       MISSING OPERAND                 11026000
         SPACE                                                          11027000
PUSHR2   X5ERRL 190,CLMPTR,AOP400       UNDEFINED PUSH REQUEST          11028000
         SPACE                                                          11029000
PUSHR3   X5ERRL 191,CLMPTR,AOP400       PUSH LEVEL EXCEEDED - PRINT     11030000
         SPACE                                                          11031000
PUSHR4   X5ERRL 185,CLMPTR,AOP400       INVALID DELIMITER -BLANK        11032000
         SPACE 3                                                        11033000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11034000
               - ''POP'' STATEMENT PROCESSOR'                           11035000
POP100   GOIF  OPNPRS,OFF=POPER1        DOES POP HAVE AN OPERAND        11036000
         L     R4,OPNADR                POINT TO OPERAND                11037000
POP200   CLC   D0(D5,R4),PSPOUS         ARE WE POPING USING             11038000
         ST    R4,ERRPTR                SAVE COLUMN PTR                 11039000
         BE    POP400                   YES, GO MOVE USING UP A LEVEL   11040000
         CLC   D0(D5,R4),PSPOPR         POP PRINT REQUESTED             11041000
         BNE   POPER2                   NO, ERROR UNDEFINED OPERATION   11042000
         LH    R1,PRPU                  GET PRINT PUSH LEVEL            11043000
         LTR   R1,R1                    IS TI ZERO                      11044000
         BZ    POPER3                   YES, EXCEEDED PUSH LEVEL        11045000
         BCTR  R1,0                     DECREMENT COUNT                 11046000
         LA    R2,PRPU+D2(R1)           POINT TO LAST LEVEL SAVED       11047000
         MVC   PRINTSW,D0(R2)           RESTORE PREVIOUS PRINT SWITCH   11048000
         STH   R1,PRPU                  SAVE NEW PUSH COUNT             11049000
         GOIF  PSTMT,ON=POP300          IF PRINT ON OK                  11050000
         SET   PRPP,ON                  ELSE FORCE PRINT OF POP         11051000
POP300   GOIF  D5(R4),JBLANK,EQ=AOP400  IS PUSH OPERAND FOLLOWED BLANK  11052000
         GOIF  D5(R4),JCOMMA,NE=POPER4  NO, CHECK COMMA - IF NO ERROR   11053000
         LA    R4,D6(,R4)               YES, POINT TO NEXT OPERAND      11054000
         B     POP200                   CONTINUE SCAN OF OPERAND        11055000
POP400   LH    R1,USPHL                 GET USING PUSH LEVEL            11056000
         LTR   R2,R1                    SAVE AND TEST FOR ZERO          11057000
         BZ    POPER3                   NO MORE LEVEL TO POP            11058000
         MH    R1,=AL2(USTL)            POINT TO USING PUSH DOWN        11059000
         LA    R1,USINGT(R1)             SEGMENT FOR RESTORE            11060000
         MVC   USINGT(USTL),D0(R1)      RESTORE USING TABLE             11061000
         BCTR  R2,0                     DECREMENT PUSH DOWN LEVEL       11062000
         STH   R2,USPHL                 SAVE NEW PUSH COUNT             11063000
         B     POP300                   CONTINUE SCAN                   11064000
         SPACE                                                          11065000
POPER1   MVC   ERRPTR,OPNADR            SET COLUMN PTR                  11066000
         X5ERRL 177,CLMPTR,AOP400       MISSING OPERAND                 11067000
         SPACE                                                          11068000
POPER2   X5ERRL 192,CLMPTR,AOP400       INVALID (UNDEFINED) POP REQUEST 11069000
         SPACE                                                          11070000
POPER3   X5ERRL 193,CLMPTR,AOP400       NO LEVEL LEFT TO POP FOR PRINT  11071000
         SPACE                                                          11072000
POPER4   X5ERRL 185,CLMPTR,AOP400       INVALID DELIMITER - BLANK       11073000
PUPOLV   EQU   4                        PUSH LEVEL MAXIMUM              11074000
USTL     EQU   (17*8)                   USING TABLE LENGTH              11075000
PSPOUS   JGENIN 'USING'                 INTERNAL DC -USING-             11076000
PSPOPR   JGENIN 'PRINT'                 INTERNAL DC -PRINT-             11077000
         SPACE 3                                                        11078000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11079000
               - ''PRINT'' STATEMENT PROCESSOR'                         11080000
PRINT0   IC    R2,PRINTSW               SAVE PRINT SWITCH               11081000
         SET   (PSTMT,PGEN),ON          FORCE PRINT ON                  11082000
         BAL   R6,AOP440                GO PRINT PRINT STATEMENT        11083000
         STC   R2,PRINTSW               RESTORE PRINT SWITCH            11084000
         GOIF  OPNPRS,OFF=PRTER1        GO LOG ERROR IF NO OPERAND      11085000
         L     R10,OPNADR               GET OPERAND POINTER             11086000
         L     R11,OPNEND               GET OPEREND END                 11087000
         SR    R14,R14                  ZERO REGISTER TO CLEAR 3 BYTES  11088000
PRT100   LA    R15,PRTBL                POINT TO POSSIBLE PRINT OPERNDS 11089000
         CR    R10,R11                  ARE WE TO THE END OF OPERAND    11090000
         BNL   PRT350                   YES,GO LOG ERROR                11091000
PRT300   IC    R14,D0(,R15)             GET LENGTH OF TABLE ENTRY       11092000
         EX    R14,PRTCLC               IS THIS THE PRINT OPTION        11093000
         BE    PRT400                   YES, GO SET PRINT FLAGS         11094000
         LA    R15,D3(R14,R15)          POINT TO NEXT TABLE ENTRY       11095000
         GOIF  D0(R15),BITFF,NE=PRT300  HAVE WE SCANNED THE WHOLE TABLE 11096000
         SPACE                                                          11097000
PRT350   ST    R10,ERRPTR               SAVE OPERAND COLUMN PTR         11098000
         X5ERRL 194,CLMPTR,AOP300       INVALID PRINT REQUEST           11099000
PRT400   ST    R10,ERRPTR               SAVE ERROR PTR                  11100000
         LA    R10,D1(R14,R10)          POINT TO NEXT OPERAND           11101000
         GOIF  D0(R10),JBLANK,EQ=PRT450 OK IF DELIMITED BY BLANK        11102000
         GOIF  D0(R10),JCOMMA,NE=PRTER2 ERROR IF NOT DELIMITED BY COMMA 11103000
         SPACE                                                          11104000
PRT450   TM    D1(R15),BIT7             HOW TO TURN FLAG                11105000
         BO    PRT600                   GO TO TURN FLAG OFF             11106000
         OC    PRINTSW,D1(R15)          TURN FLAG ON                    11107000
         SPACE                                                          11108000
PRT500   GOIF  D0(R10),JCOMMA,NE=AOP300  FINISH IF NOT COMMA            11109000
         LA    R10,D1(R10)              STEP PASS COMMA                 11110000
         B     PRT100                   GO SCAN NEXT OPERAND            11111000
PRT600   NC    PRINTSW,D1(R15)          TURN OF FLAG                    11112000
         B     PRT500                   GO STEP TO NEXT OPERAND         11113000
PRTER1   X5ERRL 177,0,AOP300            NO OPERAND                      11114000
PRTER2   X5ERRL 185,CLMPTR,AOP300       INVALID DELIMITER               11115000
PRTCLC   CLC   D0(0,R10),D2(R15)        COMPARE EXECUTED ABOVE          11116000
PRTBL    DC    AL1(L'GON-1)             LENGTH OF 'ON' -1               11117000
         DC    AL1(PSTMT)               OR FLAG TO TURN ON PSTMT        11118000
GON      JGENIN 'ON'                    ON - INTERNAL                   11119000
         DC    AL1(L'GOFF-1)            LENGTH OF 'OFF' -1              11120000
         DC    AL1(BITFF-PSTMT)         AND FLAG TO TURN OF PSTMT       11121000
GOFF     JGENIN 'OFF'                   OFF - INTERNAL                  11122000
         DC    AL1(L'GGEN-1)            LENGTH OF 'GEN' -1              11123000
         DC    AL1(PGEN)                OR FLAG TO TURN ON PGEN         11124000
GGEN     JGENIN 'GEN'                   GEN - INTERNAL                  11125000
         DC    AL1(L'GDATA-1)           LENGTH OF 'DATA' -1             11126000
         DC    AL1(PDATA)               OR FLAG TO TURN ON PDATA        11127000
GDATA    JGENIN 'DATA'                  DATA - INTERNAL                 11128000
         DC    AL1(L'GNOGN-1)           LENGTH OF 'NOGEN' -1            11129000
         DC    AL1(BITFF-PGEN)          AND FLAG TO TURN OFF PGEN       11130000
GNOGN    JGENIN 'NOGEN'                 NOGEN-INTERNAL                  11131000
         DC    AL1(L'GNODTA-1)          LENGTH OF 'NODATA' -1           11132000
         DC    AL1(BITFF-PDATA)         AND FLAG TO TURN OFF PDATA      11133000
GNODTA   JGENIN 'NODATA'                                                11134000
         DC    AL1(BITFF)                                               11135000
         SPACE 3                                                        11136000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11137000
               - ''USING'' STATEMENT PROCESSOR'                         11138000
USING0   GOIF  OPNPRS,ON=USI050         OPERAND PRESENT?                11139000
         X5ERRL 210,0,AOP405            LOG ERROR AND EXIT              11140000
         SPACE                                                          11141000
USI050   XC    LHSAVE(2),LHSAVE         CLEAR SAVE AREA                 11142000
         L     R10,OPNADR               GET OPERAND POINTER             11143000
         ST    R10,ERRPTR               SAVE COLUMN PTR                 11144000
         GOIF  D0(R10),JASTER,GT=USI800 IS 1ST OPERAND PRESENT?         11145000
         LH    R2,LHSAVE                GET OPERAND COUNT               11146000
         LA    R2,D1(R2)                INCREMENT BY 1                  11147000
         STH   R2,LHSAVE                STORE OPERAND COUNT             11148000
         BAL   R6,AOP600                GO EVALUATE FIRST OPERAND       11149000
         BC    CMPX+ERRX,USI900         IS 1ST OPERAND VALID?           11150000
         LR    R6,R11                   SAVE REGISTER                   11151000
         LTR   R11,R11                  IS VALUE NEGATIVE               11152000
         BNM   USI085                   NO,BRANCH AROUND                11153000
         LCR   R6,R11                   COMPLEMENT VALUE                11154000
         SPACE                                                          11155000
USI085   STM   R10,R11,DWORD1           SAVE ESD AND VALUE              11156000
         GOIF  D0(R14),JCOMMA,NE=USI600 IF NOT A COMMA-SYNTATIC ERROR   11157000
         MVC   ADDRS2(D4),DWORD1+D4     MOVE VALUE TO LEFT HALF         11158000
         SET   EOUBIT,ON                INDICATE NO LOCTR IN LISTING    11159000
USI100   LA    R10,D1(,R14)             POINT TO NEXT OPERAND           11160000
         LH    R2,LHSAVE                GET OPERAND COUNT               11161000
         LA    R2,D1(R2)                INCREMENT OPERAND COUNT BY 1    11162000
         STH   R2,LHSAVE                STORE OPERAND COUNT             11163000
         CH    R2,=H'17'                TOO MANY OPERAND?               11164000
         BNH   USI110                   NO,BRANCH AROUND                11165000
         X5ERRL 211,0,AOP405            LOG ERROR AND EXIT              11166000
         SPACE                                                          11167000
USI110   BAL   R6,AOP600                GO EVALUATE                     11168000
         BNZ   USI700                   GO LOG ERROR IF NOT ABSOLUTE    11169000
         STH   R11,DWORD2               SAVE REGISTER NUMBER            11170000
         CL    R11,=A(HIREG)            IS REGISTER NUMBER TO HIGH      11171000
         BH    USI700                   YES, GO LOG ERROR               11172000
         GOIF  (R11),ZERO=USI500        IS REGISTER NUMBER ZERO         11173000
USI120   LA    R4,USINGT                POINT TO USING TABLE            11174000
         USING UESD,R4                  ESTABLISH USING FOR USING TABLE 11175000
         LR    R1,R14                   SAVE OPERAND TERMINATOR POINTER 11176000
USI200   TM    UREG,X'0F'               ARE WE TO THE END OF   @OX08876 11177000
         BO    USI300                    TABLE - YES, TRM SCN  @OX08876 11178000
         CLC   UREG,DWORD2              NO, CHECK REGISTER              11179000
         BE    USI320                   BRANCH IF REPLACING REGISTER    11180000
         LA    R4,USNXT                 POINT TO NEXT ENTRY             11181000
         B     USI200                   CONTINUE SCAN                   11182000
USI300   XC    USNXT(USSL),USNXT        MAKE SURE END OF TABLE DEFINED  11183000
         MVI   USNXT+D6,X'0F'           IND END OF TABLE       @OX08876 11184000
USI320   MVC   UESD(USSL),DWORD1+D2     MOVE IN NEW USING ENTRY         11185000
         NC    UESD,UESD                IS ESD ZERO                     11186000
         BNZ   USI340                   NO, NOT ABSOLUTE                11187000
         SET   ABSUS,ON                 TURN ABSOLUTE USING SWITCH      11188000
USI340   LA    R6,USINGT                PREPARE FOR BUBBLE SORT         11189000
         USING JTEXTA,R4                RE-ESTABLISH OPERAND USING      11190000
         USING UESD,R6                  CHANGE USING FOR USING TABLE    11191000
         SET   USSRT,OFF                TURN OFF SORT SWITCH            11192000
USI360   TM    USNXT+D6,X'0F'           HAVE WE  END OF TABLE  @OX08876 11193000
         BO    USI400                   YES, SORT COMPLETE?    @OX08876 11194000
         CLC   UESD(2),USNXT            COMPARE ESD'S                   11195000
         BL    USI380                   GO TO EXCHANGE IF LOW           11196000
         BH    USI370                   GO TO NEXT IF HIGH              11197000
         L     R15,UVAL                 GET USING VALUE                 11198000
         C     R15,USNXT+D2             COMPARE VALUES                  11199000
         BL    USI380                   GO TO EXCHANGE IF LOW           11200000
         BH    USI370                   GO TO NEXT ENTRY IF HIGH        11201000
         CLC   UREG+D1(1),USNXT+D7      COMPARE REGISTER NR    @OX08876 11202000
         BL    USI380                   NO, GO EXCHANGE ENTRIES         11203000
USI370   LA    R6,USNXT                 STEP TO NEXT ENTRY              11204000
         B     USI360                   CONTINUE SORT                   11205000
USI380   XC    UESD(USSL),USNXT         EXCHANGE (SORT)                 11206000
         XC    USNXT(USSL),UESD           ENTRIES                       11207000
         XC    UESD(USSL),USNXT             IN USING TABLE              11208000
         SET   USSRT,ON                 TURN ON SORT FLAG               11209000
         B     USI370                   GO CONTINUE SORT                11210000
USI400   GOIF  USSRT,ON=USI340          IS SORT COMPLETE                11211000
USI420   EQU   *                        STEP TO NEXT OPERAND            11212000
         GOIF  D0(R14),JBLANK,EQ=AOP405  ARE WE AT THE END OF OPERAND   11213000
         GOIF  D0(R14),JCOMMA,NE=USI600  IS TERMINATOR A COMMA          11214000
         L     R2,DWORD1+D4             YES, GET VALUE                  11215000
         AH    R2,=H'4096'              ADD 4096 FOR SECOND USING       11216000
         ST    R2,DWORD1+D4             SAVE NEW VALUE                  11217000
         B     USI100                   GO GET NEXT REGISTER            11218000
USI500   CLC   LHSAVE(2),=H'2'          IS REGISTER ZERO THE FIRST OPRA 11219000
         BNE   USI700                   NO,GO LOG ERROR                 11220000
         XC    DWORD1+D4(L'UVAL),DWORD1+D4 NO, ZERO VALUE               11221000
         B     USI120                   GO ENTER ENTRY                  11222000
USI600   X5ERRL 178,CLMPTR,AOP405       SYNTAX ERROR                    11223000
USI700   X5ERRL 195,CLMPTR,AOP405       INVALID REGISTER                11224000
USI800   X5ERRL 216,CLMPTR,AOP405       ILLEGAL FORMAT                  11225000
USI900   X5ERRL 217,CLMPTR,AOP405       RELOCATABILITY ERROR            11226000
         SPACE 3                                                        11227000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11228000
               - ''DROP'' STATEMENT PROCESSOR'                          11229000
DROP00   L     R10,OPNADR               GET OPERAND POINTER             11230000
         GOIF  OPNPRS,OFF=DRP400        DROP ALL IF OPERAND EMPTY       11231000
         CLC   D0(2,R10),=AL1(JCOMMA,JBLANK) IS OPERAND MISSING?        11232000
         BE    DRP400                   BRANCH IF YES                   11233000
         GOIF  D0(R10),JASTER,GT=DRP800 IS OPERAND MISSING?             11234000
DRP100   BAL   R6,AOP600                GO EVALUATE OPERAND             11235000
         BNZ   DRP700                   EVAL ERRORS OR RELOCATABLE      11236000
         CL    R11,=A(HIREG)            IS REGISTER VALID               11237000
         BH    DRP700                   NO GO LOG ERROR                 11238000
         LA    R4,USINGT                POINT TO USING TABLE            11239000
         DROP  R6                       ELIMINATE USING THIS REGISTER   11240000
         USING UESD,R4                  DEFINE USING FOR TABLE SCAN     11241000
DRP200   TM    UREG,X'0F'               IS SCAN COMPLETE       @OX08876 11242000
         BO    DRP500                   YES8 REG NOT IN USE    @OX08876 11243000
         CH    R11,UREG                 IS THIS REGISTER TO BE DROPPED  11244000
         BE    DRP300                   REGISTER FOUND GO DELETE        11245000
         LA    R4,USNXT                 STEP TO NEXT ENTRY              11246000
         B     DRP200                   CONTINUE SCAN                   11247000
DRP300   LA    R2,USINGT+USSL*(HIREG+D2)-D1  POINT END OF TABLE         11248000
         SR    R2,R4                    GET MOVE LENGTH REMAINDER TABLE 11249000
         BNH   DRPABT                   ABORT SOMETHING IS WRONG        11250000
         EX    R2,DRPMVC                OVERLAY DROPED REGISTER         11251000
DRP350   GOIF  D0(R14),JBLANK,EQ=AOP400 REGISTER(S) DROPPED EXIT        11252000
         GOIF  D0(R14),JCOMMA,NE=DRP600 INVALID SYNTAX                  11253000
         LA    R10,D1(,R14)             POINT TO NEXT OPERAND           11254000
         B     DRP100                   GO REPEAT PROCESS               11255000
DRP400   XC    USINGT(USSL),USINGT      INITAILIZE USING TABLE          11256000
         MVI   USINGT+D6,X'0F'          IND END OF TABLE       @OX08876 11257000
         SET   ABSUS,OFF                TURN OFF ABSOLUTE USING SWITCH  11258000
         B     AOP400                   GO PRINT AND EXIT               11259000
DRP500   X5ERRL 195,CLMPTR,AOP400       INVALID REGISTER                11260000
DRP600   X5ERRL 178,CLMPTR,AOP400       SYNTAX ERROR                    11261000
DRP700   LR    R2,R14                   SAVE TEXT POINTER               11262000
         X5ERRL 195,CLMPTR              INVALID REGISTER                11263000
         LR    R14,R2                   RESTORE TEXT POINTER            11264000
         B     DRP350                   GO CONTINUE SCAN                11265000
DRP800   EQU   *                                                        11266000
         ST    R10,ERRPTR               SAVE COLUMN PTR                 11267000
         X5ERRL 216,CLMPTR,AOP400       ILLEGAL OPERAND FORMAT          11268000
DRPABT   DC    H'0'                                                     11269000
DRPMVC   MVC   UESD(0),USNXT            EXECUTED MVC LENGTH OR-ED IN    11270000
         SPACE 3                                                        11271000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11272000
               - ''SPACE'' AND ''EJECT'' STATEMENT PROCESSOR'           11273000
SPACE0   GOIF  OPNPRS,OFF=SPC200        GO SPACE 1 IF NO OPERAND        11274000
         L     R10,OPNADR               POINT TO OPERAND                11275000
         LR    R11,R10                  SAVE OPERAND POINTER            11276000
         CLC   D0(2,R11),=AL1(JCOMMA,JBLANK) IS OPERAND MISSING?        11277000
         BE    SPC200                   BRANCH IF MISSING               11278000
SPC050   CLI   D0(R11),JNUMMAX          IS IT NUMERIC?                  11279000
         BH    SPC075                   NO,GO CHECK FURTHER             11280000
         LA    R11,D1(R11)              SKIP TO NEXT CHARACTER          11281000
         B     SPC050                   CONTINUE SCAN                   11282000
SPC075   CLI   D0(R11),JBLANK           IS IT BLANK?                    11283000
         BNE   SPCER1                   ERROR IF NOT BLANK              11284000
         JCALL EVAL                     GO EVALUATE                     11285000
         BO    AOP400                   EVAL ERROR EXIT                 11286000
         BNZ   SPCER1                   OPERAND CANNOT BE RELOCATABLE   11287000
         LTR   R11,R11                  IS VALUE ZERO                   11288000
         BZ    AOP300                   YES, EXIT                       11289000
         BM    SPCER1                   IF NEGATIVE ERROR               11290000
SPC100   LA    R10,CAROUT               GET PRINT INDEX                 11291000
         B     AOP410                   GO SPACE PRINTER                11292000
SPC200   LA    R11,D1                   INDICATE 1 SPACE                11293000
         B     SPC100                   EXIT                            11294000
SPCER1   X5ERRL 242,CLMPTR,AOP400       OPERAND INVALID                 11295000
         SPACE 3                                                        11296000
EJECT0   LNR   R11,R13                  LOAD NEGATIVE VALUE IN REGISTER 11297000
         LA    R10,CAROUT               LOAD CARRIAGE CONTROL INDEX     11298000
         B     AOP410                   GO EJECT PAGE                   11299000
         SPACE 3                                                        11300000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11301000
               - ''TITLE'' STATEMENT PROCESSOR'                         11302000
TITLE0   BAL   R6,AOP500                GO SQUEEZE OUT QUOTE AND AMPSND 11303000
         MVI   JTITLE,JBLANK                  BLANK OUT TITLE           11304000
         MVC   JTITLE+D1(L'JTITLE-D1),JTITLE  HOLD AREA FOR NEW TITLE   11305000
         GOIF  (R11),ZERO=TTL150        NULL OPERAND - BLANK TITLE      11306000
         GOIF  TPTEXT,ON=TTL300         FORGET TITLE IF OPERAND ERROR   11307000
         CH    R11,H100                 IS TITLE LENGTH GT. 100         11308000
         BH    TTL200                   YES, SAVE ONLY 100 CHARACTERS   11309000
         BCTR  R11,0                    GET MOVE LENGTH                 11310000
         EX    R11,TTLMVC               MOVE TITLE                      11311000
TTL100   GOIF  PSTMT,OFF=AOP310         EXIT IF PRINT OFF               11312000
         GOIF  JGEN,OFF=TTL150          BRANCH AROUND IF NOT GENERATED  11313000
         GOIF  PGEN,ON=TTL150           BRANCH IF PRINT GEN             11314000
         B     AOP310                   EXIT IF PRINT NOGEN             11315000
         SPACE                                                          11316000
TTL150   LNR   R11,R13                  LOAD NEGATIVE VALUE FOR EJECT   11317000
         LA    R10,CAROUT               LOAD CARRIAGE CONTROL FOR EJECT 11318000
         JCALL OUTPUT                   CALL PRINT                      11319000
         SET   TWASLC,ON                SET BUFFER AVAIL. FLAG          11320000
         B     AOP300                   EXIT                            11321000
TTL200   X5ERRL 171,0                   TITLE LENGTH GREATER THAN 100   11322000
         MVC   JTITLE,D0(R4)            MOVE ONLY 100 CHARACTERS        11323000
         B     TTL100                   GO ESTABLISH PRINT INDEXES      11324000
TTL300   SET   TPTEXT,OFF               RESET BAD OPERAND INDICATOR     11325000
         B     AOP400                   GO PRINT TITLE STATEMENT        11326000
H100     DC    H'100'                   MAX. LENGTH OF TITLE            11327000
TTLMVC   MVC   JTITLE(D0),D0(R4)        EXECUTE MOVE OF NEW TITLE       11328000
         SPACE 3                                                        11329000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11330000
               - ''MNOTE'' STATEMENT PROCESSOR'                         11331000
MNOTE0   GOIF  OPNPRS,ON=MNO100         CHECK IF OPERAND PRESENT        11332000
         X5ERRL 177,0,AOP400            MISSING OPERAND                 11333000
MNO050   MVI   LHFLGS,DNTPLH            SET DON'T PRINT LEFTHALF        11334000
         GOIF  PSTMT,OFF=MNO075                                         11335000
         GOIF  JLIST,OFF=MNO075                                         11336000
         LA    R10,LSTOUT               GET PRINT INDEX FOR LISTING     11337000
         JCALL OUTPUT                   CALL PRINT                      11338000
MNO075   SET   MNOPRT,OFF               RESET MNOTE FLAG                11339000
         B     AOP300                   EXIT                            11340000
MNO085   GOIF  PSTMT,OFF=MNO075         EXIT IF PRINT OFF               11341000
         GOIF  JLIST,OFF=MNO075         EXIT IF NOLIST                  11342000
         SET   MNOPRT,OFF               ELSE GO EVALUATE FOR PRINT      11343000
         LA    R10,MNOOUT               LOAD MNOTE PRINT INDEX          11344000
         JCALL OUTPUT                   GO GET BUILD AREA RECORD        11345000
         LR    R2,R11                   SAVE PRINT BUFFER POINTER       11346000
         MVC   STMTNO(D5,R2),DWORD2     MOVE STATEMENT NUMBER TO PRINT  11347000
         LH    R6,JENDCL                END COLUMN                      11348000
         AR    R6,R11                   POINT TO END OF PRINT BUFFER    11349000
         B     MNO135                   GO EVALUATE                     11350000
MNO100   SET   MNOPRT,ON                INDICATE SCAN OF OPERAND        11351000
MNO135   L     R4,OPNADR                GET OPERAND POINTER             11352000
         GOIF  D0(R4),JASTER,EQ=MNO800  CHECK MNOTE SEVERITY            11353000
         GOIF  D0(R4),JNUMMAX,GT=MNO250 IS SEVERITY NUMERIC             11354000
         LR    R10,R4                   YES, SAVE PARAMETER             11355000
         JCALL EVAL                     CALL EVALUATION ROUTINE         11356000
         BNZ   MNOER1                   GO LOG ERROR                    11357000
         CH    R11,=H'255'              IS SEVERITY WITHIN RANGE        11358000
         BH    MNOER2                   NO, ERROR                       11359000
MNO150   EX    R11,PRNTLEV              IS MSG TO BE LOGGED (MSGLEVEL)  11360000
         BH    MNO200                   NO                              11361000
         GOIF  MNOPRT,OFF=MNO200        DO NOT LOG ERR IF MSG BUILD ON  11362000
         X5ERRL 197,0                   FLAG AS MNOTE ....              11363000
         EX    R11,SEVTST               IS SEVERITY HIGHER THAN RECORD  11364000
         BNL   MNO200                   NO,DONT SAVE NEW SEVERITY       11365000
         STC   R11,JSEVER               YES, SAVE NEW SEVERITY          11366000
MNO200   GOIF  MNOPRT,ON=MNO225         IF NO PRINT SKIP MOVE           11367000
         LR    R11,R14                  GET MOVE LENGTH                 11368000
         SR    R11,R4                     LENGTH OF                     11369000
         LA    R2,D4(,R2)               MNOTE WITH SEVERITY DISPLACEMT  11370000
         EX    R11,SEVMOV               MOVE TO PRINT - BY EXECUTE-     11371000
         LA    R2,D1(R11,R2)            STEP PRINT BUFFER POINTER       11372000
MNO225   GOIF  D0(R14),JCOMMA,NE=MNOER3 ERROR IF NEXT CHAR NOT ,        11373000
         LA    R4,D1(,R14)              STEP OVER COMMA                 11374000
MNO300   GOIF  D0(R4),JQUOTE,NE=MNOER3  NEED A QUOTE NOW                11375000
         LA    R4,D1(,R4)               STEP OVER QUPTE                 11376000
MNO400   GOIF  D0(R4),JQUOTE,EQ=MNO700  ELIMINATE DUPLICATE QUOTES      11377000
         GOIF  D0(R4),JAMPER,EQ=MNO750   AND AMPERSANDS                 11378000
         C    R4,OPNEND                 COMPARE WITH OPERAND END        11379000
         BNL   MNO875                   YES CHECK DELIMITER             11380000
MNO500   GOIF  MNOPRT,ON=MNO550         NO PRINT OF MNOTE ?             11381000
         MVC   MNOALN(D1,R2),D0(R4)     MOVE CHARACTER TO PRINT         11382000
         LA    R4,D1(,R4)               STEP TO NEXT CHARACTER          11383000
         LA    R2,D1(,R2)               STEP PRINT OUTPUT               11384000
         CR    R2,R6                    END OF PRINT BUFFER             11385000
         BNL   MNO600                   YES, GO PRINT LINE              11386000
         B     MNO400                   NO, CONTINUE SCAN               11387000
MNO550   LA    R4,D1(R4)                STEP TO NEXT CHAR               11388000
         B     MNO400                   CONTINUE SCAN                   11389000
MNO250   GOIF  D0(R4),JCOMMA,EQ=MNO275   COMMA ALLOWED                  11390000
         GOIF  D0(R4),JBLANK,NE=MNO300  ERROR IF NOT BLANK EITHER       11391000
         LA    R4,D1(R4)                STEP UP POINTER                 11392000
         B     MNO250                   SCAN FOR DELIMITER              11393000
MNO275   LA    R11,D1                   SET SEVERITY TO ONE             11394000
         LR    R14,R4                   POINT R14 AT COMMA (,) ALSO     11395000
         B     MNO150                   GO PROCESS SEVERITY             11396000
MNO600   GOIF  D0(R4),JQUOTE,EQ=MNO650  IS NEXT CHARACTER A QUOTE       11397000
MNO610   GOIF  MNOPRT,ON=MNO400         CONTINUE SCAN IF NOT PRINTED    11398000
         LA    R10,MNOOUT               LOAD INDEX FOR PRINT            11399000
         MVI   MNOALN(R2),JX            PUT IN CONTINUATION CHAR        11400000
         JCALL OUTPUT                   GO GET NEXT LINE BUFFER         11401000
         LR    R2,R11                   SAVE PRINT BUFFER POINTER       11402000
         LH    R6,JENDCL                END COLUMN                      11403000
         AR    R6,R11                   POINT TO END OF PRINT BUFFER    11404000
         B     MNO400                   CONTINUE SCAN                   11405000
MNO650   GOIF  D1(R4),JQUOTE,EQ=MNO610  IS QUOTE A TERMINATOR           11406000
         B     MNO900                   YES, CHECK DELIMITER            11407000
MNO700   GOIF  D1(R4),JQUOTE,NE=MNO900  QUOTE IS AN ENDING TERMINATOR   11408000
MNO710   LA    R4,D1(,R4)               NO, ELIMINATE EXTRA             11409000
         B     MNO500                   CONTINUE SCAN                   11410000
MNO750   GOIF  D1(R4),JAMPER,EQ=MNO710,ELSE=MNO500 IS AMPERSAND TWO     11411000
MNO800   GOIF  D1(R4),JCOMMA,NE=MNOER3  DOES COMMA FOLLOW ASTERISK      11412000
         GOIF  MNOPRT,ON=MNO850         BRANCH AROUND MOVE IF NO PRINT  11413000
         MVC   MNOALN(D2,R2),D0(R4)     YES, MOVE BOTH TO PRINT         11414000
         LA    R2,D2(,R2)               STEP POINTERS PAST              11415000
MNO850   LA    R4,D2(R4)                ASTERISK AND COMMA              11416000
         B     MNO300                   CONTINUE OUTPUT                 11417000
MNO875   BCTR  R4,0                     ADJUST REGISTER FOR DELIM TEST  11418000
MNO900   CLI   D1(R4),JBLANK            DO BLANK FOLLOW TERM QUOTE      11419000
         BNE   MNOER4                   ERROR IF NOT                    11420000
         GOIF  MNOPRT,ON=MNO085         BRANCH IF SCAN ONLY             11421000
         B     MNO075                   BRANCH IF MESSAGE BUILD DONE    11422000
MNOER1   X5ERRL 179,CLMPTR,MNO050       SEVERITY CODE MUST BE ABSOLUTE  11423000
MNOER2   X5ERRL 183,CLMPTR,MNO050                                       11424000
         SPACE                                                          11425000
MNOER3   ST    R4,ERRPTR                SAVE COLUMN PTR FOR LOGGING     11426000
         X5ERRL 178,CLMPTR,MNO050       SYNTAX ERROR - NOT A COMMA      11427000
MNOER4   ST  R4,ERRPTR                  SAVE COLUMN POINTER FOR LOGGING 11428000
         X5ERRL 185,CLMPTR,MNO050       SYNTAX ERROR NO BLANK           11429000
         SPACE                                                          11430000
PRNTLEV  CLI   JMSGL,*-*                EXECUTED MSGLEVEL CHECK         11431000
SEVTST   CLI   JSEVER,D0                EXECUTE SEVERITY CHECK          11432000
SEVMOV   MVC   MNOALN(D0,R2),D0(R4)     EXECUTED SEVERITY MOVE          11433000
MNOOUT   EQU   24                       MNOTE PRINT INDEX               11434000
STMTNO   EQU   X'23'                    STATEMENT NUMBER DISPLACEMENT   11435000
MNOALN   EQU   41                       MNOTE PRINT DISPLACEMENT        11436000
         SPACE 3                                                        11437000
    TITLE '&COMPNM&ASMID - ASSEMBLER OPCODE PROCESSOR - ASSEMBLY PHASE -11438000
               - ERROR RECORD PROCESSING '                              11439000
ERROR0   SET   JERRCHK,ON               SET ERROR RECORDS PRESENT       11440000
         DROP  R11                      DROP REG. FOR LATER USE         11441000
         USING JERRCD,R5                SET UP BASE FOR ERR RECORD      11442000
         MVC   JESTMTNO,STMTN+D4-L'JESTMTNO  PUT STATMENT NO. IN ERR RD 11443000
         CLI   JERCDE,ERR60             GENERATED END STATEMENT ERROR   11444000
         BNE   ERROR1                   NO                              11445000
         MVC   JESTMTNO,ENDSTMNO+D4-L'JESTMTNO  GET SAVED STATEMENT NO. 11446000
         USING JTEXT,R5                 SET UP BASE FOR TEXT RECORD     11447000
ERROR1   LH    R10,JOUTFILE             POINT TO ERROR RECORD           11448000
         JPUTM FILE=(R10),ADDR=JTEXT    OUTPUT ERROR RECORD             11449000
         XC    SYMCNT,SYMCNT            CLEAR SYMBOL COUNT              11450000
         B     AOP310                   EXIT                            11451000
         SPACE 3                                                        11452000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - PATCH AREA '           11453000
         JPATCH X5A00,15B0              5% PATCH AREA                   11454000
    TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - ALIGNMENT ROUTINE '         11455000
         JCSECT (X5A20)                 DEFINE CSECT                    11456000
ALIGN    JSAVE BASE=YES                 SAVE REGISTERS                  11457000
         JENTRY (X5A21=ALIGN)           DEFINE MODULE ENTRY POINT       11458000
ALIGN0   L     R1,ELCTR                 GET LOCATION COUNTER            11459000
         GOIF  VLIT,ON=ALIGN1           BRANCH AROUND IF ON             11460000
         ST    R1,LOCATN                STORE FOR PRINT                 11461000
ALIGN1   AR    R1,R2                    ADD MAX ALIGN ADJUSTMENT        11462000
         LCR   R2,R2                    CREATE MASK TO GET ALIGNED      11463000
         BCTR  R2,0                       LOCATION COUNTER              11464000
         NR    R2,R1                    DETERMINE ALIGNED VALUE         11465000
         S     R2,ELCTR                 GET NUMBER OF PADDING BYTES     11466000
         ST    R2,LOCLEN                SAVE FOR LOCATION COUNTER       11467000
         ST    R2,FULLWD                SAVE ALIGNMENT                  11468000
         JCALL LOCUPD                   CALL LOCATION COUNTER UPDATE    11469000
ALNEND   JRETURN ,                      EXIT                            11470000
         JPATCH X5A20,54                5% PATCH AREA                   11471000
         SPACE 3                                                        11472000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - LOCATION COUNTER UPDATE11473000
               E ROUTINE '                                              11474000
         JCSECT (X5A30)                 DEFINE CSECT                    11475000
LOCUPD   JSAVE BASE=YES                 SAVE REGISTERS                  11476000
         JENTRY (X5A31=LOCUPD)          DEFINE MODULE ENTRY POINT       11477000
         GOIF  LTDECV,ON=LUDEND         EXIT IF LITERAL REFERENCE       11478000
         L     R1,ELCTR                 GET LOCATION COUNTER            11479000
         A     R1,LOCLEN                ADD LENGTH OF DC                11480000
         ST    R1,ELCTR                 SAVE NEW LOCATION               11481000
         C     R1,=X'1000000'           IS IT GREATER THAN MAXIMUM?     11482000
         BL    LUDEND                   BRANCH IF NOT                   11483000
         GOIF  WRPFLG,ON=LUDEND         HAS ERROR BEEN LOGGED           11484000
         SET   WRPFLG,ON                NO, SET FLAG                    11485000
         X5ERRL 246,0,LUDEND            LOCATION COUNTER ERROR          11486000
LUDEND   JRETURN ,                      EXIT                            11487000
         SPACE 3                                                        11488000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - LOCATION COUNTER UPDATE11489000
               E ROUTINE - PATCH AREA '                                 11490000
         JPATCH X5A30,68                5% PATCH AREA                   11491000
         SPACE 3                                                        11492000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - RLD OUTPUT ROUTINE '   11493000
         JCSECT (X5A40)                 DEFINE CSECT                    11494000
RLDOUT   JSAVE BASE=YES                 SAVE REGISTERS                  11495000
         JENTRY (X5A41=RLDOUT)          DEFINE MODULE ENTRY POINT       11496000
         GOIF  LTDECV,ON=RLDEND         EXIT IF LITERAL REFERENCE       11497000
         GOIF  (DSSW,DXDSW),ANY=RLDEND  SKIP RLD IF DS OR DXD           11498000
         TM    EESDI,BIT1+BIT2+BIT3     IS THIS IN DSECT OR COMMON      11499000
         BNZ   RLDEND                   YES, NO RLD - EXIT              11500000
         SR    R4,R4                    ZERO REGISTER                   11501000
         IC    R4,RELOCTR               GET NUMBER OF RLD'S TO PUT      11502000
         GOIF  (R4),NOTPOS=RLDEND       DON'T PUT RLD IF NOT POSITIVE   11503000
         LA    R6,RLIST                 POINT TO ESD LIST               11504000
RLD100   LH    R10,JOUTFILE             POINT TO OUTPUT FILE            11505000
RLD115   LH    R1,D0(R6)                GET RELOCATION ID               11506000
         LTR   R1,R1                    IS IT NEGATIVE?                 11507000
         BNZ   RLD125                   BRANCH AROUND IF NOT ZERO       11508000
         LA    R6,D2(R6)                SKIP TO NEXT ESDID              11509000
         B     RLD115                   GO TRY AGAIN                    11510000
         SPACE                                                          11511000
RLD125   BNM   RLD150                   NO BRANCH AROUND                11512000
         OI    X5VSW,BIT2               SET BIT TO INDICATE NEGATIVE    11513000
         LCR   R1,R1                    COMPLEMENT ESDID                11514000
         STH   R1,D0(R6)                STORE BACK                      11515000
         SPACE                                                          11516000
RLD150   LR    R2,R1                    SAVE R1                         11517000
         TM    D0(R6),BIT1+BIT3         IS IT IN A DSECT                11518000
         BNZ   RLDER1                   ERRONEOUS RELID                 11519000
         JPUTL FILE=(R10),BUFREQ=RLDND  GO GET BUFFER                   11520000
         SET   JRLDCHK,ON               INDICATE RLD PRESENT   @OX11000 11521000
         USING RLDIN,R11                ESTABLISH USING                 11522000
         MVC   RLDIN(D6),=AL1(0,RLDND,0,0,RLDTYPE,0) INITIALIZE RECORD  11523000
         MVC   POSID,EESDI              GET POSITION ID                 11524000
         MVC   RLDFLG,DWORD1            MOVE TYPE TO FLAG               11525000
         MVC   RLDVAL,DWORD1+D1         MOVE VALUE TO RECORD            11526000
         STH   R2,RELID                 PUT IN RELID                    11527000
         NI    RELID,D15                MASK OUT HIGH ORDER HALF BYTE   11528000
         TM    X5VSW,BIT2               IS ESDID NEGATIVE?              11529000
         BNO   RLD200                   NO,BRANCH AROUND                11530000
         NI    X5VSW,BITFF-BIT2         TURN OFF BIT2                   11531000
         OI    RLDFLG,BIT6              INDITATE NEGATIVE RELOCATION    11532000
RLD200   LH    R1,DWORD2                GET LENGTH                      11533000
         BCTR  R1,0                     DECREMENT IT                    11534000
         SLL   R1,D2                    POSITION IT FOR FLAG BYTE       11535000
         EX    R1,RLDORL                OR IN LENGTH-1                  11536000
         LA    R6,D2(,R6)               STEP TO NEXT ESD                11537000
         BCT   R4,RLD100                CONTINUE IF COUNT NOT DEPLETE   11538000
RLDEND   JRETURN ,                      EXIT                            11539000
RLDER1   X5ERRL 158,CLMPTR,RLDEND                                       11540000
RLDORL   OI    RLDFLG,D0                EXECUTE OR OF LENGTH-1          11541000
         JPATCH X5A40,F2                5 % PATCH AREA                  11542000
         SPACE 3                                                        11543000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - XREF OUTPUT ROUTINE '  11544000
         JCSECT (X5A50)                 DEFINE CSECT                    11545000
XREF     JSAVE BASE=YES                 SAVE REGISTERS                  11546000
         JENTRY (X5A51=XREF)            DEFINE ENTRY POINT              11547000
         L     R1,SYMXRF                GET NBR SYMBOLS XREF    OX02675 11548000
         LA    R1,D1(,R1)                THIS STATEMENT AND ADD 1       11549000
         ST    R1,SYMXRF                STORE NEW COUNT         OX02675 11550000
         GOIF  (JXREF,JLIST),NOTALL=XRFXIT  BOTH SWITCHES MUST BE ON    11551000
         LR    R4,R11                   SAVE REFERENCE DATA POINTER     11552000
         SET   JXREFCHK,ON              SET FLAG TO INDICATE XREF MADE  11553000
         USING DSECT10,R4               ESTABLISH USING                 11554000
         USING XRFIN,R11                ESTABLISH USING                 11555000
         LH    R10,JOUTFILE             POINT TO OUTPUT FILE            11556000
         JPUTL FILE=(R10),BUFREQ=XRFND  GET OUTPUT BUFFER               11557000
         MVC   XRECLN(D6),=AL2(XRFND,0,XRFTYPE*256)  INITIALISE HEADER  11558000
         STC   R2,XRFFLG                INDICATE DUP OR REF             11559000
         MVC   XRFSYM,RNAME             MOVE SYMBOL TO XREF RECORD      11560000
         MVC   XRFSTM,STMTN+D2          STATEMENT NUMBER TO RECORD      11561000
         MVC   XRFLEN,RLNGQ             LENGTH ATTRIBUTE TO RECORD      11562000
         MVC   XRFVAL,RLCTR             LOCATION TO RECORD              11563000
         LR    R11,R4                   RESTORE INPUT POINTER           11564000
XRFXIT   JRETURN ,                      EXIT                            11565000
         SPACE 3                                                        11566000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - XREF OUTPUT ROUTINE - X11567000
               PATCH AREA '                                             11568000
         JPATCH X5A50,7E                5% PATCH AREA                   11569000
         END                                                            11570000
./ ADD NAME=IFNX5D                                                      11571000
* /* START OF SPECIFICATIONS ****                                       11572000
*02* PROCESSOR = ASSEMBLER                                              11573000
**** END OF SPECIFICATIONS ***/                                         11574000
         GBLC  &COMPNM,&ASMID                                           11575000
         SPACE 2                                                        11576000
         JHEAD 'ASSEMBLY PHASE - DC EVALUATION',                       X11577000
               PHASEID=X5D,                                            X11578000
               LEVEL=10                                                 11579000
*                                                                     * 11580000
*FUNCTION                                                             * 11581000
*   1. SCAN DC/DS/DXD OPERAND FIELDS ENCODED IN TEXT-BUCKET FORMAT.   * 11582000
*   NOTE- LITERAL-POOL GENERATED CONSTANTS ARE PROCESSED IN THE SAME  * 11583000
*   MANNER AS DC OPERANDS.                                            * 11584000
*   2. CONVERT ALL CONSTANTS TO HEXADECIMAL AND OUTPUT THE REQUIRED   * 11585000
*   OBJECT CODE, EXCEPT ON DS/DXD CALLS, FOR PRINTING AND/OR PUNCHING.* 11586000
*   3. LIST THE CORRESPONDING SOURCE OR GENERATED STATEMENTS.         * 11587000
*   4. ALIGN AND INCREMENT THE LOCATION-COUNTER FOR EACH CONSTANT     * 11588000
*   THAT DOES NOT HAVE A SYNTACTIC ERROR.  PRINTING AND/OR PUNCHING   * 11589000
*   ALIGNMENT BYTES WHERE REQUIRED.                                   * 11590000
*   5. OUTPUT RLD RECORDS FOR A-, Y-, V- AND Q-TYPE CONSTANTS.        * 11591000
*   7. LOG THOSE ERRORS THAT ARE DETECTED.                            * 11592000
*                                                                     * 11593000
*ENTRY POINT                                                          * 11594000
*        DCEVAL                                                       * 11595000
*                                                                     * 11596000
*INPUT                                                                * 11597000
*   R10 POINTS TO THE 1ST TEXT-BUCKET OF THE OPERAND FIELD.           * 11598000
*   R7 POINTS TO THE ASSEMBLY PHASE WORK AREA, X5COM.                 * 11599000
*   THE HALF-WORD AT LCTRSAV+D8 IS A COUNT OF THE NUMBER OF VALID     * 11600000
*   OPERANDS.                                                         * 11601000
*   FLAGS IN THE COMMON REGION ARE SET TO INDICATE THE TYPE           * 11602000
*   OF CALL-                                                          * 11603000
*   DSSW  - DS STATEMENT                                              * 11604000
*   DXDSW - DXD STATEMENT                                             * 11605000
*                                                                     * 11606000
*OUTPUT                                                               * 11607000
*   NO INFORMATION IS RETURNED TO THE CALLING ROUTINE.  IN DC AND     * 11608000
*   LITERAL-POOL CONSTANTS, OBJECT CODE IS PASSED TO THE PRINT/PUNCH  * 11609000
*   ROUTINE FOR OPTION-CONTROLLED OUTPUT. SIMILARLY, PRINT/PUNCH IS   * 11610000
*   CALLED FOR STATEMENT LISTING.  RLD RECORDS ARE OUTPUT FOR THOSE   * 11611000
*   RELOCATABLE A- AND Y-TYPE CONSTANTS AND VALID V- AND Q-TYPE       * 11612000
*   CONSTANTS WHICH OCCUR IN A DC OR LITERAL-POOL IN A REAL CONTROL-  * 11613000
*   SECTION, WITHOUT A ZERO DUP-FACTOR.                               * 11614000
*   THE LOCATION-COUNTER WILL BE ALIGNED AND INCREMENTED AS REQUIRED. * 11615000
*   SEMANTIC ERRORS ARE LOGGED BUT DO NOT AFFECT THE LOCATION-COUNTER * 11616000
*   ADJUSTMENTS.                                                      * 11617000
*                                                                     * 11618000
*EXTERNAL REFERENCES                                                  * 11619000
*        IFNX5A21 - FOR LOCATION-COUNTER ALIGNMENT                    * 11620000
*        IFNX5A31 - FOR LOCATION-COUNTER INCREMENTING                 * 11621000
*        IFNX5A41 - FOR RLD OUTPUT                                    * 11622000
*        IFNX5A51 - FOR XREF OUTPUT                                   * 11623000
*        IFNX5F01 - FOR FIXED- AND FLOATING-POINT CONVERSION          * 11624000
*        IFNX5L01 - FOR ERROR LOGGING                                 * 11625000
*        IFNX5P01 - FOR PRINT/PUNCH                                   * 11626000
*        IFNX5V01 - FOR EXPRESSION EVALUATION                         * 11627000
*                                                                     * 11628000
*EXITS, NORMAL                                                        * 11629000
*   THIS ROUTINE ALWAYS EXITS NORMALLY, VIA THE JRETURN MACRO.        * 11630000
*                                                                     * 11631000
*EXITS, ERROR                                                         * 11632000
*   NONE                                                              * 11633000
*                                                                     * 11634000
*TABLES/WORK AREAS                                                    * 11635000
*   ONLY ONE INTERNAL TABLE IS USED -                                 * 11636000
*   DCTABLE CONTAINS THE INFORMATION NECESSARY TO PROCESS EACH        * 11637000
*   CONSTANT TYPE.                                                    * 11638000
*   EXTERNAL TABLES ACCESSED ARE -                                    * 11639000
*   JTRTABLE - INTERNAL-TO-EXTERNAL CHARACTER-SET TRANSLATE TABLE,    * 11640000
*   USED FOR C-TYPE CONSTANT.                                         * 11641000
*   USINGT - USED FOR ADDRESS DECOMPOSITION IS S-TYPE CONSTANTS.      * 11642000
*   WORK SPACE IS CURRENTLY 106 BYTES, FULL-WORD ALIGNED, AT LOCATION * 11643000
*   WORKAREA IN THE X5COM  AREA.                                      * 11644000
*                                                                     * 11645000
*ATTRIBUTES                                                           * 11646000
*   REENTRANT, READ-ONLY, REUSABLE                                    * 11647000
*                                                                     * 11648000
*NOTES                                                                * 11649000
*   THE STATUS OF PRINTSW IS SAVED ON ENTRY AND RESTORED ON EXIT.     * 11650000
*                                                                     * 11651000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - COPY CODE'   11652000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   11653000
         COPY  JCOMMON                  COPY ASSEMBLER COMMON MODULE    11654000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     11655000
         COPY  JTEXT                    GET TEXT DEFINITION             11656000
         PRINT OFF                      DON'T PRINT X5COM COPY CODE     11657000
         COPY  X5COM                    GET COMMON WORK AREA DSECT      11658000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  11659000
         COPY  JERMSGCD                 DEFINE ERROR CODES AND SEVERITY 11660000
         PRINT ON                       WE'RE PAST THE COPY CODE        11661000
         SPACE 2                                                        11662000
BASE     EQU   X'01'                    BASE MASK - XREF DEFN           11663000
REF      EQU   X'02'                    REFERENCE MASK - XREF           11664000
DUP      EQU   X'03'                    DUPLICATE MASK - XREF           11665000
         USING X5COM,R7                 ESTABLISH COMMON USING          11666000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - INITIALIZATIO11667000
               ON'                                                      11668000
         JCSECT (X5D00)                 START MODULE CSECT              11669000
* VS1 RELEASE 2 CHANGES                                                 11670000
*A027700-027920,075700                                          OX00221 11671000
* VS1 RELEASE 2.6 CHANGES                                               11672000
*A718900-719120                                                 OX00223 11673000
*A027800-027980,045300,075720                                   OX00107 11674000
*C075700                                                        OX00107 11675000
* VS1 RELEASE 3.1 CHANGES                                               11676000
*C527200,5278800                                                OX02675 11677000
*A027700                                                        OY02614 11678000
* VS2 RELEASE 3.0 CHANGES                                               11679000
*C359200                                                        OY02610 11680000
*A025100                                                       @OX08862 11681000
*A593500,593520                                                @OY06592 11682000
*C593600                                                       @OY06592 11683000
*A480100,481500                                                @OX09734 11684000
*C736800,737000                                                @OX09734 11685000
*C614400,615200                                                @OZ04407 11686000
*C603200,604000                                                @OX08876 11687000
*C623200                                                       @OY11250 11688000
*C475600-480100                                            D78 @AX21436 11689000
         JMODID ,                       CREATE MODULE  ID               11690000
DCEVAL   JSAVE BASE=YES                 SAVE ENTRY REGISTERS            11691000
         JENTRY (X5D01=DCEVAL)          DEFINE ENTRY POINT              11692000
         XC    CLEAR2(CLEAR1-CLEAR2),CLEAR2       CLEAR BIG WORK        11693000
         XC    X5ATEMP,X5ATEMP          CLEAR ERROR LOGGING AREA        11694000
         XC    RLIST(40),RLIST          CLEAR ERROR LOGGING AREFX0000   11695000
         XC    DCLNG,DCLNG              CLEAR ACC LENGTH AREA           11696000
         XC    ZDUPSW,ZDUPSW            CLEAR ZERO DUPFACTOR SWITCH     11697000
         LR    R6,R10                   SET TEXT POINTER                11698000
         ST    R10,JFWORD2              SAVE OPER ADDR         @OX08862 11699000
LITSKIP  MVC   DCPRSW,PRINTSW           SAVE PRINT SWITCH               11700000
         NI    EVALMODE,BITFF-(SUBLIST) JUST IN CASE            OY02614 11701000
         LR    R4,R10                   SAVE REG                OX00107 11702000
         BCTR  R4,0                     POINT TO LENGTH         OX00107 11703000
         CLI   0(R4),X'00'              LENGTH EQ ZERO          OX00107 11704000
         BNE   LITSKIP1                 BRANCH IF NOT ZERO      OX00107 11705000
         SET   NOOP,ON                  SET FLAG FOR NO OPERAND OX00107 11706000
LITSKIP1 EQU   *                                                OX00107 11707000
         GOIF  DSSW,ON=SETPDUM          IS ENTRY A DS                   11708000
         GOIF  DXDSW,OFF=PNODUM         NO, IS THIS DXD                 11709000
SETPDUM  OI    PRINTSW,BIT5             TURN ON PRINT DUMMY-BIT         11710000
         MVI   DUMSW,TESTER             AND LOCAL DUMMY FLAG            11711000
PNODUM   LA    R5,LEFTHF                SET PRINT-AREA BASE             11712000
         USING LEFTHF,R5                ESTABLISH LEFT HALF USING       11713000
         L     R1,ELCTR                 GET CURRENT LC                  11714000
         LA    R1,D0(,R1)               CLEAR WRAP BITS                 11715000
         ST    R1,LOCATN                TO PRINT                        11716000
         SLL   R1,D3                    CHANGE TO BITS                  11717000
         ST    R1,BITLC                 SET BIT LC                      11718000
         XC    DCDATA,DCDATA            CLEAR PRINT DATA                11719000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - NEXT OPERAND*11720000
                INIT && DUP FACTOR CHECK'                               11721000
NEXTOP   XC    WORKAREA(CLEAR2-WORKAREA),WORKAREA      SMALL CLEAR      11722000
         MVI   TUBEOP,TESTER-TESTER     TURN OFF DUP FACTOR ERROR IND   11723000
         LH    R1,OPNDCT                STEP                            11724000
         LA    R1,D1(,R1)                   OPERAND                     11725000
         STH   R1,OPNDCT                       COUNT                    11726000
         SET   XRFNO,ON                 SET XREF SWITCH ON              11727000
         MVC   LCTRSAV+D12,ELCTR        SAVE LOCATION COUNTER           11728000
         MVC   LCTRSAV+D10(D2),OBITS    SAVE OUTPUT BIT COUNT           11729000
         SPACE 5                                                        11730000
         GOIF  NOOP,ON=NOOPRND          TEST IF NO OPERAND      OX00107 11731000
         LA    R11,D1                   PRE-SET VALUE TO 1.             11732000
         BAL   R9,EVAL1                 GO SET UP EVAL CALL             11733000
         B     DFZCHEK0                 GO CHECK FOR ZERO DUPLICATION   11734000
         GOIF  D0(R6),JLPARN,NE=DFVSET  IS THERE AN EXPRESSION          11735000
         SET   (SUBLIST,PRDEFREQ),ON    INIT SWITCHES ON                11736000
         LR    R10,R6                   POINT AT LEFT PAREN             11737000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     11738000
         JEXTRN (X5V01=EVAL)            DEFINE EVAL AS EXTERNAL         11739000
         LR    R6,R14                   RESTORE POINTER                 11740000
         BC    D1,DUPERR                FATAL DUP FACTOR ERROR BRANCH   11741000
         BZ    DFZCHEK                  LOG ERROR IF NOT ABSOLUTE       11742000
DSCAN2   MVI   TUBEOP,TESTER            INDICATE DUP FACTOR ERROR       11743000
         LA    R11,D1                   DUMMY UP DUP FACTOR             11744000
         B     DFZCHEK                  GO SAVE DUP FACTOR              11745000
DFZCHEK0 LTR   R11,R11                  SELF DEFINING ZERO              11746000
         BNZ   DFVSET                   SET VALUE                       11747000
         OI    ZDUPSW,BITFF             INDICATE SELFDEF ZERO           11748000
DFZCHEK  LTR   R11,R11                  TEST FOR ZERO DUP FACTOR        11749000
         BP    DFVSET                   NO - POSITIVE - OK              11750000
         BM    DSCAN2                   NO - NEGATIVE - NOT OK          11751000
         OI    ZDUPSW,TESTER            SET ZERO DUP-FACTOR FLAG        11752000
DFVSET   ST    R11,DUPF                 SAVE DUP FACTOR                 11753000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - TYPE RANGE CH11754000
               HECK'                                                    11755000
         GOIF  D0(R6),JALFAMIN,LT=TYPERR CHECK TYPE FOR LEGAL           11756000
         GOIF  D0(R6),JALFAMAX,GT=TYPERR RANGE OF ALLOWABLE TYPES       11757000
         MVC   TYPE(D1),D0(R6)           SAVE TYPE                      11758000
         TR    TYPE(D1),DCTRBL-JALFAMIN  TRANSLATE TYPE                 11759000
         SR    R3,R3                    ZERO REGISTER                   11760000
         IC    R3,TYPE                  GET TYPE                        11761000
         LTR   R3,R3                    IS TYPE VALID                   11762000
         BZ    TYPERR                   BRANCH IF ILLEGAL TYPE          11763000
         BCTR  R3,0                     DECREMEN FOR LOOKUP             11764000
         MH    R3,TABLENG               TIMES LENGTH OF TABLE           11765000
         A     R3,=A(DCTABLE)           PLUS TABLE ORIGIN      FX0000   11766000
         LH    R1,IMPLINC(,R3)          IMPLIED LENGTH                  11767000
         ST    R1,LMOD                  TO L-MODIFIER                   11768000
         SLL   R1,D3                    BYTES TO BITS                   11769000
         ST    R1,BITMOD                IN BIT-LENGTH MODIFIER          11770000
         LA    R6,D1(,R6)               STEP TEXT PNTR                  11771000
         B     LTEST                    GO TEST FOR LENGTH MODIFIER     11772000
TYPERR   ST    R6,ERRPTR                SAVE ERROR COLUMN PTR           11773000
         X5ERRL 198,CLMPTR              INVALID DC,DS, OR DXD TYPE      11774000
         TM    TUBEOP,TESTER            DUP FACTOR ERROR                11775000
         BZ    STMEND                   NO                              11776000
DUPERR   X5ERRL 206,0,STMEND            INVALID DUPFACTOR               11777000
NOOPRND  SET   NOOP,OFF                 RESET FLAG              OX00107 11778000
         X5ERRL 62,0,STMEND             OMITTED OPERAND OX00221,OX00107 11779000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - CHECK AND ALI11780000
               IGNMENT IF NONE'                                         11781000
LTEST    GOIF  D0(R6),JL,NE=LNOBIT      IS THERE A LENGTH MODIFIER      11782000
         LA    R6,D1(,R6)               STEP OVER L BUCKET              11783000
         MVI   LMODSW,TESTER            TURN ON EXPLICIT-LENGTH FLAG    11784000
         GOIF  D0(R6),JPERIOD,NE=LNOBIT IS LENGTH MODIFIER BIT LENGTH   11785000
         TM    FLAGINC(R3),BIT1         IS BIT LENGTH LEGAL             11786000
         BO    LTEST1                   YES,BRANCH AROUND               11787000
         ST    R6,ERRPTR                SAVE COLUMN PTR FOR LOGGING     11788000
         B     LIMITH                   GO LOG LENGTH ERROR             11789000
LTEST1   MVI   BITLSW,TESTER            YES, TURN ON BIT-LENGTH FLAG    11790000
         LA    R6,D1(,R6)               STEP OVER POINT BUCKET          11791000
         B     TUBECHK                  TO CHECK INTERLUDE ERROR        11792000
LNOBIT   LH    R2,OBITS                 GET OUTPUT-BIT COUNT            11793000
         LA    R2,D7(,R2)               PAD PARTIAL BYTE                11794000
         N     R2,BYTEMSK                                               11795000
         STH   R2,OBITS                                                 11796000
         CLI   OBITS+D1,D8*D8           CHECK FULL OUTPUT               11797000
         BL    SETEMP                   NO                              11798000
         LA    R1,ENTDC                 SET FOR DC PRINT                11799000
         L     R12,=A(DCPRINT)          SET FOR DCPRINT                 11800000
         BALR  R9,R12                   BRANCH TO ROUTINE               11801000
SETEMP   L     R1,BITLC                 PAD BIT LOCATION COUNTER        11802000
         AH    R1,SEVEN                 TO BYTES AND                    11803000
         SRL   R1,D3                    STORE IN TEMPORARY LC           11804000
         LA    R1,D0(,R1)               CLEAR WRAP BIT                  11805000
         ST    R1,TEMPLC                                                11806000
         L     R2,ELCTR                 GET NON-WRAP                    11807000
         LA    R2,0(,R2)                CURRENT LC                      11808000
         SR    R1,R2                    CHECK FOR PADDING INCREMENT     11809000
         BZ    NOLCINC                  NO                              11810000
         ST    R1,LOCLEN                YES, SET 1 BYTE INCREMENT       11811000
         JCALL LOCUPD                   CALL LOCATION COUNTER UPDATE    11812000
         JEXTRN (X5A31=LOCUPD)          DEFINE EXTERNAL SYMBOL          11813000
NOLCINC  L     R1,TEMPLC                UPDATE BIT LC                   11814000
         SLL   R1,3                                                     11815000
         ST    R1,BITLC                                                 11816000
         TM    LMODSW,TESTER            WAS THERE AN L-MODIFIER         11817000
         BNZ   TUBECHK                  YES                             11818000
         LH    R2,ALININC(,R3)          NO, GET ALIGNMENT               11819000
         EX    R2,ALNTEST               IS ALIGNMENT REQUIRED           11820000
         BZ    NOLIGN                   NO                              11821000
         TM    ZDUPSW,BITFF             ZERO SELF DEF DUP FACTOR        11822000
         BO    ALIGN0                   YES DO ALWAYS ALIGN IF NEEDED   11823000
         GOIF  JALGN,OFF=NOLIGN         DON'T ALIGN IF NOALIGN OPTION   11824000
ALIGN0   SET   VLIT,ON                  TURN ON SWITCH FOR ALIGN        11825000
         JCALL ALIGN                    CALL ALIGNMENT ROUTINE          11826000
         SET   VLIT,OFF                 TURN OFF SWITCH USED IN ALIGN   11827000
         JEXTRN (X5A21=ALIGN)           DEFINE EXTERNAL SYMBOL          11828000
         MVC   LCTRSAV+D12,ELCTR        SAVE LOC CTR                    11829000
         L     R4,ELCTR                 GET ALIGNED LC                  11830000
         LA    R4,D0(,R4)               CLEAR WRAP BITS                 11831000
         SLL   R4,D3                    UPDATE BIT LC                   11832000
         ST    R4,BITLC                 STORE BIT LOCATION CAONTER      11833000
         TM    DUMSW,TESTER             ARE WE IN DS OR DXD             11834000
         BZ    LNODUM                   NO                              11835000
         MVC   LOCATN,ELCTR             UPDATE PRINT LC                 11836000
         XC    DCDATA,DCDATA            CLEAR PRINT DATA                11837000
         MVI   OBITS+D1,D0              CLEAR OUTPUT-BIT COUNT          11838000
         B     NOLIGN                   TO CHECK PASS 1 ERROR           11839000
* TO PRINT INTER-OPERAND ALIGNMENT ON SEPARATE LINES, REPLACE THE       11840000
* FOLLOWING SEGMENT OF CODE WITH THE COMMENT CODE.                      11841000
LNODUM   CLI   OPNDCT+D1,D1             IS THIS 1ST OPERAND             11842000
         BE    ALINOUT                  YES, PRINT SEPARATE ALIGNMENT   11843000
         LA    R10,ALINMT               POINT TO ALIGN BYTES            11844000
         SR    R2,R2                    CLEAR BIT REMAINDER             11845000
         L     R11,FULLWD               GET BYTE COUNT                  11846000
         SLL   R11,D3                   CONVERT TO BIT COUNT            11847000
         L     R12,=A(KOUTPUT)          CALL OUTPUT                     11848000
         BALR  R9,R12                   BRANCH TO ROUTINE               11849000
         B     NOLIGN                                                   11850000
*LNODUM  CLI   OBITS+D1,D0              CHECK ANY OUTPUT LEFT           11851000
*        BE    ALINOUT                  NO                              11852000
*        LH    R2,OBITS                 YES, PRINT THEM                 11853000
*        LA    R1,X'40'                                                 11854000
*        LA    R12,DCPRINT                                              11855000
*        BALR  R5,R12                                                   11856000
ALINOUT  L     R2,FULLWD                GET BYTES SKIPPED               11857000
         LA    R1,ENTALN                SET FOR ALIGNMENT PRINT         11858000
         L     R12,=A(DCPRINT)          SET FOR DCPRINT                 11859000
         BALR  R9,R12                   CALL ROUTINE                    11860000
TUBECHK  EQU   *                        BRANCH LABEL                    11861000
NOLIGN   TM    TUBEOP,TESTER            INVALID DUP FACTOR              11862000
         BZ    NOLIGN2                  OK                              11863000
         X5ERRL 206,0,STMEND3           INVALID DUP FACTOR              11864000
NOLIGN2  MVC   STRTLC(D4),BITLC         SAVE OPERAND START              11865000
         TM    LMODSW,TESTER            CHECK EXPLICIT LENGTH           11866000
         BZ    STEST                    NO, TO S-MOD TEST               11867000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - EVALUATE LENG11868000
               GTH MODIFIER'                                            11869000
         BAL   R9,EVAL1                 GO SET UP EVAL CALL             11870000
         B     SETLMOD                  TO STORE                        11871000
         CLI   D0(R6),JLPARN            IS IT LEFT PAREN?               11872000
         BNE   LDELIM3                  GO LOG ERROR IF NOT             11873000
         SET   (SUBLIST,PRDEFREQ),ON    SET SUBLIST AND PRDEFREQ BITS   11874000
         LR    R10,R6                   POINT AT LEFT PAREN             11875000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     11876000
         LR    R6,R14                   RESTORE POINTER                 11877000
         BC    D1,STMEND3               SYNTAX ERROR, EXIT              11878000
         BZ    SETLMOD                  LOG ERROR IF NOT ABSOLUTE       11879000
         X5ERRL 179,CLMPTR,STMEND3      INVALID LENGTH - NOT ABSOLUTE   11880000
         SPACE                                                          11881000
SETLMOD  LR    R1,R11                   SAVE VALUE                      11882000
         ST    R1,LMOD                  STORE L-MOD VALUE               11883000
         TM    BITLSW,TESTER            CHECK BIT-LENGTH                11884000
         BNZ   LBITM                    YES                             11885000
         SLL   R1,D3                    NO, CHANGE TO BITS              11886000
LBITM    ST    R1,BITMOD                SET BIT-LENGTH                  11887000
         LH    R15,HILMINC(,R3)         GET L-MOD HIGH LIMIT            11888000
         TM    DUMSW,TESTER             IS IT DS OR DXD                 11889000
         BZ    LIMITL                   NO                              11890000
         CLI   TYPE,XBKT                YES,IS IT C OR X TYPE?          11891000
         BH    LIMITL                   NO                              11892000
         L     R15,BIGLIM               GET SPECIAL UPPER LIMIT         11893000
LIMITL   CH    R1,LOLMINC(,R3)          IS IT TOO SHORT?                11894000
         BL    LIMITH                   YES, GO LOG ERROR               11895000
         CR    R1,R15                   IS IT TOO LONG ?                11896000
         BNH   STEST                    NO, CONTINUE                    11897000
LIMITH   X5ERRL 199,CLMPTR,STMEND       LENGTH ERROR                    11898000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - SCALE MODIFIE11899000
               ER SCAN && EVALUATION'                                   11900000
STEST    SET   PRDEFREQ,OFF             TURN PRIOR DEF REQ BIT OFF      11901000
         GOIF  D0(R6),JS,NE=ETEST       IS THERE A SCALE FACTOR         11902000
         TM    FLAGINC(R3),BIT2         IS SCALE ALLOWED?               11903000
         BNO   SMBAD                    LOG ERROR IF NOT ALLOWED        11904000
         LA    R6,D1(,R6)               STEP OVER S                     11905000
         MVI   SIGNSW,D0                SET SIGN FLAG PLUS              11906000
         GOIF  D0(R6),JMINUS,EQ=SNEG    IS IT NEGATIVE                  11907000
         GOIF  D0(R6),JPLUS,EQ=SPOS     IS IT POSITIVE                  11908000
         B     SNOSIGN                  NO, TO GET VALUE                11909000
SNEG     MVI   SIGNSW,TESTER            SET SIGN FLAG MINUS             11910000
SPOS     LA    R6,D1(,R6)               STEP OVER SIGN                  11911000
SNOSIGN  BAL   R9,EVAL1                 GO SET UP EVAL CALL             11912000
         B     SLIMCHK                  TO VALIDITY CHECK               11913000
         CLI   D0(R6),JLPARN            IS IT LEFT PAREN?               11914000
         BNE   LDELIM3                  GO LOG ERROR IF NOT             11915000
         SET    SUBLIST,ON              TURN SUBLIST BIT ON             11916000
         LR    R10,R6                   POINT AT LEFT PAREN             11917000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     11918000
         LR    R6,R14                   RESTORE POINTER                 11919000
         BC    1,STMEND3                SYNTAX ERROR, EXIT              11920000
         BNZ   SMBAD                    TO BAD VALUE                    11921000
SLIMCHK  TM    SIGNSW,TESTER            CHECK MINUS                     11922000
         LR    R1,R11                   GET VALUE                       11923000
         BZ    CHKSBIT                  YES                             11924000
         LCR   R1,R1                    NO, COMPLEMENT VALUE            11925000
CHKSBIT  LH    R14,LOSMINC(,R3)         GET VALUE LIMITS                11926000
         LH    R15,HISMINC(,R3)                                         11927000
         CR    R1,R14                   CHECK LO LIMIT                  11928000
         BL    SMBAD                    TOO LOW                         11929000
         CR    R1,R15                   CHECK HI LIMIT                  11930000
         BH    SMBAD                    TOO HIGH                        11931000
ST0SCAL  ST    R1,SMOD                  STORE GOOD S-MOD                11932000
         B     ETEST                    TO E-MOD TEST                   11933000
SMBAD    BAL  R9,ERLOG                  GO LOG ERROR                    11934000
         DC    AL1(SEV200,ERR200,CLMPTR,0)  INVALID SCALE MODIFIER      11935000
         SR    R1,R1                    SET SCALE TO ZERO               11936000
         B     ST0SCAL                  GO DO IT                        11937000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - EXPONENT MODI11938000
               IFIER SCAN && EVALUATION'                                11939000
ETEST    GOIF  D0(R6),JE,NE=KSCAN       IS THERE AN EXPONENT            11940000
         TM    FLAGINC(R3),BIT3         IS EXPONENT ALLOWED?            11941000
         BNO   EMBAD                    ERROR IF NOT ALLOWED            11942000
         LA    R6,D1(,R6)               STEP OVER E                     11943000
         MVI   SIGNSW,D0                SET SIGN FLAG PLUS              11944000
         GOIF  D0(R6),JMINUS,EQ=ENEG    IS IT NEGATIVE                  11945000
         GOIF  D0(R6),JPLUS,EQ=EPOS     IS IT POSITIVE                  11946000
         B     ENOSIGN                  NO, TO GET VALUE                11947000
ENEG     MVI   SIGNSW,TESTER            SET SIGN FLAG MINUS             11948000
EPOS     LA    R6,D1(,R6)               STEP OVER SIGN                  11949000
ENOSIGN  BAL   R9,EVAL1                 GO SET UP EVAL CALL             11950000
         B     ELIMCHK                  TO VALIDITY CHECK               11951000
         CLI   D0(R6),JLPARN            IS IT LEFT PAREN?               11952000
         BNE   LDELIM3                  GO LOG ERROR IF NOT             11953000
         SET    SUBLIST,ON              TURN SUBLIST BIT ON             11954000
         LR    R10,R6                   POINT AT LEFT PAREN             11955000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     11956000
         LR    R6,R14                   RESTORE POINTER                 11957000
         BC    D1,STMEND3               SYNTAX ERROR, EXIT              11958000
         BNZ   EMBAD                    TO BAD VALUE                    11959000
ELIMCHK  TM    SIGNSW,TESTER            CHECK MINUS                     11960000
         LR    R1,R11                   GET VALUE                       11961000
         BZ    CHKEBIT                  YES                             11962000
         LCR   R1,R1                    NO, COMPLEMENT VALUE            11963000
CHKEBIT  TM    FLAGINC(R3),EBIT         IS E-MOD LEGAL FOR TYPE         11964000
         BZ    EMBAD                    NO                              11965000
         LH    R14,LOEMINC(,R3)         YES, GET VALUE LIMITS           11966000
         LH    R15,HIEMINC(,R3)                                         11967000
         CR    R1,R14                   CHECK LO LIMIT                  11968000
         BL    EMBAD                    TOO LOW                         11969000
         CR    R1,R15                   CHECK HI LIMIT                  11970000
         BH    EMBAD                    TOO HIGH                        11971000
ST0EXP   ST    R1,EMOD                  STORE GOOD E-MOD                11972000
         B     KSCAN                    TO CONSTANT PRE-SCAN            11973000
EMBAD    BAL   R9,ERLOG                 GO LOG ERROR                    11974000
         DC    AL1(SEV201,ERR201,CLMPTR,0)  INVALID EXPONENT MODIFIER   11975000
         SR    R1,R1                    SET EXPONENT TO ZERO            11976000
         B     ST0EXP                   GO DO IT                        11977000
EVAL1    CLI   D0(R6),JNUMMAX           IS IT NUMERIC?                  11978000
         BC    D2,D4(R9)                NO, RETURN                      11979000
         MVI   SELFDEFN,D0              SET SELF DEFN FLAG OFF          11980000
         LR    R10,R6                   POINT TO NUMBER FOR EVAL        11981000
         L     R12,=A(EVAL)             GET EVAL ADDRESS                11982000
         LR    R2,R9                    SAVE R9                         11983000
         BALR  R9,R12                   CALL EVAL                       11984000
         LR    R9,R2                    RESTORE R9                      11985000
         MVI   SELFDEFN,BITFF           RESET SELFDEFN FLAG             11986000
         LR    R6,R14                   SET TEXT POINTER                11987000
         BR    R9                       RETURN                          11988000
 TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - CONSTANT SCAN' 11989000
KSCAN    ST    R6,ERRPTR                SAVE COL PTR FOR LOGGING        11990000
         TM    DUMSW,TESTER             IS THIS DS OR DXD               11991000
         BZ    LDELIM                   NO                              11992000
         TM    FSTPSW,TESTER            YES, HAVE WE PRINTED YET        11993000
         BNZ   MTCHK                    YES                             11994000
         SR    R1,R1                    FORCE STATEMENT PRINT           11995000
         L     R12,=A(DCPRINT)          SET FOR DCPRINT                 11996000
         BALR  R9,R12                   CALL ROUTINE                    11997000
MTCHK    GOIF  D0(R6),JBLANK,EQ=KEMPTY                                  11998000
         GOIF  D0(R6),JCOMMA,NE=LDELIM  IS DS VARIABLE LENGTH           11999000
KEMPTY   L     R2,BITMOD                YES, FORM TOTAL LENGTH          12000000
         L     R1,DUPF                  IN BITS                         12001000
         MR    R0,R2                                                    12002000
DUPDS    ST    R1,BITMOD                                                12003000
         SLDL  R0,D5                    CHECK ADDRESS OVERFLOW          12004000
         MVI   MTSW,TESTER              TURN ON EMPTY FLAG              12005000
         LTR   R0,R0                                                    12006000
         BZ    KDELIM                   TO OK                           12007000
         ST    R2,BITMOD                TOO BIG, TREAT LIKE NO DUP-F    12008000
         B     LENER2                   GO LOG ERROR                    12009000
LENER    XC    BITMOD,BITMOD            ZERO OUTPUT LENGTH              12010000
LENER2   BAL   R9,ERLOG2                GO LOG LENGTH ERROR             12011000
         DC    AL1(SEV224,ERR224,CLMPTR,0)  LENGTH ERROR                12012000
         B     KDELIM                   PLOW ON                         12013000
         SPACE                                                          12014000
LDELIM   GOIF  D0(R6),JLPARN,NE=LDELIM2 IS IT LEFT PAREN?               12015000
         TM    FLAGINC(R3),BIT0         IS IT ADDRESS TYPE?             12016000
         BO    LDELIM1                  YES,BRANCH AROUND               12017000
LDELIM3  ST    R6,ERRPTR                SAVE COL PTR FOR LOGGING        12018000
         SPACE                                                          12019000
         B     SYN178                   GO LOG SYNTAX ERROR             12020000
         SPACE                                                          12021000
LDELIM2  GOIF  D0(R6),JQUOTE,NE=LDELIM3 IS IT A QUOTE?                  12022000
         TM    FLAGINC(R3),BIT0         IS IT ADDRESS TYPE?             12023000
         BO    LDELIM3                  ERROR IF ADDRESS TYPE           12024000
         SPACE                                                          12025000
LDELIM1  LA    R6,D1(,R6)               STEP OVER QUOTE OR LEFT PAREN   12026000
         ST    R6,KONSTRT               SAVE CONSTANT START PNTR        12027000
         CLC   DUPF,=F'1'               IS DUP FACTOR GREATER THAN 1    12028000
         BNH   DUPLOOP                  NO, DON'T WORRY ABOUT POINT     12029000
         CLI   TYPE,ABKT                IS DC AN ADDRES CONSTANT        12030000
         BL    DUPLOOP                  NO, WILL NOT HAVE TO POINT      12031000
         SET   NOTEWL,ON                SET ON SWITCH TO NOTE IF NECESS 12032000
DUPLOOP  XC    KCOUNT(D2),KCOUNT        CLEAR CONSTANT COUNT            12033000
MLTLOOP  L     R4,ALPTR                 SET EVAL WORK FOR BUILD         12034000
         ST    R4,OUTSTART              SAVE BUILD START ADDRESS        12035000
         L     R15,ADDRINC(,R3)         GET PROCESS LOC FOR TYPE        12036000
         MVI   KLENGTH+D3,D32           SET TRUNCATION INSURANCE        12037000
         BR    R15                                                      12038000
ALNTEST  TM    TEMPLC+D3,D0             DUMMY ALIGNMENT TESTER          12039000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS C-TYP12040000
               PE CONSTANT'                                             12041000
CKON     LH    R12,ONE                  SET STEPPER                     12042000
         LR    R15,R4                   SAVE OUTPUT START               12043000
         MVI   D0(R4),EXBLANK           PRE-SET OUTPUT                  12044000
         MVC   D1(D17*D15,R4),D0(R4)    TO EXTERNAL BLANKS              12045000
CNEXTCH  GOIF  D0(R6),JQUOTE,NE=CAMPR   IS IT A QUOTE                   12046000
         GOIF  D1(R6),JQUOTE,EQ=CDOUBL  ARE THEY PAIRED?                12047000
         GOIF  D1(R6),JBLANK,EQ=CENDS   OK IF BLANK                     12048000
         GOIF  D1(R6),JCOMMA,EQ=CENDS   OK IF COMMA                     12049000
         B     LDELIM3                  GO LOG ERROR                    12050000
CAMPR    GOIF  D0(R6),JAMPER,NE=CNOTDBL IS IT AN AMPERSAND              12051000
         GOIF  D1(R6),JAMPER,NE=CERR    ARE THEY PAIRED                 12052000
CDOUBL   AR    R6,R12                   SKIP OVER DOUBLE                12053000
CNOTDBL  MVC   D0(D1,R4),D0(R6)         NEXT CHARACTER TO OUTPUT        12054000
         AR    R6,R12                   STEP POINTER TO NEXT CHARACTER  12055000
         AR    R4,R12                   STEP OUTPUT POINTER             12056000
         C     R6,OPNEND                CHECK FOR END OF OPERAND        12057000
         BL    CNEXTCH                  NO, CONTINUE SCAN               12058000
         X5ERRL 35,0,STMEND3            NO ENDING QUOTE                 12059000
CENDS    SR    R4,R15                   GET DATA LENGTH                 12060000
         LTR   R4,R4                    IS IT ZERO?                     12061000
         BZ    LDELIM3                  ERROR IF YES                    12062000
         LR    R1,R4                    SAVE VALUE                      12063000
         BCTR  R4,0                     FORM MACHINE LENGTH             12064000
         EX    R4,CTRANS                TRANSLATE TO EXTERNAL CODE      12065000
         SLL   R1,D3                    CHANGE IMPL-LENGTH TO BITS      12066000
         TM    LMODSW,TESTER            CHECK EXPLICIT LENGTH           12067000
         BNZ   CSPECL                   YES, TO ERROR CHECK             12068000
         ST    R1,BITMOD                NO SET IMPLICIT LENGTH          12069000
CSPECL   L     R0,BITMOD                GET MOD BIT-LENGTH              12070000
         ST    R0,KLENGTH               SET FOR RIGHT-PADDING           12071000
         B     LJUST                    TO OUTPUT                       12072000
CERR     ST    R6,ERRPTR                SAVE COLUMN PTR FOR LOGGING     12073000
         X5ERRL 176,CLMPTR,STMEND3      UNPAIRED AMPERSAND              12074000
CTRANS   TR   D0(0,R15),JTRTABLE        DUMMY TRANSLATE                 12075000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS X-TYP12076000
               PE CONSTANTS'                                            12077000
XKON     SR    R2,R2                    CLEAR CHARACTER REGISTER        12078000
         LR    R1,R2                    ZERO TO INDEX                   12079000
         LA    R14,D4                   SET SHIFT CONTROL               12080000
         LR    R15,R14                  SET SHIFT SWITCHER              12081000
         STH   R2,D0(R4)                CLEAR WORKAREA                  12082000
         MVC   D2(D16*D16,R4),D0(R4)    CLEAR WORKAREA                  12083000
         LA    R0,UNBKT                 SET TEXT-BUCKET START TESTER    12084000
XNEXTCH  IC    R2,D0(R1,R6)             GET NEXT TEXT BYTE              12085000
         CR    R2,R0                    IS IT HEX DIGIT                 12086000
         BL    XDIGIT                   YES                             12087000
         B     XCHECK                   GO CHECK FURTHER                12088000
XDIGIT   SLL   R2,D0(R14)               SHIFT FOUR OR ZERO              12089000
         EX    R2,BSTORE                DIGIT TO OBJECT BYTE            12090000
         LA    R1,D1(,R1)               STEP INDEX                      12091000
         XR    R14,R15                  SWITCH SHIFT CONTROL            12092000
         BZ    XNEXTCH                  CONTINUE IF NEW SHIFT 15 ZERO   12093000
         LA    R4,D1(,R4)               STEP OBJECT POINTER             12094000
         B     XNEXTCH                  CONTINUE                        12095000
XFINISH  AR    R6,R1                    UPDATE TEXT POINTER             12096000
         SLL   R1,2                     HEX COUNT TO BITS               12097000
BFINISH  ST    R1,KLENGTH               STORE IMPLICIT BIT-LENGTH       12098000
         LTR   R1,R1                    IS IT ZERO?                     12099000
         BZ    LDELIM3                  ERROR IF YES=                   12100000
         LA    R4,D1(,R4)               POINT TO PAD BYTES              12101000
         TM    LMODSW,TESTER            CHECK EXPLICIT LENGTH           12102000
         BNZ   LJUST                    YES, TO OUTPUT                  12103000
         AH    R1,SEVEN                 NO, PAD BITS TO BYTES           12104000
         N     R1,BYTEMSK                                               12105000
         ST    R1,BITMOD                SET IMPLICIT LENGTH             12106000
         B     LJUST                    TO LEFT PAD TEST                12107000
BSTORE   OI    D0(R4),D0                DUMMY BIT-STORE                 12108000
         SPACE                                                          12109000
XCHECK   LA    R0,JQUOTE                PUT JQUOTE IN REG               12110000
         CR    R2,R0                    IS IT A QUOTE?                  12111000
         BE    XFINISH                  FINISH IF EQUAL                 12112000
         LA    R0,JCOMMA                GET COMMA TEXT                  12113000
         CR    R2,R0                    IS IT COMMA?                    12114000
         BE    XFINISH                  GO TO FINISH SCAN               12115000
XBERR1   ST    R6,ERRPTR                SAVE COL PTR FOR LOGGING        12116000
         X5ERRL 236,CLMPTR,STMEND3      ILLEGAL CHARACTER               12117000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS B-TYP12118000
               PE CONSTANTS'                                            12119000
BKON     SR    R1,R1                    CLEAR BIT-LENGTH                12120000
         STH   R1,D0(,R4)               CLEAR WORK AREA                 12121000
         MVC   D2(D16*D16,R4),D0(R4)    CLEAR WORKAREA                  12122000
         BCTR  R4,0                    COMPENSATE FOR 1ST INCREMENT     12123000
BBITMSK  LA    R15,X'80'                POSITION OBJECT BIT             12124000
         LA    R2,D8                    SET SHIFT COUNTER               12125000
         LA    R4,D1(,R4)               STEP OBJECT POINTER             12126000
BNEXTCH  CLI   D0(R6),D1                IS TEXT BYTE 1                  12127000
         BL    BZERO                    NO, IT IS ZERO                  12128000
         BE    BONE                     YES                             12129000
         CLI   D0(R6),JQUOTE            IS IT A QUOTE?                  12130000
         BE    BFINISH                  FINISH IF EQUAL                 12131000
         CLI   D0(R6),JCOMMA            IS IT COMMA?                    12132000
         BE    BFINISH                  YES, GO TO FINISH               12133000
         B     XBERR1                   GO LOG ERROR                    12134000
BONE     EX    R15,BSTORE               BIT TO OBJECT BYTE              12135000
BZERO    SRL   R15,D1                   SHIFT OBJECT BIT                12136000
         LA    R1,D1(,R1)               STEP BIT-LENGTH                 12137000
         LA    R6,D1(,R6)               STEP TEXT POINTER               12138000
         BCT   R2,BNEXTCH               REDUCE SHIFT COUNTER AND LOOP   12139000
         B     BBITMSK                  GO RE-SET FOR NEW BYTE          12140000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS P-TYP12141000
               PE CONSTANTS'                                            12142000
PKON     SR    R2,R2                    CLEAR CHARACTER REGISTER        12143000
         LR    R1,R2                    ZERO TO INDEX                   12144000
         LA    R14,D4                   SET SHIFT CONTROL               12145000
         LR    R15,R14                  SET SHIFT SWITCHER              12146000
         LA    R0,JQUOTE                SET QUOTE TESTER                12147000
         LA    R10,JCOMMA               SET COMMA TESTER                12148000
         XC    D0(D18,R4),D0(R4)        CLEAR 1ST 17 BYTES      OY02610 12149000
         LA    R9,X'0C'                 SET PLUS-ZONE CODE              12150000
         CLI   D0(R6),JPLUS             CHECK PLUS SIGN                 12151000
         BE    PTSTEP                   YES                             12152000
         CLI   D0(R6),JMINUS            NO, CHECK MINUS SIGN            12153000
         BNE   PNEXTCH                  NO                              12154000
         LA    R9,X'0D'                 YES, SET MINUS-ZONE CODE        12155000
PTSTEP   LA    R6,D1(,R6)               STEP TEXT POINTER               12156000
PNEXTCH  IC    R2,D0(R1,R6)             GET NEXT TEXT BYTE              12157000
         LA    R12,D0(R1,R6)            GET OPERAND POINTER             12158000
         CLI   D0(R12),J9               IS IT NUMERIC?                  12159000
         BNH   PDIGIT                   BRANCH IF YES                   12160000
         CLI   D0(R12),JPERIOD          IS IT A PERIOD?                 12161000
         BE    PCHECK                   BRANCH IF EQUAL                 12162000
         CR    R2,R10                   IS IT A COMMA?                  12163000
         BE    PKON1                    BRANCH IF EQUAL                 12164000
         CR    R2,R0                    IS IT A QUOTE?                  12165000
         BNE   XBERR1                   LOG ILLEGAL CHARACTER ERROR     12166000
         SPACE                                                          12167000
PKON1    LTR   R1,R1                    NULL OPERAND?                   12168000
         BZ    LDELIM3                  ERROR IF YES                    12169000
         AR    R6,R1                    DONE, UPDATE TEXT POINTER       12170000
         SLL   R9,D0(R14)               SHIFT ZONE CODE FOUR OR ZERO    12171000
         EX    R9,BSTORE                ZONE TO LAST OBJECT BYTE        12172000
         CH    R1,HISMINC(,R3)          IS IT GREATER THAN 31           12173000
         BH    LENER                    ERROR IF YES                    12174000
         LA    R1,D1(,R1)               INCLUDE ZONE IN COUNT           12175000
         SLL   R1,D2                    DIGIT COUNT TO BITS             12176000
         B     BFINISH                  TO CHECK L-MOD                  12177000
PDIGIT   SLL   R2,D0(R14)               SHIFT FOUR OR ZERO              12178000
         EX    R2,BSTORE                DIGIT TO OBJECT BYTE            12179000
         LA    R1,D1(,R1)               STEP INDEX                      12180000
         XR    R14,R15                  SWITCH SHIFT CONTROL            12181000
         BZ    PNEXTCH                  CONTINUE IF NEW SHIFT IS ZERO   12182000
         LA    R4,D1(,R4)               STEP OBJECT POINTER             12183000
         B     PNEXTCH                  CONTINUE                        12184000
PCHECK   GOIF  VLIT,ON=ZCHECK1          GO IF PERIOD SWITCH IS ON       12185000
         SET   VLIT,ON                  SET PERIOD SWITCH ON            12186000
         B     PTSTEP                   GO SKIP PERIOD                  12187000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS Z-TYP12188000
               PE CONSTANTS'                                            12189000
ZKON     SR    R2,R2                    CLEAR CHARACTER REGISTER        12190000
         LR    R1,R2                    ZERO TO INDEX                   12191000
         LA    R0,JQUOTE                SET QUOTE TESTER                12192000
         LA    R10,JCOMMA               SET COMMA TESTER                12193000
         LA    R15,X'F0'                SET NUMERIC ZONE CODE           12194000
         STC   R15,D0(,R4)              PRE-SET 15 PAD BYTES            12195000
         MVC   D1(D14,R4),D0(R4)                                        12196000
         LA    R4,D15(,R4)              STEP OUTPUT OVER PAD            12197000
         LA    R9,X'CF'                 SET PLUS ZONE MASK              12198000
         CLI   D0(R6),JPLUS             CHECK PLUS SIGN                 12199000
         BE    ZTSTEP                   YES                             12200000
         CLI   D0(R6),JMINUS            CHECK MINUS SIGN                12201000
         BNE   ZNEXTCH                  NO                              12202000
         LA    R9,X'DF'                 YES, SET MINUS ZONE MASK        12203000
ZTSTEP   LA    R6,D1(,R6)               STEP TEXT POINTER               12204000
ZNEXTCH  IC    R2,D0(R1,R6)             GET NEXT TEXT BYTE              12205000
         LA    R12,D0(R1,R6)            GET OPERAND POINTER             12206000
         CLI   D0(R12),J9               IS IT NUMERIC?                  12207000
         BNH   ZDIGIT                   BRANCH IF YES                   12208000
         CLI   D0(R12),JPERIOD          IS IT A PERIOD?                 12209000
         BE    ZCHECK                   BRANCH IF EQUAL                 12210000
         CR    R2,R10                   IS IT A COMMA?                  12211000
         BE    ZKON1                    BRANCH IF EQUAL                 12212000
         CR    R2,R0                    IS IT A QUOTE?                  12213000
         BNE   XBERR1                   LOG ILLEGAL CHARACTER ERROR     12214000
         SPACE                                                          12215000
ZKON1    LTR   R1,R1                    IS IT ZERO?                     12216000
         BZ    LDELIM3                  ERROR IF YES                    12217000
         AR    R6,R1                    DONE, UPDATE TEXT POINTER       12218000
         BCTR  R4,0                     BACK UP OUTPUT POINTER          12219000
         AR    R4,R1                    POINT TO LAST OUTPUT BYTE       12220000
         EX    R9,ZSIGN                 CHANGE LAST BYTE ZONE TO SIG    12221000
         CH    R1,HISMINC(,R3)          IS IT GREATER THAN 16           12222000
         BH    LENER                    ERROR IF YES                    12223000
         SLL   R1,D3                    DIGIT COUNT TO BITS             12224000
         TM    LMODSW,TESTER            CHECK EXPLICIT LENGTH           12225000
         BNZ   ZINC                     YES                             12226000
         ST    R1,BITMOD                NO, SET IMPLICIT LENGTH         12227000
ZINC     LA    R1,D8*D15(,R1)           INSURE NEEDED PADDING           12228000
         ST    R1,KLENGTH               STORE IMPLICIT BIT-LENGTH       12229000
         B     LJUST                    TO LEFT PAD TEST                12230000
ZDIGIT   OR    R2,R15                   SET NUMERIC ZONE                12231000
         STC   R2,D0(R1,R4)             STORE OBJECT BYTE               12232000
         LA    R1,D1(,R1)               STEP INDEX                      12233000
         B     ZNEXTCH                  CONTINUE                        12234000
ZCHECK   GOIF  VLIT,ON=ZCHECK1          GO IF PERIOD SWITCH IS ON       12235000
         SET   VLIT,ON                  SET PERIOD SWITCH ON            12236000
         B     ZTSTEP                   GO SKIP PERIOD                  12237000
ZCHECK1  SET   VLIT,OFF                 SET PERIOD SWITCH OFF           12238000
         ST    R6,ERRPTR                STORE PTR FOR ERROR LOGGING     12239000
SYN178   X5ERRL 178,CLMPTR,STMEND3      ILLEGAL FORMAT                  12240000
ZSIGN    NI    D0(R4),D0                DUMMY ZONE CHANGER              12241000
   TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION - PROCESS L-, D12242000
               D-, E-, F-, H-TYPE CONSTANTS'                            12243000
DKON     LA    R11,WORKAREA             SET PARAMETER POINTER           12244000
         LA    R2,D16*D8                SET TRUNCATION INSURANCE        12245000
         ST    R2,KLENGTH                                               12246000
         LR    R10,R6                   SET TEXT POINTER                12247000
         JCALL DKVERT                   CALL DECIMAL CONVERSION         12248000
         JEXTRN (X5F01=DKVERT)          DEFINE EXTERNAL SYMBOL          12249000
         TM    EBYTE,X'FF'              WERE ANY ERRORS FLAGGED         12250000
         BZ    DKFINISH                 NO, GO TO OUTPUT                12251000
         ST    R10,ERRPTR               SAVE ERROR POINTER              12252000
         LA    R6,ERLOG2                PT TO ERROR LOGGING ROUTINE     12253000
         SPACE 1                                                        12254000
         TM    EBYTE,BIT0               SCALE INVALID ERROR             12255000
         BZ    DK10                     BR NO ERROR                     12256000
         BALR  R9,R6                    GO LOG ERROR                    12257000
         DC    AL1(SEV200,ERR200,CLMPTR,0) SCALE INVALID                12258000
         SPACE 1                                                        12259000
DK10     TM    EBYTE,BIT1               EXPONENT INVALID ERROR          12260000
         BZ    DK20                     BR NO ERROR                     12261000
         BALR  R9,R6                    GO LOG ERROR                    12262000
         DC    AL1(SEV201,ERR201,CLMPTR,0) EXPONENT INVALID             12263000
         SPACE 1                                                        12264000
DK20     TM    EBYTE,BIT2               TRUNCATION ERROR                12265000
         BZ    DK30                     BR NO ERROR                     12266000
         BALR  R9,R6                    GO LOG ERROR                    12267000
         DC    AL1(SEV203,ERR203,CLMPTR,0) TRUNCATION                   12268000
         SPACE 1                                                        12269000
DK30     TM    EBYTE,BIT4               FLOATING POINT CHAR ERROR       12270000
         BZ    DK40                     BR NO ERROR                     12271000
         BALR  R9,R6                    GO LOG ERROR                    12272000
         DC    AL1(SEV239,ERR239,CLMPTR,0) FLOATING POINT CHAR          12273000
         SPACE 1                                                        12274000
DK40     TM    EBYTE,BIT5               PRECISION LOST ERROR            12275000
         BZ    DK50                     BR NO ERROR                     12276000
         BALR  R9,R6                    GO LOG ERROR                    12277000
         DC    AL1(SEV202,ERR202,CLMPTR,0) PRECISION LOST ERROR         12278000
         SPACE 1                                                        12279000
DK50     TM    EBYTE,BIT3+BIT6+BIT7     INVALID DELIMITER ERROR         12280000
         BZ    DKFINISH                 BR NO ERROR                     12281000
         BALR  R9,R6                    GO LOG ERROR                    12282000
         DC    AL1(SEV255,ERR255,CLMPTR,0) INVALID DELIMITER ERROR      12283000
         LR    R6,R10                   RESTORE TEXT POINTER            12284000
         B     NOTINC                   SYNTAX ERROR, FLUSH STATEMENT   12285000
DKFINISH LR    R6,R10                   UPDATE TEXT PTR                 12286000
         LA    R11,D16(,R11)            POINT TO OUTPUT                 12287000
         ST    R11,OUTSTART             ''                              12288000
         B     LJUST                    TO LEFT PAD TEST                12289000
         SPACE                                                          12290000
         SPACE                                                          12291000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - DC EVALUATION '        12292000
AYKON    LR    R10,R6                   SET TEXT POINTER                12293000
         L     R2,ELCTR                 SAVE CURRENT LOCTR              12294000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     12295000
         LR    R6,R14                   UPDATE TEXT PTR                 12296000
         ST    R2,ELCTR                 RESTORE CURRENT LOCATION CTR    12297000
         BZ    MAGCHK                   ABSOLUTE, TO SIZE CHECK         12298000
         BH    AYREL                    TO RELOCATABLE                  12299000
         BC    ERRX,STMEND3             SYNTAX ERROR,EXIT               12300000
         GOIF  COMPLEX,EQ=AYREL         IS EXPRESSION COMPLEXLY RELOC   12301000
         SR    R1,R1                    ZERO VALUE                      12302000
         B     NOTY                     TO STORE VALUE                  12303000
AYREL    CLI   D0(R6),JRPARN            IS IT RIGHT PAREN?              12304000
         BE    AYREL1                   BRANCH IF YES                   12305000
         CLI   D0(R6),JCOMMA            IS IT COMMA?                    12306000
         BE    AYREL1                   BRANCH IF YES                   12307000
         B     LDELIM3                  IF NOT GO LOG ERROR             12308000
AYREL1   EQU   *                        BRANCH LABEL                    12309000
         TM    BITLSW,TESTER            CHECK BIT-LENGTH-MOD            12310000
         BZ    YCHK                     NO, OK                          12311000
RELOERR  BAL   R9,ERLOG2                GO LOG ERROR           @AX21436 12312000
         DC    AL1(SEV204,ERR204,0,0)   RELOCATION ERROR       @AX21436 12313000
         SR    R11,R11                  ZERO EXPRESSION VALUE  @AX21436 12314000
         B     MAGCHK                   CHECK FURTHER          @AX21436 12315000
YCHK     L     R1,LMOD                  GET L-MODIFIER         @AX21436 12316000
         LA    R2,2                     SET A L-TESTER         @AX21436 12317000
         CLI   TYPE,YBKT                CHECK Y-TYPE           @AX21436 12318000
         BNE   ALCHK                    NO                     @AX21436 12319000
         BCTR  R2,0                     SET Y L-TESTER         @AX21436 12320000
ALCHK    CLR   R1,R2                    CHECK RELOC LGTH LIMIT @AX21436 12321000
         BNH   RELOERR                  LOG ERROR IF NEEDED    @AX21436 12322000
         CLI   TYPE,YBKT                CHECK Y-TYPE           @AX21436 12323000
         BNE   AYZCHK                   NO                     @AX21436 12324000
         GOIF  JYFLAG,OFF=AYZCHK        SUPR ERR MSG YFLAG OFF @AX21436 12325000
         BAL   R9,ERLOG2                GO LOG ERROR                    12326000
         DC    AL1(SEV205,ERR205,0,0)   RELOCATABLE Y-CON               12327000
AYZCHK   TM    ZDUPSW,TESTER            CHECK ZERO DUP-F                12328000
         BNZ   MAGCHK                   YES, BYPASS RLD                 12329000
         MVC   DWORD1+D1(D3),ELCTR+D1   GET LOCATION OF A OR Y CON      12330000
         ST    R11,EMOD                 SAVE SYMBOL VALUE               12331000
         MVI   DWORD1,D0                SET RLD FLAGS                   12332000
         MVC   DWORD2(D2),LMOD+D2       MOVE LENGTH FOR RLD             12333000
         JCALL RLDOUT                   CALL RLD OUTPUT ROUTINE         12334000
         JEXTRN (X5A41=RLDOUT)          DEFINE EXTERNAL SYMBOL          12335000
         L     R11,EMOD                 RESTORE VALUE                   12336000
MAGCHK   LR    R1,R11                   GET VALUE                       12337000
         CLI   D0(R6),JRPARN            IS IT RIGHT PAREN?              12338000
         BE    MAGCHK1                  BRANCH AROUND IF YES            12339000
         CLI   D0(R6),JCOMMA            IS IT COMMA?                    12340000
         BE    MAGCHK1                  BRANCH AROUND IF YES            12341000
         B     LDELIM3                  LOG ERROR                       12342000
MAGCHK1  EQU   *                        BRANCH LABEL                    12343000
         CLI   TYPE,YBKT                IS IT A Y-CON                   12344000
         BNE   NOTY                     NO                              12345000
         C     R1,YMASK                 YES, IS IT TOO BIG              12346000
         BH    YDATA                    YES                             12347000
         C     R1,YNMASK                TOO SMALL                       12348000
         BNL   NOTY                     NO                              12349000
YDATA    LR    R10,R1                   SAVE REGISTER CONTENT           12350000
         BAL   R9,ERLOG2                GO LOG ERROR                    12351000
         DC    AL1(SEV203,ERR203,CLMPTR,0)  TRUNCATION                  12352000
         LR    R1,R10                   RESTORE REGISTER CONTENT        12353000
*                                                                       12354000
NOTY     ST    R1,0(,R4)                SET OUTPUT                      12355000
         B     LJUST                    TO OUTPUT                       12356000
         EJECT                                                          12357000
VKON     LR    R10,R6                   SET TEXT POINTER                12358000
         LR    R1,R6                    GET OPERAND POINTER             12359000
         GOIF  D0(R6),JALFAMIN,LT=LDELIM3 ERROR IF NOT ALPHABTIC        12360000
VESCAN   GOIF  D0(R1),JALFAMAX,GT=VSCN10  IS SYMBOL CONTINUING          12361000
         LA    R1,D1(,R1)               YES, CHECK NEXT CHARACTER       12362000
         B     VESCAN                   CONTINUE SCAN                   12363000
VSCN10   GOIF  D0(R1),JCOMMA,EQ=VSCN20  V-CON IS DELIMITED BY A COMMA   12364000
         GOIF  D0(R1),JRPARN,EQ=VSCN20   OR A RIGHT PARN                12365000
         ST    R1,ERRPTR                SAVE OPERAND PTR FOR ERROR LOG  12366000
         B     SYN178                   GO LOG SYNTAX ERROR             12367000
VSCN20   SR    R1,R6                    DETERMINE LENGTH OF SYMBOL      12368000
         AR    R6,R1                    STEP OPERAND POINTER            12369000
         CH    R1,=H'8'                 IS SYMBOL LENGTH LEGAL          12370000
         BNH   VSCN30                   YES,GO MAKE RLD                 12371000
VSCN25   EQU   *                        BRANCH LABEL                    12372000
         ST    R6,ERRPTR                SAVE OPERAND PTR FOR ERROR LOG  12373000
         X5ERRL 187,CLMPTR,STMEND3      INVALID SYMBOL                  12374000
VSCN30   LTR   R1,R1                    WAS FIELD NULL                  12375000
         BZ    LDELIM3                  GO LOG ERROR                    12376000
         LH    R10,JINFILE              POINT TO REFERENCE FILE         12377000
         JGETL FILE=(R10)               GET REFERENCE RECORD            12378000
         GOIF  NOTEWL,OFF=VSCN15        IS NOTE NECESSARY?              12379000
         SET   NOTEHS,ON                TURN ON FILE NOTED SWITCH       12380000
         SET   NOTEWL,OFF               TURN OFF NOTE REQUIRED SWITCH   12381000
         LR    R2,R11                   SAVE RECORD POINTER             12382000
         LH    R10,JINFILE              GET INPUT FILE NUMBER           12383000
         JNOTE FILE=(R10)               NOTE INPUT FILE                 12384000
         MVC   NOTEVAL,JNOTEVAL         SAVE NOTED VALUE                12385000
         LR    R11,R2                   RESTORE RECORD POINTER          12386000
VSCN15   EQU   *                                                        12387000
         L     R14,SYMXRF               INCREMENT               OX02675 12388000
         LA    R14,D1(R14)                 SYMBOL COUNT                 12389000
         ST    R14,SYMXRF               RESTORE SYMBOL XREFED   OX02675 12390000
         SPACE                                                          12391000
         TM    ZDUPSW,TESTER            IS DUP FACTOR ZERO              12392000
         BNZ   LJUST                    YES, NO RLD                     12393000
         GOIF  DSSW,ON=LJUST            NO RLD IF DS                    12394000
         MVI   RELOCTR,D1               SET UP RLD DATA                 12395000
         MVC   RLIST,D6(R11)            SAVE ESD                        12396000
         MVC   DWORD1+D1(D3),ELCTR+D1   SAVE LOCATION OF V-CON          12397000
         MVI   DWORD1,BIT3              SET RLD FLAG                    12398000
         MVC   DWORD2(D2),LMOD+D2       MOVE LENGTH FOR RLD             12399000
         JCALL RLDOUT                   GO CREATE RLD                   12400000
         XC    D0(D4,R4),D0(R4)         ZERO OUTPUT AREA                12401000
         B     LJUST                    CONTINUE OUTPUT                 12402000
         EJECT                                                          12403000
QKON     LR    R10,R6                   SET TEXT POINTER                12404000
         GOIF  D0(R10),JALFAMIN,LT=LDELIM3  ERROR IF NOT ALPHABETIC     12405000
QESCAN   GOIF  D0(R10),JALFAMAX,GT=QEND SCAN SYMBOL                     12406000
         LA    R10,D1(,R10)             STEP SCAN POINTER               12407000
         B     QESCAN                   CONTINUE SCAN                   12408000
QEND     GOIF  D0(R10),JCOMMA,EQ=QSCN10 DELIMITER MUST BE A COMMA       12409000
         GOIF  D0(R10),JRPARN,EQ=QSCN10 OR A RIGHT PAREN                12410000
         ST    R10,ERRPTR               SAVE OPERAND PTR FOR ERROR LOG  12411000
         B     SYN178                   GO LOG SYNTAX ERROR             12412000
QSCN10   SR    R10,R6                   DETERMINT SYMBOL LENGTH         12413000
         BZ    LDELIM3                  BRANCH TO LOG ERROR             12414000
         CH    R10,=H'8'                8 CHARACTERS OR LESS            12415000
         BH    VSCN25                   BRANCH TO LOG INVALID SYMBOL    12416000
         AR    R6,R10                   POINT TO DELIMITER              12417000
         LH    R10,JINFILE              POINT TO INPUT FILE             12418000
         JGETL FILE=(R10)               GET NEXT RECORD                 12419000
         TM    D5(R11),BIT1+BIT2        IS IT PREVIOUSLY DEFINED?       12420000
         BO    QSCN15                   BRANCH IF YES                   12421000
         ST    R11,ERRPTR               SAVE RECORD PTR FOR LOGGING     12422000
         BAL   R9,ERLOG2                GO LOG ERROR                    12423000
         DC    AL1(SEV231,ERR231,DTAPTR,0)  SYMBOL NOT PREVIOUSLY DEF'D 12424000
QSCN15   EQU   *                        BRANCH LABEL                    12425000
         GOIF  NOTEWL,OFF=QSCN20        IS NOTE NECESSARY?              12426000
         SET   NOTEHS,ON                TURN ON FILE NOTED SWITCH       12427000
         SET   NOTEWL,OFF               TURN OFF NOTE REQUIRED SWITCH   12428000
         LH    R10,JINFILE              GET INPUT FILE NUMBER           12429000
         LR    R2,R11                   SAVE SYMBOL RECORD PTR          12430000
         JNOTE FILE=(R10)               NOTE INPUT FILE                 12431000
         MVC   NOTEVAL,JNOTEVAL         SAVE NOTED VALUE                12432000
         LR    R11,R2                   RESTOR RECORD PTR               12433000
QSCN20  EQU    *                                                        12434000
         GOIF  XRFNO,OFF=QSCN30         DO WE MAKE XREF?                12435000
         LA    R2,REF                   INDICATE XREF REF               12436000
         JCALL XREF                     GO MAKE XREF ENTRY              12437000
QSCN30   EQU   *                                                        12438000
         TM    ZDUPSW,TESTER            IS DUP FACTRO ZERO?             12439000
         BNZ   LJUST                    BRANCH IF YES                   12440000
         TM    D3(R11),BIT4+BIT6+BIT7   IS IT DSECT OR DXD?             12441000
         BNO   QER4                                                     12442000
         MVI   RELOCTR,D1               SET UP RLD DATA                 12443000
         MVC   RLIST,D6(R11)            SAVE ESD                        12444000
         NI    RLIST,X'0F'              CLEAR FLAG                      12445000
         MVC   DWORD1+D1(D3),ELCTR+D1   SAVE LOCATION FOR RLD           12446000
         MVC   DWORD2(D2),LMOD+D2       SAVE LENGTH FOR RLD             12447000
         MVI   DWORD1,BIT2              SET Q-CON RLD FLAG              12448000
         JCALL RLDOUT                   GO CREATE RLD                   12449000
QRLD1    EQU   *                        BRANCH LABEL                    12450000
         XC    D0(D4,R4),D0(R4)         ZERO WORK AREA                  12451000
         B     LJUST                    GO OUTPUT Q-CON                 12452000
         SPACE                                                          12453000
QER4     BAL   R9,ERLOG2                GO LOG ERROR                    12454000
         DC    AL1(SEV207,ERR207,CLMPTR,0) NOT A DXD OR DSECT NAME      12455000
         B     QRLD1                    PLOW ON                         12456000
         JEXTRN (X5A51=XREF)            DEFINE EXTERNAL SYMBOL          12457000
         EJECT                                                          12458000
SKON     MVI   SIGNSW,0                 TURN OFF SUB-FIELD FLAG         12459000
         XC    DECKON(4),DECKON         CLEAR ESD POINTER               12460000
SVLOOP   LR    R10,R6                   SET TEXT POINTER                12461000
         JCALL EVAL                     CALL THE EVALUATION ROUTINE     12462000
         LR    R6,R14                   UPDATE TEXT PTR                 12463000
         ST    R11,EMOD                 SET EXPRESSION VALUE            12464000
         BZ    SDELIM                   ABSOLUTE, TO CHECK DELIMITER    12465000
         BO    SDELIM                   GO CHECK SUB FIELD              12466000
         BM    SPLEX                    TO NON-SYNTAX ERROR CHECK       12467000
         ST    R10,DECKON               SET EXPRESSION ESD              12468000
         B     SDELIM                   TO CHECK DELIMITER              12469000
SPLEX    XC    EMOD(4),EMOD             ZERO TO VALUE                   12470000
         GOIF  COMPLEX,NE=SDELIM        IS EXPRESSION COMPLEXLY RELOC   12471000
         BAL   R9,ERLOG2                GO LOG ERROR                    12472000
         DC    AL1(SEV213,ERR213,CLMPTR,0)  COMPLEXLY RELOCATABLE       12473000
SDELIM   TM    EVALSW1,FATALER          HAS AN ERROR OCCURED   @OY06592 12474000
         BO    STMEND3                  GO TO NEXT             @OY06592 12475000
         CLI   D0(R6),JLPARN            CHECK SUB-FIELD        @OY06592 12476000
         BNE   SDCHK                    NO, CHECK DECOMPOSE             12477000
         MVI   SIGNSW,TESTER            TURN ON SUB-FIELD FLAG          12478000
         MVC   SMOD(4),EMOD             SET DISPLACEMENT VALUE          12479000
         LA    R6,D1(,R6)               STEP TEXT POINTER               12480000
         B     SVLOOP                   TO SCAN SUB-FIELD               12481000
SDCHK    TM    SIGNSW,TESTER            CHECK IF SUB-FIELD              12482000
         BNZ   SUBF                     YES                             12483000
         L     R9,DECKON                GET POF POINTE                  12484000
         L     R12,EMOD                 GET VALUE                       12485000
         LA    R14,USINGT               POINT TO USING TABLE            12486000
         USING UESD,R14                 ESTABLISH USING                 12487000
SCOMPB   TM    UREG,X'0F'               THE END OF TABLE?      @OX08876 12488000
         BO    SCOMPF                   YES, GO CHECK ABSOLUTE @OX08876 12489000
         CH    R9,UESD                  NO, DO ESD'S COMPARE            12490000
         BH    SADLOG                   NO, GO LOG ADDRESSING ERROR     12491000
         BE    SCOMPD                   YES, GO CHECK DISPLACEMENT      12492000
SCOMPC   LA    R14,USNXT                STEP TO NEXT USING ENTRY        12493000
         B     SCOMPB                   GO CONTINUE SEARCH              12494000
SCOMPD   LR    R1,R12                   GET EXPRESSION VALUE            12495000
         S     R1,UVAL                  SUBTRACT USING VALUE            12496000
         BM    SCOMPC                   USING VALUE TOO LARGE           12497000
         CH    R1,=H'4096'              IS DISPLACEMENT 4096 OR GREATER 12498000
         BNL   SCOMPC                   YES, GO CONTINUE SEARCH         12499000
         LTR   R12,R12                  IS DISPLACEMENT POSITIVE        12500000
         BL    SCOMPE                   NO, GO ALLOW NEG DISPLACEMENT   12501000
         TM    UVAL,BITFF               IS USING OUT OF RANGE   OZ04407 12502000
         BM    SCOMPC                   YES, DON'T ALLOW IT     OZ04407 12503000
SCOMPE   LH    R0,UREG                  GET USING REGISTER              12504000
         SLL   R0,D12                   FORM VALUE                      12505000
         OR    R1,R0                                                    12506000
         B     SKONOUT                  TO SET OUTPUT                   12507000
SCOMPF   LTR   R9,R9                    IS USING ABSOLUTE               12508000
         BNZ   SADLOG                   NO, GO LOG ERROR                12509000
         LR    R1,R12                   GET VALUE                       12510000
         CH    R1,=H'4096'              IS DISPLACEMENT TOO LARGE       12511000
         BNL   SADLOG                   YES, GO LOG ERROR               12512000
         LTR    R1,R1                   IS NEG DISP TO BIG     @OY11250 12513000
         BL    SADLOG                   YES, GO LOG ERROR               12514000
         N     R1,=A(X'FFF')            CLEAR ANY NEGATIVE BITS         12515000
         B     SKONOUT                  GO COMPLETE OUTPUT              12516000
SADLOG   BAL   R9,ERLOG2                GO LOG ERROR                    12517000
         DC    AL1(SEV209,ERR209,CLMPTR,0)  ADDRESSABILITY ERROR        12518000
SZVAL    SR    R1,R1                    ZERO TO VALUE                   12519000
         B     SKONOUT                  TO OUTPUT                       12520000
SUBF     L     R0,DECKON                CHECK ESD PTR                   12521000
         LA    R6,D1(R6)                STEP OVER RIGHT PAREN OF SUBFLD 12522000
         LTR   R0,R0                                                    12523000
         BZ    SDISP                    OK                              12524000
         BAL   R9,ERLOG2                GO LOG ERROR                    12525000
         DC    AL1(SEV159,ERR159,0,0)   RELOCATION ERROR                12526000
         B     SZVAL                    PLOW ON                         12527000
SDISP    L     R1,SMOD                  GET DISPLACEMENT                12528000
         CL    R1,DISPLIM               CHECK TOO BIG                   12529000
         BL    SREG                     OK                              12530000
         BAL   R9,ERLOG2                GO LOG ERROR                    12531000
         DC    AL1(SEV208,ERR208,0,0)  BAD DISPLACEMENT                 12532000
         B     SZVAL                    PLOW ON                         12533000
SREG     L     R2,EMOD                  GET REGISTER                    12534000
         CL    R2,REGLIM                CHECK TOO BIG                   12535000
         BNH   SFVAL                    OK                              12536000
         BAL   R9,ERLOG2                GO LOG ERROR                    12537000
         DC    AL1(SEV230,ERR230,CLMPTR,0) INVALID REGISTER             12538000
         B     SZVAL                    PLOW ON                         12539000
SFVAL    SLL   R2,12                    FORM VALUE                      12540000
         CH    R1,=H'-4096'             IS NEGATIVE DISPLACEMENT TO BIG 12541000
         BL    SADLOG                   YES, GO LOG ERROR               12542000
         N     R1,=A(X'FFF')             CLEAR ANY NEGATIVE BITS        12543000
         OR    R1,R2                                                    12544000
SKONOUT  ST    R1,0(,R4)                SET OUTPUT                      12545000
         EJECT                                                          12546000
LJUST    GOIF  LITRSW,ON=LITEV          OPERAND OF LITERAL ?            12547000
         CLC   OPNDCT(D2),LCTRSAV+D8    OVER OPERAND COUNT              12548000
         BH    NOTINC                   YES FORGET OUTPUT               12549000
LITEV    TM    ZDUPSW,TESTER            CHECK ZERO DUP FACTOR           12550000
         BZ    NOZDP2                   NO                              12551000
         XC    BITMOD(4),BITMOD         YES, CLEAR BIT-LENGTH           12552000
         B     KDELIM                   SKIP OUTPUT                     12553000
NOZDP2   TM    DUMSW,TESTER             IS THIS A DXD OR DS             12554000
         BNZ   KDELIM                   YES, SKIP OUTPUT                12555000
         L     R10,BITMOD               GET EXPLICIT BIT-LENGTH         12556000
         S     R10,KLENGTH              SUBTRACT IMPLICIT LENGTH        12557000
         BZ    KNORMAL                  TO NO PAD OR TRUNCATION         12558000
         BP    KPAD                     TO OUTPUT PADDING               12559000
         LCR   R10,R10                  GET POSITIVE DIFFERENCE         12560000
         SRDL  R10,3                    CHANGE TO BYTES                 12561000
         A     R10,OUTSTART             TRUNCATED START ADDRESS         12562000
         LR    R2,R11                   SET BIT REMAINDER               12563000
         SRL   R2,29                                                    12564000
         L     R11,BITMOD               SET TRUNCATED COUNT             12565000
         B     KALLOUT                  TO OUTPUT                       12566000
KPAD     LR    R11,R10                  SET PAD OUTPUT COUNT            12567000
         SR    R2,R2                    CLEAR BIT REMAINDER             12568000
         LA    R10,1(,R4)               SET PAD OUTPUT POINTER          12569000
         L     R12,=A(KOUTPUT)          CALL OUTPUT                     12570000
         BALR  R9,R12                   BRANCH TO ROUTINE               12571000
KNORMAL  L     R10,OUTSTART             SET CONSTANT START              12572000
         SR    R2,R2                    CLEAR BIT REMAINDER             12573000
         L     R11,KLENGTH              SET CONSTANT BIT LENGTH         12574000
KALLOUT  L     R12,=A(KOUTPUT)          CALL OUTPUT                     12575000
         BALR  R9,R12                   BRANCH TO ROUTINE               12576000
         EJECT                                                          12577000
KDELIM   L     R1,BITLC                 INCREMENT BIT LOCATION COUNTER  12578000
         A     R1,BITMOD                                                12579000
         LR    R0,R1                    SAVE IT                         12580000
         L     R2,ELCTR                 GET CURRENT LC                  12581000
         LA    R2,0(,R2)                CLEAR WRAP BITS                 12582000
         SRL   R0,3                     TRUNCATE BIT LC TO BYTES        12583000
         N     R1,WRAPMSK               CLEAR BIT LC WRAP               12584000
         ST    R1,BITLC                 SET UPDATED BIT LC              12585000
         SR    R0,R2                    FORM LC INCREMENT               12586000
         BZ    NOTINC                   TO NO INCREMENT                 12587000
         ST    R0,LOCLEN                STORE INCREMENT                 12588000
         JCALL LOCUPD                   CALL LOCATION COUNTER UPDATE    12589000
NOTINC   SET   VLIT,OFF                 TURN OFF PERIOD SWITCH          12590000
         L     R1,LMOD                  ACCUMULATE LENGTH OF DC         12591000
         A     R1,DCLNG                                                 12592000
         ST    R1,DCLNG                 SAVE ACCUMULATED LENGTH         12593000
         TM    MTSW,TESTER              IS EMPTY DS SWITCH ON?          12594000
         BNZ   OPEND                    YES, TO FINISH OPERAND          12595000
         CLI   0(R6),JCOMMA             CHECK MULTIPLE CONSTANT         12596000
         LA    R6,1(,R6)                STEP OVER DELIMITER             12597000
         BE    MLTKON                   YES                             12598000
         L     R1,DUPF                  REDUCE DUP-FACTOR               12599000
         SH    R1,ONE                                                   12600000
         ST    R1,DUPF                                                  12601000
         BNP   OPEND                    TO NO DUPLICATE SCAN            12602000
         GOIF  LTDECV,ON=STMEND         IS THIS A LITERAL REFERENCE     12603000
         GOIF  DSSW,OFF=NOTDS           IS ENTRY A DS                   12604000
         L     R2,BITLC                 FORM BIT INCREMENT              12605000
         S     R2,STRTLC                                                12606000
         MR    R0,R2                    TIMES DUP FACTOR LESS 1         12607000
         SR    R2,R2                                                    12608000
         B     DUPDS                    TO OVERFLOW CHECK               12609000
NOTDS    BCTR  R6,0                     BACK-UP TEXT POINTER            12610000
         SET   XRFNO,OFF                TURN OFF XREF                   12611000
         MVI   SKLOG,TESTER             TURN OFF ERLOG                  12612000
         TM    FLAGINC(R3),ABIT         CHECK ADDRESS-TYPE              12613000
         BO    REPSCAN                  YES, TO SCAN AGAIN              12614000
         LH    R0,KCOUNT                TEST MULTIPLE CONSTANTS         12615000
         LTR   R0,R0                                                    12616000
         BZ    LJUST                    NO, TO REPEAT OUTPUT            12617000
REPSCAN  L     R6,KONSTRT               RE-SET TEXT POINTER             12618000
         SET   DUPEVAL,ON               INDICATE DUPLICATE EVALUATION   12619000
         GOIF  NOTEHS,OFF=DUPLOOP       IS POINT NECESSARY              12620000
         LH    R10,JINFILE              POINT TO INPUT FILE             12621000
         JPOINT FILE=(R10),NEXT=GET,ADDR=NOTEVAL POINT BACK FOR SYMBOLS 12622000
         SET   XRFNO,OFF                TURN XREF OFF                   12623000
*                                                TO BE RESCANNED        12624000
         B     DUPLOOP                                                  12625000
MLTKON   LH    R1,KCOUNT                STEP CONSTANT COUNT             12626000
         LA    R1,1(,R1)                                                12627000
         STH   R1,KCOUNT                                                12628000
         B     MLTLOOP                  TO SCAN NEXT CONSTANT           12629000
         EJECT                                                          12630000
OPEND    SET   (NOTEWL,NOTEHS),OFF      TURN OFF NOTE POINT SWITCHES    12631000
         SET   DUPEVAL,OFF              RESET DUP EVALUATION            12632000
         SET   PDUPERR,OFF              RESET PRINT DUP        FX0000   12633000
         GOIF  LTDECV,ON=OPEND1         IF LITERAL,EXIT                 12634000
         GOIF  LITRSW,ON=STMEND         IF LITERAL DC THEN EXIT         12635000
         CLI   D0(R6),JCOMMA            IS COMMA NEXT                   12636000
         BNE   STMEND1                  GO CHECK FOR BLANK              12637000
         LA    R6,1(,R6)                YES, STEP OVER COMMA            12638000
         B     NEXTOP                   TO NEXT OPERAND                 12639000
OPEND1   LR    R10,R6                   RESTORE OPERAND POINTER         12640000
         B     KLEANUP                  GO CLEAN UP AND EXIT            12641000
STMEND3  EQU   *                        BRANCH LABEL                    12642000
         MVC   ELCTR,LCTRSAV+D12        RESTORE LOCTR                   12643000
         MVC   OBITS(2),LCTRSAV+D10     RESTORE OUTPUT BIT COUNT        12644000
         SET   (NOTEWL,NOTEHS),OFF      TURN OFF NOTE SWITCHES          12645000
         TM    DUMSW,TESTER             IS IT A DS              OX00223 12646000
         BZ    NOFNINC                  NO, GO TO EXIT          OX00223 12647000
         GOIF  PGEN,ON=NOFNINC          YES, IF PRT GEN ON EXIT OX00223 12648000
         MVI   FSTPSW,D0                NO, CLEAR FIRST PRNT SW OX00223 12649000
         B     NOFNINC                  GO TO EXIT                      12650000
STMEND1  GOIF  D0(R6),JBLANK,EQ=OPEND2  IS IT BLANK?                    12651000
         BAL   R9,ERLOG                 GO LOG ERROR                    12652000
         DC    AL1(SEV178,ERR178,CLMPTR,0)  BLANK EXPECTED              12653000
OPEND2   CLC   OPNDCT(2),LCTRSAV+D8     OVER OPERAND COUNT?             12654000
         BNH   STMEND                   BRANCH AROUND IF NO             12655000
         MVC   ELCTR,LCTRSAV+D12        RESTORE LOCTR                   12656000
         MVC   OBITS(2),LCTRSAV+D10     RESTORE OUTPUT BIT COUNT        12657000
         B     NOFNINC                  EXIT                            12658000
         EJECT                                                          12659000
STMEND   L     R1,BITLC                 PADDED BIT LOCATION COUNTER     12660000
         AH    R1,SEVEN                 TO BYTES                        12661000
         SRL   R1,3                                                     12662000
         L     R2,ELCTR                 GET CURRENT LC                  12663000
         LA    R2,0(,R2)                CLEAR WRAP BITS                 12664000
         SR    R1,R2                    IS INCREMENT NEEDED             12665000
         BZ    NOFNINC                  NO                              12666000
         ST    R1,LOCLEN                YES, SET INCREMENT = 1          12667000
         LR    R10,R6                   SAVE TEXT POINTER               12668000
         SET   (NOTEWL,NOTEHS),OFF      BE SURE NOTE-POINT SWITCHES OFF 12669000
         JCALL LOCUPD                   CALL LOCATION COUNTER UPDATE    12670000
NOFNINC  CLI   DCLNG,X'00'              IS DC TOO LONG         @OX09734 12671000
         BE    OKLNG                                           @OX09734 12672000
         X5ERRL 157,0                   LENGTH ERROR                    12673000
OKLNG    SR    R1,R1                                                    12674000
         TM    DUMSW,TESTER             IS THIS DS OR DXD               12675000
         BNZ   CHEK1ST                  YES                             12676000
         LH    R2,OBITS                 NO, SET OUTPUT BIT COUNT        12677000
         LA    R1,ENTDC                 SET FOR DC PRINT                12678000
         LTR   R2,R2                    CHECK UNPRINTED DATA            12679000
         BNZ   FPRCALL                  YES                             12680000
CHEK1ST  TM    FSTPSW,TESTER            HAVE WE PRINTED YET             12681000
         BZ    FPRCALL                  NOPE, GO TO IT         FX0000   12682000
         GOIF  PGEN,ON=KLEANUP          CLEANUP IF PGEN ON     FX0000   12683000
         L     R12,TXTPTR               POINTER TO CURRENT LINEFX0000   12684000
         TM    3(R12),X'40'             ?????                  FX0000   12685000
         BZ    KLEANUP                  YES                    FX0000   12686000
FPRCALL  L     R12,=A(DCPRINT)          SET FOR DCPRINT                 12687000
         BALR  R9,R12                   BRANCH TO ROUTINE               12688000
KLEANUP  SET   XRFNO,ON                 TURN ON XREF                    12689000
         MVC   PRINTSW,DCPRSW           RESTORE PRINT SWITCH            12690000
         SET   PRDEFREQ,OFF             TURN PRIOR DEF REQUIRED OFF     12691000
GETOT    JRETURN ,                      EXIT                            12692000
         JEXTRN (X5L01=LOGERR)          DEFINE EXTRNAL SYMBOL           12693000
DISPLIM  DC    F'4096'                  DISPLACEMENT UPPER LIMIT        12694000
REGLIM   DC    F'15'                    REGISTER UPPER LIMIT            12695000
BIGLIM   DC    F'524280'                L-MOD BIT LIMIT FOR C/X IN DS   12696000
YMASK    DC    X'00007FFF'              Y-CON OVERFLOW CHECKER          12697000
YNMASK   DC    X'FFFF8000'              Y-CON LOWER LIMIT               12698000
WRAPMSK  DC    X'07FFFFFF'              BIT LOCTR WRAP MASK             12699000
BYTEMSK  DC    X'FFFFFFF8'              PARTIAL-BYTE PAD MASK           12700000
ALINMT   DC    4F'0'                    ALIGNMENT BYTES FOR PRINT       12701000
TABLENG  DC    H'20'                    TYPE-TABLE ITEM LENGTH          12702000
ONE      DC    H'1'                                                     12703000
SEVEN    DC    H'7'                                                     12704000
         EJECT                                                          12705000
*                                                                       12706000
*  SUBROUTINE LINKAGE TO CHECK FOR DUPLICATE ERROR MESSAGES AND TO      12707000
*  CALL THE ERROR LOGGING ROUTINE IF IT IS NOT                          12708000
*                                                                       12709000
*  NOTE - R0 AND R1 ARE DESTROYED                                       12710000
*                                                                       12711000
ERLOG    ST    R6,ERRPTR                SAVE COLUMN POINTER             12712000
ERLOG2   SR    R0,R0                    ZERO FOR INSERT                 12713000
         IC    R0,D1(,R9)               PICK UP THE ERROR CODE          12714000
         SLL   R0,D24                   POSITON IT                      12715000
         SRA   R0,D16                      WITH A SIGN                  12716000
         IC    R0,KCOUNT+D1                  AND COUNT                  12717000
         L     R1,X5ATEMP               GET INDEX                       12718000
         LTR   R1,R1                    ARE ANY LOGGED YET THIS OPERAND 12719000
         BZ    LOGIT                    NO, DO IT                       12720000
LOGLOOP  CH    R0,X5ATEMP+D2(R1)        YES, IS IT A DUPLICATE          12721000
         BE    D4(R9)                   YES, BYPASS ERROR LOGGING       12722000
         BCTR  R1,0                     BACK UP THE INDEX               12723000
         BCT   R1,LOGLOOP               TO NEXT COMPARE                 12724000
LOGIT    CLI   X5ATEMP+D3,ELIM          ANY ROOM LEFT                   12725000
         BE    NOTABE                   NO, SKIP ENTRY                  12726000
         L     R1,X5ATEMP               YES, REFRESH INDEX              12727000
         STH   R0,X5ATEMP+D4(R1)        PLUG CODE & CONSTANT ID         12728000
         LA    R1,D2(,R1)               BUMP INDEX                      12729000
         ST    R1,X5ATEMP               AND SAVE IT                     12730000
NOTABE   L     R12,=A(LOGERR)           POINT AT ERROR ROUTINE          12731000
         BR    R12                      GO THERE                        12732000
ELIM     EQU   L'X5ATEMP-D4             MAXIMUM ERROR ENTRY DISP        12733000
         LTORG                                                          12734000
DCTRBL   DC    26X'00'                  DC TYPE TRANSLATE TABLE         12735000
DCTABLE  DC    0F'0'                                                    12736000
         DC    H'1,0,1,2048,0,0,0,0',B'01000000',AL3(CKON)            C 12737000
         DC    H'1,0,1,2048,0,0,0,0',B'01000000',AL3(XKON)            X 12738000
         DC    H'1,0,1,2048,0,0,0,0',B'01000000',AL3(BKON)            B 12739000
         DC    H'1,0,1,128,0,31,0,0',B'01000000',AL3(PKON)            P 12740000
         DC    H'1,0,1,128,0,16,0,0',B'01000000',AL3(ZKON)            Z 12741000
         DC    H'16,7,1,128,0,28,-85,75',B'01110000',AL3(DKON)        L 12742000
         DC    H'8,7,1,64,0,14,-85,75',B'01110000',AL3(DKON)          D 12743000
         DC    H'4,3,1,64,0,14,-85,75',B'01110000',AL3(DKON)          E 12744000
         DC    H'4,3,1,64,-187,346,-85,75',B'01110000',AL3(DKON)      F 12745000
         DC    H'2,1,1,64,-187,346,-85,75',B'01110000',AL3(DKON)      H 12746000
         DC    H'4,3,1,32,0,0,0,0',B'11000000',AL3(AYKON)             A 12747000
         DC    H'2,1,1,16,0,0,0,0',B'11000000',AL3(AYKON)             Y 12748000
         DC    H'4,3,24,32,0,0,0,0',B'10000000',AL3(VKON)             V 12749000
         DC    H'4,3,8,32,0,0,0,0',B'10000000',AL3(QKON)              Q 12750000
         DC    H'2,1,16,16,0,0,0,0',B'10000000',AL3(SKON)             S 12751000
         EJECT                                                          12752000
KOUTPUT  JSAVE BASE=YES                 SAVE REGISTERS                  12753000
         MVC   FULLWD(4),0(R10)         GET 1ST 4 BYTES                 12754000
         LR    R4,R7                    SAVE REGISTER                   12755000
         L     R7,FULLWD                GET FIRST 4 BYTES               12756000
         LA    R10,4(,R10)              SET FOR NEXT PICKUP             12757000
         LA    R3,32                    SET INPUT BIT COUNT             12758000
         SLL   R7,D0(R2)                TRUNCATE 1ST BYTE               12759000
         SR    R3,R2                    ADJUST IN-BIT COUNT             12760000
         B     KOBCHEK                  TO CHECK OUT-BIT LIMIT          12761000
KOUTSET  LH    R14,OBITS                GET PRINT BIT COUNT             12762000
         SRDL  R14,3                    DIVIDE BY 8                     12763000
         LA    R9,DCDATA(R14)           POINT TO CURRENT PRINT BYTE     12764000
         SR    R14,R14                                                  12765000
         SLDL  R14,3                    8 - REMAINDER                   12766000
         LA    R2,8                     INTO SHIFT CONTROL              12767000
         SR    R2,R14                                                   12768000
         SR    R3,R2                    ADJUST INBIT COUNT BY SHIFT     12769000
         BM    KNEGCT                   TO NOT ENOUGH IN-BITS           12770000
         SR    R6,R6                    CLEAR OUTPUT REGISTER           12771000
         SLDL  R6,0(R2)                 SHIFT IN BITS                   12772000
         EX    R6,KBITOR                OR BITS TO PRINT                12773000
         AH    R2,OBITS                 INCREMENT OUT-BIT COUNT         12774000
         STH   R2,OBITS                                                 12775000
         SRA   R2,6                     IS PRINT FULL                   12776000
         BZ    KOUTSET                  NO, KEEP SHIFTING               12777000
* PRINT 8 BYTES HERE                                                    12778000
         LA    R2,64                    CALL PRINT FOR                  12779000
         LA    R1,ENTDC                 SET FOR DC PRINT                12780000
         STM   R10,R11,PREGSV           SAVE IN-BIT CONTROLS            12781000
         XR    R7,R4                    EXCHANGE                        12782000
         XR    R4,R7                      REGISTERS                     12783000
         XR    R7,R4                        FOR NEXT ROUTINE            12784000
         LA    R12,DCPRINT                                              12785000
         BALR  R9,R12                   BRANCH TO ROUTINE               12786000
         XR    R7,R4                    RESTORE                         12787000
         XR    R4,R7                      BY EXCHANGING                 12788000
         XR    R7,R4                        THEM                        12789000
         LM    R10,R11,PREGSV           RESTORE IN-BIT CONTROLS         12790000
         B     KOUTSET                  TO NEXT OUTPUT                  12791000
KNEGCT   LCR   R1,R3                    SET ZERO-FILL SHIFT             12792000
         AR    R2,R3                    REDUCE INITIAL SHIFT            12793000
         SR    R6,R6                    CLEAR OUTPUT REGISTER           12794000
         SLDL  R6,0(R2)                 SHIFT IN REMAINING BITS         12795000
         SLL   R6,0(R1)                 POSITION FOR OUTPUT             12796000
         EX    R6,KBITOR                OR BITS TO PRINT                12797000
         AH    R2,OBITS                 INCREMENT OUT-BIT COUNT         12798000
         STH   R2,OBITS                 FULL PRINT IS IMPOSSIBLE        12799000
         MVC   FULLWD(4),0(R10)         GET NEXT 4 BYTES                12800000
         L     R7,FULLWD                GET NEXT 4 BYTES                12801000
         LA    R10,4(,R10)              SET FOR NEXT PICKUP             12802000
         LA    R3,32                    RE-SET INPUT BIT COUNT          12803000
KOBCHEK  SR    R11,R3                   REDUCE TOTAL IN-BIT COUNT       12804000
         BNM   KOUTSET                  TO OUTPUT UNLESS NEGATIVE       12805000
         AR    R3,R11                   FORM REMAINING IN-BIT COUNT     12806000
         BP    MORPRNT                  EXIT IF ZERO                    12807000
KXIT     JRETURN ,                      EXIT                            12808000
MORPRNT  SR    R11,R11                  ZERO TO TOTAL REMAINDER         12809000
         B     KOUTSET                  TO OUTPUT THE REST              12810000
KBITOR   OI    D0(R9),D0                EXECUTED OR FOR PRINT           12811000
         DROP  R5                       RETURN TO COMMON USING REGISTER 12812000
         EJECT                                                          12813000
         PRINT DATA                                                     12814000
* SUBROUTINE TO CALL PRINT                                              12815000
* TO CALL -  LA R12,DCPRINT  -  BALR R5,R12                             12816000
* SAVES R3 THRU R13                                                     12817000
* CLEARS PRINT DATA, CONTROL BYTE, AND OBITS AFTER PRINT                12818000
* TURNS OFF 1ST TIME SWITCH IF NOT ALIGN CALL                           12819000
* PRINT LOCATION COUNTER IS UPDATED AFTER PRINT                         12820000
* PARAMETERS -                                                          12821000
*        R1 = 0 FORCES ENTIRE STATEMENT PRINT, NO DATA (FOR DS, DXD)    12822000
*        R1 = X'80' FORCES ALIGNMENT PRINT                              12823000
*           R2 = ALIGNMENT BYTE COUNT                                   12824000
*        R1 = X'40' FORCES DATA PRINT                                   12825000
*           R2 = OUTPUT BIT COUNT (PARTIAL BYTE GETS PADDED)            12826000
DCPRINT  JSAVE BASE=YES                 SAVE REGISTERS                  12827000
         STM   R10,R12,PRNTSV           SAVE REGISTERS                  12828000
         LTR   R1,R1                    CHECK STATEMENT PRINT           12829000
         BNZ   DCPACT                   NO                              12830000
         SR    R2,R2                    ZERO DATA BYTES                 12831000
         MVI   LHFLGS,D0                YES, ZERO CONTROL BYTE          12832000
         MVI   FSTPSW,TESTER            TURN OFF 1ST TIME SWITCH        12833000
         GOIF  DXDSW,OFF=DCPCALL        IS THIS DXD                     12834000
         MVI   LHFLGS,DNTPLH            SET NO LEFT-HALF                12835000
         B     DCPCALL                  TO PRINT                        12836000
DCPACT   LA    R0,ENTALN                CHECK ALIGN CALL                12837000
         CLR   R1,R0                                                    12838000
         BNE   POBITS                   NO                              12839000
         XC    DCDATA,DCDATA            CLEAR PRINT DATA                12840000
         B     PCTROL                   TO SET CONTROL                  12841000
POBITS   LA    R2,7(,R2)                PAD PARTIAL BYTE                12842000
         SRL   R2,3                     FORM BYTE COUNT                 12843000
         MVI   FSTPSW,TESTER            TURN OFF 1ST TIME SWITCH        12844000
PCTROL   LA    R1,0(R1,R2)              SET CONTROL BYTE                12845000
         STC   R1,LHFLGS                SET LEFT HALF FLAGS             12846000
DCPCALL  LA    R10,DC0OUT               SET PRINT INDEX                 12847000
         LR    R3,R2                    SAVE DATA BYTES                 12848000
         L     R5,TXTPTR                GET TEXT POINTER                12849000
         JCALL OUTPUT                   CALL PRINT PUNCH ROUTINE        12850000
         LA    R5,LEFTHF                POINT TO WORK AREA              12851000
         JEXTRN (X5P01=OUTPUT)          DEFINE EXTERNAL SYMBOL          12852000
         XC    DCDATA,DCDATA            CLEAR DATA                      12853000
         MVI   OBITS+1,0                CLEAR OUTPUT-BIT COUNT          12854000
         L     R1,LOCATN                INCREMENT PRINT LOCATION        12855000
         ALR   R1,R3                    OR ALIGNMENT BYTES              12856000
         ST    R1,LOCATN                STORE NEW LOCATION COUNTER      12857000
         LM    R10,R12,PRNTSV           RESTORE REGISTERS               12858000
DCXIT    JRETURN ,                      EXIT                            12859000
         EJECT                                                          12860000
* DC CHARACTERISTICS AND GO-TO TABLE                                    12861000
* EACH TABLE ITEM IS 20 BYTES LONG                                      12862000
*       BYTES 0-1 - IMPLIED LENGTH                                      12863000
*       BYTES 2-3 - ALIGNMENT FACTOR                                    12864000
*       BYTES 4-5 - LENGTH-MOD LOWER LIMIT                              12865000
*       BYTES 6-7 - LENGTH-MOD UPPER LIMIT                              12866000
*       BYTES 8-9 - SCALE-MOD LOWER LIMIT                               12867000
*       BYTES 10-11 - SCALE-MOD UPPER LIMIT                             12868000
*       BYTES 12-13 - EXPONENT-MOD LOWER LIMIT                          12869000
*       BYTES 14-15 - EXPONENT-MOD UPPER LIMIT                          12870000
*       BYTE 16 - FLAG BYTE                                             12871000
*          BIT 0 = 1 IF ADDRESS TYPE                                    12872000
*          BIT 1 = 1 IF BIT-LENGTH LEGAL                                12873000
*          BIT 2 = 1 IF SCALE-MOD LEGAL                                 12874000
*          BIT 3 = 1 IF EXPONENT-MOD LEGAL                              12875000
*          BITS 4 - 7 CURRENTLY UNUSED                                  12876000
*       BYTES 17-19 - BRANCH ADDRESS FOR CONSTANT SCAN                  12877000
IMPLINC  EQU   0                        IMPLICIT LENGTH ACCESS          12878000
ALININC  EQU   2                        ALIGNMENT ACCESS                12879000
LOLMINC  EQU   4                        LO L-MOD ACCESS                 12880000
HILMINC  EQU   6                        HI L-MOD ACCESS                 12881000
LOSMINC  EQU   8                        LO S-MOD ACCESS                 12882000
HISMINC  EQU   10                       HI S-MOD ACCESS                 12883000
LOEMINC  EQU   12                       LO E-MOD ACCESS                 12884000
HIEMINC  EQU   14                       HI E-MOD ACCESS                 12885000
FLAGINC  EQU   16                       FLAG BYTE ACCESS                12886000
ADDRINC  EQU   16                       ADDRESS WORD ACCESS             12887000
ABIT     EQU   X'80'                    ADDRESS TYPE TESTER             12888000
EBIT     EQU   X'10'                    E-MOD VALIDITY TESTER           12889000
CBKT     EQU   1                        C  TYPE FLAG  (DC)              12890000
XBKT     EQU   CBKT+1                   X  TYPE FLAG  (DC)              12891000
BBKT     EQU   XBKT+1                   B  TYPE FLAG  (DC)              12892000
PBKT     EQU   BBKT+1                   P  TYPE FLAG  (DC)              12893000
ZBKT     EQU   PBKT+1                   Z  TYPE FLAG  (DC)              12894000
LBKT     EQU   ZBKT+1                   L  TYPE FLAG  (DC)              12895000
DBKT     EQU   LBKT+1                   D  TYPE FLAG  (DC)              12896000
EBKT     EQU   DBKT+1                   E  TYPE FLAG  (DC)              12897000
FBKT     EQU   EBKT+1                   F  TYPE FLAG  (DC)              12898000
HBKT     EQU   FBKT+1                   H  TYPE FLAG  (DC)              12899000
ABKT     EQU   HBKT+1                   A  TYPE FLAG  (DC)              12900000
YBKT     EQU   ABKT+1                   Y  TYPE FLAG  (DC)              12901000
VBKT     EQU   YBKT+1                   V  TYPE FLAG  (DC)              12902000
QBKT     EQU   VBKT+1                   Q  TYPE FLAG  (DC)              12903000
SBKT     EQU   QBKT+1                   S  TYPE FLAG  (DC)              12904000
         ORG   DCTRBL+JC-JALFAMIN       ORG TO CORRECT PLACE FOR C      12905000
         DC    AL1(CBKT)                C ENTRY IN TABLE                12906000
         ORG   DCTRBL+JX-JALFAMIN       ORG TO CORRECT PLACE FOR X      12907000
         DC    AL1(XBKT)                X ENTRY IN TABLE                12908000
         ORG   DCTRBL+JB-JALFAMIN       ORG TO CORRECT PLACE FOR B      12909000
         DC    AL1(BBKT)                B ENTRY IN TABLE                12910000
         ORG   DCTRBL+JP-JALFAMIN       ORG TO CORRECT PLACE FOR P      12911000
         DC    AL1(PBKT)                P ENTRY IN TABLE                12912000
         ORG   DCTRBL+JZ-JALFAMIN       ORG TO CORRECT PLACE FOR Z      12913000
         DC    AL1(ZBKT)                Z ENTRY IN TABLE                12914000
         ORG   DCTRBL+JL-JALFAMIN       ORG TO CORRECT PLACE FOR L      12915000
         DC    AL1(LBKT)                L ENTRY IN TABLE                12916000
         ORG   DCTRBL+JD-JALFAMIN       ORG TO CORRECT PLACE FOR D      12917000
         DC    AL1(DBKT)                D ENTRY IN TABLE                12918000
         ORG   DCTRBL+JE-JALFAMIN       ORG TO CORRECT PLACE FOR E      12919000
         DC    AL1(EBKT)                E ENTRY IN TABLE                12920000
         ORG   DCTRBL+JF-JALFAMIN       ORG TO CORRECT PLACE FOR F      12921000
         DC    AL1(FBKT)                F ENTRY IN TABLE                12922000
         ORG   DCTRBL+JH-JALFAMIN       ORG TO CORRECT PLACE FOR H      12923000
         DC    AL1(HBKT)                H ENTRY IN TABLE                12924000
         ORG   DCTRBL+JA-JALFAMIN       ORG TO CORRECT PLACE FOR A      12925000
         DC    AL1(ABKT)                A ENTRY IN TABLE                12926000
         ORG   DCTRBL+JY-JALFAMIN       ORG TO CORRECT PLACE FOR Y      12927000
         DC    AL1(YBKT)                Y ENTRY IN TABLE                12928000
         ORG   DCTRBL+JV-JALFAMIN       ORG TO CORRECT PLACE FOR V      12929000
         DC    AL1(VBKT)                V ENTRY IN TABLE                12930000
         ORG   DCTRBL+JQ-JALFAMIN       ORG TO CORRECT PLACE FOR Q      12931000
         DC    AL1(QBKT)                Q ENTRY IN TABLE                12932000
         ORG   DCTRBL+JS-JALFAMIN       ORG TO CORRECT PLACE FOR S      12933000
         DC    AL1(SBKT)                S ENTRY IN TABLE                12934000
         ORG   , GET LOCATION COUNTER IN STEP                           12935000
         EJECT                                                          12936000
TESTER   EQU   X'F0'                    FLAG TEST MASK                  12937000
EXBLANK  EQU   X'40'                    EXTERNAL BLANK CODE             12938000
UNBKT    EQU   X'10'                    UNCLASSIFIED TEXT BKT TYPE      12939000
         JPATCH X5D00,122C              5% PATCH AREA                   12940000
         END                                                            12941000
./ ADD NAME=IFNX5L                                                      12942000
* /* START OF SPECIFICATIONS ****                                       12943000
*02* PROCESSOR = ASSEMBLER                                              12944000
**** END OF SPECIFICATIONS ***/                                         12945000
         GBLC  &COMPNM,&ASMID                                           12946000
         JHEAD 'ASSEMBLY PHASE - ERROR LOGGING ROUTINE',               X12947000
               PHASEID=X5L,                                            X12948000
               LEVEL=10                                                 12949000
*                                                                     * 12950000
*FUNCTION/OPERATION                                                   * 12951000
*   THIS ROUTINE IS CALLED TO GENERATE ERROR RECORDS FOR ANY ERRORS   * 12952000
*   DETECTED IN THE ASSEMBLY PHASE. THIS ROUTINE WILL ALSO CALL THE   * 12953000
*   PRINT ROUTINE TO PRINT *** ERROR *** FOLLOWING THE STATEMENT IN   * 12954000
*   ERROR.                                                            * 12955000
*                                                                     * 12956000
*ENTRY POINT-                                                         * 12957000
*                                                                     * 12958000
*        LGR100                                                       * 12959000
*INPUT-                                                               * 12960000
*   ERROR CODE IN R10                                                 * 12961000
*   POINTER TO DATA IN ERROR IN R11                                   * 12962000
*                                                                     * 12963000
*OUTPUT                                                               * 12964000
*   ERROR RECORDS DEFINED IN THE DIAGNOSTIC PHASE                     * 12965000
*                                                                     * 12966000
*EXTERNAL ROUTINES-                                                   * 12967000
*        PRINT ROUTINE                                                * 12968000
*                                                                     * 12969000
*EXITS, NORMAL-                                                       * 12970000
*   EXITS TO THE CALLING ROUTINE THROUGH THE JRETURN MACRO            * 12971000
*                                                                     * 12972000
*EXITS, ERROR-                                                        * 12973000
*   NONE                                                              * 12974000
*                                                                     * 12975000
*TABLES/WORK AREA                                                     * 12976000
*   NONE                                                              * 12977000
*                                                                     * 12978000
*ATTRIBUTES-                                                          * 12979000
*   REFRESHABLE                                                       * 12980000
*                                                                     * 12981000
*NOTES-                                                               * 12982000
*   NONE                                                              * 12983000
*                                                                     * 12984000
         SPACE 5                                                        12985000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   12986000
         COPY  JCOMMON                  INCLUDE COMMON DSECT            12987000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     12988000
         COPY  JTEXT                    INCLUDE TEXT DSECT              12989000
         PRINT OFF                      DON'T PRINT X5COM COPY CODE     12990000
         COPY  X5COM                    INCLUDE ASSEMBLY PHASE COMMON   12991000
         PRINT OFF                      DON'T PRINT JERRCD COPY CODE    12992000
         COPY  JERRCD                                                   12993000
         PRINT ON                       THAT'S THE END OF THE COPY CODE 12994000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - ERROR LOGGING ROUTINE X12995000
               - RSYMRCD COPY CODE'                                     12996000
RSYMRCD  DSECT                                                          12997000
         COPY  RSYMRCD                                                  12998000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - ERROR LOGGING ROUTINE' 12999000
         JCSECT (X5L00)                 START MODULE CSECT              13000000
* APAR CHANGES                                                          13001000
*A830500-832000,950500                                         @OX08862 13002000
*C840000,850000                                                @OX08862 13003000
*A700500,702000                                                @OX10348 13004000
*A710500,712500                                                @OX10348 13005000
*A790500-792000                                                @AZ07356 13006000
         JMODID ,                       CREATE MODULE ID                13007000
         USING JTEXT,R5                 TEXT USING                      13008000
         USING JTEXTA,R4                VARIABLE TEXT USING             13009000
         USING X5COM,R7                 ASSEMBLY COMMON USING           13010000
LGR100   LR    R0,R9                    SAVE POINTER TO PARAMETER LIST  13011000
         LA    R9,D4(R9)                SET UP RETURN REGISTER TO RETURN13012000
                                           BEYOND THE PARAMETER LIST    13013000
LGR200   JSAVE BASE=NO                  SAVE CALLING REGISTERS          13014000
         LR    R8,R12                   SET UP SUBRTN BASE              13015000
         USING LGR100,R8                USING FOR SUBRTN                13016000
         LR    R3,R0                    RETRIEVE POINTER TO PARAM LIST  13017000
         L     R5,TXTPTR                GET TEXT RECORD POINTER         13018000
         STM   R10,R11,X5LSAV           SAVE REGISTERS 10 AND 11        13019000
         ST    R14,X5LSAV+D8            SAVE REGISTER 14                13020000
         JENTRY (X5L01=LGR100)          DEFINE ENTRY                    13021000
         USING RSYMRCD,R2               USING FOR RSYMRCD DSECT         13022000
         USING JERRCD,R11               ERROR RECORD USING              13023000
         GOIF  DUPEVAL,OFF=LABNODUP     NOT DUP EVAL ERROR     FX0000   13024000
         GOIF  PDUPERR,ON=LGR700        DO NOT LOG ERR IF DUP EFX0000   13025000
*    TSO CODE STARTS HERE                                               13026000
LABNODUP DS    0H                                              FX0000   13027000
         SET   PDUPERR,ON                                      FX0000   13028000
         GOIF  JTERM,OFF=LABL1          DO WE PRINT TO TERMINAL?        13029000
         CLI   D1(R3),ERR197            LOG MNOTE                       13030000
         BE    LABL00                   DO NOT CHECK MSGLEVEL           13031000
         CLC   D0(D1,R3),JMSGL          CHECK MESSAGE LEVEL             13032000
         BL    LABL1                    IF NOT TO BE LOGGED NO TERM     13033000
LABL00   GOIF  ERRBIT,ON=LABL1          BRANCH AROUND IF ERRBIT ON      13034000
         GOIF  JGEN,OFF=LABL0           SHALL WE FETCH MODEL            13035000
         LH    R10,JOUTFILE             GET FILE INDEX                  13036000
         JPUTM FILE=(R10),ADDR=MODEL    OUTPUT MODEL STMT               13037000
         MVC   D4(,R11),=AL1(JT,J0)     INDICATE TEXT RECORD            13038000
         MVC   D16(D1,R11),D3(R11)      SAVE FLAGB                      13039000
         MVC   D2(D2,R11),MODSTMT       INSERT STMT NUMBER              13040000
LABL0    LH    R10,JOUTFILE             GET FILE INDEX                  13041000
         JPUTM FILE=(R10),ADDR=JTEXT    WRITE OUT TEXT RECORD           13042000
         MVC   D4(,R11),=AL1(JT,J0)     MOVE IN TEXT RECORD OPCODE      13043000
         CLI   D1(R3),ERR197            MNOTE?                          13044000
         BNE   LABL05                   NO NO CHANGE                    13045000
         MVI   D5(R11),JM               INDICATE MNOTE MESSAGE          13046000
LABL05   MVC   D16(D1,R11),D3(R11)      SAVE JTFLGB                     13047000
         MVC   D2(D2,R11),STMTN+D2      SAVE STMNT NUMBER               13048000
         SET   ERRBIT,ON                TURN ERRBIT ON                  13049000
         SPACE                                                          13050000
*    TSO CODE ENDS HERE                                                 13051000
LABL1    L     R5,TXTPTR                GET TEXT POINTER                13052000
ERR197   EQU   197                      ERROR NUMBER FOR MNOTE          13053000
         CLI   D1(R3),ERR197            IS THIS MNOTE ?                 13054000
         BE    NOLEVT                   YES, LOG IT                     13055000
         CLC   D0(D1,R3),JMSGL          IF SEVERITY CODE LOWER THAN MSG 13056000
         BL    LGR900                   LEVEL, RETURN TO CALLER         13057000
         SET   JERR,ON                  INDICATE ERROR FLAG             13058000
         TM    DUMSW,TESTER             IS IT A DS             @OX10348 13059000
         BZ    NOLEVT                   NO                     @OX10348 13060000
         GOIF  PGEN,ON=NOLEVT           YES, IF PRT GEN ON     @OX10348 13061000
         MVI   FSTPSW,D0                CLEAR FIRST PRINT SW   @OX10348 13062000
NOLEVT   SET   JERRCHK,ON               TURN ON ERROR FLAG IN COMMON    13063000
         TM    DUMSW,TESTER                                    @OX10348 13064000
         BZ    LABL2                                           @OX10348 13065000
         GOIF  PGEN,ON=LABL2                                   @OX10348 13066000
         MVI   FSTPSW,X'00'                                    @OX10348 13067000
LABL2    EQU   *                                               @OX10348 13068000
         LH    R10,JOUTFILE             GET ADDRESS OF OUTPUT FILE      13069000
         JPUTL FILE=(R10),BUFREQ=27     GET OUTPUT BUFFER               13070000
         MVC   JEFLGA(D3),=AL1(0,8,JTERROR)  SET UP FIXED PART OF RCD   13071000
         LH    R1,=AL2(JEDATA-JERECL)   ACCUMULATE RECORD LENGTH        13072000
         MVC   JESTMTNO,STMTN+D4-L'JESTMTNO PUT IN THE STATEMENT NUMBER 13073000
         MVC   JESEV(D2),D0(R3)         MOVE ERROR & SEV CODE TO ERRRCD 13074000
         GOIF  EQUOPR,OFF=COLPTR1       BR IF NOT 2ND-3RD OPER @AZ07356*13075000
                                        IN AN EQU STMT         @AZ07356 13076000
         MVI   JESEV,X'04'              RESET SEV CODE         @AZ07356 13077000
COLPTR1  EQU   *                                               @AZ07356 13078000
         L     R2,ERRPTR                GET ADDR OF COL PTR OR DATA     13079000
         TM    D2(R3),BIT0              CHECK FOR COLUMN POINTER        13080000
         BZ    DATACK                   IF SW OFF GO CHECK FOR DATA     13081000
         TM    DUMSW,TESTER             IS IT DS OR DXD        @OX08862 13082000
         BZ    COLPTR                   NO                     @OX08862 13083000
         S     R2,JFWORD2               YES, COMP OPR COL PTR  @OX08862 13084000
         B     COLPTRDS                                        @OX08862 13085000
COLPTR   S     R2,OPNADR                COMP OPERANDCOL PTR    @OX08862 13086000
COLPTRDS LA    R2,D1(R2)                CONV TO 1 ORIGON COUNT @OX08862 13087000
         STC   R2,JECOLPTR              INSERT IN INTO ERROR RECORD     13088000
         B     LGREXIT                  EXIT                            13089000
DATACK   TM    D2(R3),BIT1              CHECK FOR DATA TO APPEND        13090000
         BZ    LGREXIT                  IF NO DATA, EXIT                13091000
         MVC   JEDATA(D8),RNAME         MOVE DATA TO ERROR RECORD       13092000
         LA    R1,D8(R1)                ADD DATA LENGTH TO RCD LGTH     13093000
LGREXIT  STH   R1,JERECL                PUT RECORD LENGTH INTO RECORD   13094000
LGR700   LM    R10,R11,X5LSAV           RESTORE REGISTERS 10 AND 11     13095000
         L     R14,X5LSAV+D8            RESTORE REGISTER 14             13096000
LGR900   JRETURN ,                      EXIT                            13097000
TESTER   EQU   X'F0'                    FLAG TEST MASK         @OX08862 13098000
         JPATCH X5L00,135               5% PATCH AREA                   13099000
         END                                                            13100000
./ ADD NAME=IFNX5M                                                      13101000
* /* START OF SPECIFICATIONS ****                                       13102000
*02* PROCESSOR = ASSEMBLER                                              13103000
**** END OF SPECIFICATIONS ***/                                         13104000
         TITLE ' TEXT AND MITAB MACRO DEFINITIONS '                     13105000
         MACRO                                                          13106000
&LABEL   TEXT  &ADDR1,&DELIM,&ADDR2                                     13107000
.*********************************************************************. 13108000
.*  CHECK FOR DELIMITER AND ADVANCE TEXT POINTER WHEN APPROPRIATE    *. 13109000
.*********************************************************************. 13110000
         GBLC  &TCP                                                     13111000
&LABEL   C     &TCP,OPNEND              DOES TEXT END HERE ?            13112000
         BNL   &ADDR1                   YES                             13113000
         AIF   ('&DELIM' EQ '').MEND    GO IF NO DELIMITER SPECIFIED    13114000
         GOIF  &DELIM,NE=&ADDR2         GO IF DELIMITER NOT IN TEXT     13115000
         LA    &TCP,NXTCH               POINT TO NEXT CHARACTER         13116000
.MEND    MEND                                                           13117000
         SPACE 5                                                        13118000
         MACRO                                                          13119000
&NAME    MITAB                                                          13120000
.*********************************************************************. 13121000
.* THIS MACRO IS ONLY CALLED ONCE.ITS PURPOSE IS TO SET THE GLOBAL   *. 13122000
.* VARIABLES USED IN THE CONSTRUCTION OF THE FAR TABLE.THE VARIABLES *. 13123000
.* CORRESPOND TO THE BIT SETTINGS DEFINED IN THE FARENT DSECT - IE   *. 13124000
.* &FSNLIT CORRESPONDS TO FSNLIT ETC.                                *. 13125000
.*********************************************************************. 13126000
         GBLA  &FSNLIT,&FSALOC,&FILEN,&FIALOC                           13127000
         GBLA  &RIDEC,&RIBND,&RIDIV                                     13128000
         GBLA  &RSMOD,&RSALW,&RSDIV                                     13129000
&FSNLIT  SETA  32768                                                    13130000
&FSALOC  SETA  4096                                                     13131000
&FILEN   SETA  2048                                                     13132000
&FIALOC  SETA  256                                                      13133000
&RIDEC   SETA  128                                                      13134000
&RIBND   SETA  16                                                       13135000
&RIDIV   SETA  1                                                        13136000
&RSMOD   SETA  &RIDEC                                                   13137000
&RSALW   SETA  8                                                        13138000
&RSDIV   SETA  &RIDIV                                                   13139000
&NAME    EQU   *                                                        13140000
         MEND                                                           13141000
         TITLE ' OPND MACRO DEFINITION '                                13142000
         MACRO                                                          13143000
&NAME    OPND  &T,                      TYPE                           X13144000
               &A,                      ALLOCATION                     X13145000
               &R                       RESTRICTIONS                    13146000
.*********************************************************************. 13147000
.* THIS MACRO IS CALLED TO CONSTRUCT AN OPERAND ENTRY IN THE FAR     *. 13148000
.* TABLE.NO CODE IS GENERATED - THE TABLE ENTRY IS PASSED IN THE     *. 13149000
.* GLOBAL &E(&I) TO THE NEAREST FOLLOWING OPCD MACRO.                *. 13150000
.* THE VALID PARAMETER FORMATS ARE -                                 *. 13151000
.*                                                                   *. 13152000
.* PARM MEANING      FORMAT   DESCRIPTION                            *. 13153000
.* ---  -------      ------   -----------                            *. 13154000
.* &T   TYPE         I OR R   IMMEDIATE,REGISTER OR MASK.            *. 13155000
.*                   S        STORAGE,SHIFT OR I/O UNIT.FORMAT D(B). *. 13156000
.*                   SX       INDEXED STORAGE.FORMAT IS D(X,B).      *. 13157000
.*                   SL       STORAGE WITH LENGTH.FORMAT IS D(L,B).  *. 13158000
.* &A   ALLOCATION   N        N IS 1,2 OR 3 AND SETS  ALLOCATION FOR *. 13159000
.*                            TYPE I OPERANDS TO FIRST,SECOND OR     *. 13160000
.*                            BOTH HOLFBYTES OF SECOND INSTR BYTE.   *. 13161000
.*                            FOR TYPE S OPERANDS,SETS ALLOCATION TO *. 13162000
.*                            SECOND,THIRD OR FOURTH HALWORD,RESP.   *. 13163000
.*                   (N,M)    USED FOR SX AND SL TYPE OPERANDS.N     *. 13164000
.*                            GIVE S PART ALLOCATION M I PART ALLOC. *. 13165000
.* &R   RESTRICTIONS N OR (N,M) FOR I OPERANDS.N IS DIVISIBILITY     *. 13166000
.*                            (POWER OF 2) AND M IS UPPER BOUND      *. 13167000
.*                            (POWER OF 2).                          *. 13168000
.*                   A OR                                            *. 13169000
.*                   (A,B,..) FOR S,SX AND SL OPERANDS.A,B ETC CAN   *. 13170000
.*                            BE EITHER OF                           *. 13171000
.*                            H,F,D     H,F OR D ALIGNMENT           *. 13172000
.*                            ALW       ALWAYS CHECK ALIGNMENT       *. 13173000
.*                            NLIT      NO LITERAL ALLOWED           *. 13174000
.*                            MOD       MODIFIED AT EXECUTION        *. 13175000
.*********************************************************************. 13176000
         GBLA  &E(5)                    FAR ENTRY CANDIDATE             13177000
         GBLA  &I                       ENTRY INDEX                     13178000
         GBLA  &M                       MAXIMUM NUMBER OF OPERANDS      13179000
         GBLB  &ERR                     ERROR HAS OCCURRED              13180000
         GBLA  &FSNLIT,&FSALOC,&FILEN,&FIALOC     FLAGS                 13181000
         GBLA  &RIDEC,&RIBND,&RIDIV     MORE FLAGS                      13182000
         GBLA  &RSMOD,&RSALW,&RSDIV     GOOD GRIEF,MORE FLAGS           13183000
         LCLA  &J                       SUBSCRIPT                       13184000
&I       SETA  &I+1                     POINT TO NEXT ENTRY             13185000
         AIF   (&I LE &M).CT                                            13186000
         MNOTE 8,'TOO MANY OPERANDS'                                    13187000
.ERR     ANOP                                                           13188000
&ERR     SETB  1                                                        13189000
         MEXIT                                                          13190000
.* CHECK TYPE                                                           13191000
.*                                                                      13192000
.CT      AIF   ('&T' EQ 'R' OR '&T' EQ 'I').I                           13193000
         AIF   ('&T' EQ 'S').S                                          13194000
         AIF   ('&T' EQ 'SX').SX                                        13195000
         AIF   ('&T' EQ 'SL').SL                                        13196000
         MNOTE 8,'INVALID TYPE'                                         13197000
         AGO   .ERR                                                     13198000
.* I (OR R) TYPE OPERAND                                                13199000
.*                                                                      13200000
.I       AIF   (N'&A NE 1).IVP                                          13201000
         AIF   (&A EQ 1 OR &A EQ 2).I12                                 13202000
&E(&I)   SETA  &A*&FIALOC               SET FIALOC                      13203000
         AGO   .RIDIV                                                   13204000
.I12     ANOP                                                           13205000
&E(&I)   SETA  (3-&A)*&FIALOC                                           13206000
.RIDIV   AIF   (N'&R EQ 0).OK                                           13207000
         AIF   (K'&R(1) EQ 0).RIBND                                     13208000
&E(&I)   SETA  &E(&I)+&R(1)*&RIDIV      SET RIDIV                       13209000
.RIBND   AIF   (N'&R EQ 1).OK                                           13210000
         AIF   (K'&R(2) EQ 0).RIDEC                                     13211000
&E(&I)   SETA  &E(&I)+&R(2)*&RIBND      SET RIBND                       13212000
.RIDEC   AIF   (N'&R EQ 2).OK                                           13213000
         AIF   ('&R(3)' NE 'DEC').IVP                                   13214000
&E(&I)   SETA  &E(&I)+&RIDEC            SET RIDEC                       13215000
         AGO   .OK                                                      13216000
.* S TYPE OPERAND                                                       13217000
.S       AIF   (N'&A NE 1).IVP                                          13218000
.SP      ANOP                                                           13219000
&E(&I)   SETA  &E(&I)+&A(1)*&FSALOC     SET FSALOC                      13220000
.RS      AIF   (&J GE N'&R).OK                                          13221000
&J       SETA  &J+1                                                     13222000
         AIF   ('&R(&J)' EQ 'H').H                                      13223000
         AIF   ('&R(&J)' EQ 'F').F                                      13224000
         AIF   ('&R(&J)' EQ 'D').D                                      13225000
         AIF   ('&R(&J)' EQ 'ALW').RSALW                                13226000
         AIF   ('&R(&J)' EQ 'NLIT').FSNLIT                              13227000
         AIF   ('&R(&J)' EQ 'MOD').RSMOD                                13228000
.IVP     MNOTE 8,'INVALID PARAMETER'                                    13229000
         AGO   .ERR                                                     13230000
.H       ANOP                                                           13231000
&E(&I)   SETA  &E(&I)+1*&RSDIV          SET RSDIV FOR H ALIGNMENT       13232000
         AGO   .RS                                                      13233000
.F       ANOP                                                           13234000
&E(&I)   SETA  &E(&I)+2*&RSDIV          SET RSDIV FOR F ALIGNMENT       13235000
         AGO   .RS                                                      13236000
.D       ANOP                                                           13237000
&E(&I)   SETA  &E(&I)+3*&RSDIV          SET RSDIV FOR D ALIGNMENT       13238000
         AGO   .RS                                                      13239000
.RSALW   ANOP                                                           13240000
&E(&I)   SETA  &E(&I)+&RSALW            SET RSALW                       13241000
         AGO   .RS                                                      13242000
.FSNLIT  ANOP                                                           13243000
&E(&I)   SETA  &E(&I)+&FSNLIT           SET FSNLIT                      13244000
         AGO   .RS                                                      13245000
.RSMOD   ANOP                                                           13246000
&E(&I)   SETA  &E(&I)+&RSMOD            SET RSMOD                       13247000
         AGO   .RS                                                      13248000
.* SX TYPE OPERAND                                                      13249000
.*                                                                      13250000
.SX      AIF   (N'&A NE 2).IVP                                          13251000
         AIF   (&A(2) EQ 1 OR &A(2) EQ 2).SX12                          13252000
&E(&I)   SETA  &E(&I)+&A(2)*&FIALOC     SET FIALOC                      13253000
         AGO   .SP                                                      13254000
.SX12    ANOP                                                           13255000
&E(&I)   SETA  &E(&I)+(3-&A(2))*&FIALOC                                 13256000
         AGO   .SP                                                      13257000
.* SL TYPE OPERAND                                                      13258000
.*                                                                      13259000
.SL      ANOP                                                           13260000
&E(&I)   SETA  &E(&I)+&FILEN            SET FILEN                       13261000
         AGO   .SX                                                      13262000
.OK      ANOP                                                           13263000
         MEND                                                           13264000
         TITLE ' OPCD MACRO DEFINITION '                                13265000
         MACRO                                                          13266000
&NAME    OPCD  &O                                                       13267000
.*********************************************************************. 13268000
.* THIS MACRO IS CALLED TO GENERATE AN INSTRUCTION ENTRY IN THE FAR  *. 13269000
.* TABLE (IF AN IDENTICAL ONE IS NOT ALREADY THERE) AND TO CONSTRUCT *. 13270000
.* A POINTER IN THE FGT OR FGTX TABLE TO THE FAR ENTRY FOR THE       *. 13271000
.* INSTRUCTION.                                                      *. 13272000
.* THE OPERAND IS THE ONE- OR TWOBYTE OPCODE FOR THE INSTRUCTION.    *. 13273000
.* FOR EXTENDED BRANCHES,TWO BYTES MUST BE USED - EG X'07F0' FOR BR  *. 13274000
.*********************************************************************. 13275000
         GBLA  &E(5)                    CANDIDATE FOR FAR ENTRY         13276000
         GBLA  &I                       INDEX IN ENTRY                  13277000
         GBLB  &ERR                     ERROR HAS OCCURRED              13278000
         GBLA  &M                       MAXIMUM NUMBER OF OPERANDS      13279000
         GBLA  &F1(255),&F2(255),&F3(255),&F4(255),&F5(255)             13280000
         GBLA  &FGT1(128),&FGT2(128)    **** STUPID ASSEMBLER ***       13281000
         GBLA  &FGTXO(255),&FGTXP(255)  FGT FOR EXTENDED OPCODES        13282000
         GBLA  &FP                      FAR POINTER                     13283000
         GBLA  &XOCP                    POINTER FOR EXTENDED OPCODES    13284000
         LCLA  &J,&N                    INDICES                         13285000
         LCLC  &FOP(5)                  FAR OPERANDS                    13286000
         AIF   (&ERR).ERR                                               13287000
.L1      ANOP                                                           13288000
&J       SETA  &J+1                                                     13289000
         AIF   (&J GT &FP).NEW          GO MAKE NEW ENTRY               13290000
         AIF   (&F1(&J) NE &E(1)).L1    GO IF 1:ST OPND NOT EQUAL       13291000
         AIF   (&F2(&J) NE &E(2)).L1    GO IF 2=ND OPND NOT EQUAL       13292000
         AIF   (&F3(&J) NE &E(3)).L1    GO IF 3=RD OPND NOT EQUAL       13293000
         AIF   (&F4(&J) NE &E(4)).L1    GO IF 4=TH OPND NOT EQUAL       13294000
         AIF   (&F5(&J) NE &E(5)).L1    GO IF 5=TH OPND NOT EQUAL       13295000
.OLD     AIF   (&O GT X'FF').XOC        GO IF EXTENDED OPCODE           13296000
         AIF   (&O GT 127).FGT2                                         13297000
&FGT1(&O+1)   SETA  &J-1                SET FAR POINTER IN FGT          13298000
         AGO   .OK                                                      13299000
.FGT2    ANOP                                                           13300000
&FGT2(&O-127) SETA  &J-1                SET FAR POINTER IN FGT          13301000
         AGO   .OK                                                      13302000
.XOC     ANOP                                                           13303000
&XOCP    SETA  &XOCP+1                                                  13304000
&FGTXO(&XOCP) SETA &O                                                   13305000
&FGTXP(&XOCP) SETA  &J-1                SET FAR POINTER IN FGTX         13306000
         AGO   .OK                                                      13307000
.NEW     ANOP                                                           13308000
&N       SETA  2                                                        13309000
.L2      AIF   (&N GT &M).GEN                                           13310000
&FOP(&N) SETC  ','.'&E(&N)'                                             13311000
&N       SETA  &N+1                                                     13312000
         AGO   .L2                                                      13313000
.GEN     ANOP                                                           13314000
&NAME    DC  AL2(&E(1)&FOP(2)&FOP(3)&FOP(4)&FOP(5))                     13315000
&FP      SETA  &FP+1                                                    13316000
&F1(&FP) SETA  &E(1)                                                    13317000
&F2(&FP) SETA  &E(2)                                                    13318000
&F3(&FP) SETA  &E(3)                                                    13319000
&F4(&FP) SETA  &E(4)                                                    13320000
&F5(&FP) SETA  &E(5)                                                    13321000
         AGO   .OLD                                                     13322000
.ERR     MNOTE 8,'NO TABLE ENTRIES GENERATED'                           13323000
         AGO   .END                                                     13324000
.OK      ANOP                                                           13325000
         MNOTE *,'FAR ENTRY NUMBER IS &J'                               13326000
.END     ANOP                                                           13327000
&E(1)    SETA  0                                                        13328000
&E(2)    SETA  0                                                        13329000
&E(3)    SETA  0                                                        13330000
&E(4)    SETA  0                                                        13331000
&E(5)    SETA  0                                                        13332000
&I       SETA  0                                                        13333000
&ERR     SETB  0                                                        13334000
         MEND                                                           13335000
         TITLE ' MIEND MACRO DEFINITION '                               13336000
         MACRO                                                          13337000
&NAME    MIEND                                                          13338000
.*********************************************************************. 13339000
.* THIS MACRO IS ONLY CALLED ONCE.ITS PURPOSE IS TO GENERATE CODE    *. 13340000
.* FOR THE FGT AND FGTX TABLES THAT HAVE BEEN GUILT BY PRECEDING     *. 13341000
.* OPCD MACRO INSTRUCTIONS.                                          *. 13342000
.*********************************************************************. 13343000
         GBLA  &FGT1(128),&FGT2(128)                                    13344000
         GBLA  &FGTXO(255),&FGTXP(255),&XOCP                            13345000
         LCLA  &J,&N                                                    13346000
&NAME    EQU   *    FAR GET TABLE FOR INSTRUCTIONS WITH ONE-BYTE OPCODE 13347000
.L1      AIF   (&J GE 256).XOC                                          13348000
         AIF   (&J GT 127).FGT2                                         13349000
         DC    AL1(&FGT1(&J+1),&FGT1(&J+2),&FGT1(&J+3),&FGT1(&J+4),&FGT?13350000
               1(&J+5),&FGT1(&J+6),&FGT1(&J+7),&FGT1(&J+8))             13351000
         AGO   .COM                                                     13352000
.FGT2    ANOP                                                           13353000
         DC    AL1(&FGT2(&J-127),&FGT2(&J-126),&FGT2(&J-125),&FGT2(&J-1X13354000
               24),&FGT2(&J-123),&FGT2(&J-122),&FGT2(&J-121),&FGT2(&J-1X13355000
               20))                                                     13356000
.COM     ANOP                                                           13357000
&J       SETA  &J+8                                                     13358000
         AGO   .L1                                                      13359000
.XOC     ANOP                                                           13360000
&J       SETA  1                                                        13361000
&NAME.X  EQU   *    FAR GET TABLE FOR INSTRUCTIONS WITH EXTENDED OPCODE 13362000
.*                                                                      13363000
.* THIS SECTION ASSUMES THAT EXTENDED INSTRUCTIONS HAVE BEEN ENTERED    13364000
.* SORTED IN ASCENDING ORDER ON THE OPCODE.                             13365000
&N       SETA  1                                                        13366000
         AIF   (&XOCP EQ 0).OUT                                         13367000
.L2      AIF   (&FGTXO(&J)/256 NE &FGTXO(&N)/256).GEN                   13368000
         AIF   (&FGTXP(&J) NE &FGTXP(&N)).GEN                           13369000
&N       SETA  &N+1                                                     13370000
         AIF   (&N LE &XOCP).L2                                         13371000
.GEN     DC    AL2(&FGTXO(&N-1))        MAX OPCODE                      13372000
         DC    AL1(&FGTXP(&N-1))        FAR ENTRY NUMBER                13373000
&J       SETA  &N                                                       13374000
         AIF   (&N LE &XOCP).L2                                         13375000
.OUT     MEND                                                           13376000
         TITLE ' GLOBAL DECLARATIONS AND INITIAL SETTINGS FOR X5M '     13377000
* THE GLOBAL &M IS THE MAXIMUM NUMBER OF OPERANDS IN ANY MACHINE        13378000
* INSTRUCTION.EACH ENTRY IN FAR CONSISTS OF &M HALFWORDS.THE            13379000
* MAXIMUM NUMBER THAT CAN BE ACCOMODATED WITH PRESENT BIT ASSIGNMENTS   13380000
* IS 5 - THREE STORAGE OPERANDS AND TWO IMMEDIATE OPERANDS.             13381000
         GBLA &M                                                        13382000
* REGISTERS                                                             13383000
         GBLC  &SCH                     SCRATCH REG                     13384000
         GBLC  &RTN                     RETURN REG                      13385000
         GBLC  &COM                     PHASE COMMON AREA ADDRESS       13386000
         GBLC  &SCR                     SCRATCH - LOCAL USE ONLY        13387000
         GBLC  &WRK                     WORK                            13388000
         GBLC  &TBP                     TEXT BASE POINTER               13389000
         GBLC  &TCP                     TEXT CURRENT POINTER            13390000
         GBLC  &FRG                     FAR TABLE POINTER               13391000
         GBLC  &ESD1                    ESDID OF EXPRESSION 1           13392000
         GBLC  &EXP1                    VALUE OF EXPRESSION 1           13393000
         SPACE 2                                                        13394000
&M       SETA  3                                                        13395000
&COM     SETC  'R7'                                                     13396000
&SCR     SETC  'R14'                                                    13397000
&WRK     SETC  'R6'                                                     13398000
&TBP     SETC  'R5'                                                     13399000
&TCP     SETC  'R10'                                                    13400000
&SCH     SETC  'R15'                                                    13401000
&RTN     SETC  'R9'                                                     13402000
&ESD1    SETC  'R6'                                                     13403000
&EXP1    SETC  'R4'                                                     13404000
&FRG     SETC  'R3'                                                     13405000
* NOTE - R1 AND R2 ARE DESTROYED IN THIS MODULE                         13406000
         JHEAD 'MACHINE INSTRUCTION PROCESSOR',                        X13407000
               PHASEID=X5M,                                            X13408000
               LEVEL=10                                                 13409000
*FUNCTION/OPERATION-                                                  * 13410000
*   ASSEMBLE MACHINE INSTRUCTIONS.                                    * 13411000
*   THE OPERAND LIST OF A MACHINE INSTRUCTION CONSISTS OF NONE OR     * 13412000
*   MORE OPERANDS,SEPARATED BY COMMAS.EACH OPERAND IS CONSIDERED      * 13413000
*   TO CONSIST OF AN OPTIONAL 'I PART' AND AN OPTIONAL 'S PART'.      * 13414000
*   THE FOLLOWING OPERAND TYPES ARE RECOGNIZED -                      * 13415000
*                                                                     * 13416000
*   TYPE FORMAT DESCRIPTION                       I PART   S PART     * 13417000
*   ---- ------ -----------                       -----    ------     * 13418000
*   I    I      IMMEDIATE,MASK OR REGISTER FIELD   I        N/A       * 13419000
*   S    D(B)   STORAGE,OR SHIFT OR I/O UNIT       N/A      D(B)      * 13420000
*   SX   D(X,B) INDEXED STORAGE OPERAND            X        D(B)      * 13421000
*   SL   D(L,B) STORAGE OPERAND WITH LENGTH FIELD  L        D(B)      * 13422000
*                                                                     * 13423000
*   EACH OPERAND IS PROCESSED SEPARATELY.THE PROCESSING IS DRIVEN     * 13424000
*   BY A TABLE -FAR- THAT DESCRIBES THE OPERAND FORMAT,ALLOCATION     * 13425000
*   (IN ASSEMBLED INSTRUCTION) AND RESTRICTIONS.THE TABLE ENTRY       * 13426000
*   FORMAT IS DESCRIBED WITH THE DSECT 'FARENT'.                      * 13427000
*                                                                     * 13428000
*ENTRY POINT-                                                         * 13429000
*        X5M.                                                         * 13430000
*                                                                     * 13431000
*INPUT-                                                               * 13432000
*   INTERNAL TEXT RECORD - READ BY PHASE MAINLINE TO JTEXT BUFFER.    * 13433000
*                                                                     * 13434000
*OUTPUT-                                                              * 13435000
*   ASSEMBLED TEXT IN LEFTHF (IN PHASE COMMON).                       * 13436000
*                                                                     * 13437000
*EXTERNAL ROUTINES-                                                   * 13438000
*        X5V - EVALUATE EXPRESSIONS.                                  * 13439000
*        X5P - PRINT AND PUNCH.                                       * 13440000
*        X5L - LOG ERRORS.                                            * 13441000
*                                                                     * 13442000
*EXITS,NORMAL-                                                        * 13443000
*   RETURN TO PHASE MAINLINE.                                         * 13444000
*                                                                     * 13445000
*EXITS,ERROR-                                                         * 13446000
*   N/A                                                               * 13447000
*                                                                     * 13448000
*TABLES/WORK AREAS-                                                   * 13449000
*   FAR - MACHINE INSTRUCTION TABLE(SEE ABOVE).                       * 13450000
*   USING - USING TABLE.                                              * 13451000
*                                                                     * 13452000
*ATTRIBUTES-                                                          * 13453000
*   REFRESHABLE.                                                      * 13454000
*                                                                     * 13455000
*NOTES-                                                               * 13456000
*   INSTRUCTIONS FOR MODIFYING THE FAR TABLE ARE INCLUDED WITH THE    * 13457000
*   TABLE.TO ACCOMODATE MORE THAN 3 OPERANDS,CHANGE THE GLOBAL &M.    * 13458000
*   TO HANDLE THREE STORAGE OPERANDS,LEFTHF MUST BE EXPANDED.         * 13459000
*                                                                     * 13460000
         SPACE 2                                                        13461000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   13462000
         COPY  JCOMMON                  JCOMMON COPY CODE               13463000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     13464000
         COPY  JTEXT                    JTEXT COPY CODE                 13465000
         PRINT OFF                      DON'T PRINT THE X5COM COPY CODE 13466000
         COPY  X5COM                    X5COM COPY CODE                 13467000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  13468000
         COPY  JERMSGCD                 DEFINE ERROR CODES AND SEVERITY 13469000
         PRINT ON,DATA,GEN              THAT'S ALL THE COPY CODFX0000   13470000
         SPACE 5                                                        13471000
JTEXTA   DSECT                          RESUME VARIABLE PART OF TEXT    13472000
         ORG   JTEXTA                   REORG FOR CURRENT CHARACTER     13473000
CURCH    DBV   COMMA(JCOMMA),                                          X13474000
               LPAREN(JLPARN),                                         X13475000
               RPAREN(JRPARN)                                           13476000
NXTCH    EQU   *                        NEXT CHARACTER                  13477000
         EJECT                                                          13478000
FGTXE    DSECT                          ENTRY IN FGT FOR EXTENDED OPS   13479000
XOPCM    DS    CL2                      OPCODE MASK - TWO BYTES         13480000
XFPTR    DS    C                        FAR POINTER                     13481000
XNEXT    EQU   *                        NEXT ENTRY                      13482000
         COPY  RXLFMTS                  POST PROCESSOR RECORD FORMATS   13483000
         EJECT                                                          13484000
* FARENT                                                                13485000
*                                                                       13486000
*   THIS DSECT DESCRIBES THE FORMAT OF AN OPERAND ENTRY IN FAR.         13487000
*   EACH INSTRUCTION ENTRY IN FAR CONSISTS OF A FIXED NUMBER OF         13488000
*   FAR OPERAND ENTRIES.THE FIXED NUMBER IS THE MAXIMUM NUMBER OF       13489000
*   OPERANDS IN ANY MACHINE INSTRUCTION AND IS SET THROUGH THE          13490000
*   GLOBAL &M.                                                          13491000
*   EACH FAR OPERAND ENTRY CONSISTS OF TWO BYTES.THE FORMAT OF THE      13492000
*   FIRST BYTE IS -                                                     13493000
*                                                                       13494000
*   NAME     BITS   DESCRIPTION                                         13495000
*   ----     ----   -----------                                         13496000
*   FSNLIT   0      1    LITERAL NOT ALLOWED (WHEN FSALOC NONZERO)      13497000
*            1           NOT USED                                       13498000
*   FSALOC   2-3    00   NO S PART                                      13499000
*                   01   S PART ASSEMBLED INTO HALFWORD 1               13500000
*                   10   S PART ASSEMBLED INTO HALFWORD 2               13501000
*                   11   NOT USED                                       13502000
*   FILEN    4      1    SUBTRACT 1 FROM EVALUATED I PART(LENGTH FIELD) 13503000
*            5           NOT USED                                       13504000
*   FIALOC   6-7    00   NO I PART                                      13505000
*                   01   I PART ASSEMBLED INTO BITS 12-15               13506000
*                   10   I PART ASSEMBLED INTO BITS 8-11                13507000
*                   11   I PART ASSEMBLED INTO BITS 8-15                13508000
*                                                                       13509000
*   THE FORMAT OF THE SECOND BYTE FOR OPERANDS WITHOUT S PART IS -      13510000
*                                                                       13511000
*   NAME     BITS   DESCRIPTION                                         13512000
*   ----     ----   -----------                                         13513000
*   RIDEC    0      1    DECIMAL DIGIT                                  13514000
*            1           NOT USED                                       13515000
*   RIBND    2-3    00   FIELD WIDTH ONLY BOUND FOR VALUE               13516000
*                   01   NOT USED                                       13517000
*                   10   NOT USED                                       13518000
*                   11   VALUE LESS THAN 8                              13519000
*            4-5         NOT USED                                       13520000
*   RIDIV    6-7    00   NO DIVISIBILITY CONSTRAINTS                    13521000
*                   01   VALUE DIVISIBLE BY 2                           13522000
*                   10   VALUE DIVISIBLE BY 4                           13523000
*                   11   NOT USED                                       13524000
*                                                                       13525000
*   THE FORMAT OF THE SECOND BYTE FOR OPERANDS WITH S PART IS -         13526000
*                                                                       13527000
*   NAME     BITS   DESCRIPTION                                         13528000
*   ----     ----   -----------                                         13529000
*   RSMOD    0      1    OPERAND MODIFIED AT EXECUTION                  13530000
*            1-3         NOT USED                                       13531000
*   RSALW    4      1    CHECK ALIGNMENT EVEN IF NOALGN OPTION          13532000
*            5           NOT USED                                       13533000
*   RSDIV    6-7    00   NO ALIGNMENT RESTRICTIONS                      13534000
*                   01   ALIGN ON HALFWORD BDRY                         13535000
*                   10   ALIGN ON FULLWORD BDRY                         13536000
*                   11   ALIGN ON DOUBLEWORD BDRY                       13537000
*                                                                       13538000
         SPACE                                                          13539000
FARENT   DSECT                                                          13540000
FENT     DS    0H                                                       13541000
FMT      DSW   FSNLIT,                  NO LITERAL                     X13542000
               ,,,                                                     X13543000
               FILEN,                   LENGTH FIELD                   *13544000
               ,                                                       *13545000
               FIAL1                    FIRST BIT OF FIALOC             13546000
FSALOC   EQU   BIT2+BIT3                S ALLOCATION                    13547000
FIALOC   EQU   BIT6+BIT7                I ALLOCATION                    13548000
RIST     DSW   RIDEC                    DECIMAL DIGIT                   13549000
RIBND    EQU   BIT2+BIT3                I FIELD UPPER BOUND             13550000
RIDIV    EQU   BIT6+BIT7                I FIELD DIVISIBILITY            13551000
         ORG   RIST                                                     13552000
RSST     DSW   RSMOD,                   STORAGE MODIFIED               X13553000
               ,,,                                                     X13554000
               RSALW                    ALIGNMENT ALWAYS CHECKED        13555000
RSDIV    EQU   BIT6+BIT7                S DIVISIBILITY(I.E.,ALIGNMENT)  13556000
NXTFENT  EQU   *                        NEXT FAR ENTRY                  13557000
         ORG   FMT                                                      13558000
         DBV   EOP(0)                   END OF OPERAND                  13559000
         EJECT                                                          13560000
         JCSECT (X5M00)                 CREATE CSECT                    13561000
* VS1 RELEASE 3.1 CHANGES                                               13562000
*C579600,580800,594700,594900                                   OX02675 13563000
*A540500,540540                                                @OY09690 13564000
*D540600                                                       @OY09690 13565000
*C536400                                                       @AZ07389 13566000
*A590900                                                       @AX13632 13567000
*C876300,877200,880200,881400,884490,884610                    @AM07317 13568000
         JMODID                         EMBED MODULE IDENTIFIER         13569000
         SPACE                                                          13570000
X5M      JSAVE BASE=YES                 SAVE CALLING REGISTERS          13571000
         JENTRY (X5M01=X5M)             IDENTIFY ENTRY POINT            13572000
         JEXTRN (X5P01=X5P)             ENTRY POINT FOR PRINT AND PUNCH 13573000
         JEXTRN (X5L01=LOGERR)          ENTRY POINT FOR ERROR LOGGING   13574000
         JEXTRN (X5V01=X5V)             ENTRY POINT FOR EXPR EVALUATION 13575000
         USING X5COM,&COM                                               13576000
         USING JTEXT,&TBP                                               13577000
         USING JTEXTA,&TCP                                              13578000
         USING FARENT,&FRG                                              13579000
         USING XRFIN,R11                SETUP BASE FOR XREF RECORD      13580000
         EJECT                                                          13581000
*********************************************************************** 13582000
* INIT                                                                * 13583000
*   INITIALIZE FOR MACHINE INSTRUCTION PROCESSING.                    * 13584000
*********************************************************************** 13585000
         SPACE                                                          13586000
         SET   (TOOMANY,LEAVE),OFF      RESET SWITCHES                  13587000
         SET   ZAPIT,OFF                INITLZ SW FOR ZEROING OP CODE   13588000
         L     &WRK,ELCTR               GET LOCATION COUNTER            13589000
         TM    ELCTR+L'ELCTR-1,BIT7     IS IT ODD ?                     13590000
         BNO   INTLCT                   NO, STORE                       13591000
* PRODUCE ALIGNMENT BYTE FOR PRINTING                                   13592000
         ST    &WRK,LOCATN              STORE LOCATION CTR IN OUTPUT    13593000
         MVI   LHFLGS,D1                LENGTH IS ONE                   13594000
         SET   ENTALN,ON                INDICATE ALIGNMENT              13595000
         LA    R10,LSTOUT               SET PARAMETER FOR X5P           13596000
         JCALL X5P             GO PRINT AND PUNCH ALIGNMENR BYTE        13597000
         LA    &WRK,D1(,&WRK)           ROUND LOCTR TO HALFWORD         13598000
         ST    &WRK,ELCTR               STORE IT                        13599000
INTLCT   ST    &WRK,LOCATN              SET LOCATION FOR INSTRUCTION    13600000
         SPACE                                                          13601000
*   GET LENGTH OF INSTRUCTION(NEEDED IN X5V)                            13602000
         SPACE                                                          13603000
         IC    &SCR,JTFLGA              GET LENGTH FLAGS(IN JTFLGA)     13604000
         SLL   &SCR,D32-JLN4            SHIFT OUT GARBAGE               13605000
         SRL   &SCR,D32-(JLN4+D1)       SHIFT BACK AND MULTIPLY BY 2    13606000
         LA    &SCR,D2(,&SCR)           ADD 2 (BASIC LENGTH)            13607000
         STH   &SCR,CLCLNG              STORE INSTRUCTION LENGTH        13608000
         SPACE                                                          13609000
         XC    LHIMD(LHFLGS-LHIMD),LHIMD  CLEAR LEFTHALF                13610000
         MVC   LHOPCD,JTIOP             MOVE OPCODE TO OUTPUT           13611000
         SPACE                                                          13612000
* GET POINTER TO OPERAND LIST                                           13613000
         SPACE                                                          13614000
         L     &TCP,OPNADR              INITIALIZE TEXT POINTER         13615000
         SPACE                                                          13616000
* GET ADDRESS OF INSTRUCTION ENTRY IN FAR.                              13617000
*   THE ENTRY IS LOOKED UP VIA ONE OF TWO AUXILIARY TABLES,FGT AND      13618000
*   FGTX.FGT IS USED FOR INSTRUCTIONS WITH ONE-BYTE OPCODE AND IS       13619000
*   SIMPLY A TRANSLATION TABLE.FGTX IS USED FOR EXTENDED OPCODE,IE      13620000
*   EXTENDED BRANCHES AND TWO-BYTE OPCODES.ITS ENTRIES ARE SORTED IN    13621000
*   ASCENDING ORDER ON THE OPCODE.                                      13622000
         SPACE                                                          13623000
         SR    R2,R2                    CLEAR POINTER REG               13624000
         GOIF  JEXTB,ON=INTXOC          GO IF EXTENDED OPCODE           13625000
         TRT   JTIOP1,FGT               GET FAR ENTRY NUMBER IN REG 2   13626000
         B     INTGFR                                                   13627000
         SPACE                                                          13628000
INTXOC   LA    &SCR,FGTX                GET FAR-GET-TABLE ADDRESS  FOR  13629000
         USING FGTXE,&SCR               EXT OPCODES                     13630000
INTXCP   CLC   XOPCM,JTIOP              IS THIS THE ENTRY               13631000
         BNL   INTXFD                   YES                             13632000
         LA    &SCR,XNEXT               NO,TRY                          13633000
         B     INTXCP                   NEXT ENTRY                      13634000
INTXFD   IC    R2,XFPTR                 GET FAR ENTRY NUMBER            13635000
         SPACE                                                          13636000
INTGFR   MH    R2,=Y(&M*L'FENT)         GET ADDR (REL TO FAR) OF ENTRY  13637000
         LA    &FRG,FAR(R2)             ADD FAR BASE POINTER            13638000
         LA    &SCR,FARENT+&M*L'FENT    GET ADDR OF FAR ENTRY END       13639000
         ST    &SCR,FNTEND              STORE IT                        13640000
         TEXT  DRVCKE                   GO IF NO OPERAND THERE          13641000
         CLC   D0(,&FRG),=H'0'          ZERO FAR ENTRY. TREAT OPND AS   13642000
         BNE   DRVRST                    A COMMENT                      13643000
         B     CLOSE                    GO OUTPUT                       13644000
*   END OF INITIALIZATION                                               13645000
         EJECT                                                          13646000
*********************************************************************** 13647000
* DRIVER                                                              * 13648000
*   FUNCTION                                                          * 13649000
*    -MONITOR OPERAND PROCESSING.                                     * 13650000
*    -DIAGNOSE THE FOLLOWING ERRORS-                                  * 13651000
*      ERROR                                 ACTION                   * 13652000
*      ----                                  ------                   * 13653000
*      TOO FEW OPERANDS                      LEAVE *                  * 13654000
*      TOO MANY OPERANDS                     SCAN SUPERFLUOUS OPERANDS* 13655000
*                                            FOR ERRORS               * 13656000
*      COMMA EXPECTED AFTER OPERAND          LEAVE                    * 13657000
*                                                                     * 13658000
*      *'LEAVE' MEANS THAT CONTROL IS RETURNED TO PHASE MAINLINE,WITH * 13659000
*        UNPROCESSED OPERANDS SET TO ZERO.                            * 13660000
*********************************************************************** 13661000
         SPACE 2                                                        13662000
DRIVERZ  SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13663000
DRIVER   GOIF  LEAVE,ON=CLOSEZ          EXIT IF UNRECOVERABLE ERROR    *13664000
                                        OCCURRED DURING OPERAND PROC    13665000
         LA    &FRG,NXTFENT             GET NEXT FORMAT                 13666000
         CLI   D0(R10),JBLANK           IS IT BLANK?                    13667000
         BE    DRVCKE                   YES,GO CHECK IF IT SHOILD BE    13668000
         TEXT  DRVCKE,COMMA,DRVNCM      GO TO DRVCKE IF END OF TEXT,   *13669000
                                        DRVNCM IF NOT SO AND NO COMMA   13670000
         GOIF  EOP,EQ=DRV2MN            GO IF END OF FORMAT             13671000
         C     &FRG,FNTEND                   LIKE-                      13672000
         BNL   DRV2MN                        WISE                       13673000
DRVRST   EQU   *                   RESET SWITCHES AND WORK AREAS        13674000
         SET   (E2PR,E3PR,E1ERR,E2ERR,E3ERR),OFF       RESET SWITCHES   13675000
         XC    MWORK(MWLEN),MWORK       CLEAR WORK AREA                 13676000
         SR    &ESD1,&ESD1              CLEAR                           13677000
         SR    &EXP1,&EXP1              CLEAR                           13678000
         MVI   LQ1+L'LQ1-1,1            SET INITIAL LENGTH ATTR TO 1    13679000
         B     COLLECT                  GO SCAN OPERAND                 13680000
         SPACE                                                          13681000
DRVCKE   EQU   *                   NO MORE TEXT.CHECK IF IT SHOULD BE.  13682000
         GOIF  EOP,EQ=CLOSE             GO IF FORMAT END (ALL OK)       13683000
         C     &FRG,FNTEND                   LIKE-                      13684000
         BNL   CLOSE                         WISE                       13685000
         X5ERRL 210,0,CLOSEZ            TOO FEW OPERANDS                13686000
         SPACE                                                          13687000
DRVNCM   X5ERRL 178,CLMPTR,CLOSEZ       SYNTAX ERROR                    13688000
         SPACE                                                          13689000
DRV2MN   EQU   *                   TOO MANY OPERANDS                    13690000
         GOIF  TOOMANY,ON=DRVRST        GO IF ALREADY DIAGNOSED         13691000
         X5ERRL 211,0                   TOO MANY OPERANDS               13692000
         SET   TOOMANY,ON               REMEMBER WE DID                 13693000
         SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13694000
         B     DRVRST                   CONTINUE                        13695000
         SPACE 5                                                        13696000
CLOSEZ   SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13697000
         EJECT                                                          13698000
*********************************************************************** 13699000
* CLOSE                                                               Q 13700000
*   WRAP UP INSTRUCTION PROCESSING.CALL PRINT ROUTINE.EXIT            * 13701000
*********************************************************************** 13702000
         SPACE 2                                                        13703000
CLOSE    L     &SCR,ELCTR               TAKE A LOCATION COUNTER         13704000
         LH    &SCH,CLCLNG              ... AND ITS LENGTH              13705000
         AR    &SCR,&SCH                    ADD THEM TOGETHER           13706000
         ST    &SCR,ELCTR               AND YOU HAVE A NEW,BETTER LOCTR 13707000
         STC   &SCH,LHFLGS              SET LENGTH FOR OUTPUT           13708000
         GOIF  ZAPIT,OFF=CLOSE0         BR IF NO ERROR                  13709000
         BCTR  &SCH,0                   DECR LNG BY 1                   13710000
         EX    &SCH,ZAPER               ZERO OP CODE                    13711000
         SPACE                                                          13712000
CLOSE0   C     R14,=X'1000000'          IS IT GREATER THAN MAXIMUM?     13713000
         BL    CLOSE1                   BRANCH AROUND IF BELOW LIMIT    13714000
         GOIF  WRPFLG,ON=CLOSE1         BRANCH AROUND IF NOT FIRST      13715000
         SET   WRPFLG,ON                SET WRAPFLAG                    13716000
         X5ERRL 246,0                   LOCATION COUNTER OVERFLOW       13717000
         SPACE                                                          13718000
CLOSE1   LA    R10,LSTOUT               SET PARAMETER FOR X5P           13719000
         JCALL X5P                      PRINT AND/OR PUNCH INSTR        13720000
         GOIF  JERR,OFF=X5M99           WAS AN ERROR FLAGGED            13721000
         LA    R10,ERROUT               YES, LOAD ERROR FLAG INDEX      13722000
         JCALL X5P                      GO PRINT FLAG                   13723000
X5M99    JRETURN ,                      RETURN TO PHASE MAINLINE        13724000
ZAPER    XC    LHOPCD(*-*),LHOPCD       ZERO OPCODE                     13725000
         EJECT                                                          13726000
*********************************************************************** 13727000
* COLLECT                                                             * 13728000
* FUNCTION                                                            * 13729000
*  -SCAN ONE OPERAND AND COLLECT DATA                                 * 13730000
*  -DIAGNOSE THE FOLLOWING ERRORS-                                    * 13731000
*    ERROR                                   ACTION                   * 13732000
*    -----                                   ------                   * 13733000
*    PREMATURE END OF OPERAND                LEAVE                    * 13734000
*    RIGHT PARENTHESES EXPECTED              LEAVE                    * 13735000
*    COMPLEXLY RELOCATABLE OPERAND           SET TO ZERO              * 13736000
*    ILLEGAL LITERAL USAGE                   -                        * 13737000
*                                                                     * 13738000
*    THE FOLLOWING FORMATS ARE ACCEPTED,REGARDLESS OF FORMAT SPECIFIED* 13739000
*    IN FAR TABLE                                                     * 13740000
*        EXP1                                                         * 13741000
*        EXP1(EXP2)                                                   * 13742000
*        EXP1(,EXP3)                                                  * 13743000
*        EXP1(EXP2,EXP3)                                              * 13744000
*        LITERAL                                                      * 13745000
*   ALL OTHERS ARE FLAGGED AS SYNTAX ERRORS EITHER BY X5V OR BY THIS  * 13746000
*   ROUTINE.                                                          * 13747000
*********************************************************************** 13748000
         SPACE 2                                                        13749000
COLLECT  EQU   *                                                        13750000
         TEXT  COLPME                   GO IF PREMATURE END OF OPERAND  13751000
         GOIF  D0(R10),JEQUAL,EQ=LIT100 IS OPERAND A LITERAL            13752000
         GOIF  D0(R10),JCOMMA,NE=CONTIN CONTINUE IF NOT COMMA           13753000
         X5ERRL 210,CLMPTR,COLFAT       OPERAND MISSING                 13754000
         SPACE                                                          13755000
CONTIN   JCALL X5V                      EVALUATE EXPRESSION 1           13756000
         ST    R14,ERRPTR               SAVE COLUMN PTR FOR LOGGING     13757000
         BC    ERRX,COLFAT              GO IF FATAL EVALUATION ERROR    13758000
         BC    CMPX,COLCMP              GO IF NONFATAL ERROR            13759000
         LR    &ESD1,R10                SET ESDID OF EXPR 1             13760000
         LR    &EXP1,R11                SET VALUE OF EXPR1              13761000
         MVC   LQ1,IMPLNG               ... AND LENGTH ATTRIBUTE        13762000
         SPACE                                                          13763000
COLCLP   LR    &TCP,R14                 RECOVER TEXT POINTER FROM X5V   13764000
         TEXT  COLOUT,LPAREN,COLOUT     GO TO COLOUT IF END OF OPERAND *13765000
                                        LIST OR NOT LEFT PAREN          13766000
         TEXT  COLPME,COMMA,COLEE2      GO TO COLPME IF END OF OPERAND,*13767000
                                        TO COLEE2 IF NOT COMMA          13768000
         TM    FMT,FIALOC               IS EXP2 ALLOWED                 13769000
         TM    FMT,FIALOC               IS THERE AN I PART              13770000
         BZ    IPROC1                   NO, LOG AN ERROR                13771000
         TM    FMT,FSALOC               IS THERE AN S PART              13772000
         BZ    IPROC1                   NO, LOG AN ERROR                13773000
         SPACE                                                          13774000
COLEE3   JCALL X5V                      EVALUATE EXPRESSION 3           13775000
         ST    R14,ERRPTR               SAVE COLUMN PTR FOR LOGGING     13776000
         LR    &TCP,R14                 RECOVER TEXT POINTER FROM X5V   13777000
         BC    ERRX,COLFAT              GO IF FATAL EVALUATION ERROR    13778000
         BC    ABSX,COLE3A              GO IF EXP3 ABSOLUTE             13779000
         SET   E3ERR,ON                 NOT ABSOLUTE - SET ERROR FLAG   13780000
         B     COLE3P                                                   13781000
         SPACE                                                          13782000
COLE3A   ST    R11,EXP3                 SET EXP3 VALUE                  13783000
COLE3P   SET   E3PR,ON                  SET EXP3 PRESENT                13784000
COLCRP   TEXT  COLPME,RPAREN,COLRPE     GO TO COLPME IF END OF OPERAND,*13785000
                                        TO COLRPE IF NOT RIGHT PAREN    13786000
         TM    FMT,FSALOC               IS THERE AN S PART              13787000
         BZ    IPROC1                   NO, LOG AN ERROR                13788000
         GOIF  E3PR,OFF=COLOUT          IF ONLY EXP2, EXIT              13789000
         TM    FMT,FIALOC               IS THERE AN I PART              13790000
         BZ    IPROC1                   NO, LOG AN ERROR                13791000
COLOUT   GOIF  TOOMANY,ON=DRIVER        GO IF THIS IS ONE OF TOO MANY   13792000
         TM    FMT,FSALOC               ANY S PART                      13793000
         BZ    IPROC                    NO                              13794000
         TM    FMT,FIALOC               ANY I PART                      13795000
         BZ    SPROC                    NO                              13796000
         GOIF  FILEN,OFF=SXPROC         GO IF SX OPERAND                13797000
         B     SLPROC                   GO PROCESS SL OPERAND           13798000
COLPME   X5ERRL 212,CLMPTR              PREMATURE END OF OPERAND        13799000
COLFAT   SET   LEAVE,ON                 FATAL ERROR - DONT COLLECT MORE 13800000
         B     COLOUT                   TRY WITH WHAT YOU GOT           13801000
         SPACE                                                          13802000
COLCMP   EQU   *                   EXP1 COMPLEXLY RELOCATABLE,OR WHAT ? 13803000
         SET   ZAPIT,ON                 SET TO ZERO LEFT HALF           13804000
         GOIF  COMPLEX,NE=COLCLP        IF NOT COMPLEX,NON-SYNTATIC     13805000
         SET   E1ERR,ON                 SET EXPRESSION 1 ERROR          13806000
         X5ERRL 213,CLMPTR,COLCLP       COMPLEXLY RELOCATABLE           13807000
         SPACE                                                          13808000
COLLIT   GOIF  FSNLIT,OFF=COLOUT        GO IF LITERAL ALLOWED           13809000
         SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13810000
         X5ERRL 214,CLMPTR,COLOUT       ILLEGAL LITERAL USAGE           13811000
         SPACE                                                          13812000
COLEE2   JCALL X5V                      EVALUATE EXPRESSION 2           13813000
         ST    R14,ERRPTR               SAVE COLUMN PTR FOR LOGGING     13814000
         LR    &TCP,R14                 RECOVER TEXT POINTER FROM X5V   13815000
         BC    ERRX,COLFAT              GO IF FATAL EVALUATION ERROR    13816000
         BC    ABSX,COLE2A              GO IF EXP2 ABSOLUTE             13817000
         SET   E2ERR,ON                 NOT ABSOLUTE - SET ERROR FLAG   13818000
         B     COLE2P                                                   13819000
         SPACE                                                          13820000
COLE2A   ST    R11,EXP2                 SET EXP2 VALUE                  13821000
COLE2P   SET   E2PR,ON                  SET EXP2 PRESENT                13822000
         TEXT  COLPME,COMMA,COLCRP      GO TO COLPME IF END OF OPERAND,*13823000
                                        TO COLCRP IF NOT COMMA          13824000
         B     COLEE3                   GO HANDLE EXP3                  13825000
         SPACE                                                          13826000
COLRPE   X5ERRL 215,CLMPTR,COLFAT       RIGHT PAREN EXPECTED            13827000
         EJECT                                                          13828000
*********************************************************************** 13829000
* IPROC                                                               * 13830000
*   FUNCTION                                                          * 13831000
*    -PROCESS I TYPE OPERAND                                          * 13832000
*    -DIAGNOSE THE FOLLOWING ERRORS-                                  * 13833000
*      ERROR                                 ACTION                   * 13834000
*      -----                                 ------                   * 13835000
*      ILLEGAL FORMAT FOR I OPERAND          SET TO ZERO              * 13836000
*      OPERAND IS RELOCATABLE                SET TO ZERO              * 13837000
*      FIELD OVERFLOW                        TRUNCATED                * 13838000
*      BOUND EXCEEDED                        -                        * 13839000
*      DIVISIBILITY ERROR                    -                        * 13840000
*********************************************************************** 13841000
         SPACE                                                          13842000
IPROC    GOIF  (E2PR,E3PR),OFF=IPRNFE   GO IF NEITHER EXP2 NOR EXP3 PR  13843000
         SPACE                                                          13844000
IPROC1   X5ERRL 216,CLMPTR,DRIVERZ      ILLEGAL FORMAT                  13845000
IPRNFE   GOIF  E1ERR,ON=DRIVER          GO IF COMPLEXLY RELOCATABLE     13846000
         LTR   &ESD1,&ESD1              IS IT ABSOLUTE                  13847000
         BZ    IPRABS                   YES                             13848000
         X5ERRL 217,CLMPTR,DRIVERZ      I OPERAND RELOCATABLE           13849000
IPRABS   JCALL CDIV,BASE=NO             CHECK DIVISIBILITY              13850000
         BNZ   IPRBER                   NOT OK, GO LOG ERROR            13851000
         ST    &EXP1,EXP2               SET PARAMETER FOR IASGN         13852000
         JCALL IASGN,BASE=NO            ASSIGN AND CHECK FOR(FIELD)SIZE 13853000
         BL    IPRBND                   GO IF OK                        13854000
         GOIF  RIDEC,ON=IPRDEC          SHOULD IT BE DEC DIGIT ?        13855000
         X5ERRL 219,CLMPTR,DRIVERZ      FIELD OVERFLOW                  13856000
IPRBND   TM    RIST,RIBND+RIDEC         ANY BOUND REQUIREMENT           13857000
         BZ    DRIVER                   NO                              13858000
         GOIF  RIDEC,ON=IPRDEC          GO IF IT SHOULD BE DEC DIGIT    13859000
         SR    R2,R2                    ZERO REGISTER                   13860000
         MVC   DWORD1(L'RIST),RIST      GET RESTRICTION BYTE            13861000
         NI    DWORD1,RIBND             STRIP OFF NON-BOUND BITS        13862000
         IC    R2,DWORD1                GET BOUND BITS                  13863000
         SRL   R2,4                     SHIFT TO LOWER HALF BYTE        13864000
         STC   R2,DWORD1                RESTORE BOUND BITS              13865000
         TRT   DWORD1(L'RIST),IPRTAB    GET TEST BITS IN REG 2          13866000
         LCR   R2,R2                    COMPLEMENT                      13867000
         NR    R2,&EXP1                 RESULT SHOULD BE ZERO           13868000
         BZ    DRIVER                   IT IS                           13869000
IPRBER   X5ERRL 218,0,DRIVERZ           INVALID REGISTER SPECIFICATION  13870000
IPRDEC   C     &EXP1,=F'10'             IS IT A DECIMAL DIGIT           13871000
         BNL   DECERR                   ERROR IF GE THAN 10             13872000
         LTR   R4,R4                    IS IT NEGATIVE                  13873000
         BNM   DRIVER                   OK IF NOT NEGATIVE              13874000
DECERR   X5ERRL 162,CLMPTR,DRIVERZ      DECIMAL DIGIT ERROR             13875000
         SPACE                                                          13876000
IPRTAB   DC    AL1(0,2,4,8)             TABLE OF TEST BITS              13877000
         EJECT                                                          13878000
*********************************************************************** 13879000
* SPROC                                                               * 13880000
*   FUNCTION                                                          * 13881000
*    -REFORMAT THE DATA COLLECTED FOR SPART INPUT                     * 13882000
*    -DIAGNOSE THE FOLLOWING ERRORS-                                  * 13883000
*      ERROR                                 ACTION                   * 13884000
*      -----                                 ------                   * 13885000
*      NO INDEX OR LENGTH FIELD EXPECTED     -                        * 13886000
*********************************************************************** 13887000
         SPACE                                                          13888000
SPROC    GOIF  E3PR,ON=SPRSE3           GO IF EXP3 PRESENT              13889000
         GOIF  E2PR,OFF=SPART           GO IF NO EXP2 PRESENT           13890000
         SET   E3PR,ON                  PRETEND EXP3 IS EXP2            13891000
         MVC   EXP3,EXP2                ---                             13892000
         GOIF  E2ERR,ON=SPRE2R          GO IF REL BASE                  13893000
SPRFG2   SET   E2PR,OFF                 FORGET EXP2                     13894000
         B     SPART                                                    13895000
SPRSE3   GOIF  E2PR,OFF=SPART           DONT MENTION IF EXP2 NOT THERE  13896000
         SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13897000
         X5ERRL 221,CLMPTR,SPRFG2       ILLEGAL LENGTH OR INDEX         13898000
SPRE2R   SET   E3ERR,ON                 EXP2 WAS EXP3,WASN'T IT ?       13899000
         B     SPART                                                    13900000
         EJECT                                                          13901000
*********************************************************************** 13902000
* SXPROC                                                              * 13903000
*   FUNCTION                                                          * 13904000
*    -PROCESS INDEX FIELD IN SX OPERAND                               * 13905000
*    -DIAGNOSE THE FOLLOWING ERRORS-                                  * 13906000
*      ERROR                                 ACTION                   * 13907000
*      -----                                 ------                   * 13908000
*      INDEX NOT ABSOLUTE                    SET TO ZERO              * 13909000
*      INDEX FIELD OVERFLOW                  TRUNCATED                * 13910000
*********************************************************************** 13911000
SXPROC   EQU   *                                                        13912000
         GOIF  E2PR,OFF=SPART           GO IF INDEX NOT EXPLICIT        13913000
         GOIF  E2ERR,ON=SXPXNA          GO IF INDEX NOT ABSOLUTE        13914000
         OC    EXP2,EXP2                IS INDEX ZERO ?                 13915000
         BZ    SPART                    YES,IGNORE IT                   13916000
         JCALL IASGN,BASE=NO            MOVE INDEX TO OBJECT CODE       13917000
         BL    SPARTX                   GO IF NO OVERFLOW               13918000
         X5ERRL 222,CLMPTR,SPARTXZ      INVALID INDEX                   13919000
         SPACE                                                          13920000
SXPXNA   X5ERRL 223,CLMPTR,SPARTXZ      RELOCATABLE INDEX               13921000
         EJECT                                                          13922000
*********************************************************************** 13923000
* SLPROC                                                              * 13924000
*   FUNCTION                                                          * 13925000
*    -PROCESS LENGTH FIELD IN SL OPERAND                              * 13926000
*    -DIAGNOSE THE FOLLOWING ERRORS-                                  * 13927000
*      ERROR                                 ACTION                   * 13928000
*      -----                                 ------                   * 13929000
*      LENGTH NOT ABSOLUTE                   IMPLIED LENGTH USED      * 13930000
*      LENGTH FIELD OVERFLOW                 TRUNCATED                * 13931000
*********************************************************************** 13932000
         SPACE 2                                                        13933000
SLPROC   EQU   *                                                        13934000
         GOIF  E2PR,ON=SLPLE2           GO IF EXPLICIT LENGTH           13935000
         LH    &SCR,LQ1                 GET IMPLIED LENGTH              13936000
         SPACE                                                          13937000
SLPLS1   LTR   &SCR,&SCR                IS IT ZERO ?                    13938000
         BZ    SPART                    YES                             13939000
         BCTR  &SCR,0                   SUBTRACT 1 FROM LENGTH          13940000
         ST    &SCR,EXP2                STORE MOVE LENGTH IN EXP2       13941000
         JCALL IASGN,BASE=NO            MOVE LENGTH TO OBJECT CODE      13942000
         BL    SPART                    GO IF NOT TOO BIG               13943000
         X5ERRL 224,CLMPTR,SLPROCZ      LENGTH ERROR                    13944000
         SPACE                                                          13945000
SLPLE2   GOIF  E2ERR,ON=SLPELR          GO IF LENGTH ERROR              13946000
         L     &SCR,EXP2                GET EXPLICIT LENGTH             13947000
         B     SLPLS1                                                   13948000
SLPELR   X5ERRL 225,CLMPTR              RELOCATABLE LENGTH              13949000
         SPACE                                                          13950000
SLPROCZ  SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13951000
         EJECT                                                          13952000
*********************************************************************** 13953000
* SPART                                                               * 13954000
* FUNCTION                                                            * 13955000
*  -PROCESS S PART OF STORAGE OPERAND                                 * 13956000
*  -DECOMPOSE IMPLICIT VALUES INTO BASE-DISPLACEMENT                  * 13957000
*  -DIAGNOSE THE FOLLOWING ERRORS-                                    * 13958000
*    ERROR                                   ACTION                   * 13959000
*    -----                                   ------                   * 13960000
*    RELOCATABLE DISPLACEMENT                SET TO ZERO              * 13961000
*    BASE NOT ABSOLUTE                       SET TO ZERO              * 13962000
*    ADDRESSABILITY ERROR                    BASE,DISP SET TO ZERO    * 13963000
*    BASE REG FIELD OVERFLOW                 TRUNCATED                * 13964000
*    DISPLACEMENT FIELD OVERFLOW                                      * 13965000
*    (IE,DISP NOT IN RANGE -4096 TO 4095)    TRUNCATED                * 13966000
*    ALIGNMENT ERROR                         -                        * 13967000
*    REENTERABILITY ERROR                    -                        * 13968000
* ENTRY POINTS - SPART,SPARTX                                         * 13969000
*********************************************************************** 13970000
         SPACE                                                          13971000
* CHECK ALIGNMENT                                                       13972000
         SPACE                                                          13973000
SPART    GOIF  E3PR,OFF=SPALG1          GO IF NO EXPLICIT BASE          13974000
         OC    EXP3,EXP3                IS BASE ZERO                    13975000
         BNZ   SPARTX                   NO                              13976000
         SPACE                                                          13977000
SPALG1   GOIF  RSALW,ON=SPALGN          GO IF ALGN ALWAYS TO BE CHECKED 13978000
         GOIF  JALGN,OFF=SPARTX         GO IF NOALGN OPTION             13979000
SPALGN   JCALL CDIV,BASE=NO             CHECK ALIGNMENT                 13980000
         BZ    SPARTX                   GO IF OK                        13981000
         X5ERRL 220,CLMPTR,SPARTX       ALIGNMENT ERROR                 13982000
         SPACE                                                          13983000
SPARTXZ  SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13984000
         SPACE                                                          13985000
SPARTX   GOIF  E3PR,OFF=SPAHK1          GO IF NO EXPLICIT BASE          13986000
         GOIF  E3ERR,OFF=SPAEA1         GO IF BASE OK                   13987000
         X5ERRL 226,CLMPTR              BASE NOT ABSOLUTE               13988000
         SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            13989000
SPAEA1   LTR   &ESD1,&ESD1              IS EXP1 ABSOLUTE                13990000
         BNZ   SPARDP                   NO - RELOCATABLE DISPLACEMENT   13991000
         SPACE                                                          13992000
SPAHKD   STH   &EXP1,DISPL              SAVE DISPLACEMENT               13993000
         CL    &EXP1,=F'4096'           IS IT LT 4096                   13994000
         BL    SPASGN                   NO,ERROR                        13995000
         X5ERRL  208,0,SPASGNZ          DISPLACEMENT TOO LARGE          13996000
         SPACE                                                          13997000
SPARDP   X5ERRL 228,CLMPTR,SPASGNZ      RELOCATABLE DISPLACEMENT        13998000
SPAHK1   GOIF  E1ERR,ON=DRIVER          GO IF EXP1 COMPL RELOCATABLE    13999000
         LTR   &ESD1,&ESD1              IS EXP1 ABSOLUTE                14000000
         BNZ   SPAREL                   NO                              14001000
         GOIF  ABSUS,OFF=SPAHKD         GO IF NO ABS USING IS CURRENT   14002000
         SPACE                                                          14003000
* ATTEMPT DECOMPOSITION                                                 14004000
         SPACE                                                          14005000
SPADEC   LA    &SCH,USINGT              GET USING TABLE ADDRESS         14006000
         USING UESD,&SCH                USE THE USING USING             14007000
         SPACE                                                          14008000
SPATRY   CH    &ESD1,UESD               IS IT SAME ESDID                14009000
         BH    SPAAER                   ADDR ERROR IF HIGH              14010000
         BE    SPAMBS                   EQUAL - MAYBE SUCCESS           14011000
SPAPNE   LA    &SCH,USNXT               POINT TO NEXT ENTRY             14012000
         B     SPATRY                   GO TRY IT                       14013000
SPAMBS   LTR   &ESD1,&ESD1              IS IT ABSOLUTE                  14014000
         BZ    SPAABS                   YES                             14015000
         SPACE                                                          14016000
SPAG1V   LR    &SCR,&EXP1               GET EXP1 VALUE                  14017000
         S     &SCR,UVAL                GET TENTATIVE DISPLACEMENT      14018000
         BM    SPAPNE                   NEG DISP NOT VALID HERE         14019000
         C     &SCR,=F'4096'            IS IT LT 4096                   14020000
         BNL   SPAPNE         *         NO - TRY NEXT (IT WILL FAIL)    14021000
         STH   &SCR,DISPL               SAVE DISPLACEMENT               14022000
         LH    &SCR,UREG      *         GET USING REG                   14023000
         ST    &SCR,EXP3                SAVE IT                         14024000
         B     SPASGN                                                   14025000
SPAABS   CLI   UREG+1,X'00'             REG 0 (END OF TABLE)   @AZ07389 14026000
         BNZ   SPAG1V                   NO                              14027000
         B     SPAHKD                   YES - CHECK DISPLACEMENT        14028000
         SPACE                                                          14029000
SPAREL   GOIF  JRENT,OFF=SPADEC         GO IF NORENT OPTION             14030000
         GOIF  RSMOD,OFF=SPADEC         GO IF OPERAND NOT STORED INTO   14031000
         STH   &ESD1,JHWORD1            TEST FOR OPERAND-      @OY09690 14032000
         TM    JHWORD1,X'50'            IN DSECT OR Q-CONST    @OY09690 14033000
         BM    SPADEC                   BR IF SO.              @OY09690 14034000
         X5ERRL 229,CLMPTR,SPADEC       REENTERABILITY ERROR            14035000
SPAAER   X5ERRL 209,CLMPTR,DRIVERZ      ADDRESSABILITY ERROR            14036000
         SPACE                                                          14037000
SPASGNZ  SET   ZAPIT,ON                 SET TO ZERO LEFTHALF            14038000
         SPACE                                                          14039000
SPASGN   PACK  SALOC,FMT                GET ZERO+GARBAGE+S PART ALLOC   14040000
         NI    SALOC+D1,FSALOC/D16      STRIP OFF GARBAGE               14041000
         LH    &SCH,SALOC               HALFWORD NUMBER INTO REG        14042000
         SLL   &SCH,D2                  MULTIPLY BY 4                   14043000
         ST    &EXP1,ADDRS1-D4(&SCH)    STORE INTO ADDR1 OR -2          14044000
         SRL   &SCH,D1                  DIVIDE OFFSET BY 2              14045000
         LA    &SCH,LHOPCD(&SCH)        SCH NOW CONTAINS TARGET ADDRESS 14046000
         MVC   D0(L'DISPL,&SCH),DISPL   MOVE DISPL TO INSTRUCTION       14047000
         MVO   D0(L'BASEX,&SCH),BASEX   MOVE BASE                       14048000
         CLC   EXP3,=F'16'    *         IS BASE REG LT 16               14049000
         BL    DRIVER                   YES                             14050000
         X5ERRL 230,CLMPTR,DRIVERZ      BASE REGISTER TOO LARGE         14051000
         EJECT                                                          14052000
* CDIV                                                                  14053000
*                                                                       14054000
*   CHECK DIVISIBILITY (FOR PURE I OPERANDS) AND ALIGNMENT ( FOR        14055000
*   OPERANDS WITH S PART).RETURN WITH CC=0 IF OK.REG 2 IS DESTROYED.    14056000
*                                                                       14057000
         SPACE                                                          14058000
CDIV     TM    RIST,RIDIV               ANY DIVISIBILITY REQUIRED ?     14059000
         BZR   &RTN                     NO - RETURN WITH CC 0.          14060000
         MVC   DWORD1(L'RIST),RIST      GET RESTRICTION FIELD           14061000
         NI    DWORD1,RIDIV             STRIP OFF ALL BUT DIV BITS      14062000
         SR    R2,R2                    CLEAR                           14063000
         TRT   DWORD1(L'RIST),CDVTAB    GET TEST BITS IN REG 2          14064000
         NR    R2,&EXP1                 RESULT SHOULD BE ZERO           14065000
         BR    &RTN                     RETURN                          14066000
CDVTAB   DC    AL1(0,1,3,7)             TABLE TO GET TEST BITS          14067000
         EJECT                                                          14068000
* IASGN                                                                 14069000
*                                                                       14070000
*   MOVE I PART VALUE TO INSTRUCTION.SET CC=1 IF NO FIELD OVERFLOW.     14071000
*                                                                       14072000
         SPACE                                                          14073000
IASGN    TM    FMT,FIALOC               IS IT 4-BIT OR 8-BIT FIELD      14074000
         BM    IAS4BT                   4-BIT IF MIXED                  14075000
         MVC   LHIMD,I                  MOVE TO INSTRUCTION             14076000
         CLC   EXP2,=F'256'             SET CONDITION CODE              14077000
         BR    &RTN                                                     14078000
         SPACE                                                          14079000
IAS4BT   GOIF  FIAL1,ON=IASRRECK        GO IF FIELD IN 1ST HALFFX0000   14080000
         CLC   LHOPCD,ISERVC            IS THIS A NEW RRE INST FX0000   14081000
         BL    IASSHB                   LESS THAN NEW          FX0000   14082000
         CLC   LHOPCD,IPGOUT            NEW RANGE IS 20-2F     FX0000   14083000
         BNH   IASRRESH                 NEW XA OP, CONTINUE    FX0000   14084000
         SPACE ,                                               FX0000   14085000
IASSHB   DS    0H                                              FX0000   14086000
         MVN   LHIMD,I                  MOVE TO 2ND HALF-BYTE  FX0000   14087000
         B     IAS4BR                   GO SET CC              FX0000   14088000
         SPACE ,                                               FX0000   14089000
IASRRECK DS    0H                                              FX0000   14090000
         CLC   LHOPCD,ISERVC            IS THIS A NEW RRE INST FX0000   14091000
         BL    IASFHB                   LESS THAN NEW          FX0000   14092000
         CLC   LHOPCD,IPGOUT            NEW RANGE IS 20-2F     FX0000   14093000
         BNH   IASRREFH                 NEW XA OP, CONTINUE    FX0000   14094000
         SPACE ,                                               FX0000   14095000
IASFHB   DS    0H                                              FX0000   14096000
         MVO   LHIMD,I                  MOVE TO 1ST HALF-BYTE  FX0000   14097000
         SPACE ,                                               FX0000   14098000
IAS4BR   CLC   EXP2,=F'16'              SET CONDITION CODE     FX0000   14099000
         BR    &RTN                     RETURN                 FX0000   14100000
         SPACE ,                                               FX0000   14101000
IASRRESH DS    0H                                              FX0000   14102000
         MVN   RREREGS,I                MOVE TO 2ND HALF-BYTE  FX0000   14103000
         B     IAS4BR                   GO SET CC                       14104000
         SPACE ,                                               FX0000   14105000
IASRREFH DS    0H                                              FX0000   14106000
         MVO   RREREGS,I                MOVE TO 1ST HALF-BYTE  FX0000   14107000
         B     IAS4BR                   GO SET CC              FX0000   14108000
         SPACE ,                                               FX0000   14109000
ISERVC   DC    X'B220'                                         FX0000   14110000
IPGOUT   DC    X'B22F'                                         FX0000   14111000
         EJECT                                                          14112000
*********************************************************************** 14113000
*  LITERAL OPERAND PROCESSING                                         * 14114000
*********************************************************************** 14115000
LIT100   LR    R6,R10                   SAVE TEXT POINTER               14116000
         ST    R6,ERRPTR                SAVE COLUMN PTR FOR LOGGING     14117000
         CLI   D1(R10),JBLANK           CAN'T HAVE A BLANK FOLLOWING    14118000
         BE    LIT140                   OR IT'S CURTAINS FOR THIS GUY   14119000
         LH    R10,JINFILE              POINT TO INPUT FILE             14120000
         JGETL FILE=(R10)               GET LITERAL REFERENCE           14121000
         L     R9,SYMXRF                GET SYMBOL XREFED       OX02675 14122000
         LA    R9,D1(R9)                INCREMENT 1                     14123000
         ST    R9,SYMXRF                STORE BACK              OX02675 14124000
         CLI   D4(R11),JTLITII          IS IT LITERAL REFERENCE REC     14125000
         BE    LIT125                   BRANCH AROUND IF YES            14126000
         SPACE                                                          14127000
         X5ERRL 167,0,CLOSEZ            SYMBOL FILE OUT OF PHASE        14128000
         SPACE                                                          14129000
LIT125   LH    R10,D6(R11)              GET LITERAL ESDID               14130000
         LTR   R10,R10                  IS IT ZERO?                     14131000
         BNZ   LIT150                   INVALID LITERAL IF YES          14132000
         SPACE                                                          14133000
LIT140   X5ERRL 161,CLMPTR,CLOSEZ       INVALID LITERAL                 14134000
         SPACE                                                          14135000
LIT150   MVC   LCTRSAV(4),D8(R11)       SAVE LITERAL LOCTR              14136000
         MVC   LCTRSAV+D4(2),D6(R11)    SAVE LITERAL ESDID              14137000
         SR    R2,R2                    CLEAR REGISTER                  14138000
         IC    R2,D2(R11)               GET LENGTH ATTRIBUTE            14139000
         LA    R2,D1(R2)                INCREMENT 1                     14140000
         STH   R2,LQ1                   SAVE IT                         14141000
         SR    R2,R2                    CLEAR REGISTER         @AX13632 14142000
         IC    R2,D5(R11)               GET LITERAL LENGTH              14143000
         LA    R2,D1(R2,R6)             POINT AFTER LITERAL             14144000
         ST    R2,LHSAVE                SAVE IT                         14145000
         SR    R2,R2                    CLEAR REGISTER                  14146000
         IC    R2,D3(R11)               GET SYMBOL COUNT                14147000
         LTR   R2,R2                    IS IT ZERO?                     14148000
         BZ    LIT175                   BRANCH IF YES                   14149000
         L     R9,SYMXRF                GET SYMBOLS XREFED      OX02675 14150000
         AR    R9,R2                    INCREMENT BY NO. OF SYMBOLS     14151000
         ST    R9,SYMXRF                STOR BACK               OX02675 14152000
LIT165   LH    R10,JINFILE              GET INPUT FILE INDEX            14153000
         JGETL FILE=(R10)               GET SYMBOL RECORD               14154000
         BCT   R2,LIT165                GO BACK IF MORE                 14155000
         SPACE                                                          14156000
LIT175   GOIF  (JXREF,JLIST),NOTALL=LIT200 NEED TO XREF?                14157000
         LH    R10,JOUTFILE             GET OUTPUT FILE NUMBER          14158000
         JPUTL FILE=(R10),BUFREQ=D18    LOCATE NEXT BUFFER              14159000
         MVC   XRFIN(6),=AL2(17,0,JY*256)  XREF RECORD HEADER           14160000
         MVC   LITLOCTR(4),LCTRSAV      PUT IN LITERAL LOCTR            14161000
         MVC   LITESDID(2),LCTRSAV+4    PUT IN LITERAL ESDID            14162000
         LH    R6,LITPID                GET POOL ID                     14163000
         LA    R6,1(R6)                 ADD 1                           14164000
         SLL   R6,8                     PUT POOL ID IN THE RIGHT PLACE  14165000
         STH   R6,LITPOLID              PUT POOLID IN RECORD            14166000
         MVI   XRFFLG,REF               INDICATE A REFERENCE            14167000
         MVC   XRFSTM,STMTN+D2          MOVE IN STATEMENT NUMBER        14168000
LIT200   EQU   *                                                        14169000
         L     R10,LHSAVE               RESTORE OPERAND POINTER         14170000
         LH    R6,LCTRSAV+4             PUT IN LITERAL ESDID            14171000
         L     R4,LCTRSAV               PUT IN LITERAL LOCTR            14172000
         B     COLLIT                   GO COLLECT OPERAND              14173000
         EJECT                                                          14174000
*********************************************************************** 14175000
* FAR TABLE                                                           * 14176000
*   THE FUNCTION OF THIS TABLE IS DESCRIBED IN THE MODULE PROLOGUE.   * 14177000
*   THE TABLE,AS WELL AS THE FGT AND FGTX TABLES ARE GENERATED BY     * 14178000
*   FOUR MACROS - MITAB (GLOBAL INITIALIZATION),OPND (DESCRIBE AN     * 14179000
*   OPERAND),OPCD (GIVE INSTRUCTION OPCODE) AND MIEND (WRAP-UP,GENE-  * 14180000
*   RATE FGT AND FGTX TABLES).                                        * 14181000
*    EACH MACHINE INSTRUCTION IS DESCRIBED BY ONE OPND INSTRUCTION    * 14182000
*   PER OPERAND,FOLLOWED BY AN OPCD INSTRUCTION.                      * 14183000
*   NOTE MACHINE INSTRUCTIONS WITH EXTENDED OPCODE MUST BE ENTERED    * 14184000
*   IN ASCENDING SEQUENCE ON THE OPCODE.                              * 14185000
*********************************************************************** 14186000
         SPACE 2                                                        14187000
FAR      MITAB ,                        SET GLOBALS FOR FAR MACROS      14188000
SPM      OPND  R,1                                                      14189000
         OPCD  X'04'                                                    14190000
BALR     OPND  R,1                                                      14191000
         OPND  R,2                                                      14192000
         OPCD  X'05'                                                    14193000
BCTR     OPND  R,1                                                      14194000
         OPND  R,2                                                      14195000
         OPCD  X'06'                                                    14196000
BCR      OPND  I,1                                                      14197000
         OPND  R,2                                                      14198000
         OPCD  X'07'                                                    14199000
SSK      OPND  R,1                                                      14200000
         OPND  R,2                                                      14201000
         OPCD  X'08'                                                    14202000
ISK      OPND  R,1                                                      14203000
         OPND  R,2                                                      14204000
         OPCD  X'09'                                                    14205000
SVC      OPND  I,3                      I FIELD IS IN WHOLE I BYTE      14206000
         OPCD  X'0A'                                                    14207000
MVCL     OPND  R,1,1                    EVEN REGS                       14208000
         OPND  R,2,1                                                    14209000
         OPCD  X'0E'                                                    14210000
CLCL     OPND  R,1,1                                                    14211000
         OPND  R,2,1                                                    14212000
         OPCD  X'0F'                                                    14213000
LPR      OPND  R,1                                                      14214000
         OPND  R,2                                                      14215000
         OPCD  X'10'                                                    14216000
LNR      OPND  R,1                                                      14217000
         OPND  R,2                                                      14218000
         OPCD  X'11'                                                    14219000
LTR      OPND  R,1                                                      14220000
         OPND  R,2                                                      14221000
         OPCD  X'12'                                                    14222000
LCR      OPND  R,1                                                      14223000
         OPND  R,2                                                      14224000
         OPCD  X'13'                                                    14225000
NR       OPND  R,1                                                      14226000
         OPND  R,2                                                      14227000
         OPCD  X'14'                                                    14228000
CLR      OPND  R,1                                                      14229000
         OPND  R,2                                                      14230000
         OPCD  X'15'                                                    14231000
OR       OPND  R,1                                                      14232000
         OPND  R,2                                                      14233000
         OPCD  X'16'                                                    14234000
XR       OPND  R,1                                                      14235000
         OPND  R,2                                                      14236000
         OPCD  X'17'                                                    14237000
LR       OPND  R,1                                                      14238000
         OPND  R,2                                                      14239000
         OPCD  X'18'                                                    14240000
CR       OPND  R,1                                                      14241000
         OPND  R,2                                                      14242000
         OPCD  X'19'                                                    14243000
AR       OPND  R,1                                                      14244000
         OPND  R,2                                                      14245000
         OPCD  X'1A'                                                    14246000
SR       OPND  R,1                                                      14247000
         OPND  R,2                                                      14248000
         OPCD  X'1B'                                                    14249000
MR       OPND  R,1,1                                                    14250000
         OPND  R,2                                                      14251000
         OPCD  X'1C'                                                    14252000
DR       OPND  R,1,1                                                    14253000
         OPND  R,2                                                      14254000
         OPCD  X'1D'                                                    14255000
ALR      OPND  R,1                                                      14256000
         OPND  R,2                                                      14257000
         OPCD  X'1E'                                                    14258000
SLR      OPND  R,1                                                      14259000
         OPND  R,2                                                      14260000
         OPCD  X'1F'                                                    14261000
LPDR     OPND  R,1,(1,3)                                                14262000
         OPND  R,2,(1,3)                                                14263000
         OPCD  X'20'                                                    14264000
LNDR     OPND  R,1,(1,3)                                                14265000
         OPND  R,2,(1,3)                                                14266000
         OPCD  X'21'                                                    14267000
LTDR     OPND  R,1,(1,3)                                                14268000
         OPND  R,2,(1,3)                                                14269000
         OPCD  X'22'                                                    14270000
LCDR     OPND  R,1,(1,3)                                                14271000
         OPND  R,2,(1,3)                                                14272000
         OPCD  X'23'                                                    14273000
HDR      OPND  R,1,(1,3)                                                14274000
         OPND  R,2,(1,3)                                                14275000
         OPCD  X'24'                                                    14276000
LRDR     OPND  R,1,(1,3)                                                14277000
         OPND  R,2,(2,3)                                                14278000
         OPCD  X'25'                                                    14279000
MXR      OPND  R,1,(2,3)                                                14280000
         OPND  R,2,(2,3)                                                14281000
         OPCD  X'26'                                                    14282000
MXDR     OPND  R,1,(2,3)                                                14283000
         OPND  R,2,(1,3)                                                14284000
         OPCD  X'27'                                                    14285000
LDR      OPND  R,1,(1,3)                                                14286000
         OPND  R,2,(1,3)                                                14287000
         OPCD  X'28'                                                    14288000
CDR      OPND  R,1,(1,3)                                                14289000
         OPND  R,2,(1,3)                                                14290000
         OPCD  X'29'                                                    14291000
ADR      OPND  R,1,(1,3)                                                14292000
         OPND  R,2,(1,3)                                                14293000
         OPCD  X'2A'                                                    14294000
SDR      OPND  R,1,(1,3)                                                14295000
         OPND  R,2,(1,3)                                                14296000
         OPCD  X'2B'                                                    14297000
MDR      OPND  R,1,(1,3)                                                14298000
         OPND  R,2,(1,3)                                                14299000
         OPCD  X'2C'                                                    14300000
DDR      OPND  R,1,(1,3)                                                14301000
         OPND  R,2,(1,3)                                                14302000
         OPCD  X'2D'                                                    14303000
AWR      OPND  R,1,(1,3)                                                14304000
         OPND  R,2,(1,3)                                                14305000
         OPCD  X'2E'                                                    14306000
SWR      OPND  R,1,(1,3)                                                14307000
         OPND  R,2,(1,3)                                                14308000
         OPCD  X'2F'                                                    14309000
LPER     OPND  R,1,(1,3)                                                14310000
         OPND  R,2,(1,3)                                                14311000
         OPCD  X'30'                                                    14312000
LNER     OPND  R,1,(1,3)                                                14313000
         OPND  R,2,(1,3)                                                14314000
         OPCD  X'31'                                                    14315000
LTER     OPND  R,1,(1,3)                                                14316000
         OPND  R,2,(1,3)                                                14317000
         OPCD  X'32'                                                    14318000
LCER     OPND  R,1,(1,3)                                                14319000
         OPND  R,2,(1,3)                                                14320000
         OPCD  X'33'                                                    14321000
HER      OPND  R,1,(1,3)                                                14322000
         OPND  R,2,(1,3)                                                14323000
         OPCD  X'34'                                                    14324000
LRER     OPND  R,1,(1,3)                                                14325000
         OPND  R,2,(1,3)                                                14326000
         OPCD  X'35'                                                    14327000
AXR      OPND  R,1,(2,3)                                                14328000
         OPND  R,2,(2,3)                                                14329000
         OPCD  X'36'                                                    14330000
SXR      OPND  R,1,(2,3)                                                14331000
         OPND  R,2,(2,3)                                                14332000
         OPCD  X'37'                                                    14333000
LER      OPND  R,1,(1,3)                                                14334000
         OPND  R,2,(1,3)                                                14335000
         OPCD  X'38'                                                    14336000
CER      OPND  R,1,(1,3)                                                14337000
         OPND  R,2,(1,3)                                                14338000
         OPCD  X'39'                                                    14339000
AER      OPND  R,1,(1,3)                                                14340000
         OPND  R,2,(1,3)                                                14341000
         OPCD  X'3A'                                                    14342000
SER      OPND  R,1,(1,3)                                                14343000
         OPND  R,2,(1,3)                                                14344000
         OPCD  X'3B'                                                    14345000
MER      OPND  R,1,(1,3)                                                14346000
         OPND  R,2,(1,3)                                                14347000
         OPCD  X'3C'                                                    14348000
DER      OPND  R,1,(1,3)                                                14349000
         OPND  R,2,(1,3)                                                14350000
         OPCD  X'3D'                                                    14351000
AUR      OPND  R,1,(1,3)                                                14352000
         OPND  R,2,(1,3)                                                14353000
         OPCD  X'3E'                                                    14354000
SUR      OPND  R,1,(1,3)                                                14355000
         OPND  R,2,(1,3)                                                14356000
         OPCD  X'3F'                                                    14357000
NOPR     OPND  R,2                                                      14358000
         OPCD  X'0700'                                                  14359000
BOR      OPND  R,2                                                      14360000
         OPCD  X'0710'                                                  14361000
BHR      OPND  R,2                      BPR ALSO                        14362000
         OPCD  X'0720'                                                  14363000
BLR      OPND  R,2                      BMR ALSO                        14364000
         OPCD  X'0740'                                                  14365000
BNER     OPND  R,2                      BNZR ALSO                       14366000
         OPCD  X'0770'                                                  14367000
BER      OPND  R,2                      BZR ALSO                        14368000
         OPCD  X'0780'                                                  14369000
BNLR     OPND  R,2                      BNMR ALSO                       14370000
         OPCD  X'07B0'                                                  14371000
BNHR     OPND  R,2                      BNPR ALSO                       14372000
         OPCD  X'07D0'                                                  14373000
BNOR     OPND  R,2                                                      14374000
         OPCD  X'07E0'                                                  14375000
BR       OPND  R,2                                                      14376000
         OPCD  X'07F0'                                                  14377000
STH      OPND  R,1                                                      14378000
         OPND  SX,(1,2),(H,NLIT,MOD)                                    14379000
         OPCD  X'40'                                                    14380000
LA       OPND  R,1                                                      14381000
         OPND  SX,(1,2)                                                 14382000
         OPCD  X'41'                                                    14383000
STC      OPND  R,1                                                      14384000
         OPND  SX,(1,2),(NLIT,MOD)                                      14385000
         OPCD  X'42'                                                    14386000
IC       OPND  R,1                                                      14387000
         OPND  SX,(1,2)                                                 14388000
         OPCD  X'43'                                                    14389000
EX       OPND  R,1                                                      14390000
         OPND  SX,(1,2),(H,ALW)                                         14391000
         OPCD  X'44'                                                    14392000
BAL      OPND  R,1                                                      14393000
         OPND  SX,(1,2),(H,ALW)                                         14394000
         OPCD  X'45'                                                    14395000
BCT      OPND  R,1                                                      14396000
         OPND  SX,(1,2),(H,ALW)                                         14397000
         OPCD  X'46'                                                    14398000
BC       OPND  R,1                                                      14399000
         OPND  SX,(1,2),(H,ALW)                                         14400000
         OPCD  X'47'                                                    14401000
LH       OPND  R,1                                                      14402000
         OPND  SX,(1,2),H                                               14403000
         OPCD  X'48'                                                    14404000
CH       OPND  R,1                                                      14405000
         OPND  SX,(1,2),H                                               14406000
         OPCD  X'49'                                                    14407000
AH       OPND  R,1                                                      14408000
         OPND  SX,(1,2),H                                               14409000
         OPCD  X'4A'                                                    14410000
SH       OPND  R,1                                                      14411000
         OPND  SX,(1,2),H                                               14412000
         OPCD  X'4B'                                                    14413000
MH       OPND  R,1                                                      14414000
         OPND  SX,(1,2),H                                               14415000
         OPCD  X'4C'                                                    14416000
CVD      OPND  R,1                                                      14417000
         OPND  SX,(1,2),(D,NLIT,MOD)                                    14418000
         OPCD  X'4E'                                                    14419000
CVB      OPND  R,1                                                      14420000
         OPND  SX,(1,2),D                                               14421000
         OPCD  X'4F'                                                    14422000
ST       OPND  R,1                                                      14423000
         OPND  SX,(1,2),(F,NLIT,MOD)                                    14424000
         OPCD  X'50'                                                    14425000
N        OPND  R,1                                                      14426000
         OPND  SX,(1,2),F                                               14427000
         OPCD  X'54'                                                    14428000
CL       OPND  R,1                                                      14429000
         OPND  SX,(1,2),F                                               14430000
         OPCD  X'55'                                                    14431000
O        OPND  R,1                                                      14432000
         OPND  SX,(1,2),F                                               14433000
         OPCD  X'56'                                                    14434000
X        OPND  R,1                                                      14435000
         OPND  SX,(1,2),F                                               14436000
         OPCD  X'57'                                                    14437000
L        OPND  R,1                                                      14438000
         OPND  SX,(1,2),F                                               14439000
         OPCD  X'58'                                                    14440000
C        OPND  R,1                                                      14441000
         OPND  SX,(1,2),F                                               14442000
         OPCD  X'59'                                                    14443000
A        OPND  R,1                                                      14444000
         OPND  SX,(1,2),F                                               14445000
         OPCD  X'5A'                                                    14446000
S        OPND  R,1                                                      14447000
         OPND  SX,(1,2),F                                               14448000
         OPCD  X'5B'                                                    14449000
M        OPND  R,1,1                                                    14450000
         OPND  SX,(1,2),F                                               14451000
         OPCD  X'5C'                                                    14452000
D        OPND  R,1,1                                                    14453000
         OPND  SX,(1,2),F                                               14454000
         OPCD  X'5D'                                                    14455000
AL       OPND  R,1                                                      14456000
         OPND  SX,(1,2),F                                               14457000
         OPCD  X'5E'                                                    14458000
SL       OPND  R,1                                                      14459000
         OPND  SX,(1,2),F                                               14460000
         OPCD  X'5F'                                                    14461000
STD      OPND  R,1,(1,3)                                                14462000
         OPND  SX,(1,2),(D,NLIT,MOD)                                    14463000
         OPCD  X'60'                                                    14464000
MXD      OPND  R,1,(2,3)                                                14465000
         OPND  SX,(1,2),D                                               14466000
         OPCD  X'67'                                                    14467000
LD       OPND  R,1,(1,3)                                                14468000
         OPND  SX,(1,2),D                                               14469000
         OPCD  X'68'                                                    14470000
CD       OPND  R,1,(1,3)                                                14471000
         OPND  SX,(1,2),D                                               14472000
         OPCD  X'69'                                                    14473000
AD       OPND  R,1,(1,3)                                                14474000
         OPND  SX,(1,2),D                                               14475000
         OPCD  X'6A'                                                    14476000
SD       OPND  R,1,(1,3)                                                14477000
         OPND  SX,(1,2),D                                               14478000
         OPCD  X'6B'                                                    14479000
MD       OPND  R,1,(1,3)                                                14480000
         OPND  SX,(1,2),D                                               14481000
         OPCD  X'6C'                                                    14482000
DD       OPND  R,1,(1,3)                                                14483000
         OPND  SX,(1,2),D                                               14484000
         OPCD  X'6D'                                                    14485000
AW       OPND  R,1,(1,3)                                                14486000
         OPND  SX,(1,2),D                                               14487000
         OPCD  X'6E'                                                    14488000
SW       OPND  R,1,(1,3)                                                14489000
         OPND  SX,(1,2),D                                               14490000
         OPCD  X'6F'                                                    14491000
STE      OPND  R,1,(1,3)                                                14492000
         OPND  SX,(1,2),(F,NLIT,MOD)                                    14493000
         OPCD  X'70'                                                    14494000
LE       OPND  R,1,(1,3)                                                14495000
         OPND  SX,(1,2),F                                               14496000
         OPCD  X'78'                                                    14497000
CE       OPND  R,1,(1,3)                                                14498000
         OPND  SX,(1,2),F                                               14499000
         OPCD  X'79'                                                    14500000
AE       OPND  R,1,(1,3)                                                14501000
         OPND  SX,(1,2),F                                               14502000
         OPCD  X'7A'                                                    14503000
SE       OPND  R,1,(1,3)                                                14504000
         OPND  SX,(1,2),F                                               14505000
         OPCD  X'7B'                                                    14506000
ME       OPND  R,1,(1,3)                                                14507000
         OPND  SX,(1,2),F                                               14508000
         OPCD  X'7C'                                                    14509000
DE       OPND  R,1,(1,3)                                                14510000
         OPND  SX,(1,2),F                                               14511000
         OPCD  X'7D'                                                    14512000
AU       OPND  R,1,(1,3)                                                14513000
         OPND  SX,(1,2),F                                               14514000
         OPCD  X'7E'                                                    14515000
SU       OPND  R,1,(1,3)                                                14516000
         OPND  SX,(1,2),F                                               14517000
         OPCD  X'7F'                                                    14518000
NOP      OPND  SX,(1,2),(H,ALW)         NOP OPERAND                     14519000
         OPCD  X'4700'                  NOP OP CODE                     14520000
BO       OPND  SX,(1,2),(H,ALW)                                         14521000
         OPCD  X'4710'                                                  14522000
BH       OPND  SX,(1,2),(H,ALW)    BP ALSO                              14523000
         OPCD  X'4720'                                                  14524000
BL       OPND  SX,(1,2),(H,ALW)    BM ALSO                              14525000
         OPCD  X'4740'                                                  14526000
BNE      OPND  SX,(1,2),(H,ALW)                                         14527000
         OPCD  X'4770'                                                  14528000
BE       OPND  SX,(1,2),(H,ALW)                                         14529000
         OPCD  X'4780'                                                  14530000
BNL      OPND  SX,(1,2),(H,ALW)    BNM ALSO                             14531000
         OPCD  X'47B0'                                                  14532000
BNH      OPND  SX,(1,2),(H,ALW)    BNP ALSO                             14533000
         OPCD  X'47D0'                                                  14534000
BNO      OPND  SX,(1,2),(H,ALW)                                         14535000
         OPCD  X'47E0'                                                  14536000
B        OPND  SX,(1,2),(H,ALW)                                         14537000
         OPCD  X'47F0'                                                  14538000
SSM      OPND  S,1                                                      14539000
         OPCD  X'80'                                                    14540000
LPSW     OPND  S,1,(D,ALW)                                              14541000
         OPCD  X'82'                                                    14542000
WRD      OPND  S,1                                                      14543000
         OPND  I,3                                                      14544000
         OPCD  X'84'                                                    14545000
RDD      OPND  S,1,(MOD,NLIT)                                           14546000
         OPND  I,3                                                      14547000
         OPCD  X'85'                                                    14548000
BXH      OPND  R,1                                                      14549000
         OPND  R,2                                                      14550000
         OPND  S,1,(H,ALW)                                              14551000
         OPCD  X'86'                                                    14552000
BXLE     OPND  R,1                                                      14553000
         OPND  R,2                                                      14554000
         OPND  S,1,(H,ALW)                                              14555000
         OPCD  X'87'                                                    14556000
SRL      OPND  R,1                                                      14557000
         OPND  S,1,NLIT                                                 14558000
         OPCD  X'88'                                                    14559000
SLL      OPND  R,1                                                      14560000
         OPND  S,1,NLIT                                                 14561000
         OPCD  X'89'                                                    14562000
SRA      OPND  R,1                                                      14563000
         OPND  S,1,NLIT                                                 14564000
         OPCD  X'8A'                                                    14565000
SLA      OPND  R,1                                                      14566000
         OPND  S,1,NLIT                                                 14567000
         OPCD  X'8B'                                                    14568000
SRDL     OPND  R,1,1                                                    14569000
         OPND  S,1,NLIT                                                 14570000
         OPCD  X'8C'                                                    14571000
SLDL     OPND  R,1,1                                                    14572000
         OPND  S,1,NLIT                                                 14573000
         OPCD  X'8D'                                                    14574000
SRDA     OPND  R,1,1                                                    14575000
         OPND  S,1,NLIT                                                 14576000
         OPCD  X'8E'                                                    14577000
SLDA     OPND  R,1,1                                                    14578000
         OPND  S,1,NLIT                                                 14579000
         OPCD  X'8F'                                                    14580000
STM      OPND  R,1                                                      14581000
         OPND  R,2                                                      14582000
         OPND  S,1,(F,NLIT,MOD)                                         14583000
         OPCD  X'90'                                                    14584000
TM       OPND  S,1                                                      14585000
         OPND  I,3                                                      14586000
         OPCD  X'91'                                                    14587000
MVI      OPND  S,1,(MOD,NLIT)                                           14588000
         OPND  I,3                                                      14589000
         OPCD  X'92'                                                    14590000
TS       OPND  S,1,(MOD,NLIT)                                           14591000
         OPCD  X'93'                                                    14592000
NI       OPND  S,1,(MOD,NLIT)                                           14593000
         OPND  I,3                                                      14594000
         OPCD  X'94'                                                    14595000
CLI      OPND  S,1                                                      14596000
         OPND  I,3                                                      14597000
         OPCD  X'95'                                                    14598000
OI       OPND  S,1,(MOD,NLIT)                                           14599000
         OPND  I,3                                                      14600000
         OPCD  X'96'                                                    14601000
XI       OPND  S,1,(MOD,NLIT)                                           14602000
         OPND  I,3                                                      14603000
         OPCD  X'97'                                                    14604000
LM       OPND  R,1                                                      14605000
         OPND  R,2                                                      14606000
         OPND  S,1,F                                                    14607000
         OPCD  X'98'                                                    14608000
SIO      OPND  S,1,NLIT                                                 14609000
         OPCD  X'9C'                                                    14610000
SIOF     OPND  S,1,NLIT                                                 14611000
         OPCD  X'9C01'                                                  14612000
TIO      OPND  S,1,NLIT                                                 14613000
         OPCD  X'9D'                                                    14614000
CLRIO    OPND  S,1,NLIT                                                 14615000
         OPCD  X'9D01'                                                  14616000
HIO      OPND  S,1,NLIT                                                 14617000
         OPCD  X'9E'                                                    14618000
HDV      OPND  S,1,NLIT                                                 14619000
         OPCD  X'9E01'                                                  14620000
TCH      OPND  S,1,NLIT                                                 14621000
         OPCD  X'9F'                                                    14622000
CLRCH    OPND  S,1,NLIT                                        FX0000   14623000
         OPCD  X'9F01'                                         FX0000   14624000
STNSM    OPND  S,1,(NLIT,MOD)                                  <AM07317 14625000
         OPND  I,3                                                      14626000
         OPCD  X'AC'                                                    14627000
STOSM    OPND  S,1,(NLIT,MOD)                                  <AM07317 14628000
         OPND  I,3                                                      14629000
         OPCD  X'AD'                                                    14630000
SIGP     OPND  R,1                                                      14631000
         OPND  R,2                                                      14632000
         OPND  S,1,NLIT                                                 14633000
         OPCD  X'AE'                                                    14634000
MC       OPND  S,1                                                      14635000
         OPND  I,2                                                      14636000
         OPCD  X'AF'                                                    14637000
LRA      OPND  R,1                                                      14638000
         OPND  SX,(1,2)                                                 14639000
         OPCD  X'B1'                                                    14640000
CONCS    OPND  S,1,NLIT                                        FX0000   14641000
         OPCD  X'B200'                                         FX0000   14642000
DISCS    OPND  S,1,NLIT                                        FX0000   14643000
         OPCD  X'B201'                                         FX0000   14644000
STIDP    OPND  S,1,(NLIT,MOD)                                  <AM07317 14645000
         OPCD  X'B202'                                                  14646000
STIDC    OPND  S,1,(NLIT,MOD)                                  <AM07317 14647000
         OPCD  X'B203'                                                  14648000
SCK      OPND  S,1                                                      14649000
         OPCD  X'B204'                                                  14650000
STCK     OPND  S,1,(MOD,NLIT)                                           14651000
         OPCD  X'B205'                                                  14652000
SCKC     OPND  S,1,(D,ALW)                                              14653000
         OPCD  X'B206'                                                  14654000
STCKC    OPND  S,1,(D,ALW,NLIT,MOD)                            <AM07317 14655000
         OPCD  X'B207'                                                  14656000
SPT      OPND  S,1,(D,ALW)                                              14657000
         OPCD  X'B208'                                                  14658000
STPT     OPND  S,1,(D,ALW,NLIT,MOD)                            <AM07317 14659000
         OPCD  X'B209'                                                  14660000
SPKA     OPND  S,1,NLIT                                                 14661000
         OPCD  X'B20A'                                                  14662000
IPK      OPCD  X'B20B'                                                  14663000
PTLB     OPCD  X'B20D'                                                  14664000
SPX      OPND  S,1,(F,ALW)                                              14665000
         OPCD  X'B210'                                                  14666000
STPX     OPND  S,1,(F,NLIT,MOD,ALW)                                     14667000
         OPCD  X'B211'                                                  14668000
STAP     OPND  S,1,(H,NLIT,MOD,ALW)                                     14669000
         OPCD  X'B212'                                                  14670000
RRB      OPND  S,1,NLIT                                                 14671000
         OPCD  X'B213'                                                  14672000
IPTE     OPND  R,1                                             FX0000   14673000
         OPND  R,2                                             FX0000   14674000
         OPCD  X'B221'                                         FX0000   14675000
STCTL    OPND  R,1                                                      14676000
         OPND  R,2                                                      14677000
         OPND  S,1,(F,MOD,NLIT)                                         14678000
         OPCD  X'B6'                                                    14679000
LCTL     OPND  R,1                                                      14680000
         OPND  R,2                                                      14681000
         OPND  S,1,F                                                    14682000
         OPCD  X'B7'                                                    14683000
CS       OPND  R,1                                                      14684000
         OPND  R,2                                                      14685000
         OPND  S,1,(F,NLIT,MOD,ALW)                                     14686000
         OPCD  X'BA'                                                    14687000
CDS      OPND  R,1,1                                                    14688000
         OPND  R,2,1                                                    14689000
         OPND  S,1,(D,NLIT,MOD,ALW)                                     14690000
         OPCD  X'BB'                                                    14691000
CLM      OPND  R,1                                                      14692000
         OPND  I,2                                                      14693000
         OPND  S,1                                                      14694000
         OPCD  X'BD'                                                    14695000
STCM     OPND  R,1                                                      14696000
         OPND  I,2                                                      14697000
         OPND  S,1,(MOD,NLIT)                                           14698000
         OPCD  X'BE'                                                    14699000
ICM      OPND  R,1                                                      14700000
         OPND  I,2                                                      14701000
         OPND  S,1                                                      14702000
         OPCD  X'BF'                                                    14703000
MVN      OPND  SL,(1,3),(MOD,NLIT)                                      14704000
         OPND  S,2                                                      14705000
         OPCD  X'D1'                                                    14706000
MVC      OPND  SL,(1,3),(MOD,NLIT)                                      14707000
         OPND  S,2                                                      14708000
         OPCD  X'D2'                                                    14709000
MVZ      OPND  SL,(1,3),(MOD,NLIT)                                      14710000
         OPND  S,2                                                      14711000
         OPCD  X'D3'                                                    14712000
NC       OPND  SL,(1,3),(MOD,NLIT)                                      14713000
         OPND  S,2                                                      14714000
         OPCD  X'D4'                                                    14715000
CLC      OPND  SL,(1,3)                                                 14716000
         OPND  S,2                                                      14717000
         OPCD  X'D5'                                                    14718000
OC       OPND  SL,(1,3),(MOD,NLIT)                                      14719000
         OPND  S,2                                                      14720000
         OPCD  X'D6'                                                    14721000
XC       OPND  SL,(1,3),(MOD,NLIT)                                      14722000
         OPND  S,2                                                      14723000
         OPCD  X'D7'                                                    14724000
TR       OPND  SL,(1,3),(MOD,NLIT)                                      14725000
         OPND  S,2                                                      14726000
         OPCD  X'DC'                                                    14727000
TRT      OPND  SL,(1,3)                                                 14728000
         OPND  S,2                                                      14729000
         OPCD  X'DD'                                                    14730000
ED       OPND  SL,(1,3),(MOD,NLIT)                                      14731000
         OPND  S,2                                                      14732000
         OPCD  X'DE'                                                    14733000
EDMK     OPND  SL,(1,3),(MOD,NLIT)                                      14734000
         OPND  S,2                                                      14735000
         OPCD  X'DF'                                                    14736000
TPROT    OPND  S,1                                             FX0000   14737000
         OPND  S,2,NLIT                                        FX0000   14738000
         OPCD  X'E501'                                         FX0000   14739000
MVCIN    OPND  SL,(1,3),(MOD,NLIT)                             FX0000   14740000
         OPND  S,2                                             FX0000   14741000
         OPCD  X'E8'                                           FX0000   14742000
SRP      OPND  SL,(1,1),(MOD,NLIT)                                      14743000
         OPND  S,2,NLIT                                                 14744000
         OPND  I,2,(,,DEC)                                              14745000
         OPCD  X'F0'                                                    14746000
MVO      OPND  SL,(1,1),(MOD,NLIT)                                      14747000
         OPND  SL,(2,2)                                                 14748000
         OPCD  X'F1'                                                    14749000
PACK     OPND  SL,(1,1),(MOD,NLIT)                                      14750000
         OPND  SL,(2,2)                                                 14751000
         OPCD  X'F2'                                                    14752000
UNPK     OPND  SL,(1,1),(NLIT,MOD)                                      14753000
         OPND  SL,(2,2)                                                 14754000
         OPCD  X'F3'                                                    14755000
ZAP      OPND  SL,(1,1),(MOD,NLIT)                                      14756000
         OPND  SL,(2,2)                                                 14757000
         OPCD  X'F8'                                                    14758000
CP       OPND  SL,(1,1)                                                 14759000
         OPND  SL,(2,2)                                                 14760000
         OPCD  X'F9'                                                    14761000
AP       OPND  SL,(1,1),(MOD,NLIT)                                      14762000
         OPND  SL,(2,2)                                                 14763000
         OPCD  X'FA'                                                    14764000
SP       OPND  SL,(1,1),(MOD,NLIT)                                      14765000
         OPND  SL,(2,2)                                                 14766000
         OPCD  X'FB'                                                    14767000
MP       OPND  SL,(1,1),(MOD,NLIT)                                      14768000
         OPND  SL,(2,2)                                                 14769000
         OPCD  X'FC'                                                    14770000
DP       OPND  SL,(1,1),(MOD,NLIT)                                      14771000
         OPND  SL,(2,2)                                                 14772000
         OPCD  X'FD'                                                    14773000
         EJECT                                                          14774000
FGT      MIEND                                                          14775000
ESDSECT  DC    HS14'1'                  ESDID FOR A DSECT IS GE THIS    14776000
         JPATCH X5M00,A42               5 % PATCH AREA                  14777000
         END   X5M                      DID I FORGET ANYTHING ?         14778000
./ ADD NAME=IFNX5P                                                      14779000
* /* START OF SPECIFICATIONS ****                                       14780000
*02* PROCESSOR = ASSEMBLER                                              14781000
**** END OF SPECIFICATIONS ***/                                         14782000
         LCLC  &TBP                     TEXT BASE POINTER               14783000
         LCLC  &BAL                     LINK REGISTER                   14784000
         LCLC  &OPT                     OUTPUT POINTER                  14785000
         LCLC  &LEN                     FIELD LENGTH                    14786000
         LCLC  &SCR                     SCRATCH REGISTER                14787000
         LCLC  &SCH                     ALSO SCRATCH                    14788000
         LCLC  &COM                     PHASE WORK AREA POINTER         14789000
         LCLC  &IPT                     INPUT FIELD ADDRESS             14790000
         LCLC  &PRN                     PRINT BUFFER POINTER            14791000
         SPACE 5                                                        14792000
&SCR     SETC  'R1'                                                     14793000
&COM     SETC  'R7'                                                     14794000
&OPT     SETC  'R3'                                                     14795000
&IPT     SETC  'R4'                                                     14796000
&BAL     SETC  'R6'                                                     14797000
&TBP     SETC  'R5'                                                     14798000
&LEN     SETC  'R14'                                                    14799000
&PRN     SETC  'R2'                                                     14800000
&SCH     SETC  'R15'                                                    14801000
         SPACE 5                                                        14802000
         JHEAD 'ASSEMBLY PHASE - PRINT ROUTINE',                       X14803000
               PHASEID=X5P,                                            X14804000
               LEVEL=10                                                 14805000
*                                                                     * 14806000
*FUNCTION/OPERATION-                                                  * 14807000
*   THIS ROUTINE IS CALLED TO LIST AND PUNCH ALL TEXT OUTPUT FROM     * 14808000
*   THE ASSEMBLY PORTION OF THE ASSEMBLE. THIS ROUTINE RECONSTRUCTS   * 14809000
*   THE ASSEMBY PORTION OF THE ASSEMBLER. THIS ROUTINE RECONSTRUCTS   * 14810000
*   TEXT FOR THE PRINT FILE FROM THE EDITED TEXT RECORD. IT ALSO USES * 14811000
*   INPUT FROM LEFTHF TO CONSTRUCT THE LEFT HALF OF THE PRINT IMAGE,  * 14812000
*   AND TO BUILD PUNCH RECORD FOR THE PUNCH AND LINK FILES.           * 14813000
*                                                                     * 14814000
*ENTRY POINT-                                                         * 14815000
*        PRN100                                                       * 14816000
*                                                                     * 14817000
*INPUT-                                                               * 14818000
*   EDITED TEXT RECORDS ON JINFILE.                                   * 14819000
*   THE LEFT HALF VALUES IN A 19 BYTE TABLE CALLED LEFT HALF          * 14820000
*                                                                     * 14821000
*OUTPUT-                                                              * 14822000
*   ASSEMBLY LISTINGS TO THE PRINT FILE.                              * 14823000
*   RELOCATABLE OBJECT TEXT TO THE PUNCH AND LINK FILES.              * 14824000
*                                                                     * 14825000
*EXTERNAL ROUTINES                                                    * 14826000
*        JPUTL                                                        * 14827000
*        JPUNCH                                                       * 14828000
*                                                                     * 14829000
*EXITS, NORMAL-                                                       * 14830000
*   EXITS TO THE CALLING ROUTINE THROUGH THE JRETURN MACRO.           * 14831000
*                                                                     * 14832000
*EXITS, ERROR-                                                        * 14833000
*   NONE                                                              * 14834000
*                                                                     * 14835000
*TABLES/WORK AREAS-                                                   * 14836000
*   THE DEFINITION OF LEFTHF IS:                                      * 14837000
*                                                                     * 14838000
*   BYTES BITS  DATA                                                  * 14839000
*                                                                     * 14840000
*                                                                     * 14841000
*   00-03       LOCATION OF ENTRY                                     * 14842000
*   04-11       DC DATA IF ENTRY IS A DC OR CCW                       * 14843000
*   04-05       OPCODE  IF ENTRY IS A MACHINE OPERATION               * 14844000
*               BYTE 05 MAY ALSO CONTAIN LENGTH, REGISTERS, IMEDIATE  * 14845000
*               DATA.                                                 * 14846000
*   06-07       BASE-DISPLACEMENT 1                                   * 14847000
*   08-09       BASE-DISPLACEMENT 2                                   * 14848000
*   10-11       FLAGS                                                 * 14849000
*          0-1  01 ENTRY IS ALIGNMENT.                                * 14850000
*               10 ENTRY IS A DC                                      * 14851000
*               11 ENTRY IS AN EQUATE                                 * 14852000
*           2   BASE-DISPLACEMENT 1 PRESENT                           * 14853000
*           3   BASE-DISPLACEMENT 2 PRESENT                           * 14854000
*          4-7  LENGTH OF ENTRY. (IF ALL BITS ON DON'T PRINT LEFT HALF* 14855000
*   12-15       ADDRESS 1                                             * 14856000
*   16-19       ADDRESS 2                                             * 14857000
*   TOTAL LENGTH OF LEFT HALF IS 20 BYTES                             * 14858000
*                                                                     * 14859000
*ATTRIBUTES-                                                          * 14860000
*   REFRESHABLE                                                       * 14861000
*                                                                     * 14862000
*NOTES                                                                * 14863000
*   NONE                                                              * 14864000
*                                                                     * 14865000
*                                                                     * 14866000
         EJECT                                                          14867000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   14868000
         COPY  JCOMMON                  INCLUDE COMMON DSECT            14869000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     14870000
         COPY  JTEXT                    INCLUDED TEXT DSECT             14871000
         PRINT OFF                      DON'T PRINT X5COM COPY CODE     14872000
         COPY  X5COM                    INCLUED ASSEMBLY PHASE COMMON   14873000
         PRINT ON                       PRINT PRINT AREA DSECT          14874000
PRNIMG   DSECT                                                          14875000
*   PRINT WORK AREA                                                     14876000
PRNLN    DS    0CL121                   LENGTH OF PRINT LINE            14877000
CCTRL    DS    C                        CARRIAGE CONTROL                14878000
TITCD    DS    CL8                      TITLE CODE FIELD                14879000
         DS    C                        BLANKS                          14880000
TITLEO   DS    CL100                    TITLE FROM ASSEMBLY             14881000
         DS    2C                       BLANKS                          14882000
PAGEO    DS    CL4                      PAGE FOR HEADING                14883000
PGNO     DS    CL5                      PAGE NUMBER                     14884000
         ORG   PRNIMG                   RE-ORG FOR HEADING LINE 2       14885000
         DS    C                        CARRIAGE CONTROL ALREADY DEFINE 14886000
         DS    2C                       BLANKS                          14887000
SNDHDO   DS    CL56                     HEADING 2                       14888000
         DS    38C                      BLANKS                          14889000
SNDHID   DS    CL24                     ID AND DATE PLUS TIME           14890000
         ORG   PRNIMG                   RE-ORG FOR LIST EACH LINE       14891000
         DS    C                        CARRIAGE CONTROL                14892000
LOCO     DS    CL6                      LOCATION                        14893000
         DS    C                        BLANK                           14894000
OPCDO    DS    CL4                      OP CODE                         14895000
IMEDO    EQU   OPCDO+2                  IMEDIATE, RX, OR LENGTH FIELD   14896000
         DS    C                        BLANK                           14897000
BDPL1    DS    CL4                      BASE-DISPLACEMENT 1             14898000
         DS    C                        BLANK                           14899000
BDPL2    DS    CL4                      BASE-DISPLACEMENT 2             14900000
ADDR1    DS    CL6                      ADDRESS 1                       14901000
ADDR2    DS    CL6                      ADDRESS 2                       14902000
         DS    C                        BLANK                           14903000
STMTNO   DS    CL5                      STATEMENT NUMBER                14904000
GENFLG   DS    C                        GENERATION INDICATION           14905000
NAMFLD   EQU   *                        NAME FIELD                      14906000
COMMENT  DS    0CL80                    COMMENT STATEMENTS COME HERE    14907000
         ORG   PRNIMG                   RE-ORG FOR OPCODE               14908000
OPFLD    DS    0C                       OPCODE FIELD                    14909000
CMNFLD   DS    0C                       COMMENT FIELD                   14910000
OPNFLD   DS    0C                       OPERAND FIELD                   14911000
MRGFLD   DS    0C                       MARGIN OR POST END FIELD        14912000
         ORG   PRNIMG                   REORG FOR ERROR NOTE            14913000
         DS    CL(1+9)                  CARR CTL + BLANK                14914000
ERRLOC   DC    C'*** ERROR ***'                                         14915000
         ORG                                                            14916000
PEJECT   EQU   0                        CARRIAGE CONTROL EJECT          14917000
P1SPACE  EQU   1                        CARRIAGE CONTROL SPACE 1        14918000
P2SPACE  EQU   2                        CARRIAGE CONTROL SPACE 2        14919000
P3SPACE  EQU   3                        CARRIAGE CONTROL SPACE 3        14920000
GENIND   EQU   JPLUS                    MACRO GENERATED INDICATOR       14921000
JTEXTA   DSECT                                                          14922000
         ORG   JTOCO                                                    14923000
OPTR     DSW   CDPTR                    CARD POINTER FLAG               14924000
         ORG   JTOCO                    REORG FOR OTHER POINTERS        14925000
OCPTR    DS    C                        OUTPUT COLUMN POINTER           14926000
LENGTH   DS    C                        FIELD (TRUE) LENGTH             14927000
FIELD    EQU   *                                                        14928000
         EJECT                                                          14929000
CRDSCT   DSECT  ,                       DSECT FOR TXT CARDS             14930000
CRDID    DS    CL4                      12-2-9 PUNCH AND TXT            14931000
         ORG   CRDID+1                  POINT TO AREA THAT NEEDS TRANS  14932000
CRDTR    DS    0CL71                    LENGTH OF TRANSLATE             14933000
         ORG   ,                        ORG BACK TO NEXT BYTE           14934000
         DS    C                        BLANK                           14935000
CRDVLO   DS    CL3                      ADDRESS OF FIRST BYTE OF TEXT   14936000
         DS    2C                       BLANK                           14937000
CRDLEN   DS    CL2                      NUMBER OF BYTES OF TEXT         14938000
         DS    2C                       BLANK                           14939000
CRDESD   DS    CL2                      ESD OF TEXT                     14940000
CRDTXT   DS    CL56                     TEXT - MAXIMUM OF 56 BYTES      14941000
D80      EQU   80                                                       14942000
         PRINT ON                       THAT'S ALL THE COPY CODE        14943000
         EJECT                                                          14944000
         JCSECT (X5P00)                 START MODULE CSECT              14945000
* VS1 RELEASE 2.6 CHANGES                                               14946000
*D301000-305000                                                 OX00222 14947000
*A194100                                                        OX00412 14948000
* VS1 RELEASE 4 CHANGES                                                 14949000
*C608000,617200                                                 OX01764 14950000
*A633900-633940                                                 OX01764 14951000
*A366120,379500,412500                                          OX02266 14952000
*C336200,380000                                                 OX02266 14953000
*A219500                                                       @AZ13709 14954000
*D288000                                                       &AZ13795 14955000
*A633360,633380                                                @AX16963 14956000
*D633380                                                       @AZ29272 14957000
*A633340,633380                                                @AZ29272 14958000
         JMODID ,                       CREAT ROUTINE ID                14959000
         USING JTEXT,R5                 FIXED TEXT USING                14960000
         USING JTEXTA,R4                VARIABLE TEXT USING             14961000
         USING X5COM,R7                 COMMON USING                    14962000
         USING PRNIMG,R2                PRINT BUFFER USING              14963000
PRN100   JSAVE BASE=YES                 SAVE CALLING REGISTERS          14964000
         JENTRY (X5P01=PRN100)          MAKE ENTRY POINT EXTERNAL       14965000
         EJECT                                                          14966000
         GOIF  (JLIST,JDECK,JLINK),     IF DECK, LIST, LINK ARE NOT    X14967000
               OFF=PRNXIT               REQUIRED EXIT                   14968000
         GOIF  LTDECV,ON=PRNXIT         EXIT IF LITERAL REFERENCE       14969000
         CH    R10,=H'4'                IS IT PRNCAR PRINT INDEX        14970000
         BE    PRN110                   YES                             14971000
         SET   SPACECC,OFF              RESET SPACE CONTROL             14972000
PRN110   EQU   *                                                        14973000
         GOIF  JLIST,OFF=INDEX2(R10)    IF LIST IS OF USE BRANCH TABLE X14974000
                                        NUMBER 2                        14975000
         GOIF  PSTMT,OFF=PRN125         IS STATEMENT TO BE PRINTED      14976000
         GOIF  JGEN,ON=PRN150           IS TEXT GENERATED               14977000
         B     INDEX1(R10)              NO, USE BRANCH TABLE NUMBER1    14978000
INDEX1   B     PRNLST                   ENTRY IS FOR STANDARD LISTING   14979000
         B     PRNCAR                   ENTRY IS CARRIAGE CONTROL       14980000
         B     PRNPUN                   ENTRY IS FOR PUNCH STATEMENT    14981000
         B     PRNRPO                   ENTRY IS FOR REPRO CARD         14982000
         B     PRNDC                    ENTRY IS FOR A DC               14983000
         B     PRNERR                   ERROR ROUTINE                   14984000
         B     PRNMNO                   GET BUFFER FOR MNOTE            14985000
INDEX2   B     PUNRTN                   NO LIST - GO CHECK PUNCH OPTION 14986000
         B     PRNXIT                   NO LIST - EXIT                  14987000
         B     PRNPUN                   GO CHECK PUNCH OPTION           14988000
         B     PRNRPO                   GO CHECK PUNCH OPTION           14989000
         B     PUNRTN                   GO CHECK PUNCH OPTION           14990000
         B     PRNXIT                   EXIT IF NOLIST                  14991000
         B     PRNXIT                   EXIT NO MNOTE                   14992000
PRN125   GOIF  PRPP,ON=INDEX1(R10)      WAS PRINT FORCED ?              14993000
         B     INDEX2(R10)              IF NOT USE BRANCH TABLE NR 2    14994000
PRN150   GOIF  PGEN,ON=INDEX1(R10)      CHECK PRINT GEN OPTION IF ON    14995000
         CLI   JTIOP1,JTMNOTE           IS IT AN MNOTE?                 14996000
         BE    INDEX1(R10)              USE INDEX 1 IF MNOTE            14997000
         GOIF  JERR,ON=INDEX1(R10)      USE INDEX 1 IF STMT FLAGGED     14998000
         SET   DCMOP,OFF                CLEAR SWITCH TO BE SURE OX00412 14999000
         B     INDEX2(R10)              ELSE USE INDEX 2                15000000
PRNXIT   SET   (DCSWH,DCCOMP,DCMOP,DCSTRT),OFF  TURN OFF ALL DC FLAGS   15001000
         SET   PRPP,OFF                 RESET FORCED POP PUSH PRINT     15002000
PRN200   XC    DCDATA(L'LEFTHF-L'LOCATN),DCDATA ZERO LEFT HALF          15003000
         SET   COLOVLP,OFF              TURN OVERLAP SWITCH OFF         15004000
PRNLEV   JRETURN ,                      EXIT                            15005000
         EJECT                                                          15006000
PRN800   CVD   &SCR,DWORD1              CONVERT NUMBER TO DECIMAL       15007000
         UNPK  DWORD2(L'STMTNO),DWORD1  UNPACK NUMBER                   15008000
         NC    DWORD2(D5),ZMASK         MASK OUT ZONE BITS              15009000
         LA    &SCR,D4                  GET MAXIMUM BLANKS TO ADD       15010000
         LA    &SCH,DWORD2              POINT TO NUMBER                 15011000
PRN810   CLI   D0(&SCH),J0              IS LEADING DIGIT ZERO           15012000
         BNE   PRN820                   NO                              15013000
         MVI   D0(&SCH),JBLANK          YES,BLANK OUT                   15014000
         LA    &SCH,D1(,&SCH)           BUMP POIMTER                    15015000
         BCT   &SCR,PRN810             GO BACK IF COUNT NOT DEPLETE     15016000
PRN820   BR    R6                       RETURN                          15017000
         SPACE                                                          15018000
PRN600   L     R2,PRNSV1                                                15019000
         JPRINT ,                                                       15020000
         LR    &PRN,R11                 SAVE NEW BUFFER ADDRESS         15021000
         ST    R2,PRNSV1                SAVE PRINT BUFFER POINTER       15022000
         BR    &BAL                     RETURN                          15023000
         EJECT                                                          15024000
PRNLST   BAL   R6,PRINT                 GO GET PRINT LINE               15025000
         SET   SPACECC,OFF              RESET SPACE CONTROL    @AZ13709 15026000
         TM    LHFLGS,DNTPLH            IS LEFT HALF TO BE PRINTED      15027000
         BO    LIST1                    YES, GO PRINT SOURCE            15028000
         UNPK  LHWORK(D15),LEFTHF(D8)         UNPACK THE LEFT HALF OF   15029000
         UNPK  LHWORK+D14(D15),LEFTHF+D7(D8)  THE PRINT LINE FOR        15030000
         UNPK  LHWORK+D28(D15),LEFTHF+D14(D8) PRINTING                  15031000
         NC    LHWORK,ZMASK             MASK OUT ZONE BITS FROM UNPACK  15032000
         GOIF  EOUBIT,ON=PRL300         BRANCH IF ORG EQU OR USING      15033000
         TM    LHFLGS,ENTDC+ENTALN                                      15034000
         MVC   LOCO,ULOCO+D2            MOVE LOCATION TO PRINT LINE     15035000
         BZ    PRL200                   NOT ALIGNMENT OR DC             15036000
         BM    PRL100                   IS ALIGNMENT OR DC              15037000
         B     LIST1                    GO PRINT SOURCE                 15038000
PRL100   IC    R14,LHFLGS               GET LENGTH OF DATA              15039000
         LA    R15,JF                   GET MASK                        15040000
         NR    R14,R15                  AND OUT EXTRA BITS              15041000
         BZ    PRL150                   BRANCH IF NO DATA TO MOVE       15042000
         SLL   R14,D1                   DOUBLE FOR PRINT LENGTH         15043000
         BCTR  R14,0                    GET MOVE LENGTH                 15044000
         EX    R14,MVDCDA               EXECUTE MOVE TO PRINT LINE      15045000
PRL150   EQU   *                        BRANCH LABEL                    15046000
         GOIF  ENTALN,ON=PUNRTN         PRINT COMPLETE FOR ALIGNMENT    15047000
         GOIF  DCSWH,ON=DC100           DC OR CCW                       15048000
         B     LIST1                    GO PRINT CCW                    15049000
MVDCDA   MVC   OPCDO(D0),UOPCOD         EXECUTED MOVE OF DC AND ALIGN   15050000
         EJECT                                                          15051000
PRL200   TM    LHFLGS,DNTPLH            IS LENGTH OF ENTRY ZERO         15052000
         BZ    LIST1                    YES, LEFT HALF COMPLETE         15053000
         MVC   OPCDO,UOPCOD             GET OPCODE AND SECOND BYTE      15054000
         CLI   LHFLGS,D2                IS ENTRY 2 BYTES LONG           15055000
         BE    LIST1                    YES, LEFT HALF COMPLETE         15056000
         MVC   BDPL1,UBASD1             MOVE BASE-DISPLACEMENT 1        15057000
         MVC   ADDR1,UADR1+D2           MOVE ADDRESS 1 TO PRINT         15058000
         CLI   ADDR1,J0                 DOES ADDRES 1 HAVE LEADING 0    15059000
         BNE   PRL250                   NO, LEAVE AS IS                 15060000
         MVI   ADDR1,JBLANK             YES, BLANK OUT ZERO             15061000
PRL250   CLI   LHFLGS,D4                IS ENTRY LENGTH 4               15062000
         BE    LIST1                    YES, LEFT HALF COMPLETE         15063000
         MVC   BDPL2,UBASD2             MOVE BASE-DISPLACEMENT 2        15064000
         MVC   ADDR2,UADR2+D2           MOVE ADDRESS 2 TO PRINT         15065000
         CLI   ADDR2,J0                 DOES ADDRESS 2 HAVE LEADING 0   15066000
         BNE   LIST1                    NO, LEAVE AS IS                 15067000
         MVI   ADDR2,JBLANK             YES, BLANK LEADING ZERO         15068000
         B     LIST1                    GO PRINT RIGHT HALF             15069000
PRL300   MVI   LOCO,X'2F'               ZERO OUT LEFTH HALF             15070000
         MVC   LOCO+D1(D23),LOCO                                        15071000
         MVC   ADDR2-D2(D8),UADR2       MOVE VALUE FOR PRINT            15072000
         CLI   ADDR2-D2,J0              SUPRESS UP TO 3 LEADING ZEROS   15073000
         BNE   PRL400                                                   15074000
         MVI   ADDR2-D2,JBLANK                                          15075000
         CLI   ADDR2-D1,J0                                              15076000
         BNE   PRL400                                                   15077000
         MVI   ADDR2-D1,JBLANK                                          15078000
         CLI   ADDR2,J0                                                 15079000
         BNE   PRL400                                                   15080000
         MVI   ADDR2,JBLANK                                             15081000
PRL400   GOIF  JTORG,NE=LIST1           IS IT ORG ?                     15082000
         MVC   LOCO,ULOCO+D2            YES MOVE LOCTR FOR PRINT        15083000
         B      LIST1                   GO PRINT SOURCE                 15084000
         EJECT                                                          15085000
PRNCAR   LR    R3,R11                   SAVE NUMBER OF LINES TO SPACE   15086000
         GOIF  (R3),NEG=CAR600          IS IT EJECT                     15087000
         GOIF  JLNCT,LNCNT+D2,NE=CAR025  TOP OF PAGE ?                  15088000
         GOIF  SPACECC,OFF=CAR025       FIRST LINE ON NEW PAGE          15089000
         SET   SPACECC,OFF              RESET NEW PAGE INDICATOR        15090000
         LA    R3,D1(R3)                ADD 1 FOR SPACE IN HEADING      15091000
         L     R4,LNCNT                 GET LINES LEFT ON PAGE          15092000
         LA    R4,D1(R4)                COMPENSATE FOR 1 SPACE          15093000
         ST    R4,LNCNT                 SAVE NEW LNCNT                  15094000
CAR025   GOIF  TWASLC,ON=CAR050         BUFF AVAIL SO DO NOT COMP PRT   15095000
         L     R4,LNCNT                 PICK UP LNCNT                   15096000
         LA    R4,D1(R4)                COMPENSATE FOR PRINT            15097000
         ST    R4,LNCNT                 SAVE NEW LNCNT                  15098000
CAR050   BAL   R6,PRINT                 GO GET PRINT LINE               15099000
         L     R4,LNCNT                 PICK UP LNCNT                   15100000
         SR    R4,R3                    SUBTRACT NUMBER OF SPACES       15101000
         BNH   CAR700                   EJECT IF NOT ENOUGH LINES LEFT  15102000
         ST    R4,LNCNT                 STORE REMAINING LINES + COMP    15103000
CAR100   BCT   R3,CAR200                DOES SPACE = 1                  15104000
         B     PRNXIT                   YES, EXIT                       15105000
CAR200   BCT   R3,CAR300                DOES SPACE = 2                  15106000
         MVI   CCTRL,P2SPACE            YES, SET CARRIAGE CONTROL       15107000
         B     PRNXIT                   EXIT                            15108000
CAR300   MVI   CCTRL,P3SPACE            SET CARRIAGE CONTROL = 3        15109000
         BCT   R3,CAR400                STILL MORE LINES TO SPACE       15110000
         B     PRNXIT                   NO, EXIT                        15111000
CAR400   L     R4,LNCNT                 COMP FOR PRT TO PREVENT EJECT   15112000
         LA    R4,D1(R4)                ADD 1 TO COMPENSATE FOR PRINT   15113000
         ST    R4,LNCNT                 STORE REMAINING LINES           15114000
         BAL   R6,PRINT                 PRINT SPACE 3                   15115000
         B     CAR100                   GO CHECK FOR MORE SPACES        15116000
CAR600   GOIF  TWASLC,ON=CAR700         WAS EJECT LAST OP               15117000
         BAL   R6,PRINT                 GET PRINT LINE                  15118000
         GOIF  JLNCT,LNCNT+D2,NE=CAR700 TOP OF PAGE ?                   15119000
         SET   TWASLC,ON                INDICATE BUFFER AVAILABLE       15120000
         B     PRNXIT                   SUPRESS EJECT                   15121000
CAR700   L     R2,PRNSV1                RESTORE BUFFER POINTER          15122000
         BAL   R6,PRNEJT                SET UP RETURN REGISTER          15123000
         B     PRNXIT                   RETURN                          15124000
PRNEJT   ST    R6,PRNSAVE               SAVE RETURN REGISTER            15125000
         SET   TWASLC,ON                INDICATE BUFFER AVAILABLE       15126000
         B     PRT150                   GO PRINT TITLES                 15127000
         EJECT                                                          15128000
* LISTSRC                                                               15129000
*                                                                       15130000
*   THIS ROUTINE RECONSTRUCTS THE SOURCE RECORDS IN THE PRINT AREA      15131000
*   AND CALLS PRINT TO LIST ALL CARDS BUT THE LAST IN THE STATEMENT     15132000
*   THE LAST(OR,MOST OFTEN,THE ONLY)CARD IS PRINTED AFTER PROCESSING    15133000
         SPACE                                                          15134000
LIST1    GOIF  JNOCNT,ON=LST100         DOES STATEMENT GET NUMBER       15135000
         L     R1,STMTN                 GET STATEMENT NUMBER            15136000
         BAL   R6,PRN800                GO CONVERT IT FOR LISTING       15137000
         MVC   STMTNO,DWORD2            MOVE CONVERTED NUMBER TO LIST   15138000
         SPACE                                                          15139000
LST100   SET   COLOVLP,OFF              TURN OFF OVERLAP CHECK BIT      15140000
         XC    COLSAV,COLSAV            ZEROED OUT SAVE AREA            15141000
         LH    R4,JTNMP                 GET NAME POINTER                15142000
         BAL   &BAL,FLDMOVE             MOVE NAME TO OUTPUT             15143000
         SPACE                                                          15144000
*   MOVE OPCODE FIELD                                                   15145000
         SPACE                                                          15146000
         LH    &IPT,JTOCP               GET OPCODE POINTER              15147000
         BAL   &BAL,FLDMOVE             MOVE TO OUTPUT                  15148000
         SPACE                                                          15149000
*   MOVE OPERAND FIELD                                                  15150000
         SPACE                                                          15151000
         LH    &IPT,JTOPP               GET OPERAND POINTER             15152000
         BAL   &BAL,FLDMOVE             MOVE TO OUTPUT                  15153000
         SPACE                                                          15154000
*   MOVE COMMENTS TO OUTPUT                                             15155000
         SPACE                                                          15156000
         LH    &IPT,JTCPR               GET COMMENTS POINTER            15157000
         BAL   &BAL,FLDMOVE             MOVE TO OUTPUT                  15158000
         BAL   &BAL,STRING              INSERT STRINGS INTO PRINT LINE  15159000
         GOIF  JGEN,OFF=LIST6           GOIF NOT GENERATED              15160000
         L     &SCR,DWORD1              GET CONTINUATION COLUMN POINTER 15161000
         CLI   D0(&SCR),JBLANK          IS CONTINUATION COL BLANK       15162000
         BE    LIST6                    YES                             15163000
         MVI   D0(&SCR),JBLANK          NO, MAKE IT SO                  15164000
         SPACE                                                          15165000
LIST6    GOIF  DCSWH,ON=DC300           IS ENTRY A DC                   15166000
         GOIF  ENTDC,ON=PRNXIT          EXIT IF DATA NO TO BE PUNCHED   15167000
         TM    LHFLGS,DNTPLH            ANY PUNCH DATA                  15168000
         BM    PUNRTN                   YES, GO PACK IN PUNCH CARD      15169000
         B     PRNXIT                   RETURN TO MAINLINE              15170000
         EJECT                                                          15171000
* FLDMOVE                                                               15172000
*                                                                       15173000
*   THIS ROUTINE MOVES THE NAME,OPERATION,OPERAND OR COMMENTS FIELD     15174000
*   TO THE PRINT AREA.IF THE FIELD IS TOO LONG TO FIT INTO THE CURRENT  15175000
*   LINE PART OF THE FIELD IS MOVED AND THE LINE IS PRINTED.THIS        15176000
*   PROCESS CONTINUES UNTIL THE WHOLE FIELD IS MOVED.                   15177000
*   CALL BY BAL BAL,FLDMOVE WITH REG IPT CONTAINIG A POINTER TO THE     15178000
*   FIELD GROUP.                                                        15179000
         SPACE                                                          15180000
FLDMOVE  ST    &BAL,FLDSAVE             SAVE LINK REGISTER              15181000
         AR    &IPT,&TBP                TURN POINTER INTO ADDRESS       15182000
         GOIF  CDPTR,OFF=FLD1           TEST IF CARD PTR,GO IF NOT      15183000
         SPACE                                                          15184000
*   HANDLE CARD POINTER                                                 15185000
         SPACE                                                          15186000
         MVC   CARDP,OPTR               SAVE CARD POINTER               15187000
         SET   CDPTR1,OFF               TURN OFF FLAG BIT               15188000
FLD01    SR    &SCR,&SCR                CLEAR REGISTER                  15189000
         IC    &SCR,CARDP               GET CARD POINTER                15190000
         SH    &SCR,CDSTMT              SUBTR CURRENT CARD-WITHIN-STMT  15191000
         BNH   FLD02                    WE ARE DONE IF NOT IN NEW CARD  15192000
         BAL   &BAL,STRING              INSERT STRINGS INTO PRINT LINE  15193000
         BAL   &BAL,PRINT               PRINT CURRENT CARD              15194000
         XC    COLSAV,COLSAV            CLEAR SAVE AREA FOR COLUMN PTR  15195000
         SET   COLOVLP,OFF              TURN OFF OVERLAP CHECK BIT      15196000
         B     FLD01                    GO TEST NEXT CARD               15197000
FLD02    LA    &IPT,L'OPTR(,&IPT)       POINT TO COLUMN POINTER         15198000
         SPACE                                                          15199000
FLD1     SR    &OPT,&OPT                CLEAR REGOSTER                  15200000
         IC    &OPT,OCPTR               GET OUTPUT COLUMN POINYER       15201000
         SR    &LEN,&LEN                CLEAR THIS ONT TOO              15202000
         IC    &LEN,LENGTH              GET FIELD LENGTH                15203000
         GOIF  (R14),NOTZERO=FLD10      CHECK IF OPERAND LENGTH ZERO    15204000
         GOIF  JPSOP,OFF=FLD1A          CAN IT BE ICTL                  15205000
         GOIF  JTICTL,EQ=FLD2           ICTL STATEMENT ?                15206000
FLD1A    GOIF  JPRGICTL,OFF=FLD2        USE STD ICTL            OX02266 15207000
         LH    &SCR,JENDCL              NOT ICTL -GET END COL-1 OX02266 15208000
         B     FLD3                     GO GET OUT                      15209000
FLD2     LA    &SCR,D7*D10+D1           USE STANDARD ICTL               15210000
FLD3     LA    &SCR,NAMFLD(&SCR)        POINT TO END COLUMN             15211000
         ST    &SCR,DWORD1              SAVE IT                         15212000
         L     R6,FLDSAVE               RESTORE LINKAGE REGISTER        15213000
         BR    R6                       RETURN                          15214000
         SPACE                                                          15215000
*   LEN NOW CONTAINS TRUE LENGTH,OPT OUTPUT COLUMN POINTER              15216000
         SPACE                                                          15217000
FLD10    BCTR  &LEN,0                   DECREASE TO MOVE LENGTH         15218000
         GOIF  COLOVLP,OFF=FLD20        BRANCH IF OVERLAP BIT IS OFF    15219000
         CH    R3,COLSAV                DOES FIELD OVERLAP?             15220000
         BNL   FLD20                    NO,BRANCH AROUND                15221000
         LH    R3,COLSAV                GET COLUMN PTR SAVED            15222000
         SPACE                                                          15223000
FLD20    SET   COLOVLP,ON               TURN OVERLAP CHECK BIT ON       15224000
         GOIF  JPSOP,OFF=FLD22          CAN IT BE ICTL                  15225000
         GOIF  JTICTL,EQ=FLD30          ICTL STATEMENT?                 15226000
FLD22    GOIF  JPRGICTL,OFF=FLD30       USE STD ICTL            OX02266 15227000
         LH    &SCR,JENDCL              NOT ICTL -GET END COL-1 OX02266 15228000
         SPACE                                                          15229000
FLD25    SR    &SCR,&OPT                GET MAXIMUM MOVE LENGTH         15230000
         BM    FLD30                    TRY STD ICTL                    15231000
FLD27    LA    R15,D2(R3,R14)           COMPUTE NEXT FIELD PTR          15232000
         STH   R15,COLSAV               SAVE COLUMN PTR FOR NXT FIELD   15233000
         CR    &LEN,&SCR                WILL FIELD FIT INTO THIS LINE   15234000
         LA    &OPT,NAMFLD-D1(&OPT)                                     15235000
         BH    FLD100                   NO                              15236000
         EX    &LEN,MOVE                YES,MOVE IT                     15237000
         L     &BAL,FLDSAVE             RESTORE LINK REGISTER           15238000
         LA    R1,D1(R1,R3)             COMPUTE END COL + 1             15239000
         ST    R1,DWORD1                SAVE IT                         15240000
         BR    &BAL                     RETURN                          15241000
FLD30    LA    R1,D7*D10+D1             USE STD ICTL END COL            15242000
         SR    R1,R3                    NOW TRY MAX MOVE LENGTH         15243000
         BNM   FLD27                    BRANCH IF OK                    15244000
         LA    &OPT,NAMFLD-D1(&OPT)     PT TO PRINT POSITION            15245000
         LA    R6,D1(R1,R3)             COMPUTE END COLUMN + 1          15246000
         LH    R1,=H'-1'                SET TO -1 (0=1 BYTE,-1=NO BYTE) 15247000
         B     FLD101                   NOW SKIP MOVE                   15248000
FLD100   EX    &SCR,MOVE               MOVE PART OF FIELD               15249000
         LA    R6,D1(R1,R3)             COMPUTE END COLUMN + 1          15250000
FLD101   SR    &LEN,&SCR                GET (TRUE) LENGTH OF REMAINDER  15251000
         STH   &LEN,HWD                 SAVE LENGTH                     15252000
         LA    &IPT,D1(&SCR,&IPT)      GET ADDR OF REMAINING PART       15253000
         LR    R1,R6                    TRANSFER END COLUMN+1 TO R1     15254000
         GOIF  LITRSW,ON=FLD102         SKIP IF LITERAL                 15255000
         ST    R1,DWORD1                SAVE IT                         15256000
         BAL   &BAL,STRING              INSERT STRINGS INTO PRINT LINE  15257000
         L     R1,DWORD1                RESTORE R1                      15258000
         SPACE                                                          15259000
FLD102   CLI   D0(R1),JBLANK            IS IT BLANK?                    15260000
         BNE   FLD105                   BRANCH AROUND IF NOT EQUAL      15261000
         MVI   D0(R1),JX                PUT IN CONTINUATION CHAR        15262000
         SPACE                                                          15263000
FLD105   GOIF  DCSWH,ON=DC500           IS ENTRY A DC                   15264000
         SPACE                                                          15265000
FLD110   BAL   &BAL,PRINT               PRINT COMPLETED LINE            15266000
         SPACE                                                          15267000
FLD120   LH    &LEN,HWD                 GET LENGTH AGAIN                15268000
         GOIF  JTICTL,EQ=FLD40          ICTL STATEMENT?                 15269000
         GOIF  JPRGICTL,OFF=FLD40       USE STD ICTL            OX02266 15270000
         LH    &OPT,JCNTCL              SET OUTPUT COL PTR=CONT COL     15271000
         SPACE                                                          15272000
FLD35    XC    COLSAV,COLSAV            ZEROED OUT SAVE AREA            15273000
         SET   COLOVLP,OFF              TURN OFF OVERLAP CHECK BIT      15274000
         B     FLD10                    GO MOVE REMAINING PART          15275000
FLD40    LA    R3,D16                   PUT 16 IN R3                    15276000
         B     FLD35                    GO BACK                         15277000
         EJECT                                                          15278000
* STRING                                                                15279000
*                                                                       15280000
*   EXTRACT STRINGS FROM TEXT RECORD AND INSERT THEM INTO THE           15281000
*   CURRENT PRINT LINE.                                                 15282000
*   PARAMETER - STRADR CONTAINS ADDRESS OF CURRENT STRING GROUP.THIS    15283000
*   FIELD IS UPDATED HERE,AS IS THE CARD-WITHIN-STATEMTNT COUNTER.      15284000
         SPACE                                                          15285000
STRING   LH    &SCR,CDSTMT              GET CARD-WITHIN-STMT COUNTER    15286000
         LA    &SCR,D1(,&SCR)           AND                             15287000
         STH   &SCR,CDSTMT              UPDATE IT                       15288000
         GOIF  JGEN,OFF=STR050          IS STATEMENT GENERATED          15289000
         MVI   GENFLG,GENIND            YES, INDICATE AS SUCH           15290000
         SPACE                                                          15291000
STR050   L     &SCH,STRADR              GET STRING GROUP ADDRESS        15292000
         DROP  &IPT                                                     15293000
         USING JTEXTA,&SCH              DON'T DESTROY IPT-USE SCH       15294000
         CLI   JTSTC,D0                 ANY STRINGS                     15295000
         BER   &BAL                     NO                              15296000
         SR    &SCR,&SCR                ZERO REGISTER                   15297000
         IC    &SCR,JTSTC               GET STRING COUNT                15298000
         LA    &SCH,JTSTO               POINT TO OUTPUT POINTER         15299000
STR100   SR    &LEN,&LEN                CLEAR REGISTER                  15300000
         IC    &LEN,JTSTL2              GET STRING LENGTH               15301000
         BCTR  &LEN,0                   DECREASE TO MOVE LENGTH         15302000
         SR    &OPT,&OPT                CLEAR REGISTER                  15303000
         IC    &OPT,JTSTO2              GET OUTPUT POINTER              15304000
         LA    &OPT,NAMFLD-D1(&OPT)     MAKE IT AN ABS ADDRESS          15305000
         EX    &LEN,STRMOVE             MOVE STRING TO OUTPUT           15306000
         LA    &SCH,JTSTR2+D1(&LEN)     POINT TO NEXT STRING            15307000
         BCT   R1,STR100                GO BACK IF SECOND STRING        15308000
         SPACE                                                          15309000
         ST    &SCH,STRADR              STORE UPDATED STRING POINTER    15310000
         DROP  &SCH                                                     15311000
         USING JTEXTA,&IPT              BACK TO NORMAL REGISTER         15312000
         BR    &BAL                     RETURN                          15313000
         EJECT                                                          15314000
* PRINT                                                                 15315000
*                                                                       15316000
*   THE PRINT BUFFER CONTENTS ARE PRINTED.IF THAT LINE WAS THE          15317000
*   THE LAST ON A PAGE,HEADINGS ARE WRITTEN ON NEXT PAGE.               15318000
         SPACE                                                          15319000
PRINT    ST    &BAL,PRNSAVE             SAVE LINK REGISTER              15320000
         GOIF  TWASLC,OFF=PRT120        WAS LAST STATEMENT TITLE        15321000
         L     R2,PRNSV1                RESTORE PRINT BUFFER POINTER    15322000
         SET   TWASLC,OFF               TURN OFF TITLE INDICATOR        15323000
         BR    R6                       PRINT LINE ALREADY  AVAILABLE   15324000
PRT120   BAL   &BAL,PRN600              GO GET PRINT LINE               15325000
         L     R1,LNCNT                 GET LINE COUNT                  15326000
         BCT   R1,PRT200                DECREMENT AND BRANCH IF NOT 1   15327000
PRT150   MVI   CCTRL,PEJECT             EJECT CARRIAGE CONTROL          15328000
         MVC   TITCD,JDECKID            MOVE DECK ID TO TITLE           15329000
         MVC   TITLEO,JTITLE            MOVE TITLE                      15330000
         MVC   PAGEO,PAGE               MOVE PAGE                       15331000
         LH    R1,JPAGENO               GET PAGE COUNT                  15332000
         LA    R1,D1(,R1)               INCREMENT BY 1                  15333000
         STH   R1,JPAGENO               STORE NEW COUNT                 15334000
         BAL   R6,PRN800                GO CONVERT IT FOR PRINT         15335000
         MVC   PGNO,DWORD2              MOVE TO PRINT LINE              15336000
         BAL   R6,PRN600                GO PRINT AND GET NEXT LINE      15337000
         MVI   CCTRL,P3SPACE            CARRIAGE CONTROL 3 SPACES       15338000
         MVC   SNDHDO,SNDHDR            GET SECOND HEADER               15339000
         MVC   SNDHID,JLVTMDT           GET MODULE ID AND DATE          15340000
         BAL   R6,PRN600                GO PRINT                        15341000
         MVI   CCTRL,P2SPACE            CARRIAGE CONTROL 2 SPACES       15342000
         SET   SPACECC,ON               INDICATE TOP OF PAGE            15343000
         LH    R1,JLNCT                 GET NEW LINE COUNT              15344000
PRT200   ST    R1,LNCNT                 STORE LINES LEFT ON PAGE        15345000
         L     &BAL,PRNSAVE             RESTORE LINK REGISTER           15346000
         BR    &BAL                     ..AND RETURN                    15347000
         EJECT                                                          15348000
PRNERR   GOIF  PERR,ON=PRNXIT           GO IF NOT FIRST ERR THIS STMT   15349000
         BAL   R6,PRINT                 GET POINTER TO PRINT BUFFER     15350000
         SET   PERR,ON                  REMEMBER ERROR HAS OCCURRED     15351000
         MVC   ERRLOC,ERRNOTE           MOVE ***ERROR*** TO PRINT LINE  15352000
         B     PRNXIT                   EXIT                            15353000
         SPACE 5                                                        15354000
PRNMNO   BAL   R6,PRINT                 GET PRINT BUFFER                15355000
         SET   SPACECC,OFF              RESET TOP SPACE        FX0000   15356000
         TM    JTFLGB,JGEN              IS IT GENERATED                 15357000
         BZ    PRNMNO1                  BRANCH AROUND IF NOT            15358000
         MVI   GENFLG,GENIND            PUT IN FLAG                     15359000
         SPACE                                                          15360000
PRNMNO1  L     R1,STMTN                 GET STATEMENT NUMBER            15361000
         BAL   R6,PRN800                CONVERT IT FOR PRINTING         15362000
         LR    R11,R2                   RET BUFFER ADDR TO PRINT RTN    15363000
         B     PRN200                   RETURN TO MNOTE ROUTINE         15364000
         EJECT                                                          15365000
PRNDC    SET   DCSWH,ON                 TURN ON DC SWITCH               15366000
         L     R4,OPNADR                PICK UP OPERAND POINTER         15367000
         GOIF  DCMOP,ON=DC200           IS DC COMPLETE                  15368000
         GOIF  DCCOMP,ON=DC220          IS PRINT OF RECORD COMPLETE     15369000
         B     PRNLST                   GO PRINT LEFT HALF              15370000
DC100    GOIF  DCCOMP,ON=PUNRTN              IS LIST OF RECORD COMPLETE 15371000
         GOIF  DCSTRT,OFF=LIST1,ELSE=FLD120  IS THIS FIRST LINE OF DC   15372000
DC200    GOIF  DCCOMP,ON=PRNXIT,ELSE=FLD110  EXIT IF LIST COMPLETE      15373000
DC220    GOIF  PDATA,OFF=PUNRTN,ELSE=PRNLST  IS PRINT DATA ON           15374000
DC300    GOIF  DCMOP,ON=PRNXIT               IS STATEMENT COMPLETED     15375000
         SET   DCCOMP,ON                     TURN ON LIST COMPLETE      15376000
         B     PUNRTN                        GO PUNCH DATA              15377000
DC500    SET   DCSTRT,ON                SET START LIST OF RECORD        15378000
         ST    R4,OPNADR                SAVE OPERAND POINTER            15379000
         GOIF  DCMOP,ON=FLD110          ARE WE MOPPING UP?              15380000
         TM    DCEVSW,DSSW+DXDSW        DS OR DXD?                      15381000
         BZ    PUNRTN                   ID DC GO TO PUNCH RTN           15382000
         B     PRN200                   EXIT                            15383000
         EJECT                                                          15384000
PUNRTN   GOIF  (JDECK,JLINK),NONE=PRN200 EXIT IF DECK AND LINK BOTH OFF 15385000
         TM    EESDI,BIT1+BIT2+BIT3     ARE WE IN DSECT OR COM          15386000
         BNZ   PRN200                   YES, NO PUNCH                   15387000
         TM    LHFLGS,DNTPLH            IS THERE ANY DATA TO PUNCH      15388000
         BNM   PRN200                   NO, EXIT                        15389000
         L     R2,CRDPTR                GET POINTER TO PUNCH RECORD     15390000
         USING CRDSCT,R2                ESTBLISH USING FOR PUNCH RECORD 15391000
         LH    R1,CRDCNT                GET COUNT OF BYTES IN TEXT CARD 15392000
         LTR   R1,R1                    IS IT ZERO                      15393000
         BZ    PUN300                   YES GO GET A NEW CARD           15394000
         CH    R1,=H'56'                IS CARD FULL                    15395000
         BE    PUN300                   YES GO GET A NEW CARD           15396000
         CLC   CRDVAL,LOCATN            HAS LOCATION COUNTER JUMPED     15397000
         BNE   PUN500                   NO, GO PUNCH NEW RECORD         15398000
         CLC   CRDESD,EESDI             DID ESD ID CHANGE               15399000
         BNE   PUN500                   YES                             15400000
PUN100   IC    R10,LHFLGS               GET LENGTH OF PUNCH DATA        15401000
         N     R10,=A(X'0F')            CLEAR EXTRA BITS                15402000
         AR    R1,R10                   COMPUTE NEW LENGTH              15403000
         CH    R1,=H'56'                WILL NEW DATA FIT IN THIS CARD  15404000
         BH    PUN400                   NO GO SPLIT IT                  15405000
         AH    R2,CRDCNT                POINT PAST TEXT ALREADY IN CARD 15406000
         LR    R11,R10                  SAVE LENGTH OF DATA             15407000
         BCTR  R10,0                    GET MOVE LENGTH OF INPUT        15408000
         EX    R10,CRDMVC               MOVE DATA TO CARD               15409000
         A     R11,CRDVAL               ADD TO CARD LOCATION COUNTER    15410000
         ST    R11,CRDVAL               SAVE NEW ADDRESS                15411000
         STH   R1,CRDCNT                SAVE COUNT OF TEXT BYTES        15412000
         B     PRN200                   EXIT                            15413000
PUN500   MVC   CRDLEN,CRDCNT            MOVE TEXT LENGTH                15414000
PUN300   MVC   CRDVAL,LOCATN            UPDATE CARD LOCATION COUNTER    15415000
         BAL   R6,PUN800                GO PUNCH CARD                   15416000
         SR    R1,R1                    ZERO CARD BYTE COUNT            15417000
         XC    CRDCNT,CRDCNT            INITIALIZE BYTE COUNT           15418000
         B     PUN100                   CONTINUE OUTPUT                 15419000
PUN400   LR    R4,R1                    SAVE BYTE COUNT                 15420000
         SH    R4,=H'56'                GET BYTES OVER FIT              15421000
         SR    R10,R4                   GET NUMBER OF BYTES THAT FIT    15422000
         LR    R11,R10                  SAVE COUNT                      15423000
         STH   R10,CRDLAC               SAVE NUMBER BYTES PUT THIS CARD 15424000
         BCTR  R10,0                    GET MOVE LENGTH                 15425000
         AH    R2,CRDCNT                ADD CARD COUNT                  15426000
         EX    R10,CRDMVC               MOVE PART OF INPUT TO TEXT CARD 15427000
         A     R11,CRDVAL               COMPUTE ADDRESS OF NEXT CARD    15428000
         ST    R11,CRDVAL               SAVE NEW ADDRESS                15429000
         BAL   R6,PUN800                GO PUNCH CARD                   15430000
         LH    R10,CRDLAC               GET BYTES PUT LAST CARD         15431000
         AR    R10,R7                   STEP PAST BYTES ALREADY PUT     15432000
         LR    R11,R4                   SAVE LENGTH OF DATA             15433000
         BCTR  R4,0                     GET MOVE LENGTH OF DATA         15434000
         EX    R4,CRDMV2                MOVE REMAINING OUTPUT DATA      15435000
         STH   R11,CRDCNT               SAVE NEW BYTE COUNT             15436000
         A     R11,CRDVAL               COMPUTE NEXT INPUT ADDRESS      15437000
         ST    R11,CRDVAL               SAVE NEW ADDRESS                15438000
         B     PRN200                   EXIT                            15439000
PUN800   JPUNCH SEQ=YES                 PUNCH RECORD                    15440000
         LR    R2,R11                   LOAD TEXT POINTER               15441000
         MVC   CRDID,TXTID              MOVE IDENTIFIER TO TEXT CARD    15442000
         TR    CRDTR,JTRTABLE           TRANSLATE CARD TO EXTERNAL      15443000
         ST    R11,CRDPTR               STORE IT FOR LATER USE          15444000
         MVC   CRDVLO,CRDVAL+D1         MOVE VALUE TO PRINT             15445000
         MVC   CRDESD,EESDI             MOVE TXT ESD                    15446000
         MVC   CRDLEN,=H'56'            MOVE TXT LENGTH                 15447000
         BR    R6                       RETURN TO CALLING LOCATION      15448000
TXTID    JGENIN '2TXT'                  INTERNAL TEXT ID                15449000
CRDMVC   MVC   CRDTXT(0),DCDATA         EXECUTED MOVE TO TXT CARD       15450000
         DROP  R7                       INVALIDATE THIS REGISTER        15451000
         USING X5COM,R10                ESTABLISH NEW USING             15452000
CRDMV2   MVC   CRDTXT(0),DCDATA         EXECUTED MOVE TO NEW CARD       15453000
         DROP  R10                      INVALIDATE THIS REGISTER        15454000
         USING X5COM,R7                 RE-ESTABLISH COMMON USING       15455000
         EJECT                                                          15456000
PRNPUN   GOIF  (JDECK,JLINK),NONE=PRN200  LINK OR DECK MUST BE ON       15457000
         NC    CRDCNT,CRDCNT            IS BYTES IN CARD ZERO           15458000
         BZ    PPUN10                   YES FORGET TEXT CARD            15459000
         L     R2,CRDPTR                POINT TO OUTPUT CARD            15460000
         MVC   CRDLEN,CRDCNT            MOVE NUMBER OF BYTES TO OUTPUT  15461000
         XC    CRDCNT,CRDCNT            ZERO BYTE COUNT                 15462000
PPUN10   LR    R6,R11                   SAVE PUNCH BYTE COUNT           15463000
         JPUNCH SEQ=NO                  GET PUNCH BUFFER                15464000
         BCTR  R6,0                     GET MOVE LENGTH                 15465000
         EX    R6,MOVPUN                MOVE DATA TO PUNCH BUFFER       15466000
         B     PRN200                   EXIT                            15467000
         EJECT                                                          15468000
PRNRPO   GOIF  JLIST,OFF=PRP030         LIST MUST BE ON         OX01764 15469000
         GOIF  PSTMT,OFF=PRPO25         AND PRINT MUST BE ON            15470000
         BAL   R6,PRINT                 GO GET PRINT BUFFER             15471000
         GOIF  JNOCNT,ON=PRP005         IF NOCOUNT ON THEN SKIP         15472000
         L     R1,STMTN                 GET STATEMENT NUMBER            15473000
         BAL   R6,PRN800                CONVERT IT                      15474000
         MVC   D32+D3(D5,R2),DWORD2     MOVE STMT NUM TO PRINTLINE      15475000
         SPACE                                                          15476000
PRP005   LH    R4,JTCPR                 GET COMMENTS POINTER            15477000
         AR    R4,R5                    POINT TO COMMENT FIELD          15478000
         MVC   D32+D9(D80,R2),D2(R4)    MOVE PRINT DATA OF REPRO        15479000
PRP007   GOIF  REPCARD,OFF=PRPO10       PRINT ONLY REPRO CARD   OX01764 15480000
         SET   REPCARD,OFF              YES, RESET BIT AND EXIT         15481000
         GOIF  JPRONLY,ON=PRN200        EXIT IF PRINT ONLY              15482000
         USING CRDSCT,R2                ESTABLISH PUNCH CARD USING      15483000
PRPO10   GOIF  (JDECK,JLINK),NONE=PRN200  ONE AT LEAST MUST BE ON       15484000
         GOIF  JSYSGEN,OFF=PRP015       DO WE NEED TO TEST              15485000
         GOIF  JPRESD,ON=PRN200         IF PRE ESD - EXIT               15486000
PRP015   NC    CRDCNT,CRDCNT            IS BYTES IN CARD ZERO           15487000
         BZ    PRPO20                   YES, NO CARD IN BUFFER          15488000
         L     R2,CRDPTR                POINT TO OUTPUT CARD            15489000
         MVC   CRDLEN,CRDCNT            MOVE NUMBER OF BYTES TO OUTPUT  15490000
         XC    CRDCNT,CRDCNT            ZERO BYTE COUNT                 15491000
PRPO20   JPUNCH SEQ=NO                  GET PUNCH BUFFER                15492000
         MVC   D0(D80,R11),D2(R4)       MOVE REPRO DATA                 15493000
         B     PRN200                   EXIT                            15494000
PRPO25   SET   REPCARD,OFF              CLEAR REP PRT ONLY IND          15495000
         GOIF  JSYSGEN,OFF=PRP027       IF PHASE 4 WAS SKIPPED @AZ29272 15496000
         GOIF  JPRONLY,ON=PRN200        EXIT IF PRINT ONLY     @AX16963 15497000
PRP027   EQU   *                                               @AZ29272 15498000
         LH    R4,JTCPR                 GET COMMENT POINTER             15499000
         AR    R4,R5                    POINT TO COMMENT FIELD          15500000
         B     PRPO10                   GO PUNCH                        15501000
PRP030   LH    R4,JTCPR                 GET COMMENT POINTER     OX01764 15502000
         AR    R4,R5                    POINT TO COMMENT FIELD  OX01764 15503000
         B     PRP007                                           OX01764 15504000
         EJECT                                                          15505000
MOVPUN   MVC   D0(0,R11),D0(R4)         EXECUTED MOVE OF PUNCH CARD     15506000
MOVE     MVC   D0(0,&OPT),FIELD         EXECUTED MOVE-FIELD TO PRINT    15507000
         DROP  &IPT                                                     15508000
         USING JTEXTA,&SCH              USE SCH FOR STRING MOVE         15509000
STRMOVE  MVC   D0(0,&OPT),JTSTR2        EXECUTED - STRING TO OUTPUT     15510000
PAGE     JGENIN 'PAGE'                                                  15511000
SNDHDR   JGENIN 'LOC  OBJECT CODE    ADDR1 ADDR2  STMT   SOURCE STATEMEX15512000
               NT'                      SECOND HEADER IN INTERNAL CODE  15513000
ERRNOTE  JGENIN '*** ERROR ***'         TOO WELL KNOWN TO BE EXPLAINED  15514000
ZMASK    DC    40X'0F'                  MASK TO REMOVE ZONE BITS        15515000
         JPATCH X5P00,8A2               5% PATCH AREA                   15516000
         END                                                            15517000
./ ADD NAME=IFNX6A                                                      15518000
         JHEAD 'POST PROCESSOR PHASE',                                 *15519000
               PHASEID=X6A,                                            *15520000
               LEVEL=10                                                 15521000
*FUNCTION/OPERATION-                                                  * 15522000
*   THE POST PROCESSOR PHASE SORTS, FORMATS, AND WRITES ON PUNCH/LINK * 15523000
*   FILE(S) THE RELOCATION DICTIONARY (RLD) TO THE DESIRED FORMAT     * 15524000
*   REQUIRED BY THE LINKAGE EDITOR.  THE PHASE ALSO SORTS, FORMATS,   * 15525000
*   AND WRITES OUT ON PRINT FILE THE SYMBOL CROSS REFERENCE, AND THE  * 15526000
*   LITERAL CROSS REFERENCE.                                          * 15527000
*                                                                     * 15528000
*ENTRY POINT-                                                         * 15529000
*        PPENT                                                        * 15530000
*                                                                     * 15531000
*INPUT-                                                               * 15532000
*   INPUT FROM 'JINFILE'.                                             * 15533000
*   RLD RECORDS FORMAT --                                             * 15534000
*   FIELD             BYTES                                           * 15535000
*   RECORD LENGTH     2                                               * 15536000
*   (NOT USED)        2                                               * 15537000
*   RECORD TYPE       2                                               * 15538000
*   POSITION ESD/ID   2                                               * 15539000
*   RELOCATION ESD/ID 2                                               * 15540000
*   SYMBOL ADDRESS    3                                               * 15541000
*   FLAG              1                                               * 15542000
*   BITS                                                              * 15543000
*   0-1  00                                                           * 15544000
*   2-3  00  A-, Y-, Q-TYPE ADDRESS CONSTANT                          * 15545000
*        01  V TYPE ADDRESS CONSTANT                                  * 15546000
*        11 CXD                                                       * 15547000
*   4-5      LENGTH OF ADDRESS CONSTANT MINUS ONE                     * 15548000
*   6        EXD SIGN 0=PLUS, 1=MINUS                                 * 15549000
*   7    1   NEXT ENTRY HAS SAME POSITION AND RELOCATION ID           * 15550000
*        0   NEXT ENTRY HAS DIFFERENT POSITION AND/OR RELOCATION ID   * 15551000
*                                                                     * 15552000
*   XREF RECORDS FORMAT --                                            * 15553000
*   FIELD             BYTES                                           * 15554000
*   RECORD LENGTH       2                                             * 15555000
*   (NOT USED)        2                                               * 15556000
*   RECORD TYPE         2                                             * 15557000
*   SYMBOL              8                                             * 15558000
*   FLAGS               1                                             * 15559000
*   STATEMENT NUMBER    2                                             * 15560000
*   LENGTH              2                                             * 15561000
*   ASSEMBLED ORIGIN    4                                             * 15562000
*                                                                     * 15563000
*   RECORD FORMAT FOR LITERAL PER SE                                  * 15564000
*   FIELD              BYTES                                          * 15565000
*   RECORD LENGTH       2                                             * 15566000
*   (NOT USED)        2                                               * 15567000
*   RECORD TYPE         2                                             * 15568000
*   LITERAL             VARIABLE                                      * 15569000
*                                                                     * 15570000
*   LITERAL CROSS REFERENCE FORMATS                                   * 15571000
*   FIELD              BYTES                                          * 15572000
*   RECORD LENGTH       2                                             * 15573000
*   (NOT USED)          2                                             * 15574000
*   RECORD TYPE         2                                             * 15575000
*   LITERAL POOL ID     8                                             * 15576000
*   FLAGS               1                                             * 15577000
*   STATEMENT NUMBER    2                                             * 15578000
*   ENTRIES AFTER THIS POINT ARE FOR LITERAL XREF DEFINITION          * 15579000
*   RECORD ONLY.                                                      * 15580000
*   ASSEMBLED ORIGIN    4                                             * 15581000
*   N/P VALUE           L'JNOTEVAL                                    * 15582000
*                                                                     * 15583000
*OUTPUT-                                                              * 15584000
*   RLD RECORDS ARE PUNCHED AND/OR LINKED INTO PUNCH/LINK FILE(S).    * 15585000
*   SYMBOL/LITERAL CROSS REFERENCE RECORDS ARE WRITTEN ONTO PRINT FILE. 15586000
*                                                                     * 15587000
*   JOUTFILE AND FILE 2 ARE USED AS SORT/MERGE FILES AT SORT/MERGE TIME 15588000
*                                                                     * 15589000
*EXTERNAL ROUTINE-                                                    * 15590000
*   N/A                                                               * 15591000
*                                                                     * 15592000
*EXIT, NORMAL-                                                        * 15593000
*        JRETURN                                                      * 15594000
*                                                                     * 15595000
*EXITS, ERROR-                                                        * 15596000
*   N/A                                                               * 15597000
*TABLES/WORK AREAS-                                                   * 15598000
*   SORT AREA SIZE VARIES FROM 'MINCNT' BYTES TO 'MAXCNT' BYTES WITH  * 15599000
*   REGISTER 'SORTPTR' POINTS TO POINTERS AREA AND REGISTER 'DATAPTR' * 15600000
*   POINTS TO DATA AREA.                                              * 15601000
*   INPUT/OUTPUT BUFFERS ARE DYNAMICALLY LOCATED ABOVE THE EXECUTABLE * 15602000
*   CODE OF THIS PHASE WITH REGISTER R5 POINTS TO INPUT RECORD,       * 15603000
*   REGISTER 'LOUTNDX' POINTS TO PRINT OUTPUT RECORD, AND REGISTER    * 15604000
*   'COUTNDX' POINTS TO CARD OUTPUT RECORD.                           * 15605000
*                                                                     * 15606000
*ATTRIBUTES-                                                          * 15607000
*   REFRESHABLE                                                       * 15608000
*                                                                     * 15609000
*NOTES-                                                               * 15610000
*   N/A                                                               * 15611000
         EJECT                                                          15612000
         COPY  JCOMMON                                                  15613000
         EJECT                                                          15614000
         IECTDECB ,                     DECB MAPPING           FX0000   15615000
         EJECT                                                 FX0000   15616000
         DCBD  DSORG=(PS,PO),DEVD=(DA)  DCB MAPPING            FX0000   15617000
         EJECT                                                 FX0000   15618000
******************* COMMON AREA FOR POST PROCESSOR ******************** 15619000
X6ACOMM  DSECT                          COMMON FOR X6A                  15620000
         USING X6ACOMM,R7                                               15621000
STRTCOM  EQU   *                        START OF X6A COMMON             15622000
PPSW     DSW   RENT,                    RE-ENTRY TO SPILL ROUTINE      X15623000
               DRDCHK,                  CHECK DUMMY READ               X15624000
               FSW,                     FIRST TIME SWTICH              P15625000
               EOFSW,                   EOF                            P15626000
               HEADOUT,                 HEADER HAS JUST BEEN PRINTED   P15627000
               PROCRLD,                 PROCESSING RLD RECORDS         P15628000
               PROCXRF,                 PROCESSING XREF RECORDS        P15629000
               PROCLIT                  PROCESSING LITERAL XREF RECORDS 15630000
PPSWI    DSW   JINREAD,                 READ(ON)/WRITE(OFF) ON JINFILE X15631000
               LASTDEF,                 LAST XREF REC A DEF REC        X15632000
               LASTREC,                 LAST REC TO OUTPUT             X15633000
               ENDSTR1,                 END OF STRING ON 1             X15634000
               ENDSTR2,                 END OF STRING ON 2             X15635000
               FIRST,                   FIRST RLD PRINT        @OY06558X15636000
               HEADPEND,                IND XREF HEADER PENDING@AZ28946X15637000
               LINKSW                   ROUTER FOR PRINT RUTINE@AZ18946 15638000
CURFLE   DS    3D                       FILE 1                          15639000
GNBLK1   EQU   CURFLE+2                 JINFILE ID                      15640000
CFL1CC   EQU   GNBLK1+2                 STRING (GP) COUNT               15641000
CFL1VV   EQU   CFL1CC+2                 ARGUMENT                        15642000
CURFLE2  EQU   CFL1VV+2                 FILE 2                          15643000
GNBLK2   EQU   CURFLE2+2                JINFILE ID                      15644000
CFL2CC   EQU   GNBLK2+2                 COUNT                           15645000
CFL2VV   EQU   CFL2CC+2                 ARGUMENT                        15646000
CURFLE3  EQU   CFL2VV+2                 FILE 3                          15647000
GNBLK3   EQU   CURFLE3+2                JINFILE ID                      15648000
CFL3CC   EQU   GNBLK3+2                 COUNT                           15649000
CFL3VV   EQU   CFL3CC+2                 ARGUMENT                        15650000
CHKFILE  DS    H                        FILE YET TO BE CHECKED          15651000
RECNUM   DS    H                        NUMBER OF RECORDS               15652000
STMTNUM  DS    F                        XREF STATEMENT NUMBER           15653000
STMTN2   EQU   STMTNUM+2                                                15654000
RTNSV2   DS    F                                                        15655000
NEXTREC  DS    F                                                        15656000
RTNSV1   DS    F                                                        15657000
MRECSV   DS    F                        MERGE RECORD ADDRESS SAVED      15658000
RTNSV    DS    F                        RTN SAVE AREA                   15659000
RFSAVE   DS    2F                       REG SAVE AREA                   15660000
R15SAVE  DS    F                        R15 SAVE AREA                   15661000
SAVEALL  DS    16F                                                      15662000
BUFFER   DC    A(0)                     1                               15663000
         DC    A(0)                     2                               15664000
BUFEND1  DC    A(0)                     3                               15665000
BUFFER2  DC    A(0)                     4                               15666000
         DC    A(0)                     5                               15667000
BUFEND2  DC    A(0)                     6                               15668000
BUFFER3  DC    A(0)                     7                               15669000
         DC    A(0)                     8                               15670000
BUFEND3  DC    A(0)                     9                               15671000
BUFFER4  DC    A(0)                     10                              15672000
         DC    A(0)                     11                              15673000
BUFEND4  DC    A(0)                     12                              15674000
BUFFER5  DC    A(0)                     13                              15675000
         DC    A(0)                     14                              15676000
BUFEND5  DC    A(0)                     15                              15677000
BUFFER6  DC    A(0)                     16                              15678000
         DC    A(0)                     17.                             15679000
BUFEND6  DC    A(0)                     18                              15680000
BUFNDX   DS    F                        CURR REC IN CURR O/P BUFFER     15681000
JINFLP   DS    F                        JINFILE IN INDEX SAVED          15682000
SORTPTR  DS    F                        SORT AREA POINTER               15683000
DATAPTR  DS    F                        DATA AREA POINTER               15684000
R1SAVE   DS    F                        R1 SAVE                         15685000
LOUTSV   DS    2F                       LOUTNDX SAVED                   15686000
XRFPSV   EQU   LOUTSV+4                 XREF REF NEXT AVAIL LOC         15687000
LNCTRSV  DS    F                        LINE COUNTER SAVED              15688000
RTADDR2  DS    F                        RTN SAVED                       15689000
PCHSAVE  DS    F                        PUNCH BUFFER POINTER            15690000
FWORD    DS    F                        WORK AREAS                      15691000
SAVSYM   DS    D                        XREF SYMBOL SAVE AREA           15692000
UNDFSYM  DS    D                        XREF UNDEFINED SYMBOL SAVE AREA 15693000
NOTESV   DS    CL(L'JNOTEVAL)           N/P SAVE AREA                   15694000
DATAAND  DS    F                                                        15695000
LLOCTRSV DS    F                        LITERAL LOCTR SAVED             15696000
SAVE2B   DS CL2                         OVERLAP BYTES SAVED             15697000
         DS    0D                                                       15698000
UNPKAREA DS    CL15                     UNPACK AREA                     15699000
         ORG   UNPKAREA                 REDEFINE                        15700000
UPPOS    DS    CL4                      POSITIONAL ID                   15701000
UPREL    DS    CL4                      RELATIONAL ID                   15702000
UPVAL    DS    CL6                      ASSEMBLED ORIGIN                15703000
UPFLG    DS    CL2                      FLAGS                           15704000
UPFLGN   EQU   UPFLG+1                                                  15705000
         ORG   UNPKAREA                 REDEFINE                        15706000
CVDCML   DS    D                        CONVERT INTO DECIMAL            15707000
UPDCML   EQU   CVDCML+5                 UNPACK 3 BYTES                  15708000
UPXRL    EQU   *-UPDCML                 LENGTH OF 3                     15709000
         ORG   UPVAL+2                  REDEFINE                        15710000
UPX      DS    CL5                      INTO 5-BYTE AREA                15711000
         ORG   UNPKAREA                 REDEFINE                        15712000
UPXVAL   DS    CL9                      XREF VALUE UNPACK AREA          15713000
         ORG                                                            15714000
RTADDR   DS    3D                       SAVE AREA                       15715000
RLDHLD   DS    0CL8                     RLD HOLD AREA                   15716000
RELHLD   DS    CL2                      RELOCATION I.D.                 15717000
POSHLD   DS    CL2                      POSITION I.D.                   15718000
FLGHLD   DS    C                        FLAG                            15719000
ADDRHLD  DS    CL3                      SYMBOL ADDRESS                  15720000
ESDCOMP  DS    0CL4                     ESDID SAVE AREA                 15721000
RELTST   DS    CL2                      RELOCATION I.D.                 15722000
POSTST   DS    CL2                      POSITION I.D.                   15723000
XLDSV    DS    CL20                     LITERAL SAVE AREA               15724000
UPXSV    DS    CL5                      UNDEF SYM STMT NUMBER SAVED     15725000
RECSAVE  DS    CL(121)                  SAVE AREA FOR XREF REC @AZ28946 15726000
         EJECT                                                          15727000
*************************************** EQUATE TABLE ****************** 15728000
LBASE    EQU   2                        LOWER DATA ITEM REGISTER        15729000
SINDEX   EQU   2                        SORT AREA INDEX REG             15730000
COUTNDX  EQU   5                        CARD OUTPUT POINTER             15731000
XRFPTR   EQU   3                        XREF REF ENTRY POINT            15732000
HBASE    EQU   3                        UPPER DATA ITEM REGISTER        15733000
DINDEX   EQU   3                        DATA AREA INDEX REG             15734000
LOUTNDX  EQU   2                        LIST OUTPUT POINTER             15735000
RECCTR   EQU   4                        RECORD COUNTER                  15736000
SRTNTRY  EQU   4                        SORT AREA ENTRY LENGTH          15737000
LINCTR   EQU   RECCTR                   LINE COUNTER                    15738000
RLREG    EQU   5                        RECORD LENGTH REGISTER          15739000
RTN      EQU   6                        RETURN LINKAGE                  15740000
PARM1    EQU   10                       PARAMETER REG 1                 15741000
PARM2    EQU   11                       PARAMETER REG 2                 15742000
LINK     EQU   12                       LINKAGE                         15743000
RLDCNT   EQU   14                       RLD BYTE COUNT                  15744000
HPOINT   EQU   14                       ADDRESS OF UPPER DATA ITEM      15745000
LPOINT   EQU   15                       ADDRESS OF LOWER DATA ITEM      15746000
SAMEID   EQU   1                        XREF DEFINITION ID              15747000
MINCNT   EQU   127                      MINIMUM CORE IN DOUBLE WORDS    15748000
MAXCNT   EQU   4095                     MAXIMUM CORE IN DOUBLE WORDS    15749000
MASKLEN  EQU   4                        MASK LENGTH FOR PAGE COUNT      15750000
XBLANK   EQU   X'40'                    EXTERNAL BLANK                  15751000
JTEOF    EQU   X'FF'                    INTERNAL EOF OP CODE            15752000
JPSOP    EQU   X'80'                                                    15753000
MRGFLE1  EQU   JOUTFILE                 MERGE FILE 1                    15754000
MRGFLE2  EQU   FILE2                    MERGE FILE 2                    15755000
ENDCOMM  DS    0D                       END OF X6A COMMON               15756000
         EJECT                                                          15757000
*************************************** OUTPUT RECORD FORMATS ********* 15758000
RPRINT   DSECT                          RLD PRINT RECORD FORMAT         15759000
         USING RPRINT,LOUTNDX                                           15760000
RCNTRL   DS    C                        RLD PRINT CONTROL BYTE          15761000
         DS    CL1                                                      15762000
POSOUT   DS    CL4                      POSITION ESD/ID                 15763000
         DS    CL5                                                      15764000
RELOUT   DS    CL4                      RELOCATION ESD/ID               15765000
         DS    CL6                                                      15766000
FLGOUT   DS    CL2                      RLD FLAG                        15767000
         DS    CL5                                                      15768000
VALOUT   DS    CL6                      RLD SYMBOL ADDRESS              15769000
         DS    CL87                                                     15770000
         SPACE                                                          15771000
         ORG   RCNTRL                   XREF PRINT RECORD FORMAT        15772000
XCNTRL   DS    C                        XREF PRINT CONTROL BYTE         15773000
XSYMOUT  DS    CL8                      XREF SYMBOL                     15774000
         DS    C                                                        15775000
XLENOUT  DS    CL5                      LENGTH OF XREF                  15776000
         DS    C                                                        15777000
XVALOUT  DS    CL8                      VALUE OF XREF                   15778000
         DS    C                                                        15779000
XDEFOUT  DS    CL5                      ADDRESS WHERE XREF DEFINED      15780000
LITDL    EQU   *-XLENOUT                                                15781000
XDE      DS    CL2                                                      15782000
XDEFLN   EQU   *-XCNTRL                                                 15783000
XRFREF   DS    CL89                     REFERENCES TO SYMBOL            15784000
XPRTND   EQU   *                                                        15785000
         ORG   XRFREF                                                   15786000
XRFENT   DS    CL5                      XREF REFERENCE ENTRY            15787000
         DS    C                        SEPARATOR                       15788000
XRENTL   EQU   *-XRFENT                                                 15789000
         SPACE                                                          15790000
         ORG   XCNTRL                   LIT XREF DEF PRINT RECORD FMT   15791000
LCNTRL   DS    C                        LIT XREF CONTROL CHAR           15792000
LITSYM   EQU   *                        LITERAL XREF DEFINITION         15793000
LITSYM5  EQU   LITSYM+5                                                 15794000
         ORG                                                            15795000
XRL      EQU   *-XCNTRL                                                 15796000
         SPACE                                                          15797000
         ORG   RCNTRL                   LISTING HEADER FORMATS          15798000
CONTROL  DBV   ,                        LIST CONTROL CHARACTER VALUES  X15799000
               EJBYTE(0),               EJECT                          X15800000
               SPACE1(EJBYTE+1),        SINGLE SPACE                   X15801000
               SPACE2(SPACE1+1),        DOUBLE SPACE                   X15802000
               SPACE3(SPACE2+1)         TRIPPLE SPACE                   15803000
TITLE    DS    CL4                      TITLE                           15804000
         DS    CL38                     BLANKS                          15805000
LHDPTR   DS    CL8                      LIT XREF HEADING PTR            15806000
HDGPTR   DS    CL21                     RLD OR XREF PAGE IDENTIFIER     15807000
         DS    CL25                                                     15808000
DTEPTR   DS    CL15                     DATE                            15809000
PGEPTR   DS    CL4                      PAGE                            15810000
PGENUM   DS    CL5                      PAGE NUMBER                     15811000
         SPACE 3                                                        15812000
***************                                                         15813000
RCARD    DSECT                          RLD PUNCH RECORD FORMAT         15814000
         USING RCARD,COUTNDX                                            15815000
CARDID   DS    C                        RLD CARD LAYOUT                 15816000
RLDNAM   DS    CL3                      RLD NAME                        15817000
         DS    CL6                                                      15818000
RLDBYT   DS    CL2                      NUMBER OF BYTES IN DATA FIELD   15819000
         DS    CL4                                                      15820000
RLDFLD   DS    CL56                     RLD DATA FIELD (VARIABLE)       15821000
DECKID   DS    CL4                      ID AND                          15822000
SEQNUM   DS    CL4                      SEQUENCE FIELD                  15823000
RCARDL   EQU   *-CARDID                                                 15824000
         SPACE 3                                                        15825000
*************************************** INPUT RECORD FORMATS ********** 15826000
         COPY  RXLFMTS                                                  15827000
         EJECT                                                          15828000
************************************************************            15829000
*   ENTRY TO POST PROCESSOR                                             15830000
************************************************************            15831000
         JCSECT (X6A00)                                                 15832000
* VS1 RELEASE 2.6 CHANGES                                               15833000
*C381500-382000                                                 OX00413 15834000
*C280000                                                        OX00106 15835000
*A284700-284800                                                 OX00106 15836000
*A722064                                                        OX02645 15837000
*C722060                                                        OX02645 15838000
*C381500                                                        OX02955 15839000
*D382000                                                        OX02955 15840000
*D684400                                                       @OY06121 15841000
*A803400,803500                                                @OY07206 15842000
*A076920,789000,789300                                         @OY06558 15843000
*C789400                                                       @OY06558 15844000
*A613520-613540                                                @OY08038 15845000
*C975800                                                       @OY10363 15846000
*C284700                                                       @OY08064 15847000
*C722350                                                       @AX14198 15848000
*A613504-613516                                                @AX14816 15849000
*A613536-613599,613820-613849                                  @AZ11958 15850000
*D613520,613540                                                @AZ11958 15851000
*A076930,713000-713270,714800-715200,137300,751900             @AZ28946 15852000
*A750500-751030,613509-613516,076950,615850-615880             @AZ28946 15853000
*C613508                                                       @AZ28946 15854000
         JMODID                                                         15855000
PPENT    JSAVE                                                          15856000
         JENTRY (X6A01=PPENT)                                           15857000
         EJECT                                                          15858000
************************************************************            15859000
*   PHASE INITIALIZATION                                                15860000
************************************************************            15861000
         GOIF  (JRLDCHK,JXREFCHK),OFF=RETURN  RETURN TO CONTROLLER      15862000
         LA    R10,(ENDCOMM-STRTCOM+7)/8  SIZE OF X6ACOMM               15863000
         JGETCORE DBL=(R10)             GET CORE FOR COMMON AREA        15864000
         LR    R7,R10                   BASE FOR X6A COMMON AREA        15865000
         BCTR  PARM2,0                  MAKE IT MOVE LENGTH             15866000
         XC    STRTCOM(255),STRTCOM          CLEAR COMMON AREA          15867000
         S     PARM2,F255                                               15868000
         EX    PARM2,CLRCOM             CLEAR COMMON AREA               15869000
         LH    R3,MRGFLE1               INITIALIZE MERGE FILE SWITCHES  15870000
         LA    R4,MRGFLE2                                               15871000
         STH   R3,CURFLE                                                15872000
         STH   R4,CURFLE2                                               15873000
         LH    R3,JINFILE                                               15874000
         STH   R3,CURFLE3                                               15875000
         MVI   GNBLK3,X'80'             JINFILE ID                      15876000
************************************************************            15877000
*   BUFFER AND SORT AREA INITIALIZATION                                 15878000
************************************************************            15879000
X6AENT   EQU   *                                                        15880000
         GOIF  (JDECK,JLINK,JLIST),OFF=RETRN                            15881000
         LH    R3,JMAXRL                ASSURE MINIMUM CORE AVAILABLE   15882000
         LR    R4,R3                      IS JMAXRL*2 PLUS ITS SORTPTR  15883000
         AR    R3,R4                      AREA AND MAXIMUM OF 64K BYTES 15884000
         SR    R2,R2                      WHICH CAN STILL BE EXTENDED   15885000
         LA    R5,RLDND                                                 15886000
         DR    R2,R5                                                    15887000
         SLL   R3,D2                                                    15888000
         AR    R3,R4                    .                               15889000
         AR    R3,R4                    .                               15890000
         AR    R3,R4                    .                               15891000
         AR    R3,R4                    .                               15892000
         AR    R3,R4                    .                               15893000
         AR    R3,R4                    .                               15894000
         SRL   R3,D3                    MAKE IT DOUBLE WORD             15895000
         L     R11,K72D                                                 15896000
         JGETCORE MINDBL=(R3),MAXDBL=(R11)                              15897000
         LA    R5,BUFFER                                                15898000
         LA    R6,D6                    LOOP 6 TIMES                    15899000
INIT     ST    PARM1,D0(,R5)            BUFFER BEGIN                    15900000
         STH   R4,D4(,R5)               JMAXRL                          15901000
         SR    PARM2,R4                                                 15902000
         AR    PARM1,R4                                                 15903000
         ST    PARM1,D8(,R5)            BUFFER END                      15904000
         LA    R5,D12(,R5)                                              15905000
         BCT   R6,INIT                  ITERATE TILL DONE               15906000
         SR    PARM1,R4                 BACK UP                         15907000
         SR    PARM1,R4                 BACK UP                         15908000
         AR    PARM2,R4                 BACK UP                         15909000
         AR    PARM2,R4                 BACK UP                         15910000
         ST    PARM1,SORTPTR            SET START POINT OF SORT AREA    15911000
         LR    R3,PARM2                 GET AVAILABLE CORE SIZE         15912000
         SR    R2,R2                                                    15913000
         LA    R5,XRFND+SRTNTRY         COMPUTE SORT AREA SIZE          15914000
         LH    R14,JLITLNG                                              15915000
         LTR   R14,R14                                                  15916000
         BZ    INIT10                   NO LITERALS                     15917000
         LA    R5,SRTNTRY+LXEND+D3+D1(,R14) COMPUTE DIVISOR             15918000
         N     R5,=X'FFFFFFFC'          WITH FULL-WORD ALIGNMENT.       15919000
INIT10   EQU   *                                                        15920000
         DR    R2,R5                    FIND LENGTH OF                  15921000
         SLL   R3,D2                    SORT AREA AND                   15922000
         AR    R3,PARM1                 SET POINTER TO DATA AREA        15923000
         ST    R3,DATAPTR               AND SAVE                        15924000
         ST    R3,XRFPSV                CREATE DUMMY CONDITION          15925000
         LA    PARM2,D0(PARM2,PARM1)                                    15926000
         ST    PARM2,DATAAND            END OF SORT AREA                15927000
         L     R3,BUFFER3                                               15928000
         LA    R3,D6(,R3)               OVER HEADER                     15929000
         ST    R3,BUFNDX                AND SAVE IT                     15930000
         SET   FSW,ON                                                   15931000
X6AREAD  EQU   *                                                        15932000
         SR    RECCTR,RECCTR            INITIAL RECORD COUNT IS ZERO    15933000
         LM    SINDEX,DINDEX,SORTPTR    GET POINTERS                    15934000
         SPACE                                                          15935000
         USING PPIN,PARM2                                               15936000
         BAL   R6,RDPHYREC              READ PHYSICAL RECORD            15937000
         EJECT                                                          15938000
************************************************************            15939000
*   GTRGTR ROUTINE READS DATA FROM JINFILE AND SELECTIVELY MOVES        15940000
*   RECORDS INTO SORT AREA.                                             15941000
*   BUFFERS USED ARE BUFFER AND BUFFER2.                                15942000
************************************************************            15943000
GTRGTR   BAL   R12,BUFIN                READ RECORDS                    15944000
GTRGTR0  L     R9,DATAPTR               SET UP REGISTERS                15945000
         L     R10,BUFEND2                                              15946000
GTRGTR1  LH    R15,PPRLI                                                15947000
         CLI   PPIOC,XRFTYPE            SELECT THE FOLLOWING            15948000
         BE    GTRGTR15                   THREE TYPES OF RECORDS        15949000
         CLI   PPIOC,RLDTYPE              INTO SORT AREA, AND THROW     15950000
         BE    GTRGTR02                    AWAY OTHERWISE       OX00106 15951000
         CLI   PPIOC,LITTYPE                                            15952000
         BE    GTRGTR5                  LITERAL                         15953000
         CLI   PPIOC,JTEOF              DON'T LET EOF RECORD            15954000
         BNE   GTRGTR4                    SLIP THROUGH                  15955000
         SET   EOFSW,ON                                                 15956000
         B     GTRGTR3                  ITS AS GOOD AS SORT AREA FULL   15957000
GTRGTR02 NI    RELID,X'F3'                                     @OY08064 15958000
         B     GTRGTR2                                          OX00106 15959000
GTRGTR15 EQU   *                                                        15960000
*                                       DON'T PICK UP XREF RECORD IF    15961000
         GOIF  (JLIST,JXREF),NOTALL=GTRGTR4    NO LIST/XREF OPTIONS     15962000
         TR    XRFSYM,JTRTABLE                                          15963000
GTRGTR2  BCTR  R15,0                                                    15964000
         EX    R15,MOVREC               MOVE TO SORT AREA               15965000
         LA    R15,D1(,R15)               AND                           15966000
         ST    DINDEX,D0(,SINDEX)         SET UP ITS POINTER,           15967000
GTRGTR25 LA    SINDEX,SRTNTRY(,SINDEX)                                  15968000
         LA    RECCTR,D1(,RECCTR)       RECORD COUNT                    15969000
         AR    DINDEX,R15                                               15970000
         CR    SINDEX,R9                TEST IF SORT AREA FULL          15971000
         BL    GTRGTR4                  NO, CONTINUE                    15972000
         AR    PARM2,R15                YES                             15973000
         CR    PARM2,R10                TEST IF BUFFER FULL             15974000
         BL    GTRGTR3                  NOT YET                         15975000
         BAL   R12,BUFIN                GET NEXT BUFFER                 15976000
GTRGTR3  ST    PARM2,JINFLP             SAVE NEXT RECORD LOCATION       15977000
         STH   RECCTR,RECNUM                                            15978000
         CLI   PPIOC,JTEOF              END OF FILE                     15979000
         BNE   X6ARD                    GO TO SORT IF NOT EOF           15980000
         SET   EOFSW,ON                 IND END OF FILE                 15981000
         B     X6ARD                    GO TO SORT                      15982000
GTRGTR4  AR    PARM2,R15                TEST IF                         15983000
         CR    PARM2,R10                  BUFFER FULL                   15984000
         BL    GTRGTR1                  NOT YET                         15985000
         B     GTRGTR                   YES                             15986000
GTRGTR5  GOIF  (JLIST,JXREF),NOTALL=GTRGTR4                             15987000
         C     R15,F255                 LITERAL RECORD MIGHT GO         15988000
         BNH   GTRGTR2                    OVER 255 CHARACTERS. SO       15989000
         MVC   D0(255,DINDEX),PPRLI       WATCH OUT HOW YOU MOVE IT     15990000
         S     R15,F255                                                 15991000
         ST    DINDEX,D0(,SINDEX)                                       15992000
         A     DINDEX,F255                                              15993000
         A     PARM2,F255                                               15994000
         EX    R15,MOVREC                                               15995000
         B     GTRGTR25                 CONTINUE                        15996000
MOVREC   MVC   D0(0,DINDEX),PPRLI       OFF-THE-LINE MOVE               15997000
X6ARD    EQU   *                                                        15998000
         LTR   RECCTR,RECCTR            MUST BE EOF IF RECCTR = 0       15999000
         BP    X6ASRT                   NOT ZERO                        16000000
*                                              IF NOT 1ST TIME AND      16001000
         GOIF  (EOFSW,FSW),NOTALL=X6ARDX         EOF THEN FINISH SORT   16002000
         LH    PARM1,JINFILE            GET FILE ID                     16003000
         JCHECK FILE=(R10)              CHECK THE LAST INPUT READ       16004000
         B     RETRN                    NO RECORDS, SO WE'RE DONE       16005000
         EJECT                                                          16006000
X6ASRT   EQU   *                                                        16007000
************************************************************            16008000
*   THIS ROUTINE LINKS TO SORT ROUTINE, SELECTS AN OUTPUT FILE FOR      16009000
*   THE SORTED DATA ACCORDING TO THE PREDETERMINED NUMBER OF STRINGS    16010000
*   TO BE OUTPUT ON THE TWO OUTPUT FILES - CURFLE AND CURFLE2.          16011000
*   IT ALSO PADS THE OUTPUT FILES, IF NECESSARY, TO THE NUMBER OF       16012000
*   STRINGS THAT WILL SATISFY THE REQUIREMENT OF THE CASCADE MERGE.     16013000
************************************************************            16014000
         BAL   RTN,SORT                 SORT RECORDS IN BUFFER          16015000
         GOIF  EOFSW,ON=X6ARDX          DID WE HIT EOF SO FAR           16016000
         SR    RECCTR,RECCTR            NO                              16017000
         LM    SINDEX,DINDEX,SORTPTR    GO BACK TO READ IN              16018000
         L     PARM2,JINFLP               NEXT SORT AREA FULL           16019000
         B     GTRGTR0                    OF RECORDS                    16020000
X6ARDX   EQU   *                                                        16021000
*        END OF SORT. PAD BOTH FILES IF NECESSARY.                      16022000
         CLC   CFL1CC(D2),CFL1VV        HASH OUT HOW MANY STRINGS       16023000
         BL    RDX10                      WE NEED ON EITHER OF FX0000   16024000
         CLC   CFL2CC(D2),CFL2VV          THE TWO FILES, AND HOW MANY   16025000
         BL    RDX20                      HAVE WE GOT ON EACH OFX0000   16026000
         B     RDX40                      HAVE WE GOT ON EACH OFX0000   16027000
                                                       SPACE , FX0000   16028000
RDX10    DS    0H                                              FX0000   16029000
         BAL   R6,PADDING1                                     FX0000   16030000
         B     X6ARDX                                          FX0000   16031000
                                                       SPACE , FX0000   16032000
RDX20    DS    0H                                              FX0000   16033000
         BAL   R6,PADDING                                      FX0000   16034000
         B     X6ARDX                                          FX0000   16035000
                                                       SPACE , FX0000   16036000
RDX40    SET   EOFSW,OFF                                                16037000
         LH    PARM1,CHKFILE                                            16038000
         JCHECK FILE=(R10)              CHK LAST OUTPUT FOR COMPLETION  16039000
         LH    R10,JINFILE                                              16040000
         JNOTE FILE=(R10)               NOTE LAST RECORD READ           16041000
         MVC   NOTESV(L'JNOTEVAL),JNOTEVAL  SAVE NOTED VALUE            16042000
         LH    R10,CURFLE                                               16043000
         JPOINT FILE=(R10),NEXT=START   REPOSITION ALL FILES            16044000
         LH    R10,CURFLE2                TO START EXCEPT               16045000
         JPOINT FILE=(R10),NEXT=START     JINFILE                       16046000
         LH    R0,CFL1CC                                                16047000
         LH    R1,CFL2CC                                                16048000
         B     MERGE                    ENTER MERGE STAGE               16049000
         SPACE                                                          16050000
PADDING  XC    CURFLE(D8),CURFLE2       THIS IS TO PAD ONE STRING ON    16051000
         XC    CURFLE2(D8),CURFLE         EITHER OF THE TWO FILES, BUT  16052000
         XC    CURFLE(D8),CURFLE2         CHECK LAST OUTPUT FOR         16053000
PADDING1 LH    PARM1,CHKFILE              COMPLETION FIRST              16054000
         JCHECK FILE=(R10)                                              16055000
         L     R2,BUFFER3                                               16056000
         MVC   D6(L'EOFREC,R2),EOFREC                                   16057000
         LH    R3,H1                                                    16058000
         STH   R3,D2(,R2)               LAST BLK IN GP                  16059000
         STH   R3,D4(,R2)               ONE RECORD IN BLK               16060000
         LA    R3,L'EOFREC+D6                                           16061000
         STH   R3,D0(,R2)               RECORD LENGTH                   16062000
         LH    PARM1,CURFLE                                             16063000
         LA    PARM2,BUFFER3                                            16064000
         JWRITE FILE=(R10),PARM=(R11)   PADDED BLK                      16065000
         STH   R10,CHKFILE                                              16066000
         LH    R9,CFL1CC                                                16067000
         LA    R9,D1(,R9)               UP ONE STRING (GP)              16068000
         STH   R9,CFL1CC                                                16069000
         BR    RTN                      RETURN                          16070000
CLRCOM   XC    STRTCOM+255(0),STRTCOM+255 OFF-THE-LINE ZAC              16071000
         EJECT                                                          16072000
*******************************************************************     16073000
*   THIS ROUTINE READS DATA FROM JINFILE.                               16074000
*   BUFFERS USED ARE BUFFER AND BUFFER2.                                16075000
*******************************************************************     16076000
BUFIN    ST    R12,RTNSV2                                               16077000
         LH    PARM1,JINFILE            CHECK JINFILE I/O               16078000
         JCHECK FILE=(R10)                COMPLETION HERE               16079000
         L     PARM2,BUFFER                                             16080000
         LH    R12,D0(,PARM2)                                           16081000
         AR    R12,PARM2                                                16082000
         ST    R12,BUFEND1                                              16083000
         XC    BUFFER(D12),BUFFER2      INTERCHANGE BUFFERS             16084000
         XC    BUFFER2(D12),BUFFER                                      16085000
         XC    BUFFER(D12),BUFFER2                                      16086000
         SH    R12,H8                                                   16087000
         CLC   D2(D3,R12),EOFREC+2      TEST IF LAST INPUT BLOCK        16088000
         BE    BUFIN40                  YES.                            16089000
         BAL   R6,RDPHYREC              NO, READ NEXT BLOCK             16090000
         L     PARM2,BUFFER2                                            16091000
BUFIN40  LA    PARM2,D2(,PARM2)         INCREMENT BY 2          OX02955 16092000
         L     R12,RTNSV2               PREPARE TO RETURN TO CALLER     16093000
         BR    R12                      RETURN TO CALLER                16094000
         SPACE 3                                                        16095000
RDPHYREC LH    PARM1,JINFILE            READ FROM JINFILE               16096000
         LA    PARM2,BUFFER                                             16097000
         JREAD FILE=(R10),PARM=(R11)                                    16098000
         BR    R6                       DON'T WAIT FOR I/O COMPLETION   16099000
         DROP  PARM2                                                    16100000
         EJECT                                                          16101000
************************************************************            16102000
*   SORT ROUTINE SORTS RLD'S, SYMBOL XREF'S, AND LITERAL XREF'S.        16103000
************************************************************            16104000
SORT     EQU   *                                                        16105000
         LA    RLREG,XRFLN-1            GET SORT CONTROL FIELD LENGTH-1 16106000
         LH    R1,RECNUM                NUMBER OF LOGICAL RECORDS IN    16107000
         BCTR  R1,0                          CORE MINUS ONE,            16108000
         SLL   R1,J2                              TIMES FOUR, BECAUSE   16109000
*                                         EACH RECORD CONTAINS 4 BYTES  16110000
         ST    R1,FWORD                                                 16111000
         L     R4,SORTPTR               POINTER TO DATA POINTERS        16112000
         CH    R1,H4                    TEST IF ONLY 2 ENTRIES          16113000
         BE    SORTZ                    YES                             16114000
SORT1    SRL   R1,J1                    MIDDLE OF DATA POINTERS         16115000
         N     R1,ALIGN                 FULL WORD ALIGNMENT             16116000
         BZ    SPILLENT                 END OF SORT                     16117000
SORTZ    EQU   *                                                        16118000
         SR    R0,R0                    INITIALIZE SUB SEQUENCE BASE    16119000
SORT4    LR    HPOINT,R0                                                16120000
SORT2    LR    LPOINT,HPOINT            STEP TO NEXT SUB SEQUENCE PAIR  16121000
SORT3    LA    HPOINT,D0(R1,LPOINT)     UPPER INDEX = LOWER + DELTA     16122000
         C     HPOINT,FWORD             UPPER INDEX = LOWER + DELTA     16123000
         BH    SORT5                    YES, STEP TO NEXT SUB SEQUENCE  16124000
         L     LBASE,D0(LPOINT,R4)      POINTER TO LOWER DATA ITEM      16125000
         L     HBASE,D0(HPOINT,R4)      POINTER TO UPPER DATA ITEM      16126000
         EX    RLREG,COMPARE            COMPARE DATA ITEMS              16127000
         BNH   SORT2                    BRANCH IF IN SEQUENCE           16128000
         ST    LBASE,D0(HPOINT,R4)      LET UPPER ITEM SINK             16129000
         ST    HBASE,D0(LPOINT,R4)      EXCHANGE DATA RECORDS           16130000
         SR    LPOINT,R1                                                16131000
         BNL   SORT3                    POSSIBLY ALL THE WAY            16132000
         B     SORT2                       TO THE BOTTOM.               16133000
SORT5    AH    R0,H4                    STEP TO NEXT SUB-SEQUENCE       16134000
         CR    R0,R1                    TEST FOR END OF PASS            16135000
         BL    SORT4                    NO, SORT NEXT SUB SEQUENCE      16136000
         B     SORT1                    YES, INITIALIZE NEW PASS        16137000
COMPARE  CLC   D4(0,LBASE),D4(HBASE)    COMPARE DATA ITEMS              16138000
         DS    0F                                                       16139000
ALIGN    DC    XL4'FFFFFFFC'            MASK FOR FULL WORD ALIGNMENT    16140000
         EJECT                                                          16141000
************************************************************            16142000
*   THIS ROUTINE HAS THE CONTROL OF THE OUTPUT OF DATA FROM SORT AREA.  16143000
*   IT CONTROLS THE DISTRIBUTION OF STRINGS ONTO THE TWO FILES THAT     16144000
*   ARE TO BECOME THE TWO INITIAL INPUT FILES TO THE CASCADE MERGE.     16145000
************************************************************            16146000
SPILLENT ST    RTN,RTADDR                                               16147000
         SET   RENT,ON                  RE ENTRY TO MERGE ROUTINE       16148000
         SR    R3,R3                                                    16149000
         L     R5,SORTPTR               GET BEGIN OF SORT AREA AND      16150000
*                                         RECORD COUNT                  16151000
         LH    R4,RECNUM                                                16152000
*                                       BRANCH IF ALL RECORDS ARE       16153000
         GOIF  (EOFSW,FSW),ALL=NOMREC     IN THE SORT AREA              16154000
         SPACE 3                                                        16155000
*        SPILL SORTED RECORDS INTO CURFLE AND CURFLE2                   16156000
SPILL    EQU   *                                                        16157000
         GOIF  FSW,OFF=SPILL10                                          16158000
*        FIRST TIME SPILLING            INITIATE STRING CONTROL NUMBER  16159000
         MVI   CFL1VV+1,D3                TO BOTH OUTPUT FILES AND      16160000
         MVI   CFL2VV+1,D1                SPILL STRINGS ONTO BOTH FILES 16161000
SPILL5   L     R2,BUFFER3                 ACCORDINGLY                   16162000
         XC    D2(D2,R2),D2(R2)                                         16163000
         LA    R2,D6(,R2)               BUMP PAST BUFFER HEADER         16164000
         L     R0,BUFEND3                                               16165000
SPILLING L     R1,D0(,R5)               GET THE NEXT DATA RECORD        16166000
         LH    R9,D0(,R1)               GET LENGTH OF DATA RECORD       16167000
SPLNG1   LR    R11,R9                   PUT DATA LENGTH IN REG          16168000
         AR    R11,R2                   ADD IN BEGINNING ADDR OF BUFFER 16169000
         CR    R11,R0                   ARE WE AT THE END OF BUFFER     16170000
         BH    SPILTH                   YES, END OF BUFFER              16171000
         C     R9,F255                  NO, MOVE IN                     16172000
         BNH   SPLNG2                                                   16173000
         MVC   D0(255,R2),D0(R1)        RCD >255, MOVE IN DEFAULT 255   16174000
         S     R9,F255                  ADJUST TO DEFAULT RECORD LENGTH 16175000
         A     R1,F255                  BUMP UP POINTERS                16176000
         A     R2,F255                                                  16177000
SPLNG2   BCTR  R9,0                     NO, MAKE IT MOVE LENGTH         16178000
         EX    R9,SPLMV                   AND MOVE                      16179000
         LR    R2,R11                   UP BUFFER POINTER               16180000
         LA    R3,D1(,R3)               UP RECORD COUNT BY 1            16181000
         LA    R5,SRTNTRY(,R5)          UP SORT AREA POINTER BY 4       16182000
         BCT   R4,SPILLING              GET NEXT RECORD                 16183000
*        WRITE LAST SHORT BLOCK                                         16184000
         SR    R9,R9                    NO MORE RECORD, SO              16185000
         L     R11,BUFFER3              GET START OF BUFF3 FOR WRITE OP 16186000
         OI    D3(R11),X'01'            LAST BLK IN THIS GP             16187000
         B     SPILTH1                  OUT ON FILE                     16188000
SPLMV    MVC   D0(0,R2),D0(R1)                                          16189000
SPILTH   L     R11,BUFFER3              GET ADDR OF BUFFER              16190000
SPILTH1  STM   R0,R9,SAVEALL            CONSTRUCT THE BLOCK             16191000
         SR    R2,R11                   HEADER                          16192000
         STH   R2,D0(,R11)              POINTER TO FIRST RCD IN BLOCK   16193000
         STH   R3,D4(,R11)              NUMBER OF RECORDS IN BLOCK      16194000
         TM    PPSW,FSW+RENT                                            16195000
         BO    SPLOUT                   FIRST TIME ENTRY                16196000
         TM    PPSW,RENT                                                16197000
         BO    CHKIT                    RE-ENTRY. MUST CHECK LAST       16198000
*                                         OUTPUT FILE                   16199000
         LH    PARM1,CURFLE                                             16200000
         JCHECK FILE=(R10)                                              16201000
         B     SPLOUT                                                   16202000
CHKIT    LH    PARM1,CHKFILE                                            16203000
         JCHECK FILE=(R10)              CHECK FOR COMPLETION            16204000
SPLOUT   SET   RENT,OFF                                                 16205000
         LH    PARM1,CURFLE                                             16206000
         LA    PARM2,BUFFER3                                            16207000
         JWRITE FILE=(R10),PARM=(R11)   WRITE ON CURFLE                 16208000
         LM    R0,R9,SAVEALL                                            16209000
         XC    BUFFER3(D12),BUFFER4     ALTER BUFFERS                   16210000
         XC    BUFFER4(D12),BUFFER3                                     16211000
         XC    BUFFER3(D12),BUFFER4                                     16212000
         L     R2,BUFFER3               INITIATE NEXT BUFFER            16213000
         XC    D2(D2,R2),D2(R2)           WHILE CURRENT BUFFER IS       16214000
         LA    R2,D6(,R2)                 BEING WRITTEN OUT             16215000
         L     R0,BUFEND3                                               16216000
         SR    R3,R3                                                    16217000
         LTR   R9,R9                    END OF GP TEST                  16218000
         BP    SPLNG1                   OVERFLOW, NOT END OF STRING     16219000
         STH   R10,CHKFILE                                              16220000
         LH    R11,CFL1CC               END OF GP (STRING)              16221000
         LA    R11,D1(,R11)             INCREMENT STRING COUNT          16222000
         STH   R11,CFL1CC                                               16223000
         L     RTN,RTADDR                                               16224000
         GOIF  FSW,OFF=(RTN)            RETURN IF NOT FIRST ACTION      16225000
         SET   FSW,OFF                  ELSE                            16226000
         XC    CURFLE(D8),CURFLE2       FLIP FIELD                      16227000
         XC    CURFLE2(D8),CURFLE                                       16228000
         XC    CURFLE(D8),CURFLE2                                       16229000
         BR    RTN                      THEN RETURN                     16230000
         SPACE                                                          16231000
SPILL10  EQU   *                                                        16232000
         CLC   CFL1CC(D2),CFL1VV                                        16233000
         BL    SPILL5                   OUTPUT ON SAME FILE             16234000
         XC    CURFLE(D8),CURFLE2       OUTPUT ON THE OTHER FILE        16235000
         XC    CURFLE2(D8),CURFLE                                       16236000
         XC    CURFLE(D8),CURFLE2                                       16237000
         LH    R11,CFL1VV               COMPUTE NEXT STRING CONTROL     16238000
         CH    R11,CFL2VV                 NUMBER ON THIS 'OTHER' FILE   16239000
         BL    SPILL20                    .                             16240000
         SH    R11,CFL2VV                 .                             16241000
         B     SPILL30                    THEN                          16242000
SPILL20  AH    R11,CFL2VV                 .                             16243000
SPILL30  STH   R11,CFL2VV                 .                             16244000
         B     SPILL5                   GO SPILL RECPRDS                16245000
EOFREC   DS    0CL18                    EOF RECORD                      16246000
         DC    AL2(L'EOFREC)            RL                              16247000
         DC    AL1(JPSOP,0)             FLAGS                           16248000
         DC    AL1(JTEOF)               IOC                             16249000
         DC    AL1(X'EE',X'00',X'FF')   SPECIAL ID                      16250000
         DC    2AL1(JASTER,X'EE',X'00',X'FF') PADDING                   16251000
         DC    AL2(0)                   PADDING                         16252000
EOFL     EQU   *-EOFREC                 LENGTH                          16253000
         EJECT                                                          16254000
************************************************************            16255000
*   THIS ROUTINE DOES THE CASCADE MERGE TILL THE NUMBER OF              16256000
*   STRINGS ON BOTH INPUT FILES DECREMENT TO ONE.                       16257000
************************************************************            16258000
*        READ FROM CURFLE AND CURFLE2                                   16259000
*        WRITE ON CURFLE3                                               16260000
*        ALL FILES REPOSITIONED TO GO                                   16261000
MERGE    EQU   *                                                        16262000
         BAL   RTN,READFL1              READ INTO BFRS 1 & 2 FROM FILE1 16263000
         BAL   RTN,READFL2              READ INTO BFRS 3 & 4 FROM FILE2 16264000
MERGE1   SR    R11,R11                                                  16265000
         L     R12,BUFFER5              WRITE BUFFER                    16266000
         XC    D2(D2,R12),D2(R12)                                       16267000
         LA    R12,D6(,R12)                                             16268000
MERGE2   SET   FSW,ON                                                   16269000
         CH    R0,H1                    DO NOT MERGE LAST PASS          16270000
         BH    CPRMRG                   IF                              16271000
         CH    R1,H1                    BOTH FILES HAVE DATA            16272000
         BH    CPRMRG                                                   16273000
         BL    MERGE3                                          FX0000   16274000
         CLC   CFL3CC(D2),H1            IF THIRD FILE CONTAINS DATA     16275000
         BNL   CPRMRG                   CONTINUE MERGE                  16276000
         B     OUTPUTS                  MERGE AS THEY PRINT/PUNCH       16277000
                                                       SPACE , FX0000   16278000
MERGE3   LA    R3,EOFREC                PREPARE FOR LAST BLK   FX0000   16279000
         B     OUTPUTS                  MERGE AS THEY PRINT/PUNFX0000   16280000
                                                       SPACE , FX0000   16281000
BUMPFL1  LR    R2,R14                                          FX0000   16282000
                                                       SPACE , FX0000   16283000
CPRMRG   CLC   D4(XRFLN,R2),D4(R3)                                      16284000
         BL    FL1LO                    FILE 1 LOW                      16285000
         BE    EEREC                    POSSIBLE END OF FILE/GROUP      16286000
FL2LO    LR    R14,R3                   RECORD POINTER                  16287000
         BAL   RTN,PUTREC               PUT ONE RECORD                  16288000
         BCT   R5,BUMPFL2               KEEP TRACK OF COUNT AND BR      16289000
         BCT   R10,CHKFL2               READ IF END OF BLOCK            16290000
         LA    R3,EOFREC                LAST BLK ON GROUP               16291000
         B     CPRMRG                   NEXT RECORD                     16292000
BUMPFL2  LR    R3,R14                   NEXT RECORD                     16293000
         B     CPRMRG                   GO                              16294000
CHKFL2   BAL   RTN,FL2CHECK             CHECK/READ                      16295000
         B     CPRMRG                   COMPARE                         16296000
         SPACE                                                          16297000
FL1LO    LR    R14,R2                                                   16298000
         BAL   RTN,PUTREC                                               16299000
         BCT   R4,BUMPFL1               COUNT/BRANCH                    16300000
         BCT   R9,CHKFL1                CHECK/READ                      16301000
         LA    R2,EOFREC                POINT TO EOFREC                 16302000
         B     CPRMRG                   NEXT REC                        16303000
CHKFL1   BAL   RTN,FL1CHECK             CHECK/READ                      16304000
         B     CPRMRG                   NEXT RECORD                     16305000
EEREC    CLI   D4(R2),JTEOF             TEST IF END OF GROUP            16306000
         BNE   FL1LO                    NO                              16307000
         BAL   RTN,PUTLBLK              OUTPUT LAST BLOCK               16308000
         STM   R0,R1,SAVEALL                                            16309000
         LH    R10,CURFLE3              TO CURFLE3                      16310000
         JCHECK FILE=(R10)              WAIT FOR COMPLETION             16311000
         LM    R0,R1,SAVEALL                                            16312000
         BCTR  R1,0                     MINUS 1 ON CURFLE2 STRING COUNT 16313000
         SH    R0,H1                    MINUS 1 ON CURFLE STRING COUNT  16314000
         STM   R0,R1,SAVEALL                                            16315000
         BP    GPCNT2                   CURFLE=0 STRING                 16316000
         STH   R0,CFL1CC                                                16317000
         XC    CURFLE(D8),CURFLE3       FLIP 1 AND 3                    16318000
         XC    CURFLE3(D8),CURFLE       .                               16319000
         XC    CURFLE(D8),CURFLE3       .                               16320000
         LH    R0,CFL1CC                                                16321000
         ST    R0,SAVEALL                                               16322000
         TM    GNBLK1,X'80'             TEST IF JINFILE                 16323000
         BZ    EEREC2                   NO                              16324000
         LH    R10,CURFLE               YES, POINT BACK TO NOTED LOC    16325000
         LA    R11,NOTESV                                               16326000
         JPOINT FILE=(R10),ADDR=(R11),NEXT=READ                         16327000
         LH    R10,CURFLE                                               16328000
         BAL   RTN,DUMMYRD              GET BY THE NOTED RECORD         16329000
         LH    R10,CURFLE3                                              16330000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE3              16331000
         B     EERECXY                  NEXT STRING                     16332000
EEREC2   TM    GNBLK3,X'80'                                             16333000
         BZ    EEREC4                   BR IF NOT JINFILE               16334000
         LH    R10,CURFLE3              YES, POINT BACK TO NOTED LOC    16335000
         LA    R11,NOTESV                                               16336000
         JPOINT FILE=(R10),ADDR=(R11),NEXT=WRITE                        16337000
EEREC3   LH    R10,CURFLE                                               16338000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE               16339000
EERECXY  LM    R0,R1,SAVEALL                                            16340000
         BAL   RTN,READFL1              READ FIRST BLOCK FROM CURFLE    16341000
EERECXZ  BAL   RTN,FL2CHECK             CONTINUE READING CURFLE2        16342000
         B     MERGE1                   CONTINUE PROCESSING             16343000
EEREC4   LH    R10,CURFLE3                                              16344000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE3              16345000
         B     EEREC3                   .                               16346000
GPCNT2   CH    R1,H1                                                    16347000
         BL    GPCNT3                   CURFLE2=0 STRING                16348000
         BAL   RTN,FL1CHECK             NOT EXHAUSTED YET, READ         16349000
         B     EERECXZ                    NEXT BLOCK AND GO             16350000
GPCNT3   EQU   *                                                        16351000
         STH   R1,CFL2CC                                                16352000
         XC    CURFLE2(D8),CURFLE3      FLIP 2 AND 3                    16353000
         XC    CURFLE3(D8),CURFLE2                                      16354000
         XC    CURFLE2(D8),CURFLE3                                      16355000
         LH    R1,CFL2CC                                                16356000
         ST    R1,SAVEALL+4                                             16357000
         TM    GNBLK2,X'80'             TEST IF JINFILE                 16358000
         BZ    EEREC6                   NO                              16359000
         LH    R10,CURFLE2              YES, POINT TO THE NOTED LOC     16360000
         LA    R11,NOTESV                                               16361000
         JPOINT FILE=(R10),ADDR=(R11),NEXT=READ                         16362000
         LH    R10,CURFLE2                                              16363000
         BAL   RTN,DUMMYRD              GET BY THE NOTED RECORD         16364000
         LH    R10,CURFLE3                                              16365000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE3              16366000
         B     EERECXX                  NEXT STRING (GP)                16367000
EEREC6   TM    GNBLK3,X'80'                                             16368000
         BZ    EEREC8                   NOT JINFILE                     16369000
         LH    R10,CURFLE3              YES, POINT TO THE NOTED LOC     16370000
         LA    R11,NOTESV                                               16371000
         JPOINT FILE=(R10),ADDR=(R11),NEXT=WRITE                        16372000
EEREC7   LH    R10,CURFLE2                                              16373000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE2              16374000
EERECXX  LM    R0,R1,SAVEALL                                            16375000
         BAL   RTN,READFL2              READ FROM BOTH INPUT            16376000
         BAL   RTN,FL1CHECK               FILES AND                     16377000
         B     MERGE1                     CONTINUE MERGE PROCESS        16378000
EEREC8   LH    R10,CURFLE3                                              16379000
         JPOINT FILE=(R10),NEXT=START   REPOSITION CURFLE3              16380000
         B     EEREC7                   AND GO                          16381000
         SPACE                                                          16382000
DUMBUFR  EQU   BUFFER6                                                  16383000
DUMMYRD  LA    PARM2,DUMBUFR                                            16384000
*                                       READ THAT BYPASSES THE NOTED    16385000
         JREAD FILE=(R10),PARM=(R11)      RECORD ON JINFILE             16386000
         SET   DRDCHK,ON                                                16387000
         STH   R10,CHKFILE                                              16388000
         BR    RTN                      RETURN                          16389000
         EJECT                                                          16390000
************************************************************            16391000
*   THIS ROUTINE IS THE DRIVER TO PRINT/PUNCH ROUTINES.                 16392000
************************************************************            16393000
         USING PPIN,PARM2                                               16394000
         USING RPRINT,LOUTNDX                                           16395000
         USING RCARD,COUTNDX                                            16396000
OPENTRY  EQU   *                        ENTRY TO OUTPUTS                16397000
*        R2 = CURFLE INDEX                                              16398000
*        R3 = CURFLE2 INDEX                                             16399000
*        R4 = RECORDS IN CURFLE                                         16400000
*        R5 = RECORDS IN CURFLE2                                        16401000
         SPACE                                                          16402000
OUTPUTS  CLC   D4(XRFLN,R2),D4(R3)      HI LO COMPARE                   16403000
         BH    OFL2LO                   FILE 2 LOW                      16404000
         BE    EOFTEST                  POSSIBLE END OF FILE            16405000
         LR    PARM2,R2                 FILE 1 LOW                      16406000
         LH    R14,D0(,R2)              GET REC LENGTH                  16407000
         AR    R2,R14                                                   16408000
         ST    R2,NEXTREC               SAVE NEXT REC ADDR              16409000
         C     R2,BUFEND2               END OF BUFFER                   16410000
         BL    OUTIN                    NO- NOT LAST REC                16411000
         GOIF  ENDSTR1,OFF=OUTIN        NOT IN LAST BLOCK IN STRING     16412000
         CLC   EOFREC,D0(R3)            REC LEFT ON OTH FILE            16413000
         BNE   OUTIN                    YES - NOT LAST                  16414000
         SET   LASTREC,ON               NO THIS IS LAST REC             16415000
         B     OUTIN                    OUTPUT                          16416000
OFL2LO   LR    PARM2,R3                 FILE 2 LOW                      16417000
         LH    R14,D0(,R3)                                              16418000
         AR    R3,R14                                                   16419000
         ST    R3,NEXTREC               SAVE NEXT REC ADDR              16420000
         C     R3,BUFEND4               END OF BUFFER                   16421000
         BL    OUTIN                    NO - NOT LAST REC               16422000
         GOIF  ENDSTR2,OFF=OUTIN        NOT IN LAST BLOCK IN STRING     16423000
         CLC   EOFREC,D0(R2)            REC LEFT ON OTHER FILE          16424000
         BNE   OUTIN                    YES                             16425000
         SET   LASTREC,ON               THIS WAS LAST REC               16426000
OUTIN    L     R12,PRT                  GET OUTPUT ROUTINE BASE         16427000
         ST    R9,RTNSV1                SAVE STRING COUNT               16428000
         BALR  R9,R12                   OUTPUT RECORDS                  16429000
         L     R9,RTNSV1                RESTORE STRING COUNT            16430000
         C     R2,BUFEND2               TEST IF ENDOFBUFFER             16431000
         BL    OEX2                     NO                              16432000
         CLC   EOFREC,D0(R2)            IS IT END OF FILE               16433000
         BE    OEX2                     YES                             16434000
         BCT   R9,OEX1                                                  16435000
         LA    R2,EOFREC                END OF STRING HERE              16436000
         B     OEX2                     .                               16437000
OEX1     BAL   RTN,FL1CHECK             GET NEXT BUFFER                 16438000
OEX2     C     R3,BUFEND4               TEST IF END OF BUFFER           16439000
         BL    OUTPUTS                  NEXT                            16440000
         CLC   EOFREC,D0(R3)            IS IT END OF FILE               16441000
         BE    OUTPUTS                  YES                             16442000
         BCT   R10,OEX3                                                 16443000
         LA    R3,EOFREC                END OF STRING HERE              16444000
         B     OUTPUTS                  NEXT                            16445000
OEX3     BAL   RTN,FL2CHECK             GET NEXT BUFFER                 16446000
         B     OUTPUTS                  CONTINUE                        16447000
         SPACE 3                                                        16448000
NOMREC   SET   EOFSW,OFF                                                16449000
         L     R2,SORTPTR                                               16450000
ONEBFR   L     PARM2,D0(,R2)                                            16451000
         LA    R2,SRTNTRY(,R2)          GET NEXT REC POINTER            16452000
         L     R12,D0(,R2)              GET NEXT REC ADDR               16453000
         ST    R12,NEXTREC              SAVE IT                         16454000
         CH    R4,H1                    LAST REC                        16455000
         BNE   ONEBFR1                  TELL SO                         16456000
         SET   LASTREC,ON                                               16457000
ONEBFR1  L     R12,PRT                  GET OUTPUT RTN ADDR             16458000
         BALR  R9,R12                   GO OUTPUT RECORD                16459000
         BCT   R4,ONEBFR                DECREMENT COUNT                 16460000
         B     EOFOUT                   END OF FILE IF THRU'            16461000
         EJECT                                                          16462000
****************************************                                16463000
*   END OF FILE ROUTINE.                                                16464000
****************************************                                16465000
EOFTEST  CLI   D4(R2),JTEOF             TEST IF EOF RECORD              16466000
         BNE   OFL2LO                   NO, ASSUME FILE 2 LOW           16467000
EOFOUT   EQU   *                                                        16468000
         GOIF  JMINXREF,OFF=EOFOUT5     IF XREF(SHORT)-        @AX14816 16469000
         GOIF  LASTDEF,ON=EOFOUT3       BR IF LAST REC = DEF   @AZ28946 16470000
         GOIF  HEADPEND,OFF=EOFOUT5     BR IF NO HEADER PEND   @AZ28946 16471000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER @AZ28946 16472000
         MVC   RECSAVE,CONTROL          SAVE CURR XREF REC     @AZ28946 16473000
         SET   LINKSW,ON                HEADER BUT HEADER ONLY @AZ28946 16474000
         L     R12,PRT                  ADDRESS TO-            @AZ28946 16475000
         BALR  R9,R12                   PRINT ROUTINE          @AZ28946 16476000
         LM    R1,R6,RTADDR             RESTORE REGS           FX0000   16477000
         MVC   CONTROL(L'RECSAVE),RECSAVE RESTOR CURR XREF REC @AZ28946 16478000
         MVI   XCNTRL,SPACE2            SET SPACE 2            @AZ28946 16479000
         B     EOFOUT5                                         @AZ28946 16480000
EOFOUT3  EQU   *                                               @AZ28946 16481000
         SET   JSUPPRT,ON               LAST DEF PRINT LINE.   @AX14816 16482000
EOFOUT5  EQU   *                                               @AX14816 16483000
         LH    R10,CURFLE               WAIT FOR OUTSTANDING-  @AZ11958 16484000
         BAL   R9,EOFWAIT               I/O ACTIVITY.          @AZ11958 16485000
         LH    R10,CURFLE2              WAIT FOR OUTSTANDING-  @AZ11958 16486000
         BAL   R9,EOFWAIT               I/O ACTIVITY.          @AZ11958 16487000
         LH    R10,CURFLE3              WAIT FOR OUTSTANDING-  @AZ11958 16488000
         BAL   R9,EOFWAIT               I/O ACTIVITY.          @AZ11958 16489000
         LH    PARM1,JINFILE            REWINE INPUT FILE FOR           16490000
         JPOINT FILE=(PARM1),NEXT=START DIAGNOSTICS PHASE               16491000
RETRN    JFRECORE ADDR=(R7)             FREE X6A COMMON AREA            16492000
RETURN   JRETURN                        RETURN TO SYSTEM                16493000
EOFWAIT  DS    0H                                              FX0000   16494000
         AR    R10,R13                  CREATE FW ADDR OF DECB FX0000   16495000
         USING IECTDECB,R10                                    FX0000   16496000
         L     R1,DECDCBAD                                     FX0000   16497000
         USING IHADCB,R1                                       FX0000   16498000
         MVC   DCBEODAD+D1(3),ADREOFWT+D1 24 BIT ADDRESSING    FX0000   16499000
         DROP  R1,R10                                          FX0000   16500000
         LR    R1,R10                   POINT R1 TO ECB        FX0000   16501000
         USING IECTDECB,R1                                     FX0000   16502000
         L     R14,DECDCBAD                                    FX0000   16503000
         USING IHADCB,R14                                      FX0000   16504000
         L     R15,DCBCHECK                                    FX0000   16505000
         DROP  R1,R14                                          FX0000   16506000
         BALR  R14,R15                  CALL ROUTINE           FX0000   16507000
EOFWAIT1 DS    0H                                              FX0000   16508000
         USING IECTDECB,R10                                    FX0000   16509000
         L     R1,DECDCBAD                                     FX0000   16510000
         USING IHADCB,R1                                       FX0000   16511000
         XC    DCBEODAD+D1(3),DCBEODAD+D1  24 BIT ADDRESS      FX0000   16512000
         MVI   DCBEODAD+D3,X'01'        SET CONDITION CODE     FX0000   16513000
         DROP  R1,R10                                          FX0000   16514000
         BR    R9                       RETURN FOR MORE TESTS  @AZ11958 16515000
ADREOFWT DC    A(EOFWAIT1)                                     FX0000   16516000
         EJECT                                                          16517000
*   READ ROUTINE READS PHYSICAL RECORDS                                 16518000
*   FROM CURFLE INTO BUFFER/BUFFER2                                     16519000
****************************************                                16520000
READFL1  STM   R0,R15,SAVEALL           FIRST TIME ENTRY POINT          16521000
         GOIF  DRDCHK,OFF=READFL17      TEST IF NEED CHECK BEFORE READ  16522000
         LH    PARM1,CHKFILE                                            16523000
         JCHECK FILE=(R10)              YES, CHECK IT                   16524000
         SET   DRDCHK,OFF                                               16525000
READFL17 EQU   *                                                        16526000
         LH    PARM1,CURFLE             READ NEXT BLOCK OF RECORDS      16527000
         LA    PARM2,BUFFER               FROM CURFLE INTO BUFFER       16528000
         JREAD FILE=(R10),PARM=(R11)                                    16529000
         B     RDFL10                   .                               16530000
FL1CHECK STM   R0,R15,SAVEALL           NON-FIRST-TIME ENTRY POINT      16531000
         SET   ENDSTR1,OFF              RESET END OF STRING IND         16532000
         LH    PARM1,CURFLE                                             16533000
RDFL10   JCHECK FILE=(R10)              CHECK FOR COMPLETION            16534000
         L     PARM2,BUFFER             GET PTR TO BEGIN OF BUFFER      16535000
         LH    R12,D0(,PARM2)           EXTRACT LENGTH OF DATA RECORD   16536000
         AR    R12,PARM2                CALCULATE END OF BUFFER         16537000
         ST    R12,BUFEND1              KEEP PTR TO END OF BUFFER1      16538000
RDFL11   XC    BUFFER(D12),BUFFER2      FLIP THE TWO ALTERNATE          16539000
         XC    BUFFER2(D12),BUFFER        BUFFERS BY INTERCHANGE        16540000
         XC    BUFFER(D12),BUFFER2        POINTERS                      16541000
         CLI   D3(PARM2),D1             TEST IF END OF STRING           16542000
         BNE   RDFL15                   NO, GO TO READ                  16543000
         SET   ENDSTR1,ON               IND LAST BLOCK IN STRING        16544000
         L     R0,SAVEALL               YES, TEST IF LAST STRING        16545000
         CH    R0,H1                                                    16546000
         BNH   RDFL19                   YES                             16547000
RDFL15   EQU   *                                                        16548000
         LH    PARM1,CURFLE             READ NEXT BLOCK OF RECORDS      16549000
         LA    PARM2,BUFFER                                             16550000
         JREAD FILE=(R10),PARM=(R11)                                    16551000
RDFL19   LM    R0,R15,SAVEALL                                           16552000
         L     R2,BUFFER2                                               16553000
         LH    R9,D2(,R2)               # BLKS IN FL 1 GP               16554000
         LH    R4,D4(,R2)               # RECS IN FL 1 BLK              16555000
         LA    R2,D6(,R2)               BUMP OVER  HEADER               16556000
         BR    RTN                      RETURN TO CALLER                16557000
         EJECT                                                          16558000
*   READ ROUTINE READS PHYSICAL RECORDS                                 16559000
*   FROM CURFLE2 INTO BUFFER3/BUFFER4                                   16560000
****************************************                                16561000
READFL2  STM   R0,R15,SAVEALL                                           16562000
         GOIF  DRDCHK,OFF=READFL27      TEST IF NEED CHECK BEFORE READ  16563000
         LH    PARM1,CHKFILE                                            16564000
         JCHECK FILE=(R10)              YES, CHECK IT                   16565000
         SET   DRDCHK,OFF                                               16566000
READFL27 EQU   *                                                        16567000
         LH    PARM1,CURFLE2            READ NEXT BLOCK OF RECORDS      16568000
         LA    PARM2,BUFFER3              FROM CURFLE2 INTO BUFFER3     16569000
         JREAD FILE=(R10),PARM=(R11)                                    16570000
         B     RDFL20                   .                               16571000
FL2CHECK STM   R0,R15,SAVEALL           NON-FIRST-TIME ENTRY POINT      16572000
         SET   ENDSTR2,OFF              RESET END OF STRING IND         16573000
         LH    PARM1,CURFLE2                                            16574000
RDFL20   JCHECK FILE=(R10)              CHECK BEFORE READ               16575000
         L     PARM2,BUFFER3                                            16576000
         LH    R12,D0(,PARM2)                                           16577000
         AR    R12,PARM2                                                16578000
         ST    R12,BUFEND3                                              16579000
RDFL21   XC    BUFFER3(D12),BUFFER4     FLIP THE TWO ALTERNATE BUFFERS  16580000
         XC    BUFFER4(D12),BUFFER3                                     16581000
         XC    BUFFER3(D12),BUFFER4                                     16582000
         CLI   D3(PARM2),D1             TEST IF END OF STRING           16583000
         BNE   RDFL25                   NO, GO TO READ                  16584000
         SET   ENDSTR2,ON               IND LAST BLOCK INSTRING         16585000
         L     R1,SAVEALL+4                                             16586000
         CH    R1,H1                    YES, TEST IF LAST STRING        16587000
         BNH   RDFL29                   YES                             16588000
RDFL25   EQU   *                                                        16589000
         LH    PARM1,CURFLE2            READ NEXT BLOCK OF RECORDS      16590000
         LA    PARM2,BUFFER3                                            16591000
         JREAD FILE=(R10),PARM=(R11)                                    16592000
RDFL29   LM    R0,R15,SAVEALL                                           16593000
         L     R3,BUFFER4                                               16594000
         LH    R10,D2(,R3)              # BLKS IN FL 2 GP               16595000
         LH    R5,D4(,R3)               # RECS IN FL 2 BLK              16596000
         LA    R3,D6(,R3)               BUMP OVER HEADER                16597000
         BR    RTN                      RETURN TO CALLER                16598000
         EJECT                                                          16599000
************************************************************            16600000
*   WRITE ROUTINE WRITES PHYSICAL RECORDS                               16601000
*   FROM BUFFER5/BUFFER6 ONTO CURFLE3                                   16602000
************************************************************            16603000
PUTREC   EQU   *                                                        16604000
         LH    R15,D0(,R14)             GET RECORD LENGTH               16605000
PUTREC1  AR    R12,R15                                                  16606000
         C     R12,BUFEND5              TEST IF END OF BUFFER           16607000
         BH    OVRFLO                   BR IF OVERFLOW                  16608000
         SR    R12,R15                  NO, MOVE INTO BUFFER            16609000
         C     R15,F255                                                 16610000
         BNH   PUTREC2                                                  16611000
         MVC   D0(255,R12),D0(R14)      EXTRA MOVE IF RECORD LENGTH     16612000
         S     R15,F255                   EXCEEDS 255                   16613000
         A     R12,F255                                                 16614000
         A     R14,F255                                                 16615000
PUTREC2  BCTR  R15,0                    MAKE MOVE LENGTH                16616000
         EX    R15,MVMV                 MOVE RECORD TO BUFFER           16617000
         LA    R15,D1(R15)              MAKE IT LOGICAL LENGTH AGAIN    16618000
         AR    R12,R15                                                  16619000
         AR    R14,R15                                                  16620000
         LA    R11,D1(,R11)                                             16621000
         BR    RTN                      RETURN                          16622000
MVMV     MVC   D0(0,R12),D0(R14)        OFF-THE-LINE MOVE               16623000
         SPACE                                                          16624000
OVRFLO   SR    R12,R15                  WRAP UP THE BUFFER              16625000
OVRFLO1  STM   R0,R15,SAVEALL                                           16626000
         L     R10,BUFFER5                                              16627000
         SR    R12,R10                  TAKE CARE OF ITS HEADER         16628000
         STH   R12,D0(,R10)             BLOCK SIZE                      16629000
         STH   R11,D4(,R10)             # RECORDS                       16630000
         LH    PARM1,CURFLE3            BRANCH IF FIRST TIME            16631000
OVRFLO5  GOIF  FSW,ON=WRITE             ELSE, CHECK LAST OUTPUT         16632000
         JCHECK FILE=(R10)              COMPLETION BEFORE               16633000
****************************************                                16634000
WRITE    LA    PARM2,BUFFER5            WRITE CURRENT BLOCK             16635000
         SET   FSW,OFF                                                  16636000
         JWRITE FILE=(R10),PARM=(R11)                                   16637000
         LM    R0,R15,SAVEALL                                           16638000
         XC    BUFFER5(D12),BUFFER6     FLIP THE TWO                    16639000
         XC    BUFFER6(D12),BUFFER5       ALTERNATIVE                   16640000
         XC    BUFFER5(D12),BUFFER6       BUFFERS                       16641000
         L     R12,BUFFER5                AND                           16642000
         XC    D2(D2,R12),D2(R12)         INITIATE HEADER               16643000
         LA    R12,D6(,R12)                                             16644000
         SR    R11,R11                                                  16645000
         LTR   R15,R15                  END OF GP IF R15 = 0            16646000
         BP    PUTREC1                  BR IF NOT                       16647000
         LH    R10,CFL3CC               INCREMENT STRING COUNT          16648000
         LA    R10,D1(,R10)                                             16649000
         STH   R10,CFL3CC                                               16650000
         BR    RTN                      RETURN                          16651000
         SPACE                                                          16652000
LBSW     EQU   X'01'                    LAST-BLOCK-IN-GP                16653000
PUTLBLK  SR    R15,R15                                                  16654000
         L     R10,BUFFER5                                              16655000
         OI    D3(R10),LBSW             INDICATE LAST BLOCK IN GP       16656000
         B     OVRFLO1                  PUT                             16657000
         EJECT                                                          16658000
*                                                                       16659000
*   CONSTANTS                                                           16660000
*                                                                       16661000
F255     DC    F'255'                   CONSTANT 255                    16662000
PRT      DC    A(PRTPCH)                ADDRESS OF OUTPUT ROUTINE       16663000
K72D     DC    X'00007FFF'                                              16664000
H1       DC    H'1'                     CONSTANT 1                      16665000
H4       DC    H'4'                     CONSTANT 4                      16666000
H8       DC    H'8'                     CONSTANT 8                      16667000
         JPATCH X6A00,AF0                     5% PATCH AREA             16668000
         EJECT                                                          16669000
         JCSECT (X6A20)                                                 16670000
         JMODID                                                         16671000
PRTPCH   JSAVE                                                          16672000
         JENTRY (X6A21=PRTPCH)                                          16673000
         STM   R1,R10,SAVEALL                                           16674000
         L     LINCTR,LNCTRSV           RESTORE LINE COUNTER            16675000
         GOIF  LINKSW,OFF=VJGARAM       BR IF NOTHING SPECIAL  @AZ28946 16676000
         BAL   RTN,XRFHDNG              NOW LAST XREF HEADER   @AZ28946 16677000
         B     OUTEXIT                  RETURN TO EOF ROUTINE  @AZ28946 16678000
VJGARAM  EQU   *                                               @AZ28946 16679000
         CLI   PPIOC,RLDTYPE            TEST IF RLD RECORD              16680000
         BE    RLDOUT                   YES                             16681000
         CLI   PPIOC,XRFTYPE            TEST IF XREF RECORD             16682000
         BE    XRFOUT                   YES                             16683000
         CLI   PPIOC,LITTYPE            TEST IF LETERAL XREF RECORD     16684000
         BE    LITOUT                   BRANCH IF YES                   16685000
         B     RET                      RETURN TO CALLER                16686000
         SPACE                                                          16687000
OUTEXIT  ST    LINCTR,LNCTRSV           SAVE LINE COUNTER               16688000
         LM    R1,R10,SAVEALL                                           16689000
RET      JRETURN                        NEXT RECORD                     16690000
         EJECT                                                          16691000
************************************************************            16692000
*   RELOCATION LIST DICTIONARY PRINT ROUTINE.                           16693000
************************************************************            16694000
RLDOUT   EQU   *                                                        16695000
         GOIF  PROCRLD,ON=RLDGO         BRANCH IF NOT FIRST ENTRY       16696000
         LA    LINCTR,D1                DUMMY UP LINE COUNTER           16697000
         SET   PROCRLD,ON               INDICATE INVOLVED IN RLD NOW    16698000
         GOIF  (JDECK,JLINK),OFF=RLDGO   BRANCH IF NO RLD PUNCH OUTPUT  16699000
         BAL   RTN,PCHREC               LOCATE NEXT PUNCH BUFFER        16700000
RLDGO    EQU   *                                                        16701000
         GOIF  (JLIST,JRLD),NOTALL=RLDDL BRANCH IF NO LIST OUTPUT       16702000
         L     LOUTNDX,LOUTSV           SAVE LIST BUFFER POINTER        16703000
         BCT   LINCTR,RLDLST            BRANCH IF LIST HDG NOT NEEDED   16704000
         BAL   RTN,RLDHDNG              ELSE, BUILD ONE                 16705000
         LH    LINCTR,JLNCT             GET LINE COUNT PER PAGE         16706000
         ST    LINCTR,LNCTRSV                                           16707000
         MVI   RCNTRL,SPACE2            DOUBLE SPACE                    16708000
RLDLST   EQU   *                                                        16709000
         UNPK  UNPKAREA(L'UNPKAREA),POSID(L'POSID+L'RELID+L'RLDVAL+L'RLX16710000
               DFLG)                    UNPACK                          16711000
         MVN   UPFLGN(D1),RLDFLG        COMPLETE UNPACKING              16712000
         NC    UNPKAREA(L'UNPKAREA+1),MASK1 MASK OUT ZONE PORTION       16713000
         MVC   POSOUT,UPPOS             POSITIONAL ID                   16714000
         MVC   RELOUT,UPREL             RELATIONAL ID                   16715000
         MVC   VALOUT,UPVAL             ADDRESSE                        16716000
         MVC   FLGOUT,UPFLG             FLAGS                           16717000
         BAL   RTN,PRTREC               PRINT ONE LINE                  16718000
RLDDL    EQU   *                                                        16719000
         GOIF  (JDECK,JLINK),OFF=OUTEXIT  NEXT RECORD                   16720000
RLDBLD   EQU   *                                                        16721000
         LM    RLDCNT,R15,RFSAVE        RESTORE                         16722000
         CH    RLDCNT,H56               TEST IF BUFFER FULL             16723000
         BL    RLDBLD1                  BRANCH IF NOT                   16724000
         BAL   RTN,PCHREC               ELSE, PUNCH OUT RECORD          16725000
RLDBLD1  EQU   *                                                        16726000
         MVC   RELHLD,RELID             RELOCATION ID                   16727000
         MVC   POSHLD,POSID             POSITIONAL ID                   16728000
         MVC   FLGHLD,RLDFLG            RLD FLAGS                       16729000
         MVC   ADDRHLD,RLDVAL           RLD ASSEMBLED ORIGIN            16730000
         CLC   ESDCOMP,RLDHLD           TEST IF POS/REL ID CHANGED      16731000
         BNE   RLDB                     YES.                            16732000
         SH    R15,H4I                  BACK UP TO FLAG IN PREV ENTRY   16733000
         OI    D0(R15),SAMEID           INDICATE NEXT ENTRY HAS SAME ID 16734000
         AH    R15,H4I                                                  16735000
         LA    PARM2,FLGHLD             LOCATION OF ITEM TO BE MOVED    16736000
         LA    PARM1,D3                 AND ITS MOVE LENGTH             16737000
         B     RLDB1                    GO MOVE IT TO BUFFER            16738000
RLDBZ    EQU   *                                                        16739000
         BAL   RTN,PCHREC               LOCATE NEXT PUNCH BUFFER        16740000
RLDB     LA    PARM1,D7                 MOVE LENGTH FOR SAME-ID ENTRY   16741000
         LA    PARM2,RLDHLD             AND ITS LOCATION                16742000
         MVC   ESDCOMP,RLDHLD           UPDATE ESDCOMP                  16743000
RLDB1    LA    RLDCNT,D1(PARM1,RLDCNT)  UPDATE RLD DATA BYTE COUNT      16744000
         CH    RLDCNT,H56               IF IT ACCUMULATES               16745000
         BH    RLDBZ                    MORE THAN 56 BYTES MUST SPLIT   16746000
         EX    PARM1,MVCRLD             ELSE, MOVE INTO BUFFER          16747000
         STH   RLDCNT,JHWORD1           ENTER NUMBER OF BYTES ACCUM'D   16748000
         L     COUTNDX,PCHSAVE                                          16749000
         MVC   RLDBYT(L'RLDBYT),JHWORD1                                 16750000
         LA    R15,D1(PARM1,R15)        MIGHT HAVE ROOM FOR NEXT ENTRY  16751000
         STM   RLDCNT,R15,RFSAVE        SAVE                            16752000
         B     OUTEXIT                  READ NEXT CARD                  16753000
         DROP  COUTNDX                                                  16754000
*                                                                       16755000
MVCRLD   MVC   D0(0,R15),D0(PARM2)      OFF-THE-LINE MOVE               16756000
         EJECT                                                          16757000
************************************************************            16758000
*   SYMBOL CROSS-REFERENCE LISTING ROUTINE.                             16759000
************************************************************            16760000
         DROP  PARM2                                                    16761000
         USING PPIN,R5                                                  16762000
XRFOUT   EQU   *                                                        16763000
         LR    R5,PARM2                 SET BASE FOR XREF'S             16764000
         GOIF  PROCXRF,ON=XRFLST        BRANCH IF NOT FIRST ENTRY       16765000
         LA    LINCTR,D1                ELSE, FORCE OUT PREVIOUS LINE   16766000
         XC    SAVSYM(L'SAVSYM+L'UNDFSYM),SAVSYM ZERO OUT SAVE AREAS    16767000
         SET   PROCXRF,ON                                               16768000
         B     XRFLST                   GO PROCESS                      16769000
XRFOUT0  CLI   XRFFLG,BASE              DEF REC                         16770000
         BNE   XRFOUT2                  NO PROCESSING STARTS            16771000
         GOIF  LASTREC,ON=OUTEXIT       LAST REC NOTHING TO PRINT       16772000
         L     R1,NEXTREC               GET NEXT REC ADDR               16773000
         CLI   XRFFLG-XRFIN(R1),BASE    A DEF REC TOO                   16774000
         BE    OUTEXIT                  YES DO NOT PROCESS YET          16775000
XRFOUT2  SET   PROCXRF,ON               NOT DEF PROCESSING STARTS       16776000
XRFLST   EQU   *                                                        16777000
         MVC   STMTN2(D2),XRFSTM        ALIGN STMT # TO HWD BNDRY       16778000
         CLI   XRFFLG,REF               IS IT A REFERENCE RECORD        16779000
         BE    XREFIN                   BRANCH IF YES                   16780000
         BAL   RTN,XRFDEFS              ELSE, PROCESS DEFINITION        16781000
XRFEXIT  STM   LOUTNDX,XRFPTR,LOUTSV                                    16782000
         B     OUTEXIT                  READ NEXT CARD                  16783000
         SPACE 3                                                        16784000
XREFIN   EQU   *                                                        16785000
         SET   LASTREC,OFF              REF NO WORRIES                  16786000
         LM    LOUTNDX,XRFPTR,LOUTSV                                    16787000
         LA    PARM2,XPRTND             GET END PRINT BUFFER ADDRESS    16788000
         CR    XRFPTR,PARM2             TEST IF REFERENCE LINE FULL     16789000
         BL    XRFR0                    BRANCH IF STILL ROOM            16790000
         BAL   R1,HDLINE1               ELSE, PRINT THE LINE            16791000
XRFR0    EQU   *                                                        16792000
         L     R15,STMTNUM              XREF STATEMENT NUMBER           16793000
         BAL   RTN,CVTXRF               NUMBER FOR PRINTING.            16794000
         GOIF  PROCLIT,ON=XRFR2         SKIP IF PROCESSING LIT XREF     16795000
         CLC   SAVSYM,XRFSYM            SYMBOL = PREVIOUS SYMBOL        16796000
         BE    XRFR2                    YES, BYPASS UNDEFINED SYM CODE  16797000
         CLC   UNDFSYM,XRFSYM           UNDEFINED SYMBOL = TO LAST      16798000
         BE    XRFR2                    YES, GO PUT OUT REFERENCE NUM.  16799000
         GOIF  HEADOUT,ON=XRFR15        BRANCH IF BUFFER EMPTY          16800000
         GOIF  LASTDEF,ON=XRFR15        SKIP LAST BUF IF IT WAS DEF     16801000
         MVC   UPXSV(L'XRFENT),UPX      SAVE STMT NUMBER                16802000
         BAL   R1,HDLINE                ELSE, PRINT A LINE              16803000
         MVC   UPX(L'XRFENT),UPXSV      RESTORE STMT NUMBER             16804000
XRFR15   EQU   *                                                        16805000
         MVC   UNDFSYM,XRFSYM           SAVE UNDEFINED SYMBOL           16806000
         TR    XRFSYM,JTRTABLE          CONVERT SYMBOL TO INTERNAL CODE 16807000
         MVC   XSYMOUT,XRFSYM           XREF SYMBOL                     16808000
         MVC   XLENOUT(L'UNDFMSG),UNDFMSG    UNDEFINED MESSAGE          16809000
XRFR2    EQU   *                                                        16810000
         MVC   D0(L'XRFENT,XRFPTR),UPX  REFERENCE NUMBER                16811000
         LA    XRFPTR,XRENTL(,XRFPTR)   BUMP REF PRINT POINTER          16812000
         SET   HEADOUT,OFF                                              16813000
         SET   LASTDEF,OFF              REFERENCE RESETS DEF REC IND    16814000
         B     XRFEXIT                  GET OUT                         16815000
         SPACE 3                                                        16816000
HDLINE1  SET   HEADOUT,ON                                               16817000
HDLINE   EQU   *                                                        16818000
         ST    R1,R1SAVE                                                16819000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER          16820000
         GOIF  LASTDEF,ON=HDLINE2       WAS LAST XREF A DEF             16821000
         GOIF  HEADPEND,OFF=HDLINE11    BR IF NOT XREF HEADER  @AZ28946 16822000
         MVC   RECSAVE,CONTROL          SAVE XREF RECORD       @AZ28946 16823000
         BAL   RTN,XRFHDNG              PRINT HEADER           @AZ28946 16824000
         LH    LINCTR,JLNCT             GET LINE COUNT         @AZ28946 16825000
         ST    LINCTR,LNCTRSV                                  @AZ28946 16826000
         MVC   CONTROL(L'RECSAVE),RECSAVE BACK SAVED XREF REC  @AZ28946 16827000
         MVI   XCNTRL,SPACE2            DOUBLE SPACE           @AZ28946 16828000
         SET   HEADPEND,OFF             RESET SW               @AZ28946 16829000
HDLINE11 EQU   *                                               @AZ28946 16830000
         BAL   RTN,PRTREC               PRINT ONE LINE                  16831000
HDLINE2  EQU   *                                                        16832000
         MVI   XCNTRL,SPACE1            SINGLE SPACE                    16833000
         BCT   LINCTR,HDLNX             EXIT IF PAGE NOT FULL           16834000
         GOIF  PROCXRF,OFF=HDLINE3      BR IF NOT XREF         @AZ28946 16835000
         GOIF  JMINXREF,OFF=HDLINE3     BR IF NOT XREF(SHORT)  @AZ28946 16836000
         SET   HEADPEND,ON              IND XREF HEADER PEND   @AZ28946 16837000
         B     HDLNX                    TRY NEXT XREF RECORD   @AZ28946 16838000
HDLINE3  EQU   *                                               @AZ28946 16839000
         BAL   RTN,XRFHDNG              ELSE, PRINT HEADING             16840000
         LH    LINCTR,JLNCT             GET LINE COUNT PER PAGE         16841000
         ST    LINCTR,LNCTRSV                                           16842000
         MVI   XCNTRL,SPACE2            DOUBLE SPACE                    16843000
HDLNX    LA    XRFPTR,XRFREF            GET REFERENCE POINTER           16844000
         L     R1,R1SAVE                                                16845000
         SET   LASTDEF,OFF              RESET DEF REC IND               16846000
         BR    R1                       BEFORE YOU GO                   16847000
         SPACE 3                                                        16848000
XRFDEFS  EQU   *                                                        16849000
         ST    RTN,RTNSV                SAVE RETURN LINKAGE             16850000
         GOIF  JMINXREF,ON=XRFDEF0      WORRIE ONLY IF SHORT XREF       16851000
         SET   LASTREC,OFF              SO CLEAR LAST REC IND           16852000
XRFDEF0  GOIF  LASTDEF,OFF=XRFDEFS0     WAS ALST REC ALSO A DEF REC     16853000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER OPOINTER         16854000
         LA    XRFPTR,XRFREF            GET REFERENCE POINTER           16855000
         CLI   XRFFLG,DUPL              DUPL DEF                        16856000
         BE    XRFDEFS1                 YES CONT PROC                   16857000
         CLI   XOPCDE,X'FF'             FINISHED IF LAST REC ON OX02645 16858000
         BNE   XRFDEFS1                 FINIS                   OX02645 16859000
         MVI   D1(LOUTNDX),JBLANK       MAKE SURE NO INF PRINTED        16860000
         MVC   D2(D30,LOUTNDX),D1(LOUTNDX)                              16861000
         BR    RTN                      BYPASS OUTPUT                   16862000
XRFDEFS0 EQU   *                                                        16863000
         CLI   XRFFLG,DUPL              DUPL DEF REC                    16864000
         BE    XRFDEFSA                 YES PRINT IT                    16865000
         GOIF  LASTREC,ON=XRFDEFSA      FINISHED IF LST REC ON @AX14198 16866000
XRFDEFSA BAL   R1,HDLINE                UNLOAD PREVIOUS BUFFER          16867000
XRFDEFS1 MVC   SAVSYM,XRFSYM            SAVE XREF SYMBOL FOR FUTURE TST 16868000
         TR    XRFSYM,JTRTABLE          CONVERT SYMBOL TO INTERNAL CODE 16869000
         MVC   XSYMOUT,XRFSYM           XREF SYMBOL                     16870000
         B     XLREF1                   CONTINUE PROCESSING             16871000
XLREF    EQU   *                                                        16872000
         ST    RTN,RTNSV                                                16873000
XLREF1   EQU   *                                                        16874000
         XC    JFWORD1,JFWORD1          ALIGN LENGTH ATTRIBUTE VALUE    16875000
         MVC   JFWORD1+D2(D2),XRFLEN    IN A FULL WORD AREA             16876000
         L     R15,JFWORD1              CONVERT LENGTH ATTRIBUTE        16877000
         BAL   RTN,CVTXRF               AND MOVE IT TO                  16878000
         MVC   XLENOUT,UPX              PRINT BUFFER.                   16879000
         GOIF  PROCLIT,ON=LITVAL        BRANCH IF PROCESSING LITERAL    16880000
         UNPK  UPXVAL(L'UPXVAL),XRFVAL(L'XRFVAL+1) CONVERT LOC CTR      16881000
XLREF2   EQU   *                                                        16882000
         NC    UPXVAL(L'UPXVAL),MASK1   ZERO OUT ZONES                  16883000
         MVC   XVALOUT,UPXVAL           AND MOVE IT TO PRINT            16884000
         L     R15,STMTNUM              XREF DEF STATEMENT NUMBER       16885000
         BAL   RTN,CVTXRF               DEFINED AT AND MOVE IT TO       16886000
         MVC   XDEFOUT,UPX              PRINT BUFFER.                   16887000
         L     RTN,RTNSV                                                16888000
         CLI   XRFFLG,BASE              IS RECORD A DEFINITION ONE      16889000
         BC    12,XLREF3                YES BYPASS DUPLICATION CODE     16890000
         MVC   XRFREF(L'DUPMSG),DUPMSG  DUPLICATE SYMBOL MESSAGE        16891000
         SET   LASTDEF,OFF              DUPLICATE SHOULD BE PRINTED     16892000
         BR    RTN                      RETURN TO CALLER                16893000
XLREF3   GOIF  JMINXREF,OFF=(RTN)       IS SHORT XREF REQUESTED         16894000
         SET   LASTDEF,ON               YES INDICATE THIS WAS DEF REC   16895000
         BR    RTN                      RETURN TO CALLER                16896000
LITVAL   UNPK  UPXVAL(L'UPXVAL),LITLOCTR(L'LITLOCTR+1) GET LOCATION CTR 16897000
         B     XLREF2                   RESUME PROCESSING               16898000
         SPACE                                                          16899000
CVTXRF   CVD   R15,CVDCML                         CONVERT XREF DEF, OR  16900000
         UNPK  UPX(L'UPX),UPDCML(D3)    UNPACK                          16901000
         NC    UPX(L'UPX),MASK1         ZERO OUT ZONES                  16902000
         BR    RTN                      RETURN TO CALLER                16903000
         EJECT                                                          16904000
************************************************************            16905000
*   LITERAL CROSS-REFERENCE LISTING ROUTINE.                            16906000
*   THERE ARE NO SUCH RECORD TYPES AS DUPLICATE OR UNDEFINED ON LITERAL 16907000
*   CROSS REFERENCE RECORDS. IF FOUND, GIVE X4 A DUMP.                  16908000
************************************************************            16909000
LITOUT   EQU   *                                                        16910000
         LR    R5,PARM2                                                 16911000
         GOIF  PROCLIT,ON=LITLST        BRANCH IF NOT FIRST ENTRY       16912000
         GOIF  HEADPEND,OFF=LITOUT4     BR IF NO HEADER PEND   @AZ28946 16913000
         GOIF  LASTDEF,ON=LITOUT2       BR IF LAST REC = DEF   @AZ28946 16914000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER @AZ28946 16915000
         MVC   RECSAVE,CONTROL          SAVE CURR XREF REC     @AZ28946 16916000
         BAL   RTN,XRFHDNG              PRINT XREF HEADER      @AZ28946 16917000
         MVC   CONTROL(L'RECSAVE),RECSAVE RESTOR XREF REC      @AZ28946 16918000
         MVI   XCNTRL,SPACE2            SET CONTR CHAR FOR SP2 @AZ28943 16919000
LITOUT2  EQU   *                                               @AZ28946 16920000
         SET   HEADPEND,OFF             RESET SW               @AZ28946 16921000
LITOUT4  EQU   *                                               @AZ28946 16922000
         LA    LINCTR,D1                DUMMY UP LINE COUNTER           16923000
         SET   PROCLIT,ON                                               16924000
         SET   PROCXRF,OFF              RESET SW               @AZ28946 16925000
LITLST   EQU   *                                                        16926000
         MVC   STMTN2(D2),XRFSTM        ALIGN STMT # TO HWD BNDRY       16927000
         CLI   XRFFLG,REF               TEST IF REFERENCE RECORD        16928000
         BE    XREFIN                   MAKE REFERENCE ENTRY IF YES     16929000
         SPACE 3                                                        16930000
LITDEFS  EQU   *                                                        16931000
         BAL   R1,HDLINE                PRINT HEADING IF NECESSARY      16932000
         LH    R15,LITPOLID                                             16933000
         CH    R15,LLOCTRSV                                             16934000
         BNH   LITD0                    BRANCH IF SAME POOL             16935000
         STH   R15,LLOCTRSV                                             16936000
LITD0    EQU   *                                                        16937000
         ST    R5,RFSAVE                SAVE RECORD POINTER             16938000
         SR    R15,R15                                                  16939000
         IC    R15,LITDTL               GET DATA LENGTH                 16940000
         CH    R15,H8I                  TEST IF LONGER THAN 8 CHAR.     16941000
         BH    LITD1                    YES, SPLIT INTO 2 LINES OR MORE 16942000
         BCTR  R15,0                    MAKE IT MOVE LENGTH             16943000
         EX    R15,LITMOVH              MOVE ALL INFORMATION INTO       16944000
         B     LITD5                    ONE LINE                        16945000
LITD1    EQU   *                                                        16946000
LITMOVH  MVC   LITSYM(D5),LITDTA        MOVE IN 5 BYTES                 16947000
         LA    R5,LITDTA+5              ADJUST POINTER                  16948000
         SH    R15,H5                                                   16949000
         CH    R15,H115                 TEST IF RECORD GT 115 CHAR      16950000
         BNH   LITD4                    BRANCH IF NOT                   16951000
LITD2    MVC   LITSYM5(XRL-5),D0(R5)    COMPLETE ONE LINE               16952000
         ST    R15,R15SAVE              SAVE LENGTH                     16953000
         BAL   R1,HDLINE                PRINT HEADING IF NECESSARY      16954000
         L     R15,R15SAVE              RESTORE LENGTH                  16955000
LITD3    SH    R15,H115                 DECREMENT BYTE COUNT            16956000
         AH    R5,H115                  BUMP POINTER                    16957000
         CH    R15,H115                 TEST IF STILL GT 115 CHAR       16958000
         BH    LITD2                    BRANCH IF YES                   16959000
LITD4    BCTR  R15,0                    MAKE IT MOVE LENGTH             16960000
         EX    R15,LITMOV               MOVE THE REST                   16961000
         CH    R15,H2                   TEST IF LAST LINE               16962000
         BNH   LITD5                    NOT MORE THAN 3 CHARACTERS      16963000
         BAL   R1,HDLINE                PRINT HEADING IF NECESSARY      16964000
LITD5    EQU   *                                                        16965000
         L     R5,RFSAVE                POINT BACK                      16966000
         BAL   RTN,XLREF                BUILD RECORD                    16967000
         B     XRFEXIT                  NEXT RECORD                     16968000
*                                                                       16969000
LITMOV   MVC   LITSYM5(0),D0(R5)        OFF-THE-LINE MOVE               16970000
         EJECT                                                          16971000
************************************************************            16972000
*   RLD HEADING ROUTINE                                                 16973000
************************************************************            16974000
RLDHDNG  STM   R1,R6,RTADDR             SAVE REGISTERS 1 - 6            16975000
         BAL   RTN,PGECNT               BUMP PAGE COUNT                 16976000
         GOIF  FIRST,ON=SECPRT          BRANCH IF SECOND PRINT @OY06558 16977000
         BAL   RTN,PRTREC                                               16978000
         SET   FIRST,ON                 SET FIRST PRINT ON     @OY08558 16979000
SECPRT   L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER @OY06558 16980000
         MVI   CONTROL,EJBYTE           EJECT TO NEW PAGE               16981000
         MVC   TITLE(L'JDECKID),JDECKID TITLE ID                        16982000
         MVC   HDGPTR(L'RLDH1),RLDH1    'RELOCATION DICTIONARY'         16983000
         MVC   PGEPTR(L'PAGE),PAGE      'PAGE'                          16984000
         MVC   PGENUM(L'PGENUM),UPX     RLD PAGE COUNT                  16985000
         BAL   RTN,PRTREC               PRINT ONE LINE                  16986000
         MVI   CONTROL,SPACE3           TRIPLE SPACE                    16987000
         MVC   TITLE(L'RLDH2),RLDH2     RLD HEADING 2                   16988000
         MVC   DTEPTR(L'JLVTMDT),JLVTMDT COMPNT-LEVEL-MONTH-DAY-YR      16989000
         B     HDNGX                    PRINT ONE LINE AND EXIT         16990000
         EJECT                                                          16991000
************************************************************            16992000
*   SYMBOL/LITERAL XREF HEADING ROUTINE                                 16993000
************************************************************            16994000
XRFHDNG  STM   R1,R6,RTADDR             SAVE ADDRESS OF CALLER          16995000
         BAL   RTN,PGECNT               CONVERT PAGE COUNT FOR PRINTING 16996000
         GOIF  LASTDEF,OFF=XRFHD0       DONT PRINT IF IT WAS DEF        16997000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER          16998000
         B     XRFHD05                  BYPASS PRINT                    16999000
XRFHD0   EQU   *                                                        17000000
         L     LOUTNDX,LOUTSV           RESTORE BUFFER POINTER @OY06558 17001000
XRFHD05  EQU   *                                                        17002000
         MVI   CONTROL,EJBYTE           EJECT TO NEW PAGE               17003000
         MVC   TITLE(L'JDECKID),JDECKID TITLE ID                        17004000
         MVI   TITLE+D8,JBLANK         CLEAN HEADER LINE       @OX07206 17005000
         MVC   TITLE+D9(PGEPTR-TITLE-D9),TITLE+D8 CLN HDRLINE  @OX07206 17006000
         MVC   HDGPTR(L'XRFH1),XRFH1    'CROSS-REFERENCE'               17007000
         GOIF  PROCLIT,OFF=XRFHD1       BRANCH IF PROC'G LIT XREF       17008000
         MVC   HDGPTR(L'LITH1+L'XRFH1),LITH1 MOVE IN HEADING            17009000
XRFHD1   EQU   *                                                        17010000
         MVC   PGEPTR(L'PAGE),PAGE      'PAGE'                          17011000
         MVC   PGENUM(L'PGENUM),UPX     XREF PAGE COUNT                 17012000
         BAL   RTN,PRTREC               PRINT ONE LINE                  17013000
         MVI   CONTROL,SPACE3           TRIPLE SPACE                    17014000
         MVC   TITLE(L'XRFH2),XRFH2     XREF HEADING 2                  17015000
         MVC   DTEPTR(L'JLVTMDT),JLVTMDT COMPNT-LEVEL-MONTH-DAY-YEAR    17016000
HDNGX    EQU   *                                                        17017000
         BAL   RTN,PRTREC               PRINT ONE LINE                  17018000
         ST    LOUTNDX,RTADDR+4         OUTPUT POINTER                  17019000
         LM    R1,R6,RTADDR             ADDRESS OF CALLER               17020000
         BR    RTN                      RETURN TO CALLER                17021000
         EJECT                                                          17022000
************************************************************            17023000
*   PAGE COUNT SUBROUTINE                                               17024000
************************************************************            17025000
PGECNT   EQU   *                                                        17026000
         LH    R2,JPAGENO               XREF PAGE COUNT                 17027000
         LA    R2,D1(,R2)               INCREASE PAGE COUNT             17028000
         STH   R2,JPAGENO               SAVE PAGE NUMBER                17029000
         CVD   R2,CVDCML                CONVERT INTO DECIMAL            17030000
         UNPK  UPX(L'UPX),UPDCML(D3)    UNPACK                          17031000
         NC    UPX(L'UPX),MASK1         ZERO OUT ZONES                  17032000
         LA    R2,MASKLEN               COUNT FOR MASKING OUT LEADING 0 17033000
         LA    R3,UPX                   POINTER TO LEAD CHARACTER       17034000
LOOP     CLI   D0(R3),J0                TEST FOR LEADING ZEROS          17035000
         BCR   7,RTN                    BRANCH IF NOT ZERO              17036000
         MVI   D0(R3),JBLANK            MASK OUT ZERO WITH A BLANK      17037000
         LA    R3,D1(,R3)               STEP TO NEXT CHARACTER          17038000
         BCT   R2,LOOP                  LOOP BACK UP TO 3 TIMES         17039000
         BR    RTN                      RETURN TO CALLER                17040000
         EJECT                                                          17041000
************************************************************            17042000
*   THIS ROUTINE PRINTS ONE LINE ONTO PRINT FILE.                       17043000
************************************************************            17044000
PRTREC   EQU   *                                                        17045000
         ST    PARM2,FWORD                                              17046000
         JPRINT                         PRINT ONE LINE                  17047000
         LR    LOUTNDX,PARM2            GET BASE                        17048000
         ST    LOUTNDX,LOUTSV           SAVE POINTER                    17049000
         L     PARM2,FWORD                                              17050000
         BR    RTN                      RETURN TO CALLER                17051000
         SPACE 5                                                        17052000
************************************************************            17053000
*   THIS ROUTINE PUNCHES ONE LINE ONTO PUNCH FILE.                      17054000
************************************************************            17055000
         USING RCARD,COUTNDX                                            17056000
PCHREC   EQU   *                                                        17057000
         ST    PARM2,FWORD                                              17058000
         JPUNCH SEQ=YES                                                 17059000
         LR    COUTNDX,PARM2            AND SAVE ADDRESS                17060000
         MVI   CARDID,XBLANK            FILL BUFFER WITH EXTERNAL       17061000
         MVC   RLDNAM(RCARDL-1),CARDID  BLANKS                          17062000
         MVI   CARDID,J2                12-2-9 COMBINATION IN COLUMN 1  17063000
         MVC   RLDNAM,RLDC              RLD NAME EXTERNAL FORMAT        17064000
         LA    R15,RLDFLD               POINT TO DATA FIELD             17065000
         SR    RLDCNT,RLDCNT            INITIAL RLD COUNT               17066000
         ST    COUTNDX,PCHSAVE                                          17067000
         STM   RLDCNT,R15,RFSAVE        SAVE                            17068000
         XC    ESDCOMP,ESDCOMP                                          17069000
         L     PARM2,FWORD                                              17070000
         BR    RTN                      RETURN TO CALLER                17071000
         EJECT                                                          17072000
************************************************************            17073000
*   CONSTANTS, CONSTANTS, CONSTANTS                                     17074000
************************************************************            17075000
         DS    0F                                                       17076000
H1I      DC    H'1'                                                     17077000
H2       DC    H'2'                                                     17078000
H4I      DC    H'4'                                                     17079000
H5       DC    H'5'                                                     17080000
H7       DC    H'7'                                                     17081000
H8I      DC    H'8'                                                     17082000
H56      DC    H'56'                                                    17083000
H115     DC    H'115'                                                   17084000
RLDC     DC    CL3'RLD'                 EXTERNAL RLD NAME               17085000
RLDH1    JGENIN 'RELOCATION DICTIONARY'                                 17086000
RLDH2    JGENIN 'POS.ID   REL.ID   FLAGS   ADDRESS'                     17087000
PAGE     JGENIN 'PAGE'                                                  17088000
LITH1    JGENIN 'LITERAL '                                              17089000
XRFH1    JGENIN 'CROSS-REFERENCE'                                       17090000
XRFH2    JGENIN 'SYMBOL    LEN   VALUE   DEFN    REFERENCES'            17091000
DUPMSG   JGENIN '****DUPLICATE****'                                     17092000
UNDFMSG  JGENIN '****UNDEFINED****   '                         @OX10363 17093000
MASK1    DC    16X'0F'                  ZONE DELETOR                    17094000
         JPATCH X6A20,5E0             5% PATCH AREA                     17095000
         END   PPENT                                                    17096000
./ ADD NAME=IFNX6B                                                      17097000
* /* START OF SPECIFICATIONS ****                                       17098000
*02* PROCESSOR = ASSEMBLER                                              17099000
**** END OF SPECIFICATIONS ***/                                         17100000
         MACRO                                                          17101000
         BLDPRM &SW,&PARM                                               17102000
.*  THIS MACRO IS USED TO BUILD THE ASSEMBLER OPTIONS PRINT LINES FOR   17103000
.*   THE STATISTICS PRINT ROUTINE.                                      17104000
         GOIF  &SW,ON=MV&PARM           CHECK OPTION SWITCH             17105000
         EX    R0,MVNO                  IF OFF MOVE IN THE WORD NO      17106000
         LA    COUNT,L'NO(COUNT)        BUMP PRINT LINE INDEX           17107000
MV&PARM  LA    R2,P&PARM                GET ADDRESS AND                 17108000
         LA    R1,L'P&PARM.-D1(R0)          LENGTH OF PARM              17109000
         EX    R1,MVPARM                MOVE IN PARM                    17110000
         AR    COUNT,R1                 BUMP PRINT LINE INDEX           17111000
         LA    COUNT,D1(COUNT)          ADD 1 TO PRINT LINE INDEX       17112000
         MEND                                                           17113000
         SPACE 5                                                        17114000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                17115000
         SPACE 5                                                        17116000
         JHEAD 'DIAGNOSTIC PHASE - PROLOG',                            C17117000
               PHASEID=X6B,                                            C17118000
               LEVEL=10                                                 17119000
*FUNCTION/OPERATION-                                                  * 17120000
*   THE DIAGNOSTIC PROCESSOR PHASE DECODES ERROR RECORDS AND LISTS    * 17121000
*   THE ASSOCIATED ERROR MESSAGES COMPLETE WITH DATA APPENDED TO THE  * 17122000
*   ERROR RECORDS INSERTED INTO THE MESSAGES AT THE POINTS NECESSARY  * 17123000
*   FOR INTELLEGENT READING.  IF THE RELOCATABLE YCON OR RE-ENTRANT   * 17124000
*   TEST FAILURE FLAGS ARE SET, THEIR ASSOCIATED WARNINGS ARE ALSO    * 17125000
*   LISTED.  OPTION STAT PRODUCES THE FOLLOWING STATISTICS AT THE     * 17126000
*   END OF THE ASSEMBLY LISTING-                                      * 17127000
*                                                                     * 17128000
*   1.  HIGHEST SEVERITY CODE ENCOUNTERED (IF ANY).                   * 17129000
*   2.  OPTIONS FOR THE ASSEMBLY.                                     * 17130000
*   3.  TOTAL RECORDS READ FROM SYSIN.                                * 17131000
*   4.  TOTAL RECORDS READ FROM SYSLIB.                               * 17132000
*   5.  TOTAL LINES PRINTED.                                          * 17133000
*   6.  TOTAL CARDS PUNCHED.                                          * 17134000
*                                                                     * 17135000
*   FINALLY IF  OPTION DECK IS EXERCISED AND THE ASSEMBLY HAS         * 17136000
*   PRODUCED OBJECT OUTPUT, AN END CARD WILL BE PUNCHED CONTAINING    * 17137000
*   THE FOLLOWING INFORMATION-                                        * 17138000
*                                                                     * 17139000
*   COLUMNS         CONTENTS                                          * 17140000
*     1             12-2-9 PUNCH                                      * 17141000
*     2-4           END                                               * 17142000
*     5             BLANK                                             * 17143000
*     6-8           ENTRY ADDRESS FROM SOURCE DECK END CARD OPERAND   * 17144000
*                   (BLANK IF NO OPERAND)                             * 17145000
*     9-14          BLANK                                             * 17146000
*     15-16         ESDID OF ENTRY POINT (BLANK IF NO OPERAND)        * 17147000
*     17 - 32       BLANK                                             * 17148000
*     33            NUMBER OF IDR ITEMS FOLLOWING                     * 17149000
*     34 - 43       TRANSLATOR IDENTIFICATION, PADDED                 * 17150000
*     44 - 45       VERSION LEVEL OF PROCESSOR                        * 17151000
*     46 - 47       MODIFICATION LEVEL OF PROCESSOR                   * 17152000
*     48 - 49       LAST TWO DIGITS OF YEAR                           * 17153000
*     50 - 52       DAY OF YEAR                                       * 17154000
*     53 - 71       SAME AS 34 - 52 FOR SECOND IDR IF PRESENT         * 17155000
*     72            BLANK                                             * 17156000
*     73-76         DECK ID (FROM FIRST TITLE CARD)                   * 17157000
*     77-80         CARD SEQUENCE NUMBER                              * 17158000
*                                                                     * 17159000
*                                                                     * 17160000
*                                                                     * 17161000
*                                                                     * 17162000
*ENTRY POINT-                                                         * 17163000
*   BEGIN                                                             * 17164000
*                                                                     * 17165000
*                                                                     * 17166000
*INPUT-                                                               * 17167000
*   ERROR RECORDS.  THE RECORD FORMAT IS-                             * 17168000
*                                                                     * 17169000
*   BYTE       CONTENTS                                               * 17170000
*   0-1        RECORD LENGTH                                          * 17171000
*   2          FLAG A                                                 * 17172000
*   3          FLAG B                                                 * 17173000
*   4          INTERNAL OP CODE                                       * 17174000
*   5          COLUMN POINTER                                         * 17175000
*   6-7        ERROR NUMBER CODE                                      * 17176000
*   8-9        STATEMENT NUMBER                                       * 17177000
*   10         NUMBER OF APPENDED 8-BYTE DATA ITEMS (MAXIMUM 10)      * 17178000
*   11-90      APPENDED 8-BYTE DATA ITEMS                             * 17179000
*                                                                     * 17180000
*OUTPUT-                                                              * 17181000
*   ERROR MESSAGES, NUMBER OF STATEMENTS FLAGGED, AND ASSEMBLY        * 17182000
*   STATISTICS WRITTEN TO THE PRINT FILE.  END CARD WRITTEN TO THE    * 17183000
*   PUNCH FILE.                                                       * 17184000
*                                                                     * 17185000
*EXTERNAL ROUTINES-                                                   * 17186000
*   N/A                                                               * 17187000
*EXITS, NORMAL-                                                       * 17188000
*   JRETURN                                                           * 17189000
*                                                                     * 17190000
*EXITS, ERROR-                                                        * 17191000
*   NONE                                                              * 17192000
*                                                                     * 17193000
*ATTRIBUTES-                                                          * 17194000
*   REFRESHABLE                                                       * 17195000
*                                                                     * 17196000
*                                                                     * 17197000
*                                                                     * 17198000
         SPACE 3                                                        17199000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   17200000
         COPY  JCOMMON                                                  17201000
         PRINT OFF                      DON'T PRINT JTEXT COPY CODE     17202000
         COPY  JTEXT                                                    17203000
         PRINT OFF                      DON'T PRINT JERRCD COPY CODE    17204000
         COPY  JERRCD                                                   17205000
         PRINT ON                       THAT'S ALL THE COPY CODE        17206000
         SPACE 2                                                        17207000
    TITLE '&COMPNM&ASMID - DIAGNOSTIC PHASE - X6B COMMON AREA (X6BCOM)' 17208000
X6BCOM   DSECT                          X6B COMMON AREA                 17209000
STRTCOM  DS    0D                       START OF X6B COMMON             17210000
DWORD1   DS    D                        DOUBLEWORD1                     17211000
DWORD2   DS    D                        DOUBLEWORD2                     17212000
DBLWD1   DS    D                        WORK                            17213000
DBLWD2   DS    0D                           AREAS                       17214000
         DS    CL3                                                      17215000
CSTMT    DS    0CL5                     CONVERTED STATEMENT NUMBER      17216000
         DS    C                                                        17217000
CERROR   DS    0CL4                     CONVERTED ERROR CODE            17218000
CPAGE    DS    0CL4                     CONVERTED PAGE NUMBER           17219000
         DS    CL1                                                      17220000
CCOLPTR  DS    CL3                      CONVERTED COLUMN POINTER        17221000
SAVERTN1 DS    F                        SAVE AREAS FOR                  17222000
SAVERTN2 DS    F                             RTN REGISTER               17223000
SVPRTBAS DS    F                        PRINT BUFFER BASE SAVE AREA     17224000
ERDATADR DS    F                       SAVE AREA FOR APPENDED DATA ADDR 17225000
FLDSAVE  DS    F                        SAVE AREA                       17226000
STRADR   DS    F                        STRING ADDRESS                  17227000
LSTMTNO  DS    F                        LAST STATEMENT NUMBER SAVE AREA 17228000
PGLINES  DS    H                        LINES PRINTED ON CURRENT PAGE   17229000
ERRQTY   DS    H                        COUNT OF STATEMENTS FLAGGED     17230000
CDSTMT   DS    H                        CARD WITHIN STMT                17231000
HWD      DS    H                        HALFWORD SAVE AREA              17232000
COLSAV   DS    H                        COLUMN SAVE AREA                17233000
SWITCHES DSW   STATSW,                  TO CONTROL STMT-ERROR-MSG HDNG X17234000
               NOBLK,                   LEFT ZERO SUPPRESSION CONTROL  *17235000
               ERRSW,                   UNDEFINED ERROR CODE SWITCH    X17236000
               ERLIT,                   ERROR AFTER LITERAL            X17237000
               COLOVLP                  COLUMN OVERLAP CHECK BIT        17238000
CARDP    DSW   CDPTR1                   CARD PTR FLAG                   17239000
TSPRINT  EQU   12                       TSO PRINT                       17240000
SEVCDE   DS    C                        SEVERITY CODE SAVE AREA         17241000
PRTLNSAV DS    CL120                    PRINT LINE SAVE AREA            17242000
BUFTERM  DS    31F                      124 BYTES FOR TERMINAL BUFFER   17243000
MNDX     EQU   R2                      MESSAGE INDEX                    17244000
MTABPTR  EQU   R3                      MTABLE BASE                      17245000
COUNT    EQU   R4                       COUNTING REGISTER               17246000
RTN      EQU   R5                       INTERNAL RETURN LINKAGE         17247000
INBASE   EQU   R6                       JGETL BUFFER BASE REGISTER      17248000
FILEREG  EQU   R10                      JGETL FILENAME PARAMETER REG    17249000
MSGLN    EQU   R10                     MESSAGE LENGTH                   17250000
PRTBASE  EQU   R11                      PRINT BUFFER BASE REGISTER      17251000
EJCT     EQU   X'00'                    EJECT THEN PRINT                17252000
SPACE1   EQU   X'01'                    SINGLE SPACE THEN PRINT         17253000
SPACE2   EQU   X'02'                    DOUBLE SPACE THEN PRINT         17254000
SPACE3   EQU   X'03'                    TRIPLE SPACE THEN PRINT         17255000
ENDCOM   EQU   *                        END OF X6BCOM COMMON AREA       17256000
    TITLE '&COMPNM&ASMID - DIAGNOSTIC PHASE - TERMINAL BUFFER DSECT ANDX17257000
                JTEXTA DSECT'                                           17258000
TERMBUF  DSECT                                                          17259000
BUFC     DS    C                        BUFFER RECORD LENGTH            17260000
PRTIMG   DS    0CL120                   LENGTH OF PRINTLINE             17261000
SEQNO    DS    CL8                      SEQUENCE NUMBER                 17262000
BLNK1    DS    CL4                      BLANKS                          17263000
STMTNO   DS    CL5                      STMT NUMBER                     17264000
GENFLG   DS    CL1                      GENERATED STMT FLAG             17265000
SOURCE   DS    CL80                     SOURCE IMAGE                    17266000
         ORG   SOURCE+72                                                17267000
SEQNUM   DS    CL8                      SEQ NUM FROM SOURCE             17268000
         ORG   PRTIMG                                                   17269000
ERCDE    DS    CL6                      ERROR CODE                      17270000
BLNK2    DS    CL1                      BLANK                           17271000
ERMSG    DS    CL101                    ERROR MESSAGE                   17272000
         SPACE 5                                                        17273000
JTEXTA   DSECT                          JTEXTA DSECT                    17274000
         ORG   JTOCO                                                    17275000
OPTR     DSW   CDPTR                    CARD PTR FLAG                   17276000
         ORG   JTOCO                    REORG FOR OTHER PTRS            17277000
OCPTR    DS    C                        OUTPUT COLUMN PTR               17278000
LENGTH   DS    C                        LENGTH OF FIELD                 17279000
FIELD    EQU   *                        FIELD IN TEXT RECORD            17280000
         SPACE 3                                                        17281000
         TITLE '&COMPNM&ASMID - DIAGNOSTIC PHASE - PRINT BUFFER DSECT AX17282000
               ND PUNCH BUFFER DSECT'                                   17283000
*                             GENERAL MESSAGE LINE HEADING              17284000
PRTBUF   DSECT                                                          17285000
         USING PRTBUF,R11               USING FOR ALL PRINT LINES       17286000
CNTRL    DS    C                        CONTROL BYTE                    17287000
PRTLINE  DS    0CL120                   GENERAL PURPOSE PRINT LINE      17288000
         DS    CL19                                                     17289000
MSGBEG   DS    CL101                    MESSAGE BEGINING                17290000
*                                                                       17291000
*                             PAGE HEADING FORMAT                       17292000
*                                                                       17293000
         ORG   PRTLINE                                                  17294000
HLDIAG2  DS    0C                      STMT - ERROR-CODE - MESSAGE      17295000
HLTITLE  DS    CL4                      TITLE ID                        17296000
         DS    CL46                                                     17297000
HLDIAG   DS    CL11                     DIAGNOSTIC HEADING              17298000
         DS    CL35                                                     17299000
HLDATE   DS    CL15                     DATE                            17300000
HLPAGE   DS    CL4                      PAGE                            17301000
         DS    C                                                        17302000
HLPGENO  DS    CL4                      PAGE NUMBER                     17303000
*                                                                       17304000
*                             ERROR MESSAGE FORMAT                      17305000
*                                                                       17306000
         ORG   PRTLINE                                                  17307000
ELSTMTNO DS    CL5                      ERROR STATEMENT NUMBER          17308000
         DS    CL2                                                      17309000
ELERPFIX DS    CL2                      COMPONENT PREFIX                17310000
ELERRCDE DS    CL4                      ERROR CODE                      17311000
         DS    CL6                                                      17312000
ELERMSG  DS    CL101                    BEGINING OF ERROR MESSAGE       17313000
         SPACE 3                                                        17314000
PCHBUF   DSECT                                                          17315000
PCNTRL   DS    C                        12-2-9 PUNCH                    17316000
PCLINE   DS    0CL71                    PUNCH LINE                      17317000
PCEND    DS    CL3                      END                             17318000
         DS    C                        BLANK                           17319000
PCENTAD  DS    CL3                      ENTRY FROM SOURCE END CD OPND   17320000
         DS    CL6                      BLANK                           17321000
PCESDID  DS    CL2                      ESDID OF ENTRY POINT            17322000
         DS    CL16                    BLANK                            17323000
PCCOMP   DS    CL(L'JIDR)              IDR                              17324000
MTBLE    DSECT                                                          17325000
MADDR    DS    H                        MESSAGE ADDRESS                 17326000
MLN      DS    H                        MOVE LENGTH OF MESSAGE          17327000
         SPACE 2                                                        17328000
    TITLE '&COMPNM&ASMID - DIAGNOSTIC PHASE '                           17329000
         JCSECT (X6B00)                                                 17330000
* VS1 RELEASE 5.0 CHANGES                                               17331000
*A560304,680370                                                @OX09734 17332000
*C669600                                                       @OX09734 17333000
*A664600                                                       @OX12916 17334000
*A557024,557028,557081-557083,667520,600400-600820             @AZ13738 17335000
*A681400,560305-560408                                         @AZ13738 17336000
*C681700,680370                                                @AZ13738 17337000
         JMODID                                                         17338000
*********************************************************************** 17339000
*              THIS IS THE MAIN LINE OF THE PHASE.  IT PERFORMS ANY   * 17340000
*              INITIALIZATION NECESSARY AND CHECKS THE OPTIONS        * 17341000
*              DESIRED (LIST, DECK, LINK).  IF NONE OF THESE OPTIONS  * 17342000
*              ARE REQUESTED, IT TERMINATES.  IN ADDITION, IF THE     * 17343000
*              FLAG IS SET TO INDICATE THE PRESENCE OF A RELOCATABLE  * 17344000
*              YCON, THAT MESSAGE IS CREATED.  IT THEN CHECKS THE     * 17345000
*              ERROR FLAG FOR OTHER ERRORS.  IF IT IS OFF, CONTROL IS * 17346000
*              PASSED TO THE NO-ERROR ROUTINE.  OTHERWISE IT BEGINS   * 17347000
*              GETTING RECORDS FROM THE INPUT FILE AND CHECKING THEM  * 17348000
*              FOR END-OF-DATA OR ERROR-RECORD FLAGS.  IF NEITHER OF  * 17349000
*              THESE FLAGS IS PRESENT, IT GETS ANOTHER RECORD.  OTHER-* 17350000
*              WISE IT TRANSFERS CONTROL TO THE APPROPRIATE SUBROUTINE* 17351000
*********************************************************************** 17352000
BEGIN    JSAVE                                                          17353000
         JENTRY (X6B01=BEGIN)                                           17354000
         USING X6BCOM,R7                USING FOR X6B COMMON            17355000
         LA    R10,(ENDCOM-STRTCOM+D7)/D8 SIZE OF COMMON                17356000
         JGETCORE DBL=(R10)                                             17357000
         LR    R7,R10                   BASE FOR X6B COMMON             17358000
         LA    R15,D1(R0)               INIT LINE CNT TO FORCE PG HDNG  17359000
         STH   R15,PGLINES               ON FIRST PRINT ATTEMPT         17360000
         L     R0,=H'-1'                                                17361000
         ST    R0,LSTMTNO               SET TO NEG TO COUNT STMT 0 ERR  17362000
         SR    R0,R0                    CLEAR REGISTER                  17363000
         ST    R0,JFWORD1               CLEAR WORK AREA                 17364000
         STH   R0,ERRQTY                INITIALIZE ERROR COUNT TO ZERO  17365000
         MVC   SEVCDE(L'SEVCDE),JSEVER  AND SEVERITY CODE               17366000
         STC   R0,SWITCHES              SET ALL SWITCHES TO OFF         17367000
         GOIF  (JDECK,JLINK),NONE=NPCH  IF NODECK NOLINK SKIP END CARD  17368000
         GOIF  JENDCHK,OFF=NPCH         IF END CARD SW OFF DONT PCH     17369000
         BAL   RTN,PUNCHEC                  ELSE GO TO END CARD ROUTINE 17370000
NPCH     GOIF  JTERM,OFF=SKTERM1        BRANCH IF TERM OFF              17371000
         USING TERMBUF,R11              SET UP USING FOR TERM BUFEER    17372000
         BAL   RTN,BUFINIT              INITIALIZE BUFFER               17373000
         MVI   BUFC,EJCT                MAKE A NEW PAGE                 17374000
         MVC   PRTIMG(L'ASMXF),ASMXF    PRINT XF DONE MESSAGE           17375000
         JTPRINT                        GET TERMINAL BUFFER             17376000
         BAL   RTN,BUFINIT              CLEAR BUFFER                    17377000
SKTERM1  EQU   *                        BRANCH LABEL                    17378000
         USING PRTBUF,R11               SET UP USING FOR PRINTBUF       17379000
         LA    R11,BUFTERM              PT TO TERM BUF INCASE NOLIST    17380000
         GOIF  JLIST,OFF=NPRT           BRANCH IF LIST OFF              17381000
         JPRINT                                                         17382000
NPRT     GOIF  (JMISLIN,JMISPCH,JINVOPT,JMISPRT,JMISTERM,JMISLIB),     *17383000
               NONE=REYCONCK                 CHECK FOR JCL ERRORS       17384000
         GOIF  JMISLIB,OFF=CKLDDER      SYSLIB DD CARD MISSING          17385000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J6,J9)  SET UP ERR CDE  17386000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX               AND PREFIX     17387000
         MVC   ELERMSG(L'S269),S269     MOVE MESSAGE TO PRINT LINE      17388000
         BAL   RTN,TERMERR              PRINT ON SYSTERM TOO            17389000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17390000
         CLI   SEVCDE,X'10'             IS SEVCDE HIGHER THAN 16        17391000
         BNL   CKLDDER                  YES - DON'T SAVE SEV CODE       17392000
         MVI   SEVCDE,X'10'             NO - SAVE SEV CODE              17393000
         SPACE                                                          17394000
CKLDDER  GOIF  JMISLIN,OFF=CKPRTER      SYSLIN DD CARD ERROR TEST       17395000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J5,J6)  SET UP ERR CDE  17396000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX         AND PREFIX           17397000
         MVC   ELERMSG(L'S256),S256     MOVE MESSAGE TO PRINT LINE      17398000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17399000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17400000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17401000
         BNL   CKPRTER                  YES - DON'T SACE SEV CODE       17402000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17403000
         SPACE                                                          17404000
CKPRTER  GOIF  JMISPRT,OFF=CKPDDER      SYSPRINT DD CARD ERROR TEST     17405000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J6,J7) SET UP ERR CODE  17406000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX       AND PREFIX             17407000
         MVC   ELERMSG(L'S267),S267     MOVE MSG TO PRINT LINE          17408000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17409000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17410000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17411000
         BNL   CKPDDER                  YES - DONT SAVE SEV CODE        17412000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17413000
         SPACE                                                          17414000
CKPDDER  GOIF  JMISPCH,OFF=CKTDDER      SYSPUNCH DD CARD ERROR TEST     17415000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J5,J7)  SET UP ERR CDE  17416000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX         AND PREFIX           17417000
         MVC   ELERMSG(L'S257),S257     MOVE MESSAGE TO PRINT LINE      17418000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17419000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17420000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17421000
         BNL   CKTDDER                  YES - DON'T SAVE SEV CODE       17422000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17423000
         SPACE                                                          17424000
CKTDDER  GOIF  JMISTERM,OFF=CKOPTER     SYSTERM DD CARD MISSING         17425000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J6,J8)  SET UP ERR CDE  17426000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX         AND PREFIX           17427000
         MVC   ELERMSG(L'S268),S268     MOVE MESSAGE TO PRINT LINE      17428000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17429000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17430000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17431000
         BNL   CKOPTER                  YES - DON'T SAVE SEV CODE       17432000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17433000
         SPACE                                                          17434000
CKOPTER  GOIF  JINVOPT,OFF=REYCONCK     INVALID OPTION ERROR TEST       17435000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J5,J8)  SET UP ERR CDE  17436000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX         AND PREFIX           17437000
         MVC   ELERMSG(L'S258),S258     MOVE MESSAGE TO PRINT LINE      17438000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17439000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17440000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17441000
         BNL   REYCONCK                 YES - DON'T SAVE SEV CODE       17442000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17443000
         SPACE                                                          17444000
REYCONCK GOIF  JESDOFLO,OFF=YCONCHK     BRANCH IF NO ESDID OVERFLOW     17445000
         MVC   ELERRCDE+D1(L'ELERRCDE-D1),=AL1(J2,J6,J4) SETUP ERR CODE 17446000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX  SETUP PREFIX                17447000
         MVC   ELERMSG(L'S264),S264     MOVE MSG TO PRINT LINE          17448000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17449000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17450000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17451000
         BNL   YCONCHK                  YES - DON'T SAVE SEV CODE       17452000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17453000
         SPACE                                                          17454000
YCONCHK  GOIF  JYCON,OFF=ERRCHK         IF YCON SW OFF GO TEST ERROR SW 17455000
         MVC   ELERRCDE+1(L'ELERRCDE-1),=AL1(J2,J5,J9)  SET UP ERR CDE  17456000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX         AND PREFIX           17457000
         MVC   ELERMSG(L'S259),S259     MOVE MESSAGE TO PRINT LINE      17458000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17459000
         BAL   RTN,PRINT                GO TO PRINT ROUTINE             17460000
         CLI   SEVCDE,X'04'             IS SEV CODE HIGHER THAN 4       17461000
         BH    ERRCHK                   YES - DON'T SAVE SEV CODE       17462000
         MVI   SEVCDE,X'04'             NO - SAVE SEVERITY CODE         17463000
ERRCHK   EQU   *                                                        17464000
         TM    JPRTONLY,JPRONLY         SYMBOL TABLE OVERFLOWED         17465000
         BZ    ERRCHK1                  BRANCH IF NOT                   17466000
         MVC   ELERRCDE+D1(L'ELERRCDE-D1),=AL1(J2,J6,J5) SETUP ERRCDE   17467000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX    AND PREFIX                17468000
         MVC   ELERMSG(L'S265),S265     MOVE MSG TO PRINT LINE          17469000
         BAL   RTN,TERMERR              PRINT ON SYSTERM IF SO          17470000
         BAL   RTN,PRINT                GO PRINT MSG                    17471000
         CLI   SEVCDE,X'10'             IS SEV CODE HIGHER THAN 16      17472000
         BNL   ERRCHK1                  YES - DON'T SAVE SEV CODE       17473000
         MVI   SEVCDE,X'10'             NO - SAVE SEVERITY CODE         17474000
ERRCHK1  EQU   *                        BRANCH LABEL                    17475000
         GOIF  JERRCHK,OFF=NOERR        IF NO ERRORS GO TO NO ERROR RTN 17476000
GETRCD   EQU   *                                                        17477000
         LH    FILEREG,JINFILE          GET NAME OF INPUT FILE          17478000
         ST    PRTBASE,SVPRTBAS         SAVE PRINT BUFFER BASE REG      17479000
         JGETL FILE=(FILEREG)                                           17480000
         LR    INBASE,R11               ESTABLISH BASE FOR INPUT RCD    17481000
         USING JERRCD,INBASE            USING FOR INPUT RECORD          17482000
         L     PRTBASE,SVPRTBAS         RESTORE PRINT BUFFER BASE REG   17483000
         GOIF  JEEOF,EQ=EODRTN          CHECK FOR END-OF-DATA FLAG      17484000
         GOIF  JTERM,OFF=GETRCD1        TSO ON?                         17485000
         CLI   D4(INBASE),JT            IS IT A TEXT RECORD             17486000
         BNE   GETRCD1                  BRANCH IF NOT EQUAL             17487000
         LH    R1,D14(,INBASE)          GET STRING POINTER              17488000
         AR    R1,INBASE                POINT TO STRING GROUP           17489000
         ST    R1,STRADR                SAVE STRING GROUP POINTER       17490000
         MVC   CDSTMT,=H'1'             RESET CARD-WITHIN-STMT          17491000
         JCALL PRINTEXT                 CALL PRINT TEXT RECORD          17492000
         L     PRTBASE,SVPRTBAS         RE-RESTORE PRINT BUF BASE REG   17493000
         SET   ERLIT,OFF                RESET ERROR-AFTER LITERAL BIT   17494000
         B     GETRCD                   GO GET NEXT RECORD              17495000
GETRCD1  EQU   *                        BRANCH LABEL                    17496000
         GOIF  JEOPCOD,NE=GETRCD2       IS IT ERROR RECORD?             17497000
         BAL   RTN,ERRORTN              GO PROCESS ERROR RECORD         17498000
         B     GETRCD                   GET NEXT RECORD                 17499000
GETRCD2  EQU   *                        BRANCH LABEL                    17500000
         GOIF  JTERM,OFF=GETRCD         TSO ON?                         17501000
         CLI   D4(INBASE),JY            IS IT A LITERAL XREF            17502000
         BNE   GETRCD                   BRANCH TO GET RECORD IF NOT     17503000
         CLI   D4(INBASE),BIT6          IS IT LITERAL REFERENCE         17504000
         BE    GETRCD                   YES,GO GET NEXT RECORD          17505000
         SET   ERLIT,ON                 START OF LITERALS               17506000
         B     GETRCD                   GET NEXT RECORD                 17507000
BUFINIT  EQU   *                        INITIALIZE BUFFER               17508000
         USING TERMBUF,R11              USING FOR TERMINAL BUFFER       17509000
         LA    R11,BUFTERM              GET ADDRESS OF BUFFER           17510000
         MVI   BUFC,SPACE1              DO SINGLE SPACE                 17511000
         MVI   PRTIMG,JBLANK            SET 1ST CHAR TO BLANK           17512000
         MVC   PRTIMG+D1(L'PRTIMG-D1),PRTIMG  BLANK OUT BUFFER          17513000
         BR    RTN                      RETURN TO CALLER                17514000
EODRTN   EQU   *                                                        17515000
         USING PRTBUF,R11               SET UP USING FOR PRINTBUF       17516000
         B     STATRTN                  GO TO STATISTICS ROUTINE        17517000
         EJECT                                                          17518000
ERRORTN  EQU   *                                                        17519000
*              THIS ROUTINE RECEIVES CONTROL FROM THE MAIN LINE ONLY  * 17520000
*              IF THE ERROR FLAG (JERRCHK) IS ON.  IT PERFORMS THE    * 17521000
*              FOLLOWING FUNCTIONS-                                   * 17522000
*                                                                     * 17523000
*                  1.  INCREMENT COUNT OF STATEMENTS FLAGGED.         * 17524000
*                  2.  STORE HIGHEST SEVERITY CODE FROM ERROR RECORDS.* 17525000
*                  3.  SET UP PRINT LINE WITH STATEMENT NUMBER, ERROR * 17526000
*                      CODE AND COMPONENT PREFIX, AND ERROR MESSAGE.  * 17527000
*                  4.  INSERT A COLUMN POINTER OR APPENDED DATA FROM  * 17528000
*                      ERROR RECORD WHERE INDICATED IN MESSAGE.       * 17529000
*                  5.  TRANSFER CONTROL TO THE PRINT ROUTINE.         * 17530000
*                  6.  RETURN TO MAIN LINE.                           * 17531000
*                                                                     * 17532000
*              INPUT-                                                 * 17533000
*                                                                     * 17534000
*                  1.  ERROR RECORD POINTED TO BY INBASE.             * 17535000
*                  2.  OUTPUT BUFFER POINTED TO BY PRTBASE.           * 17536000
*********************************************************************** 17537000
         ST    RTN,SAVERTN1             SAVE RETURN LINKAGE             17538000
         MVC   JFWORD1+D4-L'JESTMTNO(L'JESTMTNO),JESTMTNO  GET          17539000
         L     COUNT,JFWORD1            STATEMENT NUMBER                17540000
         C     COUNT,LSTMTNO            IF SAME STATEMENT NUMBER        17541000
         BE    NOCOUNT                     DON'T COUNT IT AGAIN         17542000
         ST    COUNT,LSTMTNO            ELSE SAVE IT IF DIFFERENT       17543000
         LH    R0,ERRQTY                INCREMENT NUMBER OF STATEMENTS  17544000
         AH    R0,=H'01'                 FLAGGED AND                    17545000
         STH   R0,ERRQTY                   STORE IT BACK                17546000
         SPACE                                                          17547000
NOCOUNT  BAL   RTN,CONVERT              CONVERT IT                      17548000
         MVC   ELSTMTNO(L'CSTMT),CSTMT      MOVE IT TO PRINT LINE       17549000
CONTINUE SR    COUNT,COUNT              CLEAR COUNT REGISTER            17550000
         IC    COUNT,JERCDE             GET ERROR CODE FROM RECORD      17551000
         SET   NOBLK,ON                 TURN OFF LEFT ZERO SUPPRESSION  17552000
         BAL   RTN,CONVERT              CONVERT IT                      17553000
         SET   NOBLK,OFF                TURN ON LEFT ZERO SUPPRESSION   17554000
         MVC   ELERRCDE(L'CERROR),CERROR    MOVE IT TO PRINT LINE       17555000
         MVC   ELERPFIX(L'JPREFIX),JPREFIX  MOVE IN COMPONENT PREFIX    17556000
         SLL   COUNT,D2                 COMPUTE OFFSET IN MSG ADDT TBLE 17557000
         L     MNDX,=A(ERRMSGS)         GET ADDR OF START OF MSGS       17558000
         L     MTABPTR,=A(MTABLE)       BASE FOR MSG ADDR INDEX TABLE   17559000
         USING MTBLE,MTABPTR            USING FOR MSG ADDR INDEX TABLE  17560000
         AH    MNDX,MADDR(COUNT)        ADD OFFSET FOR MESSAGE          17561000
         LH    MSGLN,MLN(COUNT)         GET MESSAGE LENGTH              17562000
         GOIF  (MSGLN),NOTZERO=MOVEIT   TEST FOR UNDEFINED ERROR CODE   17563000
         SR    COUNT,COUNT                  UNDEFINED ERROR- GET LGTH   17564000
         LH    MSGLN,MLN(COUNT)             OF UNDEFINED ERR CDE MSG    17565000
         SET   ERRSW,ON                 TURN ON UNDEFINED ERROR CODE SW 17566000
         CLI   SEVCDE,X'10'             USE SEV OF 16                   17567000
         BNH   MOVEIT                                                   17568000
         MVI   SEVCDE,X'10'             SAVE HIGHEST SEVERITY CODE      17569000
         DROP  MTABPTR                                                  17570000
MOVEIT   EQU   *                                                        17571000
         STH   MSGLN,HWD                SAVE MESSAGE LENGTH             17572000
         EX    MSGLN,MOVEMSG            MOVE MSG TO PRINT LINE          17573000
         LA    R14,ELERMSG              INITIALIZE REG FOR TRT SCAN     17574000
         GOIF  ERRSW,OFF=GOODERCD       CHECK UNDEFINED ERROR CODE SW   17575000
         SET   ERRSW,OFF                TURN IT OFF IF IT IS ON         17576000
         AR    R14,MSGLN                FIND END OF UNDEFINED ERROR     17577000
         MVC   D2(D7,R14),ELERPFIX      MOVE UNDEF ERR CODE TO MESS     17578000
         MVC   ELERRCDE+D1(D3),=F'0'    MESSAGE NUMBER SHOULD BE ZERO   17579000
         LA    MSGLN,D8(MSGLN)          ADD ERROR NUMBER LENGTH         17580000
         STH   MSGLN,HWD                SAVE IT                         17581000
         LH    R14,JERECL               GET RECORD LENGTH               17582000
         B     ENDSCAN                  GO PRINT MESSAGE                17583000
GOODERCD EQU   *                                                        17584000
         GOIF  JESEV,SEVCDE,LE=APPDATA  CHECK SEVERITY CODE             17585000
         MVC   SEVCDE(L'JESEV),JESEV    SAVE HIGHEST SEVERITY CODE      17586000
APPDATA  EQU   *                                                        17587000
         LA    R0,JEDATA                GET INITIAL APPENDED DATA ADDR  17588000
         ST    R0,ERDATADR                  AND SAVE IT                 17589000
SCANMSG  SR    MNDX,MNDX                CLEAR FUNCTION REGISTER         17590000
         EX    MSGLN,SCANTRT            SCAN MSG FOR DATA INSERT FLAGS  17591000
         BZ    ENDSCAN                  SCAN COMPLETED                  17592000
         BAL   RTN,BRTABLE(MNDX)        GO TO BRANCH TABLE              17593000
         LR    COUNT,R1                 CHECK TO DETERMINE IF ALL OF    17594000
         SR    COUNT,R14                    MSG HAS BEEN SCANNED        17595000
         GOIF  (COUNT),(MSGLN),GE=ENDSCAN   IF SO TERMINATE SCAN        17596000
         SR    MSGLN,COUNT              IF NOT COMPUTE REMAINING LENGTH 17597000
         LR    R14,R1                       AND SCAN CONTINUE POINT     17598000
         B     SCANMSG                      AND RESUME SCAN             17599000
MOVEMSG  MVC   ELERMSG(0),0(MNDX)       EXECUTED MOVE FOR ERROR MSG TXT 17600000
SCANTRT  TRT   0(0,R14),TRTABLE         EXECUTED TRT FOR POUND OR DOLLR 17601000
MOVEDATA EQU   *                                                        17602000
         L     MNDX,ERDATADR            GET ADDR OF APPENDED DATA       17603000
         MVC   D0(D8,R1),D0(MNDX)       MOVE APPENDED DATA TO OVLAY FLG 17604000
         LA    MNDX,D8(MNDX)            INCREMENT TO NEXT APPENDED ITEM 17605000
         ST    MNDX,ERDATADR                AND SAVE IT                 17606000
         LA    R1,D8(,R1)               INCREMENT BY 8 FOR '$        '  17607000
         BR    RTN                      RETURN TO CALLER                17608000
MOVECOL  EQU   *                                                        17609000
         ST    RTN,SAVERTN2             SAVE RETURN LINKAGE             17610000
         LNR   COUNT,R1                 COMPUTE REMAINING LENGTH OF     17611000
         AR    COUNT,R14                    MESSAGE NOT YET SCANNED     17612000
         AR    COUNT,MSGLN                  THEN SUBTRACT 1 BECAUSE NOT 17613000
         LR    MNDX,COUNT                   MOVING FLAG ITSELF          17614000
         BCTR  COUNT,R0                 SAVE LENGTH OF REMAINING MSG    17615000
         AR    MNDX,R1                  ADD ADDRESS OF FLAG = MSG END   17616000
         LR    R15,MNDX                 SAVE BEGINING ADDR OF MOVE      17617000
         A     MNDX,=A(L'COLMSG)        ADD COLMSG LGTH TO TARGET ADDR  17618000
SHIFTMSG MVC   D0(D1,MNDX),D0(R15)      SHIFT LAST BYTE OF MSG TO RIGHT 17619000
         BCTR  MNDX,R0                  DECREMENT TO AND FROM ADDRESSES 17620000
         BCTR  R15,R0                       TO GET NEXT BYTE TO LEFT    17621000
         BCT   COUNT,SHIFTMSG           IF ALL OF MSG SHIFTED - STOP    17622000
         MVC   D0(L'COLMSG,R1),COLMSG   MOVE COL MSG TO VACATED AREA    17623000
         LH    COUNT,HWD                GET SAVED MSG LENGTH            17624000
         A     COUNT,=A(L'COLMSG)       MAKE LENGTH INCLUDE COLMSG      17625000
         STH   COUNT,HWD                SAVE NEW LENGTH FOR ENDSCAN     17626000
         SR    COUNT,COUNT              CLEAR COUNT REGISTER            17627000
         IC    COUNT,JECOLPTR           GET COLUMN POINTER              17628000
         BAL   RTN,CONVERT              CONVERT IT                      17629000
         MVC   L'COLMSG(L'CCOLPTR,R1),CCOLPTR  MOVE IT TO PRINT LINE    17630000
         LA    R1,D2(,R1)               INCREMENT BY 2 FOR '# ' IN MSG  17631000
         L     RTN,SAVERTN2             RETURN TO                       17632000
         BR    RTN                          CALLER                      17633000
ENDSCAN  LH    MNDX,HWD                 PICK UP SAVED MESSAGE LENGTH    17634000
         LA    R1,ELERMSG               GET ADDRESS OF MESSAGE IN TWO   17635000
         LR    R3,R1                     REGISTERS                      17636000
         AR    MNDX,R1                  COMPUTE END OF MESSAGE          17637000
ENDSCANA CLI   D0(R3),X'2F'             IS CHAR A BLANK                 17638000
         BNE   ENDSCANB                 NO - GO MOVE CHAR               17639000
         CLI   D1(R3),X'2F'             IS THERE A SECOND BLANK         17640000
         BNE   ENDSCANB                 NO - GO MOVE CHAR               17641000
         LA    R3,D1(R3)                UPDATE SCAN INDEX               17642000
         CR    R3,MNDX                  END OF MESSAGE REACHED          17643000
         BNH   ENDSCANA                 NO                              17644000
         B     ENDSCANC                 YES                             17645000
ENDSCANB MVC   D0(D1,R1),D0(R3)         MOVE ONE CHAR                   17646000
         LA    R1,D1(R1)                UPDATE INSERT INDEX             17647000
         LA    R3,D1(R3)                UPDATE SCAN INDEX               17648000
         CR    R3,MNDX                  END OF MESSAGE ?                17649000
         BNH   ENDSCANA                 NO - GO SCAN NEXT CHAR          17650000
ENDSCANC MVI   D0(R1),X'2F'             YES - FILL WITH BLANKS          17651000
         LA    R1,D1(R1)                UPDATE INSERT INDEX             17652000
         CR    R1,MNDX                  END OF MESSAGE REACHED          17653000
         BNH   ENDSCANC                 NO                              17654000
ENDSCAN2 BAL   RTN,TERMERR              GO PRINT ON SYSTERM IF SO       17655000
         BAL   RTN,PRINT                GO PRINT LINE                   17656000
         L     RTN,SAVERTN1             RETURN TO                       17657000
         BR    RTN                          CALLER                      17658000
         EJECT                                                          17659000
*    PRINT ERROR MESSAGE ON SYSTERM DATA SET                            17660000
*    TAKE MESSAGE FROM SYSPRINT BUFFER AND                              17661000
*    REMOVE UNNESSASARYBLANKS                                           17662000
         USING TERMBUF,R11              ESTABLISH BASE FOR TERM BUFFER  17663000
TERMERR  GOIF  JTERM,OFF=(RTN)          RETURN IF NOTERMINAL USED       17664000
         LR    R4,R11                   SAVE SYSPRINT BUFFER POINTER    17665000
         LR    R3,RTN                   SAVE RETURN REGISTER            17666000
         LA    R11,BUFTERM              GET TERM BUFFER ADDR            17667000
         MVC   ERCDE,D8(R4)             MOVE MESSAGE NUMBER             17668000
         MVC   ERMSG,D20(R4)            MOVE MESSAGE TEXT               17669000
         JTPRINT                        PRINT BUFFER                    17670000
         BAL   RTN,BUFINIT              INITIALIZE BUFFER               17671000
         LR    RTN,R3                   RESTORE RETURN REGISTER         17672000
         LR    R11,R4                   RESTORE BUFFER POINTER          17673000
         BR    RTN                      RETURN TO CALLER                17674000
         SPACE 3                                                        17675000
*  PRINT STATISTICS LINES ON SYSTERM IF TERM OPTION USED                17676000
TERMSTAT GOIF  JTERM,OFF=(RTN)          RETURN IF NOTERMINAL USED       17677000
         LR    R4,R11                   SAVE SYSPRINT BUFFER POINTER    17678000
         ST    R3,JFWORD2               SAVE  THIS REGISTER IF SYSPARM  17679000
         LR    R3,RTN                   SAVE RETURN REGISTER            17680000
         LA    R11,BUFTERM              GET TERM BUFFER ADDR            17681000
         MVC   PRTIMG(L'PRTLINE),D1(R4)  MOVE LINE TO SYSTERM BUF       17682000
         JTPRINT                        PRINT IT                        17683000
         BAL   RTN,BUFINIT              INITIALIZE BUFFER               17684000
         LR    RTN,R3                   RESTORE RETURN REG              17685000
         LR    R11,R4                   RESTORE BUFFER POINTER          17686000
         L     R3,JFWORD2               RESTORE REG AGAIN               17687000
         BR    RTN                      RETURN TO CALLER                17688000
          EJECT                                                         17689000
         USING PRTBUF,R11               ESTABLISH BASE                  17690000
PRINT    EQU   *                                                        17691000
*********************************************************************** 17692000
*              THE PRINT ROUTINE CONTROLS PAGE SKIPPING AND PAGE      * 17693000
*              HEADING.                                               * 17694000
*********************************************************************** 17695000
         GOIF  JLIST,OFF=(RTN)          RETURN IF LIST IS OFF           17696000
         ST    RTN,SAVERTN2             SAVE RETURN LINKAGE             17697000
         LH    COUNT,PGLINES            CHECK FOR END OF PAGE.  IF NOT  17698000
         BCT   COUNT,WRITEMSG             END OF PAGE GO WRITE MSG.     17699000
*                                         ELSE SET UP AND PRINT NEW     17700000
*                                         PAGE HEADING ON NEW PAGE.     17701000
         LH    COUNT,JPAGENO            GET PAGE NUMBER                 17702000
         AH    COUNT,=H'01'             INCREMENT PAGE NUMBER           17703000
         STH   COUNT,JPAGENO            PUT BACK NEW PAGE NUMBER        17704000
         MVC   PRTLNSAV(L'PRTLINE),PRTLINE  SAVE PRINT LINE IN BUFFER   17705000
         MVI   PRTLINE,JBLANK           BLANK PRINT BUFFER              17706000
         MVC   PRTLINE+D1(L'PRTLINE-D1),PRTLINE                         17707000
         MVI   CNTRL,EJCT               INSERT EJECT CONTROL CHARACTER  17708000
         MVC   HLTITLE(L'JDECKID),JDECKID TITLE PART OF FIRST HDNG LINE 17709000
         MVC   HLDIAG(L'HDNG1),HDNG1    MOVE IN HDNG PART OF FIRST LINE 17710000
         MVC   HLPAGE(L'PAGE),PAGE      MOVE IN 'PAGE'                  17711000
         BAL   RTN,CONVERT              CONVERT PAGE NUMBER             17712000
         MVC   HLPGENO(L'CPAGE),CPAGE   MOVE IN PAGE NUMBER             17713000
         JPRINT                                                         17714000
         GOIF  STATSW,ON=STATONLY       CHECK STATSW BEFORE NEXT INSTR  17715000
         MVC   HLDIAG2(L'HDNG2),HDNG2   STMT-ERROR-CODE-MESSAGE HEADING 17716000
STATONLY MVI   CNTRL,SPACE3             TRIPLE SPACE                    17717000
         MVC   HLDATE(L'JLVTMDT),JLVTMDT  COMP-LEVEL-TIME-DATE          17718000
         JPRINT                                                         17719000
         MVI   CNTRL,SPACE2             INSERT DOUBLE SPACE CHAR        17720000
         MVC   PRTLINE(L'PRTLNSAV),PRTLNSAV  RESTORE ORIG PRINT LINE    17721000
         LH    COUNT,JLNCT              RESET LINE COUNT PER PAGE       17722000
WRITEMSG EQU   *                                                        17723000
         JPRINT                                                         17724000
         STH   COUNT,PGLINES            SAVE LINE COUNT PER PAGE        17725000
         L     RTN,SAVERTN2             RESTORE LINKAGE TO CALLER       17726000
         BR    RTN                      RETURN TO CALLER                17727000
         EJECT                                                          17728000
CONVERT  EQU   *                                                        17729000
*********************************************************************** 17730000
*              THE CONVERT ROUTINE RECIEVES A BINARY NUMBER IN COUNT  * 17731000
*              (REGISTER 4) AND CONVERTS IT TO INTERNAL FORMAT IN     * 17732000
*              DBLWD2.  IT ALSO SUPPRESSES LEADING ZEROS BASED UPON   * 17733000
*              THE SETTING OF THE FLAG NOBLK.                         * 17734000
*********************************************************************** 17735000
         CVD   COUNT,DBLWD1             CONVERT BINARY NO. TO DECIMAL   17736000
         UNPK  DBLWD2,DBLWD1            UNPACK IT                       17737000
         NC    DBLWD2,=X'0F0F0F0F0F0F0F0F'  STRIP ZONES FOR INTL FORMAT 17738000
         GOIF  NOBLK,ON=GOBACK          IF LEFT ZERO SUPP OFF EXIT      17739000
         LA    R15,DBLWD2               ADDRESS OF NUMBER               17740000
         LA    R14,L'DBLWD2-1           LENGTH OF NUMBER                17741000
SZEROS   CLI   D0(R15),J0               SCAN FOR LEADING ZERO           17742000
         BNE   GOBACK                   IF NOT ZERO EXIT                17743000
         MVI   D0(R15),JBLANK           IF ZERO - BLANK IT              17744000
         LA    R15,D1(R15)              INDEX TO NEXT CHARACTER         17745000
         BCT   R14,SZEROS               GO BACK AND SCAN IT             17746000
GOBACK   BR    RTN                      RETURN TO CALLER                17747000
*  SUPPRESS LEADING BLANKS IN THE FLAG AND LINECOUNT OPTION VALUES      17748000
*  IN THE OPTIONS PRINT BUFFER AND RETURNS WITH R1 POINTING TO THE      17749000
*  LAST CHARACTER IN THE VALUE                                          17750000
BLNKSUP  EQU   *                                                        17751000
         LA    COUNT,L'CPAGE-1          GET MOVE LENGTH OF FIELD        17752000
SBLANKS  GOIF  D0(R1),JBLANK,NE=BACK    RETURN ON FIRST NONBLANK        17753000
         EX    COUNT,MVFIELD            DELETE ONE BLANK CHAR           17754000
         BCT   COUNT,SBLANKS            DECREMENT MOVE LENGTH           17755000
BACK     AR    R1,COUNT                 POINT TO LAST CHAR IN VALUE     17756000
         LA    R1,D1(R1)                                                17757000
         BR    RTN                      RETURN TO CALLER                17758000
MVFIELD  MVC   D0(COUNT,R1),D1(R1)      MOVE ONE CHAR TO THE LEFT       17759000
         EJECT                                                          17760000
NOERR    EQU   *                                                        17761000
         USING PRTBUF,R11               SET UP USING FOR PRINTBUF       17762000
STATRTN  EQU   *                                                        17763000
         SET   STATSW,ON                TURN ON STATISTICS SWITCH       17764000
         LH    R0,PGLINES               CHECK NUMBER OF LINES LEFT ON   17765000
         CH    R0,=H'15'                   PAGE. IF GT/EQ TO THE REQ'D  17766000
         BNL   DSKIP                       NUMBER DONT EJECT PAGE.      17767000
         LA    COUNT,D1(R0)             FORCE SKIP TO                   17768000
         STH   COUNT,PGLINES                NEW PAGE                    17769000
DSKIP    MVI   CNTRL,SPACE2             SET UP DOUBLE SPACE             17770000
         LH    COUNT,ERRQTY             GET TOTAL COUNT OF ERRORS       17771000
         GOIF  (COUNT),ZERO=NOERRS      ANY ERRORS.  BRANCH IF NONE     17772000
         MVC   PRTLINE(L'ERCTMSG),ERCTMSG  SET UP NR OF ERRS MSG        17773000
         BAL   RTN,CONVERT              CONVERT NUMBER OF ERRORS        17774000
         MVC   PRTLINE+L'ERCTMSG(L'CSTMT),CSTMT  MOVE IT TO PRINT LINE  17775000
         B     NOEPRINT                 BRANCH TO PRINT IT              17776000
NOERRS   MVC   PRTLINE(L'NOERMSG),NOERMSG  NO ERROR MSG                 17777000
NOEPRINT BAL   RTN,TERMSTAT             PRINT ON SYSTERM TOO            17778000
         BAL   RTN,PRINT                GO PRINT MESSAGE                17779000
         MVC   PRTLINE(L'SEVMSG),SEVMSG  SET UP SEVERITY CODE MESSAGE   17780000
         SR    COUNT,COUNT              CLEAR COUNT REGISTER            17781000
         IC    COUNT,SEVCDE             GET HIGHEST SEVERITY CODE       17782000
         BAL   RTN,CONVERT              AND CONVERT IT                  17783000
         MVC   PRTLINE+L'SEVMSG(L'CPAGE),CPAGE  MOVE IT TO PRINT LINE   17784000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM TOO            17785000
         BAL   RTN,PRINT                GO PRINT IT                     17786000
         MVC   PRTLINE(L'OPTM1),OPTM1   MOVE IN ASM OPTNS MESSAGE       17787000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM TOO            17788000
         BAL   RTN,PRINT                PRINT IT                        17789000
         LA    COUNT,PRTLINE+D2(R0)     START OF MESSAGE                17790000
         BLDPRM JALGN,ALGN                                              17791000
         BLDPRM JALOGIC,ALOGIC                                          17792000
         LA    R2,PBUF                  GET ADDRESSS AND LENGTH OF PARM 17793000
         LA    R1,L'PBUF-D1(R0)                                         17794000
         EX    R1,MVPARM                MOVE IN PARM                    17795000
         AR    COUNT,R1                 BUMP PRINT LINE INDEX           17796000
         TM    JPARM3,JMINBUF           MINIMUM BUFFER SIZE             17797000
         BO    MVMIN                    YES                             17798000
         TM    JPARM4,JMBUF             BR IF MULTIPEL-        @AZ13738 17799000
         BO    MVMAX                    BUFFERS USED.          @AZ13738 17800000
         MVC   D0(L'STD,COUNT),STD      STANDARD BUFFER SIZE USED       17801000
         LA    COUNT,L'STD(COUNT)       BUMP PRINT LINE INDEX           17802000
         B     MVBUF                    TAKE NEXT OPTION                17803000
MVMAX    MVC   D0(L'MAX,COUNT),MAX      MBUF USED              @AZ13738 17804000
         LA    COUNT,L'MAX(COUNT)       BUMP PRINT LINE INDEX  @AZ13738 17805000
         B     MVBUF                    TAKE NEXT OPTION       @AZ13738 17806000
MVMIN    MVC   D0(L'MIN,COUNT),MIN      MINIMUM BUFFER SIZE USED        17807000
         LA    COUNT,L'MIN(COUNT)       BUMP PRINT LINE INDEX           17808000
MVBUF    LA    COUNT,D1(COUNT)          ADD 1 TO PRINT LINE INDEX       17809000
         BLDPRM JDECK,DECK                                              17810000
         BLDPRM JESD,ESD                                                17811000
         LR    R1,COUNT                 TRANSFER POSITION PTR TO R1     17812000
         MVC   D0(L'PFLAG,R1),PFLAG      MOVE IN FLAG(                  17813000
         LA    R1,L'PFLAG(R1)           BUMP PRINT LINE INDEX           17814000
         SR    COUNT,COUNT              CLEAR COUNT REGISTER            17815000
         IC    COUNT,JMSGL              GET MESSAGE LEVEL               17816000
         BAL   RTN,CONVERT                AND CONVERT IT                17817000
         MVC   D0(L'CPAGE,R1),CPAGE     MOVE IN CONVERTED MSGLEVEL      17818000
         BAL   RTN,BLNKSUP              SUPRESS LEADING BLANKS          17819000
         MVI   D0(R1),JRPARN            SUPPLY RIGTH PAREN              17820000
         LA    R1,D1(R1)                ADD 1 TO PRINT LINE INDEX       17821000
         MVC   D0(L'PLC,R1),PLC         MOVE IN ', LINECOUNT('          17822000
         LA    R1,L'PLC(R1)             BUMP PRINT LINE INDEX           17823000
         LH    COUNT,JLNCT              GET LINE COUNT                  17824000
         BAL   RTN,CONVERT                AND CONVERT IT                17825000
         MVC   D0(L'CPAGE,R1),CPAGE     MOVE IN CONVERTED LINE COUNT    17826000
         BAL   RTN,BLNKSUP              SUPRESS LEADING BLANKS          17827000
         MVI   D0(R1),JRPARN            SUPPLY RIGTH PAREN              17828000
         MVI   D1(R1),JCOMMA                 AND COMMA                  17829000
         MVI   D2(R1),JBLANK               AND A BLANK                  17830000
         LA    R1,D3(R1)                ADD 1 TO PRINT INE INDEX        17831000
         LR    COUNT,R1                 RESTORE PRINT LINE INDEX        17832000
         BLDPRM JLIST,LIST                                              17833000
         BLDPRM JCALLS,CALLS                                            17834000
         BLDPRM JYFLAG,YFLAG                                   @OX09734 17835000
         LR    R1,COUNT                 TRASF.PRT LINE INDX    @AZ13738 17836000
         MVC   D0(L'PSIZE,R1),PSIZE     MOVE IN 'WORKSIZE('    @AZ13738 17837000
         LA    R1,L'PSIZE(R1)           BUMP PRINT LINE INDEX  @AZ13738 17838000
         L     COUNT,CORESIZE           GET REQUESTED CORE     @AZ13738 17839000
         BAL   RTN,CONVERT              CONVERT VALUE          @AZ13738 17840000
         MVC   D0(L'DBLWD2,R1),DBLWD2   MOVE VALUE TO PRINT LN @AZ13738 17841000
         LA    COUNT,L'DBLWD2-1         GET MOVE LENGH         @AZ13738 17842000
         BAL   RTN,SBLANKS              SUPPR LEADING BLANKS   @AZ13738 17843000
         MVI   D0(R1),JRPARN            SUPPLY RIGHT PAREN     @AZ13738 17844000
         LA    R1,D1(,R1)               ADD 1 TO PRINT INDEX   @AZ13738 17845000
         LR    COUNT,R1                 RESTORE PRINT LINE NDX @AZ13738 17846000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM                17847000
         BAL   RTN,PRINT                PRINT THIS OPTION LINE          17848000
         LA    COUNT,PRTLINE+D2         START OF MESSAGE LINE           17849000
         BLDPRM JMLOGIC,MLOGIC                                          17850000
         BLDPRM JNUM,NUM                                                17851000
         BLDPRM  JLINK,LOAD                                             17852000
         BLDPRM JRENT,RENT                                              17853000
         BLDPRM JRLD,RLD                                                17854000
         BLDPRM JSTMT,STMT                                              17855000
         BLDPRM  JSYSMAC,SYSMAC                                         17856000
         BLDPRM JTERM,TERM                                              17857000
         BLDPRM JTEST,TEST                                              17858000
         BLDPRM JXREF,XREF                                              17859000
         GOIF  JMINXREF,OFF=XRFPRT      SHORT XREF                      17860000
         BCTR  COUNT,R0                 DECR COUNT TO GET NO BLANK      17861000
         MVC   D0(L'SHORT,COUNT),SHORT  YES TELL IT                     17862000
         LA    COUNT,L'SHORT+D1(COUNT)  UPDATE POINTER                  17863000
XRFPRT   BAL   RTN,TERMSTAT             PRINT ON SYSTERM                17864000
         BAL   RTN,PRINT                GO PRINT IND LINE OF ASM OPTNS  17865000
         LA    R1,PRTLINE+D2            START OF MESSAGE LINE           17866000
         MVC   D0(L'PSYSPARM,R1),PSYSPARM  MOVE IN 'SYSPARM = '         17867000
         LA    R1,L'PSYSPARM(R1)        BUMP PRINT LINE INDEX           17868000
         L     R2,JSYSPARM              GET ADDRESS OF SYSPARM          17869000
         GOIF  (R2),ZERO=PRTSTAT        IF NO SYSPARM SKIP CODE TO MOVE-17870000
                                            IT TO PRINT LINE.           17871000
         SR COUNT,COUNT                 CLEAR COUNT REGISTER            17872000
         IC    COUNT,D0(R2)             GET LENGTH OF SYSPARM           17873000
         SH    COUNT,=H'01'             COMPUTE MV LGTH OF SYSPARM      17874000
         LA    R3,L'PRTLINE-L'PSYSPARM-D2(R0)  COMPUTE LGTH OF PRT LINE-17875000
                                            AVAILABLE FOR SYSPARM MSG   17876000
         SR    COUNT,R3                 DETERMINE NO OF LINES NEEDED    17877000
         BNM   LINE2                    BRANCH IF 2 OR 3                17878000
         AR    COUNT,R3                 MAKE COUNT EQUAL TO MOVE LENGTH 17879000
         B     LPRT                     PRIMT                           17880000
LINE2    EX    R3,MSYSPARM              MOVE LINE 1 TO BUFFER           17881000
         STH   COUNT,HWD                SAVE LENGTH OF REMAINDER        17882000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM                17883000
         BAL   RTN,PRINT                PRINT                           17884000
         AR    R2,R3                    UPDATE SYSPARM MESSAGE INDEX    17885000
         LA    R1,PRTLINE+D2            MAKE 2 BLANKS FIRST IN LINE     17886000
         LA    R3,L'PRTLINE-D2(R0)      COMPUTE  LENGTH OF FULL LINE    17887000
         LH    COUNT,HWD                RESTORE LENGTH OF REMAINDER     17888000
         SR    COUNT,R3                 IS 3 LINES NEEDED               17889000
         BNM   LINE3                    BRANCH IF YES                   17890000
         AR    COUNT,R3                 MAKE COUNT MOVE LENGTH OF REM   17891000
         B     LPRT                     PRIMT                           17892000
LINE3    EX    R3,MSYSPARM              MOVE 2ND LINE OF 3              17893000
         STH   COUNT,HWD                SAVE LENGTH OF REMAINDER        17894000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM                17895000
         BAL   RTN,PRINT                PRINT                           17896000
         AR    R2,R3                    UPDATE SYSPARM MESSAGE INDEX    17897000
         LA    R1,PRTLINE+D2            POINT TO BUFFER +2              17898000
         LH    COUNT,HWD                RESTORE LENGTH OF REMAINDER     17899000
LPRT     EX    COUNT,MSYSPARM           MOVE REMAINING CHARATERS        17900000
         AR    R1,COUNT                 BUMP PRINT LINE INDEX           17901000
         LA    R1,D1(R1)                BUMP PRINT LINE INDEX           17902000
PRTSTAT  MVI   D0(R1),JRPARN            SUPPLY RIGTH PAREN              17903000
         BAL   RTN,TERMSTAT             PRINT ON SYSTERM                17904000
         BAL   RTN,PRINT                GO PRINT SYSPARM                17905000
         LA    R1,PRTLINE               GET BUFFER ADDRESS              17906000
         MVC   D0(L'PBUFSIZE,R1),PBUFSIZE MOVE BUFSIZE MSG              17907000
         LA    R1,L'PBUFSIZE(R1)        BUMP PRINT LINE INDEX           17908000
         LH    COUNT,JMAXRL             GET BUGFER SIZE                 17909000
         BAL   RTN,CONVERT              CONVERT IT                      17910000
         MVC   D0(L'CSTMT,R1),CSTMT     MOVE NUMBER INTO PRINT LINE     17911000
         LA    R1,L'CSTMT(R1)           BUMP PRINT LINE INDEX  @AZ13738 17912000
         MVI   D0(R1),JSLASH            MOVE SLASH TO PRINT    @AZ13738 17913000
         LA    R1,D1(R1)                BUMP PRINT LINE INDEX  @AZ13738 17914000
         LH    COUNT,NRMBUF             GET NR OF MBUF         @AZ13738 17915000
         BAL   RTN,CONVERT              CONVERT IT             @AZ13738 17916000
         MVC   D0(D2,R1),CSTMT+D3       MOVE OUT NUMBER        @AZ13738 17917000
         BAL   RTN,PRINT                PRINT WORKFILE BUFFER SIZE      17918000
         MVC   PRTLINE(L'TSYSIN),TSYSIN  TOTAL RCDS FROM SYSTEM INPUT   17919000
         L     COUNT,JRECIN             GET NUMBER OF RECORDS READ FROM 17920000
         BAL   RTN,CONVERT                  SYSTEM INPUT AND CONVERT IT 17921000
         MVC   PRTLINE+L'TSYSIN(L'DBLWD2),DBLWD2  MOVE IT TO PRINT LINE 17922000
         BAL   RTN,PRINT                GO PRINT IT                     17923000
         MVC   PRTLINE(L'TSYSLIB),TSYSLIB  TOTAL RCDS FROM SYSTEM LIB   17924000
         L     COUNT,JRECLIB            GET NUMBER OF RECORDS READ FROM 17925000
         BAL   RTN,CONVERT                  SYSTEM LIBRARY & CONVERT IT 17926000
         MVC   PRTLINE+L'TSYSLIB(L'DBLWD2),DBLWD2  MOVE IT TO PRT LINE  17927000
         BAL   RTN,PRINT                GO PRINT IT                     17928000
         MVC   PRTLINE(L'TSYSPCH),TSYSPCH   TOTAL RECORDS PUNCHED       17929000
         L     COUNT,JRECPCH            GET NUMBER OF RECORDS PUNCHED   17930000
         BAL   RTN,CONVERT                  AND CONVERT IT              17931000
         MVC   PRTLINE+L'TSYSPCH(L'DBLWD2),DBLWD2  MOVE IT TO PRINT LN  17932000
         BAL   RTN,PRINT                GO PRINT IT                     17933000
         MVC   PRTLINE(L'TSYSPRT),TSYSPRT  TOTAL LINES PRINTED          17934000
         L     COUNT,JRECPRT            GET NUMBER OF LINES PRINTED AND 17935000
         LA    COUNT,D1(COUNT)          ADD 1 FOR LINE TO BE PRINTED    17936000
         BAL   RTN,CONVERT              AND CONVERT IT                  17937000
         MVC   PRTLINE+L'TSYSPRT(L'DBLWD2),DBLWD2  MOVE IT TO PRINT LIN 17938000
RETURN   EQU   *                                                        17939000
         SR    COUNT,COUNT              CLEAR COUNT REGISTER            17940000
         IC    COUNT,SEVCDE             GET HIGHEST SEVERITY CODE       17941000
         JFRECORE  ADDR=(R7)            FREE X6BCOM COMMON AREA         17942000
         LR    R10,COUNT                RETURN HIGHEST SEVERITY CODE    17943000
RTRN     JRETURN                        RETURN TO CALLER                17944000
         EJECT                                                          17945000
MVNO     MVC   D0(L'NO,COUNT),NO        EXECUTED MOVE FOR 'NO'          17946000
MVPARM   MVC   D0(R1,COUNT),D0(R2)      EXECUTED MOVE FOR ASM OPTIONS   17947000
MSYSPARM MVC   D0(R0,R1),D1(R2)         EXECUTED MOVE FOR SYSPARM MSG   17948000
PUNCHEC  EQU   *                                                        17949000
*********************************************************************** 17950000
*              THE PUNCH ROUTINE RECEIVES CONTROL FROM THE MAIN LINE  * 17951000
*              ONLY IF THE DECK OR LINK OPTION FLAGS ARE ON.  IT SETS * 17952000
*              UP THE 'END' CARD FOR PUNCHING AND RETURNS TO THE MAIN * 17953000
*              LINE.                                                  * 17954000
*********************************************************************** 17955000
         ST    PRTBASE,SVPRTBAS         SAVE PRINT BUFFER BASE REGISTER 17956000
         JPUNCH                                                         17957000
         USING PCHBUF,R11               USING FOR PUNCH BUFFER          17958000
         MVI   PCNTRL,X'02'             12-2-9 PUNCH                    17959000
         MVC   PCEND(L'END),END         MOVE IN END                     17960000
         MVC   PCCOMP(L'JIDR),JIDR     IDR                              17961000
         TR    PCLINE(L'PCLINE),JTRTABLE  TRANSLATE TO EXTERNAL FORMAT  17962000
         GOIF  JESDCHK,OFF=NOESD        IF ESD SWITCH OFF DONT MOVE ESD 17963000
         MVC   PCENTAD(L'JENTRYPT-D1),JENTRYPT+D1  MOVE IN ENTRY PT ADR 17964000
         MVC   PCESDID(L'JESDID),JESDID  MOVE IN ESDID                  17965000
NOESD    L     PRTBASE,SVPRTBAS         RESTORE PRINT BUFFER BASE       17966000
         BR    RTN                      RETURN TO CALLER                17967000
         EJECT                                                          17968000
*                                                                       17969000
********************************  CONSTANTS AND DATA  ***************** 17970000
*                                                                       17971000
BRTABLE  DS    F                        DATA INSERTION BRANCH TABLE     17972000
         B     MOVEDATA                 GO TO DATA INSERT ROUTINE       17973000
         B     MOVECOL                  GO TO COL POINTER INSERT RTN    17974000
TRTABLE  DC    XL51'00'                 TRANSLATE TABLE TO SCAN MSGS    17975000
         ORG   TRTABLE+JPOUND               FOR COL PTR INSERT          17976000
         DC    X'08'                        OR                          17977000
         ORG   TRTABLE+JDOLLAR              FOR APPENDED DATA INSERT    17978000
         DC    X'04'                        CHARATERS                   17979000
         ORG   ,                        TO RESUME LOC CTR               17980000
ZMASK    DC    X'0F0F0F0F0F0F0F0F0F0F0F0F0F0F0F0F'                      17981000
BLANKS   JGENIN '  '                                                    17982000
HDNG1    JGENIN 'ASSEMBLER DIAGNOSTICS AND STATISTICS'                  17983000
HDNG2    JGENIN 'STMT  ERROR CODE   MESSAGE'                            17984000
PAGE     JGENIN 'PAGE'                                                  17985000
NOERMSG  JGENIN 'NO STATEMENTS FLAGGED IN THIS ASSEMBLY'                17986000
ASMXF    JGENIN 'ASSEMBLER (XF) DONE'                          @OX12916 17987000
ERCTMSG  JGENIN  'NUMBER OF STATEMENTS FLAGGED IN THIS ASSEMBLY = '     17988000
OPTM1    JGENIN 'OPTIONS FOR THIS ASSEMBLY'                             17989000
NO       JGENIN 'NO'                                                    17990000
MIN      JGENIN '(MIN),'                                                17991000
STD      JGENIN '(STD),'                                                17992000
MAX      JGENIN '(MAX),'                                       @AZ13738 17993000
SHORT    JGENIN '(SHORT)'                                               17994000
PALGN    JGENIN 'ALIGN, '                                               17995000
PALOGIC  JGENIN 'ALOGIC, '                                              17996000
PCALLS   JGENIN 'MCALL, '                                      @OX09734 17997000
PDECK    JGENIN 'DECK, '                                                17998000
PESD     JGENIN 'ESD, '                                                 17999000
PLOAD    JGENIN 'OBJECT, '                                              18000000
PLIST    JGENIN 'LIST, '                                                18001000
PMLOGIC  JGENIN 'MLOGIC, '                                              18002000
PRENT    JGENIN 'RENT, '                                                18003000
PRLD     JGENIN 'RLD, '                                                 18004000
PSYSMAC  JGENIN 'LIBMAC, '                                              18005000
PTEST    JGENIN 'TEST, '                                                18006000
PXREF    JGENIN 'XREF '                                                 18007000
PBUF     JGENIN 'BUFSIZE '                                              18008000
PTERM    JGENIN 'TERMINAL, '                                            18009000
PNUM     JGENIN 'NUMBER, '                                              18010000
PSTMT    JGENIN 'STMT, '                                                18011000
PYFLAG   JGENIN 'YFLAG, '                                      @AZ13738 18012000
PFLAG    JGENIN 'FLAG('                                                 18013000
PLC      JGENIN ', LINECOUNT('                                          18014000
PSIZE    JGENIN 'WORKSIZE('                                    @AZ13738 18015000
PBUFSIZE JGENIN 'WORK FILE BUFFER SIZE/NUMBER ='               @AZ13738 18016000
PSYSPARM JGENIN 'SYSPARM('                                              18017000
TSYSIN   JGENIN 'TOTAL RECORDS READ FROM SYSTEM INPUT   '               18018000
TSYSLIB  JGENIN 'TOTAL RECORDS READ FROM SYSTEM LIBRARY '               18019000
TSYSPRT  JGENIN 'TOTAL RECORDS PRINTED                  '               18020000
TSYSPCH  JGENIN 'TOTAL RECORDS PUNCHED                  '               18021000
COLMSG   JGENIN 'NEAR OPERAND COLUMN '                                  18022000
SEVMSG   JGENIN 'HIGHEST SEVERITY WAS '                                 18023000
S259     JGENIN 'RELOCATABLE Y-TYPE ADDRESS CONSTANT IN THIS ASSEMBLY'  18024000
S256     JGENIN 'SYSGO DD CARD MISSING - NOOBJECT OPTION USED'          18025000
S257     JGENIN 'SYSPUNCH DD CARD MISSING - NODECK OPTION USED'         18026000
S258     JGENIN 'INVALID ASSEMBLER OPTION ON EXEC CARD -- OPTION IGNOREX18027000
               D'                                                       18028000
S264     JGENIN 'MAXIMUM OF 512 ESD ENTRIES EXCEEDED'          FX0000   18029000
S265     JGENIN 'SYMBOL RESOLUTION DATA AREA HAS BEEN EXHAUSTED'        18030000
S267     JGENIN 'SYSPRINT DD CARD MISSING - NOLIST OPTION USED'         18031000
S268     JGENIN 'SYSTERM DD CARD MISSING - NOTERMINAL OPTION USED'      18032000
S269     JGENIN 'SYSLIB DD CARD MISSING'                                18033000
END      JGENIN  'END'                                                  18034000
         JPATCH X6B00,FA7               5% PATCH AREA          FX0000   18035000
         JEXTRN (X6C01=ERRMSGS)         ADDR OF BEGINNING OF ERR MSGS   18036000
         JEXTRN (X6C02=MTABLE)          ADDR OF ERR MSG INDEX TABLE     18037000
         EJECT                                                          18038000
         JCSECT (X6B20)                 DEFINE CSECT                    18039000
PRINTEXT JSAVE BASE=YES                 SAVE REGISTER                   18040000
         JENTRY (X6B21=PRINTEXT)        DEFINE ENTRY POINT              18041000
*LISTSOURCE                                                             18042000
*  THIS ROUTINE RECONSTRUCT THE SOURCE RECORDS IN THE PRINT AREA AND    18043000
*  DETERMINE WHETHER SEQUENCE NUMBER NEEDS TO BE ATTACHED OR NOT        18044000
*                                                                       18045000
*                                                                       18046000
         USING JTEXT,R5                 SET USING FOR TEXT              18047000
         USING JTEXTA,R4                SET UP USING FOR JTEXTA         18048000
         USING TERMBUF,R11              USING FOR TERMINAL BUFFER       18049000
         LR    R5,INBASE                SET R5 FOR TEXT PTR             18050000
         BAL   R6,INITBUF               GO TO INITIALIZE BUFFER         18051000
         GOIF  JSTMT,OFF=LST100         DO WE PRINT STMT NUM?           18052000
         TM    D16(R5),BIT2             TEST SAVED FLAGB FOR JNOCNT     18053000
         BO    LST100                   IF SO DO NOT ASSIGN STMTNR      18054000
         LH    R1,JTFLGA                GET STMT NUMBER                 18055000
         BAL   R6,PRN800                CONVERT TO DECIMAL              18056000
         MVC   STMTNO,DWORD2            MOVE TO PRINT LINE              18057000
LST100   EQU   *                        BRANCH LABEL                    18058000
         CLI   D5(R5),JM                IS THIS AN MNOTE MESSAGE        18059000
         BE    LSTMNOTE                 THAN HANDLE IT SEPARATELY       18060000
         SET   COLOVLP,OFF              TURN OVERLAP CHECK BIT OFF      18061000
         XC    COLSAV,COLSAV            CLEAR SAVEAREA                  18062000
*  MOVE NAME FIELD                                                      18063000
         LH    R4,JTNMP                 GET NAME POINTER                18064000
         BAL   R6,FLDMOVE               GO MOVE NAME FIELD              18065000
*  MOVE OPCODE FIELD                                                    18066000
         LH    R4,JTOCP                 GET OPCODE POINTER              18067000
         BAL   R6,FLDMOVE               MOVE OPCODE                     18068000
*  MOVE OPERAND FIELD                                                   18069000
         LH    R4,JTOPP                 GET OPERAND POINTER             18070000
         BAL   R6,FLDMOVE               MOVE OPERAND                    18071000
*  MOVE COMMENT FIELD                                                   18072000
         LH    R4,JTCPR                 GET COMMENT POINTER             18073000
         BAL   R6,FLDMOVE               MOVE COMMENT                    18074000
*  MOVE PRE-BEGIN POST-END FIELDS                                       18075000
LST200   BAL   R6,STRING                INSERT STRING                   18076000
         GOIF  JNUM,OFF=LIST6           DO WE PRINT SEQ NUM?            18077000
         MVC   SEQNO(8),SEQNUM          YES MOVE IN SEQ NUM             18078000
         MVI   SEQNUM,JBLANK            SET BLANK CHARACTER             18079000
         MVC   SEQNUM+1(7),SEQNUM       BLANK OUT SEQNUM                18080000
         BAL   R6,ZEROSUP               SUPRESS LEADING ZEROS           18081000
LIST6    EQU   *                        BRANCH LABEL                    18082000
         JTPRINT                        CALL TERMINAL PRINT             18083000
         BAL   R6,INITBUF               CLEAR BUFFER                    18084000
RTPOINT  JRETURN                        EXIT                            18085000
* LSTMNOTE HANDELS MNOTE PROCESSING FOR CORRECT MNOTES TO SYSTERM       18086000
LSTMNOTE EQU   *                                                        18087000
         LH    R4,JTOPP            GET OPERAND POINTER                  18088000
         AR    R4,R5               MAKE IT AN ADDRESS                   18089000
         LA    R3,SOURCE           GET OUTPUT POINTER                   18090000
         SR    R14,R14             CLEAR REGISTER                       18091000
         IC    R14,LENGTH          GET OPERAND LENGTH                   18092000
         GOIF  (R14),NOTZERO=LSTMN10 SCAN OPERAND                       18093000
         B     LST200              FINISH MNOTE                         18094000
LSTMN10  BCTR  R14,0               MAKE IT MOVE LENGTH                  18095000
         AR    R14,R4              GET END OF OPERAND                   18096000
         L     R1,JCTCHR           GET END COL -1                       18097000
         AR    R1,R3               POINT TO END OF BUFFER               18098000
LSTMN15  CLI   FIELD,JASTER        COMMENT MNOTE                        18099000
         BE    LSTMN20             YES, HANDEL IT                       18100000
         CLI   FIELD,JCOMMA        SEV CODE OMITTED                     18101000
         BE    LSTMN30             YES, HANDEL                          18102000
         CLI   FIELD,JBLANK        BLANK SEV CODE                       18103000
         BNE   LSTMN40             NO, TAKE CARE                        18104000
         LA    R4,D1(R4)           STEP UP INPUT                        18105000
         B     LSTMN15             CONTINUE SCAN FOR SEV CODE           18106000
LSTMN20  MVC   D0(D2,R3),FIELD     MOVE *,                              18107000
         LA    R4,D2(R4)           STEP UP INPUT                        18108000
         LA    R3,D2(R3)           STEP UP OUTPUT                       18109000
         B     LSTMN50             HANDEL MESSAGE                       18110000
LSTMN30  MVC   D5(D1,R3),FIELD     MOVE ,                               18111000
         LA    R3,D6(R3)           STEP UP OUTPUT                       18112000
         LA    R4,D1(R4)           STEP UP INPUT                        18113000
         B     LSTMN50             HANDEL MESSAGE                       18114000
LSTMN40  LR    R6,R4               SAVE INPUT POINTER                   18115000
LSTMN42  LA    R4,D1(R4)           STEP UP ONE CHAR                     18116000
         CLI   FIELD,JCOMMA        COUNT CHAR BEFORE COMMA              18117000
         BNE   LSTMN42             CONT NOT COMMA                       18118000
         SR    R4,R6               NO OF CHAR PAST                      18119000
         LA    R3,D5(R3)           5 MAX NO                             18120000
         SR    R3,R4               MINUS NO OF CHAR =NO BLANKS          18121000
         LR    R4,R6               BACK UP INPUT POINTER                18122000
LSTMN46  MVC   D0(D1,R3),FIELD     MOVE SEV CODE 1 CHAR AT A TIME       18123000
         LA    R4,D1(R4)           STEP UP INPUT                        18124000
         LA    R3,D1(R3)           STEP UP OUTPUT                       18125000
         CLI   FIELD,JCOMMA        NEXT CHAR A COMMA?                   18126000
         BNE   LSTMN46             CONT IF NOT                          18127000
         MVC   D0(D1,R3),FIELD     MOVE THE COMMA                       18128000
         LA    R3,D1(R3)           STEP UP OUTPUT                       18129000
         LA    R4,D1(R4)           STEP PAST COMMA                      18130000
LSTMN50  LA    R4,D1(R4)           STEP PAST FIRST QOUTE                18131000
LSTMN55  CLI   FIELD,JQUOTE        TERMINATING QUOTE?                   18132000
         BE    LSTMN70             ELIMINATE DOUBLE QUOTE               18133000
         CLI   FIELD,JAMPER        ELIMINATE DOUBLE AMPERSANDS          18134000
         BE    LSTMN80             CHECK IF TWO                         18135000
         CR    R4,R14              END OF OPERAND                       18136000
         BNL   LST200              FINISH MNOTE PROC IF YES             18137000
LSTMN60  MVC   D0(D1,R3),FIELD     MOVE CHAR TO OUTPUT                  18138000
         LA    R3,D1(R3)           STEP UP OUTPUT                       18139000
         LA    R4,D1(R4)           STEP UP INPUT                        18140000
         CR    R3,R1               END OF BUFFER                        18141000
         BNL   LSTMN90             YES, HANDEL IT                       18142000
         B     LSTMN55             NO CONT SCAN                         18143000
LSTMN70  CLI   FIELD+D1,JQUOTE     DOUBLE QUOTE                         18144000
         BNE   LST200              NO- TERMINATE STRING                 18145000
LSTMN75  LA    R4,D1(R4)           STEP PAST 1 QUOTE                    18146000
         B     LSTMN60             OUPUT 1 QUOTE                        18147000
LSTMN80  CLI   FIELD+D1,JAMPER     A 2ND AMPERSAND                      18148000
         BNE   LSTMN60             OUTPUT THE SINGLE AMPER              18149000
         B     LSTMN75             STEP BY 1 OF 2                       18150000
LSTMN90  CLI   FIELD,JQUOTE        NEXT CHAR A QUOTE                    18151000
         BE    LSTMN95             YES - END OF STRING?                 18152000
LSTMN92  MVI   D0(R3),JX           INSERT CONT CHAR                     18153000
         BAL   R6,STRING           GET STRINGS                          18154000
         GOIF  JNUM,OFF=LSTMN94    NUM OPTION ON                        18155000
         MVC   SEQNO(D8),SEQNUM    MOVE SEQNO TO PROPER PLACE           18156000
         MVI   SEQNUM,JBLANK       INSERT BLANK                         18157000
         MVC   SEQNUM+D1(D7),SEQNUM BLANK SEQNUM FIELD                  18158000
         BAL   R6,ZEROSUP          SUPRESS LEADING ZEROS                18159000
LSTMN94  JTPRINT                                                        18160000
         BAL   R6,INITBUF          INITIALIZE TERM BUFFER               18161000
         LA    R3,SOURCE           GET OUTPUT POINTER                   18162000
         L     R1,JCTCHR           GET END COL - 1                      18163000
         AR    R1,R3               POINT TO END OF BUFFER               18164000
         B     LSTMN55             CONTINUE SCAN                        18165000
LSTMN95  CLI   FIELD+D1,JQUOTE     A 2ND QUOTE                          18166000
         BNE   LST200              NO STRING TERMINATED                 18167000
         B     LSTMN92             YES  PRINT THE LINE                  18168000
*FLDMOVE   THIS ROUTINE MOVE THE NAME,OPERATION,OPERAND OR COMMENTS TO  18169000
*        THE PRINT LINE.IT TAKES CARE OF PRINTING TO CONTINUATION LINES 18170000
*        THE ROUTINE IS CALLED BY BAL FLDMOVE WITH REG R4 POINTING TO   18171000
*        THE FIELD TO BE MOVED.                                         18172000
*                                                                       18173000
*                                                                       18174000
FLDMOVE  ST    R6,FLDSAVE               SAVE LINK REGISTER              18175000
         AR    R4,R5                    TURN POINTER INTO ADDRESS       18176000
         GOIF  CDPTR,OFF=FLD1           CARD PTR?                       18177000
*   HANDLE CARD POINTER                                                 18178000
         MVC   CARDP,OPTR               SAVE CARD POINTER               18179000
         SET   CDPTR1,OFF               TURN OFF FLAG BIT               18180000
FLD01    SR    R1,R1                    CLEAR REGISTER                  18181000
         IC    R1,CARDP                 GET CARD PTR                    18182000
         SH    R1,CDSTMT                SUBTRACT CURR-CARD-WITHIN STMT  18183000
         BNH   FLD02                    NOT IN NEW CARD                 18184000
         BAL   R6,STRING                GO INSERT STRING                18185000
         GOIF  JNUM,OFF=FLD03           DO WE PRINT SEQ NUMBER?         18186000
         MVC   SEQNO(8),SEQNUM          YES,MOVE SEQNUM TO PROPER PLACE 18187000
         MVI   SEQNUM,JBLANK            SET BLANK CHARACTER             18188000
         MVC   SEQNUM+1(7),SEQNUM       BLANK OUT SEQNUM                18189000
         BAL   R6,ZEROSUP               SUPRESS LEADING ZEROS           18190000
FLD03    EQU   *                        BRANCH LABEL                    18191000
         JTPRINT                        CALL TERMINAL PRINT             18192000
         BAL   R6,INITBUF               INITIALIZE BUFFER               18193000
         XC    COLSAV,COLSAV            CLEAR SAVE AREA FOR COL PTR     18194000
         SET   COLOVLP,OFF              TURN OVERLAP CHECK BIT OFF      18195000
         B     FLD01                    GO TEST NEXT CARD               18196000
FLD02    LA    R4,L'OPTR(,R4)           POINT TO COLUMN POINTER         18197000
FLD1     SR    R3,R3                    CLEAR REGISTER                  18198000
         IC    R3,OCPTR                 GET OUTPUT COL PTR              18199000
         SR    R14,R14                  CLEAR REGISTER                  18200000
         IC    R14,LENGTH               GET FIELD LENGTH                18201000
         GOIF  (R14),NOTZERO=FLD10      CHECK IF OPERAND LENGTH ZERO    18202000
         L     R6,FLDSAVE               RESTORE LINKAGE REGISTER        18203000
         BR    R6                                                       18204000
*   R14 NOW CONTAINS TRUE LENGTH,R3 CONTAINS OUTPUT COLUMN POINTER      18205000
FLD10    BCTR  R14,0                    DECREASE TO MOVE LENGTH         18206000
         GOIF  COLOVLP,OFF=FLD20        BRANCH IF OVERLAP BIT OFF       18207000
         CH    R3,COLSAV                DID FIELDS OVERLAPPED?          18208000
         BNL   FLD20                    NO,BRANCH AROUND                18209000
         LH    R3,COLSAV                GET ADJUSTED COLUMN PTR         18210000
FLD20    EQU   *                        BRANCH LABEL                    18211000
         SET   COLOVLP,ON               TURN OVERLAP CHECK BIT ON       18212000
         L     R1,JCTCHR                GET END COLUMN - 1              18213000
         SR    R1,R3                    GET MAXIMUM MOVE LENGTH         18214000
         LA    R15,D2(R3,R14)           COMPUTE NEXT FIELD PTR          18215000
         STH   R15,COLSAV               SAVE COLUMN PTR FOR NXT FIELD   18216000
         CR    R14,R1                   WILL FIELD FIT INTO THIS LINE   18217000
         LA    R3,SOURCE-D1(R3)         GET PRINT POSITION              18218000
         BH    FLD100                   BRANCH IF LINE WONT FIT         18219000
         EX    R14,MOVE                 MOVE IT                         18220000
         L     R6,FLDSAVE               RESTORE LINK REGISTER           18221000
         BR    R6                       RETURN                          18222000
*  MOVE PART OF FIELD                                                   18223000
FLD100   EX    R1,MOVE                  MOVE PART OF FIELD              18224000
         SR    R14,R1                   GET LENGTH OF REMAINDER         18225000
         STH   R14,HWD                  SAVE LENGTH                     18226000
         LA    R4,D1(R1,R4)             GET ADDR OF REMAINING PART      18227000
         BAL   R6,STRING                INSERT STRINGS INTO PRINT LINE  18228000
             GOIF  JNUM,OFF=FLD30           DO WE PRINT SEQ NUMBER?     18229000
         MVC   SEQNO(8),SEQNUM          YES,MOVE SEQNUM TO PROPER PLACE 18230000
         MVI   SEQNUM,JBLANK            SET BLANK CHARACTER             18231000
         MVC   SEQNUM+1(7),SEQNUM       BLANK OUT SEQNUM                18232000
         BAL   R6,ZEROSUP               SUPRESS LEADING ZEROS           18233000
FLD30    EQU   *                        BRANCH LABEL                    18234000
         JTPRINT                        CALL TERMINAL PRINT             18235000
         BAL   R6,INITBUF               INITIALIZE BUFFER               18236000
*                                                                       18237000
         LH    R14,HWD                  GET LENGTH AGAIN                18238000
         L     R3,JCTBGN                SET OUTPUT COLUMN POINTER       18239000
         LA    R3,D1(,R3)                 TO CONTINUE COLUMN            18240000
         XC    COLSAV,COLSAV            ZEROED OUT SAVEAREA             18241000
         SET   COLOVLP,OFF              TURN OFF OVERLAP CHECK BIT      18242000
         B     FLD10                    GO MOVE REMAINING PART          18243000
*STRING                                                                 18244000
*   EXTRACT STRINGS FROM TEXT RECORD AND INSERT THEM INTO THE CURRENT   18245000
*   PRINT LINE. STRADR(ADDRESS OF STRING GROUP) AND CDSTMT(CARD WITHIN  18246000
*   START COUNTER) ARE UPDATED                                          18247000
STRING   EQU   *                        BRANCH LABEL                    18248000
         LH    R1,CDSTMT                GET CARD WITHIN STMT COUNTER    18249000
         LA    R1,D1(R1)                INCREMENT 1                     18250000
         STH   R1,CDSTMT                UPDATE IT                       18251000
         TM    JTSYMCNT,JGEN            IS STMT GENERATED?              18252000
         BZ    STR050                   NO,BRANCH AROUND                18253000
         MVI   GENFLG,JPLUS             YES,PUT IN + SIGN               18254000
STR050   EQU   *                        BRANCH LABEL                    18255000
         L     R15,STRADR               GET STRING GROUP POINTER        18256000
         DROP  R4                       DROP USING FOR JTEXTA           18257000
         USING JTEXTA,R15               SET NEW USING FOR JTEXTA        18258000
         SR    R1,R1                    CLEAR REGISTER                  18259000
         IC    R1,JTSTC                 GET STRING COUNT                18260000
         LTR   R1,R1                    IS IT ZERO?                     18261000
         BCR   8,R6                     YES,RETURN                      18262000
         LA    R15,JTSTO                POINT TO OUTPUT COL PTR         18263000
STR100   SR    R14,R14                  CLEAR REGISTER                  18264000
         IC    R14,JTSTL2               GET STRING LENGTH               18265000
         BCTR  R14,0                    DECREASE MOVE                   18266000
         SR    R3,R3                    CLEAR REGISTER                  18267000
         IC    R3,JTSTO2                GET OUTPUT COLUMN POINTER       18268000
         LA    R3,SOURCE-D1(R3)         POINT TO PRINT POSITION         18269000
         EX    R14,STRMOVE              MOVE STRING TO OUTPUT           18270000
         LA    R15,JTSTR2+D1(R14)       POINT TO NEXT STRING            18271000
         BCT   R1,STR100                GO BACK IF MORE                 18272000
         ST    R15,STRADR                                               18273000
         BR    R6                                                       18274000
STRMOVE  MVC   D0(0,R3),JTSTR2          EXECUTED STRING MOVE            18275000
         DROP  R15                      DROP USING FOR JTEXTA           18276000
         USING JTEXTA,R4                BACK TO OLD USING               18277000
MOVE     MVC   D0(0,R3),FIELD           EXECUTED MOVE TO PRINT          18278000
INITBUF  EQU   *        F               BRANCH LABEL                    18279000
         LA    R11,BUFTERM              GET BUFFER ADDRESS              18280000
         MVI   BUFC,SPACE1              DO SINGLE SPACE                 18281000
         MVI   PRTIMG,JBLANK            BLANK FIRST BYTE                18282000
         MVC   PRTIMG+D1(L'PRTIMG-D1),PRTIMG  BLANK THE REST            18283000
         BR    R6                       RETURN TO CALLER                18284000
*  CONVERT TO DECIMAL                                                   18285000
*                                                                       18286000
PRN800   CVD   R1,DWORD1                CONVERT NUMBER TO DECIMAL       18287000
         UNPK  DWORD2(5),DWORD1         UNPACK NUMBER                   18288000
         NC    DWORD2(5),MASK1          MASKED OUT ZONE BITS            18289000
         LA    R1,D4                    GET MAXIMUM BLANKS TO ADD       18290000
         LA    R15,DWORD2               POINT TO NUMBER                 18291000
PRN810   CLI   D0(R15),J0               IS LEADING DIGIT ZERO           18292000
         BNE   PRN820                   NO                              18293000
         MVI   D0(R15),JBLANK           YES,BLANK OUT                   18294000
         LA    R15,D1(R15)              BUMP POINTER                    18295000
         BCT   R1,PRN810                GO BACK IF MORE                 18296000
PRN820   BR    R6                       RETURN                          18297000
*       SUPRESS LEADING ZEROS IN SEQUENCE NUMBER                        18298000
ZEROSUP  LA    R3,D8                    GET LENGTH OF NUM FIELD         18299000
         LA    R2,SEQNO                 GET ADDRESS                     18300000
ZEROS    CLI   D0(R2),J0                LEADING ZERO ?                  18301000
         BNE   ZERORET                  NO                              18302000
         MVI   D0(R2),JBLANK            SUPRESS LEADING ZERO            18303000
         LA    R2,D1(R2)                POINT TO NEXT DIGIT             18304000
         BCT   R3,ZEROS                 DECREMENT COUNT                 18305000
ZERORET  BR    R6                       RETURN TO CALLER                18306000
MASK1    DC    5X'0F'                   MASK TO REMOVE ZONE BITS        18307000
         JPATCH X6B20,3D0               5% PATCH AREA          FX0000   18308000
         END   BEGIN                                                    18309000
./ ADD NAME=IFOX0A                                                      18310000
         MACRO                                                          18311000
         JPHASE &PHASE=,&PHSUFF=,&BUF=,&DBLBUF=                         18312000
         LCLA  &A,&B                                                    18313000
         LCLC  &C                                                       18314000
         AIF   (K'&PHSUFF EQ 0).NX10                                    18315000
&C       SETC  '&PHSUFF'(2,2)                                           18316000
PHASE&C  DC    C'&PHSUFF'                 PHASE SUFFIX                  18317000
         AIF   ('&PHSUFF'(2,1) EQ '0').EXIT                             18318000
&A       SETA  &BUF(1)+&BUF(2)+&BUF(3)  COUNT NUMBER OF SINGLE BUFFERS  18319000
&B       SETA  &DBLBUF(1)+&DBLBUF(2)+&DBLBUF(3)+&A TOTAL BUFFERS        18320000
         DC    X'&A&B'                      NO. OF BUF IF SINGLE,DOUBLE 18321000
         AIF   (&B EQ 0).EXIT                                           18322000
         DC    B'&BUF(1)&DBLBUF(1).000000'  FILE1                       18323000
         DC    B'&BUF(2)&DBLBUF(2).000000'  FILE2                       18324000
         DC    B'&BUF(3)&DBLBUF(3).000000'  FILE3                       18325000
         MEXIT                                                          18326000
.NX10    ANOP                                                           18327000
&C       SETC  '&PHASE'(5,2)                                            18328000
PHASE&C  DC    CL8'&PHASE'                LOAD NAME                     18329000
.EXIT    MEND                                                           18330000
         SPACE 3                                                        18331000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                18332000
         SPACE 5                                                        18333000
         JHEAD 'ASSEMBLER DRIVER - PROLOG',                            X18334000
               PHASEID=X0A,                                            X18335000
               LEVEL=21                                        @AX14179 18336000
*                                                                     * 18337000
*FUNCTION/OPERATION-                                                  * 18338000
*   THIS MODULE IS THE DRIVER FOR THE ASSEMBLER.  THIS MODULE TREATS  * 18339000
*   ALL OTHER PHASES AS SUBROUTINES.                                  * 18340000
*                                                                     * 18341000
*ENTRY POINT-                                                         * 18342000
*        START - ENTERED BY SYSTEM.                                   * 18343000
*                                                                     * 18344000
*INPUT-                                                               * 18345000
*   REGISTER R1 POINTS TO PARAMETER LIST (EXEC CARD).                 * 18346000
*                                                                     * 18347000
*OUTPUT-                                                              * 18348000
*   RETURN CODE IN REGISTER R15.                                      * 18349000
*                                                                     * 18350000
*EXTERNAL ROUTINES-                                                   * 18351000
*   ALL OTHER PHASES OF THE ASSEMBLER                                 * 18352000
*                                                                     * 18353000
*EXITS, NORMAL-                                                       * 18354000
*   RETURN TO SYSTEM                                                  * 18355000
*                                                                     * 18356000
*EXITS, ERROR-                                                        * 18357000
*   N/A                                                               * 18358000
*                                                                     * 18359000
*TABLE/WORK AREAS-                                                    * 18360000
*   COMMON - LOADED BY THIS PHASE.                                    * 18361000
*                                                                     * 18362000
*ATTRIBUTES-                                                          * 18363000
*   REFRESHABLE.                                                      * 18364000
*                                                                     * 18365000
*NOTES-                                                               * 18366000
         SPACE 5                                                        18367000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - JCOMMON COPY CODE'   18368000
         COPY  JCOMMON                  JCOMMON COPY CODE               18369000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - JFLEBLK COPY CODE'   18370000
         COPY  JFLEBLK                  JFLEBLK COPY CODE               18371000
         SPACE 3                                                        18372000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - EQUATES'             18373000
MINBUF   EQU   2+788                    2 BYTE HEADER + LONGEST LOG REC 18374000
PHAS1    EQU   C'1'                     PHAS1 SUFFIX                    18375000
PCPREQ   EQU   8192                     MFT SYSTEM REQUIREMENT  OX01003 18376000
MVTREQ   EQU   8192                     MVT SYSTEM REQUIREMENTS OX01003 18377000
CVTADDR  EQU   X'10'                    LOCATION OF CVT ADDRESS         18378000
CVTDCB   EQU   X'74'                    DISP INTO CVT FOR SYSTEM CONFIG 18379000
MVT      EQU   X'10'                   BIT IN CVTDCB THAT INDICATES MVT 18380000
         SPACE 5                                                        18381000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER'                       18382000
         JCSECT (X0A00)                 SECTION NAME                    18383000
* VS1 RELEASE 2.6 CHANGES                                               18384000
*C122400-122600                                                 OX01003 18385000
*C046000                                                       @OZ01709 18386000
*C046000                                                       @OX07280 18387000
*C670000                                                       @OX07284 18388000
*C046000                                                       OX09734  18389000
*C046000                                                       @AX14179 18390000
*A510500-511960,512500-513800,572500-574799,488500-491900      @AZ13738 18391000
*C421000,670000                                                @AZ13738 18392000
*A420500                                                       @AX19340 18393000
MODID    JMODID                         EMBEDDED IDENTIFIER             18394000
         JEXTRN (X0B01=MLC)             WORKFILE I/O MODULE             18395000
START    SAVE  (14,12)                  SAVE REGISTERS                  18396000
         JENTRY (X0A01=START)                                           18397000
         LR    R8,R15                   SET BASE REGISTER               18398000
         USING START,R8                 ''                              18399000
         LR    R2,R1                    SAVE PARM POINTER               18400000
         SPACE                                                          18401000
         LOAD  EPLOC=PHASE01            LOAD COMMON                     18402000
         LR    R12,R0                   LOAD R12 FROM R0                18403000
         ST    R13,D4(,R12)             CHAIN SAVE AREAS                18404000
         ST    R12,D8(,R13)             ''                              18405000
         LR    R13,R12                  SET R13 TO COMMON               18406000
         MVC   JPHNAME,PHASE01          SAVE PREFIX OF PHASE            18407000
         LA    R6,LDPHASE               GET ADDR OF LOAD ROUTINE        18408000
         LA    R7,DLPHASE               GET ADDR OF DELETE ROUTINE      18409000
         SPACE 2                                                        18410000
         MVC   JMLC,=A(MLC)             ADDR OF WORKFILE I/O PACKAGE    18411000
         MVC   JAABORT,=A(ABORT)        ADDRESS OF ABORT ROUTINE        18412000
         SPACE 2                                                        18413000
         LA    R5,PHASE02               LOAD INITIALIZATION             18414000
         BALR  R9,R6                    ''                              18415000
         L     R10,AMODID               PASS MODID ADDR TO INIT         18416000
         LR    R11,R2                   PASS PARM FIELD POINTER         18417000
         BALR  R9,R12                   GO TO INIT                      18418000
         SPACE                                                          18419000
         BALR  R9,R7                    DELETE INITIALIZATION           18420000
         SPACE                                                          18421000
         L     R1,JSYSOPEN              OPEN WORKFILES                  18422000
         OPEN  MF=(E,(1))               ''                              18423000
         SPACE 2                                                        18424000
         LA    R5,PHASE03               LOAD INPUT COMMON               18425000
         BALR  R9,R6                    ''                              18426000
         ST    R12,JADINCM              SAVE ADDRESS OF INPUT COMMON    18427000
         SPACE                                                          18428000
         LA    R5,PHASE04               LOAD INPUT PACKAGE              18429000
         BALR  R9,R6                    ''                              18430000
         ST    R12,JINMLC               SAVE INPUT MLC ADDRESS          18431000
         LR    R11,R2                   PASS PARM FIELD POINTER         18432000
         BAL   R9,JININIT(,R12)         GO TO INPUT INIT                18433000
         SPACE 2                                                        18434000
         LA    R5,PHASE11               LOAD EDITOR                     18435000
         BALR  R9,R6                    ''                              18436000
         BALR  R9,R12                   GO TO EDITOR                    18437000
         SPACE 2                                                        18438000
         L     R12,JINMLC               GO TO INPUT INIT TO CLOSE FILES 18439000
         BAL   R9,JININIT(,R12)         ''                              18440000
         SPACE                                                          18441000
         BALR  R9,R7                    DELETE EDITOR                   18442000
         SPACE                                                          18443000
         LA    R5,PHASE04               DELETE INPUT PACKAGE            18444000
         BALR  R9,R7                    ''                              18445000
         SPACE 2                                                        18446000
         LA    R5,PHASE03               DELETE INPUT COMMON             18447000
         BALR  R9,R7                    ''                              18448000
         SPACE 2                                                        18449000
         LA    R5,PHASE21               LOAD DICT. RES.                 18450000
         BALR  R9,R6                    ''                              18451000
         BALR  R9,R12                   GO TO DICT. RES.                18452000
         SPACE                                                          18453000
         BALR  R9,R7                    DELETE DICT. INTERLUDE          18454000
         SPACE                                                          18455000
         LA    R5,PHASE31               LOAD GENERATOR                  18456000
         BALR  R9,R6                    ''                              18457000
         BALR  R9,R12                   GO TO GENERATOR                 18458000
         SPACE                                                          18459000
         BALR  R9,R7                    DELETE GENERATOR                18460000
         SPACE                                                          18461000
         LA    R5,PHASE05               LOAD OUTPUT COMMON              18462000
         BALR  R9,R6                    ''                              18463000
         ST    R12,JADOUTCM             SAVE ADDRESS OF OUTPUT COMMON   18464000
         SPACE 2                                                        18465000
         LA    R5,PHASE06               LOAD OUTPUT PACKAGE             18466000
         BALR  R9,R6                    ''                              18467000
         ST    R12,JOUTMLC              SAVE OUTPUT MLC ADDRESS         18468000
         LR    R11,R2                   PASS PARM FIELD POINTER         18469000
         BAL   R9,JOUTINIT(,R12)        GO TO OUTPUT INIT               18470000
         SPACE 3                                                        18471000
         GOIF  JSYSGEN,OFF=SKIPX4       SKIP X4 IF JSYSGEN OFF          18472000
         LA    R5,PHASE41               LOAD SYMBOL RES (NO SYM CARDS)  18473000
         GOIF  JTEST,OFF=NOTEST         NO SYM CARDS WANTED             18474000
         GOIF  (JDECK,JLINK),NONE=NOTEST     FRUSTRATE SYM OUTPUT       18475000
         LA    R5,PHASE42               LOAD SYMBOL RES (SYM CARDS)     18476000
NOTEST   BALR  R9,R6                    ''                              18477000
         BALR  R9,R12                   GO TO SYMBOL RES.               18478000
         SPACE                                                          18479000
         BALR  R9,R7                    DELETE SYMBOL RES.              18480000
         SPACE                                                          18481000
SKIPX4   LA    R5,PHASE51               LOAD OUTPUT LISTER              18482000
         BALR  R9,R6                    ''                              18483000
         BALR  R9,R12                   GO TO OUTPUT LISTER             18484000
         SPACE                                                          18485000
         BALR  R9,R7                    DELETE ASSEMBLER                18486000
         SPACE                                                          18487000
         LA    R5,PHASE61               LOAD RLD & XREF PROCESSOR       18488000
         BALR  R9,R6                    ''                              18489000
         BALR  R9,R12                   GO TO LISTER                    18490000
         SPACE 2                                                        18491000
         BALR  R9,R7                    DELETE RLD & XREF PROCESSOR     18492000
         LA    R5,PHASE62               LOAD DIAGNOSTIC PHASE           18493000
         BALR  R9,R6                    ''                              18494000
         BALR  R9,R12                   GO TO DIAGNOSTIC PHASE          18495000
         LR    R2,R10                   SAVE RETURN CODE                18496000
         SPACE                                                          18497000
         BALR  R9,R7                    DELETE DIAGNOSTIC PHASE         18498000
         SPACE                                                          18499000
         L     R12,JOUTMLC              GO TO OUT INIT TO CLOSE FILES   18500000
         BAL   R9,JOUTINIT(,R12)        ''                              18501000
         SPACE 2                                                        18502000
         LA    R5,PHASE06               DELETE OUTPUT PACKAGE           18503000
         BALR  R9,R7                    ''                              18504000
         SPACE 2                                                        18505000
         LA    R5,PHASE05               DELETE OUTPUT COMMON            18506000
         BALR  R9,R7                    ''                              18507000
         SPACE 2                                                        18508000
         L     R1,JSYSCLOS              CLOSE WORKFILES                 18509000
         CLOSE MF=(E,(1))               ''                              18510000
         SPACE 2                                                        18511000
         L     R1,JPARMPTR              FREE TRANSLATED PARM AREA       18512000
         LTR   R1,R1                    HAS AREA BEEN FREED BY INIT     18513000
         BZ    FREED                    YES.  ALREADY FREED             18514000
         LH    R0,D0(,R1)               GET LENGTH OF AREA              18515000
         FREEMAIN R,LV=(0),A=(1)        FREE CORE                       18516000
         SPACE 2                                                        18517000
FREED    L     R13,D4(,R13)             PT TO SAVE AREA                 18518000
         DELETE EPLOC=PHASE01           DELETE COMMON                   18519000
         SPACE 2                                                        18520000
         LR    R15,R2                   LOAD RETURN CODE                18521000
         RETURN (14,12),RC=(15)         RETURN TO CALLER                18522000
         SPACE 3                                                        18523000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - PHASE LOAD ROUTINE'  18524000
*        THIS ROUTINE LOADS THE PHASE WHOSE NAME IS POINTED TO BY R5. * 18525000
*   IT RETURNS WITH THE ENTRY POINT ADDRESS IN R12.                   * 18526000
         SPACE 3                                                        18527000
LDPHASE  JSAVE BASE=NO                  SAVE REGISTERS                  18528000
         SPACE                                                          18529000
         MVC   JPHSUFF,D0(R5)           BUILD COMPLETE PHASE NAME       18530000
         LOAD  EPLOC=JPHNAME            LOAD PHASE                      18531000
         SPACE                                                          18532000
         LR    R2,R0                    SAVE ENTRY POINT                18533000
         CLI   JPHSUFF+D1,PHAS1         WAS SYS IND PHASE LOADED        18534000
         BL    LD50                     NO, RETURN                      18535000
         L     R3,=A(PCPREQ)            PCP MFT REQUIREMENT             18536000
         L     R1,CVTADDR               GET ADDR OF CVT                 18537000
         TM    CVTDCB(R1),MVT           IS SYSTEM MVT                   18538000
         BZ    GETREQ                   NO, GET PCP REQUIREMENT         18539000
         LA    R3,MVTREQ-PCPREQ(,R3)    MVT REQUIREMENTS                18540000
GETREQ   GETMAIN R,LV=(R3)              GET CORE FOR RETURN TO SYSTEM   18541000
         SPACE                                                          18542000
         LR    R10,R1                   SAVE CORE ADDRESS               18543000
         MVC   JEOS,CORESIZE            GET REQ CORESIZE       FX0000   18544000
         MVC   JBOS(D4),MINCORE         GET MIN CORE VALUE     @AZ13738 18545000
         GETMAIN VU,LA=JBOS,A=JBOS,SP=0,HIARCHY=0,MF=(E,JDWORD)        X18546000
                                        GET ALL THE CORE WE CAN         18547000
         SPACE                                                          18548000
         LR    R1,R10                   PT TO AREA THAT IS TO BE FREED  18549000
         FREEMAIN R,LV=(R3),A=(1)       FREE CORE THAT SYSTEMS NEED     18550000
         SPACE                                                          18551000
         LM    R14,R15,JBOS             LD ADDR OF CORE & LENGTH        18552000
         AR    R14,R15                  CALC END OF CORE ADDR           18553000
         ST    R14,JEOS                 SAVE IN JEOS                    18554000
         ST    R15,JSLEN                SAVE LENGTH OF AREA (JEOS-JBOS) 18555000
         CLC   JPHSUFF,PHASE11          IS THIS THE EDITOR              18556000
         BNE   LD30                     NO, GO ALLOC BUFFERS            18557000
         SR    R14,R14                  DIVIDE AVAILABLE BUFFER SPACE   18558000
         D     R14,=F'8'                TAKE 37.5 PERCENT AND           18559000
         LR    R14,R15                  DIVIDE BY THREE BUFFERS         18560000
         GOIF  JMINBUF,ON=LD22          MIN BUFFER ALLOC REQUIRED       18561000
         MH    R15,=H'10'               IS AVAILABLE SPACE 60 PERCENT   18562000
         SRA   R15,D5                   (16/10) LARGER THAN JMAXRL      18563000
         SPACE                                                          18564000
         CH    R15,JMAXRL               ''                              18565000
         BNH   LD10                     NO, SINGLE BUFFER               18566000
         SET   JDBLALL,ON               YES, DOUBLE BUFFER AND ALLOW    18567000
         SRA   R14,D1                     HALF THE BUFFER SIZE          18568000
LD10     CH    R14,JMAXRL               IF SIZE OF EACH BUFFER IS GT    18569000
         BNH   LD20                       MAXRL, THEN SET SIZE TO MAXRL 18570000
         LH    R14,JMAXRL                 ''                            18571000
LD20     SH    R14,=H'2'                TRUNCATE RL TO A MULTIPLE OF    18572000
         N     R14,=X'FFFFFFFC'           FW + 2 BYTES                  18573000
         LA    R14,D2(,R14)               ''                            18574000
         CH    R14,=Y(MINBUF)           BUFFER SIZE MUST BE LARGE       18575000
         BNL   LD25                       ENOUGH TO CONTAIN THE         18576000
LD22     LH    R14,=Y(MINBUF)             LONGEST POSSIBLE LOGICAL REC. 18577000
LD25     STH   R14,JMAXRL               SAVE NEW MAXRL                  18578000
         STH   R14,JFLEBLK1+JRL-JFLEBLK SET FILE1 RL                    18579000
         STH   R14,JFLEBLK2+JRL-JFLEBLK SET FILE2 RL                    18580000
         STH   R14,JFLEBLK3+JRL-JFLEBLK SET FILE3 RL                    18581000
         GOIF  JMBUF,OFF=LD30           BR IF NO MBUF REQ      @AZ13738 18582000
         GOIF  JDBLALL,OFF=LD30         BR IF SINGEL BUFFERS   @AZ13738 18583000
         L     R15,JSLEN                GET LENGH OF AREA      @AZ13738 18584000
         SRA   R15,D3                   GET 37,5 PERCENT       @AZ13738 18585000
         M     R14,=F'3'                OF WORK AREA.          @AZ13738 18586000
         LH    R11,JMAXRL               GET USABEL REC LENGH   @AZ13738 18587000
         DR    R14,R11                  GET MAX NR OF BUFFERS  @AZ13738 18588000
         IC    R11,PHASE31+D3           GET MIN NR OF DBLBUFS  @AZ13738 18589000
         N     R11,=X'0000000F'         MASK OUT THE REST      @AZ13738 18590000
         SR    R15,R11                  GET NR OF MULTIPLE BUFS@AZ13738 18591000
         BNP   LD30                     BR IF NO MBUFS         @AZ13738 18592000
         STH   R15,NRMBUF               SAVE VALUE             @AZ13738 18593000
LD30     LA    R5,D3(,R5)               ADVANCE PHASE NAME PTR TO PARM  18594000
         IC    R15,D0(,R5)              PICK UP NUMBER OF SINGLE AND   X18595000
                                          DOUBLE BUFFERS FOR FILE       18596000
         GOIF  JDBLALL,ON=LD40          FILES CAN BE DOUBLEED BUFFERED  18597000
         SPACE                                                          18598000
         SRL   R15,D4                   LEFT HALF OF BYTE IS NO. OF    X18599000
                                          SINGLE BUFFERS. RT NO. OF DBL 18600000
LD40     N     R15,=X'0000000F'         MASK OUT REST OF REGISTER       18601000
         BZ    LD50                     BRANCH IF NO BUFFERS WANTED     18602000
         LH    R3,JMAXRL                GET MAXRL, BUMP TO A MULTIPLE   18603000
         LA    R3,D2(,R3)                 OF FW (2 BYTES WASTED), AND   18604000
         USING JFLEBLK,R11              ADDRABIL TO FILES      @AZ13738 18605000
         LA    R11,JFLEBLK1             PT TO FILE 1           @AZ13738 18606000
         SET   JMLTBUF,OFF              RESET MBUF SW          @AZ13738 18607000
         LA    R11,JFLEBLK2             PT TO FILE 2           @AZ13738 18608000
         SET   JMLTBUF,OFF              RESET MBUF SW          @AZ13738 18609000
         LA    R11,JFLEBLK3             PT TO FILE 3           @AZ13738 18610000
         SET   JMLTBUF,OFF              RESET MBUF SW          @AZ13738 18611000
         DROP  R11                      DROP ADDRABIL TO FILES @AZ13738 18612000
         CLC   JPHSUFF,PHASE31          IS PHASE X31 LOADED    @AZ13738 18613000
         BNE   LD42                     BR IF NOT PHASE X31    @AZ13738 18614000
         GOIF  JMBUF,OFF=LD42           BR IF NOT MBUF REQ.    @AZ13738 18615000
         LH    R10,NRMBUF              LOAD NR OF MBUFFERS     @AZ13738 18616000
         CH    R10,=H'2'                TEST FOR NR OF-        @AZ13738 18617000
         BL    LD42                     MULTIBUFFERS ARE-      @AZ13738 18618000
         CH    R10,=H'15'               WITHIN 2 AND 15-       @AZ13738 18619000
         BNH   LD41                     AND BR IF SO OR-       @AZ13738 18620000
         LA    R10,15                   SET MAXIMUM NR.        @AZ13738 18621000
         STH   R10,NRMBUF               SAVE NEW VALUE         @AZ13738 18622000
LD41     EQU   *                        PROCEED                @AZ13738 18623000
         BCTR  R10,0                    SUBTRACT BY ONE        @AZ13738 18624000
         AR    R15,R10                  ADD TO TOTAL NR OF BUFS@AZ13738 18625000
         LA    R11,JFLEBLK1             PT TO FILE 1           @AZ13738 18626000
         USING JFLEBLK,R11              ADDRESSABILITY TO FILE1@AZ13738 18627000
         SET   JMLTBUF,ON               IND MULTIBUFFERS REQ.  @AZ13738 18628000
LD42     EQU   *                        PROCEED                @AZ13738 18629000
         MR    R14,R3                     MULTIPLY BY NUMBER OF BUFFERS 18630000
         GOIF  JMLTBUF,OFF=LD44         BR IF NOT NBUF REQ.    @AZ13738 18631000
         DROP  R11                      DROP ADDR              @AZ13738 18632000
         LA    R10,BUFENLN              LOAD LENGH OF ENTRY    @AZ13738 18633000
         MH    R10,NRMBUF               GET TOTAL SPACE        @AZ13738 18634000
         AR    R15,R10                  ADD TO PREV. SPACE     @AZ13738 18635000
LD44     EQU   *                        PROCEED                @AZ13738 18636000
         LA    R10,D7(,R15)             CONVERT VALUE TO NUMBER OF DW   18637000
         SRL   R10,D3                     (GREATER THAN ORIGINAL VALUE) 18638000
         JGETCORE DBL=(R10)             ALLOCATE MEMORY                 18639000
         SPACE                                                          18640000
         LA    R10,D2(,R10)             PT TO HW BOUNDRY                18641000
         LA    R11,JFLEBLK1             PT TO FILE1 BLOCK               18642000
         BAL   R9,ALLOCBUF              GO ALLOC BUF FOR FILE1          18643000
         LA    R11,JFLEBLK2             PT TO FILE2 BLOCK               18644000
         BAL   R9,ALLOCBUF              GO ALLOC BUF FOR FILE2          18645000
         LA    R11,JFLEBLK3             PT TO FILE3 BLOCK               18646000
         BAL   R9,ALLOCBUF              GO ALLOC BUF FOR FILE3          18647000
LD50     LR    R12,R2                   LOAD ENTRY POINT INTO R12       18648000
LDRTN    JRETURN                        RETURN                          18649000
         SPACE 2                                                        18650000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - PHASE DELETION AND BX18651000
               UFFER ALLOCATION ROUTINES'                               18652000
*        THIS ROUTINE DELETE THE PHASE WHOSE NAME IS POINTED TO BY R5.  18653000
         SPACE                                                          18654000
DLPHASE  MVC   JPHSUFF,D0(R5)           BUILD PHASE NAME TO BE DELETED  18655000
         DELETE EPLOC=JPHNAME           DELETE PHASE                    18656000
         SPACE                                                          18657000
         CLI   JPHSUFF+D1,PHAS1         IS IT A SYS IND PHASE           18658000
         BLR   R9                       NO, RETURN                      18659000
         LM    R0,R1,JSLEN              GET LENGTH AND ADDR OF AREA     18660000
         FREEMAIN R,LV=(0),A=(1)        FREE CORE                       18661000
         SPACE                                                          18662000
         XC    JSLEN,JSLEN              INDICATE NO CORE FOR ABORT      18663000
         BR    R9                       RETURN                          18664000
         SPACE 5                                                        18665000
*        THIS ROUTINE ALLOCATES BUFFERS FOR A FILE.                     18666000
*   R5 POINTS TO PARAMETER BYTE.  R11 POINTS TO JFLEBLK.                18667000
         SPACE                                                          18668000
         USING JFLEBLK,R11              ADDRESSABILITY TO JFLEBLK       18669000
ALLOCBUF SET   JDBLBUF,OFF              TURN OFF JDBLBUF FOR FILE       18670000
         SPACE                                                          18671000
         LA    R5,D1(,R5)               PT TO PARM BYTE FOR FILE        18672000
         GOIF  JMLTBUF,OFF=ALLOC10      BR IF NOT MBUF REQ.    @AZ13738 18673000
         LH    R15,NRMBUF               LOAD NR OF MBUFFERS    @AZ13738 18674000
         SR    R12,R12                  CLEAR REGISTER         @AZ13738 18675000
         ST    R10,LOWPRIOR             LOWPRIOR ADDR          @AZ13738 18676000
         LA    R14,1                    SET LOWPRIOR VALUE     @AZ13738 18677000
ALLOC5   XC    FWBUFPTR(BUFENLN,R10),FWBUFPTR(R10) CLEAN ENTRY @AZ13738 18678000
         ST    R12,FWBUFPTR(R10)        SET FOWARD CHAIN       @AZ13738 18679000
         LR    R12,R10                  SAVE ENTRY ADDR        @AZ13738 18680000
         ST    R10,BUFSTART             SAVE END OF TABEL      @AZ13738 18681000
         LA    R10,BUFENLN(R10)         ADD WITH ENTRY LENGH   @AZ13738 18682000
         ST    R10,BUFADR(R12)          SET ADDR TO BUFFER     @AZ13738 18683000
         AR    R10,R3                   ADD LENGH OF BUFFER    @AZ13738 18684000
         STH   R14,PRIOR(R12)           SET PRIORITY TO BUF    @AZ13738 18685000
         SLL   R14,1                    INCREASE PRIORITY      @AZ13738 18686000
         BCT   R15,ALLOC5               BR IF MORE BUFFERS     @AZ13738 18687000
         SRL   R14,1                    REPOS PRIORITY         @AZ13738 18688000
         STH   R14,HIMASK               SAVE HIGEST PRIORITY   @AZ13738 18689000
         L     R12,LOWPRIOR             LOAD LAST ENTRY        @AZ13738 18690000
         L     R15,BUFADR(R12)          LOAD THIS BUF ADDR     @AZ13738 18691000
         ST    R15,JBUF                 INIT JFLE BUF PTR      @AZ13738 18692000
         BR    R9                       RETURN                 @AZ13738 18693000
ALLOC10  EQU   *                        PROCEED                @AZ13738 18694000
         TM    D0(R5),BIT0              DO ANY BUFFERS NEED ALLOC       18695000
         BZR   R9                       NO, RETURN                      18696000
         ST    R10,JBUF                 STORE ADDRESS OF PRIMARY BUFFER 18697000
         AR    R10,R3                   BUMP PTR BY (MAXRL + 2)         18698000
         GOIF  JDBLALL,OFF=(R9)         NO FILES ARE DOUBLED BUFFERED   18699000
         SPACE                                                          18700000
         TM    D0(R5),BIT1              DO ANY ALT BUF NEED ALLOC       18701000
         BZR   R9                       NO, RETURN                      18702000
         SET   JDBLBUF,ON               SET JDBLBUF ON FOR FILE         18703000
         SPACE                                                          18704000
         ST    R10,JBUFFER              STORE ADDRESS OF ALT BUFFER     18705000
         AR    R10,R3                   BUMP PTR BY (MAXRL + 2)         18706000
         BR    R9                       RETURN                          18707000
         DROP  R11                      DROP ADDRESSABILITY             18708000
         SPACE 2                                                        18709000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - ABORT ROUTINE'       18710000
*        THIS ROUTINE LOADS THE ABORT ROUTINE.  R10 CONTAINS THE ERROR  18711000
*   CODE.  R11 WILL CONTAIN R1 INFO AT THE TIME THE ASSEMBLER WAS       18712000
*   INVOKED (PARAMETER LIST PTR) (ERR260) OR R0 INFO FROM SYNAD EXIT    18713000
*   (ERR261).  R1 WILL CONTAIN THE DCB ADDRESS FOR ERR261.              18714000
         SPACE 3                                                        18715000
         USING ABORT,R12                REGISTER R12 IS BASE            18716000
ABORT    LR    R2,R1                    DCB ADDR MAY BE IN REG. R1      18717000
         DELETE EPLOC=JPHNAME           DELETE LAST PHASE LOADED        18718000
         LOAD  EPLOC=PHASE07            LOAD ABORT ROUTINE              18719000
         LR    R12,R0                   GO TO ABORT                     18720000
         BALR  R9,R12                   ''                              18721000
         DELETE EPLOC=PHASE07           DELETE ABORT ROUTINE            18722000
         L     R13,D4(,R13)             PT TO SAVE AREA                 18723000
         DELETE EPLOC=PHASE01           DELETE COMMON                   18724000
         RETURN (14,12),RC=20           RETURN TO CALLER                18725000
         SPACE 3                                                        18726000
         TITLE '&COMPNM&ASMID - ASSEMBLER DRIVER - CONSTANTS '          18727000
*        CONSTANTS                                                      18728000
*                                                                       18729000
         JPHASE PHASE=&COMPNM.X01       X01 PHASE ID                    18730000
         JPHASE PHSUFF=X02              X02 PHASE ID                    18731000
         JPHASE PHSUFF=X03              X03 PHASE ID                    18732000
         JPHASE PHSUFF=X04              X04 PHASE ID                    18733000
         JPHASE PHSUFF=X05              X05 PHASE ID                    18734000
         JPHASE PHSUFF=X06              X06 PHASE ID                    18735000
         JPHASE PHASE=&COMPNM.X07       X07 PHASE ID                    18736000
         JPHASE PHSUFF=X11,BUF=(1,1,1),DBLBUF=(1,1,1)    X11 PHASE ID   18737000
         JPHASE PHSUFF=X21,BUF=(1,1,1),DBLBUF=(0,0,0)    X21 PHASE ID   18738000
         JPHASE PHSUFF=X31,BUF=(1,1,1),DBLBUF=(0,1,1)    X31 PHASE ID   18739000
         JPHASE PHSUFF=X41,BUF=(1,0,1),DBLBUF=(1,0,1)    X41 PHASE ID   18740000
         JPHASE PHSUFF=X42,BUF=(1,0,1),DBLBUF=(1,0,1)    X42 PHASE ID   18741000
         JPHASE PHSUFF=X51,BUF=(1,1,1),DBLBUF=(0,0,0)    X51 PHASE ID   18742000
         JPHASE PHSUFF=X61,BUF=(0,0,0),DBLBUF=(0,0,0)    X61 PHASE ID   18743000
         JPHASE PHSUFF=X62,BUF=(1,0,1),DBLBUF=(0,0,0)    X62 PHASE ID   18744000
         SPACE 3                                                        18745000
AMODID   DC    A(MODID+6)               ADDRESS OF MASTER MODID LEVEL   18746000
MINCORE  DC    A(8)                 MIN CORE REQUEST           @AZ13738 18747000
         SPACE 3                                                        18748000
         JPATCH X0A00,3BE               5% PATCH AREA                   18749000
         END   START                                                    18750000
./ ADD NAME=IFOX0B                                                      18751000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                18752000
         JHEAD 'WORKFILE I/O MODULE - PROLOG',                         X18753000
               PHASEID=X0B,                                            X18754000
               LEVEL=10                                                 18755000
*                                                                     * 18756000
*FUNCTION/OPERATION-                                                  * 18757000
*   THIS MODULE IS THE WORKFILE I/O PACKAGE FOR THE ASSEMBLY.  THE    * 18758000
*   OTHER PHASES INTERFACE WITH THIS MODULE FOR ALL WORKFILE I/O RE-  * 18759000
*   QUESTS AND CORE MANAGEMENT.                                       * 18760000
*                                                                     * 18761000
*ENTRY POINT-                                                         * 18762000
*        START+0  - JPUTL    - PUT LOGICAL RECORD IN LOCATE MODE.     * 18763000
*        START+4  - JPUTM    - PUT LOGICAL RECORD IN MOVE MODE.       * 18764000
*        START+8  - JGETL    - GET LOGICAL RECORD IN LOCATE MODE.     * 18765000
*        START+12 - JTRUNC   - TRUNCATE PHYSICAL BUFFER.              * 18766000
*        START+16 - JRELSE   - RELEASE PHYSICAL BUFFER.               * 18767000
*        START+20 - JREAD    - READ A PHYSICAL RECORD.                * 18768000
*        START+24 - JWRITE   - WRITE A PHYSICAL RECORD.               * 18769000
*        START+28 - JCHECK   - CHECK READ OR WRITE FOR COMPLETION.    * 18770000
*        START+32 - JGETCORE - GET DYNAMIC CORE STORAGE.              * 18771000
*        START+36 - JFRECORE - FREE DYNAMIC CORE STORAGE.             * 18772000
*        START+40 - JNOTE    - NOTE FILE POSITION                     * 18773000
*        START+44 - JPOINT   - POSITION FILE.                         * 18774000
*                                                                     * 18775000
*INPUT-                                                               * 18776000
*   SYSUT1, STSUT2, SYSUT3.                                           * 18777000
*                                                                     * 18778000
*OUTPUT-                                                              * 18779000
*   THREE WORKFILES (FILE1,FILE2,FILE3).                              * 18780000
*                                                                     * 18781000
*EXTERNAL ROUTINES-                                                   * 18782000
*   N/A                                                               * 18783000
*                                                                     * 18784000
*EXITS, NORMAL                                                        * 18785000
*   RETURN TO CALLER VIA REGISTER R9.                                 * 18786000
*                                                                     * 18787000
*EXITS, ERROR-                                                        * 18788000
*   BRANCH TO JABORT IN COMMON.                                       * 18789000
*                                                                     * 18790000
*TABLES/WORK AREA-                                                    * 18791000
*   REGISTER R13 POINTS TO COMMON.                                    * 18792000
*                                                                     * 18793000
*ATTRIBUTES-                                                          * 18794000
*   REFRESHABLE.                                                      * 18795000
*                                                                     * 18796000
*NOTES-                                                               * 18797000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - COPY CODE'        18798000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   18799000
         COPY  JCOMMON                  JCOMMON COPY CODE               18800000
         PRINT OFF                      DON'T PRINT JFLEBLK COPY CODE   18801000
         COPY  JFLEBLK                  JFLEBLK COPY CODE               18802000
         PRINT ON                       PRINT READ/WRITE PARM LIST      18803000
         SPACE 3                                                        18804000
RDWRPARM DSECT                          READ/WRITE PARAMETER LIST       18805000
RDWRBUF  DS    F                        BUFFER LOCATION                 18806000
RDWRLEN  DS    H                        RECORD LENGTH                   18807000
         SPACE 3                                                        18808000
MAXMVC   EQU   256                      MAXIMUM MOVE                    18809000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  18810000
         COPY  JERMSGCD                 JERMSGCD COPY CODE              18811000
         PRINT ON                       THAT'S ALL THE COPY CODE        18812000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - MAINLINE CONTROL' 18813000
         JCSECT (X0B00)                 SECTION ID                      18814000
* VS1 RELEASE 2.5 CHANGES                                               18815000
*A264500,327500,375100-375300,480600-482500,546500              OX00413 18816000
*A762100-766500,888000-890000,891500-892000                     OX00413 18817000
*C474000-474020,483000,504000,723000,759000,768000,891000       OX00413 18818000
*D267000,486000-489000,501000,741000,747000-756000,762000       OX00413 18819000
*D765000,771000                                                 OX00413 18820000
* VS1 RELEASE 3.1 CHANGES                                               18821000
*A480500,481000,504500,738500,744500-746000,759500,762600,      OX02955 18822000
*A763100,888500                                                 OX02955 18823000
*C264500,504000,762100,759000                                   OX02955 18824000
*D327500,330100,375100-375300,474020,480600-481500,483000,      OX02955 18825000
*D547000,762300-768000,888500-892000                            OX02955 18826000
*A672500                                                       @0X13606 18827000
*A708500-710000                                                @AZ10942 18828000
*                                                                       18829000
         JMODID                                                         18830000
         USING START,R12                SET BASE TO R12                 18831000
START    B     PUTL                     ENTRY FOR JPUTL        00       18832000
         B     PUTM                               JPUTM        04       18833000
         B     GETL                               JGETL        08       18834000
         B     TRUNC                              JTRUNC       12       18835000
         B     RELSE                              JRELSE       16       18836000
         B     READ                               JREAD        20       18837000
         B     WRITE                              JWRITE       24       18838000
         B     CHECK                              JCHECK       28       18839000
         B     GETCORE                            JGETCORE     32       18840000
         B     FRECORE                            JFRECORE     36       18841000
         B     NOTE                               JNOTE        40       18842000
         B     POINT                              JPOINT       44       18843000
         SPACE 3                                                        18844000
         JENTRY (X0B01=START)                                           18845000
         SPACE 3                                                        18846000
SAVE     JSAVE BASE=NO                  SAVE REGISTERS                  18847000
         LR    R7,R13                   LOAD COMMON ADDR + FILE DISP.   18848000
         AR    R7,R10                   THIS HAS NO MEANING FOR GETCORE 18849000
         USING JFLEBLK,R7               & FRECORE                       18850000
         BR    R14                      NOW GO ON WITH BUSINESS         18851000
         SPACE 3                                                        18852000
RETURN   JRETURN                        RESTORE REGISTERS & RETURN      18853000
         SPACE 2                                                        18854000
       TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - PUT LOCATE ROUTINE' 18855000
PUTL     BAL   R14,SAVE                 GO SAVE REGISTERS               18856000
         SET   JPUTLWRT,OFF             CLEAR                           18857000
         L     R3,JBUF                  GET PHY BUF ADDRESS             18858000
         LR    R5,R3                    LOG BUF ADDR = PHY BUF ADDR +   18859000
         AH    R5,JBUFNDX                 PHY RL                        18860000
         GOIF  JPUTLPND,OFF=NOREC       FIRST PUTL OF SEQUENCE  OX02955 18861000
         LH    R4,D0(,R5)               LOAD LOGICAL RECORD LENGTH      18862000
         LA    R4,D3(,R4)               ROUND RECORD LENGTH TO          18863000
         SRA   R4,D2                      FULL                          18864000
         SLA   R4,D2                        WORD                        18865000
         BZ    NOREC                    RL ZERO, THEREFORE NO RECORD    18866000
         STH   R4,D0(,R5)               STORE ROUNDED RECORD LENGTH     18867000
         AR    R5,R4                    LOG BUF ADDR = LOG BUF ADDR+RL  18868000
         AH    R4,JBUFNDX               PHY RL = PHY RL +               18869000
         STH   R4,JBUFNDX                 LOG RL                        18870000
         LCR   R4,R4                    MAKE PHY RL NEGATIVE            18871000
         AH    R4,JRL                   SPACE AVAIL = BUF SIZE - USED   18872000
         BM    JABORT                   **TEMP** BLEW IT                18873000
         BZ    REC                      NO ROOM FOR NEXT LOGICAL RECORD 18874000
         LA    R11,D3(,R11)             ROUND REQUESTED RL TO FULL WORD 18875000
         SRA   R11,D2                   ''                              18876000
         SLA   R11,D2                   ''                              18877000
         GOIF  (R4),(R11),NOTLOW=NOREC  THERE IS ROOM FOR NEXT BUFFER   18878000
REC      MVC   D0(L'JBUFNDX,R3),JBUFNDX SET PHYSICAL RL                 18879000
         GOIF  JCHKFILE,OFF=DONTCHK1    FILE DOESN'T NEED CHECKING      18880000
         BAL   R9,CHECK                 CHECK PENDING WRITE             18881000
DONTCHK1 LA    R11,JBUF                 POINT TO PARM LIST              18882000
         BAL   R9,WRITE                 WRITE RECORD                    18883000
         SET   JPUTLWRT,ON              INDICATE WRITE                  18884000
         GOIF  JDBLBUF,OFF=DONTSWAP     FILE IS NOT DOUBLE BUFFERED     18885000
         SET   JCHKFILE,ON              INDICATE FILE NEEDS CHECKING    18886000
         XC    JBUF,JBUFFER             SWAP BUFFER ADDRESSES           18887000
         XC    JBUFFER,JBUF             ''                              18888000
         XC    JBUF,JBUFFER             ''                              18889000
         L     R3,JBUF                  GET NEW PHY BUFFER ADDRESS      18890000
         B     DONTCHK2                 BYPASS FILE CHECKING NOW        18891000
DONTSWAP BAL   R9,CHECK                 CHECK WRITE                     18892000
DONTCHK2 MVC   JBUFNDX,RESETRL          PHY RL = RESETRL                18893000
         LR    R5,R3                    LOG BUF ADDR = PHY BUF ADDR +   18894000
         AH    R5,JBUFNDX                 RESETTED RL                   18895000
NOREC    LR    R11,R5                   RETURN PTR TO LOGICAL RECORD    18896000
         XC    D0(D2,R11),D0(R11)       ZERO RECORD LENGTH              18897000
         SET   JPUTLPND,ON              PUTL NOW PENDING                18898000
         B     RETURN                   RETURN                          18899000
         SPACE 2                                                        18900000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - PUT MOVE ROUTINE' 18901000
PUTM     BAL   R14,SAVE                 GO SAVE REGISTERS               18902000
         LR    R3,R11                   SAVE R11 (FROM ADDR)            18903000
         MVC   JHWORD1,D0(R3)           REQUEST BUFFER (RL)             18904000
         LH    R11,JHWORD1              ''                              18905000
         LTR   R2,R11                   IS RL ZERO                      18906000
         BZ    JABORT                   YES, ABORT                      18907000
         BAL   R9,PUTL                  PUTL                            18908000
         LR    R4,R11                   TO ADDRESS                      18909000
         BAL   R9,MOVE                  MOVE RECORD                     18910000
         B     RETURN                   RETURN                          18911000
         SPACE 6                                                        18912000
MOVEX    MVC   D0(MAXMVC,R4),D0(R3)     MOVE 256 BYTES                  18913000
         LA    R3,MAXMVC(,R3)           BUMP FROM ADDR BY 256           18914000
         LA    R4,MAXMVC(,R4)           BUMP TO ADDR BY 256             18915000
MOVE     SH    R2,=H'256'               SUBTRACT 256 FROM LENGTH        18916000
         BP    MOVEX                    IF POSITIVE, STILL 256 BYTES    18917000
         AH    R2,=H'255'               WENT NEGATIVE, ADD 255          18918000
         EX    R2,MVCIM                 MOVE FINAL 1-256 BYTES          18919000
         BR    R9                       RETURN                          18920000
MVCIM    MVC   D0(*-*,R4),D0(R3)        EXECUTED MOVE                   18921000
         SPACE 2                                                        18922000
       TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - GET LOCATE ROUTINE' 18923000
GETL     BAL   R14,SAVE                 GO SAVE REGISTERS               18924000
         SET   JPUTLPND,OFF             TURN OFF PUTL PENDING FLAG      18925000
         L     R3,JBUF                  POINT TO PHYSICAL BUFFER        18926000
         LH    R4,JBUFNDX               PICK UP OLD BUFFER DISPLACEMENT 18927000
         GOIF  JGETLSBF,ON=NORD4GET     GET, POINT TO SAME BUF, GET     18928000
         GOIF  JGETLPND,OFF=CHKCHAIN    DO WE HAVE TO READ A NEFX0000   18929000
         AH    R4,D0(R3,R4)             CALC NEW DISPLACEMENT (TO BYPAS 18930000
         STH   R4,JBUFNDX                 OLD LOG RECORD)               18931000
         CLC   JBUFNDX,D0(R3)           END OF BUFFER                   18932000
         BL    NORD4GET                 BRANCH OF NOT END OF BUFFER     18933000
         GOIF  JMLTBUF,OFF=GO4READ                             FX0000   18934000
         L     R8,CURRBUF               ADDRESS OF MBUF IN USE FX0000   18935000
         LTR   R8,R8                                           FX0000   18936000
         BNZ   RD4GET10                 GOT ONE                FX0000   18937000
         L     R8,LOWPRIOR              GET OLDEST             FX0000   18938000
         ST    R8,CURRBUF               MAKE CURRENT           FX0000   18939000
         BAL   R9,UNCHAIN               GO READ THE RECORD     FX0000   18940000
         MVC   JBUF,BUFADR(R8)          SAVE ADDRESS OF BUFFER FX0000   18941000
         B     GO4READ                                         FX0000   18942000
                                                       SPACE , FX0000   18943000
RD4GET10 DS    0H                                              FX0000   18944000
         L     R9,FWCHAIN(R8)           ?                      FX0000   18945000
         LTR   R9,R9                                           FX0000   18946000
         BZ    RD4GET20                                        FX0000   18947000
         MVC   JLSTNOTE(4),BUFTTR(R9)                          FX0000   18948000
         ST    R9,CURRBUF                                      FX0000   18949000
         L     R9,BUFADR(R9)                                   FX0000   18950000
         ST    R9,JBUF                                         FX0000   18951000
         SET   JNOTED,ON                                       FX0000   18952000
         LR    R3,R9                                           FX0000   18953000
         B     GO4READ4                                        FX0000   18954000
                                                       SPACE , FX0000   18955000
RD4GET20 DS    0H                                              FX0000   18956000
         MVC   OLDBUF,CURRBUF                                  FX0000   18957000
         L     R9,BUFNOTE(R8)                                  FX0000   18958000
         AL    R9,=F'1'                                        FX0000   18959000
         ST    R9,JFWORD1                                      FX0000   18960000
         L     R4,JFLE                                         FX0000   18961000
         POINT (R4),JFWORD1                                    FX0000   18962000
         LH    R4,JBUFNDX                                      FX0000   18963000
         L     R8,LOWPRIOR                                     FX0000   18964000
         ST    R8,CURRBUF                                      FX0000   18965000
         BAL   R9,UNCHAIN                                      FX0000   18966000
         MVC   JBUF,BUFADR(R8)                                 FX0000   18967000
         L     R3,JBUF                                         FX0000   18968000
         CLC   CURRBUF,OLDBUF                                  FX0000   18969000
         BE    GO4READ                                         FX0000   18970000
         L     R9,OLDBUF                                       FX0000   18971000
         ST    R8,FWCHAIN(R9)                                  FX0000   18972000
         ST    R9,BWCHAIN(R8)                                  FX0000   18973000
                                                       SPACE , FX0000   18974000
GO4READ  DS    0H                                              FX0000   18975000
         LA    R11,JBUF                 ADR OF CURR BUF ADR    FX0000   18976000
         BAL   R9,READ                  CHECK RECORD           FX0000   18977000
         BAL   R9,CHECK                 CHECK RECORD           FX0000   18978000
         BAL   R9,NOTE                  NOTE RECORD             OX02955 18979000
         MVC   JLSTNOTE,JNOTEVAL        SAVE NOTE VALUE         OX02955 18980000
         SET   JNOTED,ON                INDICATE NOTED RECORD   OX00413 18981000
         GOIF  JMLTBUF,OFF=GO4READ3     PUTL PENDING ?         FX0000   18982000
         L     R9,CURRBUF               ADDRESS CURRENT BUFFER FX0000   18983000
         MVC   BUFNOTE(4,R9),JLSTNOTE   LAST RECORD NOTED      FX0000   18984000
         BAL   R9,PRTYUPDT                                     FX0000   18985000
         L     R8,BUFSTART                                     FX0000   18986000
                                                       SPACE , FX0000   18987000
GO4READ0 DS    0H                                              FX0000   18988000
         C     R8,CURRBUF                                      FX0000   18989000
         BE    GO4READ1                                        FX0000   18990000
         CLC   JLSTNOTE(4),BUFNOTE(R8)                         FX0000   18991000
         BE    GO4READ2      I658                              FX0000   18992000
                                                       SPACE , FX0000   18993000
GO4READ1 DS    0H                                              FX0000   18994000
         L     R8,FWBUFPTR(R8)                                 FX0000   18995000
         LTR   R8,R8                                           FX0000   18996000
         BZ    GO4READ3                                        FX0000   18997000
         B     GO4READ0                                        FX0000   18998000
                                                       SPACE , FX0000   18999000
GO4READ2 DS    0H                                              FX0000   19000000
         CLC   RESETRL,BUFDISPL(R8)                            FX0000   19001000
         BH    GO4READ1                                        FX0000   19002000
         XC    BUFDISPL(2,R8),BUFDISPL(R8)                     FX0000   19003000
         L     R11,FWCHAIN(R8)                                 FX0000   19004000
         LTR   R11,R11                                         FX0000   19005000
         BZ    GO4READ3                                        FX0000   19006000
         L     R9,CURRBUF                                      FX0000   19007000
         ST    R11,FWCHAIN(R9)                                 FX0000   19008000
         ST    R9,BWCHAIN(R11)                                 FX0000   19009000
         XC    FWCHAIN(4,R8),FWCHAIN(R8)                       FX0000   19010000
                                                       SPACE , FX0000   19011000
GO4READ3 DS    0H                                              FX0000   19012000
         GOIF  JGETLPNT,ON=DONTRSET    702     0202BE 91207028 FX0000   19013000
                                                       SPACE , FX0000   19014000
GO4READ4 DS    0H                                              FX0000   19015000
         LH    R4,RESETRL               NO. RESET BUFFER DISP.          19016000
         STH   R4,JBUFNDX               ''                              19017000
                                                       SPACE , FX0000   19018000
DONTRSET SET   JGETLPND,ON              SET GETL PEND FLAG ON   OX02955 19019000
         SET   JGETLPNT,OFF             SET GET AFTER POINT OFF OX02955 19020000
                                                       SPACE , FX0000   19021000
NORD4GET LA    R11,D0(R3,R4)            POINT TO BUFFER                 19022000
         SET   JGETLSBF,OFF             RESET POINT TO SAME BUFFER SW   19023000
         GOIF  JMLTBUF,OFF=NORD4GT1                            FX0000   19024000
         LH    R8,JBUFNDX                                      FX0000   19025000
         L     R9,CURRBUF                                      FX0000   19026000
         STH   R8,BUFDISPL(R9)                                 FX0000   19027000
NORD4GT1 DS    0H                                              FX0000   19028000
         B     RETURN                   RETURN                          19029000
         SPACE ,                                               FX0000   19030000
CHKCHAIN GOIF  JMLTBUF,OFF=GO4READ      GO READ THE NEXT RECORDFX0000   19031000
         L     R8,LOWPRIOR              GET ADR OF NEXT AVAIL  FX0000   19032000
         ST    R8,CURRBUF               AND MAKE IT THE CURR BUFX0000   19033000
         MVC   JBUF,BUFADR(R8)          MAKE IT THE CURRENT BUFFX0000   19034000
         L     R3,JBUF                  SET R3 TO THE WORK AREAFX0000   19035000
         BAL   R9,UNCHAIN               FIX CHAINING           FX0000   19036000
         B     GO4READ                  GO READ THE NEXT RECORDFX0000   19037000
         SPACE 2                                                        19038000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - TRUNCATION AND REX19039000
               LEASE ROUTINES'                                          19040000
TRUNC    BAL   R14,SAVE                 GO SAVE REGISTERS               19041000
         GOIF  JCHKFILE,OFF=DONTCHK3    FILE DOESN'T NEED CHECKING      19042000
         BAL   R9,CHECK                 CHECK PENDING WRITE             19043000
         SET   JCHKFILE,OFF             INDICATE FILE HAS BEEN CHECKED  19044000
DONTCHK3 SR    R11,R11                  INDICATE NO BUFFER NEEDED       19045000
         BAL   R9,PUTL                  PUT OUT RECORD BEFORE TRUNC.    19046000
         SET   JPUTLPND,OFF             TURN OFF PUTL PENDING FLAG      19047000
         L     R3,JBUF                  POINT TO PHYSICAL BUFFER        19048000
         MVC   D0(L'JBUFNDX,R3),JBUFNDX SET PHYSICAL RL                 19049000
         LA    R11,JBUF                 POINT TO PARM LIST              19050000
         GOIF  (JPUTLWRT,JCHKFILE),ALL=DONTWRT,MIX=DONTWRCK     OX00413 19051000
         BAL   R9,WRITE                 WRITE RECORD           FX0000   19052000
DONTWRT  BAL   R9,CHECK                 CHECK RECORD                    19053000
DONTWRCK MVC   JBUFNDX,RESETRL          PHY RL = RESETRL                19054000
         B     RETURN                   RETURN                          19055000
         SPACE 6                                                        19056000
RELSE    BAL   R14,SAVE                 GO SAVE REGISTERS               19057000
         SET   JGETLPND,OFF             TURN OFF SETL PENDING FLAG      19058000
         MVC   JBUFNDX,RESETRL          PHY RL=RESETRL (GET,RELSE,PUT)  19059000
         B     RETURN                   RETURN                          19060000
         SPACE 2                                                        19061000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - READ, WRITE AND CX19062000
               HECK ROUTINES'                                           19063000
         USING RDWRPARM,R11                                             19064000
READ     BAL   R14,SAVE                 GO SAVE REGISTERS               19065000
         L     R8,RDWRBUF               BUFFER ADDRESS                  19066000
         LH    R9,RDWRLEN               RECORD LENGTH                   19067000
         READ  JDECB,SF,,(R8),(R9),MF=E READ PHYSICAL RECORD            19068000
         SET   JNOTED,OFF               NEW RECORD NOT NOTED            19069000
         B     RETURN                   RETURN                          19070000
         DROP  R11                                                      19071000
         SPACE 3                                                        19072000
         USING RDWRPARM,R11                                             19073000
WRITE    BAL   R14,SAVE                 GO SAVE REGISTERS               19074000
         L     R8,RDWRBUF               BUFFER ADDRESS                  19075000
         LH    R9,RDWRLEN               RECORD LENGTH                   19076000
         WRITE JDECB,SF,,(R8),(R9),MF=E WRITE PHYSICAL RECORD           19077000
         SET   JNOTED,OFF               NEW RECORD NOT NOTED            19078000
         B     RETURN                   RETURN                          19079000
         DROP  R11                                                      19080000
         SPACE 3                                                        19081000
CHECK    BAL   R14,SAVE                 GO SAVE REGISTERS               19082000
         CHECK JDECB                    CHECK FOR COMPLETION            19083000
         B     RETURN                   RETURN                          19084000
         SPACE ,                                               FX0000   19085000
PRTYUPDT BAL   R14,SAVE                1006    0203EE 45E0C030 FX0000   19086000
         L     R2,CURRBUF              GET ADR OF CURRENT BUFR FX0000   19087000
         MVC   CURRMASK,PRIOR(R2)      SAVE CUR PRIORITY       FX0000   19088000
         L     R2,BUFSTART             ADR OF BEGIN BUF TABLE  FX0000   19089000
         SPACE ,                                               FX0000   19090000
PRTYUP10 DS    0H                                              FX0000   19091000
         LH    R3,PRIOR(R2)            GET ITS PRIORITY        FX0000   19092000
         CH    R3,CURRMASK             ARE THEY THE SAME ?     FX0000   19093000
         BE    PRTYUP20                YES, CONTINUE           FX0000   19094000
         BH    PRTYUP30                THIS IS HIGHER, FX THAT FX0000   19095000
         B     PRTYUP40                CONTINUE                FX0000   19096000
         SPACE ,                                               FX0000   19097000
PRTYUP20 DS    0H                                              FX0000   19098000
         LH    R3,HIMASK               HIGHEST PRIORITY        FX0000   19099000
         STH   R3,PRIOR(R2)            SAVE IT IN CURRENT BUF  FX0000   19100000
         B     PRTYUP50                                        FX0000   19101000
         SPACE ,                                               FX0000   19102000
PRTYUP30 DS    0H                                              FX0000   19103000
         SRL   R3,1                    CUT IN HALF             FX0000   19104000
         STH   R3,PRIOR(R2)            SAVE IT                 FX0000   19105000
         SPACE ,                                               FX0000   19106000
PRTYUP40 DS    0H                                              FX0000   19107000
         CH    R3,LOMASK               COMPARE TO LOWEST       FX0000   19108000
         BNE   PRTYUP50                NOT THE SAME            FX0000   19109000
         ST    R2,LOWPRIOR             SAVE LOWEST PRIOR BUF   FX0000   19110000
         SPACE ,                                               FX0000   19111000
PRTYUP50 DS    0H                                              FX0000   19112000
         L     R2,FWBUFPTR(R2)         GET NEXT ENTRY          FX0000   19113000
         LTR   R2,R2                   IS IT THERE ?           FX0000   19114000
         BNZ   PRTYUP10                LOOP THRU AGAIN         FX0000   19115000
         B     RETURN                                          FX0000   19116000
         SPACE ,                                               FX0000   19117000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - GETCORE AND FRECOX19118000
               RE ROUTINES'                                             19119000
GETCORE  BAL   R14,SAVE                 GO SAVE REGISTERS               19120000
         SLL   R11,D3                   CONV TO REQ MAX BYTES           19121000
         LA    R2,D8(,R11)              ALLOW 8 MORE BYTES FOR HEADER   19122000
         L     R4,JEOS                  POINT TO CURRENT END-OF-STORAGE 19123000
         LR    R3,R4                    SPACE AVAILABLE =               19124000
         S     R3,JBOS                    END - BEGINNING               19125000
         GOIF  (R3),(R2),NOTLOW=REQFILLD ENOUGH SPACE FOR MAX BYTES     19126000
         LR    R2,R3                    USE REMAINING SPACE             19127000
         LR    R11,R3                   RETURN NO. OF BYTES AVAILABLE   19128000
         SH    R11,=H'8'                  AFTER SUBTRACTING OUT HEADER  19129000
         BC    4,ABORTCOR               IS IT NEGATIVE         @OX13606 19130000
         SLL   R10,D3                   BRANCH IF BYTES AVAILABLE IS    19131000
         GOIF  (R10),(R11),HIGH=ABORTCOR  LESS THAN MINIMUM REQUEST     19132000
REQFILLD SR    R4,R2                    REDUCE EOS ADDR BY              19133000
         ST    R4,JEOS                    NUMBER OF BYTES USED          19134000
         ST    R2,D0(,R4)               STORE LENGTH IN HEADER          19135000
         LA    R10,D8(,R4)              RETURN ADDR OF CORE             19136000
         B     RETURN                   RETURN                          19137000
ABORTCOR LA    R10,ERR262               SET OUT OF CORE ERROR FLAG      19138000
         B     JABORT                   GO ABORT                        19139000
         SPACE 6                                                        19140000
FRECORE  BAL   R14,SAVE                 GO SAVE REGISTERS               19141000
         L     R4,JEOS                  INCREASE EOS BY LENGTH          19142000
         L     R5,JBOS                  CHECK IF-              @AZ10942 19143000
         A     R5,JSLEN                 OUTSIDE-               @AZ10942 19144000
         CR    R4,R5                    STORAGE-               @AZ10942 19145000
         BNL   RETURN                   KEY.                   @AZ10942 19146000
         A     R4,D0(,R4)                 OF LAST GETCORE REQ.          19147000
         ST    R4,JEOS                      AND SAVE IT                 19148000
         B     RETURN                   RETURN                          19149000
                                                       SPACE , FX0000   19150000
UNCHAIN  BAL   R14,SAVE                 GO SAVE REGS           FX0000   19151000
         L     R2,FWCHAIN(R8)           ADR OF NEXT SEQ BUFF   FX0000   19152000
         LTR   R2,R2                    IS THERE ONE ?         FX0000   19153000
         BZ    UNCHAIN1                 NO, CONTINUE           FX0000   19154000
         XC    BWCHAIN(4,R2),BWCHAIN(R2) CLR  PREV SEQ BUF ADR FX0000   19155000
         XC    FWCHAIN(4,R8),FWCHAIN(R8) CLR  NEXT SEQ BUF ADR FX0000   19156000
                                                       SPACE , FX0000   19157000
UNCHAIN1 DS    0H                                              FX0000   19158000
         L     R2,BWCHAIN(R8)           ADR OF PRIOR BUF BW PTRFX0000   19159000
         LTR   R2,R2                    IS IT EMPTY ?          FX0000   19160000
         BZ    RETURN                   THEN LEAVE             FX0000   19161000
         XC    FWCHAIN(4,R2),FWCHAIN(R2) CLR  NEXT SEQ BUF ADR FX0000   19162000
         XC    BWCHAIN(4,R8),BWCHAIN(R8) CLR  PREV SEQ BUF ADR FX0000   19163000
         B     RETURN                                          FX0000   19164000
                                                       SPACE , FX0000   19165000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - NOTE ROUTINE'     19166000
NOTE     BAL   R14,SAVE                 GO SAVE REGISTERS       OX00413 19167000
         GOIF  JCHKFILE,OFF=DONTCHK4    FILE DOESN'T NEED CHECKING      19168000
         BAL   R9,CHECK                 CHECK PENDING WRITE             19169000
         SET   JCHKFILE,OFF             INDICATE FILE HAS BEEN CHECKED  19170000
                                                       SPACE , FX0000   19171000
DONTCHK4 MVC   JNOTEVAL+D6(L'JBUFNDX),JBUFNDX SAVE BUFFER DISPLACEMENT  19172000
         GOIF  JMLTBUF,OFF=NOTBUFRD     NOT BUFFERING, SKIP    FX0000   19173000
         GOIF  JNOTED,ON=NTBEFORE       ALREADY NOTED          FX0000   19174000
                                                       SPACE , FX0000   19175000
NOTBUFRD DS    0H                                              FX0000   19176000
         L     R4,JFLE                  GET ADDR OF FILE DEFINIFX0000   19177000
         GOIF  JPUTLPND,OFF=NOPENDA     NO BUFF PEND FOR PUTL   OX02955 19178000
         GOIF  JNOTED,ON=NTBEFORE       BR IF RECORD BEEN NOTED BEFORE  19179000
         LA    R11,JBUF                 POINT TO PARM LIST      OX02955 19180000
         BAL   R9,WRITE                 WRITE RECORD            OX02955 19181000
         BAL   R9,CHECK                 CHECK                   OX02955 19182000
         SET   JNOTED,ON                INDICATED REC NOTED     OX02955 19183000
                                                       SPACE , FX0000   19184000
NOPENDA  NOTE  (R4)                     NOTE WHERE REC IS WRITE OX00413 19185000
         ST    R1,JNOTEVAL              STORE TTRZ OR NNNN      OX02955 19186000
         GOIF  JPUTLPND,OFF=RETURN      POSITION FILE, QUERY.   OX02955 19187000
         MVC   JLSTNOTE,JNOTEVAL        SAVE NOTE VALUE         OX02955 19188000
         POINT (R4),JNOTEVAL            REPOSITION FILE         OX02955 19189000
         B     RETURN                   RETURN                 FX0000   19190000
                                                       SPACE , FX0000   19191000
NTBEFORE MVC   JNOTEVAL(L'JLSTNOTE),JLSTNOTE SET LAST VALUE             19192000
         B     RETURN                   RETURN                          19193000
         SPACE 3                                                        19194000
         TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - POINT ROUTINE'    19195000
POINT    BAL   R14,SAVE                 GO SAVE REGISTERS               19196000
         SET   JGETLPND,OFF             TURN OFF GETL PENDING           19197000
         GOIF  JPUTLPND,OFF=NOPENDB     BUFFER PENDING FOR PUTL         19198000
         LR    R2,R11                   SAVE R11                        19199000
         BAL   R9,TRUNC                 TRUNC BUFFER                    19200000
         LR    R11,R2                   RESTORE R11                     19201000
                                                       SPACE , FX0000   19202000
NOPENDB  L     R4,JFLE                  GET ADDR OF FILE DEF.           19203000
         GOIF  JPT4STAR,ON=POINTS       POINTS                          19204000
         MVC   JFWORD1,D0(R11)          SAVE NOTE VALUE ON FW BOUNDRY   19205000
         GOIF  JPT4WRIT,ON=POINTW       POINT  NEXT=WRITE               19206000
         GOIF  JMLTBUF,OFF=NOPNMBUF     IF WE ARE NOT BUFFERED?FX0000   19207000
         L     R9,CURRBUF               ADDRESS OF CURRENT BUF FX0000   19208000
         LTR   R9,R9                    DO WE HAVE A BUFFER?   FX0000   19209000
         BNZ   NOPENDBF                 YES, CONTINUE          FX0000   19210000
                                                       SPACE , FX0000   19211000
NOBUFUSE DS    0H                                              FX0000   19212000
         SET   JNOTED,OFF               TURN OFF BUFF NOTE     FX0000   19213000
         B     NOPNMBUF                 GO AS IF NOT BUFFERED  FX0000   19214000
                                                       SPACE , FX0000   19215000
NOPENDBF DS     0H                                             FX0000   19216000
         GOIF  JPT4GET,OFF=POINTR1     IS THIS A GET           FX0000   19217000
         CLC   JFWORD1,BUFNOTE(R9)     IS THIS THE CURRENT TTR FX0000   19218000
         BE    NOPENOTE                                        FX0000   19219000
         L     R9,BUFSTART                                     FX0000   19220000
                                                       SPACE , FX0000   19221000
NOCHKBUF DS    0H                                              FX0000   19222000
         CLC   JFWORD1,BUFNOTE(R9)     IS THIS THE CURRENT TTR FX0000   19223000
         BNE   NOTBUFNT                NO, GET NEXT BUFFER     FX0000   19224000
         CLC   RESETRL,BUFDISPL(R9)    DISPLACEMENT IN BUFFER  FX0000   19225000
         BH    NOTBUFNT                TOO FAR INTO BUFFER     FX0000   19226000
         B     NOPENOTE                NO, USE CURRENT BUF     FX0000   19227000
                                                       SPACE , FX0000   19228000
NOTBUFNT DS    0H                                              FX0000   19229000
         L     R9,FWBUFPTR(R9)         NEXT BUFFER ADDRESS     FX0000   19230000
         LTR   R9,R9                   IS THERE ONE?           FX0000   19231000
         BZ    NOBUFUSE                NO, CONTINUE WITHOUT    FX0000   19232000
         B     NOCHKBUF                                        FX0000   19233000
                                                       SPACE , FX0000   19234000
NOPENOTE DS    0H                                              FX0000   19235000
         ST    R9,CURRBUF              SAVE AS CURRENT ADDRESS FX0000   19236000
         MVC   JLSTNOTE,BUFNOTE(R9)    SAVE TTR VALUE          FX0000   19237000
         L     R9,BUFADR(R9)           GET ADDRESS OF NEW BUF  FX0000   19238000
         ST    R9,JBUF                 MORE PLACES TO SAVE ADR FX0000   19239000
         SET   JNOTED,ON               INDICATE BUF IN USE     FX0000   19240000
         BAL   R9,PRTYUPDT                                     FX0000   19241000
                                                       SPACE , FX0000   19242000
NOPNMBUF DS    0H                                              FX0000   19243000
         GOIF  JPT4GET,OFF=POINTR1      NOT POINT  NEXT=GET             19244000
         MVC   JBUFNDX,D6(R11)          SET BUFFER DISPLACEMENT         19245000
         GOIF  JNOTED,OFF=POINTR1       RECORD NOT NOTED                19246000
         CLC   JLSTNOTE(D4),D0(R11)     POSITIONING TO DIFF PHY REC     19247000
         BNE   POINTR1                  BRANCH IF YES                   19248000
         SET   (JGETLPND,JGETLSBF),ON   SAME RECORD, GETL PENDING.      19249000
         B     POINTR2                  GO TURN OFF FLAGS               19250000
POINTR1  POINT (R4),JFWORD1             POINT FOR READ OR GET           19251000
         GOIF  JPT4GET,OFF=POINTR2      NOT POINT  NEXT=GET             19252000
         SET   JGETLPNT,ON              GETL TO FOLLOW POINT            19253000
POINTR2  SET   (JPT4READ,JPT4GET),OFF   TURN OFF POINTR FLAGS           19254000
         B     RETURN                   RETURN                          19255000
POINTW   L     R5,JFWORD1               POSITION THE FILE TO WRITE      19256000
         AL    R5,=F'1'                   A RECORD AFTER THE ONE        19257000
         ST    R5,JFWORD1                 NOTED.                        19258000
         POINT (R4),JFWORD1             POINT FOR WRITE                 19259000
         SET   JPT4WRIT,OFF             TURN OFF POINTW FLAG            19260000
         B     RETURN                   RETURN                          19261000
POINTS   CLOSE TYPE=T,MF=(E,JTCLOSE)    CLOSE TYPE=T (REWIND)           19262000
         MVC   JBUFNDX,RESETRL          RESET DISP FOR PUTL             19263000
         SET   JPT4STAR,OFF             TURN OFF POINTS FLAG            19264000
         B     RETURN                   RETURN                          19265000
         SPACE 3                                                        19266000
 TITLE '&COMPNM&ASMID - WORKFILE I/O MODULE - CONSTANTS AND PATCH AREA' 19267000
*        CONSTANTS                                                      19268000
*                                                               OX00413 19269000
RESETRL  DC    H'2'                     RESET RECORD LENGTH    FX0000   19270000
         SPACE 3                                                        19271000
         JPATCH X0B00,42A                                               19272000
         SPACE 3                                                        19273000
         END   START                                                    19274000
./ ADD NAME=IFOX0C                                                      19275000
* /* START OF SPECIFICATIONS ****                                       19276000
*02* PROCESSOR = ASSEMBLER                                              19277000
**** END OF SPECIFICATIONS ***/                                         19278000
         GBLA  &SNUMBER                 GLOBAL VARIABLE                 19279000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                19280000
         JHEAD 'ASSEMBLER COMMON LOAD MODULE - PROLOG',                X19281000
               PHASEID=X0C,                                            X19282000
               LEVEL=10                                                 19283000
*                                                                     * 19284000
*FUNCTION/OPERATION-                                                  * 19285000
*   THIS MODULE IS THE MASTER COMMON WORK AREA FOR THE ASSEMBLER.     * 19286000
*   THE MODULE IS MAPPED ACCORDING TO THE JCOMMON DSECT.  THE MODULE  * 19287000
*   IS LOADED BY THE DRIVER AND REMAINS IN CORE UNTIL THE END OF JOB. * 19288000
*   REGISTER R13 ALWAYS POINTS TO THIS MODULE.                        * 19289000
*                                                                     * 19290000
*ENTRY POINT-                                                         * 19291000
*   N/A                                                               * 19292000
*                                                                     * 19293000
*INPUT-                                                               * 19294000
*   SYSUT1, STSUT2, SYSUT3.                                           * 19295000
*                                                                     * 19296000
*OUTPUT-                                                              * 19297000
*   N/A                                                               * 19298000
*   N/A                                                               * 19299000
*                                                                     * 19300000
*EXTERNALS ROUTINES-                                                  * 19301000
*   N/A                                                               * 19302000
*                                                                     * 19303000
*EXITS, NORMAL-                                                       * 19304000
*   N/A                                                               * 19305000
*                                                                     * 19306000
*EXITS, ERROR-                                                        * 19307000
*   N/A                                                               * 19308000
*                                                                     * 19309000
*TABLE/WORK AREAS-                                                    * 19310000
*   THIS MODULE IS ONE ENTIRE WORK AREA.                              * 19311000
*                                                                     * 19312000
*ATTRIBUTES-                                                          * 19313000
*   NON-REFRESHABLE.                                                  * 19314000
*                                                                     * 19315000
*NOTES-                                                               * 19316000
         SPACE 2                                                        19317000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   19318000
         COPY  JCOMMON                  JCOMMON COPY CODE               19319000
         PRINT OFF                      DON'T PRINT JFLEBLK COPY CODE   19320000
         COPY  JFLEBLK                  JFLEBLK COPY CODE               19321000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  19322000
         COPY  JERMSGCD                 JERMSGCD COPY CODE              19323000
         PRINT ON                       THAT'S ALL THE COPY CODE        19324000
         SPACE 2                                                        19325000
         TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE'           19326000
         JCSECT (X0C00)                 SECTION START                   19327000
* VS1 RELEASE 2.5 CHANGES                                               19328000
*C336000,378000,420000                                          OX00413 19329000
* VS1 RELEASE 3.1 CHANGES                                               19330000
*C336000,378000,420000                                          OX02955 19331000
*A432000                                                       @AZ07378 19332000
         JMODID                         EMBEDDED IDENTIFIER             19333000
         USING START,R13                ESTABLISH BASE                  19334000
START    DS    0D                       R13 POINTS HERE                 19335000
         JENTRY (X0C01=START)           SECTION ENTRY                   19336000
         ORG   START+JFLEBLK1-JCOMMON+JDECB-JFLEBLK FILE 1 DECB         19337000
         WRITE JDECB1,SF,IJSYS01,MF=L   WRITE DECB FOR SYSUT1           19338000
         ORG   START+JFLEBLK1-JCOMMON+JTCLOSE-JFLEBLK TCLOSE PARM LIST  19339000
         CLOSE (IJSYS01,REREAD),TYPE=T,MF=L    TCLOSE FOR SYSUT1        19340000
         JGEN  JFLEBLK1+JFLE-JFLEBLK,A,IJSYS01    DCB POINTER           19341000
         JGEN  JFLEBLK1+JBUFNDX-JFLEBLK,H,2       BUFR DISPLACE OX02955 19342000
         JGEN  JFLEBLK1+JIOFLAG-JFLEBLK,X,00      FILE REQUEST FLAG     19343000
         ORG   START+JFLEBLK2-JCOMMON+JDECB-JFLEBLK FILE 2 DECB         19344000
         WRITE JDECB2,SF,IJSYS02,MF=L   WRITE DECB FOR SYSUT2           19345000
         ORG   START+JFLEBLK2-JCOMMON+JTCLOSE-JFLEBLK TCLOSE PARM LIST  19346000
         CLOSE (IJSYS02,REREAD),TYPE=T,MF=L    TCLOSE FOR SYSUT2        19347000
         JGEN  JFLEBLK2+JFLE-JFLEBLK,A,IJSYS02    DCB POINTER           19348000
         JGEN  JFLEBLK2+JBUFNDX-JFLEBLK,H,2       BUFR DISPLACE OX02955 19349000
         JGEN  JFLEBLK2+JIOFLAG-JFLEBLK,X,00      FILE REQUEST FLAG     19350000
         ORG   START+JFLEBLK3-JCOMMON+JDECB-JFLEBLK FILE 3 DECB         19351000
         WRITE JDECB3,SF,IJSYS03,MF=L          WRITE DECB FOR SYSUT3    19352000
         ORG   START+JFLEBLK3-JCOMMON+JTCLOSE-JFLEBLK TCLOSE PARM LIST  19353000
         CLOSE (IJSYS03,REREAD),TYPE=T,MF=L    TCLOSE FOR SYSUT3        19354000
         JGEN  JFLEBLK3+JFLE-JFLEBLK,A,IJSYS03    DCB POINTER           19355000
         JGEN  JFLEBLK3+JBUFNDX-JFLEBLK,H,2       BUFR DISPLACE OX02955 19356000
         JGEN  JFLEBLK3+JIOFLAG-JFLEBLK,X,00      FILE REQUEST FLAG     19357000
         JGEN  JMAXRL,H,32767           MAX RL FOR FILES       FX0000   19358000
         JGEN  JADINCM,A,0              ZERO INPUT COMMON ADDRESS       19359000
         JGEN  JADOUTCM,A,0             ZERO OUTPUT COMMON ADDRESS      19360000
         ORG   START+JLVTMDT-JCOMMON    BLANK LEVEL TIME DATE           19361000
         JGENIN ' ASM 0000 00.00 00/00/00'   LEVEL TIME AND DATE        19362000
         ORG   START+JIDR-JCOMMON                                       19363000
         JGENIN '15741SC103 000000000                   '               19364000
         JGEN  JDECKIDL,X,00            ZERO DECK ID LENGTH             19365000
         ORG   START+JDECKID-JCOMMON    BLANK DECK ID                   19366000
         JGENIN ' ',8                   ''                              19367000
         JGEN  JMSGL,X,00               ZERO MESSAGE LEVEL              19368000
         JGEN  JSYSPARM,A,0             ZERO SYSPARM POINTER            19369000
         JGEN  JPARMPTR,A,0             ZERO PARM ADDR                  19370000
         JGEN  JPARM,A,0                ZERO PARM BYTES                 19371000
         ORG   START+JPREFIX-JCOMMON    INTERNAL COMPONENT NAME         19372000
         JGENIN &COMPNM                 COMPONENT ID                    19373000
         JGEN  JWARNFLG,X,00            ZERO WARNING FLAG               19374000
         JGEN  JRECCHK,X,00             ZERO POST PROCESSOR FLAG        19375000
         JGEN  JINDERRF,X,00            ZERO ERROR FLAGS                19376000
         JGEN  JINFLAG,X,00             ZERO INFLAG                     19377000
         JGEN  JOUTFLAG,X,00            ZERO OUTFLAG                    19378000
         JGEN  JMLCFLAG,X,00            ZERO MLCFLAG                    19379000
         JGEN  JRECIN,F,0               ZERO RECORDS IN COUNT           19380000
         JGEN  JRECLIB,F,0              ZERO RECORDS IN FROM LIB CNT.   19381000
         JGEN  JRECPCH,F,0              ZERO RECORDS PUNCHED            19382000
         JGEN  JRECPRT,F,0              ZERO RECORDS PRINTED            19383000
         JGEN  JSLEN,F,0                ZERO STORAGE LENGTH             19384000
         JGEN  JCLVLPTR,A,(SAVETBL-JSAVESZ,0-JSAVESZ) INIT SAVE AREA PT 19385000
         ORG   START+JSAVETBL-JCOMMON   ZERO SAVE TABLE                 19386000
SAVETBL  DC    (JSAVESZ*JSAVELVL/4)A(0) PUSH-POP SAVE AREA              19387000
         ORG   START+JABORT-JCOMMON     ABORT ERROR                     19388000
         B     ABORT                    GO TO ABORT                     19389000
AABORT   JGEN  JAABORT,A,0              ADDR OF ABORT ROUTINE IN DRIVER 19390000
         JGEN  JSYSOPEN,A,SYSOPEN       ADDR OF OPEN PARM LIST          19391000
         JGEN  JSYSCLOS,A,SYSCLOS       ADDR OF CLOSE PARM LIST         19392000
         JGEN  LOMASK,H,1               LOWEST PRIORITY        FX0000   19393000
         JGEN  NRMBUF,H,1               NUMBER OF MBUFFS       FX0000   19394000
         JGEN  JSRCLN,F,70              DATA PORTION MOVE LENGTH  (1-7) 19395000
         JGEN  JBEGCL,F,0               BEGIN COLUMN MINUS 1      (2-7) 19396000
         JGEN  JCTCHR,F,71              CONT CHR COLUMN MINUS 1   (3-7) 19397000
         JGEN  JSEQCL,F,72              SEQ FLD BEGIN COL MINUS 1 (4-7) 19398000
         JGEN  JSEQLN,F,7               SEQ FLD MOVE LENGTH       (5-7) 19399000
         JGEN  JCTBGN,F,15              CONT COLUMN MINUS 1       (6-7) 19400000
         JGEN  JCTLN,F,55               CONT FLD MOVE LENGTH      (7-7) 19401000
         JGEN  JINFILE,Y,FILE3          INPUT FILE FOR X3               19402000
         JGEN  JOUTFILE,Y,FILE1         OUTPUT FILE FOR X3              19403000
         JGEN  JPAGENO,H,0              ZERO PAGE NUMBER                19404000
         JGEN  JPRTONLY,X,0000000000    CLEAR JPRTONLY,JSYSGEN,JLTLNG   19405000
         ORG   START+JTRTABLE-JCOMMON   TRANSLATE TABLE                 19406000
         DC    X'F0F1F2F3F4F5F6F7F8F9C1C2C3C4C5C6'     CARD 01 OF 16    19407000
         DC    X'C7C8C9D1D2D3D4D5D6D7D8D9E2E3E4E5'     CARD 02 OF 16    19408000
         DC    X'E6E7E8E95B7B7C7E4D4E605C615D6B40'     CARD 03 OF 16    19409000
         DC    X'7D504B333435363738393A3B3C3D3E3F'     CARD 04 OF 16    19410000
         DC    X'2F4142434445464748494A324C28294F'     CARD 05 OF 16    19411000
         DC    X'315152535455565758595A242B2D5E5F'     CARD 06 OF 16    19412000
         DC    X'2A2C62636465666768696A2E6C6D6E6F'     CARD 07 OF 16    19413000
         DC    X'707172737475767778797A252630277F'     CARD 08 OF 16    19414000
         DC    X'808182838485868788898A8B8C8D8E8F'     CARD 09 OF 16    19415000
         DC    X'909192939495969798999A9B9C9D9E9F'     CARD 10 OF 16    19416000
         DC    X'A0A1A2A3A4A5A6A7A8A9AAABACADAEAF'     CARD 11 OF 16    19417000
         DC    X'B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF'     CARD 12 OF 16    19418000
         DC    X'C00A0B0C0D0E0F101112CACBCCCDCECF'     CARD 13 OF 16    19419000
         DC    X'D0131415161718191A1BDADBDCDDDEDF'     CARD 14 OF 16    19420000
         DC    X'E0E11C1D1E1F20212223EAEBECEDEEEF'     CARD 15 OF 16    19421000
         DC    X'00010203040506070809FAFBFCFDFEFF'     CARD 16 OF 16    19422000
         ORG   START+JCOMEND-JCOMMON    END OF COMMON                   19423000
         SPACE 5                                                        19424000
         TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE - UTILITY X19425000
               FILE OPEN AND CLOSE LISTS'                               19426000
SYSOPEN  OPEN  (IJSYS01,(OUTIN,REREAD),IJSYS02,(OUTIN,REREAD),IJSYS03,(X19427000
               OUTIN,REREAD)),MF=L      OPEN PARM LIST                  19428000
         SPACE 3                                                        19429000
SYSCLOS  CLOSE (IJSYS01,,IJSYS02,,IJSYS03,),MF=L CLOSE PARM LIST        19430000
         SPACE 3                                                        19431000
ABORTSYN LA    R10,ERR261               SYNAD EXIT (I/O ERROR) ABORT    19432000
         LR    R11,R0                   SAVE R0 FOR ABORT ROUTINE       19433000
         SPACE 1                                                        19434000
ABORT    L     R12,AABORT               GET ADDR OF ABORT ROUTINE       19435000
         BR    R12                      GO TO IT                        19436000
         SPACE 3                                                        19437000
     TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE - SYSUT1 DCB'  19438000
IJSYS01  DCB   DDNAME=SYSUT1,MACRF=(RP,WP),RECFM=U,DSORG=PS,           X19439000
               SYNAD=ABORTSYN,DEVD=DA,NCP=1                             19440000
         SPACE 5                                                        19441000
     TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE - SYSUT2 DCB'  19442000
IJSYS02  DCB   DDNAME=SYSUT2,MACRF=(RP,WP),RECFM=U,DSORG=PS,           X19443000
               SYNAD=ABORTSYN,DEVD=DA,NCP=1                             19444000
         SPACE 5                                                        19445000
     TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE - SYSUT3 DCB'  19446000
IJSYS03  DCB   DDNAME=SYSUT3,MACRF=(RP,WP),RECFM=U,DSORG=PS,           X19447000
               SYNAD=ABORTSYN,DEVD=DA,NCP=1                             19448000
         SPACE 5                                                        19449000
      TITLE '&COMPNM&ASMID - ASSEMBLER COMMON LOAD MODULE - PATCH AREA' 19450000
         JPATCH X0C00,630               5% PATCH AREA                   19451000
         SPACE 3                                                        19452000
         END   START                                                    19453000
./ ADD NAME=IFOX0D                                                      19454000
* /* START OF SPECIFICATIONS ****                                       19455000
*02* PROCESSOR = ASSEMBLER                                              19456000
**** END OF SPECIFICATIONS ***/                                         19457000
         SPACE 3                                                        19458000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                19459000
         JHEAD 'ASSEMBLER INITILIZATION - PROLOG',                     X19460000
               PHASEID=X0D,                                            X19461000
               LEVEL=10                                                 19462000
*                                                                     * 19463000
*FUNCTION/OPERATION-                                                  * 19464000
*   THIS MODULE INITIALIZES THE ASSEMBLER.  IT FORMATS THE TIME,      * 19465000
*   DATE AND ASSEMBLER LEVEL, CHECKS FOR VALID PARAMETERS, CHECKS TO  * 19466000
*   SEE THAT ALL NECESSARY DD CARDS ARE PRESENT, AND SETS THE MAXIMUM * 19467000
*   WORKFILE RECORD SIZE.                                             * 19468000
*                                                                     * 19469000
*ENTRY POINT-                                                         * 19470000
*        START - ENTERED BY LOAD AND BRANCH FROM DRIVER.              * 19471000
*                                                                     * 19472000
*INPUT-                                                               * 19473000
*   N/A                                                               * 19474000
*                                                                     * 19475000
*OUTPUT-                                                              * 19476000
*   N/A                                                               * 19477000
*                                                                     * 19478000
*EXTERNAL ROUTINES-                                                   * 19479000
*   N/A                                                               * 19480000
*                                                                     * 19481000
*EXITS, NORMAL-                                                       * 19482000
*   RETURN TO DRIVER BY JRETURN MACRO.                                * 19483000
*                                                                     * 19484000
*EXITS, ERROR-                                                        * 19485000
*   BRANCH TO JABORT IN COMMON.                                       * 19486000
*                                                                     * 19487000
*TABLE/WORK AREAS-                                                    * 19488000
*   REGISTER R13 POINTS TO COMMON.                                    * 19489000
*                                                                     * 19490000
*ATTRIBUTES-                                                          * 19491000
*   REFRESHABLE.                                                      * 19492000
*                                                                     * 19493000
*NOTES-                                                               * 19494000
         SPACE 3                                                        19495000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   19496000
         COPY  JCOMMON                  JCOMMON COPY CODE               19497000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  19498000
         COPY  JERMSGCD                 JERMSGCD COPY CODE              19499000
         PRINT ON                       THAT'S ALL WE DON'T WANT        19500000
         SPACE 2                                                        19501000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - FILE BLOCK DSE19502000
               ECT (JFLEBLK)'                                           19503000
         COPY  JFLEBLK                  JFLEBLK COPY CODE               19504000
         SPACE 2                                                        19505000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - DCBD MACRO '  19506000
         DCBD  DSORG=(PS),DEVD=(DA)     DCBD MACRO                      19507000
         SPACE 7                                                        19508000
LVTMDT   DSECT                          , LEVEL TIME AND DATE DSECT     19509000
         DS    CL5                     ' ASM '                          19510000
LV       DS    CL4                      NNNN VERSION LEVEL              19511000
         DS    C                        ' '                             19512000
TM       DS    CL5                      HH.MM          TIME             19513000
         DS    C                        ' '                             19514000
DT       DS    CL8                      MM/DD/YY       DATE             19515000
IDR      DSECT                                                          19516000
         DS    CL11                                                     19517000
VLML     DS    CL2                     VERSION AND MOD. LEVEL           19518000
         DS    CL2                                                      19519000
YEARADAY DS    CL5                     YEAR AND DAY OF YEA9             19520000
SECIDR   DS    CL19                    SECOND IDR                       19521000
         SPACE 6                                                        19522000
P        DSECT                          DDNAME OVERRIDE LIST            19523000
PLEN     DS    H                        LENGTH OF LIST                  19524000
         DS    3CL8                     (NOT APPLICABLE)                19525000
PSYSLIB  DS    CL8                      SYSLIB DDNAME                   19526000
PSYSIN   DS    CL8                      SYSIN DDNAME                    19527000
PSYSPRIN DS    CL8                      SYSPRINT DDNAME                 19528000
PSYSPUNC DS    CL8                      SYSPUNCH DDNAME                 19529000
PSYSUT1  DS    CL8                      SYSUT1 DDNAME                   19530000
PSYSUT2  DS    CL8                      SYSUT2 DDNAME                   19531000
PSYSUT3  DS    CL8                      SYSUT3 DDNAME                   19532000
PSYSGO   DS    CL8                      SYSGO DDNAME                    19533000
PSYSTERM DS    CL8                      SYSTERM DDNAME                  19534000
         SPACE 2                                                        19535000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION '               19536000
* VS1 RELEASE 3.1 CHANGES                                               19537000
*C273350,278000,290000,301000,312000,324000,339000,354000      @OY02543 19538000
*A504500-504800                                                @OX09734 19539000
         JCSECT (X0D00)                 SECTION NAME                    19540000
         JMODID                                                         19541000
START    JSAVE BASE=YES                 SAVE REGISTERS                  19542000
         JENTRY (X0D01=START)           SECTION ENTRY POINT             19543000
         SPACE 2                                                        19544000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - FORMAT HEADING19545000
               G IDENTIFIER (LEVEL, TIME, DATE)'                        19546000
         LA    R5,JLVTMDT               SET BASE FOR HEADING            19547000
         USING LVTMDT,R5                ''                              19548000
         LA    R2,JIDR                                                  19549000
         USING IDR,R2                                                   19550000
         LH    R14,D0(,R10)             PICK UP MASTER ROOT SEG LEVEL   19551000
         CVD   R14,JDWORD               0000000000000NNC                19552000
         UNPK  JDWORD(D2),JDWORD+D6(D2) FNCN                            19553000
         MVN   LV(D2),JDWORD            0N0N                            19554000
         MVI   VLML,X'00'                                               19555000
         MVC   VLML+D1(D1),LV                                           19556000
         MVI   VLML+D2,X'00'                                            19557000
         MVC   VLML+D3(D1),LV+D1                                        19558000
         MVC   LV,VLML                                                  19559000
         SPACE 2                                                        19560000
         TIME  DEC                      GET THE TIME                    19561000
         ST    R0,JFWORD1               HHMMSSTH                        19562000
         UNPK  JDWORD(D5),JFWORD1(D3)   FHFHFMFMSS                      19563000
         MVN   TM(D2),JDWORD            0H0H                            19564000
         MVN   TM+D3(D2),JDWORD+D2      0M0M                            19565000
         SPACE 2                                                        19566000
         ST    R1,JFWORD1               00YYDDDC                        19567000
         UNPK  JDWORD(D3),JFWORD1+D1(D2) FYFYDD                         19568000
         MVN   DT+D6(D2),JDWORD         0Y0Y                            19569000
         MVN   YEARADAY(D2),JDWORD                                      19570000
         UNPK  JDWORD(D3),JFWORD1+D2(D2)                                19571000
         MVN   YEARADAY+D2(D3),JDWORD                                   19572000
         SR    R2,R2                    ZERO                            19573000
         XC    JDWORD,JDWORD            ZERO WORK AREA                  19574000
         STH   R1,JDWORD+D6             PUT IN DDDC                     19575000
         CVB   R1,JDWORD                CONVERT TO BINARY               19576000
         CH    R1,=H'59'                IS IT BEFORE FEB 29             19577000
         BNH   TIMC                     YES, DON'T CHECK FOR LEAP YEAR  19578000
         TM    JFWORD1+D1,D1            IS IT AN ODD YEAR               19579000
         BO    TIMB                     YES, SET AS NOT LEAP YEAR       19580000
         TM    JFWORD1+D1,D18           IS IT LEAP YEAR                 19581000
         BNM   TIMC                     NOT MIXED IS A LEAP YEAR        19582000
TIMB     LA    R1,D1(,R1)               SET AS NOT LEAP YEAR            19583000
TIMC     LA    R14,D1                   SET FOR FIRST MONTH             19584000
TIMD     IC    R2,CALEN-R1(R14)         GET DAYS PER MONTH              19585000
         SR    R1,R2                    REDUCE DAYS BY THIS MONTH       19586000
         BNP   TIME                     IN THIS MONTH, BRANCH           19587000
         LA    R14,D1(,R14)             UP TO NEXT MONTH                19588000
         B     TIMD                       AND TRY AGAIN                 19589000
TIME     AR    R1,R2                    ADD BACK THIS MONTH             19590000
         STC   R14,DT+D1                PUT IN MONTH                    19591000
         SH    R14,=H'10'               IS IT OCT, NOV OR DEC           19592000
         BM    TIMF                     NO, CONTINUE                    19593000
         MVI   DT,J1                    YES, PUT IN                     19594000
         STC   R14,DT+D1                  CORRECT MONTH                 19595000
TIMF     CVD   R1,JDWORD                CONVERT DAY TO PACKED           19596000
         UNPK  JDWORD(D2),JDWORD+D6(D2) UNPACK THE DAY                  19597000
         MVN   DT+D3(D2),JDWORD         MOVE IN DAY                     19598000
         DROP  R5                       DROP HEADING BASE               19599000
         SPACE                                                          19600000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - PROCESS PARAME19601000
               ETER OPTIONS'                                            19602000
*        SET DEFAULT OPTIONS                                            19603000
*                                                                       19604000
         JEXTRN  (X0J00=X0J00)          EXTERNAL ENTRY POINT            19605000
         L     R3,=A(X0J00)             POINT TO DEFAULT PARMS          19606000
         MVC   JPARMS,D1(R3)            MOVE UM                         19607000
         MVC   JPARM,D4(R3)                  IN                         19608000
         MVI   JPDFLAG,D0               ZERO OUT DUMP FLAG     FX0000   19609000
         MVC   JWRKSIZE,D16(R3)                                FX0000   19610000
         MVC   CORESIZE,D16(R3)                                FX0000   19611000
         SPACE 3                                                        19612000
*        PROCESS OPTION PARAMETERS                                      19613000
*                                                                       19614000
         L     R2,D0(,R11)              POINT TO DATA AREA              19615000
         LH    R6,D0(,R2)               GET LENGTH OF INFO FIELD        19616000
         LTR   R6,R6                    IS IT ZERO                      19617000
         BZ    SCAN999                  YES.  NO PARM INFORMATION       19618000
         LA    R0,D2(,R6)               REQUEST SPACE FOR TOTAL PARM    19619000
         LR    R4,R0                    SAVE REQUESTED LENGTH           19620000
         GETMAIN R,LV=(0)               GET CORE                        19621000
         STH   R4,D0(,R1)               SAVE REQUESTED LENGTH           19622000
         ST    R1,JPARMPTR              SAVE ADDR OF TRANS PARM AREA    19623000
         LA    R5,D2(,R1)               POINT TO TRANSLATED FIELD       19624000
MOVLOP   SH    R6,=H'256'               SEE IF ONE MOVE WILL DO IT      19625000
         BP    MOVLOP1                  BRANCH IF NOT                   19626000
         AH    R6,=H'255'               GET REMAINING MOVE LENGTH       19627000
         EX    R6,MVCPARM               MOVE PARM INFO INTO OUR CORE    19628000
         EX    R6,TRPARM                TRANSLATE INFO TO INTERNAL      19629000
         LA    R5,D2(,R1)               POINT TO TRANSLATED FIELD       19630000
         L     R2,D0(,R11)              POINT TO DATA AREA              19631000
         LH    R6,D0(,R2)               GET LENGTH OF INFO FIELD        19632000
         BCTR  R6,R0                    GET MACHINE LENGTH              19633000
         B     SCAN                     GO SCAN                         19634000
MOVLOP1  MVC   D0(256,R5),D2(R2)        MOVE 256 BYTES                  19635000
         TR    D0(256,R5),JTRTABLE      TRANSLATE 256 BYTES             19636000
         LA    R5,256(,R5)              UPDATE POINTER                  19637000
         LA    R2,256(,R2)              UPDATE POINTER                  19638000
         B     MOVLOP                   MOVE AND TRANSLATE MORE         19639000
         SPACE 3                                                        19640000
*        AT THIS POINT, REGISTER R6 = PARM INFO FIELD LENGTH (MACHINE)  19641000
*                       REGISTER R5 = ADDR OF TRANSLATED INFO FIELD     19642000
*                       JPARMPTR = ADDR OF ACQUIRED CORE.  FORMAT IS AS 19643000
*                                  FOLLOWS  LLIII...III  WHERE          19644000
*                                  LL = LENGTH OF ACQUIRED CORE.        19645000
*                                  I  = TRANSLATED PARM INFO FIELD.     19646000
*                                  (JPARMPTR WILL BE SET TO ZERO WHEN   19647000
*                                  THE ACQUIRED CORE IS FREED BECAUSE   19648000
*                                  NO SYSPARM IS PRESENT OR BECAUSE     19649000
*                                  THE OVERRIDING SYSPARM IS SHORTER    19650000
*                                  THAN THE SYSGENED SYSPARM).          19651000
SCAN     SR    R2,R2                    ZERO FOR TRT                    19652000
SCAN10   CH    R6,=H'256'               TEST IF ONE TRT IS ENOUGH       19653000
         BL    SCAN15                   BRANCH IF YES                   19654000
         TRT   D0(256,R5),TRTTABLE      STOP ON , = ( BLANK             19655000
         BNZ   SCAN20                   BRANCH IF DELIMITER             19656000
         SH    R6,=H'256'               GET REMAINING LENGTH            19657000
         AH    R5,=H'256'               UPDATE POINTER                  19658000
         SET   JINVOPT,ON               INDICATE ERROR                  19659000
         B     SCAN10                   CONTINUE SCAN                   19660000
SCAN15   EX    R6,TRTPARM               STOP ON , = ( BLANK             19661000
         BNZ   SCAN20                   BRANCH IF NOT END OF FIELD      19662000
         LA    R1,D1(R5,R6)             DUMMY UP TRT OUTPUT TO SIMULATE 19663000
         LA    R2,JCOMMA                  STOPPING ON , AFTER FIELD     19664000
SCAN20   LR    R14,R1                   CALCULATE LENGTH OF CHAR STRING 19665000
         SR    R14,R5                   ''                              19666000
         SR    R6,R14                   REDUCE REMAINING LENGTH         19667000
         CH    R14,=H'10'               GREATER THAN 10 CHARACTERS      19668000
         BH    SCAN110                  ERROR.                          19669000
         LTR   R14,R14                  NULL STRING (ZERO LENGTH)       19670000
         BNP   SCAN110                  ERROR.                          19671000
         BCTR  R14,R0                   GET MACHINE LEN OF CHAR STRING  19672000
         LA    R15,PARMTAB              GET ADDR OF OPTION TABLE        19673000
         MVC   COMPAREA,BLANKS          BLANK COMAPRE AREA              19674000
         EX    R14,MVCDWORD             MOVE OPTION TO BLANK AREA       19675000
SCAN30   CLC   COMPAREA,D0(R15)         IS IT THIS OPTION               19676000
         BE    SCAN40                   YES.                            19677000
         LA    R15,PARMLEN(,R15)        BUMP OPTION TABLE ADDR          19678000
         C     R15,=A(PARMEND)          END OF TABLE                    19679000
         BL    SCAN30                   BRANCH IF NOT AT END OF TABLE   19680000
         B     SCAN110                  ERROR.  OPTION NOT FOUND        19681000
SCAN40   EX    R0,D10(,R15)             EXEC INST TO SET OPTION        *19682000
                                          CHK PARM TBL.  SOME DONT RTN. 19683000
         CH    R2,=Y(JCOMMA)            IS OPTION DELIMITED BY COMMA    19684000
         BE    SCAN50                   DON'T SET FLAG IF OK            19685000
SCAN110  SET   JINVOPT,ON                                               19686000
SCAN50   LA    R5,D1(,R1)               BUMP PART DELIMITER             19687000
         BCTR  R6,R0                    REDUCE LENGTH BY ONE            19688000
         LTR   R6,R6                    CHECK LENGTH                    19689000
         BNM   SCAN10                   IF NOT MINUS, LOOK FOR NEXT OPT 19690000
         TM    JSYSPARM,BIT0            WAS THERE A SYSPARM (HI-ORDER)  19691000
         BO    SCAN70                   BR IF SYSPARM                   19692000
         L     R1,JPARMPTR              FREE TRANSLATED PARM AREA       19693000
         LH    R0,D0(,R1)               GET LENGTH OF AREA              19694000
         FREEMAIN R,LV=(0),A=(1)        FREE CORE                       19695000
         XC    JPARMPTR,JPARMPTR        SET PTR TO ZERO (FOR DRIVER)    19696000
SCAN70   L     R2,JPARM                 GET POINTER                     19697000
         O     R2,D8(,R3)               COMPUTE AND                     19698000
         N     R2,D12(,R3)              STRIP OFF BITS                  19699000
         CL    R2,JPARM                 END OF JPARM                    19700000
         ST    R2,JPARM                 SAVE POINTER                    19701000
         BE    SCAN999                  GO TO SCAN IF END               19702000
         SET   JINVOPT,ON               INDICATE INVALID OPTION         19703000
         B     SCAN999                  START SCANNING                  19704000
         SPACE 3                                                        19705000
SCAN80   SR    R15,R15                  CONVERT NUMBER                  19706000
SCAN90   LA    R1,D1(,R1)               DUMP PTR                        19707000
         BCTR  R6,R0                    DECREMENT LENGTH BY ONE         19708000
         LTR   R6,R6                    ANY FIELD LEFT                  19709000
         BMR   R9                       BRANCH IF END OF FIELD          19710000
         CLI   D0(R1),JNUMMAX           IS THIS CHAR A NUMBER           19711000
         BHR   R9                       RETURN IF NOT A NUMBER          19712000
         M     R14,=F'10'               MULTIPLY ACCUMULATED NUFX0000   19713000
         IC    R2,D0(,R1)                 BY 10 AND ADD IN UNITS        19714000
         AR    R15,R2                     POSITION                      19715000
         B     SCAN90                   TRY NEXT CHARACTER              19716000
         SPACE 3                                                        19717000
SCAN200  CH    R2,=Y(JLPARN)            IS DELIMITER LEFT PAREN         19718000
         BNE   SCAN110                  ERROR IF NOT                    19719000
         BAL   R9,SCAN80                CONVERT NUMBER                  19720000
         CLI   D0(R1),JRPARN            FOLLOWED BY RIGHT PAREN         19721000
         BNE   SCAN110                  ERROR IF NOT                    19722000
         LA    R1,D1(,R1)               BUMP POINTER                    19723000
         BCTR  R6,R0                    DECREMENT LENGTH                19724000
         LTR   R6,R6                    ANY FIELD LEFT                  19725000
         BM    SCAN230                  BRANCH IF END OP FIELD          19726000
         B     SCAN220                  CONTINUE CHECKING               19727000
SCAN210  CH    R2,=Y(JEQUAL)            TEST IF =                       19728000
         BNE   SCAN110                  BRANCH IF NOT =                 19729000
         BAL   R9,SCAN80                CONVERT NUMBER                  19730000
         LTR   R6,R6                    CHECK IF END OF FIELD           19731000
         BM    SCAN230                  BRANCH IF SO                    19732000
SCAN220  CLI   D0(R1),JCOMMA            FOLLOWED BY COMMA               19733000
         BNE   SCAN110                  ERROR IF NOT                    19734000
SCAN230  CH    R15,=H'255'              MORE THAN 255                   19735000
         BH    SCAN110                  YES.  LOG ERROR                 19736000
         GOIF  JMSGLKEY,ON=SCAN110                                      19737000
         STC   R15,JMSGL                SAVE IN MSGL                    19738000
         B     SCAN50                   GO SCAN FOR MORE OPTIONS        19739000
         SPACE 3                                                        19740000
SCAN300  CH    R2,=Y(JLPARN)            IS DELIMITER LEFT PAREN         19741000
         BNE   SCAN110                  ERROR IF NOT                    19742000
         BAL   R9,SCAN80                CONVERT NUMBER                  19743000
         CLI   D0(R1),JRPARN            FOLLOWED BY RIGHT PAREN         19744000
         BNE   SCAN110                  ERROR IF NOT                    19745000
         LA    R1,D1(,R1)               BUMP POINTER                    19746000
         BCTR  R6,R0                    DECREMENT LENGTH                19747000
         LTR   R6,R6                    ANY FIELD LEFT                  19748000
         BM    SCAN330                  BRANCH IF END OF FIELD          19749000
         B     SCAN320                  CONTINUE CHECKING               19750000
SCAN310  CH    R2,=Y(JEQUAL)            TEST IF =                       19751000
         BNE   SCAN110                  BRANCH IF NOT =                 19752000
         BAL   R9,SCAN80                CONVERT NUMBER                  19753000
         LTR   R6,R6                    CHECK IF END OF FIELD           19754000
         BM    SCAN330                  BRANCH IF SO                    19755000
SCAN320  CLI   D0(R1),JCOMMA            FOLLOWED BY COMMA               19756000
         BNE   SCAN110                  ERROR IF NOT                    19757000
SCAN330  CH    R15,=H'999'              MORE THAN 999          FX0000   19758000
         BH    SCAN110                  YES. LOG ERROR                  19759000
         GOIF  JLNCTKEY,ON=SCAN110                                      19760000
         STH   R15,JLNCT                SAVE LINECNT OF BODY OF LISTING 19761000
         B     SCAN50                   GO SCAN FOR MORE OPTIONS        19762000
         SPACE 3                                                        19763000
SCAN400  LA    R1,D1(,R1)               BUMP POINTER                    19764000
         BCTR  R6,R0                    DECREMENT LENGTH                19765000
         LTR   R6,R6                    END OF PARAM                    19766000
         BM    SCAN110                  ERROR IF NO RIGHT PAREN         19767000
         CLI   D0(R1),JLPARN            CHARACTER IS LEFT PAREN         19768000
         BE    SCAN405                  BRANCH IF SO                    19769000
         CLI   D0(R1),JRPARN            CHARACTER IS RIGHT PAREN        19770000
         BNE   SCAN400                  CONTINUE TO SCAN IF NOT         19771000
         BCTR  R14,R0                   DECREASE PAREN COUNT            19772000
         LTR   R14,R14                  TEST PAREN COUNT                19773000
         BNM   SCAN400                  CONTINUE TO SCAN IF MORE        19774000
         LR    R14,R1                   POINTER TO END OF SYSPARM       19775000
         LA    R1,D1(,R1)               BUMP POINTER                    19776000
         BCTR  R6,R0                    DECREMENT COUNT                 19777000
         LTR   R6,R6                    TEST IF END OF PARAM            19778000
         BM    SCAN465                  BRANCH IF END                   19779000
         CLI   D0(R1),JCOMMA            TEST NEXT CHARACTER             19780000
         BE    SCAN465                  HANDLE SYSPARM IF COMMA         19781000
         B     SCAN110                  ERROR IF NOT                    19782000
SCAN405  LA    R14,D1(,R14)             INCREASE PAREN COUNT            19783000
         B     SCAN400                  CONTINUE TO SCAN                19784000
SCAN410  SR    R14,R14                  ZERO PAREN COUNT                19785000
         LR    R15,R1                   SAVE STARTING POSITION          19786000
         CH    R2,=Y(JLPARN)            OPTION DELIMITED BY LEFT PAREN  19787000
         BE    SCAN400                  HANDLE SYSPARM(STRING) IF (     19788000
         CH    R2,=Y(JEQUAL)            TEST IF =                       19789000
         BNE   SCAN110                  ERROR IF NOT                    19790000
SCAN420  LA    R1,D1(,R1)               BUMP POINTER                    19791000
         BCTR  R6,R0                    DECREMENT LENGTH                19792000
         LTR   R6,R6                    END OF PARM                     19793000
         BM    SCAN450                  YES.  CHECK PAREN BALANCE.      19794000
         CLI   D0(R1),JLPARN            CHARACTER (                     19795000
         BE    SCAN430                  YES.  GO INCREMENT PAREN COUNT  19796000
         CLI   D0(R1),JRPARN            CHARACTER )                     19797000
         BE    SCAN440                  YES.  GO DECREMENT PAREN COUNT. 19798000
         LTR   R14,R14                  IS PAREN BALANCE ZERO           19799000
         BNZ   SCAN420                  NO.  GO CONTINUE SCAN           19800000
         CLI   D0(R1),JCOMMA            COUNT ZERO.  IS IT A COMMA.     19801000
         BE    SCAN460                  YES.  THAT IS ALL OF SYSPARM.   19802000
         B     SCAN420                  GO CONTINUE SCAN                19803000
SCAN430  LA    R14,D1(,R14)             INCREMENT PAREN COUNT           19804000
         B     SCAN420                  GO CONTINUE SCAN                19805000
SCAN440  BCTR  R14,R0                   DECREMENT PAREN COUNT           19806000
         LTR   R14,R14                  IS IT NEGATIVE                  19807000
         BNM   SCAN420                  NO.  CONTINUE SCAN.             19808000
         B     SCAN110                  ERROR.                          19809000
SCAN450  LTR   R14,R14                  WERE PAREN BALANCED.            19810000
         BNZ   SCAN110                  NO.  ERROR.                     19811000
SCAN460  LR    R14,R1                   LENGTH = END -                  19812000
SCAN465  SR    R14,R15                  START                           19813000
         BCT   R14,SCAN470              BR IF LENGTH IS GT 1            19814000
         XC    JSYSPARM,JSYSPARM        NULL SYSPARM   SYSPARM=,        19815000
         B     SCAN50                   CONTINUE WITH OTHER OPTIONS     19816000
SCAN470  STC   R14,D0(,R15)             STORE ACT LENGTH OF CHAR STRING 19817000
         L     R4,JSYSPARM              SEE IF DEFAULT SYSPARM          19818000
         LTR   R4,R4                    ''                              19819000
         BZ    SCAN480                  BR IF NO DEFAULT SYSPARM        19820000
         CLC   D0(D1,R4),D0(R15)        IS LENGTH OF SYSPARM LE DEFAULT 19821000
         BL    SCAN480                    LENGTH.  NO.  MUST SAVE PARM  19822000
         EX    R14,MVCSYSPM             OVERLAY DEFAULT SYSPARM         19823000
         B     SCAN50                   CONTINUE WITH OTHER OPTIONS     19824000
SCAN480  ST    R15,JSYSPARM             SAVE SYSPARM ADDR               19825000
         OI    JSYSPARM,BIT0            SET BIT ON TO INDICATE DON'T    19826000
         B     SCAN50                     FREE PARM AREA.  NEXT OPTION  19827000
SCAN500  C     R6,=F'4'                 CHECK REMAINING CHARACTERS      19828000
         BL    SCAN110                  ERROR IF LESS THAN 5            19829000
         CLC   D0(D5,R1),=AL1(JLPARN,JM,JI,JN,JRPARN) TEST IF MIN       19830000
         BNE   SCAN510                  BRANCH IF NOT MIN BLOCK SIZE    19831000
         SET   JMINBUF,ON               INDICATE MIN BUFFERS            19832000
         SET   JMBUF,OFF                SET MULTIBUFF OFF      FX0000   19833000
         B     SCAN530                  GO UPDATE POINTER      FX0000   19834000
SCAN510  CLC   D0(D5,R1),=AL1(JLPARN,JS,JT,JD,JRPARN) TEST IF STD       19835000
         BNE   SCAN520                  KEEP CHECKING MAX NEXT FX0000   19836000
         SET   JMINBUF,OFF              INDICATE STANDARD BUFFERS       19837000
         SET   JMBUF,OFF                SET MULTIBUFF OFF      FX0000   19838000
         B     SCAN530                  GO UPDATE POINTER      FX0000   19839000
SCAN520  CLC   D0(D5,R1),=AL1(JLPARN,JM,JA,JX,JRPARN) TEST IF MFX0000   19840000
         BNE   SCAN110                  ERROR IF NOT           FX0000   19841000
         SET   JMBUF,ON                 SET MULTIBUFF ON       FX0000   19842000
         SET   JMINBUF,OFF              INDICATE STANDARD BUFFEFX0000   19843000
SCAN530  LA    R1,D5(,R1)               BUMP TO NEXT OPTION    FX0000   19844000
         S     R6,=F'5'                 DECREMENT LENGTH                19845000
         LTR   R6,R6                    TEST IF END                     19846000
         BM    SCAN50                   CONTINUE TO SCAN                19847000
         CLI   D0(R1),JCOMMA            CHECK IF COMMA                  19848000
         BNE   SCAN110                  ERROR IF NOT                    19849000
         B     SCAN50                   CONTINUE TO SCAN                19850000
SCAN600  SET   JXREF,ON                 INDICATE XREF                   19851000
         SET   JMINXREF,OFF             INDICATE FULL XREF              19852000
         CH    R2,=Y(JCOMMA)            CHECK IF XREF,                  19853000
         BE    SCAN50                   CONTINUE SCAN                   19854000
         C     R6,=F'5'                 CHECK REMAINING CHARACTERS      19855000
         BL    SCAN110                  ERROR IF LESS THAN (FULL)       19856000
         CLC   D0(D6,R1),=AL1(JLPARN,JF,JU,JL,JL,JRPARN)                19857000
         BE    SCAN610                  BRANCH IF (FULL)                19858000
         C     R6,=F'6'                 CHECK REMAINING CHARACTERS      19859000
         BL    SCAN110                  ERROR IF LESS THAN (SHORT)      19860000
         CLC   D0(D7,R1),=AL1(JLPARN,JS,JH,JO,JR,JT,JRPARN)             19861000
         BNE   SCAN110                  ERROR IF NOT (SHORT)            19862000
         SET   JMINXREF,ON              INDICATE SHORT XREF             19863000
         LA    R1,D7(,R1)               ADVANCE POINTER                 19864000
         S     R6,=F'7'                 DECREASE COUNT                  19865000
         B     SCAN620                  CHECK NEXT CHARACTER            19866000
SCAN610  LA    R1,D6(,R1)               ADVANCE POINTER                 19867000
         S     R6,=F'6'                 DECREASE COUNT                  19868000
SCAN620  LTR   R6,R6                    CHECK IF LAST OPTION            19869000
         BM    SCAN50                   BRANCH IF LAST                  19870000
         CLI   D0(R1),JCOMMA            CHECK IF COMMA                  19871000
         BE    SCAN50                   BRANCH IF COMMA                 19872000
         B     SCAN110                  ERROR IF NOT                    19873000
         SPACE ,                                               FX0000   19874000
SCAN700  CH    R2,=Y(JLPARN)            IS DELIMITER LEFT PARENFX0000   19875000
         BNE   SCAN110                  ERROR IF NOT           FX0000   19876000
         BAL   R9,SCAN80                CONVERT NUMBER         FX0000   19877000
         CLI   D0(R1),JK                FOLLOWED BY K ?        FX0000   19878000
         BNE   SCAN710                  NOT IN K VALUES        FX0000   19879000
         SLA   R15,D10                  VALUE * 1024           FX0000   19880000
         BO    SCAN110                  ERROR IF TOO LARGE     FX0000   19881000
         B     SCAN720                  CONTINUE ...           FX0000   19882000
SCAN710  DS    0H                                              FX0000   19883000
         CLI   D0(R1),JM                FOLLOWED BY M ?        FX0000   19884000
         BNE   SCAN720                  NOT IN M VALUES        FX0000   19885000
         SLA   R15,D20                  VALUE * 1048576 (1024K)FX0000   19886000
         BO    SCAN110                  ERROR IF TOO LARGE     FX0000   19887000
SCAN720  DS    0H                                              FX0000   19888000
         LA    R1,D1(,R1)               BUMP POINTER           FX0000   19889000
         BCTR  R6,R0                    DECREMENT LENGTH       FX0000   19890000
         CLI   D0(R1),JRPARN            FOLLOWED BY RIGHT PARENFX0000   19891000
         BNE   SCAN110                  ERROR IF NOT           FX0000   19892000
         LA    R1,D1(,R1)               BUMP POINTER           FX0000   19893000
         BCTR  R6,R0                    DECREMENT LENGTH       FX0000   19894000
         LTR   R6,R6                    CHECK IF END OF FIELD  FX0000   19895000
         BM    SCAN760                  BRANCH IF SO           FX0000   19896000
         LTR   R14,R14                  TEST PAREN COUNT       FX0000   19897000
         BNZ   SCAN110                  ERROR IF MORE          FX0000   19898000
         B     SCAN760                  CONTINUE               FX0000   19899000
SCAN730  CH    R2,=Y(JEQUAL)            TEST IF =              FX0000   19900000
         BNE   SCAN110                  BRANCH IF NOT =        FX0000   19901000
         BAL   R9,SCAN80                CONVERT NUMBER         FX0000   19902000
         LTR   R6,R6                    CHECK IF END OF FIELD  FX0000   19903000
         BM    SCAN760                  BRANCH IF SO           FX0000   19904000
         CLI   D0(R1),JK                FOLLOWED BY K ?        FX0000   19905000
         BNE   SCAN740                  NOT IN K VALUES        FX0000   19906000
         SLA   R15,D10                  VALUE * 1024           FX0000   19907000
         BO    SCAN110                  ERROR IF TOO LARGE     FX0000   19908000
         LA    R1,D1(,R1)               SKIP PAST 'K'          FX0000   19909000
         B     SCAN750                  CONTINUE ...           FX0000   19910000
SCAN740  DS    0H                                              FX0000   19911000
         CLI   D0(R1),JM                FOLLOWED BY M ?        FX0000   19912000
         BNE   SCAN750                  NOT IN M VALUES        FX0000   19913000
         SLA   R15,D20                  VALUE * 1048576 (1024K)FX0000   19914000
         BO    SCAN110                  ERROR IF TOO LARGE     FX0000   19915000
         LA    R1,D1(,R1)               SLIP PAST 'M'          FX0000   19916000
SCAN750  CLI   D0(R1),JCOMMA            FOLLOWED BY COMMA      FX0000   19917000
         BNE   SCAN110                  ERROR IF NOT           FX0000   19918000
SCAN760  DS    0H                                              FX0000   19919000
         C     R15,=A(10*1024*1024)     GREATER THAN 10M?      FX0000   19920000
         BH    SCAN110                  YES, TOO LARGE         FX0000   19921000
         C     R15,=A(32*1024)          LESS THAN 32K?         FX0000   19922000
         BL    SCAN110                  YES, TOO SMALL         FX0000   19923000
         ST    R15,JWRKSIZE             WORKSIZE STORED        FX0000   19924000
         ST    R15,CORESIZE             WORKSIZE STORED        FX0000   19925000
         B     SCAN50                   GO SCAN FOR MORE OPTIONFX0000   19926000
         SPACE 3                                                        19927000
SCAN999  DC    0H'0'                    CONTINUE                        19928000
         SPACE 3                                                        19929000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - PROCESS OVERRI19930000
               IDING DDNAMES IF THERE ARE ANY'                          19931000
         LA    R10,ERR260               ERROR CODE FOR MISSING DD CARD  19932000
         SR    R6,R6                    MAKE R6 & R7 EQUAL IN CASE      19933000
         LR    R7,R6                      THERE IS NO OVERRIDING DD     19934000
         TM    D0(R11),BIT0             ANY OVERRIDING DDNAMES          19935000
         BO    TSYSTERM                 NO. R5 WILL BE GT R7 NOW        19936000
         L     R6,D4(,R11)              PT TO DDNAME LIST               19937000
         USING P,R6                     ''                              19938000
         LA    R7,P                     CALC END-OF-LINE (-2)           19939000
         AH    R7,PLEN                  ''                              19940000
         SPACE 3                                                        19941000
TSYSTERM GOIF  JTERM,OFF=TSYSLIN        NOTERMINAL SPECIFIED            19942000
         LA    R5,PSYSTERM              PT TO OVERRIDING DDNAME         19943000
         CR    R5,R7                    IS IT PAST END OF LIST          19944000
         BH    XSYSTERM                 YES GO CHANGE POINTER           19945000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 19946000
         BNZ   DSYSTERM                 YES                             19947000
XSYSTERM LA    R5,CSYSTERM              PT TO STANDARD NAME             19948000
DSYSTERM DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      19949000
         LTR   R15,R15                  WAS DDNAME FOUND                19950000
         BZ    TSYSLIN                  YES                             19951000
         SET   JMISTERM,ON              INDICATE SYSTERM DD CARD MISSIN 19952000
         SET   JTERM,OFF                SET TERM OFF                    19953000
TSYSLIN  GOIF  JLINK,OFF=TSYSIN         NOLOAD SPECIFIED                19954000
         LA    R5,PSYSGO                PT TO OVERRIDING DDNAME         19955000
         CR    R5,R7                    IS IT PAST END OF LIST          19956000
         BH    XSYSLIN                  YES. GO CHANGE PTR              19957000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 19958000
         BNZ   DSYSLIN                  YES.                            19959000
XSYSLIN  LA    R5,CSYSGO                PT TO STANDARD NAME             19960000
DSYSLIN  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      19961000
         LTR   R15,R15                  WAS DDNAME FOUND                19962000
         BZ    TSYSIN                   YES                             19963000
         SET   JMISLIN,ON               NO. FLAG ERROR FOR DIAG.        19964000
         SET   JLINK,OFF                SUPPRESS OBJECT FILE            19965000
         SPACE 3                                                        19966000
TSYSIN   LA    R5,PSYSIN                PT TO OVERRIDING DDNAME         19967000
         CR    R5,R7                    IS IT PAST END OF LIST          19968000
         BH    XSYSIN                   YES. GO CHANGE PTR              19969000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 19970000
         BNZ   DSYSIN                   YES.                            19971000
XSYSIN   LA    R5,CSYSIN                PT TO STANDARD NAME             19972000
DSYSIN   DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      19973000
         LTR   R15,R15                  WAS DDNAME FOUND                19974000
         BP    JABORT                   NO. ABORT                       19975000
         SPACE 3                                                        19976000
         GOIF  JLIST,OFF=TSYSPUNC       NOLIST SPECIFIED                19977000
         LA    R5,PSYSPRIN              PT TO OVERRIDING DDNAME         19978000
         CR    R5,R7                    IS IT PAST END OF LIST          19979000
         BH    XSYSPRIN                 YES. GO CHANGE PTR              19980000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 19981000
         BNZ   DSYSPRIN                 YES.                            19982000
XSYSPRIN LA    R5,CSYSPRIN              PT TO STANDARD NAME             19983000
DSYSPRIN DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      19984000
         LTR   R15,R15                  WAS DDNAME FOUND                19985000
         BZ    TSYSPUNC                 YES                             19986000
         SET   JMISPRT,ON               INDICATE MISSING SYSPRINT       19987000
         WTO   MF=(E,NSPRTMSG)          GIVE MSG FOR MISSING SYSPRINT   19988000
         SET   JLIST,OFF                                                19989000
         SPACE 3                                                        19990000
TSYSPUNC GOIF  JDECK,OFF=TSYSUT1        NODECK SPECIFIED                19991000
         LA    R5,PSYSPUNC              PT TO OVERRIDING DDNAME         19992000
         CR    R5,R7                    IS IT PAST END OF LIST          19993000
         BH    XSYSPUNC                 YES. GO CHANGE PTR              19994000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 19995000
         BNZ   DSYSPUNC                 YES.                            19996000
XSYSPUNC LA    R5,CSYSPUNC              PT TO STANDARD NAME             19997000
DSYSPUNC DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      19998000
         LTR   R15,R15                  WAS DDNAME FOUND                19999000
         BZ    TSYSUT1                  YES                             20000000
         SET   JMISPCH,ON               NO. FLAG ERROR FOR DIAG.        20001000
         SET   JDECK,OFF                SUPPRESS PUNCH FILE             20002000
         SPACE 3                                                        20003000
TSYSUT1  LA    R5,PSYSUT1               PT TO OVERRIDING DDNAME         20004000
         CR    R5,R7                    IS IT PAST END OF LIST          20005000
         BH    XSYSUT1                  YES. GO CHANGE PTR              20006000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 20007000
         BNZ   DSYSUT1                  YES.                            20008000
XSYSUT1  LA    R5,CSYSUT1               PT TO STANDARD NAME             20009000
DSYSUT1  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      20010000
         LTR   R15,R15                  WAS DDNAME FOUND                20011000
         BP    JABORT                   NO. ABORT                       20012000
         MVC   JMAXRL1,JDWORD+D6        SET MAXRL FOR SYSUT1            20013000
         L     R1,JFLEBLK1+JFLE-JFLEBLK PT TO SYSUT1 DCB                20014000
         USING IHADCB,R1                ''                              20015000
         MVC   DCBDDNAM,D0(R5)          MOVE IN DDNAME                  20016000
         DROP  R1                       DROP DCB ADDRESSABILITY         20017000
         SPACE 3                                                        20018000
         LA    R5,PSYSUT2               PT TO OVERRIDING DDNAME         20019000
         CR    R5,R7                    IS IT PAST END OF LIST          20020000
         BH    XSYSUT2                  YES. GO CHANGE PTR              20021000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 20022000
         BNZ   DSYSUT2                  YES.                            20023000
XSYSUT2  LA    R5,CSYSUT2               PT TO STANDARD NAME             20024000
DSYSUT2  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      20025000
         LTR   R15,R15                  WAS DDNAME FOUND                20026000
         BP    JABORT                   NO. ABORT                       20027000
         MVC   JMAXRL2,JDWORD+D6        SET MAXRL FOR SYSUT2            20028000
         L     R1,JFLEBLK2+JFLE-JFLEBLK PT TO SYSUT2 DCB                20029000
         USING IHADCB,R1                ''                              20030000
         MVC   DCBDDNAM,D0(R5)          MOVE IN DDNAME                  20031000
         DROP  R1                       DROP DCB ADDRESSABILITY         20032000
         SPACE 3                                                        20033000
         LA    R5,PSYSUT3               PT TO OVERRIDING DDNAME         20034000
         CR    R5,R7                    IS IT PAST END OF LIST          20035000
         BH    XSYSUT3                  YES. GO CHANGE PTR              20036000
         CLC   D0(D8,R5),=8X'00'        IS DDNAME OVERRIDEN     OY02543 20037000
         BNZ   DSYSUT3                  YES.                            20038000
XSYSUT3  LA    R5,CSYSUT3               PT TO STANDARD NAME             20039000
DSYSUT3  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      20040000
         LTR   R15,R15                  WAS DDNAME FOUND                20041000
         BP    JABORT                   NO. ABORT                       20042000
         MVC   JMAXRL3,JDWORD+D6        SET MAXRL FOR SYSUT3            20043000
         L     R1,JFLEBLK3+JFLE-JFLEBLK PT TO SYSUT3 DCB                20044000
         USING IHADCB,R1                ''                              20045000
         MVC   DCBDDNAM,D0(R5)          MOVE IN DDNAME                  20046000
         DROP  D1                       DROP DCB ADDRESSABILITY         20047000
         SPACE 4                                                        20048000
*   CHECK FOR CONSISTENT OPTIONS -                                      20049000
*                            IF NOLIST, THEN NOXREF, NOESD, AND NORLD   20050000
*                            IF NODECK AND NOLINK, THEN NOTEST          20051000
         GOIF  JLIST,ON=CKTEST          CHECK LIST OPTION               20052000
         SET   (JXREF,JRLD,JESD),OFF    NOLIST, SO NOXREF NORLD & NOESD 20053000
CKTEST   GOIF  (JLINK,JDECK),ANY=CKTERM BOTH NOLINK AND NODECK          20054000
         SET   JTEST,OFF                YES, THEN NOTEST                20055000
CKTERM   GOIF  JTERM,ON=VALRL0          IF NOTERM OPTION       FX0000   20056000
         SET   (JNUM,JSTMT),OFF         FORCE NONUM AND NOSTMT          20057000
         SPACE 5                                                        20058000
VALRL0   DS    0H                                              FX0000   20059000
         TM    JMAXRL1,X'80'            IS RECORD GREATER THAN FX0000   20060000
         BNO   VALRL1                   NO, CHECK NEXT         FX0000   20061000
         ICM   R14,B'0011',JMAXRL1      YES, GET LENGTH        FX0000   20062000
         SRL   R14,1                    DIVIDE BY 2            FX0000   20063000
         STCM  R14,B'0011',JMAXRL1      STORE LENGTH           FX0000   20064000
VALRL1   DS    0H                                              FX0000   20065000
         TM    JMAXRL2,X'80'            IS RECORD GREATER THAN FX0000   20066000
         BNO   VALRL2                   NO, CHECK NEXT         FX0000   20067000
         ICM   R14,B'0011',JMAXRL2      YES, GET LENGTH        FX0000   20068000
         SRL   R14,1                    DIVIDE BY 2            FX0000   20069000
         STCM  R14,B'0011',JMAXRL2      STORE LENGTH           FX0000   20070000
VALRL2   DS    0H                                              FX0000   20071000
         TM    JMAXRL3,X'80'            IS RECORD GREATER THAN FX0000   20072000
         BNO   VALRL3                   NO, CHECK NEXT         FX0000   20073000
         ICM   R14,B'0011',JMAXRL3      YES, GET LENGTH        FX0000   20074000
         SRL   R14,1                    DIVIDE BY 2            FX0000   20075000
         STCM  R14,B'0011',JMAXRL3      STORE LENGTH           FX0000   20076000
VALRL3   DS    0H                                              FX0000   20077000
         TM    JMAXRL3,X'80'            IS RECORD GREATER THAN FX0000   20078000
         BNO   MIN0                     NO, CONTINUE           FX0000   20079000
         ICM   R14,B'0011',JMAXRL       YES, GET LENGTH        FX0000   20080000
         SRL   R14,1                    DIVIDE BY 2            FX0000   20081000
         STCM  R14,B'0011',JMAXRL       STORE LENGTH           FX0000   20082000
MIN0     LH    R14,JMAXRL1              FIND THE MINIMUM OF JMAXRL1,    20083000
         CH    R14,JMAXRL2                JMAXRL2, JMAXRL3 & JMAXRL     20084000
         BNH   MIN1                     ''                              20085000
         LH    R14,JMAXRL2              ''                              20086000
MIN1     CH    R14,JMAXRL3              ''                              20087000
         BNH   MIN2                     ''                              20088000
         LH    R14,JMAXRL3              ''                              20089000
MIN2     CH    R14,JMAXRL               ''                              20090000
         BNH   MIN3                     ''                              20091000
         LH    R14,JMAXRL               ''                              20092000
MIN3     STH   R14,JMAXRL               SAVE MINIMUM OF JMAXRL(S)       20093000
         SPACE 3                                                        20094000
RETURN   JRETURN                                                        20095000
         SPACE 2                                                        20096000
         TITLE '&COMPNM&ASMID - ASSEMBLER INITILIZATION - CONSTANTS ANDX20097000
                PATCH AREA '                                            20098000
CSYSTERM DC    CL8'SYSTERM'             STANDARD FILE NAME FOR SYSTERM  20099000
CSYSGO   DC    CL8'SYSGO'               STANDARD FILE NAME FOR SYSGO    20100000
CSYSIN   DC    CL8'SYSIN'               STANDARD FILE NAME FOR SYSIN    20101000
CSYSPRIN DC    CL8'SYSPRINT'            STANDARD FILE NAME FOR SYSPRINT 20102000
CSYSPUNC DC    CL8'SYSPUNCH'            STANDARD FILE NAME FOR SYSPUNCH 20103000
CSYSUT1  DC    CL8'SYSUT1'              STANDARD FILE NAME FOR SYSUT1   20104000
CSYSUT2  DC    CL8'SYSUT2'              STANDARD FILE NAME FOR SYSUT2   20105000
CSYSUT3  DC    CL8'SYSUT3'              STANDARD FILE NAME FOR SYSUT3   20106000
         SPACE 1                                                        20107000
CALEN    DC    AL1(31,29,31,30,31,30,31,31,30,31,30,31) DAYS IN MONTH   20108000
         SPACE 1                                                        20109000
TRTTABLE DC    39AL1(0)                 TRANSLATE AND TEST TABLE        20110000
         DC    AL1(JEQUAL)              STOP ON =                       20111000
         DC    AL1(JLPARN)              STOP ON (                       20112000
         DC    5AL1(0)                  (DON'T STOP)                    20113000
         DC    AL1(JCOMMA)              STOP ON ,                       20114000
         DC    AL1(JBLANK)              STOP ON BLANK                   20115000
         DC    208AL1(0)                (DON'T STOP)                    20116000
         SPACE 1                                                        20117000
MVCPARM  MVC   D0(D0,R5),D2(R2)         MVC TO MOVE PARM TO OUR CORE    20118000
TRPARM   TR    D0(D0,R5),JTRTABLE       TR TO TRANSLATE TO INTERNAL     20119000
TRTPARM  TRT   D0(D0,R5),TRTTABLE       TRT TO SCAN FOR DELIMITER       20120000
MVCDWORD MVC   JDWORD(D0),D0(R5)        MVC OPTION TO JDWORD            20121000
MVCSYSPM MVC   D0(D0,R4),D0(R15)        MVC TO MOVE SYSPARM TO DEFAULT  20122000
         SPACE 1                                                        20123000
COMPAREA EQU   JDWORD,10                JDWORD+JFWORD1 IN COMMA         20124000
PARMLEN  EQU   14                       LENGTH OF EACH ENTRY            20125000
BLANKS   JGENIN ' ',10                  10 INTERNAL BLANKS              20126000
PARMTAB  DS    0F                       OPTION TABLE                    20127000
         JGENIN 'DECK',10                                               20128000
         SET   JDECK,ON                 SET DECK OPTION ON              20129000
         JGENIN 'NODECK',10                                             20130000
         SET   JDECK,OFF                SET DECK OPTION OFF             20131000
         JGENIN 'OBJECT',10                                             20132000
         SET   JLINK,ON                 SET OBJECT OPTION ON            20133000
         JGENIN 'OBJ',10                                                20134000
         SET   JLINK,ON                 SET OBJECT OPTION ON            20135000
         JGENIN 'NOOBJECT',10                                           20136000
         SET   JLINK,OFF                SET OBJECT OPTION OFF           20137000
         JGENIN 'NOOBJ',10                                              20138000
         SET   JLINK,OFF                SET OBJECT OPTION OFF           20139000
         JGENIN 'XREF',10                                               20140000
         B     SCAN600                  CHECK IF SHORT OR FULL          20141000
         JGENIN 'NOXREF',10                                             20142000
         SET   JXREF,OFF                SET XREF OPTION OFF             20143000
         JGENIN 'ESD',10                                                20144000
         SET   JESD,ON                  SET ESD OPTION ON               20145000
         JGENIN 'NOESD',10                                              20146000
         SET   JESD,OFF                 SET ESD OPTION OFF              20147000
         JGENIN 'RLD',10                                                20148000
         SET JRLD,ON                    SET RLD OPTION ON               20149000
         JGENIN 'NORLD',10                                              20150000
         SET   JRLD,OFF                 SET RLD OPTION OFF              20151000
         JGENIN 'RENT',10                                               20152000
         SET   JRENT,ON                 SET RENT OPTION ON              20153000
         JGENIN 'NORENT',10                                             20154000
         SET   JRENT,OFF                SET RENT OPTION OFF             20155000
         JGENIN 'ALIGN',10                                              20156000
         SET   JALGN,ON                 SET ALIGN OPTION ON             20157000
         JGENIN 'NOALIGN',10            SET ALIGN OPTION OFF            20158000
         SET   JALGN,OFF                SET ALIGN OPTION OFF            20159000
         JGENIN 'TERM',10                                               20160000
         SET   JTERM,ON                 SET TERM OPTION ON              20161000
         JGENIN 'TERMINAL',10                                           20162000
         SET   JTERM,ON                 SET TERM OPTION ON              20163000
         JGENIN 'NOTERM',10                                             20164000
         SET JTERM,OFF                  SET TERM OPTION OFF             20165000
         JGENIN 'NOTERMINAL',10                                         20166000
         SET   JTERM,OFF                SET TERM OPTION OFF             20167000
         JGENIN 'NUM',10                                                20168000
         SET   JNUM,ON                  SET NUM OPTION ON               20169000
         JGENIN 'NUMBER',10                                             20170000
         SET   JNUM,ON                  SET NUM OPTION ON               20171000
         JGENIN 'NONUM',10                                              20172000
         SET   JNUM,OFF                 SET NUM OPTION OFF              20173000
         JGENIN 'NONUMBER',10                                           20174000
         SET   JNUM,OFF                 SET NUM OPTION OFF              20175000
         JGENIN 'STMT',10                                               20176000
         SET   JSTMT,ON                 SET STMT OPTION ON              20177000
         JGENIN 'NOSTMT',10                                             20178000
         SET   JSTMT,OFF                SET STMT OPTION OFF             20179000
         JGENIN 'TEST',10                                               20180000
         SET   JTEST,ON                 SET TEST OPTION ON              20181000
         JGENIN 'NOTEST',10                                             20182000
         SET   JTEST,OFF                SET TEST OPTION OFF             20183000
         JGENIN 'MCALL',10                                              20184000
         SET   JCALLS,ON                SET MCALL OPTION DN             20185000
         JGENIN 'NOMCALL',10                                            20186000
         SET   JCALLS,OFF               SET MCALL OPTION OFF            20187000
         JGENIN 'ALOGIC',10                                             20188000
         SET   JALOGIC,ON               SET ALOGIC OPTION ON            20189000
         JGENIN 'NOALOGIC',10                                           20190000
         SET   JALOGIC,OFF              SET ALOGIC OPTION OFF           20191000
         JGENIN 'MLOGIC',10                                             20192000
         SET   JMLOGIC,ON               SET MLDGIC OPTION ON            20193000
         JGENIN 'NOMLOGIC',10                                           20194000
         SET   JMLOGIC,OFF              SET MLOGIC OPTION OFF           20195000
         JGENIN 'LIBMAC',10                                             20196000
         SET   JSYSMAC,ON               SET LIBMAC OPTION ON            20197000
         JGENIN 'NOLIBMAC',10                                           20198000
         SET   JSYSMAC,OFF              SET LIBMAC OPTION OFF           20199000
         JGENIN 'SYSMAC',10                                             20200000
         SET   JSYSMAC,ON               SET SYSMAC OPTION DN            20201000
         JGENIN 'NOSYSMAC',10                                           20202000
         SET   JSYSMAC,OFF              SET SYSMAC OPTION OFF           20203000
         JGENIN 'YFLAG',10              SET Y-CON FLAG ON      @OX09734 20204000
         SET   JYFLAG,ON                                       @OX09734 20205000
         JGENIN 'NOYFLAG',10            SET Y-CON FLAG OFF     @OX09734 20206000
         SET   JYFLAG,OFF                                      @OX09734 20207000
         JGENIN 'LIST',10                                               20208000
         SET   JLIST,ON                 SET LIST OPTION ON              20209000
         JGENIN 'NOLIST',10                                             20210000
         SET   JLIST,OFF                SET LIST OPTION OFF             20211000
         JGENIN 'BUF',10                                                20212000
         B     SCAN500                  HANDLE BUFSIZE OPTION           20213000
         JGENIN 'BUFSIZE',10                                            20214000
         B     SCAN500                  HANDLE BUFSIZE OPTION           20215000
         JGENIN 'FLAG',10                                               20216000
         B     SCAN200                  HANDLE FLAG OPTION              20217000
         JGENIN 'LINECOUNT',10                                          20218000
         B     SCAN300                  HANDLE LINECOUNT                20219000
         JGENIN 'LC',10                                                 20220000
         B     SCAN300                  HANDLE LINECOUNT                20221000
         JGENIN 'SYSPARM',10                                            20222000
         B     SCAN410                  HANDLE SYSPARM                  20223000
         JGENIN 'LOAD',10                                               20224000
         SET   JLINK,ON                 SET LOAD OPTION ON              20225000
         JGENIN 'NOLOAD',10                                             20226000
         SET   JLINK,OFF                SET LOAD OPTION OFF             20227000
         JGENIN 'ALGN',10                                               20228000
         SET   JALGN,ON                 SET ALIGN OPTION ON             20229000
         JGENIN 'NOALGN',10                                             20230000
         SET   JALGN,OFF                SET ALIGN OPTION OFF            20231000
         JGENIN 'CALLS',10                                              20232000
         SET   JCALLS,ON                SET CALLS OPTION ON             20233000
         JGENIN 'NOCALLS',10                                            20234000
         SET   JCALLS,OFF               SET CALLS OPTION OFF            20235000
         JGENIN 'MINBUF',10                                             20236000
         SET   JMINBUF,ON               SET MINBUF OPTION ON            20237000
         JGENIN 'NOMINBUF',10                                           20238000
         SET   JMINBUF,OFF              SET MINBUF OPTION OFF           20239000
         JGENIN 'MSGLEVEL',10                                           20240000
         B     SCAN210                  HANDLE MSGLEVEL                 20241000
         JGENIN 'LINECNT',10                                            20242000
         B     SCAN310                  HANDLE LINECOUNT                20243000
         JGENIN 'WORKSIZE',10                                  FX0000   20244000
         B     SCAN730                  HANDLE WORKSIZE        FX0000   20245000
PARMEND  DS    0F                       END OF OPTION TABLE             20246000
         SPACE 3                                                        20247000
NSPRTMSG WTO   '&COMPNM.267  SYSPRINT DD CARD MISSING - NOLIST OPTION UX20248000
               SED',ROUTCDE=(2,11),MF=L                                 20249000
         JPATCH X0D00,D38               5% PATCH AREA          FX0000   20250000
         SPACE 3                                                        20251000
         END   START                                                    20252000
./ ADD NAME=IFOX0F                                                      20253000
* /* START OF SPECIFICATIONS ****                                       20254000
*02* PROCESSOR = ASSEMBLER                                              20255000
**** END OF SPECIFICATIONS ***/                                         20256000
         GBLC  &COMPNM,&ASMID                                           20257000
         JHEAD 'INPUT I/O MODULE - PROLOG',                            X20258000
               PHASEID=X0F,                                            X20259000
               LEVEL=10                                                 20260000
*                                                                     * 20261000
*FUNCTION/OPERATION-                                                  * 20262000
*   THIS MODULE IS THE INPUT I/O MODULE FOR THE ASSEMBLER.  IT IS     * 20263000
*   USED BY THE MACRO EDITOR TO READ SOURCE INPUT, COPY CODE AND      * 20264000
*   MACROS.                                                           * 20265000
*                                                                     * 20266000
*ENTRY POINT-                                                         * 20267000
*        START+0  - GET INPUT STATEMENT. DISPLACEMENT-JINPUT.         * 20268000
*        START+4  - FIND MACRO IN LIBRARY. DISPLACEMENT-JFIND.        * 20269000
*        START+8  - NOTE POSITION OF LIBRARY. DISPLACEMENT-JNOTELB.   * 20270000
*        START+12 - POINT TO NOTED POSITION. DISPLACEMENT-JPOINTLB.   * 20271000
*        START+16 - INITIALIZE INPUT I/O MODULE, OPEN INPUT FILES ON  * 20272000
*   FIRST ENTRY, CLOSE INPUT FILES ON SECOND ENTRY. DISP.-JININIT.    * 20273000
*                                                                     * 20274000
*INPUT-                                                               * 20275000
*   SYSIN, SYSLIB.                                                    * 20276000
*                                                                     * 20277000
*OUTPUT-                                                              * 20278000
*   N/A                                                               * 20279000
*                                                                     * 20280000
*EXTERNAL ROUTINES-                                                   * 20281000
*   N/A                                                               * 20282000
*                                                                     * 20283000
*EXITS, NORMAL-                                                       * 20284000
*   RETURN TO CALLER VIA REGISTER R9.                                 * 20285000
*   FOR JINPUT, CC=2 MEANS RECORD READ CORRECTLY. CC=0 MEANS EOF READ.* 20286000
*   FOR JFIND, CC=2 MEANS MACRO OR COPY CODE FOUND. CC=0 MEANS MACRO  * 20287000
*   OR COPY CODE NOT FOUND                                            * 20288000
*                                                                     * 20289000
*EXITS, ERROR-                                                        * 20290000
*   BRANCH TO JABORT IN COMMON.                                       * 20291000
*                                                                     * 20292000
*TABLE/WORK AREAS-                                                    * 20293000
*   REGISTER R13 POINTS TO COMMON.  JADINCM, WHICH IS LOADED INTO     * 20294000
*   REGISTER R7, POINTS TO THE INPUT COMMON AREA.                     * 20295000
*                                                                     * 20296000
*ATTRIBUTES-                                                          * 20297000
*   REFRESHABLE.                                                      * 20298000
*                                                                     * 20299000
*NOTES-                                                               * 20300000
         SPACE 3                                                        20301000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   20302000
         COPY  JCOMMON                  JCOMMON COPY CODE               20303000
         PRINT ON                       THAT'S ALL WE WON'T PRINT       20304000
         SPACE                                                          20305000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - JINCOM COPY CODE'    20306000
         COPY  JINCOM                                                   20307000
         SPACE 3                                                        20308000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - DCBD MACRO'          20309000
         DCBD  DSORG=(PS,PO),DEVD=(DA)                                  20310000
         SPACE 3                                                        20311000
    TITLE '&COMPNM&ASMID - INPUT I/O MODULE - MAPPING DSECT (MAPDSECT)' 20312000
         IEZIOB                                                         20313000
         SPACE 3                                                        20314000
        TITLE '&COMPNM&ASMID - INPUT I/O MODULE - DDNAME OVERRIDE LIST' 20315000
P        DSECT                          DDNAME OVERRIDE LIST            20316000
PLEN     DS    H                        LENGTH OF LIST                  20317000
         DS    3CL8                     (NOT APPLICABLE)                20318000
PSYSLIB  DS    CL8                      SYSLIB DDNAME                   20319000
PSYSIN   DS    CL8                      SYSIN DDNAME                    20320000
PSYSPRIN DS    CL8                      SYSPRINT DDNAME                 20321000
PSYSPUNC DS    CL8                      SYSPUNCH DDNAME                 20322000
PSYSUT1  DS    CL8                      SYSUT1 DDNAME                   20323000
PSYSUT2  DS    CL8                      SYSUT2 DDNAME                   20324000
PSYSUT3  DS    CL8                      SYSUT3 DDNAME                   20325000
PSYSGO   DS    CL8                      SYSGO DDNAME                    20326000
D80      EQU   80                       DECIMAL 80                      20327000
         SPACE 5                                                        20328000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - MAINLINE CONTROL'    20329000
* VS1 RELEASE 3.1 CHANGES                                               20330000
*C678000                                                        OY02543 20331000
*A258500-259500                                                @0Z04367 20332000
*A705100,705200                                                @AX19477 20333000
*C706500                                                       @AX19477 20334000
         JCSECT (X0F00)                 SECTION ID                      20335000
         JMODID                         EMBEDDED IDENTIFIER             20336000
         USING START,R12                SET BASE OF R12                 20337000
START    B     INPUT                    JINPUT ENTRY                    20338000
         B     FIND                     JFIND ENTRY                     20339000
         B     NOTELB                   JNOTELB ENTRY                   20340000
         B     POINTLB                  JPOINTLB ENTRY                  20341000
         B     ININIT                   INIT & TERM ENTRY               20342000
         SPACE 3                                                        20343000
         JENTRY (X0F01=START)           MODULE ENTRY POINT              20344000
         SPACE 3                                                        20345000
SAVE     JSAVE BASE=NO                  SAVE REGISTERS                  20346000
         L     R7,JADINCM               LOAD ADDRESS OF INPUT COMMON    20347000
         BR    R14                      NOW GO ON WITH BUSINESS         20348000
         SPACE 3                                                        20349000
RETURN   JRETURN                        RESTORE REGISTERS & RETURN      20350000
         SPACE 5                                                        20351000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - ''JINPUT'' ROUTINE'  20352000
INPUT    BAL   R14,SAVE                 GO SAVE REGISTERS               20353000
         GOIF  JINLIB,ON=INLIB          INPUT FROM LIBRARY              20354000
         LA    R6,RETURN                LOAD RETURN ADDR FOR EOD USE    20355000
         L     R1,JSYSIN                LOAD INPUT FILE DEF ADDRESS     20356000
         LR    R11,R10                  SAVE R10               @0Z04367 20357000
         LA    R10,XTIN                 GET ADDRESS TO EXIT    @OZ04367 20358000
         GET   (1)                      GET A RECORD. ADDR IN R1        20359000
         L     R14,JRECIN               WELL...NO EOF, THEN COUNT CARDS 20360000
         LA    R14,D1(,R14)             ONE MORE CARD READ              20361000
         ST    R14,JRECIN               SAVE IT FOR NEXT TIME           20362000
         TR    D0(D80,R1),JTRTABLE      TRANSLATE STATEMENT             20363000
         LTR   R11,R1                   PASS BACK RECORD ADDRESS, SET   20364000
         B     RETURN                   CC=2 AND RETURN                 20365000
         SPACE 3                                                        20366000
INLIB    LH    R4,JLIBNDX               GET BUFFER INDEX                20367000
         AH    R4,=H'80'                ADD 80 (LOGICAL RECORD LENGTH)  20368000
         L     R5,JLIBBUF               POINT TO PHYSICAL BUFFER        20369000
         GOIF  JREADPT,ON=READ          READ NECESSARY FOR POINT        20370000
CHECKSIZ CH    R4,JBLKSIZE              HAVE WE EXAUSTED PHY REC        20371000
         BL    NOREAD                   NO.                             20372000
READ     LA    R6,RETURN                EOF RETURN PT AFTER CC=0        20373000
         READ  JLIBDECB,SF,,(R5),MF=E   READ PHY RECORD                 20374000
         CHECK JLIBDECB                 CHECK READ                      20375000
         L     R1,JSYSLIB               POINT TO DCB                    20376000
         USING IHADCB,R1                FIND RECORD SIZE                20377000
         L     R14,DCBIOBA              GET ADDR OF IOB                 20378000
         LH    R15,DCBBLKSI             RECORD SIZE = READ LENGTH -     20379000
         USING IOBBPAMN,R14             SET UP IOB USING                20380000
         SH    R15,IOBCSW+5             GET RESIDUAL COUNT              20381000
         DROP  R14                                                      20382000
         STH   R15,JBLKSIZE               ''                            20383000
         DROP  R1                       DROP DCB BASE                   20384000
         GOIF  JREADPT,OFF=RESET        READ WASN'T NECESSARY FOR POINT 20385000
         SET   JREADPT,OFF              SET READ BECUASE OF POINT OFF   20386000
         B     CHECKSIZ                 CHK TO SEE IF END OF BUF        20387000
RESET    SR    R4,R4                    ZERO BUFFER INDEX               20388000
NOREAD   STH   R4,JLIBNDX               SAVE BUFFER INDEX               20389000
         LA    R11,D0(R4,R5)            LOG ADDR=PHY ADDR+INDEX         20390000
         TR    D0(D80,R11),JTRTABLE     TRANSLATE TO INTERNAL           20391000
         L     R14,JRECLIB              ADD ONE TO LIB CARD COUNT       20392000
         LA    R14,D1(,R14)             ''                              20393000
         ST    R14,JRECLIB              ''                              20394000
         LTR   R11,R11                  SET CC=2 (NO EOF) AND           20395000
         B     RETURN                   RETURN                          20396000
         SPACE 5                                                        20397000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - ''JFIND'' ROUTINE'   20398000
FIND     BAL   R14,SAVE                 GO SAVE REGISTERS               20399000
         L     R1,JSYSLIB               POINT TO DCB                    20400000
         USING IHADCB,R1                ''                              20401000
         TM    DCBOFLGS,BIT3            WAS OPEN SUCCESSFUL             20402000
         BNZ   OPENSUC                  BR IF OPEN NOT SUCCESSFUL       20403000
         L     R2,JINOPEN               OPEN LIST                       20404000
         TM    D0(R2),BIT0              DD CARD FOUND                   20405000
         BZ    RETURN                   YES                             20406000
         SET   JMISLIB,ON               SYSLIB DD CARD MISSING          20407000
         SR    R2,R2                    SET NOT FOUND                   20408000
         B     RETURN                   RETURN                          20409000
         DROP  R1                                                       20410000
OPENSUC  MVC   JDWORD,D0(R10)           CONVERT MEMBER NAME             20411000
         TR    JDWORD,JTRTABLE          ''                              20412000
         FIND  (1),JDWORD,D             FIND MEMBER                     20413000
         SH    R15,=H'4'                CHECK RETURN CODE               20414000
         BZ    RETURN                   RC=4.  MEMBER NOT FOUND.  CC=0  20415000
         BP    ABORTFND                 RC=3  I/O ERROR.                20416000
         MVC   JLIBNDX,=X'7FAF'         FORCE READ                      20417000
         SET   JREADPT,OFF              RESET FLAG                      20418000
         LTR   R13,R13                  RC=0.  MEMBER FOUND.  CC=2      20419000
         B     RETURN                   RETURN                          20420000
         SPACE 4                                                        20421000
ABORTFND L     R1,JSYSLIB               PT TO DCB                       20422000
         USING IHADCB,R1                ''                              20423000
         O     R1,=X'FF000000'          SET FLAG TO INDICATE FIND ABORT 20424000
         L     R15,DCBSYNAD             GET ADDRESS OF SYDAD ROUTINE    20425000
         DROP  R1                       DROP DCB BASE                   20426000
         BR    R15                      NOW GO ABORT                    20427000
         SPACE 5                                                        20428000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - ''NOTELB'' AND ''POIX20429000
               NT'' ROUTINES'                                           20430000
         SPACE 2                                                        20431000
NOTELB   BAL   R14,SAVE                 GO SAVE REGISTERS               20432000
         L     R1,JSYSLIB               POINT TO DCB                    20433000
         NOTE  (1)                      NOTE LIBRARY POSITION           20434000
         ST    R1,JNOTEVAL              SAVE FILE POSITION              20435000
         MVC   JNOTEVAL+D6(D2),JLIBNDX  SAVE BUFFER INDEX               20436000
         B     RETURN                   RETURN                          20437000
         SPACE 6                                                        20438000
POINTLB  BAL   R14,SAVE                 GO SAVE REGISTERS               20439000
         MVC   JFWORD1,D0(R10)          ALIGN TO FULLWORD               20440000
         L     R1,JSYSLIB               POINT TO DCB                    20441000
         POINT (1),JFWORD1              POSITION LIBRARY                20442000
         MVC   JLIBNDX,D6(R10)          SET BUFFER INDEX                20443000
         SET   JREADPT,ON               INDICATE NEXT READ IS FOR POINT 20444000
         B     RETURN                   RETURN                          20445000
         SPACE 3                                                        20446000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - OPEN ROUTINE FOR ''SX20447000
               YSIN'' AND ''SYSLIB'' DCB''S'                            20448000
ININIT   BAL   R14,SAVE                 GO SAVE REGISTERS               20449000
         GOIF  JIN2ND,ON=CLOSE          SECOND TIME HERE                20450000
         SET   JIN2ND,ON                FIRST TIME. SET FLAG            20451000
         SPACE 2                                                        20452000
         TM    D0(R11),BIT0             ANY OVERRIDING DDNAMES          20453000
         BO    NOPARM                   BR IF END OF PARM LIST          20454000
         L     R14,D4(,R11)             PT TO DDNAME LIST               20455000
         USING P,R14                    ESTABLISH PARMLIST BASE         20456000
         LA    R15,P                    CLEAR END-OF-LIST FLAG          20457000
         AH    R15,PLEN                 CALC END OF TABLE (-2)          20458000
         SPACE 1                                                        20459000
         L     R1,JSYSLIB               PT TO SYSLIB DCB                20460000
         LA    R2,PSYSLIB               PT TO SYSLIB DDNAME             20461000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20462000
         SPACE 1                                                        20463000
         L     R1,JSYSIN                PT TO SYSIN DCB                 20464000
         LA    R2,PSYSIN                PT TO SYSIN DDNAME              20465000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20466000
         DROP  R14                      DROP DSECT BASE                 20467000
         SPACE 2                                                        20468000
         USING IHADCB,R1                BASE FOR DCB                    20469000
NOPARM   L     R1,JSYSLIB               POINTS TO SYSLIB DCB            20470000
         LA    R15,DCBDDNAM             POINTS TO SYSLIB DDNAME         20471000
         DROP  R1                                                       20472000
DSYSLIB  DEVTYPE (R15),JDWORD           GET DEVICE CHARACTERISTICS      20473000
         LTR   R15,R15                  WAS DDNAME FOUND                20474000
         BZ    ININIT5                  YES                             20475000
         L     R15,JINOPEN              POINT TO OPEN LIST              20476000
         OI    D0(R15),BIT0             DO NOT OPEN SYSLIB              20477000
         L     R15,JINCLOS              POINT TO CLOSE LIST             20478000
         OI    D0(R15),BIT0             DO NOT CLOSE SYSLIB             20479000
ININIT5  LA    R10,XTIN                 ADDRESS OF SYSIN LIB DCB EXIT   20480000
         L     R1,JINOPEN               OPEN INPUT                      20481000
         OPEN  MF=(E,(1))               ''                              20482000
         SPACE 2                                                        20483000
         USING IHADCB,R1                ESTABLISH ADDRESSABILITY        20484000
         L     R1,JSYSLIB               PT TO SYSLIB DCB                20485000
         TM    DCBOFLGS,BIT3            WAS OPEN SUCCESSFUL             20486000
         BZ    RETURN                   NO.  RETURN                     20487000
         SPACE 2                                                        20488000
         LH    R0,DCBBLKSI              GET BUFFER FOR LIBRARY          20489000
         DROP  R1                       DROP DCB BASE                   20490000
         GETMAIN R,LV=(0)               ACQUIRE CORE                    20491000
         ST    R1,JLIBBUF               SAVE LIBRARY BUFFER ADDRESS     20492000
         B     RETURN                   RETURN                          20493000
         SPACE                                                          20494000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - CLOSE ROUTINE FOR ''X20495000
               SYSIN'' AND ''SYSLIB'' DCB''S'                           20496000
CLOSE    L     R1,JSYSLIB               POINT TO DCB                    20497000
         USING IHADCB,R1                ''                              20498000
         TM    DCBOFLGS,BIT3            WAS OPEN SUCCESSFUL FOR LIBRARY 20499000
         BZ    NOTSUC                   NOT SUCCESSFUL                  20500000
         LH    R0,DCBBLKSI              GET BUFFER LENGTH               20501000
         DROP  R1                       DROP DCB BASE                   20502000
         L     R1,JLIBBUF               GET LIBRARY BUFFER ADDRESS      20503000
         FREEMAIN R,LV=(0),A=(1)        FREE LIBRARY BUFFER             20504000
NOTSUC   L     R1,JINCLOS               CLOSE INPUT                     20505000
         CLOSE MF=(E,(1))               ''                              20506000
         SPACE 3                                                        20507000
         L     R1,JSYSIN                PT TO SYSIN DCB                 20508000
         USING IHADCB,R1                ''                              20509000
         TM    DCBBUFCB+D3,BIT7         IS THERE A BUFCB                20510000
         BO    NOBUFCB                  BR IF NO BUFCB                  20511000
         FREEPOOL (1)                   FREE BUFFERS IN BUFCB           20512000
         DROP  R1                       DROP DCB BASE                   20513000
         SPACE 1                                                        20514000
NOBUFCB  XC    JADINCM,JADINCM          ZERO ADDRESS FOR ABORT MODULE   20515000
         B     RETURN                   RETURN                          20516000
         SPACE 2                                                        20517000
         TITLE '&COMPNM&ASMID - INPUT I/O MODULE - DCB OVERRIDE AND DCBX20518000
                EXIT ROUTINE FOR ''SYSIN'' AND ''SYSLIB'' DCB''S'       20519000
         USING IHADCB,R1                ESTABLISH BASE FOR DCB          20520000
OVERRIDE CR    R2,R15                   PAST END OF LIST                20521000
         BHR   R9                       YES, RETURN                     20522000
         CLC   D0(D8,R2),=8X'00'        IS DDNAME ZERO          OY02543 20523000
         BZR   R9                       YES, RETURN                     20524000
         MVC   DCBDDNAM,D0(R2)          OVERRIDE DDNAME                 20525000
         BR    R9                       RETURN                          20526000
         DROP  R1                       DROP DCB BASE                   20527000
         SPACE 3                                                        20528000
         USING IHADCB,R1                ESTABLISH ADDR OF DCB           20529000
*        DCB EXIT FOR SYSIN & SYSLIB                                    20530000
         USING *,R10                    ESTABLISH BASE ADDRESS          20531000
XTIN     LH    R3,DCBLRECL              LOGICAL RECORD LENGTH           20532000
         TM    DCBRECFM,BIT0            FIXED RECORD LENGTH             20533000
         BNZ   XTIN10                   NO, MAKE RECFM=FB               20534000
XTIN05   MVI   DCBRECFM,BIT0+BIT3       FORCE RECFM=FB         @AX19477 20535000
XTIN10   LH    R5,DCBBLKSI              IS BLKSIZE SPECIFIED            20536000
         LTR   R5,R5                                                    20537000
         BZ    XTIN20                   NO, GO SET DEFAULT BLKSIZE      20538000
         CR    R3,R5                    BLKSIZE LESS THAN LRECL         20539000
         BH    XTIN20                   IF SO SET BLKSIZE=LRECL         20540000
         OI    DCBRECFM,BIT3            SET BLOCKED                     20541000
         LR    R3,R5                    SAVE BLKSIZE                    20542000
         LH    R2,DCBLRECL              LOGICAL RECORD LENGTH           20543000
         SR    R4,R4                    ZERO FOR DIVIDE                 20544000
         DR    R4,R2                    R4(REMAINDER)=R4R5/R2 LRECL     20545000
         SR    R3,R4                    NOW BLKSIZE IS MULT OF LRECL    20546000
         B     XTIN30                   STORE BLKSIZE                   20547000
XTIN20   NI    DCBRECFM,BITFF-BIT3      SET UNBLOCKED                   20548000
XTIN30   STH   R3,DCBBLKSI              STORE BLKSIZE                   20549000
         BR    R14                                                      20550000
         DROP  R1,R10                   DROP BASES                      20551000
         SPACE 5                                                        20552000
*        PATCH AREA                                                     20553000
*                                                                       20554000
         JPATCH X0F00,302               5% PATCH AREA                   20555000
         END   START                                                    20556000
./ ADD NAME=IFOX0H                                                      20557000
* /* START OF SPECIFICATIONS ****                                       20558000
*02* PROCESSOR = ASSEMBLER                                              20559000
**** END OF SPECIFICATIONS ***/                                         20560000
         GBLC  &COMPNM,&ASMID           GLOBAL VARIABLES                20561000
         JHEAD 'OUTPUT I/O MODULE - PROLOG',                           X20562000
               PHASEID=X0H,                                            X20563000
               LEVEL=10                                                 20564000
*                                                                     * 20565000
*FUNCTION/OPERATION-                                                  * 20566000
*   THIS MODULE IS THE OUTPUT PACKAGE FOR THE ASSEMBLER.  THE OTHER   * 20567000
*   PHASES INTERFACE WITH THIS MODULE BY USE OF THE JPRINT AND JPUNCH * 20568000
*   MACROS.                                                           * 20569000
*                                                                     * 20570000
*ENTRY POINT-                                                         * 20571000
*        START+0    LOCATE PRINT BUFFER & PRINT PREVIOUS BUFFER.      * 20572000
*   DISPLACEMENT-JPRINT.                                              * 20573000
*        START+4  - LOCATE PUNCH BUFFER & PUNCH PREVIOUS BUFFER.      * 20574000
*   DISPLACEMENT-JPUNCH.                                              * 20575000
*        START+8  - INITIALIZE OUTPUT I/O MODULE.  OPEN OUTPUT FILES  * 20576000
*   (AS REQUIRED), CLOSE OUTPUT FILES ON SECOND ENTRY. DISP.-JOUTINIT.* 20577000
*                                                                     * 20578000
*INPUT-                                                               * 20579000
*   N/A                                                               * 20580000
*                                                                     * 20581000
*OUTPUT-                                                              * 20582000
*   SYSPRINT, SYSPUNCH, SYSLIN.                                       * 20583000
*                                                                     * 20584000
*EXTERNAL ROUTINES-                                                   * 20585000
*   N/A                                                               * 20586000
*                                                                     * 20587000
*EXITS, NORMAL-                                                       * 20588000
*   RETURN TO CALLER VIA REGISTER R9.                                 * 20589000
*                                                                     * 20590000
*EXITS, ERROR-                                                        * 20591000
*   N/A                                                               * 20592000
*                                                                     * 20593000
*TABLE/WORK AREAS-                                                    * 20594000
*   REGISTER R13 POINTS TO COMMON.  JADOUTCM, WHICH IS LOADED INTO    * 20595000
*   REGISTER R7, POINTS TO THE OUTPUT COMMON AREA.                    * 20596000
*                                                                     * 20597000
*ATTRIBUTES-                                                          * 20598000
*   REFRESHABLE                                                       * 20599000
*                                                                     * 20600000
*NOTES-                                                               * 20601000
         SPACE 2                                                        20602000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   20603000
         COPY  JCOMMON                                                  20604000
         PRINT ON                       THAT'S ALL WE WON'T PRINT       20605000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - JOUTCOM COPY CODE'  20606000
         COPY  JOUTCOM                                                  20607000
         SPACE 2                                                        20608000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - DCBD MACRO'         20609000
         DCBD  DSORG=(PS),DEVD=(DA)                                     20610000
         SPACE 3                                                        20611000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - PRINT IMAGE, PUNCH I20612000
               IMAGE AND DDNAME OVERRIDE DDNAME LIST DSECT''S'          20613000
PRTLINE  DSECT                          PRINTLINE DSECT                 20614000
CC       DS    X                        CARRIAGE CONTROL                20615000
EJECT    EQU   0                        EJECT CONTROL CODE              20616000
SPACE1   EQU   1                        SINGLE SPACE CONTROL CODE       20617000
SPACE2   EQU   2                        DOUBLE SPACE CONTROL CODE       20618000
SPACE3   EQU   3                        TRIPLE SPACE CONTROL CODE       20619000
IMAGE    DS    CL120                    PRINT IMAGE                     20620000
         SPACE 6                                                        20621000
PCHLINE  DSECT                          PUNCHLINE DSECT                 20622000
PCHIMAGE DS    0CL80                    CARD IMAGE                      20623000
PCHDATA  DS    CL72                     FIRST 72 COLUMNS                20624000
PCHSEQ   DS    CL8                      ID & SEQUENCE FIELDS            20625000
         SPACE 6                                                        20626000
P        DSECT                          DDNAME OVERRIDE LIST            20627000
PLEN     DS    H                        LENGTH OF LIST                  20628000
         DS    3CL8                     (NOT APPLICABLE)                20629000
PSYSLIB  DS    CL8                      SYSLIB DDNAME                   20630000
PSYSIN   DS    CL8                      SYSIN DDNAME                    20631000
PSYSPRIN DS    CL8                      SYSPRINT DDNAME                 20632000
PSYSPUNC DS    CL8                      SYSPUNCH DDNAME                 20633000
PSYSUT1  DS    CL8                      SYSUT1 DDNAME                   20634000
PSYSUT2  DS    CL8                      SYSUT2 DDNAME                   20635000
PSYSUT3  DS    CL8                      SYSUT3 DDNAME                   20636000
PSYSGO   DS    CL8                      SYSGO DDNAME                    20637000
PSYSTERM DS    CL8                      SYSTERM DDNAME                  20638000
         SPACE 3                                                        20639000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - MAINLINE CONTROL'   20640000
* VS1 RELEASE 3.1 CHANGES                                               20641000
*C741000                                                        OY02543 20642000
*A324500-326000,360500                                         @AX14816 20643000
         JCSECT (X0H00)                                                 20644000
         JMODID                         EMBEDDED IDENTIFIER             20645000
         USING START,R12                SET BASE TO R12                 20646000
START    B     PRINT                    JPRINT ENTRY                    20647000
         B     PUNCH                    JPUNCH ENTRY                    20648000
         B     OUTINIT                  INIT & TERM ENTRY               20649000
         B     TSOPRINT                 GO PRINT TO TERMINAL            20650000
         SPACE 3                                                        20651000
         JENTRY (X0H01=START)                                           20652000
         SPACE 3                                                        20653000
SAVE     JSAVE BASE=NO                  SAVE REGISTERS                  20654000
         L     R7,JADOUTCM              LOAD ADDRESS OF OUTPUT COMMON   20655000
         BR    R14                      NOW GO ON WITH BUSINESS         20656000
         SPACE 3                                                        20657000
RETURN   JRETURN                        RESTORE REGISTER & RETURN       20658000
         SPACE 3                                                        20659000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - TSOPRINT ROUTINE'   20660000
         USING PRTLINE,R1                                               20661000
TSOPRINT BAL   R14,SAVE                 GO SAVE REGISTERS               20662000
         GOIF  BYPASTRM,OFF=FIRSTRM     FIRST TERM PRINT                20663000
         L     R1,JCURTRM               PICK UP CURRENT BUFFER ADDR     20664000
         TR    CC,CCTRTAB               TRANSLATE CC TO EXTERNAL        20665000
         TR    IMAGE,JTRTABLE           TRANSLATE PRINT LINE            20666000
         GOIF  CLOSTRM,ON=RETURN        FINAL PRINT (IN CLOSE ROUTINE)  20667000
FIRSTRM  SET   BYPASTRM,ON              INDICATE NOT 1ST PRINT          20668000
         L     R1,JSYSTRM               LOAD TERM FILE DEF ADDR         20669000
         PUT   (1)                      PUT CURRENT REC & GET NEW ADDR  20670000
         ST    R1,JCURTRM               SAVE NEW BUFFER ADDRESS         20671000
         MVC   CC,D0(R11)               INIT LINE TO SINGLE SPACE       20672000
         MVC   IMAGE(L'IMAGE),D1(R11)   MOVE TERM BUFFER CONTENT        20673000
         LR    R11,R1                   TRANSFER NEW BUFFER ADDRESS     20674000
         B     RETURN                   RETURN TO CALLER                20675000
         DROP  R1                                                       20676000
         SPACE 3                                                        20677000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - JPRINT ROUTINE'     20678000
         USING PRTLINE,R1               DEFINE BASE FOR PRINTLINE       20679000
PRINT    BAL   R14,SAVE                 GO SAVE REGISTERS               20680000
         GOIF  BYPASPRT,OFF=FIRSTPRT    FIRSTPRINT                      20681000
         L     R1,JCURPRT               GET CURRENT PRINT BUFFER        20682000
         GOIF  JSUPPRT,OFF=PRINT5       IF SUPPRESS SW OFF BR  @AX14816 20683000
         SET   JSUPPRT,OFF              RESET SUPPRESS SW      @AX14816 20684000
         B     PRINT10                  DON'T PRINT-JUST DUMMY @AX14816 20685000
PRINT5   EQU   *                                               @AX14816 20686000
         LH    R14,=H'1'                GET INCREMENT                   20687000
         A     R14,JRECPRT              ADD OLD COUNT                   20688000
         ST    R14,JRECPRT              STORE NEW COUNT                 20689000
         TR    CC,CCTRTAB               TRANSLATE IN.CC TO ASA CC       20690000
         TR    IMAGE,JTRTABLE           TRANSLATE PRINT LINE            20691000
         GOIF  CLOSPRT,ON=RETURN        FINAL PRINT (IN CLOSE ROUTINE)  20692000
FIRSTPRT SET   BYPASPRT,ON              AT LEAST ONE PRINT HAS OCCURED  20693000
         L     R1,JSYSLST               LOAD PRINT FILE DEF ADDRESS     20694000
         PUT   (1)                      PUT CURRENT REC & GET NEW ADDR  20695000
         ST    R1,JCURPRT               SAVE NEW BUFFER ADDRESS AND     20696000
PRINT10  EQU   *                                               @AX14816 20697000
         MVI   CC,SPACE1                INIT LINE TO SINGLE SPACE       20698000
         MVI   IMAGE,JBLANK             NOW BLANK LINE                  20699000
         MVC   IMAGE+D1(L'IMAGE-D1),IMAGE  BLANK OUT LINE               20700000
         LR    R11,R1                   RETURN BUFFER ADDRESS TO CALLER 20701000
         B     RETURN                   RETURN                          20702000
         DROP  R1                                                       20703000
         SPACE 3                                                        20704000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - JPUNCH ROUTINE'     20705000
         USING PCHLINE,R1               SET PUNCH LINE BASE             20706000
PUNCH    BAL   R14,SAVE                 GO SAVE REGISTERS               20707000
         GOIF  BYPASPCH,OFF=FIRSTPCH    FIRST PUNCH                     20708000
         L     R1,JCURPCH               GET CURRENT PUNCH BUFFER        20709000
         GOIF  NOSEQ,ON=DONOTSEQ        NOT TO BE SEQUENCED             20710000
         LH    R14,JDECKSEQ             INCREMENT DECK SEQ BY ONE       20711000
         LA    R14,D1(,R14)             ''                              20712000
         STH   R14,JDECKSEQ             ''                              20713000
         CVD   R14,JDWORD               CONVERT TO DECIMAL              20714000
         UNPK  PCHSEQ,JDWORD            UNPACK                          20715000
         NC    PCHSEQ,=8X'0F'           AND OUT ZONES (TO INTERNAL)     20716000
         SR    R14,R14                  ZERO REG                        20717000
         IC    R14,JDECKIDL             GET LENGTH OF DECKID            20718000
         SH    R14,=H'1'                DECREMENT BY ONE                20719000
         BM    NOID                     BR IF NO DECKID                 20720000
         EX    R14,MVCID                MOVE ID TO PCHSEQ               20721000
NOID     TR    PCHSEQ,JTRTABLE          TRANSLATE PCHSEQ TO EXTERNAL    20722000
         B     DONTTR                   DON'T TRANSLATE ANYTHING ELSE   20723000
DONOTSEQ TR    PCHIMAGE,JTRTABLE        TRANSLATE TO EXTERNAL           20724000
DONTTR   GOIF  (JDECK,JLINK),NOTALL=NOALT NOT DECK & LINK               20725000
         LR    R2,R1                    PUT RECORD TO OBJECT FILE TOO   20726000
         L     R1,JSYSLNK               LOAD LINK FILE DEF ADDR         20727000
         PUT   (1)                      LOCATE BUFFER                   20728000
         MVC   PCHIMAGE,D0(R2)          MOVE FROM PUNCH TO LINK BUFFER  20729000
NOALT    GOIF  CLOSPCH,ON=RETURN        FINAL PUNCH (IN CLOSE ROUTINE)  20730000
FIRSTPCH SET   (BYPASPCH,NOSEQ),ON      AT LEAST ONE PUNCH AS OCCURED   20731000
         GOIF  JNOSEQPH,ON=DONTSEQ      RECORD IS NOT TO BE SEQUENCED   20732000
         SET   NOSEQ,OFF                SEQ RECORD NEXT TIME AROUND     20733000
DONTSEQ  L     R1,JSYSLNK               LOAD LINK FILE DEF ADDR         20734000
         GOIF  JDECK,OFF=PUTLINK        NODECK                          20735000
         L     R1,JSYSPCH               LOAD PUNCH FILE DEF ADDR        20736000
PUTLINK  PUT   (1)                      LOCATE BUFFER                   20737000
         ST    R1,JCURPCH               SAVE NEW BUFFER ADDRESS         20738000
         L     R14,JRECPCH              ADD ONE TO PUNCH RECORD COUNT   20739000
         LA    R14,D1(,R14)             ''                              20740000
         ST    R14,JRECPCH              ''                              20741000
         MVI   PCHIMAGE,JBLANK          INIT TO INTERNAL BLANKS         20742000
         MVC   PCHIMAGE+D1(L'PCHIMAGE-D1),PCHIMAGE ''                   20743000
         SET   JNOSEQPH,OFF             RESET NOSEQ SWITCH              20744000
         LR    R11,R1                   RETURN BUFFER ADDR TO CALLER    20745000
         B     RETURN                   RETURN                          20746000
MVCID    MVC   PCHSEQ(*-*),JDECKID     OUT-OF-LINE MVC OF DECKID        20747000
         DROP  R1                       DROP PUNCH LINE BASE            20748000
         SPACE 3                                                        20749000
        TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - DCB OPEN'            20750000
OUTINIT  BAL   R14,SAVE                 GO SAVE REGISTERS               20751000
         GOIF  JOUT2ND,ON=CLOSE         SECOND TIME HERE                20752000
         SET   JOUT2ND,ON               FIRST TIME. SET FLAG            20753000
         SPACE 3                                                        20754000
         TM    D0(R11),BIT0             ANY OVERRIDING DDNAMES          20755000
         BO    NOPARM                   BR IF END OF PARM LIST          20756000
         L     R14,D4(,R11)             PT TO DDNAME LIST               20757000
         USING P,R14                    ESTABLISH PARMLIST BASE         20758000
         LA    R15,P                    CLEAR END-OF-LIST FLAG          20759000
         AH    R15,PLEN                 CALC END OF TABLE (-2)          20760000
         SPACE 1                                                        20761000
         L     R1,JSYSLST               PT TO SYSPRINT DCB              20762000
         LA    R2,PSYSPRIN              PT TO SYSPRINT DDNAME           20763000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20764000
         SPACE 1                                                        20765000
         L     R1,JSYSPCH               PT TO SYSPUNCH DCB              20766000
         LA    R2,PSYSPUNC              PT TO SYSPUNCH DDNAME           20767000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20768000
         SPACE 1                                                        20769000
         L     R1,JSYSLNK               PT TO SYSLIN DCB                20770000
         LA    R2,PSYSGO                PT TO DDNAME                    20771000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20772000
         SPACE 1                                                        20773000
         L     R1,JSYSTRM               PT TO SYSTRM DCB                20774000
         LA    R2,PSYSTERM              PT TO DDNAME                    20775000
         BAL   R9,OVERRIDE              CHECK FOR OVERRIDE              20776000
         DROP  R14                      DROP DSECT BASE                 20777000
NOPARM   DC    0H'0'                    CONTINUE                        20778000
         SPACE 3                                                        20779000
         LM    R1,R2,JOUTOPEN           LOAD ADDR OF OPEN & CLOSE PL    20780000
         GOIF  JTERM,OFF=NOTERM         TERM OPTION ON                  20781000
         GOIF  (JLIST,JDECK,JLINK),ALL=OPEN,     OK ALL ON             X20782000
               ELSE=CHECK               MODIFY PARAMETER LIST FOR OPEN  20783000
NOTERM   GOIF  (JLIST,JDECK,JLINK),NONE=RETURN NO DATA SETS NEEDED      20784000
CHECK    EQU   *                                                        20785000
         SR    R14,R14                  ZERO INDEX                      20786000
         LM    R3,R4,D4(R1)             OPEN PARM LIST (PCH, LNK)       20787000
         LM    R5,R6,D4(R2)             CLOS PARM LIST (PCH, LNK)       20788000
         GOIF  JLIST,OFF=NOPENLST       LIST OPTION OFF                 20789000
         LA    R14,D4(,R14)             INCREMENT PTR (LST ALREADY ST)  20790000
NOPENLST GOIF  JDECK,OFF=NOPENPCH       DECK OPTION OFF                 20791000
         ST    R3,D0(R14,R1)            STORE PCH DCB ADDR (OPEN)       20792000
         ST    R5,D0(R14,R2)            STORE PCH DCB ADDR (CLOSE)      20793000
         LA    R14,D4(,R14)             INCREMENT PTR                   20794000
NOPENPCH GOIF  JLINK,OFF=NOPENLNK       LINK OPTION IS OFF              20795000
         ST    R4,D0(R14,R1)            STORE LNK DCB ADDR (OPEN)       20796000
         ST    R6,D0(R14,R2)            STORE LNK DCB ADDR (CLOSE)      20797000
         LA    R14,D4(,R14)             INCREMENT PTR                   20798000
NOPENLNK GOIF  JTERM,OFF=NOPENTRM       TERM OPTION IS OFF              20799000
         L     R4,D12(R1)               OPEN PARM LIST (TRM)            20800000
         L     R6,D12(R2)               CLOSE PARM LIST (TRM)           20801000
         ST    R4,D0(R14,R1)            STORE TRM DCB ADDR(OPEN)        20802000
         ST    R6,D0(R14,R2)            STORE TRM DCB ADDR(CLOSE)       20803000
         LA    R14,D4(R14)              INCREMENTE POINTER              20804000
NOPENTRM SH    R14,=H'4'                DECREMENTE POINTER              20805000
         LA    R3,D0(R14,R1)            PT TO LAST OPEN PARM            20806000
         OI    D0(R3),BIT0              SET END OF OPEN PARM LIST       20807000
         LA    R3,D0(R14,R2)            POINT TO LAST CLOSE PARM        20808000
         OI    D0(R3),BIT0              SET END OF LIST FLAG            20809000
         SPACE 3                                                        20810000
OPEN     LA    R10,XTPRT                ADDR OF SYSPRINT DCB EXIT       20811000
         LA    R11,XTPCHLIN             ADDR OF SYSPUNCH,LIN DCB EXIT   20812000
         OPEN  MF=(E,(1))               OPEN FILES                      20813000
         SPACE 3                                                        20814000
         B     RETURN                   RETURN                          20815000
         SPACE 3                                                        20816000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - DCB CLOSE'          20817000
CLOSE    GOIF  (JLIST,JDECK,JLINK),ANY=CLOSE1 IF ANY ON CLOSE DATA SETS 20818000
         GOIF  JTERM,OFF=RETURN         IF NONE ON RETURN               20819000
CLOSE1   SET   (CLOSPRT,CLOSPCH,CLOSTRM),ON INDICATE FINAL PRINT & PCH  20820000
         GOIF  JLIST,OFF=NOLIST         LIST OPTION OFF                 20821000
         BAL   R9,PRINT                 FORCE OUT LAST BUFFER           20822000
NOLIST   GOIF  JTERM,OFF=NOJTERM        IS TERM OPTION USED             20823000
         BAL   R9,TSOPRINT              PRINT LAST SYSTERM TOO          20824000
NOJTERM  GOIF  (JDECK,JLINK),NONE=NODKLK DECK & LINK OPTIONS OFF        20825000
         GOIF  BYPASPCH,OFF=NODKLK      NO CARDS PUNCHED                20826000
         BAL   R9,PUNCH                 FORCE OUT LAST BUFFER           20827000
NODKLK   L     R1,JOUTCLOS              CLOSE OUTPUT                    20828000
         CLOSE MF=(E,(1))               ''                              20829000
         SPACE 1                                                        20830000
         L     R1,JSYSLST               PT TO SYSPRINT DCB              20831000
         BAL   R9,FREEPOOL              GO FREE BUFFERS                 20832000
         L     R1,JSYSPCH               PT TO SYSPUNCH DCB              20833000
         BAL   R9,FREEPOOL              GO FREE BUFFERS                 20834000
         L     R1,JSYSLNK               PT TO SYSLIN DCB                20835000
         BAL   R9,FREEPOOL              GO FREE BUFFERS                 20836000
         L     R1,JSYSTRM               PT TO SYSTRM DCB                20837000
         BAL   R9,FREEPOOL              GO FREE BUFFERS                 20838000
         SPACE 1                                                        20839000
         XC    JADOUTCM,JADOUTCM        ZERO ADDRESS FOR ABORT MODULE   20840000
         B     RETURN                   RETURN                          20841000
         SPACE 3                                                        20842000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - DDNAME OVERRIDE ROUT20843000
               TINE AND DCB EXIT ROUTINES'                              20844000
         USING IHADCB,R1                ESTABLISH BASE FOR DCB          20845000
OVERRIDE CR    R2,R15                   PAST END OF LIST                20846000
         BHR   R9                       YES, RETURN                     20847000
         CLC   D0(D8,R2),=8X'00'        IS DDNAME ZERO          OY02543 20848000
         BZR   R9                       YES, RETURN                     20849000
         MVC   DCBDDNAM,D0(R2)          OVERRIDE DDNAME                 20850000
         BR    R9                       RETURN                          20851000
         DROP  R1                       DROP DCB BASE                   20852000
         SPACE 2                                                        20853000
         USING IHADCB,R1                                                20854000
*        DCB EXIT FOR SYSPRINT AND SYSTERM                              20855000
         USING *,R10                    ESTABLISH BASE ADDRESS          20856000
XTPRT    LH    R3,DCBLRECL              LD DEFAULT BLKSIZE              20857000
         NI    DCBRECFM,BITFF-BIT6      TURN OFF M BIT                  20858000
         OI    DCBRECFM,BIT5            TURN ON A BIT                   20859000
         TM    DCBRECFM,BIT0            IS RECORD LENGTH FIXED (F)      20860000
         BO    XTALL10                  YES, GO CHECK FOR RECFM=FB      20861000
         MVI   DCBRECFM,BIT0+BIT3+BIT5  SET RECFM=FBA                   20862000
         B     XTALL10                  GO CHECK BLKSIZE                20863000
         DROP  R10                      DROP BASE                       20864000
         SPACE                                                          20865000
*        DCB EXIT FOR SYSPUNCH & SYSLIN                                 20866000
         USING *,R11                    ESTABLISH BASE ADDRESS          20867000
XTPCHLIN LH    R3,DCBLRECL              LD DEFAULT BLKSIZE              20868000
         NI    DCBRECFM,BITFF-BIT5-BIT6 TURN OFF M & A BITS             20869000
         CLI   DCBRECFM,BIT0            IS RECORD LENGTH FIXED FX0000   20870000
         BE    XTALL10                  YES, GO CHECK FOR RECFMFX0000   20871000
         MVI   DCBRECFM,BIT0+BIT3       SET RECFM=FB                    20872000
         DROP  R11                      DROP BASE                       20873000
         SPACE                                                          20874000
XTALL10  BALR  R15,R0                   ESTABLISH BASE ADDRESS IN REG   20875000
         USING *,R15                    ''                              20876000
         LH    R5,DCBBLKSI              IS BLKSIZE SPECIFIED            20877000
         LTR   R5,R5                    ''                              20878000
         BZ    XTALL30                  NO, GO SET DEFAULT BLKSIZE      20879000
         CR    R3,R5                    BLKSIZE LESS THAN LRECL?        20880000
         BH    XTALL30                  IF SO SET BLKSIZE=LRECL         20881000
         OI    DCBRECFM,BIT3            SET BLOCKED                     20882000
         LR    R3,R5                    SAVE BLKSIZE FOR LATER USE      20883000
         LH    R2,DCBLRECL              GET LOGICAL RECORD LENGTH       20884000
         SR    R4,R4                    ZERO FOR DIVIDE                 20885000
         DR    R4,R2                    R4(REMAINDER)=R4R5 / R2(LRECL)  20886000
         SR    R3,R4                    NOW BLKSIZE IS MULT OF LRECL    20887000
XTALL20  STH   R3,DCBBLKSI              STORE BLKSIZE IN DCB            20888000
         BR    R14                      RETURN TO OPEN                  20889000
XTALL30  NI    DCBRECFM,BITFF-BIT3      SET UNBLOCKED                   20890000
         B     XTALL20                  SET DEFAULT BLKSIZE             20891000
         DROP  R1,R15                   DROP BASES                      20892000
         TITLE '&COMPNM&ASMID - OUTPUT I/O MODULE - FREEPOOL ROUTINE, CO20893000
               ONSTANTS AND PATCH AREA'                                 20894000
         USING IHADCB,R1                ESTABLISH DCB ADDRESSABILITY    20895000
FREEPOOL TM    DCBBUFCB+D3,BIT7         IS THERE A BUFCB                20896000
         BOR   R9                       RETURN IF NO BUFCB              20897000
         FREEPOOL (1)                   FREE BUFFERS IN BUFCB           20898000
         BR    R9                       RETURN                          20899000
         DROP  R1                       DROP DCB BASE                   20900000
         SPACE 3                                                        20901000
*        CONSTANTS                                                      20902000
*                                                                       20903000
CCTRTAB  DC    C'1 0-'                  ASA CC FOR EJECT,SINGLE,DOUBLE X20904000
                                        AND TRIPLE SPACE                20905000
         SPACE 3                                                        20906000
         JPATCH X0H00,3BC               5% PATCH AREA                   20907000
         SPACE 2                                                        20908000
         END   START                                                    20909000
./ ADD NAME=IFOX0J                                                      20910000
         TITLE 'IFOX0J - ASSEMBLER XF PARAMETER OPTIONS'                20911000
*TITLE-  ASSEMBLER XF PARAMETER OPTIONS                               * 20912000
*                                                                     * 20913000
*FUNCTION/OPERATION-                                                  * 20914000
*        A TABLE OF PARAMETER OPTIONS FOR ASSEMBLER XF.  THIS TABLE   * 20915000
*   IS REFERENCED BY THE ASSEMBLER XF INITIALIZATION PHASE (IFOX02).  * 20916000
*   THE PARAMETER OPTIONS ARE THOSE WHICH MAY BE SPECIFIED BY THE     * 20917000
*   PROGRAMMER IN THE 'PARM' FIELD OF THE 'EXEC' STATEMENT.  THIS     * 20918000
*   TABLE ALSO PROVIDES FOR A STANDARD SET OF DEFAULE PARAMETERS WHEN * 20919000
*   NONE IS SPECIFIED.                                                * 20920000
*        A STANDARD VERSION OF THIS TABLE IS FURNISHED WITH THE       * 20921000
*   ASSEMBLER.  HOWEVER, THE SYSTEM PROGRAMMER MAY REASSEMBLE THIS    * 20922000
*   TABLE AND RESPECIFY OTHER DEFAULT OPTIONS TO MEET THE REQUIREMENTS* 20923000
*   OF HIS INSTALLATION.  IN ADDITION, OPTIONS MAY BE 'FIXED' TO      * 20924000
*   PREVENT THEIR MISUSE.  'FIXED' OPTIONS SHOULD BE AVOIDED BECAUSE  * 20925000
*   THEY LIMIT THE PROGRAMMER'S PREROGATIVES.  THEY SHOULD BE USED    * 20926000
*   ONLY WHEN THEIR INVERSE FUNCTION MAY CAUSE INCOMPATIBLE           * 20927000
*   INSTALLATION PROCEDURES.                                          * 20928000
*                                                                     * 20929000
*ENTRY POINTS-                                                        * 20930000
*        IFOX0J00                                                     * 20931000
*                                                                     * 20932000
*INPUT-  N/A                                                          * 20933000
*                                                                     * 20934000
*OUTPUT- N/A                                                          * 20935000
*                                                                     * 20936000
*EXITS. NORMAL-                                                       * 20937000
*        N/A                                                          * 20938000
*                                                                     * 20939000
*EXITS,ERROR-                                                         * 20940000
*        N/A                                                          * 20941000
*                                                                     * 20942000
*EXTERNAL REFERENCES-                                                 * 20943000
*        NONE                                                         * 20944000
*                                                                     * 20945000
*TABLES/WORK AREAS-                                                   * 20946000
*        N/A                                                          * 20947000
*                                                                     * 20948000
*ATTRIBUTES-                                                          * 20949000
*        REFRESHABLE                                                  * 20950000
*                                                                     * 20951000
*NOTES-  THE FORMAT OF THIS TABLE IS DEPENDENT TO THE FORMAT OF THE   * 20952000
*   FOLLOWING FIELDS IN THE ASSEMBLER XF COMMON STORAGE AS DEFINED    * 20953000
*   IN COPY CODE 'JCOMMON'-                                           * 20954000
*        JPARMS   DS    0XL8            INITIAL SETTINGS              * 20955000
*                 DS    X               VERSION IDENTIFICATION        * 20956000
*        JMSGL    DS    X               MSGLEVEL=                     * 20957000
*        JLNCT    DS    H               LINECNT=                      * 20958000
*        JWRKSIZE DS    A               WORKSIZE=              FX0000   20959000
*        *                                                            * 20960000
*        JPARM    DS    0A              PARAMETER OPTIONS (1/2/3/4)   * 20961000
*        *                                                            * 20962000
         EJECT                                                          20963000
         JPARM                                                          20964000
         END                                                            20965000
./ ADD NAME=IFNX1J                                                      20966000
         JHEAD 'EDIT PHASE DICTIONARY ROUTINES',                       X20967000
               PHASEID=X1J,                                            X20968000
               LEVEL=10                                                 20969000
         EJECT                                                          20970000
*   THE EDIT PHASE DICTIONARY ROUTINES ARE A SET OF SUBROUTINES.      * 20971000
*   THESE SUBROUTINES PROVIDE ALL THE FUNCTIONS REQUIRED BY THE EDIT  * 20972000
*   PHASE RELATIVE TO THE COLLECTION TIME DICTIONARIES, CALLED        * 20973000
*   DIRECTORIES. THE FUNCTIONS PROVIDED ARE- INITIALIZATION,          * 20974000
*   BUILDING, REFERENCING, AND OUTPUTTING. THESE FUNCTIONS ARE        * 20975000
*   REQUESTED DURING THE CONVERSION OF SOURCE INPUT TEXT FOR BOTH     * 20976000
*   MACRO DEFINITIONS AND OPEN CODE INTO EDITED TEXT TO BE PROCESSED  * 20977000
*   BY THE GENERATE PHASE. THE PERTINENT DICTIONARIES ARE- OP CODE    * 20978000
*   TABLE, MACRO DEFINITION DIRECTORY, VARIABLE SYMBOL DIRECTORY,     * 20979000
*   SEQUENCE SYMBOL REFERENCE DIRECTORY, ORDINARY SYMBOL REFERENCE    * 20980000
*   DIRECTORY, AND OPSYN TABLE.                                       * 20981000
*                                                                     * 20982000
*ENTRY POINT-                                                         * 20983000
*        DICTENTR                                                     * 20984000
*              THE CALLING SEQUENCE IS-                               * 20985000
*                  LA    RETURN,ENTRY                                 * 20986000
*                  L     LINK,POINTER                                 * 20987000
*                  BAL   RETURN,0(RETURN,LINK)                        * 20988000
*              WHERE LINK IS THE STANDARD REGISTER FOR THE ADDRESS    * 20989000
*                             OF THE CALLED ROUTINE                   * 20990000
*                    POINTER CONTAINS THE ADDRESS OF THE DICTIONARY   * 20991000
*                             ENTRY ROUTINE                           * 20992000
*                    ENTRY IS THE NAME OF THE DICTIONARY FUNCTION     * 20993000
*                             REQUIRED (ENTRY NAMES ARE EQUATED TO    * 20994000
*                             ABSOLUTE VALUES USED AS DISPLACEMENTS   * 20995000
*                             INTO A BRANCH TABLE)                    * 20996000
*                    RETURN IS THE STANDARD REGISTER FOR THE RETURN   * 20997000
*                             ADDRESS                                 * 20998000
*                                                                     * 20999000
*INPUT-                                                               * 21000000
*   ITEMS EXTRACTED FROM THE SOURCE TEXT BY THE EDITOR, TO BE         * 21001000
*   EXCHANGED FOR POINTERS TO GENERATION TIME DICTIONARIES (IN THE    * 21002000
*   CASES OF MACRO NAMES, MACRO PARAMETERS, GLOBAL VARIABLES, LOCAL   * 21003000
*   VARIABLES, SEQUENCE SYMBOLS, AND OPEN CODE ORDINARY SYMBOLS       * 21004000
*   USED IN ATTRIBUTE REFERENCES OR IN MACRO INSTRUCTION OPERANDS)    * 21005000
*   OR POINTERS TO OP CODE TABLE ENTRIES (IN THE CASE OF OP CODES).   * 21006000
*                                                                     * 21007000
*OUTPUT-                                                              * 21008000
*   FILE 2 - TEXT SEGMENT DICTIONARY FILE FOR EACH MACRO DEFINITION   * 21009000
*          - TEXT SEGMENT DICTIONARY FILE FOR OPEN CODE               * 21010000
*   FILE 3 - ORDINARY SYMBOL DEFINITION FILE                          * 21011000
*          - MACRO DEFINITION DIRECTORY/OPSYN TABLE                   * 21012000
*                                                                     * 21013000
*EXTERNAL ROUTINES-                                                   * 21014000
*   NONE                                                              * 21015000
*                                                                     * 21016000
*                                                                     * 21017000
*EXITS,NORMAL-                                                        * 21018000
*   RETURN TO THE EDITOR WITH THE BYTE 'CONCODE' SET TO A ZERO        * 21019000
*   VALUE.                                                            * 21020000
*                                                                     * 21021000
*EXITS,ERROR-                                                         * 21022000
*   RETURN TO THE EDITOR WITH THE BYTE 'CONCODE' SET TO A NON-ZERO    * 21023000
*   VALUE, THE SPECIFIC VALUE INDICATING THE ERROR DETECTED.          * 21024000
*                                                                     * 21025000
*TABLES/WORK AREAS-                                                   * 21026000
*   MACRO DEFINITION DIRECTORY - A CHAINED TABLE CONTAINING AN        * 21027000
*        ENTRY FOR EACH UNIQUE MACRO NAME ENCOUNTERED IN THE TEXT     * 21028000
*        OF ALL MACRO DEFINITIONS AND OPEN CODE, AND AN ENTRY FOR     * 21029000
*        OPEN CODE (MERGED WITH THE OPSYN TABLE).                     * 21030000
*   VARIABLE SYMBOL DIRECTORY - A CHAINED TABLE CONTAINING AN         * 21031000
*        ENTRY FOR EACH VARIABLE SYMBOL (SYSTEM VARIABLE, GLOBAL      * 21032000
*        VARIABLE, LOCAL VARIABLE, OR SYMBOLIC PARAMETER)             * 21033000
*        ENCOUNTERED IN THE TEXT OF THE MACRO DEFINITION CURRENTLY    * 21034000
*        BEING EDITED OR IN THE TEXT OF OPEN CODE.                    * 21035000
*   SEQUENCE SYMBOL REFERENCE DIRECTORY - A REVOLVING TABLE           * 21036000
*        CONTAINING AN ENTRY FOR THE 10 MOST RECENTLY REFERENCED      * 21037000
*        SEQUENCE SYMBOLS ENCOUNTERED IN THE TEXT OF A MACRO          * 21038000
*        DEFINITION OR OF OPEN CODE.                                  * 21039000
*   ORDINARY SYMBOL REFERENCE DIRECTORY - A REVOLVING TABLE CONTAIN-  * 21040000
*        ING AN ENTRY FOR THE 10 MOST RECENTLY REFERENCED ORDINARY    * 21041000
*        SYMBOLS ENCOUNTERED IN ATTRIBUTE REFERENCES OR IN MACRO      * 21042000
*        INSTRUCTION OPERANDS.                                        * 21043000
*   OP CODE TABLE - A CHAINED TABLE CONTAINING AN ENTRY FOR EACH      * 21044000
*        OF THE DEFINED ASSEMBLER AND MACHINE OPERATION CODES.        * 21045000
*   OPSYN TABLE - A CHAINED TABLE CONTAINING AN ENTRY FOR EACH        * 21046000
*        UNIQUE MNEMONIC AFFECTED BY AN OPSYN STATEMENT (MERGED       * 21047000
*        WITH THE MACRO DEFINITION DIRECTORY).                        * 21048000
*                                                                     * 21049000
*ATTRIBUTES-                                                          * 21050000
*   REFRESHABLE                                                       * 21051000
*                                                                     * 21052000
*NOTES-                                                               * 21053000
*                                                                     * 21054000
*                                                                     * 21055000
*                                                                     * 21056000
         EJECT                                                          21057000
         COPY JCOMMON                                                   21058000
         EJECT                                                          21059000
         COPY  EDSECT                                                   21060000
         EJECT                                                          21061000
*                                                                       21062000
* THIS DSECT MAPS ALL ENTRIES IN THE VARIABLE SYMBOL DIRECTORY.         21063000
*                                                                       21064000
VSDENTRY DSECT                                                          21065000
VCHAIN   DS    XL3                      CHAIN POINTER     3 BYTES       21066000
VFLAGS   DS    X                        ENTRY FLAGS       1 BYTE        21067000
VLNGTH   DS    X                        SYMBOL LENGTH     1 BYTE        21068000
VSYMBL   EQU   *                        VARIABLE SYMBOL 1-7 BYTES       21069000
         ORG   VSDENTRY                 ORIGIN 0                        21070000
VTFVAL   DS    X                        META TEXT FLAG    1 BYTE        21071000
VGVECTR  DS    XL3                      GBL VECTOR PTR    3 BYTES       21072000
         ORG   VGVECTR                  ORIGIN 1                        21073000
VLDICTR  DS    XL3                      LCL DICTNRY PTR   3 BYTES       21074000
         ORG   VGVECTR                  ORIGIN 1                        21075000
VPVECTR  DS    XL3                      PARAM VCTR PTR    3 BYTES       21076000
VGDIMEN  DS    XL2                      GBL DIMEN/SUBSC   2 BYTES       21077000
         ORG   VGDIMEN                  ORIGIN 4                        21078000
VLDIMEN  DS    XL2                      LCL DIMEN/SUBSC   2 BYTES       21079000
         ORG   VGDIMEN                  ORIGIN 4                        21080000
VPPAD    DS    XL2                      PARAM TERM PAD    2 BYTES       21081000
*                                                                       21082000
* THIS DSECT MAPS THE GLOBAL VARIABLE ENTRY IN THE VARIABLE SYMBOL      21083000
*            DIRECTORY.                                                 21084000
*                                                                       21085000
GBLNTRY  DSECT                                                          21086000
GCHAIN   DS    XL3                      CHAIN POINTER     3 BYTES       21087000
GFLAGS   DS    X                        FLAGS             1 BYTE        21088000
GLNGTH   DS    X                        SYMBOL LENGTH     1 BYTE        21089000
GSYMBL   EQU   *                        VARIABLE SYMBOL 2-8 BYTES       21090000
         ORG   GBLNTRY                  ORIGIN 0                        21091000
GTFVAL   DS    X                        TEXT FLAG VALUE   1 BYTE        21092000
GVECTR   DS    XL3                      VECTOR POINTER    3 BYTES       21093000
GDIMEN   DS    XL2                      DIMENSION         2 BYTES       21094000
*                                                                       21095000
* THIS DSECT MAPS THE LOCAL VARIABLE ENTRY IN THE VARIABLE SYMBOL       21096000
*            DIRECTORY.                                                 21097000
*                                                                       21098000
LCLNTRY  DSECT                                                          21099000
LCHAIN   DS    XL3                      CHAIN POINTER     3 BYTES       21100000
LFLAGS   DS    X                        FLAGS             1 BYTE        21101000
LLNGTH   DS    X                        SYMBOL LENGTH     1 BYTE        21102000
LSYMBL   EQU   *                        VARIABLE SYMBOL 2-8 BYTES       21103000
         ORG   LCLNTRY                  ORIGIN 0                        21104000
LTFVAL   DS    X                        TEXT FLAG VALUE   1 BYTE        21105000
LDICTR   DS    XL3                      DICTIONARY PTR    3 BYTES       21106000
LDIMEN   DS    XL2                      DIMENSION         2 BYTES       21107000
*                                                                       21108000
* THIS DSECT MAPS THE MACRO PARAMETER ENTRY IN THE VARIABLE SYMBOL      21109000
*            DIRECTORY.                                                 21110000
*                                                                       21111000
PRMNTRY  DSECT                                                          21112000
PCHAIN   DS    XL3                      CHAIN POINTER     3 BYTES       21113000
PFLAGS   DS    X                        FLAGS             1 BYTE        21114000
PLNGTH   DS    X                        SYMBOL LENGTH     1 BYTE        21115000
PSYMBL   EQU   *                        VARIABLE SYMBOL 2-8 BYTES       21116000
         ORG   PRMNTRY                  ORIGIN 0                        21117000
PTFVAL   DS    X                        TEXT FLAG VALUE   1 BYTE        21118000
PVECTR   DS    XL3                      VECTOR POINTER    3 BYTES       21119000
PPAD     DS    XL2                      PADDING           2 BYTES       21120000
*                                                                       21121000
* THIS DSECT MAPS THE OP CODE TABLE ENTRY.                              21122000
*                                                                       21123000
OPNTRY   DSECT                                                          21124000
OCHAIN   DS    XL2                      CHAIN POINTER     2 BYTES       21125000
OFLAGS   DS    X                        FLAGS             1 BYTE        21126000
OMNEM    EQU   *                        MNEMONIC        1-8 BYTES       21127000
         ORG   OPNTRY                   ORIGIN 0                        21128000
OFLAGA   DS    X                        SWITCH CODES      1 BYTE        21129000
OINTCD   DS    X                        INTERNAL OP COD   1 BYTE        21130000
OMASK    DS    X                        MASK, EXT MNEMS   1 BYTE        21131000
OINTCD2  EQU   OMASK                    OP (2ND BYTE)     1 BYTE        21132000
*                                                                       21133000
* THIS DSECT MAPS THE MACRO DEFINITION DIRECTORY ENTRY.                 21134000
*                                                                       21135000
MDDNTRY  DSECT                                                          21136000
MCHAIN   DS    XL3                      CHAIN PTR         3 BYTES       21137000
MFLAGS   DSW   TSEDIT,                  ON-SEGMENT EDITED              X21138000
               OCTS,                    ON-OPEN CODE ENTRY             X21139000
               FLUSH,                   ON-MACRO FLUSHED               X21140000
               DELETE,,                 ON-MACRO DELETED VIA OPSYN     X21141000
               MNL1,MNL2,MNL3           MACRO NAME LENGTH               21142000
MSYMBL   DS    XL8                      SYMBOL (PADDED)   8 BYTES       21143000
MVECTR   DS    XL3                      VECTOR POINTER    3 BYTES       21144000
MTXTNP   DS    XL8                      TEXT FILE N/P     8 BYTES       21145000
MTSDNP   DS    XL8                      DICT FILE N/P     8 BYTES       21146000
MGBLSZ   DS    XL3                      GBL VCTR SIZE     3 BYTES       21147000
MSEQSZ   DS    XL3                      SEQ SYM DICT SIZE 3 BYTES       21148000
MLCLSZ   DS    XL3                      LCL DICT SIZE     3 BYTES       21149000
MDDEND   EQU   *                                                        21150000
*                                                                       21151000
* THIS DSECT MAPS THE OPSYN TABLE ENTRY.                                21152000
*                                                                       21153000
OPSYNTRY DSECT                                                          21154000
OPSYNCH  DS    XL3                      CHAIN POINTER  3 BYTES          21155000
OPSYNFLG DSW   ,,,,                     ROOM FOR OP CODE FLAGS         X21156000
               OMAC,                    MACRO OPSYN ENTRY              X21157000
               ODEL,                    DELETED OPSYN ENTRY            X21158000
               OPREV                    PREVIOUS OPSYN ENTRY USED       21159000
OPSYNATT DS    XL3                      ATTRIBUTES                      21160000
         ORG   OPSYNATT                 OVERLAY WITH ALTERNATE          21161000
OPSYNCHN DS    XL3                      MACRO CHAIN POINTER             21162000
ONAMEL   DS    XL1                      NAME LENGTH                     21163000
ONAME    DS    XL8                      NAME                            21164000
OPSYND   EQU   *                        END OF DSECT                    21165000
OPSYNLN  EQU   OPSYND-OPSYNTRY          OPSYN ENTRY LENGTH              21166000
*                                                                       21167000
* THIS DSECT MAPS THE SEQUENCE SYMBOL REFERENCE DIRECTORY ENTRY.        21168000
*                                                                       21169000
SSDIR    DSECT                                                          21170000
SSSYM    DS    XL8                      SEQ SYMB (PADDED) 8 BYTES       21171000
STFVAL   DS    X                        TEXT FLAG VALUE   1 BYTE        21172000
SSRDP    DS    XL3                      DICT POINTER      3 BYTES       21173000
SSPAD    DS    XL2                      PADDING           2 BYTES       21174000
SSDIRND  EQU   *                                                        21175000
*                                                                       21176000
* THIS DSECT MAPS THE ORDINARY SYMBOL REFERENCE DIRECTORY ENTRY.        21177000
*                                                                       21178000
OSDIR    DSECT                                                          21179000
OSSYM    DS    XL8                      ORD SYMB (PADDED) 8 BYTES       21180000
OTFVAL   DS    X                        TEXT FLAG VALUE   1 BYTE        21181000
OSRDP    DS    XL3                      DICT POINTER      3 BYTES       21182000
OSPAD    DS    XL2                      PADDING           2 BYTES       21183000
OSDIRND  EQU   *                                                        21184000
*                                                                       21185000
* THIS DSECT MAPS THE LOGICAL RECORD PUT TO THE TEXT SEGMENT          * 21186000
*            DICTIONARY FILE FOR A GLOBAL DEFINITION.                 * 21187000
*                                                                       21188000
GBLDEF   DSECT                                                          21189000
GDEFRL   DS    XL2                      RECORD LENGTH     2 BYTES       21190000
GDEFRT   DS    X'00'                    RECORD TYPE       1 BYTE        21191000
GDEFF    DS    X                        FLAGS             1 BYTE        21192000
GDEFSL   DS    X                        SYMBOL LENGTH     1 BYTE        21193000
GDEFVS   EQU   *                        VARIABLE SYMBOL 2-8 BYTES       21194000
         ORG   GBLDEF                   ORIGIN 0                        21195000
GDEFTF   DS    X                        TEXT FLAG VALUE   1 BYTE        21196000
GDEFVP   DS    XL3                      VECTOR POINTER    3 BYTES       21197000
GDEFD    DS    XL2                      DIMENSION         2 BYTES       21198000
*                                                                       21199000
* THIS DSECT MAPS THE LOGICAL RECORD PUT TO THE TEXT SEGMENT          * 21200000
*            DICTIONARY FILE FOR A SEQUENCE SYMBOL DEFINITION.        * 21201000
*                                                                       21202000
SSDEF    DSECT                                                          21203000
SDEFRL   DS    XL2                      RECORD LENGTH     2 BYTES       21204000
SDEFRT   DS    X'04'                    RECORD TYPE       1 BYTE        21205000
SDEFNP   DS    XL8                      NOTE/POINT ADDR   8 BYTES       21206000
SDEFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        21207000
SDEFSS   EQU   *                        SEQUENCE SYMBOL 2-8 BYTES       21208000
*                                                                       21209000
* THIS DSECT MAPS THE LOGICAL RECORD PUT TO THE TEXT SEGMENT          * 21210000
*            DICTIONARY FILE FOR A SEQUENCE SYMBOL REFERENCE.         * 21211000
*                                                                       21212000
SSREF    DSECT                                                          21213000
SREFRL   DS    XL2                      RECORD LENGTH     2 BYTES       21214000
SREFRT   DS    X'08'                    RECORD TYPE       1 BYTE        21215000
SREFDP   DS    XL3                      DICTIONARY PTR    3 BYTES       21216000
SREFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        21217000
SREFSS   EQU   *                        SEQUENCE SYMBOL 2-8 BYTES       21218000
*                                                                       21219000
* THIS DSECT MAPS THE LOGICAL RECORD PUT TO THE TEXT SEGMENT          * 21220000
*            DICTIONARY FILE FOR AN ORDINARY SYMBOL REFERENCE.        * 21221000
*                                                                       21222000
OSREF    DSECT                                                          21223000
OREFRL   DS    XL2                      RECORD LENGTH     2 BYTES       21224000
OREFRT   DS    X'0C'                    RECORD TYPE       1 BYTE        21225000
OREFDP   DS    XL3                      DICTIONARY PTR    3 BYTES       21226000
OREFSL   DS    XL1                      SYMBOL LENGTH     1 BYTE        21227000
OREFOS   EQU   *                        ORDINARY SYMBOL 1-8 BYTES       21228000
*                                                                       21229000
* THIS DSECT MAPS THE LOGICAL RECORD PUT TO THE ORDINARY SYMBOL         21230000
*            DEFINITION FILE.                                           21231000
*                                                                       21232000
         COPY  JTEXT                                                    21233000
*                                                                       21234000
* THIS DSECT MAPS THE END-OF-SEGMENT RECORD PUT TO THE TEXT SEGMENT     21235000
*            DICTIONARY FILE.                                           21236000
*                                                                       21237000
ENDSEG   DSECT                                                          21238000
ESEGRL   DS    XL2                      RECORD LENGTH     2 BYTES       21239000
ESEGRT   DS    X'10'                    RECORD TYPE       1 BYTE        21240000
*                                                                       21241000
* THIS DSECT MAPS THE END-OF-FILE RECORD PUT TO THE TEXT SEGMENT        21242000
*            DICTIONARY FILE AND THE ORDINARY SYMBOL DEFINITION FILE.   21243000
*                                                                       21244000
ENDFIL   DSECT                                                          21245000
EFILRL   DS    XL2                      RECORD LENGTH     2 BYTES       21246000
EFILRT   DS    X'FF'                    RECORD TYPE       1 BYTE        21247000
*                                                                       21248000
         COPY  JTMTXT                                                   21249000
         EJECT                                                          21250000
         COPY  JERMSGCD                                                 21251000
         EJECT                                                          21252000
WORK4    EQU   R6                       SCRATCH REGISTER                21253000
MODCOMM  EQU   R2                       PTR REGISTER, EDSECT BASE       21254000
LNGTHREG EQU   R3                       SYMBOL LENGTH REGISTER          21255000
PARMREG  EQU   R4                       SYMBOL POINTER REGISTER         21256000
VSDPTR   EQU   R5                       PTR TO ENTRY IN VSD             21257000
SSRDPTR  EQU   R5                       PTR TO ENTRY IN SSRD            21258000
OCHNPTR  EQU   R5                       PTR TO ENTRY IN OP CODE TABLE   21259000
WORK3    EQU   R5                       SCRATCH REGISTER                21260000
WORK2    EQU   R6                       SCRATCH REGISTER                21261000
WORK1    EQU   R7                       SCRATCH REGISTER                21262000
RTNLNK   EQU   R9                       LINKAGE REGISTER                21263000
BUFPTR   EQU   R11                      PTR TO RECORD IN BUFFER         21264000
EOPAIR1  EQU   R14                      EVEN REGISTER OF PAIR           21265000
HASHO    EQU   R14                      OP CODE TABLE HASH VALUE REG    21266000
HASHV    EQU   R15                      VSD HASH VALUE REGISTER         21267000
EOPAIR2  EQU   R15                      ODD REGISTER OF PAIR            21268000
SSRDNE   EQU   10                       NO. OF SSRD ENTRIES             21269000
SSRDEL   EQU   SSDIRND-SSDIR            LENGTH OF AN SSRD ENTRY         21270000
SSRDLNGT EQU   SSRDNE*SSRDEL            LENGTH OF WHOLE SSRD            21271000
OSRDPTR  EQU   SSRDPTR                  PTR TO ENTRY IN OSRD            21272000
OSRDNE   EQU   SSRDNE                   NO. OF OSRD ENTRIES             21273000
OSRDEL   EQU   SSRDEL                   LENGTH OF AN OSRDENTRY          21274000
OSRDLNGT EQU   SSRDLNGT                 LENGTH OF WHOLE OSRD            21275000
OSALNGT  EQU   6                        LENGTH OF ORD SYMB ATTRIBUTES   21276000
GDEFTYPE EQU   0                        TYPE FOR GBL DEFIN RCD          21277000
SDEFTYPE EQU   4                        TYPE FOR SEQ SYMB DEFIN RCD     21278000
SSREFTYP EQU   8                        TYPE FOR SEQ SYMB REFER RCD     21279000
OSREFTYP EQU   12                       TYPE FOR ORD SYMB REFER RCD     21280000
ESEGTYPE EQU   16                       TYPE FOR END-OF-SEGMENT RCD     21281000
EFILTYPE EQU   255                      TYPE FOR END-OF-FILE RCD        21282000
MINSPACE EQU   512                      MINIMUM WORK SPACE IN DBL WDS   21283000
PVPTRLNG EQU   3                        LENGTH OF ENTRY IN PARAM VCTRS  21284000
GVPTRLNG EQU   3                        LENGTH OF ENTRY IN GBL VECTOR   21285000
VSDHTLNT EQU   128*3                    LENGTH OF VAR SYMB DIR HSH TBL  21286000
MDVEL    EQU   19                       LENGTH OF ENTRY IN MDV          21287000
SAVMDDPT EQU   JDPASS                   SAVE AREA, MDD ADDRESS          21288000
SAVMDDLN EQU   JDPASS+D8                SAVE AREA, MDD LENGTH           21289000
SAVMDDCN EQU   JDPASS+D12               SAVE AREA, MDD ENTRY CHAIN      21290000
SAVMDDCT EQU   JDPASS+D16               SAVE AREA, MDD ENTRY COUNT      21291000
SAVOPSCN EQU   JDPASS+D20               SAVE AREA, OPSYN ENTRY CHAIN    21292000
PAIR1E   EQU   R4                       EVEN REGISTER OF PAIR           21293000
PAIR1O   EQU   R5                       ODD REGISTER OF PAIR            21294000
PAIR2E   EQU   R6                       EVEN REGISTER OF PAIR           21295000
PAIR2O   EQU   R7                       ODD REGISTER OF PAIR            21296000
VSDEL    EQU   19                       MAX, LENGTH OF VSD ENTRY        21297000
MINRECSZ EQU   18                       MINIMUM I/O LENGTH              21298000
WORK5    EQU   R1                       SCRATCH REGISTER                21299000
NAMEPTR  EQU   R5                       OPSYN SYNONYM PTR REGISTER      21300000
ENTRYPTR EQU   R6                       PTR TO ENTRY IN OPSYN TABLE     21301000
SCANPTR  EQU   R7                       PTR TO SYNONYM ENTRY REGISTER   21302000
D256     EQU   256                      SYMBOLIC SDT (256)              21303000
         EJECT                                                          21304000
         JCSECT (X1J00)                                                 21305000
         JMODID                                                         21306000
*DICTIONARY ENTRY ROUTINE - ALL CALLS TO THE EDIT PHASE DICTIONARY    * 21307000
*   ROUTINES ENTER THROUGH THE FOLLOWING BRANCH TABLE WHICH PROVIDES  * 21308000
*   THE LINK TO THE REQUIRED ROUTINE.                                 * 21309000
*                                                                     * 21310000
         USING DICTENTR,R12                                             21311000
DICTENTR B     DICTSAVE                 GO DIRECTLY TO COMMON ENTRY     21312000
         DC    AL2(PHASENT-DICTENTR)    DISPL TO PHASENT ROUTINE        21313000
         DC    AL2(MACRENT-DICTENTR)    DISPL TO MACRENT ROUTINE        21314000
         DC    AL2(MACREND-DICTENTR)    DISPL TO MACRENT  ROUTINE       21315000
         DC    AL2(OPENENT-DICTENTR)    DISPL TO OPENENT  ROUTINE       21316000
         DC    AL2(OPENEND-DICTENTR)    DISPL TO OPENEND  ROUTINE       21317000
         DC    AL2(VARBSYMR-DICTENTR)   DISPL TO VARBSYMR ROUTINE       21318000
         DC    AL2(SEQSYMBR-DICTENTR)   DISPL TO SEQSYMBR ROUTINE       21319000
         DC    AL2(SEQSYMBD-DICTENTR)   DISPL TO SEQSYMBD ROUTINE       21320000
         DC    AL2(ORDSYMBR-DICTENTR)   DISPL TO ORDSYMBR ROUTINE       21321000
         DC    AL2(ORDSYMBD-DICTENTR)   DISPL TO ORDSYMBD ROUTINE       21322000
         DC    AL2(VARBSYMD-DICTENTR)   DISPL TO VARBSYMD ROUTINE       21323000
         DC    AL2(OPERCODE-DICTENTR)   DISPL TO OPERCODE ROUTINE       21324000
         DC    AL2(OPSYNBLD-DICTENTR)   DISPL TO OPSYNBLD ROUTINE       21325000
         SPACE 5                                                        21326000
         JENTRY (X1J01=DICTENTR)                                        21327000
         EJECT                                                          21328000
*                                                                       21329000
* THIS SUBROUTINE IS USED BY ALL THE DICTIONARY ROUTINES TO SAVE        21330000
*        REGISTERS AND ESTABLISH ADDRESSABILITY.                        21331000
*                                                                       21332000
DICTSAVE STM   R2,R9,REGSTACK           SAVE REGISTER FOR EDITOR        21333000
         LR    R8,R12                   SET UP BASE REGISTER            21334000
         USING DICTENTR,R8                                              21335000
         DROP  R12                                                      21336000
         LH    R9,DDNDX                 PICK UP ENTRY INDICATOR         21337000
         LH    R9,DICTENTR+D4(R9)       GET DISPL TO REQ'D ROUTINE      21338000
         B     DICTENTR(R9)             LINK TO DICTIONARY ROUTINE      21339000
         SPACE 10                                                       21340000
*                                                                       21341000
* THIS ROUTINE IS THE COMMON EXIT POINT FOR THE DICTIONARY ROUTINES.    21342000
*                                                                       21343000
DICTEXIT LM    R2,R9,REGSTACK           RESTORE EDITOR'S REGISTERS      21344000
         BR    R9                       RETURN TO EDITOR                21345000
         EJECT                                                          21346000
*PHASENT - THIS ROUTINE IS CALLED AT THE START OF THE EDIT PHASE.     * 21347000
*   ITS FUNCTION IS TO GET AND ALLOCATE THE SPACE REQUIRED FOR THE    * 21348000
*   VARIOUS COLLECTION TIME DICTIONARIES, TO PERFORM THE GENERAL      * 21349000
*   INITIALIZATION FOR THOSE DICTIONARIES, AND TO INITIALIZE THE      * 21350000
*   MODULE COMMON SPACE USED BY ALL THE EDIT PHASE DICTIONARY         * 21351000
*   ROUTINES.                                                         * 21352000
*        INPUT - NONE.                                                * 21353000
*        OUTPUT - NONE.                                               * 21354000
*                                                                     * 21355000
PHASENT  EQU   *                                                        21356000
         XC    DICTCOMS(DICTCOME-DICTCOMS),DICTCOMS INITIALIZE COMMON   21357000
         LH    R11,=H'32000'            SET UP MAX SPACE VALUE          21358000
         JGETCORE MINDBL=MINSPACE,MAXDBL=(R11) GET FREE SPACE           21359000
         ST    R10,FREESTRT             KEEP ADDR FOR LATER RELEASE     21360000
         AR    R11,R10                  GET HIGH BYTE ADDR AND SAVE AS  21361000
         ST    R11,MDDSTRT              MACRO DEF DIR BASE ADDR         21362000
         ST    R11,MDDSLOT              SAVE MDD PTR FOR FIRST MACRO    21363000
         ST    R10,SSRDSTRT             SAVE SEQ SYMB REF DIR PTR       21364000
         LA    R10,SSRDLNGT(,R10)       DISPLACE BY SEQ SYMB REF DIR    21365000
         ST    R10,OSRDSTRT             SAVE ORD SYMB REF DIR PTR       21366000
         MVI   D0(R10),JBLANK           INSERT CHARACTER TO CLEAR       21367000
         MVC   D1(OSRDLNGT-D1,R10),D0(R10) ORDINARY SYMBOL REFER DIRECT 21368000
         LA    R10,OSRDLNGT(,R10)       DISPLACE BY ORD SYMB REF DIR    21369000
         ST    R10,VSDSTRT              SAVE VAR SYMB DIR BASE ADDR     21370000
         XC    D0(VSDHTLNT-256,R10),D0(R10)  CLEAR VSD HASH TABLE,      21371000
         XC    VSDHTLNT-256(256,R10),VSDHTLNT-256(R10) PARTS 1 AND 2    21372000
         MVC   GTMVALOC,=F'19'          INITIALIZE MDV POINTER          21373000
         MVC   SSDLNGTH(D12),=AL1(0,L'JNOTEVAL,JTMSEQ,SSREFTYP,0,0,0,0,X21374000
               0,OSALNGT,JTMOSA,OSREFTYP) SET UP TABLE DATA FOR SYMBOL X21375000
               REFERENCES - SEQUENCE AND ORDINARY                       21376000
         B     DICTEXIT                 RETURN                          21377000
         EJECT                                                          21378000
*MACRENT - THIS ROUTINE IS CALLED AT THE START OF EDITING A MACRO     * 21379000
*   DEFINITION. ITS FUNCTION IS TO INITIALIZE THAT PART OF MODULE     * 21380000
*   COMMON USED IN EDITING MACRO DEFINITIONS, TO INITIALIZE THE       * 21381000
*   VARIABLE SYMBOL DIRECTORY, TO INITIALIZE THE SEQUENCE SYMBOL      * 21382000
*   REFERENCE DIRECTORY, TO INITIALIZE THE TEXT SEGMENT DICTIONARY    * 21383000
*   FILE, AND TO NOTE THE START OF THE MACRO DEFINITION TEXT FOR      * 21384000
*   THE ENTRY IN THE MACRO DEFINITION DIRECTORY.                      * 21385000
*        INPUT - THE 'MACRO' STATEMENT HAS BEEN PUT TO THE TEXT       * 21386000
*                FILE PRIOR TO ENTRY.                                 * 21387000
*        OUTPUT - NONE.                                               * 21388000
*                                                                     * 21389000
MACRENT  EQU   *                                                        21390000
         XC    MDINITS(TSINITE-MDINITS),MDINITS REINITIALIZE COMMON     21391000
         BAL   WORK3,COMNINIT           GO TO COMMON INITIALIZATION     21392000
         JNOTE FILE=FILE1               NOTE THE TEXT FILE              21393000
         MVC   NOTESAVE,JNOTEVAL        SAVE N/P ADDR FOR MDD ENTRY     21394000
         LA    WORK5,SYSNDX             POINT TO SYST LCL, GBL LIST     21395000
         B     VSDINIT                  GO TO ENTER THEN IN VSD         21396000
         EJECT                                                          21397000
*MACREND - THIS ROUTINE IS CALLED AT THE END OF EDITING A MACRO       * 21398000
*   DEFINITION. FOR A MACRO SUCCESSFULLY EDITED, ITS FUNCTION IS TO   * 21399000
*   CLOSE OUT THE TEXT SEGMENT DICTIONARY FILE, TO INSERT THE LOCAL   * 21400000
*   DICTIONARY, GLOBAL VECTOR, AND SEQUENCE SYMBOL REFERENCE DICTION- * 21401000
*   ARY ALLOCATIONS IN THE ENTRY FOR THE MACRO DEFINITION IN THE      * 21402000
*   MACRO DEFINITION DIRECTORY, TO INSERT THE POINTER TO THE MACRO    * 21403000
*   DEFINITION EDITED TEXT AND THE POINTER TO THE TEXT SEGMENT        * 21404000
*   DICTIONARY FILE SEGMENT FOR THE MACRO DEFINITION IN THE ENTRY     * 21405000
*   FOR THE MACRO DEFINITION IN THE MACRO DEFINITION DIRECTORY AND    * 21406000
*   TO FLAG THE MACRO AS EDITED. FOR A MACRO NOT SUCCESSFULLY EDITED, * 21407000
*   ITS FUNCTION IS TO FLAG THE MACRO AS AN UNDEFINED OP CODE AND     * 21408000
*   TO FLAG THE MACRO AS EDITED. IF LIBRARY MACROS ARE BEING EDITED,  * 21409000
*   THE NEXT NAME IS RETURNED TO THE EDITOR.                          * 21410000
*        INPUT - IF 'SKPMND' IS ON, 'SNOSMCRO', 'SBDPROTO', OR        * 21411000
*                'SNOSYSMD' INDICATE THE CAUSE FOR ABORTING THE       * 21412000
*                MACRO DEFINITION.                                    * 21413000
*        OUTPUT - NONE.                                               * 21414000
*                                                                     * 21415000
MACREND  EQU   *                                                        21416000
         GOIF  SKPMND,OFF=MRSKPA        BRANCH IF NORMAL END OF EDIT    21417000
         GOIF  SSYSMD,ON=MRSKP          SKIP IF EDITING SYS MACS        21418000
         GOIF  SMDDENTR,OFF=DICTEXIT    EXIT IF NO MDD ENTRY WAS MADE   21419000
MRSKP    L     WORK1,CURMDDPT           GET MDD ENTRY POINTER           21420000
         USING MDDNTRY,WORK1                                            21421000
         SET   FLUSH,ON                 INDICATE EDIT ABORTED           21422000
         MVI   MTSDNP+(L'MTSDNP-D1),D4  INDICATE NO SUCH MACRO          21423000
         GOIF  SNOSYSMD,ON=MRSKPB       SKIP IF THATS THE ERROR         21424000
         GOIF  SSYSMD,OFF=MRSKPB        BR IF PRGMR MACRO               21425000
         MVI   MTSDNP+(L'MTSDNP-D1),D8  INDICATE BOGUS PROTOTYPE        21426000
         GOIF  SBDPROTO,ON=MRSKPB       SKIP IF THATS THE ERROR         21427000
         MVI   MTSDNP+(L'MTSDNP-D1),D12 INDICATE NO MACRO STMT          21428000
         GOIF  SNOSMCRO,ON=MRSKPB       SKIP IF THATS THE ERROR         21429000
         MVI   MTSDNP+(L'MTSDNP-D1),D16 INDICATE MEMBER, MACRO UNALIKE  21430000
         GOIF  LSTSYSMS,OFF=MRSKPB      SKIP IF THATS THE ERROR         21431000
         MVI   MTSDNP+(L'MTSDNP-D1),D20 DICT OVERFLOW ON THIS SYS MAC   21432000
         B     MRSKPB                   GO TO FINISH MDD ENTRY          21433000
MRSKPA   EQU   *                                                        21434000
         BAL   WORK3,COMNEND            GO TO COMMON TERMINATION        21435000
         MVC   MTXTNP(L'MTXTNP+L'MTSDNP),NOTESAVE                      X21436000
               INSERT TEXT AND TSDF N/P ADDRS IN MDD ENTRY              21437000
MRSKPB   EQU   *                                                        21438000
         SET   SMDDENTR,OFF             RESET MDD ENTRY MADE SWITCH     21439000
         SET   TSEDIT,ON                INDICATE MACRO EDITED           21440000
         GOIF  SSYSMD,ON=EDITSYSM,      CONTINUE LIBRARY MACRO EDIT    X21441000
               ELSE=DICTEXIT            RETURN OTHERWISE                21442000
         DROP  WORK1                                                    21443000
         EJECT                                                          21444000
*OPENENT - THIS ROUTINE IS CALLED AT THE START OF EDITING OPEN CODE.  * 21445000
*   ITS FUNCTION IS TO INITIALIZE THAT PART OF MODULE COMMON USED IN  * 21446000
*   EDITING OPEN CODE, TO INITIALIZE THE VARIABLE SYMBOL DIRECTORY,   * 21447000
*   TO INITIALIZE THE TEXT SEGMENT DICTIONARY FILE, TO INITIALIZE     * 21448000
*   THE SEQUENCE SYMBOL REFERENCE DIRECTORY, AND TO INITIALIZE THE    * 21449000
*   ENTRY FOR OPEN CODE IN THE MACRO DEFINITION DIRECTORY.            * 21450000
*        INPUT - NONE.                                                * 21451000
*        OUTPUT - APPROPRIATE FLAGS IN 'CONCODE' IF INSUFFICIENT      * 21452000
*                 SPACE REMAINS FOR THE MACRO DEFINITION DIRECTORY    * 21453000
*                 ENTRY.                                              * 21454000
*                                                                     * 21455000
OPENENT  EQU   *                                                        21456000
         XC    OCINITS(TSINITE-OCINITS),OCINITS REINITIALIZE COMMON     21457000
         BAL   WORK3,COMNINIT           GO TO COMMON INITIALIZATION     21458000
         L     WORK1,MDDSLOT            GET PRESENT END OF MDD PTR      21459000
         SH    WORK1,=AL2(MDDEND-MDDNTRY) ADJUST FOR OPEN CODE ENTRY    21460000
         C     WORK1,VSDSLOT            LOOK FOR OVERLAP WITH VSD       21461000
         BL    OERR                     IF OVERLAP, GO FLAG THE ERROR   21462000
         ST    WORK1,MDDSLOT            PUT END OF MDD PTR BACK         21463000
         ST    WORK1,CURMDDPT           SET CURRENT ENTRY PTR ALSO      21464000
         USING MDDNTRY,WORK1                                            21465000
         MVC   MCHAIN,MDDCHN+(L'MDDCHN-L'MCHAIN) INSERT CHAIN PTR       21466000
         XC    MFLAGS(L'MFLAGS+L'MSYMBL+L'MVECTR),MFLAGS               X21467000
               CLEAR LENGTH,NAME, GT MDV POINTER                        21468000
         L     WORK2,MDDSTRT            PICK UP TABLE BASE              21469000
         SR    WORK2,WORK1              GET DISPL TO LATEST ENTRY       21470000
         ST    WORK2,MDDCHN             SAVE AS NEW FIRST CHAIN PTR     21471000
         L     WORK2,MDDCNT             PICK UP NUMBER OF MDD ENTRIES   21472000
         LA    WORK2,D1(,WORK2)         INCREMENT FOR NEW ENTRY         21473000
         ST    WORK2,MDDCNT             SAVE NEW MDD ENTRY COUNT        21474000
         SET   OCTS,ON                  INDICATE OPEN CODE ENTRY        21475000
         LA    WORK5,SYSPRM             POINT TO SYST GBL LIST          21476000
         B     VSDINIT                  GO TO ENTER THEM IN VSD         21477000
         DROP  WORK1                                                    21478000
         EJECT                                                          21479000
*OPENEND - THIS ROUTINE IS CALLED AT THE END OF EDITING OPEN CODE.    * 21480000
*   ITS FUNCTION IS TO CLOSE OUT THE TEXT SEGMENT DICTIONARY FILE,    * 21481000
*   INSERT THE LOCAL DICTIONARY, GLOBAL VECTOR, AND SEQUENCE SYMBOL   * 21482000
*   REFERENCE DICTIONARY ALLOCATIONS IN THE ENTRY FOR OPEN CODE IN    * 21483000
*   THE MACRO DEFINITION DIRECTORY. IF THERE ARE LIBRARY MACROS       * 21484000
*   TO BE EDITED, THE FIRST NAME IS RETURNED,TO THE EDITOR. WHEN      * 21485000
*   ALL LIBRARY MACROS ARE EDITED, 'LSTSYSMS' IS SET ON, AND THE      * 21486000
*   PHASE TERMINATION IS PERFORMED.                                   * 21487000
*        INPUT - NONE.                                                * 21488000
*        OUTPUT - A POINTER IN R11 TO THE LENGTH OF THE NAME (1       * 21489000
*                 BYTE) IMMEDIATELY FOLLOWED BY THE NAME ITSELF       * 21490000
*                 (PADDED WITH ZEROS TO 8 BYTES) OF A LIBRARY MACRO   * 21491000
*                 TO BE EDITED.                                       * 21492000
*                                                                     * 21493000
OPENEND  EQU   *                                                        21494000
         BAL   WORK3,COMNEND            GO TO COMMON TERMINATION        21495000
         USING MDDNTRY,WORK1                                            21496000
         MVC   MTSDNP,SAVENOTE          INSERT TSDF N/P ADDR IN MDD     21497000
         XC    MTXTNP,MTXTNP            CLEAR TEXT N/P ADDR FOR O.C.    21498000
         SET   TSEDIT,ON                INDICATE OPEN CODE EDITED       21499000
EDITSYSM GOIF  LSTSYSMS,ON=PHASEND      SKIP IT ALL IF OVERLAP OCCURRED 21500000
         MVC   HIBYTE0,MDDCHN           SET UP PTR FOR FULL CHAIN SCAN  21501000
SYSEDTLP L     WORK1,MDDSTRT            PICK UP TABLE BASE              21502000
         S     WORK1,HIBYTE0            DISPLACE TO NEXT CHAIN ENTRY    21503000
         C     WORK1,MDDSTRT            SEE IF END OF CHAIN REACHED     21504000
         BE    ENDSYSM                  BRANCH IF YES                   21505000
         GOIF  TSEDIT,OFF=EDITIT        GO TO EDIT IF NOT ALREADY       21506000
         MVC   HIBYTE0+(L'HIBYTE0-L'MCHAIN)(L'MCHAIN),MCHAIN           X21507000
               PICK UP PTR TO NEXT ENTRY IN CHAIN                       21508000
         B     SYSEDTLP                 GO BACK TO START OF SEARCH      21509000
EDITIT   ST    WORK1,CURMDDPT           SAVE PTR TO ENTRY BEING EDITED  21510000
         LA    R10,MSYMBL               GET NAME PTR FOR EDITOR         21511000
         B     DICTEXIT                 RETURN                          21512000
ENDSYSM  SET   LSTSYSMS,ON              ALL LIBRARY MACROS EDITED       21513000
         DROP  WORK1                                                    21514000
         EJECT                                                          21515000
*PHASEND - THIS ROUTINE IS CALLED AT THE END OF EDITING ALL LIBRARY   * 21516000
*   MACROS. ITS FUNCTION IS TO CLOSE OUT THE ORDINARY SYMBOL          * 21517000
*   DEFINITION FILE, OUTPUT THE MACRO DEFINITION DIRECTORY, CLOSE     * 21518000
*   OUT THE TEXT SEGMENT DICTIONARY FILE, TO PUT IN COMMON THE DATA   * 21519000
*   REQUIRED BY THE DICTIONARY INTERLUDE PHASE, AND TO RELEASE THE    * 21520000
*   DICTIONARY SPACE.                                                 * 21521000
*        INPUT - NONE.                                                * 21522000
*        OUTPUT - NONE.                                               * 21523000
*                                                                     * 21524000
PHASEND  EQU   *                                                        21525000
         JPUTL FILE=FILE3,BUFREQ=L'EFILRL+L'EFILRT GET RECORD LENGTH    21526000
         USING ENDFIL,BUFPTR                                            21527000
         MVC   EFILRL(L'EFILRL+L'EFILRT),=AL1(0,L'EFILRL+L'EFILRT,EFILTX21528000
               YPE) INSERT RECORD LENGTH AND TYPE                       21529000
         JTRUNC FILE=FILE2              COMPLETE OUTPUT, FILE 2         21530000
         JTRUNC FILE=FILE3              COMPLETE OUTPUT, FILE 3         21531000
         JPOINT FILE=FILE2,NEXT=START   REWIND FOR INTERLUDE            21532000
         MVC   PIOPARMA,MDDSLOT         SET UP BUFFER ADDRESS           21533000
         L     WORK1,MDDSTRT            GET PTR TO MDD HIGH END         21534000
         S     WORK1,MDDSLOT            GET LENGTH OF MDD               21535000
         ST    WORK1,PIOPARMB           SET UP WRITE LENGTH             21536000
         MVC   SAVMDDLN(L'PIOPARMB),PIOPARMB LENGTH IN COMMON           21537000
         LH    R5,JMAXRL3               SET UP MAXIMUM RECORD THIS FILE 21538000
         LA    R6,FILE3                 SET UP FILE POINTER             21539000
         BAL   R7,BUFRITE               GO PUT MDD TO FILE 3            21540000
         MVC   SAVMDDPT(L'JNOTEVAL),JNOTEVAL  SAVE NOTE/POINT AND MDD   21541000
         MVC   SAVMDDCN(L'MDDCHN),MDDCHN PASS MDD CHAIN LINK TO INTERL  21542000
         MVC   SAVMDDCT(L'MDDCNT),MDDCNT PASS MACRO NAME COUNT ALSO     21543000
         MVC   SAVOPSCN(L'OPSCHN),OPSCHN PASS OPSYN CHN PTR TO X2A      21544000
         JFRECORE ADDR=FREESTRT         RELEASE DIRECTORY SPACE         21545000
         B     DICTEXIT                 RETURN TO EDITOR                21546000
         DROP  BUFPTR                                                   21547000
         EJECT                                                          21548000
*MACRNAME - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21549000
*   DEFINITION WHEN THE MACRO NAME IS ENCOUNTERED ON THE PROTOTYPE    * 21550000
*   STATEMENT. ITS FUNCTION IS TO ENTER THE MACRO NAME IN THE MACRO   * 21551000
*   DEFINITION DIRECTORY, IF IT HAS NOT BEEN PREVIOUSLY ENTERED, AND  * 21552000
*   TO RETURN TO THE EDITOR A POINTER TO THE APPROPRIATE ENTRY IN THE * 21553000
*   GENERATION TIME MACRO DEFINITION VECTOR.                          * 21554000
*        INPUT - THE LENGTH OF THE MNEMONIC IN R11.                   * 21555000
*              - A POINTER TO THE MNEMONIC (1-8 BYTES) IN R10.        * 21556000
*                THE MNEMONIC HAS BEEN VERIFIED AS A VALID SYMBOL.    * 21557000
*                THE MNEMONIC HAS NOT BEEN FOUND IN THE OP CODE TABLE.* 21558000
*        OUTPUT - A POINTER IN R11 TO THE APPROPRIATE ENTRY IN THE    * 21559000
*                 MACRO DEFINITION DIRECTORY AND APPROPRIATE FLAGS    * 21560000
*                 SET IN THE BYTE 'IOCID'.                            * 21561000
*               - APPROPRIATE FLAGS IN 'CONCODE' IF THE NAME OF A     * 21562000
*                 PROGRAMMER MACRO DUPLICATES A PREVIOUS ONE OR IF    * 21563000
*                 INSUFFICIENT SPACE REMAINS FOR THE MACRO DEFINI-    * 21564000
*                 TION ENTRY OF IF THE NAME ON THE PROTOTYPE IN A     * 21565000
*                 LIBRARY MACRO IS DIFFERENT FROM THE NAME THE        * 21566000
*                 MACRO IS CATALOGED UNDER.                           * 21567000
*                                                                     * 21568000
MACRNAME EQU   *                                                        21569000
         MVC   JDWORD,=8AL1(JBLANK)     SET UP PAD FOR MACRO NAME       21570000
         EX    LNGTHREG,MACRNMOV        SET UP MACRO NAME WITH PAD      21571000
         MVC   HIBYTE0,MDDCHN           SET UP PTR TO START CHAIN SERCH 21572000
MDDSCAN  L     WORK1,MDDSTRT            PICK UP TABLE BASE              21573000
         S     WORK1,HIBYTE0            DISPLACE TO NEXT ENTRY IN CHAIN 21574000
         C     WORK1,MDDSTRT            SEE IF END OF CHAIN REACHED     21575000
         BER   R4                       BRANCH IF YES                   21576000
         USING MDDNTRY,WORK1                                            21577000
         GOIF  DELETE,ON=MSCANB         DELETED, IGNORE                 21578000
         CLC   JDWORD,MSYMBL            COMPARE MACRO NAMES             21579000
         BE    MSCANA                   BRANCH IF NAMES MATCH           21580000
MSCANB   EQU   *                                                        21581000
         MVC   HIBYTE0+(L'HIBYTE0-L'MCHAIN)(L'MCHAIN),MCHAIN           X21582000
               PICK UP PTR IN ENTRY TO NEXT ENTRY IN CHAIN              21583000
         B     MDDSCAN                  GO BACK TO START OF SEARCH      21584000
MSCANA   GOIF  SXPRTO,OFF=MACDONE       SEE IF PRGMR MACRO PROTOTYPE    21585000
         GOIF  TSEDIT,ON=MACERR         IF ENTRY ALREADY EDITED, ERROR  21586000
         ST    WORK1,CURMDDPT           SET CURRENT PTR TO THIS ENTRY   21587000
         SET   SMDDENTR,ON              SHOW THAT MDD ENTRY WAS MADE    21588000
MACDONE  LA    R11,MVECTR               GET PTR FOR EDITOR TO MDV SLOT  21589000
         MVI   IOCID,J0                 SET OP CODE FLAGS PROPERLY      21590000
         B     D4(R4)                   RETURN                          21591000
MACERR   MVC   DSEVCD(D2),=AL1(SEV10,ERR10) INDICATE DUPL PRGMR MACROS  21592000
         B     D4(R4)                   RETURN                          21593000
MACENTRY EQU   *                                                        21594000
         GOIF  SSYSMD,OFF=MAKENTRY      MAKE CHECK ONLY IN SYST MACROS  21595000
         GOIF  SXPRTO,OFF=MAKENTRY      SEE IF BOOK NAME AND MACRO NAME 21596000
         MVC   DSEVCD(D2),=AL1(SEV11,ERR11) DO NOT AGREE, FLAG IF NOT   21597000
         B     DICTEXIT                 EXIT                            21598000
MAKENTRY EQU   *                                                        21599000
         L     WORK1,MDDSLOT            GET END OF DICT PTR             21600000
         SH    WORK1,=AL2(MDDEND-MDDNTRY) ALLOW ROOM FOR THIS ENTRY     21601000
         C     WORK1,VSDSLOT            LOOK FOR OVERLAP WITH VSD       21602000
         BL    OERR                     IF OVERLAP, GO FLAG THE ERROR   21603000
         ST    WORK1,MDDSLOT            IF NOT, UPDATE NEXT SLOT PTR    21604000
         MVC   MCHAIN,MDDCHN+(L'MDDCHN-L'MCHAIN) INSERT CHAIN PTR       21605000
         STC   LNGTHREG,MFLAGS          INSERT FLAGS IN MDD ENTRY       21606000
         MVC   MSYMBL,JDWORD            INSERT NAME IN MDD ENTRY        21607000
         MVC   MVECTR,GTMVALOC+(L'GTMVALOC-L'MVECTR)   INSERT MACRO    X21608000
               DEFINITION VECTOR PTR IN MDD ENTRY                       21609000
         XC    MTXTNP(L'MTXTNP+L'MTSDNP),MTXTNP  CLEAR N/P ADDRS        21610000
         L     R14,GTMVALOC             PICK UP CURRENT MDV PTR         21611000
         LA    R14,MDVEL(,R14)          BUMP IT FOR NEXT ENTRY          21612000
         ST    R14,GTMVALOC             PUT IT BACK UPDATED             21613000
         L     R14,MDDSTRT              PICK UP TABLE BASE              21614000
         SR    R14,WORK1                GET DISPL TO LATEST ENTRY       21615000
         ST    R14,MDDCHN               STORE IT                        21616000
         L     R14,MDDCNT               NUMBER OF MOD ENTRIES           21617000
         LA    R14,D1(R14)              BUMP                            21618000
         ST    R14,MDDCNT               STORE                           21619000
         B     MSCANA                   GO SEE IF EDITING THE ENTRY     21620000
MACRNMOV MVC   JDWORD(D0),JFWORD1       MOVE MACRO NAME                 21621000
         DROP  WORK1                                                    21622000
         EJECT                                                          21623000
*VARBSYMD - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21624000
*   DEFINITION OR OF OPEN CODE WHEN THE DEFINITION OF A VARIABLE      * 21625000
*   SYMBOL IS ENCOUNTERED (IN THE OPERAND OF A GLOBAL OR LOCAL        * 21626000
*   DECLARATION OR IN THE OPERAND OF THE MACRO PROTOTYPE STATEMENT).  * 21627000
*   ITS FUNCTION IS TO ENTER THE VARIABLE SYMBOL IN THE VARIABLE      * 21628000
*   SYMBOL DIRECTORY. FOR GLOBALS, THIS ROUTINE ALSO MAKES AN ENTRY   * 21629000
*   IN THE TEXT SEGMENT DICTIONARY FILE FOR THE GLOBAL DEFINITION.    * 21630000
*        INPUT - THE LENGTH OF THE VARIABLE SYMBOL IN R11.            * 21631000
*              - A POINTER IN R10 TO THE VARIABLE SYMBOL (1-8 BYTES). * 21632000
*                THE VARIABLE SYMBOL HAS BEEN VERIFIED AS VALID.      * 21633000
*                IF THE VARIABLE SYMBOL IS DIMENSIONED, THE           * 21634000
*                DIMENSION VALUE IS IN 'JHWORD1'. THE DIMENSION       * 21635000
*                HAS BEEN VERIFIED AS VALID.                          * 21636000
*              - APPROPRIATE FLAGS SET IN THE BYTE 'FLGBYT'.          * 21637000
*        OUTPUT - APPROPRIATE FLAGS IN 'CONCODE' IF THE VARIABLE      * 21638000
*                 SYMBOL DUPLICATES A PREVIOUS ONE OR IF INSUFFIC-    * 21639000
*                 IENT SPACE REMAINS FOR THE VARIABLE SYMBOL          * 21640000
*                 DIRECTORY ENTRY.                                    * 21641000
*                                                                     * 21642000
VSDINIT  EQU   *                                                        21643000
         SET   ITERSW,ON                INDICATE VSD INITIALIZATION     21644000
VSDINITA SR    R11,R11                  CLEAR PARAMETER REGISTER        21645000
         IC    R11,D1(,WORK5)           PICK UP VARB SYMB LENGTH        21646000
         LA    R10,D2(,WORK5)           GET PTR TO SYST VARB SYMBOL     21647000
         MVC   FLGBYT,D0(WORK5)         SET UP APPROPRIATE FLAGS        21648000
VARBSYMD EQU   *                                                        21649000
         BAL   RTNLNK,VSLOOKUP          SEE IF VAR SYM DEFINED PREV     21650000
         GOIF  FNDFLG,ON=VERR           IF YES, THIS DECLR AN ERROR     21651000
         L     WORK2,VSDSLOT            GET PTR TO NEW ENTRY            21652000
         LA    WORK1,VSDEL(,WORK2)      ASSUME LONGEST VSD ENTRY        21653000
         C     WORK1,MDDSLOT            CHECK FOR OVERLAP               21654000
         BNL   OERR                     IF OVERLAP, BRANCH              21655000
         L     WORK1,VSDSTRT            GET VSD HASH TBL PTR            21656000
         AR    WORK1,HASHV              GET PTR TO HSH TBL ENTRY        21657000
         USING VSDENTRY,WORK2                                           21658000
         MVC   VCHAIN,D0(WORK1)         PUT CHN LINK IN NEW ENTRY       21659000
         LR    WORK3,WORK2              SET UP NEW ENTRY ADDR           21660000
         S     WORK3,VSDSTRT            GET DISPL FOR HASH TBL ENTRY    21661000
         ST    WORK3,JFWORD1            SAVE TEMPORARILY AND PUT IN     21662000
         MVC   D0(L'VCHAIN,WORK1),JFWORD1+(L'JFWORD1-L'VCHAIN) HSH TBL  21663000
         STC   LNGTHREG,VLNGTH          INSERT VARB SYMB LENGTH         21664000
         EX    LNGTHREG,SYMBMOVE        PUT VAR SYMB IN ENTRY           21665000
         LA    WORK2,L'VCHAIN+L'VFLAGS+L'VLNGTH+D1(LNGTHREG,WORK2)     X21666000
               UPDATE ENTRY (DSECT) PTR                                 21667000
         GOIF  (VTYP1,VTYP2),NOTALL=LGVARB GO AHEAD IF LOCAL, GLOBAL    21668000
PENTRY   GOIF  VPTYP,ON=KENTRY                                          21669000
         MVI   VTFVAL,JTMPPAR           FLAG POS PARAM FOR TEXT         21670000
         MVC   VPVECTR,GTPVALOC+(L'GTPVALOC-L'VPVECTR) PUT IN POSITNL  X21671000
               PARAMETER VECTOR DISPLACEMENT                            21672000
         L     WORK3,GTPVALOC           GET CURRENT POSIT PARM DISPL    21673000
         LA    WORK3,PVPTRLNG(,WORK3)   INCR FOR NEXT POS ENTRY         21674000
         ST    WORK3,GTPVALOC           PUT IT BACK UPDATED             21675000
         B     COMPNTRY                 CONTINUE AT COMMON PARAM PT     21676000
KENTRY   MVI   VTFVAL,JTMKPAR           FLAG KWD PARAM FOR TEXT         21677000
         MVC   VPVECTR,GTKVALOC+(L'GTKVALOC-L'VPVECTR) PUT IN KEYWORD  X21678000
               PARAMETER VECTOR DISPLACEMENT                            21679000
         L     WORK3,GTKVALOC           GET CURRENT KEYWRD PARM DISPL   21680000
         LA    WORK3,PVPTRLNG(,WORK3)   INCR FOR NEXT KWD ENTRY         21681000
         ST    WORK3,GTKVALOC           PUT IT BACK UPDATED             21682000
COMPNTRY EQU   *                                                        21683000
         XC    VPPAD,VPPAD              INSERT PAD OF ZEROES IN ENTRY   21684000
         B     COMALL                   CONTINUE AT COMMON PT FOR ALL   21685000
SYMBMOVE MVC   VSYMBL(D0),D0(PARMREG)   EXECUTED VARB SYMB MOVE         21686000
LGVARB   GOIF  (VSTP1,VSTP2),NONE=ATYP,MIX=BTYP BRANCH ON VARB TYPE     21687000
         MVI   VTFVAL,JTMSVC            FLAG C-TYPE FOR TEXT            21688000
         B     FANOUT                   GO ON                           21689000
ATYP     MVI   VTFVAL,JTMSVA            FLAG A-TYPE FOR TEXT            21690000
         B     FANOUT                   GO ON                           21691000
BTYP     MVI   VTFVAL,JTMSVB            FLAG B-TYPE FOR TEXT            21692000
FANOUT   GOIF  (VTYP1,VTYP2),NONE=GENTRY SEPARATE GLOBALS AND LOCALS    21693000
LENTRY   EQU   *                                                        21694000
         GOIF  VSLS,OFF=SLSKIP          HANDLE SYSLIST SPECIALLY        21695000
         MVI   VTFVAL,JTMLSTO           SET SPECIAL SYSLIST FLAG        21696000
         XC    VLDICTR,VLDICTR          CLEAR DICTIONARY PTR            21697000
         MVC   VLDIMEN,=H'1'            PRE-SET SYSLIST DIMENSION FLAG  21698000
         B     COMALL                   SKIP ALLOCATION FOR SYSLIBT     21699000
SLSKIP   MVC   VLDICTR,GTLDALOC+(L'GTLDALOC-L'VLDICTR) PUT IN DICT PTR  21700000
         LA    EOPAIR2,D1               ALLOCATE 1 BYTE FOR B-TYPE      21701000
         GOIF  (VSTP1,VSTP2),MIX=DIMENCK  BRANCH IF B-TYPE              21702000
         LA    EOPAIR2,D4               ALLOCATE 4 BYTES FOR A-TYPE     21703000
         GOIF  (VSTP1,VSTP2),NONE=DIMENCK BRANCH IF A-TYPE              21704000
         LA    EOPAIR2,D9               ALLOCATE 9 BYTES FOR C-TYPE     21705000
DIMENCK  GOIF  VDIM,ON=LSKIP            BRANCH IF VARB DIMENSIONED      21706000
         XC    VLDIMEN,VLDIMEN          SET DIMEN TO ZERO               21707000
         B     COMLNTRY                 SKIP DIMEN CALCULATION          21708000
LSKIP    MVC   VLDIMEN,JHWORD1          PUT DIMEN VALUE IN ENTRY        21709000
         MH    EOPAIR2,JHWORD1          COMPUTE DIMEN'D ALLOCATION      21710000
         GOIF  (VSTP1,VSTP2),NOTMIX=COMLNTRY   BRANCH IF NOT B-TYPE     21711000
         LA    EOPAIR2,D7(,EOPAIR2)     ADJUST TO GET ROUNDED RESULT    21712000
         SR    EOPAIR1,EOPAIR1          INITIALIZE AND DIVIDE TO ALLOC  21713000
         D     EOPAIR1,=F'8'            FORM                            21714000
COMLNTRY A     EOPAIR2,GTLDALOC         ADJUST DICTIONARY ALLOCATION    21715000
         ST    EOPAIR2,GTLDALOC         PUT BACK UPDATED                21716000
         B     COMALL                   CONTINUE AT COMMON PT FOR ALL   21717000
GENTRY   OI    VTFVAL,JTMGBL            INSERT GLOBAL FLAG              21718000
         MVC   VGVECTR,GTGVALOC+(L'GTGVALOC-L'VGVECTR) PUT IN GLOBAL   X21719000
               VECTOR DISPLACEMENT                                      21720000
         L     WORK3,GTGVALOC           GET CURRENT GBL VECTR DISPL     21721000
         LA    WORK3,GVPTRLNG(,WORK3)   INCR FOR NEXT GBL ENTRY         21722000
         ST    WORK3,GTGVALOC           PUT IT BACK UPDATED             21723000
         GOIF  VDIM,ON=GSKIP            BRANCH IF VARB DIMENSIONED      21724000
LSKIPA   EQU   *                                                        21725000
         XC    VGDIMEN,VGDIMEN          SET DIMEN TO ZERO               21726000
         B     COMALL                   SKIP DIMEN HANDLING             21727000
GSKIP    MVC   VGDIMEN,JHWORD1          PUT DIMEN VALUE IN ENTRY        21728000
COMALL   EQU   *                                                        21729000
         LA    WORK2,L'VTFVAL+L'VGVECTR+L'VGDIMEN(,WORK2) UPDATE PTR    21730000
         L     WORK3,VSDSLOT            GET PTR TO START OF ENTRY       21731000
         DROP  WORK2                                                    21732000
         USING VSDENTRY,WORK3                                           21733000
         MVC   VFLAGS,FLGBYT            INSERT FLAGS IN ENTRY           21734000
         ST    WORK2,VSDSLOT            UPDATE NEXT ENTRY ADDRESS       21735000
         GOIF  (VTYP1,VTYP2),ANY=VSDINITX FINSIHED EXCEPT FOR GLOBALS   21736000
         SR    WORK2,WORK3              GET ENTRY LENGTH                21737000
         LR    R11,WORK2                SET UP LENGTH FOR JPUTL         21738000
         ST    WORK5,REGSAVE2           PRESERVE VSDINIT POINTER        21739000
         JPUTL FILE=FILE2,BUFREQ=(R11)  GET BUFFER PTR AND SPACE        21740000
         USING GBLDEF,BUFPTR                                            21741000
         BCTR  WORK2,D0                 GET RECORD MOVE LENGTH          21742000
         EX    WORK2,GDEFMOVE           MOVE DIR ENTRY TO DEF RECORD    21743000
         LA    WORK2,D1(,WORK2)         RESTORE TRUE LENGTH             21744000
         STH   WORK2,GDEFRL             PUT AT HEAD OF DEF RCRD         21745000
         MVI   GDEFRT,GDEFTYPE          INSERT RECORD TYPE              21746000
         BAL   RTNLNK,GETNPF2           NOTE TEXT SEG DICT, IF NECESS   21747000
         L     WORK5,REGSAVE2           RESTORE VSDINIT POINTER         21748000
VSDINITX GOIF  ITERSW,OFF=DICTEXIT      EXIT FI NOT VSD INITIALIZATION  21749000
         LA    WORK5,D9(,WORK5)        BUMP TO NEXT SYST VARB DEFIN     21750000
         CLI   D0(WORK5),BITFF          SEE IF END OF LIST REACHED      21751000
         BNE   VSDINITA                 BRANCH IF NOT                   21752000
         SET   ITERSW,OFF               INDICATE VSD INITIALIZE DONE    21753000
         B     DICTEXIT                 AND EXIT                        21754000
GDEFMOVE MVC   GDEFRL(D0),VCHAIN        EXECUTED GBL DEFINITION MOVE    21755000
         DROP  BUFPTR                                                   21756000
         DROP  WORK3                                                    21757000
         USING VSDENTRY,VSDPTR                                          21758000
OERR     MVC   DSEVCD(D2),=AL1(SEV9,ERR9) FLAG DICTIONARY OVERLAP       21759000
         SET   LSTSYSMS,ON              PREVENT SYSTEM MACRO EDITING    21760000
         B     DICTEXIT                 RETURN TO EDITOR                21761000
VERR     GOIF  (VTYP1,VTYP2),ON=PERR    BRANCH IF PARAM IN ERROR        21762000
         TM    VFLAGS,VSNS              SEE IF DUP ENTRY FOR SYS VARB   21763000
         BO    VERRA                    BRANCH IF YES                   21764000
         TM    VFLAGS,VTYP1+VTYP2       SEE IF DUP ENTRY FOR PARAM      21765000
         BO    VERRB                    BRANCH IF YES                   21766000
         MVC   DSEVCD(D2),=AL1(SEV5,ERR5) FLAG VAR SYMB DUPL OF VAR SYM 21767000
         B     DICTEXIT                 EXIT                            21768000
VERRA    MVC   DSEVCD(D2),=AL1(SEV3,ERR3) FLAG VAR SYMB DUPL OF SYS VAR 21769000
         B     DICTEXIT                 EXIT                            21770000
VERRB    MVC   DSEVCD(D2),=AL1(SEV4,ERR4) FLAG VAR SYMB DUPL OF PARAM   21771000
         B     DICTEXIT                 EXIT                            21772000
PERR     TM    VFLAGS,VTYP1+VTYP2       SEE IF DUPL ENTRY FOR PARAM     21773000
         BO    PERRA                    BRANCH IF YES                   21774000
         MVC   DSEVCD(D2),=AL1(SEV1,ERR1) FLAG PARAM DUPL OF SYST VAR   21775000
         B     DICTEXIT                 EXIT                            21776000
PERRA    MVC   DSEVCD(D2),=AL1(SEV2,ERR2) FLAG PARAM DUPL OF PARAM      21777000
         B     DICTEXIT                 RETURN TO EDITOR                21778000
         DROP  VSDPTR                                                   21779000
         EJECT                                                          21780000
*VARBSYMR - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21781000
*   DEFINITION OR OF OPEN CODE WHEN A REFERENCE TO A VARIABLE SYMBOL  * 21782000
*   IS ENCOUNTERED. ITS FUNCTION IS TO DETERMINE THE TYPE OF          * 21783000
*   REFERENCE (SYMBOLIC PARAMETER, LOCAL VARIABLE, OR GLOBAL VARI-    * 21784000
*   ABLE), AND TO RETURN TO THE EDITOR A POINTER TO THE APPROPRIATE   * 21785000
*   ENTRY IN THE APPROPRIATE GENERATION TIME DICTIONARY (THE KEYWORD  * 21786000
*   OR POSITIONAL PARAMETER VECTOR IN THE CASE OF A SYMBOLIC PARAM-   * 21787000
*   ETER, THE LOCAL DICTIONARY IN THE CASE OF A LOCAL VARIABLE, THE   * 21788000
*   GLOBAL VECTOR IN THE CASE OF A GLOBAL VARIABLE).                  * 21789000
*        INPUT - THE LENGTH OF THE VARIABLE SYMBOL IN R11.            * 21790000
*              - A POINTER IN R10 TO THE VARIABLE SYMBOL (1-8 BYTES). * 21791000
*                IF SUBSCRIPTED, THE VARIABLE SYMBOL IS FOLLOWED BY   * 21792000
*                A LEFT PARENTHESIS (1 BYTE).                         * 21793000
*                THE VARIABLE SYMBOL HAS BEEN VERIFIED AS VALID.      * 21794000
*        OUTPUT - A POINTER IN R11 TO THE TEXT FLAG BYTE IN THE       * 21795000
*                 VARIABLE SYMBOL DIRECTORY ENTRY FOR THE VARIABLE    * 21796000
*                 SYMBOL.                                             * 21797000
*               - APPROPRIATE FLAGS SET IN THE BYTE 'FLGBYT'.         * 21798000
*               - APPROPRIATE FLAGS IN 'CONCODE' IF THE VARIABLE      * 21799000
*                 SYMBOL WAS NOT PREVIOUSLY DEFINED OR IF ITS         * 21800000
*                 USEAGE IS INCONSISTENT WITH ITS DECLARATION.        * 21801000
*                                                                     * 21802000
VARBSYMR EQU   *                                                        21803000
         MVI   FLGBYT,J0                CLEAN UP BEFORE GOING ON        21804000
         BAL   RTNLNK,VSLOOKUP          SEE IF VARB SYMB DECLARED PREV  21805000
         GOIF  FNDFLG,OFF=VERRC         IF NOT, THIS REFER AN ERROR     21806000
         GOIF  SPGRMD,OFF=RSKIP         BR IF NOT PRGR MACS             21807000
         GOIF  SMDEF,OFF=VERRC          ERROR IF BETWEEN MACRO DEFS     21808000
RSKIP    EQU   *                                                        21809000
         USING VSDENTRY,VSDPTR                                          21810000
         MVC   FLGBYT,VFLAGS            GET FLAGS FOR EDITOR            21811000
RSKIPA   LA    WORK1,D1(LNGTHREG,PARMREG) GET PTR PAST VARB SYMB        21812000
         CLI   D0(WORK1),JLPARN         LOOK FOR LEFT PAREN (DIMEN)     21813000
         BNE   RSKIPB                   IF NOT, DONT SET FLAG           21814000
         OI    FLGBYT,VDIM              INDICATE PAREN FOUND            21815000
         B     RSKIPB1                  GO CHECK CONSISTENCY            21816000
RSKIPB   NI    FLGBYT,BITFF-VDIM        INDICATE NO PAREN FOUND         21817000
RSKIPB1  TM    VFLAGS,VTYP1+VTYP2       CONSIDER PARAMS SPECIALLY       21818000
         BO    RSKIPD                   SKIP IF THATS THE CASE          21819000
         CLC   FLGBYT,VFLAGS            SEE IF USEAGE CONSISTENT        21820000
         BNE   VERRD                    BRANCH IF NOT                   21821000
RSKIPC   EQU   *                                                        21822000
         LA    R11,L'VCHAIN+L'VFLAGS+L'VLNGTH+D1(LNGTHREG,VSDPTR)      X21823000
               GET POINTER TO TEXT FLAG BYTE                            21824000
         B     DICTEXIT                 RETURN                          21825000
VERRC    MVC   DSEVCD(D2),=AL1(SEV6,ERR6) FLAG UNDECLARED VAR SYMB      21826000
         B     DICTEXIT                 RETURN                          21827000
VERRD    TM    VFLAGS,VSLS              LOOK FOR SYSLIST REFERENCE      21828000
         BZ    VERRE                    BRANCH IF GBL OR LCL            21829000
         MVC   DSEVCD(D2),=AL1(SEV7,ERR7) FLAG INCONSISTENCY ERROR FOR  21830000
         B     RSKIPC                   SYSLIST, BUT STILL GET POINTER  21831000
RSKIPD   LA    R11,L'VCHAIN+L'VFLAGS+L'VLNGTH+D1(LNGTHREG,VSDPTR)      X21832000
               GET POINTER TO TEXT FLAG BYTE                            21833000
         USING PTFVAL,R11                                               21834000
         MVI   PPAD+D1,J0               SET DIMEN TO ZERO INITIALLY     21835000
         TM    FLGBYT,VDIM              SEE IF SUBSCRIPT ON PARAM       21836000
         BZ    DICTEXIT                 BRANCH IF NOT                   21837000
         MVI   PPAD+D1,J1               INSERT NON-ZERO IN DIMEN BYTES  21838000
         B     DICTEXIT                 RETURN                          21839000
VERRE    EQU   *                                                        21840000
         MVC   DSEVCD(D2),=AL1(SEV7,ERR7) FLAG INCONSISTENCY ERROR      21841000
         B     DICTEXIT                 RETURN TO EDITOR                21842000
         DROP  VSDPTR                                                   21843000
         DROP  R11                                                      21844000
         EJECT                                                          21845000
*SEQSYMBR - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21846000
*   DEFINITION OR OF OPEN CODE WHEN A REFERENCE TO A SEQUENCE SYMBOL  * 21847000
*   IS ENCOUNTERED. ITS FUNCTION IS TO ENTER THE SEQUENCE SYMBOL IN   * 21848000
*   THE SEQUENCE SYMBOL REFERENCE DIRECTORY, IF IT HAS NOT BEEN       * 21849000
*   PREVIOUSLY ENTERED, AND TO RETURN TO THE EDITOR A POINTER TO THE  * 21850000
*   APPROPRIATE ENTRY IN THE GENERATION TIME SEQUENCE SYMBOL REFER-   * 21851000
*   ENCE DICTIONARY. FOR EACH NEW ENTRY IN THE SEQUENCE SYMBOL        * 21852000
*   REFERENCE DIRECTORY, THIS ROUTINE ALSO MAKES AN ENTRY IN THE      * 21853000
*   TEXT SEGMENT DICTIONARY FILE FOR THE SEQUENCE SYMBOL REFERENCE.   * 21854000
*        INPUT - THE LENGTH OF THE SEQUENCE SYMBOL IN R11.            * 21855000
*              - A POINTER TO THE SEQUENCE SYMBOL (2-8 BYTES) IN R10. * 21856000
*                THE SEQUENCE SYMBOL HAS BEEN VERIFIED AS VALID.      * 21857000
*        OUTPUT - A POINTER IN R11 TO THE TEXT FLAG BYTE IN THE       * 21858000
*                 SEQUENCE SYMBOL REFERENCE DIRECTORY ENTRY FOR THE   * 21859000
*                 SEQUENCE SYMBOL.                                    * 21860000
*                                                                     * 21861000
SEQSYMBR EQU   *                                                        21862000
         LA    R6,SSPARMS               POINT TO SEQ SYMBOL VALUES      21863000
         LA    R10,D1(,R10)             DROP LEADING PERIOD             21864000
         BCTR  R11,0                    FROM SEQUENCE SYMBOL            21865000
COMNREF  EQU   *                                                        21866000
         USING SSPARMS,R6                                               21867000
         LR    LNGTHREG,R11             SAVE LENGTH PARAMETER           21868000
         LR    PARMREG,R10              SAVE POINTER PARAMETER          21869000
         MVC   JDWORD,=8AL1(JBLANK)     CLEAR NAME BUFFER               21870000
         EX    LNGTHREG,SSMVC           MOVE SEQ SYMB INTO BUFFER       21871000
         L     SSRDPTR,SSRDSTRT         GET SS REF DIR BASE ADDR        21872000
         USING SSDIR,SSRDPTR                                            21873000
         LA    WORK1,SSRDNE             SET UP COMPARE LIMIT            21874000
SSLOOP   CLI   SSSYM,J0                 LOOK FOR SS IN DIR ENTRY        21875000
         BE    SSENTRY                  IF NO SS, GO MAKE ENTRY         21876000
         CLC   JDWORD,SSSYM             COMPARE SEQUENCE SYMBOLS        21877000
         BE    SSFOUND                  IF ALIKE, GO GET PTR AND EXIT   21878000
         LA    SSRDPTR,SSRDEL(,SSRDPTR) IF NOT, BUMP PTR TO NEXT ENTRY  21879000
         BCT   WORK1,SSLOOP             BRANCH 10 TIMES, THEN FALL      21880000
         L     SSRDPTR,SSRDSTRT         GET TABLE BASE ADDR             21881000
         AH    SSRDPTR,SSRAPDIS         DEVELOP PTR TO NEXT ENTRY SLOT  21882000
SSENTRY  MVC   SSSYM,JDWORD             MOVE SS NAME INTO ENTRY         21883000
         MVC   STFVAL,SSFLGVAL          INSERT FLAG FOR TEXT REFER      21884000
         MVC   SSRDP,GTSDALOC+L'GTSDALOC-L'SSRDP      GET DICT PTR      21885000
         XC    SSPAD,SSPAD              INSERT PAD OF ZEROES IN ENTRY   21886000
         LA    WORK1,D8(,LNGTHREG)      GET LENGTH OF SS REF RECORD     21887000
         LR    R11,WORK1                SET UP FOR JPUTL                21888000
         JPUTL FILE=FILE2,BUFREQ=(R11)  GET BUFFER PTR AND SPACE        21889000
         USING SSREF,BUFPTR                                             21890000
         STH   WORK1,SREFRL             INSERT RECORD LENGTH            21891000
         MVC   SREFDP,SSRDP             INSERT DICTIONARY PTR           21892000
         MVC   SREFRT,SREFTYPE          INSERT RECORD TYPE              21893000
         STC   LNGTHREG,SREFSL          INSERT SEQ SYMB LENGTH          21894000
         EX    LNGTHREG,SREFMOVE        INSERT SEQUENCE SYMBOL          21895000
         BAL   RTNLNK,GETNPF2           NOTE TEXT SEG DICT, IF NECESS   21896000
         L     WORK1,GTSDALOC           PICK UP CURRENT DICT PTR        21897000
         AH    WORK1,SSDLNGTH           INCREMENT BY DICT ENTRY LENGTH  21898000
         ST    WORK1,GTSDALOC           PUT IT BACK UPDATED             21899000
         LH    WORK1,SSRAPDIS           PICK UP CURRENT DISPL           21900000
         LA    WORK1,SSRDEL(,WORK1)     ADD IN NEWEST ENTRY             21901000
         CH    WORK1,=AL2(SSRDEL*(SSRDNE-D1)) CHECK IF WRAP POINT HIT   21902000
         BNH   SSSKIP                   IF NOT, SKIP                    21903000
         SR    WORK1,WORK1              IF SO, RESET DISPL TO ZERO      21904000
SSSKIP   STH   WORK1,SSRAPDIS           SAVE WRAP-AROUND DISPL          21905000
SSFOUND  LA    R11,STFVAL               GET PTR TO STUFF FOR EDITOR     21906000
         B     DICTEXIT                 RETURN TO EDITOR                21907000
SSMVC    MVC   JDWORD(D0),D0(PARMREG)   EXECUTED SEQ SYMB MOVE          21908000
SREFMOVE MVC   SREFSS(D0),D0(PARMREG)   EXECUTED SEQ SYMB MOVE          21909000
         DROP  SSRDPTR                                                  21910000
         DROP  BUFPTR                                                   21911000
         DROP  R6                                                       21912000
         EJECT                                                          21913000
*SEQSYMBD - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21914000
*   DEFINITION OR OF OPEN CODE AFTER THE EDITED TEXT RECORD HAS       * 21915000
*   BEEN BUILT FOR A STATEMENT IN WHICH A SEQUENCE SYMBOL WAS         * 21916000
*   ENCOUNTERED IN THE NAME FIELD. ITS FUNCTION IS TO MAKE AN         * 21917000
*   ENTRY IN THE TEXT SEGMENT DICTIONARY FILE FOR THE SEQUENCE        * 21918000
*   SYMBOL DEFINITION.                                                * 21919000
*        INPUT - THE LENGTH OF THE SEQUENCE SYMBOL IN R11.            * 21920000
*              - A POINTER TO THE SEQUENCE SYMBOL (2-8 BYTES) IN R10. * 21921000
*                THE SEQUENCE SYMBOL HAS BEEN VERIFIED AS VALID.      * 21922000
*                THE STATEMENT DEFINING THE SEQUENCE SYMBOL HAS       * 21923000
*                BEEN PUT TO THE TEXT FILE PRIOR TO ENTRY.            * 21924000
*        OUTPUT - NONE.                                               * 21925000
*                                                                     * 21926000
SEQSYMBD EQU   *                                                        21927000
         LR    LNGTHREG,R11             SAVE LENGTH PARAMETER           21928000
         LR    PARMREG,R10              SAVE POINTER PARAMETER          21929000
         JNOTE FILE=FILE1               GET N/P ADDR AS SS DEF          21930000
         LA    WORK1,L'JNOTEVAL+D5(,LNGTHREG) DEVELOP RECORD LENGTH     21931000
         LR    R11,WORK1                SET UP FOR JPUTL                21932000
         JPUTL FILE=FILE2,BUFREQ=(R11)  GET BUFFER PTR AND SPACE        21933000
         USING SSDEF,BUFPTR                                             21934000
         STH   WORK1,SDEFRL             INSERT RECORD LENGTH            21935000
         MVC   SDEFNP(L'JNOTEVAL),JNOTEVAL  INSERT N/P ADDR             21936000
         BCTR  LNGTHREG,0               DROP LEADING PERIOD             21937000
         STC   LNGTHREG,SDEFSL          INSERT SEQ SYMB LENGTH          21938000
         EX    LNGTHREG,SSDEFMV         INSERT SEQ SYMB                 21939000
         MVI   SDEFRT,SDEFTYPE          INSERT RECORD TYPE              21940000
         BAL   RTNLNK,GETNPF2           NOTE TEXT SEG DICT, IF NECESS   21941000
         B     DICTEXIT                 RETURN TO EDITOR                21942000
SSDEFMV  MVC   SDEFSS(D0),D1(PARMREG)   EXECUTED SEQ SYMB MOVE          21943000
         DROP  BUFPTR                                                   21944000
         EJECT                                                          21945000
*OPERCODE - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 21946000
*   DEFINITION OR OF OPEN CODE WHEN AN OPERATION CODE IS ENCOUNT-     * 21947000
*   ERED. ITS FUNCTION IS TO LOCATE THE APPROPRIATE ENTRY IN THE      * 21948000
*   OP CODE TABLE AND TO RETURN TO THE EDITOR A POINTER TO THE ENTRY  * 21949000
*   LOCATED. ANY OPERATION CODE NOT LOCATED IN THE OP CODE TABLE IS   * 21950000
*   ENTERED IN THE MACRO DEFINITION DIRECTORY (SEE THE ROUTINE        * 21951000
*   'MACRNAME').                                                      * 21952000
*        INPUT - THE LENGTH OF THE MNEMONIC IN R11.                   * 21953000
*              - A POINTER TO THE MNEMONIC (1-8 BYTES) IN R10.        * 21954000
*                THE MNEMONIC HAS BEEN VERIFIED AS A VALID SYMBOL.    * 21955000
*        OUTPUT - A POINTER IN R11 TO THE 'FLAGA' BYTE IN THE OP      * 21956000
*                 CODE TABLE ENTRY FOR THE MNEMONIC.                  * 21957000
*               - APPROPRIATE FLAGS SET IN THE BYTE 'IOCID'.          * 21958000
*                                                                     * 21959000
OPERCODE EQU   *                                                        21960000
         LR    LNGTHREG,R11             SAVE LENGTH PARAMETER           21961000
         XC    JFWORD1(D8),JFWORD1      CLEAR WORK AREA                 21962000
         EX    R11,MNEMOVE              MOVE MNEMONIC T-6 WORK AREA     21963000
         NC    OPSCHN,OPSCHN            SEE IF ANY OPSYN ENTRIES        21964000
         BZ    OPERCD1                  BRANCH AROUND IF NONE           21965000
         BAL   R4,OPSYNAME              DO OPSYN SCAN                   21966000
OPERCD1  EQU   *                                                        21967000
         BAL   R4,OPERNAME              SEARCH OP CODE TABLE FIRST      21968000
         B     OPERCD2                  RETURN--NOT FOUND               21969000
         B     DICTEXIT                 RETURN--FOUND                   21970000
OPERCD2  BAL   R4,MACRNAME              LOOK UP AS A MACRO              21971000
         B     MACENTRY                 NOT FOUND                       21972000
         B     DICTEXIT                 FOUND                           21973000
OPERNAME EQU   *                                                        21974000
         L     EOPAIR2,JFWORD1          GET FIRST HALF OF NAME          21975000
         AL    EOPAIR2,JFWORD2          ADD SECOND HALF                 21976000
         SR    EOPAIR1,EOPAIR1          INITIALIZE AND DIVIDE BY        21977000
         D     EOPAIR1,=F'71'           HASHING VALUE                   21978000
         SLL   EOPAIR1,D1               DEVELOP HASH TABLE INDEX        21979000
         L     OCHNPTR,OCTSTRT          GET OP COD TBL BASE ADDR        21980000
         AR    OCHNPTR,HASHO            ADD DISPL TO REQ'D CHAIN        21981000
         USING OPNTRY,OCHNPTR                                           21982000
NXTCHN   CLC   OCHAIN,=FL3'0'           CHECK FOR END OF CHAIN          21983000
         BZR   R4                       IF FOUND, GO HANDLE MACRO CALL  21984000
         MVC   JHWORD1,OCHAIN           ALIGN CHAIN POINTER             21985000
         LH    OCHNPTR,JHWORD1          PICK UP LINK TO NEXT ENTRY      21986000
         A     OCHNPTR,OCTSTRT          GET ADDR OF NEXT CHAIN ENTRY    21987000
         SR    WORK1,WORK1              CLEAR WORK REGISTER             21988000
         IC    WORK1,OFLAGS             PICK UP ENTRY FLAGS             21989000
         N     WORK1,=F'7'              STRIP OUT ALL BUT MNEM LENGTH   21990000
         CLR   WORK1,LNGTHREG           SEE IF LENGTHS EQUAL            21991000
         BNE   NXTCHN                   BRANCH IF NOT                   21992000
         EX    LNGTHREG,OPCOMP          COMPARE MNEMONICS               21993000
         BNE   NXTCHN                   IF NOT SAME, SEARCH FURTHER     21994000
         MVC   IOCID(L'OFLAGS),OFLAGS        GET FLAGS FROM TBL ENTRY   21995000
         NI    IOCID,BITFF-BIT5-BIT6-BIT7    STRIP OUT LENGTH BITS      21996000
         LA    R11,D4(LNGTHREG,OCHNPTR) GET POINTER TO FLAGA BYTE       21997000
         B     D4(R4)                   RETURN--FOUND                   21998000
MNEMOVE  MVC   JFWORD1(D0),D0(R10)      REMOTE MNEMONIC MOVE            21999000
OPCOMP   CLC   JFWORD1(D0),OMNEM        EXECUTED MNEMONIC COMPARE       22000000
         DROP  OCHNPTR                                                  22001000
OPSYNAME LA    NAMEPTR,JFWORD1-D1       SET UP POINTER FOR OPSYN SCAN   22002000
         LA    R1,D1(,LNGTHREG)         GET MNEMONIC TRUE LENGTH        22003000
         STC   R1,JFWORD1-D1            STORE FOR COMPARE               22004000
OPSYNM1  BAL   RTNLNK,SCANOPSN          GO LOOK FOR OPSYN ENTRY         22005000
         B     OPSYNM2                  BRANCH IF FOUND                 22006000
         BR    R4                       BRANCH IF NOT FOUND             22007000
         USING OPSYNTRY,SCANPTR                                         22008000
OPSYNM2  GOIF  ODEL,ON=D4(R4)           SKIP OPCODE LOOKUP IF DELETED   22009000
         MVC   IOCID(D1),OPSYNFLG       MOVE FLAGS                      22010000
         LA    R11,OPSYNATT             POINT TO FLAGA, ETC.            22011000
         B     DICTEXIT                 AND EXIT                        22012000
         DROP  SCANPTR                                                  22013000
         EJECT                                                          22014000
*ORDSYMBR - THIS ROUTINE IS CALLED DURING THE EDITING OF A MACRO      * 22015000
*   DEFINITION OR OF OPEN CODE WHEN AN EXPLICIT REFERENCE TO AN       * 22016000
*   ATTRIBUTE OF AN ORDINARY SYMBOL IS ENCOUNTERED IN A CONDITIONAL   * 22017000
*   ASSEMBLY STATEMENT OR WHEN AN ORDINARY SYMBOL IS ENCOUNTERED      * 22018000
*   IN THE OPERAND OF A MACRO INSTRUCTION.                            * 22019000
*   ITS FUNCTION IS TO ENTER THE ORDINARY SYMBOL IN THE ORDINARY      * 22020000
*   SYMBOL REFERENCE DIRECTORY, IF IT HAS NOT BEEN PREVIOUSLY         * 22021000
*   ENTERED, AND TO RETURN TO THE EDITOR A POINTER TO THE APPRO-      * 22022000
*   PRIATE ENTRY IN THE GENERATION TIME ORDINARY SYMBOL REFERENCE     * 22023000
*   DICTIONARY. FOR EACH NEW ENTRY IN THE ORDINARY SYMBOL REFERENCE   * 22024000
*   DIRECTORY, THIS ROUTINE ALSO MAKES AN ENTRY IN THE TEXT SEGMENT   * 22025000
*   DICTIONARY FILE FOR THE ORDINARY SYMBOL REFERENCE.                * 22026000
*        INPUT - THE LENGTH OF THE ORDINARY SYMBOL IN R11.            * 22027000
*              - A POINTER TO THE ORDINARY SYMBOL (1-8 BYTES) IN R10. * 22028000
*                THE ORDINARY SYMBOL HAS BEEN VERIFIED AS VALID.      * 22029000
*        OUTPUT - A POINTER IN R11 TO THE TEXT FLAG BYTE IN THE       * 22030000
*                 ORDINARY SYMBOL REFERENCE DIRECTORY ENTRY FOR THE   * 22031000
*                 ORDINARY SYMBOL.                                    * 22032000
*                                                                     * 22033000
ORDSYMBR EQU   *                                                        22034000
         LA    R6,OSPARMS               POINT TO ORD SYMB VALUES        22035000
         B     COMNREF                  HANDLE AS SEQUENCE SYMBOL       22036000
         EJECT                                                          22037000
*ORDSYMBD - THIS ROUTINE IS CALLED DURING THE EDITING OF OPEN         * 22038000
*   CODE AFTER THE EDITED TEXT RECORD HAS BEEN BUILT FOR AN           * 22039000
*   'EXTRN' OR 'WXTRN' STATEMENT OR FOR A STATEMENT IN WHICH AN       * 22040000
*   ORDINARY SYMBOL WAS ENCOUNTERED IN THE NAME FIELD. ITS FUNCTION   * 22041000
*   IS TO MAKE AN ENTRY IN THE ORDINARY SYMBOL DEFINITION FILE.       * 22042000
*        INPUT - A POINTER IN R10 TO THE START OF THE EDITED TEXT     * 22043000
*                RECORD.                                              * 22044000
*        OUTPUT - NONE.                                               * 22045000
*                                                                     * 22046000
ORDSYMBD EQU   *                                                        22047000
         LR    R11,R10                  SET UP PTR FOR PUTL             22048000
         JPUTM FILE=FILE3,ADDR=(R11)    PUT RCD TO ORD SYMB DEF FILE    22049000
         B     DICTEXIT                 RETURN TO EDITOR                22050000
         EJECT                                                          22051000
*OPSYNBLD - THIS ROUTINE IS CALLED AFTER THE EDITING OF AN OPSYN      * 22052000
*   STATEMENT. ITS FUNCTION IS TO ENTER THE MNEMONIC AND ITS          * 22053000
*   SYNONYM IN THE OPSYN TABLE.                                       * 22054000
*        INPUT - A POINTER IN R10 TO THE EDITED TEXT RECORD.          * 22055000
*        OUTPUT - NONE.                                               * 22056000
*                                                                     * 22057000
OPSYNBLD EQU   *                                                        22058000
         USING JTEXT,R10                                                22059000
         LH    NAMEPTR,JTNMP            GET DISPL TO NAME FIELD         22060000
         LA    NAMEPTR,D1(NAMEPTR,R10)  DEVELOP PTR TO OPSYN NAME       22061000
         LH    SCANPTR,JTOPP            GET OPERAND FIELD DISPLACEMENT  22062000
         AR    R10,SCANPTR              POINT TO OPERAND                22063000
         USING JTOPO,R10                  AND DECLARE AS BASE.          22064000
         GOIF  JTOPOCD,OFF=OPBLD1       BRANCH IF NO CARD POINTER       22065000
         LA    R10,JTOPL                BUMP OVER CARD POINTER          22066000
OPBLD1   LA    R10,JTOPL                POINT TO OPERAND LENGTH         22067000
         USING JTOPL,R10                  AND RESET BASE.               22068000
         SR    R1,R1                    CLEAR REGISTER                  22069000
         IC    R1,D0(NAMEPTR)           PICK UP NAME FIELD LENGTH       22070000
         LR    LNGTHREG,R1              PLACE MNEMONIC IN LENGTH REG    22071000
         BCTR  LNGTHREG,0                 AND MAKE MOVE LENGTH          22072000
         GOIF  JTOPL,D0,EQ=OPBLD10      EXIT IF NULL OPERAND            22073000
         CLC   JTOPL(D2),=AL1(D1,JCOMMA) CHECK FOR COMMA IN OPERAND     22074000
         BE    OPBLD10                  BRANCH IF YES--NULL OPERAND     22075000
*              NAMEPTR POINTS TO MNEMONIC TO BE SEARCHED                22076000
         BAL   RTNLNK,SCANOPSN          SEARCH FOR PREVIOUS ENTRY       22077000
         B     OPBLD2                   RETURN HERE IF FOUND            22078000
*                                       RETURN HERE IF NOT FOUND        22079000
         BAL   RTNLNK,OPENTRY           GO MAKE OPSYN ENTRY             22080000
         B     OPBLD3                   SKIP AROUND                     22081000
OPBLD2   EQU   *                                                        22082000
         LR    ENTRYPTR,SCANPTR         POINT TO ENTRY                  22083000
*              ENTRYPTR IS OPSYN ENTRY BASE                             22084000
         USING OPSYNTRY,ENTRYPTR        DECLARE BASE                    22085000
         SET   OPREV,ON                                                 22086000
OPBLD3   EQU   *                                                        22087000
OPBLD4   EQU   *                                                        22088000
         LR    NAMEPTR,R10              POINT TO MNEMONIC               22089000
         IC    R1,JTOPL                 PICK UP OPSYN OPERAND LENGTH    22090000
         DROP  R10                                                      22091000
         LR    LNGTHREG,R1              PUT LENGTH IN LENGTH REG        22092000
         BCTR  LNGTHREG,0                 AND MAKE INTO MOVE LENGTH     22093000
         BAL   RTNLNK,SCANOPSN          SEE IF THERE IS AN OPSYN        22094000
         B     OPBLD6                   RETURN HERE IF FOUND            22095000
OPBLD7   XC    JFWORD1(D8),JFWORD1      CLEAR WORK AREA                 22096000
         EX    R1,NAMEMV                USE TO MOVE OPERAND TO WORK    X22097000
                                          AREA.                         22098000
OPBLD8   BAL   R4,OPERNAME              GO SEE IF THERE'S AN OP CODE    22099000
         B     OPBLD5                   RETURN HERE IF NOT FOUND        22100000
*                                       RETURN HERE IF FOUND            22101000
         MVC   OPSYNATT,D0(R11)         MOVE ATTRIBUTES TO OPSYN ENTRY  22102000
         MVC   OPSYNFLG(D1),IOCID       MOVE FLAGS TO OPSYN ENTRY       22103000
         B     DICTEXIT                 EXIT POINT                      22104000
         SPACE                                                          22105000
OPBLD6   EQU   *                                                        22106000
*              SCANPTR POINTS TO OLD OPSYN ENTRY                        22107000
         CLC   HIBYTE0,OPSCHN           IS IT THE LAST OPSYN            22108000
         BNE   OPBLD9                   NO                              22109000
         TM    D3(SCANPTR),OPREV                                        22110000
         BZ    OPBLD7                                                   22111000
OPBLD9   TM    D3(SCANPTR),ODEL         DELETED                         22112000
         BO    OPBLDER1                 OR AN ERRONEOUS OPSYN           22113000
         MVC   OPSYNFLG(D4),D3(SCANPTR) MOVE ATTRIBUTES AND FLAGS       22114000
         B     DICTEXIT                 EXIT                            22115000
         SPACE                                                          22116000
OPBLD5   EQU   *                                                        22117000
         GOIF  OPREV,OFF=OPBLDER1                                       22118000
OPBLDERR SET   ODEL,ON                  MARK AS A DELETE ENTRY          22119000
         MVC   DSEVCD(D2),=AL1(SEV8,ERR8)    LOG ERROR--CIRCULAR       X22120000
                                             OPSYN OPERAND              22121000
         B     DICTEXIT                 EXIT                            22122000
         SPACE                                                          22123000
*        OPSYN DELETE ROUTINE                                           22124000
         SPACE                                                          22125000
OPBLD10  EQU   *                        DELETE AN ENTRY                 22126000
         SPACE                                                          22127000
*        ON ENTRY R1 CONTAINS MNEMONIC LENGTH                           22128000
*              LNGTHREG CONTAINS LENGTH-1                               22129000
*                 NAMEPTR CONTAINS POINTER TO MNEMONIC IN TEXT RECORD   22130000
         SPACE                                                          22131000
         XC    JFWORD1(D8),JFWORD1      CLEAR WORK AREA                 22132000
         EX    R1,NAMEMV                MOVE NAME TO WORK AREA          22133000
         BAL   RTNLNK,SCANOPSN          SEARCH FOR OPSYN ENTRY          22134000
         B     OPBLD11                  RETURN HERE IF FOUND            22135000
*                                       RETURN HERE IF NOT FOUND        22136000
         BAL   R4,OPERNAME              LOOK FOR OP CODE                22137000
         B     OPBLDER1                 RETURN HERE IF NOT FOUND        22138000
*                                       RETURN HERE IF FOUND            22139000
         LA    NAMEPTR,JFWORD1-D1       RESET POINTER TO MNEMONIC       22140000
         BAL   RTNLNK,OPENTRY           MAKE OPSYN ENTRY                22141000
         SET   ODEL,ON                  MARK AS A DELETE                22142000
         B     DICTEXIT                 RETURN                          22143000
OPBLDER1 SET   ODEL,ON                  MARK AS A DELETE ENTRY          22144000
         MVC   DSEVCD(D2),=AL1(SEV14,ERR14)                            X22145000
               LOG ERROR - INVALID OPCODE IN NAME FIELD                 22146000
         B     DICTEXIT                 RETURN                          22147000
OPBLD11  EQU   *                                                        22148000
         DROP  ENTRYPTR                                                 22149000
         USING OPSYNTRY,SCANPTR         BASE                            22150000
         SET   OPREV,ON                                                 22151000
         SET   ODEL,ON                  MARK AS DELETE                  22152000
         DROP  SCANPTR                                                  22153000
         USING OPSYNTRY,ENTRYPTR        BASE FOR OPSYN ENTRY            22154000
         B     DICTEXIT                 RETURN                          22155000
         SPACE                                                          22156000
         SPACE                                                          22157000
OPENTRY  EQU   *                                                        22158000
         L     ENTRYPTR,MDDSLOT         POINTER TO NEXT FREE SLOT       22159000
         SH    ENTRYPTR,=AL2(OPSYND-OPSYNTRY)  MAKE ROOM FOR NEW ENTRY  22160000
         GOIF  (ENTRYPTR),VSDSLOT,LOW=OERR EXIT IF NO ROOM              22161000
         ST    ENTRYPTR,MDDSLOT         UPDATE TABLE BOUNDARY           22162000
         XC    OPSYNTRY(OPSYNLN),OPSYNTRY    CLEAR IT OUT               22163000
         MVC   OPSYNCH,OPSCHN+(L'OPSCHN-L'OPSYNCH)  LINK THE CHAIN      22164000
         LCR   R15,ENTRYPTR             COMPLEMENT AND USE TO CALCULATE 22165000
         A     R15,MDDSTRT              NEW CHAIN POINTER               22166000
         ST    R15,OPSCHN               SAVE AS MASTER LINK             22167000
         EX    R1,NAME1MV               MOVE NAME TO OPSYN ENTRY        22168000
         BR    RTNLNK                   RETURN                          22169000
         SPACE                                                          22170000
*        EXECUTED OPERATIONS                                            22171000
         SPACE                                                          22172000
NAME1MV  MVC   ONAMEL(D0),D0(NAMEPTR)   MNEMONIC MOVE TO OPSYN ENTRY    22173000
NAMEMV   MVC   JFWORD1-D1(D0),D0(NAMEPTR)    ALIGN OPSYN NAME           22174000
         DROP  ENTRYPTR                                                 22175000
         EJECT                                                          22176000
*                                                                       22177000
* THIS SUBROUTINE SEARCHES THE VARIABLE SYMBOL DIRECTORY FOR A          22178000
*        SPECIFIED VARIABLE SYMBOL.                                     22179000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES-                      22180000
*                   VARBSYMD                                            22181000
*                   VARBSYMR                                            22182000
*                                                                       22183000
VSLOOKUP EQU   *                                                        22184000
         LR    LNGTHREG,R11             SAVE LENGTH PARAMETER           22185000
         LR    PARMREG,R10              SAVE POINTER PARAMETER          22186000
         XC    JDWORD,JDWORD            CLEAR VARB NAME AREA            22187000
         EX    LNGTHREG,VARMOVE         MOVE NAME TO ALIGNED AREA       22188000
         L     EOPAIR2,JDWORD           GET FIRST HALF OF NAME          22189000
         AL    EOPAIR2,JDWORD+D4        ADD SECOND HALF                 22190000
         SR    EOPAIR1,EOPAIR1          INITIALIZE AND DIVIDE BY        22191000
         D     EOPAIR1,=F'201'          HASHING VALUE                   22192000
         N     EOPAIR1,=F'127'          INSURE HASH VALUE IN RANGE      22193000
         LR    EOPAIR2,EOPAIR1          SET UP TO CALC DISPL            22194000
         MH    EOPAIR2,=H'3'            MULTIPLY FOR RANGE 0-381        22195000
         L     VSDPTR,VSDSTRT           GET VAR SYMB DIR BASE ADDR      22196000
         AR    VSDPTR,HASHV             ADD DISPL TO REQ'D CHAIN        22197000
         USING VSDENTRY,VSDPTR                                          22198000
CHNON    CLC   VCHAIN,=FL3'0'           CHECK FOR END OF CHAIN          22199000
         BZ    NTFND                    IF YES, GO FLAG IT AND EXIT     22200000
         MVC   HIBYTE0+(L'HIBYTE0-L'VCHAIN)(L'VCHAIN),VCHAIN           X22201000
               MOVE CHAIN POINTER                                       22202000
         L     VSDPTR,HIBYTE0           TO ALIGNED AREA, PICK IT UP     22203000
         A     VSDPTR,VSDSTRT           GET ADDR OF NEXT CHAIN ENTRY    22204000
         SR    WORK1,WORK1              CLEAR WORK REGISTER             22205000
         IC    WORK1,VLNGTH             PICK UP LENGTH OF ENTRY         22206000
         N     WORK1,=F'7'              STRIP OUT ALL BUT LENGTH BITS   22207000
         CLR   WORK1,LNGTHREG           COMPARE VARB SYMB LENGTHS       22208000
         BNE   CHNON                    IF UNEQUAL, SEARCH FURTHER      22209000
         EX    LNGTHREG,VARCOMP         COMPARE VARIABLE SYMBOLS        22210000
         BNE   CHNON                    IF NOT SAME, SEARCH FURTHER     22211000
         SET   FNDFLG,ON                IF SAME, FLAG IT                22212000
         BR    RTNLNK                        AND EXIT                   22213000
NTFND    SET   FNDFLG,OFF               INDICATE VARB SYM NOT FOUND     22214000
         BR    RTNLNK                   RETURN TO CALLING RTN           22215000
VARCOMP  CLC   VSYMBL(D0),D0(PARMREG)   EXECUTED VARB NAME COMPARE      22216000
VARMOVE  MVC   JDWORD(D0),D0(PARMREG)   EXECUTED VARB NAME MOVE         22217000
         DROP  VSDPTR                                                   22218000
*                                                                       22219000
* THIS SUBROUTINE NOTES THE TEXT SEGMENT DICTIONARY FILE FOLLOWING      22220000
*        THE FIRST WRITE TO THAT FILE FOR EACH TEXT SEGMENT.            22221000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES-                      22222000
*                   VARBSYMD                                            22223000
*                   SEQSYMBR                                            22224000
*                   SEQSYMBD                                            22225000
*                   ORDSYMBR                                            22226000
*                                                                       22227000
GETNPF2  GOIF  NOTEFIL2,OFF=(RTNLNK)    RETURN IF FLAG SET OFF          22228000
         SET   NOTEFIL2,OFF             SET FLAG OFF                    22229000
         ST    RTNLNK,REGSAVE1          TEMPOR SAVE LINK REG            22230000
         JNOTE FILE=FILE2               NOTE TEXT SEG DICT FILE         22231000
         MVC   SAVENOTE,JNOTEVAL        SAVE N/P ADDR FOR MDD ENTRY     22232000
         L     RTNLNK,REGSAVE1          RESTORE LINK REG                22233000
         BR    RTNLNK                   RETURN                          22234000
*                                                                       22235000
* THIS SUBROUTINE PERFORMS A BUFFERED WRITE TO ANY FILE.                22236000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       22237000
*                   PHASEND                                             22238000
*                                                                       22239000
BUFRITE  EQU   *                                                        22240000
         MVI   FSWITCH,J0               CLEAR FIRST WRITE/NOTE SWITCH   22241000
         LM    R3,R4,PIOPARMB           PICK UP I/O PARAMETERS          22242000
BR1      CLR   R3,R5                    SEE IF RECORD LESS THAN MAX     22243000
         BH    BR4                      BRANCH IF NOT                   22244000
         CH    R3,=AL2(MINRECSZ)        SEE IF BLOCK OVER MINIMUM       22245000
         BNL   BR11                     BRANCH IF MORE OR JUST ENUF     22246000
         LA    R3,MINRECSZ              IF NOT, USE MINIMUM SIZE        22247000
BR11     EQU   *                                                        22248000
         STH   R3,PIOPARMC              SET UP I/O LENGTH PARAM         22249000
         SR    R3,R3                    INDICATE LAST WRITE             22250000
BR2      JWRITE FILE=(R6),PARM=PIOPARMA WRITE RECORD TO PROPER FILE     22251000
         JCHECK FILE=(R6)               CHECK THE WRITE                 22252000
         TS    FSWITCH                  TEST AND SET FIRST WRITE SW     22253000
         BNZ   BR3                      BRANCH IF NOT FIRST WRITE       22254000
         JNOTE FILE=(R6)                NOTE FIRST BLOCK WRITTEN        22255000
BR3      LTR   R3,R3                    SEE IF WRITE COMPLETE           22256000
         BZR   R7                       RETURN IF YES                   22257000
         AR    R4,R5                    DEVELOP PTR TO NEXT I/O AREA    22258000
         ST    R4,PIOPARMA              PUT PTR IN I/O CONTROL AREA     22259000
         B     BR1                      GO SET UP NEW WRITE LENGTH      22260000
BR4      STH   R5,PIOPARMC              USE MAX RCD LENGTH THIS TIME    22261000
         SR    R3,R5                    ADJUST RECORD LENGTH            22262000
         B     BR2                      GO WRITE NEXT RECORD            22263000
*                                                                       22264000
* THIS SUBROUTINE PERFORMS THE INITIALIZATION COMMON TO A MACRO         22265000
*        DEFINITION AND OPEN CODE. IT IS CALLED FROM THE                22266000
*        FOLLOWING ROUTINES - OPENENT, MACRENT                          22267000
*                                                                       22268000
COMNINIT EQU   *                                                        22269000
         SET   NOTEFIL2,ON              SET NOTE FLAG FOR FILE 2        22270000
         L     WORK1,SSRDSTRT           GET PTR TO SS REF DIRECTORY     22271000
         MVI   D0(WORK1),JBLANK         INSERT CHARACTER TO CLEAR       22272000
         MVC   D1(SSRDLNGT-D1,WORK1),D0(WORK1) SEQ SYMB REFER DIRECT    22273000
         L     WORK1,VSDSTRT            GET PTR TO VSD HASH TABLE       22274000
         XC    D0(VSDHTLNT-D256,WORK1),D0(WORK1) CLEAR VSD HASH TABLE,  22275000
         XC    VSDHTLNT-D256(D256,WORK1),VSDHTLNT-D256(WORK1) 2 PARTS   22276000
         LA    WORK1,VSDHTLNT(,WORK1)   ADJUST PTR PAST HASH TABLE      22277000
         ST    WORK1,VSDSLOT            RESET START OF VSD ENTRY AREA   22278000
         BR    WORK3                    RETURN                          22279000
*                                                                       22280000
* THIS SUBROUTINE PERFORMS THE TERMINATION COMMON TO A MACRO            22281000
*        DEFINITION AND OPEN CODE. IT IS CALLED FROM THE                22282000
*        FOLLOWING ROUTINES - OPENEND, MACREND                          22283000
*                                                                       22284000
COMNEND  EQU   *                                                        22285000
         JPUTL FILE=FILE2,BUFREQ=L'ESEGRL+L'ESEGRT GET RECORD LENGTH    22286000
         USING ENDSEG,BUFPTR                                            22287000
         MVC   ESEGRL(L'ESEGRL+L'ESEGRT),=AL1(0,L'ESEGRL+L'ESEGRT,ESEGTX22288000
               YPE) INSERT RECORD LENGTH AND TYPE                       22289000
         BAL   RTNLNK,GETNPF2           NOTE TEXT SEG DICT, IF NECESS   22290000
         L     WORK1,CURMDDPT           PICK UP CURRENT MDD SLOT PTR    22291000
         USING MDDNTRY,WORK1                                            22292000
         MVC   MLCLSZ,GTLDALOC+(L'GTLDALOC-L'MLCLSZ) INSERT LCL DICT    22293000
         MVC   MSEQSZ,GTSDALOC+(L'GTSDALOC-L'MSEQSZ) INSERT SEQ DICT    22294000
         MVC   MGBLSZ,GTGVALOC+(L'GTGVALOC-L'MGBLSZ) INSERT GBL VCT     22295000
         BR    WORK3                    RETURN                          22296000
         DROP  WORK1                                                    22297000
*                                                                       22298000
* THIS SUBROUTINE SCANS THE OPSYN TABLE FOR A GIVEN OP CODE.            22299000
*                                                                       22300000
SCANOPSN MVC   HIBYTE0,OPSCHN           SET UP INITIAL CHAIN PTR        22301000
SCOPN1   L     SCANPTR,HIBYTE0          PICK UP PTR TO NEXT CHAIN ENTRY 22302000
         LTR   SCANPTR,SCANPTR          SEE IF END OF CHAIN             22303000
         BZ    D4(,RTNLNK)              TAKE NOT-FOUND EXIT             22304000
         USING OPSYNTRY,SCANPTR                                         22305000
         LCR   SCANPTR,SCANPTR          GET VALUE FOR CALCULATION OF    22306000
         A     SCANPTR,MDDSTRT          OPSYN ENTRY LOCATION            22307000
         EX    R1,COMPNAME              REMOTE MNEMONIC COMPARE         22308000
         BER   RTNLNK                   TAKE FOUND EXIT                 22309000
         MVC   HIBYTE0+(L'HIBYTE0-L'OPSYNCH)(L'OPSYNCH),OPSYNCH        X22310000
                SET UP LINK TO NEXT ENTRY                               22311000
         B     SCOPN1                   GO BACK THRU SEARCH LOOP        22312000
COMPNAME CLC   ONAMEL,D0(NAMEPTR)       COMPARE MNEMONICS               22313000
         DROP  SCANPTR                                                  22314000
         EJECT                                                          22315000
OCTSTRT  DC    A(OPBASE)                POINTER TO OP CODE TABLE        22316000
         JEXTRN (X1K01=OPBASE)                                          22317000
SYSNDX   DC    AL1(VSNS+VTYP2),X'05',AL1(JS,JY,JS,JN,JD,JX,JBLANK)     X22318000
               DEFINITION OF SYSNDX SYSTEM LOCAL                        22319000
SYSECT   DC    AL1(VSNS+VTYP2+VSTP1+VSTP2),X'05',AL1(JS,JY,JS,JE,JC,JT,X22320000
               JBLANK) DEFINITION OF SYSECT SYSTEM LOCAL                22321000
SYSLST   DC    AL1(VSNS+VSLS+VDIM+VTYP2),X'06',AL1(JS,JY,JS,JL,JI,JS,JTX22322000
               ) DEFINITION OF SYSLIST SYSTEM LOCAL                     22323000
SYSPRM   DC    AL1(VSNS+VSTP1+VSTP2),X'06',AL1(JS,JY,JS,JP,JA,JR,JM)   X22324000
               DEFINITION OF SYSPARM SYSTEM GLOBAL                      22325000
SYSTME   DC    AL1(VSNS+VSTP1+VSTP2),X'06',AL1(JS,JY,JS,JT,JI,JM,JE)   X22326000
               DEFINITION OF SYSTIME SYSTEM GLOBAL                      22327000
SYSDTE   DC    AL1(VSNS+VSTP1+VSTP2),X'06',AL1(JS,JY,JS,JD,JA,JT,JE)   X22328000
               DEFINITION OF SYSDATE SYSTEM GLOBAL                      22329000
         DC    X'FF'                    END OF TABLE FLAG               22330000
         SPACE 3                                                        22331000
         EJECT                                                          22332000
         JPATCH X1J00,B64                                               22333000
         END                                                            22334000
./ ADD NAME=IFNX1S                                                      22335000
         MACRO                                                          22336000
         BIND  &OP                                                      22337000
         ORG   BINDERS+JTM&OP           ORIGIN                          22338000
         DC    AL1(BIND&OP)                  VALUE                      22339000
         SPACE                                                          22340000
         MEND                                                           22341000
         EJECT                                                          22342000
         JHEAD 'CONDITIONAL ASSEMBLY POSTFIX ROUTINE',                 X22343000
               PHASEID=X1S,                                            X22344000
               LEVEL=10                                                 22345000
*FUNCTION/OPERATION--                                                 * 22346000
*   AS THE EDITOR PROCESSES EXPRESSIONS, IT WILL PLACE ALL TERMS IM-  * 22347000
*   MEDIATELY INTO THE TEXT, BUT WILL PASS ALL OPERATORS TO POSTER.   * 22348000
*   POSTER WILL ENTER OPERATORS INTO AN OPERATOR STACK, RETURNING     * 22349000
*   OPERATORS TO THE EDITOR IN PROPER SEQUENCE FOR POSTFIX NOTATION,  * 22350000
*   ALSO CALLED REVERSE POLISH, WITHOUT PARENTHESES.                  * 22351000
*                                                                     * 22352000
*   EACH OPERATOR IS ASSIGNED A BINDING FACTOR.  LOWEST BINDING FACTOR* 22353000
*   IS TO BE EVALUATED FIRST.  ALL INCOMING OPERATORS ARE COMPARED    * 22354000
*   WITH THE LAST OPERATOR IN THE STACK. IF THE BINDING FACTOR OF     * 22355000
*   THE INPUT IS LOWER THAN THAT OF THE STACK, THE NEW ONE IS ADDED   * 22356000
*   TO THE STACK. IF EQUAL OR GREATER, THE INPUT IS SAVED AND THE     * 22357000
*   LAST STACK ENTRY IS RETURNED.                                     * 22358000
*                                                                     * 22359000
*   A LEFT PAREN IS ENTERED IMMEDIATELY INTO THE STACK.  A RIGHT PAREN* 22360000
*   CAUSES THE STACK TO DUMP TO A LEFT PAREN, AND THE PARENS ARE DIS- * 22361000
*   CARDED.  A TERMINATOR HAS HIGHEST BINDING FACTOR, AND CAUSES THE  * 22362000
*   ENTIRE STACK TO DUMP.  THE TERMINATOR ITSELF WILL BE THE LAST OP- * 22363000
*   ERATOR RETURNED TO THE EDITOR.                                    * 22364000
*                                                                     * 22365000
*ENTRY POINTS--                                                       * 22366000
*        X1S01  =  POSTER01             FUNCTIONAL ENTRY POINT        * 22367000
*                                                                     * 22368000
*INPUT--                                                              * 22369000
*   INPUT IS AN OPERATOR IN REGISTER R10.                             * 22370000
*                                                                     * 22371000
*OUTPUT--                                                             * 22372000
*   NONE                                                              * 22373000
*                                                                     * 22374000
*EXTERNAL ROUTINES--NONE                                              * 22375000
*                                                                     * 22376000
*EXITS--                                                              * 22377000
*   NORMAL-                                                           * 22378000
*        B     D4(,R9)                  TAKE NORMAL EXIT              * 22379000
*   ERROR-                                                            * 22380000
*        BR    R9                       TAKE ERROR EXIT               * 22381000
*                                                                     * 22382000
*TABLES/WORK AREAS--                                                  * 22383000
*   BINDERS--A TABLE OF BINDING FACTORS OF THE OPERATORS.             * 22384000
*                                                                     * 22385000
*   STACK--A DYNAMIC OPERATOR STACK CONTAINING ALL OPERATORS NOT YET  * 22386000
*   RETURNED TO THE EDITOR.  PUSH DOWN.  TWO BYTES/ENTRY.             * 22387000
*                                                                     * 22388000
*   TEMP--THE LAST OPERATOR IN AND ITS BINDING FACTOR, UNTIL IT IS PUT* 22389000
*   IN THE STACK.                                                     * 22390000
*                                                                     * 22391000
*   POINTER--POINTS TO NEXT AVAILABLE STACK POSITION.                 * 22392000
*                                                                     * 22393000
*ATTRIBUTES--                                                         * 22394000
*   REFRESHABLE.  ALL DYNAMIC ELEMENTS ARE IN MODULE COMMON POINTED TO* 22395000
*   BY R7.                                                              22396000
*                                                                     * 22397000
*NOTES--                                                              * 22398000
*                                                                     * 22399000
         EJECT                                                          22400000
         COPY  JCOMMON                                                  22401000
         EJECT                                                          22402000
         COPY  JTMTXT                                                   22403000
         EJECT                                                          22404000
         COPY  EDSECT                                                   22405000
         EJECT                                                          22406000
STACKREC DSECT ,                        STACK ELEMENT SNAPSHOT          22407000
LAST     DS    0H                       LAST STACK ENTRY                22408000
LASTOP   DS    C                             OPERATOR                   22409000
LASTBIND DS    C                             BINDING FACTOR             22410000
NEXT     DS    0H                       NEXT STACK ENTRY                22411000
NEXTOP   DS    C                             OPERATOR                   22412000
NEXTBIND DS    C                             BINDING FACTOR             22413000
         SPACE                                                          22414000
TEXTPTR  DSECT                                                          22415000
TEXT     DS    C                        CURRENT TEXT POINTER            22416000
TEXTNEXT DS    C                        NEXT AVAILABLE TEXT POSITION    22417000
         EJECT                                                          22418000
         JCSECT (X1S00)                                                 22419000
         JMODID                                                         22420000
         SPACE 3                                                        22421000
*        REGISTERS                                                      22422000
         SPACE                                                          22423000
RLAST    EQU   R3                       POINTS TO LAST STACK ELEMENT    22424000
OP       EQU   R10                      INPUT OPERATOR                  22425000
FACTOR   EQU   R15                      BINDING FACTOR WORK REGISTER    22426000
MODCOMM  EQU   R2                       BASE FOR PHASE COMMON           22427000
         SPACE                                                          22428000
*        OTHER VALUES                                                   22429000
         SPACE                                                          22430000
ASTACK   EQU   ALAST                   ALAST IS IN EDSECT               22431000
D70      EQU   70                      LENGTH OF OPERATOR STACK - 2     22432000
         SPACE 3                                                        22433000
POSTER01 EQU   *                        INITIALIZATION ENTRY            22434000
         SPACE                                                          22435000
         JENTRY (X1S01=POSTER01)                                        22436000
         SPACE                                                          22437000
         USING POSTER01,R12                                             22438000
         L     RLAST,SVLAST             PICK UP STACK POINTER           22439000
         USING STACKREC,RLAST             AND DECLARE AS BASE.          22440000
         STC   OP,TEMPOP                SAVE THE OPERATOR               22441000
         SPACE                                                          22442000
POSTER12 EQU   *                                                        22443000
         SPACE                                                          22444000
         IC    FACTOR,BINDERS(OP)       LOAD REGISTER WITH BINDING     X22445000
                                          FACTOR CORRESPONDING TO INPUT 22446000
         STC   FACTOR,TEMPBIND          SAVE THE BINDING FACTOR         22447000
         SPACE                                                          22448000
POSTER14 EQU   *                                                        22449000
         SPACE                                                          22450000
         GOIF  TEMPOP,JTMLPAR,EQ=POSTER40   PUT IN STACK IF LEFT PAREN  22451000
         GOIF  TEMPBIND,BINDPLUS,EQ=POSTER40      PUT IN STACK IF UNARY 22452000
         GOIF  TEMPOP,JTMSCM,EQ=POSTER50 PUT IN TEXT IF START CHARACTERX22453000
                                          MODE.                         22454000
         GOIF  TEMPOP,JTMECM,EQ=POSTER50    LIKEWISE IF END CHARACTER  X22455000
                                            MODE                        22456000
POSTER20 GOIF  (RLAST),ALAST,LOW=POSTER40  GO ENTER NEW OP IF          X22457000
                                                  THE STACK IS EMPTY.   22458000
         GOIF  TEMPBIND,LASTBIND,LOW=POSTER40     ENTER THE NEW OP IF  X22459000
                                                  ITS BINDING FACTOR   X22460000
                                                  IS LOW.               22461000
         SPACE                                                          22462000
POSTER22 EQU   *                        ONE FROM STACK TO TEXT.         22463000
         SPACE                                                          22464000
         USING TEXTPTR,R4               TEXT BASED ON REG 4             22465000
         MVC   TEXT,LASTOP              MOVE OPERATOR TO TEXT           22466000
         LA    R4,TEXTNEXT              NEXT TEXT POSITION              22467000
         SH    RLAST,=H'2'              REMOVE ONE ELEMENT FROM STACK   22468000
         B     POSTER20                 LOOP THE LOOP                   22469000
         SPACE 3                                                        22470000
POSTER50 EQU   *                                                        22471000
         SPACE                                                          22472000
         MVC   TEXT,TEMPOP                                              22473000
         B     POSTER66                 GO TO EXIT SEQUENCE             22474000
         SPACE                                                          22475000
POSTER40 EQU   *                                                        22476000
         LA    OP,STACK+D70             GET PTR TO LAST STACK SLOT      22477000
         CR    OP,RLAST                 SEE IF STACK OVERFLOW OCCURS    22478000
         BNHR  R9                       TAKE ERROR EXIT OF SO           22479000
         MVC   NEXT,TEMP                MOVE OP AND BINDER TO STACK AND 22480000
         LA    RLAST,NEXT                 UPDATE POINTER.               22481000
         SPACE                                                          22482000
POSTER60 EQU   *                                                        22483000
         SPACE                                                          22484000
         GOIF  TEMPOP,JTMRPAR,EQ=POSTER70    IF RIGHT PAREN, REMOVE IT X22485000
                                             AND LEFT PAREN FROM STACK  22486000
POSTER64 GOIF  TEMPOP,JTMCOM,EQ=POSTER72     COMMA, BRANCH              22487000
         GOIF  TEMPOP,JTMPER,NE=POSTER90  EXIT IF LAST OP NOT PERIOD    22488000
         MVI   TEXT,JTMPER              ELSE PUT A PERIOD IN THE TEXT   22489000
POSTER65 SH    RLAST,=H'2'              REMOVE TERM FROM STACK          22490000
POSTER66 LA    R4,TEXTNEXT              ADJUST TEXT OUTPUT POINTER      22491000
         SPACE                                                          22492000
POSTER90 ST    RLAST,SVLAST             SAVE THE STACK POINTER          22493000
         SPACE                                                          22494000
POSTER99 B     D4(,R9)                  NO ERROR TO LOG, NORMAL EXIT    22495000
         SPACE                                                          22496000
POSTER70 SH    RLAST,=H'4'              REMOVE LPAREN AND RPAREN        22497000
         GOIF  LASTOP,JTMDIM,EQ=POSTER71     BRANCH IF DIMENSION        22498000
         GOIF  LASTOP,JTMDIM3,NE=POSTER90    EXIT IF NO DIMENSION       22499000
POSTER71 MVC   TEXT,LASTOP              MOVE DIMENSION TO TEXT          22500000
         B     POSTER65                 GO TO EXIT SEQUENCE             22501000
         SPACE                                                          22502000
POSTER72 SH    RLAST,=H'4'              REMOVE L AND RPAREN             22503000
         GOIF  LASTOP,JTMDIM,NE=POSTER74  BRANCH IF NOT DIMENSION       22504000
         MVI   TEXT,JTMDIM2             SYSLIST(N) TO TEXT              22505000
         LA    R4,TEXTNEXT              UPDATE TEXT POINTER             22506000
         MVI   LASTOP,JTMDIM3           CHANGE DIMENSION OP IN STACK    22507000
POSTER74 AH    RLAST,=H'2'              PUT LPAREN BACK IN STACK        22508000
         B     POSTER90                 AND EXIT.                       22509000
         DROP  R4                                                       22510000
         SPACE                                                          22511000
         EJECT                                                          22512000
*        CONSTANTS, TABLES, EQUATES                                     22513000
         SPACE                                                          22514000
*        BINDING FACTORS                                                22515000
         SPACE                                                          22516000
BINDDIM  EQU   0                        DIMENSION OPERATOR              22517000
BINDSTR  EQU   BINDDIM+1                STRING OPERATOR                 22518000
BINDDUP  EQU   BINDSTR+1                DUPLICATION OPERATOR            22519000
BINDPER  EQU   BINDDUP+1                PERIOD--CONCATENATOR            22520000
BINDPLUS EQU   BINDPER+1                UNARY PLUS                      22521000
BINDMIN  EQU   BINDPLUS                 UNARY MINUS                     22522000
BINDTAT  EQU   BINDPLUS                 TYPE ATTRIBUTE                  22523000
BINDLAT  EQU   BINDPLUS                 LENGTH ATTRIBUTE                22524000
BINDSAT  EQU   BINDPLUS                 SCALE ATTRIBUTE                 22525000
BINDIAT  EQU   BINDPLUS                 INTEGER ATTRIBUTE               22526000
BINDKAT  EQU   BINDPLUS                 COUNT ATTRIBUTE                 22527000
BINDNAT  EQU   BINDPLUS                 NUMBER ATTRIBUTE                22528000
BINDMULT EQU   BINDPLUS+1               MULTIPLY                        22529000
BINDDIV  EQU   BINDMULT                 DIVIDE                          22530000
BINDADD  EQU   BINDMULT+1               ADD                             22531000
BINDSUB  EQU   BINDADD                  SUBTRACT                        22532000
BINDGT   EQU   BINDADD+1                GREATER THAN                    22533000
BINDGE   EQU   BINDGT                   GREATER OR EQUAL                22534000
BINDLT   EQU   BINDGT                   LESS THAN                       22535000
BINDLE   EQU   BINDGT                   LESS OR EQUAL                   22536000
BINDEQ   EQU   BINDGT                   EQUAL                           22537000
BINDNE   EQU   BINDGT                   NOT EQUAL                       22538000
BINDNOT  EQU   BINDGT+1                 NOT                             22539000
BINDAND  EQU   BINDNOT+1                AND                             22540000
BINDOR   EQU   BINDAND+1                OR                              22541000
BINDRPAR EQU   BINDOR+1                 RIGHT PAREN                     22542000
BINDECM  EQU   BINDRPAR                 END CHARACTER MODE              22543000
BINDCOM  EQU   BINDRPAR                 COMMA                           22544000
BINDLPAR EQU   BINDRPAR+1               LEFT PAREN                      22545000
BINDSCM  EQU   BINDLPAR                 START CHARACTER MODE            22546000
BINDSTRM EQU   BINDLPAR+1               STATEMENT TERMINATOR            22547000
HIBIND   EQU   BINDSTRM                 HIGHEST BINDING FACTOR          22548000
         SPACE                                                          22549000
BINDERS  EQU   *                        NAME THE TABLE,                 22550000
         SPACE                                                          22551000
         BIND  DIM                      DIMENSION                       22552000
         BIND  STR                      SUB STRING                      22553000
         BIND  DUP                      DUPLICATION                     22554000
         BIND  PER                      CONCATENATION                   22555000
         BIND  PLUS                     UNARY PLUS                      22556000
         BIND  MIN                      UNARY MINUS                     22557000
         BIND  MULT                     MULTIPLY                        22558000
         BIND  DIV                      DIVIDE                          22559000
         BIND  ADD                      ADD                             22560000
         BIND  SUB                      SUBTRACT                        22561000
         BIND  GT                       GREATER THAN                    22562000
         BIND  GE                       GREATER OR EQUAL                22563000
         BIND  LT                       LESS THAN                       22564000
         BIND  LE                       LESS OR EQUAL                   22565000
         BIND  EQ                       EQUAL                           22566000
         BIND  NE                       NOT EQUAL                       22567000
         BIND  NOT                      NOT                             22568000
         BIND  AND                      AND                             22569000
         BIND  OR                       OR                              22570000
         BIND  RPAR                     RIGHT PAREN                     22571000
         BIND  ECM                      END CHARACTER MODE              22572000
         BIND  COM                      COMMA                           22573000
         BIND  LPAR                     LEFT PAREN                      22574000
         BIND  SCM                      START CHARACTER MODE            22575000
         BIND  STRM                     STATEMENT TERMINATOR            22576000
         BIND  TAT                      TYPE ATTRIBUTE                  22577000
         BIND  LAT                      LENGTH ATTRIBUTE                22578000
         BIND  SAT                      SCALE ATTRIBUTE                 22579000
         BIND  IAT                      INTEGER ATTRIBUTE               22580000
         BIND  KAT                      COUNT ATTRIBUTE                 22581000
         BIND  NAT                      NUMBER ATTRIBUTE                22582000
         SPACE                                                          22583000
         JPATCH X1S00,12C               X1S PATCH AREA                  22584000
         SPACE                                                          22585000
         END                                                            22586000
./ ADD NAME=IFNX3B                                                      22587000
         JHEAD 'SYMBOL RESOLUTION PREPROCESSOR',                       ,22588000
               PHASEID=X3B,                                            ,22589000
               LEVEL=10                                                 22590000
*                                                                     * 22591000
*FUNCTION/OPERATION-                                                  * 22592000
*   THE SYMBOL RESOLUTION PREPROCESSOR SCANS ALL GENERATED STATEMENTS * 22593000
*   AND PRODUCES A SEQUENTIAL FILE OF ALL NECESSARY RECORDS REQUIRED  * 22594000
*   BY THE ASSEMBLER SYMBOL RESOLUTION PHASE.  THIS FILE CONSISTS OF  * 22595000
*   THE FOLLOWING TYPES OF RECORDS-                                   * 22596000
*        1.   RECORDS GENERATED BY 'PUNCH' AND 'REPRO' STATEMENTS     * 22597000
*             BEFORE THE ESD.                                         * 22598000
*        2.   SYMBOL DEFINITIONS.                                     * 22599000
*        3.   SYMBOL REFERENCES.                                      * 22600000
*        4.   LITERALS.                                               * 22601000
*        5.   OTHER ASSEMBLER OPERATIONS AFFECTING THE ESD OR STORAGE * 22602000
*             ASSIGNMENT (START, CSECT, DSECT, COM, DXD, ENTRY,       * 22603000
*             EXTRN, WXTRN, EQU, ORG, LTORG, CNOP, DC, DS, END)       * 22604000
*                                                                     * 22605000
*ENTRY POINT-                                                         * 22606000
*        X3B01                                                        * 22607000
*                                                                     * 22608000
*INPUT-                                                               * 22609000
*   'TXTOUT' IS A POINTER TO THE GENERATED RECORD.                    * 22610000
*                                                                     * 22611000
*OUTPUT-                                                              * 22612000
*   FILE 3 IS A FILE OF THE RECORDS DESCRIBED ABOVE.                  * 22613000
*                                                                     * 22614000
*EXTERNAL ROUTINES-                                                   * 22615000
*   ROUTINES 'JPUTL' AND 'JPUTM' INT THE CONTROLLER TO WRITE THE      * 22616000
*   OUTPUT RECORDS.                                                   * 22617000
*                                                                     * 22618000
*EXITS, NORMAL-                                                       * 22619000
*   RETURN TO THE MACRO GENERATOR.                                    * 22620000
*                                                                     * 22621000
*EXITS, ERROR-                                                        * 22622000
*   NONE                                                              * 22623000
*                                                                     * 22624000
*TABLE/WORK AREAS-                                                    * 22625000
*   NONE                                                              * 22626000
*                                                                     * 22627000
*ATTRIBUTES-                                                          * 22628000
*   REFRESHABLE                                                       * 22629000
*                                                                     * 22630000
*NOTES-                                                               * 22631000
         EJECT                                                          22632000
         COPY  JCOMMON                                                  22633000
         EJECT                                                          22634000
         COPY  JTEXT                                                    22635000
         EJECT                                                          22636000
         COPY  GENCOM                                                   22637000
         EJECT                                                          22638000
         COPY  RSYMRCD                                                  22639000
         EJECT                                                          22640000
*A690500-692500,708500                                         @OZ01688 22641000
*D690500-692500,708500                                         @OY09620 22642000
         JCSECT  (X3B00)                                                22643000
         JMODID                                                         22644000
X3B01    STM   R8,R9,SAVVY              SAVE VASE AND VETURN VEGISTERS  22645000
         LR    R8,R12                   MY BASE                         22646000
         JENTRY  (X3B01=X3B01)          ENTRY                           22647000
         USING X3B01,R8                 USING                           22648000
         USING JTEXT,R5                 USING                           22649000
         USING RRCDL,R11                USING                           22650000
         L     R5,TXTOUT                RECORD POINTER                  22651000
         LR    R4,R5                    TEXT POINTER                    22652000
         AH    R4,JTOPP                 OPERAND POINTER                 22653000
         SR    R6,R6                    INITIALIZE OP LENGTH            22654000
         ST    R6,SYMBLCNT              INITIALIZE                      22655000
         MVC   LFLGA(D3),JTFLGA         RECORD TYPE                     22656000
         GOIF  JDEF,OFF=EXTRACT              NO DEFINITION RECORD       22657000
         GOIF  (JINPC,JINHB),NONE=LOCTR1     SKIP IF PC NOT REQUIRED    22658000
         TS    INHI                          SEE IF IN SECTION          22659000
         BNZ   LOCTR1                   SKIP IF ALREADY IN SECTION      22660000
         GOIF  JINHB,ON=LOCTR1          SKIP IF PC NOT REQUIRED         22661000
         JPUTM FILE=FILE3,ADDR=LOCTRUPC INITIATE PC                     22662000
LOCTR1   GOIF  JPSOP,OFF=LOCTR3         SEE IF MACHINE OP               22663000
         SET   FRCMI,ON                 INDICATE PSEUDO OP              22664000
         GOIF  JTEND,EQUAL=LOCTR0       END                             22665000
         GOIF  JTUSING,EQUAL=USING      FINISHED IF USING               22666000
         GOIF  JTPUNCH,EQUAL=PUNCH      SKIP IF PUNCH                   22667000
         GOIF  JTREPRO,EQUAL=REPRO      SKIP IF REPRO                   22668000
         GOIF  JTCXD,EQUAL=LOCTR2       SET OP LENGTH TO 4              22669000
         GOIF  JTCCW,NOTEQ=LOCTR4       SKIP IF NOT CCW                 22670000
         LA    R6,D4                    SET OP LENGTH TO 4              22671000
LOCTR2   LA    R6,D4(,R6)               SET OP LENGTH TO 4 OR 8         22672000
         B     LOCTR4                   CONTINUE                        22673000
LOCTR3   MVI   LFLGA+D2,JTPMOP          PSEUDO OP CODE FOR MACHINE OP   22674000
         IC    R6,JTFLGA                GET OP LENGTH                   22675000
         N     R6,=F'3'                 ISOLATE SIGNIFICANT BITS        22676000
         LA    R6,D2(R6,R6)             COMPUTE LENGTH                  22677000
LOCTR4   SET   JSYSGEN,ON               CALL X4                         22678000
LOCTR0   LR    R3,R5                    POINTER                         22679000
         AH    R3,JTNMP                 NAME POINTER                    22680000
         SR    R2,R2                    INITIALIZE TO ZERO              22681000
         GOIF  JNMERR,ON=LOCTR7         NO NAME, NO ERROR               22682000
         CLI   JTNML-JTNMO(R3),D0         SEE IF NAMED                  22683000
         BNZ   LOCTR5                       THERE'S A NAME              22684000
LOCTRR   GOIF  JPSOP,ON=LOCTR7          FORCE PSEUDO OP                 22685000
         GOIF  FRCMI,ON=LOCTR7,ELSE=EXTRACT1 FORCE FIRST MACHINE INSTR  22686000
LOCTR5   CLI   JTNAME-JTNMO(R3),JPERIOD     SEE IF SEQUENCE SYMBOL      22687000
         BE    LOCTRR                     NOT REALLY A NAME             22688000
LOCTR6   LA    R2,D10                   LENGTH OF NAME APPENDAGE        22689000
LOCTR7   STH   R2,NAMELNG                 SAVE                          22690000
         LA    R2,D12(,R2)                  RECORD LENGTH               22691000
         GOIF  (JPSOP,JREQOP),NOTALL=LOCTR8   SKIP NOT REQUIRED OPERAND 22692000
         TM    JTOPO-JTOPO(R4),JTOPOCD      SEE IF SWITCH ON            22693000
         BZ    LOCTRA                     NO                            22694000
         LA    R4,JTOPL-JTOPO(,R4)      BUMP                            22695000
LOCTRA   CLI   JTOPL-JTOPO(R4),D0       SEE IF ZERO                     22696000
         BZ    LOCTR8                   SKIP IF NOT                     22697000
         SR    R1,R1                    CLEAR REGISTER                  22698000
         IC    R1,JTOPL-JTOPO(,R4)      GET OPERAND LENGTH              22699000
         LA    R2,D2(R1,R2)             RECORD LENGTH                   22700000
LOCTR8   GOIF  JPSOP,ON=PASSIT          BRANCH IF PSEUDO OP             22701000
         SET   FRCMI,OFF                INDICATE MACHINE INSTRUCTION    22702000
PASSIT   JPUTL FILE=FILE3,BUFREQ=(R2)   GET BUFFER                      22703000
         STH   R2,RRCDL                 RECORD LENGTH                   22704000
         MVC   RFLGA(D3),LFLGA          RECORD TYPE                     22705000
         XC    RFLDI(D3),RFLDI          INITIALIZE TO ZERO              22706000
         MVI   RFLGB,D0                 DON'T PASS FLGB                 22707000
         L     R0,LCR                   GET LOCATION COUNTER            22708000
         ST    R0,RLCTR                 PASS IN RECORD                  22709000
         SR    R0,R0                    PUT A ZERO                      22710000
         ST    R0,LCR                   BACK                            22711000
         CLI   NAMELNG+D1,D0            SEE IF ANME APPENDAGE           22712000
         BZ    LOCTR9                   SKIP IF NO NAME                 22713000
         IC    R1,JTNML-JTNMO(,R3)      GET NAME LENGTH                 22714000
         BCTR  R1,D0                      GET MACHINE LENGTH            22715000
         MVC   RNAME+D1(D7),=7AL1(JBLANK)   PAD WITH BLANKS             22716000
         EX    R1,LOCTRMVC                MOVE IN NAME                  22717000
         LA    R1,RFIELDN(,R1)          SET FLAG ON                     22718000
         STC   R1,RFLDI                 PASS FIELD INDICATORS           22719000
         STH   R6,RLNGQ                 PASS LENGTH ATTRIBUTE           22720000
         SH    R2,NAMELNG               COMPENSATE FOR RECORD LENGTH    22721000
LOCTR9   SH    R2,=H'14'                SEE IF OPERAND PRESENT          22722000
         BNP   EXTRACT                  SKIP IF NO OPERAND              22723000
         SET   RFIELDX,ON               INDICATE OPERAND PRESENT        22724000
         AH    R11,NAMELNG              BUMP PAST NAME, IF PRESENT      22725000
         EX    R2,LOCTRMOV              MOVE IN OPERAND                 22726000
         AR    R11,R2                   BUMP PAST OPERAND               22727000
         MVI   RFLDA,JBLANK             AND INSERT A BLANK              22728000
EXTRACT  GOIF  JREF,OFF=FINIS           EXIT IF NOT REQUESTED           22729000
EXTRACT1 TM    JTOPO-JTOPO(R4),JTOPOCD  SEE IF CARD POINTER             22730000
         BZ    EXTRACT0                 NAH                             22731000
         LA    R4,JTOPL-JTOPO(,R4)      HOP                             22732000
EXTRACT0 CLI   JTOPL-JTOPO(R4),D0       SEE IF OPERAND                  22733000
         BZ    FINIS                    EXIT IF NO OPERAND              22734000
         SET   (VCONV,MODV),OFF         CLEAR VCON BITS                 22735000
         SET   (VCONW,MODW),OFF         CLEAR VCON BITS                 22736000
         SR    R3,R3                    CLEAR REGISTER                  22737000
         IC    R3,JTOPL-JTOPO(,R4)      GET OPERAND LENGTH              22738000
         LA    R5,D1(R3,R4)             POINT TO END-OF-OPERAND         22739000
         LA    R3,D2(,R4)               POINT TO START-OF-OPERAND       22740000
         LA    R4,D1                    INCREMENT                       22741000
EXTRACT4 TM    LFLGA,JPSOP+JEXTB        SEE IF EXTERNAL SYMBOL          22742000
         BNO   EXTRACT2                 SKIP IF NOT                     22743000
EXTRACT5 CLI   D0(R3),JAT               SEE IF INVALID CHARACTER        22744000
         BH    FINIS                    INVALID CHARACTER               22745000
         CLI   D0(R3),J9                SEE IF INVALID CHARACTER        22746000
         BH    SYMBOL                   POSSIBLE EXTERNAL SYMBOL        22747000
         B     FINIS                    SYNTAX ERROR                    22748000
EXTRACT2 MVC   SUPPRESV,LFLGA           SET SUPPRESS SWITCH             22749000
         SET   VCONV,OFF                CLEAR VCON BIT                  22750000
         SET   MODV,OFF                 CLEAR MODIFIER BIT              22751000
EXTRACT3 MVC   SUPPRESW,SUPPRESV        SET SUPPRESS SWITCH             22752000
LOOK     CLI   D0(R3),JEQUAL            SEE IF ALPHANUMERIC             22753000
         BL    ALPHANUM                 GO IF ALPHANUMERIC              22754000
LOOKY    CLI   D0(R3),JPERIOD           SEE IF VALID CHARACTER          22755000
         BH    FINIS                    GO IF INVALID CHARACTER         22756000
         SR    R2,R2                    ZERO INDEX                      22757000
         TRT   D0(D1,R3),INDEX          COMPUTE INDEX                   22758000
         B     PIVOT(R2)                INVESTIGATE SPECIAL CHARACTER   22759000
COMMA    CH    R4,PARENCNT              SEE IF INSIDE PARENS            22760000
PIVOT    EQU   COMMA                    SAME                            22761000
         BNH   ADVANCE                  IGNORE IF INSIDE PARENS         22762000
         BXLE  R3,R4,EXTRACT2           END-OF-OPERAND ENCOUNTERED      22763000
         B     FINIS                    END-OF-OPERAND                  22764000
LPARN    SET   SUPPRESS,OFF             SET SUPPRESS SWITCH OFF         22765000
         LH    R1,PARENCNT              GET PAREN COUNT                 22766000
         GOIF  VCONW,ON=CHCKMOD         CHECK IF VCON                   22767000
LPARN1   AR    R1,R4                    BUMP IT BY ONE                  22768000
         B     STPAR                    CONTINUE                        22769000
RPARN    LH    R1,PARENCNT              GET PAREN COUNT                 22770000
         BCT   R1,STPAR                 WATCH PAREN LEVEL               22771000
         EX    R0,EXTRACT3              SET SUPPRESS SWITCH             22772000
STPAR    STH   R1,PARENCNT              SAVE PAREN COUNT                22773000
ADVANCE  BXLE  R3,R4,LOOK                 LOOK AT NEXT CHARACTER        22774000
FINIS    A     R6,LCR                       ADD LENGTH OF CURRENT OP    22775000
         ST    R6,LCR                         SAVE FOR BYRON            22776000
         L     R2,TXTOUT                        RECORD POINTER          22777000
         MVC   JTSYMCNT-JTRLI(D1,R2),SYMBLCNT+D1  SYMBOL COUNT          22778000
         LM    R8,R9,SAVVY                      RESTORE REGISTERS       22779000
         BR    R9                             RETURN TO BYRON           22780000
USING    SET   JSYSGEN,ON               INDICATE X4 TO BE CALLED        22781000
         B     EXTRACT1                 SCAN OPERAND                    22782000
EQUAL    TM    LFLGA,JPSOP                  SEE IF MACHINE OP           22783000
         BO    FINIS                      LITERAL ILLEGAL OTHERWISE     22784000
         SR    R5,R3                    GET LENGTH OF LITERAL           22785000
         CLI   D1(R3),JBLANK            CAN'T HAVE A BLANK FOLLOWING    22786000
         BE    FINIS                    OR IT'S CURTAINS FOR THIS GUY   22787000
         LA    R2,D14(,R5)              LENGTH OF RECORD                22788000
         JPUTL FILE=FILE3,BUFREQ=(R2)   GET BUFFER                      22789000
         STH   R2,RRCDL                 RECORD LENGTH                   22790000
         MVC   RFLGA(D6),LITRHDR        RECORD HEADER                   22791000
         L     R0,LCR                   LOCATION COUNTER                22792000
         ST    R0,RLCTR                 PASS IN RECORD                  22793000
         SR    R0,R0                    PUT A ZERO BACK                 22794000
         ST    R0,LCR                   INTO THE LOCATION COUNTER       22795000
         EX    R5,LITRMVC               MOVE LITERAL INTO RECORD        22796000
         STC   R5,RLNGA                 PASS LENGTH OF LITERAL          22797000
         AR    R11,R5                   LOCATE THE END OF LITERAL       22798000
         MVI   RFLDA,JBLANK             AND APPEND A BLANK              22799000
         LH    R0,SYMBLCNT              GET COUNT OF SYMBOLS            22800000
         AR    R0,R4                    BUMP COUNT BY ONE               22801000
         STH   R0,SYMBLCNT              SAVE COUNT OF SYMBOLS           22802000
         SET   (VPSOP,SUPPREST),ON      SET SUPPRESS SWITCH ON          22803000
         AR    R5,R3                    POINT TO THE END OF OPERAND     22804000
         AR    R3,R4                      BUMP COLUMN POINTER           22805000
         B     EXTRACT3                     LOOK FOR MORE SYMBOLS       22806000
ALPHANUM GOIF  (WPSOP,SUPPRESS),ALL=CHCKVCON SUPPRESS CONDITION ON      22807000
         CLI   D0(R3),JA                    SEE IF ALPHA                22808000
         BL    ELFLUSHO                   DECIMAL SELF-DEFINING-VALUE   22809000
         CLI   D1(R3),JQUOTE            SEE IF FOLLOWED BY A QUOTE      22810000
         BNE   SYMBOL                   SYMBOL ENCOUNTERED              22811000
         CLI   D0(R3),JL                SEE IF LENGTH ATTRIBUTE         22812000
         BXH   R3,R4,FINIS              BUMP COLUMN POINTER BY ONE      22813000
         BE    ADVANCE                  LENGTH ATTRIBUTE REFERENCE      22814000
QUOTE    BALR  R1,D0                    PIVOT                           22815000
         BXH   R3,R4,FINIS              BUMP COLUMN POINTER             22816000
         CLI   D0(R3),JQUOTE            LOOKING FOR QUOTES ONLY         22817000
         BNER  R1                       IGNORE THE OTHERS               22818000
         BXH   R3,R4,FINIS              BUMP COLUMN POINTER             22819000
         CLI   D0(R3),JQUOTE            CHECK FOR PAIRED QUOTES         22820000
         BNE   LOOK                     VALID DELIMITER                 22821000
         BR    R1                       TREAT AS ONE                    22822000
ELFLUSHO BALR  R1,D0                    PIVOT                           22823000
         BXH   R3,R4,FINIS              BUMP COLUMN POINTER             22824000
         CLI   D0(R3),JEQUAL            TEST FOR DELIMITERS             22825000
         BLR   R1                       LOOP ON LOW                     22826000
         B     LOOKY                    CHECK THIS ONE OUT              22827000
SYMBOL   LR    R2,R3                    SAVE COLUMN POINTER             22828000
SYMBOL1  BXH   R2,R4,SYMBOL2            ADVANCE COLUMN POINTER          22829000
         CLI   D0(R2),JEQUAL            LOOK FOR DELIMITER              22830000
         BL    SYMBOL1                  LOOP IF NOT FOUND               22831000
SYMBOL2  SR    R2,R3                    FIND LENGTH OF SYMBOL           22832000
         CH    R2,=H'8'                 MUST NOT BE MORE THAN 8 CHARS   22833000
         BH    FINIS                    OR IT'S A BADDIE                22834000
         TM    LFLGA,JPSOP+JEXTB        SEE IF EXTERNAL SYMBOL          22835000
         BNO   SYMBOLS                  SKIP IF NOT                     22836000
         LA    R1,D0(R2,R3)             UPDATE COLUMN POINTER           22837000
         CR    R1,R5                    SEE IF END-OF-OPERAND           22838000
         BH    SYMBOLS                  SKIP IF SO                      22839000
         CLI   D0(R1),JBLANK            SEE IF END-OF-OPERAND           22840000
         BE    SYMBOLS                  SKIP IF SO                      22841000
         CLI   D0(R1),JCOMMA            SEE IF VALID DELIMITER          22842000
         BNE   FINIS                    INVALID DELIMITER               22843000
SYMBOLS  LH    R1,SYMBLCNT              GET SYMBOL COUNT                22844000
         AR    R1,R4                    BUMP IT BY ONE                  22845000
         STH   R1,SYMBLCNT              SAVE SYMBOL COUNT               22846000
         SET   JSYSGEN,ON               CALL X4                         22847000
         JPUTL FILE=FILE3,BUFREQ=D24    GO FIND A BUFFER                22848000
         MVC   RRCDL(D24),SYMBOL4       BUILD RECORD HEADER             22849000
         BCTR  R2,D0                    GET LENGTH OF SYMBOL            22850000
         EX    R2,SYMBOL3               MOVE IN SYMBOL                  22851000
         GOIF  (VCONW,MODW),ALL=NOTVCON,NONE=NOTVCON                    22852000
         OI    RNAME,BIT0               INDICATE VCON OPERAND           22853000
NOTVCON  AR    R3,R2                    UPDATE COLUMN POINTER           22854000
         LA    R2,RFIELDN(,R2)          FLAG                            22855000
         STC   R2,RFLDI                 PASS SYMBOL LENGTH IN RECORD    22856000
         TM    LFLGA,JPSOP+JEXTB        SEE IF EXTERNAL SYMBOL          22857000
         BNO   ADVANCE                  SKIP IF NOT                     22858000
         MVC   RTYPE,LFLGA+D2           SET TYPE                        22859000
         CLI   D1(R3),JCOMMA            SEE IF MULTIPLE OPERAND         22860000
         BNE   FINIS                    END-OF-OPERAND                  22861000
         AR    R3,R4                    UPDATE COLUMN POINTER           22862000
         BXLE  R3,R4,EXTRACT5           CHECK OUT NEXT OPERAND          22863000
         B     FINIS                    ALL DONE OTHERWISE              22864000
SYMBOL3  MVC   RNAME(D0),D0(R3)         EXECUTED INSTRUCTION            22865000
SYMBOL4  DC    H'24',AL1(JPSOP,D0,JTSYMBL,D0),3H'0',8AL1(JBLANK),H'0' X 22866000
CHCKVCON CLI   D0(R3),JV                CHECK IF VCON                   22867000
         BNE   ELFLUSHO                 CONTINUE IF NOT                 22868000
         SET   VCONV,ON                 INDICATE VCON                   22869000
         SET   VCONW,ON                 INDICATE VCON                   22870000
         B     ELFLUSHO                 CONTINUE                        22871000
CHCKMOD  LTR   R1,R1                    CHECK PAREN COUNT               22872000
         BNZ   LPARN1                   BR IF WITHIN PARENS             22873000
         SR    R3,R4                    POINT TO CHAR BEFORE LEFT       22874000
         CLI   D0(R3),JL                LENGTH MODIFIER                 22875000
         BE    CHCKMOD5                 BRANCH IF YES                   22876000
         CLI   D0(R3),JE                EXPONENT MODIFIER               22877000
         BE    CHCKMOD5                 BRANCH IF SO                    22878000
         CLI   D0(R3),JS                SCALE MODIFIER                  22879000
         BNE   CHCKMOD6                 VCON IF NOT                     22880000
CHCKMOD5 SET   MODW,ON                  INDICATE MODIFIER               22881000
CHCKMOD6 AR    R3,R4                    UPDATE POINTER                  22882000
         B     LPARN1                   CONTINUE                        22883000
REPRO    LR    R4,R5                    TEXT POINTER                    22884000
         AH    R4,JTCPR                 COMMENT POINTER                 22885000
PUNCH    GOIF  INHIBIT,ON=FINIS         EXIT IF ON                      22886000
         GOIF  (JDECK,JLINK),NONE=FINIS   SKIP IF NOT OPTIONED          22887000
         SET   JPRESD,ON                PINCHED                         22888000
         SR    R3,R3                    CLEAR REGISTER                  22889000
         IC    R3,JTOPL-JTOPO(,R4)      GET OPERAND LENGTH              22890000
         LA    R2,D7(,R3)               GET RECORD LENGTH               22891000
         JPUTL FILE=FILE3,BUFREQ=(R2)   GET BUFFER                      22892000
         STH   R2,RRCDL                 RECORD LENGTH                   22893000
         MVC   RFLGA(D4),PUNCHEAD       PUNCH RECORD HEADER             22894000
         EX    R3,PUNCHMVC              MOVE IN OPERAND                 22895000
         GOIF  JTPUNCH,EQUAL=FINIS      SKIP IF PUNCH STATEMENT         22896000
         MVI   RTYPE,JTPREP             REPRO                           22897000
         B     FINIS                     FINIS                          22898000
PUNCHEAD DC    AL1(D0,D0,JTPPCH,D1)        TYPE                         22899000
PUNCHMVC MVC   RESDI(D0),JTOPL-JTOPO(R4)     EXECUTED INSTRUCTION       22900000
LITRMVC  MVC   RLNGA(D0),D0(R3)                EXECUTED INSTRUCTION     22901000
LITRHDR  DC    AL1(JPSOP+JDEF,D0,JTLITR,RFIELDX) LITERAL RECORD HEADER  22902000
LOCTRUPC DC    H'8',AL1(JPSOP,D0,JTINPC,D0)    UNINITIATED PRIVATE CODE 22903000
LOCTRMVC MVC   RNAME(D0),JTNAME-JTNMO(R3)    EXECUTED INSTRUCTION       22904000
LOCTRMOV MVC   RLNGA(D0),JTOPL-JTOPO(R4)   EXECUTED INSTRUCTION         22905000
INDEX    EQU   *-JEQUAL                  TABLE ORIGIN                   22906000
         DC    YL1(EQUAL-PIVOT)         EQUAL SIGN                      22907000
         DC    YL1(LPARN-PIVOT)         LEFT PAREN                      22908000
         DC    YL1(ADVANCE-PIVOT)       PLUS SIGN                       22909000
         DC    YL1(ADVANCE-PIVOT)       MINUS SIGN                      22910000
         DC    YL1(ADVANCE-PIVOT)       ASTERISK                        22911000
         DC    YL1(ADVANCE-PIVOT)       SLASH                           22912000
         DC    YL1(RPARN-PIVOT)         RIGHT PAREN                     22913000
         DC    YL1(COMMA-PIVOT)         COMMA                           22914000
         DC    YL1(FINIS-PIVOT)         BLANK                           22915000
         DC    YL1(QUOTE-PIVOT)         QUOTE                           22916000
         DC    YL1(FINIS-PIVOT)         AMPERSAND                       22917000
         DC    YL1(ADVANCE-PIVOT)       PERIOD                          22918000
         JPATCH X3B00,41F                                               22919000
         END                                                            22920000
./ ADD NAME=IFNX3N                                                      22921000
         JHEAD 'GENERATE PHASE DICTIONARY ROUTINES',                   X22922000
               PHASEID=X3N,                                            X22923000
               LEVEL=10                                                 22924000
*FUNCTION/OPERATION-                                                  * 22925000
*   THE GENERATE PHASE DICTIONARY ROUTINES ARE A SET OF SUBROUTINES.  * 22926000
*   THESE SUBROUTINES PROVIDE ALL THE FUNCTIONS REQUIRED BY THE       * 22927000
*   GENERATE PHASE RELATIVE TO THE GENERATION TIME DICTIONARIES. THE  * 22928000
*   FUNCTIONS PROVIDED ARE- INITIALIZATION, SETTING, AND REFERENCING. * 22929000
*   THESE FUNCTIONS ARE REQUESTED DURING THE EXPANSION OF MACRO       * 22930000
*   INSTRUCTIONS AND IN CONDITIONAL ASSEMBLY FOR THE GENERATION OF    * 22931000
*   THE TEXT TO BE PROCESSED BY THE ASSEMBLY PHASE. THE PERTINENT     * 22932000
*   DICTIONARIES ARE- GLOBAL DICTIONARY, ORDINARY SYMBOL REFERENCE    * 22933000
*   DICTIONARY, AND THE DICTIONARY FOR THE TEXT SEGMENT CURRENTLY     * 22934000
*   BEING USED BY THE GENERATE PHASE. THE DICTIONARY FOR A TEXT       * 22935000
*   SEGMENT INCLUDES THE SKELETON DICTIONARY BUILT BY THE DICTIONARY  * 22936000
*   INTERLUDE PHASE FOR THAT TEXT SEGMENT (CONSISTING OF THE          * 22937000
*   DICTIONARY HEADER, THE GLOBAL VECTOR, AND THE SEQUENCE SYMBOL     * 22938000
*   REFERENCE DICTIONARY), THE LOCAL DICTIONARY, AND, IN THE CASE     * 22939000
*   OF A MACRO DEFINITION, THE MACRO PARAMETER WORK AREA.             * 22940000
*                                                                     * 22941000
*ENTRY POINT-                                                         * 22942000
*        DICTENTR                                                     * 22943000
*              THE CALLING SEQUENCE IS-                               * 22944000
*                  DICTCALL ENTRY                                     * 22945000
*              WHICH GENERATES-                                       * 22946000
*                  L     LINK,POINTER                                 * 22947000
*                  BAL   RETURN,ENTRY(,LINK)                          * 22948000
*              WHERE LINK IS THE STANDARD REGISTER FOR THE ADDRESS    * 22949000
*                             OF THE CALLED ROUTINE                   * 22950000
*                    POINTER CONTAINS THE ADDRESS OF THE DICTIONARY   * 22951000
*                            ENTRY ROUTINE                            * 22952000
*                    ENTRY IS THE NAME OF THE DICTIONARY FUNCTION     * 22953000
*                             REQUIRED (ENTRY NAMES ARE EQUATED TO    * 22954000
*                             ABSOLUTE VALUES USED AS DISPLACEMENTS   * 22955000
*                             INTO A BRANCH TABLE                     * 22956000
*                    RETURN IS THE STANDARD REGISTER FOR THE RETURN   * 22957000
*                             ADDRESS                                 * 22958000
*                                                                     * 22959000
*INPUT-                                                               * 22960000
*   FILE 1 - SKELETON DICTIONARY FOR EACH TEXT SEGMENT                * 22961000
*   FILE 1 - OVERFLOW DICTIONARIES                                    * 22962000
*   FILE 2 - MACRO DEFINITION VECTOR                                  * 22963000
*          - ORDINARY SYMBOL REFERENCE DICTIONARY                     * 22964000
*          - OPSYN TABLE                                              * 22965000
*                                                                     * 22966000
*OUTPUT-                                                              * 22967000
*   FILE 1 - OVERFLOW DICTIONARIES                                    * 22968000
*                                                                     * 22969000
*EXTERNAL ROUTINES-                                                   * 22970000
*                                                                     * 22971000
*                                                                     * 22972000
*                                                                     * 22973000
*EXITS,NORMAL-                                                        * 22974000
*   EXIT TO THE CONTROLLER WITH THE COMPLETION CODE SET TO A ZERO     * 22975000
*   VALUE.                                                            * 22976000
*                                                                     * 22977000
*EXITS,ERROR-                                                         * 22978000
*   EXIT TO THE CONTROLLER WITH THE COMPLETION CODE SET TO A NON-ZERO * 22979000
*   VALUE, THE SPECIFIC VALUE INDICATING THE ACTION TO BE TAKEN BY    * 22980000
*   THE CONTROLLER.                                                   * 22981000
*                                                                     * 22982000
*TABLES/WORK AREAS-                                                   * 22983000
*   MACRO DEFINITION VECTOR - A SEQUENTIAL TABLE. THERE IS ONE ENTRY  * 22984000
*        IN THE TABLE FOR EACH TEXT SEGMENT. EACH ENTRY CONSISTS      * 22985000
*        OF THE NOTE/POINT ADDRESS OF THE EDITED TEXT (NOT PRESENT    * 22986000
*        IN THE ENTRY FOR OPEN CODE), THE NOTE/POINT ADDRESS OF THE   * 22987000
*        SKELETON DICTIONARY, AND THE SIZE OF SKELETON DICTIONARY.    * 22988000
*   GLOBAL DICTIONARY - THE AREA IN WHICH THE VALUES OF THE VARIABLE  * 22989000
*        SYMBOLS ASSIGNED AS GLOBAL VARIABLES IN THE EDIT PHASE ARE   * 22990000
*        SET AND REFERENCED IN THE GENERATE PHASE DURING THE          * 22991000
*        EXPANSION OF MACRO INSTRUCTIONS AND IN CONDITIONAL ASSEMBLY. * 22992000
*   ORDINARY SYMBOL REFERENCE DICTIONARY - A SEQUENTIAL TABLE. THERE  * 22993000
*        IS ONE ENTRY IN THE TABLE FOR EACH ORDINARY SYMBOL           * 22994000
*        REFERENCED IN ATTRIBUTE REFERENCES OR IN MACRO INSTRUCTION   * 22995000
*        OPERANDS (LESS THOSE RESOLVED AS DUPLICATES). EACH ENTRY     * 22996000
*        CONSISTS OF THE TYPE, LENGTH, AND SCALE ATTRIBUTES OF THE    * 22997000
*        CORRESPONDING ORDINARY SYMBOL.                               * 22998000
*   DICTIONARY FOR A TEXT SEGMENT - THE SKELETON DICTIONARY (CONSIS-  * 22999000
*        TING OF THE DICTIONARY HEADER, THE GLOBAL VECTOR, AND THE    * 23000000
*        SEQUENCE SYMBOL REFERENCE DICTIONARY) PLUS THE LOCAL DIC-    * 23001000
*        TIONARY PLUS, IN THE CASE OF A MACRO DEFINITION, THE MACRO   * 23002000
*        PARAMETER WORK AREA.                                         * 23003000
*      --DICTIONARY HEADER - WORK AREA CONTAINING ALL THE OVERHEAD    * 23004000
*              PECULIAR TO THE DICTIONARY FOR A TEXT SEGMENT.         * 23005000
*      --GLOBAL VECTOR - A SEQUENTIAL TABLE OF POINTERS, ONE FOR      * 23006000
*              EACH SYSTEM GLOBAL VARIABLE AND ONE FOR EACH OF THE    * 23007000
*              VARIABLE SYMBOLS IN THE TEXT SEGMENT ASSIGNED          * 23008000
*              AS GLOBAL VARIABLES IN THE EDIT PHASE, EACH POINTING   * 23009000
*              TO THE CORRESPONDING ENTRY IN THE GLOBAL DICTIONARY.   * 23010000
*      --SEQUENCE SYMBOL REFERENCE DICTIONARY - A SEQUENTIAL TABLE    * 23011000
*              OF NOTE/POINT ADDRESSES, ONE FOR EACH SEQUENCE SYMBOL  * 23012000
*              REFERENCE IN THE TEXT SEGMENT (LESS THOSE RESOLVED     * 23013000
*              AS DUPLICATES), EACH POINTING TO THE POSITION IN THE   * 23014000
*              EDITED TEXT WHERE THE CORRESPONDING SEQUENCE SYMBOL    * 23015000
*              IS DEFINED.                                            * 23016000
*      --LOCAL DICTIONARY - THE AREA IN WHICH THE VALUES OF THE       * 23017000
*              VARIABLE SYMBOLS ASSIGNED AS LOCAL VARIABLES FOR THE   * 23018000
*              TEXT SEGMENT IN THE EDIT PHASE ARE SET AND REFERENCED  * 23019000
*              IN THE GENERATE PHASE DURING THE EXPANSION OF MACRO    * 23020000
*              INSTRUCTIONS AND IN CONDITIONAL ASSEMBLY.              * 23021000
*      --MACRO PARAMETER WORK AREA - THE KEYWORD PARAMETER VECTOR     * 23022000
*              PLUS THE POSITIONAL PARAMETER VECTOR PLUS THE          * 23023000
*              PARAMETER TABLE, CONSISTING OF THE VALUES OF ALL       * 23024000
*              THE MACRO INSTRUCTION OPERANDS.                        * 23025000
*                                                                     * 23026000
*ATTRIBUTES-                                                          * 23027000
*   REFRESHABLE                                                       * 23028000
*                                                                     * 23029000
*NOTES-                                                               * 23030000
*                                                                     * 23031000
*                                                                     * 23032000
*                                                                     * 23033000
         EJECT                                                          23034000
         COPY  JCOMMON                                                  23035000
         EJECT                                                          23036000
         COPY  JTMTXT                                                   23037000
         EJECT                                                          23038000
         COPY  GENCOM                                                   23039000
         EJECT                                                          23040000
*                                                                       23041000
* THIS DSECT MAPS THE MACRO DEFINITION VECTOR ENTRY.                    23042000
*                                                                       23043000
MDVNTRY  DSECT                                                          23044000
MNPTXT   DS    XL8                      TEXT FILE N/P     8 BYTES       23045000
MNPSD    DS    XL8                      SKEL DICTION N/P  8 BYTES       23046000
MSDL     DS    XL3                      SKEL DICT LENGTH  3 BYTES       23047000
MDVEND   EQU   *                                                        23048000
*                                                                       23049000
* THIS DSECT MAPS THE HEADER FOR THE SKELETON DICTIONARY.               23050000
*                                                                       23051000
SKDCTHDR DSECT                                                          23052000
SKSRDPT  DS    XL3                      DISPL SEQ SYM DIC 3 BYTES       23053000
SKLDADR  DS    XL3                      LCL DICT PTR      3 BYTES       23054000
SKLDLNG  DS    XL3                      LCL DICT LENGTH   3 BYTES       23055000
SKMPADR  DS    XL3                      MACRO PARAM PTR   3 BYTES       23056000
SKKVADR  DS    XL3                      KEYWD VECTR PTR   3 BYTES       23057000
SKADNLD  DS    XL4                      DICT ADR NXT LVL  4 BYTES       23058000
SKNPNLT  DS    XL8                      TEXT N/P NXT LVL  8 BYTES       23059000
SKACTRV  DS    XL4                      ACTR VALUE        4 BYTES       23060000
SKNOFSLS DS    XL2                      N'&SYSLIST        2 BYTES       23061000
SKHDREND EQU   *                                                        23062000
*                                                                       23063000
* THIS DSECT MAPS THE MACRO CALL META-TEXT.                             23064000
*                                                                       23065000
MCRCAL   DSECT                                                          23066000
MDVPNT   DS    XL3                      PTR TO MDV ENTRY FOR MACRO      23067000
*                                                                       23068000
*                                                                       23069000
* THIS DSECT MAPS THE GLOBAL AND LOCAL REFERENCE META-TEXT.             23070000
*                                                                       23071000
VREF     DSECT                                                          23072000
VFLAG    DS    X                        META-TEXT FLAG/OPERATOR         23073000
VPNT     DS    XL3                      PTR TO DICT/VECTOR ENTRY        23074000
VSUBS    DS    XL2                      VARIABLE SUBSCRIPT/DIMENSION    23075000
*                                                                       23076000
* THIS DSECT MAPS THE SEQUENCE SYMBOL REFERENCE META-TEXT.              23077000
*                                                                       23078000
SEQREF   DSECT                                                          23079000
SFLAG    DS    X                        META-TEXT FLAG/OPERATOR         23080000
SEQPNT   DS    XL3                      PTR TO DICTIONARY ENTRY         23081000
SEQPAD   DS    XL2                      PADDING                         23082000
*                                                                       23083000
* THIS DSECT MAPS THE ORDINARY SYMBOL REFERENCE META-TEXT.              23084000
*                                                                       23085000
ORDREF   DSECT                                                          23086000
OFLAG    DS    X                        META-TEXT FLAG/OPERATOR         23087000
ORDPNT   DS    XL3                      PTR TO DICTIONARY ENTRY         23088000
ORDPAD   DS    XL2                      PADDING                         23089000
*                                                                       23090000
* THIS DSECT MAPS THE PARAMETER REFERENCE META-TEXT.                    23091000
*                                                                       23092000
PARMREF  DSECT                                                          23093000
PARMFLG  DS    X                        META-TEXT FLAG/OPERATOR         23094000
PARMPNT  DS    XL3                      PTR TO PARAM VECTOR ENTRY       23095000
PARMPAD  DS    XL2                      PADDING                         23096000
         ORG   PARMPAD                  ORIGIN FOUR                     23097000
PARMSUB  DS    XL2                      SUBOPERAND NUMBER               23098000
*                                                                       23099000
* THIS DSECT MAPS THE ENTRY IN THE GLOBAL OR LOCAL DICTIONARY FOR A     23100000
*        SETA VARIABLE.                                                 23101000
*                                                                       23102000
SETANTRY DSECT                                                          23103000
SETAVAL  DS    XL4                      DICT ENTRY, SETA VARIABLE       23104000
*                                                                       23105000
* THIS DSECT MAPS THE ENTRY IN THE GLOBAL OR LOCAL DICTIONARY FOR A     23106000
*        SETB VARIABLE.                                                 23107000
*                                                                       23108000
SETBNTRY DSECT                                                          23109000
SETBVAL  DS    X                                                        23110000
*                                                                       23111000
* THIS DSECT MAPS THE ENTRY IN THE GLOBAL OR LOCAL DICTIONARY FOR A     23112000
*        SETC VARIABLE.                                                 23113000
*                                                                       23114000
SETCNTRY DSECT                                                          23115000
SETCLEN  DS    C                        LENGTH BYTE, SETC VARIABLE      23116000
SETCVAL  DS    CL8                      DICT ENTRY, SETC VARIABLE       23117000
         ORG   SETCVAL+D5               ORIGIN SIX                      23118000
SETCPTR  DS    XL3                      PTR TO VALUE, EXTENDED SETC     23119000
*                                                                       23120000
* THIS DSECT MAPS THE ENTRIES FOR THE SYSTEM GLOBAL VARIABLES           23121000
*        AT THE HEAD OF THE GLOBAL DICTIONARY.                          23122000
GSYSVALS DSECT                                                          23123000
PARMLEN  DS    C                        LENGTH SYSPARM VALUE            23124000
PARMVAL  DS    CL8                      SYSPARM VALUE                   23125000
TIMELEN  DS    C                        LENGTH, SYSTIME VALUE           23126000
TIMEVAL  DS    CL8                      SYSTIME VALUE                   23127000
DATELEN  DS    C                        LENGTH, SYSDATE VALUE           23128000
DATEVAL  DS    CL8                      SYSDATE VALUE                   23129000
*                                                                       23130000
* THIS DSECT MAPS THE ENTRIES FOR THE SYSTEM LOCAL VARIABLES            23131000
*        AT THE HEAD OF EACH LOCAL DICTIONARY                           23132000
*                                                                       23133000
LSYSVALS DSECT                                                          23134000
INDXVAL  DS    XL4                      SYSNDX VALUE                    23135000
SECTLEN  DS    CL1                      LENGTH, SYSECT VALUE            23136000
SECTVAL  DS    CL8                      SYSECT VALUE                    23137000
*                                                                       23138000
* THIS DSECT MAPS THE LOGICAL RECORD FOR A MACRO INSTRUCTION            23139000
*        OR MACRO PROTOTYPE OPERAND.                                    23140000
*                                                                       23141000
         COPY  JTEXT                                                    23142000
*                                                                       23143000
* THIS DSECT MAPS THE ERROR STACK ENTRY                                 23144000
*                                                                       23145000
ERRMESS  DSECT                                                          23146000
EMSGSVTY DS    C                        ERROR SEVERITY CODE             23147000
EMSGCODE DS    C                        ERROR NUMBER                    23148000
EMSGHL   EQU   *-EMSGSVTY                                               23149000
ENTRYLNG DS    C                        LENGTH, SNAPSHOT DATA           23150000
EMSGNTRY DS    CL8                      SNAPSHOT DATA                   23151000
*                                                                       23152000
*        MORE DISPLACEMENT EQUATES                                      23153000
*                                                                       23154000
D36      EQU   36                       DISPLACEMENT                    23155000
D44      EQU   44                       DISPLACEMENT                    23156000
D48      EQU   48                       DISPLACEMENT                    23157000
D256     EQU   256                      MAXIMUM MOVE LENGTH             23158000
         EJECT                                                          23159000
         COPY JERMSGCD                                                  23160000
         EJECT                                                          23161000
SAVMDVNP EQU   JDPASS                   SAVE AREA, MDV ADDRESS          23162000
SAVMDVLN EQU   JDPASS+D8                SAVE AREA, MDV LENGTH           23163000
SAVGDLNT EQU   JDPASS+D12               SAVE AREA GLOBAL DICT ALLOC     23164000
SAVOSDNP EQU   JDPASS+D16               SAVE AREA, OSRD ADDRESS         23165000
SAVOSDLN EQU   JDPASS+D24               SAVE AREA, OSRD LENGTH          23166000
SAVOVFPT EQU   JDPASS+D28               SAVE AREA, END OF FILE 1 ADDR   23167000
SAVOPTNP EQU   JDPASS+D36               SAVE AREA, OPSYN TABLE ADDRESS  23168000
SAVOPTLN EQU   JDPASS+D44               SAVE AREA, OPSYN TABLE LENGTH   23169000
SAVERRNP EQU   JDPASS+D48               SAVE AREA, ERROR BLOCK ADDRESS  23170000
GBLVCTEL EQU   3                        GLOBAL VECTOR ENTRY LENGTH      23171000
OPNDSTR  EQU   BIT7                     CHARACTER STRING PARAM FLAG     23172000
OPNDTRM  EQU   BIT6                     SELF-DEF TERM PARAM FLAG        23173000
OPNDORD  EQU   BIT5                     ORDINARY SYMBOL PARAM FLAG      23174000
OPNDOMT  EQU   BIT4                     OMITTED OPERAND PARAM FLAG      23175000
OPNDPRM  EQU   BIT3                     PASSED PARAMETER PARAM FLAG     23176000
OPNDSUB  EQU   BIT0                     SUBOPERAND PARAM FLAG           23177000
OPNDSUBF EQU   BIT2                     FIRST SUBOPERAND PARAM FLAG     23178000
OPNDSUBL EQU   BIT1                     LAST SUBOPERAND PARAM FLAG      23179000
MINRECSZ EQU   18                       MINIMUM I/O LENGTH              23180000
WORK1    EQU   R1                       SCRATCH REGISTER                23181000
WORKX    EQU   R1                       SCRATCH REGISTER                23182000
LOCTR    EQU   R2                       PTR TO NEXT BYTE FOR ALLOCAT    23183000
MDVPTR   EQU   R2                       PTR TO MDV ENTRY                23184000
PTPTR    EQU   R2                       PTR TO NEXT PARAM TBL SLOT      23185000
KEYPTR   EQU   R2                       PTR TO KEYWORD IN PARAM RECORD  23186000
KCPTR    EQU   R2                       PTR TO KEYWORD CHAIN ENTRY      23187000
SKDCTPTR EQU   R2                       PTR TO START OF SKEL DICT       23188000
PARAMPTR EQU   R2                       PTR TO PARAM TBL ENTRY          23189000
EPTR     EQU   R3                       PTR TO ERROR RCD IN ERROR BLOCK 23190000
PVEPTR   EQU   R3                       PTR TO NEXT PARAM VECTOR SLOT   23191000
KEYLEN   EQU   R3                       KEYWORD LENGTH REGISTER         23192000
SETPTR   EQU   R3                       PTR TO GBL/LCL DICT ENTRY, LIMB 23193000
OVLPTR   EQU   R4                       PTR TO ALLOC ADJUSTED FOR OVRLP 23194000
KEYCHAIN EQU   R4                       PTR TO KEYWORD CHAIN ENTRY      23195000
DICTPTR  EQU   R4                       PTR TO GBL/LCL DICT ENTRY, ROOT 23196000
VALLEN   EQU   R5                       PARAM VALUE LENGTH REGISTER     23197000
SETLEN   EQU   R5                       SETC VALUE LENGTH REGISTER      23198000
TXTPTR   EQU   R6                       PTR TO PARAM RECORD HDR DATA    23199000
RETURN   EQU   R9                       LINKAGE REGISTER                23200000
RTNLNK   EQU   R9                       LINKAGE REGISTER                23201000
PARMA    EQU   R10                      PARAMETER PASSAGE REGISTER      23202000
PARMB    EQU   R11                      PARAMETER PASSAGE REGISTER      23203000
WORKA    EQU   R14                      SCRATCH REGISTER                23204000
WORK2    EQU   R14                      SCRATCH REGISTER                23205000
WORKY    EQU   R14                      SCRATCH REGISTER                23206000
PAIRE    EQU   R14                      EVEN REGISTER OF PAIR           23207000
WORKB    EQU   R15                      SCRATCH REGISTER                23208000
WORK3    EQU   R15                      SCRATCH REGISTER                23209000
WORKZ    EQU   R15                      SCRATCH REGISTER                23210000
PAIRO    EQU   R15                      ODD REGISTER OF PAIR            23211000
         EJECT                                                          23212000
         JCSECT (X3N00)                                                 23213000
* VS1 RELEASE 2 CHANGES                                                 23214000
*C374400,378200                                                 OX00049 23215000
*A377900-378000                                                 OX00049 23216000
*A751700-751700                                                 OX00218 23217000
*A754700-754784                                                 OX00218 23218000
* VS1 RELEASE 4 CHANGES                                                 23219000
*A568000                                                        OY01298 23220000
         JMODID                                                         23221000
*DICTIONARY ENTRY ROUTINE - ALL CALLS TO THE GENERATE PHASE           * 23222000
*   DICTIONARY ROUTINES ENTER THROUGH THE FOLLOWING BRANCH TABLE      * 23223000
*   WHICH PROVIDES THE LINK TO THE REQUIRED ROUTINE.                  * 23224000
*                                                                     * 23225000
         USING DICTENTR,R12                                             23226000
DICTENTR B     DICTSAVE                 LINK TO ENTRY/SAVE ROUTINE      23227000
         DC    AL2(PHASENTR-DICTENTR)   DISPL TO PHASENTR ROUTINE       23228000
         DC    AL2(MACRCALL-DICTENTR)   DISPL TO MACRCALL ROUTINE       23229000
         DC    AL2(CALLEND-DICTENTR)    DISPL TO CALLEND  ROUTINE       23230000
         DC    AL2(MACRKWRD-DICTENTR)   DISPL TO MACRKWRD ROUTINE       23231000
         DC    AL2(MACRPOST-DICTENTR)   DISPL TO MACRPOST ROUTINE       23232000
         DC    AL2(PROTOKWD-DICTENTR)   DISPL TO PROTOKWD ROUTINE       23233000
         DC    AL2(PROTOEND-DICTENTR)   DISPL TO PROTOEND ROUTINE       23234000
         DC    AL2(GBLDICTR-DICTENTR)   DISPL TO GBLDICTR ROUTINE       23235000
         DC    AL2(GBLDICTS-DICTENTR)   DISPL TO GBLDICTS ROUTINE       23236000
         DC    AL2(LCLDICTR-DICTENTR)   DISPL TO LCLDICTR ROUTINE       23237000
         DC    AL2(LCLDICTS-DICTENTR)   DISPL TO LCLDICTS ROUTINE       23238000
         DC    AL2(PARMTBLR-DICTENTR)   DISPL TO PARMTBLR ROUTINE       23239000
         DC    AL2(SEQSYMBR-DICTENTR)   DISPL TO SEQSYMBR ROUTINE       23240000
         DC    AL2(ORDSYMBR-DICTENTR)   DISPL TO ORDSYMBR ROUTINE       23241000
         DC    AL2(MACRFINI-DICTENTR)   DISPL TO MACRFINI ROUTINE       23242000
         SPACE 5                                                        23243000
         JENTRY (X3N01=DICTENTR)                                        23244000
         EJECT                                                          23245000
*                                                                       23246000
* THIS SUBROUTINE IS USED BY ALL THE DICTIONARY ROUTINES TO SAVE        23247000
*        REGISTERS AND ESTABLISH ADDRESSABILITY.                        23248000
*                                                                       23249000
DICTSAVE STM   R2,R9,REGSTACK           PRESERVE CALLERS REGISTERS      23250000
         LR    R8,R12                   SET UP DICT RTN BASE ADDR       23251000
         USING DICTENTR,R8                                              23252000
         DROP  R12                                                      23253000
         LH    R9,ENTRYNDX              PICK UP ENTRY PT FLAG           23254000
         LH    R9,DICTENTR+D4(R9)       GET DISPL TO REQ'D RTN          23255000
         B     DICTENTR(R9)             ENTER DICTIONARY SUBRTN         23256000
         SPACE 10                                                       23257000
*                                                                       23258000
* THIS ROUTINE IS THE COMMON EXIT POINT FOR THE DICTIONARY ROUTINES.    23259000
*                                                                       23260000
DICTEXIT LM    R2,R9,REGSTACK           RESTORE CALLERS REGISTERS       23261000
         BR    R9                       RETURN TO CALLER                23262000
         EJECT                                                          23263000
*PHASENTR - THIS ROUTINE IS CALLED AT THE START OF THE GENERATE       * 23264000
*   PHASE. ITS FUNCTION IS TO FETCH THE MACRO DEFINITION VECTOR,      * 23265000
*   GET THE SPACE FOR AND INITIALIZE THE GLOBAL DICTIONARY, FETCH     * 23266000
*   THE ORDINARY SYMBOL REFERENCE DICTIONARY, FETCH THE SKELETON      * 23267000
*   DICTIONARY FOR OPEN CODE, AND GET THE SPACE FOR AND INITIALIZE    * 23268000
*   THE LOCAL DICTIONARY FOR OPEN CODE.                               * 23269000
*        INPUT - NONE.                                                * 23270000
*        OUTPUT - NONE.                                               * 23271000
*                                                                     * 23272000
PHASENTR EQU   *                                                        23273000
         XC    DICTCOMS(DICTCOME-DICTCOMS),DICTCOMS CLEAR COMMON AREA   23274000
         L     R11,=A(X'1FFFF0')        MAX CORE REQUEST IN DW          23275000
         JGETCORE MINDBL=750,MAXDBL=(R11) GET FREE SPACE                23276000
         ST    R10,FREESTRT             SAVE START PTR                  23277000
         AR    R11,R10                  DETERMINE END PTR               23278000
         ST    R11,FREEEND              SAVE END PTR                    23279000
         ST    R11,SPACEAH              SET UP FREE AREA END FIRST      23280000
         LR    LOCTR,R10                SET UP MAIN ALLOCATION PTR      23281000
         MVC   PIOPARMB,SAVMDVLN        GET LENGTH OF MDV               23282000
         ST    LOCTR,PIOPARMA           SET UP TO READ IN MDV           23283000
         L     WORK1,PIOPARMB           PICK UP MOV LENGTH              23284000
         MVC   JFWORD1,SAVGDLNT         GET GLOBAL DICT SIZE            23285000
         A     WORK1,JFWORD1            ADD IN FOR CALCULATION          23286000
         MVC   JFWORD1,SAVOSDLN         GET ORD SYMB REF DICT SIZE      23287000
         A     WORK1,JFWORD1            ADD IN FOR CALCULATION          23288000
         MVC   JFWORD1,SAVOPTLN         PICK UP OPSYN TABLE LENGTH      23289000
         A     WORK1,JFWORD1            ADD IN FOR CALCULATION          23290000
         AR    WORK1,LOCTR              DEVELOP OVERLAP POINTER         23291000
         CL    WORK1,FREEEND            LOOK FOR OVERLAP                23292000
         BNL   OVERLP4A                 BRANCH IF NO ROOM FOR GBL DICTS 23293000
         ST    LOCTR,MDVSTRT            SAVE AS MDV PTR                 23294000
         JPOINT FILE=FILE2,ADDR=SAVMDVNP,NEXT=READ POINT TO MDV         23295000
         LH    R5,JMAXRL2               SET UP MAXIMUM RECORD THIS FILE 23296000
         LA    R6,FILE2                 SET UP FILE POINTER             23297000
         BAL   RTNLNK,BUFREAD           GO GET MDV FROM FILE 2          23298000
         A     LOCTR,PIOPARMB           BUMP PTR PAST MDV               23299000
         CLC   SAVOPTLN(D4),=D'0'       SEE IF OPSYN TABLE REQ'D        23300000
         BZ    SKPOPSYN                 BRANCH IF NOT                   23301000
         ST    LOCTR,PIOPARMA           SET UP I/O AREA POINTER         23302000
         ST    LOCTR,OPSNSTRT           SET UP OPSYN TABLE POINTER      23303000
         MVC   PIOPARMB,SAVOPTLN        SET UP OPSYN TABLE LENGTH       23304000
         JPOINT FILE=FILE2,ADDR=SAVOPTNP,NEXT=READ POINT TO OPSYN TBL   23305000
         LH    R5,JMAXRL2               GET MAX RECD LNGT FOR FILE      23306000
         LA    R6,FILE2                 GET FILE INDICATOR              23307000
         BAL   RTNLNK,BUFREAD           GO FETCH OPSYN TABLE            23308000
         A     LOCTR,PIOPARMB           BUMP PTR PAST OPSYN TABLE       23309000
SKPOPSYN EQU   *                                                        23310000
         ST    LOCTR,GDSTRT             SAVE AS GBL DICT PTR            23311000
         MVC   JFWORD1,SAVGDLNT         GET LENGTH OF GBL DICT          23312000
         L     WORK1,JFWORD1            PICK IT UP FOR CLEARING DICT    23313000
         LR    WORKA,LOCTR              SET UP PTR TO AREA TO CLEAR     23314000
         LA    WORKB,D1(,WORKA)         SET UP DESTINATION POINTER      23315000
         MVI   D0(WORKA),J0             INSERT CHARACTER TO PROPAGATE   23316000
         BAL   RETURN,MOVLOP            GO CLEAR OUT AREA               23317000
         USING GSYSVALS,LOCTR                                           23318000
         L     WORK2,JSYSPARM           PICK UP SYSPARM PTR IN COMMON   23319000
         LTR   WORK2,WORK2              SEE IF SYSPARM SPECIFIED        23320000
         BZ    SKIPPARM                 BRANCH IF NOT                   23321000
         IC    WORK3,D0(,WORK2)         PICK UP SYSPARM LENGTH          23322000
         STC   WORK3,PARMLEN            INSERT IN SYSPARM ENTRY         23323000
         CLI   PARMLEN,L'PARMVAL        SEE IF LENGTH OVER 8            23324000
         BH    SKIPPARM                 IF YES, LEAVE POINTER ZERO      23325000
         BCTR  WORK3,D0                 OTHERWISE, GET MOVE LENGTH      23326000
         EX    WORK3,SYSPMOVE           MOVE SYSPARM VALUE INTO ENTRY   23327000
SKIPPARM EQU   *                                                        23328000
         LA    WORK3,L'JSYSTIME         GET LENGTH FOR SYSTIME ENTRY    23329000
         STC   WORK3,TIMELEN            INSERT IN DICTIONARY            23330000
         MVC   TIMEVAL(L'JSYSTIME),JSYSTIME INSERT SYSTIME VALUE        23331000
         LA    WORK3,L'JSYSDATE         GET LENGTH FOR SYSDATE ENTRY    23332000
         STC   WORK3,DATELEN            INSERT IN DICTIONARY            23333000
         MVC   DATEVAL(L'JSYSDATE),JSYSDATE  INSERT SYSDATE VALUE       23334000
         A     LOCTR,JFWORD1            BUMP PTR PAST GLOBAL DICT       23335000
         CLC   SAVOSDLN(D4),=D'0'       SEE IF OSRD LENGTH FOR READ     23336000
         BZ    SKPOSRD                  BRANCH IF YES                   23337000
         MVC   PIOPARMB,SAVOSDLN        PICK UP OSRD LENGTH FOR READ    23338000
         ST    LOCTR,PIOPARMA           SET UP TO READ IN OSRD          23339000
         ST    LOCTR,OSRDSTRT           SAVE AS OSRD PTR                23340000
         JPOINT FILE=FILE2,ADDR=SAVOSDNP,NEXT=READ POINT TO OSRD        23341000
         LH    R5,JMAXRL2               SET UP MAXIMUM RECORD THIS FILE 23342000
         LA    R6,FILE2                 SET UP FILE POINTER             23343000
         BAL   RTNLNK,BUFREAD           GO GET OSRD FROM FILE 2         23344000
         A     LOCTR,PIOPARMB           BUMP PTR PAST OSRD              23345000
SKPOSRD  EQU   *                                                        23346000
         ST    LOCTR,OVLYSTRT           SAVE AS DICT AREA START PTR     23347000
         BAL   RETURN,OVERLP4B          GO DUMP INTERLUDE ERRORS        23348000
         ST    LOCTR,SPACEAL            SET UP FREE SPACE LOW ADDR      23349000
         LCR   WORK1,LOCTR              GET COMPLEMENT FOR CALCULATE    23350000
         A     WORK1,SPACEAH            COMPUTE LENGTH OF FREE SPACE    23351000
         ST    WORK1,SPACEAE            SAVE FREE SPACE LENGTH          23352000
         ST    LOCTR,PIOPARMA           SET UP TO READ O.C. SKEL DICT   23353000
         L     PARMA,MDVSTRT            GET PTR TO OPEN CODE ENTRY      23354000
         USING MDVNTRY,PARMA                                            23355000
         CLC   MNPSD,=D'0'              SEE IF OPEN CODE OVERFLOWED     23356000
         BZ    OVERLP4F                 BRANCH IF IT DID                23357000
         MVC   PIOPARMB+(L'PIOPARMB-L'MSDL)(L'MSDL),MSDL               X23358000
               SET UP LENGTH OF O.C. SKELETON DICTIONARY                23359000
         L     R0,PIOPARMB              LENGTH OF SKEL DICTIONARY       23360000
         C     R0,SPACEAE               CHECK FOR SPACE OVERLAP         23361000
         BNL   OVERLP4C                 BRANCH IF OVERLAP FOUND         23362000
         LCR   R0,R0                    SUBTRACT LENGTH FROM            23363000
         A     R0,SPACEAE               FREE SPACE                      23364000
         ST    R0,SPACEAE                                               23365000
         ST    LOCTR,CURRDICT           SAVE AS CURRENT DICT PTR        23366000
         BAL   RETURN,DCTFETCH          GO TO BRING IN SKEL DICT        23367000
         USING SKDCTHDR,LOCTR                                           23368000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKLDLNG)(L'SKLDLNG),SKLDLNG        X23369000
               GET LOCAL DICTIONARY SIZE                                23370000
         L     R0,HIBYTE0               AND PICK IT UP                  23371000
         CL    R0,SPACEAE               CHECK FOR SPACE OVERLAP         23372000
         BNL   OVERLP4C                 BRANCH IF OVERLAP FOUND         23373000
         BAL   RETURN,PTRINIT           GO TO SET UP DICT POINTERS      23374000
         CLC   CURRLOCL,SPACEAL         SEE IF ANY LOCAL DICT ALLOCTD   23375000
         BNL   NOLCLOC                  BRANCH IF NOT                   23376000
         LR    WORK1,R0                 GET LCL DICT LENGTH FOR MOVLOP  23377000
         BAL   RETURN,LOCLINIT           INITIALIZE LOCAL DICTIONARY    23378000
NOLCLOC  EQU   *                                                        23379000
NOLOCAL  EQU   *                                                        23380000
         MVC   ACTRCNT,=F'4096'         INITIATE ACTR COUNT             23381000
         B     OVERLP4E                 BRANCH TO REPOSITION TEXT       23382000
OVERLP4A LA    RETURN,OVERLP4C          SET UP FOR FULSH EXIT,SEQUENCE  23383000
OVERLP4B ST    RETURN,REGSAVEB          PRESERVE LINK REGISTER          23384000
         JPOINT FILE=FILE2,NEXT=START   REPOSITION TEXT OUTPUT FILE     23385000
         MVC   D0(L'JNOTEVAL,LOCTR),SAVERRNP SET UP N/P CHAIN           23386000
         ST    LOCTR,PIOPARMA           SET UP I/O AREA POINTER         23387000
         MVC   PIOPARMB,=F'190'         SET UP ERROR BLOCK LENGTH       23388000
INLP     CLC   D0(L'JNOTEVAL,LOCTR),=D'0'   SEE IF ANY ERROR BLOCKS     23389000
         L     RETURN,REGSAVEB          RESTORE LINK REGISTER           23390000
         BZR   RETURN                   BRANCH IF NOT                   23391000
         JPOINT FILE=FILE1,ADDR=(LOCTR),NEXT=READ POINT TO ERROR BLOCK  23392000
         LH    R5,JMAXRL1               SET UP MAX RCD LENGTH FOR FILE  23393000
         LA    R6,FILE1                 SET UP FILE INDICATOR           23394000
         BAL   RTNLNK,BUFREAD           GO FETCH ERROR BLOCK            23395000
         LA    EPTR,L'JNOTEVAL(,LOCTR)  GET PTR TO ERROR RECORD         23396000
         USING JTEXT,EPTR                                               23397000
OUTLP    CLC   JTRLI,=H'0'              LOOK FOR END OF BLOCK FLAG      23398000
         BE    INLP                     BRANCH IF FOUND                 23399000
         JPUTM FILE=FILE2,ADDR=(EPTR)   PUT ERROR,RCD TO TXT FILE       23400000
         LA    EPTR,D36(,EPTR)          BUMP TO NEXT ERROR RECORD       23401000
         B     OUTLP                    GO BACK TO HANDLE NEXT ONE      23402000
OVERLP4C JPUTM FILE=FILE2,ADDR==AL1(D0,D12,JPSOP,JNOCNT,JTERROR,D0,D0,DX23403000
               0,D0,SEV89,ERR89,D0) PUT ERROR RECORD INTO TEXT FILE     23404000
         SET   INMACRO,OFF              INDICATE NOT IN MACRO NEST      23405000
OVERLP4D SET   FLUSH2,ON                INDICATE TEXT TO BE FLUSHED     23406000
OVERLP4E JPOINT FILE=FILE1,ADDR=SAVOVFPT,NEXT=WRITE                    X23407000
               POINT TO END OF FILE PRIOR TO REWIND                     23408000
         JPOINT FILE=FILE1,NEXT=START   REWIND TEXT FILE FOR GENERATOR  23409000
         B     DICTEXIT                 RETURN TO GENERATOR             23410000
OVERLP4F JPUTM FILE=FILE2,ADDR==AL1(D0,D12,JPSOP,JNOCNT,JTERROR,D0,D0,DX23411000
               0,D0,SEV133,ERR133,D0) PUT ERROR RECORD INTO TEXT FILE   23412000
         B     OVERLP4D                 GO SET FLUSH SWITCH,ETC.        23413000
         USING GSYSVALS,LOCTR                                           23414000
SYSPMOVE MVC   PARMVAL(D0),D1(WORK2)    EXECUTED SYSPARM MOVE           23415000
         DROP  LOCTR                                                    23416000
         DROP  EPTR                                                     23417000
         DROP  PARMA                                                    23418000
         EJECT                                                          23419000
*MACRCALL - THIS ROUTINE IS CALLED WHEN A MACRO INSTRUCTION IS        * 23420000
*   ENCOUNTERED. ITS FUNCTION IS TO PERFORM THE INITIALIZATION        * 23421000
*   REQUIRED TO BEGIN PARAMETER PROCESSING AND TO SUBSEQUENTLY        * 23422000
*   FETCH THE SKELETON DICTIONARY FOR THE MACRO DEFINITION.           * 23423000
*        INPUT - A POINTER IN R10 TO THE MACRO DEFINITION VECTOR      * 23424000
*                POINTER IN THE MACRO INSTRUCTION.                    * 23425000
*        OUTPUT - ON VALID MACRO CALL, R11 SET TO ZERO.               * 23426000
*                 ON UNDEFINED OP CODE, R11,SET TO VALUE INDICATING   * 23427000
*                 REASON FOR NON-DEFINITION.                          * 23428000
*                                                                     * 23429000
MACRCALL EQU   *                                                        23430000
         USING MCRCAL,PARMA                                             23431000
         MVC   HIBYTE0+(L'HIBYTE0-L'MDVPNT)(L'MDVPNT),MDVPNT           X23432000
               SAVE MDV PTR FROM TEXT FOR CURRENT AND LATER USE         23433000
         L     MDVPTR,MDVSTRT           GET BASE PTR TO MDV             23434000
         A     MDVPTR,HIBYTE0           DEVELOP PTR TO PROPER MDV SLOT  23435000
         ST    MDVPTR,MDVPTRSV          SAVE THIS POINTER FOR LATER     23436000
         USING MDVNTRY,MDVPTR                                           23437000
         SR    PARMB,PARMB              CLEAR RTN REG. CALL ASSUMED OK  23438000
         CLC   MNPTXT,=D'0'             CHECK FOR INVALID OP CODE       23439000
         BZ    BADCALL                  IF INVALID, BRANCH              23440000
         MVC   PPARMCNT,=F'-1'          INITIALIZE POSITIONAL COUNT     23441000
         XC    PRMTBLDS(L'PRMTBLDS+L'PVECTDIS+L'KVECTDIS+L'KCHANPTR),PRX23442000
               MTBLDS INITIALIZE OTHER CRUCIAL PARAMETER PROCESS VALUES 23443000
         MVI   PRMSWTCH,J0              INITIALIZE PARAMETER SWITCHES   23444000
         B     DICTEXIT                 RETURN                          23445000
BADCALL  IC    PARMB,MSDL+(L'MSDL-D1)   PICK UP FLAG FOR INVALID TYPE   23446000
         B     DICTEXIT                 RETURN                          23447000
         DROP  PARMA                                                    23448000
         DROP  MDVPTR                                                   23449000
         EJECT                                                          23450000
*CALLEND - THIS ROUTINE IS CALLED WHEN THE END-OF-PARAMETERS RECORD   * 23451000
*   IS ENCOUNTERED FOLLOWING A MACRO INSTRUCTION. ITS FUNCTION IS     * 23452000
*   TO NOTE AND SAVE THE TEXT RESUMPTION POINT FOR THE CURRENT TEXT   * 23453000
*   SEGMENT AND TO POSITION THE TEXT FILE TO THE START OF THE MACRO   * 23454000
*   DEFINITION TEXT SEGMENT.                                          * 23455000
*        INPUT - NONE.                                                * 23456000
*        OUTPUT - NONE.                                               * 23457000
*                                                                     * 23458000
CALLEND  EQU   *                                                        23459000
         JNOTE FILE=FILE1               NOTE TEXT FILE AT END OF CALL   23460000
         MVC   NOTESAVE,JNOTEVAL        SAVE N/P  TEMPORARILY           23461000
         L     MDVPTR,MDVPTRSV          GET PTR TO MDV ENTRY CALLED     23462000
         USING MDVNTRY,MDVPTR                                           23463000
         JPOINT FILE=FILE1,ADDR=MNPTXT,NEXT=GET POINT TO START OF TEXT  23464000
         B     DICTEXIT                 RETURN                          23465000
         DROP  MDVPTR                                                   23466000
         EJECT                                                          23467000
*MACRKWRD - THIS ROUTINE IS CALLED WHEN A KEYWORD PARAMETER RECORD    * 23468000
*   IS ENCOUNTERED FOLLOWING A MACRO INSTRUCTION. ITS FUNCTION IS     * 23469000
*   TO ADD THE PARAMETER VALUE TO THE KEYWORD PARAMETER CHAIN IN      * 23470000
*   PARAMETER TABLE.                                                  * 23471000
*        INPUT - A POINTER IN R10 TO THE PARAMETER RECORD.            * 23472000
*              - A POINTER IN R11 TO THE PARAMETER VALUE LENGTH       * 23473000
*                ( 1 BYTE) FOLLOWED BY THE PARAMETER VALUE CHARACTER  * 23474000
*                STRING (1-255 BYTES).                                  23475000
*        OUTPUT - NONE.                                               * 23476000
*                                                                     * 23477000
MACRKWRD EQU   *                                                        23478000
         SET   KEYFLG,ON                INDICATE KEYWORD PARAMETER      23479000
         L     PTPTR,PRMTBLAD           GET PTR TO BASE OF PARAM TABLE  23480000
         A     PTPTR,PRMTBLDS           GET PTR TO NEXT PARAM SLOT      23481000
         L     PVEPTR,PVECTPTR          GET PTR TO BASE OF POSIT VECTR  23482000
         S     PVEPTR,PVECTDIS          GET PTR TO END OF VECTOR        23483000
         S     PVEPTR,KVECTDIS          ALLOW FOR KEYWORDS UP TO HERE   23484000
         LR    OVLPTR,PTPTR             SET UP PTR FOR OVERLAP CHECK    23485000
         SR    VALLEN,VALLEN            CLEAR KEYWORD/VALUE LENGTH      23486000
         USING JTEXT,PARMA                                              23487000
         LH    TXTPTR,JTOPP             GET DISPL TO OPERAND FIELD      23488000
         AR    TXTPTR,PARMA             GET PTR TO OPERAND FIELD        23489000
         SH    TXTPTR,=H'5'              BACK UP TO START OF HEADER     23490000
         TM    D0(TXTPTR),OPNDSUB+OPNDSUBF BYPASS KEYWORD ENTRY IF NOT  23491000
         BM    MP0                      OPERAND OR FIRST SUBOPERAND     23492000
MK1      LA    WORKA,D5(,TXTPTR)        GET PTR TO OPERAND FIELD        23493000
         IC    VALLEN,D1(,WORKA)        GET KEYWORD LENGTH              23494000
         LA    OVLPTR,D5(VALLEN,OVLPTR) MAKE OVERLAP CALCULATION        23495000
         CLR   OVLPTR,PVEPTR            AND CHECK FOR OVERLAP           23496000
         BH    OVERLAP1                 BRANCH IF PARAM WON'T FIT       23497000
         MVC   D0(D4,PTPTR),KCHANPTR    PUT KEYWORD CHAIN PTR IN TBL    23498000
         LA    PTPTR,D0(,PTPTR)         MAKE FIRST BYTE ZERO            23499000
         ST    PTPTR,KCHANPTR           UPDATE KEYWORD CHAIN PTR        23500000
         EX    VALLEN,KEYMOVE           PUT KEYWORD LEN,KEYWORD IN TBL  23501000
         LA    PTPTR,D5(VALLEN,PTPTR)   UPDATE PARAMETER TABLE PTR      23502000
         SR    VALLEN,VALLEN            INSURE ZERO LENGTH REG          23503000
         B     MP0                      CONTINUE AS POSITIONAL PARAM    23504000
KEYMOVE  MVC   D4(D0,PTPTR),D1(WORKA)   EXECUTED KEYWORD MOVE           23505000
         DROP  PARMA                                                    23506000
         EJECT                                                          23507000
*MACRPOST - THIS ROUTINE IS CALLED WHEN A POSITIONAL PARAMETER        * 23508000
*   RECORD IS ENCOUNTERED FOLLOWING A MACRO INSTRUCTION. ITS FUNCTION * 23509000
*   IS TO ADD THE PARAMETER VALUE TO THE PARAMETER TABLE AND TO       * 23510000
*   MAKE AN ENTRY IN THE POSITIONAL VECTOR.                           * 23511000
*        INPUT - A POINTER IN R10 TO THE PARAMETER RECORD.            * 23512000
*              - A POINTER IN R11 TO THE PARAMETER VALUE LENGTH       * 23513000
*                ( 1 BYTE) FOLLOWED BY THE PARAMETER VALUE CHARACTER  * 23514000
*                STRING (1-255 BYTES).                                * 23515000
*        OUTPUT - NONE.                                               * 23516000
*                                                                     * 23517000
MACRPOST EQU   *                                                        23518000
         SET   KEYFLG,OFF               INDICATE POSITIONAL PARAM       23519000
         L     PTPTR,PRMTBLAD           GET PTR TO BASE OF PARAM TABLE  23520000
         A     PTPTR,PRMTBLDS           GET PTR TO NEXT PARAM SLOT      23521000
         L     PVEPTR,PVECTPTR          GET PTR TO BASE OF POSIT VECTR  23522000
         S     PVEPTR,PVECTDIS          GET PTR TO END OF VECTOR        23523000
         LR    OVLPTR,PTPTR             SET UP PTR FOR OVERLAP CHECK    23524000
         SR    VALLEN,VALLEN            CLEAR VALUE LENGTH              23525000
         USING JTEXT,PARMA                                              23526000
         LH    TXTPTR,JTOPP             GET DISPL TO OPERAND FIELD      23527000
         AR    TXTPTR,PARMA             GET PTR TO OPERAND FIELD        23528000
         SH    TXTPTR,=H'5'             BACK UP TO START OF HDR DATA    23529000
MP0      TM    D0(TXTPTR),OPNDSUB+OPNDSUBF LOOK FOR SUBOPERAND FLAGS    23530000
         BZ    MP2                      BRANCH IF NOT SUBOPERAND        23531000
         BM    MP3                      BRANCH IF NOT FIRST SUBOPER     23532000
         XC    SUBCNT(L'SUBCNT+L'SUBLEN+L'SUBVCTDS),SUBCNT             X23533000
               INITIALIZE SUBOPERAND PROCESSING VALUES                  23534000
MP2      ST    PTPTR,PRMPTRSV           SAVE POINTER TO STRT OF PARAM   23535000
MP3      TM    D0(TXTPTR),OPNDPRM       SEE IF PARAM PASSED FROM OUTER  23536000
         BO    MP3B                     BRANCH IF THE CASE              23537000
         TM    D0(TXTPTR),OPNDOMT       SEE IF OMITTED OPERAND. IF SO,  23538000
         BO    MP3A                     SKIP PICK UP OF VALUE LENGTH    23539000
         IC    VALLEN,D0(,PARMB)        PICK UP LENGTH OF PARAM VALUE   23540000
MP3A     LA    OVLPTR,D7(VALLEN,OVLPTR) MAKE OVERLAP CALCULATION        23541000
         CLR   OVLPTR,PVEPTR            SEE IF PARAMETER WILL FIT       23542000
         BH    OVERLAP2                 BRANCH IF NOT                   23543000
MP3B     TM    D0(TXTPTR),OPNDSUB+OPNDSUBF LOOK FOR SUBOPERAND FLAGS    23544000
         BZ    MP5                      BRANCH IF NOT SUBOPERAND        23545000
         BM    MP4                      BRANCH IF NOT FIRST SUBOPERAND  23546000
         LA    OVLPTR,D13(,OVLPTR)      DEVELOP POSSIBLE OVERLAP PTR    23547000
         CLR   OVLPTR,PVEPTR            CHECK IF OVERLAP MAY OCCUR      23548000
         BH    OVERLAP2                 BRANCH IF YES                   23549000
         MVC   D0(D13,PTPTR),=X'80000000000000000000000000'            X23550000
               PUT SUBLIST HEADER IN TO PARAM TABLE                     23551000
         LA    PTPTR,D13(,PTPTR)        ALLOW FOR SUBLIST HEADER        23552000
MP4      LR    WORKA,PVEPTR             GET POSIT VECTOR PTR FOR CALC   23553000
         S     WORKA,SUBVCTDS           DISPL TO END OF SUBLIST VECTOR  23554000
         SH    WORKA,=H'3'              ADJUST FOR ENTRY TO BE MADE     23555000
         LR    WORKB,PTPTR              GET PARAM TBL POINTER           23556000
         S     WORKB,PRMPTRSV           GET REL PTR TO SUBOPERAND       23557000
         ST    WORKB,HIBYTE0            SAVE COMPUTED DISPL             23558000
         MVC   D0(D3,WORKA),HIBYTE0+D1  INSERT IN SUBLIST VECTOR ENTRY  23559000
         LR    WORKB,PVEPTR             GET PTR TO PARAM VCTR END       23560000
         SR    WORKB,WORKA              GET NEW DISPL FOR SUBLST VCTR   23561000
         ST    WORKB,SUBVCTDS           SAVE DISPL FOR NEXT TIME        23562000
MP5      TM    D0(TXTPTR),OPNDPRM       SEE IF PARAM PASSED FROM OUTER  23563000
         BO    MP12                     BRANCH IF THE CASE              23564000
         TM    D0(TXTPTR),OPNDOMT       SEE IF OMITTED OPERAND          23565000
         BZ    MP6                      BRANCH IF NOT THE CASE          23566000
MPOMIT   MVC   D0(D8,PTPTR),=AL1(OPNDOMT,JO,J0,J1,J0,J0,X'60',J0)      X23567000
               SET ENTRY TYPE FLAG, ATTRIBUTES, AND LENGTH      OX00049 23568000
         LA    PTPTR,D8(,PTPTR)         ADJUST PARAM TBL POINTER        23569000
         B     MP9                      GO FINISH UP WITH THIS PARAM    23570000
MP6      TM    D0(TXTPTR),OPNDSTR       SEE IF CHARACTER STRING         23571000
         BZ    MP7                      BRANCH IF NOT THE CASE          23572000
         TM    D0(TXTPTR),OPNDORD       CHECK FOR COMPOS OPERAND        23573000
         BZ    MP6B                     BRANCH IF SIMPLE STRING         23574000
         MVI   D0(PTPTR),OPNDSTR        PUT IN STRING FLAG              23575000
         B     MP8A                     GO HANDLE AS ORD SYMBOL REFER   23576000
MP6B     LTR   VALLEN,VALLEN            IF NULL STRING          OX00049 23577000
         BZ    MPOMIT                   OMITTED OPERAND         OX00049 23578000
         MVC   D0(D7,PTPTR),=AL1(OPNDSTR,JU,J0,J1,J0,J0,X'60')  OX00049X23579000
               SET ENTRY TYPE FLAG AND ATTRIBUTES               OX00049 23580000
         LA    PTPTR,D7(,PTPTR)         ADJUST PARAM TBL POINTER        23581000
MP6A     EQU   *                                                        23582000
         EX    VALLEN,STRINGMV          INSERT VALUE LENGTH, VALUE      23583000
         LA    PTPTR,D1(VALLEN,PTPTR)   ADJUST PARAM TBL POINTER        23584000
         B     MP9                      GO FINISH UP WITH THIS PARAM    23585000
MP7      TM    D0(TXTPTR),OPNDTRM       SEE IF SELF-DEFINING TERM       23586000
         BZ    MP8                      BRANCH IF NOT THE CASE          23587000
         MVC   D0(D2,PTPTR),=AL1(OPNDTRM,JN) SET ENTRY TYPE FLAG,ATTRS  23588000
         MVC   D2(D4,PTPTR),D1(TXTPTR)  INSERT BINARY VALUE             23589000
         LA    PTPTR,D7(,PTPTR)         ADJUST PARAM TBL POINTER        23590000
         B     MP6A                     GO HANDLE VALUE                 23591000
MP8      MVI   D0(PTPTR),OPNDORD        INSERT TYPE FLAG (ORDINARY SYM) 23592000
         USING ORDREF,TXTPTR                                            23593000
MP8A     EQU   *                                                        23594000
         MVC   HIBYTE0+(L'HIBYTE0-L'ORDPNT)(L'ORDPNT),ORDPNT           X23595000
               PICK UP DICTIONARY POINTER FROM META TEXT                23596000
         L     WORKA,HIBYTE0            GET IT FOR POINTER CALCULATION  23597000
         CLC   OSRDSTRT,=D'0'           SEE IF ANY OSRD PRESENT         23598000
         BZ    MP8NG                    BRANCH IF NOT                   23599000
         A     WORKA,OSRDSTRT           DEVELOP PTR TO DICT ENTRY       23600000
         MVC   D1(D6,PTPTR),D0(WORKA)   PULL ACROSS ORDINARY SYMB ATTR  23601000
         LA    PTPTR,D7(,PTPTR)         ADJUST PARAM TBL POINTER        23602000
         B     MP6A                     GO HANDLE VALUE                 23603000
MP8NG    MVC   D1(D6,PTPTR),=AL1(JU,J0,J1,J0,J0,X'E0')   DEFAULT        23604000
         LA    PTPTR,D6(,PTPTR)         ADJUST PARAM TBL POINTER        23605000
         B     MP6A                     GO ON WITH PROCESS              23606000
MP9      TM    D0(TXTPTR),OPNDSUB       LOOK FOR SUBOPERAND FLAG        23607000
         BZ    MP10                     BRANCH IF NOT SUBOPERAND        23608000
         LH    WORKA,SUBCNT             GET CURRENT SUBOPERAND COUNT    23609000
         LA    WORKA,D1(,WORKA)         INCREMENT BY ONE                23610000
         STH   WORKA,SUBCNT             SAVE NEW COUNT                  23611000
         LH    WORKA,SUBLEN             GET CURRENT SUBLIST LENGTH      23612000
         AR    WORKA,VALLEN             INCREMENT BY SUBOPERAND LENGTH  23613000
         STH   WORKA,SUBLEN             SAVE NEW LENGTH                 23614000
         TM    D0(TXTPTR),OPNDSUBL      LOOK FOR LAST SUBOPER FLAG      23615000
         BZ    MP11                     BRANCH IF NOT LAST SUBOPER      23616000
         L     WORKA,PRMPTRSV           GET PTR TO SUBLIST HEADER       23617000
         MVC   D6(L'SUBCNT+L'SUBLEN,WORKA),SUBCNT INSERT SUBOPERAND    X23618000
               COUNT AND SUBLIST LENGTH IN HEADER DATA                  23619000
         MVC   D1(D5,WORKA),D14(WORKA)  INSERT ATTRIBUTES OF FIRST     X23620000
               SUBOPERAND AS ATTRIBUTES OF SUBLIST                      23621000
         LR    WORKB,PTPTR              GET PTR TO PARAM TABLE          23622000
         SR    WORKB,WORKA              GET LENGTH OF SUBLIST ENTRY     23623000
         A     WORKB,SUBVCTDS           GET DISPL TO SUBLIST VCTR STRT  23624000
         ST    WORKB,JFWORD1            SAVE DISPL TO SUBLIST VECTOR    23625000
         MVC   D10(D3,WORKA),JFWORD1+D1 INSERT INTO SUBLIST HEADER      23626000
         L     WORK1,SUBVCTDS           GET LENGTH OF SUBLIST VECTOR    23627000
         LR    WORKA,PVEPTR             GET PTR TO END OF SUBLST VCTR   23628000
         SR    WORKA,WORK1              GET PTR TO STRT OF SUBLST VCTR  23629000
         LR    WORKB,PTPTR              GET PTR TO PARAM TABLE          23630000
         BAL   RETURN,MOVLOP            GO MERGE VECTOR WITH SUBLIST    23631000
         A     PTPTR,SUBVCTDS           ADJUST PTR FOR SUBLIST VECTOR   23632000
MP10     GOIF  KEYFLG,ON=MP11           BRANCH IF KEYWORD OPERAND       23633000
         L     WORKA,PRMPTRSV           GET PTR TO PARAMETER START      23634000
         S     WORKA,PRMTBLAD           GET DISPL TO PARAM IN TABLE     23635000
         SH    PVEPTR,=H'3'             GET PTR TO NEXT VECTOR ENTRY    23636000
         ST    WORKA,HIBYTE0            SAVE DISPL TO PARAM ENTRY       23637000
         MVC   D0(D3,PVEPTR),HIBYTE0+D1 AND PUT INTO VECTOR ENTRY       23638000
         L     WORKA,PVECTPTR           PICK UP PARAM VECTOR BASE       23639000
         SR    WORKA,PVEPTR             GET DISPL TO NEW END OF VECTOR  23640000
         ST    WORKA,PVECTDIS           SAVE DISPLACEMENT               23641000
         L     WORKA,PPARMCNT           GET CURRENT POSIT PARAM COUNT   23642000
         LA    WORKA,D1(,WORKA)         INCREMENT BY ONE                23643000
         ST    WORKA,PPARMCNT           SAVE NEW COUNT                  23644000
MP11     S     PTPTR,PRMTBLAD           GET NEW PARAM TBL LENGTH        23645000
         ST    PTPTR,PRMTBLDS           SAVE DISPL                      23646000
         B     DICTEXIT                 RETURN                          23647000
MP12     GOIF  PASSPARM,ON=MP12A        GO TO HANDLE PARAM AS PARAM     23648000
         IC    VALLEN,D0(,PARMB)        PICK UP LENGTH OF PARAM STRING  23649000
         LA    OVLPTR,D7(VALLEN,OVLPTR) CALCULATE OVERLAP POINTER       23650000
         CLR   OVLPTR,PVEPTR            SEE IF OVERLAP OCCURRED         23651000
         BH    OVERLAP2                 BRANCH IF SO. OTHERWISE,        23652000
         B     MP6B                     HANDLE PARAM AS STRING          23653000
MP12A    EQU   *                                                        23654000
         TM    D0(PARMB),OPNDSUB        SEE IF PASSING A SUBLIST        23655000
         BZ    MP13                     BRANCH IF NOT SUBLIST           23656000
         MVC   HIBYTE0+D1(D3),D10(PARMB) PICK UP PTR TO SUBLIST VCTR    23657000
         L     WORK1,HIBYTE0            GET IT AS SUBLIST LENGTH        23658000
         B     MP13A                    GO CHECK FOR OVERLAP CONDITION  23659000
MP13     IC    VALLEN,D7(,PARMB)        PICK UP VALUE LENGTH            23660000
         LA    WORK1,D8(,VALLEN)        GET WHOLE PARAMETER LENGTH      23661000
MP13A    LA    OVLPTR,D3(WORK1,OVLPTR)  DEVELOP OVERLAP PTR             23662000
         CLR   OVLPTR,PVEPTR            CHECK FOR POSSIBLE OVERLAP      23663000
         BH    OVERLAP2                 BRANCH IF YES                   23664000
         LR    R0,WORK1                 PRESERVE PARAMETER LENGTH       23665000
         LR    WORKA,PARMB              GET PTR TO PARAMETER VALUE      23666000
         LR    WORKB,PTPTR              GET PTR TO PARAMETER TABLE      23667000
         BAL   RETURN,MOVLOP            GO TO PUT PARAM VALUE IN TABLE  23668000
         AR    PTPTR,R0                 ADJUST PTR FOR PARAM VALUE      23669000
         SET   PASSPARM,OFF             CLEAN UP PASSED PARAM SWITCH    23670000
         B     MP9                      GO FINISH UP WITH THIS PARAM    23671000
STRINGMV MVC   D0(D0,PTPTR),D0(PARMB)   EXECUTE PARM VALUE MOVE         23672000
OVERLAP1 EQU   *                                                        23673000
OVERLAP2 EQU   *                                                        23674000
         SET   (CALLING,NOCALL),FLIP    RESET SWITCHES FOR REST OF CALL 23675000
         SET   DEFLG,OFF                SET FLAG FOR DEFAULT OVERLAP    23676000
         BAL   R2,ERRRTN                GO TO LOG ERROR AND FIX COUNT   23677000
         B     DICTEXIT                 RETURN TO GENERATOR             23678000
         DROP  PARMA                                                    23679000
         DROP  TXTPTR                                                   23680000
         EJECT                                                          23681000
* PROTOKWD - THIS ROUTINE IS CALLED WHEN A KEYWORD PARAMETER RECORD   * 23682000
*   IS ENCOUNTERED FOLLOWING A PROTOTYPE STATEMENT. ITS FUNCTION IS   * 23683000
*   TO ADD THE DEFAULT PARAMETER VALUE TO THE KEYWORD PARAMETER       * 23684000
*   CHAIN IN THE PARAMETER TABLE IF THE KEYWORD PARAMETER WAS NOT     * 23685000
*   SPECIFIED ON THE MACRO INSTRUCTION. IT ALSO MAKES AN ENTRY IN     * 23686000
*   THE KEYWORD VECTOR.                                               * 23687000
*        INPUT - A POINTER IN R10 TO THE PARAMETER RECORD.            * 23688000
*              - A POINTER IN R11 TO THE PARAMETER VALUE LENGTH       * 23689000
*                ( 1 BYTE) FOLLOWED BY THE PARAMETER VALUE CHARACTER  * 23690000
*                STRING (1-255 BYTES).                                * 23691000
*        OUTPUT - NONE.                                               * 23692000
*                                                                     * 23693000
PROTOKWD EQU   *                                                        23694000
         USING JTEXT,PARMA                                              23695000
         LH    KEYPTR,JTOPP             GET DISPL TO OPERAND FIELD      23696000
         AR    KEYPTR,PARMA             GET PTR TO STRT OF OPRND FIELD  23697000
         GOIF  BYFLG,ON=PK8             BRANCH IF BYPASS FLAG ON        23698000
         GOIF  ENFLG,ON=PK7             BRANCH IF ENTRY FLAG ON         23699000
         SET   PREVDEF,OFF              INITIALIZE DUPLICATION SWITCH   23700000
         SR    KEYLEN,KEYLEN            CLEAR REG FOR KEYWORD LENGTH    23701000
         IC    KEYLEN,D1(,KEYPTR)       PICK UP KEYWORD LENGTH          23702000
         BCTR  KEYLEN,D0                DROP AMPERSAND                  23703000
         STC   KEYLEN,KEYLENSV          SAVE FOR LENGTH COMPARISON      23704000
         BCTR  KEYLEN,D0                GET MOVE LENGTH OF KEYWORD      23705000
         L     KEYCHAIN,KCHANPTR        PICK UP KEYWORD CHAIN POINTER   23706000
PK1      LTR   KEYCHAIN,KEYCHAIN        SEE IF CHAIN PTR ZERO (END)     23707000
         BZ    PK5                      BRANCH IF END TO ENTER DEFAULT  23708000
         TM    D0(KEYCHAIN),BIT0        LOOK FOR PROCESSED INDICATOR    23709000
         BO    PK2                      BRANCH IF ON TO GET NEXT ENTRY  23710000
         CLC   KEYLENSV,D4(KEYCHAIN)    COMPARE KEYWORD LENGTHS         23711000
         BNE   PK2                      BRANCH IF UNALIKE TO GET NEXT   23712000
         EX    KEYLEN,KEYCOMP           COMPARE KEYWORDS                23713000
         BE    PK3                      BRANCH IF IDENTICAL             23714000
PK2      MVC   HIBYTE0(D4),D0(KEYCHAIN) GET CHAIN PTR FROM ENTRY        23715000
         NI    HIBYTE0,BITFF-BIT0       STRIP OUT HIGH BIT IF THERE     23716000
         L     KEYCHAIN,HIBYTE0         MAKE IT THE NEW CHAIN POINTER   23717000
         B     PK1                      GO BACK TO CONTINUE SEARCH      23718000
PK3      GOIF  PREVDEF,ON=KDUPLERR      BRANCH IF MATCH ALREADY FOUND   23719000
         SET   PREVDEF,ON               INDICATE INITIAL MATCH          23720000
         LR    WORKX,KEYPTR             SET UP OPERAND FIELD PTR        23721000
         SH    WORKX,=H'5'              GET PTR TO START OF HEADER      23722000
         TM    D0(WORKX),OPNDSUB+OPNDSUBF+OPNDSUBL                     X23723000
               CHECK SUBOPERAND FLAGS                                   23724000
         BNM   PK4                      BRANCH IF NOT SUBOPERAND (NTH)  23725000
         SET   BYFLG,ON                 SET BYPASS FLAG ON              23726000
PK4      EQU   *                                                        23727000
         BAL   R9,KWDEND                GO TO FINISH KEYWORD ENTRY      23728000
         B     PK2                      GO BACK TO COMPLETE SCAN        23729000
PK5      GOIF  PREVDEF,ON=DICTEXIT      DONT ENTER DEFALT OF DUPLICATE  23730000
         LR    WORKX,KEYPTR             SET UP OPERAND FIELD PTR        23731000
         SH    WORKX,=H'5'              GET PTR TO START OF HEADER      23732000
         TM    D0(WORKX),OPNDSUB+OPNDSUBF+OPNDSUBL                     X23733000
               CHECK SUBOPERAND FLAGS                                   23734000
         BNM   PK6                      BRANCH IF NOT SUBOPERAND (NTH)  23735000
         SET   ENFLG,ON                 SET ENTRY FLAG ON               23736000
PK6      SET   DEFLG,ON                 INDICATE DEFAULT VALUE ASSGNMT  23737000
         LR    R12,R8                   SET UP DUMMY BASE ADDR          23738000
         MVC   RECURSTK(D32),REGSTACK   PRESERVE OUTER LEVEL REGISTERS  23739000
         LA    R11,D5(KEYLEN,KEYPTR)    GET PTR TO PARAM STRING         23740000
         MVI   NDXVAL,D6                SET UP FOR MACRKWRD ENTRY       23741000
         BALR  R9,R12                   MAKE RECURRSIVE ENTRY           23742000
         MVC   REGSTACK(D32),RECURSTK   RESTORE OUTER LEVEL REGISTERS   23743000
         GOIF  DEFLG,OFF=OVERLAP3       BRANCH IF OVERLAP OCCURRED      23744000
         GOIF  ENFLG,ON=DICTEXIT        FINISHED WITH SUBOPERAND        23745000
         B     PK7A                     GO TO MAKE VECTOR ENTRY         23746000
PK7      MVC   RECURSTK(D32),REGSTACK   PRESERVE OUTER LEVEL REGISTERS  23747000
         LR    R12,R8                   SET UP DUMMY BASE ADDR          23748000
         LA    R11,D1(,KEYPTR)          GET PTR TO PARAM STRING         23749000
         MVI   NDXVAL,D6                SET UP FOR MACRKWRD ENTRY       23750000
         BALR  R9,R12                   MAKE RECURRSIVE ENTRY           23751000
         MVC   REGSTACK(D32),RECURSTK   RESTORE OUTER LEVEL REGISTERS   23752000
PK71     EQU   *                                                        23753000
         GOIF  DEFLG,OFF=OVERLAP3       BRANCH IF OVERLAP OCCURRED      23754000
         LR    WORKX,KEYPTR             SET UP OPERAND FIELD PTR        23755000
         SH    WORKX,=H'5'              GET PTR TO START OF HEADER      23756000
         TM    D0(WORKX),OPNDSUBL       LOOK FOR LAST SUBOPERAND FLAG   23757000
         BZ    DICTEXIT                 BRANCH IF NOT FOUND             23758000
         SET   ENFLG,OFF                TURN OFF ENTRY FLAG             23759000
PK7A     L     KEYCHAIN,KCHANPTR        PICK UP PTR TO KEYWORD ENTERED  23760000
         SR    KEYLEN,KEYLEN            CLEAR REG FOR KEYWORD LENGTH    23761000
         IC    KEYLEN,KEYLENSV          PICK UP SAVED KEYWORD LENGTH    23762000
         BAL   R9,KWDEND                GO TO FINISH KEYWORD ENTRY      23763000
         B     DICTEXIT                 DONE WITH THIS ENTRY            23764000
PK8      LR    WORKX,KEYPTR             SET UP OPERAND FIELD PTR        23765000
         SH    WORKX,=H'5'              GET PTR TO START OF HEADER      23766000
         TM    D0(WORKX),OPNDSUBL       LOOK FOR LAST SUBOPERAND FLAG   23767000
         BZ    DICTEXIT                 BRANCH IF NOT FOUND             23768000
         SET   BYFLG,OFF                TURN OFF BYPASS FLAG            23769000
         B     DICTEXIT                 RETURN                          23770000
KWDEND   L     WORKZ,PVECTPTR           GET PTR TO END OF PARAM VCTRS   23771000
         S     WORKZ,PVECTDIS           GET PTR TO START OF POSIT VCTR  23772000
         SH    WORKZ,=H'3'              GET PTR TO FIRST KEYWORD SLOT   23773000
         S     WORKZ,KVECTDIS           DISPLACE TO NEXT KEYWORD SLOT   23774000
         LA    WORKY,D6(KEYLEN,KEYCHAIN) GET PTR TO PARAM TBL ENTRY     23775000
         S     WORKY,PRMTBLAD           GET DISPL TO PARAM TBL ENTRY    23776000
         ST    WORKY,JFWORD1            SAVE DISPLACEMENT AND           23777000
         MVC   D0(D3,WORKZ),JFWORD1+D1  INSERT INTO KEYWORD VECTOR SLOT 23778000
         L     WORKY,KVECTDIS           PICK UP CURRENT KEYWORD VECTOR  23779000
         AH    WORKY,=H'3'              LENGTH, ADJUST FOR NEW PARAM,   23780000
         ST    WORKY,KVECTDIS           AND SAVE ADJUSTED LENGTH        23781000
         OI    D0(KEYCHAIN),BIT0        INDICATE KEYWORD ENTRY PROCESSD 23782000
         BR    R9                       RETURN TO CALLER                23783000
KEYCOMP  CLC   D5(D0,KEYCHAIN),D3(KEYPTR) EXECUTED KEYWORD COMPARE      23784000
KDUPLERR L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    23785000
         JEXTRN (X3A02=LOGERR01)                                        23786000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          23787000
         DC    AL1(SEV91,ERR91)         ERROR PARAMETERS                23788000
         L     WORKX,ESTKNDX            PICK UP ERROR STACK POINTER     23789000
         MVC   D0(D8,WORKX),=8AL1(JBLANK) INSERT NAME PADDING           23790000
         IC    WORKY,D4(,KEYCHAIN)      PICK UP KEYWORD LENGTH          23791000
         BCTR  WORKX,D0                 BACK UP TO LAST ENTRY           23792000
         EX    WORKY,KEYDUPMV          INSERT KEYWORD IN MESSAGE        23793000
         LA    WORKX,D9(,WORKX)         ADJUST ERROR STACK POINTER      23794000
         ST    WORKX,ESTKNDX            SAVE ERROR STACK POINTER        23795000
         L     R15,TXTOUT               PICK UP PTR TO LAST TEXT RCD    23796000
         USING JTEXT,R15                                                23797000
         SET   JERR,ON                  INDICATE AN ERROR FOLLOWS       23798000
         OI    D0(KEYCHAIN),BIT0        INDICATE KEYWORD ENTRY PROCESSD 23799000
         B     PK2                      GO BACK FOR FURTHER SCAN        23800000
KEYDUPMV MVC   D0(D0,WORKX),D4(KEYCHAIN) EXECUTED MOVE OF DUPL KEYWRD   23801000
         DROP  PARMA                                                    23802000
         DROP  R15                                                      23803000
         EJECT                                                          23804000
*PROTOEND - THIS ROUTINE IS CALLED WHEN THE END-OF-PARAMETERS RECORD  * 23805000
*   IS ENCOUNTERED FOLLOWING A PROTOTYPE STATEMENT. ITS FUNCTION IS   * 23806000
*   TO CHECK FOR AND FLAG UNDECLARED KEYWORD PARAMETERS, TO COMPLETE  * 23807000
*   THE PARAMETER PROCESSING AND TO MERGE THE PARAMETER VECTORS       * 23808000
*   AND THE PARAMETER TABLE INTO THE MACRO PARAMETER WORK AREA, TO    * 23809000
*   ALLOCATE THE SPACE FOR AND FETCH THE SKELETON DICTIONARY FOR      * 23810000
*   THE MACRO DEFINITION, AND TO ALLOCATE THE SPACE FOR AND           * 23811000
*   INITIALIZE THE LOCAL DICTIONARY FOR THE MACRO DEFINITION. IF      * 23812000
*   NECESSARY TO GET THE SPACE FOR THE DICTIONARY BEING BUILT, THE    * 23813000
*   DICTIONARY(S) FOR THE HIGHER LEVEL TEXT SEGMENT(S) ARE SAVED      * 23814000
*   ON A WORKFILE.                                                    * 23815000
*        INPUT - NONE.                                                * 23816000
*        OUTPUT - NONE.                                               * 23817000
*                                                                     * 23818000
PROTOEND EQU   *                                                        23819000
         L     KCPTR,KCHANPTR           PICK UP KEYWORD CHAIN PTR       23820000
PE0      LTR   KCPTR,KCPTR              SEE IF END OF CHAIN INDICATED   23821000
         BZ    PE2                      BRANCH IF YES                   23822000
         TM    D0(KCPTR),BIT0           SEE IF KEYWORD DEFINED          23823000
         BO    PE1                      BRANCH IF YES AND MATCH FOUND   23824000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    23825000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          23826000
         DC    AL1(SEV92,ERR92)         ERROR PARAMETERS                23827000
         L     WORKX,ESTKNDX            PICK UP ERROR STACK POINTER     23828000
         MVC   D0(D8,WORKX),=8AL1(JBLANK) INSERT NAME PADDING           23829000
         IC    WORKY,D4(,KCPTR)         PICK UP KEYWORD LENGTH          23830000
         BCTR  WORKX,D0                 BACK UP TO LAST ENTRY           23831000
         EX    WORKY,KEYUNDMV           INSERT KEYWORD IN MESSAGE       23832000
         LA    WORKX,D9(,WORKX)         ADJUST ERROR STACK POINTER      23833000
         ST    WORKX,ESTKNDX            SAVE ERROR STACK POINTER        23834000
         L     R15,TXTOUT               PICK UP PTR TO LAST TEXT RCD    23835000
         USING JTEXT,R15                                                23836000
         SET   JERR,ON                  INDICATE AN ERROR FOLLOWS       23837000
PE1      NI    D0(KCPTR),BITFF-BIT0     STRIP OFF FLAG BIT              23838000
         MVC   HIBYTE0(D4),D0(KCPTR)    GET CHAIN POINTER FROM ENTRY    23839000
         L     KCPTR,HIBYTE0            PICK UP PTR FOR NEXT ENTRY      23840000
         B     PE0                      GO BACK TO REPEAT PROCESS       23841000
PE2      EQU   *                                                        23842000
         L     WORK1,PVECTDIS           GET LENGTH OF POSITIONAL VCTR   23843000
         A     WORK1,KVECTDIS           GET LENGTH OF BOTH VECTORS      23844000
         LTR   WORK1,WORK1              SEE IF ANY VECTORS TO MOVE      23845000
         BZ    PE3                      IF NOT, SKIP MOVE               23846000
         ST    WORK1,KVECTDIS           PRESERVE LENGTH OF VECTORS      23847000
         L     WORKB,PRMTBLAD           GET PTR TO START OF PARAM TBL   23848000
         A     WORKB,PRMTBLDS           GET PTR TO END OF PARAM TBL     23849000
         L     WORKA,PVECTPTR           GET PTR TO END OF VECTORS       23850000
         SR    WORKA,WORK1              GET PTR TO START OF VECTORS     23851000
         BAL   RETURN,MOVLOP            GO MOVE PARAM VECTORS TO TABLE  23852000
PE3      EQU   *                                                        23853000
         JNOTE FILE=FILE1               KEEP PTR TO TEXT FILE           23854000
         MVC   SAVENOTE,JNOTEVAL        SAVE NOTE/POINT ADDR            23855000
         L     SKDCTPTR,CURRDICT        GET PTR TO CALLING LEVEL DICT   23856000
         USING SKDCTHDR,SKDCTPTR                                        23857000
         MVC   SKACTRV,ACTRCNT          SAVE CURRENT ACTR VALUE         23858000
         MVC   SKNOFSLS,NOFSYSLS        SAVE POSITIONAL PARAM COUNT     23859000
         ST    SKDCTPTR,ALTPTRSV        SAVE DICT PTR TEMPORARILY       23860000
         L     SKDCTPTR,SPACEAL         GET PTR TO STRT OF FREE AREA    23861000
         A     SKDCTPTR,PRMTBLDS        ALLOW FOR PARAMETER TABLE       23862000
         A     SKDCTPTR,KVECTDIS        ALLOW FOR PARAMETER VECTORS     23863000
         ST    SKDCTPTR,PIOPARMA        SET UP PTR FOR DICT SKEL FETCH  23864000
         L     PARMA,MDVPTRSV           GET PTR TO MDV ENTRY            23865000
         USING MDVNTRY,PARMA                                            23866000
         MVC   PIOPARMB+(L'PIOPARMB-L'MSDL)(L'MSDL),MSDL               X23867000
               SET UP SKEL DICT LENGTH                                  23868000
         L     R0,PRMTBLDS              LENGTH OF PARAMETERS TABLE      23869000
         A     R0,KVECTDIS              LENGTH OF PARAMETER VECTORS     23870000
         A     R0,PIOPARMB              LENGTH OF SKEL DICTIONARY       23871000
         C     R0,SPACEAE               CHECK FOR SPACE OVERLAP         23872000
         BNL   OVERLAP5                 BRANCH IF INSUFF SPACE          23873000
         LCR   R0,R0                    SUBTRACT LENGTH FROM            23874000
         A     R0,SPACEAE               FREE SPACE                      23875000
         ST    R0,SPACEAE                                               23876000
         BAL   RETURN,DCTFETCH          GO TO FETCH SKELETON DICT       23877000
         MVC   SKNPNLT,NOTESAVE         PUT TXT N/P IN SKEL DICT HDR    23878000
         MVC   SKKVADR,PVECTDIS+(L'PVECTDIS-L'SKKVADR) GET POSITIONAL  X23879000
               VECTOR LENGTH FOR HEADER                                 23880000
         MVC   SKADNLD,ALTPTRSV         SAVE PTR TO NEXT LEVEL DICT     23881000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKLDLNG)(L'SKLDLNG),SKLDLNG        X23882000
               GET LOCAL DICT LENGTH FROM DICT HEADER                   23883000
         L     R0,HIBYTE0               PICK UP LENGTH FOR INITIAL      23884000
         CL    R0,SPACEAE               SEE IF SPACE OVERLAP OCCURS     23885000
         BNL   OVERLAP5                 BRANCH ON OVERLAP               23886000
         ST    SKDCTPTR,CURRDICT        SET UP NEW CURRENT DICT PTR     23887000
         LR    WORK1,SKDCTPTR           GET PTR TO DICT AREA BASE       23888000
         S     WORK1,SPACEAL            COMPUTE PARAM TBL LENGTH        23889000
         ST    WORK1,HIBYTE0            SAVE TEMPORARILY AND INSERT     23890000
         MVC   SKMPADR,HIBYTE0+(L'HIBYTE0-L'SKMPADR) IN DICT HDR        23891000
         BAL   RETURN,PTRINIT           GO INITIALIZE DICT POINTERS     23892000
         CLC   CURRLOCL,SPACEAL         SEE IF LOCAL DICT LENGTH ZERO   23893000
         BE    NOLCLMD                  SKIP INITIALIZATION IF SO       23894000
         LR    WORK1,R0                 GET LOCAL LENGTH FOR MOVLOP     23895000
         BAL   RETURN,LOCLINIT           GO INITIZE LOCAL DICTIONARY    23896000
         L     WORK1,CURRLOCL           GET PTR TO LOCAL DICT BASE      23897000
         USING LSYSVALS,WORK1                                           23898000
         MVC   INDXVAL,SYSNDX           PUT SYSNDX VALUE IN LCL DICT    23899000
         IC    WORK3,SYSECTL            GET LENGTH OF SYSECT VALUE      23900000
         EX    WORK3,SECTMOVE           PUT SYSECT VALUE,LEN IN LCL DT  23901000
NOLCLMD  EQU   *                                                        23902000
         MVC   ACTRCNT,=F'4096'         INITIALIZE ACTR VALUE           23903000
         L     WORK2,PPARMCNT           PICK UP FINAL POSITIONAL COUNT  23904000
         LTR   WORK2,WORK2              SEE IF ANY WERE PRESENT         23905000
         BNM   GOODCNT                  BRANCH IF ONE OR MORE           23906000
         SR    WORK2,WORK2              SET COUNT TO ZERO               23907000
GOODCNT  STH   WORK2,NOFSYSLS           SAVE POSITIONAL COUNT FOR DICT  23908000
         JPOINT FILE=FILE1,ADDR=SAVENOTE,NEXT=GET REPOSITION TEXT       23909000
         JGETL FILE=FILE1               DUMMY GET ON TEXT FILE          23910000
         B     DICTEXIT                 RETURN                          23911000
SECTMOVE MVC   SECTLEN(D0),SYSECTL      EXECUTED SYSECT MOVE            23912000
KEYUNDMV MVC   D0(D0,WORKX),D4(KCPTR)   EXECUTED MOVE OF UNDEF KEYWORD  23913000
OVERLAP5 SET   CALLING,OFF              EFFECTIVELY ABORT CALL          23914000
         BAL   R2,ERRRTN                GO TO LOG OVERLAP ERROR         23915000
OVERLAP3 EQU   *                                                        23916000
         NI    EVALSW01,BITFF-(CALLING+NOCALL)                  OY01298 23917000
         JPOINT FILE=FILE1,ADDR=NOTESAVE,NEXT=GET REPOSITION TEXT FILE  23918000
         B     DICTEXIT                 EXIT                            23919000
         DROP  PARMA                                                    23920000
         DROP  SKDCTPTR                                                 23921000
         DROP  R15                                                      23922000
         EJECT                                                          23923000
*GBLDICTR/GBLDICTS - THIS ROUTINE IS CALLED WHEN THE VALUE OF A       * 23924000
*   GLOBAL VARIABLE IS TO BE SET OR IS REFERENCED. ITS FUNCTION       * 23925000
*   IS TO LOCATE THE APPROPRIATE ENTRY IN THE GLOBAL DICTIONARY       * 23926000
*   THROUGH THE GLOBAL VECTOR AND TO EITHER SET THE GLOBAL DICTIONARY * 23927000
*   ENTRY TO A SPECIFIED VALUE (ENTRY AT 'GBLDICTS') OR GET THE       * 23928000
*   VALUE OF THE GLOBAL DICTIONARY ENTRY FOR THE GENERATOR (ENTRY     * 23929000
*   AT 'GBLDICTR').                                                   * 23930000
*                           * ENTRY AT GBLDICTS *                     * 23931000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 23932000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 23933000
*                FOLLOWED BY THE EFFECTIVE SUBSCRIPT (2 BYTES)        * 23934000
*              - SETA VARIABLE, VALUE TO BE ASSIGNED IN R11           * 23935000
*                SETB VARIABLE, ZERO VALUE IN R11 TO SET VARIABLE OFF * 23936000
*                               NON-ZERO VALUE IN R11 TO SET VARIABLE * 23937000
*                                       ON                            * 23938000
*                SETC VARIABLE, POINTER TO CHARACTER STRING TO BE     * 23939000
*                                       ASSIGNED IN R11               * 23940000
*        OUTPUT - NONE.                                               * 23941000
*                           * ENTRY AT GBLDICTR *                     * 23942000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 23943000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 23944000
*                FOLLOWED BY THE EFFECTIVE SUBSCRIPT (2 BYTES)        * 23945000
*        OUTPUT - SETA VARIABLE, VALUE OF VARIABLE IN R11             * 23946000
*                 SETB VARIABLE, ZERO VALUE IN R11 IF VARIABLE OFF    * 23947000
*                                NON-ZERO VALUE IN R11 IF VARIABLE ON * 23948000
*                 SETC VARIABLE, POINTER TO CHARACTER STRING IN R11   * 23949000
*                                                                     * 23950000
GBLDICTR EQU   *                                                        23951000
         SET   REFFLAG,ON               INDICATE REFERENCE ENTRY        23952000
         B     GCOM                     CONTINUE AT GLOBAL COMMON       23953000
GBLDICTS EQU   *                                                        23954000
         SET   REFFLAG,OFF              INDICATE SET ENTRY              23955000
GCOM     EQU   *                                                        23956000
         SET   GBLCALL,ON               INDICATE GLOBAL ENTRY           23957000
         L     SETPTR,CURRGLBL          PICK UP CURRENT GBL VCTR PTR    23958000
         USING VREF,PARMA                                               23959000
         MVC   HIBYTE0+(L'HIBYTE0-L'VPNT)(L'VPNT),VPNT                 X23960000
               PICK UP PTR TO GBL VECTOR ENTRY FROM TEXT                23961000
         A     SETPTR,HIBYTE0           DEVELOP PTR TO GBL VECTOR ENTRY 23962000
         CLC   D0(GBLVCTEL,SETPTR),=X'FFFFFE' LOOK FOR GBL ERROR FLAG   23963000
         BE    GBLERR                   BRANCH IF FOUND                 23964000
         MVC   HIBYTE0+(L'HIBYTE0-GBLVCTEL)(GBLVCTEL),D0(SETPTR)       X23965000
               PICK UP PTR TO GBL DICT FROM GBL VECTR ENTRY             23966000
         L     SETPTR,HIBYTE0           SET IT UP AND ADD TO GBL        23967000
         A     SETPTR,GDSTRT            DICT BASE ADDR                  23968000
         B     ALLCOM                   GO TO COMMON HANDLING           23969000
GBLERR   GOIF  REFFLAG,ON=REFERR         DIVERGE ON REFERENCE OR SET    23970000
SETERR   EQU   *                                                        23971000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    23972000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          23973000
         DC    AL1(SEV131,ERR131)       ERROR PARAMETERS                23974000
         B     DICTEXIT                 RETURN                          23975000
REFERR   EQU   *                                                        23976000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    23977000
         BALR  R9,R12                   MAKE ERROR STACK ENTRY          23978000
         DC    AL1(SEV132,ERR132)       ERROR PARAMETERS                23979000
DEADEXIT EQU   *                                                        23980000
         SR    R11,R11                  SET UP SETA/SETB DEFAULT        23981000
         CLI   VFLAG,JTMSVC             SET IF SETA OR SETB REFERENCE   23982000
         BL    DICTEXIT                 RETURN DIRECTLY IF SO           23983000
         LA    R11,=9X'00'              SET UP DEFAULT FOR SETC REFER   23984000
         B     DICTEXIT                 RETURN                          23985000
         DROP  PARMA                                                    23986000
         EJECT                                                          23987000
*LCLDICTR/LCLDICTS - THIS ROUTINE IS CALLED WHEN THE VALUE OF A       * 23988000
*   LOCAL VARIABLE IS TO BE SET OR IS REFERENCED. ITS FUNCTION        * 23989000
*   IS TO LOCATE THE APPROPRIATE ENTRY IN THE LOCAL DICTIONARY        * 23990000
*   AND TO EITHER SET THE LOCAL DICTIONARY ENTRY TO A SPECIFIED       * 23991000
*   VALUE (ENTRY A 'LCLDICTS') OR GET THE VALUE OF THE LOCAL          * 23992000
*   DICTIONARY ENTRY FOR THE GENERATOR (ENTRY AT 'LCLDICTR').         * 23993000
*                           * ENTRY AT LCLDICTS *                     * 23994000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 23995000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 23996000
*                FOLLOWED BY THE EFFECTIVE SUBSCRIPT (2 BYTES)        * 23997000
*              - SETA VARIABLE, VALUE TO BE ASSIGNED IN R11           * 23998000
*                SETB VARIABLE, ZERO VALUE IN R11 TO SET VARIABLE OFF * 23999000
*                               NON-ZERO VALUE IN R11 TO SET VARIABLE * 24000000
*                                       ON                            * 24001000
*                SETC VARIABLE, POINTER TO CHARACTER STRING TO BE     * 24002000
*                                       ASSIGNED IN R11               * 24003000
*        OUTPUT - NONE.                                               * 24004000
*                           * ENTRY AT LCLDICTR *                     * 24005000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 24006000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 24007000
*                FOLLOWED BY THE EFFECTIVE SUBSCRIPT (2 BYTES)        * 24008000
*        OUTPUT - SETA VARIABLE, VALUE OF VARIABLE IN R11             * 24009000
*                 SETB VARIABLE, ZERO VALUE IN R11 IF VARIABLE OFF    * 24010000
*                                NON-ZERO VALUE IN R11 IF VARIABLE ON * 24011000
*                 SETC VARIABLE, POINTER TO CHARACTER STRING IN R11   * 24012000
*                                                                     * 24013000
LCLDICTR EQU   *                                                        24014000
         SET   REFFLAG,ON               INDICATE REFERENCE ENTRY        24015000
         B     LCOM                     CONTINUE AT LOCAL COMMON        24016000
LCLDICTS EQU   *                                                        24017000
         SET   REFFLAG,OFF              INDICATE SET ENTRY              24018000
LCOM     EQU   *                                                        24019000
         SET   GBLCALL,OFF              INDICATE LOCAL ENTRY            24020000
         L     SETPTR,CURRLOCL          PICK UP CURRENT LCL DICT PTR    24021000
         USING VREF,PARMA                                               24022000
         MVC   HIBYTE0+(L'HIBYTE0-L'VPNT)(L'VPNT),VPNT                 X24023000
               PICK UP PTR TO LCL DICT ENTRY FROM TEXT                  24024000
         A     SETPTR,HIBYTE0           ADD TO DICT BASE                24025000
ALLCOM   EQU   *                                                        24026000
         TM    VSUBS,BIT0               SEE IF DEAD TERM                24027000
         BNZ   DEADTERM                 BRANCH IF SO                    24028000
         MVC   JHWORD1,VSUBS            GET SUBSCRIPT FIELD FROM TEXT   24029000
         LH    PAIRE,JHWORD1            PICK IT UP FOR CALCULATION      24030000
         LTR   PAIRE,PAIRE              TEST FOR ZERO SUBSCRIPT         24031000
         BZ    TYPETEST                 BRANCH IF ZERO                  24032000
         BCTR  PAIRE,D0                 ADJUST THE SUBSCRIPT            24033000
TYPETEST CLI   VFLAG,JTMSVB             TEST FOR SET VARIABLE TYPE      24034000
         BL    TYPEA                    BRANCH IF FLAG FOR A-TYPE       24035000
         CLI   VFLAG,JTMSVC             TEST FOR TYPE AGAIN             24036000
         BNL   TYPEC                    BRA CH IF FLAG FOR C-TYPE       24037000
         SRDL  PAIRE,D3                 DIVIDE SETB SUBSCRIPT BY 8      24038000
         SRL   PAIRO,D29                GET THE REMAINDER               24039000
         LA    WORK1,BIT0               INSERT A BIT FOR MASK GENERAT   24040000
         SRL   WORK1,D0(PAIRO)          SHIFT BY REMAINDER FOR MASK     24041000
         ALR   SETPTR,PAIRE             PUT PTR TO REQUIRED ENTRY       24042000
         USING SETBNTRY,SETPTR                                          24043000
         GOIF  REFFLAG,ON=REFSETB       BRANCH IF VARB REFERENCE        24044000
         LTR   PARMB,PARMB              TEST FOR CONDITION TO BE SET    24045000
         BZ    SETBOFF                  BRANCH IF SET TO ZERO           24046000
         EX    WORK1,SETONE             SET IT ON USING OR MASK         24047000
         B     DICTEXIT                 GO TO COMMON EXIT               24048000
SETBOFF  LA    WORK1,D1(,WORK1)         INCREMENT OR MASK BY ONE AND    24049000
         LCR   WORK1,WORK1              DEVELOP AND MASK                24050000
         EX    WORK1,SETZERO            SET IT OFF USING AND MASK       24051000
         B     DICTEXIT                 GO TO COMMON EXIT               24052000
REFSETB  EX    WORK1,TESTINST           TEST IF SETB ON                 24053000
         BO    SETBON                   BRANCH IF ON                    24054000
         SR    PARMB,PARMB              INDICATE SETB OFF TO GENERATOR  24055000
         B     DICTEXIT                 GO TO COMMON EXIT               24056000
SETBON   LA    PARMB,D1                 INDICATE SETB ON TO GENERATOR   24057000
         B     DICTEXIT                 GO TO COMMON EXIT               24058000
TESTINST TM    SETBVAL,D0               EXECUTED SETB VARB TEST         24059000
SETONE   OI    SETBVAL,D0               EXECUTED TURN-ON FOR SETB VARB  24060000
SETZERO  NI    SETBVAL,D0               EXECUTED TURN-OFF FOR SETB VARB 24061000
DEADTERM GOIF  REFFLAG,OFF=DICTEXIT,    IGNORE ATTEMPT TO SET VARIABLE X24062000
               ELSE=DEADEXIT            GET DEFAULT (NULL) ON REFERENCE 24063000
TYPEA    EQU   *                                                        24064000
         SLL   PAIRE,D2                 MULTIPLY SUBSCRIPT BY 4         24065000
         ALR   SETPTR,PAIRE             DEVELOP PTR TO ARRAY ENTRY      24066000
         USING SETANTRY,SETPTR                                          24067000
         GOIF  REFFLAG,ON=REFSETA       BRANCH IF VARB NOT TO BE SET    24068000
         ST    PARMB,JFWORD1            STORE VALUE FROM GENERATOR      24069000
         MVC   SETAVAL,JFWORD1          INSERT INTO DICT ENTRY          24070000
         B     DICTEXIT                 GO TO COMMON EXIT               24071000
REFSETA  MVC   JFWORD1,SETAVAL          GET DICT ENTRY                  24072000
         L     PARMB,JFWORD1            PICK IT UP FOR GENERATOR        24073000
         B     DICTEXIT                 GO TO COMMON EXIT               24074000
TYPEC    EQU   *                                                        24075000
         MH    PAIRE,=H'9'              MULTIPLY SUBSCRIPT BY 9         24076000
         ALR   SETPTR,PAIRE             DEVELOP PTR TO ARRAY ENTRY      24077000
         LR    DICTPTR,SETPTR           PRESERVE ORIGINAL DICT PTR      24078000
         CLI   D0(DICTPTR),J8           SEE IF SETC EXTENDED            24079000
         BNH   REFCHEK                  BRANCH IF NOT                   24080000
         MVC   HIBYTE0+D1(D3),D6(SETPTR) PICK UP PTR TO EXTENSION ENTRY 24081000
         GOIF  GBLCALL,ON=GETGBLEX      BRANCH IF GLOBAL EXTENSION      24082000
         L     SETPTR,HIBYTE0           PICK UP DISPLACEMENT            24083000
         A     SETPTR,CURRLOCL          COMPUTE PTR TO LOCAL EXTENSION  24084000
REFCHEK  GOIF  REFFLAG,ON=REFSETC       BRANCH IF SETC REFERENCE ONLY   24085000
         SR    PAIRO,PAIRO              CLEAR REG FOR EXTENSION CALCS   24086000
         IC    PAIRO,D0(,PARMB)         PICK UP STRING LENGTH           24087000
         L     PAIRE,=F'-16'            SET UP INITIAL MASK             24088000
         AR    PAIRO,PAIRO              SHIFT LENGTH LEFT ONE           24089000
         NR    PAIRO,PAIRE              DROP OFF LOW ORDER FOUR BITS    24090000
HSHLP    LR    SETLEN,PAIRO             PRESERVE CURRENT LENGTH         24091000
         AR    PAIRE,PAIRE              SHIFT MASK LEFT ONE             24092000
         NR    PAIRO,PAIRE              AND TO GET NEXT EXTENSION LNGT  24093000
         BNZ   HSHLP                    RETRY IF NOT LARGER THAN STRING 24094000
         CLI   D0(DICTPTR),J8           SEEIF ENTRY EXTENDED            24095000
         BH    EXTEST                   IF YES, LOOK AT EXTENSION       24096000
         CLI   D0(PARMB),J8             SEE IF SET VALUE WILL FIT       24097000
         BNH   PUTSET                   BRANCH IF IT WILL FIT           24098000
         B     TPCHEK                   GO TO EXTEND DICTIONARY ENTRY   24099000
EXTEST   CLC   D0(D1,DICTPTR),D0(PARMB) SEE IF SET VALUE WILL FIT       24100000
         BNL   PUTSET                   BRANCH IF IT WILL FIT           24101000
TPCHEK   EQU   *                                                        24102000
         GOIF  GBLCALL,ON=GBLEXTND      BRANCH IF GLOBAL EXTENSION REQD 24103000
         CL    SETLEN,SPACEAE           SEE IF ROOM IS AVAILABLE        24104000
         BNL   OVERLAP9                 BRANCH IF NOT                   24105000
         L     SETPTR,SPACEAL           SET UP PTR TO EXTENSION ENTRY   24106000
         LR    WORK1,SETPTR             SET UP EXTENSION BASE ADDR      24107000
         S     WORK1,CURRLOCL           COMPUTE DISPL TO LCL ENTRY      24108000
         ST    WORK1,JFWORD1            SAVE TEMPORARILY                24109000
         MVC   D6(D3,DICTPTR),JFWORD1+D1 INSERT IN ORIGINAL DICT ENTRY  24110000
         L     SKDCTPTR,CURRDICT        SET UP PTR TO DICT HDR          24111000
         USING SKDCTHDR,SKDCTPTR                                        24112000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKLDLNG)(L'SKLDLNG),SKLDLNG        X24113000
               PICK UP CURRENT LOCAL DICTIONARY LENGTH                  24114000
         L     WORK1,HIBYTE0            SET UP TO ADD EXTENSION ENTRY   24115000
         AR    WORK1,SETLEN             ADJUST FOR EXTENSION            24116000
         ST    WORK1,JFWORD1            SAVE TEMPORARILY AND REPLACE    24117000
         MVC   SKLDLNG,JFWORD1+(L'JFWORD1-L'SKLDLNG) IN DICT HEADER     24118000
         LA    WORK1,D0(SETLEN,SETPTR)  DEVELOP NEW LOW SPACE ADDR      24119000
         ST    WORK1,SPACEAL            SAVE NEW LOW SPACE ADDR         24120000
         L     WORK2,SPACEAH            PICK UP HIGH SPACE ADDR         24121000
         SR    WORK2,WORK1              SUBTRACT LOW SPACE ADDR         24122000
         ST    WORK2,SPACEAE            SAVE NEW SPACE EXTENT           24123000
SETMAX   BCTR  SETLEN,D0                GET EXTENSION LENGTH -1         24124000
         STC   SETLEN,D0(,DICTPTR)      PUT IN PRIMARY DICT ENTRY       24125000
         USING SETCNTRY,SETPTR                                          24126000
PUTSET   IC    SETLEN,D0(,PARMB)        PICK UP STRING LENGTH           24127000
         EX    SETLEN,MOVEINST          MOVE STRING INTO SETC ENTRY     24128000
         B     DICTEXIT                 RETURN                          24129000
GETGBLEX CLC   HIBYTE0,=D'0'            SEE IF EXTENDED SYSPARM         24130000
         BZ    GGX1                     BRANCH IF IT IS                 24131000
         L     SETPTR,FREEEND           PICK UP EXTENSION AREA BASE     24132000
         S     SETPTR,HIBYTE0           COMPUTE PTR TO GLOBAL EXTENSION 24133000
         B     REFCHEK                  RETURN TO MAIN FLOW             24134000
REFSETC  LR    PARMB,SETPTR             GET PTR FOR GENERATOR TO SETC   24135000
         B     DICTEXIT                 RETURN                          24136000
GGX1     L     PARMB,JSYSPARM           PICK UP SYSPARM POINTER         24137000
         B     DICTEXIT                 RETURN                          24138000
OVERLAP8 EQU   *                                                        24139000
OVERLAP9 EQU   *                                                        24140000
         BAL   R2,ERRRTN                 GO TO LOG ERROR AND FIX COUNT  24141000
         GOIF  FLUSH2,OFF=MACRPOP,      BRANCH IF NO OVERLAP FOUND     X24142000
               ELSE=DICTEXIT            IN OPEN CODE                    24143000
GBLEXTND CL    SETLEN,SPACEAE           SEE IF ENOUGH ROOM IN AREA      24144000
         BNL   OVERLAP8                 BRANCH IF NOT                   24145000
         L     SETPTR,SPACEAH           PICK UP AREA HIGH ADDRESS       24146000
         SR    SETPTR,SETLEN            ADJUST FOR STRING BYTES         24147000
         ST    SETPTR,SPACEAH           SAVE NEW AREA HIGH ADDRESS      24148000
         LR    WORK1,SETPTR             GET NEW AREA HIGH ADDRESS       24149000
         S     WORK1,SPACEAL            SUBTRACT AREA LOW ADDRESS       24150000
         ST    WORK1,SPACEAE            SAVE NEW AREA LENGTH            24151000
         L     WORK1,FREEEND            GET EXTENSION BASE PTR          24152000
         SR    WORK1,SETPTR             COMPUTE DISPLACEMENT            24153000
         ST    WORK1,JFWORD1            SAVE TEMPORARILY AND INSERT     24154000
         MVC   D6(D3,DICTPTR),JFWORD1+D1 IN ORIGINAL DICTIONARY ENTRY   24155000
         B     SETMAX                   GO TO COMPLETE SET              24156000
MOVEINST MVC   SETCLEN(D0),D0(PARMB)    EXECUTED ASSIGN FOR SETC VARB   24157000
         DROP  PARMA                                                    24158000
         DROP  SKDCTPTR                                                 24159000
         DROP  SETPTR                                                   24160000
         EJECT                                                          24161000
*PARMTBLR - THIS ROUTINE IS CALLED WHEN THE VALUE OF A PARAMETER IS   * 24162000
*   REFERENCED. ITS FUNCTION IS TO LOCATE THE APPROPRIATE ENTRY IN    * 24163000
*   THE PARAMETER TABLE THROUGH THE APPROPRIATE VECTOR, KEYWORD OR    * 24164000
*   POSITIONAL, AND TO GET THE VALUE OF THE PARAMETER TABLE ENTRY     * 24165000
*   FOR THE GENERATOR.                                                * 24166000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 24167000
*                FOLLOWED BY THE VECTOR POINTER (3 BYTES)             * 24168000
*                FOLLOWED BY PADDING (2 BYTES) IF NOT A SUBOPERAND    * 24169000
*                REFERENCE OR BY SUBOPERAND NUMBER (2 BYTES) IF A     * 24170000
*                SUBOPERAND REFERENCE                                 * 24171000
*        OUTPUT - A POINTER IN R11 TO THE PARAMETER TABLE ENTRY       * 24172000
*                                                                     * 24173000
PARMTBLR EQU   *                                                        24174000
         USING PARMREF,PARMA                                            24175000
         TM    PARMSUB,BIT0             LOOK FOR DEAD TERM FLAG         24176000
         BO    PTR1X                    BRANCH IF FOUND                 24177000
         CLI   PARMFLG,JTMKPAR          SEE IF KEYWORD REFERENCE        24178000
         BNE   PTR1                     BRANCH IF NOT                   24179000
         L     PARAMPTR,CURRKEYD        GET POINTER TO KEYWORD VECTOR   24180000
         B     PTR2                     GO JOIN MAIN FLOW               24181000
PTR1     LH    WORK1,NOFSYSLS           PICK UP POSITIONAL COUNT        24182000
         MH    WORK1,=H'3'              GET MAXIMUM VECTOR DISPL        24183000
         ST    WORK1,JFWORD1            SET ASIDE FOR PTR COMPARE       24184000
         CLC   PARMPNT,JFWORD1+(L'JFWORD1-L'PARMPNT) COMPARE DISPLS     24185000
         BNH   PTR0                     BRANCH IF PARAM IN RANGE        24186000
PTR1X    LA    PARMB,=AL1(OPNDOMT,JO,J0,J1,J0,J0,X'60',J0)  OMITTED     24187000
         B     DICTEXIT                 RETURN TO GENERATOR             24188000
PTR0     L     PARAMPTR,CURRPOST        GET POINTER TO POSITIONAL VCTR  24189000
PTR2     EQU   *                                                        24190000
         MVC   HIBYTE0+(L'HIBYTE0-L'PARMPNT)(L'PARMPNT),PARMPNT        X24191000
               PICK UP PTR TO PARAM VECTOR SLOT                         24192000
         S     PARAMPTR,HIBYTE0         DEVELOP PTR TO VECTOR ENTRY     24193000
         MVC   HIBYTE0+D1(D3),D0(PARAMPTR) PICK UP VECTOR ENTRY         24194000
         L     PARMB,HIBYTE0            GET FOR PARAM TBL REFERENCE     24195000
         A     PARMB,CURRPARM           DEVELOP PTR TO PARAM ENTRY      24196000
         CLC   PARMPAD,=D'0'            SEE IF SUBOPERAND REFERENCE     24197000
         BZ    DICTEXIT                 IF NOT, RETURN                  24198000
         MVC   JHWORD1,PARMSUB          PICK UP SUBOPERAND NUMBER       24199000
         TM    D0(PARMB),OPNDSUB        SEE IF SUBLIST BEING REFER'D    24200000
         BO    PTR4                     IF SO, PROCEED                  24201000
         CLC   JHWORD1,=H'1'            SEE IF SUBOPERAND 1 REFER'D     24202000
         BE    DICTEXIT                 IF SO, RETURN WHOLE PARAM PTR   24203000
         B     PTR1X                    GO RETURN DEFAULT               24204000
PTR4     CLC   JHWORD1,D6(PARMB)        SEE IF SUBOPERAND IN RANGE      24205000
         BH    PTR1X                    GO RETURN DEFAULT               24206000
         LH    WORK1,JHWORD1            GET SUBOPERAND NUMBER           24207000
         MH    WORK1,=H'3'              CONVERT TO VECTOR INDEX         24208000
         LR    WORK2,PARMB              GET PARAM ENTRY PTR FOR CALC    24209000
         MVC   HIBYTE0+D1(D3),D10(PARMB) PICK UP SUBLIST VECTOR PTR     24210000
         A     WORK2,HIBYTE0            GET PTR TO STRT OF SUBL VCTR    24211000
         SR    WORK2,WORK1              GET PTR TO SUBLIST VECTR ENTRY  24212000
         MVC   HIBYTE0+D1(D3),D0(WORK2) PICK UP SUBLIST VECTOR ENTRY    24213000
         A     PARMB,HIBYTE0            DEVELOP PTR TO SUBOPERAND       24214000
         B     DICTEXIT                 RETURN                          24215000
         DROP  PARMA                                                    24216000
         EJECT                                                          24217000
*SEQSYMBR - THIS ROUTINE IS CALLED WHEN A REFERENCE TO A SEQUENCE     * 24218000
*   SYMBOL IS ENCOUNTERED. ITS FUNCTION IS TO LOCATE THE APPROPRIATE  * 24219000
*   ENTRY IN THE SEQUENCE SYMBOL REFERENCE DICTIONARY AND TO GET      * 24220000
*   THE NOTE/POINT ADDRESS IN THE SEQUENCE SYMBOL REFERENCE           * 24221000
*   DICTIONARY ENTRY FOR THE GENERATOR.                               * 24222000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 24223000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 24224000
*        OUTPUT - A POINTER IN R11 TO THE NOTE/POINT ADDRESS          * 24225000
*                                                                     * 24226000
SEQSYMBR EQU   *                                                        24227000
         L     SKDCTPTR,CURRSEQS        GET PTR TO SEQ SYMB REF DICT    24228000
         USING SEQREF,PARMA                                             24229000
         USING JTEXT,R5                                         OX00218 24230000
         MVC   HIBYTE0+(L'HIBYTE0-L'SEQPNT)(L'SEQPNT),SEQPNT           X24231000
               GET DISPL TO SEQ SYMB REF DICT ENTRY                     24232000
         A     SKDCTPTR,HIBYTE0         DEVELOP PTR TO DICT ENTRY       24233000
         CLC   D0(D8,SKDCTPTR),=D'0'    LOOK FOR UNDEFINED SEQ SYM      24234000
         BZ    DICTEXIT                 RETURN DIRECTLY IF THE CASE     24235000
         GOIF  JERR,OFF=NOERREC         ANY ERROR IN REC        OX00218 24236000
ERREC    JGETL FILE=FILE1               YES, GET ERROR REC      OX00218 24237000
         LR    R5,R11                   LOAD BASE FOR TEXT      OX00218 24238000
         GOIF  JTERROR,NE=NOERREC       IS THE REC ERROR REC    OX00218 24239000
         JPUTM FILE=FILE2,ADDR=(R5)     YES,PUT IT OUT          OX00218 24240000
         B     ERREC                    SEE IF MORE ERROR REC   OX00218 24241000
NOERREC  EQU   *                        NO MORE OR NO ERROR REC OX00218 24242000
         JPOINT FILE=FILE1,ADDR=(SKDCTPTR),NEXT=GET POSITION TEXT FILE  24243000
         CLI   *,BITFF                  SET COND CODE FOR DEF SEQ SYM   24244000
         B     DICTEXIT                 RETURN TO GENERATOR             24245000
         DROP  PARMA                                                    24246000
         EJECT                                                          24247000
*ORDSYMBR - THIS ROUTINE IS CALLED WHEN A REFERENCE TO AN ORDINARY    * 24248000
*   SYMBOL IS ENCOUNTERED. ITS FUNCTION IS TO LOCATE THE APPROPRIATE  * 24249000
*   ENTRY IN THE ORDINARY SYMBOL REFERENCE DICTIONARY AND TO GET      * 24250000
*   THE TYPE, LENGTH, AND SCALE ATTRIBUTES OF THE ORDINARY SYMBOL     * 24251000
*   IN THE ORDINARY SYMBOL REFERENCE DICTIONARY ENTRY FOR THE         * 24252000
*   GENERATOR.                                                        * 24253000
*        INPUT - A POINTER IN R10 TO THE TEXT FLAG (1 BYTE)           * 24254000
*                FOLLOWED BY THE DICTIONARY POINTER (3 BYTES)         * 24255000
*                FOLLOWED BY 2 BYTES OF PADDING                       * 24256000
*        OUTPUT - A POINTER IN R11 TO THE TYPE ATTRIBUTE (1 BYTE)     * 24257000
*                 FOLLOWED BY THE LENGTH ATTRIBUTE (2 BYTES)          * 24258000
*                 FOLLOWED BY THE SCALE ATTRIBUTE (2 BYTES)           * 24259000
*                 ATTRIBUTES                                          * 24260000
*                                                                     * 24261000
ORDSYMBR EQU   *                                                        24262000
         CLC   OSRDSTRT,=D'0'           SEE IF ANY OSRD PRESENT         24263000
         BZ    OSRDBAD                  BRANCH IF NONE (OVERFLOWED)     24264000
         USING ORDREF,PARMA                                             24265000
         MVC   HIBYTE0+(L'HIBYTE0-L'ORDPNT)(L'ORDPNT),ORDPNT           X24266000
               PICK UP DICTIONARY POINTER FROM META-TEXT                24267000
         L     PARMB,HIBYTE0            GET IT FOR POINTER CALCULATION  24268000
         A     PARMB,OSRDSTRT           DEVELOP PTR TO DICT ENTRY       24269000
         BCTR  PARMB,D0                 BACK UP PTR FOR GEN USEAGE      24270000
         B     DICTEXIT                 RETURN TO GENERATOR             24271000
OSRDBAD  LA    PARMB,=AL1(OPNDSTR,JU,J0,J0,J0,J0) RETURN DEFAULT ATTRS  24272000
         B     DICTEXIT                 RETURN                          24273000
         DROP  PARMA                                                    24274000
         EJECT                                                          24275000
*MACRFINI - THIS ROUTINE IS CALLED WHEN THE EXPANSION OF A MACRO      * 24276000
*   INSTRUCTION IS COMPLETED. ITS FUNCTION IS TO RESTORE THE          * 24277000
*   DICTIONARY FOR THE NEXT HIGHER LEVEL TEXT SEGMENT AS THE CURRENT  * 24278000
*   DICTIONARY AND TO REPOSITION THE TEXT FILE TO THE RESUMPTION      * 24279000
*   POINT IN THE NEXT HIGHER LEVEL TEXT SEGMENT.                      * 24280000
*        INPUT - NONE.                                                * 24281000
*        OUTPUT - NONE.                                               * 24282000
*                                                                     * 24283000
MACRFINI EQU   *                                                        24284000
MACRPOP  EQU   *                                                        24285000
         L     SKDCTPTR,CURRDICT        GET CURRENT DICT PTR            24286000
         USING SKDCTHDR,SKDCTPTR                                        24287000
MACRPOS  EQU   *                                                        24288000
         JPOINT FILE=FILE1,ADDR=SKNPNLT,NEXT=GET REPOSITION TEXT FILE   24289000
         MVC   CURRDICT,SKADNLD         SET UP NEW CURRENT DICT PTR     24290000
         L     SKDCTPTR,CURRDICT        POINT TO SKEL DICT HDR          24291000
         MVC   ACTRCNT,SKACTRV          RESTORE ACTR COUNT              24292000
         MVC   NOFSYSLS,SKNOFSLS        RESTORE POSITIONAL PARAM COUNT  24293000
         BAL   RETURN,PTRINIT           REESTABLISH DICTIONARY POINTERS 24294000
         B     DICTEXIT                 RETURN TO GENERATOR             24295000
         DROP  SKDCTPTR                                                 24296000
         EJECT                                                          24297000
*                                                                       24298000
* THIS SUBROUTINE PERFORMS A BUFFERED READ FROM ANY FILE.               24299000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES                       24300000
*                   PHASENTR                                            24301000
*                   PROTOEND                                            24302000
*                                                                       24303000
BUFREAD  EQU   *                                                        24304000
         ST    RTNLNK,REGSAVEA          PRESERVE LINK REGISTER          24305000
         LM    R3,R4,PIOPARMB           PICK UP I/O PARAMETERS          24306000
BRD1     CLR   R3,R5                    SEE IF RECORD LESS THAN MAX     24307000
         BH    BRD4                     BRANCH IF NOT                   24308000
         CH    R3,=AL2(MINRECSZ)        SEE IF BLOCK OVER MINIMUM       24309000
         BNL   BRD11                    BRANCH IF MORE OR JUST ENUF     24310000
         LA    R3,MINRECSZ              IF NOT, USE MINIMUM SIZE        24311000
BRD11    STH   R3,PIOPARMC              SET UP RECORD LENGTH            24312000
         SR    R3,R3                    INDICATE LAST READ              24313000
BRD2     JREAD FILE=(R6),PARM=PIOPARMA  READ RECORD FROM PROPER FILE    24314000
         JCHECK FILE=(R6)               CHECK THE READ                  24315000
         LTR   R3,R3                    SEE IF READ COMPLETE            24316000
         BNZ   BRD3                     DKIP AHEAD IF NOT               24317000
         L     RTNLNK,REGSAVEA          RESTORE LINK REGISTER           24318000
         BR    RTNLNK                   RETURN TO CALLING ROUTINE       24319000
BRD3     EQU   *                                                        24320000
         AR    R4,R5                    DEVELOP PTR TO NEXT I/O AREA    24321000
         ST    R4,PIOPARMA              PUT PTR IN I/O CONTROL AREA     24322000
         B     BRD1                     GO SET UP NEW READ LENGTH       24323000
BRD4     STH   R5,PIOPARMC              SET UP MAXIMUM RECORD LENGTH    24324000
         SR    R3,R5                    ADJUST READ LENGTH              24325000
         B     BRD2                     GO READ NEXT RECORD             24326000
*                                                                       24327000
* THIS SUBROUTINE MOVES DATA TO AN AREA POINTED TO BY WORKB FROM        24328000
*        AN AREA POINTED TO BY WORKA USING THE LENGTH IN WORK1.         24329000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES -                     24330000
*        PHASENTR, PROTOEND, MACRPOST                                   24331000
*                                                                       24332000
MOVLOP1  MVC   D0(D256,WORKB),D0(WORKA) MOVE BLOCK OF 256 BYTES         24333000
         LA    WORKA,D256(,WORKA)       ADJUST SOURCE POINTER           24334000
         LA    WORKB,D256(,WORKB)       ADJUST DESTINATION POINTER      24335000
MOVLOP   SH    WORK1,=H'256'            SEE IF ONE MOVE WILL DO IT      24336000
         BP    MOVLOP1                  BRANCH IF NOT                   24337000
         AH    WORK1,=H'255'            GET MOVE LENGTH REMAINING       24338000
         EX    WORK1,MOVLOP2            MOVE REMAINING SEGMENT          24339000
         BR    RETURN                   RETURN                          24340000
MOVLOP2  MVC   D0(D0,WORKB),D0(WORKA)   EXECUTED MOVE - 256 OR LESS     24341000
*                                                                       24342000
* THIS SUBROUTINE LOGS THE OVERLAP ERROR MESSAGE AND DECREMENTS THE     24343000
*        MACRO NEST COUNT. IT ADJUSTS THE 'INMACRO' SWITCH IF           24344000
*        NECESSARY.                                                     24345000
*                                                                       24346000
ERRRTN   EQU   *                                                        24347000
         L     R12,=A(LOGERR01)         GET PTR TO ERROR LOGGING RTN    24348000
         BALR  R9,R12                   GO MAKE ERROR STACK ENTRY       24349000
         DC    AL1(SEV89,ERR89)         ERROR PARAMETERS                24350000
         L     R9,MACROLVL              GET CURRENT MACRO NEST COUNT    24351000
         GOIF  (R9),NOTZERO=ERRRTN0     BRANCH IF NOT OPEN CODE         24352000
         SET   FLUSH2,ON                INDICATE TEXT TO BE FLUSHED     24353000
         BR    R2                       EXIT DIRECTLY                   24354000
ERRRTN0  EQU   *                                                        24355000
         BCT   R9,ERRRTN1               DECREMENT BY ONE. IF ZERO,      24356000
         SET   INMACRO,OFF              INDICATE POPPED TO OPEN CODE    24357000
ERRRTN1  ST    R9,MACROLVL              SAVE ADJUSTED MACRO NEST COUNT  24358000
         BR    R2                       RETURN                          24359000
*                                                                       24360000
* THIS SUBROUTINE SETS UP IN THE COMMON AREA THE POINTERS TO THE        24361000
*        VARIOUS GENERATION-TIME DICTIONARY ELEMENTS. THE POINTERS      24362000
*        ARE COMPUTED FROM VALUES IN THE DICTIONARY HEADER.             24363000
*        IT IS CALLED BY THE FOLLOWING ROUTINES -                       24364000
*        MACRFINI,PHASENTR,PROTOEND                                     24365000
*                                                                       24366000
PTRINIT  EQU   *                                                        24367000
         L     SKDCTPTR,CURRDICT        GET PTR TO DICT FOR INIT'ATION  24368000
         LR    WORK1,SKDCTPTR           GET COPY FOR CALCULATION        24369000
         USING SKDCTHDR,SKDCTPTR                                        24370000
         LA    WORK1,SKHDREND-SKDCTHDR(,WORK1) GET PTR TO GBL VECTOR    24371000
         ST    WORK1,CURRGLBL           SET ASIDE FOR GLBL REFERENCES   24372000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKSRDPT)(L'SKSRDPT),SKSRDPT        X24373000
               GET LENGTH OF GLOBAL VECTOR FROM DICT HEADER             24374000
         A     WORK1,HIBYTE0            CALCULATE PTR TO SEQ SYMB DICT  24375000
         ST    WORK1,CURRSEQS           SET ADIDE FOR SEQ SYMB REFERS   24376000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKLDADR)(L'SKLDADR),SKLDADR        X24377000
               GET LENGTH OF SEQ SYMB REFERENCE DICT FROM DICT HDR      24378000
         A     WORK1,HIBYTE0            CALCULATE PTR TO LOCAL DICT     24379000
         ST    WORK1,CURRLOCL           SET ASIDE FOR LOCAL REFERS      24380000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKLDLNG)(L'SKLDLNG),SKLDLNG        X24381000
               GET LENGTH OF LOCAL DICT FROM DICT HEADER                24382000
         A     WORK1,HIBYTE0            CALCULATE PTR TO END OF SPACE   24383000
         ST    WORK1,SPACEAL            SET ASIDE FOR FREE SPACE LOW    24384000
         LCR   WORK1,WORK1              COMPLEMENT FOR CALCULATION      24385000
         A     WORK1,SPACEAH            ADD FREE SPACE HIGH             24386000
         ST    WORK1,SPACEAE            SAVE FREE SPACE EXTENT          24387000
         LR    WORK1,SKDCTPTR           RE-GET CALCULATION BASE         24388000
         SH    WORK1,=H'3'              GET PTR TO POSITIONAL VECTOR    24389000
         ST    WORK1,CURRPOST           SAVE FOR POSIT PARAM REFERS     24390000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKKVADR)(L'SKKVADR),SKKVADR        X24391000
               GET LENGTH OF POSITIONAL VECTOR FROM DICT HEADER         24392000
         S     WORK1,HIBYTE0            GET PTR TO KEYWORD VECTOR       24393000
         ST    WORK1,CURRKEYD           SET ASIDE FOR KEYWORD REFERS    24394000
         MVC   HIBYTE0+(L'HIBYTE0-L'SKMPADR)(L'SKMPADR),SKMPADR        X24395000
               PICK UP PARAM TBL LENGTH FROM DICT HEADER                24396000
         S     SKDCTPTR,HIBYTE0         CALCULATE PTR TO PARAM TABLE    24397000
         ST    SKDCTPTR,CURRPARM        SET ASIDE FOR PARAM REFERS      24398000
         BR    RETURN                   RETURN                          24399000
         DROP  SKDCTPTR                                                 24400000
*                                                                       24401000
* THIS SUBROUTINE INITIALIZES THE LOCAL DICTIONARY SPACE TO ZEROES.     24402000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES -                     24403000
*        PHASENTR,PROTOEND                                              24404000
*                                                                       24405000
LOCLINIT EQU   *                                                        24406000
         LR    R12,RETURN               PRESERVE RETURN REGISTER        24407000
         L     WORKA,CURRLOCL           GET PTR TO START OF LOCAL DICT  24408000
         LA    WORKB,D1(,WORKA)         GET PTR TO SINK LOCATION        24409000
         MVI   D0(WORKA),J0             INSERT ZERO TO BE PROPAGATED    24410000
         BAL   RETURN,MOVLOP            GO TO CLEAR LOCAL DICT SPACE    24411000
         BR    R12                      RETURN                          24412000
*                                                                       24413000
* THIS SUBROUTINE FETCHES A SKELETON DICTIONARY INTO THE FREE           24414000
*        SPACE. THE I/O PARAMETERS ARE SET UP IN PIOPARMA AND           24415000
*        PIOPARMB, AND R10 POINTS TO THE MDV ENTRY.                     24416000
*        IT IS CALLED FROM THE FOLLOWING ROUTINES-                      24417000
*        PHASENTR,PROTOEND                                              24418000
*                                                                       24419000
DCTFETCH EQU   *                                                        24420000
         ST    RETURN,REGSAVEB          SAVE LINK REGISTER              24421000
         USING MDVNTRY,PARMA                                            24422000
         LA    R11,MNPSD                GET PTR TO N/P ADDRESS          24423000
         JPOINT FILE=FILE1,ADDR=(R11),NEXT=READ POSITION TO DICTIONARY  24424000
         LH    R5,JMAXRL1               SET UP FILES BLOCK SIZE         24425000
         LA    R6,FILE1                 SET UP FILE INDICATOR           24426000
         BAL   RTNLNK,BUFREAD           LINK TO BUFFERED READ RTN       24427000
         L     RETURN,REGSAVEB          RESTORE LINK REGISTER           24428000
         BR    RETURN                   RETURN                          24429000
         DROP  PARMA                                                    24430000
         EJECT                                                          24431000
         LTORG                                                          24432000
         SPACE 3                                                        24433000
         JPATCH X3N00,E40               X3N PATCH AREA                  24434000
         END                                                            24435000
./ ADD NAME=IFNX5C                                                      24436000
* /* START OF SPECIFICATIONS ****                                       24437000
*02* PROCESSOR = ASSEMBLER                                              24438000
**** END OF SPECIFICATIONS ***/                                         24439000
         LCLC  &TBP                     TEXT BASE POINTER               24440000
         LCLC  &BAL                     LINK REGISTER                   24441000
         LCLC  &OPT                     OUTPUT POINTER                  24442000
         LCLC  &LEN                     FIELD LENGTH                    24443000
         LCLC  &SCR                     SCRATCH REGISTER                24444000
         LCLC  &SCH                     ALSO SCRATCH                    24445000
         LCLC  &COM                     PHASE WORK AREA POINTER         24446000
         LCLC  &IPT                     INPUT FIELD ADDRESS             24447000
         LCLC  &PRN                     PRINT BUFFER POINTER            24448000
         SPACE 5                                                        24449000
         GBLC  &COMPNM,&ASMID                                           24450000
         SPACE 5                                                        24451000
&SCR     SETC  'R1'                                                     24452000
&COM     SETC  'R7'                                                     24453000
&OPT     SETC  'R3'                                                     24454000
&IPT     SETC  'R4'                                                     24455000
&BAL     SETC  'R6'                                                     24456000
&TBP     SETC  'R5'                                                     24457000
&LEN     SETC  'R14'                                                    24458000
&PRN     SETC  'R2'                                                     24459000
&SCH     SETC  'R15'                                                    24460000
         SPACE 5                                                        24461000
         JHEAD 'ASSEMBLY PHASE - MAINLINE CONTROL - PROLOG',           X24462000
               PHASEID=X5C,                                            X24463000
               LEVEL=10                                                 24464000
*FUNCTION/OPERATION-                                                  * 24465000
*   THIS PHASE ACCEPTS THE MACRO GENERATION PHASE AND THE SYMBOL      * 24466000
*   RESOLUTION PHASE OUTPUT AND COMPLETES THE ASSEMBLY PROCESS.  THIS * 24467000
*   IS THE MAINLINE CONTROL FOR THE ASSEMBLY PHASE. CONTROL IS PASSED * 24468000
*   TO THE ASSEMBLY PHASE BY THE SYMBOL RESOLUTION INTERLUDE PHASE.   * 24469000
*   PHASE INITIALIZE ROUTINE IS CALLED TO ALLOCATE ALL OF THE NEC-    * 24470000
*   ESSARY WORK STORAGE AND BUFFERS, AND SET ANY REQUIRED ENTRY CON-  * 24471000
*   DITIONS. THE GET TEXT ROUTINE IS THEN CALLED TO BRING IN THE FIRST* 24472000
*   TEXT RECORD. CONTROL IS THEN PASSED TO THE APPROPIATE ROUTINES TO * 24473000
*   PERFORM THE ASSEMBLY FOR THAT RECORD. THE RECORD IS THEN OUTPUT   * 24474000
*   THROUGH THE PRINT AND PUNCH ROUTINE. THE GET TEXT ROUTINE IS      * 24475000
*   CALLED TO GET THE NEXT RECORD AND THE PROCESS IS REPEATED.        * 24476000
*                                                                     * 24477000
*ENTRY POINT-                                                         * 24478000
*        MLC100                                                       * 24479000
*INPUT-                                                               * 24480000
*   INTERNAL TEXT FILE FROM THE GENERATOR PHASE.                      * 24481000
*   RESOLVED SYMBOLS IN ORDER OF OCCURANCE FROM THE SYMBOL RESOLUTION * 24482000
*   PHASE.                                                            * 24483000
*                                                                     * 24484000
*OUTPUT-                                                              * 24485000
*   RELOCATABLE OBJECT TEXT TO THE PUNCH FILE.                        * 24486000
*   ASSEMBLY LISTINGS TO THE PRINT FILE.                              * 24487000
*   RELOCATION DICTIONARY ENTRIES TO THE POST PROCESSOR.              * 24488000
*   CROSS REFERENCE ENTRIES TO THE POST PROCESSOR.                    * 24489000
*   ERROR RECORDS TO THE DIAGNOSTIC PHASE.                            * 24490000
*                                                                     * 24491000
*EXTERNAL ROUTINES-                                                   * 24492000
*        TEXT GET                                                     * 24493000
*        ASSEMBLER OPCODE PROCESSOR                                   * 24494000
*        MACHINE OPCODE PROCESSOR                                     * 24495000
*                                                                     * 24496000
*EXITS, NORMAL-                                                       * 24497000
*   EXITS TO THE POST PROCESS PHASE.                                  * 24498000
*EXITS, ERROR-                                                        * 24499000
*   N/A                                                               * 24500000
*                                                                     * 24501000
*TABLES/WORK AREAS-                                                   * 24502000
*   THESE ARE ALLOCATED IN THE INITIALIZATION MODULE AND ARE          * 24503000
*   DESCRIBED THERE.                                                  * 24504000
*                                                                     * 24505000
*ATTRIBUTES-                                                          * 24506000
*   REFRESHABLE                                                       * 24507000
*                                                                     * 24508000
*NOTES-                                                               * 24509000
*   N/A                                                               * 24510000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - JCOX24511000
               MMON COPY CODE'                                          24512000
         COPY  JCOMMON                  INCLUDE COMMON DSECT            24513000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - JTEX24514000
               XT COPY CODE'                                            24515000
         COPY  JTEXT                                                    24516000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - X5CX24517000
               OM COPY CODE'                                            24518000
         COPY  X5COM                                                    24519000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - DSEX24520000
               CT10 DEFINITION (RSYMRCD)'                               24521000
DSECT10  DSECT                                                          24522000
         COPY  RSYMRCD                  GET DSECT10 DEFINITION          24523000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - POSX24524000
               T PROCESSOR RECORD DEFNS (BMDSECTS)'                     24525000
         COPY  BMDSECTS                 GET POST PROCESSOR RECORD DEFNS 24526000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - JERX24527000
               MSGCD COPY CODE'                                         24528000
         COPY  JERMSGCD                 DEFINE ERROR CODES AND SEVERITY 24529000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL'      24530000
         JCSECT (X5C00)                 INITIALIZE MODULE CSECT         24531000
* VS1 REL 3.1 CHANGES                                                   24532000
*C714000                                                       @OX02675 24533000
*A714500                                                       @OX10362 24534000
*A369000                                                       @OX08876 24535000
         JMODID ,                       CREATE OBJECT PHASE ID          24536000
*                            USINGS FOR-                                24537000
         USING JTEXT,&TBP               FIXED TEXT PART                 24538000
         USING JTEXTA,&IPT              VARIABLE TEXT PART              24539000
         USING X5COM,&COM               PHASE COMMON AREA               24540000
         USING DSECT10,R11              ESTABLISH DEFINITION FILE USING 24541000
         EJECT                                                          24542000
MLC100   JSAVE BASE=YES                 SAVE CALLING REGISTERS          24543000
         JENTRY (X5C01=MLC100)          DEFINE ENTRY                    24544000
         B     INIT                     INITIALIZE PHASE                24545000
MLC200   B     TEXTGET                  GO GET TEXT RECORD              24546000
MLC250   GOIF  JPRONLY,ON=MLC275        IS RECORD PRINT ONLY            24547000
         GOIF  JPSOP,OFF=MLC285         IS STATEMENT A PSEUDO OP?       24548000
         CLI   JTIOP1,JTERROR           IS IT AN ERROR RECORD?          24549000
         BE    MLC275                   BRANCH AROUND IF YES            24550000
         BAL   R6,GETDFN                GO GET NAME DEFINITION DATA     24551000
MLC275   JCALL ASMOP                    CALL ASSEMBLER OP ROUTINE       24552000
         B     MLC200                   GO GET NEXT RECORD              24553000
MLC285   BAL   R6,GETDFN                GO GET NAME DEFINITION DATA     24554000
         JCALL MACHOP                   CALL MACHINE OP ROUTINE         24555000
         B     MLC200                   GO GET NEXT TEXT RECORD         24556000
         JEXTRN (X5M01=MACHOP)          DEFINE MACHINE OP ENTRY         24557000
         JEXTRN (X5A01=ASMOP)           DEFINE ASSEMBLER OP ENTRY       24558000
         SPACE                                                          24559000
MLC900   JRETURN ,                      EXIT TO CONTROLLER              24560000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - PHAX24561000
               SE INITIALIZATION'                                       24562000
* INIT                                                                  24563000
*                                                                       24564000
*   THIS ROUTINE PERFORMS INITIALIZATION FOR THE ASSEMBLY PHASE         24565000
         SPACE                                                          24566000
INIT     JGETCORE   DBL=X5COMLEN        GET WORK STORAGE                24567000
         LR    &COM,R10                 LOAD BASE FOR COMMON            24568000
* INITIALIZE COMMON                                                     24569000
         XC    PRPU,PRPU                ZERO PRINT PUSH LEVEL COUNTER   24570000
         SET   PRDEFREQ,OFF             TURN OFF PRIOR DEFINITION REQ.  24571000
         XC    USINGT(USSL),USINGT      INITIALIZE USING TABLE          24572000
         MVI   USINGT+D6,X'0F'          IND END USING TABLE    @OX08876 24573000
         XC    LITPID,LITPID            INITIALIZE LITERAL POOL ID      24574000
         TS    SELFDEFN                 SET SELF DEFINITION FLAG ON     24575000
         XC    ELCTR(FLDEND-ELCTR),ELCTR  INITIALIZE TO ZERO            24576000
         MVI   JSEVER,D0                SET HIGH.SEV.CODE TO 0          24577000
         SET   XRFNO,ON                 TURN ON XREF SWITCH             24578000
         MVC   EESDI,JESDID             INITIALIZE ESDID                24579000
         LA    R1,TERMS                 INITIALIZE                      24580000
         ST    R1,ATPTR                   EVALUATION                    24581000
         LA    R1,RLIST                     WORK                        24582000
         ST    R1,ALPTR                       AREA                      24583000
         LA    R1,OPRNS-1                       POINTERS                24584000
         ST    R1,AOPTR                           FOR ASSEMBLY          24585000
         MVI   LNCNT+D3,D1              INITIALIZE LINE COUNT TO 1      24586000
         MVI   JTITLE,JBLANK            BLANK OUT                       24587000
         MVC   JTITLE+D1(L'JTITLE-D1),JTITLE   THE TITLE BUFFER         24588000
         MVI   LISTSW,BITFF             INITIALIZE LIST SWITCH          24589000
         GOIF  JLIST,ON=INIT1           LEAVE ON IF JLIST IS ON         24590000
         NI    LISTSW,BITFF-PSTMT       TURN OFF LIST SWITCH            24591000
INIT1    SET   (JRLDCHK,JXREFCHK,JERRCHK),OFF ASSUME NO RLDS,ERRS,XREFS 24592000
         SPACE                                                          24593000
         L     &SCR,JBEGCL             GET BEGIN COLUMN-1               24594000
         LA    &SCR,D1(,&SCR)          ADD 1                            24595000
         STH   &SCR,JBGNCL             STORE BEGIN COL PTR              24596000
         L     &SCR,JCTBGN              GET CONTINUE COLUMN-1           24597000
         LA    &SCR,D1(,&SCR)           ADD 1                           24598000
         STH   &SCR,JCNTCL              STORE CONT COL PTR              24599000
         L     &SCR,JBEGCL              GET BEGIN COLUMN-1              24600000
         A     &SCR,JSRCLN              ADD SOURCE FIELD MOVE LENGTH    24601000
         LA    &SCR,D1(,&SCR)           AND 1                           24602000
         STH   &SCR,JENDCL              JENDCL NOW CONTAINS END COL-1   24603000
         SPACE                                                          24604000
         SET   (PSTMT,PGEN),ON          INITIALIZE PRINT SWITCH         24605000
         NC    PRINTSW,LISTSW           TURN OFF PSTMT IF JLIST IS OFF  24606000
         JPOINT FILE=FILE2,NEXT=START   REWIND FILE2                    24607000
         B     MLC200                   GO GET FIRST TEXT RECORD        24608000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - GETX24609000
                DEFINITION RECORD ROUTINE'                              24610000
GETDFN   LH    R4,JTNMP                 GET NAME FIELD POINTER          24611000
         SET   NAMPRS,OFF               TURN OF NAME PRESENT SWITCH     24612000
         AR    R4,R5                    ADD TEXT RECORD POINTER         24613000
         GOIF  JTNML,D0,EQ=(R6)         IS NAME PRESENT                 24614000
         GOIF  JPSOP,OFF=GT100          CHECK FOR MACHINE OPERATION     24615000
         GOIF  JTEND,LT=(R6)            DO WE WORRY ABOUT NAME          24616000
         GOIF  JTTITLE,EQ=(R6)          EXIT IF TITLE                   24617000
GT100    CLI   JTNAME,JALFAMAX          SEE IF REAL NAME                24618000
         BHR   R6                       EXIT IF NOT                     24619000
         GOIF  JNMERR,ON=(R6)           IS NAME VALID?                  24620000
         LH    R10,JINFILE              YES, GET FILE NUMBER            24621000
         JGETL FILE=(R10)               GET DEFINITION DATA             24622000
         ST    R11,SYMDEF               SAVE DATA POINTER               24623000
         SET   NAMPRS,ON                TURN ON NAME PRESENT SWITCH     24624000
         SR    R2,R2                    CLEAR REGISTER                  24625000
         IC    R2,JTNML                 GET NAME LENGTH                 24626000
         BCTR  R2,0                     SUBTRACT 1 FOR EXECUTE          24627000
         EX    R2,COMPNAME              GO TO COMPARE NAME              24628000
         BE    GT150                    BRANCH IF EQUAL                 24629000
         X5ERRL 167,0                   SYMBOL FILE OUT OF PHASE        24630000
         LA    R10,LSTOUT               GET PRINT LISTING INDEX         24631000
         JCALL OUTPUT                   CALL PRINT                      24632000
         LA    R10,ERROUT               GET ERROR FLAG INDEX            24633000
         JCALL OUTPUT                   CALL PRINT                      24634000
         B     TEXTGET                  GO BACK TO GET TEXT RECORD      24635000
         JEXTRN (X5P01=OUTPUT)                                          24636000
         SPACE                                                          24637000
GT150    GOIF  JXREF,OFF=GT250          DO WE MAKE CROSS REFERENCES     24638000
         SET   JXREFCHK,ON              YES, TURN ON XREF MADE          24639000
         LR    R4,R11                   SAVE DEFINITION POINTER         24640000
         LH    R10,JOUTFILE             GET OUTPUT FILE NUMBER          24641000
         JPUTL FILE=(R10),BUFREQ=XRFVAL-XRFIN+L'XRFVAL GET XRF OUTPUT   24642000
         USING XRFIN,R11                ESTABLISH USING FOR XREF        24643000
         USING DSECT10,R4               CHANGE USING FOR DEFN DATA      24644000
         MVC   XRECLN(D6),=AL2(XRFND,0,XRFTYPE*256) MOVE HEADER DATA    24645000
         MVC   XRFSYM,RNAME             MOVE NAME TO RECORD             24646000
         MVI   XRFFLG,BASE              SET DEFINITION DATA FLAG        24647000
         MVC   XRFSTM,STMTN+D2          MOVE STATEMENT DATA TO RECORD   24648000
         MVC   XRFLEN,RLNGQ             MOVE LENGTH OF DATA ITEM        24649000
         MVC   XRFVAL,RLCTR             VALUE OR ADDRESS OF ITEM        24650000
         GOIF  PRIORDEF,OFF=GT200       IS THIS A MULTIPLE DEFINITION   24651000
         MVI   XRFFLG,DUPL              YES, CHANGE DEFINITION FLAG     24652000
         ST    R4,ERRPTR                SAVE DEFINITION DATA POINTER    24653000
         X5ERRL 196,DTAPTR              LOG ERROR                       24654000
         BR    R6                       EXIT                            24655000
COMPNAME CLC   2(0,R4),12(R11)          COMPARE NAME IN TEXT & SYMFILE  24656000
GT200    GOIF  DEFINED,OFF=(R6)         HAS IT BEEN DEFINED BEFORE      24657000
         MVI   XRFFLG,REF                                               24658000
         BR    R6                                                       24659000
GT250    LR    R4,R11                   SAVE SYMBOL DEFINITION POINTER  24660000
         GOIF  PRIORDEF,OFF=(R6)        IS THIS A PRIOR DEFINITION      24661000
         ST    R4,ERRPTR                SAVE DEFINITION DATA POINTER    24662000
         X5ERRL 196,DTAPTR              LOG ERROR                       24663000
         BR    R6                       RETURN TO MAINLINE              24664000
         JEXTRN (X5L01=LOGERR)          DEFINE EXTERNAL SYMBOL          24665000
         USING JTEXTA,R4                RESET USING FOR VARIABLE TEXT   24666000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - PHAX24667000
               SE WRAP-UP FUNCTIONS'                                    24668000
* CLOSE                                                                 24669000
*                                                                       24670000
*   THIS ROUTINE PERFORMS PHASE WRAP-UP FUNCTIONS                       24671000
         SPACE                                                          24672000
CLOSE    NC    CRDCNT,CRDCNT            IS BYTES IN PUNCHED CARD ZERO   24673000
         BZ    CLOSE0                   YES, DON'T PLACE IN TEXT CARD   24674000
         L     R1,CRDPTR                GET POINTER TO PUNCH CARD       24675000
         MVC   D10(D2,R1),CRDCNT        MOVE NUMBER BYTES TO CARD       24676000
         SPACE                                                          24677000
CLOSE0   GOIF  (JERRCHK,JXREFCHK,JRLDCHK),OFF=CLOSE1  IS EOF RECORD NEC 24678000
         LH    R10,JOUTFILE             GET OUTPUT FILE POINTER         24679000
         JPUTM FILE=(R10),ADDR=ERREOF   OUTPUT EOF RECORD               24680000
CLOSE1   JFRECORE   ADDR=(&COM)         RELEASE WORK STORAGE            24681000
         LH    R10,JINFILE              SWITCH INPUT AND                24682000
         MVC   JINFILE,JOUTFILE          OUTPUT FILES                   24683000
         STH   R10,JOUTFILE               FOR NEXT PHASE                24684000
         JPOINT FILE=FILE1,NEXT=START   REPOSITION                      24685000
         JPOINT FILE=FILE2,NEXT=START    ALL                            24686000
         JPOINT FILE=FILE3,NEXT=START     WORK FILES                    24687000
         B     MLC900                   THUS ENDETH THE ASSEMBLY        24688000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - TEXX24689000
               T RECORD GET ROUTINE'                                    24690000
* TEXT GET ROUTINE                                                      24691000
*   GETS A TEXT RECORD AND INITIALIZES FOR PROCESSING OF IT             24692000
         SPACE                                                          24693000
TEXTGET  L     R1,SYMXRF                GET NBR OF SYMB XREFED  OX02675 24694000
         MVI   DUMSW,X'00'              CLEAR SW FOR X5L       @OX10362 24695000
         SR    R4,R4                    ZERO REGISTER FOR NEXT USE      24696000
         IC    R4,SYMCNT                GET NUMBER OF SYMBOLS THIS CARD 24697000
         SR    R4,R1                    DETERMINE SYMBOLS REMAINING     24698000
         BNH   TXT040                   ALL SYMBOLS REFERENCED          24699000
TXT010   LH    R10,JINFILE              GET FILE NUMBER                 24700000
         JGETL FILE=(R10)               GET REFERENCE DATA              24701000
         BCT   R4,TXT010                GO BACK IF MORE SYMBOLS         24702000
TXT040   XC    SYMXRF,SYMXRF            RESET REFERENCE COUNT           24703000
         JGETL FILE=FILE2               GET TEXT RECORD                 24704000
         LR    &TBP,R11                 LOAD TEXT BASE REGISTER         24705000
         ST    R5,TXTPTR                SAVE TEXT POINTER               24706000
         GOIF  JTEOF,EQ=CLOSE           GO CLOSE PHASE IF END-OF-FILE   24707000
         GOIF  JPSOP,OFF=TXT045         BRANCH IF NOT PSEUDO OP         24708000
         GOIF  JTERROR,EQ=MLC275        GET OUT IF ERROR                24709000
TXT045   OC    JTFLGB,JPRTONLY          OR IN X4 CATASTROPHIC FLAG      24710000
*   THE FOLLOWING CARDS ARE FOR TSO                                     24711000
         GOIF  JTERM,OFF=TXT050         DO WE PRINT TO TERMINAL?        24712000
         SET   ERRBIT,OFF               TURN ERRBIT OFF                 24713000
         GOIF  TERR,ON=TXT047           CAN THIS BE CONTINUATION        24714000
         GOIF  JTCALL,EQ=ERRSCAN        CAN IT BE MACRO CALL            24715000
         GOIF  JTPROTO,EQ=ERRSCAN       OR A PROTOTYPE                  24716000
TXT0455  GOIF  JPRONLY,OFF=TXT048       CAN IT BE MODEL                 24717000
         GOIF  (JSUBNAME,JSUBOPCD,JSUBOPND),OFF=TXT048 OK IF SUBST REQ  24718000
TXT046   BAL   R6,RECSAVE               SAVE RECORD                     24719000
         B     TXT048                   CONTINUE                        24720000
ERRSCAN  GOIF  JNOCNT,ON=TXT0455        NOT BEGIN OF PROTO OR CALL      24721000
         JNOTE FILE=FILE2               SAVE POSITION OF CALL OR PROTO  24722000
         MVC   MODNOTV,JNOTEVAL         SAVE VALUE                      24723000
         GOIF  JERR,ON=ERRSCAN1         RECORD IN ERROR                 24724000
ERRSCAN0 JGETL FILE=FILE2               GET NEXT RECORD                 24725000
         LR    R5,R11                   GET RECORD ADDRESS              24726000
         GOIF  JTCALL,EQ=ERRSCAN1       CALL ?                          24727000
         GOIF  JTPROTO,EQ=ERRSCAN1      PROTOTYPE ?                     24728000
         JPOINT FILE=FILE2,NEXT=GET,ADDR=MODNOTV POSITION BACK TO START 24729000
         JGETL FILE=FILE2               READ 1ST RECORD AGAIN           24730000
         LR    R5,R11                   ESTABLISH RECORD BASE           24731000
         GOIF  JTCALL,NE=TXT048         IF CALL SAVE RECORD             24732000
         GOIF  JGEN,ON=TXT048           DO NOT SAVE IF INNER CALL       24733000
         BAL   R6,RECSAVE               SAVE CALL                       24734000
         B     TXT048                   CONTINUE                        24735000
ERRSCAN1 GOIF  JERR,OFF=ERRSCAN0        READ NEXT RECORD IF NO ERROR    24736000
         JPOINT FILE=FILE2,NEXT=GET,ADDR=MODNOTV POSITION BACK          24737000
         JGETL FILE=FILE2               GET 1ST RECORD                  24738000
         LR    R5,R11                   GET RECORD ADDRESS              24739000
         SET   TERR,ON                  INDICATE REST TO TERM           24740000
         GOIF  JTCALL,NE=TXT049         SAVE RECORD IF CALL             24741000
         GOIF  JGEN,ON=TXT049           IF INNER CALL DO NOT SAVE       24742000
         BAL   R6,RECSAVE               ELSE CONTINUE                   24743000
         B     TXT049                   CONTINUE SCAN                   24744000
RECSAVE  LH    R4,JTRLI                 GET RECORD LENGTH               24745000
         LA    R3,MODEL                 GET SAVE ADDRESS                24746000
         LR    R2,R5                    SAVE RECORD POINTER             24747000
         SH    R4,=H'256'               CHECK MOVE LENGTH               24748000
         BM    RECSAVE1                 OK                              24749000
         MVC   D0(256,R3),D0(R2)        MOVE 256 FIRST CHAR             24750000
         AH    R3,=H'256'               UPDATE BOTH POINTERS            24751000
         AH    R2,=H'256'                                               24752000
RECSAVE1 EX    R4,RECMOVE               MOVE REST                       24753000
         L     R1,STMTN                 GET STATEMENT NUMBER OF         24754000
         LA    R1,D1(R1)                  NOTED RECORD                  24755000
         STH   R1,MODSTMT               SAVE IT                         24756000
         BR    R6                       CONTINUE                        24757000
RECMOVE  MVC   D0(R0,R3),D0(R2)         MOVE MODEL STATEMENT            24758000
TXT047   GOIF  JNOCNT,ON=TXT049         PRINT ALL LINES OF STMT ON TSO  24759000
         SET   TERR,OFF                 INDICATE ALL PRINTED            24760000
         B     TXT045                   DO ORDINARY CHECK               24761000
TXT048   GOIF  JERR,OFF=TXT050          ANY ERROR RECORD EEXPECTED      24762000
         GOIF  JGEN,OFF=TXT049          SHALL WE GET NOTED STMT         24763000
TXT0485  LH    R10,JOUTFILE             GET FILE UNDEX                  24764000
         JPUTM FILE=(R10),ADDR=MODEL    OUTPUT MODEL STMT               24765000
         MVC   D4(,R11),=AL1(JT,J0)     INDICATE TEXT RECORD            24766000
         MVC   D16(D1,R11),D3(R11)      SAVE FLAGB                      24767000
         MVC   D2(D2,R11),MODSTMT       MOVE IN STATEMENT NUMBER        24768000
TXT049   LH    R10,JOUTFILE             GET FILE INDEX                  24769000
         SET   TERR,ON                  INDICATE MORE LINES CAN COME    24770000
         JPUTM FILE=(R10),ADDR=JTEXT    WRITE OUT TEXT RECORD           24771000
         MVC   D4(,R11),=AL1(JT,J0)     MOVE IN TEXT RECORD OPCODE      24772000
         MVC   D16(D1,R11),D3(R11)      SAVE JTFLGB                     24773000
         L     R1,STMTN                 GET STMT NUMBER                 24774000
         LA    R1,D1(,R1)               INCREMENT 1                     24775000
         STH   R1,D2(R11)               SAVE STMNT NUMBER               24776000
         SET   ERRBIT,ON                YES, TURN 1ST TIME SWITCH OFF   24777000
*   TSO ENDS HERE                                                       24778000
TXT050   LH    R4,JTOPP                 GET OPERAND POINTER             24779000
         AR    R4,R5                    ADD TEXT POINTER                24780000
         GOIF  JTOPOCD,OFF=TXT100       BRANCH IF CARD POINTER          24781000
         LA    R4,D1(,R4)               STEP PAST CARD POINTER          24782000
TXT100   SR  R14,R14                    ZERO WORK REGISTER              24783000
         SET   OPNPRS,OFF               INDICATE OPERAND NOT PRESENT    24784000
         GOIF  JTOPL,D0,EQ=TXT200       ZERO OPERAND LENGTH - NO OPND   24785000
         CLC   JTOPND(D2),=AL1(JCOMMA,JBLANK) IS OPERAND ONLY A COMMA   24786000
         BE    TXT200                   YES, NO OPERAND LEAVE INDICATOR 24787000
         SET   OPNPRS,ON                NO, INDICATE OPERAND PRESENT    24788000
TXT200   IC    R14,JTOPL                GET OPERAND LENGTH              24789000
         LA    R4,JTOPND                POINT TO FIRST CHAR OF OPERAND  24790000
         AR    R14,R4                   POINT TO END OF OPERAND         24791000
         ST    R4,OPNADR                SAVE OPERAND POINTER            24792000
         ST    R14,OPNEND               SAVE POINTER TO END OF OPERAND  24793000
         MVC   CDSTMT,=H'1'             RESET CARD-WITHIN-STMT COUNTER  24794000
         MVC   CLCLNG,=H'1'             DEFAULT LENGTH TO 1 FOR L'*     24795000
         SPACE                                                          24796000
         LH    &SCR,JTSPR               GET STRING GROUP POINTER        24797000
         AR    &SCR,&TBP                ADD TEXT BASE POINTER           24798000
         ST    &SCR,STRADR              STORE STRING GROUP ADDRESS      24799000
         TM    JPRTONLY,BIT0            IS X4 CATASTROPHIC ON           24800000
         BO    TXT250                   YES, NO SYMBOLS TO XREF         24801000
         MVC   SYMCNT,JTSYMCNT          SAVE OPERAND SYMBOL COUNT       24802000
TXT250   SET   PERR,OFF                TURN OFF ERROR SWITCH            24803000
         GOIF  JNOCNT,ON=MLC250         BRANCH IF STATEMENT NOT COUNTED 24804000
         L     &SCR,STMTN               GET STATEMENT NUMBER            24805000
         LA    &SCR,D1(,&SCR)           STEP IT BY 1                    24806000
         C     R1,=F'65535'             IS IT THE LIMIT ?               24807000
         BNH   TXT300                   NO,BRANCH AROUND                24808000
         SR    R1,R1                    YES,START FROM ZERO             24809000
TXT300   ST    &SCR,STMTN               SAVE IT                         24810000
         B     MLC250                   RETURN TO MAINLINE              24811000
         TITLE '&COMPNM&ASMID - ASSEMBLY PHASE - MAINLINE CONTROL - CONX24812000
               STANTS AND PATCH AREA'                                   24813000
ERREOF   DS    0CL8                      EOF RECORD TO OVERFLOW FILE    24814000
         DC    AL2(L'ERREOF)            RECORD LENGTH                   24815000
         DC    AL1(JPSOP,0)             FLAGS                           24816000
         DC    AL1(JTEOF,X'EE',X'00',X'FF')  FLAGS                      24817000
         SPACE 2                                                        24818000
         JPATCH X5C00,520               5% PATCH AREA                   24819000
         END   MLC100                                                   24820000
./ ADD NAME=IFNX5F                                                      24821000
         JHEAD 'DC FIXED-FLOATING POINT CONVERSION',                   X24822000
               PHASEID=X5F,                                            X24823000
               LEVEL=10                                                 24824000
         COPY  JCOMMON                  GET COMMON DEFINITION           24825000
         EJECT                                                          24826000
         COPY  X5COM                    GET PHASE COMMON DEFINITION     24827000
         EJECT                                                          24828000
*                                                                       24829000
*DUMMY SECTION FOR WORKING STORAGE                                      24830000
*                                                                       24831000
WSDSECT  DSECT                                                          24832000
HOLD     DS    D                        DOUBLE WORD FOR CVB INST        24833000
AFIRST   DS    F                        SAVE AREA FOR BEGINNING POINTER 24834000
SAVEAD   DS    F                        SAVE AREA FOR ENDING POINTER    24835000
* ZWDE THRU ZWACC ARE STORED AND LOADED BY MULTIPLE OPS                 24836000
* AND MUST BE IN GIVEN SEQUENCE.                                        24837000
ZWDE     DS    F                   DECIMAL EXPONENT                     24838000
ZWSF     DS    F                   FIXED PT SCALE AND FLOATING PT EXPON 24839000
ZWTXPT   DS    F                   SAVE TEXT POINTER                    24840000
         DS    0F                  ENSURE WORD ALIGNMENT OF ZWACC       24841000
ZWACC    DS    XL20                ACCUMULATOR                          24842000
         DS    0F                  SET PROPER ALIGNMENT FOR ZWW1        24843000
ZWW1     DS    XL56                WORK AREA                            24844000
ZWW2     EQU   ZWW1+L'ZWW1-4       LOW WORD OF WORK AREA                24845000
*                                                                       24846000
DCLNGTH  DS    F                        LENGTH MODIFIER                 24847000
VASCTL   DS    C                        DECON FLAG                      24848000
ZWSW     DS    C                   CONTROL SWITCHES AND VALUE SIGN      24849000
*                             BIT 7 X'01' = FLOATING POINT  (ELSE FIXD) 24850000
*                                 6    2  = VALUE FOUND (MAYBE ZERO)    24851000
*                                 5    4  = FLT.PT IS INITIALIZED (WSF) 24852000
*                                 4    8  = FLT.PT IS L-CON             24853000
*                                                                       24854000
         EJECT                                                          24855000
*TITLE 'FFPCONV'                                                      * 24856000
*FUNCTION/OPERATION - TO DO ALL FIXED OR FLOATING POINT CONVERSION FOR* 24857000
*   DC STATEMENTS.  IT IS CALLED BY          ONCE FOR EACH CONSTANT TO* 24858000
*   BE CONVERTED.                                                     * 24859000
*ENTRY POINT- L     R12,                                              * 24860000
*            BALR R9,R12                                              * 24861000
*INPUT- R10 WILL POINT TO AN UNCLASSIFIED TEXT BUCKET CONTAINING THE  * 24862000
*          CONSTANT TO BE CONVERTED.  THE FIRST BYTE OF THE TEXT      * 24863000
*          BUCKET IS THE BUCKET CODE (NOT USED).  THE SECOND BYTE     * 24864000
*          CONTAINS THE LENGTH - 1 OF THE CONSTANT THAT FOLLOWS.      * 24865000
*       R11 WILL POINT TO AN INPUT ARRAY OF 8 FULLWORDS, FULLWORD     * 24866000
*          ALIGNED.  IF BYTE 1, WORD 1 = 1, THEN THE LENGTH IS IN BITS* 24867000
*          OTHERWISE THE LENGTH IS IN BYTES.  BYTE 4, WORD 1 IS THE   * 24868000
*          TYPE (19=L-CON, 1A=DOUBLE WORD, 1B=FLOATING POINT FULLWORD,* 24869000
*          1C=FIXED POINT FULLWORD, AND 1D=HALFWORD).  WORD 2 IS THE  * 24870000
*          LENGTH IN BYTES OR BITS, DEPENDENT ON BYTE 1, WORD 1.  WORD* 24871000
*          3 IS THE SCALING FACTOR, AND WORD 4 IS THE EXTERNAL        * 24872000
*          EXPONENT.  WORDS 5-8 ARE NOT USED FOR INPUT.               * 24873000
*       $HEVAL+4 WILL POINT TO AN AREA OF CORE FOR WORKING STORAGE    * 24874000
*OUTPUT-R10 POINTS TO A , OR A ' BUCKET.                              * 24875000
*       R11 POINTS TO THE INPUT ARRAY.  BYTE 2 WORD 1 IS THE ERROR    * 24876000
*          CODE BYTE.  WORDS 5-8 ARE THE RIGHT JUSTIFIED CONSTANT.    * 24877000
*EXTERNAL ROUTINES- NONE                                              * 24878000
*EXITS- NORMAL - $EXIT                                                * 24879000
*       ERROR - SAME, EXCEPT THE ERRORS ARE LOGGED IN THE ERROR BYTE. * 24880000
*TABLES/WORK AREAS-                                                   * 24881000
*                   (ZWDE)     F   MODIFIED EXPONENT SAVE AREA        * 24882000
*                   (ZWSF)     F   FIXED PT SCALE & FLOATING PT EXPON * 24883000
*                   (ZWTXPT)   F   TEXT POINTER SAVE AREA             * 24884000
*                   (ZWACC)   5F   ACCUMULATOR                        * 24885000
*                   (ZWW1)   56C   WORK AREA                          * 24886000
*                   (DCLNG)    F   LENGTH MODIFIER                    * 24887000
*                   (VASCTL)   C   DECON FLAG BYTE                    * 24888000
*                   (ZWSW)     C   CONTROL SWITCH AND VALUE SIGN      * 24889000
*                   (SAVEAD)   F   POINTER SAVE AREA                  * 24890000
*                   (AFIRST)   F   POINTER SAVE AREA                  * 24891000
*                   (HOLD)     D   DOUBLE WORD FOR CVB                * 24892000
*ATTRIBUTES- N/A                                                      * 24893000
*NOTES-                                                               * 24894000
         EJECT                                                          24895000
*                                                                       24896000
*    INITIALIZATION                                                     24897000
*                                                                       24898000
         USING WSDSECT,R4                                               24899000
         USING X5COM,R7                 DEFINE COMMON USING             24900000
         JCSECT (X5F00)                 INITIATE CSECT                  24901000
*C127000                                                       @AX14184 24902000
         JMODID ,                       CREATE ROUTINE IDENTIFIER       24903000
FXFLCV   JSAVE BASE=NO                  SAVE REGISTERS                  24904000
         JENTRY (X5F01=FXFLCV)          DEFINE ENTRY                    24905000
         USING FXFLCV,R3                DEFINE PHASE USING              24906000
         LR    R3,R12                   ESTABLISH BASE                  24907000
         L     R4,ALPTR                 FETCH WORKING STORAGE POINTER   24908000
         MVI   ZARYERR(R11),BIT0-BIT0   ZERO ERROR BYTE                 24909000
         L     R2,ZARYLEN(0,R11)        FETCH LENGTH MODIFIER VALUE     24910000
         TM    ZARYSGN(R11),BIT0        IS LENGTH MODIFIER BITS         24911000
         BO    CNV3                     YES                             24912000
         SLL   R2,3                     NO, BYTES, SO SHIFT FOR BITS    24913000
CNV3     BCTR  R2,0                     DECREMENT BIT LENGTH BY ONE     24914000
         ST    R2,DCLNGTH               SAVE BIT LENGTH VALUE           24915000
         CLI   ZARYTYPE(R11),BTYPEFL    IS THIS FLOATING POINT          24916000
         BH    ZWFXCV                     NO.  FIXED POINT              24917000
         CLI   ZARYTYPE(R11),BTYPEL     IS THIS AN L-CON                24918000
         BH    ZWFLCV                     NO.  FLOATING POINT           24919000
         MVI   ZWSW,BIT4+BIT7             YES. SET INDICATOR FOR L-CON  24920000
         B     ZWA1                     GO INITIALIZE                   24921000
         SPACE                                                          24922000
ZWFLCV   MVI   ZWSW,BIT7                SET INDICATOR FOR FLOATING PT   24923000
ZWA1     XR    ZWRD,ZWRD                LOWER LIMIT SCALE FACTOR        24924000
         LA    ZWRE,30                  UPPER LIMIT SCALE FACTOR        24925000
         B     ZWA2                       GO AROUND FIXED POINT SET UP  24926000
         SPACE                                                          24927000
ZWFXCV   MVI   ZWSW,BIT0-BIT0           SET INDICATOR FOR FIXED POINT   24928000
         LA    ZWRD,187                 LOWER                           24929000
         LCR   ZWRD,ZWRD                  LIMIT SCALE FACTOR            24930000
         LA    ZWRE,346                 UPPER LIMIT SCAL FACTOR         24931000
ZWA2     LR    ZWRARY,R11               SAVE INPUT ARRAY POINTER        24932000
         L     ZWRA,ZARYSCL(ZWRARY)     FETCH SCALE FACTOR              24933000
         L     ZWRH,ZARYEXP(ZWRARY)     FETCH EXTRN EXPONENT MODIFIER   24934000
         LR    ZWRB,R10                 LOAD SCAN CHAR POINTER          24935000
         STM   ZWRH,ZWRB,ZWDE           SAVE EXP, SCALE MOD AND TXT PTR 24936000
         XC    ZWACC,ZWACC         CLEAR ACCUMULATOR                    24937000
         SR    ZWRL,ZWRL           PREPARE TO MARK DECIMAL POINT        24938000
         LR    ZWRF,ZWRB           SET UP FOR NO EXP DIGITS TEST        24939000
         LR    ZWRI,ZWRH           SAVE EXPONENT MODIFIER               24940000
         EJECT                                                          24941000
*B                                                                      24942000
*B SCAN TEXT MARKING DECIMAL,END OF VALUE,FIRST TERMINATOR.             24943000
*B CONVERT EXPONENT IF ANY AND MODIFY.                                  24944000
*B                                                                      24945000
ZWB1     LR    ZWRJ,ZWRB           MARK END OF VALUE FIELD              24946000
         GOIF  D0(ZWRB),JCOMMA,EQ=ZWC1  CHECK FOR END OF OPERAND        24947000
         GOIF  D0(ZWRB),JQUOTE,EQ=ZWC1  CHECK FOR END OF OPERAND        24948000
         GOIF  D0(ZWRB),JBLANK,EQ=ZWZ4  CHECK FOR END OF OPER  @AX14184 24949000
         CLI   0(ZWRB),JE               BRANCH                          24950000
         BNE   ZWB3                     IF CHARACTER NOT E              24951000
         LA    ZWRB,1(ZWRB)             STEP OVER E                     24952000
         BAL   ZWRG,ZWS1           STEP OVER SIGN IF PRESENT            24953000
         BAL   ZWRG,DECON          CONVERT EXPONENT                     24954000
         LR    ZWRLAST,ZWRB             SET TERMINATOR POINTER          24955000
         GOIF  D0(ZWRB),JCOMMA,EQ=ZWB1A  OK IF COMMA                    24956000
         GOIF  D0(ZWRB),JQUOTE,EQ=ZWB1A  OK IF QUOTE                    24957000
         B     ZWZ4                     GO LOG ERROR AND EXIT           24958000
ZWB1A    EQU   *                        BRANCH LABEL                    24959000
         CLI   1(ZWRJ),JMINUS      BRANCH                               24960000
         BNE   ZWB2                     UNLESS EXP NEGATIVE             24961000
         LCR   ZWRH,ZWRH           COMPLEMENT EXPONENT                  24962000
         SPACE                                                          24963000
ZWB2     AR    ZWRI,ZWRH           ADD TO EXP MODIFIER                  24964000
         ST    ZWRI,ZWDE           STORE MODIFIED EXP                   24965000
         B     ZWC1                     EXIT-ALL CHAR HAVE BEEN SCANNED 24966000
         SPACE                                                          24967000
ZWB3     CLI   0(ZWRB),JPERIOD          BRANCH                          24968000
         BNE   ZWB4                     UNLESS CHAR DECIMAL POINT       24969000
         LR    ZWRL,ZWRB           MARK DECIMAL POINT                   24970000
ZWB4     LA    ZWRB,1(ZWRB)             ADVANCE TEXT POINTER            24971000
         B     ZWB1                     CONTINUE LOOP                   24972000
*C                                                                      24973000
*C SAVE POINTER TO TERMINATOR.CHECK EXPONENT AND SCALE FACTOR RANGE AND 24974000
*C CHECK FOR NO EXPONENT DIGITS. SET UP TO SCAN VALUE.                  24975000
*C                                                                      24976000
ZWC1     AH    ZWRI,=H'5'               MAKE RANGE SYMETRIC             24977000
         LR    ZWRLAST,ZWRB             SAVE TERMINATOR POINTER         24978000
         LPR   ZWRI,ZWRI           TAKE MAGNITUDE                       24979000
         CH    ZWRI,=H'80'         BRANCH                               24980000
         BNH   ZWC2                     IF EXPONENT WITHIN RANGE        24981000
         OI    ZARYERR(ZWRARY),ZRCD13   SET EXPONENT OUT OF RANGE INDIC 24982000
         SR    ZWRI,ZWRI                SET EXPONENT TO ZERO AND        24983000
         ST    ZWRI,ZWDE                  CONTINUE AS IF EXP WAS ZERO   24984000
         SPACE                                                          24985000
ZWC2     LA    ZWRH,ZRCD11              SET NO. FOR SCL FAC RANGE ERROR 24986000
         CR    ZWRA,ZWRD           BRANCH                               24987000
         BL    ZWZ3                     IF SF TOO SMALL                 24988000
         CR    ZWRA,ZWRE           BRANCH                               24989000
         BH    ZWZ3                     IF SF TOO LARGE                 24990000
         CR    ZWRB,ZWRF           BRANCH TO ERROR ROUTINE              24991000
         BE    ZWZ4                     IF NO EXP DIGIT OR TEXT         24992000
         L     ZWRB,ZWTXPT         RESET TEXT POINT TO BEGINNING VALUE  24993000
         BAL   ZWRG,ZWS1           STEP OVER VALUE SIGN IF PRESENT      24994000
         SPACE                                                          24995000
         LTR   ZWRL,ZWRL           IF NO DECIMAL                        24996000
         BNZ   ZWD1                  SET MARK TO                        24997000
         LR    ZWRL,ZWRJ             END OF VALUE                       24998000
         EJECT                                                          24999000
*D                                                                      25000000
*D STEP OVER DECIMAL POINT. CHECK FOR END OF VALUE.                     25001000
*D                                                                      25002000
ZWD1     CR    ZWRB,ZWRL           IF NEXT CHAR                         25003000
         BNE   ZWD2                     DECIMAL POINT                   25004000
         LA    ZWRB,1(ZWRB)             ADVANCE VALUE POINTER           25005000
         LR    ZWRL,ZWRB             AND DECIMAL MARKER                 25006000
ZWD2     CR    ZWRB,ZWRJ           IF END OF VALUE                      25007000
         BNL   ZWM1                  BRANCH                             25008000
*E                                                                      25009000
*E CONVERT PIECE OF VALUE.CHECK FOR ZERO.COMPUTE ADJUSTED EXP FOR PIECE 25010000
*E                                                                      25011000
ZWE1     BAL   ZWRG,DECON          CONVERT PIECE OF VALUE               25012000
         TM    VASCTL,BIT0+BIT1    IF ONE OR MORE DIGITS CONVERTED      25013000
         BZ    ZWE2                     AND NON-DIGIT REACHED, BRANCH   25014000
         TM    VASCTL,BIT0         IF NO DIGITS FOUND                   25015000
         BO    ZWZ4                     BRANCH TO INVALID TERM. MESSAGE 25016000
         LA    ZWRB,9(ZWRF)        CORRECT VALUE POINTER                25017000
ZWE2     OI    ZWSW,BIT6           SET VALUE FOUND SWITCH               25018000
         LTR   ZWRD,ZWRH           COPY AND TEST VALUE                  25019000
         BZ    ZWD1                     BRANCH IF ZERO                  25020000
         LR    ZWRG,ZWRL           LOCATION DECIMAL                     25021000
         SR    ZWRG,ZWRB             MINUS LOCATION CHAR AFTER FLD CNVT 25022000
         A     ZWRG,ZWDE             PLUS EXP GIVES ADJ EXP FOR THIS    25023000
*                                    PIECE OF VALUE                     25024000
         TM    ZWSW,BIT5+BIT7      BRANCH UNLESS FIRST NON-ZERO         25025000
         BNM   ZWG1                  PIECE FLOATING VALUE               25026000
*F                                                                      25027000
*F IF FLOATING PT COMPUTE WORKING SCALE FACTOR.                         25028000
*F                                                                      25029000
         LCR   ZWRC,ZWRG           COMPLEMENT ADJ EXP                   25030000
         MH    ZWRC,=HS13'3.322'   MULT BY LOG 10 BASE 2 (3.527 HEX)    25031000
         SRA   ZWRC,13             SCALE PRODUCT                        25032000
ZWF1     BCTR  ZWRC,0              COUNT NUMBER BITS                    25033000
         SRA   ZWRD,1                AND SUBTRACT                       25034000
         BP    ZWF1                     FROM PRODUCT                    25035000
         SRA   ZWRC,2              ROUND DOWN TO MULTIPLE OF 4          25036000
         SLA   ZWRC,2                                                   25037000
         AH    ZWRC,=H'124'          AND ADD 124                        25038000
         ST    ZWRC,ZWSF           STORE WORKING SCALE FACTOR           25039000
         OI    ZWSW,BIT5           SET FL PT INIT SWITCH                25040000
         LPR   ZWRF,ZWRC           IF WORKING SCALE FACTOR WILL         25041000
         CH    ZWRF,=H'400'          PRODUCE INVALID CHARACTERISTIC     25042000
         BH    ZWQ7                     BRANCH TO INVALID EXP MSG       25043000
*G                                                                      25044000
*G COMPUTE AMT OF BINARY SHIFT. SPLIT INTO WORD INDEX AND BIT SHIFT.    25045000
*G RESET WORKING AREA. TEST SIGN OF ADJ EXPONENT.                       25046000
*G                                                                      25047000
ZWG1     LA    ZWRC,32             32                                   25048000
         AR    ZWRC,ZWRG             PLUS ADJ EXP                       25049000
         A     ZWRC,ZWSF           PLUS SCALE FACTOR GIVES BIN SHIFT    25050000
         SPACE                                                          25051000
* NOTE - ZWSF HAS S-MODIFIER VALUE IF F-, H-CON,                        25052000
*             OR THE WORKING SCALE FACTOR IF L-, D-, OR E-CON.          25053000
         SRDA  ZWRC,5              SEPARATE INTO BIT AND WORD SHIFTS    25054000
         SRL   ZWRD,27             POSITION BIT SHIFT                   25055000
         SLL   ZWRC,2              POSITION WORD SHIFT                  25056000
         XC    ZWW1,ZWW1           CLEAR WORK AREA                      25057000
         LTR   ZWRG,ZWRG           TEST ADJ EXP                         25058000
         BNP   ZWI1                BRANCH IF ZERO OR NEG                25059000
         EJECT                                                          25060000
*H                                                                      25061000
*H ADJ EXP IS PLUS.  MULTIPLY VALUE BY 5 TO THE GIVEN POWER.            25062000
*H                                                                      25063000
         ST    ZWRH,ZWW2           STORE VALUE                          25064000
         LR    ZWRA,ZWRC           WORD SHIFT IN BYTES                  25065000
         SH    ZWRA,=H'16'           LESS 16 = LEFT LIMIT OF WORK AREA  25066000
         BP    ZWJ8                     BRANCH IF LIMIT DEFINES NO WORK 25067000
ZWH1     SR    ZWRI,ZWRI           RESET WORK AREA POINTER              25068000
         SR    ZWRH,ZWRH           CLEAR CARRY REG                      25069000
ZWH2     L     ZWRF,ZWW2(ZWRI)     LOAD PART OF VALUE                   25070000
         M     ZWRE,=F'5'          TIMES 5                              25071000
         ALR   ZWRF,ZWRH           ADD CARRY                            25072000
         BC    12,ZWH3             PROPAGATE                            25073000
         AH    ZWRE,=H'1'            CARRY                              25074000
ZWH3     LTR   ZWRH,ZWRE           SAVE CARRY AND TEST SIGN             25075000
         BNM   ZWH4                  IF NEGATIVE                        25076000
         AH    ZWRH,=H'5'            CORRECT                            25077000
ZWH4     ST    ZWRF,ZWW2(ZWRI)     STORE PARTIAL PRODUCT                25078000
         SH    ZWRI,=H'4'          STEP AREA POINTER LEFT               25079000
         CR    ZWRI,ZWRA           IF LEFT LIMIT NOT REACHED            25080000
         BNL   ZWH2                  BRANCH                             25081000
         LTR   ZWRH,ZWRH           TEST FINAL CARRY                     25082000
         BZ    ZWH5                     IF NOT ZERO                     25083000
         OI    ZARYERR(ZWRARY),DCTRUN   SET TRUNCATION INDICATOR        25084000
ZWH5     BCT   ZWRG,ZWH1           DECREMENT ADJ EXP AND CLOSE LOOP     25085000
         B     ZWJ1                     SHIFT VALUE                     25086000
*I                                                                      25087000
*I ADJ EXP IS NOT PLUS. SHIFT VALUE AS INDICATED BY THE WORD INDEX AND  25088000
*I DIVIDE BY 5 TO THE MAGNITUDE OF THE GIVEN POWER. RESET WORD INDEX    25089000
*I                                                                      25090000
ZWI1     LCR   ZWRC,ZWRC           COMPLEMENT WORD SHIFT GIVES LEFT     25091000
*                                    LIMIT WORK AREA                    25092000
         BP    ZWD1                     BRANCH IF LIMIT DEFINES NO WORK 25093000
         ST    ZWRH,ZWW2(ZWRC)     STORE VALUE IN WORK AREA SHIFTED     25094000
         LCR   ZWRG,ZWRG           COMPLEMENT AND TEST ADJ EXP GIVES    25095000
*                                    COUNT FOR NUMBER TIMES TO DIVIDE   25096000
         BZ    ZWI5                     BRANCH IF ZERO                  25097000
ZWI2     LR    ZWRI,ZWRC           SET WORKING POINTER TO LEFT LIMIT    25098000
         SR    ZWRE,ZWRE           CLEAR UPPER DIVIDEND REG             25099000
ZWI3     L     ZWRF,ZWW2(ZWRI)     LOAD PART OF DIVIDEND                25100000
         D     ZWRE,=F'10'         DIVIDE                               25101000
         SLL   ZWRF,1                BY 5                               25102000
         CH    ZWRE,=H'5'          IF REMAINDER                         25103000
         BL    ZWI4                     TOO LARGE                       25104000
         SH    ZWRE,=H'5'            CORRECT REMAINDER                  25105000
         AH    ZWRF,=H'1'            AND DIVIDEND                       25106000
ZWI4     ST    ZWRF,ZWW2(ZWRI)     STORE PARTIAL QUOTIENT               25107000
         AH    ZWRI,=H'4'          STEP WORKING POINTER RIGHT           25108000
         BNP   ZWI3                REPEAT UNTIL RIGHT LIMIT REACHED     25109000
         BCT   ZWRG,ZWI2           REDUCE COUNT AND CLOSE LOOP          25110000
ZWI5     SR    ZWRC,ZWRC           CLEAR WORD SHIFT                     25111000
         OC    ZWW1(L'ZWW1-L'ZWACC),ZWW1  TEST HI PART OF WORK AREA     25112000
         BE    ZWJ1                     IF NOT ZERO                     25113000
         OI    ZARYERR(ZWRARY),DCTRUN   SET TRUNCATION INDICATOR        25114000
         EJECT                                                          25115000
*J                                                                      25116000
*J SHIFT VALUE PER WORD SHIFT AND BIT SHIFT. TRUNCATE TO 160            25117000
*J BITS AND ADD TO ACCUMULATOR.                                         25118000
*J                                                                      25119000
ZWJ1     SR    ZWRG,ZWRG           RESET CARRY REG                      25120000
         LA    ZWRH,16             INIT ACCUMULATOR POINTER             25121000
ZWJ2     SR    ZWRE,ZWRE           RESET WORKING REGISTERS              25122000
         SR    ZWRF,ZWRF                                                25123000
         LTR   ZWRC,ZWRC           TEST WORD INDEX                      25124000
         BP    ZWJ4                     IF PLUS LEAVE WORK AREA CLEAR   25125000
         BZ    ZWJ3                     IF ZERO FETCH ONE WORD OF RESLT 25126000
         L     ZWRF,ZWW2+4(ZWRC)   FETCH LO WORD OF RESULT              25127000
ZWJ3     L     ZWRE,ZWW2(ZWRC)     FETCH HI WORD OF RESULT              25128000
ZWJ4     SLDL  ZWRE,0(ZWRD)        BIT SHIFT                            25129000
         ALR   ZWRE,ZWRG           ADD IN CARRY                         25130000
         BC    3,ZWJ5              BRANCH IF CARRY LEAVING ONE IN ZWRG  25131000
         SR    ZWRG,ZWRG           RESET CARRY                          25132000
ZWJ5     LTR   ZWRH,ZWRH           END OF ACCU                          25133000
         BM    ZWJ7                     YES, BRANCH                     25134000
         AL    ZWRE,ZWACC(ZWRH)    ADD IN PIECE FROM ACCUMULATOR        25135000
         BC    12,ZWJ6             BRANCH IF NO CARRY                   25136000
         LA    ZWRG,1              SET CARRY                            25137000
ZWJ6     ST    ZWRE,ZWACC(ZWRH)    STEP WORKAREA PT                     25138000
         SH    ZWRC,=H'4'          STEP ACCU PT                         25139000
         SH    ZWRH,=H'4'          REPEAT FOR EACH WORD OF ACCU         25140000
         B     ZWJ2                     LOOP                            25141000
ZWJ7     LTR   ZWRE,ZWRE           TEST CARRY                           25142000
         BZ    ZWD1                     IF ON                           25143000
ZWJ8     OI    ZARYERR(ZWRARY),DCTRUN   SET TRUNCATION INDICATOR        25144000
         B     ZWD1                     STEP OVER DECIMAL POINT         25145000
*M                                                                      25146000
*M SET UP TO FORMAT RESULT. BRANCH TO APPROPRIATE ROUTINE.              25147000
*M                                                                      25148000
ZWM1     LM    ZWRL,ZWRJ,ZWSF      GET SCALE FACTOR AND TEXT POINTER,   25149000
         L     ZWRC,DCLNGTH             GET BIT LENGTH                  25150000
         LCR   ZWRC,ZWRC             AND COMPLEMENT                     25151000
         TM    ZWSW,BIT5+BIT6      WHAT FORMAT REQUIRED                 25152000
         BZ    ZWZ4                     BRANCH IF TEXT TRIVIAL          25153000
         BO    ZWP1                     BRANCH IF FLOAT PT AND NON-ZERO 25154000
         EJECT                                                          25155000
*N                                                                      25156000
*N FORMAT FIXED POINT RESULT.                                           25157000
*N                                                                      25158000
ZWN1     TM    ZWACC+L'ZWACC-4,BIT0     TEST DROPPED BIT                25159000
         BZ    ZWN2                       NO ROUND NEEDED               25160000
         LA    ZWRI,L'ZWACC-4           LOAD INDEX REG                  25161000
ZWN3     LA    ZWRA,1                   LOAD ROUND/CARRY BIT            25162000
         AL    ZWRA,ZWACC-4(ZWRI)       ADD IN PIECE OF VALUE           25163000
         ST    ZWRA,ZWACC-4(ZWRI)                                       25164000
         BC    12,ZWN2                  IF NO CARRY, GO QUIT            25165000
         SH    ZWRI,=H'4'                 ELSE PROPAGATE CARRY          25166000
         BP    ZWN3                         THRU ALL OF ZWACC           25167000
         OI    ZARYERR(ZWRARY),DCTRUN   IF CARRY OUT, SET TRUNC. INDIC. 25168000
ZWN2     CLI   0(ZWRJ),JMINUS           IF VALUE SIGN IS NEGATIVE       25169000
         BE    ZWN4                       GO DO NEG. OUTPUT             25170000
* VALUE IS POSITIVE.  MOVE INTACT TO OUTPUT.                            25171000
         LM    ZWRG,ZWRB,ZWACC                                          25172000
         STM   ZWRG,ZWRB,ZARYCON(ZWRARY)  STORE IN OUTPUT AREA          25173000
* TEST FOR TRUNCATION OF HIGH-ORDER BITS (POSITIVE DATA)                25174000
         CH    ZWRC,=H'-63'             IS LENGTH OVER 2 WORDS          25175000
         BL    ZWN6                       YES.  GO DO HI 2 WORDS        25176000
         OR    ZWRG,ZWRH                TEST HI 2 WORDS FIRST           25177000
         BNZ   ZWN8                     SHOULD BE ZERO                  25178000
         SLDA  ZWRA,63(ZWRC)            TEST TRUN. IN BITS OF LO 2 WDS  25179000
         B     ZWN6+L'ZWN6                THEN GO TEST                  25180000
ZWN6     SLDA  ZWRG,127(ZWRC)           TEST TRUN. IN BITS OF HI 2 WDS  25181000
         BC    10,ZWZ5                  IF OKAY GO PUT IT OUT           25182000
         B     ZWN8                     ELSE GO LOG ERROR               25183000
* VALUE IS NEGATIVE.  COMPLIMENT IT AND PUT IN OUTPUT.                  25184000
ZWN4     LA    ZWRI,L'ZWACC-4           LOAD UP INDEX                   25185000
         SR    ZWRA,ZWRA                CLEAR REDUCTION BIT             25186000
ZWN5     L     ZWRB,ZWACC-4(ZWRI)       PICK UP A WORD                  25187000
         LCR   ZWRB,ZWRB                COMPLIMENT IT, 2'S COMP         25188000
         SLR   ZWRB,ZWRA                REDUCE TO 1'S COMP IF ABOVE    X25189000
                                            FIRST NON-ZERO WORD         25190000
         BC    2,ZWN0                   BRANCH IF VALUE IS STILL ZERO   25191000
* BRANCH GOES WRONG IF ZERO IS DEVELOPED ABOVE 1ST NON-ZERO. BUT THAT'S 25192000
*  OKAY, AS, ONCE ZWRA IS = 1, RELOADING IT DOESN'T MATTER ANYWAY.      25193000
         LA    ZWRA,1                   BEGIN 1'S COMPLIMENT NEXT WORD  25194000
ZWN0     ST    ZWRB,ZARYCON-4(ZWRARY,ZWRI) STORE IN OUTPUT AREA         25195000
         SH    ZWRI,=H'4'               NEXT                            25196000
         BP    ZWN5                       WORD                          25197000
* TEST FOR TRUNCATION OF HIGH-ORDER BITS (NEGATIVE DATA)                25198000
         LM    ZWRG,ZWRB,ZARYCON(ZWRARY) PICK UP COMP. VALUE            25199000
         CH    ZWRC,=H'-63'             IS LENGTH OVER 2 WORDS          25200000
         BL    ZWN7                       YES.  GO DO HI 2 WORDS        25201000
         SLDA  ZWRG,63                  TEST HI 2 WORDS FIRST           25202000
         BC    3,ZWN8                   SHOULD BE MAX NEG OR ZERO       25203000
         SLDA  ZWRA,63(ZWRC)            TEST TRUN. IN BITS OF LO 2 WDS  25204000
         B     ZWN7+L'ZWN7                THEN GO TEST                  25205000
ZWN7     SLDA  ZWRG,127(ZWRC)           TEST TRUN. IN BITS OF HI 2 WDS  25206000
         BC    12,ZWZ5                  IF OKAY GO PUT IT OUT           25207000
* SET TRUNCATION INDICATOR AND GO PUT OUT VALUE                         25208000
ZWN8     OI    ZARYERR(ZWRARY),DCTRUN   ELSE SET TRUNCATION BIT         25209000
         B     ZWZ5                         THEN GO PUT IT OUT.         25210000
         EJECT                                                          25211000
*P                                                                      25212000
*P NORMALIZE FLOATING POINT RESULT                                      25213000
*P                                                                      25214000
ZWP1     L     ZWRD,ZARYSCL(ZWRARY)     GET S-MODIFIER                  25215000
         CLI   ZWACC,BIT3               IS HIGH HEX DIGIT GT 0          25216000
         BNL   ZWP2                     -YES.                           25217000
* VALUE NEEDS NORMALIZATION.            -NO.                            25218000
         MVC   ZWW1(L'ZWACC),ZWACC      PUT IN TEMP STORAGE             25219000
         MVO   ZWACC+10(10),ZWW1+10(10) SHIFT VALUE LEFT 4 BITS         25220000
         MVO   ZWACC+00(11),ZWW1+00(11)                                 25221000
         AH    ZWRL,=H'4'               ADJUST WORKING SCALE FACTOR     25222000
         B     ZWP1                     RETEST NORMALIZATION            25223000
* ROUND VALUE TO LENGTH                                                 25224000
*   CALCULATE LEFT SHIFT FOR ROUNDING-BIT                               25225000
ZWP2     LR    ZWRE,ZWRD                GRAB S-MOD (HEX BYTES)          25226000
         SLA   ZWRE,2                     MAKE INTO BITS                25227000
         TM    ZWSW,BIT4                IS THIS AN L-CON                25228000
         BZ    ZWP3                       NO. GO TO  D-,E- FORMULA      25229000
         CH    ZWRC,=H'-63'               YES. IS LENGTH .GT. 64 BITS   25230000
         BNL   ZWP3                         NO. USE D,E-CON FORMULA     25231000
         CH    ZWRC,=H'-71'                 YES. IS LENGTH .GT. 72      25232000
         BL    ZWP4                           YES. USE LONG L FORMULA   25233000
         SH    ZWRE,=H'-71'                   NO. SPECIAL L FORMULA,    25234000
         B     ZWP5                             GO SHIFT                25235000
ZWP4     AH    ZWRE,=H'8'               LONG L-CON FORM.                25236000
ZWP3     AH    ZWRE,=H'134'             SHORT L-CON, D-E-CON.           25237000
         AR    ZWRE,ZWRC                SUBTRACT LENGTH-1               25238000
*                                                                       25239000
ZWP5     CH    ZWRE,=H'127'             WILL ANY OF VALUE BE RETAINED   25240000
         BH    ZWQ1                       NO.  SKIP ROUNDING.           25241000
         SRDL  ZWRE,5                   SPLIT SHIFT INTO                25242000
         SRL   ZWRF,32-5                  BITS AND                      25243000
         SLL   ZWRE,2                     WORDS  (IN BYTE TERMS).       25244000
         LCR   ZWRE,ZWRE                                                25245000
         LA    ZWRI,L'ZWACC-4(,ZWRE)    INIT INDEX WORD-SHIFT ADJUSTED  25246000
         LA    ZWRA,1                   LOAD ROUND BIT                  25247000
         SLL   ZWRA,0(ZWRF)             POSITION IT                     25248000
ZWP6     AL    ZWRA,ZWACC-4(ZWRI)       ADD IN PIECE OF VALUE           25249000
         ST    ZWRA,ZWACC-4(ZWRI)                                       25250000
         BC    12,ZWQ1                  IF NO CARRY, GO QUIT            25251000
         LA    ZWRA,1                     ELSE LOAD CARRY REGISTER,     25252000
         SH    ZWRI,=H'4'                                               25253000
         BP    ZWP6                       GO PROPAGATE CARRY            25254000
*OVERFLOW ON ROUNDING. NUTS.                                            25255000
         MVI   ZWACC,X'10'              PUT CORRECTED VALUE             25256000
         SH    ZWRL,=H'4'  (ART'S FIX)  ADJUST WORKING SCALE FACTOR     25257000
         EJECT                                                          25258000
*Q                                                                      25259000
*Q SHIFT RIGHT PER SCALE MOD., PLACE EXPONENT(S), POSITION FOR OUTPUT   25260000
*Q                                                                      25261000
ZWQ1     LR    ZWRB,ZWRD                GET S-MOD                       25262000
         AH    ZWRB,=H'1'               BUMP TO MOVE EXTRA BYTE IF     X25263000
                                          S-MOD IS ODD                  25264000
         SRA   ZWRB,1                   MAKE INTO BYTES                 25265000
         XC    ZWW1(L'ZWACC-3),ZWW1     CLEAR NEW HIGH BYTES            25266000
         LA    ZWRI,ZWW1+1(ZWRB)        INDEX MOVE. ADD 1 FOR EXP.      25267000
         MVC   0(L'ZWACC-5,ZWRI),ZWACC  MOVE AND SHIFT BY BYTES         25268000
         TM    ZARYSCL+3(ZWRARY),BIT7   WAS S-MOD ODD                   25269000
         BZ    ZWQ2                       NO. LET IT SIT                25270000
         MVO   ZWW1+1(16),ZWW1+1(16)    SHIFT BACK 1 HEX DIGIT          25271000
ZWQ2     MVC   ZWACC(L'ZWACC-3),ZWW1    BRING IT HOME                   25272000
*VALUE IN ZWW1 USED LATER IN LOST PRECISION TEST                        25273000
*                                                                       25274000
*CALCULATE EXPONENT BYTE AND INSERT IT IN VALUE                         25275000
         LA    ZWRB,384                 FORM                            25276000
         SR    ZWRB,ZWRL                  CHARACTERISTIC                25277000
         SRA   ZWRB,2                                                   25278000
         AR    ZWRB,ZWRD                ADJUST FOR S-MODIFIER           25279000
         LR    ZWRA,ZWRB                                                25280000
         SRA   ZWRA,7                   TEST FOR                        25281000
ZWQ7     LA    ZWRH,ZRCD70              CHARACTERISTIC                  25282000
         BNZ   ZWZ3                       OUT OF BOUNDS                 25283000
         CLI   0(ZWRJ),JMINUS           IF VALUE IS NEGATIVE            25284000
         BNE   ZWQ6                       NOT NEG                       25285000
         LA    ZWRB,X'80'(,ZWRB)          PUT - SIGN                    25286000
ZWQ6     STC   ZWRB,ZWACC               PLUG IN EXPONENT                25287000
         TM    ZWSW,BIT4                IS THIS A L-CON                 25288000
         BZ    ZWQ3                       NO.  GO DO FINALS.            25289000
*THIS IS AN L-CON, PROCESS LOWER EXPONENT                               25290000
         LM    ZWRE,ZWRF,ZWACC+8        PICK LOW 2 WORDS                25291000
         SRDL  ZWRE,8                   MAKE ROOM FOR EXPONENT          25292000
         STM   ZWRE,ZWRF,ZWACC+8                                        25293000
         STM   ZWRE,ZWRF,ZWW1+8         SAVE FOR LATER TEST             25294000
         SH    ZWRB,=H'14'              LOWER EXPONENT IS 14 LESS       25295000
         STC   ZWRB,ZWACC+8             PLUG IT IN                      25296000
* IF LOW EXPONENT UNDERFLOWED, THE SIGN BIT WILL BE WRONG.              25297000
*  CORRECT FOR THAT POSSIBILITY.                                        25298000
         NI    ZWACC+8,BITFF-BIT0       KILL WHATEVER SIGN BIT          25299000
         CLI   0(ZWRJ),JMINUS           IS VALUE NEGATIVE               25300000
         BNE   ZWQ3                     BIF NO                          25301000
         OI    ZWACC+8,BIT0             YES, PUT - SIGN                 25302000
* CLODDY LOOP TO SHIFT VALUE FROM ZWACC TO DCVW, AND ALSO MOVE          25303000
* TEST VALUE FROM ZWW1 TO LOW ZWW1.                                     25304000
ZWQ3     AH    ZWRC,=H'127'             COMPUTE SHIFT                   25305000
         SRDL  ZWRC,5                                                   25306000
         SRL   ZWRD,32-5                BIT SHIFT                       25307000
         SLL   ZWRC,2                   WORD SHIFT IN BYTES             25308000
         XC    ZARYCON(12,ZWRARY),ZARYCON(ZWRARY)  CLEAR RECEIVING AREA 25309000
         XC    ZWW1+16(12),ZWW1+16      CLEAR RECIEVING AREA            25310000
         SR    ZWRI,ZWRI                CLEAR LOOP INDEX                25311000
         SR    ZWRG,ZWRG                CLEAR CARRY REG                 25312000
         SR    ZWRH,ZWRH                CLEAR CARRY REG                 25313000
ZWQ4     L     ZWRE,ZWACC(ZWRI)         PICK UP WORD                    25314000
         L     ZWRL,ZWW1(ZWRI)          PICK UP WORD                    25315000
         SR    ZWRF,ZWRF                CLEAR RH WORD                   25316000
         SR    ZWRJ,ZWRJ                CLEAR RH WORD                   25317000
         SRDL  ZWRE,0(ZWRD)             SHIFT PER BIT SHIFT             25318000
         SRDL  ZWRL,0(ZWRD)             SHIFT PER BIT SHIFT             25319000
         OR    ZWRE,ZWRG                PUT IN BIT FROM PREVIOUS WORD   25320000
         OR    ZWRL,ZWRH                PUT IN BIT FROM PREVIOUS WORD   25321000
         LR    ZWRG,ZWRF                SAVE OUTSHIFT FOR NEXT WORD     25322000
         LR    ZWRH,ZWRJ                SAVE OUTSHIFT FOR NEXT WORD     25323000
         LA    ZWRB,0(ZWRI,ZWRC)        ADD 2 INDEX REGS TOGETHER       25324000
         ST    ZWRE,ZARYCON(ZWRARY,ZWRB)  PUT WORD OFFSET PER WD SHIFT  25325000
         ST    ZWRL,ZWW1+16(ZWRB)       PUT WORD OFFSET PER WD SHIFT    25326000
         AH    ZWRI,=H'4'               BUMP INDEX                      25327000
         CH    ZWRB,=H'12'              TEST WHERE LATEST WD STORED     25328000
         BL    ZWQ4                       BR IF NOT LAST WORD           25329000
* TEST THE VALUE AT ZWW1+4 FOR LOST PRECISION                           25330000
         OC    ZWW1+16(16),ZWW1+16      ZERO IF SHIFTED OUT ALL BITS    25331000
         BNZ   ZWZ5                       IF BIT, GO OUTPUT             25332000
         LA    ZWRH,ZRCD109                                             25333000
         BAL   ZWRG,MERROR              POST ERROR MESSAGE, THEN        25334000
         B     ZWZ5                       GO OUTPUT                     25335000
         EJECT                                                          25336000
*S1                                                                     25337000
*S1 STEP OVER SIGN.                                                     25338000
*S1                                                                     25339000
ZWS1     CLI   0(ZWRB),JPLUS            IF CHARACTER IS PLUS            25340000
         BE    ZWS11                    BRANCH                          25341000
         CLI   0(ZWRB),JMINUS           IF CHARACTER                    25342000
         BCR   7,ZWRG                IS - RETURN                        25343000
ZWS11    LA    ZWRB,1(ZWRB)        STEP TEXT POINTER                    25344000
         BR    ZWRG                     RETURN                          25345000
*Z                                                                      25346000
*Z ERROR ROUTINE  AND RETURN ROUTINE.                                   25347000
*Z                                                                      25348000
ZWZ4     LA    ZWRH,ZRCD39              LOAD ERROR NUMBER               25349000
ZWZ3     BAL   ZWRG,MERROR         STORE ERROR MESSAGE                  25350000
         XC    16(16,ZWRARY),16(ZWRARY) CLEAR OUTPUT AREA               25351000
ZWZ5     LR    R10,ZWRLAST              LOAD POINTER TO TERM CHAR       25352000
         LR    R11,ZWRARY               RESTORE INPUT ARRAY POINTER     25353000
XIT      JRETURN ,                      EXIT                            25354000
*                                                                       25355000
MERROR   STC   ZWRH,ZARYERR(0,ZWRARY)   SET ERROR                       25356000
         BR    ZWRG                     AND RETURN                      25357000
         EJECT                                                          25358000
*DECON- CONVERT A PIECE OF THE VALUE                                    25359000
*       INPUT- CONDEX POINTS TO FIRST CHAR                              25360000
*       OUTPUT-BINVAL CONTAINS CONVERTED VALUE                          25361000
*              CONDEX TO TERMINATING CHAR                               25362000
*              ZWRF POINTS TO FIRST CHAR OF FIELD                       25363000
*              VASCTL CONTAINS X'00'  NO ERRORS                         25364000
*                        BIT1  X'40'  TOO LONG                          25365000
*                        BIT0  X'80'  NO CHAR TO CONVERT                25366000
         SPACE 2                                                        25367000
DECON    MVI   VASCTL,BIT0-BIT0         AND FLAG                        25368000
         ST    CONDEX,AFIRST            SAVE POINTER TO BEGINNING-1     25369000
ADDIT    CLI   0(CONDEX),J9             IS CHARACTER NUMERIC            25370000
         BH    SETUP                    NO, BRANCH                      25371000
         LA    CONDEX,1(0,CONDEX)       UP TO NEXT CHAR                 25372000
         B     ADDIT                    LOOP, LOOKING FOR NON-NUMERIC   25373000
SETUP    ST    CONDEX,SAVEAD            SAVE END POINTER                25374000
         LR    CNT,CONDEX               LOAD ENDING POINTER             25375000
         L     CONDEX,AFIRST            BEGIN AT BEGINNING              25376000
         SR    CNT,CONDEX               MINUS BEGINNING PTR = # OF CHAR 25377000
         BZ    ZNONE                    BRANCH IF NO CHAR TO CONVERT    25378000
SET1     CH    CNT,=H'10'               YES, IS IT GREATER THAN MAX     25379000
         BL    GOTOIT                   NO, OK                          25380000
         BH    GTTEN                    YES, TRY TO GET DOWN TO NINE    25381000
         CLC   0(10,CONDEX),=X'02010407040803060407'  =10 CHARS, IS IT X25382000
                                                        .GT. 2**31-1    25383000
         BNH   GOTOIT                   NO, CONVERT                     25384000
ZLONG    OI    VASCTL,BIT1              YES, SET FLAG                   25385000
         LA    CNT,9                    AND CONVERT 9                   25386000
GOTOIT   BCTR  CNT,0                    DECREMENT FOR MOVE              25387000
         EX    CNT,PACKIT               PACK VALUE INTO HOLD            25388000
         OI    HOLD+7,BIT4+BIT5         SET POSITIVE SIGN               25389000
         CVB   BINVAL,HOLD              CONVERT HOLD TO BINARY          25390000
LEAV     LR    ZWRF,CONDEX              SET TO FIRST CHAR               25391000
         L     CONDEX,SAVEAD            SET TO TERMINATOR               25392000
         BR    REG                      RETURN                          25393000
GTTEN    CLI   0(CONDEX),J0             IS FIRST CHARACTER A ZERO       25394000
         BNE   ZLONG                    NO, TOO LONG                    25395000
         LA    CONDEX,1(0,CONDEX)       YES, IGNORE ZERO                25396000
         BCTR  CNT,0                    DECREMENT COUNT                 25397000
         LTR   CNT,CNT                  ARE THERE CHAR TO CONVERT       25398000
         BNZ   SET1                    YES, NOW SEE IF SHORT ENOUGH     25399000
ZNONE    OI    VASCTL,BIT0              SET CODE, NONE TO CONVERT       25400000
         B     LEAV                     AND EXIT                        25401000
PACKIT   PACK  HOLD(8),0(00,CONDEX)     EXECUTED PACK TO PACK HOLD      25402000
         EJECT                                                          25403000
*                                                                       25404000
*LITERAL POOL                                                           25405000
*                                                                       25406000
         SPACE                                                          25407000
         LTORG                                                          25408000
*                                                                       25409000
         EJECT                                                          25410000
*                                                                       25411000
*REGISTER EQUATES                                                       25412000
*                                                                       25413000
ZWRA     EQU   R0                       REGISTERS- SCALE FACTOR         25414000
ZWRB     EQU   R1                                  POINTER TO SCAN CHAR 25415000
ZWRARY   EQU   R2                                  POINTER TO IN ARRAY  25416000
ZWRLAST  EQU   R5                                  LAST CONSTANT ADDR   25417000
ZWRC     EQU   R6                                  WORKING SCALE FACTOR 25418000
ZWRD     EQU   R7                                  LOWER LIMIT SCALE    25419000
ZWRE     EQU   R8                                  UPPER LIMIT SCALE    25420000
ZWRF     EQU   R9                                  LOW WORD OF RESULT   25421000
ZWRL     EQU   R10                                 POSITION OF DEC PONT 25422000
ZWRJ     EQU   R11                                 END POINTER          25423000
ZWRI     EQU   R12                                 EXPONENT MODIFIER    25424000
ZWRG     EQU   R14                                 ADJECTIVE EXPONENT   25425000
ZWRH     EQU   R15                                 BINARY RESULT        25426000
CONDEX   EQU   ZWRB                     POINTER TO SCAN CHAR            25427000
CNT      EQU   ZWRF                     COUNTER FOR CHAR TO CONVERT     25428000
REG      EQU   ZWRG                     RETURN REGISTER-DECON           25429000
BINVAL   EQU   ZWRH                     BINARY VALUE-DECON              25430000
*                                                                       25431000
*ERROR CODE EQUATES                                                     25432000
*                                                                       25433000
ZRCD11   EQU   BIT0                     SCALE MODIFIER ERROR            25434000
ZRCD13   EQU   BIT1                     EXPONENT MODIFIER ERROR         25435000
DCTRUN   EQU   BIT2                     TRUNCATION ERROR                25436000
ZRCD39   EQU   BIT3                     INVALID DELIMITER               25437000
ZRCD70   EQU   BIT4         FLOATING POINT CHARACTERISTIC OUT OF RANGE  25438000
ZRCD109  EQU   BIT5                     PRECISION LOST                  25439000
*                                                                       25440000
*MODIFIER TYPES                                                         25441000
*                                                                       25442000
BTYPEFL  EQU   X'08'                    MODIFIER TYPE - FLOATING POINT  25443000
BTYPEL   EQU   X'06'                    L-CON MODIFIER TYPE             25444000
*                                                                       25445000
*INPUT ARRAY EQUATES                                                    25446000
*                                                                       25447000
*LENGTH IN BYTES IF SIGN = 0, LENGTH IN BITS IF SIGN = 1                25448000
ZARYSGN  EQU   0                        INPUT ARRAY - SIGN              25449000
ZARYERR  EQU   1                                      ERROR CODE        25450000
ZARYTYPE EQU   3                                      TYPE(BUCKET CODE) 25451000
ZARYLEN  EQU   4                                      LENGTH            25452000
ZARYSCL  EQU   8                                      SCALE FACTOR      25453000
ZARYEXP  EQU   12                                     EXTERNAL EXPONENT 25454000
ZARYCON  EQU   16                                     RIGHT JUSTIFIED  X25455000
                                                        CONSTANT        25456000
         JPATCH X5F00,5FA                                               25457000
         END                                                            25458000
./ ADD NAME=IFNX5V                                                      25459000
X5V      XEVAL                                                          25460000
         JPATCH X5V00,684                                               25461000
         END                                                            25462000
./ ADD NAME=IFNX6C                                                      25463000
         GBLC  &COMPNM,&ASMID                                           25464000
         JHEAD 'DIAGNOSTIC MESSAGE PHASE - PROLOG',                    X25465000
               PHASEID=X6C,                                            X25466000
               LEVEL=10                                                 25467000
*FUNCTION/OPERATION-                                                  * 25468000
*   THE DIAGNOSTIC MESSAGE PHASE CONTAINS THE ERROR MESSAGES CALLED   * 25469000
*   FOR BY THE ERROR RECORDS READ BY THE DIAGNOSTIC PHASE, X6B, AND   * 25470000
*   THE INDEX TABLE, MTABLE, USED TO ACCESS THE MESSAGES.  IT MUST BE * 25471000
*   LINK EDITED WITH X6B.  IT CONTAINS DATA ONLY, NO EXECUTABLE CODE. * 25472000
*                                                                     * 25473000
*ENTRY POINTS-                                                        * 25474000
*   ERRMSGS - BEGINNING OF LIST OF ERROR MESSAGES                     * 25475000
*   MTABLE  - BEGINNING OF ERROR MESSAGE INDEX TABLE                  * 25476000
*                                                                     * 25477000
*INPUT-                                                               * 25478000
*   NONE                                                              * 25479000
*                                                                     * 25480000
*OUTPUT-                                                              * 25481000
*   NONE                                                              * 25482000
*                                                                     * 25483000
*EXTERNAL ROUTINES-                                                   * 25484000
*   NONE                                                              * 25485000
*                                                                     * 25486000
*EXITS-                                                               * 25487000
*   NONE                                                              * 25488000
*                                                                     * 25489000
*ATTRIBUTES-                                                          * 25490000
*   REFRESHABLE                                                       * 25491000
   TITLE '&COMPNM&ASMID - DIAGNOSTIC MESSAGE PHASE - JCOMMON COPY CODE' 25492000
         COPY  JCOMMON                  MASTER COMMUNICATIONS AREA      25493000
      TITLE '&COMPNM&ASMID - DIAGNOSTIC MESSAGE PHASE - ERROR MESSAGES' 25494000
         JCSECT (X6C00)                 SECTION ID                      25495000
*C                                                             @AX21436 25496000
         JMODID                                                         25497000
ERRMSGS  DS    0C                       START OF ERROR MESSAGES         25498000
         JENTRY (X6C01=ERRMSGS)         ALTERNATE ENTRY POINT           25499000
S0       JGENIN 'UNDEFINED ERROR CODE'   ERROR 0 MESSAGE TEXT           25500000
         JGENERR GEN                                                    25501000
         GENTAB                                                         25502000
         JENTRY (X6C02=MTABLE)          ALTERNATE ENTRY POINT           25503000
         JPATCH X6C00,25A8              5% PATCH AREA                   25504000
         END                                                            25505000
./ ADD NAME=IFOX0E                                                      25506000
         GBLC  &COMPNM,&ASMID                                           25507000
         JHEAD 'INPUT COMMON LOAD MODULE - PROLOG',                    X25508000
               PHASEID=X0E,                                            X25509000
               LEVEL=10                                                 25510000
*                                                                     * 25511000
*FUNCTION/OPERATION-                                                  * 25512000
*   THIS MODULE IS THE INPUT COMMON WORK AREA FOR THE INPUT I/O PACK- * 25513000
*   AGE.  THE IS LOAD BY THE DRIVER.  REGISTER R7 POINTS TO THIS      * 25514000
*   MODULE WHILE THE INPUT I/O PACKAGE HAS CONTROL.                   * 25515000
*                                                                     * 25516000
*ENTRY POINT-                                                         * 25517000
*   N/A                                                               * 25518000
*                                                                     * 25519000
*INPUT-                                                               * 25520000
*   SYSIN, SYSLIB.                                                    * 25521000
*                                                                     * 25522000
*OUTPUT-                                                              * 25523000
*   N/A                                                               * 25524000
*                                                                     * 25525000
*EXTERNAL ROUTINES-                                                   * 25526000
*   N/A                                                               * 25527000
*                                                                     * 25528000
*EXITS, NORMAL-                                                       * 25529000
*   N/A                                                               * 25530000
*                                                                     * 25531000
*EXITS, ERROR-                                                        * 25532000
*   BRANCH TO JABORT IN COMMON.                                       * 25533000
*                                                                     * 25534000
*TABLE/WORK AREAS-                                                    * 25535000
*   THIS MODULE IS ONE ENTIRE WORK AREA.                              * 25536000
*                                                                     * 25537000
*ATTRIBUTES-                                                          * 25538000
*   NON-REFRESHABLE                                                   * 25539000
*                                                                     * 25540000
*NOTES-                                                               * 25541000
         SPACE 3                                                        25542000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   25543000
         COPY  JCOMMON                  JCOMMON COPY CODE               25544000
         PRINT OFF                      DON'T PRINT JINCOM COPY CODE    25545000
         COPY  JINCOM                   JINCOM COPY CODE                25546000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  25547000
         COPY  JERMSGCD                 JERMSGCD COPY CODE              25548000
         PRINT ON                       THAT'S ALL THE COPY CODE        25549000
         TITLE '&COMPNM&ASMID - INPUT COMMON LOAD MODULE - DECB'        25550000
         JCSECT (X0E00)                 SECTION ID                      25551000
         JMODID                                                         25552000
         USING START,R7                 ESTABLISH A BASE                25553000
START    DS    0D                                                       25554000
         JENTRY (X0E01=START)           ENTRY POINT FOR MODULE          25555000
         ORG   START+JSYSIN-JINCOM      ADDR OF INPUT FILE DEF          25556000
         DC    A(SYSIN)                         ''                      25557000
         ORG   START+JSYSLIB-JINCOM     ADDR OF LIB FILE DEF            25558000
         DC    A(SYSLIB)                         ''                     25559000
         ORG   START+JINOPEN-JINCOM     ADDR OF OPEN PARM LIST          25560000
         DC    A(INOPEN)                         ''                     25561000
         ORG   START+JINCLOS-JINCOM     ADDR OF CLOSE PARM LIST         25562000
         DC    A(INCLOS)                         ''                     25563000
         ORG   START+JLIBDECB-JINCOM    DECB FOR LIBRARY                25564000
         READ  LIBDECB,SF,SYSLIB,MF=L        READ                       25565000
         ORG   START+JINSW-JINCOM       ZERO INPUT SWITCH               25566000
         DC    X'00'                          ''                        25567000
         ORG   START+JINCMEND-JINCOM    END OF INPUT COMMON             25568000
         SPACE 3                                                        25569000
         TITLE '&COMPNM&ASMID - INPUT COMMON LOAD MODULE - OPEN AND CLOX25570000
               SE LISTS'                                                25571000
INOPEN   OPEN  (SYSIN,(INPUT,DISP),SYSLIB,(INPUT,DISP)),MF=L PARM LIST  25572000
         SPACE 3                                                        25573000
INCLOS   CLOSE (SYSIN,DISP,SYSLIB,DISP),MF=L INPUT CLOSE PARM LIST      25574000
         SPACE 3                                                        25575000
ABORTSYN LA    R10,ERR261               SYNAD EXIT (I/O ERROR) ABORT    25576000
         LR    R11,R0                   SAVE R0 FOR ABORT ROUTINE       25577000
         B     JABORT                   GO ABORT                        25578000
         SPACE 3                                                        25579000
EOF      SR    R11,R11                  EOF ON INPUT FILE. RETURN WITH  25580000
         BR    R6                       CC=0 TO INDICATE EOF            25581000
         SPACE 3                                                        25582000
XTINLIB  DC    0F'0',X'85',AL3(*+3)     SYSIN & SYSLIB DCB EXIT         25583000
         BR    R10                      R10 LOADED BEFORE OPEN          25584000
         SPACE 3                                                        25585000
         TITLE '&COMPNM&ASMID - INPUT COMMON LOAD MODULE - SYSIN DCB'   25586000
SYSIN    DCB   DSORG=PS,DEVD=DA,MACRF=(GL),BFTEK=S,SYNAD=ABORTSYN,     X25587000
               DDNAME=SYSIN,LRECL=80,EODAD=EOF,EXLST=XTINLIB            25588000
         SPACE 3                                                        25589000
         TITLE '&COMPNM&ASMID - INPUT COMMON LOAD MODULE - SYSLIB DCB'  25590000
SYSLIB   DCB   DSORG=PO,DEVD=DA,MACRF=(R),SYNAD=ABORTSYN,              X25591000
               DDNAME=SYSLIB,LRECL=80,EODAD=EOF,EXLST=XTINLIB           25592000
         SPACE 5                                                        25593000
         JPATCH X0E00,118               5% PATCH AREA                   25594000
         END   START                                                    25595000
./ ADD NAME=IFOX0G                                                      25596000
* /* START OF SPECIFICATIONS ****                                       25597000
*02* PROCESSOR = ASSEMBLER                                              25598000
**** END OF SPECIFICATIONS ***/                                         25599000
         GBLC  &COMPNM,&ASMID                                           25600000
         JHEAD 'OUTPUT COMMON LOAD MODULE - PROLOG',                   X25601000
               PHASEID=X0G,                                            X25602000
               LEVEL=10                                                 25603000
*                                                                     * 25604000
*FUNCTION/OPERATION-                                                  * 25605000
*   THIS MODULE IS THE OUTPUT COMMON WORK AREA FOR THE OUTPUT I/O     * 25606000
*   PACKAGE.  THIS IS LOADED BY THE DRIVER.  REGISTER R7 POINTS TO    * 25607000
*   THIS MODULE WHILE THE INPUT I/O PACKAGE HAS CONTROL.              * 25608000
*                                                                     * 25609000
*ENTRY POINT-                                                         * 25610000
*   N/A                                                               * 25611000
*                                                                     * 25612000
*INPUT-                                                               * 25613000
*   N/A                                                               * 25614000
*                                                                     * 25615000
*OUTPUT-                                                              * 25616000
*   SYSPRINT, SYSPUNCH, SYSLIN.                                       * 25617000
*                                                                     * 25618000
*EXITS, NORMAL-                                                       * 25619000
*   N/A                                                               * 25620000
*                                                                     * 25621000
*EXITS, ERROR-                                                        * 25622000
*   BRANCH TO JABORT IN COMMON.                                       * 25623000
*                                                                     * 25624000
*TABLE/WORK AREAS-                                                    * 25625000
*   THIS MODULE IS ONE ENTIRE WORK AREA.                              * 25626000
*                                                                     * 25627000
*ATTRIBUTES-                                                          * 25628000
*   NON-REFRESHABLE.                                                  * 25629000
*                                                                     * 25630000
*NOTES-                                                               * 25631000
         SPACE 2                                                        25632000
         PRINT OFF                      DON'T PRINT JCOMMON COPY CODE   25633000
         COPY  JCOMMON                                                  25634000
         PRINT OFF                      DON'T PRINT JERMSGCD COPY CODE  25635000
         COPY  JERMSGCD                                                 25636000
         PRINT ON                       THAT'S ALL WE WON'T PRINT       25637000
      TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - JOUTCOM DSECT' 25638000
         COPY  JOUTCOM                                                  25639000
         SPACE 2                                                        25640000
       TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - POINTER LIST' 25641000
         JCSECT (X0G00)                                                 25642000
         JMODID                         EMBEDDED IDENTIFIER             25643000
         USING START,R7                                                 25644000
START    DS    0D                                                       25645000
         JENTRY (X0G01=START)                                           25646000
         ORG   START+JSYSLST-JOUTCOM    ADDRESS OF PRINT FILE DEF       25647000
         DC    A(SYSLST)                         ''                     25648000
         ORG   START+JSYSPCH-JOUTCOM    ADDR OF PUNCH FILE DEF          25649000
         DC    A(SYSPCH)                         ''                     25650000
         ORG   START+JSYSLNK-JOUTCOM    ADDR OF LINK FILE DEF           25651000
         DC    A(SYSLNK)                         ''                     25652000
         ORG   START+JSYSTRM-JOUTCOM    ADDR OF TERM FILE DEF           25653000
         DC    A(SYSTRM)                         ''                     25654000
         ORG   START+JOUTOPEN-JOUTCOM   ADDR OF OUTPUT OPEN PARM LIST   25655000
         DC    A(OUTOPEN)                        ''                     25656000
         ORG   START+JOUTCLOS-JOUTCOM   ADDR OF OUTPUT CLOSE PARM LIST  25657000
         DC    A(OUTCLOS)                        ''                     25658000
         ORG   JDECKSEQ+START-JOUTCOM   ZERO DECK SEQUENCE NUMBER       25659000
         DC    H'0'                           ''                        25660000
         ORG   START+JOUTSW-JOUTCOM     ZERO JOUTSW                     25661000
         DC    X'00'                          ''                        25662000
         ORG   START+JOUTCMND-JOUTCOM   END OF OUTPUT COMMON            25663000
         SPACE 5                                                        25664000
       TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - OPEN AND CLOSX25665000
               E LISTS FOR SYSPUNCH, SYSPRINT AND SYSGO'                25666000
OUTOPEN  OPEN  (SYSLST,(OUTPUT,DISP),SYSPCH,(OUTPUT,DISP),SYSLNK,      X25667000
               (OUTPUT,DISP),SYSTRM,(OUTPUT,DISP)),MF=L OPEN PARM LIST  25668000
OUTCLOS  CLOSE (SYSLST,DISP,SYSPCH,DISP,SYSLNK,DISP,SYSTRM,DISP),MF=L  *25669000
                                        OUTPUT CLOSE PARM LIST          25670000
         SPACE 3                                                        25671000
XTPRT    DC    0F'0',X'85',AL3(*+3)     SYSPRINT DCB EXIT               25672000
         BR    R10                      R10 LOADED BEFORE OPEN          25673000
         SPACE 3                                                        25674000
XTPCHLIN DC    0F'0',X'85',AL3(*+3)     SYSPUNCH & SYSLIN DCB EXIT      25675000
         BR    R11                      R11 LOADED BEFORE OPEN          25676000
         SPACE 3                                                        25677000
ABORTSYN LA    R10,ERR261               SYNAD EXIT (I/O ERROR) ABORT    25678000
         LR    R11,R0                   SAVE R0 FOR ABORT ROUTINE       25679000
         B     JABORT                   GO ABORT                        25680000
         SPACE 3                                                        25681000
       TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - SYSPRINT DCB' 25682000
SYSLST   DCB   DSORG=PS,DEVD=DA,MACRF=(PL),BFTEK=S,SYNAD=ABORTSYN,     X25683000
               DDNAME=SYSPRINT,LRECL=121,EXLST=XTPRT                    25684000
         SPACE 3                                                        25685000
       TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - SYSPUNCH DCB' 25686000
SYSPCH   DCB   DSORG=PS,DEVD=DA,MACRF=(PL),BFTEK=S,SYNAD=ABORTSYN,     X25687000
               DDNAME=SYSPUNCH,LRECL=80,EXLST=XTPCHLIN                  25688000
         SPACE 3                                                        25689000
       TITLE '&COMPNM&ASMID - OUTPUT COMMON LOAD MODULE - SYSGO DCB'    25690000
SYSLNK   DCB   DSORG=PS,DEVD=DA,MACRF=(PL),BFTEK=S,SYNAD=ABORTSYN,     X25691000
               DDNAME=SYSGO,LRECL=80,EXLST=XTPCHLIN                     25692000
SYSTRM   DCB   DSORG=PS,DEVD=DA,MACRF=(PL),BFTEK=S,SYNAD=ABORTSYN,     *25693000
               DDNAME=SYSTERM,LRECL=121,EXLST=XTPRT                     25694000
               SPACE 5                                                  25695000
         JPATCH X0G00,1E8               5% PATCH AREA                   25696000
         SPACE 3                                                        25697000
         END   START                                                    25698000
./ ADD NAME=IFOX0I                                                      25699000
* /* START OF SPECIFICATIONS ****                                       25700000
*02* PROCESSOR = ASSEMBLER                                              25701000
**** END OF SPECIFICATIONS ***/                                         25702000
         GBLC  &COMPNM,&ASMID                                           25703000
         SPACE 5                                                        25704000
         JHEAD 'ABORT ROUTINE - PROLOG',                               X25705000
               PHASEID=X0I,                                            X25706000
               LEVEL=10                                                 25707000
*                                                                     * 25708000
*FUNCTION/OPERATION-                                                  * 25709000
*   THIS MODULE IS CALLED WHEN AN IRRECOVERABLE ERROR EXISTS.  IT IS  * 25710000
*   ENTERED FOR PERMANENT I/O ERRORS, MISSING DD CARDS (SYSPRINT,     * 25711000
*   SYSUT1, SYSUT2, SYSUT3, SYSIN), INSUFFICIENT MEMORY AND CERTAIN   * 25712000
*   PROGRAM LOGIC ERRORS.  THIS ROUTINE FREES ALL CORE, CLOSES ALL    * 25713000
*   FILES, FREEPOOL AS NECESSARY, WRITES A MESSAGE TO THE OPERATOR    * 25714000
*   AND DELETES ALL LOADED PHASES EXCEPT ITSELF AND COMMON.           * 25715000
*                                                                     * 25716000
*ENTRY POINT-                                                         * 25717000
*        START - ENTER BY LOAD AND BRANCH FROM DRIVER                 * 25718000
*                                                                     * 25719000
*INPUT-                                                               * 25720000
*   REGISTER R10 CONTAINS THE VALUE OF ERR260, ERR261, ERR262 OR      * 25721000
*   ERR263 DEPENDING UPON THE ERROR.                                  * 25722000
*   REGISTER R11 CONTAINS THE VALUE OF R1 AT THE TIME THE ASSEMBLER   * 25723000
*   WAS INVOKED (PARAMETER LIST PTR) (VALID ONLY FOR ERR260).         * 25724000
*   REGISTER R11 CONTAINS THE CONTENTS OF R0 AT THE TIME THE SYNAD    * 25725000
*   EXIT WAS TAKEN (VALID ONLY FOR ERR261).                           * 25726000
*   REGISTER R2 CONTAINS THE DCB ADDRESS (VALID ONLY FOR ERR261).     * 25727000
*                                                                     * 25728000
*OUTPUT-                                                              * 25729000
*   MESSAGE TO PROGRAMMER USING WTP MACRO                             * 25730000
*                                                                     * 25731000
*EXTERNAL ROUTINES-                                                   * 25732000
*   N/A                                                               * 25733000
*                                                                     * 25734000
*EXITS, NORMAL-                                                       * 25735000
*   RETURN TO DRIVER BY JRETURN MACRO                                 * 25736000
*                                                                     * 25737000
*EXITS, ERROR-                                                        * 25738000
*   N/A                                                               * 25739000
*                                                                     * 25740000
*TABLE/WORK AREAS-                                                    * 25741000
*   REGISTER R13 POINTS TO COMMON.                                    * 25742000
*   JTRTABLE IN COMMON USED AS BUFFER WORKSPACE.                      * 25743000
*                                                                     * 25744000
*ATTRIBUTES-                                                          * 25745000
*   REFRESHABLE.                                                      * 25746000
*                                                                     * 25747000
*NOTES-                                                               * 25748000
         SPACE 5                                                        25749000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - JCOMMON COPY CODE'      25750000
         COPY  JCOMMON                  JCOMMON COPY CODE               25751000
         SPACE 3                                                        25752000
BUFFER   EQU   J+((JTRTABLE+3-J)/4)*4   MESSAGE BUF FULLWORD BOUNDARY   25753000
         SPACE 3                                                        25754000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - JINCOM COPY CODE'       25755000
         COPY  JINCOM                   X0E, X0F INPUT COMMON           25756000
         SPACE 5                                                        25757000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - JOUTCOM COPY CODE'      25758000
         COPY  JOUTCOM                  X0G, X0H OUTPUT COMMON          25759000
         SPACE 5                                                        25760000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - JERMSGCD COPY CODE'     25761000
         COPY  JERMSGCD                 JERMSGCD COPY CODE              25762000
         SPACE 5                                                        25763000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - DCBD MACRO'             25764000
         DCBD  DSORG=(PO,PS),DEVD=DA                                    25765000
         SPACE 5                                                        25766000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE - DDNAME OVERRIDE DSECT'  25767000
P        DSECT                          DDNAME OVERRIDE LIST            25768000
PLEN     DS    H                        LENGTH OF LIST                  25769000
         DS    3CL8                     (NOT APPLICABLE)                25770000
PSYSLIB  DS    CL8                      SYSLIB DDNAME                   25771000
PSYSIN   DS    CL8                      SYSIN DDNAME                    25772000
PSYSPRIN DS    CL8                      SYSPRINT DDNAME                 25773000
PSYSPUNC DS    CL8                      SYSPUNCH DDNAME                 25774000
PSYSUT1  DS    CL8                      SYSUT1 DDNAME                   25775000
PSYSUT2  DS    CL8                      SYSUT2 DDNAME                   25776000
PSYSUT3  DS    CL8                      SYSUT3 DDNAME                   25777000
PSYSGO   DS    CL8                      SYSGO DDNAME                    25778000
PSYSTERM DS    CL8                      SYSTERM DD NAME                 25779000
         SPACE 5                                                        25780000
D50      EQU   50                       OFFSET OF JOBNAME FROM SYNADAF  25781000
D84      EQU   84                       OFFSET OF OPERATION FIELD       25782000
         SPACE 5                                                        25783000
         TITLE '&COMPNM&ASMID - ABORT ROUTINE'                          25784000
         JCSECT (X0I00)                 SECTION ID                      25785000
         JMODID                                                         25786000
START    JSAVE BASE=YES                 SAVE REGISTERS                  25787000
         JENTRY (X0I01=START)           MODULE ENTRY POINT              25788000
         LM    R0,R1,JSLEN              GET LENGTH AND ADDR OF AREA     25789000
         LTR   R0,R0                    IS LENGTH ZERO (SET BY DRIVER)  25790000
         BZ    FREEPARM                 YES, NO BLOCK TO FREE           25791000
         FREEMAIN R,LV=(0),A=(1)        FREE STORAGE                    25792000
FREEPARM L     R1,JPARMPTR              FREE TRANSLATED PARM AREA       25793000
         LTR   R1,R1                    HAS AREA BEEN FREED BY INIT     25794000
         BZ    FREED                    YES.  ALREADY FREED             25795000
         LH    R0,D0(,R1)               GET LENGTH OF AREA              25796000
         FREEMAIN R,LV=(0),A=(1)        FREE STORAGE                    25797000
         EJECT                                                          25798000
FREED    MVC   BUFFER(CERR266L),CERR266  MOVE MSG TO WORKAREA           25799000
         MVC   BUFFER+CERR266D(L'JPHNAME),JPHNAME  MOVE IN PHASE NAME   25800000
         WTO   MF=(E,BUFFER)            TELL WHAT WAS LAST PHASE        25801000
         CH    R10,=Y(ERR260)           IS IT A MISSING DD CARD         25802000
         BNE   TRYIOERR                 NO,TRY IOERROR                  25803000
         MVC   BUFFER(CERR260L),CERR260 MOVE MSG TO WORKAREA            25804000
         SR    R6,R6                    MAKE R6 & R7 EQUAL IN CASE      25805000
         LR    R7,R6                      THERE IS NO OVERRIDING DD     25806000
         TM    D0(R11),BIT0             ANY OVERRIDING DDNAMES          25807000
         BO    TSYSTERM                 NO. R5 WILL BE GT R7 NOW        25808000
         L     R6,D4(,R11)              PT TO DDNAME LIST               25809000
         USING P,R6                     ''                              25810000
         LA    R7,P                     CALC END-OF-LINE (-2)           25811000
         AH    R7,PLEN                  ''                              25812000
         SPACE 3                                                        25813000
TSYSTERM GOIF  JTERM,OFF=TSYSLIN        NOTERMINAL SPECIFIED            25814000
         LA    R5,PSYSTERM              PT TO OVERRIDING DDNAME         25815000
         CR    R5,R7                    IS IT PAST END OF LIST          25816000
         BH    XSYSTERM                 YES GO CHANGE POINTER           25817000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERIDEN              25818000
         BNZ   DSYSTERM                 YES                             25819000
XSYSTERM LA    R5,CSYSTERM              PT TO STANDARD NAME             25820000
DSYSTERM DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25821000
         LTR   R15,R15                  WAS DDNAME FOUND                25822000
         BZ    TSYSLIN                  YES                             25823000
         BAL   R9,TELWORLD              LOGERR                          25824000
         SPACE 3                                                        25825000
TSYSLIN  GOIF  JLINK,OFF=TSYSIN         NOLOAD SPECIFIED                25826000
         LA    R5,PSYSGO                PT TO OVERRIDING DDNAME         25827000
         CR    R5,R7                    IS IT PAST END OF LIST          25828000
         BH    XSYSLIN                  YES. GO CHANGE PTR              25829000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25830000
         BNZ   DSYSLIN                  YES.                            25831000
XSYSLIN  LA    R5,CSYSGO                PT TO STANDARD NAME             25832000
DSYSLIN  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25833000
         LTR   R15,R15                  WAS DDNAME FOUND                25834000
         BZ    TSYSIN                   YES                             25835000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25836000
         SPACE 3                                                        25837000
TSYSIN   LA    R5,PSYSIN                PT TO OVERRIDING DDNAME         25838000
         CR    R5,R7                    IS IT PAST END OF LIST          25839000
         BH    XSYSIN                   YES. GO CHANGE PTR              25840000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25841000
         BNZ   DSYSIN                   YES.                            25842000
XSYSIN   LA    R5,CSYSIN                PT TO STANDARD NAME             25843000
DSYSIN   DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25844000
         LTR   R15,R15                  WAS DDNAME FOUND                25845000
         BZ    TSYSPRIN                 YES                             25846000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25847000
         SPACE 3                                                        25848000
TSYSPRIN GOIF  JLIST,OFF=TSYSPUNC       NOLIST SPECIFIED                25849000
         LA    R5,PSYSPRIN              PT TO OVERRIDING DDNAME         25850000
         CR    R5,R7                    IS IT PAST END OF LIST          25851000
         BH    XSYSPRIN                 YES. GO CHANGE PTR              25852000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25853000
         BNZ   DSYSPRIN                 YES.                            25854000
XSYSPRIN LA    R5,CSYSPRIN              PT TO STANDARD NAME             25855000
DSYSPRIN DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25856000
         LTR   R15,R15                  WAS DDNAME FOUND                25857000
         BZ    TSYSPUNC                 YES                             25858000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25859000
         SPACE 3                                                        25860000
TSYSPUNC GOIF  JDECK,OFF=TSYSUT1        NODECK SPECIFIED                25861000
         LA    R5,PSYSPUNC              PT TO OVERRIDING DDNAME         25862000
         CR    R5,R7                    IS IT PAST END OF LIST          25863000
         BH    XSYSPUNC                 YES. GO CHANGE PTR              25864000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25865000
         BNZ   DSYSPUNC                 YES.                            25866000
XSYSPUNC LA    R5,CSYSPUNC              PT TO STANDARD NAME             25867000
DSYSPUNC DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25868000
         LTR   R15,R15                  WAS DDNAME FOUND                25869000
         BZ    TSYSUT1                  YES                             25870000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25871000
         SPACE 3                                                        25872000
TSYSUT1  LA    R5,PSYSUT1               PT TO OVERRIDING DDNAME         25873000
         CR    R5,R7                    IS IT PAST END OF LIST          25874000
         BH    XSYSUT1                  YES. GO CHANGE PTR              25875000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25876000
         BNZ   DSYSUT1                  YES.                            25877000
XSYSUT1  LA    R5,CSYSUT1               PT TO STANDARD NAME             25878000
DSYSUT1  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25879000
         LTR   R15,R15                  WAS DDNAME FOUND                25880000
         BZ    TSYSUT2                  YES                             25881000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25882000
         SPACE 3                                                        25883000
TSYSUT2  LA    R5,PSYSUT2               PT TO OVERRIDING DDNAME         25884000
         CR    R5,R7                    IS IT PAST END OF LIST          25885000
         BH    XSYSUT2                  YES. GO CHANGE PTR              25886000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25887000
         BNZ   DSYSUT2                  YES.                            25888000
XSYSUT2  LA    R5,CSYSUT2               PT TO STANDARD NAME             25889000
DSYSUT2  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25890000
         LTR   R15,R15                  WAS DDNAME FOUND                25891000
         BZ    TSYSUT3                  YES                             25892000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25893000
         SPACE 3                                                        25894000
TSYSUT3  LA    R5,PSYSUT3               PT TO OVERRIDING DDNAME         25895000
         CR    R5,R7                    IS IT PAST END OF LIST          25896000
         BH    XSYSUT3                  YES. GO CHANGE PTR              25897000
         OC    D0(D8,R5),D0(R5)         IS DDNAME OVERRIDEN             25898000
         BNZ   DSYSUT3                  YES.                            25899000
XSYSUT3  LA    R5,CSYSUT3               PT TO STANDARD NAME             25900000
DSYSUT3  DEVTYPE (R5),JDWORD            GET DEVICE CHARACTERISTICS      25901000
         LTR   R15,R15                  WAS DDNAME FOUND                25902000
         BZ    CLEANUP                  YES                             25903000
         BAL   R9,TELWORLD              NO.  LOG ERROR                  25904000
         B     CLEANUP                  GO CLEANUP CORE                 25905000
         SPACE 6                                                        25906000
TELWORLD MVC   BUFFER+CERR260D(L'DCBDDNAM),D0(R5) MOVE IN DDNAME        25907000
         WTO   MF=(E,BUFFER)            TELL SOMEONE                    25908000
         BR    R9                       RETURN                          25909000
         EJECT                                                          25910000
TRYIOERR CH    R10,=Y(ERR261)           IS IT AN I/O ERROR              25911000
         BNE   TRYNOCOR                 NO, TRY NEXT ERROR              25912000
         MVC   BUFFER(LNGER61A),CERR261A  MOVE FIRST MSG TO WORK AREA   25913000
         MVC   BUFFER+LNGER61A(LNGER61B),CERR261B   MOVE SECOND MSG     25914000
         LR    R0,R11                   RELOAD SYNADAF REGS             25915000
         LR    R1,R2                    ''                              25916000
         LA    R2,BUFFER+FIRSTAST       PT TO FIELD TO BE REPLACED      25917000
         SPACE 3                                                        25918000
         CL    R1,=X'FF000000'          ERROR DURING FIND ON SYSLIB     25919000
         BL    IOERRSAM                 NO, TRY BSAM OR QSAM ERROR      25920000
         LA    R1,D0(,R1)               CLEAR ERROR FLAGS               25921000
         SYNADAF ACSMETH=BPAM           RETRIEVE AVAILABLE DATA         25922000
         MVC   D0(LNGFLD1,R2),D50(R1)   MOVE TO FIRST MSG               25923000
         MVC   SECNDAST(LNGFLD2,R2),D84(R1)   MOVE TO SECOND MSG        25924000
         MVC   SECNDAST(D22,R2),=CL22'FIND ,'                           25925000
         B     IOERRRLS                 GO RELEASE DATA                 25926000
         SPACE 3                                                        25927000
         USING IHADCB,R1                PT TO DCB                       25928000
IOERRSAM TM    DCBMACRF,BIT1            IS I/O ERROR ON QSAM FILE       25929000
         BZ    IOERRBSM                 NO, TRY BSAM                    25930000
         DROP  R1                       DROP DCB PTR                    25931000
         SYNADAF ACSMETH=QSAM           PERFORM ANALYSIS                25932000
         B     IOERRMSG                 GO BUILD MSG                    25933000
IOERRBSM SYNADAF ACSMETH=BSAM           PERFORM ANALYSIS                25934000
IOERRMSG MVC   D0(LNGFLD1,R2),D50(R1)   MOVE TO FIRST MSG               25935000
         MVC   SECNDAST(LNGFLD2,R2),D84(R1)   MOVE TO SECOND MSG        25936000
IOERRRLS SYNADRLS                       RELEASE DATA                    25937000
         WTO   MF=(E,BUFFER)            TELL THE WORLD                  25938000
         WTO   MF=(E,BUFFER+LNGER61A)                                   25939000
         B     CLEANUP                  GO CLEAN UP                     25940000
         SPACE 6                                                        25941000
TRYNOCOR CH    R10,=Y(ERR262)           DID WE RUN OUT OF STORAGE       25942000
         BNE   TRYLOGIC                 NO, TRY NEXT ERROR              25943000
         WTO   MF=(E,CERR262)           TELL THE WORLD                  25944000
         B     CLEANUP                  GO CLEAN UP                     25945000
         SPACE 5                                                        25946000
TRYLOGIC WTO   MF=(E,CERR263)           TELL THE WORLD ABOUT LOGIC ERR  25947000
         SPACE 5                                                        25948000
CLEANUP  L     R1,JSYSCLOS              PT TO CLOSE PARM LIST           25949000
         CLOSE MF=(E,(1))               CLOSE WORKFILES                 25950000
         SPACE 3                                                        25951000
         L     R7,JADINCM               PT TO INPUT COMMON              25952000
         USING JINCOM,R7                ESTABLISH ADDRESSABILITY        25953000
         LTR   R7,R7                    IS IT PRESENT                   25954000
         BZ    NOIN                     NO, TRY OUTPUT COMMON           25955000
         SPACE 3                                                        25956000
         L     R6,JSYSLIB               PT TO SYSLIB DCB                25957000
         USING IHADCB,R6                ''                              25958000
         TM    DCBOFLGS,BIT3            WAS OPEN SUCCESSFUL             25959000
         BZ    NOTSUC                   NO, NOT SUCCESSFUL              25960000
         LH    R0,DCBBLKSI              GET BLOCKSIZE                   25961000
         DROP  R6                       DOP DCB PTR                     25962000
         L     R1,JLIBBUF               GET BUFFER ADDRESS              25963000
         FREEMAIN R,LV=(0),A=(1)        FREE BUFFER                     25964000
NOTSUC   L     R1,JINCLOS               PT TO CLOSE PARM LIST           25965000
         CLOSE MF=(E,(1))               CLOSE INPUT FILES               25966000
         SPACE 3                                                        25967000
         L     R1,JSYSIN                PT TO SYSIN DCB                 25968000
         USING IHADCB,R1                PT TO SYSIN DCB                 25969000
         TM    DCBBUFCB+D3,BIT7         ANY BUFCB                       25970000
         BO    NOIN                     NO, DON'T DO FREEPOOL           25971000
         FREEPOOL (1)                   FREEPOOL BUFFERS                25972000
         DROP  R1,R7                    DROP DCB AND COMMON PTRS        25973000
         EJECT                                                          25974000
NOIN     L     R7,JADOUTCM              PT TO OUTPUT COMMON             25975000
         USING JOUTCOM,R7               ESTABLISH ADDRESSABILITY        25976000
         LTR   R7,R7                    IS IT PRESENT                   25977000
         BZ    NOOUT                    NO                              25978000
         L     R1,JOUTCLOS              PT TO CLOSE PARM LIST           25979000
         CLOSE MF=(E,(1))               CLOSE OUTPUT FILES              25980000
         SPACE 3                                                        25981000
         USING IHADCB,R1                ESTABLISH ADDRESSABILITY        25982000
         L     R1,JSYSLST               PT TO SYSPRINT DCB              25983000
         TM    DCBBUFCB+D3,BIT7         ANY BUFCB                       25984000
         BO    FREEPCH                  NO, DON'T DO FREEPOOL           25985000
         FREEPOOL (1)                   FREEPOOL BUFFERS                25986000
         SPACE 1                                                        25987000
FREEPCH  L     R1,JSYSPCH               PT TO SYSPUNCH DCB              25988000
         TM    DCBBUFCB+D3,BIT7         ANY BUFCB                       25989000
         BO    FREELNK                  NO, DON'T DO FREEPOOL           25990000
         FREEPOOL (1)                   FREEPOOL BUFFERS                25991000
         SPACE 1                                                        25992000
FREELNK  L     R1,JSYSLNK               PT TO SYSLIN DCB                25993000
         TM    DCBBUFCB+D3,BIT7         ANY BUFCB                       25994000
         BO    NOOUT                    NO, DON'T DO FREEPOOL           25995000
         FREEPOOL (1)                   FREEPOOL BUFFERS                25996000
         DROP  R1,R7                    DROP DCB AND COMMON PTRS        25997000
         EJECT                                                          25998000
NOOUT    DELETE EP=&COMPNM.X62          DELETE ALL LOADED MODULES       25999000
         DELETE EP=&COMPNM.X61            EXCEPT THE DRIVER, MASTER     26000000
         DELETE EP=&COMPNM.X51            COMMON AND THE ABORT ROUTINE. 26001000
         DELETE EP=&COMPNM.X41            ''                            26002000
         DELETE EP=&COMPNM.X31            ''                            26003000
         DELETE EP=&COMPNM.X21            ''                            26004000
         DELETE EP=&COMPNM.X11            ''                            26005000
         DELETE EP=&COMPNM.X06            ''                            26006000
         DELETE EP=&COMPNM.X05            ''                            26007000
         DELETE EP=&COMPNM.X04            ''                            26008000
         DELETE EP=&COMPNM.X03            ''                            26009000
         DELETE EP=&COMPNM.X02            ''                            26010000
         SPACE 3                                                        26011000
RETURN   JRETURN                        RETURN TO DRIVER                26012000
         SPACE 5                                                        26013000
       TITLE '&COMPNM&ASMID - ABORT ROUTINE - CONSTANTS AND PATCH AREA' 26014000
*        CONSTANTS                                                      26015000
*                                                                       26016000
CSYSTERM DC    CL8'SYSTERM'             STANDARD FILE NAME FOR SYSTERM  26017000
CSYSGO   DC    CL8'SYSGO'               STANDARD FILE NAME FOR SYSGO    26018000
CSYSIN   DC    CL8'SYSIN'               STANDARD FILE NAME FOR SYSIN    26019000
CSYSPRIN DC    CL8'SYSPRINT'            STANDARD FILE NAME FOR SYSPRINT 26020000
CSYSPUNC DC    CL8'SYSPUNCH'            STANDARD FILE NAME FOR SYSPUNCH 26021000
CSYSUT1  DC    CL8'SYSUT1'              STANDARD FILE NAME FOR SYSUT1   26022000
CSYSUT2  DC    CL8'SYSUT2'              STANDARD FILE NAME FOR SYSUT2   26023000
CSYSUT3  DC    CL8'SYSUT3'              STANDARD FILE NAME FOR SYSUT3   26024000
         SPACE 3                                                        26025000
CERR260  WTO   '&COMPNM.260  ASSEMBLY TERMINATED.  DD CARD MISSING FOR X26026000
               ********',ROUTCDE=(2,11),MF=L                            26027000
CERR260L EQU   *-CERR260                LENGTH OF MESSAGE               26028000
CERR260D EQU   CERR260L-12              DISPLACEMENT TO VARIABLE DATA   26029000
         SPACE 1                                                        26030000
CERR261A WTO   '&COMPNM.261  ASSEMBLY TERMINATED -- PERM I/O ERROR  ***X26031000
               *****,********,***,**,********,  (1/2)',ROUTCDE=(2,11), X26032000
               MF=L                                                     26033000
LNGER61A EQU   (*-CERR261A+3)/4*4       LENGTH OF FIRST MESSAGE         26034000
FIRSTAST EQU   51                       DISP OF 1ST ASTERISK REPLACED   26035000
LNGFLD1  EQU   34                       LNG OF MSG FLD TO BE REPLACED   26036000
         SPACE                                                          26037000
CERR261B WTO   '&COMPNM.261       ******,***************,**************X26038000
               *******  (2/2)',ROUTCDE=(2,11),MF=L                      26039000
LNGER61B EQU   *-CERR261B               LENGTH OF SECOND MESSAGE        26040000
SECNDAST EQU   62                       DISP OF 2ND ASTERISK REPLACED   26041000
LNGFLD2  EQU   44                       LNG OF MSG FLD TO BE REPLACED   26042000
         SPACE                                                          26043000
CERR262  WTO   '&COMPNM.262  ASSEMBLY TERMINATED.  INSUFFICIENT MAIN STX26044000
               ORAGE',ROUTCDE=(2,11),MF=L                               26045000
CERR263  WTO   '&COMPNM.263  ASSEMBLY TERMINATED.  PROGRAM LOGIC ERROR'X26046000
               ,ROUTCDE=11,MF=L                                         26047000
CERR266  WTO   '&COMPNM.266  LAST ASSEMBLER PHASE LOADED WAS ********',X26048000
               ROUTCDE=11,MF=L                                          26049000
CERR266L EQU   *-CERR266                LENGTH OF MESSAGE               26050000
CERR266D EQU   CERR266L-12              DISPLACEMENT TO VARIABLE DATA   26051000
         SPACE 3                                                        26052000
         JPATCH X0I00,6A0               5% PATCH AREA                   26053000
         SPACE 3                                                        26054000
         END   START                                                    26055000
//MACROS  EXEC PGM=IEBUPDTE,REGION=1024K,PARM=NEW                       26056000
//SYSUT2   DD  DISP=(NEW,PASS),DSN=&&IMAC,                              26057000
//             UNIT=SYSDA,SPACE=(3120,(300,,4)),                        26058000
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=3120)                     26059000
//SYSPRINT DD  SYSOUT=*                                                 26060000
//SYSIN    DD  *                                                        26061000
./ ADD NAME=BMDSECTS                                                    26062000
*COPY BMDSECTS                                                          26063000
RLDIN    DSECT                          RLD INPUT RECORD FORMAT         26064000
RLDLEN   DS    CL2                      RLD RECORD LENGTH               26065000
RFLAG    DS    CL2                      FLAG                            26066000
ROPCDE   DS    CL2                      OPCODE BYTES                    26067000
POSID    DS    CL2                      POSITION ESD/ID                 26068000
RELID    DS    CL2                      RELOCATION ESD/ID               26069000
RLDVAL   DS    CL3                      RLD SYMBOL ADDRESS              26070000
RLDFLG   DS    C                        RLD FLAG                        26071000
RLDND    EQU   *-RLDIN                  LENGTH OF RECORD                26072000
RLDTYPE  EQU   JR                       RLD RECORD I.D.                 26073000
         SPACE                                                          26074000
XRFIN    DSECT                          XREF INPUT RECORD FORMAT        26075000
XRECLN   DS    CL2                      XREF RECORD LENGTH              26076000
XFLAG    DS    CL2                      FLAG                            26077000
XOPCDE   DS    CL2                      OP CODE                         26078000
XRFSYM   DS    CL8                      XREF SYMBOL                     26079000
XRFFLG   DS    C                        XREF FLAG, BASE, DEF, DUP,UNDEF 26080000
XRFSTM   DS    CL2                      XREF STATEMENT NUMBER           26081000
XRFLEN   DS    CL2                      XREF LENGTH                     26082000
XRFVAL   DS    CL4                      XREF VALUE                      26083000
XRFND    EQU   *-XRFIN                  LENGTH OF XREF RECORD           26084000
XRFTYPE  EQU   JX                       XREF RECORD I.D.                26085000
BASE     EQU   X'01'                    BASE MASK                       26086000
REF      EQU   X'02'                    REFERENCE MASK                  26087000
DUPL     EQU   X'03'                    DUPLICATE MASK                  26088000
         SPACE                                                          26089000
ERRIN    DSECT                          ERROR INPUT RECORD FORMAT       26090000
ERRLEN   DS    CL2                      ERROR RECORD LENGTH             26091000
ERRID    DS    C                        ERROR IDENTIFIER                26092000
NUMERR   DS    C                        NUMBER OF ERRORS                26093000
ERRSTMT  DS    CL2                      ERROR STATMENT NUMBER           26094000
ERRNUM   DS    C                        ERROR NUMBER                    26095000
ERRFLD   DS    CL15                     REST OF ERRORS                  26096000
ERRND    EQU   *-ERRIN                  LENGTH OF RECORD                26097000
ERRTYPE  EQU   JE                       ERROR RECORD I.D.               26098000
./ ADD NAME=CONTAINS                                                    26099000
         MACRO                                                          26100000
&PHASEID CONTAINS  &DUMMY                                               26101000
.*                                                                      26102000
.*             CHANGES TO RELEASE 3                                     26103000
.*             CHANGES TO RELEASE 2                                     26104000
.*             CHANGES TO RELEASE 1                                     26105000
.* INNER MACRO TO ICOMMON USED TO CREATE AN EXTERNAL                    26106000
.* ROUTINE NAME ARRAY                                                   26107000
         GBLC  &X0(26)                                                  26108000
         GBLC  &X1(26)                                                  26109000
         GBLC  &X2(26)                                                  26110000
         GBLC  &X3(26)                                                  26111000
         GBLC  &X4(26)                                                  26112000
         GBLC  &X5(26)                                                  26113000
         GBLC  &X6(26)                                                  26114000
         GBLC  &X7(26)                                                  26115000
         GBLC  &X8(26)                                                  26116000
         GBLC  &X9(26)                                                  26117000
         GBLC  &XA(26)                                                  26118000
         GBLC  &XB(26)                                                  26119000
         GBLC  &XC(26)                                                  26120000
         GBLC  &XD(26)                                                  26121000
         GBLC  &XE(26)                                                  26122000
         GBLC  &XF(26)                                                  26123000
.*                                                                      26124000
         LCLA  &I,&J                    INDEX                           26125000
.*                                                                      26126000
         AIF   (K'&PHASEID EQ 0).ERR1                                   26127000
.*                                                                      26128000
         AIF   ('&X0(1)' EQ '').X0                                      26129000
         AIF   ('&X0(1)' EQ '&PHASEID').ERR5                            26130000
         AIF   ('&X1(1)' EQ '').X1                                      26131000
         AIF   ('&X1(1)' EQ '&PHASEID').ERR5                            26132000
         AIF   ('&X2(1)' EQ '').X2                                      26133000
         AIF   ('&X2(1)' EQ '&PHASEID').ERR5                            26134000
         AIF   ('&X3(1)' EQ '').X3                                      26135000
         AIF   ('&X3(1)' EQ '&PHASEID').ERR5                            26136000
         AIF   ('&X4(1)' EQ '').X4                                      26137000
         AIF   ('&X4(1)' EQ '&PHASEID').ERR5                            26138000
         AIF   ('&X5(1)' EQ '').X5                                      26139000
         AIF   ('&X5(1)' EQ '&PHASEID').ERR5                            26140000
         AIF   ('&X6(1)' EQ '').X6                                      26141000
         AIF   ('&X6(1)' EQ '&PHASEID').ERR5                            26142000
         AIF   ('&X7(1)' EQ '').X7                                      26143000
         AIF   ('&X7(1)' EQ '&PHASEID').ERR5                            26144000
         AIF   ('&X8(1)' EQ '').X8                                      26145000
         AIF   ('&X8(1)' EQ '&PHASEID').ERR5                            26146000
         AIF   ('&X9(1)' EQ '').X9                                      26147000
         AIF   ('&X9(1)' EQ '&PHASEID').ERR5                            26148000
         AIF   ('&XA(1)' EQ '').XA                                      26149000
         AIF   ('&XA(1)' EQ '&PHASEID').ERR5                            26150000
         AIF   ('&XB(1)' EQ '').XB                                      26151000
         AIF   ('&XB(1)' EQ '&PHASEID').ERR5                            26152000
         AIF   ('&XC(1)' EQ '').XC                                      26153000
         AIF   ('&XC(1)' EQ '&PHASEID').ERR5                            26154000
         AIF   ('&XD(1)' EQ '').XD                                      26155000
         AIF   ('&XD(1)' EQ '&PHASEID').ERR5                            26156000
         AIF   ('&XE(1)' EQ '').XE                                      26157000
         AIF   ('&XE(1)' EQ '&PHASEID').ERR5                            26158000
         AIF   ('&XF(1)' EQ '').XF                                      26159000
         AIF   ('&XF(1)' EQ '&PHASEID').ERR5                            26160000
.*                                                                      26161000
         AGO   .ERR4                                                    26162000
.*                                                                      26163000
.X0      ANOP                                                           26164000
&X0(1)   SETC  '&PHASEID'                                               26165000
.X01     AIF   (&I+1 GT N'&SYSLIST).END                                 26166000
&I       SETA  &I+1                                                     26167000
         AIF   ('&SYSLIST(&I)' EQ '').X01                               26168000
         AIF   (&J GT 24).ERR6                                          26169000
&X0(&J+2) SETC '&SYSLIST(&I)'                                           26170000
&J       SETA  &J+1                                                     26171000
         AGO   .X01                                                     26172000
.*                                                                      26173000
.X1      ANOP                                                           26174000
&X1(1)   SETC  '&PHASEID'                                               26175000
.X11     AIF   (&I+1 GT N'&SYSLIST).END                                 26176000
&I       SETA  &I+1                                                     26177000
         AIF   ('&SYSLIST(&I)' EQ '').X11                               26178000
         AIF   (&J GT 24).ERR6                                          26179000
&X1(&J+2) SETC '&SYSLIST(&I)'                                           26180000
&J       SETA  &J+1                                                     26181000
         AGO   .X11                                                     26182000
.*                                                                      26183000
.X2      ANOP                                                           26184000
&X2(1)   SETC  '&PHASEID'                                               26185000
.X21     AIF   (&I+1 GT N'&SYSLIST).END                                 26186000
&I       SETA  &I+1                                                     26187000
         AIF   ('&SYSLIST(&I)' EQ '').X21                               26188000
         AIF   (&J GT 24).ERR6                                          26189000
&X2(&J+2) SETC '&SYSLIST(&I)'                                           26190000
&J       SETA  &J+1                                                     26191000
         AGO   .X21                                                     26192000
.*                                                                      26193000
.X3      ANOP                                                           26194000
&X3(1)   SETC  '&PHASEID'                                               26195000
.X31     AIF   (&I+1 GT N'&SYSLIST).END                                 26196000
&I       SETA  &I+1                                                     26197000
         AIF   ('&SYSLIST(&I)' EQ '').X31                               26198000
         AIF   (&J GT 24).ERR6                                          26199000
&X3(&J+2) SETC '&SYSLIST(&I)'                                           26200000
&J       SETA  &J+1                                                     26201000
         AGO   .X31                                                     26202000
.*                                                                      26203000
.X4      ANOP                                                           26204000
&X4(1)   SETC  '&PHASEID'                                               26205000
.X41     AIF   (&I+1 GT N'&SYSLIST).END                                 26206000
&I       SETA  &I+1                                                     26207000
         AIF   ('&SYSLIST(&I)' EQ '').X41                               26208000
         AIF   (&J GT 24).ERR6                                          26209000
&X4(&J+2) SETC '&SYSLIST(&I)'                                           26210000
&J       SETA  &J+1                                                     26211000
         AGO   .X41                                                     26212000
.*                                                                      26213000
.X5      ANOP                                                           26214000
&X5(1)   SETC  '&PHASEID'                                               26215000
.X51     AIF   (&I+1 GT N'&SYSLIST).END                                 26216000
&I       SETA  &I+1                                                     26217000
         AIF   ('&SYSLIST(&I)' EQ '').X51                               26218000
         AIF   (&J GT 24).ERR6                                          26219000
&X5(&J+2) SETC '&SYSLIST(&I)'                                           26220000
&J       SETA  &J+1                                                     26221000
         AGO   .X51                                                     26222000
.*                                                                      26223000
.X6      ANOP                                                           26224000
&X6(1)   SETC  '&PHASEID'                                               26225000
.X61     AIF   (&I+1 GT N'&SYSLIST).END                                 26226000
&I       SETA  &I+1                                                     26227000
         AIF   ('&SYSLIST(&I)' EQ '').X61                               26228000
         AIF   (&J GT 24).ERR6                                          26229000
&X6(&J+2) SETC '&SYSLIST(&I)'                                           26230000
&J       SETA  &J+1                                                     26231000
         AGO   .X61                                                     26232000
.*                                                                      26233000
.X7      ANOP                                                           26234000
&X7(1)   SETC  '&PHASEID'                                               26235000
.X71     AIF   (&I+1 GT N'&SYSLIST).END                                 26236000
&I       SETA  &I+1                                                     26237000
         AIF   ('&SYSLIST(&I)' EQ '').X71                               26238000
         AIF   (&J GT 24).ERR6                                          26239000
&X7(&J+2) SETC '&SYSLIST(&I)'                                           26240000
&J       SETA  &J+1                                                     26241000
         AGO   .X71                                                     26242000
.*                                                                      26243000
.X8      ANOP                                                           26244000
&X8(1)   SETC  '&PHASEID'                                               26245000
.X81     AIF   (&I+1 GT N'&SYSLIST).END                                 26246000
&I       SETA  &I+1                                                     26247000
         AIF   ('&SYSLIST(&I)' EQ '').X81                               26248000
         AIF   (&J GT 24).ERR6                                          26249000
&X8(&J+2) SETC '&SYSLIST(&I)'                                           26250000
&J       SETA  &J+1                                                     26251000
         AGO   .X81                                                     26252000
.*                                                                      26253000
.X9      ANOP                                                           26254000
&X9(1)   SETC  '&PHASEID'                                               26255000
.X91     AIF   (&I+1 GT N'&SYSLIST).END                                 26256000
&I       SETA  &I+1                                                     26257000
         AIF   ('&SYSLIST(&I)' EQ '').X91                               26258000
         AIF   (&J GT 24).ERR6                                          26259000
&X9(&J+2) SETC '&SYSLIST(&I)'                                           26260000
&J       SETA  &J+1                                                     26261000
         AGO   .X91                                                     26262000
.*                                                                      26263000
.XA      ANOP                                                           26264000
&XA(1)   SETC  '&PHASEID'                                               26265000
.XA1     AIF   (&I+1 GT N'&SYSLIST).END                                 26266000
&I       SETA  &I+1                                                     26267000
         AIF   ('&SYSLIST(&I)' EQ '').XA1                               26268000
         AIF   (&J GT 24).ERR6                                          26269000
&XA(&J+2) SETC '&SYSLIST(&I)'                                           26270000
&J       SETA  &J+1                                                     26271000
         AGO   .XA1                                                     26272000
.*                                                                      26273000
.XB      ANOP                                                           26274000
&XB(1)   SETC  '&PHASEID'                                               26275000
.XB1     AIF   (&I+1 GT N'&SYSLIST).END                                 26276000
&I       SETA  &I+1                                                     26277000
         AIF   ('&SYSLIST(&I)' EQ '').XB1                               26278000
         AIF   (&J GT 24).ERR6                                          26279000
&XB(&J+2) SETC '&SYSLIST(&I)'                                           26280000
&J       SETA  &J+1                                                     26281000
         AGO   .XB1                                                     26282000
.*                                                                      26283000
.XC      ANOP                                                           26284000
&XC(1)   SETC  '&PHASEID'                                               26285000
.XC1     AIF   (&I+1 GT N'&SYSLIST).END                                 26286000
&I       SETA  &I+1                                                     26287000
         AIF   ('&SYSLIST(&I)' EQ '').XC1                               26288000
         AIF   (&J GT 24).ERR6                                          26289000
&XC(&J+2) SETC '&SYSLIST(&I)'                                           26290000
&J       SETA  &J+1                                                     26291000
         AGO   .XC1                                                     26292000
.*                                                                      26293000
.XD      ANOP                                                           26294000
&XD(1)   SETC  '&PHASEID'                                               26295000
.XD1     AIF   (&I+1 GT N'&SYSLIST).END                                 26296000
&I       SETA  &I+1                                                     26297000
         AIF   ('&SYSLIST(&I)' EQ '').XD1                               26298000
         AIF   (&J GT 24).ERR6                                          26299000
&XD(&J+2) SETC '&SYSLIST(&I)'                                           26300000
&J       SETA  &J+1                                                     26301000
         AGO   .XD1                                                     26302000
.*                                                                      26303000
.XE      ANOP                                                           26304000
&XE(1)   SETC  '&PHASEID'                                               26305000
.XE1     AIF   (&I+1 GT N'&SYSLIST).END                                 26306000
&I       SETA  &I+1                                                     26307000
         AIF   ('&SYSLIST(&I)' EQ '').XE1                               26308000
         AIF   (&J GT 24).ERR6                                          26309000
&XE(&J+2) SETC '&SYSLIST(&I)'                                           26310000
&J       SETA  &J+1                                                     26311000
         AGO   .XE1                                                     26312000
.*                                                                      26313000
.XF      ANOP                                                           26314000
&XF(1)   SETC  '&PHASEID'                                               26315000
.XF1     AIF   (&I+1 GT N'&SYSLIST).END                                 26316000
&I       SETA  &I+1                                                     26317000
         AIF   ('&SYSLIST(&I)' EQ '').XF1                               26318000
         AIF   (&J GT 24).ERR6                                          26319000
&XF(&J+2) SETC '&SYSLIST(&I)'                                           26320000
&J       SETA  &J+1                                                     26321000
         AGO   .XF1                                                     26322000
.*                                                                      26323000
.ERR1    MNOTE 8,'INVALID OR NO PHASEID FURNISHED.'                     26324000
         MEXIT                                                          26325000
.ERR4    MNOTE 8,'EXTERNAL ROUTINE NAME ARRAYS FULL.'                   26326000
         MEXIT                                                          26327000
.ERR5    MNOTE 8,'DUPLICATE PHASEID.'                                   26328000
         MEXIT                                                          26329000
.ERR6    MNOTE 8,'TOO MANY NAMES.'                                      26330000
         MEXIT                                                          26331000
.END     AIF   (&J GT 0).MEND                                           26332000
         MNOTE 0,'NO ROUTINE NAMES FURNISHED.'                          26333000
.MEND    MEND                                                           26334000
./ ADD NAME=CONTENTS                                                    26335000
         MACRO                                                          26336000
&PHASEID CONTENTS  &DUMMY                                               26337000
.*                                                                      26338000
.*             CHANGES TO RELEASE 3                                     26339000
.*             CHANGES TO RELEASE 2                                     26340000
.*             CHANGES TO RELEASE 1                                     26341000
.*                                                                      26342000
.* GENERATES A BRANCH TABLE IN IFNX4E TO THE ROUTINES                   26343000
.* CONTAINED IN IFNX4E                                                  26344000
         GBLC  &X0(26)                                                  26345000
         GBLC  &X1(26)                                                  26346000
         GBLC  &X2(26)                                                  26347000
         GBLC  &X3(26)                                                  26348000
         GBLC  &X4(26)                                                  26349000
         GBLC  &X5(26)                                                  26350000
         GBLC  &X6(26)                                                  26351000
         GBLC  &X7(26)                                                  26352000
         GBLC  &X8(26)                                                  26353000
         GBLC  &X9(26)                                                  26354000
         GBLC  &XA(26)                                                  26355000
         GBLC  &XB(26)                                                  26356000
         GBLC  &XC(26)                                                  26357000
         GBLC  &XD(26)                                                  26358000
         GBLC  &XE(26)                                                  26359000
         GBLC  &XF(26)                                                  26360000
.*                                                                      26361000
         LCLA  &I                                                       26362000
.*                                                                      26363000
         AIF   (K'&PHASEID EQ 0).ERR1                                   26364000
.*                                                                      26365000
&PHASEID DS    0H                       START OF BRANCH TABLE           26366000
         USING &PHASEID,R12                                             26367000
.*                                                                      26368000
         AIF   ('&X0(1)' EQ '&PHASEID').X0                              26369000
         AIF   ('&X1(1)' EQ '&PHASEID').X1                              26370000
         AIF   ('&X2(1)' EQ '&PHASEID').X2                              26371000
         AIF   ('&X3(1)' EQ '&PHASEID').X3                              26372000
         AIF   ('&X4(1)' EQ '&PHASEID').X4                              26373000
         AIF   ('&X5(1)' EQ '&PHASEID').X5                              26374000
         AIF   ('&X6(1)' EQ '&PHASEID').X6                              26375000
         AIF   ('&X7(1)' EQ '&PHASEID').X7                              26376000
         AIF   ('&X8(1)' EQ '&PHASEID').X8                              26377000
         AIF   ('&X9(1)' EQ '&PHASEID').X9                              26378000
         AIF   ('&XA(1)' EQ '&PHASEID').XA                              26379000
         AIF   ('&XB(1)' EQ '&PHASEID').XB                              26380000
         AIF   ('&XC(1)' EQ '&PHASEID').XC                              26381000
         AIF   ('&XD(1)' EQ '&PHASEID').XD                              26382000
         AIF   ('&XE(1)' EQ '&PHASEID').XE                              26383000
         AIF   ('&XF(1)' EQ '&PHASEID').XF                              26384000
.*                                                                      26385000
         AGO   .ERR4                                                    26386000
.*                                                                      26387000
.X0      AIF   (&I GT 24).END                                           26388000
&I       SETA  &I+1                                                     26389000
         AIF   ('&X0(&I+1)' EQ '').END                                  26390000
         B     &X0(&I+1)                                                26391000
         AGO   .X0                                                      26392000
.*                                                                      26393000
.X1      AIF   (&I GT 24).END                                           26394000
&I       SETA  &I+1                                                     26395000
         AIF   ('&X1(&I+1)' EQ '').END                                  26396000
         B     &X1(&I+1)                                                26397000
         AGO   .X1                                                      26398000
.*                                                                      26399000
.X2      AIF   (&I GT 24).END                                           26400000
&I       SETA  &I+1                                                     26401000
         AIF   ('&X2(&I+1)' EQ '').END                                  26402000
         B     &X2(&I+1)                                                26403000
         AGO   .X2                                                      26404000
.*                                                                      26405000
.X3      AIF   (&I GT 24).END                                           26406000
&I       SETA  &I+1                                                     26407000
         AIF   ('&X3(&I+1)' EQ '').END                                  26408000
         B     &X3(&I+1)                                                26409000
         AGO   .X3                                                      26410000
.*                                                                      26411000
.X4      AIF   (&I GT 24).END                                           26412000
&I       SETA  &I+1                                                     26413000
         AIF   ('&X4(&I+1)' EQ '').END                                  26414000
         B     &X4(&I+1)                                                26415000
         AGO   .X4                                                      26416000
.*                                                                      26417000
.X5      AIF   (&I GT 24).END                                           26418000
&I       SETA  &I+1                                                     26419000
         AIF   ('&X5(&I+1)' EQ '').END                                  26420000
         B     &X5(&I+1)                                                26421000
         AGO   .X5                                                      26422000
.*                                                                      26423000
.X6      AIF   (&I GT 24).END                                           26424000
&I       SETA  &I+1                                                     26425000
         AIF   ('&X6(&I+1)' EQ '').END                                  26426000
         B     &X6(&I+1)                                                26427000
         AGO   .X6                                                      26428000
.*                                                                      26429000
.X7      AIF   (&I GT 24).END                                           26430000
&I       SETA  &I+1                                                     26431000
         AIF   ('&X7(&I+1)' EQ '').END                                  26432000
         B     &X7(&I+1)                                                26433000
         AGO   .X7                                                      26434000
.*                                                                      26435000
.X8      AIF   (&I GT 24).END                                           26436000
&I       SETA  &I+1                                                     26437000
         AIF   ('&X8(&I+1)' EQ '').END                                  26438000
         B     &X8(&I+1)                                                26439000
         AGO   .X8                                                      26440000
.*                                                                      26441000
.X9      AIF   (&I GT 24).END                                           26442000
&I       SETA  &I+1                                                     26443000
         AIF   ('&X9(&I+1)' EQ '').END                                  26444000
         B     &X9(&I+1)                                                26445000
         AGO   .X9                                                      26446000
.*                                                                      26447000
.XA      AIF   (&I GT 24).END                                           26448000
&I       SETA  &I+1                                                     26449000
         AIF   ('&XA(&I+1)' EQ '').END                                  26450000
         B     &XA(&I+1)                                                26451000
         AGO   .XA                                                      26452000
.*                                                                      26453000
.XB      AIF   (&I GT 24).END                                           26454000
&I       SETA  &I+1                                                     26455000
         AIF   ('&XB(&I+1)' EQ '').END                                  26456000
         B     &XB(&I+1)                                                26457000
         AGO   .XB                                                      26458000
.*                                                                      26459000
.XC      AIF   (&I GT 24).END                                           26460000
&I       SETA  &I+1                                                     26461000
         AIF   ('&XC(&I+1)' EQ '').END                                  26462000
         B     &XC(&I+1)                                                26463000
         AGO   .XC                                                      26464000
.*                                                                      26465000
.XD      AIF   (&I GT 24).END                                           26466000
&I       SETA  &I+1                                                     26467000
         AIF   ('&XD(&I+1)' EQ '').END                                  26468000
         B     &XD(&I+1)                                                26469000
         AGO   .XD                                                      26470000
.*                                                                      26471000
.XE      AIF   (&I GT 24).END                                           26472000
&I       SETA  &I+1                                                     26473000
         AIF   ('&XE(&I+1)' EQ '').END                                  26474000
         B     &XE(&I+1)                                                26475000
         AGO   .XE                                                      26476000
.*                                                                      26477000
.XF      AIF   (&I GT 24).END                                           26478000
&I       SETA  &I+1                                                     26479000
         AIF   ('&XF(&I+1)' EQ '').END                                  26480000
         B     &XF(&I+1)                                                26481000
         AGO   .XF                                                      26482000
.*                                                                      26483000
.ERR1    MNOTE 8,'INVALID OR NO PHASEID FURNISHED.'                     26484000
         MEXIT                                                          26485000
.ERR4    MNOTE 8,'UNDEFINED PHASEID.'                                   26486000
.END     DROP  R12                                                      26487000
         AIF   (&I NE 0).MEND                                           26488000
.ERR5    MNOTE 4,'NO ROUTINE NAME DEFINED FOR PHASE.'                   26489000
.MEND    MEND                                                           26490000
./ ADD NAME=DBV                                                         26491000
         MACRO                                                          26492000
&NAME    DBV   &Z                                                       26493000
         LCLA  &I,&J,&K,&M                                              26494000
         LCLC  &B(7)                                                    26495000
.*                                                                      26496000
.*             CHANGES TO RELEASE 3                                     26497000
.*             CHANGES TO RELEASE 2                                     26498000
.*             CHANGES TO RELEASE 1                                     26499000
.*                                                                      26500000
.* DEFINES BYTE VALUES THROUGH THE USE OF                               26501000
.* EQUATES AND DS 0X                                                    26502000
.*                                                                      26503000
         AIF   ('&NAME' EQ '').I1                                       26504000
&NAME    DS    0X                                                       26505000
.I1      AIF   (&M EQ 0).M1                                             26506000
&B(&M+1) SETC  ''                                                       26507000
&M       SETA  &M-1                                                     26508000
         AGO   .I1                                                      26509000
.M1      ANOP                                                           26510000
&B(&M+1) SETC  '0'                                                      26511000
&K       SETA  0                                                        26512000
&I       SETA  &I+1                                                     26513000
         AIF   (K'&SYSLIST(&I) EQ 0).D1                                 26514000
&J       SETA  K'&SYSLIST(&I)+1                                         26515000
.L1      ANOP                                                           26516000
&J       SETA  &J-1                                                     26517000
         AIF   ('&SYSLIST(&I)'(&J,1) NE ')').S1                         26518000
&K       SETA  &K+1                                                     26519000
.S1      AIF   ('&SYSLIST(&I)'(&J,1) NE '(').S2                         26520000
&K       SETA  &K-1                                                     26521000
.S2      AIF   (&K EQ 0).S3                                             26522000
         AIF   (&K GT 0 AND &J GT 1).L1                                 26523000
.ERR     MNOTE 8,'INVALID PARAMETER SYNTAX IN OPERAND &I.'              26524000
         AGO   .D1                                                      26525000
.S4      ANOP                                                           26526000
&B(&M+1) SETC  '&SYSLIST(&I)'(&J+1+&M*8,8)                              26527000
&M       SETA  &M+1                                                     26528000
.S3      AIF   (K'&SYSLIST(&I)-&M*8-&J GT 9).S4                         26529000
         AIF   (&J EQ K'&SYSLIST(&I)).S5                                26530000
&B(&M+1) SETC  '&SYSLIST(&I)'(&J+1+&M*8,K'&SYSLIST(&I)-&M*8-&J-1)       26531000
.S5      AIF   (&J EQ 1 OR &J GT 8).ERR                                 26532000
&B(7)    SETC  '&SYSLIST(&I)'(1,&J-1)                                   26533000
&B(7)    EQU   &B(1)&B(2)&B(3)&B(4)&B(5)&B(6)                           26534000
V&B(7)   DS    0X                                                       26535000
.D1      AIF   (&I LT N'&SYSLIST).I1                                    26536000
         DS    1X                                                       26537000
.MEND    MEND                                                           26538000
./ ADD NAME=DCDSWORK                                                    26539000
         MACRO                                                          26540000
&NAME    DCDSWORK  &DUMMY                                               26541000
.*                                                                      26542000
.*             CHANGES TO RELEASE 3                                     26543000
.*             CHANGES TO RELEASE 2                                     26544000
.*             CHANGES TO RELEASE 1                                     26545000
.*                                                                      26546000
.* GENERATES A WORK AREA FOR DC/DS EVALUATION ROUTINE                   26547000
.* (IFNX4D AND IFNX4N). THE WORK AREA IS GENERATED IN                   26548000
.* IFNX4D AND IFNX4N BY A CALL FROM MACRO ICOMMON                       26549000
&NAME    DS    0F                       NAME                            26550000
DCSWORK  DS    0XL11                             DC SWITCH CODES        26551000
DCSWTCH  DSW   BITLN,ESMOD,TYPEL,TYPEV,TYPEZ     DC/DS SWITCH CODE      26552000
LFDEL    DS    C                                 LEFT FIELD DELIMITER   26553000
RTDEL    DS    C                        RIGHT FIELD DELIMITER           26554000
SCADDR   DS    X                        SCAN ROUTINE ADDRESS            26555000
DCALIGN  DS    X                        IMPLIED LENGTH AND ALIGNMENT    26556000
MINLN    DS    X                        MINIMUM LENGTH LODIFIER RANGE   26557000
MAXLN    DS    H                        MAXIMUM LENGTH MODIFIER RANGE   26558000
BITINCR  DS    H                        NUMBER OF BITS PER DIGIT        26559000
HILIMIT  DS    X                        HIGHEST VALUE OF VALID DIGIT    26560000
PERIOD   EQU   D0+BITINCR               DECIMAL POINT ENCOUNTERED       26561000
EXPONENT EQU   D1+BITINCR               EXPONENT ENCOUNTERED            26562000
SUBFIELD EQU   D1+BITINCR               SUBFIELD ENCOUNTERED            26563000
TYPECALL DSW   ,DXDALIGN,DEFNAME,DLOCTREF,DCCALL,DSCALL,LTCALL,LTORGSCN 26564000
LEVELPTR DS    A                        LEVEL POINTER                   26565000
DUPFAC   DS    F                        DUPLICATION FACTOR              26566000
CONLNG   DS    F                        CONSTANT LENGTH                 26567000
DCDSWORK DS    0XL38                    INITIALIZE                      26568000
REFCOUNT DS    H                        SYMBOL COUNT                    26569000
SYMCOUNT DS    H                        SYMBOL COUNT                    26570000
VEETABLE DS    16X                      V-TYPE CONSTANTS TABLE          26571000
ADSYM    DS    A                        ADDRESS OF SYMBOL TABLE ENTRY   26572000
BITADD   DS    H                        RESIDUAL BIT COUNT              26573000
OPCNT    DS    H                        OPERAND COUNT                   26574000
LATTRSAV DS    H                        SAVE                            26575000
DCWORK   DS    0XL8                     INITIALIZE                      26576000
LATTR    DS    H                        LENGTH ATTRIBUTE                26577000
ADUPFAC  DS    A                        ADDRESS OF DUPLICATION FACTOR   26578000
CONCT    DS    H                        CONSTANT COUNT                  26579000
         MEND                                                           26580000
./ ADD NAME=DSW                                                         26581000
         MACRO                                                          26582000
&NAME    DSW                                                            26583000
         GBLA  &INDEX                                                   26584000
         GBLC  &DEFNAME(255),&SWNAME(255)                               26585000
         LCLA  &I,&J                                                    26586000
         LCLC  &X,&Y                                                    26587000
.*                                                                      26588000
.*             CHANGES TO RELEASE 3                                     26589000
.*             CHANGES TO RELEASE 2                                     26590000
.*             CHANGES TO RELEASE 1                                     26591000
.*                                                                      26592000
.* DEFINES SWITCH BYTE AND NAMES THE BITS IN THE BYTE                   26593000
.*                                                                      26594000
         AIF   (N'&SYSLIST GT 8).ERR1                                   26595000
&X       SETC  'JSW&SYSNDX'                                             26596000
         AIF   (K'&NAME EQ 0).NEXT                                      26597000
&X       SETC  '&NAME'                                                  26598000
.NEXT    ANOP                                                           26599000
&X       DS    X                                                        26600000
         AIF   (N'&SYSLIST EQ 0).EXIT                                   26601000
.LOOP    ANOP                                                           26602000
&J       SETA  &I+1                                                     26603000
         AIF   (K'&SYSLIST(&J) EQ 0).BYPASS                             26604000
         AIF   (K'&SYSLIST(&J) GT 8).ERR1                               26605000
&INDEX   SETA  &INDEX+1                                                 26606000
         AIF   (&INDEX GT 255).ERR2                                     26607000
&Y       SETC  '&SYSLIST(&J)'                                           26608000
&DEFNAME(&INDEX) SETC '&X'                                              26609000
&SWNAME(&INDEX)  SETC '&Y'                                              26610000
&Y       EQU   BIT&I                                                    26611000
.BYPASS  ANOP                                                           26612000
&I       SETA  &I+1                                                     26613000
         AIF   (N'&SYSLIST GT &I).LOOP                                  26614000
.EXIT    MEXIT                                                          26615000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     26616000
         MEXIT                                                          26617000
.ERR2    MNOTE 8,'TOO MANY SWITCHES DEFINED FOR ASSEMBLY.'              26618000
         MEND                                                           26619000
./ ADD NAME=EDSECT                                                      26620000
*COPY EDSECT                                                            26621000
************************************************************            26622000
* VS1 RELEASE 3 CHANGES                                                 26623000
*A418600                                                        OX00224 26624000
* VS1 RELEASE 3.1 CHANGES                                               26625000
*A150960                                                        OX04106 26626000
*A405500,407520                                                @OX07230 26627000
*A046200-046420                                                @OZ06551 26628000
*D046100                                                       @OZ06551 26629000
*C042000                                                       @OZ06551 26630000
*A389720                                                       @AY11215 26631000
ERRMESS  DSECT                          DSECT DEFINED FOR ERRSTK        26632000
*********************************************************************** 26633000
EMSGSVTY DS    C                        ERROR MSG SEVERITY CODE         26634000
EMSGCODE DS    C                        ERROR MSG CODE                  26635000
EMSGHL   EQU   *-EMSGSVTY               ERROR MSG ENTRY ADD-ON LENGTH   26636000
ENTRYLNG DS    C                        ERROR MSG ENTRY LENGTH          26637000
EMSGNTRY DS    CL8                      ERROR MSG ENTRY                 26638000
ERMEND   EQU   *-ERRMESS                                                26639000
         EJECT                                                          26640000
************************************************************            26641000
EDSECT   DSECT ,                        EDIT PHASE COMMON AREA          26642000
************************************************************            26643000
         USING EDSECT,MODCOMM           EDSECT BASE REGISTER            26644000
EDSCTGO  EQU   *                        BEGIN OF MODULE COMMON AREA     26645000
SWITCH1  DSW   SMDEF,                   WITHIN MAC DEF (SET BY MACRO)  X26646000
               SXPRTO,                  PROTO EXPECTED (SET BY MACRO)  X26647000
               SMISCN,                  RETURN TO MISCAN               X26648000
               SNOPSYN,                 OPSYN NO LONGER ALLOW  @OZ06551X26649000
               SUBLERR,                 SUBLIST IN ERROR       @OZ06551X26650000
               ENDSUBL,                 END OF SUBL IN MI-SCAN @OZ06551X26651000
               ALTERN                   IN ALTERNATE FORM      @OZ06551 26652000
*                                                              @OZ06551 26653000
SWITCH2  DSW   SONECD,                  READ ONE CARD (REPRO)          X26654000
               SBYCNT,                  BYPASS ALL CONTINUATIONS       X26655000
               SONECT,                  READ ONE CONTINUATION          X26656000
               SALLCT,                  READ ALL CONTINUATIONS         X26657000
               SBYONE,                  BYPASS ONE CARD IN EDITED FORM X26658000
               ,                                                       X26659000
               SCTLRTN,                 RETURN TO CALLER               X26660000
               SNOPND                   RETURN TO CALLER                26661000
*                                                                       26662000
SWITCH3  DSW   SCMTCT,                  COMMENTS CONTINUED             X26663000
               SNXTCT,                  NEXT CD CNT'N OF THIS CD       X26664000
               SPRVCT,                  THIS CD CNT'N OF PREVIOUS CD   X26665000
               SLSTCD,                  LAST CARD                      X26666000
               SINEOF,                  EOF ON SYSTEM INPUT            X26667000
               SGBLCL,                  PROC'G GBLX, LCLX STMT         X26668000
               SMI,                     EDITING MACRO INSTRUCTION      X26669000
               SUBSOP                   SUBSTITUTED OP CODE FOUND       26670000
*                                                                       26671000
SWITCH4  DSW   SPGRMD,                  PROCESSING PROGRAMMER MACRO    X26672000
               SOPNCD,                  IN OPEN CODE                   X26673000
               SSYSMD,                  IN SYSTEM MACRO DEFINITION     X26674000
               SICTL,                   ICTL PROCESSED IN THIS RUN     X26675000
               SNOACTR,                                                X26676000
               SABORT,                                                 X26677000
               SKPMND,                  SKIP TO MEND                   X26678000
               SKPEND                   SKIP TO END                     26679000
*                                                                       26680000
SWITCH5  DSW   SCOPY,                   COPY STATEMENT                 X26681000
               SXMCRO,                  EXPECT MACRO (EDITING SYS MD'S)X26682000
               SFSTCD,                  READ FIRST CARD                X26683000
               SDINIT,                  PREPARE TO INIT./CLOSE D'S     X26684000
               SDENT,                   PREPARE TO MAKE D ENTRY        X26685000
               SUPDNT,                  SUPPRESS DIRECTORY ENTRY       X26686000
               SMDDENTR,                MDD ENTRY MADE FOR THIS MACRO  X26687000
               AMPER                    AMPERSAND IN SUBLIST            26688000
*                                                                       26689000
SWITCH6  DSW   SUBLST,                  PROCESSING SUBLIST             X26690000
               POSSUBL,                 FIRST SCAN OF SUBLIST CANDIDATEX26691000
               SCNCAT,                  CONCATENATION IN OPERAND       X26692000
               SKWPRM,                  PROCESSING KEYWORD PARAMETER   X26693000
               PROTOCAL,                EDITING PROTO/MACRO CALL       X26694000
               SKPNAME,                 SKIP TO OP CODE FIELD          X26695000
               SPRMER,                  PARAMETER ERROR                X26696000
               SENDST                   END STATEMENT ENCOUNTERED       26697000
*                                                                       26698000
SWITCH7  DSW   SNMFND,                  NAME FOUND                     X26699000
               SNOFND,                  FIELD NOT FOUND                X26700000
               SNOSMCRO,                NO MACRO STMT IN SYS MAC DEF   X26701000
               SBDPROTO,                BAD PROTOTYPE STATEMENT        X26702000
               SNOSYSMD,                SYSTEM MAC DEF NOT FOUND       X26703000
               SDTCMT,                  .* TYPE COMMENTS               X26704000
               SASTCMT,                 * TYPE COMMENT                 X26705000
               STRCMT                   * TYPE COMMENT                  26706000
*                                                                       26707000
SWITCH8  DSW   ,,,,,                    DO NOT USE                     X26708000
               SENAME,                  EDITING NAME FIELD             X26709000
               SEOPCD,                  EDITING OPERATION FIELD        X26710000
               SEOPND                   EDITING OPERAND FIELD           26711000
*                                                                       26712000
SWITCH9  DSW   SINCPY,                  IN COPY CODE                   X26713000
               SISEQ,                   SEQ CHECK (SET BY ISEQ)        X26714000
               SNOCNT,                  CNT'N NOT ALLOWED (SET BY ICTL)X26715000
               SMAC,                    MACRO STMT COPIED AT THIS LEVELX26716000
               AMPER1                   VARIABLE SYM IN POSSUBL OX04106 26717000
*                                                                       26718000
AOTSW    DSW   AOEND,                   END STATEMENT                  X26719000
               AOMEND,                  MEND STATEMENT                 X26720000
               AICOPY,                  ICTL/COPY STATEMENT            X26721000
               AOPSYN,                  OPSYN STATEMENT                X26722000
               AOCOPYX,                 ILLEGAL WITHIN COPY CODE       X26723000
               AOMACROX,                ILLEGAL WITHIN MACRO DEF       X26724000
               AOPENCDX,                ILLEGAL WITHIN OPEN CODE       X26725000
               AOKBTNPM                 ALLOWED BETWEEN PROG'R MACROS   26726000
* X0 = ALLOWED ANYWHERE                                                 26727000
*                                                                       26728000
GSCNSW   DSW   GQST,                    ODD QUOTE CHECKER              X26729000
               GSUBS,                   FIELD NEEDS SUBSTITUTION       X26730000
               GAIF,                    AIF STATEMENT BEING SCANNED    X26731000
               METSW                    META TEXT INDICATION            26732000
*                                                                       26733000
PARMSTAT DSW   DMIENT,                  ENTERED FROM MIPRTOIN ROUTINE  X26734000
               DUMOPND,                 OPERAND TREATED AS DUMMY       X26735000
               DSDTX,                   DISALLOW SDT                   X26736000
               DLPRN,                   LEFT PARENTHESIS WAS READ      X26737000
               DECMA,                   END OPERAND - COMMA PASSED     X26738000
               DEEQL,                   END OPERAND - EQUAL SIGN PASSEDX26739000
               DQUOT,                   ODD QUOTE STATUS               X26740000
               DNOCRD                   NEW CARD WAS READ               26741000
*                                                                       26742000
NAMBYT   DSW   NQTSTG,                  QUOTED STRING                  X26743000
               NNALFA,                  FIRST CARD NOT ALPHA           X26744000
               NCNCAT,                  CONCATENATION                  X26745000
               NMPURE,                  IMPURITY (PASSED END COLUMN)   X26746000
               NNTGER,                  INTEGER (DECIMAL)              X26747000
               NOSYM,                   O SYM                          X26748000
               NSSYM,                   SEQUENCE SYMBOL                X26749000
               NVSYM                    V SYM                           26750000
*                                                                       26751000
GSUMRY   DSW   RQTSTG,                  QUOTED STRING                  X26752000
               RNALFA,                  FIRST CHARACTER NOT ALPHA      X26753000
               RCNCAT,                  CONCATENATION                  X26754000
               RMPURE,                  IMPURITY  (PASSED END COLUMN)  X26755000
               RNTGER,                  INTEGER (DECIMAL)              X26756000
               ROSYM,                   ORDINARY SYMBOL                X26757000
               RSSYM,                   SEQUENCE SYMBOL                X26758000
               RVSYM                    VARIABLE SYMBOL                 26759000
*  BLANK = ALL ZEROS                                                    26760000
*                                                                       26761000
         SPACE 3                                                        26762000
MSERR    DSW   MXVS,                    INVALID VARIABLE SYMBOL        X26763000
               MXRPRN                   EXCESSIVE RIGHT PARENTHESES     26764000
SDENTR   DS    C                        DIRECTORY ENTRY INDEX           26765000
SDENTR1  DS    C                        DIR INDEX FOR EXTRN/WXTRN OPND  26766000
DDNDX    DS    H                        D ENTRY INDEX                   26767000
DDNDX1   EQU   DDNDX+1                  D ENTRY INDEX                   26768000
DSTGEND  DC    A(0)                     DESTINATION AREA END PLUS 1     26769000
ENDATA   DC    A(0)                     END OF DATA IN WORK BUFFER      26770000
FPTRSV   DC    A(0)                     FIELD POINTER SAVE AREA         26771000
INPUT    DC    A(0)                     INPUT WORK BUFFER ADDRESS       26772000
IPTRSV   DC    A(0)                     INPUT BUFFER ADDRESS SAVE AREA  26773000
IRTNSV   DC    A(0)                     RETURNED ADDRESS SAVE AREA      26774000
OUTADR   DC    A(0)                     OUTPUT BUFFER LOCATION          26775000
VECPTR   DS    F                        PARAM VECTOR POINTER SAVE AREA  26776000
FSTGL    DS    F                        BEGIN OF STRING (PARAM)         26777000
AERRSTK  DC    A(ERRSTK)                ERROR MSG STACK ADDRESS         26778000
ESTKNDX  DC    A(0)                     ERROR MSG STACK INDEX           26779000
DSTGBGN  DS    F                        DESTINATION AREA POINTER        26780000
DSTGADJ  DS    F                        DEST. AREA POINTER AFTER ADJ.   26781000
DSTGNDX  DS    F                        DESTINATION AREA INDEX          26782000
STGNDX   DS    F                        DISPATCH AREA INDEX             26783000
EDTSVX   DS    F                        RETURN/TLINK REG SAVE           26784000
EDTSVY   DS    F                        RETURN POINTER SAVE AREA        26785000
EDTSVZ   DS    5F                       R15,R3 SAVE AREA                26786000
OCPTRSV  DS    F                        OP CODE POINTER SAVE AREA       26787000
INTERMET DS    F                        INTERMEDIATE LOCATION IN MT     26788000
MEZZOPTR DS    F                        INTERMEDIATE LOC IN WORK AREA   26789000
OPNDPTR  DS    F                        OPERAND FIELD POINTER SAVED     26790000
RTNSV    DS    F                        POINTER SAVE AREA               26791000
MIOPNDSV DS    F                                                        26792000
********************DO NOT CHANGE ORDER OF NAMP AND NAML***********     26793000
NAMP     DS    F                        SYMBOL LOCATION POINTER         26794000
NAML     DS    F                        MOVE LENGTH OF THE SYMBOL       26795000
*******************************************************************     26796000
NAMP1    DS    F                        SYMBOL PTR TO EXTRN/WXTRN OPND  26797000
NAML1    DS    F                        ADDT'L SYMBOL LENGTH SAVE AREA  26798000
NOTESV1  DS    F                        NOTED VALUE SAVE AREA 1         26799000
NOTESV2  DS    F                        NOTED VALUE SAVE AREA           26800000
SEQSV    DC    XL40'00'                 SEQ FIELD SAVE AREA             26801000
COPYSV1  EQU   SEQSV                                                    26802000
COPYSV2  DS    F                        SWITCH SAVE AREA                26803000
COPYSV2A EQU   COPYSV2+1                .                               26804000
COPYSV2B EQU   COPYSV2A+1               .                               26805000
COPYSV2C EQU   COPYSV2B+1               .                               26806000
COPYSV3  DS    7F                       ICTL FORMAT SAVE AREA           26807000
COPYSV4  DS    6F                                                       26808000
HICVAL   DS    F                        SDT HIGH CHAR VAL               26809000
HICVAL1  EQU   HICVAL+1                 SAVE AREA                       26810000
HICCNT   EQU   HICVAL+2                 MAX CHAR COUNT SAVE AREA        26811000
TBGLN    DS    F                        PREBEGIN STRING LENGTH          26812000
TSRCLN   DS    F                        DATA PORTION TRUE LENGTH        26813000
TCNTLN   DS    F                        CONTINUATION FLD TRUE LENGTH    26814000
PBGLEN   DS    F                        PREBEGIN STRING LENGTH MINUS 1  26815000
PNDLEN   DS    F                        POSTEND STRING LENGTH MINUS 1   26816000
ENDCOL   DS    F                        END COLUMN MINUS 1              26817000
ENDCOL3  EQU   ENDCOL+3                                                 26818000
SMACNAM  DS    CL8                      MACRO NAME SAVE AREA            26819000
COPYCODE DS    CL8                      COPY CODE                       26820000
COPYLN   DS    H                        COPY CODE LENGTH                26821000
DSTGLN   DS    H                        STRING LENGTH                   26822000
OCSAVE   DS    H                        INTERNAL OP CODE SAVE AREA      26823000
PRNLVL   DS    H                        PAREN LEVEL COUNTER             26824000
PRNLVL1  EQU   PRNLVL+1                                                 26825000
FLAGBT   DS    C                        FLAG BYTE SAVE AREA             26826000
DTLENG   DS    H                        DATA LENGTH                     26827000
OPNDCTR  DS    H                        OPERAND COUNTER                 26828000
OPNDC1   EQU   OPNDCTR+1                OPERAND COUNTER                 26829000
PARML    DS    H                        TOTAL PARM TEXT LENGTH @AY11215 26830000
MINDIF   DS    H                        DIF BETWEEN MINPUT AND INPUT    26831000
MTXTP    DS    F                        MI/PROTO META TEXT POINTER      26832000
MINPUT   DS    F                        CURRENT MI DATA AREA POINTER    26833000
MINPSTD  DS    F                        STANDARD MINPUT SAVED           26834000
STNPSTD  DS    F                        STANDARD INPUT SAVED            26835000
MINPADJ  DS    F                        ADJUSTED MINPUT SAVED           26836000
STNPADJ  DS    F                        ADJUSTED INPUT SAVED            26837000
OPCDPTR  DS    F                        OP CODE FIELD POINTER           26838000
ENDWKA   DS    F                        END OF DATA AREA PLUS 1         26839000
ENDWKADJ DS    F                        ADJUSTED 'ENDWKA'      @OX07230 26840000
MREGSV   DS    F                        EDSECT BASE REG SAVED           26841000
SVENDWKA DS    F                        SAVE END OF DATA AREA+1         26842000
COLCTR   DS    F                        COLUMN COUNTER                  26843000
CRDCTR   EQU   COLCTR+2                 CARD COUNTER                    26844000
OFPTRSV  DS    F                        INDEXP SAVE AREA                26845000
SVMINDIF DS    H                        SAVE STANDARD MINDIF            26846000
MINDFADJ DS    H                        ADJUSTED 'MINDIF'      @OX07230 26847000
LASTFIND DS    CL8                      LAST FOUND COPY MEMBER          26848000
         SPACE                                                          26849000
*        THE FOLLOWING 7 CONSTANTS MUST BE IN THE PREARRANGED SEQUENCE  26850000
RAVSP    DC    A(RSTACK)              1 RSTACK NEXT AVAILABLE LOCATION  26851000
NRSTK    DC    A(RSTACK+L'RSTACK)     2 END OF RSTACK + 1               26852000
RSTACK   DS    CL200                  3 MAXIMUM OF 25 ENTRIES           26853000
CSTK     DS    CL(6*(L'JNOTEVAL+9))   4 COPY CODE RECURSION STACK       26854000
CSTKX    EQU   *                                                        26855000
         DS    0F                                                       26856000
NCSTK    DC    A(CSTK+L'CSTK)           5 ENDING ADDRESS OF CSTK+1      26857000
BCSTK    DC    A(CSTK)                  6 CSTK BEGIN ADDRESS            26858000
CSTKADR  DC    A(CSTK)                  7 CSTK NEXT AVAILABLE LOCATION  26859000
SAVMALL  DS    16F                      REGISTER SAVE AREA              26860000
TPSAVE   EQU   SAVMALL                                                  26861000
TPSAVE1  EQU   SAVMALL+4                                        OX00224 26862000
ERRCNT   DS    H                        ERROR MSG COUNT - MAX 5 MSGS.   26863000
ERRCNT1  EQU   ERRCNT+1                                                 26864000
ERRSTK   DS    CL(ERMEND*6)             ERROR MSG STACK                 26865000
*        WORKSPACE FOR POSTFIX ROUTINE                                  26866000
SVLAST   DS    F                        LAST STACK ELEMENT POINTER      26867000
ALAST    DS    F                        START OF STACK--CONSTANT        26868000
TEMP     EQU   *                        PRE-STACK ENTRY                 26869000
TEMPOP   DS    C                        OPERATOR                        26870000
TEMPBIND DS    C                        BINDING FACTOR                  26871000
         SPACE                                                          26872000
STACK    DS    36H                      MAXIMUM OF 35 OPERATORS IN     X26873000
                                        STACK ( 5+ PAREN LEVELS)        26874000
         SPACE 3                                                        26875000
         DS    0H                                                       26876000
VSFLG    DC    H'0'                     SET VAR TYPE SAVED FOR NAME     26877000
VSTAT    EQU   VSFLG+1                                                  26878000
STGCNT   DC    X'00'                    STRING COUNTER                  26879000
CNTCTR   DC    X'00'                    CONTINUATION CARD COUNTER       26880000
SEQSVT   DC    40X'00'                  SEQ FIELD - COMPARE V. SEQSV    26881000
         SPACE 3                                                        26882000
         DS    0F                                                       26883000
ADJSV    DS    F                        RETURN POINTER SAVED HERE       26884000
VSRSV    DS    F                        VSRTN RETURN LINKAGE            26885000
VSRSV1   DS    F                        HEADER DATA POINTER             26886000
MPOPSV   DS    F                        MPOPND ROUTINE RETURN LINKAGE   26887000
NEXPSV   DS    F                        RETURN LINKAGE SAVED            26888000
SUBSAVE  DS    2F                       MPOPSV/NEXPSV SAVE AREA         26889000
REGSAVE3 DS    F                        REGISTER SAVE AREA              26890000
         SPACE 3                                                        26891000
         DS    0H                                                       26892000
DNTERR   DS    CL10                                                     26893000
*        BAL   TLINK,SNAPERR            LOG ERROR                       26894000
         ORG   DNTERR+4                 REDEFINE                        26895000
         DC    AL2(2)                   WRNERR ENTRY CODE               26896000
DSEVCD   DC    AL1(0)                   SEVERITY CODE                   26897000
DERRCD   DC    AL1(0)                   ERROR CODE                      26898000
*        BR    RETURN                   RETURN TO CALLER                26899000
         ORG                                                            26900000
ENDDNTL  EQU   *-DNTERR                                                 26901000
         SPACE 3                                                        26902000
*********************************************************************** 26903000
*                                                                       26904000
*         START OF EDIT PHASE COMMON INITIALIZED BY THE EDIT PHASE      26905000
*               DICTIONARY ROUTINES                                     26906000
*  THE PORTION OF COMMON BOUNDED BY DICTCOMS-DICTCOME IS INITIALIZED    26907000
*         AT THE START OF THE EDIT PHASE BY PHASENT                     26908000
DICTCOMS EQU   *                                                        26909000
FREESTRT DS    F                        PTR TO START OF DICT WORK AREA  26910000
VSDSTRT  DS    F                        PTR TO START OF VARB SYMB DIR   26911000
MDDSTRT  DS    F                        PTR TO START OF MACR DEFN DIR   26912000
SSPARMS  EQU   *                        BASE FOR SEQ SYMB REFER CONSTNT 26913000
SSRDSTRT DS    F                        PTR TO START OF SEQ SYMB REF DT 26914000
VSDSLOT  DS    F                        PTR TO NEXT AVAIL VSD ENTRY     26915000
OSPARMS  EQU   *                        BASE FOR ORD SYMB REFER CONSTNT 26916000
OSRDSTRT DS    F                        PTR TO START OF ORD SYMB REF DT 26917000
MDDSLOT  DS    F                        PTR TO NEXT AVAIL MDD ENTRY     26918000
CURMDDPT DS    F                        PTR TO CURRENT MDD ENTRY        26919000
REGSAVE1 DS    F                        REGISTER SAVE AREA              26920000
GTMVALOC DS    F                        MACRO DEFINITION VECTOR LENGTH  26921000
HIBYTE0  DS    F                        FULL WORD WORK AREA             26922000
MDDCHN   DS    F                        MASTER LINK, CHAINED MOD ENTRYS 26923000
MDDCNT   DS    F                        NUMBER OF MDD ENTRYS            26924000
OPSCHN   DS    F                        MASTER LINK, CHAINED OPSYN ENTR 26925000
*  THE PORTION OF COMMON BOUNDED BY MDINITS-TSINITE IS REINITIALIZED    26926000
*         FOR EACH MACRO DEFINITION TEXT SEGMENT BY MACRENT.            26927000
MDINITS  EQU   *                                                        26928000
GTPVALOC DS    F                        POSITIONAL PARAM VECTOR LENGTH  26929000
GTKVALOC DS    F                        KEYWORD PARAM VECTOR LENGTH     26930000
*  THE PORTION OF COMMON BOUNDED BY OCINITS-TSININTE IS REINITIALIZED   26931000
*        FOR THE OPEN CODE TEXT SEGMENT BY OPENENT.                     26932000
OCINITS  EQU   *                                                        26933000
GTLDALOC DS    F                        LOCAL DICTIONARY LENGTH         26934000
GTGVALOC DS    F                        GLOBAL VECTOR LENGTH            26935000
GTSDALOC DS    F                        SEQ SYMB REFER DICT LENGTH      26936000
SSRAPDIS DS    H                        DISPL IN SSRD FOR NEXT ENTRY    26937000
TSINITE  EQU   *                                                        26938000
SWITCHA  DSW   FNDFLG,                  MATCHING DIRECT ENTRY FOUND    X26939000
               NOTEFIL2,                NOTE OF NEXT RECORD REQ'D      X26940000
               LSTSYSMS,                SYSTEM MACRO EDIT COMPLETED    X26941000
               ITERSW,                  SYSTEM VARIABLE DEFINITIONS    X26942000
               ,,,                                                      26943000
FSWITCH  DS    X                        FIRST RECORD WRITTEN NOTED      26944000
GTODALOC DS    F                        ORD SYMB REF DICT LENGTH        26945000
OSRAPDIS DS    H                        DISPL IN OSRD FOR NEXT ENTRY    26946000
SSDLNGTH DS    H                        LENGTH OF SSRD ENTRY            26947000
SSFLGVAL DS    C                        TEXT FLAG FOR SEQ SYMB REFER    26948000
SREFTYPE DS    C                        RECORD TYPE, SEQ SYMB REFER     26949000
         DS    2H                       FILLER FOR ALIGNMENT (REQ'D)    26950000
OSDLNGTH DS    H                        LENGTH OF OSRD ENTRY            26951000
OSFLGVAL DS    C                        TEXT FLAG FOR ORD SYMB REFER    26952000
OREFTYPE DS    C                        RECORD TYPE, ORD SYMB REFER     26953000
REGSAVE2 DS    F                        REGISTER SAVE AREA              26954000
PIOPARMB DS    F                        FULL I/O AREA LENGTH            26955000
PIOPARMA DS    F                        CURRENT I/O AREA ADDRESS        26956000
PIOPARMC DS    H                        CURRENT I/O AREA LENGTH         26957000
IOCID    DSW   IZRO,IONE,               OP CODE LENGTH                 X26958000
               ITWO,ITRE                OP CODE TYPE                    26959000
IOCLNG   EQU   IZRO+IONE                OP CODE LENGTH REDEFINED        26960000
*              00 = MACRO INSTRUCTION OR UNDEFINED OP CODE              26961000
*              01 = ONE BYTE LONG OP CODE                               26962000
*              11 = TWO BYTE LONG OP CODE                               26963000
IOCTYP   EQU   ITWO+ITRE                OP CODE TYPE REDEFINED          26964000
*              00 = MACHINE OP                                          26965000
*              01 = EXTENDED MNEMONICS                                  26966000
*              11 = ASSEMBLER OP                                        26967000
*        BITS 4-7 = CURRENTLY NOT USED, ALL ZERO                        26968000
*                                                                       26969000
CONCODE  DSW   B0,B1,B2,B3,B4,B5,B6,B7                                  26970000
*                                                                       26971000
ATTRSV   DSW   AT0,AT1,AT2,AT3,AT4,AT5,AT6,AT7                          26972000
ATT      EQU   AT6                      00000010                        26973000
ATL      EQU   AT6+AT7                  00000011                        26974000
ATS      EQU   AT5                      00000100                        26975000
ATI      EQU   AT5+AT7                  00000101                        26976000
ATK      EQU   AT5+AT6                  00000110                        26977000
ATN      EQU   AT5+AT6+AT7              00000111                        26978000
SLST     EQU   AT2                      SYSLIST                         26979000
*              0 = VARIABLE SYMBOL OTHER THAN SYSLIST                   26980000
*              1 = SYSLIST                                              26981000
ATSUBS   EQU   AT0+AT1                                                  26982000
*              00 = NON-SUBSCRIPT                                       26983000
*              01 = SINGLE SUBSCRIPT                                    26984000
*              11 = DOUBLE SUBSCRIPT                                    26985000
MCALL    DSW   MCLA,                    SETA TYPE                      X26986000
               MCLC,                    SETC TYPE                      X26987000
               MCMPLX,,                 COMPLEX STATE                  X26988000
               MSLST                    SYSLIST                         26989000
FLGBYT   DSW   VTYP1,VTYP2,VPTYP,VSNS,VSLS,VDIM,VSTP1,VSTP2             26990000
*  VTYP1+VTYP2 - TYPE-- 00 = GLOBAL                                     26991000
*                       01 = LOCAL                                      26992000
*                       10 = NOT DEFINED                                26993000
*                       11 = PARAMETER                                  26994000
*  VPTYP - POSITIONAL/KEYWORD-- 0 = POSITIONAL                          26995000
*                               1 = KEYWORD                             26996000
*  VSNS - SYSTEM/NON-SYSTEM-- 0 = NON-SYSTEM                            26997000
*                             1 = SYSTEM                                26998000
*  VSLS - SYSLIST/NON-SYSLIST-- 0 = NON-SYSLIST                         26999000
*                               1 = SYSLIST                             27000000
*  VDIM - DIMENSIONED/NON-DIMENSIONED-- 0 = NON-DIMENSIONED             27001000
*                                        1 = DIMENSIONED                27002000
*  VSTP1+VSTP2 - SUBTYPE-- 00 = A-TYPE                                  27003000
*                          01 = B-TYPE                                  27004000
*                          10 = PARAMETER                               27005000
*                          11 = C-TYPE                                  27006000
*                                                                       27007000
GAFLG    EQU   D0                       GBLA FLAG                       27008000
GBFLG    EQU   VSTP2                    GBLB FLAG                       27009000
GCFLG    EQU   VSTP1+VSTP2              GBLC FALG                       27010000
LAFLG    EQU   VTYP2                    LCLA FLAG                       27011000
LBFLG    EQU   VTYP2+VSTP2              LCLB FLAG                       27012000
LCFLG    EQU   VTYP2+VSTP1+VSTP2        LCLC FLAG                       27013000
PARMFLG  EQU   VTYP1+VTYP2+VSTP1        PARAMETER FLAG                  27014000
KPARMFLG EQU   PARMFLG+VPTYP            KEYWORD PARAMETER FLAG          27015000
*                                                                       27016000
NOTESAVE DS    XL8                      NOTE OF START OF MACRO DEFINTN  27017000
SAVENOTE DS    XL8                      NOTE OF START OF DICT DATA FILE 27018000
DICTCOME EQU   *                                                        27019000
REGSTACK DS    8F                       REGISTER SAVE AREA              27020000
         SPACE 3                                                        27021000
         DS    4F                       PATCH AREA                      27022000
ENDEDSCT DS    0D                       END OF MODULE COMMON AREA       27023000
*********************************************************************** 27024000
./ ADD NAME=ERMS                                                        27025000
*COPY ERMS                                                              27026000
* /* START OF SPECIFICATIONS ****                                       27027000
*02* PROCESSOR = ASSEMBLER                                              27028000
**** END OF SPECIFICATIONS ***/                                         27029000
         GENERR ERR1,'SYSTEM VARIABLE SYMBOL $        USED AS SYMBOLIC X27030000
               PARAMETER IN MACRO PROTOTYPE'                            27031000
         GENERR ERR2,'SYMBOLIC PARAMETER $        IS DUPLICATED IN SAME*27032000
                MACRO PROTOTYPE'                                        27033000
         GENERR ERR3,'SYSTEM VARIABLE SYMBOL $        USED IN OPERAND OX27034000
               F GLOBAL OR LOCAL DECLARATION'                           27035000
         GENERR ERR4,'GLOBAL OR LOCAL VARIABLE $        DUPLICATES A SYX27036000
               MBOLIC PARAMETER IN SAME MACRO DEFINITION'               27037000
         GENERR ERR5,'GLOBAL OR LOCAL VARIABLE SYMBOL $        DUPLICATX27038000
               ES PREVIOUS DEFINITION'                                  27039000
         GENERR ERR6,'UNDEFINED VARIABLE SYMBOL $        '              27040000
         GENERR  ERR7,'USAGE OF $        IS INCONSISTENT WITH ITS DECLAX27041000
               RATION'                                                  27042000
         GENERR ERR8,'CIRCULAR OPSYN STATEMENTS'                        27043000
         GENERR ERR9,'EDIT DICTIONARY SPACE EXHAUSTED'                  27044000
   GENERR ERR10,'SOURCE MACRO $        HAS BEEN PREVIOUSLY DEFINED'     27045000
         GENERR ERR12,'ICTL OR OPSYN STATEMENT APPEARS TOO LATE IN THE X27046000
               PROGRAM'                                                 27047000
         GENERR ERR13,'OPSYN NAME FIELD NOT ORDINARY SYMBOL, OR OPSYN OX27048000
               PERAND FIELD NOT ORDINARY SYMBOL OR BLANK'               27049000
         GENERR ERR14,'INVALID OPCODE IN OPSYN OPERAND OR NAME FIELD'   27050000
         GENERR ERR16,'ILLEGAL OR INVALID NAME FIELD'                   27051000
         GENERR ERR17,'.* COMMENTS STATEMENT IS ILLEGAL OUTSIDE MACRO DX27052000
               EFINITION'                                               27053000
         GENERR ERR18,'MORE THAN 5 ERRORS ON THIS STATEMENT, ERROR ANAL*27054000
               YSIS OF THIS STATEMENT IS TERMINATED'                    27055000
         GENERR ERR19,'INVALID OPERAND ON ICTL OR ISEQ STATEMENT'       27056000
         GENERR ERR21,'INVALID TERM IN OPERAND'                         27057000
         GENERR ERR22,'ICTL STATEMENT IS ILLEGAL IN COPY CODE'          27058000
         GENERR ERR23,'ILLEGAL MACRO, MEND, OR MEXIT STATEMENT-  MAY APX27059000
               PEAR ONLY WITHIN MACRO DEFINITIONS'                      27060000
    GENERR ERR24,'UNPAIRED PARENS, OR BLANK FOUND INSIDE PAIRED PARENS' 27061000
         GENERR ERR25,'STATEMENT OUT OF SEQUENCE'                       27062000
         GENERR ERR26,'CHARACTERS APPEAR BETWEEN THE BEGIN AND CONTINUEX27063000
                COLUMNS ON CONTINUATION CARD'                           27064000
         GENERR ERR27,'ICTL, ISEQ, MACRO, OR OPSYN STATEMENT APPEARS INX27065000
                A MACRO DEFINITION'                                     27066000
       GENERR ERR28,'ILLEGAL PROTOTYPE KEYWORD PARAMETER DEFAULT VALUE' 27067000
         GENERR ERR29,'$        IS AN ILLEGAL OPERAND IN A GLOBAL OR LOX27068000
               CAL DECLARATION'                                         27069000
         GENERR ERR30,'DECLARED DIMENSION OF $        IS ILLEGAL'       27070000
         GENERR ERR31,'SET STATEMENT NAME NOT A VARIABLE SYMBOL, OR SETX27071000
                STATEMENT NAME INCONSISTENT WITH DECLARED TYPE'         27072000
         GENERR ERR32,'$         APPEARS IMPROPERLY IN THE OPERAND OF TX27073000
               HIS STATEMENT'                                           27074000
         GENERR ERR33,'$         IS AN INVALID LOGICAL OPERATOR'        27075000
         GENERR ERR35,'QUOTES NOT PAIRED, OR ILLEGAL TERMINATION OF QUOX27076000
               TED STRING'                                              27077000
         GENERR ERR36,'ATTRIBUTE REFERENCE FOR $        IS INVALID'     27078000
         GENERR ERR37,'$        IS AN ILLEGAL SUBSCRIPT'                27079000
         GENERR ERR38,'$        IS AN INVALID SELF-DEFINING TERM'       27080000
         GENERR ERR39,'$        IS AN INVALID VARIABLE SYMBOL'          27081000
         GENERR ERR42,'PARAMETER IN MACRO PROTOTYPE OR MACRO INSTRUCTIO*27082000
               N EXCEEDS 255 CHARACTERS'                                27083000
         GENERR ERR43,'MACRO PROTOTYPE STATEMENT HAS INVALID OP CODE'   27084000
         GENERR ERR46,'STATEMENT COMPLEXITY EXCEEDED'                   27085000
         GENERR ERR47,'UNEXPECTED END OF FILE ON SYSTEM INPUT (SYSIN)'  27086000
         GENERR ERR48,'ICTL STATEMENT HAS NO OPERAND'                   27087000
      GENERR ERR49,'COPY STATEMENT OPERAND NOT A VALID ORDINARY SYMBOL' 27088000
         GENERR ERR50,'COPY STATEMENT DOES NOT HAVE AN OPERAND'         27089000
       GENERR ERR51,'UNEXPECTED END OF DATA ON SYSTEM LIBRARY (SYSLIB)' 27090000
         GENERR ERR52,'UNARY OPERATOR NOT A PLUS OR MINUS SIGN'         27091000
         GENERR ERR53,'OP CODE NOT FOUND ON FIRST OR ONLY CARD'         27092000
         GENERR ERR54,'INVALID OPERATION CODE'                          27093000
         GENERR ERR55,'MEND STATEMENT GENERATED'                        27094000
         GENERR ERR57,'DUPLICATE FACTOR $        IN SETC EXPRESSION NOTX27095000
                TERMINATED BY A RIGHT PARENTHESIS'                      27096000
         GENERR ERR58,'NO ENDING QUOTE ON SETC EXPRESSION'              27097000
         GENERR ERR59,'INVALID TERM IN LOGICAL EXPRESSION'              27098000
         GENERR ERR60,'END STATEMENT GENERATED'                         27099000
         GENERR ERR61,'COPY NEST GREATER THAN FIVE'                     27100000
         GENERR ERR62,'REQUIRED OPERAND FIELD MISSING'                  27101000
         GENERR ERR64,'INTERLUDE DICTIONARY SPACE EXHAUSTED'            27102000
         GENERR ERR65,'EXPRESSION 2 OF EQU SYMBOL $        NOT IN RANGEX27103000
                0-65535'                                                27104000
         GENERR ERR66,'EXPRESSION 3 OF EQU SYMBOL $        NOT IN RANGEX27105000
                0-255'                                                  27106000
         GENERR ERR67,'DECLARED DIMENSION FOR GLOBAL VARIABLE $        X27107000
               IN $        $        IS INCONSISTENT'                    27108000
         GENERR ERR68,'COPY MEMBER $         NOT FOUND IN LIBRARY'      27109000
         GENERR ERR69,'TOO MANY CONTINUATION CARDS, TWO ALLOWED'        27110000
         GENERR ERR70,'SUBSTRING NOTATION IS NOT DELIMITED BY COMMA OR X27111000
               RIGHT PARENTHESIS'                                       27112000
         GENERR ERR73,'AGO OR AIF OPERAND NOT A SEQUENCE SYMBOL'        27113000
         GENERR   ERR74,'SEQUENCE SYMBOL $        IS MULTIPLY DEFINED IX27114000
               N $        $        '                                    27115000
         GENERR   ERR76,'SEQUENCE SYMBOL $        IS UNDEFINED IN $    X27116000
                    $        '                                          27117000
         GENERR   ERR78,'UNDEFINED OP CODE'                             27118000
         GENERR ERR80,'ATTRIBUTE REFERENCE TO UNDEFINED SYMBOL'         27119000
         GENERR ERR81,'DECLARED TYPE FOR GLOBAL VARIABLE $       IN $  X27120000
                     $        IS INCONSISTENT'                          27121000
         GENERR ERR85,'MACRO HEADER MISSING, MACRO NOT EXPANDABLE'      27122000
         GENERR ERR87,'INVALID MACRO DEFINITION PROTOTYPE, MACRO NOT EXX27123000
               PANDABLE'                                                27124000
         GENERR ERR88,'LIBRARY MACRO PROTOTYPE DOES NOT MATCH MEMBER NAX27125000
               ME - MACRO NOT EXPANDABLE'                               27126000
         GENERR ERR89,'GENERATION-TIME DICTIONARY SPACE EXHAUSTED'      27127000
         GENERR   ERR90,'UNDEFINED SEQUENCE SYMBOL ENCOUNTERED DURING CX27128000
               ONDITIONAL ASSEMBLY'                                     27129000
         GENERR   ERR91,'KEYWORD PARAMETER $        IS DUPLICATED ON SAX27130000
               ME MACRO CALL'                                           27131000
         GENERR   ERR92,'KEYWORD PARAMETER $        UNDEFINED IN MACRO X27132000
               DEFINITION'                                              27133000
         GENERR ERR100,'DICTIONARY SPACE EXHAUSTED, NO SKELETION DICTIOX27134000
               NARY BUILT'                                              27135000
         GENERR ERR101,'GENERATED OP CODE INVALID OR IS UNDEFINED'      27136000
         GENERR ERR102,'GENERATED OP CODE IS BLANK'                     27137000
         GENERR ERR104,'MORE THAN ONE TITLE STATEMENT NAMED'            27138000
         GENERR ERR105,'GENERATED FIELD EXCEEDS 255 CHARACTERS'         27139000
         GENERR ERR107,'CHARACTER STRING USED AS AN ARITHMETIC TERM EXCX27140000
               EEDS 10 CHARACTERS'                                      27141000
         GENERR ERR108,'CHARACTER STRING USED AS AN ARITHMETIC TERM CONX27142000
               TAINS NON-DECIMAL CHARACTERS'                            27143000
         GENERR ERR109,'CHARACTER STRING USED AS AN ARITHMETIC TERM IS X27144000
               A NULL STRING'                                           27145000
         GENERR ERR110,'ARITHMETIC OVERFLOW IN INTERMEDIATE RESULT OF SX27146000
               ETA EXPRESSION'                                          27147000
      GENERR ERR111,'SUBSCRIPT EXPRESSION HAS A ZERO OR NEGATIVE VALUE' 27148000
         GENERR ERR112,'SUBSCRIPT EXPRESSION EXCEEDS DECLARED DIMENSIONX27149000
               '                                                        27150000
         GENERR ERR113,'ILLEGAL REFERENCE MADE TO A PARAMETER THAT IS AX27151000
                SUBLIST'                                                27152000
        GENERR ERR114,'NEGATIVE DUPLICATION FACTOR IN CHARACTER STRING' 27153000
         GENERR ERR115,'FIRST EXPRESSION IN SUBSTRING NOTATION HAS ZEROX27154000
                OR NEGATIVE VALUE'                                      27155000
         GENERR ERR116,'SECOND EXPRESSION IN SUBSTRING NOTATION HAS NEGX27156000
               ATIVE VALUE'                                             27157000
         GENERR ERR117,'FIRST EXPRESSION IN SUBSTRING NOTATION EXCEEDS X27158000
               THE LENGTH OF THE STRING'                                27159000
         GENERR ERR118,'THE ACTR LIMIT HAS BEEN EXCEEDED'               27160000
         GENERR ERR119,'ILLEGAL TYPE ATTRIBUTE REFERENCE'               27161000
         GENERR ERR120,'ILLEGAL LENGTH ATTRIBUTE REFERENCE'             27162000
         GENERR ERR121,'ILLEGAL COUNT (K'') ATTRIBUTE REFERENCE'        27163000
         GENERR ERR122,'ILLEGAL NUMBER (N'') ATTRIBUTE REFERENCE'       27164000
         GENERR ERR123,'ILLEGAL SCALE ATTRIBUTE REFERENCE'              27165000
         GENERR ERR124,'ILLEGAL INTEGER ATTRIBUTE REFERENCE'            27166000
         GENERR ERR125,'INVALID NAME- ILLEGAL EMBEDDED CHARACTER OR NONX27167000
               -ALPHABETIC FIRST CHARACTER'                             27168000
         GENERR ERR126,'MORE THAN 5 ERRORS IN THIS STATEMENT, PROCESSINX27169000
               G OF THE STATEMENT IS TERMINATED'                        27170000
         GENERR ERR127,'VALUE OF CHARACTER STRING USED IN ARITHMETIC COX27171000
               NTEXT EXCEEDS 2,147,483,647'                             27172000
         GENERR ERR128,'GENERATED OP CODE EXCEEDS 8 CHARACTERS'         27173000
    GENERR ERR129,'GENERATED SYMBOL IN NAME FIELD EXCEEDS 8 CHARACTERS' 27174000
     GENERR ERR130,'FIRST SUBSCRIPT OF &&SYSLIST REFERENCE IS NEGATIVE' 27175000
         GENERR ERR131,'INCONSISTENT GLOBAL VARIABLE DECLARATION, SETX X27176000
               INSTRUCTION IGNORED'                                     27177000
         GENERR ERR132,'REFERENCE TO INCONSISTENTLY DECLARED GLOBAL VARX27178000
               IABLE RESULTS IN ZERO VALUE'                             27179000
         GENERR ERR133,'NO WORK SPACE FOR OPEN CODE SKELETON DICTIONARY*27180000
               '                                                        27181000
         GENERR ERR157,'DC OPERAND VALUE TOO LONG'                      27182000
         GENERR ERR158,'NAME OF STATEMENT IN DSECT USED IN RELOCATABLE *27183000
               ADDRESS CONSTANT'                                        27184000
         GENERR ERR159,'RELOCATABLE EXPRESSION AS EXPLICIT DISPLACEMENT*27185000
                IN S-TYPE CONSTANT'                                     27186000
         GENERR ERR161,'INVALID LITERAL #  '                            27187000
         GENERR ERR162,'VALUE ERROR- SHOULD BE BETWEEN 0 AND 9 - #  '   27188000
         GENERR ERR163,'MISSING OR INVALID SYMBOL IN NAME FIELD'        27189000
         GENERR ERR164,'INVALID OR ILLEGAL START STATEMENT'             27190000
         GENERR ERR165,'NULL PUNCH OPERAND OR PUNCH OPERAND EXCEEDS 80 X27191000
               CHARACTERS'                                              27192000
         GENERR ERR167,'SYMBOL FILE OUT OF STEP'                        27193000
         GENERR ERR168,'AN ARITHMETIC EXPRESSION NOT USED IN CONDITIONAX27194000
               L ASSEMBLY CONTAINS MORE THAN 20 TERMS'                  27195000
         GENERR ERR169,'INVALID SELF-DEFINING TERM #  '                 27196000
         GENERR ERR170,'TWO ADJACENT BINARY OPERATORS, OR BINARY OPERATX27197000
               OR EXPECTED BUT NOT FOUND #  '                           27198000
         GENERR ERR171,'TITLE STATEMENT OPERAND EXCEEDS 100 CHARACTERS' 27199000
         GENERR ERR172,'VALUE OF ORG OPERAND IS LESS THAN THE CONTROL SX27200000
               ECTION STARTING ADDRESS'                                 27201000
         GENERR ERR173,'ONE OR MORE SYMBOLS IN AN ORG OPERAND DO NOT BEX27202000
               LONG TO THE CURRENT CSECT, DSECT, OR COM'                27203000
         GENERR ERR174,'ORG OPERAND IS ABSOLUTE, MUST BE RELOCATABLE'   27204000
         GENERR  ERR175,'OPERAND SHOULD BEGIN WITH A QUOTE'             27205000
         GENERR  ERR176,'UNPAIRED AMPERSAND #  '                        27206000
         GENERR ERR177,'MISSING OPERAND'                                27207000
         GENERR  ERR178,'SYNTAX ERROR #  '                              27208000
         GENERR  ERR179,'OPERAND SUBFIELD #   MUST BE ABSOLUTE'         27209000
         GENERR  ERR180,'OPERAND 2 OF CNOP MUST BE EITHER 4 OR 8'       27210000
         GENERR  ERR181,'OPERAND 1 OF CNOP MUST BE 0, 2, 4 OR 6'        27211000
         GENERR ERR182,'OPERAND 1 OF CNOP IS NOT LESS THAN OPERAND 2'   27212000
         GENERR  ERR183,'MNOTE/CCW OPERAND EXCEEDS 255'                 27213000
      GENERR  ERR184,'INVALID RANGE ON CCW #  , 65535 IS MAXIMUM VALUE' 27214000
         GENERR  ERR185,'BLANK EXPECTED AS A DELIMITER #  '             27215000
         GENERR  ERR186,'INVALID SYMBOL #   OF ENTRY, EXTRN, OR WXTRN'  27216000
         GENERR  ERR187,'SYMBOL LONGER THAN 8 CHARACTERS #  '           27217000
         GENERR  ERR188,'$        IS AN UNDEFINED SYMBOL'               27218000
    GENERR  ERR189,'INVALID ENTRY OPERAND, LINKAGE CANNOT BE PERFORMED' 27219000
   GENERR  ERR190,'OPERAND OF PUSH STATEMENT IS NOT USING OR PRINT #  ' 27220000
         GENERR  ERR191,'PUSH LEVELS EXCEED 4 #  '                      27221000
    GENERR  ERR192,'OPERAND OF POP STATEMENT IS NOT USING OR PRINT #  ' 27222000
         GENERR  ERR193,'POP REQUEST NOT BALANCED BY PREVIOUS PUSH'     27223000
         GENERR  ERR194,'INVALID OPTION IN PRINT STATEMENT #  '         27224000
         GENERR  ERR195,'INVALID USING OR DROP STATEMENT #  '           27225000
         GENERR ERR196,'$        HAS BEEN PREVIOUSLY DEFINED'           27226000
         GENERR  ERR197,'*** MNOTE ***'                                 27227000
       GENERR  ERR198,'INVALID TYPE DECLARED ON DC/DS/DXD CONSTANT #  ' 27228000
         GENERR  ERR199,'INVALID LENGTH MODIFIER #  '                   27229000
         GENERR  ERR200,'INVALID SCALE MODIFIER #  '                    27230000
         GENERR  ERR201,'ILLEGAL OR INVALID EXPONENT MODIFIER IN DC/DS/X27231000
               DXD CONSTANT #  '                                        27232000
         GENERR  ERR202,'ARITHMETIC PRECISION OF FLOATING-POINT CONSTANX27233000
               T LOST #  '                                              27234000
         GENERR  ERR203,'L, D, E, F, H, OR Y-TYPE CONSTANT TRUNCATED, HX27235000
               IGH ORDER DIGITS LOST #  '                               27236000
         GENERR ERR204,'RELOCATABLE EXPRESSION IN A- OR Y-TYPE ADDRESS X27237000
               CONSTANT WITH BIT LENGTH SPECIFICATION NOT ALLOWED'      27238000
         GENERR  ERR205,'RELOCATABLE Y-TYPE CONSTANT, VALUE TRUNCATED TX27239000
               O RIGHTMOST 2 BYTES'                                     27240000
         GENERR  ERR206,'DUPLICATION FACTOR ERROR'                      27241000
         GENERR  ERR207,'OPERAND OF Q-TYPE CONSTANT DOES NOT NAME A DSEX27242000
               CT OR DXD'                                               27243000
         GENERR  ERR208,'DISPLACEMENT GREATER THAN X''FFF'''            27244000
         GENERR  ERR209,'ADDRESSABILITY ERROR- BASE AND DISPLACEMENT CAX27245000
               NNOT BE RESOLVED AND ARE SET TO 0'                       27246000
         GENERR  ERR210,'TOO FEW OPERANDS'                              27247000
         GENERR  ERR211,'TOO MANY OPERANDS'                             27248000
         GENERR  ERR212,'PREMATURE END OF OPERAND #  '                  27249000
         GENERR  ERR213,'COMPLEXLY RELOCATABLE EXPRESSION #  '          27250000
         GENERR  ERR214,'ILLEGAL USAGE OF LITERAL #  '                  27251000
     GENERR  ERR215,'ILLEGAL DELIMITER, RIGHT PARENTHESIS EXPECTED #  ' 27252000
         GENERR  ERR216,'ILLEGAL OPERAND FORMAT #  '                    27253000
         GENERR  ERR217,'RELOCATABILITY ERROR #  '                      27254000
         GENERR ERR218,'INVALID REGISTER SPECIFICATION - EVEN-NUMBERED X27255000
               REGISTER REQUIRED'                                       27256000
         GENERR  ERR219,'REGISTER OR IMMEDIATE FIELD OVERFLOW #  '      27257000
         GENERR  ERR220,'ALIGNMENT ERROR #  '                           27258000
         GENERR  ERR221,'ILLEGAL INDEX REGISTER OR LENGTH MODIFIER #  ' 27259000
         GENERR  ERR222,'INVALID INDEX REGISTER SPECIFIED #  '          27260000
         GENERR  ERR223,'RELOCATABLE INDEX REGISTER SPECIFIED #  '      27261000
         GENERR  ERR224,'LENGTH ERROR #  '                              27262000
   GENERR  ERR225,'RELOCATABLE LENGTH FIELD IN MACHINE INSTRUCTION #  ' 27263000
 GENERR  ERR226,'BASE REGISTER OF MACHINE INSTRUCTION NOT ABSOLUTE #  ' 27264000
   GENERR  ERR228,'RELOCATABLE DISPLACEMENT IN MACHINE INSTRUCTION #  ' 27265000
         GENERR  ERR229,'POSSIBLE REENTERABILITY ERROR #  '             27266000
         GENERR  ERR230,'BASE REGISTER NUMBER GREATER THAN 15 #  '      27267000
         GENERR  ERR231,'SYMBOL NOT PREVIOUSLY DEFINED - $        '     27268000
         GENERR  ERR233,'MORE THAN 6 LEVELS OF PARENTHESES #  '         27269000
         GENERR  ERR234,'PREMATURE END OF EXPRESSION #  '               27270000
         GENERR  ERR235,'ARITHMETIC OVERFLOW #  '                       27271000
         GENERR  ERR236,'ILLEGAL CHARACTER IN EXPRESSION #  '           27272000
         GENERR  ERR237,'CIRCULAR DEFINITION'                           27273000
         GENERR  ERR238,'ILLEGAL AMPERSAND IN SELF-DEFINING TERM #  '   27274000
         GENERR  ERR239,'INVALID FLOATING POINT CHARACTERISTIC'         27275000
         GENERR ERR240,'CHARACTER STRING OR SELFDEFINING TERM TERMINATEX27276000
               D BEFORE ENDING QUOTE FOUND'                             27277000
         GENERR ERR241,'SECOND OPERAND OF CCW NOT BETWEEN 0 AND X''FFFFX27278000
               FF'''                                                    27279000
         GENERR ERR242,'SPACE OPERAND NOT A SINGLE POSITIVE DECIMAL SEL*27280000
               FDEFINING TERM'                                          27281000
         GENERR ERR243,'FIRST CCW OPERAND IS NEGATIVE'                  27282000
         GENERR ERR244,'BITS 38 AND 39 OF CCW OPERAND NOT ZERO'         27283000
         GENERR ERR246,'LOCATION COUNTER OVERFLOW'                      27284000
         GENERR ERR254,'ILLEGAL FORMAT OF SECOND OPERAND OF END STATEME*27285000
               NT'                                                      27286000
         GENERR ERR255,'FIXED OR FLOATING POINT EXPRESSION ERROR #  '   27287000
./ ADD NAME=EVALWORK                                                    27288000
         MACRO                                                          27289000
&NAME    EVALWORK &DUMMY,&MAXTERM=20,&MAXPARN=6                         27290000
         LCLA  &I                                                       27291000
.*                                                                      27292000
.*             CHANGES TO RELEASE 3                                     27293000
.*             CHANGES TO RELEASE 2                                     27294000
.*             CHANGES TO RELEASE 1                                     27295000
.*                                                                      27296000
.*  GENERATES THE EVALUATION ROUTINE WORK AREA                          27297000
.* IN PHASE COMMON. THIS WORK AREA IS USED BY                           27298000
.* IFNX4V AND IFNX5V RESPECTIVLY                                        27299000
.*                                                                      27300000
SELFDEFN DBV   SELFDEF(0)                                               27301000
EVALMODE DSW   SUBLIST,PRDEFREQ,DCOP                                    27302000
CLCLNG   DS    H                                                        27303000
IMPLNG   DS    H                                                        27304000
EVALREGS DS    0A                                                       27305000
ATPTR    DS    A(TERMS)                                                 27306000
ALPTR    DS    A(RLIST)                                                 27307000
AOPTR    DS    A(OPRNS-1)                                               27308000
ERRPTR   DS    F                        ERROR COLUMN POINTER            27309000
OPNEND   DS    F                                                        27310000
&I       SETA  (&MAXTERM+1)/2*2                                         27311000
         DS    0D                       CAUSE DOUBLE WORD ALIGNMENT     27312000
RLIST    DS    &I.H                                                     27313000
&I       SETA  &MAXPARN*16+25                                           27314000
EVALWORK DS    0XL&I                                                    27315000
FIRST    DBV   ,                                                        27316000
STATUS   DBV   STATUS1(1),STATUS2(2)                                    27317000
         DS    3H                                                       27318000
RELOCTR  DBV   NORELOC(0)                                               27319000
         DS    X                                                        27320000
         DS    3H                                                       27321000
EVALSW   DSW   ,ENDOFEXP,LOCTREF,LNGQUOTE                               27322000
EVALSW1  DSW   ,EVALERR,SDVSIZE,RELOCER,OVERFLO,NOTDEFN,,FATALER        27323000
         ORG   EVALSW1                                                  27324000
         DBV   COMPLEX(0)                                               27325000
         DS    3H                                                       27326000
PARENCNT DS    0H                                                       27327000
         DS    X                                                        27328000
         DBV   NOPAREN(0),MAXPARN(&MAXPARN)                             27329000
         DS    3H                                                       27330000
SHIFTN   DBV   SHIFTB(1),SHIFTD(3),SHIFTH(4),SHIFTC(8)                  27331000
         DBV   MAXCHAR(4),MAXHEX(8),MAXDEC(10),MAXBIT(32)               27332000
         ORG   FIRST                    ORIGIN                          27333000
&I       SETA  &MAXPARN*4+6                                             27334000
TERMS    DS    &I.F                                                     27335000
         DBV   ENDPARN(0)                                               27336000
&I       SETA  &MAXPARN*4+4                                             27337000
OPRNS    DS    &I.X                                                     27338000
         DS    X                        NOT USED                        27339000
XSSAV    DS    H                        TEST ESDID                      27340000
DSECT2   DSECT ,                        TERM STACK POINTER              27341000
         ORG   DSECT2                   ORIGIN                          27342000
TERM1CNT DS    F                                                        27343000
TERM1    DS    F                                                        27344000
TERM2CNT DS    F                                                        27345000
TERM2    DS    F                                                        27346000
DSECT3   DSECT ,                        RELOCATION LIST POINTER         27347000
         ORG   DSECT3                   ORIGIN                          27348000
ESDID    DS    H                                                        27349000
NEXTESD  DS    H                                                        27350000
JTEXT    DSECT ,                        OPERATOR STACK POINTER          27351000
         ORG   JTEXT                    ORIGIN                          27352000
OLDOP    DBV   DEL0(JLPARN),ADD0(JPLUS),SUB0(JMINUS),MUL0(JASTER),     ,27353000
               DIV0(JSLASH),UNY0(JSLASH+1)                              27354000
NEWOP    DBV   DEL1(JLPARN),ADD1(JPLUS),SUB1(JMINUS),MUL1(JASTER),     ,27355000
               DIV1(JSLASH),UNY1(JSLASH+1)                              27356000
DSECT5   DSECT ,                        INPUT POINTER                   27357000
         ORG   DSECT5                   ORIGIN                          27358000
CHAR1    DS    X                        CURRENT CHARACTER               27359000
CHAR2    DS    X                        NEXT CHARACTER                  27360000
CHAR3    DS    X                        NEXT CHARACTER                  27361000
DSECT14  DSECT ,                        INPUT POINTER                   27362000
         ORG   DSECT14                  ORIGIN                          27363000
         DBV   BQUOTE(JB),CQUOTE(JC),XQUOTE(JX),LQUOTE(JL)              27364000
&SYSECT  DSECT ,                        RESUME DSECT                    27365000
         MEND                                                           27366000
./ ADD NAME=GENCOM                                                      27367000
*COPY GENCOM                                                            27368000
*D776500                                                       @OX10944 27369000
*A160000                                                       @OX10944 27370000
GENCOM   DSECT                                                          27371000
         USING GENCOM,R7                BASE FOR MODULE COMMON          27372000
         SPACE                                                          27373000
*        DYNAMIC POINTERS AND WORK VALUES                               27374000
         SPACE                                                          27375000
TXTIN    DS    F                        SAVE INPUT FIXED TEXT POINTER   27376000
TXTOUT   DS    F                        SAVE OUTPUT FIXED TEXT POINTER  27377000
LCR      DS    F                        LOCATION COUNTER WORK AREA      27378000
GENRTRN  DS    F                        SAVE AREA FOR GENFLD RETURN REG 27379000
GENPTR   DS    F                        OUTPUT LENGTH FIELD POINTER     27380000
STRRTRN  DS    F                        GENSTRNG RETURN REGISTER        27381000
OUTPTR   DS    F                        OUTPUT TEXT POINTER SAVE        27382000
RESRTRN  DS    F                        RESOLVE RETURN REGISTER SAVE    27383000
GENREGS  DS    4F                       SAVE R2 THROUGH R5              27384000
INFIXRTN DS    F                        INFIX ROUTINE RETURN REGISTER   27385000
ESTKNDX  DS    F                        DISPL TO NEXT ERROR STK ENTRY   27386000
NEWSTRNG DS    F                        NEW CHARACTER STRING START      27387000
ERRCNT   DS    H                        COUNT OF ERRORS LOGGED          27388000
STRNGLN  DS    H                        LENGTH OF THAT STRING           27389000
         SPACE                                                          27390000
*        SWITCHES FOR GENERATION                                        27391000
         SPACE                                                          27392000
INHI     DSW   INHIBIT                  ESDS STARTED SWITCH             27393000
EVALSW01 DSW   GLOBAL,                  CURRENT TERM IS GLOBAL REFERENCE27394000
               CHARMODE,                CHARACTER STRING OUTPUT WANTED X27395000
               CTYPE,                   TERM IS CHARACTER STRING       X27396000
               INMACDEF,                ON AT MACRO, OFF AT MEND       X27397000
               CALLING,                 PROCESSING MCALL STATEMENT     X27398000
               FRCMI,                   FIRST MACHINE INSTR    @OX10944X27399000
               INMACRO,                 EXPANDING A MACRO              X27400000
               NOCALL                   ABORT THE CALL IN PROCESS       27401000
EVALSW02 DSW   FRSTTITL,                TITLE WITH NAME ENCOUNTERED    X27402000
               ERR105SW,                ERR105 LOGGED ONCE ALREADY     X27403000
               PREVDEF,                 PARAM DEFINITION ALREADY FOUND X27404000
               SUBSCR2,                 SUBSCRIPT 2 ON SYSLIST TERM    X27405000
               FLUSH1,                  FLUSH TO EARLY END OF FILE     X27406000
               GENEND,                  END STMT HIT INSIDE MACRO      X27407000
               FLUSH2,                  EARLY END OF FILE REACHED      X27408000
               FLUSH3                   END STMT TO BE GENERATED        27409000
EVALSW03 DSW   CCOMP,                   DO CHARACTER COMPARE           X27410000
               SUBLIST                  PROCESSING MACRO SUBLIST        27411000
         SPACE                                                          27412000
*        STACK MANAGEMENT                                               27413000
         SPACE                                                          27414000
STACKLVL DS    F                        NEXT AVAILABLE POSITION         27415000
STACKEND DS    A(0)                     END OF STACK                    27416000
STRPTR1  DS    A(0)                     STRING 1 CURRENT                27417000
STRPTR2  DS    A(0)                     STRING 2 CURRENT                27418000
         SPACE                                                          27419000
*        MACRO LEVEL CONTROL                                            27420000
         SPACE                                                          27421000
MACROLVL DS    F                        MACRO NEST COUNT                27422000
         SPACE                                                          27423000
ENTRYNDX DS    0H                       DICTIONARY ROUTINES INDEX       27424000
         DS    XL1                      HALF-WORD PAD                   27425000
NDXVAL   DS    XL1                      ENTRY INDEX TO BRANCH TABLE     27426000
SYSNDX   DS    F                        &SYSNDX VALUE                   27427000
SYSECT   DS    0CL9                     &SYSECT VALUE                   27428000
SYSECTL  DS    C                             LENGTH                     27429000
GENSPEND EQU   *                                                        27430000
SYSECTS  DS    CL8                           STRING                     27431000
         SPACE                                                          27432000
*        EVALUATION LIMITS                                              27433000
         SPACE                                                          27434000
MAXCMPLX EQU   25                       MAXIMUM OF 25 TERMS IN STACK    27435000
TERMLNTH EQU   6                        LENGTH OF EACH STACK ENTRY      27436000
         SPACE                                                          27437000
*        EVALUATION WORK AREA                                           27438000
         SPACE                                                          27439000
         ORG   *+3-((*-GENCOM)-((*-GENCOM)/4)*4)  STACK STARTS ON NEXT X27440000
                                                  FULLWORD-1            27441000
         SPACE                                                          27442000
STKENTRY EQU   ((TERMLNTH+3)/4)*4       LENGTH OF EACH STACK ENTRY--   X27443000
                                          (ROUNDED UP TO FULL WORDS)    27444000
         SPACE                                                          27445000
STACK    EQU   *                        STACK NAME                      27446000
         SPACE                                                          27447000
STACKFLG DS    C                        FLAG BYTE                       27448000
STACKVAL DS    F                        VALUE, ON FULL WORD BOUNDARY    27449000
         SPACE                                                          27450000
         ORG   STACK+STKENTRY           START OF NEXT STACK ENTRY       27451000
         SPACE                                                          27452000
STACKNXT EQU   *                        NEXT STACK ENTRY                27453000
         SPACE                                                          27454000
NEXTFLG  DS    C                        NEXT ENTRY FLAG BYTE            27455000
NEXTVAL  DS    F                        NEXT ENTRY VALUE--FULL WORD     27456000
         SPACE                                                          27457000
         ORG   STACK                    REPOSITION TO STACK START       27458000
         SPACE                                                          27459000
EVALSTCK DS    (MAXCMPLX)CL(STKENTRY)   AND PUT IN THE WHOLE STACK      27460000
ENDSTACK EQU   *-STKENTRY               END OF STACK--STOPPER           27461000
ERRSTK   DS    CL(11*6)                 STACK FOR GENERATION ERRORS     27462000
ERRSTK7  DS    CL11                     SEVENTH ENTRY          FX0000   27463000
ERRSTKL  EQU   *-ERRSTK                                        FX0000   27464000
         SPACE                                                          27465000
UNPKBUF  DS    CL16                     UNPACK WORKSPACE                27466000
UNPKLAST EQU   UNPKBUF+15               LAST BYTE                       27467000
UNPKEND  EQU   UNPKBUF+16               END OF STRING                   27468000
         SPACE                                                          27469000
STRING1  DS    CL256                    PRIMARY CHARACTER BUFFER.  FIRST27470000
                                          BYTE IS CURRENT STRING LENGTH 27471000
STRING2  DS    CL256                    SECONDARY CHARACTER BUFFER.     27472000
         SPACE                                                          27473000
*                                                                       27474000
*        START OF GENERATE PHASE COMMON INITIALIZED AND USED BY THE     27475000
*              GENERATE PHASE DICTIONARY ROUTINES.                      27476000
*                                                                       27477000
DICTCOMS DS    0F                                                       27478000
FREESTRT DS    F                        PTR TO START OF WORK SPACE      27479000
FREEEND  DS    F                        PTR TO END OF WORK SPACE        27480000
OVLYSTRT DS    F                        PTR TO SPACE FOR LOCAL DICTS    27481000
SPACEAL  DS    F                        PTR TO CURRENT SPACE, LOW END   27482000
SPACEAH  DS    F                        PTR TO CURRENT SPACE, HI END    27483000
SPACEAE  DS    F                        LENGTH OF CURRENT SPACE         27484000
REGSAVEA DS    F                        REGISTER SAVE AREA              27485000
REGSAVEB DS    F                        REGISTER SAVE AREA              27486000
OPSNSTRT DS    F                        PTR TO START OF OPSYN TABLE     27487000
MDVPTRSV DS    F                        PTR TO CURRENT MDV ENTRY        27488000
HIBYTE0  DS    F                        FULL-WORD WORK AREA             27489000
OSRDSTRT DS    F                        PTR TO START OF ORD SYMB REF DT 27490000
GDSTRT   DS    F                        PTR TO START OF GBL DICTIONARY  27491000
MDVSTRT  DS    F                        PTR TO START OF MDV             27492000
CURRDICT DS    F                        PTR TO HEADER OF CURRENT DICT   27493000
CURRPARM DS    F                        PTR TO CURRENT PARAM TABLE      27494000
CURRGLBL DS    F                        PTR TO CURRENT GLOBAL VECTOR    27495000
CURRSEQS DS    F                        PTR TO CURRENT SEQ SYMB REF DCT 27496000
CURRLOCL DS    F                        PTR TO CURRENT LOCAL DICTIONARY 27497000
CURRPOST DS    F                        PTR TO CURRENT POSIT PARAM VCTR 27498000
CURRKEYD DS    F                        PTR TO CURRENT KEYWD PARAM VCTR 27499000
PRMTBLAD EQU   SPACEAL                  PTR TO START OF PARAM TABLE     27500000
PRMTBLDS DS    F                        CURRENT LENGTH OF PARAM TABLE   27501000
PVECTPTR EQU   SPACEAH                  PTR TO CURRENT PARAM VECTOR     27502000
PVECTDIS DS    F                        CURRENT LENGTH OF POSIT VECTOR  27503000
KVECTDIS DS    F                        CURRENT LENGTH OF KEYWD VECTOR  27504000
KCHANPTR DS    F                        LINK TO KEYWORD PARAM CHAIN     27505000
PRMPTRSV DS    F                        PTR TO BASE OF PARAM TBL ENTRY  27506000
SUBCNT   DS    H                        CURRENT SUBOPERAND COUNT        27507000
SUBLEN   DS    H                        CURRENT SUBLIST CHARAC COUNT    27508000
SUBVCTDS DS    F                        CURRENT LENGTH OF SUBLIST VECTR 27509000
ACTRCNT  DS    F                        CURRENT ACTR VALUE              27510000
PIOPARMB DS    F                        LENGTH OF I/O AREA              27511000
PIOPARMA DS    F                        PTR TO CURRENT I/O AREA         27512000
PIOPARMC DS    H                        LENGTH OF CURRENT I/O AREA      27513000
NOFSYSLS DS    H                        N ATTR OF &SYSLIST              27514000
PPARMCNT DS    F                        CURRENT POSIT PARAM COUNT       27515000
ALTPTRSV DS    F                        ALTERNATE REGISTER SAVE AREA    27516000
PRMSWTCH DSW   PASSPARM,                PARAM PASSED AS PARAM TO INNER X27517000
               GBLCALL,                 GLOBAL DICTIONARY REFERENCE    X27518000
               REFFLAG,                 DICTIONARY REFERENCE IN PROCESSX27519000
               KEYFLG,                  KEYWORD PARAMETER IN PROCESS   X27520000
               DEFLG,                   DEFAULT VALUE FOR KEYWORD      X27521000
               BYFLG,                   BYPASS DEFAULT SUBLIST         X27522000
               ENFLG                    ENTER DEFAULT SUBLIST           27523000
NOTESAVE DS    XL8                      SAVE AREA, NOTE END OF CALL     27524000
SAVENOTE DS    XL8                      SAVE AREA, NOTE END OF PROTOTYP 27525000
KEYLENSV DS    XL1                      SAVE AREA, KEYWORD SYMB LENGTH  27526000
DICTCOME EQU   *                                                        27527000
*                                                                       27528000
*        END OF GENERATE PHASE COMMON INITIALIZED AND USED BY THE       27529000
*              GENERATE PHASE DICTIONARY ROUTINES.                      27530000
*                                                                       27531000
         SPACE                                                          27532000
REGSTACK DS    8F                       REGISTER SAVE AREA, DICT RTNS   27533000
RECURSTK DS    8F                       RECURRSIVE SAVE, DICT RTNS      27534000
RESOLVST DS    8F                       REGISTER SAVE AREA, RESOLVE RTN 27535000
EVALST   DS    8F                       REGISTER SAVE AREA, EVAL RTN    27536000
GENSTRST DS    8F                       REGISTER SAVE AREA, GENSTRNG RT 27537000
         SPACE                                                          27538000
         ORG   UNPKBUF                  LOCTR WORK SPACE OVERLAY        27539000
SAVVY    DS    2F                       LOCTR SAVE AREA                 27540000
LFLGA    DS    F                        LOCTR WORK AREA                 27541000
SYMBLCNT DS    H                        SYMBOL COUNT                    27542000
PARENCNT DS    H                        PAREN LEVEL                     27543000
NAMELNG  DS    H                        LABEL INDICATOR                 27544000
SUPPRESW DSW   WPSOP,VCONW,MODW,,,,,SUPPRESS SCAN INDICATORS            27545000
SUPPRESV DSW   VPSOP,VCONV,MODV,,,,,SUPPREST SCAN INDICATORS            27546000
         ORG   ,                        RESUME                          27547000
         SPACE                                                          27548000
*        GENERATOR PATCH AREA                                           27549000
         SPACE                                                          27550000
         DS    4F                       PATCH AREA                      27551000
GENCOM99 EQU   *                        END OF GENERATOR COMMON         27552000
./ ADD NAME=GENERR                                                      27553000
         MACRO                                                          27554000
         GENERR &CODE,&LIST             PROTOTYPE FOR GENERR            27555000
         GBLC  &ERCD(255)                                               27556000
         GBLB  &GENSW                                                   27557000
         LCLC  &CN                                                      27558000
         LCLC  &LET,&GEN(8)                                             27559000
         LCLA  &A,&K,&I                                                 27560000
         LCLA  &C,&CT,&CA                COUNTERS                       27561000
.* GENERATES ERROR MESSAGES AND A BRANCH TABLE TO THEM                  27562000
.* IN CSECT X6C00.  THE CODE MUST BE A SYMBOLIC NUMBER AND THE MSG      27563000
.* MUST BE A QUOTED STRING.  ACCEPTS SAME DATA AS JGENIN MACRO.  MSG    27564000
.* MUST CONTAIN  BLANK-DOLLAR-BLANK WHEREVER APPENDED DATA IS TO BE     27565000
.* INSERTED AND BLANK- POUND -BLANK WHEREVER A COLUMN POINTER IS TO BE  27566000
.* INSERTED INTO THE MESSAGE.  USE THESE TWO CHARACTERS ONLY FOR THIS   27567000
.* PURPOSE.   ALSO GENERATES EQUATES AND COMMENTS IN THE DSECT JERMSGCD 27568000
.* DEPENDING UPON THE SETTING OF THE GLOBAL VARIABLE &GENSW.            27569000
&K       SETA  K'&LIST                                                  27570000
&I       SETA  1                                                        27571000
&CN      SETC  '&CODE'(4,K'&CODE-3)     FIND ERROR CODE NUMBER          27572000
&A       SETA  &CN                      CONVERT TO DECIMAL              27573000
&CA      SETA  0                                                        27574000
.* GENERATES INTERNALLY CODED TEXT.                                     27575000
.* ACCEPTS ALPHA, NUMBERIC, AND ALL SPECIAL CHARACTERS.                 27576000
         AIF   ('&LIST'(1,1) EQ '''').M1                                27577000
         AIF   ('&LIST'(&K,1) EQ '''').M1  MISSING QUOTE                27578000
         MNOTE 1,'MESSAGE QUOTE MISSING'                                27579000
         MEXIT                          EXIT                            27580000
.M1      ANOP                           BRANCH LABEL                    27581000
&C       SETA  2                                                        27582000
&K       SETA  &K-1                                                     27583000
         AIF   (&GENSW).CONT           ARE WE GENERATING JERMSGCD DSECT 27584000
         SPACE                                                          27585000
&CODE    EQU   &CN                      SEE FOLLOWING MNOTE             27586000
         MNOTE *,&LIST                                                  27587000
         MEXIT                                                          27588000
.CONT    ANOP                           BRANCH LABEL                    27589000
S&CODE   DC    0CL(&K-&C+1)' '                                          27590000
.L2      ANOP                                                           27591000
&CT      SETA  1                                                        27592000
.L3      AIF   ('&LIST'(&C,1) GE 'A').L5  IS IT ALPHANUMERIC?           27593000
         AIF   ('&LIST'(&C,1) EQ '$').L3DOLR      DOLLAR                27594000
         AIF   ('&LIST'(&C,1) EQ '#').L3POUND     POUND                 27595000
         AIF   ('&LIST'(&C,1) EQ ' ').L3B         BLANK                 27596000
         AIF   ('&LIST'(&C,1) EQ ',').L3C         COMMA                 27597000
         AIF   ('&LIST'(&C,1) EQ '.').L3P         PERIOD                27598000
         AIF   ('&LIST'(&C,1) EQ '=').L3EQ        EQUAL                 27599000
         AIF   ('&LIST'(&C,1) EQ '+').L3PLUS      PLUS                  27600000
         AIF   ('&LIST'(&C,1) EQ '-').L3MIN       MINUS                 27601000
         AIF   ('&LIST'(&C,1) EQ '/').L3SLASH     SLASH                 27602000
         AIF   ('&LIST'(&C,1) EQ '(').L3LP        LEFT PARN.            27603000
         AIF   ('&LIST'(&C,1) EQ ')').L3RP        RIGHT PARN.           27604000
         AIF   ('&LIST'(&C,1) EQ '*').L3AST       ASTERISK              27605000
         AIF   ('&LIST'(&C,1) EQ '&&'(1,1)).L3AMP      AMPERSAND        27606000
         AIF   ('&LIST'(&C,1) EQ ''''(1,1)).L3QUO      QUOTE            27607000
.L5      ANOP                                                           27608000
&LET     SETC  'J'.'&LIST'(&C,1)                                        27609000
.L6      AIF   (&CT EQ 1).L7                                            27610000
&LET     SETC  ','.'&LET'                                               27611000
.L7      ANOP                                                           27612000
&GEN(&CT) SETC '&LET'                                                   27613000
&C       SETA  &C+1                                                     27614000
         AIF   (&C GT &K).L9                                            27615000
&CT      SETA  &CT+1                                                    27616000
         AIF   (&CT LT 9).L3                                            27617000
         DC    AL1(&GEN(1)&GEN(2)&GEN(3)&GEN(4)&GEN(5)&GEN(6)&GEN(7)&GEX27618000
               N(8))                                                    27619000
&CT      SETA  1                                                        27620000
.L8      ANOP                                                           27621000
&GEN(&CT) SETC ''                                                       27622000
&CT      SETA  &CT+1                                                    27623000
         AIF   (&CT LT 9).L8                                            27624000
         AGO   .L2                                                      27625000
.L3DOLR  ANOP                                                           27626000
&LET     SETC  'JDOLLAR'                                                27627000
         AGO   .L6                                                      27628000
.L3POUND ANOP                                                           27629000
&LET     SETC  'JPOUND'                                                 27630000
         AGO   .L6                                                      27631000
.L3EQ    ANOP                                                           27632000
&LET     SETC  'JEQUAL'                                                 27633000
         AGO   .L6                                                      27634000
.L3PLUS  ANOP                                                           27635000
&LET     SETC  'JPLUS'                                                  27636000
         AGO   .L6                                                      27637000
.L3MIN   ANOP                                                           27638000
&LET     SETC  'JMINUS'                                                 27639000
         AGO   .L6                                                      27640000
.L3SLASH ANOP                                                           27641000
&LET     SETC  'JSLASH'                                                 27642000
         AGO   .L6                                                      27643000
.L3C     ANOP                                                           27644000
&LET     SETC  'JCOMMA'                                                 27645000
         AGO   .L6                                                      27646000
.L3B     ANOP                                                           27647000
&LET     SETC  'JBLANK'                                                 27648000
         AGO   .L6                                                      27649000
.L3P     ANOP                                                           27650000
&LET     SETC  'JPERIOD'                                                27651000
         AGO   .L6                                                      27652000
.L3LP    ANOP                                                           27653000
&LET     SETC  'JLPARN'                                                 27654000
         AGO   .L6                                                      27655000
.L3RP    ANOP                                                           27656000
&LET     SETC  'JRPARN'                                                 27657000
         AGO   .L6                                                      27658000
.L3AST   ANOP                                                           27659000
&LET     SETC  'JASTER'                                                 27660000
         AGO   .L6                                                      27661000
.L3AMP   AIF   ('&LIST'(&C+1,1) EQ '&&'(1,1)).L3AMP2  2ND AMPERSAND     27662000
         MNOTE 1,'ILLEGAL AMPERSAND - AMPERSAND IS NOT DOUBLED'         27663000
.L3AMP2  ANOP                                                           27664000
&LET     SETC  'JAMPER'                                                 27665000
&C       SETA  &C+1                                                     27666000
&CA      SETA  &CA+1                                                    27667000
         AGO   .L6                                                      27668000
.L3QUO   AIF   ('&LIST'(&C+1,1) EQ ''''(1,1)).L3QUO2  2ND QUOTE         27669000
         MNOTE 1,'ILLEGAL QUOTE - QUOTE IS NOT DOUBLED'                 27670000
.L3QUO2  ANOP                                                           27671000
&LET     SETC  'JQUOTE'                                                 27672000
&C       SETA  &C+1                                                     27673000
&CA      SETA  &CA+1                                                    27674000
         AGO   .L6                                                      27675000
.L9      AIF   (&CA EQ 0).L9D                                           27676000
&LET     SETC  ','.'JBLANK'                                             27677000
&CT      SETA  &CT+1                                                    27678000
         AIF   (&CT LT 9).L9B                                           27679000
         DC    AL1(&GEN(1)&GEN(2)&GEN(3)&GEN(4)&GEN(5)&GEN(6)&GEN(7)&GEX27680000
               N(8))                                                    27681000
&CT      SETA  1                                                        27682000
.L9A     ANOP                                                           27683000
&GEN(&CT) SETC ''                                                       27684000
&CT      SETA  &CT+1                                                    27685000
         AIF   (&CT LT 9).L9A                                           27686000
&CT      SETA  1                                                        27687000
&LET     SETC  'JBLANK'                                                 27688000
.L9B     ANOP                                                           27689000
&GEN(&CT)      SETC                     '&LET'                          27690000
&CA      SETA  &CA-1                                                    27691000
         AGO   .L9                                                      27692000
.L9D     DC    AL1(&GEN(1)&GEN(2)&GEN(3)&GEN(4)&GEN(5)&GEN(6)&GEN(7)&GEX27693000
               N(8))                                                    27694000
.L10     ANOP                                                           27695000
&ERCD(&A) SETC 'S&CODE'                 SORT & SAVE MESSAGE NAME        27696000
         MEND                                                           27697000
./ ADD NAME=GENOP                                                       27698000
         MACRO                                                          27699000
         GENOP &PHASE=,                 1=EDIT PHASE, 3=GENERATE PHASE *27700000
               &SET=UNIV,               CHAR SET-UNIV,STD,COMM,SCNTF   X27701000
               &LEVEL=1                 LEVEL OF TABLE                  27702000
.*********************************************************************. 27703000
.*                                                                   *. 27704000
.* THIS MACRO GENERATES THE OP CODE TABLE FOR THE EDIT AND GENERATE  *. 27705000
.* PHASES.IT PERFORMS ITS WORK IN THE FOLLOWING STEPS:               *. 27706000
.*       1 - INITIALIZE  GLOBALS, COPY THE COMMON JUNK ETC.          *. 27707000
.*       2 - GENERATE THE OPCODE TABLE THROUGH A SERIES OF CALLS TO  *. 27708000
.*           THE MACRO 'OP', ONE CALL FOR EACH SYMBOLIC OPCODE.      *. 27709000
.*           NOTES - IF TAILORING OF THE TABLE ACCORDING TO INSTRUCT *. 27710000
.*                   SET BECOMES DESIRABLE,THIS CAN BE ACCOMPLISHED  *. 27711000
.*                   BY ADDING SOME PARAMETERS TO 'GENOP' AND DOING  *. 27712000
.*                   SOME SUITABLE BRANCHING ON THESE IN THIS STEP.  *. 27713000
.*                 - THE TABLE IS CHAINED BACKWARDS. IN ORDER TO GET *. 27714000
.*                   A FAST TABLE LOOKUP  FREQUENTLY USED OPCODES    *. 27715000
.*                   SUCH AS DC AND MVC SHOULD BE PUT TOWARDS THE END*. 27716000
.*                   AND UNFREQUENT ONES SUCH AS ICTL AND PRIVILEGED *. 27717000
.*                   OPS SHOULD BE IN THE BEGINNING.                 *. 27718000
.*       3 - GENERATE THE HASH TABLE, ONE POINTER FOR EACH CHAIN     *. 27719000
.*                                                                   *. 27720000
.*********************************************************************. 27721000
         GBLA  &SHIFT(8)                USED FOR FOLDING MNEMONIC       27722000
         GBLA  &CHAIN(71)               NO OF ENTRIES IN EACH CHAIN     27723000
         GBLC  &TABLE(71)               NAME OF PREVIOUS ENTRY IN CHAIN 27724000
         GBLC  &SEARCH(71)              CHAINS - FOR DOCUMENTATION ONLY 27725000
         GBLC  &CHARVAL                 VALID CHARACTERS FOR MNEMONIC   27726000
.*                                                                      27727000
         LCLA  &INDEX                   SCRATCH PAD                     27728000
         LCLA  &COUNT                   SCRATCH PAD                     27729000
         LCLC  &STRING                  SCRATCH PAD                     27730000
         LCLC  &ID                      SCRATCH PAD                     27731000
         LCLC  &COMMENT                 VARIABLE COMMENT FIELD          27732000
.*                                                                      27733000
.* CHECK PARAMETERS                                                     27734000
.*                                                                      27735000
         AIF   (&PHASE EQ 1 OR &PHASE EQ 3).POK   GO IF PHASE OK        27736000
         MNOTE '***  ERROR  *** - PHASE=&PHASE'                         27737000
.POK     AIF   (T'&LEVEL EQ 'N').LOK    GO IF LEVEL OK                  27738000
         MNOTE '***  ERROR  *** - LEVEL=&LEVEL'                         27739000
.LOK     ANOP                                                           27740000
.*                                                                      27741000
&SHIFT(1) SETA X'1000000'                                               27742000
&SHIFT(2) SETA X'10000'                                                 27743000
&SHIFT(3) SETA X'100'                                                   27744000
&SHIFT(4) SETA X'1'                                                     27745000
&SHIFT(5) SETA X'1000000'                                               27746000
&SHIFT(6) SETA X'10000'                                                 27747000
&SHIFT(7) SETA X'100'                                                   27748000
&SHIFT(8) SETA X'1'                                                     27749000
.*                                                                      27750000
&CHARVAL SETC  'ABCDEFGHIJKLMNOPQRSTUVWXYZ'                             27751000
.*                                                                      27752000
&ID      SETC  '&SET'(1,2)                                              27753000
.* INITIALIZE &TABLE                                                    27754000
.*                                                                      27755000
.INIT    ANOP                                                           27756000
&COUNT   SETA  &COUNT+1                 NEXT ENTRY                      27757000
&TABLE(&COUNT) SETC 'JOPTABLE'          INITIALIZE TO START OF JOPTABLE 27758000
         AIF   (&COUNT LT 71).INIT      GO IF NOT EXHAUSTED             27759000
         JHEAD 'OP CODE TABLE',                                        *27760000
               PHASEID=X&PHASE.K,                                      *27761000
               LEVEL=&LEVEL                                             27762000
*FUNCTION/OPERATION-                                                  * 27763000
*   THIS MODULE IS THE OP CODE TABLE. IT IS GENERATED ACCORDING TO    * 27764000
*   THE USER-SPECIFIED OPTIONS. IT IS GENERATED IN HASHED FORM. IT    * 27765000
*   IS INCLUDED AS PART OF BOTH THE EDIT PHASE AND THE GENERATE       * 27766000
*   PHASE.                                                            * 27767000
*                                                                     * 27768000
*ENTRY POINT-                                                         * 27769000
*        NONE                                                         * 27770000
*                                                                     * 27771000
*INPUT-                                                               * 27772000
*   NONE                                                              * 27773000
*                                                                     * 27774000
*OUTPUT-                                                              * 27775000
*   NONE                                                              * 27776000
*                                                                     * 27777000
*EXTERNAL ROUTINES-                                                   * 27778000
*   NONE                                                              * 27779000
*                                                                     * 27780000
*EXITS,NORMAL-                                                        * 27781000
*   NONE                                                              * 27782000
*                                                                     * 27783000
*EXITS,ERROR-                                                         * 27784000
*   NONE                                                              * 27785000
*                                                                     * 27786000
*TABLES/WORK AREAS-                                                   * 27787000
*   NONE                                                              * 27788000
*                                                                     * 27789000
*ATTRIBUTES-                                                          * 27790000
*   REFRESHABLE                                                       * 27791000
*                                                                     * 27792000
*NOTES-                                                               * 27793000
*                                                                     * 27794000
*   THE FOLLOWING IS A DESCRIPTION OF THE OP CODE TABLE ENTRY(S)      * 27795000
*                                                                     * 27796000
*   ITEM            LENGTH         DESCRIPTION                        * 27797000
*   ----            ------         -----------                        * 27798000
*                                                                     * 27799000
*   CHAIN POINTER   2 BYTES        NON-ZERO = DISPLACEMENT FROM THE   * 27800000
*                                             BASE OF THE HASH TABLE  * 27801000
*                                             TO THE NEXT ENTRY IN    * 27802000
*                                             THE CHAIN               * 27803000
*                                                                     * 27804000
*                                  ZERO = LAST ENTRY IN THE CHAIN     * 27805000
*                                                                     * 27806000
*   FLAGS           1 BYTE         FLAGS REQUIRED BY THE EDITOR AND   * 27807000
*                                  OP CODE LOOK-UP ROUTINE            * 27808000
*                                                                     * 27809000
*                                  BITS 0-1                           * 27810000
*                                 01 = ONE BYTE OP CODE OR ASMOP      * 27811000
*                                 11 = TWO BYTE OP CODE OR EXT MNEMON.* 27812000
*                                                                     * 27813000
*                                  BITS 2-3                           * 27814000
*                                 00 = ONE BYTE MACHINE OP              27815000
*                                    01 = EXTENDED MNEMONIC           * 27816000
*                                 10 = TWO BYTE MACHINE OP              27817000
*                                    11 = ASSEMBLER OP                * 27818000
*                                                                     * 27819000
*                                  BIT 4                              * 27820000
*                                    0                                * 27821000
*                                                                     * 27822000
*                                  BITS 5-7                           * 27823000
*                                    LENGTH OF MNEMONIC-1             * 27824000
*                                                                     * 27825000
*   MNEMONIC        1-8 BYTES      MNEMONIC IN INTERNAL CHARACTERS    * 27826000
*                                                                     * 27827000
*   FLAGA           1 BYTE         FLAGS FOR MACHINE OPS AND          * 27828000
*                                  EXTENDED MNEMONICS, INSERTED       * 27829000
*                                  INTO JTFLGA IN THE EDITED TEXT     * 27830000
*                                  FOR USE BY ALL SUBSEQUENT PHASES   * 27831000
*                                                                     * 27832000
*                                  BIT 0                              * 27833000
*                                    0 = MACHINE OP                   * 27834000
*                                                                     * 27835000
*                                  BIT 1                              * 27836000
*                                    0 = ONE BYTE OP CODE             * 27837000
*                                    1 = EXTENDED MNEMONIC OR         * 27838000
*                                        TWO BYTE OP CODE             * 27839000
*                                                                     * 27840000
*                                  BIT 2                              * 27841000
*                                    1 = PRIVATE CODE INITIATED       * 27842000
*                                                                     * 27843000
*                                  BIT 3                              * 27844000
*                                    0                                * 27845000
*                                                                     * 27846000
*                                  BIT 4                              * 27847000
*                                    1 = STATEMENT MAY AFFECT         * 27848000
*                                        STORAGE ASSIGNMENT OR THE    * 27849000
*                                        ESD                          * 27850000
*                                                                     * 27851000
*                                  BIT 5                              * 27852000
*                                    1 = STATEMENT MAY CONTAIN        * 27853000
*                                        SYMBOL REFERENCES IN THE     * 27854000
*                                        OPERAND                      * 27855000
*                                                                     * 27856000
*                                  BITS 6-7                           * 27857000
*                                    00 = INSTRUCTION LENGTH 2 BYTES  * 27858000
*                                    01 = INSTRUCTION LENGTH 4 BYTES  * 27859000
*                                    10 = INSTRUCTION LENGTH 6 BYTES  * 27860000
*                                                                     * 27861000
*   FLAGA           1 BYTE         FLAGS FOR ASSEMBLER OPS, INSERTED  * 27862000
*                                  INTO JTFLGA IN THE EDITED TEXT     * 27863000
*                                  FOR USE BY ALL SUBSEQUENT PHASES   * 27864000
*                                                                     * 27865000
*                                  BIT 0                              * 27866000
*                                    1 = ASSEMBLER OP                 * 27867000
*                                                                     * 27868000
*                                  BIT 1                              * 27869000
*                                    1 = EXTRN, WXTRN, ENTRY          * 27870000
*                                        STATEMENT                    * 27871000
*                                                                     * 27872000
*                                  BIT 2                              * 27873000
*                                    1 = PRIVATE CODE INITIATED       * 27874000
*                                                                     * 27875000
*                                  BIT 3                              * 27876000
*                                    1 = PRIVATE CODE INITIATION      * 27877000
*                                        INHIBITED                    * 27878000
*                                                                     * 27879000
*                                  BIT 4                              * 27880000
*                                    1 = STATEMENT MAY AFFECT         * 27881000
*                                        STORAGE ASSIGNMENT OR THE    * 27882000
*                                        ESD                          * 27883000
*                                                                     * 27884000
*                                  BIT 5                              * 27885000
*                                    1 = STATEMENT MAY CONTAIN        * 27886000
*                                        SYMBOL REFERENCES IN THE     * 27887000
*                                        OPERAND                      * 27888000
*                                                                     * 27889000
*                                  BIT 6                              * 27890000
*                                    1 = OPERAND SCAN IS REQUIRED     * 27891000
*                                                                     * 27892000
*                                  BIT 7                              * 27893000
*                                    1 = DC, DS, DXD STATEMENT        * 27894000
*                                                                     * 27895000
*   INTERNAL OP     1-2 BYTES      VALUE INSERTED INTO JTIOP1 (AND,   * 27896000
*      CODE                        FOR TWO BYTE OP CODES, INTO        * 27897000
*                                  JTIOP2) IN EDITED TEXT RECORD FOR  * 27898000
*                                  USE BY ALL SUBSEQUENT PHASES       * 27899000
*                                                                     * 27900000
*                                  MACHINE OP - HEX VALUE OF MACHINE  * 27901000
*                                               INSTRUCTION           * 27902000
*                                                                     * 27903000
*                                  ASSEMBLER OP - HEX VALUE BASED ON  * 27904000
*                                                 JTEXT               * 27905000
*                                                                     * 27906000
*   MASK            1 BYTE         MASK FOR EXTENDED MNEMONICS        * 27907000
*                                  INSERTED INTO JTIOP2 IN THE        * 27908000
*                                  EDITED TEXT                        * 27909000
*                                                                     * 27910000
*                                  BITS 0-3                           * 27911000
*                                    MASK (0-F)                       * 27912000
*                                                                     * 27913000
*                                  BITS 4-7                           * 27914000
*                                    0                                * 27915000
*                                                                     * 27916000
         EJECT                                                          27917000
         PRINT NOGEN    SUPPRESS PRINTING OF JCOMMON AND JTEXT          27918000
         COPY  JCOMMON                  GET INTERNAL CODES FOR LETTERS  27919000
         EJECT                                                          27920000
         COPY  JTEXT                    GET INTERNAL OPCODES FOR ASMOPS 27921000
         EJECT                                                          27922000
         PRINT GEN                                                      27923000
         JCSECT (X&PHASE.K&ID)                                          27924000
*RELEASE 3.1 CHANGES                                                    27925000
*A274100                                                        OX02977 27926000
         JMODID                                                         27927000
         DC    CL2'&ID'                                                 27928000
JOPTABLE EQU   *                                                        27929000
         JENTRY (X&PHASE.K01=JOPTABLE)                                  27930000
         ORG   JOPTABLE+2*71                                            27931000
.********************************************************************.  27932000
.*                                                                   *. 27933000
.** END OF PRELIMINARIES - GENERATE THE OP CODE TABLE               **. 27934000
.*                                                                   *. 27935000
.*********************************************************************. 27936000
         AIF   ('&SET' NE 'UNIV').STEP0                                 27937000
RRB      OP    X'B213'                                                  27938000
LRA      OP    X'B1'                                                    27939000
PTLB     OP    X'B20D'                                                  27940000
SCKC     OP    X'B206'                                                  27941000
STCKC    OP    X'B207'                                                  27942000
RDD      OP    X'85'                                                    27943000
WRD      OP    X'84'                                                    27944000
SIGP     OP    X'AE'                                                    27945000
STAP     OP    X'B212'                                                  27946000
SPX      OP    X'B210'                                                  27947000
STPX     OP    X'B211'                                                  27948000
CONCS    OP    X'B200'                                         FX0000   27949000
DISCS    OP    X'B201'                                         FX0000   27950000
IPTE     OP    X'B221'                                         FX0000   27951000
TPROT    OP    X'E501'                                         FX0000   27952000
CLRCH    OP    X'9F01'                                         FX0000   27953000
MVCIN    OP    X'E8'                                           FX0000   27954000
.STEP0   ANOP                                                           27955000
CLRIO    OP    X'9D01'                                                  27956000
CS       OP    X'BA'                                                    27957000
CDS      OP    X'BB'                                                    27958000
SPKA     OP    X'B20A'                                                  27959000
IPK      OP    X'B20B'                                                  27960000
STIDP    OP    X'B202'                                                  27961000
STIDC    OP    X'B203'                                                  27962000
SCK      OP    X'B204'                                                  27963000
STCK     OP    X'B205'                                                  27964000
SPT      OP    X'B208'                                                  27965000
STPT     OP    X'B209'                                                  27966000
LCTL     OP    X'B7'                                                    27967000
STCTL    OP    X'B6'                                                    27968000
SSK      OP    X'08'                                                    27969000
ISK      OP    X'09'                                                    27970000
TCH      OP    X'9F'                                                    27971000
HDV      OP    X'9E01'                                                  27972000
HIO      OP    X'9E'                                                    27973000
TIO      OP    X'9D'                                                    27974000
SIOF     OP    X'9C01'                                                  27975000
SIO      OP    X'9C'                                                    27976000
STOSM    OP    X'AD'                                                    27977000
STNSM    OP    X'AC'                                                    27978000
SSM      OP    X'80'                                                    27979000
LPSW     OP    X'82'                                                    27980000
         AIF   (&PHASE EQ 3).STEP1                                      27981000
AGOB     OP    DEF=NO,REF=NO,INPC=NO                                    27982000
AIFB     OP    DEF=NO,REF=NO,INPC=NO                                    27983000
ICTL     OP    DEF=NO,REF=NO,INPC=NO                                    27984000
ISEQ     OP    DEF=NO,REF=NO,INPC=NO                                    27985000
REPRO    OP    REF=NO,INPC=NO                                           27986000
OPSYN    OP    DEF=NO,REF=NO,INPC=NO                                    27987000
ACTR     OP    DEF=NO,REF=NO,INPC=NO                                    27988000
.STEP1   ANOP                                                           27989000
DXD      OP    REQOP=YES,INPC=NO                                        27990000
CXD      OP    REF=NO                                                   27991000
COM      OP    REF=NO,INHB=YES,INPC=NO                                  27992000
WXTRN    OP    DEF=NO,INPC=NO                                           27993000
PUSH     OP    DEF=NO,REF=NO,INPC=NO                                    27994000
POP      OP    DEF=NO,REF=NO,INPC=NO                                    27995000
         AIF   ('&SET' EQ 'STD' OR '&SET' EQ 'COMM').STEP2              27996000
MXD      OP    X'67'                                                    27997000
MXDR     OP    X'27'                                                    27998000
MXR      OP    X'26'                                                    27999000
SXR      OP    X'37'                                                    28000000
AXR      OP    X'36'                                                    28001000
LRDR     OP    X'25'                                                    28002000
LRER     OP    X'35'                                                    28003000
SWR      OP    X'2F'                                                    28004000
SW       OP    X'6F'                                                    28005000
SUR      OP    X'3F'                                                    28006000
SU       OP    X'7F'                                                    28007000
AWR      OP    X'2E'                                                    28008000
AW       OP    X'6E'                                                    28009000
AUR      OP    X'3E'                                                    28010000
AU       OP    X'7E'                                                    28011000
DDR      OP    X'2D'                                                    28012000
DD       OP    X'6D'                                                    28013000
DER      OP    X'3D'                                                    28014000
DE       OP    X'7D'                                                    28015000
HDR      OP    X'24'                                                    28016000
HER      OP    X'34'                                                    28017000
MDR      OP    X'2C'                                                    28018000
MD       OP    X'6C'                                                    28019000
MER      OP    X'3C'                                                    28020000
ME       OP    X'7C'                                                    28021000
CDR      OP    X'29'                                                    28022000
CD       OP    X'69'                                                    28023000
CER      OP    X'39'                                                    28024000
CE       OP    X'79'                                                    28025000
STD      OP    X'60'                                                    28026000
STE      OP    X'70'                                                    28027000
SDR      OP    X'2B'                                                    28028000
SD       OP    X'6B'                                                    28029000
SER      OP    X'3B'                                                    28030000
SE       OP    X'7B'                                                    28031000
ADR      OP    X'2A'                                                    28032000
AD       OP    X'6A'                                                    28033000
AER      OP    X'3A'                                                    28034000
AE       OP    X'7A'                                                    28035000
LTDR     OP    X'22'                                                    28036000
LTER     OP    X'32'                                                    28037000
LCDR     OP    X'23'                                                    28038000
LCER     OP    X'33'                                                    28039000
LDR      OP    X'28'                                                    28040000
LD       OP    X'68'                                                    28041000
LNDR     OP    X'21'                                                    28042000
LNER     OP    X'31'                                                    28043000
LPDR     OP    X'20'                                                    28044000
LPER     OP    X'30'                                                    28045000
LER      OP    X'38'                                                    28046000
LE       OP    X'78'                                                    28047000
.STEP2   AIF   ('&SET' EQ 'STD' OR '&SET' EQ 'SCNTF').STEP3             28048000
DP       OP    X'FD'                                                    28049000
MP       OP    X'FC'                                                    28050000
EDMK     OP    X'DF'                                                    28051000
ED       OP    X'DE'                                                    28052000
SRP      OP    X'F0'                                                    28053000
CP       OP    X'F9'                                                    28054000
SP       OP    X'FB'                                                    28055000
AP       OP    X'FA'                                                    28056000
ZAP      OP    X'F8'                                                    28057000
.STEP3   ANOP                                                           28058000
MC       OP    X'AF'                                                    28059000
CLCL     OP    X'0F'                                                    28060000
MVCL     OP    X'0E'                                                    28061000
LCR      OP    X'13'                                                    28062000
CLM      OP    X'BD'                                                    28063000
STCM     OP    X'BE'                                                    28064000
ICM      OP    X'BF'                                                    28065000
         AIF   (&PHASE EQ 3).STEP4                                      28066000
GBLC     OP    DEF=NO,REF=NO,INPC=NO                                    28067000
GBLA     OP    DEF=NO,REF=NO,INPC=NO                                    28068000
LCLC     OP    DEF=NO,REF=NO,INPC=NO                                    28069000
MNOTE    OP    DEF=NO,REF=NO,INPC=NO                                    28070000
SETC     OP    DEF=NO,REF=NO,INPC=NO                                    28071000
AGO      OP    DEF=NO,REF=NO,INPC=NO                                    28072000
.STEP4   ANOP                                                           28073000
SPM      OP    X'04'                                                    28074000
ALR      OP    X'1E'                                                    28075000
AL       OP    X'5E'                                                    28076000
NR       OP    X'14'                                                    28077000
N        OP    X'54'                                                    28078000
NC       OP    X'D4'                                                    28079000
BCR      OP    X'07'                                                    28080000
BXH      OP    X'86'                                                    28081000
BXLE     OP    X'87'                                                    28082000
CLR      OP    X'15'                                                    28083000
CL       OP    X'55'                                                    28084000
DR       OP    X'1D'                                                    28085000
D        OP    X'5D'                                                    28086000
XR       OP    X'17'                                                    28087000
X        OP    X'57'                                                    28088000
XI       OP    X'97'                                                    28089000
BNER     OP    X'077'                                                   28090000
LNR      OP    X'11'                                                    28091000
LPR      OP    X'10'                                                    28092000
MVN      OP    X'D1'                                                    28093000
MVO      OP    X'F1'                                                    28094000
MVZ      OP    X'D3'                                                    28095000
MR       OP    X'1C'                                                    28096000
M        OP    X'5C'                                                    28097000
MH       OP    X'4C'                                                    28098000
OR       OP    X'16'                                                    28099000
O        OP    X'56'                                                    28100000
SLDA     OP    X'8F'                                                    28101000
SLA      OP    X'8B'                                                    28102000
SLDL     OP    X'8D'                                                    28103000
SLL      OP    X'89'                                                    28104000
SRDA     OP    X'8E'                                                    28105000
SRA      OP    X'8A'                                                    28106000
SRDL     OP    X'8C'                                                    28107000
SRL      OP    X'88'                                                    28108000
SLR      OP    X'1F'                                                    28109000
SL       OP    X'5F'                                                    28110000
TS       OP    X'93'                                                    28111000
TRT      OP    X'DD'                                                    28112000
CCW      OP                                                             28113000
PUNCH    OP    REF=NO,INPC=NO                                           28114000
LTORG    OP    REF=NO                                                   28115000
         AIF   (&PHASE EQ 3).STEP5                                      28116000
ANOP     OP    DEF=NO,REF=NO,INPC=NO                                    28117000
GBLB     OP    DEF=NO,REF=NO,INPC=NO                                    28118000
COPY     OP    DEF=NO,REF=NO,INPC=NO                                    28119000
.STEP5   ANOP                                                           28120000
ORG      OP    REQOP=YES                                                28121000
PRINT    OP    DEF=NO,REF=NO,INPC=NO                                    28122000
SPACE    OP    DEF=NO,REF=NO,INPC=NO                                    28123000
EJECT    OP    DEF=NO,REF=NO,INPC=NO                                    28124000
BHR      OP    X'072'                                                   28125000
BLR      OP    X'074'                                                   28126000
BER      OP    X'078'                                                   28127000
BNHR     OP    X'07D'                                                   28128000
BNLR     OP    X'07B'                                                   28129000
BNOR     OP    X'07E'                                                   28130000
BOR      OP    X'071'                                                   28131000
BPR      OP    X'072'                                                   28132000
BMR      OP    X'074'                                                   28133000
BZR      OP    X'078'                                                   28134000
BNPR     OP    X'07D'                                                   28135000
BNMR     OP    X'07B'                                                   28136000
BNZR     OP    X'077'                                                   28137000
TR       OP    X'DC'                                                    28138000
OC       OP    X'D6'                                                    28139000
CH       OP    X'49'                                                    28140000
EX       OP    X'44'                                                    28141000
LTR      OP    X'12'                                                    28142000
XC       OP    X'D7'                                                    28143000
CVB      OP    X'4F'                                                    28144000
CVD      OP    X'4E'                                                    28145000
C        OP    X'59'                                                    28146000
CR       OP    X'19'                                                    28147000
BCT      OP    X'46'                                                    28148000
SH       OP    X'4B'                                                    28149000
STH      OP    X'40'                                                    28150000
AH       OP    X'4A'                                                    28151000
DROP     OP    DEF=NO,INPC=NO                                           28152000
ENTRY    OP    DEF=NO,INPC=NO                                           28153000
EXTRN    OP    DEF=NO,INPC=NO                                           28154000
EQU      OP    REQOP=YES                                                28155000
DSECT    OP    REF=NO,INHB=YES,INPC=NO                                  28156000
CNOP     OP    REQOP=YES                                                28157000
TITLE    OP    DEF=NO,REF=NO,INPC=NO                                    28158000
START    OP    INHB=YES,REQOP=YES,INPC=NO                               28159000
END      OP    INPC=NO                                                  28160000
STC      OP    X'42'                                                    28161000
IC       OP    X'43'                                                    28162000
NI       OP    X'94'                                                    28163000
OI       OP    X'96'                                                    28164000
USING    OP                                                             28165000
NOP      OP    X'470'                                                   28166000
NOPR     OP    X'070'                                                   28167000
BNP      OP    X'47D'                                                   28168000
BP       OP    X'472'                                                   28169000
BNM      OP    X'47B'                                                   28170000
BM       OP    X'474'                                                   28171000
BNO      OP    X'47E'                                                   28172000
BO       OP    X'471'                                                   28173000
BNL      OP    X'47B'                                                   28174000
BNH      OP    X'47D'                                                   28175000
BL       OP    X'474'                                                   28176000
BH       OP    X'472'                                                   28177000
BNZ      OP    X'477'                                                   28178000
BZ       OP    X'478'                                                   28179000
AR       OP    X'1A'                                                    28180000
TM       OP    X'91'                                                    28181000
SVC      OP    X'0A'                                                    28182000
SR       OP    X'1B'                                                    28183000
STM      OP    X'90'                                                    28184000
ST       OP    X'50'                                                    28185000
UNPK     OP    X'F3'                                                    28186000
PACK     OP    X'F2'                                                    28187000
LM       OP    X'98'                                                    28188000
LH       OP    X'48'                                                    28189000
MVI      OP    X'92'                                                    28190000
BAL      OP    X'45'                                                    28191000
BALR     OP    X'05'                                                    28192000
BCTR     OP    X'06'                                                    28193000
A        OP    X'5A'                                                    28194000
S        OP    X'5B'                                                    28195000
LR       OP    X'18'                                                    28196000
BR       OP    X'07F'                                                   28197000
BC       OP    X'47'                                                    28198000
CSECT    OP    REF=NO,INHB=YES,INPC=NO                                  28199000
         AIF   (&PHASE EQ 3).STEP6                                      28200000
SETB     OP    DEF=NO,REF=NO,INPC=NO                                    28201000
SETA     OP    DEF=NO,REF=NO,INPC=NO                                    28202000
LCLB     OP    DEF=NO,REF=NO,INPC=NO                                    28203000
LCLA     OP    DEF=NO,REF=NO,INPC=NO                                    28204000
MEND     OP    DEF=NO,REF=NO,INPC=NO                                    28205000
MEXIT    OP    DEF=NO,REF=NO,INPC=NO                                    28206000
MACRO    OP    DEF=NO,REF=NO,INPC=NO                                    28207000
AIF      OP    DEF=NO,REF=NO,INPC=NO                                    28208000
.STEP6   ANOP                                                           28209000
CLI      OP    X'95'                                                    28210000
CLC      OP    X'D5'                                                    28211000
L        OP    X'58'                                                    28212000
BNE      OP    X'477'                                                   28213000
BE       OP    X'478'                                                   28214000
B        OP    X'47F'                                                   28215000
LA       OP    X'41'                                                    28216000
MVC      OP    X'D2'                                                    28217000
DS       OP    REQOP=YES                                                28218000
DC       OP    REQOP=YES                                                28219000
         DC    CL1'0'                   DUMMY                   OX02977 28220000
.*********************************************************************. 28221000
.*                                                                   *. 28222000
.** END OF OP CODE TABLE GENERATION - GENERATE HASH TABLE           **. 28223000
.*                                                                   *. 28224000
.*********************************************************************. 28225000
         EJECT                                                          28226000
         ORG   JOPTABLE                 PUT HASH TABLE BEFORE ENTRIES   28227000
         SPACE 2                                                        28228000
&COUNT   SETA  0                        INITIALIZE LOOP COUNTER         28229000
&INDEX   SETA  0                                                        28230000
.LOOP    ANOP                                                           28231000
&COUNT   SETA  &COUNT+1                                                 28232000
         MNOTE '* CHAIN &COUNT : &SEARCH(&COUNT)'    WRITE CHAIN        28233000
&STRING  SETC  '&TABLE(&COUNT)'         EXTRACT NAME OF LAST ENTRY      28234000
&COMMENT SETC  (12-K'&STRING)' '.'POINTER TO FIRST ENTRY OF &CHAIN(&COU*28235000
               NT)'                     SET VARIABLE COMMENT            28236000
         DC    AL2(&STRING-JOPTABLE)&COMMENT                            28237000
&INDEX   SETA  &INDEX+&CHAIN(&COUNT)    ACCUMULATE NO OF ENTRIES        28238000
         AIF   (&COUNT LT 71).LOOP      GO IF NOT EXHAUSTED             28239000
         SPACE 2                                                        28240000
         MNOTE '** THE OPCODE TABLE CONTAINS A TOTAL OF &INDEX ENTRIES' 28241000
         SPACE 2                                                        28242000
         MEND                                                           28243000
./ ADD NAME=GENTAB                                                      28244000
          MACRO                                                         28245000
          GENTAB                                                        28246000
          GBLC  &ERCD(255)          GLOBAL ARRAY OF MSG NAMES           28247000
          LCLA  &I                                                      28248000
          LCLC  &LQ                                                     28249000
.* THIS MACRO GENERATES A SEQUENCED INDEX TO THE ERROR MESSAGES WHICH   28250000
.* CONTAINS THE HALF-WORD ADDRESS AND THE LENGTH OF EACH MESSAGE.  THIS 28251000
.* ALLOWS THE ERROR CODE TO BE USED TO INDEX THE MESSAGE INDEX.  THIS   28252000
.* MACRO MUST BE CALLED EXACTLY ONCE AFTER ALL CALLS TO GENERR.         28253000
&LQ       SETC  'L'''                                                   28254000
MTABLE    DS    0F                       INDEX OF ERROR MSGS & LENGTHS  28255000
MADDR     DS    H                            MESSAGE ADDRESS            28256000
MLN       DS    H                            MESSAGE LENGTH             28257000
          ORG   MTABLE                   TO START AT THE TOP OF TABLE   28258000
          DC    Y(S0-ERRMSGS)            INDEX TO ERR0 MESSAGE          28259000
          DC    Y(L'S0-1)                MOVE LENGTH OF ERR0 MESSAGE    28260000
          ORG   MTABLE+4                 TO LEAVE SPACE FOR ERR0 ENTRY  28261000
.LOOP     ANOP                                                          28262000
&I        SETA  &I+1                                                    28263000
          AIF   (&I GT 255).END          CHECK FOR MAXIMUM SIZE         28264000
          AIF   ('&ERCD(&I)' NE '').C1   FOR UNDEFINED ERROR MESSAGES   28265000
          DC    F'0'                     UNDEFINED ERROR MESSAGE        28266000
          AGO   .LOOP                                                   28267000
.C1       ANOP                                                          28268000
          DC    Y(&ERCD(&I)-ERRMSGS)     ADDRESS OF MSG FOR THIS CODE   28269000
          DC    Y(&LQ&ERCD(&I).-1)       LENGTH OF MSG FOR THIS CODE    28270000
          AGO   .LOOP                                                   28271000
.END      MEND                                                          28272000
./ ADD NAME=GOIF                                                        28273000
         MACRO                                                          28274000
&NAME    GOIF  &SW, .                   SWITCH TO BE TESTED            X28275000
               &SW2, .                  COMPARAND FOR CLC OR CLI       X28276000
               &GT=, .                  BRANCH GREATER                 X28277000
               &GE=, .                  BRANCH GREATER OR EQUAL        X28278000
               &EQ=, .                  BRANCH EQUAL                   X28279000
               &LE=, .                  BRANCH LESS OR EQUAL           X28280000
               &LT=, .                  BRANCH LESS                    X28281000
               &NE=, .                  BRANCH NOT EQUAL               X28282000
               &ZERO=, .                STATUS CONDITION               X28283000
               &NOTZERO=, .             STATUS CONDITION               X28284000
               &POS=, .                 STATUS CONDITION               X28285000
               &NOTPOS=, .              STATUS CONDITION               X28286000
               &NEG=, .                 STATUS CONDITION               X28287000
               &NOTNEG=, .              STATUS CONDITION               X28288000
               &MODE=L, .               STATUS CONDITION               X28289000
               &NO=, .                  SWITCH OFF                     X28290000
               &YES=, .                 SWITCH ON                      X28291000
               &EQUAL=, .               ALTERNATE FOR EQ               X28292000
               &NOTEQ=, .               ALTERNATE FOR NE               X28293000
               &ALL=, .                 BRANCH IF ALL ON               X28294000
               &NONE=, .                BRANCH IF NONE ON              X28295000
               &MIX=, .                 BRANCH IF SOME ON (BUT NOT ALL)X28296000
               &NOTALL=, .              BRANCH IF NONE OR SOME         X28297000
               &ANY=, .                 H NOT ALL OFF (ANY OR ALL ON)  X28298000
               &NOTMIX=, .              BRANCH IF ALL ON OR ALL OFF    X28299000
               &ELSE=, .                UNCONDITIONAL FINAL BRANCH     X28300000
               &ON=, .                  BRANCH IF SINGLE SWITCH ON     X28301000
               &OFF=, .                 BRANCH IF SINGLE SWITCH OFF    X28302000
               &HIGH=,&HI=,&NOTLO=,&NOTLOW=,&LOW=,&LO=,&NOTHI=,        X28303000
               &NOTHIGH=                                                28304000
         GBLA  &INDEX                                                   28305000
         GBLC  &BYTE,&CRNT                                              28306000
         GBLC  &DEFNAME(255),&SWNAME(255)                               28307000
         LCLA  &COUNT1,&COUNT2                                          28308000
         LCLB  &FIRST,&COND(3),&USED(6),&TM,&MASK(3)                    28309000
         LCLB  &NULL                                                    28310000
         LCLC  &PLUS(7)                                                 28311000
.*                                                                      28312000
.*             CHANGES TO RELEASE 3                                     28313000
.*             CHANGES TO RELEASE 2                                     28314000
.*             CHANGES TO RELEASE 1                                     28315000
.*                                                                      28316000
.* GENERATES INSTRUCTIONS TO TEST A GIVEN CONDITION                     28317000
.* AND BRANCH IF THE BRANCH CONDITION IS SATISFIED                      28318000
.*                                                                      28319000
         AIF   (N'&SW GT 8).ERR1 .      TOO MANY SWITCHES               28320000
&COUNT1  SETA  0 .                      INITIALIZE FOR VALIDITY CHECK   28321000
.LOOP1   ANOP                                                           28322000
&COUNT1  SETA  &COUNT1+1 .              NEXT OPERAND                    28323000
         AIF   (&COUNT1 GT N'&SW).NXT1 . DONE                           28324000
&COUNT2  SETA  0 .                      INITIALIZE SWNAME LOOKUP        28325000
.LOOP2   ANOP                                                           28326000
&COUNT2  SETA  &COUNT2+1 .              NEXT IN SWNAME LIST             28327000
         AIF   (&COUNT2 GT &INDEX).ERR2 . DIDN'T FIND NAME              28328000
         AIF   ('&SW(&COUNT1)' EQ '&SWNAME(&COUNT2)').LOOP3 FOUND NAME  28329000
         AGO   .LOOP2                                                   28330000
.ERR2    ANOP  , .                      LOG NO NAME FOUND               28331000
         AIF   (N'&SW GT 1).ERR2A                                       28332000
&NAME    GOIF1 &SW,&SW2,GT=&GT&HI&HIGH,GE=&GE&NOTLOW&NOTLO,            X28333000
               EQ=&EQ&EQUAL,LE=&LE&NOTHIGH&NOTHI,LT=&LT&LOW&LO,        X28334000
               ZERO=&ZERO,              STATUS CONDITION               X28335000
               NOTZERO=&NOTZERO,        STATUS CONDITION               X28336000
               POS=&POS,                STATUS CONDITION               X28337000
               NOTPOS=&NOTPOS,          STATUS CONDITION               X28338000
               NEG=&NEG,                STATUS CONDITION               X28339000
               NOTNEG=&NOTNEG,          STATUS CONDITION               X28340000
               MODE=&MODE,              STATUS CONDITION               X28341000
               NE=&NE&NOTEQ,ELSE=&ELSE                                  28342000
         MEXIT                                                          28343000
.ERR2A   MNOTE 8,'UNDECLARED BIT SWITCH OR MORE THAN ONE CLI SWITCH'    28344000
         MEXIT                                                          28345000
.ERR1    ANOP                                                           28346000
         MNOTE 8,'TOO MANY SWITCHES, ONLY 8 ALLOWED PER CALL'           28347000
         MEXIT                                                          28348000
.LOOP3   ANOP                                                           28349000
         AIF   (&FIRST).SECOND .        FIRST TIME THROUGH              28350000
&FIRST   SETB  1 .                      YES                             28351000
&BYTE    SETC  '&DEFNAME(&COUNT2)' .    SAVE THE NAME                   28352000
         AGO   .LOOP1 .                 BACK FOR MORE                   28353000
.SECOND  ANOP                                                           28354000
         AIF   ('&DEFNAME(&COUNT2)' EQ '&BYTE').LOOP1                   28355000
         MNOTE 8,'SWITCHES NOT ALL IN THE SAME BYTE'                    28356000
         MEXIT                                                          28357000
.NXT1    ANOP                                                           28358000
&NAME    GOIF3 &SW,                                                    X28359000
               ALL=&ALL&YES&ON,                                        X28360000
               NONE=&NONE&NO&OFF,                                      X28361000
               MIX=&MIX,                                               X28362000
               NOTALL=&NOTALL,                                         X28363000
               ANY=&ANY,                                               X28364000
               NOTMIX=&NOTMIX,                                         X28365000
               ELSE=&ELSE,                                             X28366000
               ON=&ALL&YES&ON,                                         X28367000
               OFF=&NONE&NO&OFF                                         28368000
         MEND                                                           28369000
./ ADD NAME=GOIF1                                                       28370000
         MACRO                                                          28371000
&NAME    GOIF1 &LOC,&CMP,&EQ=,&NE=,&GT=,&LT=,&GE=,&LE=,&MODE=,         ,28372000
               &ZERO=,&NOTZERO=,&POS=,&NOTPOS=,&NEG=,&NOTNEG=,&ELSE=    28373000
         LCLA  &W(4)                                                    28374000
         LCLB  &B(3)                                                    28375000
         LCLC  &R                                                       28376000
.*                                                                      28377000
.*             CHANGES TO RELEASE 3                                     28378000
.*             CHANGES TO RELEASE 2                                     28379000
.*             CHANGES TO RELEASE 1                                     28380000
.*                                                                      28381000
.* INNER MACRO TO GOIF. GENERATES THE INSTRUCTIONS IF A                 28382000
.* SWITCH IS TO BE TESTED                                               28383000
.*                                                                      28384000
         AIF   (K'&LOC EQ 0).ERR1                                       28385000
&W(1)    SETA  4                                                        28386000
&W(2)    SETA  2                                                        28387000
&W(3)    SETA  13                                                       28388000
&W(4)    SETA  11                                                       28389000
&B(1)    SETB  ('&EQ' NE '')                                            28390000
&B(2)    SETB  ('&NE' NE '')                                            28391000
&B(3)    SETB  ('&NE' NE '')                                            28392000
         AIF   ('&GT' EQ '').C1                                         28393000
         AIF   (&B(3)).ERR3                                             28394000
&B(3)    SETB  1                                                        28395000
.C1      AIF   ('&LT' EQ '').C2                                         28396000
         AIF   (&B(2)).ERR3                                             28397000
&B(2)    SETB  1                                                        28398000
.C2      AIF   ('&GE' EQ '').C3                                         28399000
         AIF   (&B(1) OR &B(3)).ERR3                                    28400000
&B(1)    SETB  1                                                        28401000
&B(3)    SETB  1                                                        28402000
.C3      AIF   ('&LE' EQ '').C4                                         28403000
         AIF   (&B(1) OR &B(2)).ERR3                                    28404000
&B(1)    SETB  1                                                        28405000
&B(2)    SETB  1                                                        28406000
.C4      AIF   (NOT(&B(1) AND &B(2) AND &B(3))OR '&ELSE' EQ '').C5      28407000
.ERR3    MNOTE 8,'REDUNDANT LOGIC, MACRO EXPANSION ATTEMPTED.'          28408000
.C5      AIF   (K'&CMP EQ 0).C6                                         28409000
.*                                                                      28410000
.*                       TWO OPERANDS SUPPLIED                          28411000
.*                                                                      28412000
         AIF   ('&LOC'(1,1) EQ '(' AND '&LOC'(K'&LOC,1) EQ ')').RG1     28413000
         AIF   ('&CMP'(1,1) EQ '(' AND '&CMP'(K'&CMP,1) EQ ')').RG2     28414000
         AIF   (T'&CMP NE 'U').SS                                       28415000
.*                                                                      28416000
.*                       OPERAND 2 IS ASSUMED TO BE IMMEDIATE           28417000
.*                                                                      28418000
&NAME    CLI   &LOC,&CMP                                                28419000
         AGO   .C7                                                      28420000
.*                                                                      28421000
.*                       ONE OPERAND ONLY                               28422000
.*                                                                      28423000
.C6      AIF   ('&LOC'(1,1) EQ '(' AND '&LOC'(K'&LOC,1) EQ ')').LTR     28424000
&NAME    CLI   V&LOC,&LOC                                               28425000
.C7      AIF   (K'&ZERO+K'&NOTZERO+K'&POS+K'&NOTPOS+K'&NEG+K'&NOTNEG EQ,28426000
                0).C7A                                                  28427000
         MNOTE 8,'CALL CONTAINS OTHER THAN RELATIONAL CONDITIONS.'      28428000
.C7A     AIF   ('&EQ' EQ '').LE                                         28429000
         AIF   ('&EQ'EQ'&NE'OR'&EQ'EQ'&GT'AND'&EQ'EQ'&LT').ALL          28430000
         AIF   ('&EQ' EQ '&LT').LE1                                     28431000
         AIF   ('&EQ' EQ '&GT').GE1                                     28432000
         AIF   ('&EQ'(1,1) NE '(').EQ2                                  28433000
&R       SETC  'R'                                                      28434000
.EQ2     BC&R  8,&EQ(1)                 BRANCH PER MACRO CALL           28435000
&R       SETC  ''                                                       28436000
.LE      AIF   ('&LE' EQ '').GE                                         28437000
         AIF   ('&LE' EQ '&GT').ALL1                                    28438000
         AIF   ('&LE'(1,1) NE '(').LE2                                  28439000
&R       SETC  'R'                                                      28440000
.LE2     BC&R  &W(3),&LE(1)             BRANCH PER MACRO CALL           28441000
&R       SETC  ''                                                       28442000
         AGO   .GE                                                      28443000
.LE1     AIF   ('&EQ'(1,1) NE '(').LE3                                  28444000
&R       SETC  'R'                                                      28445000
.LE3     BC&R  &W(3),&EQ(1)             BRANCH PER MACRO CALL           28446000
&R       SETC  ''                                                       28447000
.GE      AIF   ('&GE' EQ '').LT                                         28448000
         AIF   ('&GE' EQ '&LT').ALL2                                    28449000
         AIF   ('&GE'(1,1) NE '(').GE2                                  28450000
&R       SETC  'R'                                                      28451000
.GE2     BC&R  &W(4),&GE(1)             BRANCH PER MACRO CALL           28452000
&R       SETC  ''                                                       28453000
         AGO   .LT                                                      28454000
.GE1     AIF   ('&EQ'(1,1) NE '(').GE3                                  28455000
&R       SETC  'R'                                                      28456000
.GE3     BC&R  &W(4),&EQ(1)             BRANCH PER MACRO CALL           28457000
&R       SETC  ''                                                       28458000
.LT      AIF   ('&LT' EQ '').NE                                         28459000
         AIF   ('&LT' EQ '&GT').NE1                                     28460000
         AIF   ('&LT'(1,1) NE '(').LT2                                  28461000
&R       SETC  'R'                                                      28462000
.LT2     BC&R  &W(1),&LT(1)             BRANCH PER MACRO CALL           28463000
&R       SETC  ''                                                       28464000
.NE      AIF   ('&NE' EQ '').GT                                         28465000
         AIF   ('&NE'(1,1) NE '(').NE2                                  28466000
&R       SETC  'R'                                                      28467000
.NE2     BC&R  7,&NE(1)                 BRANCH PER MACRO CALL           28468000
&R       SETC  ''                                                       28469000
         AGO   .END                                                     28470000
.NE1     AIF   ('&LT'(1,1) NE '(').NE3                                  28471000
&R       SETC  'R'                                                      28472000
.NE3     BC&R  7,&LT(1)                 BRANCH PER MACRO CALL           28473000
&R       SETC  ''                                                       28474000
.GT      AIF   ('&GT' EQ '').END                                        28475000
         AIF   ('&GT'(1,1) NE '(').GT2                                  28476000
&R       SETC  'R'                                                      28477000
.GT2     BC&R  &W(2),&GT(1)             BRANCH PER MACRO CALL           28478000
&R       SETC  ''                                                       28479000
.END     AIF   ('&ELSE' EQ '').MEND                                     28480000
         AIF   ('&ELSE'(1,1) NE '(').ELSE2                              28481000
&R       SETC  'R'                                                      28482000
.ELSE2   BC&R  15,&ELSE(1)              BRANCH PER MACRO CALL           28483000
         MEXIT                                                          28484000
.ALL     AIF   ('&EQ'(1,1) NE '(').ALL01                                28485000
&R       SETC  'R'                                                      28486000
.ALL01   BC&R  15,&EQ(1)                BRANCH PER MACRO CALL           28487000
         MEXIT                                                          28488000
.ALL1    AIF   ('&LE'(1,1) NE '(').ALL11                                28489000
&R       SETC  'R'                                                      28490000
.ALL11   BC&R  15,&LE(1)                BRANCH PER MACRO CALL           28491000
         MEXIT                                                          28492000
.ALL2    AIF   ('&GE'(1,1) NE '(').ALL21                                28493000
&R       SETC  'R'                                                      28494000
.ALL21   BC&R  15,&GE(1)                BRANCH PER MACRO CALL           28495000
         MEXIT                                                          28496000
.LTRC    AIF   ('&ZERO'(1,1) NE '(').LTRV                               28497000
&R       SETC  'R'                                                      28498000
.LTRV    BC&R  15,&ZERO(1)              BRANCH PER MACRO CALL           28499000
         MEXIT                                                          28500000
.LTRX    AIF   ('&NOTPOS'(1,1) NE '(').LTRZ                             28501000
&R       SETC  'R'                                                      28502000
.LTRZ    BC&R  15,&NOTPOS(1)            BRANCH PER MACRO CALL           28503000
         MEXIT                                                          28504000
.LTRY    AIF   ('&NOTNEG'(1,1) NE '(').LTRW                             28505000
&R       SETC  'R'                                                      28506000
.LTRW    BC&R  15,&NOTNEG(1)            BRANCH PER MACRO CALL           28507000
         MEXIT                                                          28508000
.RG1     AIF   ('&CMP'(1,1) EQ '(' AND '&CMP'(K'&CMP,1) EQ ')').RG12    28509000
         AIF   (L'&CMP NE 2).LNOT2                                      28510000
&NAME    CH    &LOC(1),&CMP                                             28511000
         AGO   .C7                                                      28512000
.LNOT2   AIF   (L'&CMP EQ 4).LEQ4                                       28513000
         MNOTE *,'LENGTH ATTRIBUTE OF &CMP NOT 2 OR 4.'                 28514000
.LEQ4    AIF   ('&MODE'(1,1) EQ 'A').NOTLOG                             28515000
&NAME    CL    &LOC(1),&CMP                                             28516000
         AGO   .C7                                                      28517000
.NOTLOG  ANOP                                                           28518000
&NAME    C     &LOC(1),&CMP                                             28519000
         AGO   .C7                                                      28520000
.RG2     AIF   (L'&LOC NE 2).LNOT22                                     28521000
&NAME    CH    &CMP(1),&LOC                                             28522000
         AGO   .C7R                                                     28523000
.LNOT22  AIF   (L'&LOC EQ 4).LEQ42                                      28524000
         MNOTE *,'LENGTH ATTRIBUTE OF &LOC NOT 2 OR 4.'                 28525000
.LEQ42   AIF   ('&MODE'(1,1) EQ 'A').NOTLOG2                            28526000
&NAME    CL    &CMP(1),&LOC                                             28527000
         AGO   .C7R                                                     28528000
.NOTLOG2 ANOP                                                           28529000
&NAME    C     &CMP(1),&LOC                                             28530000
.C7R     ANOP                                                           28531000
&W(1)    SETA  2                                                        28532000
&W(2)    SETA  4                                                        28533000
&W(3)    SETA  11                                                       28534000
&W(4)    SETA  13                                                       28535000
         AGO   .C7                                                      28536000
.RG12    AIF   ('&MODE'(1,1) EQ 'A').RG12A                              28537000
&NAME    CLR   &LOC(1),&CMP(1)                                          28538000
         AGO   .C7                                                      28539000
.RG12A   ANOP                                                           28540000
&NAME    CR    &LOC(1),&CMP(1)                                          28541000
         AGO   .C7                                                      28542000
.SS      ANOP                                                           28543000
&NAME    CLC   &LOC,&CMP                                                28544000
         AGO   .C7                                                      28545000
.LTR     ANOP                                                           28546000
&NAME    LTR   &LOC(1),&LOC(1)                                          28547000
         AIF   (&B(1)+&B(2)+&B(3) EQ 0).LTRA                            28548000
         MNOTE 8,'CALL CONTAINS RELATIONAL CONDITIONS.'                 28549000
.LTRA    AIF   (('&ZERO'EQ''OR'&NOTZERO'EQ''OR'&ELSE'EQ'')AND('&ZERO'EQ,28550000
               ''OR'&POS'EQ''OR'&NEG'EQ''OR'&ELSE'EQ'')AND('&NOTPOS'EQ''28551000
               'OR'&NEG'EQ''OR'&ELSE'EQ'')).LTRM                        28552000
         MNOTE 8,'REDUNDANT LOGIC, MACRO EXPANSION ATTEMPTED.'          28553000
.LTRM    AIF   ('&NOTNEG'EQ''OR'&POS'EQ''OR'&ELSE'EQ'').LTRN            28554000
         MNOTE 8,'REDUNDANT LOGIC, MACRO EXPANSION ATTEMPTED.'          28555000
.LTRN    AIF   ('&NOTPOS' EQ '').LTRO                                   28556000
         AIF   ('&NOTPOS' EQ 'NEG').LTRX                                28557000
         AIF   ('&NOTPOS'(1,1) NE '(').LTRP                             28558000
&R       SETC  'R'                                                      28559000
.LTRP    BC&R  13,&NOTPOS(1)            BRANCH PER MACRO CALL           28560000
&R       SETC  ''                                                       28561000
.LTRO    AIF   ('&NOTNEG' EQ '').LTRQ                                   28562000
         AIF   ('&NOTNEG' EQ '&POS').LTRY                               28563000
         AIF   ('&NOTNEG'(1,1) NE '(').LTRR                             28564000
&R       SETC  'R'                                                      28565000
.LTRR    BC&R  11,&NOTNEG(1)            BRANCH PER MACRO CALL           28566000
&R       SETC  ''                                                       28567000
.LTRQ    AIF   ('&ZERO' EQ '').LTRB                                     28568000
         AIF   ('&ZERO' EQ '&NOTZERO' AND '&ZERO' EQ '&POS' AND '&ZERO',28569000
                EQ '&NEG').LTRC                                         28570000
         AIF   ('&ZERO'(1,1) NE '(').LTRD                               28571000
&R       SETC  'R'                                                      28572000
.LTRD    BC&R  8,&ZERO(1)               BRANCH PER MACRO CALL           28573000
&R       SETC  ''                                                       28574000
.LTRB    AIF   ('&NEG' EQ '').LTRE                                      28575000
         AIF   ('&NEG' EQ '&POS').LTRF                                  28576000
         AIF   ('&NEG'(1,1) NE '(').LTRG                                28577000
&R       SETC  'R'                                                      28578000
.LTRG    BC&R  4,&NEG(1)                 BRANCH PER MACRO CALL          28579000
&R       SETC  ''                                                       28580000
.LTRE    AIF   ('&NOTZERO' EQ '').LTRH                                  28581000
         AIF   ('&NOTZERO'(1,1) NE '(').LTRI                            28582000
&R       SETC  'R'                                                      28583000
.LTRI    BC&R  7,&NOTZERO(1)            BRANCH PER MACRO CALL           28584000
&R       SETC  ''                                                       28585000
         AGO   .LTRH                                                    28586000
.LTRF    AIF   ('&POS'(1,1) NE '(').LTRK                                28587000
&R       SETC  'R'                                                      28588000
.LTRK    BC&R  7,&POS(1)                BRANCH PER MACRO CALL           28589000
&R       SETC  ''                                                       28590000
.LTRH    AIF   ('&POS' EQ '').END                                       28591000
         AIF   ('&POS'(1,1) NE '(').LTRJ                                28592000
&R       SETC  'R'                                                      28593000
.LTRJ    BC&R  2,&POS(1)                BRANCH PER MACRO CALL           28594000
&R       SETC  ''                                                       28595000
         AGO   .END                                                     28596000
.ERR1    MNOTE 8,'REQUIRED OPERANDS NOT SUPPLIED.'                      28597000
.MEND    MEND                                                           28598000
./ ADD NAME=GOIF3                                                       28599000
         MACRO                                                          28600000
&NAME    GOIF3 &SW,&ALL=,&NONE=,&MIX=,&NOTALL=,&ANY=,&NOTMIX=,         X28601000
               &ELSE=,&ON=,&OFF=                                        28602000
         GBLA  &INDEX                                                   28603000
         GBLC  &BYTE,&CRNT                                              28604000
         GBLC  &DEFNAME(255),&SWNAME(255)                               28605000
         LCLA  &COUNT1,&COUNT2                                          28606000
         LCLB  &FIRST,&COND(3),&USED(6),&TM,&MASK(3)                    28607000
.*                                                                      28608000
.*             CHANGES TO RELEASE 3                                     28609000
.*             CHANGES TO RELEASE 2                                     28610000
.*             CHANGES TO RELEASE 1                                     28611000
.*                                                                      28612000
.* INNER MACRO TO GOIF. GENERATES THE INSTRUCTIONS                      28613000
.* IF THE FIELD TO TEST IS NOT A SWITCH                                 28614000
.*                                                                      28615000
 LCLC    &PLUS(7)                                                       28616000
.NXT1    ANOP                                                           28617000
         AIF   (N'&SW EQ 1).SNGL .      ONLY ONE SWITCH                 28618000
.NXT1A   ANOP                                                           28619000
&COND(1) SETB  0                                                        28620000
&COND(2) SETB  0                                                        28621000
&COND(3) SETB  0                                                        28622000
         AIF   (&USED(1) AND &USED(2) AND &USED(3) AND &USED(4) AND &USX28623000
               ED(5) AND &USED(6)).GEN1                                 28624000
&FIRST   SETB  0                                                        28625000
.ALL     AIF   (&USED(1)).NONE                                          28626000
         AIF   (K'&ALL EQ 0).ALL3                                       28627000
&COND(1) SETB  1 .                      BRANCH CONDITION ONES           28628000
&FIRST   SETB  1                                                        28629000
&CRNT    SETC  '&ALL(1)'                                                28630000
&USED(1) SETB  1                                                        28631000
.NONE    AIF   (&USED(2)).MIX                                           28632000
         AIF   (K'&NONE EQ 0).NONE3                                     28633000
         AIF   (&FIRST).NONE2                                           28634000
&COND(2) SETB  1 .                      BRANCH CONDITION ZEROS          28635000
&FIRST   SETB  1                                                        28636000
&CRNT    SETC  '&NONE(1)'                                               28637000
&USED(2) SETB  1                                                        28638000
         AGO   .MIX                                                     28639000
.NONE2   AIF   ('&CRNT' NE '&NONE').MIX                                 28640000
&USED(2) SETB  1                                                        28641000
&COND(2) SETB  1                                                        28642000
.MIX     AIF   (&USED(3)).NOTALL                                        28643000
         AIF   (K'&MIX EQ 0).MIX3                                       28644000
         AIF   (&FIRST).MIX2                                            28645000
&FIRST   SETB  1                                                        28646000
&CRNT    SETC  '&MIX(1)'                                                28647000
&USED(3) SETB  1                                                        28648000
&COND(3) SETB  1 .                      BRANCH CONDITION MIXED          28649000
         AGO   .NOTALL                                                  28650000
.MIX2    AIF   ('&CRNT' NE '&MIX').NOTALL                               28651000
&COND(3) SETB  1                                                        28652000
&USED(3) SETB  1                                                        28653000
.NOTALL  AIF   (&USED(4)).ANY                                           28654000
         AIF   (K'&NOTALL EQ 0).NOTALL3                                 28655000
         AIF   (&FIRST).NOTALL2                                         28656000
&FIRST   SETB  1                                                        28657000
&CRNT    SETC  '&NOTALL(1)'                                             28658000
&USED(4) SETB  1                                                        28659000
&COND(2) SETB  1 .                      BRANCH CONDITION ZEROS          28660000
&COND(3) SETB  1 .                      BRANCH CONDITION MIXED          28661000
         AGO   .ANY                                                     28662000
.NOTALL2 AIF   ('&CRNT' NE '&NOTALL').ANY                               28663000
&USED(4) SETB  1                                                        28664000
&COND(2) SETB  1                                                        28665000
&COND(3) SETB  1                                                        28666000
.ANY     AIF   (&USED(5)).NOTMIX                                        28667000
         AIF   (K'&ANY EQ 0).ANY3                                       28668000
         AIF (&FIRST).ANY2                                              28669000
&FIRST   SETB  1                                                        28670000
&CRNT    SETC  '&ANY(1)'                                                28671000
&USED(5) SETB  1 .                      THIS OPTION USED                28672000
&COND(1) SETB  1 .                      BRANCH CONDITION ONES           28673000
&COND(3) SETB  1 .                      BRANCH CONDITION MIXED          28674000
         AGO   .NOTMIX                                                  28675000
.ANY2    AIF   ('&CRNT' NE '&ANY').NOTMIX                               28676000
&USED(5) SETB  1                                                        28677000
&COND(1) SETB  1                                                        28678000
&COND(3) SETB  1                                                        28679000
.NOTMIX  AIF   (&USED(6)).GEN                                           28680000
         AIF   (K'&NOTMIX EQ 0).NOTMIX3                                 28681000
         AIF   (&FIRST).NOTMIX2                                         28682000
&FIRST   SETB  1                                                        28683000
&CRNT    SETC  '&NOTMIX(1)'                                             28684000
&USED(6) SETB  1 .                      OPTION USED                     28685000
&COND(1) SETB  1 .                      BRANCH CONDITION ONES           28686000
&COND(2) SETB  1 .                      BRANCH CONDITION ZEROS          28687000
         AGO   .GEN                                                     28688000
.NOTMIX2 AIF   ('&CRNT' NE '&NOTMIX').GEN                               28689000
&USED(6) SETB  1                                                        28690000
&COND(1) SETB  1                                                        28691000
&COND(2) SETB  1                                                        28692000
.NOTMIX3 ANOP                                                           28693000
&USED(6) SETB  1                                                        28694000
         AGO   .GEN                                                     28695000
.ANY3    ANOP                                                           28696000
&USED(5) SETB  1                                                        28697000
         AGO   .NOTMIX                                                  28698000
.NOTALL3 ANOP                                                           28699000
&USED(4) SETB  1                                                        28700000
         AGO   .ANY                                                     28701000
.MIX3    ANOP                                                           28702000
&USED(3) SETB  1                                                        28703000
         AGO   .NOTALL                                                  28704000
.NONE3   ANOP                                                           28705000
&USED(2) SETB  1                                                        28706000
         AGO   .MIX                                                     28707000
.ALL3    ANOP                                                           28708000
&USED(1) SETB  1                                                        28709000
         AGO   .NONE                                                    28710000
.GEN     ANOP                                                           28711000
         AIF   ('&CRNT' EQ '&ELSE').NXT1                                28712000
.GEN1    AIF   (&TM).GEN2 .             IF ALREADY GEN'D TM             28713000
         AIF   ('&SW' EQ '').GEN2       NO SWITCHES, DON'T DO TM        28714000
         AIF   (K'&SW(2) EQ 0).ZIP1                                     28715000
&PLUS(1) SETC  '+'                                                      28716000
.ZIP1    AIF   (K'&SW(3) EQ 0).ZIP2                                     28717000
&PLUS(2) SETC  '+'                                                      28718000
.ZIP2    AIF   (K'&SW(4) EQ 0).ZIP3                                     28719000
&PLUS(3) SETC  '+'                                                      28720000
.ZIP3    AIF   (K'&SW(5) EQ 0).ZIP4                                     28721000
&PLUS(4) SETC  '+'                                                      28722000
.ZIP4    AIF   (K'&SW(6) EQ 0).ZIP5                                     28723000
&PLUS(5) SETC  '+'                                                      28724000
.ZIP5    AIF   (K'&SW(7) EQ 0).ZIP6                                     28725000
&PLUS(6) SETC  '+'                                                      28726000
.ZIP6    AIF   (K'&SW(8) EQ 0).ZIP7                                     28727000
&PLUS(7) SETC  '+'                                                      28728000
.ZIP7    ANOP                                                           28729000
&NAME    TM    &BYTE,&SW(1)&PLUS(1)&SW(2)&PLUS(2)&SW(3)&PLUS(3)&SW(4)&PX28730000
               LUS(4)&SW(5)&PLUS(5)&SW(6)&PLUS(6)&SW(7)&PLUS(7)&SW(8)   28731000
&TM      SETB  1 .                      FLAG AS GENERATED               28732000
.GEN2    ANOP                                                           28733000
         AIF   (NOT &COND(1) AND NOT &COND(2) AND NOT &COND(3)).NOP    X28734000
                                        NO CONDITIONS, MAY BE A NOP     28735000
         AIF   (&COND(2) AND &COND(3)).BNO                              28736000
         AIF   (&COND(1) AND &COND(3)).BNZ                              28737000
         AIF   (&COND(1) AND &COND(2)).BNM                              28738000
         AIF   (&COND(1)).BO                                            28739000
         AIF   (&COND(2)).BZ                                            28740000
         AIF   (&COND(3)).BM                                            28741000
&MASK(1) SETB  1                                                        28742000
&MASK(2) SETB  1                                                        28743000
&MASK(3) SETB  1                                                        28744000
         AIF   ('&CRNT'(1,1) EQ '(').BA1                                28745000
         B     &CRNT                    BRANCH PER MACRO CALL           28746000
         AGO   .NXT1 .                  GO BACK FOR MORE                28747000
.BA1     BR    &CRNT                    BRANCH PER MACRO CALL           28748000
         AGO   .NXT1                                                    28749000
.BO      AIF   (&MASK(1)).ERR4                                          28750000
&MASK(1) SETB  1                                                        28751000
         AIF   ('&CRNT'(1,1) EQ '(').BO1                                28752000
         BO    &CRNT                    BRANCH PER MACRO CALL           28753000
 AGO     .NXT1                                                          28754000
.BO1     BCR   1,&CRNT                  BRANCH PER MACRO CALL           28755000
         AGO   .NXT1                                                    28756000
.BZ      AIF   (&MASK(2)).ERR4                                          28757000
&MASK(2) SETB  1                                                        28758000
         AIF   ('&CRNT'(1,1) EQ '(').BZ1                                28759000
         BZ    &CRNT                    BRANCH PER MACRO CALL           28760000
         AGO   .NXT1                                                    28761000
.BZ1     BCR   8,&CRNT                  BRANCH PER MACRO CALL           28762000
         AGO   .NXT1                                                    28763000
.BM      AIF   (&MASK(3)).ERR4                                          28764000
&MASK(3) SETB  1                                                        28765000
         AIF   ('&CRNT'(1,1) EQ '(').BM1                                28766000
         BM    &CRNT                    BRANCH PER MACRO CALL           28767000
         AGO   .NXT1                                                    28768000
.BM1     BCR   4,&CRNT                  BRANCH PER MACRO CALL           28769000
         AGO   .NXT1                                                    28770000
.BNO     AIF   (&MASK(2) OR &MASK(3)).ERR4                              28771000
&MASK(2) SETB  1                                                        28772000
&MASK(3) SETB  1                                                        28773000
         AIF   ('&CRNT'(1,1) EQ '(').BNO1                               28774000
         BNO   &CRNT                    BRANCH PER MACRO CALL           28775000
         AGO   .NXT1                                                    28776000
.BNO1    BCR   14,&CRNT                 BRANCH PER MACRO CALL           28777000
         AGO   .NXT1                                                    28778000
.BNZ     AIF   (&MASK(1) OR &MASK(3)).ERR4                              28779000
&MASK(1) SETB  1                                                        28780000
&MASK(3) SETB  1                                                        28781000
         AIF   ('&CRNT'(1,1) EQ '(').BNZ1                               28782000
         BNZ   &CRNT                    BRANCH PER MACRO CALL           28783000
         AGO   .NXT1                                                    28784000
.BNZ1    BCR   7,&CRNT                  BRANCH PER MACRO CALL           28785000
         AGO   .NXT1                                                    28786000
.BNM     AIF   (&MASK(1) OR &MASK(2)).ERR4                              28787000
&MASK(1) SETB  1                                                        28788000
&MASK(2) SETB  1                                                        28789000
         AIF   ('&CRNT'(1,1) EQ '(').BNM1                               28790000
         BNM   &CRNT                    BRANCH PER MACRO CALL           28791000
         AGO   .NXT1                                                    28792000
.BNM1    BCR   11,&CRNT                 BRANCH PER MACRO CALL           28793000
         AGO   .NXT1                                                    28794000
.ERR4    ANOP                                                           28795000
         MNOTE 8,'REDUNDANT LOGIC--CONDITION USED MORE THAN ONCE'       28796000
         AGO   .DONE                                                    28797000
.ERR10   ANOP                                                           28798000
         MNOTE 8,'OPTIONS ARE ONLY LEGAL FOR MULTIPLE SWITCH'           28799000
         AGO   .SNGL3                                                   28800000
.ERR3    ANOP                                                           28801000
.OUT     ANOP                                                           28802000
.NOP     ANOP                                                           28803000
.DONE    AIF   (K'&ELSE EQ 0).DONE2                                     28804000
         AIF   (&MASK(1) AND &MASK(2) AND &MASK(3)).ERR4                28805000
         AIF   ('&ELSE'(1,1) EQ '(').DONE3                              28806000
         B     &ELSE                    BRANCH PER MACRO CALL           28807000
.DONE2   MEXIT                                                          28808000
.DONE3   BR    &ELSE                    BRANCH PER MACRO CALL           28809000
         MEXIT                                                          28810000
.SNGL    ANOP                                                           28811000
         AIF   ('&MIX' NE '' OR '&NOTMIX' NE '').ERR10                  28812000
.SNGL3   ANOP                                                           28813000
&NAME    TM    &BYTE,&SW                                                28814000
         AIF   ((K'&ON NE 0) AND (K'&OFF NE 0)).B2                      28815000
         AIF   ((K'&ON EQ 0) AND (K'&OFF EQ 0)).NOP                     28816000
         AIF   (K'&ON EQ 0).SNGL2                                       28817000
         AIF   ('&ON'(1,1) EQ '(').BO91                                 28818000
         BO    &ON                      BRANCH PER MACRO CALL           28819000
         AGO   .DONE                                                    28820000
.BO91    BCR   1,&ON(1)                 BRANCH PER MACRO CALL           28821000
         AGO   .DONE                                                    28822000
.SNGL2   ANOP                                                           28823000
         AIF   ('&OFF'(1,1) EQ '(').BZ91                                28824000
         BZ    &OFF                     BRANCH PER MACRO CALL           28825000
         AGO   .DONE                                                    28826000
.BZ91    BCR   8,&OFF(1)                BRANCH PER MACRO CALL           28827000
         AGO   .DONE                                                    28828000
.B2      AIF   ('&ON' EQ '&OFF').B3                                     28829000
         AIF   ('&ON'(1,1) EQ '(').B20                                  28830000
         BO    &ON                      BRANCH PER MACRO CALL           28831000
         AGO   .B21                                                     28832000
.B20     BCR   1,&ON(1)                 BRANCH PER MACRO CALL           28833000
.B21     AIF   ('&OFF'(1,1) EQ '(').B23                                 28834000
         BZ    &OFF                     BRANCH PER MACRO CALL           28835000
         AGO   .DONE                                                    28836000
.B23     BCR   8,&OFF(1)                BRANCH PER MACRO CALL           28837000
         AGO   .DONE                                                    28838000
.B3      ANOP                                                           28839000
         AIF   ('&ON'(1,1) EQ '(').B30                                  28840000
         B     &ON                      BRANCH PER MACRO CALL           28841000
         AGO   .DONE                                                    28842000
.B30     BR    &ON(1)                   BRANCH PER MACRO CALL           28843000
         AGO   .DONE                                                    28844000
         MEND                                                           28845000
./ ADD NAME=GOTO                                                        28846000
         MACRO                                                          28847000
&LABEL   GOTO  &ROUTINE                                                 28848000
.*                                                                      28849000
         GBLC  &X0(26)                                                  28850000
         GBLC  &X1(26)                                                  28851000
         GBLC  &X2(26)                                                  28852000
         GBLC  &X3(26)                                                  28853000
         GBLC  &X4(26)                                                  28854000
         GBLC  &X5(26)                                                  28855000
         GBLC  &X6(26)                                                  28856000
         GBLC  &X7(26)                                                  28857000
         GBLC  &X8(26)                                                  28858000
         GBLC  &X9(26)                                                  28859000
         GBLC  &XA(26)                                                  28860000
         GBLC  &XB(26)                                                  28861000
         GBLC  &XC(26)                                                  28862000
         GBLC  &XD(26)                                                  28863000
         GBLC  &XE(26)                                                  28864000
         GBLC  &XF(26)                                                  28865000
.*                                                                      28866000
         LCLC  &PHASEID                                                 28867000
         LCLA  &I                                                       28868000
.*                                                                      28869000
.*             CHANGES TO RELEASE 3                                     28870000
.*             CHANGES TO RELEASE 2                                     28871000
.*             CHANGES TO RELEASE 1                                     28872000
.*                                                                      28873000
.* GENERATES A BRANCH AND LINK TO A SUBROUTINE                          28874000
.* WHICH NAME IS DEFINED IN THE EXTERNAL NAME                           28875000
.* ARRAY BUILT BY CONTAINS                                              28876000
.*                                                                      28877000
         AIF   (K'&ROUTINE EQ 0 OR N'&SYSLIST GT 1).ERR1                28878000
.*                                                                      28879000
.X0      AIF   ('&X0(1)' EQ '').INT                                     28880000
&PHASEID SETC  '&X0(1)'(4,5)                                            28881000
&I       SETA  2                                                        28882000
.X01     AIF   ('&X0(&I)' EQ '&ROUTINE').EXT                            28883000
         AIF   (&I EQ 26).X1                                            28884000
&I       SETA  &I+1                                                     28885000
         AIF   ('&X0(&I)' NE '').X01                                    28886000
.*                                                                      28887000
.X1      AIF   ('&X1(1)' EQ '').INT                                     28888000
&PHASEID SETC  '&X1(1)'(4,5)                                            28889000
&I       SETA  2                                                        28890000
.X11     AIF   ('&X1(&I)' EQ '&ROUTINE').EXT                            28891000
         AIF   (&I EQ 26).X2                                            28892000
&I       SETA  &I+1                                                     28893000
         AIF   ('&X1(&I)' NE '').X11                                    28894000
.*                                                                      28895000
.X2      AIF   ('&X2(1)' EQ '').INT                                     28896000
&PHASEID SETC  '&X2(1)'(4,5)                                            28897000
&I       SETA  2                                                        28898000
.X21     AIF   ('&X2(&I)' EQ '&ROUTINE').EXT                            28899000
         AIF   (&I EQ 26).X3                                            28900000
&I       SETA  &I+1                                                     28901000
         AIF   ('&X2(&I)' NE '').X21                                    28902000
.*                                                                      28903000
.X3      AIF   ('&X3(1)' EQ '').INT                                     28904000
&PHASEID SETC  '&X3(1)'(4,5)                                            28905000
&I       SETA  2                                                        28906000
.X31     AIF   ('&X3(&I)' EQ '&ROUTINE').EXT                            28907000
         AIF   (&I EQ 26).X4                                            28908000
&I       SETA  &I+1                                                     28909000
         AIF   ('&X3(&I)' NE '').X31                                    28910000
.*                                                                      28911000
.X4      AIF   ('&X4(1)' EQ '').INT                                     28912000
&PHASEID SETC  '&X4(1)'(4,5)                                            28913000
&I       SETA  2                                                        28914000
.X41     AIF   ('&X4(&I)' EQ '&ROUTINE').EXT                            28915000
         AIF   (&I EQ 26).X5                                            28916000
&I       SETA  &I+1                                                     28917000
         AIF   ('&X4(&I)' NE '').X41                                    28918000
.*                                                                      28919000
.X5      AIF   ('&X5(1)' EQ '').INT                                     28920000
&PHASEID SETC  '&X5(1)'(4,5)                                            28921000
&I       SETA  2                                                        28922000
.X51     AIF   ('&X5(&I)' EQ '&ROUTINE').EXT                            28923000
         AIF   (&I EQ 26).X6                                            28924000
&I       SETA  &I+1                                                     28925000
         AIF   ('&X5(&I)' NE '').X51                                    28926000
.*                                                                      28927000
.X6      AIF   ('&X6(1)' EQ '').INT                                     28928000
&PHASEID SETC  '&X6(1)'(4,5)                                            28929000
&I       SETA  2                                                        28930000
.X61     AIF   ('&X6(&I)' EQ '&ROUTINE').EXT                            28931000
         AIF   (&I EQ 26).X7                                            28932000
&I       SETA  &I+1                                                     28933000
         AIF   ('&X6(&I)' NE '').X61                                    28934000
.*                                                                      28935000
.X7      AIF   ('&X7(1)' EQ '').INT                                     28936000
&PHASEID SETC  '&X7(1)'(4,5)                                            28937000
&I       SETA  2                                                        28938000
.X71     AIF   ('&X7(&I)' EQ '&ROUTINE').EXT                            28939000
         AIF   (&I EQ 26).X8                                            28940000
&I       SETA  &I+1                                                     28941000
         AIF   ('&X7(&I)' NE '').X71                                    28942000
.*                                                                      28943000
.X8      AIF   ('&X8(1)' EQ '').INT                                     28944000
&PHASEID SETC  '&X8(1)'(4,5)                                            28945000
&I       SETA  2                                                        28946000
.X81     AIF   ('&X8(&I)' EQ '&ROUTINE').EXT                            28947000
         AIF   (&I EQ 26).X9                                            28948000
&I       SETA  &I+1                                                     28949000
         AIF   ('&X8(&I)' NE '').X81                                    28950000
.*                                                                      28951000
.X9      AIF   ('&X9(1)' EQ '').INT                                     28952000
&PHASEID SETC  '&X9(1)'(4,5)                                            28953000
&I       SETA  2                                                        28954000
.X91     AIF   ('&X9(&I)' EQ '&ROUTINE').EXT                            28955000
         AIF   (&I EQ 26).XA                                            28956000
&I       SETA  &I+1                                                     28957000
         AIF   ('&X9(&I)' NE '').X91                                    28958000
.*                                                                      28959000
.XA      AIF   ('&XA(1)' EQ '').INT                                     28960000
&PHASEID SETC  '&XA(1)'(4,5)                                            28961000
&I       SETA  2                                                        28962000
.XA1     AIF   ('&XA(&I)' EQ '&ROUTINE').EXT                            28963000
         AIF   (&I EQ 26).XB                                            28964000
&I       SETA  &I+1                                                     28965000
         AIF   ('&XA(&I)' NE '').XA1                                    28966000
.*                                                                      28967000
.XB      AIF   ('&XB(1)' EQ '').INT                                     28968000
&PHASEID SETC  '&XB(1)'(4,5)                                            28969000
&I       SETA  2                                                        28970000
.XB1     AIF   ('&XB(&I)' EQ '&ROUTINE').EXT                            28971000
         AIF   (&I EQ 26).XC                                            28972000
&I       SETA  &I+1                                                     28973000
         AIF   ('&XB(&I)' NE '').XB1                                    28974000
.*                                                                      28975000
.XC      AIF   ('&XC(1)' EQ '').INT                                     28976000
&PHASEID SETC  '&XC(1)'(4,5)                                            28977000
&I       SETA  2                                                        28978000
.XC1     AIF   ('&XC(&I)' EQ '&ROUTINE').EXT                            28979000
         AIF   (&I EQ 26).XD                                            28980000
&I       SETA  &I+1                                                     28981000
         AIF   ('&XC(&I)' NE '').XC1                                    28982000
.*                                                                      28983000
.XD      AIF   ('&XD(1)' EQ '').INT                                     28984000
&PHASEID SETC  '&XD(1)'(4,5)                                            28985000
&I       SETA  2                                                        28986000
.XD1     AIF   ('&XD(&I)' EQ '&ROUTINE').EXT                            28987000
         AIF   (&I EQ 26).XE                                            28988000
&I       SETA  &I+1                                                     28989000
         AIF   ('&XD(&I)' NE '').XD1                                    28990000
.*                                                                      28991000
.XE      AIF   ('&XE(1)' EQ '').INT                                     28992000
&PHASEID SETC  '&XE(1)'(4,5)                                            28993000
&I       SETA  2                                                        28994000
.XE1     AIF   ('&XE(&I)' EQ '&ROUTINE').EXT                            28995000
         AIF   (&I EQ 26).XF                                            28996000
&I       SETA  &I+1                                                     28997000
         AIF   ('&XE(&I)' NE '').XE1                                    28998000
.*                                                                      28999000
.XF      AIF   ('&XF(1)' EQ '').INT                                     29000000
&PHASEID SETC  '&XF(1)'(4,5)                                            29001000
&I       SETA  2                                                        29002000
.XF1     AIF   ('&XF(&I)' EQ '&ROUTINE').EXT                            29003000
         AIF   (&I EQ 26).XG                                            29004000
&I       SETA  &I+1                                                     29005000
         AIF   ('&XF(&I)' NE '').XF1                                    29006000
.*                                                                      29007000
.XG      ANOP                                                           29008000
.*                                                                      29009000
.INT     ANOP                                                           29010000
&LABEL   BAL   R9,&ROUTINE              GO TO ROUTINE                   29011000
         MEXIT                                                          29012000
.*                                                                      29013000
.*                                                                      29014000
.EXT     ANOP                                                           29015000
&LABEL   L     R12,&PHASEID             GET ADDRESS OF PIVOT            29016000
         AIF   (&I EQ 2).EXT1                                           29017000
&I       SETA  &I*4-8                                                   29018000
         BAL   R9,&I.(,R12)             GO TO ROUTINE                   29019000
         MEXIT                                                          29020000
.EXT1    BALR  R9,R12                   GO TO ROUTINE                   29021000
         MEXIT                                                          29022000
.ERR1    MNOTE 4,'ROUTINE NAME EXCESSIVE OR MISSING.'                   29023000
.MEND    MEND                                                           29024000
./ ADD NAME=ICOMMON                                                     29025000
*COPY ICOMMON                                                           29026000
*                        DEFINE EXTERNAL ROUTINES                     * 29027000
         SPACE                                                          29028000
         AIF   ('&TESTRAN' NE 'YES').X4D                                29029000
&COMPNM.X4N01  CONTAINS  DCSCAN,XDSCAN,SYMPUNCH                         29030000
         AGO   .X4N                                                     29031000
.X4D     ANOP                                                           29032000
&COMPNM.X4D01  CONTAINS  DCSCAN,XDSCAN                                  29033000
.X4N     ANOP                                                           29034000
&COMPNM.X4E01  CONTAINS  BLDESD,MAKESD,GETESD,ENTRY,EXTRN,VCON,QCON,   ,29035000
               REFER                                                    29036000
&COMPNM.X4S01  CONTAINS  FIND,ENTER,SUBSET                              29037000
&COMPNM.X4V01  CONTAINS  EVAL                                           29038000
         SPACE                                                          29039000
         SPACE                                                          29040000
*                        ADDRESSING VIA WORK REGISTERS                * 29041000
         SPACE                                                          29042000
DSECT2   DSECT ,                        ADDRESS                         29043000
         USING DSECT2,R2                BASE                            29044000
         SPACE                                                          29045000
DSECT3   DSECT ,                        ADDRESS                         29046000
         USING DSECT3,R3                BASE                            29047000
         SPACE                                                          29048000
         USING JTEXT,R4                 BASE                            29049000
         SPACE                                                          29050000
DSECT5   DSECT ,                        ADDRESS                         29051000
         USING DSECT5,R5                BASE                            29052000
         SPACE                                                          29053000
DSECT6   DSECT ,                        ADDRESS                         29054000
         USING DSECT6,R6                BASE                            29055000
         SPACE                                                          29056000
DSECT7   DSECT ,                        ADDRESS                         29057000
         USING DSECT7,R7                BASE                            29058000
         SPACE                                                          29059000
DSECT10  DSECT ,                        ADDRESS                         29060000
         USING DSECT10,R10              BASE                            29061000
         SPACE                                                          29062000
DSECT11  DSECT                          ADDRESS                         29063000
         USING DSECT11,R11              BASE                            29064000
         SPACE                                                          29065000
DSECT12  DSECT ,                        ADDRESS                         29066000
         USING DSECT12,R12              BASE                            29067000
         SPACE                                                          29068000
DSECT14  DSECT ,                        ADDRESS                         29069000
         USING DSECT14,R14              BASE                            29070000
         SPACE                                                          29071000
DSECT15  DSECT ,                        ADDRESS                         29072000
         USING DSECT15,R15              BASE                            29073000
         EJECT                                                          29074000
DSECT7   DSECT ,                        ADDRESS                         29075000
         ORG   DSECT7                   ORIGIN                          29076000
         SPACE                                                          29077000
SAVE     JSAVE BASE=NO                  SAVE REGISTER                   29078000
         BR    R14                      RETURN                          29079000
EXIT     JRETURN                        RESTORE REGISTERS AND RETURN    29080000
         AIF   ('&TESTRAN' NE 'YES').X4D1                               29081000
X4N01    DS    A                        DC EVALUATION (TESTRAN VERSION) 29082000
         AGO   .X4N1                                                    29083000
.X4D1    ANOP                                                           29084000
X4D01    DS    A                        DC EVALUATION                   29085000
.X4N1    ANOP                                                           29086000
X4E01    DS    A                        ESD PROCESSING                  29087000
X4S01    DS    A                        SYMBOL TABLE ROUTINES           29088000
X4V01    DS    A                        EXPRESSION EVALUATION           29089000
         EJECT                                                          29090000
HASHNR   EQU   64                       NUMBER OF HASH CHAINS           29091000
MINDBL   EQU   1024                     MINIMUM STORAGE REQUIREMENT     29092000
MAXDBL   EQU   4095*2                   MAXIMUM STORAGE REQUIREFX0000   29093000
ALIGNB   EQU   B'00000001'              BYTE ALIGNMENT MASK             29094000
ALIGNH   EQU   B'00000010'              HALFWORD ALIGNMENT MASK         29095000
ALIGNF   EQU   B'00000100'              FULLWORD ALIGNMENT MASK         29096000
ALIGND   EQU   B'00001000'              DOUBLEWORD ALIGNMENT MASK       29097000
         EJECT                                                          29098000
*                        EXTERNAL SYMBOL DICTIONARY                   * 29099000
         SPACE                                                          29100000
ESDBLK1  DS    A(*+4),H'324,0',16XL20   ESD BLOCK 1                     29101000
ESDBLK2  DS    A(*+4),H'324,0',16XL20   ESD BLOCK 2                     29102000
FILELAST DS    01XL9                    END OF SPILL FILE               29103000
NOTELIST DS    32XL9               ADDRESS OF ESD BLOCKS - 512 FX0002   29104000
OOPS     DS    X                        ESD OVERFLOW VALVE              29105000
         EJECT                                                          29106000
SYMDIMEN DS    4F                       SYMBOL TABLE POINTERS           29107000
HASHTBL  DS    (HASHNR)F                HASH TABLE                      29108000
         EJECT                                                          29109000
SWTCH1   DSW   ,                        SWITCH 1                       ,29110000
               ,                                                       ,29111000
               ,                                                       ,29112000
               ,                                                       ,29113000
               STBLOFLO,                SYMBOL TABLE OVERFLOW          ,29114000
               LITEND,                  LITERAL AND END        @OX09723,29115000
               IOFLO,                                                  ,29116000
               INOTE                                                    29117000
         SPACE                                                          29118000
SWTCH2   DSW   ,                        SWITCH 2                       ,29119000
               ,                                                       ,29120000
               INCSECT,                                                ,29121000
               ,                                                       ,29122000
               DCMODEXP,                     DC MODIFIER EXPRESSION    ,29123000
               ,                                                       ,29124000
               ,                             NOT USED                  ,29125000
                                             NOT USED                   29126000
MODE     DS    0H                       RESERVED FOR MODE SWITCHES ONLY 29127000
         DS    X                        RESERVED FOR MODE SWITCHES ONLY 29128000
         DSW   ,,,,MODE1,MODE2,,        RESERVED FOR MODE SWITCHES ONLY 29129000
STARTLOC DS    A                        START LOCATION                  29130000
HIESDNR  DS    H                        HIGH ESD ID                     29131000
DCDSSW   DSW   SDZDUPF                  SELF DEF ZERO AS DUPF           29132000
DCDSMODE DSW   NOESD,NOESDS,LMOD,BMOD,SMOD     MODE                     29133000
LINECNT  DS    H                               LINE COUNT               29134000
LOCTRSAV DS    XL6                      LOCATION COUNTER SAVE AREA      29135000
SYMCARD  DS    3F                       TESTRAN CARD BUFFER ADDRESS     29136000
         ORG   LOCTRSAV                 AFTER ASSIGNMENT MODE           29137000
         DS    H                        NOT USED                        29138000
CARDADDR DS    2F                       ADDRESS OF ESD CARD BUFFER      29139000
ADJINDEX DS    2F                       ESD ADJUSTMENT TABLE INDEX      29140000
LATADD   DS    F                        FIRST LITERAL ENTRY ADDRESS     29141000
LATEND   DS    F                        NEXT LITERAL ENTRY ADDRESS      29142000
LATA8    DS    F                        8 CHAIN ADDRESS                 29143000
LATA4    DS    F                        4 CHAIN ADDRESS                 29144000
LATA2    DS    F                        2 CHAIN ADDRESS                 29145000
LATA1    DS    F                        1 CHAIN ADDRESS                 29146000
XPARM    DS    F                        PARAMETER                       29147000
         SPACE                                                          29148000
*                        TESTRAN OUTPUT BUFFER                        * 29149000
         SPACE                                                          29150000
         DS    0F                       ALIGNMENT                       29151000
ORGBYTE  DBV   TSPACE(X'08'),           BYTES SKIPPED                  ,29152000
               TCSECT(X'18'),           CSECT                          ,29153000
               TDSECT(X'28'),           DSECT                          ,29154000
               TCOM(X'38'),             COM                            ,29155000
               TMOP(X'48'),             MACHINE OP                     ,29156000
               TCCW(X'58'),             CCW                            ,29157000
               TMIS(X'68'),             CATCH ALL                      ,29158000
               TDATA(X'88')             DATA TYPE                       29159000
         ORG   ORGBYTE                             ORIGIN               29160000
         DSW   ,MULTIPLE,CLUSTER,SCALING,LABEL     INDICATORS           29161000
ADDRESS  DS    AL3                                 ADDRESS              29162000
NAME     DS    CL8                      NAME                            29163000
LENGTH   DS    F                        LENGTH                          29164000
MULTIP   DS    F                        MULTIPLICITY                    29165000
SCALE    DS    H                        SCALE                           29166000
DATATYPE DBV   ,                        DATA TYPE                      ,29167000
               DTYPEC(X'00'),           DATA TYPE C                    ,29168000
               DTYPEX(X'04'),           DATA TYPE X                    ,29169000
               DTYPEB(X'08'),           DATA TYPE B                    ,29170000
               DTYPEF(X'10'),           DATA TYPE F                    ,29171000
               DTYPEH(X'14'),           DATA TYPE H                    ,29172000
               DTYPEE(X'18'),           DATA TYPE E                    ,29173000
               DTYPED(X'1C'),           DATA TYPE D                    ,29174000
               DTYPEA(X'20'),           DATA TYPE A                    ,29175000
               DTYPEQ(X'20'),           DATA TYPE Q                    ,29176000
               DTYPEY(X'24'),           DATA TYPE Y                    ,29177000
               DTYPES(X'28'),           DATA TYPE S                    ,29178000
               DTYPEV(X'2C'),           DATA TYPE V                    ,29179000
               DTYPEP(X'30'),           DATA TYPE P                    ,29180000
               DTYPEZ(X'34'),           DATA TYPE Z                    ,29181000
               DTYPEL(X'38')            DATA TYPE L                     29182000
         DS    X                        NOT USED                        29183000
         SPACE                                                          29184000
*                        SYMBOL TABLE STAGING AREA                    * 29185000
         SPACE                                                          29186000
XWORK    DS    0F                       WORK                            29187000
         DS    H                        X                               29188000
XFLGA    DS    X                        WORK                            29189000
XFLGB    DS    X                        WORK                            29190000
XTYPE    DS    X                        WORK                            29191000
XFLDI    DS    X                        WORK                            29192000
XESDI    DS    H                        WORK                            29193000
XLCTR    DS    F                        WORK                            29194000
XNAME    DS    CL8                      WORK                            29195000
XLNGQ    DS    H                        WORK                            29196000
FSTCSECT DS    H                        FIRST CSECT NUMBER NUMBER       29197000
HICESDID DS    H                        HIGH EVERYTHING ELSE NUMBER     29198000
HIDESDID DS    H                        HIGH DSECT NUMBER               29199000
INOTEVAL DS    XL8                      INPUT NOT ADDRESS               29200000
         EJECT                                                          29201000
*                        DC/DS ROUTINE WORK AREA                      * 29202000
         SPACE                                                          29203000
         DCDSWORK                                                       29204000
         SPACE                                                          29205000
         DS    0F                                                       29206000
INPUTBUF DS    XL300                    INPUT BUFFER                    29207000
         EJECT                                                          29208000
*                        EVALUATION ROUTINE WORK AREA                 * 29209000
         SPACE                                                          29210000
         EVALWORK                                                       29211000
         DS    512XL1                                          FX0000   29212000
         DS    512XL1                                          FX0000   29213000
         DS    512XL1                                          FX0000   29214000
         DS    512XL1                                          FX0000   29215000
         DS    XL4                                             FX0000   29216000
ENDOFCOM DS    0F                       ENOVID                          29217000
         DS    16F                      JUST IN CASE           FX0000   29218000
         EJECT                                                          29219000
DSECT6   DSECT ,                        ADDRESS                         29220000
         ORG   DSECT6                   ORIGIN                          29221000
         SPACE                                                          29222000
EITEM    DS    0XL20                    ESD ENTRY                       29223000
ETYPE    DBV   ,                        ESD TYPE                       ,29224000
               ETYPESD(X'00'),               CONTROL SECTION--CSECT    ,29225000
               ETYPELD(X'01'),               LABEL DEFINITION--ENTRY   ,29226000
               ETYPEER(X'02'),               EXTERNAL REFERENCE--EXTRN ,29227000
               ETYPEPC(X'04'),               PRIVATE CODE--            ,29228000
               ETYPECM(X'05'),               COMMON SECTION--COM       ,29229000
               ETYPEXD(X'06'),               EXTERNAL DUMMY--DXD       ,29230000
               ETYPEDX(X'07'),               EXTERNAL DUMMY--DSECT     ,29231000
               ETYPEDS(X'08'),               DUMMY SECTION--DSECT      ,29232000
               ETYPELX(X'09'),               LABEL DEFINITION - ENTRY  ,29233000
               ETYPEWX(X'0A')                EXTERNAL REFERENCE - WXTRN 29234000
         SPACE                                                          29235000
EFLGS    DSW   ,                             NOT USED                  ,29236000
               ,                             NOT USED                  ,29237000
               ,                             NOT USED                  ,29238000
               ,                             NOT USED                  ,29239000
               ESDNRSW2,                     X                         ,29240000
               CSECTSW2,                     X                         ,29241000
               DSECTSW2,                X                              ,29242000
               DSCOMSW2                 X                               29243000
         SPACE                                                          29244000
ERCDC    DS    0XL6                     FIELD                           29245000
ESWTS    DSW   ,DSW2,CSW2,QDSW2                                         29246000
         ORG   ESWTS                    ORIGIN                          29247000
EESDI    DS    H                        ESD IDENTIFICATION              29248000
EFLDA    EQU   *                        FIELD                           29249000
ELCTR    DS    F                        CURRENT LOCATION COUNTER VALUE  29250000
EHILC    DS    F                        HIGH LOCATION COUNTER VALUE     29251000
         ORG   EFLDA                    ORIGIN                          29252000
         DS    H                        NOT USED                        29253000
ELDID    DS    H                        CONTROL SECTION DEFINED         29254000
ELDAD    DS    F                        OFFSET IN CONTROL SECTION       29255000
         ORG   EFLDA                    ORIGIN                          29256000
EXDAL    DBV   ,                        ALIGNMENT                      ,29257000
               EXDALX(B'00000000'),          BYTE BOUNDARY             ,29258000
               EXDALH(B'00000001'),          HALFWORD BOUNDARY         ,29259000
               EXDALF(B'00000011'),          FULLWORD BOUNDARY         ,29260000
               EXDALD(B'00000111'),          DOUBLEWORD BOUNDARY        29261000
         DS    X                        NOT USED                        29262000
EXDID    DS    H                        ESDID OF DSECT REFERENCED       29263000
EXDLN    DS    F                        DUMMY SECTION LENGTH            29264000
ENAME    DS    CL8                      SYMBOL                          29265000
         EJECT                                                          29266000
DSECT14  DSECT ,                        ADDRESS                         29267000
         ORG   DSECT14                  ORIGIN                          29268000
         SPACE                                                          29269000
*                        FORMAT OF SYMBOL TABLE ENTRY                 * 29270000
         SPACE                                                          29271000
SFLGS    DSW   LNGDEF,                  X                              ,29272000
               XDUMMY,                  X                              ,29273000
               XENTRY,                  X                              ,29274000
               ENTRYSW,                 X                              ,29275000
               ESDNRSW,                 X                              ,29276000
               CSECTSW,                 X                              ,29277000
               DSECTSW,                 X                              ,29278000
               DSCOMSW                  X                               29279000
         SPACE                                                          29280000
         ORG   SFLGS                    ORIGIN                          29281000
SCHPT    DS    A                        CHAIN POINTER                   29282000
SNAME    DS    CL8                      SYMBOL                          29283000
SLNGQ    DS    H                        SYMBOL LENGTH ATTRIBUTE         29284000
SSWTS    DSW   ,DSW,CSW,,ESW,EQUF       X              @OY08064,OX00106 29285000
         ORG   SSWTS                    ORIGIN                          29286000
SESDI    DS    H                        ESDID ASSOCIATED WITH VALUE     29287000
SLCTR    DS    F                        VALUE                           29288000
         SPACE                                                          29289000
SLAST    EQU   *                        X                               29290000
         ORG   SCHPT                    ORIGIN                          29291000
SITEM    DS    0XL(SLAST-SCHPT)         FIELD                           29292000
         ORG   SNAME                    ORIGIN                          29293000
SSEG1    DS    0XL(L'SNAME+L'SLNGQ)     FIELD                           29294000
         ORG   SESDI                    ORIGIN                          29295000
SSEG2    DS    0XL(L'SESDI+L'SLCTR)     FIELD                           29296000
./ ADD NAME=IEZBITS                                                     29297000
         MACRO                                                          29298000
         IEZBITS                                                        29299000
         GBLA  &IEZBITS                                                 29300000
         AIF   (&IEZBITS EQ 0).SETSW                                    29301000
         MEXIT                                                          29302000
.SETSW   ANOP                                                           29303000
&IEZBITS SETA  1                                                        29304000
         SPACE 2                                                        29305000
BIT0     EQU   128                                                      29306000
BIT1     EQU   64                                                       29307000
BIT2     EQU   32                                                       29308000
BIT3     EQU   16                                                       29309000
BIT4     EQU   8                                                        29310000
BIT5     EQU   4                                                        29311000
BIT6     EQU   2                                                        29312000
BIT7     EQU   1                                                        29313000
         SPACE 2                                                        29314000
         MEND                                                           29315000
./ ADD NAME=IEZIOB                                                      29316000
         MACRO                                                          29317000
         IEZIOB &DSECT=YES                                              29318000
*                                                                       29319000
*/*            INPUT/OUTPUT BLOCK                                    */ 29320000
*/*                                                                  */ 29321000
*/*  OS/VS2 SU30, 01/18/77, LEVEL=1                                  */ 29322000
*/*                                                                  */ 29323000
*/*  METHOD OF ACCESS                                                */ 29324000
*/*      BAL  - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.      */ 29325000
*/*             USING ON IOB GIVES ADDRESSABILITY FOR ALL SYMBOLS.   */ 29326000
         SPACE 1                                                        29327000
         AIF   ('&DSECT' EQ 'NO').NODSCT                                29328000
IOB      DSECT , -       IOBSTDRD-16                                    29329000
         AGO   .CONT                                                    29330000
.NODSCT  ANOP                                                           29331000
         DS    0D                                                       29332000
IOB      EQU   * -       IOBSTDRD-16                                    29333000
.CONT    ANOP                                                           29334000
         SPACE 1                                                        29335000
*********************************************************************** 29336000
*                                                                     * 29337000
*                    PREFIX SECTIONS OF THE IOB                       * 29338000
*                                                                     * 29339000
*********************************************************************** 29340000
         SPACE 1                                                        29341000
IOBPREFX DS    0D                                                       29342000
         SPACE 1                                                        29343000
*                            ****************************************** 29344000
*                            *                                        * 29345000
*                            *         QSAM,BSAM,BPAM PREFIX          * 29346000
*                            *    CHAINED SCHEDULING *** 16 BYTES     * 29347000
*                            *                                        * 29348000
*                            ****************************************** 29349000
         SPACE 1                                                        29350000
IOBQSAMC DS    0D                                                       29351000
IOBBSAMC DS    0D                                                       29352000
IOBBPAMC DS    0D                                                       29353000
IOBCFLG1 DS    B -       I/O INDICATORS                                 29354000
IOBV6CHN EQU   X'80' -   I/O CHAINED BIT SET BY IGG019V6  @ZA56251      29355000
IOBRSV02 EQU   X'40',,C'X' RESERVED                                     29356000
IOBRSV03 EQU   X'20',,C'X' RESERVED                                     29357000
IOBRSV04 EQU   X'10',,C'X' RESERVED                                     29358000
IOBPTST  EQU   X'08' -   NOTE OR POINT OPERATION IS IN PROCESS          29359000
IOBABAPP EQU   X'04' -   ERROR HAS BEEN PROCESSED ONCE BY ABNORMAL-END  29360000
*                        APPENDAGE ROUTINE                              29361000
IOBRSTCH EQU   X'02' -   RESTART CHANNEL                                29362000
IOBPCI   EQU   X'01' -   SET WHEN A PROGRAM-CONTROLLED INTERRUPTION     29363000
*                        (PCI) OCCURS                                   29364000
IOBRSV05 DS    XL1 -     RESERVED                                       29365000
IOBCINOP DS    CL1 -     OFFSET OF THE LAST I/O COMMAND FOR INPUT       29366000
*                        OPERATION (NOP CCW) FROM THE ORIGIN OF THE ICB 29367000
IOBCONOP DS    CL1 -     OFFSET OF THE LAST I/O COMMAND FOR AN OUTPUT   29368000
*                        OPERATION (NOP CCW) FROM THE ORIGIN OF THE ICB 29369000
IOBCECB  DS    F -       EVENT CONTROL BLOCK USED BY BSAM OR QSAM.      29370000
*                        SHOWS THE STATUS OF THE I/O OPERATION.         29371000
IOBCICB  DS    A -       ADDRESS OF THE FIRST INTERRUPT CONTROL BLOCK   29372000
*                        (ICB) ON THE ICB QUEUE                         29373000
IOBCNOPA DS    A -       ADDRESS OF THE NOP COMMAND AT THE END OF THE   29374000
*                        QUEUE                                          29375000
         SPACE 2                                                        29376000
         ORG   IOBPREFX+8                                               29377000
         SPACE 1                                                        29378000
*                            ****************************************** 29379000
*                            *                                        * 29380000
*                            *        QSAM,BSAM,BPAM PREFIX           * 29381000
*                            *    NORMAL SCHEDULING *** 8 BYTES       * 29382000
*                            *                                        * 29383000
*                            ****************************************** 29384000
         SPACE 1                                                        29385000
IOBQSAMN DS    0D                                                       29386000
IOBBSAMN DS    0D                                                       29387000
IOBBPAMN DS    0D                                                       29388000
IOBNIOBA DS    0A -      ADDRESS OF THE NEXT IOB ASSOCIATED WITH ONE    29389000
*                        PARTICULAR DCB.  THE IOB'S ARE CHAINED IN      29390000
*                        SEQUENTIAL ORDER.                              29391000
IOBNFLG1 DS    B -       FLAG BYTE                                      29392000
IOBPRTOV EQU   X'80' -   PRTOV HAS OCCURRED (PRINTER DEVICES)           29393000
*                        (MDC331)                              @Z40FP9A 29394000
IOBSEGMT EQU   X'80' -   SEGMENTING OF A SPANNED RECORD IS IN PROCESS   29395000
*                        (QSAM LOCATE MODE, LOGICAL RECORD INTERFACE,   29396000
*                        UPDATE PROCESSING) (DIRECT ACCESS) (OS/VS2)    29397000
*                        (MDC332)                              @Z40FP9A 29398000
IOBWRITE EQU   X'40' -   A WRITE OPERATION IS IN PROCESS                29399000
IOBREAD  EQU   X'20' -   A READ OPERATION IS IN PROCESS                 29400000
IOBUPDAT EQU   X'10' -   UPDATE FLAG.  SET ON TOGETHER WITH BIT 1 OF    29401000
*                        THIS BYTE TO SHOW THAT THE BLOCK IS TO BE      29402000
*                        UPDATED.  CAN ONLY OCCUR IF THE OPEN           29403000
*                        PARAMETER IS UPDAT.                            29404000
IOBBKSPC EQU   X'08' -   IOB BEING USED FOR BACKSPACE, CONTROL OR       29405000
*                        NOTE/POINT OPERATION                           29406000
IOBSPAN  EQU   X'04' -   THE RECORD CURRENTLY BEING PROCESSED HAS MORE  29407000
*                        THAN ONE SEGMENT (QSAM LOCATE MODE, LOGICAL    29408000
*                        RECORD INTERFACE, UPDATE PROCESSING OF         29409000
*                        SPANNED RECORDS)                               29410000
IOBUPERR EQU   X'02' -   UPDATE CHANNEL PROGRAM HAS BEEN SPLIT INTO     29411000
*                        TWO PARTS                               MDC036 29412000
IOBFIRST EQU   X'01' -   THIS IS THE FIRST IOB ON CHAIN                 29413000
IOBNIOBB DS    AL3 -     ADDRESS OF THE NEXT IOB ASSOCIATED WITH ONE    29414000
*                        PARTICULAR DCB.  THE IOB'S ARE CHAINED IN      29415000
*                        SEQUENTIAL ORDER.                              29416000
IOBNECB  DS    F -       EVENT CONTROL BLOCK USED BY QSAM TO INDICATE   29417000
*                        THE STATUS OF THE I/O EVENT                    29418000
         SPACE 2                                                        29419000
         ORG   IOBPREFX+8                                               29420000
         SPACE 1                                                        29421000
*                            ****************************************** 29422000
*                            *                                        * 29423000
*                            *       BDAM PREFIX *** 8 BYTES          * 29424000
*                            *                                        * 29425000
*                            ****************************************** 29426000
         SPACE 1                                                        29427000
IOBBDAM  DS    0D                                                       29428000
IOBDQADA DS    0A -      ADDRESS OF THE OTHER IOB REFERRED TO IN        29429000
*                        DESCRIPTION OF IOBDEQ BELOW                    29430000
IOBDEQIN DS    B -       DEQUEUE LOOP INDICATOR                         29431000
IOBDEQ   EQU   X'80' -   THIS IOB IS USING A TRACK THAT WAS DEQUEUED BY 29432000
*                        ANOTHER IOB WHICH IS NOW WAITING TO DEQUEUE    29433000
*                        ANOTHER TRACK.  THE OTHER IOB ENQUEUED ON TWO  29434000
*                        OR MORE TRACKS TO FIND SPACE IN WHICH TO       29435000
*                        WRITE/ADD A SPANNED RECORD.  THE OTHER IOB     29436000
*                        REMAINED ENQUEUED UNTIL IT EITHER WROTE THE    29437000
*                        RECORD OR DETERMINED THAT THERE WAS ENOUGH     29438000
*                        CONTIGUOUS FREE SPACE ON THE TRACKS TO CONTAIN 29439000
*                        THE RECORD.  AFTER THE OTHER IOB DEQUEUED THE  29440000
*                        CURRENT TRACK, THE DEQUEUEING WAS INTERRUPTED  29441000
*                        BY THE NEED OF THIS IOB FOR THE CURRENT TRACK. 29442000
IOBRSV07 EQU   X'40',,C'X' RESERVED                                     29443000
IOBRSV08 EQU   X'20',,C'X' RESERVED                                     29444000
IOBRSV09 EQU   X'10',,C'X' RESERVED                                     29445000
IOBRSV10 EQU   X'08',,C'X' RESERVED                                     29446000
IOBRSV11 EQU   X'04',,C'X' RESERVED                                     29447000
IOBRSV12 EQU   X'02',,C'X' RESERVED                                     29448000
IOBRSV13 EQU   X'01',,C'X' RESERVED                                     29449000
IOBDQADB DS    AL3 -     ADDRESS OF THE OTHER IOB REFERRED TO IN        29450000
*                        DESCRIPTION OF IOBDEQ ABOVE                    29451000
IOBSWAP  DS    A -       ADDRESS OF THE SEGMENT WORK AREA USED BY THIS  29452000
*                        IOB TO READ OR WRITE A RECORD OF A FORMAT VS   29453000
*                        DATA SET                                       29454000
         SPACE 2                                                        29455000
         ORG   IOBPREFX+12                                              29456000
         SPACE 1                                                        29457000
*                            ****************************************** 29458000
*                            *                                        * 29459000
*                            *       GAM,QISAM PREFIX *** 4 BYTES     * 29460000
*                            *                                        * 29461000
*                            ****************************************** 29462000
         SPACE 1                                                        29463000
IOBGAM   EQU   *                                                        29464000
IOBQISAM EQU   *                                                        29465000
IOBGQECB DS    F -       EVENT CONTROL BLOCK THAT IS WITHIN FIRST IOB   29466000
*                        ONLY  (GAM)                                    29467000
*                        EVENT CONTROL BLOCK USED TO INDICATE STATUS    29468000
*                        OF AN I/O EVENT  (QISAM)                       29469000
         SPACE 3                                                        29470000
*********************************************************************** 29471000
*                                                                     * 29472000
*                    STANDARD SECTION OF THE IOB                      * 29473000
*                                                                     * 29474000
*********************************************************************** 29475000
         SPACE 1                                                        29476000
IOBSTDRD DS    0D                                                       29477000
         SPACE 1                                                        29478000
IOBFLAG1 DS    B -       FLAG BYTE 1                                    29479000
IOBDATCH EQU   X'80' -   DATA CHAINING USED IN CHANNEL PROGRAM          29480000
IOBCMDCH EQU   X'40' -   COMMAND CHAINING USED IN CHANNEL PROGRAM       29481000
IOBERRTN EQU   X'20' -   ERROR ROUTINE IS IN CONTROL                    29482000
IOBRPSTN EQU   X'10' -   DEVICE IS TO BE REPOSITIONED                   29483000
IOBCYCCK EQU   X'08' -   CYCLIC REDUNDANCY CHECK (CRC) NEEDED (TAPE)    29484000
IOBFCREX EQU   X'08' -   FETCH COMMAND RETRY EXIT (DIRECT ACCESS)       29485000
IOBIOERR EQU   X'04' -   EXCEPTIONAL CONDITION.  AFTER THE ERROR        29486000
*                        ROUTINE RETURNS AND THIS BIT IS ON, THE ERROR  29487000
*                        IS CONSIDERED PERMANENT.                       29488000
IOBUNREL EQU   X'02' -   IOB UNRELATED FLAG (I.E., NONSEQUENTIAL)       29489000
IOBRSTRT EQU   X'01' -   IF 1, RESTART ADDRESS IN IOB TO BE USED.       29490000
*                        IF 0, START.  (OS/VS1)                  MDC034 29491000
IOBSPSVC EQU   X'01' -   FOR SAM/PAM, SET BY SVC IF I/O APPENDAGE       29492000
*                        SHOULD NOT PROCESS INTERRUPT (OS/VS2)   MDC035 29493000
IOBFLAG2 DS    B -       FLAG BYTE 2                                    29494000
IOBHALT  EQU   X'80' -   HALT I/O HAS BEEN ISSUED BY SVC PURGE ROUTINE  29495000
IOBSENSE EQU   X'40' -   SENSE WILL NOT BE PERFORMED UNTIL THE DEVICE   29496000
*                        IS FREE                                        29497000
IOBPURGE EQU   X'20' -   IOB HAS BEEN PURGED TO ALLOW I/O ACTIVITY TO   29498000
*                        QUIESCE.  (OS/VS1)                      MDC046 29499000
IOBRRT3  EQU   X'20' -   TYPE 3 RELATED REQUEST (OS/VS2)         MDC048 29500000
IOBRDHA0 EQU   X'10' -   HOME ADDRESS (R0) RECORD IS TO BE READ.  SEEK  29501000
*                        COMMAND NOT NEEDED.  (OS/VS1)           MDC047 29502000
IOBRRT2  EQU   X'10' -   TYPE 2 RELATED REQUEST (OS/VS2)         MDC049 29503000
IOBALTTR EQU   X'08' -   NO TEST FOR OUT-OF-EXTENT.  AN ALTERNATE TRACK 29504000
*                        IS IN USE.                                     29505000
IOBSKUPD EQU   X'04' -   SEEK ADDRESS IS BEING UPDATED.  CYLINDER END   29506000
*                        OR FILE MASK VIOLATION HAS OCCURRED.           29507000
IOBSTATO EQU   X'02' -   DEVICE END STATUS HAS BEEN OR'ED WITH CHANNEL  29508000
*                        END STATUS  (GRAPHICS DEVICE)                  29509000
IOBPNCH  EQU   X'01' -   ERROR RECOVERY IN CONTROL FOR A 2540 CARD      29510000
*                        PUNCH WITH THREE BUFFERS  (QSAM)               29511000
*                        RESETPL MACRO INSTRUCTION WAS USED  (BTAM)     29512000
IOBSENS0 DS    B -       FIRST SENSE BYTE                               29513000
IOBS0B0  EQU   X'80' -   BIT 0 (DEVICE DEPENDENT)                       29514000
IOBS0B1  EQU   X'40' -   BIT 1 (DEVICE DEPENDENT)                       29515000
IOBS0B2  EQU   X'20' -   BIT 2 (DEVICE DEPENDENT)                       29516000
IOBS0B3  EQU   X'10' -   BIT 3 (DEVICE DEPENDENT)                       29517000
IOBS0B4  EQU   X'08' -   BIT 4 (DEVICE DEPENDENT)                       29518000
IOBS0B5  EQU   X'04' -   BIT 5 (DEVICE DEPENDENT)                       29519000
IOBS0B6  EQU   X'02' -   BIT 6 (DEVICE DEPENDENT)                       29520000
IOBS0B7  EQU   X'01' -   BIT 7 (DEVICE DEPENDENT)                       29521000
IOBSNSC9 EQU   X'01' -   CHANNEL 9 SENSED IN CARRIAGE TAPE              29522000
IOBSENS1 DS    B -       SECOND SENSE BYTE                              29523000
IOBS1B0  EQU   X'80' -   BIT 0 (DEVICE DEPENDENT)                       29524000
IOBS1B1  EQU   X'40' -   BIT 1 (DEVICE DEPENDENT)                       29525000
IOBS1B2  EQU   X'20' -   BIT 2 (DEVICE DEPENDENT)                       29526000
IOBS1B3  EQU   X'10' -   BIT 3 (DEVICE DEPENDENT)                       29527000
IOBS1B4  EQU   X'08' -   BIT 4 (DEVICE DEPENDENT)                       29528000
IOBS1B5  EQU   X'04' -   BIT 5 (DEVICE DEPENDENT)                       29529000
IOBS1B6  EQU   X'02' -   BIT 6 (DEVICE DEPENDENT)                       29530000
IOBS1B7  EQU   X'01' -   BIT 7 (DEVICE DEPENDENT)                       29531000
IOBECBPT DS    0A -      ADDRESS OF ECB TO BE POSTED ON I/O COMPLETION  29532000
IOBECBCC DS    CL1 -     COMPLETION CODE FOR AN I/O REQUEST.  THIS CODE 29533000
*                        WILL APPEAR IN THE FIRST BYTE OF AN ECB.       29534000
IOBECBPB DS    AL3 -     ADDRESS OF THE ECB TO BE POSTED UPON THE       29535000
*                        COMPLETION OF AN I/O EVENT.  FOR BSAM/BPAM,    29536000
*                        ECB IS IN THE DECB.  FOR QSAM, ECB IS IN THE   29537000
*                        QSAM PREFIX OF THE IOB.                        29538000
IOBFLAG3 DS    0B -      I/O SUPERVISOR ERROR ROUTINE FLAG BYTE         29539000
*                        (DEVICE DEPENDENT)                             29540000
IOBFL3   DS    B -       FLAG 3 - STATUS ERROR COUNTS FOR MAGNETIC      29541000
*                        DOCUMENT READER (3890) OR FLAGS FOR 3800       29542000
*                        (OS/VS1)  (MDC307)                    @X50AD9A 29543000
IOBCCC   EQU   X'80' -   CHANNEL CONTROL CHECK ERROR COUNT (3890)       29544000
*                                                                MDC038 29545000
IOBICC   EQU   X'40' -   INTERFACE CONTROL CHECK ERROR COUNT (3890)     29546000
*                                                                MDC039 29547000
IOBCDC   EQU   X'20' -   CHANNEL DATA CHECK ERROR (3890)         MDC040 29548000
IOBACU   EQU   X'10' -   ATTENTION/CONTROL UNIT ERROR (3890)     MDC041 29549000
IOBCNC   EQU   X'08' -   CHAIN CHECK ERROR (3890)                MDC042 29550000
IOBSDR   EQU   X'08' -   STATISTICS ONLY FLAG (3800) (MDC306)  @X50AD9A 29551000
IOBMSG   EQU   X'04' -   MESSAGE FLAG (3890 OR 3800) (MDC308)  @X50AD9A 29552000
IOBICL   EQU   X'02' -   INCORRECT LENGTH ERROR (3890)           MDC020 29553000
IOBJAM   EQU   X'02' -   SET ON WHEN JES SUBSYSTEM HAS DETECTED A       29554000
*                        PAPER JAM SO 3800 ERP WILL SUPPRESS ITS        29555000
*                        INTERVENTION REQUIRED MESSAGE (3800)           29556000
*                        (MDC330)                              @X50AD9A 29557000
IOBLOG   EQU   X'01' -   LOG OUT FLAG (3890 OR 3800) (MDC309)  @X50AD9A 29558000
IOBCSW   DS    0CL7 -    LOW-ORDER SEVEN BYTES OF THE LAST CSW THAT     29559000
*                        REFLECTS THE STATUS FOR THIS REQUEST           29560000
IOBIOCSW DS    0CL5 -    LOW-ORDER BYTES OF CSW FOR MAGNETIC DOCUMENT   29561000
*                        READER (3890) (OS/VS1)                  MDC022 29562000
IOBCMDA  DS    AL3 -     COMMAND ADDRESS (3890)                  MDC023 29563000
IOBSTBYT DS    0BL2 -    STATUS BITS 32-47 (3890)                MDC024 29564000
IOBUSTAT DS    B -       CSW UNIT STATUS FLAGS (3800) (MDC311) @Z40MP9A 29565000
IOBUSB0  EQU   X'80' -   ATTENTION  (MDC312)                   @Z40MP9A 29566000
IOBUSB1  EQU   X'40' -   STATUS MODIFIER  (MDC313)             @Z40MP9A 29567000
IOBUSB2  EQU   X'20' -   CONTROL UNIT END  (MDC314)            @Z40MP9A 29568000
IOBUSB3  EQU   X'10' -   BUSY  (MDC315)                        @Z40MP9A 29569000
IOBUSB4  EQU   X'08' -   CHANNEL END  (MDC316)                 @Z40MP9A 29570000
IOBUSB5  EQU   X'04' -   DEVICE END  (MDC317)                  @Z40MP9A 29571000
IOBUSB6  EQU   X'02' -   UNIT CHECK  (MDC318)                  @Z40MP9A 29572000
IOBUSB7  EQU   X'01' -   UNIT EXCEPTION  (MDC319)              @Z40MP9A 29573000
IOBCSTAT DS    B -       CSW CHANNEL STATUS FLAGS (3800)                29574000
*                        (MDC320)                              @Z40MP9A 29575000
IOBCSB0  EQU   X'80' -   PROGRAM CONTROL INTERRUPT  (MDC321)   @Z40MP9A 29576000
IOBCSB1  EQU   X'40' -   INCORRECT LENGTH  (MDC322)            @Z40MP9A 29577000
IOBCSB2  EQU   X'20' -   PROGRAM CHECK  (MDC323)               @Z40MP9A 29578000
IOBCSB3  EQU   X'10' -   PROTECTION CHECK  (MDC324)            @Z40MP9A 29579000
IOBCSB4  EQU   X'08' -   CHANNEL DATA CHECK  (MDC325)          @Z40MP9A 29580000
IOBCSB5  EQU   X'04' -   CHANNEL CONTROL CHECK  (MDC326)       @Z40MP9A 29581000
IOBCSB6  EQU   X'02' -   INTERFACE CONTROL CHECK  (MDC327)     @Z40MP9A 29582000
IOBCSB7  EQU   X'01' -   CHAINING CHECK  (MDC328)              @Z40MP9A 29583000
         DS    XL2 -     LAST TWO BYTES OF IOBCSW                       29584000
IOBSTART DS    0A -      ADDRESS OF CHANNEL PROGRAM TO BE EXECUTED      29585000
IOBSIOCC DS    B -       SIO CODE.  BITS 2 AND 3 CONTAIN CONDITION CODE 29586000
*                        RETURNED AFTER EXECUTION OF SIO INSTRUCTION    29587000
*                        FOR THIS I/O EVENT.                            29588000
IOBSTRTB DS    AL3 -     ADDRESS OF CHANNEL PROGRAM TO BE EXECUTED      29589000
IOBDCBPT DS    0A -      ADDRESS OF DCB ASSOCIATED WITH THIS IOB        29590000
IOBFLAG4 DS    B -       FLAG BYTE                               MDC011 29591000
IOBGDPOL EQU   X'80' -   RE-ENTER SIO APPENDAGE FOR OLTEP GUARANTEED    29592000
*                        DEVICE PATH                             MDC012 29593000
IOBCC3WE EQU   X'40' -   USER REQUESTS THAT IOS POST A X'6D' FOR A      29594000
*                        CONDITION CODE 3 ON ATTEMPTED I/O OPERATIONS   29595000
*                        (OS/VS2)  (MDC310)                    @Z309P9A 29596000
IOBPMERR EQU   X'20' -   VTAM SETS THIS BIT ON TO INDICATE TO IOS THAT  29597000
*                        VTAM SHOULD BE POSTED WITH A PERMANENT I/O     29598000
*                        ERROR BECAUSE ALL ALTERNATE PATHS TO THE 3705  29599000
*                        HAVE BEEN TRIED (OS/VS1)  (MDC329)    @X04BH9A 29600000
IOBRSV40 EQU   X'10',,C'X' - RESERVED                                   29601000
IOBRSV41 EQU   X'08',,C'X' - RESERVED                                   29602000
IOBRSV42 EQU   X'04',,C'X' - RESERVED                                   29603000
IOBJES3I EQU   X'02' -   JES3 INTERVENTION REQUIRED NOTIFICATION.       29604000
*                        SETTING THIS BIT WILL RESULT IN TURNING ON BIT 29605000
*                        IOSPGDPX IN THE IOSB.  (OS/VS2)                29606000
*                        (MDC305)                              @Y02BP9A 29607000
IOBRSV44 EQU   X'01',,C'X' - RESERVED                                   29608000
IOBDCBPB DS    AL3 -     ADDRESS OF DCB ASSOCIATED WITH THIS IOB        29609000
IOBRESTR DS    0A -      AFTER SVC 16 (PURGE) - QUIESCE - ADDRESS OF    29610000
*                        THE NEXT IOB IN THE PURGE CHAIN.  (LAST IOB IN 29611000
*                        THE CHAIN, BYTE 4 IS FF.)                      29612000
*                        DURING I/O SUPERVISOR WRITE-TO-OPERATOR        29613000
*                        ROUTINE CONTROL - CCHH PART OF THE ADDRESS OF  29614000
*                        A DEFECTIVE TRACK.                             29615000
*                        DURING I/O ERROR CORRECTION (MEANINGFUL ONLY   29616000
*                        IF BIT 3 IN THE IOBFLAG1 FIELD IS ON) -        29617000
*                        ADDRESS OF THE CHANNEL PROGRAM USED TO CORRECT 29618000
*                        AN ERROR CONDITION.                            29619000
*                        AFTER I/O ERROR CORRECTION - IF A CHANNEL      29620000
*                        PROGRAM IS RESTARTED THROUGH A CCW OTHER THAN  29621000
*                        THE ONE POINTED TO BY THE IOBSTART FIELD, ITS  29622000
*                        ADDRESS IS HERE.                               29623000
IOBREPOS DS    CL1 -     DURING I/O ERROR CORRECTION (MEANINGFUL ONLY   29624000
*                        IF BIT 3 IN THE IOBFLAG1 FIELD IS ON) FOR      29625000
*                        MAGNETIC TAPE ONLY - THE CONTROL COMMAND       29626000
*                        (BSR, FSR, ERG) REQUIRED TO REPOSITION OVER A  29627000
*                        BLOCK.                                         29628000
IOBRSTRB DS    AL3 -     SAME AS IOBRESTR ABOVE                         29629000
IOBINCAM DS    0H -      QSAM, BSAM, EXCP ACCESS METHOD -- NORMAL       29630000
*                        SCHEDULING - VALUE USED TO INCREMENT BLOCK     29631000
*                        COUNT FIELD IN DCB FOR MAGNETIC TAPE.          29632000
*                        CHAINED SCHEDULING - ZEROS.                    29633000
*                        QSAM, BSAM -- OPERATION CODE OF WRITE CCW WHEN 29634000
*                        A USASI CONTROL CHARACTER AND NO DATA IS TO BE 29635000
*                        WRITTEN (PRINTER AND CARD PUNCH ONLY)          29636000
IOBBTAMF DS    B -       FLAG BYTE FOR BTAM                             29637000
IOBPRMER EQU   X'80' -   SAD OR ENABLE ISSUED BY OPEN RESULTED IN A     29638000
*                        PERMANENT I/O ERROR                            29639000
IOBINUSE EQU   X'40' -   THIS IOB IS CURRENTLY IN USE BY AN I/O         29640000
*                        OPERATION                                      29641000
IOBRSV14 EQU   X'20',,C'X' RESERVED                                     29642000
IOBRSV15 EQU   X'10',,C'X' RESERVED                                     29643000
IOBRSV16 EQU   X'08',,C'X' RESERVED                                     29644000
IOBRSV17 EQU   X'04',,C'X' RESERVED                                     29645000
IOBRFTMG EQU   X'02' -   A REQUEST-FOR-TEST MESSAGE RECEIVED FROM A     29646000
*                        REMOTE 3270 DISPLAY STATION             ICB478 29647000
IOBOLTST EQU   X'01' -   LINE IS UNDER ON-LINE TEST OPERATION           29648000
IOBRSV19 DS    XL1 -     RESERVED                                       29649000
         SPACE 2                                                        29650000
         ORG   IOBINCAM                                                 29651000
IOBFL4   DS    B -       FLAG 4 - SENSE ERROR COUNTS FOR MAGNETIC       29652000
*                        DOCUMENT READER (3890) (OS/VS1) OR ERROR CODE  29653000
*                        PASSBACK BYTE FOR 3895 (FOR ERROR CODE VALUES  29654000
*                        SEE IBM 3895 DOCUMENT READER/INSCRIBER MACHINE 29655000
*                        AND PROGRAMMING DESCRIPTION, GA24-3620)        29656000
*                        (MDC333)                              @G30HP9A 29657000
IOBOVR   EQU   X'80' -   OVERRUN ERROR (3890)  (MDC026)        @G30HP9A 29658000
IOBREJ   EQU   X'40' -   COMMAND REJECT ERROR (3890) (MDC027)  @G30HP9A 29659000
IOBDCK   EQU   X'20' -   DATA CHECK ERROR (3890)  (MDC028)     @G30HP9A 29660000
IOBBUS   EQU   X'10' -   BUS-OUT ERROR (3890)  (MDC029)        @G30HP9A 29661000
IOBEQP   EQU   X'08' -   EQUIPMENT CHECK ERROR (3890) (MDC030) @G30HP9A 29662000
IOBENT   EQU   X'04' -   FIRST TIME ENTRY SWITCH (3890)                 29663000
*                        (MDC045)                              @G30HP9A 29664000
IOBRSV47 EQU   X'02',,C'X' - RESERVED FOR 3890                   MDC044 29665000
IOBRSV46 EQU   X'01',,C'X' - RESERVED FOR 3890                   MDC033 29666000
         SPACE 2                                                        29667000
         ORG   IOBINCAM                                                 29668000
IOBCRDCC DS    CL1 -     DATA CHECK ERROR COUNT  (OPTICAL READER)       29669000
IOBCRILC DS    CL1 -     INCORRECT LENGTH ERROR COUNT  (OPTICAL READER) 29670000
         SPACE 2                                                        29671000
IOBERRCT DS    H -       USED BY I/O SUPERVISOR ERROR ROUTINES TO COUNT 29672000
*                        TEMPORARY ERRORS DURING RETRY                  29673000
         SPACE 3                                                        29674000
*********************************************************************** 29675000
*                                                                     * 29676000
*                   EXTENSION SECTIONS OF THE IOB                     * 29677000
*                                                                     * 29678000
*********************************************************************** 29679000
         SPACE 1                                                        29680000
IOBEXTEN DS    0D                                                       29681000
         SPACE 1                                                        29682000
*                            ****************************************** 29683000
*                            *                                        * 29684000
*                            *  DIRECT ACCESS EXTENSION *** 8 BYTES   * 29685000
*                            *                                        * 29686000
*                            ****************************************** 29687000
         SPACE 1                                                        29688000
IOBSEEK  DS    0CL8 -    A SEEK ADDRESS (IN THE FORMAT MBBCCHHR) USED   29689000
*                        WITH A CHANNEL PROGRAM                         29690000
IOBM     DS    CL1 -     THE NUMBER OF THE DEB EXTENT TO BE USED FOR    29691000
*                        THIS REQUEST.  THE FIRST EXTENT IS NUMBER 0.   29692000
IOBBB    DS    0CL2 -    BIN NUMBER(DATA CELL)                          29693000
IOBBB1   DS    CL1                                                      29694000
IOBBB2   DS    CL1                                                      29695000
IOBCC    DS    0CL2 -    CYLINDER NUMBER                                29696000
IOBCC1   DS    CL1                                                      29697000
IOBCC2   DS    CL1                                                      29698000
IOBHH    DS    0CL2 -    TRACK NUMBER                                   29699000
IOBHH1   DS    CL1                                                      29700000
IOBHH2   DS    CL1                                                      29701000
IOBR     DS    CL1 -     RECORD NUMBER                                  29702000
         SPACE 2                                                        29703000
         ORG   IOBEXTEN                                                 29704000
         SPACE 1                                                        29705000
*                            ****************************************** 29706000
*                            *                                        * 29707000
*                            *          BTAM EXTENSION ***            * 29708000
*                            *      40 BYTES + CHANNEL PROGRAM        * 29709000
*                            *                                        * 29710000
*                            ****************************************** 29711000
         SPACE 1                                                        29712000
IOBUCBX  DS    CL1 -     UCB INDEX.  THE LINE NUMBER IS USED AS AN      29713000
*                        INDEX TO LOCATE THE PROPER UCB ADDRESS IN THE  29714000
*                        DEB.                                           29715000
IOBWORK  DS    CL5 -     WORK AREA USED BY ERROR ROUTINES AND ON-LINE   29716000
*                        TERMINAL TEST ROUTINES                         29717000
IOBRCVPT DS    CL1 -     RECEIVED ACK (ACK-0 OR ACK-1)                  29718000
IOBSNDPT DS    CL1 -     SENT ACK (ACK-0 OR ACK-1)                      29719000
IOBERCCW DS    CL8 -     CCW AREA USED BY THE BTAM ERROR RECOVERY       29720000
*                        ROUTINES                                       29721000
IOBERINF DS    CL16 -    ERROR INFORMATION FIELD USED BY THE BTAM ERROR 29722000
*                        RECOVERY ROUTINES                              29723000
IOBCPA   DS    0D -      CHANNEL PROGRAMS AREA.  THE LENGTH DEPENDS ON  29724000
*                        THE TERMINAL AND THE OPTIONS.                  29725000
         SPACE 2                                                        29726000
         ORG   IOBSEEK+8                                                29727000
         SPACE 1                                                        29728000
*                            ****************************************** 29729000
*                            *                                        * 29730000
*                            *      BISAM EXTENSION *** 16 BYTES      * 29731000
*                            *                                        * 29732000
*                            ****************************************** 29733000
         SPACE 1                                                        29734000
IOBCCWAD DS    A -       FOR FIXED LENGTH RECORDS, ADDRESS OF FIRST     29735000
*                        CCW OF CHANNEL PROGRAM.                        29736000
*                        FOR VARIABLE LENGTH RECORDS, ADDRESS OF        29737000
*                        BUFFER, IF DYNAMIC BUFFERING SPECIFIED, AFTER  29738000
*                        COMPLETION OF A READ FOR UPDATE (READ KU)      29739000
IOBINDCT DS    B -       INDICATORS                                     29740000
IOBDEQCP EQU   X'80' -   DEQUEUE CHANNEL PROGRAM FROM QUEUE             29741000
IOBUNSCH EQU   X'40' -   UNSCHEDULED QUEUE                              29742000
IOBOVPTR EQU   X'20' -   IF 0, DECBAREA + 6 POINTS TO OVERFLOW RECORD   29743000
*                        DATA.                                          29744000
*                        IF 1, DCBMSWA POINTS TO OVERFLOW RECORD KEY    29745000
*                        FOLLOWED BY DATA.                              29746000
IOBKEYAD EQU   X'10' -   IF 0, DECBKEY POINTS TO OVERFLOW RECORD KEY.   29747000
*                        IF 1, DCBMSWA + 8 POINTS TO OVERFLOW RECORD    29748000
*                        KEY.                                           29749000
IOBRSV27 EQU   X'08',,C'X' RESERVED                                     29750000
IOBRSV28 EQU   X'04',,C'X' RESERVED                                     29751000
IOBRSV29 EQU   X'02',,C'X' RESERVED                                     29752000
IOBCHNNL EQU   X'01' -   IF 0, NORMAL CHANNEL END HAS OCCURRED.         29753000
*                        IF 1, ABNORMAL CHANNEL END HAS OCCURRED.       29754000
IOBUNSQR DS    B -       REASON FOR UNSCHEDULED QUEUE                   29755000
IOBCPBSY EQU   X'80' -   CHANNEL PROGRAM CP1 OR CP2 BUSY                29756000
IOBNTAV1 EQU   X'40' -   NO CP4, CP5 OR CP6 AVAILABLE                   29757000
IOBNTAV2 EQU   X'20' -   NO CP7 AVAILABLE                               29758000
IOBKNWR  EQU   X'10' -   WRITE KN IS IN EFFECT (UNSCHEDULED IOB IS FOR  29759000
*                        WRITE KN)                                      29760000
IOBKNRWR EQU   X'08' -   WRITE KN IS IN EFFECT (UNSCHEDULED IOB IS FOR  29761000
*                        READ OR WRITE KN)                              29762000
IOBRSV30 EQU   X'04',,C'X' RESERVED                                     29763000
IOBRSV31 EQU   X'02',,C'X' RESERVED                                     29764000
IOBRSV32 EQU   X'01',,C'X' RESERVED                                     29765000
IOBAPP   DS    CL1 -     APPENDAGE CODE                                 29766000
IOBASYN  DS    CL1 -     ASYNCHRONOUS ROUTINE CODE                      29767000
IOBFCHAD DS    0A -      FORWARD CHAIN ADDRESS                          29768000
IOBCOUNT DS    CL1 -     WRITE CHECK COUNTER                            29769000
IOBFCHNB DS    AL3 -     FORWARD CHAIN ADDRESS                          29770000
IOBBCHAD DS    A -       BACKWARD CHAIN ADDRESS                         29771000
         SPACE 2                                                        29772000
         ORG   IOBEXTEN                                                 29773000
         SPACE 1                                                        29774000
*                            ****************************************** 29775000
*                            *                                        * 29776000
*                            *      GAM EXTENSION *** 40 BYTES        * 29777000
*                            *                                        * 29778000
*                            ****************************************** 29779000
         SPACE 1                                                        29780000
IOBUCBXG DS    CL1 -     UCB INDEX                                      29781000
IOBRSV37 DS    XL3 -     RESERVED                                       29782000
IOBNXTPT DS    0A -      ADDRESS OF NEXT AVAILABLE IOB.  SET TO ZERO    29783000
*                        IF THIS IS LAST IOB.                           29784000
IOBSTATA DS    B -       STATUS INDICATORS                              29785000
IOBAVLFL EQU   X'80' -   IF 0, IOB IS AVAILABLE.                        29786000
*                        IF 1, IOB IS NOT AVAILABLE.                    29787000
IOBRSV20 EQU   X'40',,C'X' RESERVED                                     29788000
IOBRSV21 EQU   X'20',,C'X' RESERVED                                     29789000
IOBRSV22 EQU   X'10',,C'X' RESERVED                                     29790000
IOBRSV23 EQU   X'08',,C'X' RESERVED                                     29791000
IOBRSV24 EQU   X'04',,C'X' RESERVED                                     29792000
IOBRSV25 EQU   X'02',,C'X' RESERVED                                     29793000
IOBRSV26 EQU   X'01',,C'X' RESERVED                                     29794000
IOBNXTPB DS    AL3 -     ADDRESS OF NEXT AVAILABLE IOB.  SET TO ZERO    29795000
*                        IF THIS IS LAST IOB                            29796000
IOBCCW   DS    CL32 -    LIST OF CHANNEL COMMAND WORDS TO TRANSFER DATA 29797000
         SPACE 2                                                        29798000
         ORG   IOBSEEK+8                                                29799000
         SPACE 1                                                        29800000
*                            ****************************************** 29801000
*                            *                                        * 29802000
*                            *     QISAM EXTENSION *** 2 BYTES        * 29803000
*                            *                                        * 29804000
*                            ****************************************** 29805000
         SPACE 1                                                        29806000
W1IEXTEN DS    0CL2 -    APPENDAGE CODES FOR BOTH NORMAL AND ABNORMAL   29807000
*                        CHANNEL END CONDITIONS                         29808000
W1OEXTEN DS    CL2 -     SAME AS W1IEXTEN ABOVE                         29809000
         SPACE 2                                                        29810000
         ORG   IOBSEEK+8                                                29811000
         SPACE 1                                                        29812000
*                            ****************************************** 29813000
*                            *                                        * 29814000
*                            *          BDAM EXTENSION ***            * 29815000
*                            *      40 BYTES + CHANNEL PROGRAM        * 29816000
*                            *                                        * 29817000
*                            ****************************************** 29818000
         SPACE 1                                                        29819000
IOBDBYTR DS    H -       NUMBER OF UNUSED BYTES REMAINING ON THE TRACK  29820000
IOBDIOBS DS    H -       OVERALL SIZE OF THE IOB                        29821000
IOBDPLAD DS    0A -      ADDRESS OF THE NEXT IOB IN THE POOL OF IOB'S   29822000
IOBDAYLI DS    B -       ALL BITS SET TO ZERO INDICATE THE AVAILABILITY 29823000
*                        OF THIS IOB                                    29824000
IOBDPLB  DS    AL3 -     ADDRESS OF THE NEXT IOB IN THE POOL OF IOB'S   29825000
IOBDTYPE DS    B -       THE TYPE OF REQUEST AND SPECIFIED OPTIONS      29826000
IOBVERFY EQU   X'80' -   VERIFY                                         29827000
IOBOVFLO EQU   X'40' -   OVERFLOW                                       29828000
IOBEXTSC EQU   X'20' -   EXTENDED SEARCH                                29829000
IOBFDBCK EQU   X'10' -   FEEDBACK                                       29830000
IOBACTAD EQU   X'08' -   ACTUAL ADDRESSING                              29831000
IOBDYNBF EQU   X'04' -   DYNAMIC BUFFERING                              29832000
IOBRDEXC EQU   X'02' -   READ EXCLUSIVE                                 29833000
IOBRELBL EQU   X'01' -   RELATIVE BLOCK ADDRESSING                      29834000
IOBDTYP2 DS    B -       SECOND BYTE OF OPTIONS AND REQUESTS            29835000
IOBSKEY  EQU   X'80' -   KEY ADDRESS CODED AS 'S'                       29836000
IOBSBLKL EQU   X'40' -   BLOCK LENGTH CODED AS 'S'                      29837000
IOBSUFFX EQU   X'30' -   IF BITS 2 AND 3 ARE ONE, RU IS SUFFIXED TO THE 29838000
*                        TYPE, INDICATING THAT THE FEEDBACK ADDRESS IN  29839000
*                        DECNXADR CAN BE THE ADDRESS OF EITHER THE NEXT 29840000
*                        DATA RECORD OR THE NEXT CAPACITY RECORD,       29841000
*                        WHICHEVER OCCURS FIRST.                        29842000
*                        IF BIT 2 IS ZERO AND BIT 3 IS ONE, R IS        29843000
*                        SUFFIXED TO THE TYPE, INDICATING THAT THE      29844000
*                        FEEDBACK ADDRESS IN DECNXADR IS THE ADDRESS OF 29845000
*                        THE NEXT DATA RECORD.                          29846000
IOBRQUST EQU   X'08' -   IF 1, READ REQUEST.  IF 0, WRITE REQUEST.      29847000
IOBTYPE  EQU   X'04' -   IF 1, KEY TYPE.  IF 0, ID TYPE.                29848000
IOBADDTY EQU   X'02' -   ADD TYPE                                       29849000
IOBRELEX EQU   X'01' -   RELEX MACRO ISSUED                             29850000
IOBDSTAT DS    0CL2  -   STATUS OF THE I/O REQUEST                      29851000
IOBSTAT1 DS    B -       FLAG BYTE                                      29852000
IOBABNRM EQU   X'80' -   ABNORMAL COMPLETION                            29853000
IOBNEWVL EQU   X'40' -   ON EXTENDED SEARCH, THE NEXT EXTENT IS ON A    29854000
*                        NEW VOLUME.  THE ASI ROUTINE MUST ISSUE THE    29855000
*                        EXCP MACRO.  THE END-OF-EXTENT APPENDAGE       29856000
*                        CANNOT.                                        29857000
IOBSYNCH EQU   X'20' -   MODULE WAS ENTERED VIA SYNCH            MDC037 29858000
IOBPASS2 EQU   X'10' -   ON EXTENDED SEARCH, INDICATES TO THE RELATIVE  29859000
*                        BLOCK CONVERSION ROUTINE THAT THE SECOND PASS  29860000
*                        OF A TWO-PASS CONVERSION ROUTINE HAS COMPLETED 29861000
IOBENQUE EQU   X'08' -   FOR EXCLUSIVE CONTROL REQUEST, INDICATES THAT  29862000
*                        A RECORD HAS BEEN ENQUEUED                     29863000
IOBBUFF  EQU   X'04' -   A BUFFER HAS BEEN ASSIGNED TO THIS IOB         29864000
IOBADDVU EQU   X'02' -   IOB BEING USED TO ADD A VARIABLE (V) OR        29865000
*                        UNDEFINED (U) TYPE RECORD TO THE DATA SET      29866000
IOBSIORT EQU   X'01' -   INDICATES TO THE DYNAMIC BUFFERING ROUTINE     29867000
*                        THAT IT WAS ENTERED FROM, AND IS TO RETURN     29868000
*                        TO, THE START I/O APPENDAGE MODULE             29869000
IOBSTAT2 DS    CL1 -     ERROR CODE FOR ABNORMAL COMPLETION USED AS     29870000
*                        POST CODE IN ECB                               29871000
IOBDCPND DS    A -       ADDRESS OF LOCATION WHERE CHANNEL END PROGRAM  29872000
*                        SHOULD END                                     29873000
IOBDBYTN DS    H -       NUMBER OF BYTES NEEDED ON A TRACK TO WRITE A   29874000
*                        NEW BLOCK                                      29875000
IOBRSV34 DS    XL2 -     RESERVED                                       29876000
IOBDQPTR DS    A -       ADDRESS OF IOB FOR NEXT I/O OPERATION TO BE    29877000
*                        EXECUTED                                       29878000
IOBRSV35 DS    XL8 -     RESERVED                                       29879000
IOBDNCRF DS    CL8 -     COUNT FIELD FOR NEW BLOCK                      29880000
IOBCHNPR DS    0D -      CHANNEL PROGRAM USED TO TRANSFER DATA AS       29881000
*                        REQUESTED BY THE READ OR WRITE MACRO           29882000
*                        INSTRUCTION STARTS HERE                        29883000
         SPACE 2                                                        29884000
         ORG   IOBSEEK+8                                                29885000
         SPACE 1                                                        29886000
*                            ****************************************** 29887000
*                            *                                        * 29888000
*                            *     VSAM EXTENSION *** 24 BYTES        * 29889000
*                            *                                        * 29890000
*                            ****************************************** 29891000
         SPACE 1                                                        29892000
IOBSEEK2 DS    0CL8 -    SEEK FIELD 2                            ICB435 29893000
IOBSK2M  DS    C -       EXTENT NUMBER                           ICB435 29894000
IOBSK2BB DS    CL2 -     BIN NUMBER                              ICB435 29895000
IOBSK2CC DS    CL2 -     CYLINDER NUMBER                         ICB435 29896000
IOBSK2HH DS    CL2 -     HEAD NUMBER                             ICB435 29897000
IOBSK2R  DS    C -       RECORD NUMBER                           ICB435 29898000
IOBBUFC  DS    A -       ADDRESS OF ASSOCIATED BUFFER CONTROL BLOCK     29899000
*                                                                ICB435 29900000
IOBREADA DS    A -       ADDRESS OF FIRST READ CHANNEL PROGRAM SEGMENT  29901000
*                        THAT HAS NOT BEEN PROCESSED             ICB435 29902000
IOBNEXTA DS    A -       ADDRESS OF NEXT ACTIVE IOB              ICB435 29903000
IOBRDCHP DS    A -       ADDRESS OF READ CHANNEL PROGRAM         ICB435 29904000
         SPACE 2                                                        29905000
         ORG   IOBEXTEN                                                 29906000
         SPACE 1                                                        29907000
*                            ****************************************** 29908000
*                            *                                        * 29909000
*                            *     VTAM EXTENSION (OS/VS1 ONLY)       * 29910000
*                            *           *** 24 BYTES                 * 29911000
*                            *                                        * 29912000
*                            ****************************************** 29913000
         SPACE 1                                                        29914000
IOBERCT  DS    0A -      POINTER TO COUNTERS FOR SIO AND TEMPORARY      29915000
*                        ERRORS                                  MDC001 29916000
IOBUCBXV DS    0FL1 -    UCB INDEX                               MDC050 29917000
IOBRTYPE DS    C -       RECORD TYPE FOR OBR                     MDC002 29918000
IOBERCTA DS    AL3 -     POINTER TO COUNTERS FOR SIO AND TEMPORARY      29919000
*                        ERRORS                                  MDC003 29920000
IOBNAME  DS    0A -      POINTER TO TERMINAL NAME                MDC004 29921000
IOBNAMSZ DS    FL1 -     SIZE OF TERMINAL NAME                   MDC005 29922000
IOBNAMEA DS    AL3 -     POINTER TO TERMINAL NAME                MDC006 29923000
IOBMDREC DS    A -       POINTER TO RECORD BEING PASSED TO              29924000
*                        MISCELLANEOUS DATA RECORDER             MDC007 29925000
IOBRCD   DS    A -       POINTER TO QUEUE OF OBR RECORDS PASSED FROM    29926000
*                        3705                                    MDC008 29927000
IOBSENSV DS    X -       SENSE BYTE SAVE AREA                    MDC009 29928000
IOBCSWSV DS    XL7 -     SAVE AREA FOR LAST 7 BYTES OF CSW       MDC010 29929000
         SPACE 2                                                        29930000
         ORG   IOBEXTEN -                                      @Z30OP9A 29931000
         SPACE 1                                                        29932000
*                            ****************************************** 29933000
*                            *                                        * 29934000
*                            *   3540 EXTENSION *** 4 BYTES   @Z30OP9A* 29935000
*                            *                                        * 29936000
*                            ****************************************** 29937000
         SPACE 1                                                        29938000
IOBSKADR DS    0CL4 -    3540 SEEK ADDRESS  (MDC300)           @Z30OP9A 29939000
IOBSKRV  DS    XL1 -     RESERVED  (MDC301)                    @Z30OP9A 29940000
IOBSKTT  DS    XL1 -     TRACK NUMBER  (MDC302)                @Z30OP9A 29941000
IOBSK0   DS    XL1 -     MUST BE ZERO  (MDC303)                @Z30OP9A 29942000
IOBSKSS  DS    XL1 -     SECTOR NUMBER  (MDC304)               @Z30OP9A 29943000
         MEND  ,                                                        29944000
./ ADD NAME=IFOXMACS                                                    29945000
*         X5ERRL   MACRO    A1 IFOX00   1/07/07   16:54:00              29946000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          29947000
*         X5COM    IFOX0000 A1 IFOX00  01/07/07   16:54:00              29948000
*         X5COM    COPY     A1 IFOX00   1/07/07   16:54:00              29949000
*         XSTBL    MACRO    A1 IFOX00   1/07/07   16:54:00              29950000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          29951000
*         XFOUR    IFOX0000 A1 IFOX00  01/07/07   16:54:00              29952000
*         XFOUR    MACRO    A1 IFOX00   1/07/07   16:54:00              29953000
*         XEVAL    MACRO    A1 IFOX00   1/07/07   16:54:00              29954000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          29955000
*            INCLUDE USER CHG FOR 512 ESD ENTRIES, UP FROM 400          29956000
*         XDICT    IFOX0000 A1 IFOX00  01/07/07   16:54:00              29957000
*         XDICT    MACRO    A1 IFOX00   1/07/07   16:54:00              29958000
*         XDCDS    MACRO    A1 IFOX00   1/07/07   16:54:00              29959000
*         TBLGEN   MACRO    A1 IFOX00   1/07/07   16:54:00              29960000
*         SET      MACRO    A1 IFOX00   1/07/07   16:54:00              29961000
*         RXLFMTS  COPY     A1 IFOX00   1/07/07   16:54:00              29962000
*         RSYMRCD  COPY     A1 IFOX00   1/07/07   16:54:00              29963000
*         OP       MACRO    A1 IFOX00   1/07/07   16:54:00              29964000
*         JWRITE   MACRO    A1 IFOX00   1/07/07   16:54:00              29965000
*         JTRUNC   MACRO    A1 IFOX00   1/07/07   16:54:00              29966000
*         JTPRINT  MACRO    A1 IFOX00   1/07/07   16:54:00              29967000
*         JTMTXT   COPY     A1 IFOX00   1/07/07   16:54:00              29968000
*         JTEXT    COPY     A1 IFOX00   1/07/07   16:54:00              29969000
*         JSAVE    MACRO    A1 IFOX00   1/07/07   16:54:00              29970000
*         JRETURN  MACRO    A1 IFOX00   1/07/07   16:54:00              29971000
*         JRELSE   MACRO    A1 IFOX00   1/07/07   16:54:00              29972000
*         JREAD    MACRO    A1 IFOX00   1/07/07   16:54:00              29973000
*         JPUTM    MACRO    A1 IFOX00   1/07/07   16:54:00              29974000
*         JPUTL    MACRO    A1 IFOX00   1/07/07   16:54:00              29975000
*         JPUNCH   MACRO    A1 IFOX00   1/07/07   16:54:00              29976000
*         JPRINT   MACRO    A1 IFOX00   1/07/07   16:54:00              29977000
*         JPOINTLB MACRO    A1 IFOX00   1/07/07   16:54:00              29978000
*         JPOINT   MACRO    A1 IFOX00   1/07/07   16:54:00              29979000
*         JPATCH   MACRO    A1 IFOX00   1/07/07   16:54:00              29980000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          29981000
*         JPARM    IFOX0000 A1 IFOX00  01/07/07   16:54:00              29982000
*         JPARM    MACRO    A1 IFOX00   1/07/07   16:54:00              29983000
*         JOUTCOM  COPY     A1 IFOX00   1/07/07   16:54:00              29984000
*         JNOTELB  MACRO    A1 IFOX00   1/07/07   16:54:00              29985000
*         JNOTE    MACRO    A1 IFOX00   1/07/07   16:54:00              29986000
*         JMODID   MACRO    A1 IFOX00   1/07/07   16:54:00              29987000
*         JINST    MACRO    A1 IFOX00   1/07/07   16:54:00              29988000
*         JINPUT   MACRO    A1 IFOX00   1/07/07   16:54:00              29989000
*         JINCOM   COPY     A1 IFOX00   1/07/07   16:54:00              29990000
*         JHEAD    MACRO    A1 IFOX00   1/07/07   16:54:00              29991000
*         JGETL    MACRO    A1 IFOX00   1/07/07   16:54:00              29992000
*         JGETCORE MACRO    A1 IFOX00   1/07/07   16:54:00              29993000
*         JGENIN   MACRO    A1 IFOX00   1/07/07   16:54:00              29994000
*         JGENERR  MACRO    A1 IFOX00   1/07/07   16:54:00              29995000
*         JGEN     MACRO    A1 IFOX00   1/07/07   16:54:00              29996000
*         JFRECORE MACRO    A1 IFOX00   1/07/07   16:54:00              29997000
*         JFLEBLK  COPY     A1 IFOX00   1/07/07   16:54:00              29998000
*         JFIND    MACRO    A1 IFOX00   1/07/07   16:54:00              29999000
*         JEXTRN   MACRO    A1 IFOX00   1/07/07   16:54:00              30000000
*         JERRCD   COPY     A1 IFOX00   1/07/07   16:54:00              30001000
*         JERMSGCD COPY     A1 IFOX00   1/07/07   16:54:00              30002000
*         JENTRY   MACRO    A1 IFOX00   1/07/07   16:54:00              30003000
*         JCSECT   MACRO    A1 IFOX00   1/07/07   16:54:00              30004000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          30005000
*         JCOMMON  IFOX0000 A1 IFOX00  01/07/07   16:54:00              30006000
*         JCOMMON  COPY     A1 IFOX00   1/07/07   16:54:00              30007000
*         JCHECK   MACRO    A1 IFOX00   1/07/07   16:54:00              30008000
*         JCALL    MACRO    A1 IFOX00   1/07/07   16:54:00              30009000
*         IEZIOB   MACRO    A1 IFOX00   1/07/07   16:54:00              30010000
*         IEZBITS  MACRO    A1 IFOX00   1/07/07   16:54:00              30011000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          30012000
*            INCLUDE USER CHG FOR 512 ESD ENTRIES, UP FROM 400          30013000
*         ICOMMON  IFOX0000 A1 IFOX00  01/07/07   16:54:00              30014000
*         ICOMMON  COPY     A1 IFOX00   1/07/07   16:54:00              30015000
*         GOTO     MACRO    A1 IFOX00   1/07/07   16:54:00              30016000
*         GOIF3    MACRO    A1 IFOX00   1/07/07   16:54:00              30017000
*         GOIF1    MACRO    A1 IFOX00   1/07/07   16:54:00              30018000
*         GOIF     MACRO    A1 IFOX00   1/07/07   16:54:00              30019000
*         GENTAB   MACRO    A1 IFOX00   1/07/07   16:54:00              30020000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          30021000
*         GENOP    IFOX0000 A1 IFOX00  01/07/07   16:54:00              30022000
*         GENOP    MACRO    A1 IFOX00   1/07/07   16:54:00              30023000
*         GENERR   MACRO    A1 IFOX00   1/07/07   16:54:00              30024000
IFOX0000 V00 UPDATE SOURCE TO MATCH ALL THE CURRENT TEXT DECKS          30025000
*         GENCOM   IFOX0000 A1 IFOX00  01/07/07   16:54:00              30026000
*         GENCOM   COPY     A1 IFOX00   1/07/07   16:54:00              30027000
*         EVALWORK MACRO    A1 IFOX00   1/07/07   16:54:00              30028000
*         ERMS     COPY     A1 IFOX00   1/07/07   16:54:00              30029000
*         EDSECT   COPY     A1 IFOX00   1/07/07   16:54:00              30030000
*         DSW      MACRO    A1 IFOX00   1/07/07   16:54:00              30031000
*         DCDSWORK MACRO    A1 IFOX00   1/07/07   16:54:00              30032000
*         DBV      MACRO    A1 IFOX00   1/07/07   16:54:00              30033000
*         CONTENTS MACRO    A1 IFOX00   1/07/07   16:54:00              30034000
*         CONTAINS MACRO    A1 IFOX00   1/07/07   16:54:00              30035000
*         BMDSECTS COPY     A1 IFOX00   1/07/07   16:54:00              30036000
./ ADD NAME=JCALL                                                       30037000
         MACRO                                                          30038000
&NAME    JCALL &ROUTINE,&BASE=YES                                       30039000
.*                                                                      30040000
.*        GENERATES A BRANCH AND LINK TO A SUBROUTINE.                  30041000
.*                                                                      30042000
         AIF   ('&BASE' EQ 'YES').BASEYES                               30043000
         AIF   ('&BASE' EQ 'NO').BASENO                                 30044000
         MNOTE 8,'INVALID PARAMETER'                                    30045000
         MEXIT                                                          30046000
.BASEYES ANOP                                                           30047000
&NAME    L     R12,=A(&ROUTINE)                                         30048000
         BALR  R9,R12                                                   30049000
         MEXIT                                                          30050000
.BASENO  ANOP                                                           30051000
&NAME    BAL   R9,&ROUTINE                                              30052000
         MEND                                                           30053000
./ ADD NAME=JCHECK                                                      30054000
         MACRO                                                          30055000
&NAME    JCHECK &FILE=                                                  30056000
.*                                                                      30057000
.*       GENERATES A CALL TO WORKFILE I/O MODULE CHECK ROUTINE          30058000
.*       TO ISSUE A CHECK FOR A STARTED I/O OPERATION.                  30059000
.*                                                                      30060000
         AIF   (K'&FILE EQ 0).ERR1                                      30061000
&NAME    JINST LA,R10,&FILE,FILE                                        30062000
         L     R12,JMLC                 LOAD BASE                       30063000
         BAL   R9,JCHECK(,R12)          GO TO JCHECK                    30064000
         MEXIT                                                          30065000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30066000
         MEND                                                           30067000
./ ADD NAME=JCOMMON                                                     30068000
*COPY JCOMMON                                                           30069000
J        DSECT                                                          30070000
*A678000                                                       @AX14816 30071000
*C678500                                                       @AX14816 30072000
*A564600,831500-833800,924500-930500,831100                    @AZ13738 30073000
*C565000                                                       @AZ13738 30074000
*                                                                       30075000
*        ASSEMBLER COMMON TABLE AS OF 12/08/70.                         30076000
*                                                                       30077000
*        REGISTER EQUATES                                               30078000
*                                                                       30079000
R0       EQU   0                        SCRATCH REGISTER                30080000
R1       EQU   1                        SCRATCH REGISTER                30081000
R2       EQU   2                        WORK REGISTER                   30082000
R3       EQU   3                        WORK REGISTER                   30083000
R4       EQU   4                        WORK REGISTER                   30084000
R5       EQU   5                        WORK REGISTER                   30085000
R6       EQU   6                        WORK REGISTER                   30086000
R7       EQU   7                        MODULE COMMON REGISTER          30087000
R8       EQU   8                        BASE REGISTER                   30088000
R9       EQU   9                        RETURN ADDRESS REGISTER         30089000
R10      EQU   10                       PARAMETER REGISTER (2-WAY)      30090000
R11      EQU   11                       PARAMETER REGISTER (2-WAY)      30091000
R12      EQU   12                       SUBROUTINE CALL REGISTER        30092000
R13      EQU   13                       COMMON REGISTER                 30093000
R14      EQU   14                       SCRATCH                         30094000
R15      EQU   15                       SCRATCH                         30095000
*                                                                       30096000
*        DISPLACEMENT EQUATES                                           30097000
*                                                                       30098000
D0       EQU   0                                                        30099000
D1       EQU   1                                                        30100000
D2       EQU   2                                                        30101000
D3       EQU   3                                                        30102000
D4       EQU   4                                                        30103000
D5       EQU   5                                                        30104000
D6       EQU   6                                                        30105000
D7       EQU   7                                                        30106000
D8       EQU   8                                                        30107000
D9       EQU   9                                                        30108000
D10      EQU   10                                                       30109000
D11      EQU   11                                                       30110000
D12      EQU   12                                                       30111000
D13      EQU   13                                                       30112000
D14      EQU   14                                                       30113000
D15      EQU   15                                                       30114000
D16      EQU   16                                                       30115000
D17      EQU   17                                                       30116000
D18      EQU   18                                                       30117000
D19      EQU   19                                                       30118000
D20      EQU   20                                                       30119000
D21      EQU   21                                                       30120000
D22      EQU   22                                                       30121000
D23      EQU   23                                                       30122000
D24      EQU   24                                                       30123000
D25      EQU   25                                                       30124000
D26      EQU   26                                                       30125000
D27      EQU   27                                                       30126000
D28      EQU   28                                                       30127000
D29      EQU   29                                                       30128000
D30      EQU   30                                                       30129000
D31      EQU   31                                                       30130000
D32      EQU   32                                                       30131000
*                                                                       30132000
*        BIT EQUATES                                                    30133000
*        BIT MASKS FOR BITS 0 - 7 DEFINED BY MACRO IEZBITS              30134000
*                                                                       30135000
         IEZBITS                                                        30136000
BITFF    EQU   B'11111111'                                   ALL        30137000
*                                                                       30138000
*        INTERNAL CODES---PRECEDED BY J                                 30139000
*                                                                       30140000
J0       EQU   X'00'                    NUMBER 0                        30141000
J1       EQU   X'01'                           1                        30142000
J2       EQU   X'02'                           2                        30143000
J3       EQU   X'03'                           3                        30144000
J4       EQU   X'04'                           4                        30145000
J5       EQU   X'05'                           5                        30146000
J6       EQU   X'06'                           6                        30147000
J7       EQU   X'07'                           7                        30148000
J8       EQU   X'08'                           8                        30149000
J9       EQU   X'09'                           9                        30150000
JA       EQU   X'0A'                    LETTER A                        30151000
JB       EQU   X'0B'                           B                        30152000
JC       EQU   X'0C'                           C                        30153000
JD       EQU   X'0D'                           D                        30154000
JE       EQU   X'0E'                           E                        30155000
JF       EQU   X'0F'                           F                        30156000
JG       EQU   X'10'                           G                        30157000
JH       EQU   X'11'                           H                        30158000
JI       EQU   X'12'                           I                        30159000
JJ       EQU   X'13'                           J                        30160000
JK       EQU   X'14'                           K                        30161000
JL       EQU   X'15'                           L                        30162000
JM       EQU   X'16'                           M                        30163000
JN       EQU   X'17'                           N                        30164000
JO       EQU   X'18'                           O                        30165000
JP       EQU   X'19'                           P                        30166000
JQ       EQU   X'1A'                           Q                        30167000
JR       EQU   X'1B'                           R                        30168000
JS       EQU   X'1C'                           S                        30169000
JT       EQU   X'1D'                           T                        30170000
JU       EQU   X'1E'                           U                        30171000
JV       EQU   X'1F'                           V                        30172000
JW       EQU   X'20'                           W                        30173000
JX       EQU   X'21'                           X                        30174000
JY       EQU   X'22'                           Y                        30175000
JZ       EQU   X'23'                           Z                        30176000
JDOLLAR  EQU   X'24'                           $                        30177000
JPOUND   EQU   X'25'                           POUND SIGN               30178000
JAT      EQU   X'26'                           AT SIGN                  30179000
JEQUAL   EQU   X'27'                    SPEC.  =                        30180000
JLPARN   EQU   X'28'                           (                        30181000
JPLUS    EQU   X'29'                           +                        30182000
JMINUS   EQU   X'2A'                           -                        30183000
JASTER   EQU   X'2B'                           *                        30184000
JSLASH   EQU   X'2C'                           /                        30185000
JRPARN   EQU   X'2D'                           )                        30186000
JCOMMA   EQU   X'2E'                           ,                        30187000
JBLANK   EQU   X'2F'                           BLANK                    30188000
JQUOTE   EQU   X'30'                           '                        30189000
JAMPER   EQU   X'31'                           &                        30190000
JPERIOD  EQU   X'32'                           .                        30191000
JNUMMIN  EQU   J0                       MINIMUM NUMBER CODE             30192000
JNUMMAX  EQU   J9                       MAXIMUM NUMBER CODE             30193000
JALFAMIN EQU   JA                       MINIMUM ALPHA CODE              30194000
JALFAMAX EQU   JAT                      MAXIMUM ALPHA CODE              30195000
JOPERMIN EQU   JPLUS                    MINIMUM OPERATOR CODE           30196000
JOPERMAX EQU   JSLASH                   MAXIMUM OPERATOR CODE           30197000
*                                                                       30198000
*        COMMON STORAGE                                                 30199000
*                                                                       30200000
         USING JCOMMON,R13              SET UP COMMON BASE              30201000
JCOMMON  DS    0D                       BEGINNING OF COMMON             30202000
JSAVE    DS    18F                      SYSTEM SAVE AREA                30203000
JFLEBLK1 DS    14A                      FILE BLOCK 1                    30204000
FILE1    EQU   JFLEBLK1-JCOMMON         FILE 1 CODE                     30205000
JFLEBLK2 DS    14A                      FILE BLOCK 2                    30206000
FILE2    EQU   JFLEBLK2-JCOMMON         FILE 2 CODE                     30207000
JFLEBLK3 DS    14A                      FILE BLOCK 3                    30208000
FILE3    EQU   JFLEBLK3-JCOMMON         FILE 3 CODE                     30209000
JMAXRL1  DS    H                        MAX RL FOR FILE 1               30210000
JMAXRL2  DS    H                        MAX RL FOR FILE 2               30211000
JMAXRL3  DS    H                        MAX RL FOR FILE 3               30212000
JMAXRL   DS    H                        MIN OF MAX RL FOR ALL FILES     30213000
JADINCM  DS    A                        ADDRESS OF INPUT COMMON         30214000
JADOUTCM DS    A                        ADDRESS OF OUTPUT COMMON        30215000
JPHNAME  DS    0CL8                     PHASE NAME OF LAST PHASE LOADED 30216000
JPHPREF  DS    CL3                      PHASE NAME PREFIX               30217000
JPHSUFF  DS    CL3                      PHASE NAME SUFFIX               30218000
JPHBLANK DS    CL2                      TWO BLANKS                      30219000
JLVTMDT  DS    0CL24                    ASM LEVEL, TIME, DATE           30220000
         DS    CL10                     SAME                            30221000
JSYSTIME DS    CL5                             HH.MM                    30222000
         DS    C                        BLANK                           30223000
JSYSDATE DS    CL8                             MM/DD/YY OR DD/MM/YY     30224000
JDECKIDL DS    X                        LENGTH OF DECK ID (0 THRU 8)    30225000
JDECKID  DS    CL8                      INTERNAL DECK ID                30226000
JPARMS   DS    0XL3                     MSGLEVEL AND LINECOUNT          30227000
JMSGL    DS    X                        MSGLEVEL=                       30228000
JLNCT    DS    H                        LINECNT=                        30229000
JSYSPARM DS    A                        SYSPARM POINTER                 30230000
JPARMPTR DS    A                        ADDR OF TRANS PARM (IF PRESENT) 30231000
JPARM    DS    0A                       OPTION PARMS (PARM 1,2,3,4)     30232000
*                                       PARAMETER (OPTION BYTE 1)       30233000
JPARM1   DSW   JLIST,                          PRINT LISTING           X30234000
               JXREF,                          PRINT XREF              X30235000
               JESD,                           PRINT ESD'S             X30236000
               JRLD,                           PRINT RLD'S             X30237000
               JDECK,                          PUNCH DECK              X30238000
               JLINK,                          WRITE OBJECT MODULE     X30239000
               JTEST                           PUNCH SYMBOL TABLE       30240000
*                                       PARAMETER (OPTION BYTE 2)       30241000
JPARM2   DSW   JRENT,                          RE-ENTRANT CHECKING     X30242000
               JALGN,                          ALIGNMENT CHECKING      X30243000
               JSYSMAC,                        PRINT SYSTEM MACROS     X30244000
               JALOGIC,                        PRINT ASSEMBLER LOGIC   X30245000
               JMLOGIC,                        PRINT MACRO LOGIC       X30246000
               JCALLS                          PRINT INNER MACRO CALLS  30247000
*                                       PARAMETER (OPTION BYTE 3)       30248000
JPARM3   DSW   JTERM,                          PRINT TO TERMINAL       X30249000
               JSTMT,                          PRINT STMT NO. ON TERM  X30250000
               JNUM,                           PRINT SEQ NO. ON TERM   X30251000
               JMINXREF,                       SHORT XREF              X30252000
               JMINBUF,,                       MINIMUM BUFFERS OR      X30253000
               JLNCTKEY,                       FIXED LINECNT           X30254000
               JMSGLKEY                        FIXED MSGLEVEL           30255000
*                                       PARAMETER (OPTION BYTE 4)       30256000
JPARM4    DSW   JYFLAG,                 ERR MSG IFO205 IF ON   @OX09734X30257000
               JMBUF,                   MULTIBUFFERS REQ IF ON @AZ13738X30258000
               ,,,,JMCHECK              FLAG FOR MLC           @AZ13738 30259000
JPREFIX  DS    CL3                      COMPONENT NAME                  30260000
*                                       WARNING FLAGS                   30261000
JWARNFLG DSW   JYCON,                          RELOCATABLE YCON        X30262000
               JREENTR                         REENTRANT CHK FAILED     30263000
*                                       POST PROCESSOR FLAGS            30264000
JRECCHK  DSW   JRLDCHK,                        RLD RECORDS PRESENT     X30265000
               JXREFCHK,                       XREF RECORDS PRESENT    X30266000
               JERRCHK,                        ERROR RECORDS PRESENT   X30267000
               JESDCHK,                        ESDID PRESENT ON END    X30268000
               JENDCHK                         PUNCH END CARD           30269000
*                                       ERROR FLAGS TO POST PROCESSOR   30270000
JINDERRF DSW   JMISLIN,                        MISSING SYSLIN DD CARD  X30271000
               JMISPCH,                        MISSING SYSPUNCH DD CARDX30272000
               JINVOPT,                        INVALID OPTION          X30273000
               JESDOFLO,                       ESD OVERFLOW            X30274000
               JMISPRT,                        MISSING SYSPRINT DD CARDX30275000
               JMISTERM,                       MISSING SYSTERM DD CARD X30276000
               JMISLIB                         SYSLIB DD CARD MISSING   30277000
*                                       PDUMP FLAGS                     30278000
JPDFLAG  DSW   JDUMPX0,                        DUMP PHASE X0           X30279000
               JDUMPX1,                        DUMP PHASE X1           X30280000
               JDUMPX2,                        DUMP PHASE X2           X30281000
               JDUMPX3,                        DUMP PHASE X3           X30282000
               JDUMPX4,                        DUMP PHASE X4           X30283000
               JDUMPX5,                        DUMP PHASE X5           X30284000
               JDUMPX6                         DUMP PHASE X6            30285000
*                                       COMMUNICATION FLAGS FOR JINMLC  30286000
JINFLAG  DSW   JIN2ND,                         ENTERED JININIT ONCE    X30287000
               JINLIB                          INPUT FROM LIBRARY       30288000
*                                       COMMUN. FLAGS FOR PRT/PCH       30289000
JOUTFLAG DSW   JOUT2ND,                        ENTERED JOUTINIT ONCE   X30290000
               JNOSEQPH,                       DON'T SEQ PUNCH @AX14816X30291000
               JSUPPRT                         SUPR PRNT 1 LINE@AX14816 30292000
*                                       COMMUNICATION FLAGS FOR MLC     30293000
JMLCFLAG DSW   JPT4STAR,                       POINT TO START OF FILE  X30294000
               JPT4READ,                       READ TO FOLLOW POINT    X30295000
               JPT4WRIT,                       WRITE TO FOLLOW POINT   X30296000
               JPT4GET,                        GET TO FOLLOW POINT     X30297000
               JDBLALL                  FILES CAN BE DBLBUF             30298000
JMLC     DS    A                        ADDRESS OF MAIN LINE CONTROL    30299000
JPUTL    EQU   0                        DISPLACEMENT FOR JPUTL          30300000
JPUTM    EQU   4                                         JPUTM          30301000
JGETL    EQU   8                                         JGETL          30302000
JTRUNC   EQU   12                                        JTRUNC         30303000
JRELSE   EQU   16                                        JRELSE         30304000
JREAD    EQU   20                                        JREAD          30305000
JWRITE   EQU   24                                        JWRITE         30306000
JCHECK   EQU   28                                        JCHECK         30307000
JGETCORE EQU   32                                        JGETCORE       30308000
JFRECORE EQU   36                                        JFRECORE       30309000
JNOTE    EQU   40                                        JNOTE          30310000
JPOINT   EQU   44                                        JPOINT         30311000
JINMLC   DS    A                        ADDR OF INPUT MAIN LINE CONTROL 30312000
JINPUT   EQU   0                        DISPLACEMENT FOR JINPUT         30313000
JFIND    EQU   4                                         JFIND          30314000
JNOTELB  EQU   8                                         JNOTELB        30315000
JPOINTLB EQU   12                                        JPOINTLB       30316000
JININIT  EQU   16                                        JININIT        30317000
JOUTMLC  DS    A                        ADDR OF OUTPUT MAIN LINE CONTRL 30318000
JPRINT   EQU   0                        DISPLACEMENT FOR JPRINT         30319000
JPUNCH   EQU   4                                         JPUNCH         30320000
JOUTINIT EQU   8                                         JOUTINIT       30321000
JPDUMP   DS    A                        ADDRESS OF PDUMP ROUTINE        30322000
JNOTEVAL DS    CL8                      VALUE FROM JNOTE                30323000
JRECIN   DS    F                        NUMBER OF RECORDS FROM SYSIN    30324000
JRECLIB  DS    F                        NUMBER OF RECORDS FROM LIBRARY  30325000
JRECPCH  DS    F                        NUMBER OF CARDS PUNCHED         30326000
JRECPRT  DS    F                        NUMBER OF LINES PRINTED         30327000
JSLEN    DS    A                        LENGTH OF AREA (JEOS-JBOS)      30328000
JBOS     DS    A                        BEGINNING OF AVAILABLE CORE     30329000
JEOS     DS    A                        NEXT AVAILABLE GETCORE AREA     30330000
JWRKSIZE EQU   JEOS,4                  WORKSIZE=NN   NNK   NNM FX0000   30331000
         SPACE ,                                               FX0000   30332000
JSAVELVL EQU   10                       NUMBER OF SAVE LEVELS           30333000
JSAVESZ  EQU   4*(R9-R2+1)              SIZE OF ONE SAVE AREA IN BYTES  30334000
JCLVLPTR DS    A                        CURRENT SAVE LEVEL PTR          30335000
         DS    A                        SIZE OF ONE SAVE AREA           30336000
JSAVETBL DS    (JSAVESZ*JSAVELVL/4)A    PUSH/POP SAVE AREA              30337000
JABORT   DS    A                        ABORT ROUTINE LINKAGE           30338000
JAABORT  DS    A                        ADDR OF ABORT ROUTINE           30339000
JSYSOPEN DS    A                        WORKFILE OPEN                   30340000
JSYSCLOS DS    A                        WORKFILE CLOSE                  30341000
CORESIZE DS    F                        REQUESTED WORKAREA     @AZ13738 30342000
OLDBUF   DS    F                        PTR TO MBUF LAST USED  @AZ13738 30343000
CURRBUF  DS    F                        PTR TO MBUF IN USE     @AZ13738 30344000
BUFSTART DS    F                        PTR TO START OF BUFTABL@AZ13738 30345000
LOWPRIOR DS    F                        PTR TO LAST ENTRY      @AZ13738 30346000
HIMASK   DS    H                        HIGEST PRIORITY VALUE  @AZ13738 30347000
LOMASK   DS    H                        LOWEST PRIORITY VALUE  @AZ13738 30348000
CURRMASK DS    H                        SAVEAREA FOR PRIORITY  @AZ13738 30349000
NRMBUF   DS    H                        NUMBER OF MBUFFERS     @AZ13738 30350000
JCONTCL  DS    H                        CONTINUE COLUMN                 30351000
JENDCOL  DS    H                        END COLUMN                      30352000
ENTRPUTL DS    A                        ENTRY POINT OF PUTLINE          30353000
JDWORD   DS    D                        DOUBLE WORD OF TEMP STORAGE     30354000
JFWORD1  DS    F                        TWO FULL WORDS                  30355000
JFWORD2  DS    F                               OF TEMP STORAGE          30356000
JHWORD1  DS    H                        TWO HALF WORDS                  30357000
JHWORD2  DS    H                               OF TEMP STORAGE          30358000
JSRCLN   DS    F                        DATA PORTION MOVE LENGTH  (1-7) 30359000
JBEGCL   DS    F                        BEGIN COLUMN MINUS 1      (2-7) 30360000
JCTCHR   DS    F                        CONT CHR COLUMN MINUS 1   (3-7) 30361000
JSEQCL   DS    F                        SEQ FLD BEGIN COL MINUS 1 (4-7) 30362000
JSEQLN   DS    F                        SEQ FLD MOVE LENGTH       (5-7) 30363000
JCTBGN   DS    F                        CONT COLUMN MINUS 1       (6-7) 30364000
JCTLN    DS    F                        CONT FLD MOVE LENGTH      (7-7) 30365000
JINFILE  DS    H                        INPUT FILE NO. FOR X4,X5,X6     30366000
JOUTFILE DS    H                        OUTPUT FILE NO. FOR X4,X5,X6    30367000
JENTRYPT DS    A                        ENTRY POINT ADDR FOR END CARD   30368000
JESDID   DS    H                        ESDID FOR OBJECT END CARD       30369000
JPAGENO  DS    H                        PAGE NUMBER FOR LISTING         30370000
JDPASS   DS    CL56                     COMMUN. BETWEEN X2A AND X3N     30371000
JSEVER   DS    X                        HIGHEST SEVERITY FOR X5, X6     30372000
JPRTONLY DS    X                        CATASTROPHIC ERROR IN X4        30373000
         DSW   JSYSGEN                  OFF INDICATES SYSGEN MODE       30374000
         DS    X                        (NOT USED)                      30375000
JLITLNG  DS    H                        MAXIMUM LITERAL LENGTH          30376000
JTBLTRT  DS    CL51                     TRANSLATE AND TEST TABLE        30377000
JTRTABLE DS    CL256                    SELF MAPPING TRANSLATE TABLE    30378000
JSAFE    DS    18F                      SAVE AREA FOR PDUMPS            30379000
JIDR     DS    CL39                     IDR                             30380000
JCOMEND  DS    0D                       END OF COMMON                   30381000
* THIS DSECT DESCRIBE BUFFERENTRYS IN MULTIBUFFER MODE         @AZ13738 30382000
BUFENTRY DSECT                                                 @AZ13738 30383000
FWBUFPTR EQU   *-BUFENTRY               PTS TO NEXT ENTRY      @AZ13738 30384000
         DS    F                        PTS TO NEXT ENTRY      @AZ13738 30385000
FWCHAIN  EQU   *-BUFENTRY               PTS TO NEXT SEQ BUFF   @AZ13738 30386000
         DS    F                        PTS TO NEXT SEQ BUFF   @AZ13738 30387000
BWCHAIN  EQU   *-BUFENTRY               PTS TO PREV. SEQ BUFF  @AZ13738 30388000
         DS    F                        PTS TO PREV. SEQ BUFF  @AZ13738 30389000
BUFTTR   EQU   *-BUFENTRY               BUFFER TTR VALUE       @AZ13738 30390000
BUFNOTE  EQU   *-BUFENTRY               TTR VALUE WITH BUF DISP@AZ13738 30391000
         DS    F                        BUFFER TTR VALUE       @AZ13738 30392000
BUFDISPL EQU   *-BUFENTRY               DISPL OF REC INTO BUFF @AZ13738 30393000
         DS    H                        DISPL OF REC INTO BUFF @AZ13738 30394000
PRIOR    EQU   *-BUFENTRY               PRIORITY VALUE         @AZ13738 30395000
         DS    H                        PRIORITY VALUE         @AZ13738 30396000
BUFADR   EQU   *-BUFENTRY               PTR TO BUFFER          @AZ13738 30397000
         DS    F                        PTR TO BUFFER          @AZ13738 30398000
BUFFEND  EQU   *                        END OF ENTRY           @AZ13738 30399000
BUFENLN  EQU   BUFFEND-BUFENTRY         LENGH OF ENTRY         @AZ13738 30400000
./ ADD NAME=JCSECT                                                      30401000
         MACRO                                                          30402000
         JCSECT &PARM                                                   30403000
         GBLC  &COMPNM,&ASMID                                           30404000
         LCLC  &X,&Y                                                    30405000
.*                                                                      30406000
.*       THIS MACRO GENERATES A CSECT STATEMENT WITH A CSECT NAME       30407000
.*       COMPOSED FROM THE MACRO INSTRUCTION OPERANDS                   30408000
.*       AND AN EQU TO THIS NAME IF WANTED.                             30409000
         AIF   (K'&PARM LT 7).ERR1                                      30410000
         AIF   ('&PARM'(1,1) NE '(').ERR1                               30411000
         AIF   ('&PARM'(K'&PARM,1) NE ')').ERR1                         30412000
         AIF   (K'&PARM EQ 7).NXA                                       30413000
         AIF   ('&PARM'(7,1) NE '=').ERR1                               30414000
.NXA     AIF   ('&PARM'(2,3) NE '&ASMID').ERR1                          30415000
.*                                                                      30416000
&X       SETC  '&PARM'(2,5)                                             30417000
&COMPNM&X CSECT                                                         30418000
.*                                                                      30419000
         AIF   (K'&PARM EQ 7).NXB                                       30420000
&Y       SETC  '&PARM'(8,K'&PARM-8)                                     30421000
&Y       EQU   &COMPNM&X                                                30422000
.NXB     MEXIT                                                          30423000
.*                                                                      30424000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30425000
         MEND                                                           30426000
./ ADD NAME=JENTRY                                                      30427000
         MACRO                                                          30428000
         JENTRY &PARM                                                   30429000
         GBLC  &COMPNM,&ASMID                                           30430000
         LCLC  &X,&Y                                                    30431000
.*                                                                      30432000
.*       DEFINES AN ENTRY POINT BY GENERATING AN ENTRY STATEMENT        30433000
.*       AND IF WANTED, AN EQU TO IT WITH THE SPECIFIED SYMBOL.         30434000
.*       THE ENTRY POINT NAME MUST FOLLOW XF NAMING CONVENTIONS.        30435000
.*                                                                      30436000
         AIF   (K'&PARM LT 9).ERR1                                      30437000
         AIF   ('&PARM'(1,1) NE '(').ERR1                               30438000
         AIF   ('&PARM'(K'&PARM,1) NE ')').ERR1                         30439000
         AIF   ('&PARM'(7,1) NE '=').ERR1                               30440000
         AIF   ('&PARM'(2,3) NE '&ASMID').ERR1                          30441000
.*                                                                      30442000
&X       SETC  '&PARM'(2,5)                                             30443000
&Y       SETC  '&PARM'(8,K'&PARM-8)                                     30444000
.*                                                                      30445000
         ENTRY &COMPNM&X                                                30446000
&COMPNM&X EQU  &Y                                                       30447000
         MEXIT                                                          30448000
.*                                                                      30449000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30450000
         MEND                                                           30451000
./ ADD NAME=JERMSGCD                                                    30452000
*COPY JERMSGCD                                                          30453000
* /* START OF SPECIFICATIONS ****                                       30454000
*02* PROCESSOR = ASSEMBLER                                              30455000
**** END OF SPECIFICATIONS ***/                                         30456000
JERMSGCD DSECT                                                          30457000
*                                                                       30458000
*  THIS DSECT PROVIDES EQUATES TO ALLOW THE USE OF SYMBOLIC ERROR AND   30459000
*  SEVERITY CODES IN THE CREATION OF ERROR MESSAGES AND ERROR RECORDS.  30460000
*                                                                       30461000
ERR0     EQU   0    UNDEFINED ERROR CODE - RECORD = XXXXXXXXXXXXXXXX    30462000
ERR11    EQU   11      THIS ERROR RESERVED.  USED FOR INTERMODULE      X30463000
                          COMMUNICATION BETWEEN X1A AND X1J.            30464000
         JGENERR NOGEN                                                  30465000
ERR256   EQU   256  SYSLIN DD CARD MISSING - NOLOAD OPTION USED         30466000
ERR257   EQU   257  SYSPUNCH DD CARD MISSING - NODECK OPTION USED       30467000
ERR258   EQU   258  INVALID ASSEMBLER OPTIONS ON EXECUTE CARD - IGNORED 30468000
ERR259   EQU   259  AT LEAST ONE RELOCATABLE Y TYPE CONSTANT IN THIS AS-30469000
                    SEMBLY                                              30470000
ERR260   EQU   260  ASSEMBLY TERMINATED.  DD CARD MISSING FOT XXXXXXXX  30471000
ERR261   EQU   261  ASSEMBLY TERMINATED.  (I/O ERROR INFORMATION)       30472000
ERR262   EQU   262  ASSEMBLY TERMINATED.  INSUFFICIENT MEMORY.          30473000
ERR263   EQU   263  ASSEMBLY TERMINATED.  PROGRAM LOGIC ERROR.          30474000
ERR264   EQU   264  ESDID NUMBER HAS EXCEEDED THE LIMIT OF 768          30475000
ERR265   EQU   265  SYMBOL TABLE OVERFLOWED.                            30476000
ERR266   EQU   266  LAST ASSEMBLER PHASE LOADED WAS XXXXXXXX.           30477000
ERR267   EQU   267  SYSPRINT DD CARD MISSING - NOLIST OPTION USED       30478000
SEV0     EQU   16                                                       30479000
SEV1     EQU   8                                                        30480000
SEV2     EQU   8                                                        30481000
SEV3     EQU   8                                                        30482000
SEV4     EQU   8                                                        30483000
SEV5     EQU   8                                                        30484000
SEV6     EQU   8                                                        30485000
SEV7     EQU   8                                                        30486000
SEV8     EQU   8                                                        30487000
SEV9     EQU   12                                                       30488000
SEV10    EQU   8                                                        30489000
SEV11    EQU   8                                                        30490000
SEV12    EQU   8                                                        30491000
SEV13    EQU   8                                                        30492000
SEV14    EQU   8                                                        30493000
SEV15    EQU   0                  TEMPORARY                             30494000
SEV16    EQU   8                                                        30495000
SEV17    EQU   4                                                        30496000
SEV18    EQU   4                                                        30497000
SEV19    EQU   8                                                        30498000
SEV20    EQU   0                   TEMPORARY                            30499000
SEV21    EQU   8                                                        30500000
SEV22    EQU   8                                                        30501000
SEV23    EQU   8                                                        30502000
SEV24    EQU   8                                                        30503000
SEV25    EQU   4                                                        30504000
SEV26    EQU   4                                                        30505000
SEV27    EQU   8                                                        30506000
SEV28    EQU   8                                                        30507000
SEV29    EQU   8                                                        30508000
SEV30    EQU   8                                                        30509000
SEV31    EQU   8                                                        30510000
SEV32    EQU   8                                                        30511000
SEV33    EQU   8                                                        30512000
SEV34    EQU   8                                                        30513000
SEV35    EQU   8                                                        30514000
SEV36    EQU   8                                                        30515000
SEV37    EQU   8                                                        30516000
SEV38    EQU   8                                                        30517000
SEV39    EQU   8                                                        30518000
SEV40    EQU   8                                                        30519000
SEV41    EQU   0                     TEMPORARY                          30520000
SEV42    EQU   8                                                        30521000
SEV43    EQU   8                                                        30522000
SEV44    EQU   0                  TEMPORARY                             30523000
SEV45    EQU   8                                                        30524000
SEV46    EQU   8                                                        30525000
SEV47    EQU   4                                                        30526000
SEV48    EQU   8                                                        30527000
SEV49    EQU   8                                                        30528000
SEV50    EQU   8                                                        30529000
SEV51    EQU   4                                                        30530000
SEV52    EQU   8                                                        30531000
SEV53    EQU   8                                                        30532000
SEV54    EQU   8                                                        30533000
SEV55    EQU   8                                                        30534000
SEV56    EQU   8                                                        30535000
SEV57    EQU   8                                                        30536000
SEV58    EQU   8                                                        30537000
SEV59    EQU   8                                                        30538000
SEV60    EQU   4                                                        30539000
SEV61    EQU   8                                                        30540000
SEV62    EQU   8                                                        30541000
SEV63    EQU   0                   TEMPORARY                            30542000
SEV64    EQU   12                                                       30543000
SEV65    EQU   8                                                        30544000
SEV66    EQU   8                                                        30545000
SEV67    EQU   4                                                        30546000
SEV68    EQU   8                                                        30547000
SEV69    EQU   4                                                        30548000
SEV70    EQU   8                                                        30549000
SEV71    EQU   8                                                        30550000
SEV72    EQU   8                                                        30551000
SEV73    EQU   8                                                        30552000
SEV74    EQU   4                                                        30553000
SEV75    EQU   8                                                        30554000
SEV76    EQU   4                                                        30555000
SEV77    EQU   0                    TEMPORARY                           30556000
SEV78    EQU   8                                                        30557000
SEV79    EQU   8                                                        30558000
SEV80    EQU   4                                                        30559000
SEV81    EQU   4                                                        30560000
SEV82    EQU   0                    TEMPORARY                           30561000
SEV83    EQU   0                    TEMPORARY                           30562000
SEV84    EQU   0                    TEMPORARY                           30563000
SEV85    EQU   8                                                        30564000
SEV86    EQU   86                                                       30565000
SEV87    EQU   8                                                        30566000
SEV88    EQU   8                                                        30567000
SEV89    EQU   12                                                       30568000
SEV90    EQU   8                                                        30569000
SEV91    EQU   8                                                        30570000
SEV92    EQU   8                                                        30571000
SEV93    EQU   93                                                       30572000
SEV94    EQU   94                                                       30573000
SEV95    EQU   95                                                       30574000
SEV96    EQU   96                                                       30575000
SEV97    EQU   97                                                       30576000
SEV98    EQU   98                                                       30577000
SEV99    EQU   99                                                       30578000
SEV100   EQU   8                                                        30579000
SEV101   EQU   8                                                        30580000
SEV102   EQU   8                                                        30581000
SEV103   EQU   8                                                        30582000
SEV104   EQU   4                                                        30583000
SEV105   EQU   8                                                        30584000
SEV106   EQU   8                                                        30585000
SEV107   EQU   8                                                        30586000
SEV108   EQU   8                                                        30587000
SEV109   EQU   8                                                        30588000
SEV110   EQU   8                                                        30589000
SEV111   EQU   8                                                        30590000
SEV112   EQU   8                                                        30591000
SEV113   EQU   8                                                        30592000
SEV114   EQU   8                                                        30593000
SEV115   EQU   8                                                        30594000
SEV116   EQU   4                                                        30595000
SEV117   EQU   8                                                        30596000
SEV118   EQU   8                                                        30597000
SEV119   EQU   4                                                        30598000
SEV120   EQU   4                                                        30599000
SEV121   EQU   4                                                        30600000
SEV122   EQU   4                                                        30601000
SEV123   EQU   4                                                        30602000
SEV124   EQU   4                                                        30603000
SEV125   EQU   8                                                        30604000
SEV126   EQU   8                                                        30605000
SEV127   EQU   8                                                        30606000
SEV128   EQU   8                                                        30607000
SEV129   EQU   8                                                        30608000
SEV130   EQU   8                                                        30609000
SEV131   EQU   8                                                        30610000
SEV132   EQU   8                                                        30611000
SEV133   EQU   12                                                       30612000
SEV134   EQU   134                                                      30613000
SEV135   EQU   135                                                      30614000
SEV136   EQU   136                                                      30615000
SEV137   EQU   137                                                      30616000
SEV138   EQU   138                                                      30617000
SEV139   EQU   139                                                      30618000
SEV140   EQU   140                                                      30619000
SEV141   EQU   141                                                      30620000
SEV142   EQU   142                                                      30621000
SEV143   EQU   143                                                      30622000
SEV144   EQU   144                                                      30623000
SEV145   EQU   145                                                      30624000
SEV146   EQU   146                                                      30625000
SEV147   EQU   147                                                      30626000
SEV148   EQU   148                                                      30627000
SEV149   EQU   149                                                      30628000
SEV150   EQU   150                                                      30629000
SEV151   EQU   151                                                      30630000
SEV152   EQU   152                                                      30631000
SEV153   EQU   153                                                      30632000
SEV154   EQU   154                                                      30633000
SEV155   EQU   155                                                      30634000
SEV156   EQU   156                                                      30635000
SEV157   EQU   8                                                        30636000
SEV158   EQU   8                                                        30637000
SEV159   EQU   8                                                        30638000
SEV160   EQU   160                                                      30639000
SEV161   EQU   8                                                        30640000
SEV162   EQU   8                                                        30641000
SEV163   EQU   4                                                        30642000
SEV164   EQU   4                                                        30643000
SEV165   EQU   4                                                        30644000
SEV166   EQU   8                                                        30645000
SEV167   EQU   16                                                       30646000
SEV168   EQU   8                                                        30647000
SEV169   EQU   8                                                        30648000
SEV170   EQU   8                                                        30649000
SEV171   EQU   4                                                        30650000
SEV172   EQU   8                                                        30651000
SEV173   EQU   8                                                        30652000
SEV174   EQU   8                                                        30653000
SEV175   EQU   8                                                        30654000
SEV176   EQU   8                                                        30655000
SEV177   EQU   12                                                       30656000
SEV178   EQU   8                                                        30657000
SEV179   EQU   8                                                        30658000
SEV180   EQU   12                                                       30659000
SEV181   EQU   12                                                       30660000
SEV182   EQU   12                                                       30661000
SEV183   EQU   12                                                       30662000
SEV184   EQU   12                                                       30663000
SEV185   EQU   8                                                        30664000
SEV186   EQU   8                                                        30665000
SEV187   EQU   8                                                        30666000
SEV188   EQU   8                                                        30667000
SEV189   EQU   8                                                        30668000
SEV190   EQU   4                                                        30669000
SEV191   EQU   8                                                        30670000
SEV192   EQU   4                                                        30671000
SEV193   EQU   8                                                        30672000
SEV194   EQU   4                                                        30673000
SEV195   EQU   12                                                       30674000
SEV196   EQU   8                                                        30675000
SEV197   EQU   0                                                        30676000
SEV198   EQU   8                                                        30677000
SEV199   EQU   8                                                        30678000
SEV200   EQU   8                                                        30679000
SEV201   EQU   8                                                        30680000
SEV202   EQU   8                                                        30681000
SEV203   EQU   4                                                        30682000
SEV204   EQU   8                                                        30683000
SEV205   EQU   4                                                        30684000
SEV206   EQU   8                                                        30685000
SEV207   EQU   8                                                        30686000
SEV208   EQU   8                                                        30687000
SEV209   EQU   8                                                        30688000
SEV210   EQU   12                                                       30689000
SEV211   EQU   12                                                       30690000
SEV212   EQU   8                                                        30691000
SEV213   EQU   8                                                        30692000
SEV214   EQU   12                                                       30693000
SEV215   EQU   8                                                        30694000
SEV216   EQU   12                                                       30695000
SEV217   EQU   12                                                       30696000
SEV218   EQU   12                                                       30697000
SEV219   EQU   8                                                        30698000
SEV220   EQU   4                                                        30699000
SEV221   EQU   12                                                       30700000
SEV222   EQU   12                                                       30701000
SEV223   EQU   12                                                       30702000
SEV224   EQU   8                                                        30703000
SEV225   EQU   4                                                        30704000
SEV226   EQU   12                                                       30705000
SEV227   EQU   8                                                        30706000
SEV228   EQU   8                                                        30707000
SEV229   EQU   4                                                        30708000
SEV230   EQU   12                                                       30709000
SEV231   EQU   8                                                        30710000
SEV232   EQU   8                                                        30711000
SEV233   EQU   8                                                        30712000
SEV234   EQU   8                                                        30713000
SEV235   EQU   8                                                        30714000
SEV236   EQU   8                                                        30715000
SEV237   EQU   8                                                        30716000
SEV238   EQU   8                                                        30717000
SEV239   EQU   8                                                        30718000
SEV240   EQU   8                                                        30719000
SEV241   EQU   8                                                        30720000
SEV242   EQU   4                                                        30721000
SEV243   EQU   8                                                        30722000
SEV244   EQU   8                                                        30723000
SEV245   EQU   8                                                        30724000
SEV246   EQU   8                                                        30725000
SEV247   EQU   247                                                      30726000
SEV248   EQU   248                                                      30727000
SEV249   EQU   249                                                      30728000
SEV250   EQU   250                                                      30729000
SEV251   EQU   251                                                      30730000
SEV252   EQU   252                                                      30731000
SEV253   EQU   253                                                      30732000
SEV254   EQU   4                                                        30733000
SEV255   EQU   8                                                        30734000
SEV256   EQU   16                                                       30735000
SEV257   EQU   16                                                       30736000
SEV258   EQU   16                                                       30737000
SEV259   EQU   4                                                        30738000
SEV260   EQU   20                                                       30739000
SEV261   EQU   20                                                       30740000
SEV262   EQU   20                                                       30741000
SEV263   EQU   20                                                       30742000
SEV264   EQU   16                                                       30743000
SEV265   EQU   16                                                       30744000
SEV266   EQU   4                                                        30745000
SEV267   EQU   16                                                       30746000
./ ADD NAME=JERRCD                                                      30747000
*COPY JERRCD                                                            30748000
JERRCD   DSECT                                                          30749000
*                                                                       30750000
*              ERROR RECORD FORMAT                                      30751000
*                                                                       30752000
JERECL   DS    H                  RECORD LENGTH                         30753000
JEFLGA   DSW   JEPSOP             FLAG A                                30754000
JEFLGB   DSW   ,,,,               FLAG B                               *30755000
               JEPRPOS            ERROR MSG PRINT POSITION SWITCH       30756000
*                                  IF JEPRPOS = 1 PRINT ERROR BEFORE    30757000
*                                  STATEMENT. IF = 0 PRINT ERROR AFTER  30758000
*                                  STATEMENT.                           30759000
         DBV   JEOPCOD(JTERROR),  INTERNAL OP CODE                     C30760000
               JEEOF(JTEOF)       INTERNAL END-OF-FILE                  30761000
JECOLPTR DS    X                  COLUMN POINTER                        30762000
JESTMTNO DS    CL3                      STATEMENT NUMBER                30763000
JEERCOD  DS    0CL2                     ERROR AND SEVERITY CODE         30764000
JESEV    DS    C                  SEVERITY CODE                         30765000
JERCDE   DS    C                  ERROR CODE                            30766000
JENODATA DS    X                  NUMBER OF 8 BYTE DATA ITEMS           30767000
JEDATA   EQU   *                  DATA ITEMS MAX OF 10 ITEMS OF EXACTLY 30768000
*                                  8 BYTES EACH.                        30769000
./ ADD NAME=JEXTRN                                                      30770000
         MACRO                                                          30771000
         JEXTRN &PARM                                                   30772000
         GBLC  &COMPNM                                                  30773000
         LCLC  &X,&Y                                                    30774000
.*                                                                      30775000
.*       DEFINES AN EXTERNAL REFERENCE BY GENERATING AN EXTRN STATEMENT 30776000
.*       NAME MUST FOLLOW XF NAMING CONVENTIONS. AN EQU TO THE          30777000
.*       EXTERNAL SYMBOL IS GENERATED IF OPERAND IS GIVEN.              30778000
.*                                                                      30779000
         AIF   (K'&PARM LT 9).ERR1                                      30780000
         AIF   ('&PARM'(1,1) NE '(').ERR1                               30781000
         AIF   ('&PARM'(K'&PARM,1) NE ')').ERR1                         30782000
         AIF   ('&PARM'(7,1) NE '=').ERR1                               30783000
.*                                                                      30784000
&X       SETC  '&PARM'(2,5)                                             30785000
&Y       SETC  '&PARM'(8,K'&PARM-8)                                     30786000
.*                                                                      30787000
         EXTRN &COMPNM&X                                                30788000
&Y       EQU   &COMPNM&X                                                30789000
         MEXIT                                                          30790000
.*                                                                      30791000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30792000
         MEND                                                           30793000
./ ADD NAME=JFIND                                                       30794000
         MACRO                                                          30795000
&NAME    JFIND &ADDR=                                                   30796000
.*       GENERATES A CALL TO THE FIND ROUTINE IN THE I/O MODULE         30797000
.*       TO ISSUE A FIND FOR A MACRO OR COPY CODE MEMBER.               30798000
         AIF   (K'&ADDR EQ 0).ERR1                                      30799000
&NAME    JINST LA,R10,&ADDR                                             30800000
         L     R12,JINMLC               LOAD BASE                       30801000
         BAL   R9,JFIND(,R12)           GO TO JFIND                     30802000
         MEXIT                                                          30803000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30804000
         MEND                                                           30805000
./ ADD NAME=JFLEBLK                                                     30806000
*COPY JFLEBLK                                                           30807000
JFLEBLK  DSECT                          FILE BLOCK DSECT                30808000
*A751000                                                       @AZ13738 30809000
         WRITE JDECB,SF,MF=L            DECB FOR READ AND WRITE         30810000
JTCLOSE  CLOSE (,),TYPE=T,MF=L          TCLOSE PARM LIST                30811000
JFLE     DS    A                        ADDR OF FILE DEFINITION         30812000
JBUFFER  DS    A                        ADDR OF ALTERNATE BUFFER        30813000
JBUF     DS    A                        ADDR OF BUFFER                  30814000
JRL      DS    H                        RECORD LENGTH                   30815000
JBUFNDX  DS    H                        BUFFER DISPLACEMENT (INDEX)     30816000
JIOFLAG  DSW   JPUTLPND,                PUTL PENDING                   X30817000
               JGETLPND,                GETL PENDING                   X30818000
               JGETLPNT,                GETL TO FOLLOW POINT           X30819000
               JGETLSBF,                POINT (GETL) WITHIN SAME BUFFERX30820000
               JNOTED,                  NOTE VALUE OF LAST RECORD NOTEDX30821000
               JDBLBUF,                 OUTPUT IS DOUBLE BUFFERED      X30822000
               JCHKFILE,                FILE NEEDS TO BE CHECKED       X30823000
               JPUTLWRT                 PUTL FORCED WRITE               30824000
JMLTFLAG DSW   JMLTBUF                  MBUFFERS IN USE        @AZ13738 30825000
JLSTNOTE DS    CL6                      NOTE VALUE OF LAST RECORD NOTED 30826000
./ ADD NAME=JFRECORE                                                    30827000
         MACRO                                                          30828000
&NAME    JFRECORE &ADDR=                                                30829000
.*       GENERATES A CALL TO THE I/O INTERFACE MODULES TO FREE          30830000
.*       A BLOCK OF DOUBLE WORD STORRAGE.                               30831000
         AIF   (K'&ADDR EQ 0).ERR1                                      30832000
&NAME    JINST L,R10,&ADDR                                              30833000
         L     R12,JMLC                 LOAD BASE                       30834000
         BAL   R9,JFRECORE(,R12)        GO TO JFRECORE                  30835000
         MEXIT                                                          30836000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     30837000
         MEND                                                           30838000
./ ADD NAME=JGEN                                                        30839000
         MACRO                                                          30840000
&NAME    JGEN  &NM,&TYPE,&DATA,&LEN                                     30841000
         LCLA  &END,&I                                                  30842000
         LCLC  &C(2),&L                                                 30843000
.*       GENERATES AN ORG TO SPECIFIED ADDRESS                          30844000
.*       AND A DC OF SPECIFIED TYPE AND VALUE.                          30845000
         ORG   START+&NM-JCOMMON                                        30846000
&C(1)    SETC  '('                                                      30847000
&C(2)    SETC  ')'                                                      30848000
         AIF   ('&TYPE' EQ 'A' OR '&TYPE' EQ 'Q' OR '&TYPE' EQ 'V' OR  X30849000
               '&TYPE' EQ 'S' OR '&TYPE' EQ 'Y').NXA                    30850000
&C(1)    SETC  ''''                                                     30851000
&C(2)    SETC  ''''                                                     30852000
.NXA     AIF   (K'&LEN EQ 0).NXB                                        30853000
&L       SETC  'L'.'&LEN'                                               30854000
.NXB     AIF   (K'&NAME EQ 0).NXC                                       30855000
&NAME    DS    0&TYPE&L                                                 30856000
.NXC     ANOP                                                           30857000
&I       SETA  1                                                        30858000
&END     SETA  N'&DATA                                                  30859000
.NXD     DC    &TYPE&L&C(1)&DATA(&I)&C(2)                               30860000
&I       SETA  &I+1                                                     30861000
         AIF   (&I LE &END).NXD                                         30862000
.NXE     MEND                                                           30863000
./ ADD NAME=JGENERR                                                     30864000
         MACRO                                                          30865000
         JGENERR &OPTION                                                30866000
         GBLB  &GENSW                                                   30867000
.*  THIS MACRO IS CALLED BY ALL PHASES WITH THE OPTION NOGEN TO GENERAT 30868000
.*  THE DSECT JERMSGCD.  IT IS ALSO CALLED BY CSECT X6C WITH THE OPTION 30869000
.*  GEN TO GENERATE ALL OF THE ERROR MESSAGES.                          30870000
&GENSW   SETB  0                        TURN OFF GEN SWITCH             30871000
         AIF   ('&OPTION' EQ 'NOGEN').C1 DO WE GENERATE ERROR MESSAGES  30872000
&GENSW   SETB  1                        YES, TURN ON GEN SWITCH         30873000
.C1      ANOP                           PROCEED TO CALL GENERR MACRO    30874000
.*                                      TO GENERATE EITHER ERROR MSGS   30875000
.*                                      OR DSECT JERMSGCD, DEPENDING    30876000
.*                                      UPON THE SETTING OF &GENSW.     30877000
         COPY  ERMS                                                     30878000
         MEND                                                           30879000
./ ADD NAME=JGENIN                                                      30880000
         MACRO                                                          30881000
&LABEL   JGENIN &LIST,&LENGTH                                           30882000
         LCLA  &K,&C,&CT,&LEN                                           30883000
         LCLB  &SW,&SW1                                                 30884000
         LCLC  &LET,&GEN(8)                                             30885000
.* GENERATES INTERNALLY CODED TEXT.                                     30886000
.* ACCEPTS ALPHA, NUMBERIC, AND ALL SPECIAL CHARACTERS EXCEPT           30887000
.* AMPERSAND AND QUOTE.                                                 30888000
&K       SETA  K'&LIST                                                  30889000
&C       SETA  1                                                        30890000
         AIF   ('&LIST'(1,1) NE '''').M1                                30891000
&C       SETA  2                                                        30892000
&SW      SETB  1                                                        30893000
.M1      AIF   ('&LENGTH' NE '').M2                                     30894000
&SW1     SETB  1                                                        30895000
&LEN     SETA  0                                                        30896000
.*  SW =0 - NO QUOTE                                                    30897000
.*  SW =1 - QUOTE                                                       30898000
.*  SW1=0 - LENGTH                                                      30899000
.*  SW1=1 - NO LENGTH                                                   30900000
.M2      AIF   (&SW).M3                 BRANCH QUOTE                    30901000
         AIF   (&SW1).M5                BRANCH NO QUOTE, NO LENGTH      30902000
.*   NO QUOTE  LENGTH                                                   30903000
         AIF   (&LENGTH GT &K).M2A                                      30904000
&K       SETA  &LENGTH                                                  30905000
&LEN     SETA  0                                                        30906000
         AGO   .M5                                                      30907000
.M2A     ANOP                                                           30908000
&LEN     SETA  &LENGTH-&K                                               30909000
         AGO   .M5                                                      30910000
.*   QUOTE                                                              30911000
.M3      AIF   (&SW1).M4                BRANCH QUOTE NO LENGTH          30912000
.*   QUOTE LENGTH                                                       30913000
&K       SETA  &K-2                                                     30914000
         AIF   (&LENGTH GT &K).M3A                                      30915000
&K       SETA  &LENGTH+1                                                30916000
&LEN     SETA  0                                                        30917000
         AGO   .M5                                                      30918000
.M3A     ANOP                                                           30919000
&LEN     SETA  &LENGTH-&K                                               30920000
&K       SETA  &K+1                                                     30921000
         AGO   .M5                                                      30922000
.*   QUOTE  NO LENGTH                                                   30923000
.M4      ANOP                                                           30924000
&K       SETA  &K-1                                                     30925000
.M5      AIF   ('&LABEL' EQ '').L2                                      30926000
&LABEL   DC    0CL(&K-&C+1+&LEN)' '                                     30927000
.L2      ANOP                                                           30928000
&CT      SETA  1                                                        30929000
.L3      AIF   ('&LIST'(&C,1) EQ '$').L3DOLR      DOLLAR                30930000
         AIF   ('&LIST'(&C,1) EQ '#').L3POUND     POUND                 30931000
         AIF   ('&LIST'(&C,1) EQ '@').L3AT        AT                    30932000
         AIF   ('&LIST'(&C,1) EQ '=').L3EQ        EQUAL                 30933000
         AIF   ('&LIST'(&C,1) EQ '(').L3LP        LEFT PARN.            30934000
         AIF   ('&LIST'(&C,1) EQ '+').L3PLUS      PLUS                  30935000
         AIF   ('&LIST'(&C,1) EQ '-').L3MIN       MINUS                 30936000
         AIF   ('&LIST'(&C,1) EQ '*').L3AST       ASTER                 30937000
         AIF   ('&LIST'(&C,1) EQ '/').L3SLASH     SLASH                 30938000
         AIF   ('&LIST'(&C,1) EQ ')').L3RP        RIGHT PARN.           30939000
         AIF   ('&LIST'(&C,1) EQ ',').L3C         COMMA                 30940000
         AIF   ('&LIST'(&C,1) EQ ' ').L3B         BLANK                 30941000
         AIF   ('&LIST'(&C,1) EQ '.').L3P         PERIOD                30942000
&LET     SETC  'J'.'&LIST'(&C,1)                                        30943000
.L6      AIF   (&CT EQ 1).L7                                            30944000
&LET     SETC  ','.'&LET'                                               30945000
.L7      ANOP                                                           30946000
&GEN(&CT) SETC '&LET'                                                   30947000
&C       SETA  &C+1                                                     30948000
         AIF   (&C GT &K).L9                                            30949000
&CT      SETA  &CT+1                                                    30950000
         AIF   (&CT LT 9).L3                                            30951000
         DC    AL1(&GEN(1)&GEN(2)&GEN(3)&GEN(4)&GEN(5)&GEN(6)&GEN(7)&GEX30952000
               N(8))                                                    30953000
&CT      SETA  1                                                        30954000
.L8      ANOP                                                           30955000
&GEN(&CT) SETC ''                                                       30956000
&CT      SETA  &CT+1                                                    30957000
         AIF   (&CT LT 9).L8                                            30958000
         AGO   .L2                                                      30959000
.L3DOLR  ANOP                                                           30960000
&LET     SETC  'JDOLLAR'                                                30961000
         AGO   .L6                                                      30962000
.L3POUND ANOP                                                           30963000
&LET     SETC  'JPOUND'                                                 30964000
         AGO   .L6                                                      30965000
.L3AT    ANOP                                                           30966000
&LET     SETC  'JAT'                                                    30967000
         AGO   .L6                                                      30968000
.L3EQ    ANOP                                                           30969000
&LET     SETC  'JEQUAL'                                                 30970000
         AGO   .L6                                                      30971000
.L3LP    ANOP                                                           30972000
&LET     SETC  'JLPARN'                                                 30973000
         AGO   .L6                                                      30974000
.L3PLUS  ANOP                                                           30975000
&LET     SETC  'JPLUS'                                                  30976000
         AGO   .L6                                                      30977000
.L3MIN   ANOP                                                           30978000
&LET     SETC  'JMINUS'                                                 30979000
         AGO   .L6                                                      30980000
.L3AST   ANOP                                                           30981000
&LET     SETC  'JASTER'                                                 30982000
         AGO   .L6                                                      30983000
.L3SLASH ANOP                                                           30984000
&LET     SETC  'JSLASH'                                                 30985000
         AGO   .L6                                                      30986000
.L3RP    ANOP                                                           30987000
&LET     SETC  'JRPARN'                                                 30988000
         AGO   .L6                                                      30989000
.L3C     ANOP                                                           30990000
&LET     SETC  'JCOMMA'                                                 30991000
         AGO   .L6                                                      30992000
.L3B     ANOP                                                           30993000
&LET     SETC  'JBLANK'                                                 30994000
         AGO   .L6                                                      30995000
.L3P     ANOP                                                           30996000
&LET     SETC  'JPERIOD'                                                30997000
         AGO   .L6                                                      30998000
.L9      DC    AL1(&GEN(1)&GEN(2)&GEN(3)&GEN(4)&GEN(5)&GEN(6)&GEN(7)&GEX30999000
               N(8))                                                    31000000
         AIF   (&LEN EQ 0).L10                                          31001000
         DC    &LEN.AL1(JBLANK)                                         31002000
.L10     MEND                                                           31003000
./ ADD NAME=JGETCORE                                                    31004000
         MACRO                                                          31005000
&NAME    JGETCORE &MINDBL=,&MAXDBL=,&DBL=                               31006000
         LCLA  &AA,&BB                                                  31007000
         LCLB  &A,&B                                                    31008000
.*       GENERATES A CALL TO THE I/O INTERFACE MODULES TO GET           31009000
.*       A VARIABLE NUMBER OF DOUBLE WORD STORAGE.                      31010000
&A       SETB  (K'&MINDBL EQ 0 AND K'&MAXDBL EQ 0)                      31011000
&B       SETB  (K'&DBL EQ 0)                                            31012000
&AA      SETA  &A                                                       31013000
&BB      SETA  &B                                                       31014000
         AIF   (&AA EQ &BB).ERR1                                        31015000
         AIF   (K'&DBL EQ 0).NXA                                        31016000
&NAME    JINST LA,R10,&DBL                                              31017000
         LR    R11,R10                                                  31018000
         AGO   .NXB                                                     31019000
.NXA     ANOP                                                           31020000
&NAME    JINST LA,R10,&MINDBL                                           31021000
         JINST LA,R11,&MAXDBL                                           31022000
.NXB     L     R12,JMLC                 LOAD BASE                       31023000
         BAL   R9,JGETCORE(,R12)        GO TO JGETCORE                  31024000
         MEXIT                                                          31025000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31026000
         MEND                                                           31027000
./ ADD NAME=JGETL                                                       31028000
         MACRO                                                          31029000
&NAME    JGETL &FILE=                                                   31030000
.*       GENERATES A CALL TO TEH WORKFILE I/O MODULE TO GET THE ADDRESS 31031000
.*       OF THE NEXT LOGICAL RECORD.                                    31032000
         AIF   (K'&FILE EQ 0).ERR1                                      31033000
&NAME    JINST LA,R10,&FILE,FILE                                        31034000
         L     R12,JMLC                 LOAD BASE                       31035000
         BAL   R9,JGETL(,R12)           GO TO JGETL                     31036000
         MEXIT                                                          31037000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31038000
         MEND                                                           31039000
./ ADD NAME=JHEAD                                                       31040000
         MACRO                                                          31041000
         JHEAD &TITLE,&PHASEID=,&LEVEL=                                 31042000
         GBLA  &ASMLEV                                                  31043000
         GBLC  &COMPNM,&ASMID                                           31044000
         LCLA  &I,&J                                                    31045000
         LCLC  &X(10)                                                   31046000
.*                                                                      31047000
.*       GENERATES A TITLE STATEMENT AND A STATUS MNOTE                 31048000
.*       IN THE PROLOUGE TO AN MODULE.                                  31049000
         AIF   (K'&TITLE GT 47).ERR1    TOO BIG FOR ONE TITLE CARD      31050000
         AIF   (K'&PHASEID NE 3).ERR1   IT MUST BE THREE IN LENGTH      31051000
         AIF   (K'&LEVEL EQ 0).ERR1     IT MUST BE PRESENT              31052000
.*                                                                      31053000
&ASMID   SETC  '&PHASEID'               PUT PHASEID IN GBLC             31054000
&ASMLEV  SETA  &LEVEL                   PUT LEVEL IN GBLA               31055000
.*                                                                      31056000
&COMPNM  SETC  'IFN'                    SYSTEM INDEPENDENT NAME         31057000
         AIF   ('&ASMID'(2,1) NE '0').SKIP                              31058000
&COMPNM  SETC  'IFO'                    SYSTEM DEPENDENT NAME           31059000
.SKIP    ANOP                                                           31060000
.*                                                                      31061000
&I       SETA  1                        NOW TRANSFER TITLE TO VARIABLE  31062000
&J       SETA  2                                                        31063000
.LPA     ANOP                                                           31064000
         AIF   (K'&TITLE EQ &J).NXA                                     31065000
         AIF   (K'&TITLE LT &J+8).LPA1                                  31066000
&X(&I)   SETC  '&TITLE'(&J,8)                                           31067000
&I       SETA  &I+1                                                     31068000
&J       SETA  &J+8                                                     31069000
         AGO   .LPA                                                     31070000
.LPA1    ANOP                                                           31071000
&X(&I)   SETC  '&TITLE'(&J,K'&TITLE-&J)                                 31072000
.NXA     ANOP                                                           31073000
.*                                                                      31074000
&ASMID   TITLE '&COMPNM&ASMID - &X(1)&X(2)&X(3)&X(4)&X(5)&X(6)'         31075000
.*                                                                      31076000
         MNOTE *,'STATUS--CHANGE LEVEL &LEVEL'                          31077000
         MEXIT                                                          31078000
.*                                                                      31079000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31080000
         MEND                                                           31081000
./ ADD NAME=JINCOM                                                      31082000
*COPY JINCOM                                                            31083000
JINCOM   DSECT                                                          31084000
         USING JINCOM,R7                SET UP MODULE COMMON BASE       31085000
JSYSIN   DS    A                        ADDR OF FILE DEF FOR INPUT      31086000
JSYSLIB  DS    A                        ADDR OF FILE DEF FOR LIBRARY    31087000
JINOPEN  DS    A                        ADDR OF OPEN PARM LIST          31088000
JINCLOS  DS    A                        ADDR OF CLOSE PARM LIST         31089000
         READ  JLIBDECB,SF,MF=L         DECB FOR LIBRARY                31090000
JLIBBUF  DS    A                        ADDR OF LIBRARY BUFFER          31091000
JBLKSIZE DS    H                        BLOCK SIZE OF CURRENT LIB REC   31092000
JLIBNDX  DS    H                        BUFFER INDEX INTO LIB BUFFER    31093000
JINSW    DSW   JREADPT                  SPECIAL READ FOR POINT          31094000
JINCMEND DS    0D                       END OF INPUT COMMON             31095000
./ ADD NAME=JINPUT                                                      31096000
         MACRO                                                          31097000
&NAME    JINPUT                                                         31098000
.*       GENERATES A CALL TO THE INPUT I/O MODULE TO GET THE NEXT       31099000
.*       RECORD FROM THE INPUT FILE.                                    31100000
&NAME    L     R12,JINMLC               LOAD BASE                       31101000
         BAL   R9,JINPUT(,R12)          GO TO JINPUT                    31102000
         MEND                                                           31103000
./ ADD NAME=JINST                                                       31104000
         MACRO                                                          31105000
&NAME    JINST &OP,&REG,&ADDR,&COMP                                     31106000
         LCLC  &X                                                       31107000
         LCLA  &I                                                       31108000
.*       INNER MACRO.   GENERATES MACHINE INSTRUCTIONS ACCORDING        31109000
.*       TO MACRO CALL OPERANDS VALUES.                                 31110000
         AIF   ('&ADDR'(1,1) NE '(').NXC                                31111000
         AIF   ('&ADDR'(K'&ADDR,1) NE ')').NXC                          31112000
&X       SETC  '&ADDR'(2,K'&ADDR-2)                                     31113000
         AIF   ('&X' NE '&REG').NXB                                     31114000
         AIF   (K'&NAME EQ 0).NXA                                       31115000
&NAME    DC    0H'0'                                                    31116000
.NXA     MEXIT                                                          31117000
.NXB     ANOP                                                           31118000
&NAME    LR    &REG,&X                                                  31119000
         MEXIT                                                          31120000
.NXC     ANOP                                                           31121000
&I       SETA  4                                                        31122000
         AIF   (K'&ADDR GE 4).NXC1                                      31123000
&I       SETA  K'&ADDR                                                  31124000
.NXC1    AIF   (K'&COMP NE 0 AND '&ADDR'(1,&I) NE 'FILE').ERR1          31125000
&NAME    &OP   &REG,&ADDR                                               31126000
         MEXIT                                                          31127000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31128000
         MEND                                                           31129000
./ ADD NAME=JMODID                                                      31130000
         MACRO                                                          31131000
&NAME    JMODID                                                         31132000
         GBLA  &SNUMBER,&ASMLEV                                         31133000
         GBLC  &ASMID,&COMPNM                                           31134000
.*       GENERATES EMBEDDED IDENTIFIER CONSISTING OF SIX CARACTER       31135000
.*       MODULE NAME AND A HALF WORD BINARY ASSEMBLER LEVEL.            31136000
&NAME    DC    CL6'&COMPNM&ASMID',HL2'&ASMLEV'                          31137000
         MEND                                                           31138000
./ ADD NAME=JNOTE                                                       31139000
         MACRO                                                          31140000
&NAME    JNOTE &FILE=                                                   31141000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO GET             31142000
.*       THE RELETIVE POSITION OF THE LAST READ OR WRITE                31143000
         AIF   (K'&FILE EQ 0).ERR1                                      31144000
&NAME    JINST LA,R10,&FILE,FILE                                        31145000
         L     R12,JMLC                 LOAD BASE                       31146000
         BAL   R9,JNOTE(,R12)           GO TO JNOTE                     31147000
         MEXIT                                                          31148000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31149000
         MEND                                                           31150000
./ ADD NAME=JNOTELB                                                     31151000
         MACRO                                                          31152000
&NAME    JNOTELB                                                        31153000
.*       GENERATES A CALL TO THE INPUT I/O MODULE TO NOTE               31154000
.*       THE POSITION IN LIBRARY.                                       31155000
&NAME    L     R12,JINMLC               LOAD BASE                       31156000
         BAL   R9,JNOTELB(,R12)         GO TO JNOTELB                   31157000
         MEND                                                           31158000
./ ADD NAME=JOUTCOM                                                     31159000
*COPY JOUTCOM                                                           31160000
JOUTCOM  DSECT                          OUTPUT COMMON DSECT             31161000
         USING JOUTCOM,R7               SETUP USING FOR OUTPUT COMMON   31162000
JSYSLST  DS    A                        ADDR OF FILE DEF FOR PRINT FILE 31163000
JSYSPCH  DS    A                        ADDR OF FILE DEF FOR PUNCH FILE 31164000
JSYSLNK  DS    A                        ADDR OF FILE DEF FOR LINK FILE  31165000
JSYSTRM  DS    A                        ADDR OF FILE DEF FOR TERM FILE  31166000
JOUTOPEN DS    A                        ADDR OF OPEN PARM LIST          31167000
JOUTCLOS DS    A                        ADDR OF CLOSE PARM LIST         31168000
JCURPRT  DS    A                        ADDR OF CURRENT PRINT BUFFER    31169000
JCURTRM  DS    A                        ADDR OF CURRENT TERM PRINT BUF  31170000
JCURPCH  DS    A                        ADDR OF CURRENT PUNCH BUFFER    31171000
JDECKSEQ DS    H                        DECK SEQUENCE NUMBER            31172000
JOUTSW   DSW   BYPASPRT,                1ST PRINT SWITCH               X31173000
               BYPASPCH,                1ST PUNCH SWITCH               X31174000
               CLOSPRT,                 FINAL PRINT SWITCH             X31175000
               CLOSPCH,                 FINAL PUNCH SWITCH             X31176000
               NOSEQ,                   DON'T SEQ PUNCHED OUTPUT       X31177000
               BYPASTRM,                FIRST TERM PRINT SWITCH        X31178000
               CLOSTRM                  FINAL TERM PRINT SWITCH         31179000
JOUTCMND DS    0D                                                       31180000
./ ADD NAME=JPARM                                                       31181000
         MACRO                                                          31182000
         JPARM &FIXED=,                 FIXED PARAMETER OPTIONS        X31183000
               &DEFAULT=,               DEFAULT PARAMETER OPTIONS      X31184000
               &VERSION=0               VERSION IDENTIFICATION          31185000
         LCLA  &I,&J,&L,&X,&Y,&Z                               @AZ13738 31186000
         LCLB  &A(25),&B(25),&C(25),&D(25),&F,&N               @AZ13738 31187000
         LCLC  &K,&S                                           @AZ13738 31188000
.* GENERATES THE CODE IN IFOX0J WHICH CONTAINS THE BIT STRINGS          31189000
.* REPRESENTING OPTIONS IN EFFECT                                       31190000
&X       SETA  55                                 LINECNT=60            31191000
&Z       SETA  X'200000'                DEFAULT ASMSIZE=2M     @AZ13738 31192000
&B(1)    SETB  1                                                        31193000
&B(2)    SETB  1                                                        31194000
&B(3)    SETB  1                                                        31195000
&B(4)    SETB  1                                                        31196000
&B(5)    SETB  1                                                        31197000
&B(6)    SETB  1                                                        31198000
&B(7)    SETB  1                                                        31199000
&B(8)    SETB  1                                                        31200000
&B(9)    SETB  1                                                        31201000
&B(10)   SETB  1                                                        31202000
&B(11)   SETB  1                                                        31203000
&B(12)   SETB  1                                                        31204000
&B(13)   SETB  1                                                        31205000
&B(14)   SETB  1                                                        31206000
&B(15)   SETB  1                                                        31207000
&B(16)   SETB  1                                                        31208000
&B(17)   SETB  1                                                        31209000
&B(18)   SETB  1                                                        31210000
&B(19)   SETB  1                                                        31211000
&B(20)   SETB  1                                                        31212000
&B(21)   SETB  1                                                        31213000
&B(22)   SETB  1                                                        31214000
&B(23)   SETB  1                                                        31215000
&B(24)   SETB  1                                                        31216000
&B(25)   SETB  1                                                        31217000
&D(1)    SETB  1                                  LIST                  31218000
&D(2)    SETB  1                                  XREF                  31219000
&D(3)    SETB  1                                  ESD                   31220000
&D(4)    SETB  1                                  RLD                   31221000
&D(6)    SETB  1                                  LOAD         FX0000   31222000
&D(8)    SETB  1                                  STAT                  31223000
&D(10)   SETB  1                                  ALGN                  31224000
&D(12)   SETB  1                                  ALOGIC                31225000
&D(18)   SETB  1                        STMT                            31226000
&D(19)   SETB  1                                                        31227000
&D(20)   SETB  1                   XREF(SHORT)                          31228000
&D(25)   SETB  1                        YFLAG                           31229000
.P1      ANOP                                                           31230000
&I       SETA  &I+1                               INCREMENT INDEX       31231000
         AIF   (&I GT N'&FIXED).D1                FINIS                 31232000
         AIF   (K'&FIXED(&I) EQ 0).P1             NULL SUB PARAMETER    31233000
         AIF   (K'&FIXED(&I) GT 2).E4             INVALID SUB PARAMETER 31234000
.E5      MNOTE 4,'* * * INVALID OPERAND -- &FIXED(&I)'                  31235000
         AGO   .P1                                                      31236000
.E4      AIF   ('&FIXED(&I)'(1,2) NE 'NO').P2     PREFIX 'NO'           31237000
&N       SETB  1                                  PREFIX 'NO'           31238000
&K       SETC  '&FIXED(&I)'(3,K'&FIXED(&I)-2)     KEYWORD               31239000
         AGO   .P3                                SKIP                  31240000
.P2      AIF   (K'&FIXED(&I) GT 8).X1             KEYWORD               31241000
&N       SETB  0                                  NO PREFIX 'NO'        31242000
&K       SETC  '&FIXED(&I)'                       KEYWORD               31243000
.P3      ANOP                                                           31244000
&J       SETA  1                                  'LIST'                31245000
         AIF   ('&K' EQ 'LIST').S1                LIST/NOLIST           31246000
&J       SETA  2                                  'XREF'                31247000
         AIF   ('&K' EQ 'XREF').S1                XREF/NOXREF           31248000
&J       SETA  3                                  'ESD'                 31249000
         AIF   ('&K' EQ 'ESD').S1                 ESD/NOESD             31250000
&J       SETA  4                                  'RLD'                 31251000
         AIF   ('&K' EQ 'RLD').S1                 RLD/NORLD             31252000
&J       SETA  5                                  'DECK'                31253000
         AIF   ('&K' EQ 'DECK').S1                DECK/NODECK           31254000
&J       SETA  6                                  'LOAD'                31255000
         AIF   ('&K' EQ 'LOAD').S1                LOAD/NOLOAD           31256000
&J       SETA  7                                  'TEST'                31257000
         AIF   ('&K' EQ 'TEST').S1                TEST/NOTEST           31258000
&J       SETA  8                                  'STAT'                31259000
         AIF   ('&K' EQ 'STAT').S1                STAT/NOSTAT           31260000
&J       SETA  9                                  'RENT'                31261000
         AIF   ('&K' EQ 'RENT').S1                RENT/NORENT           31262000
&J       SETA  10                                 'ALGN'                31263000
         AIF   ('&K' EQ 'ALGN').S1                ALGN/NOALGN           31264000
&J       SETA  11                                 'SYSMAC'              31265000
         AIF   ('&K' EQ 'SYSMAC').S1              SYSMAC/NOSYSMAC       31266000
&J       SETA  12                                 'ALOGIC'              31267000
         AIF   ('&K' EQ 'ALOGIC').S1              ALOGIC/NOALOGIC       31268000
&J       SETA  13                                 'MLOGIC'              31269000
         AIF   ('&K' EQ 'MLOGIC').S1              MLOGIC/NOMLOGIC       31270000
&J       SETA  14                                 'CALLS'               31271000
         AIF   ('&K' EQ 'CALLS').S1               CALLS/NOCALLS         31272000
&J       SETA  18                                 'TERM'                31273000
         AIF   ('&K' EQ 'TERM').S1                TERM/NOTERM           31274000
&J       SETA  19                                 'STMT'                31275000
         AIF   ('&K' EQ 'STMT').S1                STMT/NOSTMT           31276000
&J       SETA  20                                 'NUM'                 31277000
         AIF   ('&K' EQ 'NUM').S1                 NUM/NONUM             31278000
&J       SETA  25                       'YFLAG'                @AZ13738 31279000
         AIF   ('&K' EQ 'YFLAG').S1     YFLAG/NOYFLAG          @AZ13738 31280000
         AIF   (NOT &F).E5                        INVALID KEYWORD       31281000
         AGO   .E7                                                      31282000
.S1      AIF   (&F).S2                                                  31283000
         AIF   (NOT &A(&J)).S4                                          31284000
.ED      MNOTE 4,'* * * INCOMPATIBLE OPTION -- &FIXED(&I)'              31285000
         AGO   .P1                                                      31286000
.S4      ANOP                                                           31287000
&A(&J)   SETB  1                                                        31288000
&B(&J)   SETB  (NOT &N)                                                 31289000
&C(&J)   SETB  (NOT &N)                                                 31290000
&D(&J)   SETB  (NOT &N)                                                 31291000
         AGO   .P1                                                      31292000
.S2      AIF   (NOT &A(&J)).S3                                          31293000
.EC      MNOTE 4,'* * * INCOMPATIBLE OPTION -- &DEFAULT(&L)'            31294000
         AGO   .D1                                                      31295000
.S3      ANOP                                                           31296000
&A(&J)   SETB  1                                                        31297000
&D(&J)   SETB  (NOT &N)                           DEFAULT OPTION        31298000
.D1      ANOP                                                           31299000
&F       SETB  1                                  DEFAULT SCAN          31300000
&L       SETA  &L+1                               INCREMENT INDEX       31301000
         AIF   (&L GT N'&DEFAULT).G1              END OF SCAN           31302000
         AIF   (K'&DEFAULT(&L) EQ 0).D1           NULL SUB OPERAND      31303000
         AIF   (K'&DEFAULT(&L) GT 2).E6           INVALID SUB PARAMETER 31304000
.E7      MNOTE 4,'* * * INVALID OPERAND -- &DEFAULT(&L)'                31305000
         AGO   .D1                                                      31306000
.E6      AIF   ('&DEFAULT(&L)'(1,2) NE 'NO').D2   PREFIX 'NO'           31307000
&N       SETB  1                                  PREFIX 'NO'           31308000
&K       SETC  '&DEFAULT(&L)'(3,K'&DEFAULT(&L)-2) KEYWORD               31309000
         AGO   .P3                                                      31310000
.D2      AIF   (K'&DEFAULT(&L) GT 8).K1           KEYWORD               31311000
&N       SETB  0                                  NO PREFIX             31312000
&K       SETC  '&DEFAULT(&L)'                     KEYWORD               31313000
         AGO   .P3                                                      31314000
.K1      AIF   ('&DEFAULT(&L)'(1,8) NE 'LINECNT=').K11                  31315000
&K       SETC  '&DEFAULT(&L)'(9,K'&DEFAULT(&L)-8) VALUE                 31316000
         AGO   .Y1                                                      31317000
.K11     AIF  ('&DEFAULT(&L)'(1,9) NE 'WORKSIZE=').K2          @AZ13738 31318000
&S       SETC  '&DEFAULT(&L)'(10,K'&DEFAULT(&L)-9) VALUE       @AZ13738 31319000
         AGO   .SIZE                                           @AZ13738 31320000
.K2      AIF   ('&DEFAULT(&L)'(1,9) NE 'MSGLEVEL=').E7                  31321000
&K       SETC  '&DEFAULT(&L)'(10,K'&DEFAULT(&L)-9)                      31322000
         AGO   .Z1                                                      31323000
.X1      AIF   ('&FIXED(&I)'(1,8) NE 'LINECNT=').X11           @AZ13738 31324000
&K       SETC  '&FIXED(&I)'(9,K'&FIXED(&I)-8)     VALUE                 31325000
         AGO   .Y1                                                      31326000
.X11     AIF   ('&FIXED(&I)'(1,9) NE 'WORKSIZE=').X2           @AZ13738 31327000
&S       SETC  '&FIXED(&I)'(10,K'&FIXED(&I)-9) VALUE           @AZ13738 31328000
         AGO   .SIZE                                           @AZ13738 31329000
.X2      AIF   ('&FIXED(&I)'(1,9) NE 'MSGLEVEL=').E5                    31330000
&K       SETC  '&FIXED(&I)'(10,K'&FIXED(&I)-9)    VALUE                 31331000
.Z1      ANOP                                                           31332000
&Y       SETA  &K                                 VALUE                 31333000
         AIF   (&Y LT 256).EF                                           31334000
         MNOTE 4,'* * * INVALID VALUE -- &Y'                            31335000
&Y       SETA  0                                                        31336000
         AIF   (&F).D1                                                  31337000
         AGO   .P1                                                      31338000
.EF      AIF   (&A(24) AND &F).EC                                       31339000
         AIF   (&A(24)).ED                                              31340000
&A(24)   SETB  1                                                        31341000
         AIF   (&F).D1                                                  31342000
&D(24)   SETB  1                                                        31343000
         AGO   .P1                                                      31344000
.Y1      ANOP                                                           31345000
&X       SETA  &K-5                               VALUE                 31346000
         AIF   (&X GT 0 AND &X LT 32768).EA       INVALID VALUE         31347000
.EB      MNOTE 4,'* * * INVALID VALUE -- &X'                            31348000
&X       SETA  60                                                       31349000
         AIF   (&F).D1                                                  31350000
         AGO   .P1                                                      31351000
.EA      AIF   (&A(23) AND &F).EC                 REDUNDANT             31352000
         AIF   (&A(23)).ED                                              31353000
&A(23)   SETB  1                                  INDICATE USED         31354000
         AIF   (&F).D1                                                  31355000
&D(23)   SETB  1                                  FIXED                 31356000
         AGO   .P1                                                      31357000
.SIZE    ANOP                                                  @AZ13738 31358000
&Z       SETA  &S                                              @AZ13738 31359000
         AIF   (&Z GT X'8000' AND &Z LT X'A00000').SIZE1       @AZ13738 31360000
         MNOTE 4,'* * * INVALID VALUE -- &Z'                   @AZ13738 31361000
&Z       SETA  X'200000'                                       @AZ13738 31362000
.SIZE1   AIF   (&F).D1                                         @AZ13738 31363000
         AGO   .P1                                             @AZ13738 31364000
.G1      ANOP                                                           31365000
IFOX0J00 CSECT                                                          31366000
         DC    AL1(&VERSION,&Y),H'&X'               , MSGLEVEL, LINECNT 31367000
         DC    B'&D(1)&D(2)&D(3)&D(4)&D(5)&D(6)&D(7)&D(8)&D(9)&D(10)&D(X31368000
               11)&D(12)&D(13)&D(14)&D(15)&D(16)&D(17)&D(18)&D(19)&D(20X31369000
               )&D(21)&D(22)&D(23)&D(24)&D(25)0000000' DEFAULT @OX09734 31370000
         DC    B'&C(1)&C(2)&C(3)&C(4)&C(5)&C(6)&C(7)&C(8)&C(9)&C(10)&C(X31371000
               11)&C(12)&C(13)&C(14)&C(15)&C(16)&C(17)&C(18)&C(19)&C(20X31372000
               )&C(21)&C(22)&C(23)&C(24)&C(25)0000000'   FIXED TO ON    31373000
         DC    B'&B(1)&B(2)&B(3)&B(4)&B(5)&B(6)&B(7)&B(8)&B(9)&B(10)&B(X31374000
               11)&B(12)&B(13)&B(14)&B(15)&B(16)&B(17)&B(18)&B(19)&B(20X31375000
               )&B(21)&B(22)&B(23)&B(24)&B(25)1111111'   FIXED TO OFF   31376000
         DC    F'&Z'                                           @AZ13738 31377000
         MEND                                                           31378000
./ ADD NAME=JPATCH                                                      31379000
         MACRO                                                          31380000
&N       JPATCH &MOD,&MODLEN,&AREA,&K1=21,&K2=20                        31381000
         GBLA  &PI                                                      31382000
         GBLC  &COMPNM,&ASMID                                           31383000
         LCLA  &A                                                       31384000
         LCLC  &NAME,&L1,&L3,&L4,&L5                                    31385000
.P2      PUSH  PRINT                                                    31386000
&NAME    SETC  '&COMPNM&MOD'                                            31387000
         PRINT GEN,DATA                                                 31388000
.*THE PATCH AREA IS INITIALIZED TO 5% OF THE ORIGINAL CSECT.  BY        31389000
.*EVOKING THE "PATCH" MACRO, SUBSEQUENT ADDITIONS TO THE MODULE WILL    31390000
.*"SHRINK" THE ORIGINAL 5%-PATCH AREA VIA THE DYNAMIC ASSIGNMENT OF A   31391000
.*NEW LESS-THAN-5%-PATCH AREA.  AT LEAST A 5%-PATCH AREA WILL BE        31392000
.*DYNAMICALLY MAINTAINED FOR DELETIONS TO THE MODULE.                   31393000
&NAME    CSECT                                                          31394000
         LTORG                                                          31395000
         PRINT GEN,NODATA                                               31396000
         AIF   (T'&AREA EQ 'O').NOAREA                                  31397000
&A       SETA  &AREA                                                    31398000
.NOAREA  AIF   (&PI NE 0).DS2                                           31399000
PATCHDC  DC    C'&NAME &SYSTIME &SYSDATE'                               31400000
ABSOLEN  EQU   X'&MODLEN'-&A+L'PATCHDC  CALCULATE ACTUAL MODULE LENGTH  31401000
PTCHLEN  EQU   &NAME+ABSOLEN*&K1/&K2-*        LENGTH OF PATCH AREA      31402000
PATCH    DC    ((PTCHLEN+1)/PTCHLEN*PTCHLEN)C' '    DYNAMIC PATCH AREA  31403000
         AGO   .EXIT                                                    31404000
.DS2     ANOP                                                           31405000
&L4      SETC  'PATCHDC&PI'                                             31406000
&L5      SETC  'L'''.'PATCHDC&PI'                                       31407000
&L4      DC    C'&NAME &SYSTIME &SYSDATE'                               31408000
&L1      SETC  'ABSOLEN&PI'                                             31409000
&L3      SETC  'PTCHLEN&PI'                                             31410000
&L1      EQU  X'&MODLEN'-&A+&L5         CALCULATE ACTUAL MODULE LENGTH  31411000
&L3      EQU   &NAME+&L1*&K1/&K2-*            LENGTH OF PATCH AREA      31412000
PATCH&PI DC    ((&L3+1)/&L3*&L3)C' '                DYNAMIC PATCH AREA  31413000
.EXIT    POP   PRINT                                                    31414000
&PI      SETA  &PI+1                    FOR UNIQUE LABELS               31415000
         MEND                                                           31416000
./ ADD NAME=JPOINT                                                      31417000
         MACRO                                                          31418000
&NAME    JPOINT &FILE=,&ADDR=,&NEXT=                                    31419000
         LCLC  &XXX                                                     31420000
         LCLA  &I                                                       31421000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO POSITION        31422000
.*       THE FILE TO A SPECIFIED POSITION                               31423000
         AIF   (K'&NEXT LT 4).IN1                                       31424000
&I       SETA  4                                                        31425000
         AGO   .IN2                                                     31426000
.IN1     ANOP                                                           31427000
&I       SETA  K'&NEXT                                                  31428000
.IN2     ANOP                                                           31429000
         AIF   (K'&FILE EQ 0 OR K'&ADDR EQ 0 AND                       X31430000
               '&NEXT' NE 'START').ERR1                                 31431000
         AIF   ('&NEXT' NE 'READ' AND '&NEXT' NE 'WRITE' AND           X31432000
               '&NEXT' NE 'GET' AND '&NEXT' NE 'PUT' AND               X31433000
               '&NEXT' NE 'START').ERR1                                 31434000
&XXX     SETC  '&NEXT'(1,&I)                                            31435000
&NAME    SET   JPT4&XXX,ON                                              31436000
         JINST LA,R10,&FILE,FILE                                        31437000
         AIF   ('&NEXT' EQ 'START').NXA                                 31438000
         JINST LA,R11,&ADDR                                             31439000
.NXA     L     R12,JMLC                 LOAD BASE                       31440000
         BAL   R9,JPOINT(,R12)          GO TO JPOINT                    31441000
         MEXIT                                                          31442000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31443000
         MEND                                                           31444000
./ ADD NAME=JPOINTLB                                                    31445000
         MACRO                                                          31446000
&NAME    JPOINTLB &ADDR=                                                31447000
.*       GENERATES A CALL TO THE INPUT I/O MODULE TO POSITION           31448000
.*       THE LIBRARY FILE TO GET THE RECORD AFTER THE ONE NOTED.        31449000
         AIF   (K'&ADDR EQ 0).ERR1                                      31450000
&NAME    JINST LA,R10,&ADDR                                             31451000
         L     R12,JINMLC               LOAD BASE                       31452000
         BAL   R9,JPOINTLB(,R12)        GO TO JPOINTLB                  31453000
         MEXIT                                                          31454000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31455000
         MEND                                                           31456000
./ ADD NAME=JPRINT                                                      31457000
         MACRO                                                          31458000
&NAME    JPRINT                                                         31459000
.*       GENERATES A CALL TO THE OUTPUT I/O MODULE TO PRINT A LINE      31460000
.*       ON SYSPRINT AND GET THE ADDRESS OF THE NEXT BUFFER BACK.       31461000
&NAME    L     R12,JOUTMLC              LOAD BASE                       31462000
         BAL   R9,JPRINT(,R12)          GO TO JPRINT                    31463000
         MEND                                                           31464000
./ ADD NAME=JPUNCH                                                      31465000
         MACRO                                                          31466000
&NAME    JPUNCH &SEQ=YES                                                31467000
.*       GENERATES A CALL TO THE OUTPUT I/O MODULE TO OUTPUT            31468000
.*       A 80-BYTE RECORD ON SYSPUNCH AND SYSGO AND GET THE ADDRESS     31469000
.*       OF THE NEXT BUFFER BACK.                                       31470000
         AIF   ('&SEQ' EQ 'YES').NXA                                    31471000
&NAME    SET   JNOSEQPH,ON                                              31472000
         L     R12,JOUTMLC              LOAD BASE                       31473000
         AGO   .NXB                                                     31474000
.NXA     ANOP                                                           31475000
&NAME    L     R12,JOUTMLC              LOAD BASE                       31476000
.NXB     BAL   R9,JPUNCH(,R12)          GO TO JPUNCH                    31477000
         MEND                                                           31478000
./ ADD NAME=JPUTL                                                       31479000
         MACRO                                                          31480000
&NAME    JPUTL &FILE=,&BUFREQ=                                          31481000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO GET THE ADDRESS 31482000
.*       OF THE NEXT RECORD IN THE BUFFER. WHEN END OF BUFFER           31483000
.*       IS REACHED THE WHOLE BUFFER IS PUT ON FILE.                    31484000
         AIF   (K'&FILE EQ 0 OR K'&BUFREQ EQ 0).ERR1                    31485000
&NAME    JINST LA,R10,&FILE,FILE                                        31486000
         JINST LA,R11,&BUFREQ                                           31487000
         L     R12,JMLC                 LOAD BASE                       31488000
         BAL   R9,JPUTL(,R12)           GO TO JPUTL                     31489000
         MEXIT                                                          31490000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31491000
         MEND                                                           31492000
./ ADD NAME=JPUTM                                                       31493000
         MACRO                                                          31494000
&NAME    JPUTM &FILE=,&ADDR=                                            31495000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO COPY A RECORD   31496000
.*       INTO THE OUTPUT BUFFER.                                        31497000
         AIF   (K'&FILE EQ 0 OR K'&ADDR EQ 0).ERR1                      31498000
&NAME    JINST LA,R10,&FILE,FILE                                        31499000
         JINST LA,R11,&ADDR                                             31500000
         L     R12,JMLC                 LOAD BASE                       31501000
         BAL   R9,JPUTM(,R12)           GO TO JPUTL                     31502000
         MEXIT                                                          31503000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31504000
         MEND                                                           31505000
./ ADD NAME=JREAD                                                       31506000
         MACRO                                                          31507000
&NAME    JREAD &FILE=,&PARM=                                            31508000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO READ            31509000
.*       A PHYSICAL RECORD. A JCHECK MACRO CALL MUST BE ISSUED          31510000
.*       BEFORE ANY ADDITIONAL OPERATIONS TO THE WORKFILE ARE DONE.     31511000
         AIF   (K'&FILE EQ 0 OR K'&PARM EQ 0).ERR1                      31512000
&NAME    JINST LA,R10,&FILE,FILE                                        31513000
         JINST LA,R11,&PARM                                             31514000
         L     R12,JMLC                 LOAD BASE                       31515000
         BAL   R9,JREAD(,R12)           GO TO JREAD                     31516000
         MEXIT                                                          31517000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31518000
         MEND                                                           31519000
./ ADD NAME=JRELSE                                                      31520000
         MACRO                                                          31521000
&NAME    JRELSE &FILE=                                                  31522000
.*       GENERATES A CALL TO THE WORKFILE I/O MODULE TO RELEASE         31523000
.*       AN INPUT BUFFER. THE NEXT JGETL MACRO INTRUCTION RETRIEVES     31524000
.*       THE FIRST RECORD IN THE NEXT INPUT BUFFER.                     31525000
         AIF   (K'&FILE EQ 0).ERR1                                      31526000
&NAME    JINST LA,R10,&FILE,FILE                                        31527000
         L     R12,JMLC                 LOAD BASE                       31528000
         BAL   R9,JRELSE(,R12)          GO TO JRELSE                    31529000
         MEXIT                                                          31530000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31531000
         MEND                                                           31532000
./ ADD NAME=JRETURN                                                     31533000
         MACRO                                                          31534000
&NAME    JRETURN                                                        31535000
.*       RESTORES THE REGISTERS OF THE CALLING PROGRAM FROM A PUSH      31536000
.*       DOWN SAVE AREA (R2 THRU R9) AND THEN RETUTNS TO THE CALLER     31537000
.*       VIA R9. REQUIRES A NAME FIELD.                                 31538000
         AIF   (K'&NAME EQ 0).ERR1                                      31539000
&NAME    LM    R8,R9,JCLVLPTR           GET CURRENT LVL & DECR          31540000
         BXLE  R8,R9,0                  DECREMENT LEVEL POINTER         31541000
         ST    R8,JCLVLPTR              SAVE NEW LEVEL POINTER          31542000
         LM    R2,R9,JSAVESZ(R8)        RESTORE REGISTERS R2 THRU R9    31543000
         BR    R9                       RETURN TO CALLING PROGRAM       31544000
         MEXIT                                                          31545000
.ERR1    MNOTE 8,'OMITTED NAME.'                                        31546000
         MEND                                                           31547000
./ ADD NAME=JSAVE                                                       31548000
         MACRO                                                          31549000
&NAME    JSAVE &BASE=YES                                                31550000
.*       SAVES THE REGISTERS OF THE CALLING PROGRAM INTO A PUSH DOWN    31551000
.*       SAVE AREA (R2 THRU R9). UNLESS OVERRIDDEN THE MACRO WILL LOAD  31552000
.*       THE BASE REGISTER R8, FROM R12 AND GIVE A USING STATEMENT.     31553000
         AIF   (K'&NAME EQ 0).ERR1                                      31554000
         AIF   ('&BASE' EQ 'NO').NXA                                    31555000
         USING &NAME,R8                 SET USING FOR SUBR BASE         31556000
.NXA     ANOP                                                           31557000
&NAME    L     R15,JCLVLPTR             POINT TO CURRENT LEVEL          31558000
         LA    R15,JSAVESZ(,R15)        INCREMENT LEVEL POINTER         31559000
         ST    R15,JCLVLPTR             STORE NEW LEVEL POINTER         31560000
         STM   R2,R9,0(R15)             SAVE R2 THRU R9                 31561000
         AIF   ('&BASE' EQ 'NO').NXB                                    31562000
         LR    R8,R12                   ESTABLISH SUBR BASE             31563000
.NXB     MEXIT                                                          31564000
.ERR1    MNOTE 8,'OMITTED NAME.'                                        31565000
         MEND                                                           31566000
./ ADD NAME=JTEXT                                                       31567000
*COPY JTEXT                                                             31568000
JTEXT    DSECT  ,                       TEXT RECORD DSECT               31569000
JTRLI    DS    1H                       RECORD LENGTH INDICATOR         31570000
         SPACE                                                          31571000
*        FLAGA                OP CODE DEPENDENT FLAGS                   31572000
         SPACE                                                          31573000
JTFLGA   DSW   JPSOP,                   PSEUDO-OP FLAG                 X31574000
               JEXTB,                   EXTENDED OPCODE FLAG           X31575000
               JINPC,                   INITIALIZE PRIVATE CODE        X31576000
               JINHB,                   INHIBIT BIT                    X31577000
               JDEF,                    DEFINITION RECORD              X31578000
               JREF,                    SCAN FOR SYMBOL REFERENCES     X31579000
               JREQOP,                  OPERAND REQUIRED FOR INTERLUDE X31580000
               JDCSX                    ON FOR DC, DS, AND DXD ONLY     31581000
         ORG   JTFLGA                   OVERLAY                         31582000
JTFLGA1  DSW   ,,,,,                    DECLARED ABOVE                 X31583000
               JPRESD,                  ON FOR PRE-ESD PUNCH & REPRO   X31584000
               JLN4,                    INSTRUCTION LENGTH BIT 1       X31585000
               JLN2                     INSTRUCTION LENGTH BIT 2        31586000
         SPACE                                                          31587000
*        FLAGB                DYNAMIC FLAGS                             31588000
         SPACE                                                          31589000
JTFLGB   DSW   JPRONLY,                 PRINT ONLY                     X31590000
               JERR,                    DEAD STATEMENT                 X31591000
               JNOCNT,                  DO NOT ASSIGN STATEMENT NUMBER X31592000
               JGEN,                    STATEMENT IS GENERATED         X31593000
               JNMERR,                  INVALID NAME FIELD             X31594000
               JSUBNAME,                SUBSTITUTION REQUIRED-NAME     X31595000
               JSUBOPCD,                SUBSTITUTION REQUIRED-OP CODE  X31596000
               JSUBOPND                 SUBSTITUTION REQUIRED-OPERAND   31597000
JTIOP    DS    0H                                                       31598000
JTIOP1   DBV   ,                        INTERNAL OP CODES 1ST BYTE     X31599000
               JTICTL(0),                    ICTL                      X31600000
               JTISEQ(JTICTL+1),             ISEQ                      X31601000
               JTOPSYN(JTISEQ+1),            OPSYN                     X31602000
               JTCOPY(JTOPSYN+1),            COPY                      X31603000
               JTANOP(JTCOPY+1),             ANOP                      X31604000
               JTGBLA(JTANOP+1),             GBLA                      X31605000
               JTGBLB(JTGBLA+1),             GBLB                      X31606000
               JTGBLC(JTGBLB+1),             GBLC                      X31607000
               JTLCLA(JTGBLC+1),             LCLA                      X31608000
               JTLCLB(JTLCLA+1),             LCLB                      X31609000
               JTLCLC(JTLCLB+1),             LCLC                      X31610000
               JTMACRO(JTLCLC+1),            MACRO                     X31611000
               LOGENOP(JTMACRO),   LOWEST GENERATOR OP                 X31612000
               JTACTR(JTMACRO+1),            ACTR                      X31613000
               JTAGO(JTACTR+1),              AGO                       X31614000
               JTAGOB(JTAGO),                AGOB  SAME AS AGO         X31615000
               JTAIF(JTAGO+1),               AIF                       X31616000
               JTAIFB(JTAIF),                AIFB  SAME AS AIF         X31617000
               JTSETA(JTAIF+1),              SETA                      X31618000
               JTSETB(JTSETA+1),             SETB                      X31619000
               JTSETC(JTSETB+1),             SETC                      X31620000
               JTMEXIT(JTSETC+1),       MEXIT                          X31621000
               JTMEND(JTMEXIT+1),            MEND                      X31622000
               JTCALL(JTMEND+1),        MACRO CALL                     X31623000
               JTCPKEY(JTCALL+1),            CALL PARAMETER--KEYWORD   X31624000
               JTCPPOS(JTCPKEY+1),           CALL PARAMETER--POSITIONALX31625000
               JTPROTO(JTCPPOS+1),      PROTOTYPE                      X31626000
               JTPREP(JTPROTO),              MODIFIED REPRO RECORD     X31627000
               JTPPKEY(JTPROTO+1),           PROTOTYPE PARM--KEYWORD   X31628000
               JTPPCH(JTPPKEY),              MODIFIED PUNCH RECORD     X31629000
               JTPPPOS(JTPPKEY+1),           PROTOTYPE PARM--POSITIONALX31630000
               JTINPC(JTPPPOS),              UNINITIATED PRIVATE CODE  X31631000
               JTPEND(JTPPPOS+1),       END OF PARMS--PROTO OR MACRO   X31632000
               JTPMOP(JTPEND),               PETE'S MACHINE OP         X31633000
               JTEND(JTPEND+1),              END                       X31634000
               HIGENOP(JTEND),          HI GENERATOR OP                X31635000
               LOREFOP(JTEND),          LO SYMBOL REFERENCE OP         X31636000
               LODEFOP(JTEND),          LO SYMBOL DEFINITION OP        X31637000
               JTDXD(JTEND+1),               DXD                       X31638000
               JTEQU(JTDXD+1),               EQU                       X31639000
               JTORG(JTEQU+1),               ORG                       X31640000
               JTCNOP(JTORG+1),              CNOP                      X31641000
               JTCCW(JTCNOP+1),              CCW                       X31642000
               JTDC(JTCCW+1),                DC                        X31643000
               JTDS(JTDC+1),                 DS                        X31644000
               JTSTART(JTDS+1),              START                     X31645000
               HIREFOP(JTSTART),        HI SYMBOL REFERENCE OP         X31646000
               JTCSECT(JTSTART+1),           CSECT                     X31647000
               JTDSECT(JTCSECT+1),           DSECT                     X31648000
               JTCOM(JTDSECT+1),             COM                       X31649000
               JTENTRY(JTCOM+1),             ENTRY                     X31650000
               JTLTLC(JTENTRY),         CSECT FOR LITERAL POOL         X31651000
               JTEXTRN(JTENTRY+1),           EXTRN                     X31652000
               JTLTDC(JTEXTRN),         LITERAL DC                     X31653000
               JTWXTRN(JTEXTRN+1),           WXTRN                     X31654000
               JTLTND(JTWXTRN),         LITERAL POOL END               X31655000
               JTCXD(JTWXTRN+1),             CXD                       X31656000
               JTLTORG(JTCXD+1),             LTORG                     X31657000
               HIDEFOP(JTLTORG),        HI SYMBOL DEFINITION OP        X31658000
               JTLITR(JTLTORG+1),            LITERAL DEFINITIONS       X31659000
               JTSYMBL(JTLITR+1),            SYMBOL REFERENCE          X31660000
               JTPUNCH(JTSYMBL+1),           PUNCH                     X31661000
               JTEOFII(JTPUNCH),             ESD ADJUSTMENT RECORD     X31662000
               JTREPRO(JTPUNCH+1),           REPRO                     X31663000
               JTLITII(JTREPRO),             LITERAL ADJUSTMENT RECORD X31664000
               JTPUSH(JTREPRO+1),            PUSH                      X31665000
               JTLTEND(JTPUSH),              END-OF-LITERAL-POOL       X31666000
               JTPOP(JTPUSH+1),              POP                       X31667000
               JTADJII(JTPOP),               PETE'S END-OF-FILE        X31668000
               JTPRINT(JTPOP+1),             PRINT                     X31669000
               JTPASS(JTPRINT),              NO PROCESS RECORD         X31670000
               JTUSING(JTPRINT+1),           USING                     X31671000
               JTSYMII(JTUSING),             SYMBOL TABLE ENTRY        X31672000
               JTDROP(JTUSING+1),            DROP                      X31673000
               JTCMNT(JTDROP+1),             COMMENT CARD              X31674000
               JTHCMNT(JTCMNT+1),       HIDDEN COMMENT                 X31675000
               JTERROR(JTHCMNT+1),      ERROR                          X31676000
               JTSPACE(JTERROR+1),           SPACE                     X31677000
               LONOPRN(JTSPACE),        LO NO-PRINT OP                 X31678000
               JTEJECT(JTSPACE+1),           EJECT                     X31679000
               JTTITLE(JTEJECT+1),           TITLE                     X31680000
               JTMNOTE(JTTITLE+1),           MNOTE                     X31681000
               JTSICTL(JTMNOTE+1),           INTERNAL ICTL ONLY        X31682000
               JTEEOF(X'FE'),                EARLY END OF TEXT FILE    X31683000
               JTEOF(X'FF')                  END OF TEXT FILE           31684000
JTIOP2   DBV   ,                        SECOND BYTE OF OP-CODE          31685000
JTNMP    DS    1H                       NAME FIELD POINTER              31686000
JTOCP    DS    1H                       OPCODE POINTER IN TEXT RECORD   31687000
JTOPP    DS    1H                       OPERAND POINTER IN TEXT RECORD  31688000
JTCPR    DS    1H                       COMMENTS POINTER IN TEXT        31689000
JTSPR    DS    1H                       STRING POINTER IN TEXT          31690000
JTSYMCNT DS    1C                       NUMBER OF SYMBOLS IN OPERAND    31691000
JTFLGC   DSW   JPRGMAC,                 PROGRAMMER MACRO               X31692000
               JPRGICTL                 STANDARD ICTL                   31693000
         SPACE                                                          31694000
JTHDREND EQU   *                        END OF TEXT HEADER              31695000
JTHDRLN  EQU   JTHDREND-JTEXT           TEXT HEADER LENGTH              31696000
         SPACE 3                                                        31697000
JTEXTA   DSECT  ,                       DSECT FOR VARIABLE TEXT PORTION 31698000
         SPACE                                                          31699000
*        NAME FIELD IN VARIABLE TEXT                                    31700000
         SPACE                                                          31701000
JTNMO    DSW   JTNMOCD,            NAME CARD POINTER--REAL PTR FOLLOWS X31702000
               ,                        NOT USED                       X31703000
               ,                        NOT USED                       X31704000
               ,                        NOT USED                       X31705000
               ,                        NOT USED                       X31706000
               ,                        NOT USED                       X31707000
               ,                        NOT USED                       X31708000
                                        NOT USED                        31709000
JTNML    DS    1C                       NAME LENGTH                     31710000
JTNAME   EQU   *                        NAME                            31711000
         SPACE                                                          31712000
         ORG   JTNMO                    RESET LOCATION COUNTER          31713000
*                                  OPCODE POINTER IN TEXT RECORD        31714000
         SPACE                                                          31715000
JTOCO    DSW   JTOCOCD,       OP-CODE CARD POINTER--REAL JTOCO FOLLOWS X31716000
               ,                        NOT USED                       X31717000
               ,                        NOT USED                       X31718000
               ,                        NOT USED                       X31719000
               ,                        NOT USED                       X31720000
               ,                        NOT USED                       X31721000
               ,                        NOT USED                       X31722000
                                        NOT USED                        31723000
         SPACE                                                          31724000
JTOCL    DS    1C                       OP CODE LENGTH                  31725000
JTOPCD   EQU   *                        OP CODE                         31726000
         ORG   JTOCO                    RE-ORG AFTER VARIABLE TEXT      31727000
JTOPO    DSW   JTOPOCD,       OPND CARD POINTER--REAL JTOPO FOLLOWS    X31728000
               ,                        NOT USED                       X31729000
               ,                        NOT USED                       X31730000
               ,                        NOT USED                       X31731000
               ,                        NOT USED                       X31732000
               ,                        NOT USED                       X31733000
               ,                        NOT USED                       X31734000
                                        NOT USED                        31735000
JTOPL    DS    1C                       OPERAND LENGTH                  31736000
JTOPND   EQU   *                        OPERAND                         31737000
         ORG   JTOCO                    RE-ORG AFTER VARIABLE TEXT      31738000
JTCOP    DS    1C                       COMMENT OUTPUT POINTER          31739000
JTCML    DS    1C                       COMMENT LENGTH                  31740000
JTCMM    EQU   *                        COMMENT                         31741000
         ORG   JTOCO                    RE-ORG AFTER VARIABLE TEXT      31742000
JTSTC    DS    1C                       STRING COUNT                    31743000
JTSTO    DS    1C                       STRING 1 OUTPUT COLUMN POINTER  31744000
JTSTL    DS    1C                       STRING 1 LENGTH                 31745000
JTSTR    EQU   *                        STRING 1                        31746000
         ORG   JTOCO                    RE-ORG AFTER VARIABLE TEXT      31747000
JTSTO2   DS    1C                       STRING 2 OUTPUT COLUMN POINTER  31748000
JTSTL2   DS    1C                       STRING 2 LENGTH                 31749000
JTSTR2   EQU   *                        STRING 2                        31750000
./ ADD NAME=JTMTXT                                                      31751000
*COPY JTMTXT                                                            31752000
JTMTXT   DSECT                                                          31753000
         SPACE                                                          31754000
*        CONDITIONAL ASSEMBLY OPERATORS                                 31755000
         SPACE                                                          31756000
JTMOP    DBV   JTMSCM(0),               START CHARACTER MODE           X31757000
               JTMECM(JTMSCM+1),        END CHARACTER MODE             X31758000
               JTMCOM(JTMECM+1),        COMMA                          X31759000
               JTMPER(JTMCOM+1),        PERIOD                         X31760000
               JTMLPAR(JTMPER+1),       LEFT PAREN                     X31761000
               JTMRPAR(JTMLPAR+1),      RIGHT PAREN                    X31762000
               JTMPLUS(JTMRPAR+1),      PREFIX PLUS                    X31763000
               JTMMIN(JTMPLUS+1),       PREFIX MINUS                   X31764000
               JTMMULT(JTMMIN+1),       MULTIPLY                       X31765000
               JTMDIV(JTMMULT+1),       DIVIDE                         X31766000
               JTMADD(JTMDIV+1),        ADD                            X31767000
               JTMSUB(JTMADD+1),        SUBTRACT                       X31768000
               JTMGT(JTMSUB+1),         GREATER THAN                   X31769000
               JTMGE(JTMGT+1),          GREATER OR EQUAL               X31770000
               JTMEQ(JTMGE+1),          EQUAL                          X31771000
               JTMLE(JTMEQ+1),          LESS OR EQUAL                  X31772000
               JTMLT(JTMLE+1),          LESS THAN                      X31773000
               JTMNE(JTMLT+1),          NOT EQUAL                      X31774000
               JTMNOT(JTMNE+1),         LOGICAL NOT                    X31775000
               JTMAND(JTMNOT+1),        LOGICAL AND                    X31776000
               JTMOR(JTMAND+1),         LOGICAL OR                     X31777000
               JTMSTR(JTMOR+1),         STRING OPERATOR                X31778000
               JTMDUP(JTMSTR+1),        DUPLICATION OPERATOR           X31779000
               JTMDIM(JTMDUP+1),        DIMENSION OPERATOR             X31780000
               JTMDIM2(JTMDIM+1),       SYSLIST(N,M) FIRST DIMENSION   X31781000
               JTMDIM3(JTMDIM2+1),      SYSLIST (N,M) SECOND DIMEN     X31782000
               JTMSTRM(JTMDIM3+1),      STATEMENT TERMINATOR           X31783000
               JTMTAT(JTMSTRM+1),       TYPE ATTRIBUTE                 X31784000
               JTMLAT(JTMTAT+1),        LENGTH ATTRIBUTE               X31785000
               JTMSAT(JTMLAT+1),        SCALE ATTRIBUTE                X31786000
               JTMIAT(JTMSAT+1),        INTEGER ATTRIBUTE              X31787000
               JTMKAT(JTMIAT+1),        COUNT ATTRIBUTE                X31788000
               JTMNAT(JTMKAT+1),        NUMBER ATTRIBUTE               X31789000
               JTMHIOP(JTMNAT)          HIGHEST OPERATOR.               31790000
         SPACE                                                          31791000
*        CONDITIONAL ASSEMBLY TERM FLAGS                                31792000
         SPACE                                                          31793000
         ORG   JTMOP                    ORIGIN ZERO                     31794000
JTMFLG   DBV   JTMSVA(((JTMHIOP+2)/2)*2),    SETA                      X31795000
               JTMSVB(JTMSVA+2),        SETB                           X31796000
               JTMSVC(JTMSVB+2),        SETC                           X31797000
               JTMOSA(JTMSVC+2),        ORDINARY SYMBOL ATTRIBUTE      X31798000
               JTMSEQ(JTMOSA+2),        SEQUENCE SYMBOL                X31799000
               JTMSDT(JTMSEQ+2),        SELF DEFINING TERM             X31800000
               JTMCS(JTMSDT+2),         CHARACTER STRING               X31801000
               JTMLSTO(JTMCS+2),        SYSLIST                        X31802000
               JTMKPAR(JTMLSTO+2),      KEYWORD PARAMETER              X31803000
               JTMPPAR(JTMKPAR+2)       POSITIONAL PARAMETER            31804000
         SPACE                                                          31805000
         ORG   JTMFLG                   DEFINE GLOBAL INDICATOR         31806000
         DSW   JTMCSW,                  EVALUATE AS CHARACTER          X31807000
               ,,,,,,                   NOT USED AS SWITCHES           X31808000
               JTMGBL                   GLOBAL REFERENCE                31809000
         SPACE                                                          31810000
JTMPTR   DS    CL3                      POINTER FIELD                   31811000
JTMD     DS    CL2                      DIMENSION FIELD                 31812000
JTMNEXT  EQU   *                        MARKER                          31813000
         SPACE                                                          31814000
         ORG   JTMPTR                   ORIGIN ONE                      31815000
JTMLSTN  DS    CL3                      N FOR SYSLIST(N) OR (N,M)       31816000
JTMLSTM  DS    CL2                      M FOR SYSLIST(N,M)              31817000
         ORG   JTMPTR                   ORIGIN ONE                      31818000
JTMLNG   DS    C                        LENGTH OF STRING                31819000
JTMSTRNG EQU   *                        START OF CHARACTER STRING       31820000
         ORG   JTMPTR                   ORIGIN ONE                      31821000
JTMVALUE DS    CL4                      SDT VALUE                       31822000
./ ADD NAME=JTPRINT                                                     31823000
         MACRO                                                          31824000
&NAME    JTPRINT                                                        31825000
.*       GENERATES A CALL TO THE OUTPUT I/O MODULE TO OUTPUT A RECORD   31826000
.*       ON SYSTERM DATA SET.                                           31827000
&NAME    L    R12,JOUTMLC               GET OUTPUT PACKAGE ENTRY        31828000
         BAL   R9,TSPRINT(,R12)         GO TO TSO PRINT                 31829000
         MEND                                                           31830000
./ ADD NAME=JTRUNC                                                      31831000
         MACRO                                                          31832000
&NAME    JTRUNC &FILE=                                                  31833000
.*       GENERATES A CALL TO THE WORKFILE I/O PACKAGE TO TRUNCATE       31834000
.*       AN OUTPUT BUFFER. THIS CAUSES THE CURRENT OUTPUT BUFFER        31835000
.*       TO BE REGARDED AS FULL AND PUT TO FILE. THE NEXT LOGICAL       31836000
.*       RECORD WILL BE PUT IN THE NEXT PHYSICAL BUFFER.                31837000
         AIF   (K'&FILE EQ 0).ERR1                                      31838000
&NAME    JINST LA,R10,&FILE,FILE                                        31839000
         L     R12,JMLC                 LOAD BASE                       31840000
         BAL   R9,JTRUNC(,R12)          GO TO JTRUNC                    31841000
         MEXIT                                                          31842000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31843000
         MEND                                                           31844000
./ ADD NAME=JWRITE                                                      31845000
         MACRO                                                          31846000
&NAME    JWRITE &FILE=,&PARM=                                           31847000
.*       GENERATES A CALL TO THE WORKFILE I/O PACKAGE TO WRITE          31848000
.*       A PHYSICAL RECORD. THE OPERATIN MUST BE CHECKED FOR COMPLETION 31849000
.*       BEFORE ANY ADDITIONAL OPERATIONS TO THE FILE IS DONE (JCHECK). 31850000
         AIF   (K'&FILE EQ 0 OR K'&PARM EQ 0).ERR1                      31851000
&NAME    JINST LA,R10,&FILE,FILE                                        31852000
         JINST LA,R11,&PARM                                             31853000
         L     R12,JMLC                 LOAD BASE                       31854000
         BAL   R9,JWRITE(,R12)          GO TO JWRITE                    31855000
         MEXIT                                                          31856000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     31857000
         MEND                                                           31858000
./ ADD NAME=OP                                                          31859000
         MACRO                                                          31860000
&MNEM    OP    &IOP,                    INT OPCODE - OMITTED FOR ASMOPS*31861000
               &INPC=YES,               INITIATE PRIVATE CODE          *31862000
               &INHB=NO,                START,DSECT,CSECT,COM HAVE'YES'*31863000
               &DEF=YES,                STMT MAY AFFECT STOR ASS OR ESD*31864000
               &REF=YES,                OPND MAY CONTAIN SYMBOL REF    *31865000
               &REQOP=NO                OPERAND SCAN REQUIRED           31866000
.*                                                                      31867000
         GBLA  &SHIFT(8)                USED IN FOLDING MNEMONIC        31868000
         GBLA  &CHAIN(71)               STATISTICS FOR EACH CHAIN       31869000
         GBLC  &SEARCH(71)              CHAINS - FOR DOCUMENTATION ONLY 31870000
         GBLC  &TABLE(71)               NAME OF PREVIOUS ENTRY IN CHAIN 31871000
         GBLC  &CHARVAL                 VALID CHARACTERS FOR MNEMONICS  31872000
.*                                                                      31873000
         LCLA  &HASHVAL                 HASH VALUE                      31874000
         LCLA  &COUNT,&INDEX            SCRATCHPADS                     31875000
         LCLA  &TYP                     TYPE OF OP                      31876000
         LCLB  &FLAGA(8)                FLAGA                           31877000
         LCLC  &STRING                  SCRATCHPAD                      31878000
         LCLC  &COMMENT                 USED FOR GENERATING VAR CMTS    31879000
         LCLC  &MI                      MNEMONIC IN INTERNAL CODE       31880000
.*                                                                      31881000
.* CHECK PARAMETERS                                                     31882000
.*                                                                      31883000
         AIF   ('&IOP' EQ '').IOPOK     GO IF IOP OMITTED               31884000
         AIF   (T'&IOP EQ 'N' AND '&IOP'(1,1) EQ 'X' AND K'&IOP LT     *31885000
               8 ).IOPOK                GO IF MACHINE OP                31886000
         MNOTE '***  ERROR  *** - &IOP'                                 31887000
         MEXIT                                                          31888000
.IOPOK   AIF   ('&INPC' EQ 'YES' OR '&INPC' EQ 'NO').INPCOK             31889000
         MNOTE '***  ERROR  *** - INPC=&INPC'                           31890000
         MEXIT                                                          31891000
.INPCOK  AIF   ('&INHB' EQ 'YES' OR '&INHB' EQ 'NO').INHBOK             31892000
         MNOTE '***  ERROR  *** - INHB=&INHB'                           31893000
         MEXIT                                                          31894000
.INHBOK  AIF   ('&DEF' EQ 'YES' OR '&DEF' EQ 'NO').DEFOK                31895000
         MNOTE '***  ERROR  *** - DEF=&DEF'                             31896000
         MEXIT                                                          31897000
.DEFOK   AIF   ('&REF' EQ 'YES' OR '&REF' EQ 'NO').REFOK                31898000
         MNOTE '***  ERROR  *** - REF=&REF'                             31899000
         MEXIT                                                          31900000
.REFOK   AIF   ('&REQOP' EQ 'YES' OR '&REQOP' EQ 'NO').REQOPOK          31901000
         MNOTE '***  ERROR  *** - REQOP=&REQOP'                         31902000
         MEXIT                                                          31903000
.REQOPOK ANOP                                                           31904000
.*********************************************************************. 31905000
.*                                                                   *. 31906000
.* CALCULATE HASH NUMBER,GENERATE CHAIN POINTER AND UPDATE HASH TABLE*. 31907000
.*                                                                   *. 31908000
.*********************************************************************. 31909000
.*                                                                      31910000
.*   CALCULATE HASH NUMBER (AND BUILD MNEM IN INT CODE CONCURRENTLY)    31911000
.*                                                                      31912000
.HOUT    ANOP                           OUTER LOOP FOR HASHING          31913000
&COUNT   SETA  &COUNT+1                 POINT TO NEXT CHAR IN MNEMONIC  31914000
&MI      SETC  '&MI,J'.'&MNEM'(&COUNT,1) APPEND ',J' AND NEXT CHAR      31915000
&INDEX   SETA  1                        POINT TO FIRST CHAR IN CHARVAL  31916000
.HIN     AIF   ('&MNEM'(&COUNT,1) EQ '&CHARVAL'(&INDEX,1)).HFOUND       31917000
&INDEX   SETA  &INDEX+1                 NO MATCH - TRY NEXT CHAR        31918000
         AIF   (&INDEX LE K'&CHARVAL).HIN  ... IF THERE IS ONE          31919000
&STRING  SETC  '&MNEM'(&COUNT,1)        EXTRACT CHARACTER IN ERROR      31920000
         MNOTE '***  ERROR  *** - INVALID CHARACTER &STRING IN &MNEM'   31921000
         MEXIT                                                          31922000
.HFOUND  ANOP                                                           31923000
&HASHVAL SETA  &HASHVAL+(&INDEX+9)*&SHIFT(&COUNT) ADD WEIGHTED VALUE    31924000
         AIF   (&COUNT LT K'&MNEM).HOUT GO IF SCAN OF MNEM NOT COMPLETE 31925000
&HASHVAL SETA  &HASHVAL-&HASHVAL/71*71+1     HERE IS THE HASH NUMBER    31926000
&CHAIN(&HASHVAL) SETA &CHAIN(&HASHVAL)+1 COLLECT STATISTICS             31927000
.*                                                                      31928000
.*   GENERATE CHAIN POINTER                                             31929000
.*                                                                      31930000
&STRING  SETC  '&TABLE(&HASHVAL)-JOPTABLE'                              31931000
&COMMENT SETC  (20-K'&STRING)' '.'PTR TO PREV ENTRY IN CHAIN &HASHVAL'  31932000
&MNEM    DC    AL2(&STRING)&COMMENT                                     31933000
.*                                                                      31934000
.*   UPDATE HASH TABLE                                                  31935000
.*                                                                      31936000
&TABLE(&HASHVAL) SETC '&MNEM'           REMEMBER THIS ENTRY             31937000
&SEARCH(&HASHVAL) SETC '->&MNEM'.'&SEARCH(&HASHVAL)'   BUILD CHAIN      31938000
.*********************************************************************. 31939000
.*                                                                   *. 31940000
.* FIND TYPE OF OP BY LOOKING AT IOP,WHICH MUST BE SPECIFIED AS      *. 31941000
.* X'HH' OR X'HHHH' FOR MACHINE OPS, X'HHM' FOR EXTENDED MNEMONICS,  *. 31942000
.* AND OMITTED FOR ASSEMBLER OPS.THE TYPE IS SET TO                  *. 31943000
.*       0 - MACHINE OP, 1-BYTE OPCODE                               *. 31944000
.*       1 - EXTENDED MNEMONIC                                       *. 31945000
.*       2 - MACHINE OP, 2-BYTE OPCODE                               *. 31946000
.*       3 - ASSEMBLER OP                                            *. 31947000
.*                                                                   *. 31948000
.*********************************************************************. 31949000
&TYP     SETA  K'&IOP/K'&IOP            0 IF OMITTED,1 IF NOT           31950000
&TYP     SETA  &TYP*(K'&IOP-5)+(1-&TYP)*3 SET TYPE AS IN BOX ABOVE      31951000
.*********************************************************************. 31952000
.*                                                                   *. 31953000
.* GENERATE 'FLAGS' BYTE                                             *. 31954000
.*                                                                   *. 31955000
.*********************************************************************. 31956000
&INDEX   SETA  &TYP*(3-&TYP)+1          SHOWS THAT INDEX IS REDUNDANT   31957000
&COUNT   SETA  K'&MNEM-1                LENGTH OF MNEM -1               31958000
&STRING  SETC  'XL.2''&INDEX'',XL.2''&TYP'',XL.1''0'',XL.3''&COUNT'''   31959000
         DC    &STRING                            FLAGS                 31960000
.*********************************************************************. 31961000
.*                                                                   *. 31962000
.* GENERATE MNEMONIC IN INTERNAL CODE                                *. 31963000
.*                                                                   *. 31964000
.*********************************************************************. 31965000
&STRING  SETC  '&MI'(2,K'&MI-1)         REMOVE FIRST COMMA              31966000
         DC    AL1(&STRING)                       MNEMONIC IN INT CODE  31967000
.*********************************************************************. 31968000
.*                                                                   *. 31969000
.* GENERATE FLAGA                                                    *. 31970000
.*                                                                   *. 31971000
.*********************************************************************. 31972000
&FLAGA(1) SETB (&TYP EQ 3)              1 FOR ASM OPS                   31973000
&FLAGA(3) SETB ('&INPC' EQ 'YES')       INITIATE PRIVATE CODE           31974000
&FLAGA(4) SETB ('&INHB' EQ 'YES')       INHIBIT PRIVATE CODE            31975000
&FLAGA(5) SETB ('&DEF' EQ 'YES')        STMT MAY AFFECT STOR ASS OR ESD 31976000
&FLAGA(6) SETB ('&REF' EQ 'YES')        OPND MAY CONTAIN SYMBOL REF     31977000
         AIF   (NOT &FLAGA(1)).MOP      GO IF NOT ASM OP                31978000
&FLAGA(2) SETB ('&MNEM' EQ 'EXTRN' OR '&MNEM' EQ 'WXTRN' OR            *31979000
               '&MNEM' EQ 'ENTRY')                                      31980000
&FLAGA(7) SETB ('&REQOP' EQ 'YES')      OPND SCAN REQUIRED              31981000
&FLAGA(8) SETB ('&MNEM' EQ 'DC' OR '&MNEM' EQ 'DS' OR '&MNEM' EQ 'DXD') 31982000
         AGO   .FLAGA                                                   31983000
.MOP     ANOP                                                           31984000
&FLAGA(2) SETB (&TYP NE 0)              1 FOR EXT MNEM OR 2-BYTE OPCODE 31985000
.*   CALCULATE INSTRUCTION LENGTH FROM FIRST TWO BITS OF OPCODE         31986000
&COUNT   SETA  &IOP/B'1000000'          SHIFT RIGHT 6 BITS              31987000
         AIF   (&TYP EQ 0).MOPL         GO IF 1-BYTE OPCODE             31988000
&COUNT   SETA  &COUNT/B'10000'          SHIFT ANOTHER 4 BITS            31989000
         AIF   (&TYP EQ 1).MOPL         GO IF EXT MNEMONIC              31990000
&COUNT   SETA  &COUNT/B'10000'          2-BYTE OPCODE - SHIFT 4 MORE    31991000
.MOPL    ANOP                                                           31992000
&FLAGA(7) SETB (&COUNT EQ 3)            INSTR LENGTH IS 6 BYTES         31993000
&FLAGA(8) SETB (&COUNT EQ 1 OR &COUNT EQ 2)  INSTR LENGTH IS 4 BYTES    31994000
.FLAGA   ANOP                                                           31995000
&STRING  SETC  '&FLAGA(1)&FLAGA(2)&FLAGA(3)&FLAGA(4)&FLAGA(5)&FLAGA(6)&*31996000
               FLAGA(7)&FLAGA(8)'       SET FLAGA                       31997000
         DC    B'&STRING'                         FLAGA                 31998000
.*********************************************************************. 31999000
.*                                                                   *. 32000000
.* GENERATE INTERNAL OPCODE (INCLUDING MASK FOR EXT MNEMONICS)       *. 32001000
.*                                                                   *. 32002000
.*********************************************************************. 32003000
         AIF   (&TYP NE 3).T012                                         32004000
&STRING  SETC  'AL1(JT&MNEM)'           ASM OP - SET INTERNAL OPCODE    32005000
         AGO   .IOP                                                     32006000
.T012    ANOP                           MACHINE OP                      32007000
&COUNT   SETA  4*(&TYP+2)               SET BIT LENGTH                  32008000
&STRING  SETC  'XL.&COUNT'.'&IOP'(2,K'&IOP-1)                           32009000
.IOP     ANOP                                                           32010000
         DC    &STRING                            INTERNAL OPCODE       32011000
         SPACE                                                          32012000
         MEND                                                           32013000
./ ADD NAME=RSYMRCD                                                     32014000
*COPY RSYMRCD                                                           32015000
RRCDL    DS    H                        RECORD LENGTH                   32016000
         SPACE                                                          32017000
RFLGA    DSW   RPSOP,                        PSEUDO OP                 ,32018000
               ,                             NOT USED                  ,32019000
               ,                             NOT USED                  ,32020000
               ,                             NOT USED                  ,32021000
               ,                             NOT USED                  ,32022000
               ,                             NOT USED                  ,32023000
               ,                             NOT USED                  ,32024000
                                             NOT USED                   32025000
         SPACE                                                          32026000
RFLGB    DSW   ,,                                                      ,32027000
               ,                             NOT USED                  ,32028000
               ENTRYSW1,                     ENTRY ITEM PENDING        ,32029000
               ESDNRSW1,                                               ,32030000
               CSECTSW1,                                               ,32031000
               DSECTSW1,                                               ,32032000
               DSCOMSW1                                                 32033000
         SPACE                                                          32034000
RTYPE    DBV   ,                        RECORD TYPE.  (SEE 'JTEXT')     32035000
         SPACE                                                          32036000
RFLDI    DSW   ESDOFLO,                                                ,32037000
               DEFINED,                      SYMBOL DEFINED, NO ERROR  ,32038000
               PRIORDEF,                     PREVIOUSLY DEFINED SYMBOL ,32039000
               RFIELDN,                      NAME FIELD APPENDED       ,32040000
               RFIELDX,                      FIELD 'A' OR 'B' APPENDED ,32041000
               ,                             LENGTH OF NAME MINUS ONE   32042000
         SPACE                                                          32043000
RSWTS    DSW   ,DSW1,CSW1,,ESW1,                                OX00106,32044000
               EQUF1                         ERRONEOUS LENGTH  @OY08064 32045000
         ORG   RSWTS                                                    32046000
RESDI    DS    H                        ESDID ASSOCIATED WITH VALUE     32047000
RLCTR    DS    F                        VALUE                           32048000
RLNGA    DS    0X                                                       32049000
RFLDA    EQU   RLNGA+1                                                  32050000
RNAME    DS    CL8                      SYMBOL                          32051000
RLNGQ    DS    H                        SYMBOL LENGTH ATTRIBUTE         32052000
RLNGB    DS    0X                                                       32053000
RFLDB    EQU   RLNGB+1                                                  32054000
         ORG   ,                                                        32055000
RLAST    EQU   *                                                        32056000
         ORG   RRCDL                                                    32057000
RITEM    DS    XL(RLAST-RRCDL)                                          32058000
         ORG   RNAME                                                    32059000
RSYMC1   DS    0XL(L'RNAME+L'RLNGQ)     COMMON SEGMENT                  32060000
         ORG   RESDI                                                    32061000
RSYMC2   DS    0XL(L'RESDI+L'RLCTR)     COMMON SEGMENT                  32062000
RESDC    DS    0XL(L'RESDI+L'RLCTR)     COMMON SEGMENT                  32063000
./ ADD NAME=RXLFMTS                                                     32064000
*COPY RXLFMTS                                                           32065000
PPIN     DSECT                                                          32066000
PPRLI    DS    CL2                      RECORD LENGTH                   32067000
PPFLG    DS    CL2                      FLAGS                           32068000
PPIOC    DS    CL2                      INTERNAL OP CODE                32069000
         SPACE                                                          32070000
         ORG   PPRLI                                                    32071000
RLDIN    EQU   *                        RLD INPUT RECORD FORMAT         32072000
RLDLEN   DS    CL2                      RLD RECORD LENGTH               32073000
RFLAG    DS    CL2                      FLAG                            32074000
ROPCDE   DS    CL2                      OPCODE BYTES                    32075000
POSID    DS    CL2                      POSITION ESD/ID                 32076000
RELID    DS    CL2                      RELOCATION ESD/ID               32077000
RLDVAL   DS    CL3                      RLD SYMBOL ADDRESS              32078000
RLDFLG   DS    C                        RLD FLAG                        32079000
         DS    0F                       FULL-WORD ALIGNMENT             32080000
RLDND    EQU   *-RLDIN                  LENGTH OF RECORD                32081000
RLDTYPE  EQU   JR                       RLD RECORD I.D.                 32082000
         SPACE                                                          32083000
         ORG   PPRLI                                                    32084000
XRFIN    EQU   *                        XREF INPUT RECORD FORMAT        32085000
XRECLN   DS    CL2                      XREF RECORD LENGTH              32086000
XFLAG    DS    CL2                      FLAG                            32087000
XOPCDE   DS    CL2                      OP CODE                         32088000
XRFSYM   DS    CL8                      XREF SYMBOL                     32089000
XRFFLG   DS    C                        XREF FLAG, BASE, DEF, DUP,UNDEF 32090000
XRFSTM   DS    CL2                      XREF STATEMENT NUMBER           32091000
XRFLN    EQU   *-XOPCDE                 SORT CONTROL FIELD LENGTH       32092000
XRFLEN   DS    CL2                      XREF LENGTH                     32093000
XRFVAL   DS    CL4                      XREF VALUE                      32094000
         DS    0F                       FULL-WORD ALIGNMENT             32095000
XRFND    EQU   *-XRFIN                  LENGTH OF XREF RECORD           32096000
XRFTYPE  EQU   JX                       XREF RECORD I.D.                32097000
         ORG   XRFSYM                   .                               32098000
LITLOCTR DS    CL4                      LITERAL LOCATION COUNTER        32099000
LITESDID DS    CL2                      LITERAL ESD ID                  32100000
LITPOLID DS    C                        LITERAL POOL ID                 32101000
         ORG   XRFVAL                   LITERAL ORIGIN                  32102000
LITDTL   DS    C                        LITERAL DATA LENGTH             32103000
LITDTA   EQU   *                        LITERAL DATA                    32104000
LXEND    EQU   *-XRFIN                                                  32105000
LITTYPE  EQU   JY                       LITERAL XREF TYPE               32106000
BASE     EQU   X'01'                    BASE MASK                       32107000
REF      EQU   X'02'                    REFERENCE MASK                  32108000
DUPL     EQU   X'03'                    DUPLICATE MASK                  32109000
./ ADD NAME=SET                                                         32110000
         MACRO                                                          32111000
&NAME    SET   &SW,&OP                                                  32112000
         GBLA  &INDEX                                                   32113000
         GBLC  &DEFNAME(255),&SWNAME(255)                               32114000
         LCLA  &I,&J,&K,&II                                             32115000
         LCLC  &DEF,&P(8)                                               32116000
.*       SET A SPECIFIED BIT ON OR OFF.                                 32117000
         AIF   (K'&SW EQ 0).ERR1                                        32118000
         AIF   (N'&SW LT 1 OR N'&SW GT 8).ERR1                          32119000
.LOOP1   ANOP                                                           32120000
&I       SETA  &I+1                                                     32121000
         AIF   (&I GT &INDEX).DBV1                                      32122000
         AIF   ('&SW(1)' NE '&SWNAME(&I)').LOOP1                        32123000
         AIF   (K'&OP EQ 0).ERR1                                        32124000
&DEF     SETC  '&DEFNAME(&I)'                                           32125000
&I       SETA  &I-7                                                     32126000
&J       SETA  &I+14                                                    32127000
         AIF   (&I GE 1).OKI                                            32128000
&I       SETA  1                                                        32129000
.OKI     AIF   (&J LE &INDEX).OKJ                                       32130000
&J       SETA  &INDEX                                                   32131000
.OKJ     ANOP                                                           32132000
&II      SETA  &I                                                       32133000
&K       SETA  1                                                        32134000
.LOOP2   ANOP                                                           32135000
&K       SETA  &K+1                                                     32136000
         AIF   (&K GT N'&SW).DONE1                                      32137000
.LOOP3   AIF   ('&SW(&K)' EQ '&SWNAME(&I)').MATCH1                      32138000
&I       SETA  &I+1                                                     32139000
         AIF   (&I LE &J).LOOP3                                         32140000
         AGO   .ERR2                                                    32141000
.MATCH1  AIF   ('&DEF' NE '&DEFNAME(&I)').ERR2                          32142000
&P(&K)   SETC  '+'                                                      32143000
&I       SETA  &II                                                      32144000
         AGO   .LOOP2                                                   32145000
.DONE1   AIF   ('&OP' NE 'ON').TRYOFF                                   32146000
&NAME    OI    &DEF,&SW(1)&P(2)&SW(2)&P(3)&SW(3)&P(4)&SW(4)&P(5)&SW(5)&X32147000
               P(6)&SW(6)&P(7)&SW(7)&P(8)&SW(8)                         32148000
         AGO   .EXIT                                                    32149000
.TRYOFF  AIF   ('&OP' NE 'OFF').TRYFLIP                                 32150000
&NAME    NI    &DEF,BITFF-(&SW(1)&P(2)&SW(2)&P(3)&SW(3)&P(4)&SW(4)&P(5)X32151000
               &SW(5)&P(6)&SW(6)&P(7)&SW(7)&P(8)&SW(8))                 32152000
         AGO   .EXIT                                                    32153000
.TRYFLIP AIF   ('&OP' NE 'FLIP').ERR1                                   32154000
&NAME    XI    &DEF,&SW(1)&P(2)&SW(2)&P(3)&SW(3)&P(4)&SW(4)&P(5)&SW(5)&X32155000
               P(6)&SW(6)&P(7)&SW(7)&P(8)&SW(8)                         32156000
         AGO   .EXIT                                                    32157000
.DBV1    AIF   (N'&SW NE 1).ERR1                                        32158000
         AIF   (K'&SW GT 7).ERR1                                        32159000
         AIF   (K'&OP EQ 0).DVB2                                        32160000
&NAME    MVI   V&SW,&OP                                                 32161000
         AGO   .EXIT                                                    32162000
.DVB2    ANOP                                                           32163000
&NAME    MVI   V&SW,&SW                                                 32164000
.EXIT    MEXIT                                                          32165000
.ERR1    MNOTE 8,'PARAMETER ERROR.'                                     32166000
         MEXIT                                                          32167000
.ERR2    MNOTE 8,'SWITCH NOT PREVIOUSLY DEFINED OR NOT IN SAME BYTE.'   32168000
         MEND                                                           32169000
./ ADD NAME=TBLGEN                                                      32170000
         MACRO                                                          32171000
         TBLGEN &OPTBL,&SQVAL,&TNAME,&TID,&LENG,&BREG                   32172000
         GBLA  &LN,&ENDC,&NDX                                           32173000
         GBLC  &TNM,&REP,&REPA,&BLK                                     32174000
.*       GENERATES TABLES IN X1A. ONE WITH OFFSET AND ONE WITH          32175000
.*       VALUES AT THE CORRESPONDING OFFSETS.  SEE MODULE X1A.          32176000
&TNM     SETC  '&TNAME'                 NAME TO BE GEN'ED FOR TABLE     32177000
&LN      SETA  K'&TNAME                                                 32178000
         AIF   (&LN LE 8).TGBGN                                         32179000
         MNOTE '&TNM EXCEEDS 8 CHARACTERS - IT HAS K'&TNAME CHARACTERS' 32180000
         MEXIT                                                          32181000
.TGBGN   ANOP                                                           32182000
&LN      SETA  &LENG                    LENGTH ATTR FOR EACH TBL ENTRY  32183000
&TNM     EQU   *                                                        32184000
&BLK     SETC  '  '                                                     32185000
&NDX     SETA  0                                                        32186000
&ENDC    SETA  N'&OPTBL                                                 32187000
         AIF   ('&TID' EQ 'SEQT').SEQTBL                                32188000
.* THE DEFAULT ID IS OP CODE TABLE ID                                   32189000
.OCTBL   ANOP                                                           32190000
&NDX     SETA  &NDX+1                                                   32191000
&REP     SETC  '&SYSLIST(1,&NDX)'                                       32192000
         AIF   (&NDX GE &ENDC).OUT1                                     32193000
         ORG   &TNM.+JT&REP.*&LN                                        32194000
         DC    AL&LN.(&REP.-&BREG.)                                     32195000
         AGO   .OCTBL                                                   32196000
.* STATEMENT SEQUENCING TABLE                                           32197000
.SEQTBL  ANOP                                                           32198000
&NDX     SETA  &NDX+1                                                   32199000
&REP     SETC  '&SYSLIST(1,&NDX)'                                       32200000
&REPA    SETC  '&SYSLIST(2,&NDX)'                                       32201000
         AIF   (&NDX GE &ENDC).OUT2                                     32202000
         ORG   &TNM.+JT&REP.*&LN                                        32203000
         DC    AL&LN.(&REPA.)                                           32204000
         AGO   .SEQTBL                                                  32205000
.OUT1    ANOP                                                           32206000
         DC    AL&LN.(&REP.-&BREG.)                                     32207000
         AGO   .EXIT                                                    32208000
.OUT2    ANOP                                                           32209000
DMMY     EQU   *                                                        32210000
         DC    AL&LN.(&REPA.)                                           32211000
.EXIT    ANOP                                                           32212000
         DS    0H                                                       32213000
         MEND                                                           32214000
./ ADD NAME=XDCDS                                                       32215000
         MACRO                                                          32216000
&ID      XDCDS &DUMMY,&TESTRAN=NO,&DIAG=NO,&LEVEL=1                     32217000
         GBLC  &COMPNM                  COMPONENT NAME                  32218000
         LCLC  &NM                      MODULE NAME                     32219000
         JHEAD 'SYMBOL RESOLUTION PHASE DC/DS EVALUATION',             ,32220000
               PHASEID=&ID,                                            ,32221000
               LEVEL=&LEVEL                                             32222000
&NM      SETC  '&COMPNM&ID'                                             32223000
*TITLE-  ASSEMBLER SYMBOL RESOLUTION PHASE DC/DS EVALUATION ROUTINE   * 32224000
*                                                                     * 32225000
*FUNCTION/OPERATION-                                                  * 32226000
*        EVALUATE OPERANDS OF ASSEMBLER OPERATION STATEMENTS DC, DS,  * 32227000
*   AND DXD, AND LITERALS IN MACHINE OPERATION STATEMENTS AND THE     * 32228000
*   LITERAL POOL.  WHEN EVALUATING A DC, DS, OR DXD STATEMENT, THE    * 32229000
*   LOCATION COUNTER IS INCREMENTED AND ALIGNED AS NECESSARY.  WHEN   * 32230000
*   EVALUATING A LITERAL IN THE MACHINE OPERATION STATEMENT, THE      * 32231000
*   OBJECT LENGTH IS RETURNED.  WHEN SCANNING A LITERAL IN THE        * 32232000
*   LITERAL POOL, A SYMBOL REFERENCE RECORD IS GENERATED FOR EACH     * 32233000
*   SYMBOL APPEARING IN THE LITERAL.                                  * 32234000
         AIF   ('&TESTRAN' NE 'YES').TEST16                             32235000
*        PUNCH 'SYM' ITEMS.                                           * 32236000
.TEST16  ANOP                                                           32237000
*                                                                     * 32238000
*ENTRY POINT-                                                         * 32239000
         ENTRY &NM.01                                                 * 32240000
*                                                                     * 32241000
*INPUT-                                                               * 32242000
*        REGISTER R5 IS THE POINTER TO THE FIRST CHARACTER TO BE      * 32243000
*   EVALUATED.                                                        * 32244000
*                                                                     * 32245000
*OUTPUT-                                                              * 32246000
*        REGISTER R14 IS THE POINTER TO THE CHARACTER WHICH LOGICALLY * 32247000
*   TERMINATED THE EVALUATION.                                        * 32248000
*        REGISTER R15 CONTAINS THE OBJECT LENGTH OF THE LITERAL IN    * 32249000
*   THE MACHINE OPERATION STATEMENT.                                  * 32250000
*        SYMBOL REFERENCE RECORDS ON 'JOUTFILE'.                      * 32251000
         AIF   ('&TESTRAN' NE 'YES').TEST17                             32252000
*        'SYM' ITEMS ON THE PUNCH FILES.                              * 32253000
.TEST17  ANOP                                                           32254000
*                                                                     * 32255000
*EXTERNAL ROUTINES-                                                   * 32256000
*        QCON-     ROUTINE IN X4E TO PROCESS SYMBOLS ENCOUNTERED IN   * 32257000
*                  Q-TYPE ADDRESS CONSTANTS.                          * 32258000
*        VCON-     ROUTINE IN X4E TO PROCESS SYMBOLS ENCOUNTERED IN   * 32259000
*                  V-TYPE ADDRESS CONSTANTS.                          * 32260000
*        EVAL-     ROUTINE IN X4V TO EVALUATE EXPRESSIONS.            * 32261000
*        REFER-    ROUTINE IN X4E TO OUTPUT SYMBOL REFERENCE RECORDS  * 32262000
*                  FOR LITERALS IN THE LITERAL POOL.                  * 32263000
*        ENTER-    ROUTINE IN X4S TO ENTER THE NAME OF A DC OR DS     * 32264000
*                  STATEMENT IN THE SYMBOL TABLE.                     * 32265000
*                                                                     * 32266000
*EXITS, NORMAL-                                                       * 32267000
*        RETURN TO THE CALLING ROUTINE.                               * 32268000
*                                                                     * 32269000
*EXITS, ERROR-                                                        * 32270000
*        RETURN TO THE CALLING ROUTINE.                               * 32271000
*                                                                     * 32272000
*TABLES/WORK AREAS-                                                   * 32273000
*        DCDSWORK- AN AREA DEFINED IN DSECT 'ICOMMON' AND USED AS     * 32274000
*                  WORK STORAGE EXCLUSIVELY BY THIS ROUTINE.          * 32275000
*                                                                     * 32276000
*ATTRIBUTES-                                                          * 32277000
*        REFRESHABLE.                                                 * 32278000
*                                                                     * 32279000
*NOTES-                                                               * 32280000
*                                                                     * 32281000
         EJECT                                                          32282000
         COPY  JCOMMON                                                  32283000
         EJECT                                                          32284000
         COPY  JTEXT                                                    32285000
         EJECT                                                          32286000
         COPY  ICOMMON                                                  32287000
         EJECT                                                          32288000
JTEXT    DSECT ,                                                        32289000
         ORG   JTEXT                    OVERLAY                         32290000
         COPY  RSYMRCD                                                  32291000
         EJECT                                                          32292000
* VS1 RELEASE 3.1 CHANGES                                               32293000
*A060500,060600                                                 OX04107 32294000
*A445500,445600                                                 OX04090 32295000
*A058500,058600                                                 OX05810 32296000
*D060500,060600                                                 OX05810 32297000
*A058100,058200                                                 OY06131 32298000
*D445500-445600                                                @OX07274 32299000
&NM.00   CSECT                                                          32300000
         JMODID                                                         32301000
&NM.01   CONTENTS                                                       32302000
         USING &NM.01,R8                                                32303000
         EJECT                                                          32304000
DCSCAN   BALR  R14,R7                   SAVE REGISTERS IN STACK         32305000
         LR    R8,R12                   BASE REGISTER                   32306000
         ST    R15,LEVELPTR             STACK LEVEL POINTER             32307000
         XC    DCDSWORK,DCDSWORK        INITIALIZATION                  32308000
         SET   SDZDUPF,OFF              CLEAR ZERO DUPF SW              32309000
         LA    R2,D1                    BUMPER                          32310000
         STH   R2,LATTRSAV              LENGTH ATTRIBUTE                32311000
         MVC   DCDSMODE,TYPECALL        ESD INHIBIT FLAG                32312000
         TM    TYPECALL,LTCALL          TEST FOR LITERAL        OY06131 32313000
         BO    NEWOPRN                  BR OVER OPERAND TST     OY06131 32314000
         TM    RFLDI,RFIELDX            ANY OPERAND             OX05810 32315000
         BZ    DCABORT                  INVALID - NOOPERAND     OX05810 32316000
NEWOPRN  SET   (NOESDS,LMOD,BMOD,SMOD),OFF   INITIAL SETTING            32317000
         ST    R2,DUPFAC                DEFAULT DUPLICATION FACTOR      32318000
         CLI   CHAR1,J9                 TEST FOR DUPLICATION FACTOR     32319000
         BH    DUPF                     NOT DECIMAL SELF-DEFINING       32320000
         BAL   R3,EXPR                  EVALUATE VALUE                  32321000
         BAL   R3,SETUP                 GO SET UP DUPLICATION FACTOR    32322000
         LTR   R11,R11                       CHECK FOR SELFDEF ZERO     32323000
         BNZ   TYPE                          IF NOT BRANCH              32324000
         SET   SDZDUPF,ON                    IND DUPF SELF DEF ZERO     32325000
         B     TYPE                     READY TO ANALYZE TYPE           32326000
DUPF     CLI   CHAR1,JLPARN             SEE IF EXPRESSION               32327000
         BNE   TYPE                     OMITTED FIELD                   32328000
         ST    R5,ADUPFAC               SAVE ADDRESS OF EXPRESSION      32329000
         BAL   R3,EXPR1                 EVALUATE EXPRESSION             32330000
TYPE     CLI   CHAR1,JZ                 TEST FOR VALID TYPE             32331000
         BH    DCABORT                  INVALID TYPE                    32332000
         TRT   CHAR1,DCTABLE            EXAMINE CLOSELY                 32333000
         BZ    DCABORT                  ILLEGAL TYPE                    32334000
         LA    R2,DCTYPES(R2)           POINT TO SWITCH CODE            32335000
         MVC   DCSWORK,D0(R2)           MOVE SWITCH CODE TO WORK AREA   32336000
         AIF   ('&TESTRAN' NE 'YES').TEST07                             32337000
         MVC   DATATYPE,CHAR1           SAVE TYPE                       32338000
.TEST07  LA    R2,D1                    INCREMENT                       32339000
         AR    R5,R2                    ADVANCE COLUMN POINTER          32340000
         CLI   CHAR1,JL                 SEE IF LENGTH MODIFIER          32341000
         BNE   NOLN                     NO LENGTH MODIFIER              32342000
         SET   DXDALIGN,OFF             SET DXD ALIGNMENT FACTOR        32343000
         SET   LMOD,ON                  INDICATE LENGTH MODIFIED        32344000
         AR    R5,R2                    BUMP COLUMN POINTER             32345000
         CLI   CHAR1,JPERIOD            SEE IF BIT LENGTH               32346000
         BNE   LNGM                     NO BIT LENGTH MODIFIER          32347000
         SET   BMOD,ON                  INDICATE BIT LENGTH MODIFIER    32348000
         AR    R5,R2                    BUMP COLUMN POINTER             32349000
         GOIF  BITLN,OFF=DCABORT        BIT LENGTH NOT ALLOWED          32350000
         L     R15,ELCTR                GET CURRENT LOCATION COUNTER    32351000
         B     LNGM1                    PUSH                            32352000
LNGM     GOIF  LTCALL,ON=LNGM3          SEE IF LITERAL                  32353000
         BAL   R1,ADDBIT                ADD RESIDUAL BITS               32354000
         ST    R15,ELCTR                UPDATE LOCATION COUNTER         32355000
LNGM1    BAL   R3,NOLN2                 GO MAKE SYMBOL TABLE ENTRY      32356000
LNGM3    CLI   CHAR1,J9                 SEE IF DECIMAL SELF DEFINING    32357000
         BH    LNGM4                    SKIP IF NOT                     32358000
         BAL   R3,EXPR                  EVALUATE                        32359000
         B     LNGM5                    CONTINUE                        32360000
LNGM4    CLI   CHAR1,JLPARN             MUST BEGIN WITH THIS            32361000
         BNE   DCABORT                  INTOLERABLE                     32362000
         BAL   R3,EXPR1                 EVALUATE                        32363000
LNGM5    BNE   DCABORT                  MUST BE ABSOLUTE                32364000
         GOIF  BMOD,ON=LNGM6            SKIP IF BIT LENGTH              32365000
         SLA   R11,D3                   CONVERT TO BITS                 32366000
         BO    DCABORT                  TOO MANY BITS                   32367000
LNGM6    CL    R11,=FS3'65535'          TEST FOR ABSOLUTE MAXIMUM       32368000
         BH    DCABORT                  TOO LONG                        32369000
         CLI   SCADDR,XBCON-SCAD        SEE IF B-, C-, OR X-TYPE        32370000
         BNE   LNGM7                    SKIP IF NOT                     32371000
         GOIF  DSCALL,ON=LNGM8          SKIP IF MAXIMUM LENGTH ALLOWED  32372000
LNGM7    CH    R11,MAXLN                TEST FOR MAXIMUM ALLOWED        32373000
         BH    DCABORT                  TOO LONG                        32374000
LNGM8    LR    R14,R2                   CLEAR                           32375000
         IC    R14,MINLN                GET MINIMUM LENGTH              32376000
         CR    R11,R14                  SEE IF ENOUGH                   32377000
         BL    DCABORT                  NOPE                            32378000
         BAL   R9,AGAIN1                SET UP LENGTH ATTRIBUTE         32379000
         SPACE                                                          32380000
EMOD     CLI   CHAR1,JS                 SEE IF SCALE MODIFIER           32381000
         BAL   R3,MODS                  SCAN EXPRESSION                 32382000
         AIF   ('&TESTRAN' NE 'YES').TEST14                             32383000
         BNE   EMOD1                    NO VALID SCALE MODIFIER         32384000
         LTR   R11,R11                  SEE IF SCALE ACTUALLY MODIFIED  32385000
         BZ    EMOD1                    NOPE                            32386000
         SET   SCALING,ON               INDICATE SCAL MODIFIER          32387000
         STH   R11,SCALE                SCALE MODIFIER                  32388000
.TEST14  ANOP                                                           32389000
EMOD1    CLI   CHAR1,JE                 SEE IF EXPONENT MODIFIER        32390000
         BAL   R3,MODS                  EVALUATE EXPRESSION             32391000
         CLC   CHAR1,LFDEL              SEE IF CONSTANTS SUBFIELD       32392000
         BNE   NOCON                    IS OMITTED                      32393000
         AR    R5,R2                    BUMP COLUMN POINTER             32394000
         AIF   ('&TESTRAN' NE 'YES').TEST13                             32395000
         ST    R5,XPARM                 SAVE COLUMN POINTER             32396000
.TEST13  SR    R4,R4                    CLEAR REGISTER                  32397000
         LR    R15,R4                   CLEAR                           32398000
         IC    R15,SCADDR               GET ADDRESS OF SCAN ROUTINE     32399000
         B     SCAD(R15)                GO SCAN CONSTANTS               32400000
         SPACE                                                          32401000
DMOD     C     R2,ADSYM                 SEE IF WE HAVE EVERYTHING       32402000
         BL    EMOD                     NO, JUST A LITTLE BIT LONGER    32403000
         BAL   R9,AGAIN2                EVALUATE THE DUPLICATION FACTOR 32404000
         B     EMOD                     GO ON                           32405000
         SPACE                                                          32406000
NOLN     LR    R11,R2                   CLEAR REGISTER                  32407000
         IC    R11,DCALIGN              GET IMPLIED ALIGNMENT           32408000
         LR    R10,R11                  SAVE                            32409000
         GOIF  TYPEL,OFF=NOLN1          SKIP IF NOT TYPE L              32410000
         AR    R11,R11                  LENGTH OF TYPE L                32411000
NOLN1    STH   R11,LATTR                LENGTH ATTRIBUTE                32412000
         SLL   R11,D3                   MULTIPLY BY EIGHT               32413000
         ST    R11,CONLNG               LENGTH OF ONE CONSTANT IN BITS  32414000
         LA    R3,DMOD                  EXIT TIME ROUTINE ADDRESS       32415000
         GOIF  LTCALL,ON=(R3)           SKIP IF LITERAL                 32416000
         BAL   R1,ADDBIT                ROUND FOR BIT                   32417000
         GOIF  SDZDUPF,ON=NOLN15        ALWAYS ALIGN IF DUPF SELF DEF 0 32418000
         GOIF  JALGN,OFF=NOLNX          DONT ALIGN IF OPTION IS OFF     32419000
NOLN15   LCR   R1,R10                   GET ALIDNMENT MASK              32420000
         BCTR  R10,0                    ROUND                           32421000
         AIF   ('&TESTRAN' NE 'YES').TEST15                             32422000
         LR    R0,R15                   SAVE                            32423000
.TEST15  AR    R15,R10                  ADD CURRENT LOCATION COUNTER    32424000
         NR    R15,R1                   ROUND                           32425000
         AIF   ('&TESTRAN' NE 'YES').TEST02                             32426000
         TM    ETYPE,ETYPEXD            SEE IF DXD                      32427000
         BO    NOLNX                    DXD, NO TESTRAN OUTPUT          32428000
         STM   R9,R1,TERMS              SAVE REGISTERS                  32429000
         SR    R15,R0                   SEE IF BYTES SKIPPED            32430000
         BE    NOLNY                    NO BYTES SKIPPED                32431000
         SET   TSPACE                   ITEM TYPE                       32432000
         MVC   ADDRESS,ELCTR+D1         ADDRESS OF BYTES SKIPPED        32433000
         STC   R15,NAME                 NUMBER OF BYTES SKIPPED         32434000
         LA    R10,D5                   LENGTH OF OUTPUT ITEM           32435000
         GOTO  SYMPUNCH                 GO TO OUTPUT ROUTINE            32436000
NOLNY    LM    R9,R1,TERMS              RESTORE REGISTERS               32437000
.TEST02  ANOP                                                           32438000
NOLNX    ST    R15,ELCTR                NEW ADDRESS                     32439000
         GOIF  DXDALIGN,OFF=NOLN2       SEE IF DXD ALIGNMENT SET        32440000
         SET   DXDALIGN,OFF             INDICATE SET                    32441000
         ST    R10,EHILC                SET DXD ALIGNMENT               32442000
         AIF   ('&TESTRAN' NE 'YES').TEST04                             32443000
NOLN2    SET   TDATA                    ORGANIZATION                    32444000
         MVC   ADDRESS,ELCTR+D1         ADDRESS                         32445000
         GOIF  DEFNAME,OFF=(R3)         RETURN IF NO NAME               32446000
         MVC   NAME,RNAME               NAME                            32447000
         TR    NAME,JTRTABLE            TRANSLATE NAME                  32448000
         IC    R1,RFLDI                 LENGTH OF SYMBOL                32449000
         N     R1,=F'7'                 LENGTH OF SYMBOL                32450000
         LA    R1,BIT0(,R1)             ORGANIZATION                    32451000
         STC   R1,ORGBYTE               ORGANIZATION                    32452000
         AGO   .TEST05                                                  32453000
.TEST04  ANOP                                                           32454000
NOLN2    GOIF  DEFNAME,OFF=(R3)         RETURN IF NO NAME               32455000
.TEST05  ANOP                                                           32456000
         SET   DEFNAME,OFF              INDICATE NO SYMBOL TABLE ENTRY  32457000
         ST    R15,RLCTR                VALUE                           32458000
         MVC   RLNGQ,LATTR              LENGTH ATTRIBUTE                32459000
         LR    R10,R4                   PARAMETER                       32460000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           32461000
         BNE   NOLN4                    ALREADY IN SYMBOL TABLE         32462000
         GOIF  LMOD,ON=NOLN3            SKIP IF LENGTH MODIFIER PRESENT 32463000
         CLI   SCADDR,XBCON-SCAD        SKIP B-, C-, P-, X-, AND Z-TYPE 32464000
         BHR   R3                       BRANCH IF HIGH                  32465000
NOLN3    ST    R14,ADSYM                SAVE SYMBOL TABLE ENTRY ADDRESS 32466000
         SET   LNGDEF,ON                INDICATE LENGTH NOT DEFINED     32467000
         BR    R3                       RETURN                          32468000
NOLN4    SET   PRIORDEF,ON              INDICATE PREVIOUSLY DEFINED     32469000
         BR    R3                       RETURN                          32470000
         SPACE                                                          32471000
NOCON    GOIF  DSCALL,OFF=DCABORT       CONSTANT SUBFIELD IS REQUIRED   32472000
         L     R4,CONLNG                INFERS ONE CONSTANT             32473000
         STH   R2,CONCT                 ONE CONSTANT ASSUMED            32474000
         LR    R11,R2                   ONE                             32475000
         BAL   R9,AGAIN3                CATCHUP                         32476000
         SPACE                                                          32477000
ENDOPRN  CLI   CHAR1,JBLANK             SEE IF VALID DELIMITER          32478000
         BE    ENDOPRN1                 SKIP IF YES                     32479000
         CLI   CHAR1,JCOMMA             SEE IF VALID DELIMITER          32480000
         BNE   DCABORT                  OH, OH                          32481000
ENDOPRN1 LR    R15,R4                   LENGTH OF CONSTANT OR CONSTANTS 32482000
         L     R1,DUPFAC                DUPLICATION FACTOR              32483000
         MR    R14,R1                   TIMES LENGTH OF CONSTANT        32484000
         LTR   R14,R14                  TEST FOR OVERFLOW               32485000
         BNZ   DCABORT                  OVERFLOWED                      32486000
         CL    R15,=FS3'16777215'       SEE IF TOO LONG                 32487000
         BH    DCABORT                  TOO LONG                        32488000
         AH    R15,BITADD               ADD RESIDUAL BITS               32489000
         D     R14,=F'8'                GET LENGTH IN BYTES             32490000
         GOIF  LTCALL,OFF=ENDOPRN2      SEE IF LITERAL                  32491000
ENDOPRN9 LTR   R14,R14                  RESIDUAL                        32492000
         LR    R14,R5                   RETURN COLUMN POINTER           32493000
         BE    EXIT                     FINIS IF NONE                   32494000
         AR    R15,R2                   ANY OVER COUNTS AS ONE          32495000
         B     EXIT                     FINIS                           32496000
ENDOPRN2 DS    0H                       PIVOT                           32497000
         AIF   ('&TESTRAN' NE 'YES').TEST00                             32498000
         TM    ETYPE,ETYPEXD            SEE IF DXD                      32499000
         BO    TESTRAN                  SKIP IF SO                      32500000
ENDOPRN8 STM   R9,R1,TERMS              SAVE REGISTERS                  32501000
         CLI   DCALIGN,D1               SEE IF B, C, P, X, OR Z-TYPE    32502000
         BH    ENDOPRN3                 BRANCH IF NOT                   32503000
         GOIF  LMOD,OFF=ENDOPRN5        SKIP IF EXPLICIT LENGTH         32504000
ENDOPRN3 MH    R1,CONCT                 TIMES NUMBER OF CONSTANTS       32505000
         L     R0,CONLNG                GET LENGTH                      32506000
         AH    R0,BITADD                PLUS ANY RESIDUAL               32507000
         LR    R4,R0                    FAKE IT                         32508000
ENDOPRN5 LR    R0,R4                    GET IT                          32509000
         SR    R0,R2                    MINUS ONE                       32510000
         SRL   R0,D3                    OVER EIGHT                      32511000
         STM   R0,R1,LENGTH             LENGTH AND MULTIPLICITY         32512000
         CR    R1,R2                    SEE IF ONE                      32513000
         BE    ENDOPRN4                 SKIP IF YES                     32514000
         SET   MULTIPLE,ON              TURN MULTIPLE ON                32515000
ENDOPRN4 LA    R10,NAME                 OUTPUT POINTER                  32516000
         LA    R11,NAME-D6              REFERENCE                       32517000
         GOIF  LABEL,ON=TESTRAN1        SKIP IF NO NAME                 32518000
         IC    R10,ORGBYTE              GET NAME LENGTH                 32519000
         N     R10,=F'7'                ISOLATE LENGTH CODE             32520000
         LA    R10,NAME+D1(R10)         POINT PAST NAME                 32521000
TESTRAN1 TR    DATATYPE,DATABLE         TRANSLATE DATA TYPE             32522000
         MVC   D0(D1,R10),DATATYPE      MOVE DATA TYPE                  32523000
         MVC   D1(D1,R10),LENGTH+D3     LENGTH                          32524000
         CLI   SCADDR,XBCON-SCAD        SEE IF X-, B-, OR C-TYPE        32525000
         BNE   TESTRAN2                 SKIP IF NOT                     32526000
         MVC   D1(D2,R10),LENGTH+D2     LENGTH                          32527000
         AR    R10,R2                   BUMP POINTER                    32528000
TESTRAN2 GOIF  MULTIPLE,OFF=TESTRAN3    SEE IF MULTIPLICITY PRESENT     32529000
         MVC   D2(D3,R10),MULTIP+D1     MULTIPLICITY                    32530000
         LA    R10,D3(,R10)             BUMP POINTER                    32531000
TESTRAN3 GOIF  SCALING,OFF=TESTRAN4     SEE IF SCALED                   32532000
         MVC   D2(D2,R10),SCALE         SCALE                           32533000
         LA    R10,D2(,R10)             BUMP POINTER                    32534000
TESTRAN4 SR    R10,R11                  GET LENGTH OF OUTPUT ITEM       32535000
         GOTO  SYMPUNCH                 GO TO OUTPUT ROUTINE            32536000
         LA    R9,TESTRAN7              ADDRESS OF NEXT ROUTINE         32537000
         GOIF  CLUSTER,OFF=(R9)         SEE IF SUB-CLUSTER              32538000
         BALR  R14,R7                   PUSH DOWN ONE LEVEL             32539000
         TS    SCADDR                   TOUGH SKIDDING                  32540000
         L     R5,XPARM                 PICK UP COLUMN POINTER          32541000
         MVC   NAME(D1),DATATYPE        DATA TYPE                       32542000
TESTRAN5 MVI   ORGBYTE,TDATA+CLUSTER    ORGANIZATION                    32543000
         BAL   R3,PZCON                 SCAN SUB-CLUSTER                32544000
         LR    R3,R11                   LENGTH                          32545000
         BCTR  R11,D0                   MINUS ONE                       32546000
         STC   R11,NAME+D1              LENGTH                          32547000
         LA    R10,D6                   LENGTH OF TESTRAN ITEM          32548000
         LCR   R0,R0                    SEE IF SCALE                    32549000
         BNP   TESTRAN6                 NO                              32550000
         LA    R10,D8                   LENGTH OF ITEM WITH SCALE       32551000
         STH   R0,NAME+D2               SCALE MODIFIER                  32552000
         SET   SCALING,ON               INDICATE SCALE                  32553000
TESTRAN6 GOTO  SYMPUNCH                 OUTPUT TESTRAN ITEM             32554000
         CLI   CHAR1,JQUOTE             SEE IF ALL DONE                 32555000
         BE    EXIT                     FINIS                           32556000
         AR    R5,R2                    BUMP COLUMN POINTER             32557000
         AL    R3,ORGBYTE               NEXT ADDRESS                    32558000
         ST    R3,ORGBYTE               NEXT ADDRESS                    32559000
         B     TESTRAN5                 GO AGAIN                        32560000
TESTRAN7 LM    R9,R1,TERMS              RESTORE REGISTERS               32561000
.TEST00  ANOP                                                           32562000
TESTRAN  STH   R14,BITADD               RESIDUAL TO NEXT BYTE           32563000
         LH    R0,OPCNT                 GET COUNT OF OPERANDS           32564000
         LTR   R0,R0                    SEE IF FIRST OPERAND            32565000
         BNE   ENDOPRN7                 NOPE                            32566000
         MVC   LATTRSAV,LATTR           LENGTH ATTRIBUTE                32567000
ENDOPRN7 AR    R0,R2                    COUNT OPERANDS                  32568000
         STH   R0,OPCNT                 AND SAVE                        32569000
         AL    R15,ELCTR                UPDATE LOCATION COUNTER         32570000
         ST    R15,ELCTR                SAVE                            32571000
         CLI   CHAR1,JBLANK             SEE IF END                      32572000
         BNE   ENDOPRN6                 SKIP IF NOT                     32573000
         BAL   R1,ADDBIT1               TACK ON ANY RESIDUAL            32574000
         ST    R15,ELCTR                SAVE                            32575000
         B     EXIT                     FINIS                           32576000
ENDOPRN6 AR    R5,R2                    BUMP COLUMN POINTER             32577000
         XC    DCWORK,DCWORK            REINITIALIZE WORK AREA          32578000
         B     NEWOPRN                  FULL SPEED AHEAD                32579000
         SPACE                                                          32580000
AGAIN    SLL   R11,D3                   MULTIPLY BY EIGHT               32581000
AGAIN1   ST    R11,CONLNG               LENGTH OF ONE CONSTANT          32582000
         LA    R11,D7(,R11)             ROUND                           32583000
         SRL   R11,D3                   LENGTH ATTRIBUTE IN BYTES       32584000
         CH    R2,LATTR                 SEE IF LENGTH ATTRIBUTE SET     32585000
         BNHR  R9                       RETURN IF ALREADY SET           32586000
         STH   R11,LATTR                SET LENGTH ATTRIBUTE            32587000
AGAIN3   L     R14,ADSYM                POINTS TO SYMBOL TABLE ENTRY    32588000
         LTR   R14,R14                  SEE IF LENGTH ATTRIBUTE DEFINED 32589000
         BZ    AGAIN2                   NO                              32590000
         STH   R11,SLNGQ                LENGTH ATTRIBUTE                32591000
         SET   LNGDEF,OFF               LENGTH ATTRIBUTE DEFINED        32592000
         SR    R14,R14                  ZERO REGISTER                   32593000
         ST    R14,ADSYM                INDICATE COMPLETE               32594000
AGAIN2   BALR  R14,R7                   PUSH DOWN A LEVEL               32595000
         L     R5,ADUPFAC               GET ADDRESS OF EXPRESSION       32596000
         LTR   R5,R5                    SEE IF AVAILABLE                32597000
         BZ    EXIT                     NONE                            32598000
         LR    R4,R11                   SAVE                            32599000
         SET   SUBLIST,ON               EVALUATE WHAT'S INSIDE PARENS   32600000
         BAL   R3,EXPR3                 EVALUATE EXPRESSION             32601000
         BAL   R3,SETUP                 APPRAISE VALUE                  32602000
         LR    R11,R4                   RESTORE                         32603000
         B     EXIT                     RETURN                          32604000
         SPACE                                                          32605000
EXPR     MVI   SELFDEFN,D0              SELF DEFINING TERM              32606000
EXPR1    SET   SUBLIST,ON               INDICATE MODE OF SCAN           32607000
EXPR2    SET   DCOP,ON                  INDICATE IN DC                  32608000
EXPR3    GOTO  EVAL                     GO EVALUATE                     32609000
         BO    DCABORT                  SYNTACTIC ERRORS                32610000
         LR    R5,R14                   UPDATE COLUMN POINTER           32611000
         BR    R3                       RETURN                          32612000
         SPACE                                                          32613000
SETUP    BNE   DCABORT                  INVALID DUPLICATION FACTOR      32614000
         ST    R11,DUPFAC               MODIFY DUPLICATION FACTOR       32615000
         LTR   R11,R11                  TEST CHARACTERISTIC             32616000
         BCR   D2,R3                    RETURN IF POSITIVE              32617000
         BM    DCABORT                  INTOLERABLE                     32618000
         SET   NOESDS,ON                INDICATE NO ESD                 32619000
         BR    R3                       RETURN                          32620000
         SPACE                                                          32621000
ADDBIT   L     R15,ELCTR                GET CURRENT LOCATION COUNTER    32622000
ADDBIT1  CLI   BITADD+D1,D0             SEE IF RESIDUAL LEFT OVER       32623000
         BCR   D8,R1                    LEAVE IF NONE                   32624000
         AR    R15,R2                   BUMP BY ONE                     32625000
         MVI   BITADD+D1,D0             ZERO COUNT                      32626000
         BR    R1                       RETURN                          32627000
         SPACE                                                          32628000
MODS     BCR   D7,R3                    RETURN IF OMITTED               32629000
         GOIF  ESMOD,OFF=DCABORT        ERROR IF NOT ALLOWED            32630000
         AR    R5,R2                    BUMP COLUMN POINTER             32631000
         CLI   CHAR1,JMINUS             SEE IF MINUS SIGN               32632000
         BE    MODS1                    BYPASS                          32633000
         CLI   CHAR1,JPLUS              SEE IF PLUS SIGN                32634000
         BNE   MODS2                    SKIP IF NOT                     32635000
MODS1    AR    R5,R2                    BUMP COLUMN POINTER             32636000
MODS2    CLI   CHAR1,J9                 SEE IF SELF-DEFINING VALUE      32637000
         BNH   EXPR                     EVALUATE                        32638000
         CLI   CHAR1,JLPARN             SEE IF LEFT PARENTHESIS         32639000
         BE    EXPR1                    EVALUATE                        32640000
         B     DCABORT                  ERROR                           32641000
         SPACE                                                          32642000
DCABORT  SR    R15,R15                  INDICATE ERROR                  32643000
         MVC   JCLVLPTR,LEVELPTR        RESTORE STACK LEVEL POINTER     32644000
         BZ    EXIT                     RETURN                          32645000
         EJECT                                                          32646000
PZEND    LCR   R11,R11                  SEE IF NULL CONSTANT            32647000
         BNP   DCABORT                  ERROR IF NULL CONSTANT          32648000
         GOIF  TYPEZ,ON=PZEND1          SKIP IF ZONED TYPE              32649000
         LA    R11,D2(,R11)             COMPUTE LENGTH FOR PACKED TYPE  32650000
         SRL   R11,D1                   COMPUTE LENGTH FOR PACKED TYPE  32651000
PZEND1   CH    R11,=H'16'               CHECK LENGTH OF CONSTANT        32652000
         BH    DCABORT                  ERROR IF MORE THAN 16 BYTES     32653000
         AIF   ('&TESTRAN' NE 'YES').TEST09                             32654000
         CLI   SCADDR,PZCON-SCAD        SEE IF CLUSTER SCAN             32655000
         BNER  R3                       SUB CLUSTER                     32656000
         GOIF  SMOD,ON=PZEND2           SEE IF SCALE SET                32657000
         SET   SMOD,ON                  INDICATE SCALE SET              32658000
         LCR   R0,R0                    TEST FOR SCALE                  32659000
         BNP   PZEND2                   NO SCALE                        32660000
         STH   R0,SCALE                 SAVE SCALE                      32661000
         SET   SCALING,ON               SCALE INDICATOR IN ORG BYTE     32662000
.TEST09  ANOP                                                           32663000
PZEND2   BAL   R3,SCANDEL               END OF ONE CONSTANT             32664000
         AIF   ('&TESTRAN' NE 'YES').TEST08                             32665000
         GOIF  LMOD,ON=PZCON            SEE IF EXPLICIT LENGTH          32666000
         SET   (MULTIPLE,CLUSTER),ON    INDICATE CLUSTER ITEM           32667000
         SET   SCALING,OFF              DEFER SCALE                     32668000
.TEST08  ANOP                                                           32669000
PZCON    MVI   PERIOD,D0                ALLOW ONE PERIOD                32670000
         AIF   ('&TESTRAN' NE 'YES').TEST10                             32671000
         SR    R1,R1                    ZERO                            32672000
         LR    R0,R2                    ONE                             32673000
.TEST10  LR    R11,R2                   INITIALIZE DIGIT COUNT          32674000
         CLI   CHAR1,JMINUS             CHECK FOR OPTIONAL MINUS SIGN   32675000
         BE    PZCON1                   STEP PAST IF PRESENT            32676000
         CLI   CHAR1,JPLUS              CHECK FOR OPTIONAL PLUS SIGN    32677000
         BNE   PZCON2                   SKIP IF NOT PRESENT             32678000
PZCON1   AR    R5,R2                    ADVANCE COLUMN POINTER          32679000
PZCON2   SR    R11,R2                   KEEP COUNT OF DIGITS            32680000
         AIF   ('&TESTRAN' NE 'YES').TEST11                             32681000
         SR    R0,R1                    COUNT SCALE                     32682000
.TEST11  CLI   CHAR1,J9                 SEE IF VALID DECIMAL DIGIT      32683000
         BNH   PZCON1                   LOOP IF YES                     32684000
         CLI   CHAR1,JPERIOD            CHECK FOR DECIMAL POINT         32685000
         BNE   PZEND                    END-OF-CONSTANT ENCOUNTERED     32686000
         AR    R11,R2                   PERIODS DO NOT COUNT            32687000
         TS    PERIOD                   SEE IF PERIOD ALLOWED           32688000
         AIF   ('&TESTRAN' NE 'YES').TEST12                             32689000
         LR    R1,R2                    BUMPER                          32690000
.TEST12  BZ    PZCON1                   ALLOW                           32691000
         B     DCABORT                  MORE THAN ONE SPELLS ERROR      32692000
         SPACE                                                          32693000
XBEND    SRA   R11,D3                   GET COUNT IN BYTES              32694000
         LCR   R11,R11                  GET ABSOLUTE COUNT              32695000
         BNP   DCABORT                  NULL CONSTANT                   32696000
         BAL   R3,SCANDEL               TEST FOR END-OF-OPERAND         32697000
XBCON    L     R3,OPNEND                POINT TO END OF OPERAND         32698000
         SR    R11,R11                  INITIALIZE ACCUMULATOR          32699000
XBCON1   CLC   CHAR1,HILIMIT            TEST FOR VALID DIGIT            32700000
         BH    XBEND                    MAY BE END OF CONSTANT          32701000
         CLI   CHAR1,JQUOTE             SEE IF A QUOTE                  32702000
         BNE   TSTAM                    SKIP IF NOT                     32703000
         CLI   CHAR2,JQUOTE             SEE IF PAIRED QUOTES            32704000
         BNE   XBEND                    END-OF-CONSTANT ENCOUNTERED     32705000
         B     TSTAM1                   PAIRED QUOTES                   32706000
         SPACE                                                          32707000
ADEND    BAL   R3,SCANDEL1              TEST FOR END-OF-OPERAND         32708000
ADCON    MVC   SUBFIELD,DCSWTCH         SUBFIELD ALLOWED/DISALLOWED     32709000
ADCON1   BAL   R3,EXPR2                 SCAN EXPRESSION                 32710000
         CLI   CHAR1,JLPARN             SUBFIELD ENCOUNTERED            32711000
         BNE   ADEND                    SKIP IF NO SUBFIELD             32712000
         TS    SUBFIELD                 SUBFIELD ALLOWED HERE           32713000
         BZ    EXPR1                    SCAN EXPRESSION                 32714000
         B     DCABORT                  ERROR IF SUBFIELD NOT ALLOWED   32715000
         EJECT                                                          32716000
QQEND    GOIF  (NOESD,NOESDS),ANY=QQEND1     SKIP IF ESD NOT OPTIONED   32717000
         GOTO  QCON                     GO CREATE ESD ENTRY             32718000
QQEND1   BAL   R3,SCANDEL1              END OF CONSTANT PROCESSING      32719000
QQCON    BAL   R3,SYMSCAN               SCAN SYMBOL                     32720000
         B     QQEND                    LOOP                            32721000
         SPACE                                                          32722000
VVEND    GOIF  (NOESD,NOESDS),ANY=VVEND1     SKIP IF NO ESD             32723000
         GOTO  VCON                     GO MAKE ESD ENTRY               32724000
VVEND1   BAL   R3,SCANDEL1              END OF CONSTANT PROCESSING      32725000
VVCON    BAL   R3,SYMSCAN               SCAN FOR SYMBOL                 32726000
         LH    R14,SYMCOUNT             COUNT OF SYMBOLS                32727000
         BCTR  R14,R0                   MINUS ONE                       32728000
         SRDL  R14,D3                   GET BYTE                        32729000
         SRL   R15,D29                  AND BIT                         32730000
         LA    R1,BIT0                  GET BIT MASK                    32731000
         SRL   R1,D0(R15)               SET UP BIT MASK                 32732000
         LA    R15,VEETABLE(R14)        POINT TO ARRAY                  32733000
         EX    R1,VVCON1                INDICATE V-CON                  32734000
         B     VVEND                    SKIP                            32735000
VVCON1   OI    D0(R15),D0               EXECUTED INSTRUCTION            32736000
         SPACE                                                          32737000
FDEND    BAL   R3,SCANDEL1              TEST FOR END-OF-OPERAND         32738000
FDCON    STH   R2,PERIOD                ALLOW PERIOD AND EXPONENT       32739000
FDCON1   LR    R11,R2                   INITIALIZE DIGIT COUNT          32740000
         CLI   CHAR1,JMINUS             SEE IF MINUS SIGN               32741000
         BE    FDCON2                   BUMP COLUMN POINTER IF YES      32742000
         CLI   CHAR1,JPLUS              SEE IF PLUS SIGN                32743000
         BNE   FDCON3                   SKIP IF NOT                     32744000
FDCON2   AR    R5,R2                    ADVANCE COLUMN POINTER          32745000
FDCON3   SR    R11,R2                   COUNT DECIMAL DIGITS            32746000
         CLI   CHAR1,JA                 SEE IF DECIMAL DIGIT            32747000
         BL    FDCON2                   LOOP FOR DECIMAL DIGITS         32748000
         CLI   CHAR1,JPERIOD            SEE IF PERIOD                   32749000
         BNE   FDCON4                   SKIP IF NOT                     32750000
         AR    R11,R2                   RESET COUNT                     32751000
         TS    PERIOD                   PERIOD ALLOWED                  32752000
         BZ    FDCON2                   GO IF PERIOD ALLOWED            32753000
         B     DCABORT                  ERROR IF PERIOD NOT ALLOWED     32754000
FDCON4   LTR   R11,R11                  SEE IF ANY VALID DECIMAL DIGITS 32755000
         BNM   DCABORT                  ERROR IF NO DIGITS              32756000
         CLI   CHAR1,JE                 SEE IF EXPONENT SPECIFIED       32757000
         BNE   FDEND                    SKIP IF NO EXPONENT SPECIFIED   32758000
         AR    R5,R2                    POINT PAST DELIMITER            32759000
         TS    PERIOD                   INDICATE PERIOD NOT ALLOWED     32760000
         TS    EXPONENT                 SEE IF EXPONENT ALLOWED         32761000
         BZ    FDCON1                   SCAN EXPONENT FIELD             32762000
         B     DCABORT                  ERROR IF MORE THAN ONE EXPONENT 32763000
         SPACE                                                          32764000
TSTAM    CLI   CHAR1,JAMPER             SEE IF AN AMPERSAND             32765000
         BNE   TSTAM2                   SKIP IF NOT                     32766000
         CLI   CHAR2,JAMPER             SEE IF PAIRED AMPERSANDS        32767000
         BNE   DCABORT                  ERROR IF AMPERSANDS NOT PAIRED  32768000
TSTAM1   AR    R5,R2                    ADVANCE COLUMN POINTER          32769000
TSTAM2   SH    R11,BITINCR              COUNT BITS IN ACCUMULATOR       32770000
         BXLE  R5,R2,XBCON1             REPEAT PROCEDURE                32771000
         B     DCABORT                  SYNTAX ERROR IF NO DELIMITER    32772000
         SPACE                                                          32773000
SCANDEL  GOIF  LMOD,ON=SCANDEL1         SKIP IF EXPLICIT LENGTH         32774000
         TM    DCALIGN,BIT7             SEE IF B-, C-, P-, X-, Z-TYPE   32775000
         BZ    SCANDEL0                 SKIP IF NOT                     32776000
         XI    DCALIGN,BIT7             ALLOW ONCE ONLY                 32777000
         MVI   LATTR+D1,D0              ALLOW                           32778000
SCANDEL0 BAL   R9,AGAIN                 SET LENGTH ATTRIBUTE            32779000
SCANDEL1 AL    R4,CONLNG                ACCUMULATE LENGTH OF CONSTANT   32780000
         LR    R14,R5                   SAVE COLUMN POINTER             32781000
         AR    R5,R2                    ADVANCE COLUMN POINTER          32782000
         AIF   ('&TESTRAN' NE 'YES').TEST06                             32783000
         LH    R0,CONCT                 COUNT NUMBER OF CONSTANTS       32784000
         AR    R0,R2                    COUNT                           32785000
         STH   R0,CONCT                 SAVE                            32786000
.TEST06  ANOP                                                           32787000
         CLC   CHAR1-CHAR1(,R14),RTDEL  SEE IF VALID DELIMITER          32788000
         BE    ENDOPRN                  END-OF-OPERAND ENCOUNTERED      32789000
         CLI   CHAR1-CHAR1(R14),JCOMMA  CHECK FOR MULTIPLE CONSTANTS    32790000
         BCR   D8,R3                    REPEAT FOR MULTIPLE CONSTANTS   32791000
         B     DCABORT                  INVALID DELIMITER               32792000
         SPACE                                                          32793000
SYMSCAN  CLI   CHAR1,JAT                SEE IF VALID CHARACTER          32794000
         BH    DCABORT                  INVALID CHARACTER               32795000
         CLI   CHAR1,JA                 SEE IF VALID CHARACTER          32796000
         BL    DCABORT                  INVALID CHARACTER               32797000
         LR    R14,R5                   SAVE SYMBOL POINTER             32798000
SYMSCAN1 AR    R5,R2                    LOOK AT NEXT CHARACTER          32799000
         CLI   CHAR1,JEQUAL             SEE IF DELIMITER                32800000
         BL    SYMSCAN1                 LOOP FOR DELIMITER              32801000
         CLI   CHAR1,JRPARN             TEST FOR VALID DELIMITER        32802000
         BE    SYMSCAN2                 VALID DELIMITER                 32803000
         CLI   CHAR1,JCOMMA             TEST FOR ALTERNATE DELIMITER    32804000
         BNE   DCABORT                  INVALID DELIMITER               32805000
SYMSCAN2 LR    R15,R5                   SAVE POINTER                    32806000
         SR    R15,R14                  GET LENGTH OF SYMBOL            32807000
         CH    R15,=H'8'                SEE IF NOT TOO LONG             32808000
         BH    DCABORT                  SYMBOL TOO LONG                 32809000
         SR    R15,R2                   GET MACHINE LENGTH              32810000
         MVC   XNAME,=8AL1(JBLANK)      PAD WITH BLANKS                 32811000
         EX    R15,MOVENAME             ISOLATE NAME                    32812000
         LH    R14,SYMCOUNT             GET SYMBOL COUNT                32813000
         AR    R14,R2                   INCREMENT BY ONE                32814000
         STH   R14,SYMCOUNT             PASS                            32815000
         GOIF  LTORGSCN,OFF=(R3)        RETURN IF THROUGH               32816000
         GOIF  MODE2,ON=(R3)            CHECK MODE                      32817000
         CLI   SCADDR,VVCON-SCAD        SEE IF V-TYPE ADDRESS CONSTANT  32818000
         BNE   SYMSCAN3                 NEAH                            32819000
         OI    XNAME,BIT0               PERMUTE NAME TO INTERNAL FORM   32820000
SYMSCAN3 GOTO  REFER                    PUT OUT RECORD                  32821000
         BR    R3                       RETURN                          32822000
         SPACE                                                          32823000
MOVENAME MVC   XNAME(0),CHAR1-CHAR1(R14)     EXECUTED INSTRUCTION       32824000
         SPACE                                                          32825000
DCTYPES  EQU   *-1                      SWITCH CODE FOR DATA TYPES    X 32826000
ACON     DC    AL1(B'10000000',JLPARN,JRPARN,ADCON-SCAD,4,1),HL2'32'  X 32827000
BCON     DC    AL1(B'10000000',JQUOTE,JQUOTE,XBCON-SCAD,1,1),HL2'2048,1'32828000
               ',AL1(J1)                                              X 32829000
CCON     DC    AL1(B'10000000',JQUOTE,JQUOTE,XBCON-SCAD,1,1),HL2'2048,8'32830000
               ',AL1(X'FF')                                           X 32831000
DCON     DC    AL1(B'11000000',JQUOTE,JQUOTE,FDCON-SCAD,8,1),HL2'64'  X 32832000
ECON     DC    AL1(B'11000000',JQUOTE,JQUOTE,FDCON-SCAD,4,1),HL2'64'  X 32833000
HCON     DC    AL1(B'11000000',JQUOTE,JQUOTE,FDCON-SCAD,2,1),HL2'64'  X 32834000
LCON     DC    AL1(B'11100000',JQUOTE,JQUOTE,FDCON-SCAD,8,1),HL2'128' X 32835000
PCON     DC    AL1(B'10000000',JQUOTE,JQUOTE,PZCON-SCAD,1,1),HL2'128' X 32836000
QCON     DC    AL1(B'00000000',JLPARN,JRPARN,QQCON-SCAD,4,8),HL2'32'  X 32837000
SCON     DC    AL1(B'00000000',JLPARN,JRPARN,ADCON-SCAD,2,16),HL2'16' X 32838000
VCON     DC    AL1(B'00010000',JLPARN,JRPARN,VVCON-SCAD,4,24),HL2'32' X 32839000
XCON     DC    AL1(B'10000000',JQUOTE,JQUOTE,XBCON-SCAD,1,1),HL2'2048,4'32840000
               ',AL1(JF)                                              X 32841000
YCON     DC    AL1(B'10000000',JLPARN,JRPARN,ADCON-SCAD,2,1),HL2'16'  X 32842000
ZCON     DC    AL1(B'10001000',JQUOTE,JQUOTE,PZCON-SCAD,1,1),HL2'128' X 32843000
         SPACE                                                          32844000
DCTABLE  EQU   *                        DATA TYPE TABLE                 32845000
         DC    10YL1(ILLEGAL-DCTYPES)   0-9 INVALID DC/DS TYPES         32846000
         DC    YL1(ACON-DCTYPES)        A-TYPE ADDRESS                  32847000
         DC    YL1(BCON-DCTYPES)        BINARY                          32848000
         DC    YL1(CCON-DCTYPES)        CHARACTER                       32849000
         DC    YL1(DCON-DCTYPES)        DOUBLE PRECISION FLOATING POINT 32850000
         DC    YL1(ECON-DCTYPES)        SINGLE PRECISION FLOATING POINT 32851000
         DC    YL1(FCON-DCTYPES)        FULLWORD FIXED POINT            32852000
         DC    YL1(GCON-DCTYPES)        G-ILLEGAL DC/DS TYPE            32853000
         DC    YL1(HCON-DCTYPES)        HALFWORD FIXED POINT            32854000
         DC    YL1(ICON-DCTYPES)        I-ILLEGAL DC/DS TYPE            32855000
         DC    YL1(JCON-DCTYPES)        J-ILLEGAL DC/DS TYPE            32856000
         DC    YL1(KCON-DCTYPES)        K-ILLEGAL DC/DS TYPE            32857000
         DC    YL1(LCON-DCTYPES)        EXTRA LONG PRECISION FLT POINT  32858000
         DC    YL1(MCON-DCTYPES)        M-ILLEGAL DC/DS TYPE            32859000
         DC    YL1(NCON-DCTYPES)        N-ILLEGAL DC/DS TYPE            32860000
         DC    YL1(OCON-DCTYPES)        O-ILLEGAL DC/DS TYPE            32861000
         DC    YL1(PCON-DCTYPES)        PACKED DECIMAL                  32862000
         DC    YL1(QCON-DCTYPES)        Q-TYPE ADDRESS                  32863000
         DC    YL1(RCON-DCTYPES)        R-ILLEGAL DC/DS TYPE            32864000
         DC    YL1(SCON-DCTYPES)        S-TYPE ADDRESS                  32865000
         DC    YL1(TCON-DCTYPES)        T-ILLEGAL DC/DS TYPE            32866000
         DC    YL1(UCON-DCTYPES)        U-ILLEGAL DC/DS TYPE            32867000
         DC    YL1(VCON-DCTYPES)        V-TYPE ADDRESS                  32868000
         DC    YL1(WCON-DCTYPES)        W-INVALID DC/DS TYPE            32869000
         DC    YL1(XCON-DCTYPES)        HEXADECIMAL                     32870000
         DC    YL1(YCON-DCTYPES)        Y-TYPE ADDRESS                  32871000
         DC    YL1(ZCON-DCTYPES)        ZONED DECIMAL                   32872000
         SPACE                                                          32873000
SCAD     EQU   PZCON                    PIVOT                           32874000
FCON     EQU   ECON                     SAME AS E-TYPE                  32875000
ILLEGAL  EQU   DCTYPES                  ILLEGAL DC/DS TYPE              32876000
GCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32877000
ICON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32878000
JCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32879000
KCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32880000
MCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32881000
NCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32882000
OCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32883000
RCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32884000
TCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32885000
UCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32886000
WCON     EQU   ILLEGAL                  ILLEGAL DC/DS TYPE              32887000
         SPACE                                                          32888000
XDSCAN   BALR  R14,R7                   SAVE REGISTERS IN STACK         32889000
         LR    R6,R10                   FAKE CURRENT CONTROL SECTION    32890000
         MVC   RESDI(D6),EESDI          PASS ESDID                      32891000
         MVI   TYPECALL,DSCALL+DXDALIGN+NOESD     PARAMETERS            32892000
         BALR  R9,R12                   SCAN OPERAND                    32893000
         B     EXIT                     RETURN                          32894000
         AIF   ('&TESTRAN' NE 'YES').MEND                               32895000
         SPACE                                                          32896000
SYMPUNCH BALR  R14,R7                   SAVE REGISTERS                  32897000
         LR    R8,R12                   SET UP BASE REGISTER            32898000
         LR    R2,R10                   LENGTH PARAMETER                32899000
         LA    R3,ORGBYTE               LOAD ADDRESS OF ORGBYTE INTO R3 32900000
         LM    R10,R12,SYMCARD          GET ADDRESS OF CARD BUFFER      32901000
         LTR   R12,R12                  SEE IF ROOM LEFT ON CARD        32902000
         BZ    GETCARD                  NO MORE ROOM                    32903000
         CR    R12,R2                   SEE IF ENOUGH ROOM              32904000
         BNL   SYMOVE                   ENOUGH, MOVE IT                 32905000
         SR    R2,R12                   DO WHAT WE CAN                  32906000
         BCTR  R12,D0                   MOVE LENGTH                     32907000
         EX    R12,SYMOVA               MOVE IT IN                      32908000
         LA    R3,D1(R3,R12)            POINT TO THE STUFF NOT MOVED    32909000
         MVI   D11(R11),D2*D28          LENGTH OF TESTRAN DATA          32910000
GETCARD  JPUNCH  SEQ=YES                GET A BUFFER                    32911000
         MVC   D0(D4,R11),=AL1(X'02',JS,JY,JM)    'SYM' CARD IDENTIFIER 32912000
         TR    D1(71,R11),JTRTABLE      TRANSLATE TO EXTERNAL FORMAT    32913000
         MVI   D10(R11),D0              INITIALIZE DATA LENGTH          32914000
         LA    R12,D28*D2               LENGTH OF TESTRAN DATA ALLOWED  32915000
         LR    R10,R11                  ADDRESS OF FIRST BYTE OF DATA   32916000
SYMOVE   SR    R12,R2                   USING UP THIS MUCH              32917000
         BCTR  R2,D0                    MACHINE LENGTH                  32918000
         EX    R2,SYMOVA                MOVE IT                         32919000
         LA    R10,D1(R10,R2)           POINT TO NEXT AVAILABLE COLUMN  32920000
         STM   R10,R12,SYMCARD          SAVE THE GARBAGE                32921000
         SLR   R10,R11                  GET DATA LENGTH                 32922000
         STC   R10,D11(,R11)            INDICATE DATA LENGTH ON CARD    32923000
         B     EXIT                     BUG OUT                         32924000
SYMOVA   MVC   D16(D0,R10),D0(R3)       EXECUTED INSTRUCTION            32925000
         SPACE                                                          32926000
DATABLE  EQU   *-D10                    TESTRAN DATA TYPE TABLE         32927000
         DC    AL1(DTYPEA)              A-TYPE                          32928000
         DC    AL1(DTYPEB)              B-TYPE                          32929000
         DC    AL1(DTYPEC)              C-TYPE                          32930000
         DC    AL1(DTYPED)              D-TYPE                          32931000
         DC    AL1(DTYPEE)              E-TYPE                          32932000
         DC    AL1(DTYPEF)              F-TYPE                          32933000
         DC    AL1(0)                   INVALID                         32934000
         DC    AL1(DTYPEH)              H-TYPE                          32935000
         DC    AL3(0)                   INVALID                         32936000
         DC    AL1(DTYPEL)              L-TYPE                          32937000
         DC    AL3(0)                   INVALID                         32938000
         DC    AL1(DTYPEP)              P-TYPE                          32939000
         DC    AL1(DTYPEQ)              Q-TYPE                          32940000
         DC    AL1(0)                   INVALID                         32941000
         DC    AL1(DTYPES)              S-TYPE                          32942000
         DC    AL2(0)                   INVALID                         32943000
         DC    AL1(DTYPEV)              V-TYPE                          32944000
         DC    AL1(0)                   INVALID                         32945000
         DC    AL1(DTYPEX)              X-TYPE                          32946000
         DC    AL1(DTYPEY)              Y-TYPE                          32947000
         DC    AL1(DTYPEZ)              Z-TYPE                          32948000
.MEND    MEND                                                           32949000
./ ADD NAME=XDICT                                                       32950000
         MACRO                                                          32951000
&ID      XDICT &DUMMY,&TESTRAN=NO,&DIAG=NO,&LEVEL=1                     32952000
         GBLC  &COMPNM                  COMPONENT NAME                  32953000
         LCLC  &NM                      MODULE NAME                     32954000
         JHEAD 'EXTERNAL SYMBOL DICTIONARY SUBROUTINES',               ,32955000
               PHASEID=&ID,LEVEL=&LEVEL                                 32956000
&NM      SETC  '&COMPNM&ID'                                             32957000
*                                                                     * 32958000
*TITLE-  EXTERNAL SYMBOL DICTIONARY ROUTINES                          * 32959000
*                                                                     * 32960000
*FUNCTION/OPERATION-                                                  * 32961000
*        BUILD AND MAINTAIN THE EXTERNAL SYMBOL DICTIONARY            * 32962000
*        PRINT AND PUNCH THE EXTERNAL SYMBOL DICTIONARY               * 32963000
*        BUILD THE EXTERNAL SYMBOL DICTIONARY ADJUSTMENT TABLE        * 32964000
*                                                                     * 32965000
*ENTRY POINT-                                                         * 32966000
         ENTRY &NM.01                                                   32967000
*                                                                     * 32968000
*INPUT-                                                               * 32969000
*        REGISTERS-                                                   * 32970000
*             R4-       REGISTER CONTAINING THE ADDRESS OF THE        * 32971000
*                       RECORD BEING PROCESSED                        * 32972000
*             R5-       REGISTER CONTAINING THE ADDRESS OF THE        * 32973000
*                       OPERAND BEING PROCESSED                       * 32974000
*             R6-       REGISTER CONTAINING THE ADDRESS OF THE        * 32975000
*                       CURRENT CONTROL SECTION ESD ENTRY             * 32976000
*                                                                     * 32977000
*OUTPUT-                                                              * 32978000
*        REGISTERS-                                                   * 32979000
*             R10       REGISTER CONTAINING THE ADDRESS OF THE        * 32980000
*                       NEW CURRENT CONTROL SECTION ESD ENTRY, IF     * 32981000
*                       CHANGED                                       * 32982000
*                                                                     * 32983000
*EXITS, NORMAL-                                                       * 32984000
*        EXITS TO THE CALLING ROUTINE                                 * 32985000
*                                                                     * 32986000
*EXITS, ERROR-                                                        * 32987000
*        EXITS TO THE CALLING ROUTINE                                 * 32988000
*                                                                     * 32989000
*TABLES/WORK AREAS-                                                   * 32990000
*        ESDBLK1-  A BLOCK IN STORAGE TO CONTAIN A MAXMI              * 32991000
*        ESDBLK1-  A BLOCK OF STORAGE TO CONTAIN A MAXIMUM OF 16 ESD  * 32992000
*                  ENTRIES, ALSO SERVES AS AN INPUT/OUTPUT BUFFER     * 32993000
*                  FOR THE OVERFLOW FILE (FILE2) WHEN NECESSARY       * 32994000
*        ESDBLK2-  SAME FUNCTION AS ESDBLK1 ABOVE                     * 32995000
*        NOTELIST- A LIST OF NOTE PARAMETERS OF OVERFLOWED ESD BLOCKS * 32996000
*                  WHEN NOT IN CORE                                   * 32997000
*                                                                     * 32998000
*ATTRIBUTES-                                                          * 32999000
*        REFRESHABLE                                                  * 33000000
*                                                                     * 33001000
*NOTES                                                                * 33002000
*                                                                     * 33003000
         EJECT                                                          33004000
         COPY  JCOMMON                                                  33005000
         EJECT                                                          33006000
         COPY  JTEXT                                                    33007000
         EJECT                                                          33008000
         COPY  ICOMMON                                                  33009000
         EJECT                                                          33010000
JTEXT    DSECT ,                                                        33011000
         ORG   JTEXT                                                    33012000
         COPY  RSYMRCD                                                  33013000
         EJECT                                                          33014000
&NM.00   CSECT                                                          33015000
* VS1 REL 2.6 CHANGES                                                   33016000
*C221000                                                        OX00106 33017000
*A246500,430500,481500                                          OX00106 33018000
*C430500,481500                                                @OY08064 33019000
         JMODID                                                         33020000
&NM.01   CONTENTS                                                       33021000
         USING &NM.01,R8                BASE REGISTER                   33022000
         EJECT                                                          33023000
*TITLE-  BLDESD                                                       * 33024000
*                                                                     * 33025000
*FUNCTION/OPERATION-                                                  * 33026000
*        BUILD OR RESUME AN ESD ENTRY                                 * 33027000
*                                                                     * 33028000
*INPUT-  R4 CONTAINS A POINTER TO THE RECORD BEING PROCESSED          * 33029000
*        R10 CONTAINS A POINTER TO A PARAMETER LIST                   * 33030000
*                                                                     * 33031000
*OUTPUT- R10 CONTAINS A POINTER TO THE ESD ENTRY                      * 33032000
*                                                                     * 33033000
         SPACE                                                          33034000
BLDESD   BALR  R14,R7                   SAVE REGISTERS IN STACK         33035000
         LR    R8,R12                   SET UP BASE REGISTER            33036000
         LA    R2,D1                    INCREMENT IN                    33037000
         LR    R3,R2                    TWO REGISTER                    33038000
         LR    R5,R10                   SAVE POINTER                    33039000
         AH    R2,D0(,R5)               ESDID                           33040000
         AH    R3,HIESDNR               ESD NUMBER                      33041000
         STH   R2,XESDI                 ESDID                           33042000
         STH   R3,XLNGQ                 ESD NUMBER                      33043000
         MVC   XFLGB,XPARM              FLAGS                           33044000
         SR    R0,R0                    ZERO                            33045000
         ST    R0,XLCTR                 INITIAL VALUE                   33046000
         OC    XESDI(D1),XPARM+D3       FLAG FOR DSECT OR COM           33047000
BLDESD1  MVC   XTYPE,XPARM+D1           TYPE                            33048000
         MVC   XNAME,=8AL1(JBLANK)      PAD                             33049000
         MVC   XNAME(D1),XTYPE          NAME                            33050000
         GOIF  RFIELDN,OFF=BLDESD2      SKIP IF NO NAME                 33051000
         MVC   RLNGQ,=H'1'              LENGTH ATTRIBUTE                33052000
         GOIF  PRIORDEF,ON=BLDESD2      SKIP IF PREVIOUSLY DEFINED      33053000
         MVC   XNAME,RNAME              GET NAME                        33054000
         MVC   XTYPE,XPARM+D2           TYPE                            33055000
BLDESD2  LA    R10,XWORK                PASS RECORD POINTER             33056000
         GOTO  ENTER                    TRY TO ENTER IN SYMBOL TABLE    33057000
         BNE   BLDESD5                  ALREADY IN SYMBOL TABLE         33058000
         STH   R2,D0(,R5)               SAVE ESDID                      33059000
         STH   R3,HIESDNR               SAVE ESD NUMBER                 33060000
         TM    XESDI,CSW2+DSW2          COM OR DSECT                    33061000
         BNE   BLDESD4                  SKIP IF SO                      33062000
         NC    FSTCSECT,FSTCSECT        SEE IF FIRST CSECT              33063000
         BNE   BLDESD3                  SKIP IF NOT                     33064000
         STH   R3,FSTCSECT              FIRST CSECT ESD NUMBER          33065000
BLDESD3  CLI   XTYPE,ETYPEPC            PRIVATE CODE                    33066000
         BNE   BLDESD4                  SKIP IF NOT                     33067000
         STH   R2,JESDID                ESDID OF PRIVATE CODE           33068000
BLDESD4  LR    R10,R3                   ESD NUMBER                      33069000
         GOTO  GETESD                   GET ESD ENTRY                   33070000
         LM    R2,R3,XTYPE              TYPE, ESDID, ADDRESS            33071000
         SR    R4,R4                    INITIALIZE                      33072000
         LM    R5,R6,XNAME              NAME                            33073000
         STM   R2,R6,ETYPE-ETYPE(R10)   CREATE ESD ENTRY                33074000
         B     EXIT                     EXIT                            33075000
BLDESD5  CLC   SFLGS,XFLGB              SEE IF SAME TYPE SECTION        33076000
         BE    BLDESD6                  RESUME SECTION IF SAME          33077000
         NI    XPARM,BITFF-(XDUMMY)     DISCOUNT EXTERNAL DUMMYS        33078000
         CLC   SFLGS,XPARM              GIVE IT ANOTHER CHANCE          33079000
         BE    BLDESD6                  LET THIS ONE GO                 33080000
         SET   PRIORDEF,ON              INDICATE PREVIOUSLY DEFINED     33081000
         B     BLDESD1                  IGNORE NAME                     33082000
BLDESD6  LH    R10,SLNGQ                ESD ASCENDSION NUMBER           33083000
         GOTO  GETESD                   RESUME ESD ENTRY                33084000
         SET   DEFINED,ON               INDICATE RESUMED SECTION        33085000
         B     EXIT                     EXIT                            33086000
         EJECT                                                          33087000
*TITLE-  GETESD                                                       * 33088000
*                                                                     * 33089000
*FUNCTION/OPERATION-                                                  * 33090000
*        GET AN ESD ENTRY                                             * 33091000
*                                                                     * 33092000
*INPUT-  R10 CONTAINS THE ESD NUMBER                                  * 33093000
*                                                                     * 33094000
*OUTPUT- R10 CONTAINS A POINTER TO THE ENTRY                          * 33095000
*                                                                     * 33096000
         SPACE                                                          33097000
GETESD   BALR  R14,R7                   SAVE REGISTER IN STACK          33098000
         LR    R8,R12                   SET UP BASE REGISTER            33099000
         LR    R2,R10                   INTO WORK REGISTER              33100000
         LA    R10,D16*D32           MAXIMUM ESD ENTRIES - 512 FX0002   33101000
         CR    R10,R2                   SEE IF EXCEEDED                 33102000
         BNL   GETESD0                  NOPE                            33103000
         BAL   R9,GETESD                RECURSIVE CALL                  33104000
         SET   JESDOFLO,ON              INDICATE ESD OVERFLOW           33105000
         MVI   D0(R10),D3               OVERFLOW ENTRY                  33106000
         XC    D1(D19,R10),D1(R10)      INITIALIZE                      33107000
         B     EXIT                     RETURN                          33108000
GETESD0  BCTR  R2,D0                    ESD NUMBER                      33109000
         SRDL  R2,D4                    BLOCK NUMBER                    33110000
         LR    R4,R2                    NOTE/POINT ADDRESS FOR BLOCK    33111000
         MH    R4,=H'9'                 X                               33112000
         LA    R4,NOTELIST(R4)          X                               33113000
         SRL   R3,D28                   DISPLACEMENT                    33114000
         MH    R3,=H'20'                DISPLACEMENT                    33115000
         TM    D8(R4),BIT7              SEE IF THIS A NEW BLOCK         33116000
         BO    GETESD4                  NO                              33117000
         TM    FILELAST+D8,BIT7         SEE IF FLIE POSITIONED TO WRITE 33118000
         BZ    GETESD1                  YES                             33119000
         JPOINT  FILE=FILE2,ADDR=FILELAST,NEXT=WRITE   POSITION FILE    33120000
GETESD1  LA    R5,ESDBLK2               POINT TO SECOND BLOCK           33121000
         CR    R5,R6                    SEE IF BLOCK CURRENTLY IN USE   33122000
         BH    GETESD2                  NO                              33123000
         LA    R5,ESDBLK1               POINT TO FIRST BLOCK            33124000
GETESD2  JWRITE  FILE=FILE2,PARM=(R5)   WRITE DESIGNATED BLOCK          33125000
         MVI   FILELAST+D8,D0           INDICATE FILE POSITIONED TO END 33126000
         JCHECK  FILE=FILE2             CHECK WRITE OPERATION           33127000
         JNOTE   FILE=FILE2             NOTE ADDRESS OF BLOCK ON FILE   33128000
         LH    R1,D6(,R5)               BLOCK NUMBER OF BLOCK WRITTEN   33129000
         MH    R1,=H'9'                 NOTE/POINT ADDRESS FOR BLOCK    33130000
         LA    R1,NOTELIST(R1)          X                               33131000
         MVI   D8(R1),BIT6              INDICATE BLOCK ON FILE          33132000
         MVC   D0(D8,R1),JNOTEVAL       SAVE BLOCK NOTE/POINT ADDRESS   33133000
         MVC   FILELAST(D8),JNOTEVAL    NOTE/POINT ADDRESS OF FILE END  33134000
         TM    D8(R4),BIT6              SEE IF BLOCK ON FILE            33135000
         BZ    GETESD3                  NOPE                            33136000
         JPOINT  FILE=FILE2,ADDR=(R4),NEXT=READ   POINT TO BLOCK        33137000
         JREAD   FILE=FILE2,PARM=(R5)   BRING IN BLOCK                  33138000
         MVI   FILELAST+D8,BIT7         INDICATE FILE NOT POSITIONED    33139000
         JCHECK  FILE=FILE2             CHECK READ OPERATION            33140000
GETESD3  ST    R5,JFWORD1               ADDRESS OF BLOCK                33141000
         MVI   D8(R4),BIT7              INDICATE BLOCK IS IN CORE       33142000
         MVC   D0(D4,R4),JFWORD1        SAVE ADDRESS OF BLOCK IN CORE   33143000
GETESD4  MVC   JFWORD1,D0(R4)           ADDRESS TO FULLWORD BOUNDARY    33144000
         L     R5,JFWORD1               ADDRESS OF BLOCK IN CORE        33145000
         STH   R2,D6(,R5)               BLOCK NUMBER                    33146000
         LA    R10,D8(R3,R5)            POINT TO ENTRY REQUESTED        33147000
         B     EXIT                     RETURN                          33148000
         EJECT                                                          33149000
*TITLE-  MAKESD                                                       * 33150000
*                                                                     * 33151000
*FUNCTION/OPERATION-                                                  * 33152000
*        CREATE THE ESD ADJUSTMENT TABLE                              * 33153000
*        ESD FINISHING AND OUTPUT                                     * 33154000
*                                                                     * 33155000
*INPUT-  THE EXTERNAL SYMBOL DICTIONARY (ESD).                        * 33156000
*                                                                     * 33157000
*OUTPUT- THE ESD ADJUSTMENT TABLE.                                    * 33158000
*        THE EXTERNAL SYMBOL DICTIONARY ON THE SYSTEM OUTPUT FILES.   * 33159000
*                                                                     * 33160000
         SPACE                                                          33161000
ENTRY    BALR  R14,R7                  SAVE REGISTERS IN STACK          33162000
         LR    R8,R12                  SET UP BASE REGISTER             33163000
         LR    R10,R4                  PASS RECORD POINTER              33164000
         MVI   RFLGB,ESDNRSW+ENTRYSW    SET FLAGS                       33165000
         GOTO  FIND                     LOOKUP IN SYMBOL TABLE          33166000
         BZ    ENTRY2                   ERROR                           33167000
         GOIF  (MODE1,MODE2),ANY=EXIT   SUSPEND ACTION IF NOT MODE IA   33168000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           33169000
         LH    R10,HIESDNR              GET HIGHEST ESD NUMBER          33170000
         LA    R10,D1(,R10)             GET NEXT ESD NUMBER             33171000
         STH   R10,HIESDNR              SAVE                            33172000
         STH   R10,SLNGQ                ESD ASCENDSION NUMBER           33173000
         GOTO  GETESD                   FIND ROOM IN ESD                33174000
         MVI   ETYPE-EITEM(R10),ETYPELX PRIME ESD ENTRY                 33175000
ENTRY1   MVI   RTYPE,JTSYMBL            CHECK BACK IN PASS 2            33176000
         B     EXIT                     FINIS                           33177000
ENTRY2   GOIF  (ESDNRSW,XENTRY,CSECTSW,DSECTSW),ALL=ENTRY1,MIX=ENTRY3   33178000
         GOIF  (CSW,DSW,ESW),ANY=ENTRY3 INVALID                 OX00106 33179000
         SR    R0,R0                    SEE IF                          33180000
         CH    R0,SESDI                 ABSOLUTE                        33181000
         BZ    ENTRY3                   BAD                             33182000
         SET   XENTRY,ON                INDICATE VALID ENTRY            33183000
         OI    RFLGB,XENTRY             INDICATE VALID ENTRY            33184000
         MVC   RESDI(D6),SESDI          ESDID AND ADDRESS               33185000
         LH    R10,HIESDNR              GET HIGHERS ESD NUMBER          33186000
         LA    R10,D1(,R10)             GET NEXT ESD NUMBER             33187000
         STH   R10,HIESDNR              SAVE                            33188000
         GOTO  GETESD                   GET ESD ENTRY                   33189000
         MVI   ETYPE-EITEM(R10),ETYPELD ESD ENTRY TYPE                  33190000
         MVC   EESDI-EITEM(D6,R10),RESDI     ESDID AND VALUE            33191000
         MVC   ENAME-EITEM(D8,R10),RNAME     NAME                       33192000
         MVI   RTYPE,JTADJII            ADJUST VALUE IN IIA             33193000
         B     EXIT                     FINIS                           33194000
ENTRY3   MVI   RTYPE,JTPASS             INVALID ENTRY                   33195000
         B     EXIT                     FINIS                           33196000
EXTRN    BALR  R14,R7                   SAVE REGISTERS IN STACK         33197000
         LR    R8,R12                   SET UP BASE REGISTER            33198000
         LA    R2,D1                    INCREMENT                       33199000
         LR    R3,R2                    IN TWO REGISTERS                33200000
         STH   R2,RLNGQ                 LENGTH ATTRIBUTE OF SYMBOL      33201000
         AH    R2,HICESDID              NEXT ESDID                      33202000
         AH    R3,HIESDNR               NEXT ESD NUMBER                 33203000
EXTRN1   STH   R2,RESDI                 ESDID                           33204000
         SET   ESW1,ON                  SET EXTRN/EQU FLAG      OX00106 33205000
EXTRN2   XI    RNAME,BIT0               UNIQUE NAME                     33206000
         LR    R10,R4                   PASS RECORD POINTER             33207000
         GOTO  ENTER                    ENTER INTO SYMBOL TABLE         33208000
         BNE   EXTRN5                   ALREADY IN SYMBOL TABLE         33209000
         TM    RNAME,BIT0               SEE IF FIRST TIME AROUND        33210000
         BNE   EXTRN2                   ENTER SECOND TIME IF FIRST      33211000
         CH    R3,HIESDNR               SEE IF NEW ENTRY                33212000
         BNH   EXTRN3                   SKIP IF NOT NEW                 33213000
         STH   R2,HICESDID              SAVE NEW ESDID                  33214000
         STH   R3,HIESDNR               SAVE NEW0ESD NUMBER             33215000
EXTRN3   LR    R10,R3                   PASS ESD NUMBER                 33216000
         GOTO  GETESD                   GET ESD ENTRY                   33217000
         MVC   ETYPE-EITEM(D8,R10),RTYPE                                33218000
         MVC   ENAME-EITEM(D8,R10),RNAME                                33219000
EXTRN4   MVI   RTYPE,JTPASS             NO PROCESS RECORD IN PASS 2     33220000
         B     EXIT                                                     33221000
EXTRN5   LH    R2,SESDI                 GET ESDID OF PREVIOUS ENTRY     33222000
         LH    R3,SLNGQ                 GET ESD ASCENDSION NUMBER       33223000
         TM    RNAME,BIT0               SEE IF FIRST TIME AROUND        33224000
         BNE   EXTRN1                   GO AGAIN IF FIRST               33225000
         SET   PRIORDEF,ON              INDICATE PREVIOUSLY DEFINED     33226000
         B     EXTRN4                   EXIT                            33227000
VCON     BALR  R14,R7                   SAVE REGISTERS IN STACK         33228000
         LR    R8,R12                   SET UP BASE REGISTER            33229000
         LR    R3,R2                    IN TWO REGISTERS                33230000
         AH    R2,HICESDID              GET NEXT ESDID                  33231000
         AH    R3,HIESDNR               GET NEXT ESD NUMBER             33232000
         STH   R2,XESDI                 ESDID                           33233000
         STH   R3,XLNGQ                 ESD NUMBER                      33234000
         MVI   XTYPE,ETYPEER            TYPE                            33235000
         MVI   XFLGB,ESDNRSW            FLAGS                           33236000
         OI    XNAME,BIT0               EXTERNAL NAME                   33237000
         SR    R0,R0                    ZERO                            33238000
         STH   R0,XLCTR                 VALUE                           33239000
         LA    R10,XWORK                POINTER TO ENTRY                33240000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           33241000
         BNZ   EXIT                     ALREADY IN SYMBOL TABLE         33242000
         STH   R2,HICESDID              SAVE ESDID                      33243000
         STH   R3,HIESDNR               SAVE ESD NUMBER                 33244000
         XI    XNAME,BIT0               RESET                           33245000
         LR    R10,R3                   GET ESD NUMBER                  33246000
         GOTO  GETESD                   GET ESD ENTRY                   33247000
         MVC   ETYPE-EITEM(D8,R10),XTYPE     TYPE, FLAGS, ESDID, VALUE  33248000
         MVC   ENAME-EITEM(D8,R10),XNAME     NAME                       33249000
         B     EXIT                     RETURN                          33250000
QCON     BALR  R14,R7                   SAVE REGISTERS IN STACK         33251000
         LR    R8,R12                   SET UP BASE REGISTER            33252000
         LA    R10,XWORK                PASS POINTER TO WORK AREA       33253000
         GOTO  FIND                     LOOKUP IN SYMBOL TABLE          33254000
         BNE   EXIT                     NOT IN SYMBOL TABLE             33255000
         GOIF  (ESDNRSW,DSECTSW,DSCOMSW,XDUMMY),NOTALL=EXIT VALID NAME  33256000
         SET   XDUMMY,OFF               ONE TIME ONLY PER DSECT NAME    33257000
         LR    R10,R2                   INCREMENT IN TWO REGISTERS      33258000
         AH    R2,HICESDID              NEXT ESDID                      33259000
         STH   R2,HICESDID              SAVE ESDID                      33260000
         LH    R3,SLNGQ                 ESD ASCENDSION NUMBER           33261000
         AH    R10,HIESDNR              NEXT ESD NUMBER                 33262000
         STH   R10,HIESDNR              SAVE ESD NUMBER                 33263000
         GOTO  GETESD                   GET ESD ENTRY                   33264000
         MVC   ENAME-EITEM(D8,R10),XNAME     NAME                       33265000
         STH   R2,EESDI-EITEM(,R10)     ESDID                           33266000
         OI    ESWTS-EITEM(R10),QDSW2   INDICATE XD ENTRY               33267000
         STH   R3,EHILC-EITEM(,R10)     ESD ASCENDSION NUMBER           33268000
         MVI   ETYPE-EITEM(R10),ETYPEDX TYPE                            33269000
         B     EXIT                     EXIT                            33270000
SUMESD   BALR  R14,R7                   PUSH DOWN ONE MORE LEVEL        33271000
SUMGET   LR    R10,R4                   PASS                            33272000
         BAL   R2,GOTESD                GET ESD ITEM                    33273000
         SR    R2,R2                    ZERO FUNCTION BYTE REGISTER     33274000
         TRT   ETYPE,SUMTBL             GET ROUTINE ADDRESS             33275000
         B     SUMGET(R2)               GO TO ROUTINE                   33276000
SUMCST   LM    R14,R15,ELCTR            GET CURRENT AND HIGH ADDRESS    33277000
         CR    R14,R15                  SEE IF CURRENT IS ALSO HIGH     33278000
         BNH   SUMCST1                  SKIP IF NOT                     33279000
         LR    R15,R14                  SAVE HIGH                       33280000
SUMCST1  SR    R14,R14                  ASSUME NO OFFSET                33281000
         GOIF  (CSW2,DSW2),ANY=SUMCST3  NO OFFSET FOR DSECTS OR COMS    33282000
         L     R14,STARTLOC             GET START ADDRESS               33283000
         NR    R14,R5                   ROUND TO SECTION ALIGNMENT      33284000
         LA    R0,D7                    INCREMENT                       33285000
         AR    R0,R14                   COMPUTE NEXT START ADDRESS      33286000
         AR    R0,R15                   COMPUTE NEXT START ADDRESS      33287000
         ST    R0,STARTLOC              SAVE                            33288000
         LTR   R14,R14                  SEE IF ADJUSTMENT REQUIRED      33289000
         BZ    SUMCST3                  NOPE                            33290000
         ST    R14,D4(,R4)              ADJUSTMENT FACTOR               33291000
         MVC   D0(D2,R4),EESDI          ARGUMENT ESDID                  33292000
SUMCST2  MVC   D2(D2,R4),EESDI          TARGET ESDID                    33293000
         SR    R4,R5                    POINT TO NEXT ADJUSTMENT ENTRY  33294000
SUMCST3  STM   R14,R15,ELCTR            ADDRESS AND LENGTH              33295000
         B     SUMGET                   CONTINUE WITH NEXT ENTRY        33296000
SUMDXD   LM    R15,R0,ELCTR             GET LENGTH AND ALIGNMENT FACTOR 33297000
         LR    R14,R0                   REORDER                         33298000
         B     SUMCST3                  SKIP                            33299000
SUMDSD   MVI   ETYPE,ETYPEXD            CHANGE TYPE                     33300000
         LH    R10,EHILC                GET ESD ASCENDSION NUMBER       33301000
         GOTO  GETESD                   GET ESD ENTRY                   33302000
         LA    R14,D7                   ALIGNMENT FACTOR                33303000
         L     R15,EHILC-EITEM(,R10)    LENGTH                          33304000
         XC    D4(D4,R4),D4(R4)                                         33305000
         MVC   D0(D2,R4),EESDI-EITEM(R10)                               33306000
         B     SUMCST2                                                  33307000
GOTESD   LA    R3,D1(,R3)               GET NEXT ESD NUMBER             33308000
         CH    R3,HIESDNR               SEE IF ALL THROUGH              33309000
         BH    EXIT                     FINIS                           33310000
         LR    R10,R3                   PASS ESD NUMBER                 33311000
         GOTO  GETESD                   GET ESD ENTRY                   33312000
         LR    R6,R10                   RETURN POINTER                  33313000
         BR    R2                       RETURN                          33314000
MAKESD   BALR  R14,R7                   SAVE REGISTERS IN STACK         33315000
         LR    R8,R12                   SET UP BASE REGISTER            33316000
         L     R4,LATEND                ESD ADJUSTMENT TABLE POINTER    33317000
         LH    R5,=H'-8'                INCREMENT                       33318000
         MVI   CARDADDR+D3,48           FLUSH CARD PUNCH BUFFER         33319000
         SR    R3,R3                    ESD NUMBER INITIALIZED          33320000
         BAL   R9,SUMESD                SUM CONTROL SECTIONS            33321000
         S     R10,LATEND               LENGTH OF ESD ADJUSTMENT TABLE  33322000
         LR    R11,R5                   INCREMENT                       33323000
         STM   R10,R11,ADJINDEX         SAVE FOR PASS TWO               33324000
MAKGET   BAL   R2,GOTESD                GET NEXT SEQUENTIAL ESD ENTRY   33325000
         SR    R2,R2                    ZERO FUNCTION BYTE REGISTER     33326000
         LR    R10,R2                   CLEAR REGISTER                  33327000
         TRT   ETYPE,MAKTBL             GET ROUTINE ADDRESS             33328000
         B     MAKGET(R2)               GO TO ROUTINE                   33329000
MAKCST   SET   (QDSW2,DSW2,CSW2),OFF    RESET XD DSECT OR COM BITS      33330000
         CLI   ENAME,J9                 SEE IF NAMED                    33331000
         BH    PRTESD                   SKIP IF NAMED                   33332000
MAKPVT   MVI   ENAME,JBLANK             FAKE THE BLANK                  33333000
         B     PRTESD                   PRINT ESD ITEM                  33334000
MAKTRY   LM    R14,R1,ADJINDEX          ESD ADJUSTMENT INDEX            33335000
         LH    R10,EESDI                GET ESDID                       33336000
MAKTRY1  BXLE  R14,R15,PRTESD           SEE IF ADJUSTMENT REQUIRED      33337000
         CH    R10,D0(R1,R14)           SEE IF THIS IS THE ENTRY        33338000
         BNE   MAKTRY1                  NO, KEEP LOOKING                33339000
         L     R10,D4(R1,R14)           GET ADJUSTMENT FACTOR           33340000
         A     R10,ELCTR                ADD OFFSET                      33341000
MAKEXT   ST    R10,ELCTR                SAVE                            33342000
         EJECT                                                          33343000
*TITLE-  PRTESD                                                       * 33344000
*                                                                     * 33345000
*FUNCTION/OPERATION-                                                  * 33346000
*        PRINT AN ITEM IN THE EXTERNAL SYMBOL DICTIONARY              * 33347000
*                                                                     * 33348000
*INPUT-  REGISTER R10 IS A POINTER TO AN ESD ENTRY                    * 33349000
*                                                                     * 33350000
*OUTPUT- THE EXTERNAL SYMBOL DICTIONARY                               * 33351000
*                                                                     * 33352000
         SPACE                                                          33353000
PRTESD   EQU   *                                                        33354000
         GOIF  (JESD,JLIST),NOTALL=PCHESD    SKIP IF NOT OPTIONED       33355000
         LH    R5,LINECNT               GET LINE COUNT                  33356000
         GOIF  (R5),POS=PRTESD2         SKIP IF NOT END OF PAGE         33357000
         JPRINT                         GET PRINT BUFFER                33358000
         SET   EJECT                    CARRIAGE CONTROL FOR TITLE LINE 33359000
         MVC   DECKID,JDECKID           DECK IDENTIFIER                 33360000
         MVC   TITLE,ZTITLE             SET TITLE                       33361000
         MVC   PAGE,ZPAGEZ              SET PAGE NUMBER DESIGNATOR      33362000
         LH    R14,JPAGENO              GET OLD PAGE NUMBER             33363000
         LA    R14,1(,R14)              INCREMENT BY 1                  33364000
         STH   R14,JPAGENO              SAVE PAGE NUMBER                33365000
         CVD   R14,JDWORD               CONVERT PAGE NUMBER TO DECIMAL  33366000
         UNPK  PAGENO,JDWORD+6(2)       UNPACK TO EBCDIC CODE           33367000
         NC    PAGENO,DIGMASK           CONVERT TO INTERNAL CHARACTERS  33368000
         GOIF  PAGENO,J0,NOTEQ=PRTESD1  SKIP IF NOT A LEADING ZERO      33369000
         MVI   PAGENO,JBLANK            FORCE TO A BLANK                33370000
         GOIF  PAGENO+1,J0,NOTEQ=PRTESD1     SKIP IF NOT A LEADING ZERO 33371000
         MVI   PAGENO+1,JBLANK          FORCE TO A BLANK                33372000
PRTESD1  JPRINT                         GET PRINT BUFFER                33373000
         MVC   HEADING,ZHEADING         SET SUBTITLE                    33374000
         MVC   LVTMDT,JLVTMDT           SET ASSEMBLER LEVEL, TIME, DATE 33375000
         LH    R5,JLNCT                 GET MAXIMUM LINE COUNT          33376000
PRTESD2  JPRINT                         GET PRINT BUFFER                33377000
         SET   SPACE1                   CARRIAGE CONTROL FOR LINE       33378000
         CH    R5,JLNCT                 COMPARE TO MAXIMUM LINE COUNT   33379000
         BL    PRTESD3                  SKIP IF NOT REACHED             33380000
         SET   SPACE2                   CARRIAGE CONTROL FOR FIRST LINE 33381000
PRTESD3  BCTR  R5,0                     DECREMENT LINE COUNT            33382000
         STH   R5,LINECNT               SAVE LINE COUNT                 33383000
         MVC   ZSYMBOL,ENAME            SET NAME                        33384000
         TRT   ETYPE,ZTYPESZ            TRANSLATE FIRST CHARACTER       33385000
         STC   R2,ZTYPE                 TO OUTPUT ITEM                  33386000
         TRT   ETYPE,ZTYPESZ+D7         TRANSLATE SECOND CHARACTER      33387000
         STC   R2,ZTYPE+D1              TO OUTPUT ITEM                  33388000
         UNPK  ZID(L'ZID+1),EESDI(L'EESDI+1) UNPACK WITH ROOM TO SPARE  33389000
         NC    ZID,DIGMASK              CONVERT TO INTERNAL CHARACTERS  33390000
         MVI   ZID+L'ZID,JBLANK         REPAIR DAMAGE                   33391000
         NI    ZID+1,BITFF-ESW-EQUF                            @OY08064 33392000
         GOIF  ETYPEER,EQUAL=PCHESD     FINIS FOR EXTERNAL REFERENCE    33393000
         GOIF  ETYPEWX,EQUAL=PCHESD     FINIS FOR EXTERNAL REFERENCE    33394000
         UNPK  ZADDR(L'ZADDR+1),ELCTR(L'ELCTR+1)  UNPACK WITH EXCESS    33395000
         NC    ZADDR,DIGMASK            CONVERT TO INTERNAL CHARACTERS  33396000
         MVI   ZADDR+L'ZADDR,JBLANK     REPAIR DAMAGE                   33397000
         GOIF  ETYPELD,NOTEQ=PRTESD4    SKIP IF NOT LD TYPE             33398000
         MVC   ZLDID,ZID                PUT IN PROPER PERSPECTIVE       33399000
         MVC   ZID,ZID-1                REPAIR                          33400000
         B     PCHESD                   FINISHED IF LD TYPE             33401000
PRTESD4  UNPK  ZLENGTH(L'ZLENGTH+1),EHILC(L'EHILC+1)   UNPACK           33402000
         NC    ZLENGTH,DIGMASK          CONVERT TO INTERNAL CHARACTERS  33403000
         MVI   ZLENGTH+L'ZLENGTH,JBLANK REPAIR                          33404000
         EJECT                                                          33405000
*TITLE-  PCHESD                                                       * 33406000
*                                                                     * 33407000
*FUNCTION/OPERATION-                                                  * 33408000
*        PUNCH ONE ITEM IN THE EXTERNAL SYMBOL DICTIONARY.            * 33409000
*                                                                     * 33410000
*INPUT-  REGISTER R6 IS A POINTER TO ONE ITEM IN THE EXTERNAL SYMBOL  * 33411000
*   DICTIONARY.                                                       * 33412000
*                                                                     * 33413000
*OUTPUT- THE EXTERNAL SYMBOL DICTIONARY ON THE PUNCH AND LINK FILES.  * 33414000
*                                                                     * 33415000
         SPACE                                                          33416000
PCHESD   GOIF  (JDECK,JLINK),NONE=MAKGET     RETURN IF NOT OPTIONED     33417000
         LM    R10,R11,CARDADDR         GET ADDRESS OF CARD             33418000
         CLI   CARDADDR+D3,48           SEE IF ANOTHER CARD NEEDED      33419000
         BL    PCHESD1                  NOT NECESSARILY                 33420000
         JPUNCH  SEQ=YES                GET ANOTHER CARD BUFFER         33421000
         SET   JENDCHK,ON               PUNCH END CARD WHEN TIME COMES  33422000
         MVC   CARDID,ZESDZ             CARD IDENTIFIER                 33423000
         TR    CARDID+D1(71),JTRTABLE   TRANSLATE TO EXTERNAL CODE      33424000
         MVI   DATALN,D0                HIGH ORDER BYTE OF FIELD ZEROED 33425000
         SR    R10,R10                  NEW CARD BUFFER INDICATION      33426000
PCHESD1  LA    R10,NEXTITEM             POINT TO NEXT ENTRY SPACE       33427000
         STM   R10,R11,CARDADDR         SAVE ADDRESS OF CARD            33428000
         STC   R10,DATALN+1             LENGTH OF DATA                  33429000
         ALR   R10,R11                  POINTER TO ESD DATA ITEM IN R3  33430000
         MVC   ZZSYMBOL,ENAME           SET NAME                        33431000
         TR    ZZSYMBOL,JTRTABLE        CONVERT TO EXTERNAL CHARACTERS  33432000
         MVC   ZZTYPE,ETYPE             SET TYPE                        33433000
         MVC   ZZADDR,ELCTR+L'ELCTR-L'ZZADDR SET ADDRESS                33434000
         GOIF  ETYPEXD,NOTEQ=PCHESD3    SKIP IF NOT XD TYPE             33435000
         MVC   ZZADDR(L'ZZADDR+L'ZZALGN),ELCTR    SET ALIGNMENT FACTOR  33436000
PCHESD3  GOIF  ETYPELD,NOTEQ=PCHESD4    SKIP IF NOT LD TYPE             33437000
         MVC   ZZLENGTH+L'ZZLENGTH-L'EESDI(L'EESDI),EESDI   LDID        33438000
         MVI   ZZLENGTH,X'00'           PAD WITH LEADING ZEROS          33439000
         B     MAKGET                   FINIS                           33440000
PCHESD4  TM    FIRSTID,X'F0'            SEE IF ESDID SET                33441000
         BZ    PCHESD5                  SKIP IF ALREADY SET             33442000
         MVC   FIRSTID,EESDI            SET ESDID OF FIRST NON LD ITEM  33443000
         NI    FIRSTID,BITFF-BIT4-EQUF                         @OY08064 33444000
PCHESD5  GOIF  ETYPEER,EQUAL=MAKGET     FINIS FOR EXTERNAL REFERENCE    33445000
         GOIF  ETYPEWX,EQUAL=MAKGET     FINIS FOR EXTERNAL REFERENCE    33446000
         MVC   ZZLENGTH,EHILC+L'EHILC-L'ZZLENGTH  SET LENGTH            33447000
         B     MAKGET                   FINIS                           33448000
         EJECT                                                          33449000
REFER    BALR  R14,R7                   SAVE REGISTERS IN STACK         33450000
         LR    R8,R12                   SET UP BASE REGISTER            33451000
         MVC   XWORK(D12),=AL1(0,24,JPSOP,0,JTSYMBL,0,0,0,0,0,0,0)      33452000
         LA    R10,XWORK                SYMBOL POINTER                  33453000
         GOTO  FIND                     LOOK UP IN SYMBOL TABLE         33454000
         BZ    REFER2                   FIND IN SYMBOL TABLE            33455000
REFER1   GOIF  MODE2,ON=EXIT            DUMPING LITERALS ON OVERFLOW    33456000
         B     REFER4                   UNDEFINED AS YET                33457000
REFER2   GOIF  ENTRYSW,ON=REFER1        NOT A DEFINED SYMBOL            33458000
         MVC   XTYPE(D2),=AL1(JTADJII,DEFINED+PRIORDEF)                 33459000
         GOIF  MODE2,OFF=REFER3         SKIP IF NOT OVERFLOW            33460000
         MVI   XTYPE,JTSYMII            REHASH IN PASS TWO              33461000
REFER3   MVC   XFLGB,SFLGS              SYMBOL FLAGS                    33462000
         MVC   XESDI(D6),SESDI          ESDID AND VALUE                 33463000
         LH    R15,SLNGQ                LENGTH ATTRIBUTE                33464000
         GOIF  ESDNRSW,OFF=REFER5       EXTERNAL SYMBOL                 33465000
REFER4   LA    R15,D1                   LENGTH ATTRIBUTE                33466000
REFER5   STH   R15,XLNGQ                SET LENGTH ATTRIBUTE            33467000
         LR    R11,R10                                                  33468000
         LH    R10,JOUTFILE             OUTPUT FILE ADDRESS             33469000
         JPUTM FILE=(R10),ADDR=(R11)                                    33470000
         B     EXIT                     FINIS                           33471000
         EJECT                                                          33472000
*                        CONSTANTS                                    * 33473000
         SPACE                                                          33474000
OIINST   OI    D0(R15),D0               EXECUTED INSTRUCTION            33475000
DIGMASK  JGENIN  'FFFFFF'               DIGIT MASK                      33476000
ZTYPESZ  JGENIN  'SLEXPCXDDRWCMDXXXX'   TYPES                           33477000
SUMTBL   DC    AL1(SUMCST-SUMGET)       00 - (SD) CONTROL SECTION       33478000
         DC    AL1(SUMGET-SUMGET)       01 - (LD) LABEL DEFINITION      33479000
         DC    AL1(SUMGET-SUMGET)       02 - (ER) EXTERNAL REFERENCE    33480000
         DC    AL1(SUMGET-SUMGET)       03        OVERFLOW ENTRY        33481000
         DC    AL1(SUMCST-SUMGET)       04 - (PC) PRIVATE CODE          33482000
         DC    AL1(SUMCST-SUMGET)       05 - (CM) COMMON                33483000
         DC    AL1(SUMDXD-SUMGET)       06 - (XD) EXTERNAL DUMMY        33484000
         DC    AL1(SUMDSD-SUMGET)       07 -      EXTERNAL DUMMY        33485000
         DC    AL1(SUMCST-SUMGET)       08 -      DUMMY CONTROL SECTION 33486000
         DC    AL1(SUMGET-SUMGET)       09        UNDEFINED ENTRY       33487000
         DC    AL1(SUMGET-SUMGET)       0A - (WX) EXTERNAL REFERENCE    33488000
MAKTBL   DC    AL1(PRTESD-MAKGET)       00 - (SD) CONTROL SECTION       33489000
         DC    AL1(MAKTRY-MAKGET)       01 - (LD) LABEL DIFINITION      33490000
         DC    AL1(MAKEXT-MAKGET)       02 - (ER) EXTERNAL REFERENCE    33491000
         DC    AL1(MAKGET-MAKGET)       03        OVERFLOW ENTRY        33492000
         DC    AL1(MAKPVT-MAKGET)       04 - (PC) PRIVATE CODE          33493000
         DC    AL1(MAKCST-MAKGET)       05 - (CM) COMMON                33494000
         DC    AL1(MAKCST-MAKGET)       06 - (XD) EXTERNAL DUMMY        33495000
         DC    AL1(MAKGET-MAKGET)       07 -      NOT USED              33496000
         DC    AL1(MAKGET-MAKGET)       08 -      DSECT                 33497000
         DC    AL1(MAKGET-MAKGET)       09 -      UNDEFINED ENTRY       33498000
         DC    AL1(MAKEXT-MAKGET)       0A - (WX) EXTERNAL REFERENCE    33499000
ZESDZ    DC    B'00000010'              12-9-2 CARD IDENTIFIER          33500000
         JGENIN  'ESD'                  ESD CARD IDENTIFIER             33501000
ZPAGEZ   JGENIN  'PAGE'                 PAGE NUMBER DESIGNATOR          33502000
ZTITLE   JGENIN  'EXTERNAL SYMBOL DICTIONARY'     ESD TITLE             33503000
ZHEADING DC    YL1(SPACE3)              CARRIAGE CONTROL CHARACTER      33504000
         JGENIN  'SYMBOL   TYPE  ID   ADDR  LENGTH LDID'    SUBTITLE    33505000
         EJECT                                                          33506000
DSECT10  DSECT  ,                                                       33507000
         ORG   DSECT10                                                  33508000
         SPACE                                                          33509000
ZZSYMBOL DS    C'XXXXXXXX'              NAME, BLANK FOR PC OR BLANK CM  33510000
ZZTYPE   DS    C'X'                     TYPE                            33511000
ZZADDR   DS    C'XXX'                   ADDRESS                         33512000
ZZALGN   DS    C'X'                     ALIGNMENT FACTOR FOR SC TYPE    33513000
ZZLENGTH DS    C'XXX'                   LENGTH                          33514000
NEXTITEM EQU   *                        NEXT ITEM FOLLOWS IMMEDIATELY   33515000
         SPACE                                                          33516000
         SPACE                                                          33517000
DSECT11  DSECT ,                                                        33518000
         ORG   DSECT11                                                  33519000
         SPACE                                                          33520000
CARD     DS    0CL72                                                    33521000
CARDID   DS    C' ESD'                  CARD IDENTIFIER                 33522000
         DS    C'      '                BLANK                           33523000
DATALN   DS    H                        NUMBER OF BYTES OF ESD DATA     33524000
         DS    C'  '                    BLANK                           33525000
FIRSTID  DS    H                        ESDID OF FIRST NON LD TYPE ITEM 33526000
DATAITEM DS    CL16                                                     33527000
         SPACE                                                          33528000
         SPACE                                                          33529000
         ORG   DSECT11                                                  33530000
         SPACE                                                          33531000
LINE     DS    0CL121                                                   33532000
CTLCHAR  DBV   EJECT(0),SPACE1(1),SPACE2(2),SPACE3(3)  CARRIAGE CONTROL 33533000
DECKID   DS    CL8                      DECK IDENTIFIER                 33534000
         ORG   LINE+48                                                  33535000
TITLE    DS    C'EXTERNAL SYMBOL DICTIONARY' ESD TITLE                  33536000
         ORG   LINE+112                                                 33537000
PAGE     DS    C'PAGE'                  PAGE NUMBER DESIGNATOR          33538000
         ORG   LINE+118                                                 33539000
PAGENO   DS    C'000'                   PAGE NUMBER                     33540000
         ORG   LINE                                                     33541000
HEADING  DS    C'3SYMBOL   TYPE  ID   ADDR  LENGTH LDID'                33542000
         ORG   LINE+L'LINE-L'JLVTMDT                                    33543000
LVTMDT   DS    CL(L'JLVTMDT)            ASSEMBLER LEVEL, TIME, DATE     33544000
         ORG   LINE+1                                                   33545000
ZSYMBOL  DS    C'XXXXXXXX'              NAME, BLANK FOR PC OR BLANK CM  33546000
         DS    C'  '                    SPACES                          33547000
ZTYPE    DS    C'XX'                    ESD ITEM TYPE                   33548000
         DS    C'  '                    SPACES                          33549000
ZID      DS    C'XXXX'                  ESD IDENTIFIER, IF NON LD TYPE  33550000
         DS    C' '                     SPACE                           33551000
ZADDR    DS    C'XXXXXX'                ADDRESS, IF TYPE SD, PC, LD     33552000
         DS    C' '                     SPACE                           33553000
ZLENGTH  DS    C'XXXXXX'                LENGTH, IF TYPE SD, PC, CM, SC  33554000
         DS    C' '                     SPACE                           33555000
ZLDID    DS    C'XXXX'                  ESD IDENTIFIER OF SD ENTRY      33556000
         MEND                                                           33557000
./ ADD NAME=XEVAL                                                       33558000
         MACRO                                                          33559000
&ID      XEVAL &DUMMY,&TESTRAN=NO,&DIAG=NO,&LEVEL=1,&LOGERR=NO          33560000
         GBLC  &COMPNM                                                  33561000
         LCLC  &NM                                                      33562000
         JHEAD 'EXPRESSION EVALUATION SUBROUTINE',                     ,33563000
               PHASEID=&ID,                                            ,33564000
               LEVEL=&LEVEL                                             33565000
&NM      SETC  '&COMPNM&ID'                                             33566000
*TITLE-  ASSEMBLER EXPRESSION EVALUATION SUBROUTINE                   * 33567000
*                                                                     * 33568000
*FUNCTION/OPERATION-                                                  * 33569000
*        EVALUATE EXPRESSIONS                                         * 33570000
*        CONVERT SELF-DEFINING TERMS                                  * 33571000
*        DETECT ERRORS IN EXPRESSIONS                                 * 33572000
*             SYNTACTIC ERRORS-                                       * 33573000
*                  ILLEGAL CHARACTER IN EXPRESSION                    * 33574000
*                  ILLEGAL COMBINATION OF OPERATORS                   * 33575000
*                  MORE THAN TWENTY TERMS IN EXPRESSION               * 33576000
*                  MORE THAN SIX LEVELS OF PARENTHESES IN EXPRESSION  * 33577000
*                  PREMATURE END OF EXPRESSION                        * 33578000
*             NON-SYNTACTIC ERRORS-                                   * 33579000
*                  SELF-DEFINING TERM TOO LARGE                       * 33580000
*                  SELF-DEFINING TERM CONTAINS TOO MANY CHARACTERS    * 33581000
*                  RELOCATABLE TERM IN A MULTIPLY OR DIVIDE OPERATION * 33582000
*                  ARITHMETIC OVERFLOW ON AN INTERMEDIATE VALUE       * 33583000
*                  UNDEFINED SYMBOL IN EXPRESSION                     * 33584000
*                  INVALID SYMBOL                                     * 33585000
*                                                                     * 33586000
*ENTRY POINT-                                                         * 33587000
         ENTRY &NM.01                                                 * 33588000
*                                                                     * 33589000
*INPUT-                                                               * 33590000
*        REGISTERS-                                                   * 33591000
*             R5-       REGISTER CONTAINING THE ADDRESS OF THE FIRST  * 33592000
*                       CHARACTER OF THE EXPRESSION TO BE EVALUATED   * 33593000
*        PARAMETERS-                                                  * 33594000
*             SELFDEFN- A BYTE IN STORAGE, WHEN SET TO ZERO, CAUSES   * 33595000
*                       ONE DECIMAL SELF-DEFINING TERM TO BE          * 33596000
*                       CONVERTED ONLY                                * 33597000
*             ELCTR-    A FULLWORD IN STORAGE CONTAINING THE VALUE OF * 33598000
*                       THE CURRENT LOCATION COUNTER                  * 33599000
*             EESDI-    A HALFWORD IN STORAGE CONTAINING THE CURRENT  * 33600000
*                       ESDID                                         * 33601000
*             CLCLNG-   A HALFWORD IN STORAGE CONTAINING THE LENGTH   * 33602000
*                       ATTRIBUTE OF THE CURRENT LOCATION COUNTER     * 33603000
*             SUBLIST-  A BIT IN STORAGE, WHEN SET TO ONE, INDICATES  * 33604000
*                       THAT THE LOGICAL END OF THE EXPRESSION IS     * 33605000
*                       WHEN THE PARENTHESES LEVEL GOES FROM ONE TO   * 33606000
*                       ZERO                                          * 33607000
*                                                                     * 33608000
*OUTPUT-                                                              * 33609000
*        CONDITION CODE SETTING-                                      * 33610000
*             0-        VALUE OF THE EXPRESSION IS ABSOLUTE           * 33611000
*             1-        IF 'EVALSW1' IS 0, VALUE OF THE EXPRESSION IS * 33612000
*                       COMPLEXLY RELOCATABLE.  IF 'EVALSW1' IS NOT   * 33613000
*                       0, ONE OR MORE NON-SYNTACTIC ERROR WAS        * 33614000
*                       ENCOUNTERED IN THE EVALUATION.                * 33615000
*             2-        VALUE OF THE EXPRESSION IS SIMPLY RELOCATABLE * 33616000
*             3-        A SYNTATIC ERROR WAS ENCOUNTERED              * 33617000
*        REGISTERS-                                                   * 33618000
*             R10-      REGISTER CONTAINING THE ESDID OF THE          * 33619000
*                       EXPRESSION, IF THE VALUE OF THE EXPRESSION IS * 33620000
*                       ABSOLUTE OR SIMPLY RELOCATABLE.  THE ESDID IN * 33621000
*                       COMPLEMENT FORM, IF THE VALUE OF THE          * 33622000
*                       EXPRESSION IS COMPLEXLY RELOCATABLE WITH ONLY * 33623000
*                       ONE RELOCATION FACTOR.                        * 33624000
*             R11-      REGISTER CONTAINING THE VALUE OF THE          * 33625000
*                       EXPRESSION                                    * 33626000
*             R14-      REGISTER CONTAINING THE ADDRESS OF THE FIRST  * 33627000
*                       CHARACTER FOLLOWING THE CHARACTER WHICH       * 33628000
*                       LOGICALLY TERMINATED THE EXPRESSION           * 33629000
*        PARAMETERS-                                                  * 33630000
*             IMPLNG-   A HALFWORD IN STORAGE CONTAINING THE LENGTH   * 33631000
*                       ATTRIBUTE OF THE EXPRESSION                   * 33632000
*             LOCCTREF- A BIT IN STORAGE, WHEN SET TO ONE, INDICATES  * 33633000
*                       THAT AT LEAST ONE LOCATION COUNTER REFERENCE  * 33634000
*                       HAD BEEN MADE                                 * 33635000
*             RELOCTR-  A BYTE IN  STORAGE CONTAINING THE NUMBER OF   * 33636000
*                       ESDID(S) ASSOOCIATED WITH THE VALUE OF THE    * 33637000
*                       EXPRESSION                                    * 33638000
*             RLIST-    A LIST OF HALFWORDS IN STORAGE CONTAINING     * 33639000
*                       THE ESDID(S) ASSOCIATED WITH THE VALUE OF THE * 33640000
*                       EXPRESSION, THE ESDID IS STORED IN COMPLEMENT * 33641000
*                       FORM IF THE RELOCATION FACTOR IS APPLIED      * 33642000
*                       NEGATIVLY.                                    * 33643000
*                                                                     * 33644000
*EXITS, NORMAL-                                                       * 33645000
*        EXITS TO THE CALLER.                                         * 33646000
*                                                                     * 33647000
*EXITS, ERROR-                                                        * 33648000
*        EXITS TO THE CALLER.                                         * 33649000
*                                                                     * 33650000
*TABLES/WORK AREAS-                                                   * 33651000
*        EVALWORK-                                                    * 33652000
*        OPRNS-    UP TO 20 ENTRIES OF ONE BYTE EACH, AN ENTRY IS     * 33653000
*                  MADE FOR EACH OPERATOR ENCOUNTERED.                * 33654000
*        RLIST-    UP TO 20 ENTRIES OF ONE HALFWORD EACH, AN ENTRY IS * 33655000
*                  MADE FOR THE ESDID OF EACH TERM ENCOUNTERED.       * 33656000
*        TERMS-    UP TO 15 ENTRIES OF TWO FULLWORDS EACH, AN ENTRY   * 33657000
*                  IS MADE FOR EACH TERM ENCOUNTERED.                 * 33658000
*                                                                     * 33659000
*ATTRIBUTES-                                                          * 33660000
*        REFRESHABLE.                                                 * 33661000
*                                                                     * 33662000
*NOTES-                                                               * 33663000
*                                                                     * 33664000
         EJECT                                                          33665000
         COPY  JCOMMON                                                  33666000
         AIF   ('&ID' NE 'X4V').NOTX4V                                  33667000
         EJECT                                                          33668000
         COPY  ICOMMON                                                  33669000
         EJECT                                                          33670000
&NM.00   CSECT                                                          33671000
* VS1 REL 2.6 CHANGES                                                   33672000
*A585500-585900                                                 OX00106 33673000
* VS1 RELEASE 3.1 CHANGES                                               33674000
*C643000,645000                                                 OX02675 33675000
         JMODID                                                         33676000
         USING &NM.01,R8                BASE REGISTER                   33677000
&NM.01   BALR  R14,R7                   SAVE REGISTERS                  33678000
         LR    R8,R12                   BASE REGISTER                   33679000
         AGO   .X4V                                                     33680000
.NOTX4V  EJECT                                                          33681000
         COPY  X5COM                                                    33682000
         EJECT                                                          33683000
DSECT10  DSECT                                                          33684000
         COPY  RSYMRCD                                                  33685000
         EJECT                                                          33686000
         COPY  BMDSECTS                 GET POST PROCESSOR RECORD DSECT 33687000
         EJECT                                                          33688000
         COPY  JERMSGCD                 DEFINE ERROR CODES AND SEVERITY 33689000
         EJECT                                                          33690000
* VS1 RELEASE 3.1 CHANGES                                               33691000
*C625000,631000                                                 OX02953 33692000
*C648000                                                       @OY08064 33693000
*A648100-648200                                                @OY08064 33694000
*A589100,589200                                                @VM05316 33695000
&NM.00   CSECT                                                          33696000
         JMODID                                                         33697000
&NM.01   JSAVE                                                          33698000
EVAL     EQU   &NM.01                   LABEL                           33699000
         USING DSECT2,R2                                                33700000
         USING DSECT3,R3                                                33701000
         USING JTEXT,R4                                                 33702000
         USING DSECT5,R5                                                33703000
         USING X5COM,R7                                                 33704000
         USING DSECT10,R11              DEFINITION FILE USING           33705000
         USING DSECT14,R14                                              33706000
         LR    R5,R10                   INPUT COLUMN POINTER            33707000
.X4V     XC    EVALWORK,EVALWORK        INITIALIZE WORK AREA            33708000
         LM    R2,R4,EVALREGS           INITIAL SETTING OF REGISTERS    33709000
         SPACE                                                          33710000
*                        SCAN EXPRESSION                              * 33711000
         SPACE                                                          33712000
SCAN     ST    R5,ERRPTR                SAVE FOR ERROR DIAGNOSTICS      33713000
         AIF   ('&ID' EQ 'X5V').X5V1                                    33714000
         CLI   CHAR1,JBLANK             SEE IF A BLANK                  33715000
         BH    SYNTAXER                 ILLEGAL CHARACTER IN EXPRESSION 33716000
         CLI   CHAR1,JEQUAL             SEE IF AN EQUAL SIGN            33717000
         BE    SYNTAXER                 ILLEGAL CHARACTER IN EXPRESSION 33718000
         AGO   .X4V1                                                    33719000
.X5V1    CLI   CHAR1,JBLANK             SEE IF A BLANK                  33720000
         BH    SYNERR1                  ILLEGAL CHARACTER IN EXPRESSION 33721000
         CLI   CHAR1,JEQUAL             SEE IF AN EQUAL SIGN            33722000
         BE    SYNERR1                  ILLEGAL CHARACTER IN EXPRESSION 33723000
.X4V1    ANOP                                                           33724000
         BL    ALPHANUM                 TERM                            33725000
         SPACE                                                          33726000
*                        GO TO SPECIAL CHARACTER HANDLING             * 33727000
         SPACE                                                          33728000
         SR    R14,R14                  ZERO REGISTER FOR INDEX         33729000
         IC    R14,CHAR1                GET NEXT CHARACTER              33730000
         STC   R14,NEWOP                ENTER IN OPERATOR STACK         33731000
         IC    R14,GOTOTBL-JLPARN(R14)  INDEXED ADDRESS FETCH           33732000
         GOIF  STATUS1,ELSE=GOTO(R14)   GO TO ROUTINE, PASS STATUS      33733000
         EJECT                                                          33734000
*                        (1)  PLUS OR MINUS SIGN                      * 33735000
         SPACE                                                          33736000
GOTO     BH    BINARYOP           2/3 - BINARY OPERATOR                 33737000
         SPACE                                                          33738000
*                        (2)  UNARY OPERATOR                          * 33739000
         SPACE                                                          33740000
         AIF   ('&ID' EQ 'X5V').X5V2                                    33741000
         GOIF  LNGQUOTE,ON=SYNTAXER     ILLEGAL L'ATTRIBUTE REFERENCE   33742000
         AGO   .X4V2                                                    33743000
.X5V2    GOIF  LNGQUOTE,ON=SYNERR2      ILLEGAL L'ATTRIBUTE REFERENCE   33744000
.X4V2    ANOP                                                           33745000
         GOIF  ADD1,EQUAL=CALC3   '+' - UNARY PLUS, IGNORE              33746000
         SET   UNY1               '-' - SET UNARY MINUS CODE            33747000
         GOIF  UNY0,EQUAL=CALC5,ELSE=CALC2   CHECK PREVIOUS OPERATOR    33748000
         SPACE                                                          33749000
*                        (3)  SLASH                                   * 33750000
         SPACE                                                          33751000
         AIF   ('&ID' EQ 'X5V').X5V3                                    33752000
SLASH    BNH   SYNTAXER           0/1 - TWO CONSECUTIVE OPERATORS       33753000
         AGO   .X4V3                                                    33754000
.X5V3    ANOP                                                           33755000
SLASH    BNH   SYNERR3            0/1 - TWO CONSECUTIVE OPERATORS       33756000
.X4V3    ANOP                                                           33757000
         SPACE                                                          33758000
*                        (4)  BINARY OPERATOR                         * 33759000
         SPACE                                                          33760000
BINARYOP SET   STATUS1              1 - PLUS OR MINUS SIGN              33761000
         B     CALC1                    GO CALCULATE                    33762000
         SPACE                                                          33763000
*                        (5)  ASTERISK                                * 33764000
         SPACE                                                          33765000
ASTERISK BH    BINARYOP             2 - MULTIPLICATION SIGN             33766000
         SPACE                                                          33767000
*                        (6)  LOCATION COUNTER REFERENCE              * 33768000
         SPACE                                                          33769000
         SET   LOCTREF,ON               LOCATION COUNTER REFERENCED     33770000
         LA    R5,CHAR2                 ADVANCE COLUMN POINTER          33771000
         GOIF  LNGQUOTE,ON=LOCCTR1      SEE IF LENGTH ATTRIBUTE         33772000
         SPACE                                                          33773000
*                        (7)  LOCATION COUNTER                        * 33774000
         SPACE                                                          33775000
         SET   DLOCTREF,ON              LOCATION COUNTER REFERENCED     33776000
         LH    R15,CLCLNG               LENGTH ATTRIBUTE                33777000
         AIF   ('&ID' NE 'X4V').X5V41                                   33778000
         LH    R0,EESDI                 CURRENT ESDID                   33779000
         L     R1,ELCTR                 CURRENT LOCATION COUNTER        33780000
         B     CLEANUP1                 GO TO CLEANUP                   33781000
         AGO   .X4X5V                                                   33782000
.X5V41   GOIF  LITRSW,ON=SKIPLITR       BRANCH AROUND IF NOT PROC. LITR 33783000
         LH    R0,EESDI                 GET CURRENT ESDID               33784000
         L     R1,ELCTR                 GET CURRENT LOCATION CTR        33785000
         B     CLEANUP1                 GO TO CLEANUP                   33786000
SKIPLITR EQU   *                        BRANCH LABEL                    33787000
         LH    R0,LITRSD                GET LITR ESDID                  33788000
         L     R1,LITRLC                GET LITR LOCATION CTR           33789000
         B     CLEANUP1                 GO TO CLEANUP                   33790000
.X4X5V   ANOP                                                           33791000
         SPACE                                                          33792000
*                        (8)  L - QUOTE ASTERISK                      * 33793000
         SPACE                                                          33794000
LOCCTR1  LH    R1,CLCLNG                GET CURRENT LOCATION LENGTH     33795000
         B     ABSOLUTE                 CLEANUP                         33796000
         SPACE                                                          33797000
*                        (9)  LEFT PARENTHESIS                        * 33798000
         SPACE                                                          33799000
LFPAREN  BH    BLANK1             2/3 - MAY BE END OF EXPRESSION        33800000
         AIF   ('&ID' EQ 'X5V').X5V4                                    33801000
         GOIF  MAXPARN,NOTLOW=SYNTAXER  TOO MMNY LEVELS OF PARENS       33802000
         AGO   .X4V4                                                    33803000
.X5V4    GOIF  MAXPARN,NOTLOW=SYNERR4   TOO MANY LEVELS OF PARENS       33804000
.X4V4    ANOP                                                           33805000
         LH    R14,PARENCNT             GET PARENTHESES COUNT           33806000
         LA    R14,D1(,R14)             BUMP IT BY ONE                  33807000
         STH   R14,PARENCNT             AND SAVE                        33808000
         B     CALC2                    EXIT                            33809000
         SPACE                                                          33810000
*                        (10) RIGHT PARENTHESIS                       * 33811000
         SPACE                                                          33812000
         AIF   ('&ID' EQ 'X5V').X5V5                                    33813000
RTPAREN  BNH   SYNTAXER           0/1 - INVALID SYNTAX                  33814000
         AGO   .X4V5                                                    33815000
.X5V5    ANOP                                                           33816000
RTPAREN  BNH   SYNERR6            0/1 - INVALID SYNTAX                  33817000
.X4V5    ANOP                                                           33818000
         GOIF  NOPAREN,EQUAL=BLANK2,ELSE=CALC     MAY BE END OF OPERAND 33819000
         SPACE                                                          33820000
*                        (11) BLANK OR COMMA                          * 33821000
         SPACE                                                          33822000
         AIF   ('&ID' EQ 'X5V').X5V6                                    33823000
BLANK    BNH   SYNTAXER           0/1 - PREMATURE END OF EXPRESSION     33824000
BLANK1   GOIF  NOPAREN,HIGH=SYNTAXER    UNBALENCED PARENTHESES          33825000
         AGO   .X4V6                                                    33826000
.X5V6    ANOP                                                           33827000
BLANK    BNH   SYNERR6                  PREMATURE END OF EXPRESSION     33828000
BLANK1   GOIF  NOPAREN,HIGH=SYNERR6     OR UNBALANCED PARENTHESIS       33829000
.X4V6    ANOP                                                           33830000
BLANK2   SET   ENDOFEXP,ON              SET END-OF-EXPRESSION INDICATOR 33831000
         EJECT                                                          33832000
*                        ARITHMETIC CALCULATION                       * 33833000
         SPACE                                                          33834000
CALC     SET   DEL1                     FORCE COMPUTATION               33835000
CALC1    CL    R4,AOPTR                 READY TO GO TO WORK             33836000
         BH    CALC6                    YEAH                            33837000
         GOIF  ENDOFEXP,ON=FINIS1       LEAVE IF FINISHED               33838000
CALC2    LA    R4,NEWOP                 BUMP OPERATOR STACK POINTER     33839000
CALC3    LA    R5,CHAR2                 POINT TO NEXT CHARACTER         33840000
         B     SCAN                     LOOK FOR NEXT TERM OR OPERATOR  33841000
CALC4    GOIF  DEL0,HIGH=WORK           GO TO WORK                      33842000
         LH    R14,PARENCNT             GET PARENTHESES LEVEL           33843000
         BCT   R14,CALC41               SEE IF WITHOUT                  33844000
         GOIF  SUBLIST,ON=FINIS         PROCESSING MODIFIER EXPRESSIONS 33845000
CALC41   STH   R14,PARENCNT             SAVE PARENTHESES LEVEL COUNTER  33846000
CALC5    BCTR  R4,0                     POP OPERATOR STACK              33847000
         B     CALC3                    GO SCAN SOME MORE               33848000
CALC6    CLC   NEWOP,OLDOP              DO WE HAVE TO GO                33849000
         BNH   CALC4                    MAYBE NOT                       33850000
         SPACE                                                          33851000
*                        REDUCE HIERARCHY TO THREE LEVELS             * 33852000
         SPACE                                                          33853000
         GOIF  SUB1,NOTEQ=CALC7   '-' - SUBTRACTION                     33854000
         GOIF  ADD0,EQUAL=WORK    '+' - ADDITION                        33855000
CALC7    GOIF  DIV1,NOTEQ=CALC2   '/' - DIVISION                        33856000
         GOIF  MUL0,NOTEQ=CALC2   '*' - MULTIPLICATION                  33857000
         SPACE                                                          33858000
*                        PERFORM ARITHMETIC OPERATION ON LAST 2 TERMS * 33859000
         SPACE                                                          33860000
WORK     LA    R14,TERM2+L'TERM2-TERM1CNT    GET LENGTH OF TWO TERMS    33861000
         SR    R2,R14                   POINT TO FIRST OF TWO TERMS     33862000
         L     R1,TERM2                 GET THE SECOND TERM             33863000
         LR    R11,R3                   SAVE POINTER                    33864000
         LR    R10,R3                   SAVE POINTER                    33865000
         SH    R3,TERM2CNT+2            POINT TO BEGINNING FOR RLIST2   33866000
         LR    R15,R3                   SAVE POINTER                    33867000
         GOIF  UNY0,EQUAL=UNARY         UNARY                           33868000
         LR    R0,R3                    SAVE                            33869000
         SH    R3,TERM1CNT+2            POINT TO BEGINNING OF RLIST1    33870000
         SR    R11,R3                   GET LENGTH OF ENTIRE LIST       33871000
         STH   R11,TERM1CNT+2           FOR NEW LENGTH                  33872000
         GOIF  SUB0,HIGH=MULTDIV,EQUAL=SUBTRACT   +,- VS *,/            33873000
         SPACE                                                          33874000
*                        ADJUST RELOCATION INFORMATION                * 33875000
         SPACE                                                          33876000
RELOC    LH    R11,ESDID                GET NEXT ESDID FROM RLIST       33877000
         GOIF  (R11),ZERO=RELOC4        SKIP TEST IF ZERO               33878000
         AH    R11,ESDID-ESDID(,R15)    SEE IF MATCH FOUND              33879000
         BZ    RELOC2                   THIS PAIR CANCELS               33880000
RELOC1   LA    R15,NEXTESD-ESDID(,R15)  POINT TO NEXT ESDID IN RLIST2   33881000
         GOIF  (R15),(R10),NOTEQ=RELOC,ELSE=RELOC3     END OF LIST      33882000
RELOC2   STH   R11,ESDID                INDICATE CANCELLED              33883000
         STH   R11,ESDID-ESDID(,R15)    INDICATE CANCELLED              33884000
         IC    R15,RELOCTR              GET COUNT OF RELOCATABLE TERMS  33885000
         BCTR  R15,0                    DECREMENT COUNT BY 2            33886000
         BCTR  R15,0                    X                               33887000
         STC   R15,RELOCTR              SAVE                            33888000
RELOC3   LR    R15,R0                   POINT TO BEGINNING OF RLIST2    33889000
RELOC4   LA    R3,NEXTESD               POINT TO NEXT ESDID IN RLIST1   33890000
         GOIF  (R3),(R0),NOTEQ=RELOC    END OF LIST                     33891000
         SPACE                                                          33892000
*                        ADDITION                                     * 33893000
         SPACE                                                          33894000
         A     R1,TERM1                 ADD THE TWO TERMS               33895000
         BNO   STORE                    GO IF NO OVERFLOW               33896000
OVERFLOW SET   OVERFLO,ON               SET OVERFLOW BIT                33897000
         AIF   ('&ID' NE 'X5V').X4VO                                    33898000
         X5ERRL 235,CLMPTR              ARITHMETIC OVERFLOW             33899000
.X4VO    ANOP                                                           33900000
STORE    ST    R1,TERM1                 STORE RESULT                    33901000
         LA    R2,TERM2CNT              POINT TO NEXT TERM ENTRY SPACE  33902000
         LR    R3,R10                   POINT TO NEXT RLIST ENTRY SPACE 33903000
         MVC   OLDOP,NEWOP              REDUCE STACK                    33904000
         BCTR  R4,0                     DECREMENT OPERATOR STACK        33905000
         B     CALC1                    ALL DONE FOR NOW                33906000
         SPACE                                                          33907000
*                        MULTIPLICATION OR DIVISION                   * 33908000
         SPACE                                                          33909000
MULTDIV  BCTR  R11,0                    GET MACHINE LENGTH              33910000
         EX    R11,ABSCHECK             ABSCHECK NC    ESDID(0),ESDID   33911000
         BZ    MULTDIV1                 NO RELOCATABLE TERMS            33912000
         SET   RELOCER,ON               RELOCATABLE TERM IN OPERATION   33913000
         AIF   ('&ID' NE 'X5V').X4VR                                    33914000
         X5ERRL 217,CLMPTR              RELOCATION ERROR                33915000
.X4VR    ANOP                                                           33916000
MULTDIV1 GOIF  (R1),ZERO=STORE          RESULT IS ZERO IF TERM2 IS ZERO 33917000
         L     R14,TERM1                GET FIRST TERM                  33918000
         SRDA  R14,32                   PROPAGATE SIGN                  33919000
         GOIF  MUL0,EQUAL=MULTIPLY      MULTIPLICATION OR DIVISION      33920000
         SPACE                                                          33921000
*                        DIVISION                                     * 33922000
         SPACE                                                          33923000
         DR    R14,R1                   DIVISION                        33924000
         LR    R1,R15                   PASS RESULT                     33925000
         B     STORE                    STORE RESULT                    33926000
         SPACE                                                          33927000
*                        MULTIPLICATION                               * 33928000
         SPACE                                                          33929000
MULTIPLY MR    R14,R1                   PERFORM MULTIPLICATION          33930000
         LTR   R1,R15                   TEST AND PASS RESULT            33931000
         BNL   SIGNCHK                  SKIP COMPLEMENT IF POSITIVE     33932000
         LCR   R14,R14                  COMPLEMENT                      33933000
         BCTR  R14,0                    MAKE ZERO                       33934000
SIGNCHK  GOIF  (R14),ZERO=STORE,NOTZERO=OVERFLOW  TEST FOR OVERFLOW     33935000
         EJECT                                                          33936000
*                        SUBTRACTION                                  * 33937000
         SPACE                                                          33938000
UNARY    LA    R2,TERM2CNT              GOT NOTHING TO DO WITH TERM 1   33939000
SUBTRACT LCR   R1,R1                    COMPLEMENT TERM2                33940000
         BO    OVERFLOW                 CHECK FOR OVERFLOW              33941000
LESS     LH    R11,ESDID-ESDID(,R15)    GET NEXT ESDID FROM RLIST2      33942000
         LCR   R11,R11                  COMPLEMENT IT                   33943000
         STH   R11,ESDID-ESDID(,R15)    AND PUT IT BACK                 33944000
         LA    R15,NEXTESD-ESDID(,R15)  CONTINUE WITH REST OF RLIST2    33945000
         GOIF  (R15),(R10),LOW=LESS     NOT DONE YET                    33946000
         LR    R15,R0                   RESTORE TO BEGINNING OF RLIST2  33947000
         GOIF  UNY0,NOTEQ=RELOC,ELSE=STORE   ALL DONE IF UNARY          33948000
         SPACE                                                          33949000
*                        CHECK FOR SELF DEFINING VALUES               * 33950000
         SPACE                                                          33951000
ALPHANUM GOIF  STATUS1,HIGH=BLANK1      MAY BE END OF EXPRESSION        33952000
         CLI   CHAR1,JA                 SEE IF CHARACTER 'A'            33953000
         BL    DECIMAL            0-9 - DECIMAL SELF DEFINING VALUE     33954000
         LR    R14,R5                   SAVE COLUMN POINTER             33955000
         CLI   CHAR2,JQUOTE             IS NEXT CHARACTER A '           33956000
         BNE   SYM                      MAYBE WE'VE HIT UPON A SYMBOL   33957000
         AIF   ('&ID' EQ 'X5V').X5V7                                    33958000
         GOIF  LNGQUOTE,ON=SYNTAXER     L' FOLLOWED BY ANYTHING IS BAD  33959000
         AGO   .X4V7                                                    33960000
.X5V7    GOIF  LNGQUOTE,ON=SYNERR2      INVALID LENGTH ATTR REFERENCE   33961000
.X4V7    ANOP                                                           33962000
         LA    R5,CHAR3                 ADVANCE COLUMN POINTER          33963000
         GOIF  BQUOTE,EQUAL=BINARY      PROCESS IF BINARY TYPE          33964000
         GOIF  CQUOTE,EQUAL=CHARACTR    PROCESS IF CHARACTER TYPE       33965000
         GOIF  XQUOTE,EQUAL=HEXADEC     PROCESS IF HEXADECIMAL TYPE     33966000
         AIF   ('&ID' EQ 'X5V').X5V8                                    33967000
         GOIF  LQUOTE,NOTEQ=SYNTAXER    ILLEGAL CHARACTER IN EXPRESSION 33968000
         AGO   .X4V8                                                    33969000
.X5V8    GOIF  LQUOTE,NOTEQ=SYNERR1     ILLEGAL CHARACTER IN EXPRESSION 33970000
.X4V8    ANOP                                                           33971000
         SET   LNGQUOTE,ON              INDICATE ATTRIBUTE REFERENCE    33972000
         B     SCAN                     LOOK FOR SYMBOL                 33973000
         EJECT                                                          33974000
*                        DECIMAL SELF-DEFINING VALUE                  * 33975000
         SPACE                                                          33976000
DECOFLO  SET   SDVSIZE,ON               SELF DEFINING VALUE TOO LARGE   33977000
         AIF   ('&ID' EQ 'X5V').X5V9                                    33978000
DECIMAL  GOIF  LNGQUOTE,ON=SYNTAXER     DECIMAL AFTER L' ISN'T KOSHER   33979000
         AGO   .X4V9                                                    33980000
.X5V9    ANOP                                                           33981000
         X5ERRL 235,CLMPTR              OVERFLOW ERROR                  33982000
DECIMAL  GOIF  LNGQUOTE,ON=SYNERR2      INVALID LENGTH ATTR REFERENCE   33983000
.X4V9    ANOP                                                           33984000
         SR    R1,R1                    SR    R1,R1                     33985000
         LR    R0,R1                    ZERO DIGIT VALUE                33986000
         LR    R10,R1                   ZERO DIGIT COUNT                33987000
         LA    R15,MAXDEC               GET MAXIMUM DIGIT COUNT         33988000
DECIMAL1 CLI   CHAR1,J9                 SEE IF CHARACTER '9'            33989000
         BH    DIGITCHK                 NOT NUMERIC                     33990000
         LA    R10,D1(,R10)             COUNT DIGIT                     33991000
         LR    R14,R1                   SAVE CURRENT TOTAL              33992000
         SLA   R1,3                     MULTIPLY BY EIGHT               33993000
         BO    DECOFLO                  OVERFLOW ONE FULLWORD           33994000
         IC    R0,CHAR1                 GET DIGIT                       33995000
         AR    R14,R14                  DOUBLE                          33996000
         AR    R14,R0                   PLUS NEXT DIGIT                 33997000
         AR    R1,R14                   GRAND TOTAL                     33998000
         BO    DECOFLO                  SELF DEFINING VALUE TOO LARGE   33999000
         LA    R5,CHAR2                 POINT TO NEXT DIGIT             34000000
         B     DECIMAL1                 GO SOME MORE                    34001000
         SPACE                                                          34002000
*                        BINARY SELF-DEFINING VALUE                   * 34003000
         SPACE                                                          34004000
BINARY   LA    R14,SHIFTB               GET BINARY SHIFT VALUE          34005000
         GOTO  SDVEVAL                  GO EVALUATE SELF DEFINING TERM  34006000
         LA    R15,MAXBIT               GET MAXIMUM NUMBER OF BITS      34007000
         B     DELIMCHK                 PERFORM VALIDITY TESTS          34008000
         SPACE                                                          34009000
*                        CHARACTER SELF-DEFINING VALUE                * 34010000
         SPACE                                                          34011000
CHARACTR LA    R14,SHIFTC               GET CHARACTER SHIFT VALUE       34012000
         GOTO  SDVEVAL                  GO EVALUATE SELF DEFINING TERM  34013000
         LA    R15,MAXCHAR              GET MAXIMUM NUMBER OF CHARACTER 34014000
         ST    R1,JFWORD1               PUT VALUE IN STORAGE            34015000
         TR    JFWORD1,JTRTABLE         TRANSLATE TO EBCDIC             34016000
         L     R1,JFWORD1               PASS RESULT IN REGISTER         34017000
         B     DELIMCHK                 PERFORM VALIDITY TESTS          34018000
         SPACE                                                          34019000
*                        HEXADECIMAL SELF-DEFINING VALUE              * 34020000
         SPACE                                                          34021000
HEXADEC  LA    R14,SHIFTH               GET HEXADECIMAL SHIFT VALUE     34022000
         GOTO  SDVEVAL                  GO EVALUATE SELF DEFINING TERM  34023000
         LA    R15,MAXHEX               GET MAXIMUM NUMBER OF HEX DIGIT 34024000
         EJECT                                                          34025000
*                        VALIDITY TESTS                               * 34026000
         SPACE                                                          34027000
         AIF   ('&ID' EQ 'X5V').X5V10                                   34028000
DELIMCHK CLI   CHAR1,JQUOTE             SEE IF CHARACTER '''            34029000
         BNE   SYNTAXER                 INVALID DELIMITER               34030000
         AGO   .X4V10                                                   34031000
.X5V10   ANOP                                                           34032000
DELIMCHK CLI   CHAR1,JQUOTE             SEE IF CHARACTER '''            34033000
         BNE   SYNERR8                  INVALID DELIMITER               34034000
.X4V10   ANOP                                                           34035000
         LA    R5,CHAR2                 ADVANCE COLUMN POINTER          34036000
         GOIF  (R10),ZERO=EMPTYSDV      NULL BETWEEN QUOTES             34037000
DIGITCHK GOIF  (R10),(R15),NOTHIGH=ABSOLUTE  CHECK FOR MAXIMUM DIGITS   34038000
EMPTYSDV SET   SDVSIZE,ON               ERROR                           34039000
         AIF   ('&ID' NE 'X5V').X4V16                                   34040000
         X5ERRL 169,CLMPTR              INVALID SELF-DEFINING TERM      34041000
.X4V16   ANOP                                                           34042000
ABSOLUTE SR    R0,R0                    ESDID                           34043000
         SET   LNGQUOTE,OFF             NOT APPLICABLE FROM NOW ON      34044000
         SPACE                                                          34045000
*                        CLEANUP                                      * 34046000
         SPACE                                                          34047000
CLEANUP  LA    R15,D1                   LENGTH ATTRIBUTE OF TERM        34048000
CLEANUP1 CL    R3,EVALREGS              SEE IF MAXIMUM TERMS            34049000
         AIF   ('&ID' EQ 'X5V').X5V11                                   34050000
         BNL   SYNTAXER                 OF 20 EXCEEDED                  34051000
         AGO   .X4V11                                                   34052000
.X5V11   BNL   SYNERR9                  TOO MANY TERMS                  34053000
.X4V11   ANOP                                                           34054000
         STH   R0,ESDID                 SAVE ESDID                      34055000
         ST    R1,TERM1                 VALUE TO TERM1                  34056000
         MVI   TERM1CNT+D3,L'RLIST      COUNT IS LENGTH OF ONE ENTRY    34057000
         LA    R2,TERM2CNT              ADVANCE POINTER TO NEXT ENTRY   34058000
         LA    R3,NEXTESD               ADVANCE POINTER TO NEXT ENTRY   34059000
         SET   STATUS2              2 - TERM                            34060000
         GOIF  (R0),ZERO=CLEANUP2       SEE IF ABSOLUTE TERM            34061000
         IC    R14,RELOCTR              GET COUNT OF RELOCATABLE TERMS  34062000
         LA    R14,1(,R14)              BUMP THE COUNT BY 1             34063000
         STC   R14,RELOCTR              SAVE THE COUNT                  34064000
CLEANUP2 TS    FIRST                    SEE IF THIS IS THE FIRST TERM   34065000
         BNZ   SCAN                     GO ON IF NOT                    34066000
         STH   R15,IMPLNG               LENGTH ATTRIBUTE OF EXPRESSION  34067000
         TS    SELFDEFN                 SDV EXPECTED                    34068000
         BNZ   SCAN                     NOT PARTICULAR, GO ON           34069000
         B     FINIS1                   YES, MY JOB IS DONE             34070000
         EJECT                                                          34071000
*                        SELF-DEFINING VALUE EVALUATION               * 34072000
         SPACE                                                          34073000
SDVEVAL  STC   R14,SHIFTN               SAVE SHIFT VALUE                34074000
         IC    R11,SDVLIMIT-D1(R14)     GET VALID HIGH LIMIT            34075000
         SR    R15,R15                  ZERO REGISTERS                  34076000
         LR    R10,R15                  ZERO DIGIT COUNTER              34077000
         LR    R1,R15                   ZERO ACCUMULATOR                34078000
         GOIF  SHIFTC,NOTEQ=SDVEVAL1    SHIFT                           34079000
         L     R1,BCDZEROS              GET EXTERNAL ZEROS              34080000
SDVEVAL1 EX    R11,CHAR1CLI             CLI   CHAR1,0                   34081000
         BHR   R9                       EXIT ON HIGH                    34082000
         IC    R15,CHAR1                GET NEXT CHARACTER              34083000
         GOIF  SHIFTC,NOTEQ=SDVEVAL4    CHARACTER SELF DEFINING TERM    34084000
         CLI   CHAR1,JQUOTE             SEE IF CHARACTER '''            34085000
         BNE   SDVEVAL2                 NO, SEE IF CHARACTER '&'        34086000
         CLI   CHAR2,JQUOTE             SEE IF CHARACTER ''''           34087000
         BE    SDVEVAL3                 YES, TREAT AS ONE               34088000
         BR    R9                       OR ELSE IT COULD BE END OF TERM 34089000
SDVEVAL2 CLI   CHAR1,JAMPER             SEE IF CHARACTER '&'            34090000
         BNE   SDVEVAL4                 NO, JUST ANY OTHER CHARACTER    34091000
         AIF   ('&ID' EQ 'X5V').X5V12                                   34092000
         CLI   CHAR2,JAMPER             SEE IF CHARACTER '&&'           34093000
         BNE   SYNTAXER                 NO, ILLEGAL USE OF AMPERSAND    34094000
         AGO   .X4V12                                                   34095000
.X5V12   CLI   CHAR2,JAMPER             SEE IF CHARACTER '&&'           34096000
         BNE   SYNERR10                 NO, ILLEGAL USE OF AMPERSAND    34097000
.X4V12   ANOP                                                           34098000
SDVEVAL3 LA    R5,CHAR2                 ADVANCE COLUMN POINTER          34099000
SDVEVAL4 SLL   R1,D0(R14)               SHIFT BY SPECIFIED VALUE        34100000
         ALR   R1,R15                   ADD TO ACCUMULATOR              34101000
         LA    R10,D1(,R10)             KEEP COUNT OF DIGITS            34102000
         LA    R5,CHAR2                 POINT TO NEXT CHARACTER         34103000
         B     SDVEVAL1                 LOOP                            34104000
         SPACE                                                          34105000
*                        SYNTAX ERROR IN EXPRESSION                   * 34106000
         SPACE                                                          34107000
SYNTAXER SET   FATALER,ON               SYNTAX ERRORS ARE FATAL         34108000
         EJECT                                                          34109000
*                        SET RETURN CONDITION CODE                    * 34110000
         SPACE                                                          34111000
FINIS    LA    R5,CHAR2                 POINT PAST CHARACTER            34112000
FINIS1   L     R11,TERMS+TERM1-TERM1CNT PASS RESULT IN PARAMETER REG    34113000
         SET   (SUBLIST,DCOP),OFF       RESET                           34114000
         TS    SELFDEFN                 RESET                           34115000
         SR    R10,R10                  ABSOLUTE TERM IF EVALUATION ERR 34116000
         GOIF  FATALER,ON=FINIS3    3 - SYNTAX ERROR                    34117000
         TM    EVALSW1,BITFF            ANY ERROR IN EXPRESSION         34118000
         BM    FINIS3               1 - ERROR IN EXPRESSION             34119000
         GOIF  NORELOC,EQUAL=FINIS3 0 - ABSOLUTE EXPRESSION             34120000
         TM    RELOCTR,BITFF-1          MORE THAN ONE RELOCATABLE TERM  34121000
         BM    FINIS3                   NO, COMPLEXLY RELOCATABLE       34122000
         LA    R3,RLIST-L'RLIST         START AT HEAD OF LIST           34123000
FINIS2   LA    R3,NEXTESD               POINT TO NEXT ITEM              34124000
         LH    R10,ESDID                PICK IT UP                      34125000
         GOIF  (R10),ZERO=FINIS2    0 - NOT RELOCATABLE TERM            34126000
         SPACE                                                          34127000
*NOTES-  WHEN THE ONE AND ONLY RELOCATABLE TERM IS FOUND, WHETHER IT  * 34128000
*   IS SIMPLY OR COMPLEXLY RELOCATABLE, IT WILL FALL THROUGH THIS     * 34129000
*   POINT AND RETURN TO THE CALLER WITH THE PROPER CONDITION CODE     * 34130000
*   SETTING.                                                          * 34131000
         SPACE                                                          34132000
FINIS3   LR    R14,R5                   RETURN COLUMN POINTER           34133000
         B     EXIT                     EXIT                            34134000
         EJECT                                                          34135000
*                        SPECIAL CHARACTER GO TO TABLE                * 34136000
         SPACE                                                          34137000
GOTOTBL  EQU   *                        ORIGIN OF GO-TO TABLE           34138000
         DC    YL1(LFPAREN-GOTO)              ( - LEFT PARENTHESIS      34139000
         DC    YL1(PLUS-GOTO)                 + - PLUS SIGN             34140000
         DC    YL1(MINUS-GOTO)                - - MINUS SIGN            34141000
         DC    YL1(ASTERISK-GOTO)             * - ASTERISK              34142000
         DC    YL1(SLASH-GOTO)                / - SLASH                 34143000
         DC    YL1(RTPAREN-GOTO)              ) - RIGHT PARENTHESIS     34144000
         DC    YL1(COMMA-GOTO)                , - COMMA                 34145000
         DC    YL1(BLANK-GOTO)                  - BLANK                 34146000
         SPACE                                                          34147000
PLUS     EQU   GOTO                     X                               34148000
MINUS    EQU   GOTO                     X                               34149000
COMMA    EQU   BLANK                    X                               34150000
         SPACE                                                          34151000
*                        CONSTANTS                                    * 34152000
         SPACE                                                          34153000
         LTORG                                                          34154000
BCDZEROS DC    C'0000'                  PAD                             34155000
ABSCHECK NC    ESDID(0),ESDID           EXECUTED INSTRUCTION            34156000
CHAR1CLI CLI   CHAR1,D0                 EXECUTED INSTRUCTION            34157000
SDVLIMIT DC    X'0100000F000000FF'      LIMITS OF VALID CHARACTERS FOR- 34158000
*                /     /       /............ CHARACTER                  34159000
*               /     /..................... HEXADECIMAL                34160000
*              /............................ BINARY                     34161000
         EJECT                                                          34162000
*                        LOOKUP SYMBOL                                * 34163000
         SPACE                                                          34164000
DEFNERR  SET   NOTDEFN,ON               UNDEFINED SYMBOL                34165000
         SR    R1,R1                    DEFAULT VALUE TO ZERO           34166000
         B     ABSOLUTE                 GO ON                           34167000
SYM      LA    R5,CHAR2                 POINT TO NEXT CHARACTER         34168000
         CLI   CHAR1,JEQUAL             SEE IF ALPHAMERIC               34169000
         BL    SYM                      LOOK FOR DELIMITER              34170000
         LR    R15,R5                   GET ADDRESS OF DELIMITER        34171000
         SR    R15,R14                  MINUS FIRST CHARACTER ADDRESS   34172000
         BCTR  R15,D0                   YIELD LENGTH OF SYMBOL          34173000
         CH    R15,=H'7'                SYMBOL TOO LONG                 34174000
         AIF   ('&ID' NE 'X4V').NOTX4V1                                 34175000
         BH    SYNTAXER                 SYMBOL LENGTH GREATER THAN 8    34176000
         MVC   XNAME,=8AL1(JBLANK)      PAD                             34177000
         EX    R15,NAMEMOVE             PASS SYMBOL                     34178000
         GOIF  DCOP,OFF=SYM0            SKIP IF NOT DC                  34179000
         LH    R14,SYMCOUNT             GET SYMBOL COUNT                34180000
         LA    R14,D1(,R14)             INCREMENT IT BY 1               34181000
         STH   R14,SYMCOUNT             SAVE                            34182000
         GOIF  LTORGSCN,OFF=SYM0        SKIP IF NOT PROCESSING LTORG    34183000
         GOTO  REFER                    GO GENERATE A REFERENCE RECORD  34184000
SYM0     LA    R10,XWORK                ADDRESS OF SYMBOL               34185000
         GOTO  FIND                     LOOKUP IN SYMBOL TABLE          34186000
         BNZ   SYM2                     NOT FOUND                       34187000
         GOIF  ESW,OFF=SYM05            CHECK EXTRN/EQU FLAG    OX00106 34188000
         LA    R10,XWORK                MAKE SURE R10 POINTS OK OX00106 34189000
         OI    XESDI-XWORK(R10),ESW     TRANSFER EXTRN/EQU FLAG OX00106 34190000
SYM05    EQU   *                                                OX00106 34191000
         GOIF  ENTRYSW,ON=DEFNERR       NOT DEFINED                     34192000
         LA    R1,D1                    LENGTH ATTRIBUTE                34193000
         GOIF  ESDNRSW,ON=SYM1          FOR EXTERNAL SYMBOLS            34194000
         LH    R1,SLNGQ                 LENGTH ATTRIBUTE FOR OTHERS     34195000
         SLL   R1,16                    MAY BE A 16 BIT        @VM05316 34196000
         SRL   R1,16                    POSITIVE NUMBER        @VM05316 34197000
SYM1     GOIF  LNGQUOTE,ON=SYM4         LENGTH ATTRIBUTE REFERENCE      34198000
         LR    R15,R1                   PASS LENGTH ATTRIBUTE           34199000
         LH    R0,SESDI                 ESDID                           34200000
         L     R1,SLCTR                 VALUE                           34201000
         B     CLEANUP1                 CLEANUP                         34202000
SYM4     GOIF  LNGDEF,OFF=ABSOLUTE      ILLEGAL LENGTH ATTRIBUTE        34203000
SYM2     GOIF  LTORGSCN,ON=DEFNERR      UNDEFINED                       34204000
         GOIF  IOFLO,OFF=DEFNERR        UNDEFINED                       34205000
         GOIF  INOTE,OFF=SYM5           SEE IF REWIND NECESSARY         34206000
         LH    R10,JINFILE              INPUT FILE ADDRESS              34207000
         JPOINT  FILE=(R10),ADDR=INOTEVAL,NEXT=GET     REPOSITION FILE  34208000
SYM5     LH    R10,JINFILE              GET INPUT FILE ADDRESS          34209000
         JGETL FILE=(R10)               READ NEXT RECORD                34210000
         GOIF  INOTE,ON=SYM6            SEE IF ALREADY NOTED            34211000
         SET   INOTE,ON                 INDICATE FILE NOTED             34212000
         ST    R11,INOTEVAL             SAVE RECORD POINTER             34213000
         LH    R10,JINFILE              GET INPUT FILE ADDRESS          34214000
         JNOTE FILE=(R10)               NOTE FILE POSITION              34215000
         L     R11,INOTEVAL             GET RECORD POINTER              34216000
         MVC   INOTEVAL,JNOTEVAL        SAVE NOTED ADDRESS              34217000
SYM6     CLC   XNAME,XNAME-XWORK(R11)   SEE IF CORRESPONDING RECORD     34218000
         BNE   SYM5                     IF NOT, TRY AGAIN               34219000
SYM3     TM    XFLDI-XWORK(R11),DEFINED                                 34220000
DEFINED  EQU   BIT1                                                     34221000
         BZ    DEFNERR                  UNDEFINED                       34222000
         GOIF  LTCALL,OFF=SYM7          SEE IF PROCESSING LITERAL       34223000
         LR    R10,R11                  PASS TO ENTER                   34224000
         ST    R10,JFWORD1              SAVE                            34225000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           34226000
         L    R11,JFWORD1               RESTORE POINTER                 34227000
SYM7     LH    R1,XLNGQ-XWORK(,R11)     LENGTH                          34228000
         GOIF  LNGQUOTE,ON=ABSOLUTE     THAT'S ALL WE'RE INTERESTED IN  34229000
         LR    R15,R1                   LENGTH ATTRIBUTE                34230000
         LH    R0,XESDI-XWORK(,R11)     ESDID                           34231000
         L     R1,XLCTR-XWORK(,R11)     VALUE                           34232000
         B     CLEANUP1                 FINIS                           34233000
NAMEMOVE MVC   XNAME(0),CHAR1-CHAR1(R14)     EXECUTED INSTRUCTION       34234000
         MEXIT                                                          34235000
.NOTX4V1 BH    SYNERR1                  SYMBOL LENGTH > 8               34236000
         GOIF  (JXREF,JLIST),NOTALL=SYM01  CHECK IF CROSS-REFERENCE     34237000
         GOIF  XRFNO,OFF=SYM01          IS XREF TO BE MADE              34238000
         LH    R10,JOUTFILE             GET OUTPUT FILE NUMBER          34239000
         JPUTL FILE=(R10),BUFREQ=XRFND  GET BUFFER                      34240000
         LR    R6,R11                   SAVE BUFFER POINTER             34241000
SYM01    EQU   *                        BRANCH LABEL                    34242000
         LH    R10,JINFILE              GET FILE NUMBER                 34243000
         JGETL FILE=(R10)               GET FROM FILE                   34244000
         GOIF  NOTEWL,OFF=SYM02         SHOULD WE NOTE SYMBOL LOCATION  34245000
         ST    R11,JFWORD1              SAVE SYMBOL FILE PTR    OX02953 34246000
         SET   NOTEHS,ON                YES, FIRST SET POINT INDICATOR  34247000
         SET   NOTEWL,OFF               SET NOTE SWITCH OFF             34248000
         LH    R10,JINFILE              POINT INPUT FILE                34249000
         JNOTE FILE=(R10)               NOTE SYMBOL LOCATION FOR RESCAN 34250000
         MVC   NOTEVAL,JNOTEVAL         SAVE NOTE VALUE                 34251000
         L     R11,JFWORD1              RESTORE SYMBOL FILE PTR OX02953 34252000
SYM02    EQU   *                        BRANCH LABEL                    34253000
         USING XRFIN,R6                 CREATE                          34254000
         GOIF  XRFNO,OFF=SYM03          XREF NECESSARY                  34255000
         GOIF  (JXREF,JLIST),NOTALL=SYM03 !OTH OPTIONS MUST BE ON       34256000
         SET   JXREFCHK,ON              THEY ARE SET XREF SWITCH ON     34257000
         MVC   XRECLN(D6),=AL2(XRFND,0,XRFTYPE*256) CROSS REFERENCE     34258000
         MVC   XRFSYM,RNAME               RECORD                        34259000
         MVI   XRFFLG,REF                   NAME, TYPE                  34260000
         MVC   XRFSTM,STMTN+D2                AND STATEMENT NUMBER      34261000
SYM03    EQU   *                        BRANCH LABEL                    34262000
         L     R6,SYMXRF                GET NUMBER  THUS FAR    OX02675 34263000
         LA    R6,D1(,R6)               ADD 1                           34264000
         ST    R6,SYMXRF                SAVE NEW CNT THIS CARD  OX02675 34265000
         GOIF  (PRIORDEF,DEFINED),ALL=SYM1,NONE=SYMR1  IS IT DEFINED    34266000
         GOIF  PRDEFREQ,ON=SYMR2        PRIOR DEFINITION REQUIRED       34267000
SYM1     EQU   *                                               @OY08064 34268000
         GOIF  EQUF1,ON=SYNERR2         LENGTH ATTR ERROR      @OY08064 34269000
         XC    JFWORD1,JFWORD1          ALIGN LENGTH ATTR      @OY08064 34270000
         MVC   JFWORD1+D2(D2),RLNGQ     A FULLWORD AREA                 34271000
         L     R1,JFWORD1               GET LENGTH ATTRIBUTE            34272000
         GOIF  LNGQUOTE,ON=ABSOLUTE     LENGTH ATTRIBUTE REFERENCE      34273000
         LR    R15,R1                   LENGTH ATTRIBUTE OF SYMBOL      34274000
         LH    R0,RESDI                 ESDID OF SYMBOL                 34275000
         L     R1,RLCTR                 VALUE OF SYMBOL                 34276000
         B     CLEANUP1                 GO BACK                         34277000
SYNERR1  X5ERRL 236,CLMPTR,SYNTAXER     ILLEGAL CHARACTER               34278000
SYNERR2  X5ERRL 120,CLMPTR,SYNTAXER     INVALID LENGTH ATTR REFERENCE   34279000
SYNERR3  X5ERRL 170,CLMPTR,SYNTAXER     CONSECUTIVE OPERATOR            34280000
SYNERR4  X5ERRL 233,CLMPTR,SYNTAXER     TOO MANY LEVELS OF PARENS       34281000
SYNERR6  X5ERRL 234,CLMPTR,SYNTAXER     PREMATURE END OF EXPRESSION     34282000
SYNERR8  X5ERRL 240,0,SYNTAXER          MISSING QUOTE                   34283000
SYNERR9  X5ERRL 168,0,SYNTAXER          TOO MANY TERMS                  34284000
SYNERR10 X5ERRL 238,CLMPTR,SYNTAXER     ILLEGAL USE OF &                34285000
SYNERR11 X5ERRL 187,CLMPTR,SYNTAXER     SYMBOL LENGTH > 8               34286000
SYMR1    ST    R11,ERRPTR                                               34287000
         X5ERRL 188,DTAPTR,DEFNERR      UNDEFINED SYMBOL                34288000
         JEXTRN (X5L01=LOGERR)          DEFINE EXTERNAL SYMBOL          34289000
SYMR2    ST    R11,ERRPTR                                               34290000
         X5ERRL 231,DTAPTR,DEFNERR      SYMBOL NOT PREVIOUSLY DEFINED   34291000
EXIT     JRETURN                                                        34292000
         MEND                                                           34293000
./ ADD NAME=XFOUR                                                       34294000
         MACRO                                                          34295000
&ID      XFOUR &DUMMY,&TESTRAN=NO,&DIAG=NO,&LEVEL=1                     34296000
         GBLC  &COMPNM                  COMPONENT NAME                  34297000
         LCLC  &NM                      MODULE NAME                     34298000
         JHEAD 'SYMBOL RESOLUTION PHASE MAIN LINE CONTROL',            ,34299000
               PHASEID=&ID,                                            ,34300000
               LEVEL=&LEVEL                                             34301000
&NM      SETC  '&COMPNM'.'&ID'                                          34302000
*TITLE-  ASSEMBLER SYMBOL RESOLUTION PHASE                            * 34303000
*                                                                     * 34304000
*FUNCTION/OPERATION-                                                  * 34305000
*        RESOLVE SYMBOLS FOR THE ASSEMBLY PHASE                       * 34306000
*        GENERATE THE EXTERNAL SYMBOL DICTIONARY (ESD)                * 34307000
*        PUNCH RECORDS GENERATED BY 'PUNCH' AND 'REPRO' STATEMENTS    * 34308000
*   BEFORE THE ESD                                                    * 34309000
         AIF   ('&TESTRAN' NE 'YES').PCH                                34310000
*        PUNCH TESTRAN RECORDS                                        * 34311000
.PCH     ANOP                                                           34312000
*                                                                     * 34313000
*ENTRY POINT-                                                         * 34314000
         ENTRY &NM.01                                                 * 34315000
*                                                                     * 34316000
*INPUT-                                                               * 34317000
*        A FILE CREATED BY THE MACRO GENERATOR PHASE CONSISTING OF    * 34318000
*   THE FOLLOWING TYPES OF RECORDS-                                   * 34319000
*        (1)  RECORDS GENERATED BY 'PUNCH' AND 'REPRO' STATEMENTS     * 34320000
*             BEFORE THE ESD                                          * 34321000
*        (2)  SYMBOL DEFINITIONS                                      * 34322000
*        (3)  SYMBOL REFERENCES                                       * 34323000
*        (4)  LITERALS                                                * 34324000
*        (5)  ASSEMBLER OPERATIONS AFFECTING THE ESD OR STORAGE       * 34325000
*             ASSIGNMENT (START, CSECT, DSECT, COM, DXD, ENTRY,       * 34326000
*             EXTRN, WXTRN, EQU, ORG, LTORG, CNOP, DC, DS, END)       * 34327000
*                                                                     * 34328000
*OUTPUT-                                                              * 34329000
*        'PUNCH' AND 'REPRO'  RECORDS ON THE PUNCH FILES              * 34330000
*        THE ESD ON THE PRINT AND PUNCH FILES                         * 34331000
*        THE SYMBOL FILE TO THE ASSEMBLY PHASE                        * 34332000
         AIF   ('&TESTRAN' NE 'YES').PCH2                               34333000
*        TESTRAN RECORDS TO THE PUNCH FILES                           * 34334000
.PCH2    ANOP                                                           34335000
*                                                                     * 34336000
*EXTERNAL ROUTINES-                                                   * 34337000
         AIF   ('&TESTRAN' NE 'YES').EXTRN                              34338000
         EXTRN &COMPNM.X4N01,&COMPNM.X4E01,&COMPNM.X4S01,&COMPNM.X4V01  34339000
         AGO   .EXTRN1                                                  34340000
.EXTRN   EXTRN &COMPNM.X4D01,&COMPNM.X4E01,&COMPNM.X4S01,&COMPNM.X4V01  34341000
.EXTRN1  ANOP                                                           34342000
*             BLDESD-    BUILD CONTROL SECTION ENTRY IN ESD           * 34343000
*             DCSCAN-    EVALUATE DC/DS OPERANDS AND LITERALS         * 34344000
*             XDSCAN-    EVALUATE DXD OPERANDS                        * 34345000
*             ENTRY-     PROCESS ENTRY POINT SYMBOL                   * 34346000
*             EVAL-      EVALUATE EXPRESSION                          * 34347000
*             EXTRN-     PROCESS EXTERNAL REFERENCE SYMBOL            * 34348000
*             FIND-      FIND AN ENTRY IN THE SYMBOL TABLE            * 34349000
*             GETESD-    GET AN ESD ENTRY                             * 34350000
*             MAKESD-    OUTPUT THE ESD                               * 34351000
*             SUBSET-    SUBSET THE SYMBOL TABLE                      * 34352000
*                                                                     * 34353000
*        ROUTINES IN THE CONTROLLER TO PERFORM INPUT/OUTPUT AND OTHER * 34354000
*   SYSTEM DEPENDENT FUNCTIONS-                                       * 34355000
*             JCHECK-    WAIT FOR COMPLETION OF A JREAD OR JWRITE     * 34356000
*             JFRECORE-  RELEASE MAIN STORAGE ALLOCATED BY JGETCORE   * 34357000
*             JGETCORE-  ALLOCATE MAIN STORAGE FOR WORK AREA          * 34358000
*             JGETL-     READ LOGICAL RECORD (LOCATE MODE)            * 34359000
*             JNOTE-     PROVIDE RECORD POSITION                      * 34360000
*             JPOINT-    POSITION TO A RECORD                         * 34361000
*             JPUTL-     WRITE LOGICAL RECORD (LOCATE MODE)           * 34362000
*             JPUTM-     WRITE LOGICAL RECORD (MOVE MODE)             * 34363000
*             JREAD-     READ PHYSICAL RECORD                         * 34364000
*             JWRITE-    WRITE PHYSICAL RECORD                        * 34365000
*                                                                     * 34366000
*EXITS, NORMAL-                                                       * 34367000
*        EXITS TO THE CONTROLLER                                      * 34368000
*                                                                     * 34369000
*EXITS, ERROR-                                                        * 34370000
*        NONE                                                         * 34371000
*                                                                     * 34372000
*TABLES/WORK AREAS-                                                   * 34373000
*        WORK AREA ALLOCATED BY JGETCORE ROUTINE IN THE CONTROLLER    * 34374000
*                                                                     * 34375000
*ATTRIBUTES-                                                          * 34376000
*        REFRESHABLE                                                  * 34377000
*                                                                     * 34378000
*NOTES-                                                               * 34379000
*                                                                     * 34380000
         EJECT                                                          34381000
         COPY  JCOMMON                                                  34382000
         EJECT                                                          34383000
         COPY  JTEXT                                                    34384000
         EJECT                                                          34385000
         COPY  ICOMMON                                                  34386000
         EJECT                                                          34387000
JTEXT    DSECT ,                                                        34388000
         ORG   JTEXT                    OVERLAY                         34389000
         COPY  RSYMRCD                                                  34390000
         EJECT                                                          34391000
* VS1 RELEASE 3.1 CHANGES                                               34392000
*A413300-413520                                                 OX00873 34393000
*C413600                                                        OX00873 34394000
*D257600                                                        OX04097 34395000
*C258400                                                        OX04097 34396000
*A478100-478400                                                 OY02611 34397000
*D479200                                                        OY02611 34398000
*A494700-495920                                                 OY02611 34399000
*A487700-487900,602100-602300                                  @OX07274 34400000
*C488000,602400                                                @OX07274 34401000
*C487900,586400,602100                                         @OX10361 34402000
*A586900-587100                                                @OX10361 34403000
*A338100-338320                                                @OY08064 34404000
*C337600                                                       @OY08064 34405000
*C341600                                                       @PI01040 34406000
*A342100-342200                                                @PI01040 34407000
*A257300                                                       @OY09620 34408000
*C255400,260000                                                @OY09620 34409000
*D478100-478200,495700-495920                                  @OX09723 34410000
*C478400,495200,608800                                         @OX09723 34411000
*A554900,558100,494900-495160,495700,608500-608700             @OX09723 34412000
*A309300-309800                                                @OY10603 34413000
*C256800                                                       @OZ07355 34414000
*C496000                                                       @AX14216 34415000
*C495120                                                       @AZ16488 34416000
*A448100,448200                                                @AZ18392 34417000
&NM.00   CSECT                                                          34418000
         JMODID                                                         34419000
         USING &NM.01,R12                                               34420000
&NM.01   DS    0H                       PHASE ENTRY                     34421000
I        LA    R14,IIII                 DEFINE ENTRY                    34422000
II       JSAVE BASE=NO                  PUSH REGISTERS                  34423000
         BR    R14                      PROCEED                         34424000
III      JRETURN                        PHASE EXIT                      34425000
         AIF   ('&TESTRAN' NE 'YES').X4DA                               34426000
         DC    A(&COMPNM.X4N01,&COMPNM.X4E01,&COMPNM.X4S01,&COMPNM.X4V0X34427000
               1)                       EXTERNAL ROUTINE BASE           34428000
         AGO   .X4NA                                                    34429000
.X4DA    DC    A(&COMPNM.X4D01,&COMPNM.X4E01,&COMPNM.X4S01,&COMPNM.X4V0X34430000
               1)                       EXTERNAL ROUTINE BASE           34431000
.X4NA    ANOP                                                           34432000
IIII     LR    R8,R12                   BASE REGISTER                   34433000
         DROP  R12                                                      34434000
         USING &NM.01,R8                                                34435000
         SPACE                                                          34436000
*                        INITIALIZATION                               * 34437000
         SPACE                                                          34438000
         LH    R11,=Y(MAXDBL)                                           34439000
         JGETCORE  MINDBL=MINDBL,MAXDBL=(R11)  GET STORAGE              34440000
         LR    R7,R10                   INITIALIZE COMMON AREA BASE     34441000
         XC    D0*256(256,R7),D0*256(R7)                                34442000
         XC    D1*256(256,R7),D1*256(R7)                                34443000
         XC    D2*256(256,R7),D2*256(R7)                                34444000
         XC    D3*256(256,R7),D3*256(R7)                                34445000
         XC    D4*256(256,R7),D4*256(R7)                                34446000
         XC    D5*256(256,R7),D5*256(R7)                                34447000
         XC    D6*256(256,R7),D6*256(R7)                                34448000
         XC    D7*256(256,R7),D7*256(R7)                                34449000
         MVC   SAVE(IIII-II),II         INITIALIZE COMMON               34450000
*                                                                       34451000
*        INITIALIZE WORK AREA FOR SYMBOL TABLE ROUTINES                 34452000
*                                                                       34453000
         AR    R11,R10                  POINT TO END OF COMMON          34454000
         LR    R14,R11                  FIRST SYMBOL TABLE ENTRY        34455000
         LR    R15,R11                  X                               34456000
         ST    R11,ENDOFCOM-D4          SAVE FOR LATER         FX0000   34457000
         LH    R0,=H'-20'               INCREMENT                       34458000
         LA    R1,ENDOFCOM+D20*D2       LAST SYMBOL TABLE ENTRY         34459000
         STM   R14,R1,SYMDIMEN          X                               34460000
*                                                                       34461000
*        INITIALIZE WORK AREA FOR LITERAL PROCESSING                    34462000
*                                                                       34463000
         LA    R10,ENDOFCOM             END-OF-COMMON                   34464000
         LA    R11,ENDOFCOM+D20         FIRST LITERAL ENTRY             34465000
         STM   R10,R11,LATADD           ADDRESS OF ADJUSTMENT TABLE     34466000
*                                                                       34467000
*        INITIALIZE WORK AREA FOR ESD PROCESSING                        34468000
*                                                                       34469000
         L     R15,=Y(D20*D16+D4,0)     BLOCK LENGTH                    34470000
         LA    R14,ESDBLK1+D4           GET ADDRESS OF FIRST BLOCK      34471000
         STM   R14,R15,ESDBLK1          PUT IN PARAMETER FOR READ/WRITE 34472000
         LA    R14,ESDBLK2+D4           GET ADDRESS OF SECOND BLOCK     34473000
         STM   R14,R15,ESDBLK2          PUT IN PARAMETER FOR READ/WRITE 34474000
         MVI   HIDESDID,DSW             ORGIN OF DSECT ESDID            34475000
*                                                                       34476000
*        INITIALIZE WORK AREA FOR EXPRESSION EVALUATION ROUTINE         34477000
*                                                                       34478000
         LA    R14,TERMS                START OF TERMS STACK            34479000
         LA    R15,RLIST                START OF RELOCATABILITY STACK   34480000
         LA    R0,OPRNS-D1              START OF OPERATOR STACK         34481000
         STM   R14,R0,ATPTR             X                               34482000
         TS    SELFDEFN                 ASSUMED INITIAL SETTING         34483000
         MVI   CLCLNG+D1,D1             LENGTH ATTRIBUTE OF ASTERISK    34484000
         SPACE                                                          34485000
         LA    R14,ESDBLK1              ADDRESS OF ONE BLOCK            34486000
         LA    R15,ESDBLK2              ADDRESS OF OTHER BLOCK          34487000
         STM   R14,R15,JFWORD1          STORE BOTH                      34488000
         MVC   NOTELIST(D8),JFWORD1     INITIALIZE FIRST ESD BLOCK      34489000
         MVC   NOTELIST+D9(D8),JFWORD2  INITIALIZE OTHER ESD BLOCK      34490000
         MVI   NOTELIST+L'JNOTEVAL,X'01'     X                          34491000
         MVI   NOTELIST+L'JNOTEVAL*2+1,X'01' X                          34492000
         LA    R6,ESDBLK1+D8            DUMMY POINTER                   34493000
         SPACE                                                          34494000
*TITLE-  GETNEXT                                                      * 34495000
*                                                                     * 34496000
*FUNCTION/OPERATION-                                                  * 34497000
*        THIS ROUTINE IS THE MAIN LINE CONTROL AND DRIVER FOR THE     * 34498000
*   SYMBOL RESOLUTION PHASE.  THIS ROUTINE GETS THE NEXT LOGICAL      * 34499000
*   RECORD FROM THE CURRENT INPUT FILE AND PASSES CONTROL TO ONE OF   * 34500000
*   THE FUNCTIONAL ROUTINES FOR PROCESSING.  THE FUNCTIONAL ROUTINE   * 34501000
*   SELECTED IS DEPENDENT UPON THE RECORD TYPE AND THE CURRENT MODE.  * 34502000
*   IF IN PASS ONE ASSIGNMENT MODE, THIS ROUTINE ALSO ADJUSTS THE     * 34503000
*   CURRENT LOCATION COUNTER AND SETS UP THE OPERAND COLUMN POINTER.  * 34504000
*                                                                     * 34505000
*INPUT-  NONE                                                         * 34506000
*                                                                     * 34507000
*OUTPUT- REGISTER R3 CONTAINS THE CURRENT LOCATION COUNTER VALUE.     * 34508000
*        REGISTER R4 IS A POINTER TO THE INPUT RECORD.                * 34509000
*        REGISTER R5 IS A POINTER TO THE OPERAND FILED.               * 34510000
*                                                                     * 34511000
         SPACE                                                          34512000
GETNEXT  LH    R10,JINFILE              GET ADDRESS OF INPUT FILE       34513000
         JGETL FILE=(R10)               GET NEXT RECORD                 34514000
         LR    R4,R11                   RECORD POINTER                  34515000
         SR    R1,R1                    CLEAR REGISTER                  34516000
         IC    R1,JTIOP1                GET RECORD TYPE                 34517000
         AR    R1,R1                    GET INDEX                       34518000
         LH    R2,MODE                  GET MODE                        34519000
         L     R2,RADIX(R2)             GET RADIX                       34520000
         SH    R2,D0(R1,R2)             GET ROUTINE VECTOR              34521000
         GOIF  (MODE1,MODE2)            SEE IF PASS 1 ASSIGNMENT MODE   34522000
         BNER  R2                       GO TO RESPECTIVE ROUTINES IF NO 34523000
* DO NOT MOVE INPUT RECORD IF SYMBOL OVERFLOW HAS NOT OCCURED           34524000
         GOIF IOFLO,OFF=DONTMOVE                                        34525000
* DO NOT MOVE REFERENCE RECORD                                          34526000
         GOIF JTIOP,JTSYMBL,EQ=DONTMOVE                                 34527000
         LH    R1,JTRLI                 RECORD LENGTH                   34528000
         LA    R3,INPUTBUF              BUFFER ADDRESS                  34529000
         CH    R1,ADMAXMVC              EXECUTE MOVE IF                 34530000
         BNH   MOVEX                    LESS THAN MAX MOVE LENGTH       34531000
         SH    R1,ADMAXMVC              SUBTRACT MOVED BYTES            34532000
         MVC   D0(MAXMVC,R3),D0(R4)     MOVE MAX LENGTH                 34533000
         LA    R4,MAXMVC(,R4)           BUMP FROM ADDRESS               34534000
         LA    R3,MAXMVC(,R3)           BUMP TO ADDRESS                 34535000
MOVEX    BCTR  R1,R0                    MINUS ONE FOR EXECUTE           34536000
         EX    R1,MVCIM                 EXECUTE MOVE INSTRUCTION        34537000
         LA    R4,INPUTBUF              POINT TO LOGICAL RECORD         34538000
DONTMOVE GOIF  RFIELDX,OFF=LOCTR1       SKIP IF NO OPERAND              34539000
         LA    R5,RLNGA                 POINT TO OPERAND                34540000
         GOIF  RFIELDN,OFF=LOCTR        SKIP IF NO NAME                 34541000
         LA    R5,RLNGB                 POINT TO OPERAND                34542000
LOCTR    SR    R1,R1                    CLEAR REGISTER                  34543000
         IC    R1,CHAR1                 GET OPERAND LENGTH              34544000
         LA    R5,CHAR2(R1)             POINT TO END-OF-OPERAND         34545000
         ST    R5,OPNEND                NOTE IT                         34546000
         SR    R5,R1                    POINT TO BEGINNING-OF-OPERAND   34547000
LOCTR1   GOIF  JDEF,OFF=(R2)            SKIP UPDATE LOCATION COUNTER    34548000
         SET   JDEF,OFF                 RESET INDICATOR                 34549000
         L     R3,ELCTR                 GET CURRENT LOCATION COUNTER    34550000
         NC    RLCTR,RLCTR              SEE IF BYTES SKIPPED            34551000
         BZ    LOCTR2                   NO, PROCEED                     34552000
         BAL   R9,ALIGN1                ALIGN TO HALFWORD BOUNDARY      34553000
         DC    H'-2,1'                  ALIGNMENT PARAMETERS            34554000
         AL    R3,RLCTR                 ADD NUMBER OF BYTES SKIPPED     34555000
         ST    R3,ELCTR                 UPDATE CURRENT LOCATION COUNTER 34556000
LOCTR2   MVC   RESDI(D6),EESDI          PASS CURRENT LOCATION COUNTER   34557000
         BR    R2                       GO TO RESPECTIVE ROUTINE        34558000
         SPACE                                                          34559000
MAXMVC   EQU   256                      MAX MOVE LENGTH                 34560000
ADMAXMVC DC    H'256'                   MAX MOVE LENGTH                 34561000
MVCIM    MVC   D0(*-*,R3),D0(R4)        MOVE LOGICAL RECORD             34562000
         SPACE                                                          34563000
INPC     LA    R10,HICESDID             GET PARAMETER                   34564000
         MVC   XPARM,CSTPARM            PASS PARAMETERS                 34565000
         GOTO  BLDESD                   BUILD ESD ENTRY                 34566000
         LR    R6,R10                   MAKE CONTROL SECTION CURRENT    34567000
         AIF   ('&TESTRAN' NE 'YES').INPC                               34568000
         BAL   R9,ESDPUNCH              OUTPUT TESTRAN ITEM             34569000
.INPC    B     EPILOGUE                 FINIS                           34570000
         SPACE                                                          34571000
SEARCH   GOIF  (RFIELDN,PRIORDEF),NOTMIX=TRANSFER                       34572000
         LR    R10,R4                   PASS RECORD POINTER             34573000
         GOTO  FIND                     LOOKUP IN SYMBOL TABLE          34574000
         BNE   TRANSFER                 NOT FOUND                       34575000
         GOIF  ESDNRSW,ON=TRANSFER      DEFER FLAGGING                  34576000
         SET   PRIORDEF,ON              INDICATE PREVIOUSLY DEFINED     34577000
         B     TRANSFER                 OUTPUT RECORD                   34578000
         SPACE                                                          34579000
EOFIIS   SET   MODE1,OFF                INDICATE END OF SUBSTITUTION    34580000
         SET   IOFLO,ON                 INDICATE TABLE OVERFLOWED       34581000
         GOIF  STBLOFLO                 SEE IF SUBSETTED                34582000
         GOTO  SUBSET                   SUBSET                          34583000
         L     R0,SYMDIMEN+D4           GET ADDRESS                     34584000
         SH    R0,=H'1024'              MARGIN                          34585000
         C     R0,LATEND                SEE IF OVERLAPPING LITERAL POOL 34586000
         BNL   GETNEXT                  ENOUGH ROOM                     34587000
         MVI   JPRTONLY,JPRONLY         SET FLUSH CONDITION             34588000
         SET   (MODE1,MODE2),ON         SET EXIT CONDITION              34589000
         B     BUGOUT                   JUST LIKE IT SAYS               34590000
         SPACE                                                          34591000
REHASH   GOIF  STBLOFLO                 SEE IF SUBSETTED                34592000
         GOTO  SUBSET                   SUBSET                          34593000
         LR    R10,R4                   POINTER                         34594000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           34595000
         B     GETNEXT                  FINIS                           34596000
         SPACE                                                          34597000
START    SR    R0,R0                    ZERO                            34598000
         CH    R0,FSTCSECT              SEE IF FIRST CSECT              34599000
         BNE   CSECT                    ILLEGAL START IF NOT FIRST      34600000
         GOIF  RFIELDX,OFF=START1       NO OPERAND                      34601000
         CLC   CHAR1(D2),=AL1(JCOMMA,JBLANK) LOOK FOR NULL OPERAND      34602000
         BE    START1                   A CLEAN START, VRRRRRRRROM      34603000
         GOTO  EVAL                     EVALUATE OPERAND                34604000
         BNZ   CSECT                    ERROR                           34605000
         GOIF  LOCTREF,ON=CSECT         LOCATION COUNTER REFERENCE      34606000
         LA    R11,D7(,R11)             ROUND TO DOUBLE WORD BOUNDARY   34607000
         ST    R11,STARTLOC             SAVE                            34608000
START1   OI    RFLGB,BIT0               INDICATE VALID START CARD       34609000
         SPACE                                                          34610000
CSECT    L     R11,CSTPARM              GET PARAMETER                   34611000
CSECT1   LA    R10,HICESDID             X                               34612000
CSECT2   ST    R11,XPARM                PASS                            34613000
         GOTO  BLDESD                   GO MAKE ESD ENTRY               34614000
         LR    R6,R10                                                   34615000
         MVC   RESDI(L'RESDI+L'RLCTR),EESDI                             34616000
         BAL   R9,WRITE2                WRITE CROSS-REFERENCE RECORD    34617000
         AIF   ('&TESTRAN' NE 'YES').CSECT                              34618000
         BAL   R9,ESDPUNCH              OUTPUT TESTRAN ITEM             34619000
.CSECT   B     EPILOGUE                 FINIS                           34620000
         SPACE                                                          34621000
DSECT    L     R11,DSTPARM              GET PARAMETER                   34622000
         LA    R10,HIDESDID                                             34623000
         B     CSECT2                                                   34624000
         SPACE                                                          34625000
COM      L     R11,COMPARM              GET PARAMETER                   34626000
         B     CSECT1                   COMMON ROUTINE                  34627000
         SPACE                                                          34628000
REPRO    JPUNCH  SEQ=NO                 GET PUNCH BUFFER                34629000
         SR    R15,R15                  CLEAR REGISTER                  34630000
         IC    R15,RESDI                GET OPERAND LENGTH              34631000
         LTR   R15,R15                  SEE IF LENGTH OF OPERAND ZERO   34632000
         BE    GETNEXT                  FINIS IF SO                     34633000
         LR    R14,R15                  CLEAR REGISTER                  34634000
         IC    R14,RFLDI                GET OUTPUT COLUMN POINTER       34635000
         BCTR  R14,0                    DECREMENT BY ONE                34636000
         BCTR  R15,0                    DECREMENT BY ONE                34637000
         AR    R11,R14                  POINT TO OUTPUT COLUMN          34638000
         EX    R15,REPRO1               MOVE IN OPERAND                 34639000
         B     GETNEXT                  FINIS                           34640000
REPRO1   MVC   D0(D0,R11),RESDI+D1      EXECUTED INSTRUCTION            34641000
         SPACE                                                          34642000
PUNCH    LA    R2,D1                    INCREMENT                       34643000
         SR    R3,R3                    ZERO REGISTER                   34644000
         IC    R3,RESDI                 OPERAND LENGTH                  34645000
         CLI   RESDI,D3                 CHECK IF NULLSTRING             34646000
         BL    GETNEXT                  ERROR IF SO                     34647000
         AR    R3,R4                    POINT TO END OF OPERAND         34648000
         BCTR  R3,D0                    MINUS ONE                       34649000
         LR    R5,R4                    POINT TO BEGINNING OF OPERAND   34650000
         CLI   D7(R5),JQUOTE            MUST BEGIN WITH A QUOTE         34651000
         BNE   GETNEXT                  ERROR IF NOT                    34652000
PUNCH1   BXH   R5,R2,GETNEXT            POINT TO NEXT CHARACTER         34653000
PUNCH2   CLI   D7(R5),JQUOTE            SEE IF CHARACTER A QUOTE        34654000
         BNE   PUNCH6                   NOT A QUOTE                     34655000
         BXLE  R5,R2,PUNCH4             A QUOTE, SEE IF PAIRED QUOTES   34656000
PUNCH3   JPUNCH  SEQ=NO                 DEL BY A TRAIL QUOTE            34657000
         LA    R4,D3(,R4)               GET OPERAND LENGTH              34658000
         SR    R5,R4                    GET LENGTH OF OPERAND           34659000
         BM    GETNEXT                  NULL QUOTES                     34660000
         LA    R1,D9*D9-D2              79                              34661000
         CR    R1,R5                    SEE IF MORE THAN 80 CHARACTERS  34662000
         BNL   PONCHO                   LESS THAN 80                    34663000
         LR    R5,R1                    OPERNAD TOO LONG                34664000
PONCHO   EX    R5,PUNCH8                MOVE IN PUNCH OPERAND           34665000
         B     GETNEXT                  FINIS                           34666000
PUNCH4   CLI   D7(R5),JQUOTE            SEE IF PAIRED QUOTES            34667000
         BNE   GETNEXT                   NOT PAIRED ', FINIS   @OZ07355 34668000
PUNCH5   BCTR  R3,D0                    OP IS 1 LESS           @OY09620 34669000
         LR    R1,R3                    POINT TO 2:ND OF PAIR   OX04097 34670000
         SR    R1,R5                    GET LENGTH OF OPERAND REMAINDER 34671000
         BM    GETNEXT                  NO ENDING QUOTE        @OY09620 34672000
         EX    R1,PUNCH9                MAKE PAIR TO APPEAR AS ONE      34673000
         B     PUNCH2                   LOOP                            34674000
PUNCH6   CLI   D7(R5),JAMPER            SEE I& AN AMPERSAND             34675000
         BNE   PUNCH1                   JUST AN ORDINARY CHARACTER      34676000
         BXH   R5,R2,GETNEXT            POINT TO NEXT CHARACTER         34677000
         CLI   D7(R5),JAMPER            SEE IF PAINER AMPERSANDS        34678000
         BE    PUNCH5                   IT HAD BETTER BE                34679000
         B     GETNEXT                  OR OTHERWISE IT IS IN ERROR     34680000
PUNCH8   MVC   D0(D0,R11),D5(R4)        MOVE OPERAND ONTO CARD          34681000
PUNCH9   MVC   D7(D0,R5),D8(R5)         OVERLAP THE REDUNDANT ONE       34682000
         SPACE                                                          34683000
DC       MVI   TYPECALL,DCCALL+DEFNAME  PARAMETER                       34684000
         GOIF  (DSW2,CSW2),NONE=DC1     ESD SUPPRESSION                 34685000
         OI    TYPECALL,NOESD           SUPPRESS ESD PROCESSING         34686000
DC1      GOIF  (RFIELDN,PRIORDEF),MIX=DC2    NAME PREVIOUSLY DEFINED    34687000
         SET   DEFNAME,OFF              NO NAME DEFINITION              34688000
DC2      GOTO  DCSCAN                                                   34689000
         LH    R0,LATTRSAV                                              34690000
         GOIF  RFIELDN,OFF=DC3          SKIP IF NO NAME                 34691000
         STH   R0,RLNGQ                 PASS                            34692000
DC3      MVC   RFLGA,OPCNT+D1           NUMBER OF GOOD OPERANDS         34693000
B52      BAL   R9,WRITE2                WRITE RECORD                    34694000
         B     EPILOGUE                 FINIS                           34695000
         SPACE                                                          34696000
DS       MVI   TYPECALL,DSCALL+DEFNAME+NOESD PARAMETER                  34697000
         B     DC1                      VINTAGE                         34698000
         SPACE                                                          34699000
ENTRY    GOTO  ENTRY                    GO TO ROUTINE                   34700000
         B     TRANSFER                 WRITE ON OUTPUT FILE            34701000
         SPACE                                                          34702000
EXTRN    MVI   RTYPE,ETYPEER            TYPE                            34703000
EXTRN1   MVI   RFLGB,ESDNRSW            SWITCH                          34704000
         GOTO  EXTRN                    GO TO ROUTINE                   34705000
         B     TRANSFER                 WRITE ON OUTPUT FILE            34706000
         SPACE                                                          34707000
WXTRN    MVI   RTYPE,ETYPEWX            TYPE                            34708000
         B     EXTRN1                   TREAT AS EXTRN                  34709000
         SPACE                                                          34710000
DXD      GOIF  RFIELDN,OFF=GETNEXT      LIKELY                          34711000
         MVI   RFLGA,D0                                                 34712000
         LR    R10,R4                                                   34713000
         GOTO  FIND                                                     34714000
         BNZ   DXD1                                                     34715000
         GOIF  ENTRYSW,ON=DXD1                                          34716000
         SET   PRIORDEF,ON                                              34717000
DXD1     LA    R0,D1                                                    34718000
         STH   R0,RLNGQ                                                 34719000
         SR    R0,R0                                                    34720000
         ST    R0,RLCTR                                                 34721000
         GOIF  PRIORDEF,ON=B52                                          34722000
         GOIF  RFIELDX,OFF=B52                                          34723000
         MVC   XPARM,DXDPARM            PASS PARAMETERS                 34724000
         LA    R10,HICESDID             PASS ESDID                      34725000
         GOTO  BLDESD                   MAKE ESD ENTRY                  34726000
         GOTO  XDSCAN                   SCAN OPERAND                    34727000
         B     DC3                      BON VOYAGE                      34728000
         SPACE                                                          34729000
EQU      LA    R3,WRITE                 EXIT TIME ADDRESS               34730000
         XC    REFCOUNT,REFCOUNT        RESET COUNT            @OY10603 34731000
         XC    SYMCOUNT,SYMCOUNT        RESET COUNT            @OY10603 34732000
         XC    RESDI(D6),RESDI                                          34733000
         GOIF  RFIELDN,OFF=(R3)                                         34734000
         MVC   RLNGQ,=H'1'              LENGTH ATTRIBUTE OF *           34735000
         BAL   R2,EQU1                  EVALUATE EXPRESSION(S)          34736000
         GOIF  PRIORDEF,ON=(R3)         EXIT IF PREVIOUSLY DEFINED      34737000
         LR    R10,R4                   PASS POINTER                    34738000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           34739000
         BER   R3                       OK                              34740000
         SET   PRIORDEF,ON              INDICATE PREVIOUSLY DEFINED     34741000
         BR    R3                       GO ANYWAY                       34742000
EQU1     GOIF  RFIELDX,OFF=(R2)         NO OPERAND, DEFAULT TO *        34743000
         CLI   CHAR1,JCOMMA             FIRST OPERAND PRESENT           34744000
         BE    EQU4                     YEAH                            34745000
         GOTO  EVAL                     EVALUATE FIRST OPERAND          34746000
         BOR   R2                       SYNTACTIC ERROR                 34747000
         BALR  R1,D0                    SAVE CONDITION CODE             34748000
         CLI   D0(R14),JBLANK           SEE IF VALID END OF OPERAND     34749000
         BE    EQU2                     YEAH                            34750000
         CLI   D0(R14),JCOMMA           THIS IS OK ALSO                 34751000
         BNER  R2                       OTHERWISE, A NO-NO              34752000
EQU2     LR    R5,R14                   COLUMN POINTER                  34753000
         SPM   R1                       SET CONDITION CODE              34754000
         BL    EQU3                     BADDIE                          34755000
         AIF   ('&TESTRAN' NE 'YES').EQUX                               34756000
         BZ    EQUABS                   BRANCH IF ABSOLUTE OPND         34757000
         LA    R3,XREF3                 EXIT IF SIMPLY RELOCATABLE      34758000
EQUABS   STH   R10,RESDI                ESDID                           34759000
         AGO   .EQUY                                                    34760000
.EQUX    STH   R10,RESDI                ESDID                           34761000
.EQUY    ST    R11,RLCTR                VALUE                           34762000
EQU3     MVC   RLNGQ,IMPLNG             LENGTH ATTRIBUTE                34763000
         MVC   RFLGB,EVALSW1            TATTLE TALE                     34764000
         CLI   CHAR1,JBLANK             END OF EVALUATION               34765000
         BER   R2                       YUP                             34766000
EQU4     LA    R5,CHAR2                 POINT TO NEXT CHARACTER         34767000
         CLI   CHAR1,JCOMMA             NULL OPERAND                    34768000
         BER   R2                       YES                             34769000
         GOTO  EVAL                     EVALUATE SECOND OPERAND         34770000
         BE    EQU6                     OK                     @OY08064 34771000
         GOIF  NOTDEFN,OFF=(R2)         ERROR - UNDEF SYMB ?   @OY08064 34772000
         SET   EQUF1,ON                 MARK IT IN RECORD      @OY08064 34773000
         BR    R2                       AND RETURN             @OY08064 34774000
EQU6     EQU   *                                               @OY08064 34775000
         CLI   D0(R14),JBLANK           SEE IF PROPERLY DELIMITED       34776000
         BE    EQU5                     YES                             34777000
         CLI   D0(R14),JCOMMA           THIS IS OK ALSO                 34778000
         BNER  R2                       THIS ISN'T                      34779000
EQU5     EQU   *                                               @OY01040 34780000
         SET   EQUF1,ON                 MARK IN CASE OF ERROR  @PI01040 34781000
         CL    R11,=F'65535'            SEE IF WITHIN ALLOWANCE@PI01040 34782000
         BHR   R2                       NOPE                            34783000
         SET   EQUF1,OFF                ALL RIGHT              @PI01040 34784000
         STH   R11,RLNGQ                LANGTH ATTRIBUTE OVERRIDDEN     34785000
         BR    R2                       RETURN                          34786000
         SPACE                                                          34787000
CNOP     BAL   R9,ALIGN                 ALIGN TO HALFWORD BOUNDARY      34788000
         DC    H'-2,1'                  ALIGNMENT PARAMETERS            34789000
         ST    R3,RLCTR                 UPDATE CURRENT LOCATION COUNTER 34790000
         BAL   R9,XREF                  CROSS REFERENCE NAME FIELD      34791000
         AIF   ('&TESTRAN' NE 'YES').CNOPY                              34792000
         BAL   R9,MISPUNCH              OUTPUT TESTRAN ITEM             34793000
.CNOPY   GOIF  RFIELDX,OFF=EPILOGUE     NO OPERAND, NO GOOD             34794000
         GOTO  EVAL                     EVALUATE FIRST OPERAND          34795000
         BNE   EPILOGUE                 MUST BE ABSOLUTE                34796000
         CLI   D0(R14),JCOMMA           SEE IF THERE'S A SECOND OPERAND 34797000
         BNE   EPILOGUE                 TUBE IT IF NONE                 34798000
         LR    R2,R11                   SAVE VALUE OF FIRST OPERAND     34799000
         N     R11,=F'1'                SEE IF FIRST OPERAND IS ODD     34800000
         BNZ   EPILOGUE                 THAT'S ODD, TOO BAD             34801000
         LA    R5,D1(,R14)              POINT TO SECOND OF TWO OPERANDS 34802000
         GOTO  EVAL                     EVALUATE SECOND OPERAND         34803000
         BNE   EPILOGUE                 INVALID UNLESS IT'S ABSOLUTE    34804000
         CLI   D0(R14),JBLANK           LOOK FOR VALID DELIMITER        34805000
         BNE   EPILOGUE                 MUST BE A BLANK                 34806000
         LCR   R10,R11                  ALIGNMENT MASK                  34807000
         CL    R10,=F'-4'               FULLWORD                        34808000
         BE    CNOP1                    SKIP IF SO                      34809000
         CL    R10,=F'-8,4'             DOUBLEWORD                      34810000
         BNE   EPILOGUE                 8                               34811000
CNOP1    CLR   R2,R11                   FIRST OPERAND MUST BE SMALLER   34812000
         BNL   EPILOGUE                 OF THE TWO TO BE VALID          34813000
         NR    R3,R10                   TO SPECIFIED BOUNDARY           34814000
         AR    R3,R2                    ADD VALUE OF FIRST OPERAND      34815000
         C     R3,ELCTR                 THE RESULT SHOULD BE GREATER    34816000
         BNL   CNOP2                    THAN THE ORIGINAL VALUE         34817000
         AR    R3,R11                   OTHERWISE ADD ON SECOND OPERAND 34818000
CNOP2    ST    R3,ELCTR                 THIS IS THE NEW LOCATION        34819000
         B     EPILOGUE                 FINIS                           34820000
         SPACE                                                          34821000
ORG      BAL   R9,XREF                  CROSS REFERENCE NAME FIELD      34822000
         AIF   ('&TESTRAN' NE 'YES').ORGY                               34823000
         BAL   R9,MISPUNCH              OUTPUT TESTRAN ITEM             34824000
.ORGY    LH    R10,JOUTFILE             OUTPUT FILE ADDRESS             34825000
         LA    R11,D12                  LENGTH OF RECORD                34826000
         JPUTL FILE=(R10),BUFREQ=(R11)  GET OUTPUT BUFFER               34827000
         GOIF  RFIELDX                  SEE IF THERE'S AN OPERAND       34828000
         LR    R4,R11                   RECORD POINTER                  34829000
         MVC   JTRLI(D6),LOCRCD         ADJUSTMENT RECORD               34830000
         MVC   RESDI(D6),EESDI          CURRENT ESDID AND VALUE         34831000
         BZ    ORG1                     GO TO ORG BLANK                 34832000
         CLI   CHAR1,JCOMMA             SEE IF NULL OPERAND             34833000
         BE    ORG1                     X                               34834000
         GOTO  EVAL                     EVALUATE OPERAND                34835000
         BNH   EPILOGUE                 NOT SIMPLY RELOCATABLE          34836000
         CLI   D0(R14),JBLANK           CHECK FOR PROPER DELIMITER      34837000
         BNE   EPILOGUE                 BAD DELIMITER                   34838000
         CH    R10,EESDI                SEE IF IN THIS CONTROL SECTION  34839000
         BNE   EPILOGUE                 OUT OF CONTROL, SECTIONWISE     34840000
         LTR   R11,R11                  SEE IF NEGATIVE                 34841000
         BM    EPILOGUE                 NEGATIVE, OUT OF CONTROL        34842000
         CL    R3,EHILC                 SEE IF NECESSARY TO SAVE VALUE  34843000
         BNH   ORG2                     NOPE                            34844000
         ST    R3,EHILC                 SAVE CURRENT LOCATION COUNTER   34845000
         B     ORG2                     CONTINUE                        34846000
ORG1     L     R11,EHILC                GET SAVED HIGHEST ADDRESS       34847000
         CLR   R3,R11                   SEE IF HIGHER THAN CURRENT      34848000
         BNL   ORG3                     INEFFECTIVE                     34849000
ORG2     ST    R11,ELCTR                MODIFY ADDRESS TO NEW VALUE     34850000
         ST    R11,RLCTR                PASS IN RECORD                  34851000
ORG3     MVI   RFLGB,GOODORG            INDICATE ERROR FREE ORG         34852000
GOODORG  EQU   BIT0                     X                               34853000
         B     EPILOGUE                 FINIS                           34854000
         SPACE                                                          34855000
SYMBL    LH    R14,REFCOUNT             GET COUNT                       34856000
         CH    R14,SYMCOUNT             COMPARE TO TOTAL                34857000
         BNL   SYMBOL                   SKIP IF NOT APPLICABLE          34858000
         LA    R15,D1(,R14)             BUMP COUNT                      34859000
         STH   R15,REFCOUNT             UPDATE COUNT                    34860000
         SRDL  R14,D3                   FIRST SUBSCRIPT IN R14          34861000
         SRL   R15,D29                  SECOND SUBSCRIPT IN R15         34862000
         LA    R1,BIT0                  INITIAL MASK                    34863000
         SRL   R1,D0(R15)               ADDRESS BIT                     34864000
         LA    R15,VEETABLE(R14)        ADDRESS BYTE                    34865000
         EX    R1,TMINST                SEE IF V-CON SYMBOL             34866000
         BZ    SYMBOL                   SKIP IF NOT                     34867000
         SPACE                                                          34868000
SYMBOL   LR    R10,R4                   PARAMETER                       34869000
         GOTO  FIND                     LOOKUP IN SYMBOL TABLE          34870000
         BNE   TRANSFER                 NO FURTHER                      34871000
         CLI   JSW0033,MODE2            MODE 1S                 OX00873 34872000
         BNE   SYMBOL05                 NO,BRANCH               OX00873 34873000
         TM    RNAME,BIT0               TEST IF VCON BIT ON     OX00873 34874000
         BO    TRANSFER                 YES                     OX00873 34875000
SYMBOL05 GOIF  ENTRYSW,ON=TRANSFER      UNDEFINED ENTRY SYMBOL  OX00873 34876000
         SET   DEFINED,ON               INDICATE DEFINED                34877000
         MVC   RFLGB,SFLGS              PASS FLAGS                      34878000
         MVC   RESDI(L'RESDI+L'RLCTR),SESDI  PASS ESDID AND VALUE       34879000
         LA    R15,1                    PASS LENGTH ATTRIBUTE           34880000
         GOIF  ESDNRSW,ON=SYMBOL1       SEE IF EXTERNAL NAME            34881000
         LH    R15,SLNGQ                GET LENGTH ATTRIBUTE            34882000
SYMBOL1  STH   R15,RLNGQ                PASS LENGTH ATTRIBUTE           34883000
         GOIF  MODE1,OFF=SYMBOL2                                        34884000
         GOIF  MODE2,ON=ADJUST,ELSE=SYMBOL3                             34885000
SYMBOL2  SET   PRIORDEF,ON                                              34886000
         NI    RNAME,BITFF-BIT0                                         34887000
SYMBOL3  MVI   JTIOP1,JTADJII                                           34888000
         B     TRANSFER                 OUTPUT RECORD                   34889000
         SPACE                                                          34890000
CXD      BAL   R9,ALIGN1                ALIGN TO FULLWORD BOUNDARY      34891000
         DC    H'-4,3'                  ALIGNMENT PARAMETERS            34892000
         LA    R1,D4                    LENGTH ATTRIBUTE                34893000
         AIF   ('&TESTRAN' NE 'YES').CXD                                34894000
         ST    R3,RLCTR                 VALUE OF SYMBOL                 34895000
         BAL   R9,XREF1                 CROSS-REFERENCE NAME, IF ANY    34896000
         SET   TDATA                    INDICATE TESTRAN ITEM TYPE      34897000
         BAL   R9,ANYPUNCH              OUTPUT TESTRAN ITEM             34898000
         LA    R10,D2                   LENGTH                          34899000
         MVC   ORGBYTE(D2),=AL1(DTYPEA,D3)   DATA TYPE AND LENGTH       34900000
         BAL   R9,SYMPUNCH              OUTPUT TESTRAN ITEM             34901000
         B     EPILOGUE                 FINIS                           34902000
         AGO   .CXD1                                                    34903000
.CXD     B     MACHOP1                  SKIP                            34904000
.CXD1    SPACE                                                          34905000
CCW      BAL   R9,ALIGN                 ALIGN TO DOUBLEWORD BOUNDARY    34906000
         DC    H'-8,7'                  ALIGNMENT PARAMETERS            34907000
         LA    R1,D8                    LENGTH ATTRIBUTE                34908000
         AIF   ('&TESTRAN' NE 'YES').CCW                                34909000
         ST    R3,RLCTR                 VALUE OF SYMBOL                 34910000
         BAL   R9,XREF1                 CROSS-REFERENCE NAME, IF ANY    34911000
         SET   TCCW                     INDICATE TESTRAN ITEM TYPE      34912000
         BAL   R9,ANYPUNCH              OUTPUT TESTRAN ITEM             34913000
         B     EPILOGUE                 FINIS                           34914000
         AGO   .CCW1                                                    34915000
.CCW     B     MACHOP1                  SKIP                            34916000
.CCW1    SPACE                                                          34917000
MACHOP   BAL   R9,ALIGN                 ALIGN TO HALFWORD BOUNDARY      34918000
         DC    H'-2,1'                  ALIGNMENT PARAMETERS            34919000
         XC    REFCOUNT,REFCOUNT        ZERO REFCOUNT          @AZ18392 34920000
         XC    SYMCOUNT,SYMCOUNT        ZERO SYMCOUNT          @AZ18392 34921000
         GOIF  RFIELDN,OFF=MACHOP1      TEST IF NAME IS PRESENT         34922000
         LH    R1,RLNGQ                 LENGTH ATTRIBUTE                34923000
MACHOP1  ST    R3,RLCTR                 LOCATION COUNTER VALUE          34924000
         BAL   R9,XREF1                 CROSS-REFERENCE NAME, IF ANY    34925000
         AIF   ('&TESTRAN' NE 'YES').MACHOP                             34926000
         SET   TMOP                                                     34927000
         BAL   R9,MOPPUNCH              OUTPUT TESTRAN ITEM             34928000
.MACHOP  B     EPILOGUE                 FINIS                           34929000
         SPACE                                                          34930000
LITERAL  MVI   TYPECALL,LTCALL+NOESD    PASS PARAMETERS                 34931000
         GOTO  DCSCAN                   DETERMINE LITERAL OBJECT LENGTH 34932000
         SR    R3,R3                    DISPLACEMENT                    34933000
         LTR   R2,R15                   LENGTH OF LITERAL               34934000
         BZ    LITRPUT                  BAD IF ZERO OBJECT LENGTH       34935000
         N     R2,=F'7'                 GET MODULO SUM                  34936000
         IC    R2,INDEX(R2)             USE IT TO GET INDEX VALUE       34937000
         SR    R14,R5                   FIND LITERAL SOURCE LENGTH      34938000
         BCTR  R5,0                     POINT TO LENGTH INDICATOR       34939000
         STC   R14,CHAR1                MODIFY LITERAL SOURCE LENGTH    34940000
         STH   R14,JLITLNG              SAVE LONGER LENGTH              34941000
LITERAL4 SR    R0,R0                    ZERO R2                         34942000
         GOIF  DLOCTREF,OFF=LITERAL1    SKIP IF SO                      34943000
         LA    R0,D6                    LOCATION COUNTER REFERENCED     34944000
LITERAL1 LA    R3,LATA8-D4(R2)          POINT TO RESPECTIVE CHAIN       34945000
LITERAL2 LR    R1,R3                    TUCK ON CHAIN                   34946000
         L     R3,D0(,R1)               LOOK AT THE NEXT ENTRY          34947000
         LTR   R3,R3                    SEE IF AT THE END OF THE ROPE   34948000
         BZ    LITERAL3                 GO PUT IN ENTRY IF SO           34949000
         LTR   R0,R0                    IF LOCATION COUNTER REFERENCED  34950000
         BNZ   LITERAL2                 DON'T LOOK AT IT                34951000
         EX    R14,LITCLC               LOOK AT THIS LITERAL ENTRY      34952000
         BNE   LITERAL2                 SKIP IF NOT THE SAME            34953000
         L     R3,D4(,R3)               GET DISPLACEMENT OF THE ENTRY   34954000
         SLL   R14,D16                  LENGTH                          34955000
         OR    R2,R14                   LENGTH                          34956000
         B     LITRPUT                  PUT OUT THIS RECORD    FX0000   34957000
LITERAL3 LM    R11,R12,LATADD           GET LITERAL POOL ADDR  @OX09723 34958000
*        LA    R9,41(R12,R14)           ESTIMATE LENGTH OF ENTRFX0000   34959000
         LA    R9,52(,R12)              ALL OF THIS CODE IS    FX0000   34960000
         AR    R9,R0                    TO HANDLE > 13 LTORG   FX0000   34961000
         AH    R9,JLITLNG               STATEMENTS             FX0000   34962000
         STM   R4,R5,JDWORD             SAVE FOR WORK          FX0000   34963000
         L     R5,ENDOFCOM-D4           GET PTR TO 1ST SYMBOL          *34964000
                                        TABLE ENTRY            FX0000   34965000
         CR    R9,R5                    IS TABLE FULL ?        FX0000   34966000
         BNH   LITERALC                 NO, CONTINUE           FX0000   34967000
         LM    R4,R5,JDWORD             YES, RESTORE WORK REG  FX0000   34968000
         B     LITRFULL                 HANDLE FULL TABLE      FX0000   34969000
         SPACE ,                                               FX0000   34970000
LITERALC DS    0H                                              FX0000   34971000
         SR    R5,R9                    START THE ADJUSTMENT   FX0000   34972000
         SR    R4,R4                    CLEAR R4 FOR DIVIDE    FX0000   34973000
         D     R4,=F'20'                LENGTH OF ENTRY        FX0000   34974000
         AR    R9,R4                    NEW TABLE PTR ADD      FX0000   34975000
         N     R4,=F'-4'                ROUNDING TO FW BNDRY   FX0000   34976000
         STH   R4,JHWORD1               SAVE FOR LATER         FX0000   34977000
         LM    R4,R5,JDWORD             RESTORE REGS           FX0000   34978000
         CL    R9,SYMDIMEN+4            SEE IF ENOUGH ROOM              34979000
         BH    LITRFULL                 NOT ENOUGH                      34980000
         XC    D0(D4,R12),D0(R12)       ZERO CHAIN POINTER              34981000
         ST    R12,D0(,R1)              CHAIN POINTER                   34982000
         L     R3,D0(R2,R11)            OBJECT LENGTH OF THIS CHAIN     34983000
         AR    R15,R3                   ADD ON LENGTH OF THIS LITERAL   34984000
         ST    R3,D4(,R12)              PUT ONE INTO THE LITERAL POOL   34985000
         ST    R15,D0(R2,R11)           THE OTHER IN ADJUSTMENT TABLE   34986000
         MVC   D10(D6,R12),EESDI        SAVE LOCATION COUNTER           34987000
         TM    XPARM,XDUMMY             TEST IF IN DSECT       @OX07274 34988000
         BZ    LITERAL5                 NO, CSECT              @OX07274 34989000
         OI    D8(R12),INDSECT          RESIDES IN DSECT       @OX10361 34990000
LITERAL5 STH   R0,D8(,R12)              INDICATE LOC COUNTER   @OX07274 34991000
         AR    R12,R0                   BUMP PAST LOCATION COUNTER      34992000
         EX    R14,LITMVC               MOVE IN LITERAL SOURCE          34993000
         AR    R12,R14                  POINT PAST LITERAL SOURCE       34994000
         SLL   R14,D16                  MOVE TO HIGH ORDER BYTE         34995000
         OR    R2,R14                   INSERT IN OUTPUT RECORD         34996000
         MVI   D11(R12),JBLANK          INSERT A BLANK                  34997000
         LA    R12,D15(,R12)            ROUND TO FULLWORD BOUNDARY      34998000
         N     R12,=F'-4'               ROUND TO FULLWORD BOUNDARY      34999000
         ST    R12,LATEND               UPDATE PTR             FX0000   35000000
         LA    R12,40(,R12)             MARGINE FOR SYM TAB    FX0000   35001000
         AH    R12,JHWORD1              FROM BEFORE            FX0000   35002000
         ST    R12,SYMDIMEN+D12         LIMIT FOR SYMBOL TABLE          35003000
LITRPUT  LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35004000
         JPUTL FILE=(R10),BUFREQ=12     GET OUTPUT BUFFER               35005000
         STM   R2,R3,D4(R11)            PASS INDEX AND DISPLACEMENT     35006000
         MVC   D0(D5,R11),LITRCD        RECORD HEADER                   35007000
         LH    R0,LATTR                 LENGTH ATTRIBUTE                35008000
         BCTR  R0,D0                    MINUS ONE                       35009000
         STC   R0,D2(,R11)              TO RECORD                       35010000
         MVC   D3(D1,R11),SYMCOUNT+D1   SYMBOL COUNT                    35011000
         AIF   ('&DIAG' EQ 'NO').DUMP00                                 35012000
.DUMP00  B     EPILOGUE                 CLEANUP                         35013000
LITRFULL SET   STBLOFLO,ON              INDICATE SYMBOL TABLE FULL      35014000
         BAL   R9,EPILOG                CLEANUP                         35015000
         LH    R10,JOUTFILE             OUTPUT FILE ADDRESS             35016000
         LR    R11,R4                   OUTPUT RECORD POINTER           35017000
         JPUTM FILE=(R10),ADDR=(R11)    WRITE RECORD                    35018000
         B     GETNEXT                  GET NEXT                        35019000
         SPACE                                                          35020000
ENDING   NC    LATA8(D16),LATA8         LITERAL POOL EMPTY              35021000
         BZ    LTORG2                   X                               35022000
         LH    R10,FSTCSECT             ASCENDSION NUMBER               35023000
         LTR   R10,R10                  SEE IF ONE                      35024000
         BZ    ENDING0                  CAN'T DO MUCH FOR THIS GUY      35025000
         SPACE                                                          35026000
*NOTE-   THE FIRST CONTROL SECTION, IF ANY, IS RESUMED AT ITS HIGHEST * 35027000
*   ADDRESS WHEN END OF FILE IS DETECTED IN PASS 1 ASSIGNMENT MODE    * 35028000
*   AND THE LITERAL POOL IS NOT EMPTY.                                * 35029000
         GOTO  GETESD                   RESUMPTION                      35030000
         LR    R6,R10                   RESUME SECTION                  35031000
         AIF   ('&TESTRAN' NE 'YES').ENDING2                            35032000
         BAL   R9,ESDPUNCH              OUTPUT TESTRAN ITEM             35033000
.ENDING2 ANOP                                                           35034000
ENDING0  LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35035000
         JPUTM FILE=(R10),ADDR=LOCRCD   RESUMPTION RECORD               35036000
         LM    R2,R3,ELCTR              CURRENT AND HIGHEST SAVED       35037000
         CLR   R2,R3                    SEE WHICH IS GREATER            35038000
         BNH   GRRRRRRR                 R3 IS                           35039000
         LR    R3,R2                    YOU'RE THE GREATEST             35040000
GRRRRRRR ST    R3,ELCTR                 SAVE                            35041000
         MVC   D6(D6,R11),EESDI         PASS LOCATION COUNTER TO LINO   35042000
         SPACE                                                          35043000
LTORG    BAL   R9,ALIGN1                ALIGN TO DOUBLEWORD BOUNDARY    35044000
         DC    H'-8,7'                  ALIGNMENT PARAMETERS            35045000
         GOIF  JTEOFII,EQUAL=LTORG2     SKIP IF FORCED LTORG            35046000
         ST    R3,RLCTR                 ADDRESS                         35047000
         BAL   R9,XREF                  RECORD                          35048000
         AIF   ('&TESTRAN' NE 'YES').LTORG                              35049000
         BAL   R9,MISPUNCH              OUTPUT TESTRAN ITEM             35050000
.LTORG   ANOP                                                           35051000
LTORG2   SR    R2,R2                    CLEAR REGISTER                  35052000
         NC    LATA8(D16),LATA8         SEE IF CLEAN POOL               35053000
         BE    ENDING1                  SKIP IF NOT DIRTY POOL          35054000
         L     R10,LATADD               GET POINTER TO LITERAL TABLE    35055000
         LH    R14,EESDI                GET ESDID                       35056000
         LR    R15,R3                   GET LOCATION COUNTER VALUE      35057000
         LM    R0,R3,D4(R10)            GET LITERAL TABLE               35058000
         AR    R0,R15                   ADDRESS OF 4-CHAIN              35059000
         AR    R1,R0                    ADDRESS OF 2-CHAIN              35060000
         AR    R2,R1                    ADDRESS OF 1-CHAIN              35061000
         AR    R3,R2                    ADDRESS OF END-OF-LITERAL-POOL  35062000
         AIF   ('&DIAG' EQ 'NO').DUMP02                                 35063000
.DUMP02  STM   R14,R2,D0(10)            LITERAL ADJUSTMENT TABLE        35064000
         ST    R3,ELCTR                 SAVE LOCATION COUNTER           35065000
LCSAVE   MVC   LOCTRSAV,EESDI           SAVE LOCATION COUNTER AND ESDID 35066000
         SET   LITEND,ON                TO INFORM LTDUMP       @OX09723 35067000
         LM    R2,R3,=F'-8,4'           INDEX                           35068000
LTORG3   L     R5,LATA2(R2)             PASS ONE END OF A CHAIN         35069000
         BAL   R9,LTDUMP                DUMP OUT CHAIN                  35070000
         BXLE  R2,R3,LTORG3             ONE CHAIN AT A TIME             35071000
         SET   LITEND,OFF                                      @OX09723 35072000
LCRESTOR MVC   EESDI(D6),LOCTRSAV       RESTORE ESDID AND VALUE         35073000
         L     R10,LATADD               RECLAIM ADDRESS                 35074000
         LA    R2,D20                   LENGTH OF ONE LITERAL TABLE     35075000
         AR    R10,R2                   POINT TO NEXT TABLE             35076000
         LA    R11,D20(,R10)            POINT TO FRESH LITERAL POOL     35077000
         STM   R10,R11,LATADD           HERE WE GO AGAIN                35078000
         XC    LATA8(D16),LATA8         CLEAN OUT LITERAL POOL          35079000
         XC    D0(D20,R10),D0(R10)      CLEAR LITERAL TABLE             35080000
ENDING1  LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35081000
         LA    R11,D8                   RECORD LENGTH                   35082000
         JPUTL FILE=(R10),BUFREQ=(R11)  GET BUFFER                      35083000
         MVC   D0(D6,R11),EOFRCD        RECORD HEADER                   35084000
         MVI   D4(R11),JTLTEND          RECORD TYPE                     35085000
         STH   R2,D6(,R11)              PASS INCREMENT TO PASS II       35086000
         GOIF  JTEOFII,NOTEQ=EPILOGUE   SKIP IF NOT FORCED LTORG        35087000
         L     R14,LATADD               POINT TO THE END OF TABLES      35088000
         LA    R2,ENDOFCOM              POINT TO THE BEGINNING          35089000
         SR    R14,R2                   GET THE LENGTH                  35090000
         LA    R3,LATA8                 POINT TO NEW ADDRESS OF TABLE   35091000
         LA    R4,LATA8(R14)            THE END OF NEW TABLE            35092000
         STM   R3,R4,LATADD             BEGINNING OF BOTH TABLES        35093000
         BNP   ENDOFILE                 DON'T MOVE IF NO LITERALS       35094000
ENDING2  BCTR  R14,0                    GET MOVE LENGTH                 35095000
         EX    R14,LITMVC2              MOVE LITERAL ADJUSTMENT TABLE   35096000
         SRDL  R14,D8                   EXECUTED AMOUNT TO REGISTER 15  35097000
         SRL   R15,D24                  AMOUNT MOVED                    35098000
         LA    R3,D1(R3,R15)            POINT TO NEXT SEGMENT           35099000
         LA    R2,D1(R2,R15)            POINT TO NEXT SEGMENT           35100000
         SLA   R14,D8                   AMOUNT REMAINING NOT MOVED      35101000
         BZ    ENDOFILE                 GO IF TASK COMPLETED            35102000
         B     ENDING2                  REPEAT IF NOT                   35103000
         SPACE                                                          35104000
LTDUMP   BALR  R14,R7                   SAVE REGISTERS                  35105000
LTDUMP1  LTR   R4,R5                    SEE IF AT END-OF-CHAIN          35106000
         BZ    EXIT                     FINIS IF SO                     35107000
         SR    R3,R3                    BUMP PAST LOC CNTR     @OX10361 35108000
         IC    R3,D9(,R4)               COMPUTE LENGTH TO-     @OX10361 35109000
         AR    R5,R3                    LITERAL TEXT IN REC    @OX10361 35110000
INDSECT  EQU   BIT0                     LIT DEF IN DSECT       @OX10361 35111000
         SR    R3,R3                    ZERO REGISTER                   35112000
         GOIF  MODE2,ON=LTDUMP2         SKIP IF CHAINING MODE           35113000
         SR    R2,R2                    CLEAR REGISTER                  35114000
         IC    R2,D10(,R5)              GET LITERAL SOURCE LENGTH       35115000
         LA    R2,D1(,R2)               LENGTH                          35116000
         LA    R3,D13(,R2)              LENGTH                          35117000
         LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35118000
         JPUTL FILE=(R10),BUFREQ=(R3)   GET OUTPUT BUFFER               35119000
         STH   R3,D0(,R11)              RECORD LENGTH                   35120000
         MVC   D2(D6,R11),LOCRCD+D2     RECORD HEADER                   35121000
         EX    R2,LITMVC1               MOVE IN LITERAL SOURCE          35122000
         LR    R3,R11                   SAVE POINTER                    35123000
         MVI   TYPECALL,LTCALL+LTORGSCN PASS PARAMETERS                 35124000
         CR    R4,R5                    SEE IF LOCATION COUNTER         35125000
         BE    LTDUMP3                  NO                              35126000
         MVC   D6(D6,R11),D10(R4)       PASS LOCATION COUNTER           35127000
         B     LTDUMP3                  SKIP                            35128000
LTDUMP2  MVI   TYPECALL,LTCALL+LTORGSCN+NOESD     PASS PARAMETERS       35129000
LTDUMP3  MVC   EESDI(D6),D10(R4)        LOCATION COUNTER                35130000
         TM    D8(R4),INDSECT           TEST IF REF IN DSECT   @OX10361 35131000
         BZ    LTDUMP4                  NO                     @OX07274 35132000
         MVI   TYPECALL,LTCALL+LTORGSCN+NOESD PASS PARAM       @OX07274 35133000
LTDUMP4  LA    R5,D11(,R5)              TEXT POINTER           @OX07274 35134000
         AIF   ('&DIAG' EQ 'NO').DUMP04                                 35135000
.DUMP04  GOTO  DCSCAN                   SCAN LITERAL SOURCE ONCE MORE   35136000
         MVI   TYPECALL,D0              CLEAR PARAMETER                 35137000
         SR    R0,R0                    ZERO ZERO                       35138000
         STH   R0,SYMCOUNT              RESET SYMBOL COUNT              35139000
         GOIF  (STBLOFLO,LITEND),NOTALL=LTDUMP5 USE LIT POOL   @OX09723 35140000
         LA    R5,D20(R4)               ADD 20 FOR X4S         @OX09723 35141000
         ST    R5,SYMDIMEN+D4           NEW POINTER            @OX09723 35142000
LTDUMP5  L     R5,D0(,R4)               GET CHAIN POINTER               35143000
         LTR   R3,R3                    SEE IF LENGTH ATTRIBUTE DEFINED 35144000
         BE    LTDUMP1                  SKIP IF NOT NEEDED              35145000
         IC    R0,LATTR+D1              GET LENGTH ATTRIBUTE            35146000
         BCTR  R0,D0                    MINUS ONE                       35147000
         STC   R0,D2(,R3)               TO OUTPUT RECORD                35148000
         B     LTDUMP1                  TAKE IT FROM THE TOP            35149000
         SPACE                                                          35150000
LTORGII  L     R14,LATADD               ADJUSTMENT TABLE ADDRESS        35151000
         AH    R14,RESDI                INCREMENT                       35152000
         ST    R14,LATADD               UPDATE                          35153000
         B     TRANSFER                 FINIS                           35154000
         SPACE                                                          35155000
LITRII   LH    R10,RESDI                ADJUSTMENT INDEX                35156000
         LTR   R10,R10                  SEE IF VALID DEFINITION         35157000
         BZ    TRANSFER                 BAD LITERAL                     35158000
         L     R14,LATADD               LITERAL ADJUSTMENT TABLE        35159000
         L     R11,D0(R10,R14)          ADJUSTMENT FACTOR, POOL ADDRESS 35160000
         A     R11,RLCTR                LITERAL'S DISPLACEMENT IN CHAIN 35161000
         ST    R11,RLCTR                ADJUSTED LITERAL ADDRESS        35162000
         LH    R10,D2(,R14)             ESDID OF LITERAL POOL           35163000
         STH   R10,RESDI                ADJUSTED LITERAL ESDID          35164000
         AIF   ('&DIAG' EQ 'NO').DUMP06                                 35165000
.DUMP06  SPACE                                                          35166000
ADJUST   LH    R10,RESDI                ESDID                           35167000
         L     R11,RLCTR                OFFSET                          35168000
         LM    R14,R1,ADJINDEX          ADJUSTMENT PARAMETERS           35169000
ADJUST2  BXLE  R14,R15,TRANSFER         STEP INDEX                      35170000
         CH    R10,D0(R1,R14)           SEE IF ADJUSTMENT ENTRY         35171000
         BNE   ADJUST2                  GO AGAIN IF NOT                 35172000
         LH    R10,D2(R1,R14)           GET ADJUSTED ESDID              35173000
         STH   R10,RESDI                PASS IN RECORD                  35174000
         A     R11,D4(R1,R14)           ADD ADJUSTMENT FACTOR           35175000
         ST    R11,RLCTR                PASS IN RECORD                  35176000
         SPACE                                                          35177000
TRANSFER LH    R10,JOUTFILE             ADDRESS OF OUTPUT FILE          35178000
         LR    R11,R4                   OUTPUT RECORD ADDRESS           35179000
         JPUTM FILE=(R10),ADDR=(R11)    OUTPUT RECORD                   35180000
         B     EPILOGUE                 CHECK SYMBOL TABLE OVERFLOW     35181000
         SPACE                                                          35182000
ALIGN1   TM    JPARM2,JALGN             TEST ALIGN OPTION               35183000
         BZ    D4(,R9)                  RETURN TO MAINLINE IF OFF       35184000
ALIGN    LH    R0,D0(,R9)               GET ALIGN MASK                  35185000
         AH    R3,D2(,R9)               EXCESS FOR ALIGNMENT            35186000
         NR    R3,R0                    ROUND TO SPECIFIC BOUNDARY      35187000
         AIF   ('&TESTRAN' NE 'YES').ALIGN                              35188000
         LR    R0,R3                    GET NEW LOCATION COUNTER        35189000
         S     R0,ELCTR                 GET NUMBER OF BYTES SKIPPED     35190000
         MVC   ADDRESS,ELCTR+D1         ADDRESS                         35191000
         ST    R3,ELCTR                 UPDATE CURRENT LOCATION COUNTER 35192000
         LA    R9,D4(,R9)               PASS RETURN ADDRESS             35193000
         BER   R9                       NO BYTES SKIPPED                35194000
         SET   TSPACE                   ORGINIZATION BYTE               35195000
         STC   R0,NAME                  LENGTH, NUMBER OF BYTES SKIPPED 35196000
         LA    R10,D5                   LENGTH OF SPACE RECORD          35197000
         B     SYMPUNCH                 PUT OUTPUT ONTO 'SYM' CARD      35198000
         AGO   .ALIGN1                                                  35199000
.ALIGN   ST    R3,ELCTR                 UPDATE CURRENT LOCATION COUNTER 35200000
         B     D4(,R9)                  RETURN TO MAINLINE              35201000
.ALIGN1  SPACE                                                          35202000
XREF     LA    R1,D1                    ASSUME LENGTH ATTRIBUTE IS ONE  35203000
XREF1    GOIF  RFIELDN,OFF=(R9)         BUG OUT IF NOT NAMED            35204000
         STH   R1,RLNGQ                 PASS LENGTH ATTRIBUTE           35205000
         BALR  R14,R7                   PUSH REGISTERS                  35206000
         GOIF  PRIORDEF,ON=WRITE3       CHECK IF PREVIOUSLY DEFINED     35207000
         LR    R10,R4                   PASS RECORD POINTER             35208000
         GOTO  ENTER                    ENTER IN SYMBOL TABLE           35209000
         BE    WRITE3                   ENTERED SUCCESSFULLY            35210000
         SET   PRIORDEF,ON              INDICATE SYMBOL ALREADY DEFINED 35211000
         B     WRITE3                   SNEAK IN THE BACK DOOR          35212000
         AIF   ('&TESTRAN' NE 'YES').WRITE                              35213000
XREF3    BAL   R9,MISPUNCH              OUTPUT TESTRAN ITEM             35214000
.WRITE   SPACE                                                          35215000
WRITE    LA    R9,EPILOGUE              DEFINE EXIT                     35216000
WRITE1   GOIF  RFIELDN,OFF=(R9)         GIVE UP IF NOT NAMED            35217000
WRITE2   BALR  R14,R7                   PUSH REGISTERS                  35218000
WRITE3   LA    R2,D24                   CROSS-REFERENCE RECORD LENGTH   35219000
         GOIF  RFIELDN,ON=RECL22        TEST IF NAME IS PRESENT         35220000
         LA    R2,D12                   RECORD LENGTH WITHOUT NAME      35221000
RECL22   LH    R10,JOUTFILE                                             35222000
         LR    R11,R2                                                   35223000
         JPUTL FILE=(R10),BUFREQ=(R11)                                  35224000
         SH    R2,=AL2(D3)              GET MOVE LENGTH                 35225000
         EX    R2,MOVEREC               MOVE RECORD TO OUTPUT FILE      35226000
         STH   R2,D0(,R11)                                              35227000
         MVI   JTIOP1-JTRLI(R11),JTADJII                                35228000
         B     EXIT                     RETURN                          35229000
MOVEREC  MVC   D2(,R11),D2(R4)          MOVE RECORD TO OUTPUT FILE      35230000
         SPACE                                                          35231000
EPILOGUE BAL   R9,EPILOG                CLEANUP ROUTINE                 35232000
         B     GETNEXT                  CONTINUE                        35233000
EPILOG   BALR  R14,R7                   SAVE REGISTERS                  35234000
         GOIF  STBLOFLO,OFF=GET         IS SYMBOL TABLE FULL            35235000
         GOIF  MODE1,ON=GET                                             35236000
         GOIF  MODE2,ON=GET             CHECK IF 1S MODE                35237000
         SET   MODE2,ON                 CHANGE MODE                     35238000
         LM    R2,R3,=F'-8,4'           LOAD UP WITH INDEX              35239000
         EX    R0,LCSAVE                SAVE LOCATION COUNTER           35240000
EPILOOP  L     R5,LATA2(R2)             GET ONE END OF CHAIN            35241000
         BAL   R9,LTDUMP                DUMP OUT THE SYMBOLS            35242000
         BXLE  R2,R3,EPILOOP            DO IT TO ALL FOUR CHAINS        35243000
         EX    R0,LCRESTOR              RESTORE LOCATION COUNTER        35244000
         LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35245000
         JPUTM FILE=(R10),ADDR=EOFRCD   PUT OUT AN END-OF-FILE RECORD   35246000
GET      GOIF  INOTE,OFF=EXIT                                           35247000
         SET   INOTE,OFF                RESET CONDITION                 35248000
         LH    R10,JINFILE              GET INPUT FILE ADDRESS          35249000
         JPOINT  FILE=(R10),ADDR=INOTEVAL,NEXT=GET                      35250000
         B     EXIT                     FINIS                           35251000
         SPACE                                                          35252000
MAKESD   GOTO  MAKESD                   GO TO MAKE ESD                  35253000
         B     GETNEXT                                                  35254000
         SPACE                                                          35255000
ENDOFILE LH    R10,JOUTFILE             GET OUTPUT FILE ADDRESS         35256000
         LA    R11,EOFRCD               POINT TO END-OF-FILE            35257000
         JPUTM FILE=(R10),ADDR=(R11)    WRITE ONE LAST RECORD           35258000
BUGOUT   LH    R10,JOUTFILE             GET FILE ADDRESS                35259000
         JPOINT  FILE=(R10),NEXT=START  POINT TO BEGINNING OF FILE      35260000
         LH    R10,JINFILE              GET ADDRESS OF CURRENT INPUT    35261000
         MVC   JINFILE,JOUTFILE         OLD OUTPUT FILE BECOMES INPUT   35262000
         STH   R10,JOUTFILE             OLD INPUT FILE BECOMES OUTPUT   35263000
         JPOINT  FILE=(R10),NEXT=START  POINT TO BEGINNING OF OUTPUT    35264000
         AIF   ('&DIAG' EQ 'NO').DUMP08                                 35265000
.DUMP08  SET   (MODE1,MODE2),FLIP       CHANGY, CHANGY                  35266000
         GOIF  (MODE1,MODE2),MIX=GETNEXT,ALL=MAKESD                     35267000
         LR    R10,R7                   POINT TO COMMON                 35268000
         JFRECORE  ADDR=(R10)           FREE IT UP                      35269000
         B     III                      PHASE EXIT                      35270000
         AIF   ('&TESTRAN' EQ 'NO').TEST80                              35271000
         EJECT                                                          35272000
*TITLE-  ESDPUNCH                                                     * 35273000
*                                                                     * 35274000
*FUNCTION/OPERATION-                                                  * 35275000
*        FORMAT TESTRAN ITEMS FOR ROUTINE 'SYMPUNCH'.                 * 35276000
*                                                                     * 35277000
*INPUT-  REGISTER R6 POINTS TO AN ESD CONTROL SECTION ENTRY.          * 35278000
*                                                                     * 35279000
*OUTPUT- TESTRAN ITEMS IN STORAGE FOR ROUTINE 'SYMPUNCH'.             * 35280000
*                                                                     * 35281000
         SPACE                                                          35282000
MISPUNCH SET   TMIS                     ORGANIZATION BYTE               35283000
MOPPUNCH GOIF  (RFIELDN,PRIORDEF)       TEST                            35284000
         BNMR  R9                       RETURN                          35285000
ANYPUNCH LA    R10,D4                   LENGTH OF ITEM ASSUMED          35286000
         MVC   ADDRESS,RLCTR+D1         ADDRESS                         35287000
         GOIF  RFIELDN,OFF=SYMPUNCH     FINISHED IF NO NAME             35288000
         MVC   NAME,RNAME               MOVE NAME                       35289000
         IC    R10,RFLDI                GET NAME LENGTH BITS            35290000
         N     R10,=F'7'                KEEP LENGTH BITS ONLY           35291000
         LA    R10,D5(,R10)             LENGTH OF ITEM CONFIRMED        35292000
         B     STORELNG                 CONTINUE                        35293000
ESDPUNCH CLC   XSSAV,EESDI              SEE IF ACTUAL                   35294000
         BER   R9                       YEAH                            35295000
         MVC   XSSAV,EESDI              SAVE                            35296000
         LA    R10,D4                   LENGTH                          35297000
         MVC   ORGBYTE,ETYPE            ORGINIZATION BYTE               35298000
         TR    ORGBYTE,=AL1(TCSECT,0,0,0,TCSECT,TCOM,0,0,TDSECT)        35299000
         XC    ADDRESS,ADDRESS          ADDRESS                         35300000
         CLI   ENAME,JA                 SEE IF NAMED                    35301000
         BL    SYMPUNCH                 NAMELESS                        35302000
         MVC   NAME,ENAME               MOVE IN NAME                    35303000
         LA    R10,EITEM+D13            POINT TO LAST CHARACTER         35304000
LOOPLOOP BCTR  R10,0                    LOOK AT NEXT CHARACTER          35305000
         CLI   ENAME-EITEM-D5(R10),JBLANK    SEE IF PADDED              35306000
         BE    LOOPLOOP                 LOOP ON FALSIES                 35307000
         SR    R10,R6                   FIND THE LENGTH OF THE NAME     35308000
STORELNG LA    R1,BIT4-D5(,R10)         RIG MASK                        35309000
         EX    R1,SOKITUMI              INDICATE NAME PRESENT           35310000
         TR    NAME,JTRTABLE            TRANSLATE NAME                  35311000
         SPACE                                                          35312000
SYMPUNCH STM   R9,R1,TERMS              SAVE REGISTERS                  35313000
         GOTO  SYMPUNCH                 GO TO OUTPUT ROUTINE            35314000
         LM    R9,R1,TERMS              RESTORE REGOSTERS               35315000
         BR    R9                       RETURN                          35316000
         SPACE                                                          35317000
SOKITUMI XI    ORGBYTE,D0               EXECUTED INSTRUCTION            35318000
.TEST80  SPACE                                                          35319000
         DS    0F                                                       35320000
CSTPARM  DC    AL1(ESDNRSW+CSECTSW+DSECTSW+XENTRY,ETYPEPC,ETYPESD,0)    35321000
DSTPARM  DC    AL1(ESDNRSW+DSCOMSW+DSECTSW+XDUMMY,ETYPEDS,ETYPEDS,CSW)  35322000
COMPARM  DC    AL1(ESDNRSW+DSCOMSW+CSECTSW,ETYPECM,ETYPECM,CSW)         35323000
DXDPARM  DC    AL1(ESDNRSW+DSCOMSW+DSECTSW,ETYPEXD,ETYPEXD,DSW)         35324000
EOFRCD   DC    H'8',AL1(JPSOP,0,JTEOFII,0)   END-OF-FILE RECORD         35325000
LOCRCD   DC    HL2'12',AL1(JPSOP,0,JTADJII,0),HL2'0'   LITERAL DC       35326000
LITRCD   DC    HL2'12',AL1(JPSOP,0,JTLITII,0)     LITERAL RECORD HEADER 35327000
INDEX    DC    AL1(4,16,12,16,8,16,12,16)    LITERAL HASH INDEX         35328000
TMINST   TM    D0(R15),D0               EXECUTED INSTRUCTION            35329000
LITCLC   CLC   D10(D0,R3),CHAR1         EXECUTED INSTRUCTION            35330000
LITMVC   MVC   D10(D0,R12),CHAR1        EXECUTED INSTRUCTION            35331000
LITMVC1  MVC   D12(D0,R11),D10(R5)      EXECUTED INSTRUCTION            35332000
LITMVC2  MVC   D0(D0,R3),D0(R2)         EXECUTED INSTRUCTION            35333000
         SPACE                                                          35334000
RADIX    DC    A(IA,IS,IIS,IIA)         MODES                           35335000
IA       EQU   *-2*JTPREP               PASS 1 ASSIGNMENT MODE          35336000
         ORG   IA+2*JTPREP              TABLE INDEX                     35337000
         DC    Y(IA-REPRO)              ROUTINE VECTOR                  35338000
         ORG   IA+2*JTPPCH              TABLE INDEX                     35339000
         DC    Y(IA-PUNCH)              ROUTINE VECTOR                  35340000
         ORG   IA+2*JTINPC              TABLE INDEX                     35341000
         DC    Y(IA-INPC)               ROUTINE VECTOR                  35342000
         ORG   IA+2*JTPMOP              TABLE INDEX                     35343000
         DC    Y(IA-MACHOP)             ROUTINE VECTOR                  35344000
         ORG   IA+2*JTEND               TABLE INDEX                     35345000
         DC    Y(IA-GETNEXT)            ROUTINE VECTOR                  35346000
         ORG   IA+2*JTDXD               TABLE INDEX                     35347000
         DC    Y(IA-DXD)                ROUTINE VECTOR                  35348000
         ORG   IA+2*JTEQU               TABLE INDEX                     35349000
         DC    Y(IA-EQU)                ROUTINE VECTOR                  35350000
         ORG   IA+2*JTORG               TABLE INDEX                     35351000
         DC    Y(IA-ORG)                ROUTINE VECTOR                  35352000
         ORG   IA+2*JTCNOP              TABLE INDEX                     35353000
         DC    Y(IA-CNOP)               ROUTINE VECTOR                  35354000
         ORG   IA+2*JTCCW               TABLE INDEX                     35355000
         DC    Y(IA-CCW)                ROUTINE VECTOR                  35356000
         ORG   IA+2*JTDC                TABLE INDEX                     35357000
         DC    Y(IA-DC)                 ROUTINE VECTOR                  35358000
         ORG   IA+2*JTDS                TABLE INDEX                     35359000
         DC    Y(IA-DS)                 ROUTINE VECTOR                  35360000
         ORG   IA+2*JTSTART             TABLE INDEX                     35361000
         DC    Y(IA-START)              ROUTINE VECTOR                  35362000
         ORG   IA+2*JTCSECT             TABLE INDEX                     35363000
         DC    Y(IA-CSECT)              ROUTINE VECTOR                  35364000
         ORG   IA+2*JTDSECT             TABLE INDEX                     35365000
         DC    Y(IA-DSECT)              ROUTINE VECTOR                  35366000
         ORG   IA+2*JTCOM               TABLE INDEX                     35367000
         DC    Y(IA-COM)                ROUTINE VECTOR                  35368000
         ORG   IA+2*JTENTRY             TABLE INDEX                     35369000
         DC    Y(IA-ENTRY)              ROUTINE VECTOR                  35370000
         ORG   IA+2*JTEXTRN             TABLE INDEX                     35371000
         DC    Y(IA-EXTRN)              ROUTINE VECTOR                  35372000
         ORG   IA+2*JTWXTRN             TABLE INDEX                     35373000
         DC    Y(IA-WXTRN)              ROUTINE VECTOR                  35374000
         ORG   IA+2*JTCXD               TABLE INDEX                     35375000
         DC    Y(IA-CXD)                ROUTINE VECTOR                  35376000
         ORG   IA+2*JTLTORG             TABLE INDEX                     35377000
         DC    Y(IA-LTORG)              ROUTINE VECTOR                  35378000
         ORG   IA+2*JTLITR              TABLE INDEX                     35379000
         DC    Y(IA-LITERAL)            ROUTINE VECTOR                  35380000
         ORG   IA+2*JTSYMBL             TABLE INDEX                     35381000
         DC    Y(IA-SYMBL)              ROUTINE VECTOR                  35382000
         ORG   IA+2*JTEOFII             TABLE INDEX                     35383000
         DC    Y(IA-ENDING)             ROUTINE VECTOR                  35384000
         ORG   IA+2*JTADJII             TABLE INDEX                     35385000
         DC    Y(IA-TRANSFER)           ROUTINE VECTOR                  35386000
         ORG   IA+2*JTPASS              TABLE INDEX                     35387000
         DC    Y(IA-TRANSFER)           ROUTINE VECTOR                  35388000
         ORG   ,                        END-OF-TABLE                    35389000
IS       EQU   *-2*JTPMOP               PASS 1 SUBSTITUTION MODE        35390000
         ORG   IS+2*JTPMOP              TABLE INDEX                     35391000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35392000
         ORG   IS+2*JTEND               TABLE INDEX                     35393000
         DC    Y(IS-TRANSFER)           ROUTINE VECTOR                  35394000
         ORG   IS+2*JTDXD               TABLE INDEX                     35395000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35396000
         ORG   IS+2*JTEQU               TABLE INDEX                     35397000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35398000
         ORG   IS+2*JTORG               TABLE INDEX                     35399000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35400000
         ORG   IS+2*JTCNOP              TABLE INDEX                     35401000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35402000
         ORG   IS+2*JTCCW               TABLE INDEX                     35403000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35404000
         ORG   IS+2*JTDC                TABLE INDEX                     35405000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35406000
         ORG   IS+2*JTDS                TABLE INDEX                     35407000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35408000
         ORG   IS+2*JTSTART             TABLE INDEX                     35409000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35410000
         ORG   IS+2*JTCSECT             TABLE INDEX                     35411000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35412000
         ORG   IS+2*JTDSECT             TABLE INDEX                     35413000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35414000
         ORG   IS+2*JTCOM               TABLE INDEX                     35415000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35416000
         ORG   IS+2*JTENTRY             TABLE INDEX                     35417000
         DC    Y(IS-ENTRY)              ROUTINE VECTOR                  35418000
         ORG   IS+2*JTEXTRN             TABLE INDEX                     35419000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35420000
         ORG   IS+2*JTWXTRN             TABLE INDEX                     35421000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35422000
         ORG   IS+2*JTCXD               TABLE INDEX                     35423000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35424000
         ORG   IS+2*JTLTORG             TABLE INDEX                     35425000
         DC    Y(IS-SEARCH)             ROUTINE VECTOR                  35426000
         ORG   IS+2*JTLITR              TABLE INDEX                     35427000
         DC    Y(IS-TRANSFER)           ROUTINE VECTOR                  35428000
         ORG   IS+2*JTSYMBL             TABLE INDEX                     35429000
         DC    Y(IS-SYMBL)              ROUTINE VECTOR                  35430000
         ORG   IS+2*JTEOFII             TABLE INDEX                     35431000
         DC    Y(IS-ENDOFILE)           ROUTINE VECTOR                  35432000
         ORG   IS+2*JTADJII             TABLE INDEX                     35433000
         DC    Y(IS-TRANSFER)           ROUTINE VECTOR                  35434000
         ORG   IS+2*JTPASS              TABLE INDEX                     35435000
         DC    Y(IS-TRANSFER)           ROUTINE VECTOR                  35436000
         ORG   ,                        END-OF-TABLE                    35437000
IIS      EQU   *-2*JTSYMBL              PASS 2 SUBSTITUTION MODE        35438000
         ORG   IIS+2*JTSYMBL            TABLE INDEX                     35439000
         DC    Y(IIS-SYMBOL)            ROUTINE VECTOR                  35440000
         ORG   IIS+2*JTEOFII            TABLE INDEX                     35441000
         DC    Y(IIS-EOFIIS)            ROUTINE VECTOR                  35442000
         ORG   IIS+2*JTLITII            TABLE INDEX                     35443000
         DC    Y(IIS-TRANSFER)          ROUTINE VECTOR                  35444000
         ORG   IIS+2*JTLTEND            TABLE INDEX                     35445000
         DC    Y(IIS-TRANSFER)          ROUTINE VECTOR                  35446000
         ORG   IIS+2*JTADJII            TABLE INDEX                     35447000
         DC    Y(IIS-TRANSFER)          ROUTINE VECTOR                  35448000
         ORG   IIS+2*JTPASS             TABLE INDEX                     35449000
         DC    Y(IIS-TRANSFER)          ROUTINE VECTOR                  35450000
         ORG   IIS+2*JTSYMII            TABLE INDEX                     35451000
         DC    Y(IIS-REHASH)            ROUTINE VECTOR                  35452000
         ORG   ,                        END-OF-TABLE                    35453000
IIA      EQU   *-2*JTSYMBL              PASS 2 ADJUSTMENT MODE          35454000
         ORG   IIA+2*JTSYMBL            TABLE INDEX                     35455000
         DC    Y(IIA-SYMBOL)            ROUTINE VECTOR                  35456000
         ORG   IIA+2*JTEOFII            TABLE INDEX                     35457000
         DC    Y(IIA-BUGOUT)            ROUTINE VECTOR                  35458000
         ORG   IIA+2*JTLITII            TABLE INDEX                     35459000
         DC    Y(IIA-LITRII)            ROUTINE VECTOR                  35460000
         ORG   IIA+2*JTLTEND            TABLE INDEX                     35461000
         DC    Y(IIA-LTORGII)           ROUTINE VECTOR                  35462000
         ORG   IIA+2*JTADJII            TABLE INDEX                     35463000
         DC    Y(IIA-ADJUST)            ROUTINE VECTOR                  35464000
         ORG   IIA+2*JTPASS             TABLE INDEX                     35465000
         DC    Y(IIA-TRANSFER)          ROUTINE VECTOR                  35466000
         ORG   ,                        END-OF-TABLE                    35467000
         SPACE                                                          35468000
         MEND                                                           35469000
./ ADD NAME=XSTBL                                                       35470000
         MACRO                                                          35471000
&ID      XSTBL &DUMMY,&TESTRAN=NO,&DIAG=NO,&LEVEL=1                     35472000
         GBLC  &COMPNM                  COMPONENT NAME                  35473000
         LCLC  &NM                      MODULE NAME                     35474000
         JHEAD 'SYMBOL TABLE SUBROUTINES',                             ,35475000
               PHASEID=&ID,LEVEL=&LEVEL                                 35476000
&NM      SETC  '&COMPNM&ID'                                             35477000
*TITLE-  SYMBOL TABLE ROUTINES                                        * 35478000
*                                                                     * 35479000
*FUNCTION/OPERATIONS-                                                 * 35480000
*        THESE ROUTINES MAINTAIN THE SYMBOL TABLE IN THE ASSEMBLER    * 35481000
*   SYMBOL RESOLUTION PHASE.  THE FORMAT OF THE SYMBOL TABLE AND      * 35482000
*   SYMBOL TABLE ENTRIES ARE DESCRIBED IN THE PROLOGUE OF THIS        * 35483000
*   ASSEMBLY.  THE 'STBLOFLO' BIT OF 'SWTCH1' IS SET TO '1' WHEN NO   * 35484000
*   MORE SPACE IS AVAILABLE FOR NEW ENTRIES.   ENTRIES TO THE SYMBOL  * 35485000
*   TABLE ARE HANDELED BY ROUTINE 'ENTER'.  ROUTINE 'FIND' LOOKS UP   * 35486000
*   AN EXISTING ENTRY IN THE SYMBOL TABLE.  ROUTINE 'SUBSET' IS       * 35487000
*   CALLED AT THE END OF SUBSTITUTION MODE TO SUBSET THE SYMBOL       * 35488000
*   TABLE.                                                            * 35489000
*                                                                     * 35490000
*ENTRY POINT-                                                         * 35491000
         ENTRY &NM.01                                                 * 35492000
*                                                                     * 35493000
*INPUT-                                                               * 35494000
*        REGISTERS-      R10 IS AN ADDRESS OF THE ARGUEMENT RECORD.   * 35495000
*                                                                     * 35496000
*OUTPUT-                                                              * 35497000
*        REGISTERS-      R14 IS THE POINTER TO THE SYMBOL TABLE ENTRY.* 35498000
*                                                                     * 35499000
*        PARAMETERS-                                                  * 35500000
*             STBLOFLO-  A SWITCH IN STORAGE, WHEN SET TO ONE,        * 35501000
*                        INDICATES THAT THE SYMBOL TABLE IS FULL      * 35502000
*                                                                     * 35503000
*EXTERNAL ROUTINES-                                                   * 35504000
*        NONE                                                         * 35505000
*                                                                     * 35506000
*EXITS, NORMAL-                                                       * 35507000
*        RETURN TO THE CALLER                                         * 35508000
*                                                                     * 35509000
*EXITS, ERROR-                                                        * 35510000
*        RETURN TO THE CALLER                                         * 35511000
*                                                                     * 35512000
*TABLES/WORK AREAS-                                                   * 35513000
*        HASHTBL-  CONTAINS THE ADDRESS OF A HASH TABLE OF CONTIGUOUS * 35514000
*   FULLWORDS INITIALIZED TO ZEROS.                                   * 35515000
*        SYMDIMEN- 4 CONTIGUOUS FULLWORDS CONTAINING THE ADDRESS OF   * 35516000
*   THE LATEST ENTRY, THE LENGTH OF AN ENTRY IN COMPLEMENT FORM, AND  * 35517000
*   THE ADDRESS AVAILABLE FOR THE LAST ENTRY, RESPECTIVELY.           * 35518000
*                                                                     * 35519000
*ATTRIBUTES-                                                          * 35520000
*        REFRESHABLE                                                  * 35521000
*                                                                     * 35522000
*NOTES-                                                               * 35523000
*                                                                     * 35524000
         EJECT                                                          35525000
         COPY  JCOMMON                                                  35526000
         EJECT                                                          35527000
         COPY  ICOMMON                                                  35528000
         EJECT                                                          35529000
&NM.00   CSECT                                                          35530000
* VS1 REL 2.6 CHANGES                                                   35531000
*C644000                                                        OX00106 35532000
         JMODID                                                         35533000
&NM.01   CONTENTS                                                       35534000
         USING &NM.01,R8                BASE REGISTER                   35535000
         EJECT                                                          35536000
ENTER    BALR  R14,R7                   SAVE REGISTERS IN STACK         35537000
         LR    R8,R12                   SET UP BASE REGISTER            35538000
         MVC   XFLGA(D20),XFLGA-XWORK(R10)   SAVE PARAMETERS            35539000
         BALR  R9,R12                   LOOKUP IN SYMBOL TABLE          35540000
         BE    ENTER9                   ALREADY IN SYMBOL TABLE         35541000
         LM    R2,R5,SYMDIMEN           GET SYMBOL TABLE POINTERS       35542000
         BXH   R3,R4,ENTER1             POINT TO NEXT AVAILABLE SPACE   35543000
         SET   STBLOFLO,ON              SYMBOL TABLE FULL SIGN          35544000
ENTER1   TM    XFLGB,ESDNRSW            SEE IF ESD ITEM                 35545000
         BZ    ENTER5                   NO, JUST A COMMON ENTRY         35546000
         LR    R5,R3                    COMPARAND REGISTER              35547000
         BXLE  R2,R4,ENTER5             SPACE ABOVE THE CROWD           35548000
         STM   R2,R3,SYMDIMEN           SAVE NEW POINTERS               35549000
         MVC   D0(D20,R3),D0(R2)        ROLL OUT                        35550000
         CR    R14,R2                   SEE IF SAME ONE AS LAST         35551000
         BNE   ENTER2                   NOPE                            35552000
         LR    R11,R2                   PASS POINTER                    35553000
         B     ENTER4                   SKIP                            35554000
ENTER2   CR    R11,R2                   SEE IF THIS ONE POINTS TO IT    35555000
         BE    ENTER3                   IT SURE DOES                    35556000
         LR    R3,R11                   PASS POINTER                    35557000
ENTER3   LR    R4,R14                   SAVE THIS POINTER               35558000
         LR    R10,R2                   AND THIS                        35559000
         AH    R10,=H'-8'               FAKE THIS ONE                   35560000
         BALR  R9,R12                   LOOKUP THIS ONE IN SYMBOL TABLE 35561000
         ST    R4,D0(,R2)               CHAIN POINTER                   35562000
         MVC   D1(D3,R3),SYMDIMEN+D1    CHAIN THEM TOGETHER THE NEW WAY 35563000
ENTER4   MVC   D1(D3,R11),SYMDIMEN+D5   CONNECT THIS TO THE CHAIN       35564000
         LR    R14,R2                   MAKE NEW ALSO CURRENT           35565000
         B     ENTER6                   SKIP                            35566000
ENTER5   STM   R2,R3,SYMDIMEN           SAVE NEW POINTERS               35567000
         MVC   D1(D3,R11),SYMDIMEN+D5   CHAIN POINTER                   35568000
         ST    R14,D0(,R3)              CHAIN POINTER                   35569000
         LR    R14,R3                   CURRENT ENTRY POINTER           35570000
ENTER6   SR    R10,R10                  DEFINE EXIT                     35571000
ENTER7   MVC   SNAME(D10),XNAME         NAME AND LENGTH ATTRIBUTE       35572000
ENTER8   MVC   SESDI(D6),XESDI          ESDID AND VALUE                 35573000
         MVC   SFLGS,XFLGB              FLAGS                           35574000
         LTR   R10,R10                  SEE IF ALL DONE                 35575000
         BZ    EXIT                     FINIS                           35576000
         TM    XFLGB,ESDNRSW            SEE IF VALID ENTRY              35577000
         BO    ENTRY88                  NOT VALID ENTRY                 35578000
         TM    XESDI,CSW+DSW+ESW        SEE IF INVALID ENTRY    OX00106 35579000
         BNZ   ENTRY88                  NO GOOD ENTRY                   35580000
         LH    R0,XESDI                 SEE IF ABSOLUTE                 35581000
         LTR   R0,R0                    SEE IF ABSOLUTE                 35582000
         BE    EXIT                     ILLEGAL ENTRY IF ABSOLUTE       35583000
         SET   XENTRY,ON                INDICATE VALID ENTRY            35584000
         LR    R5,R14                   SAVE POINTER                    35585000
         GOTO  GETESD                   GET ESD ENTRY                   35586000
         MVI   ETYPE-EITEM(R10),ETYPELD      NEW TYPE                   35587000
         MVC   EESDI-EITEM(D6,R10),XESDI     ESDID AND VALUE            35588000
         MVC   ENAME-EITEM(D8,R10),XNAME     NAME                       35589000
         LR    R14,R5                   RESTORE POINTER                 35590000
ENTRY88  SR    R10,R10                  SET CONDITION CODE              35591000
         B     EXIT                     AND RETURN                      35592000
ENTER9   GOIF  ENTRYSW,ON=ENTER10       SEE IF ENTRY ITEM               35593000
         TM    *,BIT0                   INDICATE PREVIOUSLY DEFINED     35594000
         B     EXIT                     RETURN                          35595000
ENTER10  LH    R10,SLNGQ                GET ESD ASCENDSION NUMBER       35596000
         B     ENTER7                   SET LENGTH ATTRIBUTE            35597000
         SPACE                                                          35598000
         DROP  R8                       CHANGE BASE                     35599000
         USING &NM.01,R12               BASE REGISTER                   35600000
FIND     LM    R14,R15,XNAME-XWORK(R10) GET NAME                        35601000
         MR    R14,R14                  HASH                            35602000
         XR    R14,R15                  FOLD                            35603000
         SRL   R14,D3                   X                               35604000
         N     R14,=F'252,-4'           MASK                            35605000
         LA    R14,HASHTBL(R14)         POINT TO BEGINNING OF CHAIN     35606000
FIND2    LR    R11,R14                  CLIMB                           35607000
         L     R14,SCHPT-SCHPT(,R11)    FIND NEXT ENTRY                 35608000
         LA    R14,SCHPT                ZERO FLAG BYTE                  35609000
         LTR   R14,R14                  SEE IF END-OF-CHAIN             35610000
         BZ    FIND3                    END-OF-CHAIN, NOT FOUND         35611000
         CLC   SNAME,XNAME-XWORK(R10)   SEE IF FOUND                    35612000
         BL    FIND2                    ENTRY NOT REACHED               35613000
         BCR   D8,R9                    RETURN FOUND                    35614000
FIND3    TM    *,BIT0                   SET NOT FOUND CONDITION         35615000
         BCR   D1,R9                    RETURN NOT FOUND                35616000
         SPACE                                                          35617000
SUBSET   BZR   R9                       EXIT IF SUBSETTED THIS ROUND    35618000
         SET   STBLOFLO,OFF             INDICATE SUBSETTED              35619000
         L     R0,SYMDIMEN              GET                             35620000
         LM    R10,R11,=F'252,-4'       HASH TABLE INDEX                35621000
SUBSET1  LA    R15,HASHTBL(R10)         PASS ONE END OF THE CHAIN       35622000
         BAL   R1,SUBSET3               SUBSET ONE CHAIN AT A TIME      35623000
         BXH   R10,R11,SUBSET1          JUGGLE INDEX                    35624000
         ST    R0,SYMDIMEN+D4           NEWLY RECLAIMED AREA POINTER    35625000
         BR    R9                       RETURN                          35626000
SUBSET2  MVC   D1(D3,R15),D1(R14)       YOU'RE A LOSER                  35627000
SUBSET3  L     R14,D0(,R15)             GET NEXT ENTRY POINTER          35628000
         LA    R14,D0(,R14)             ISOLATE ADDRESS PORTION         35629000
         LTR   R14,R14                  SEE IF AT END-OF-CHAIN          35630000
         BCR   D8,R1                    RETURN IF AT END                35631000
         CR    R14,R0                   IS THIS WORTHY                  35632000
         BL    SUBSET2                  BAD, ON THE WRONG SIDE OF TRACK 35633000
         LR    R15,R14                  TUCK ON THE CHAIN               35634000
         B     SUBSET3                  CLIMB                           35635000
         MEND                                                           35636000
./ ADD NAME=X5COM                                                       35637000
*COPY X5COM                                                             35638000
* /* START OF SPECIFICATIONS ****                                       35639000
*02* PROCESSOR = ASSEMBLER                                              35640000
**** END OF SPECIFICATIONS ***/                                         35641000
*                                                                       35642000
* ASSEMBLY PHASE COMMON AREA AS OF 05/11/69                             35643000
*                                                                       35644000
         SPACE                                                          35645000
*C311800                                                       @AZ07356 35646000
*A311900                                                       @AZ07356 35647000
X5COM    DSECT                                                          35648000
         SPACE                                                          35649000
* THE FOLLOWING FIELDS MUST BE INITIALIZED                              35650000
         SPACE                                                          35651000
ELCTR    DS    3F                       CURRENT LOCATION COUNTER        35652000
TXTPTR   DS    F                        TEXT POINTER                    35653000
STMTN    DS    F                        STATEMENT NUMBER-LIKEWISE       35654000
LNCNT    DS    F                        LINE COUNT-INIT TO 1            35655000
         SPACE                                                          35656000
LEFTHF   DS    0CL21              LEFT HALF INPUT TO PRINT ROUTINE      35657000
LOCATN   DS    F                        LOCATION OF ENTRY               35658000
DCDATA   DS    CL8                      FIELD FOR DC INPUT DATA         35659000
         ORG   DCDATA                   ORG BACK FOR MACHINE OP         35660000
LHOPCD   DS    H                        OPCODE FOR MACHINE INSTRUCTION  35661000
         ORG   LHOPCD+1                 ORG BACK FOR IMMEDIATE BYTE     35662000
LHIMD    DS    X                                                        35663000
BASDS1   DS    H                        BASE-DISPLACEMENT 1             35664000
         ORG   BASDS1+1                 ORG BACK FOR RRE REGS  FX0000   35665000
RREREGS  DS    X                                               FX0000   35666000
BASDS2   DS    H                        BASE-DISPLACEMENT 2             35667000
         ORG                                                            35668000
ADDRS1   DS    F                        ADDRESS OF FIRST OPERAND        35669000
ADDRS2   DS    F                        ADDRESS OF SECOND OPERAND       35670000
LHFLGS   DSW   ENTDC,                   ENTRY IS A DC                  X35671000
               ENTALN,                  ENTRY IS ALIGNMENT             X35672000
               LHLNG,                   LENGTH OF OUTPUT DATA          X35673000
               EOUBIT                   EQU ORG OR USING BIT            35674000
DNTPLH   EQU   BIT4+BIT5+BIT6+BIT7      DON'T PRINT LEFT HALF           35675000
LHEND    EQU   *                        END OF LEFT HALF                35676000
CRDCNT   DS    H                        BYTE COUNT IN TEXT (TXT) CARD   35677000
         SPACE                                                          35678000
SYMDEF   DS    F                        POINTER TO DEFINITION DATA      35679000
SYMXRF   DS    F                        COUNT OF SYMBOLS XREF-ED THIS  *35680000
                                         STATEMENT              OX02675 35681000
SYMCNT   DS    C                        COUNT OF SYMBOLS THIS STATEMENT 35682000
AOPF     DSW   USSRT,                   USING SORT FLAG                X35683000
               OPNPRS,                  OPERAND PRESENT FLAG           X35684000
               DCCOMP,                  DC COMPLETE SWITCH             X35685000
               DCSTRT,                  OUTPUT OF DC ALREADY STARTED   X35686000
               DCMOP,                   DC FINAL MOP-UP SWITCH         X35687000
               DCSWH,                   DC SWITCH                      X35688000
               NAMPRS                   NAME PRESENT SWITCH             35689000
DCEVSW   DSW   DSSW,                    INDICATOR FOR STATEMENT A DS   X35690000
               DXDSW,                   INDICATOR FOR STATEMENT A DXD  X35691000
               DLOCTREF,                SWITCH FOR L'*                 X35692000
               NOTEWL,                  INDICATE A NOTE BAY BE NECESS. X35693000
               NOTEHS,                  INDICATE A POINT WILL BE NEC.  X35694000
               LITRSW,                  LITERAL PRESENT SWITCH         X35695000
               XRFNO,                   TURN OFF XREF                  X35696000
               DUPEVAL                  DUPLICATE EVAL OF DATA CONST    35697000
X5SW1    DSW   WRPFLG,                  WRAP OF LOCATION COUNTER FLAG  X35698000
               LTDECV,                  LITERAL IN MACHINE OP          X35699000
               COLOVLP,                 COLUMN PTR OVERLAPPED          X35700000
               ERRBIT,                  ERROR LOGGING BIT              X35701000
               TWASLC,                  TITLE WAS LAST ENTRY           X35702000
               PERR,                    ERRORS DETECTED IN LAST STMT   X35703000
               TPTEXT,                  TITLE PUNCH OPERAND VALIDITY   X35704000
               PRPP                     FORCE PRINT OF POP OR PUSH      35705000
USPHL    DS    H                        USING PUSH-DOWN LEVEL           35706000
SWITCHES DS    0F                                                       35707000
PRINTSW  DSW   PSTMT,                   PRINT STATEMENT                X35708000
               PGEN,                    SWITCH TO PRINT GENERATED TEXT X35709000
               PDATA,                   SWITCH TO PRT DC DATA          X35710000
               PDUPERR                  PRT DUP ERRORS UZ73839 FX0000   35711000
CARDP    DSW   CDPTR1                   CARD POINTER FLAG               35712000
FLDSW    DSW   PNAME,                   NAME FIELD IN STMT             X35713000
               POPER,                   OPCODE FIELD IN STMT           X35714000
               POPND,                   OPERAND FIELD IN STMT          X35715000
               PCOMM                    COMMENTS FIELD IN STMT          35716000
X5VSW    DSW   VLIT,                    LITERAL IN EXPR - SET BY X5V   X35717000
               ZAPIT                    SET TO INDICATE ZERO LEFTHF     35718000
X5MSW    DSW   E2PR,                    EXPRESSIO 2 PRESENT            *35719000
               E3PR,                    EXPRESSION 3 PRESENT           *35720000
               E1ERR,                   EXPR1 COMPLEXLY RELOCATABLE    *35721000
               E2ERR,                   EXPR 2 SIMPLY OR COMPL REL     *35722000
               E3ERR,                   EXPR 3 SIMPLY OR COMPL REL     *35723000
               TOOMANY,                 TOO MANY OPERANDS *            *35724000
               LEAVE,                   LEAVE X5M (SYNTAX ERROR)       *35725000
               ABSUS                    A USING WITH ABS VALUE EXISTS   35726000
X5ASW    DSW   MNOPRT,                  MNOTE NOT TO BE PRINTED        X35727000
               REPCARD,                 PRINT ONLY REPRO CARD EXPECTED X35728000
               INVCNOP,                 ERROR IN CNOP OPERAND          X35729000
               SPACECC,                 TO CONTROL SPACE ON TOP OF PAGE*35730000
               TERR,                    ERROR TO TERM REST OF STMT REQ *35731000
               NOOP,                    NO OPERAND ON DC STMT          *35732000
               EQUOPR                   MORE THAN 1OPER IN EQU @AZ07356 35733000
FLDEND   EQU   *                        END OF FIELD TO BE INITIALIZED  35734000
*                                       TO ZERO                         35735000
LISTSW   DS    C                        TO ISOLATE THE JLIST SWITCH     35736000
EESDI    DS    H                   CURRENT ESDID                        35737000
JTITLE   DS    CL100                    TITLE                           35738000
         EJECT                                                          35739000
* THE FOLLOWING FIELDS NEED NOT BE INITIALIZED                          35740000
DWORD1   DS    D                                                        35741000
DWORD2   DS    D                                                        35742000
FNTEND   DS    F                        END OF FAR INSTRUCTION ENTRY    35743000
OPNADR   DS    F                        OPERAND POINTER                 35744000
STRADR   DS    F                         STRING GROUP POINTER           35745000
PRNSAVE  DS    F                        LINK REGISTER SAVE WORD         35746000
FLDSAVE  DS    F                        LINK REGISTER SAVE WORD         35747000
X5LSAV   DS    3F                       LOG ERROR REGISTER SAVE         35748000
         SPACE                                                          35749000
MWORK    EQU   *                                                        35750000
EXP2     DS    0F                      EXPRESSION 2 VALUE               35751000
         DS    3X                       SPACE                           35752000
I        DS    X                        INDEX OR LENGTH FIELD           35753000
EXP3     DS    0F                      EXPRESSION 3 VALUE               35754000
         DS    3X                       SPACE                           35755000
BASEX    DS    X                        BASE REGISTER                   35756000
DISPL    DS    H                        DISPLACEMENT FIELD              35757000
LQ1      DS    H                        LENGTH ATTRIBUTE OF EXPR1       35758000
MWEND    EQU   *                                                        35759000
MWLEN    EQU   MWEND-MWORK              LENGTH OF X5M WORK AREA         35760000
         SPACE                                                          35761000
         CNOP  2,4                      ALIGN IN MIDDLE OF WORD         35762000
USINGT   DS    68H                      CURRENT USING TABLE             35763000
         DS    (4*68)H                  SPACE FOR PUSHED TABLES         35764000
PRPU     DS    5H                       PRINT PUSHDOWN AREA             35765000
HWD      DS    H                        SCRATCH HALFWORD                35766000
JBGNCL   DS    H                       BEGIN COLUMN (FROM ICTL)         35767000
JCNTCL   DS    H                        CONYINUE COLUMN(ICTL)           35768000
JENDCL   DS    H                        END COL-1(ALSO ICTL)            35769000
CDSTMT   DS    H                        CARD-WITHIN-STATEMENT COUNTER   35770000
SALOC    DS    H                        S PART ALLOC(HALFWORD NUMBER)   35771000
LHWORK   DS    0CL43                    WORK AREA TO UNPACK LEFT HALF   35772000
ULOCO    DS    CL8                      LOCATION                        35773000
UOPCOD   DS    CL4                      OPCODE + SECOND BYTE            35774000
UBASD1   DS    CL4                      BASE-DISPLACEMENT 1             35775000
UBASD2   DS    CL4                      BASE-DISPLACEMENT 2             35776000
UGARB    DS    CL4                      GARBAGE                         35777000
UADR1    DS    CL8                      ADDRESS 1                       35778000
UADR2    DS    CL8                      ADDRESS 2                       35779000
         DS    CL3                                                      35780000
PRNSV1   DS    F                        PRINT BUFFER SAVE AREA          35781000
CRDLAC   DS    H                        BYTE COUNT IN LAST CARD         35782000
COLSAV   DS    H                        COLUMN PTR SAVE AREA            35783000
CRDPTR   DS    F                        POINTER TO TEXT (TXT) CARD      35784000
CRDVAL   DS    F                        VALUE OF TEXT (TXT) CARD        35785000
LOCLEN   DS    F                        ENTRY LENGTH FOR LOCATION UPDAT 35786000
NOTEVAL  DS    CL8                      NOTE POINT SAVE                 35787000
LITRLC   DS    F                        LITERAL LOCATION COUNTER        35788000
LITPID   DS    H                        LITERAL POOL ID                 35789000
LITRSD   DS    H                        LITERAL ESD                     35790000
WORKAREA DS    8F                       DEC CONVERT I/O AREA            35791000
BITLSW   EQU   WORKAREA                 BIT-LENGTH FLAG                 35792000
EBYTE    EQU   WORKAREA+1               DEC CONVERT ERROR FLAG-BYTE     35793000
TYPE     EQU   WORKAREA+3               CONSTANT-TYPE BUCKET CODE       35794000
LMOD     EQU   WORKAREA+4               LENGTH-MODIFIER                 35795000
SMOD     EQU   WORKAREA+8               SCALE-MODIFIER                  35796000
EMOD     EQU   WORKAREA+12              EXPONENT-MODIFIER               35797000
DECKON   EQU   WORKAREA+16              16 BYTE CONVERTED CONSTANT      35798000
PRNTSV   DS    3F                       REGISTER SAVE FOR PRINT         35799000
PREGSV   DS    2F                       PRINT SAVE AREA                 35800000
DUPF     DS    F                        DUP-FACTOR STORAGE              35801000
BITMOD   DS    F                        CONSTANT LENGTH IN BITS         35802000
STRTLC   DS    F                        BIT LC SAVE                     35803000
KLENGTH  DS    F                        CONSTANT SCAN-LENGTH IN BITS    35804000
OUTSTART DS    F                        CONVERTED OUTPUT ADDRESS        35805000
FULLWD   DS    F                        SAVE WORD                       35806000
KONSTRT  DS    F                        CONSTANT FIELD START            35807000
KCOUNT   DS    H                        CONSTANT COUNT                  35808000
LMODSW   DS    C                        EXPLICIT-LENGTH FLAG            35809000
SKLOG    DS    C                        ERROR-LOG BYPASS FLAG           35810000
ZDUPSW   DS    C                        ZERO DUP-FACTOR FLAG            35811000
SIGNSW   DS    C                        MINUS-SIGN FLAG                 35812000
MTSW     DS    C                        EMPTY DS FLAG                   35813000
CLEAR2   EQU   *                        LITTLE CLEAR                    35814000
TEMPLC   DS    F                        TEMPORARY LOCATION-COUNTER      35815000
BITLC    DS    F                        LOCATION-COUNTER IN BITS        35816000
XREFYES  DS    F                        $XREF SAVE                      35817000
OPNDCT   DS    H                        OPERAND COUNT                   35818000
OBITS    DS    H                        CURRENT OUTPUT-BIT COUNT        35819000
DCPRSW   DS    C                        PRINTSW SAVE                    35820000
DUMSW    DS    C                        DS OR DXD FLAG                  35821000
FSTPSW   DS    C                        FIRST-TIME PRINT FLAG           35822000
TUBEOP   DS    C                        INTERLUDE BAD OPERAND NUMBER    35823000
CLEAR1   EQU   *                        BIG CLEAR                       35824000
* WORK AREA STORAGE LAY-OUT FOR EVAL                                    35825000
*                                                                       35826000
         EVALWORK                                                       35827000
         DS    64C                      ADDITIONAL WORK AREA DC EVAL    35828000
LCTRSAV  DS    4F                       SAVE AREA                       35829000
LHSAVE   DS    CL21                     LEFT HALF SAVE AREA             35830000
ENDSTMNO DS    F                        STATEMENT NO. OF END STATEMENT  35831000
X5ATEMP  DS    CL256                    TEMP TITLE AND PUNCH BLD AREA   35832000
*                                       ALSO ERR LOG AREA IN X5D        35833000
X5ALIT   DS    CL300                    LITERAL RECORD BUILD AREA       35834000
DCLNG    DS    F                        ACCUM OBJECT LENGTH OF BAD DC   35835000
MODNOTV  DS    CL8                      TERM-NOTE VAL TO MODEL STMT     35836000
MODSTMT  DS    H                        STMTN FOR MODEL STMT            35837000
MODEL    DS    CL600                    MODEL STATEMENT SAVE AREA       35838000
*                                       USED TO CHECK IF IT IS TOO LONG 35839000
X5COMEND EQU   *                        END OF PHASE COMMON             35840000
X5COMLEN EQU   (X5COMEND-X5COM-1)/8+1   COMMON LENGTH IN DOUBLE WORDS   35841000
LSTOUT   EQU   0                        INDEX FOR LISTING               35842000
CAROUT   EQU   4                        INDEX FOR CARRIAGE CONTROL      35843000
PUNOUT   EQU   8                        INDEX FOR PUNCH STATEMENT       35844000
RPOOUT   EQU   12                       INDEX FOR REPRO STATEMENT       35845000
DC0OUT   EQU   16                       INDEX FOR DC STATEMENT          35846000
ERROUT   EQU   20                       INDEX FOR LISTING *** ERROR***  35847000
CMNOUT   EQU   24                       INDEX FOR LISTING COMMENTS      35848000
CLMPTR   EQU   BIT0                     COLUMN POINTER FLAG             35849000
DTAPTR   EQU   BIT1                     ERROR POINTER IS TO DATA        35850000
HIREG    EQU   15                       HIGEST REGISTER POSSIBLE        35851000
* CONDITION CODE SETTINGS FOR X5V                                       35852000
ABSX     EQU   8                   EXPR IS ABSOLUTE                     35853000
CMPX     EQU   4                   EXPR IS COMPL REL,OR NON-SYNTACTIC  *35854000
                                   ERROR(S) DETECTED IN EXPR            35855000
RELX     EQU   2                   EXPR IS SIMPLY RELOCATABLE           35856000
ERRX     EQU   1                   FATAL ERROR - EXPR EVAL ABANDONED    35857000
         SPACE                                                          35858000
         EJECT                                                          35859000
* THIS DSECT DESCRIBES THE FORMAT OF AN ENTRY IN THE USING              35860000
* TABLE (USINGT).THE ENTRIES IN THE TABLE ARE SORTED IN DESCENDING      35861000
* SEQUENCE ON THEIR CONTENTS.                                           35862000
         SPACE                                                          35863000
UDSECT   DSECT ,                        USING TABLE ENTRY DSECT         35864000
         CNOP  2,4                      ALIGN IN MIDDLE OF WORD         35865000
UESD     DS    H                        ESDID FOR USING VALUE           35866000
UVAL     DS    F                        VALUE SPECIFIED IN USING STMT   35867000
UREG     DS    H                        REGISTER                        35868000
USNXT    EQU   *                        NEXT ENTRY                      35869000
USSL     EQU   L'UESD+L'UVAL+L'UREG     TOTAL LENGTH OF USING ENTRY     35870000
./ ADD NAME=X5ERRL                                                      35871000
         MACRO                                                          35872000
&NAME    X5ERRL &A,&B,&C                                                35873000
.*       MACRO GENERATES A CALL TO THE PHASE 5 ERROR LOGGING            35874000
.*       ROUTINE X51 WITH THE ERROR NUMBER AS A PARAMETER               35875000
&NAME    JCALL LOGERR                                                   35876000
         DC    AL1(SEV&A,ERR&A,&B,0)        (SEVERITY,ERROR NO.,FLAG,0) 35877000
         AIF   ('&C' EQ '').A100                                        35878000
         B     &C                       RECOVER OR ABORT RECORD         35879000
.A100    ANOP                                                           35880000
         MEND                                                           35881000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 35882000
//ASMFC   PROC                                                          35883000
//ASM     EXEC PGM=IFOX00,REGION=2056K,                                 35884000
//             PARM='LOAD,NODECK,NOLIST,NOXREF,TERM'                    35885000
//SYSLIB   DD  DSN=SYS1.MACLIB,DISP=SHR                                 35886000
//         DD  DSN=&&IMAC,DISP=(OLD,PASS)                               35887000
//SYSUT1   DD  UNIT=SYSSQ,SPACE=(1700,(600,100))                        35888000
//SYSUT2   DD  UNIT=SYSSQ,SPACE=(1700,(300,50))                         35889000
//SYSUT3   DD  UNIT=SYSSQ,SPACE=(1700,(300,50))                         35890000
//SYSTERM  DD  SYSOUT=*,DCB=BLKSIZE=1089                                35891000
//SYSPRINT DD  DSN=NULLFILE,DCB=BLKSIZE=1089                            35892000
//SYSPUNCH DD  DSN=NULLFILE                                             35893000
//SYSIN    DD  DSN=&&ISRC(&MOD),DISP=(OLD,PASS)                         35894000
//SYSGO    DD  DSN=&&IOBJ(&MOD),DISP=(MOD,PASS)                         35895000
//        PEND                                                          35896000
//ALLOC   EXEC PGM=IEFBR14                                              35897000
//SYSGO    DD  DISP=(NEW,PASS),DSN=&&IOBJ,                              35898000
//             UNIT=SYSDA,SPACE=(80,(5000,500,5)),                      35899000
//             DCB=(DSORG=PO,RECFM=F,LRECL=80,BLKSIZE=80)               35900000
//IFOX0A  EXEC ASMFC,MOD='IFOX0A'                                       35901000
//IFOX0B  EXEC ASMFC,MOD='IFOX0B'                                       35902000
//IFOX0C  EXEC ASMFC,MOD='IFOX0C'                                       35903000
//IFOX0D  EXEC ASMFC,MOD='IFOX0D'                                       35904000
//IFOX0E  EXEC ASMFC,MOD='IFOX0E'                                       35905000
//IFOX0F  EXEC ASMFC,MOD='IFOX0F'                                       35906000
//IFOX0G  EXEC ASMFC,MOD='IFOX0G'                                       35907000
//IFOX0H  EXEC ASMFC,MOD='IFOX0H'                                       35908000
//IFOX0I  EXEC ASMFC,MOD='IFOX0I'                                       35909000
//IFOX0J  EXEC ASMFC,MOD='IFOX0J'                                       35910000
//IFNX1A  EXEC ASMFC,MOD='IFNX1A'                                       35911000
//IFNX1J  EXEC ASMFC,MOD='IFNX1J'                                       35912000
//IFNX1K  EXEC ASMFC,MOD='IFNX1K'                                       35913000
//IFNX1S  EXEC ASMFC,MOD='IFNX1S'                                       35914000
//IFNX2A  EXEC ASMFC,MOD='IFNX2A'                                       35915000
//IFNX3A  EXEC ASMFC,MOD='IFNX3A'                                       35916000
//IFNX3B  EXEC ASMFC,MOD='IFNX3B'                                       35917000
//IFNX3K  EXEC ASMFC,MOD='IFNX3K'                                       35918000
//IFNX3N  EXEC ASMFC,MOD='IFNX3N'                                       35919000
//IFNX4D  EXEC ASMFC,MOD='IFNX4D'                                       35920000
//IFNX4E  EXEC ASMFC,MOD='IFNX4E'                                       35921000
//IFNX4M  EXEC ASMFC,MOD='IFNX4M'                                       35922000
//IFNX4N  EXEC ASMFC,MOD='IFNX4N'                                       35923000
//IFNX4S  EXEC ASMFC,MOD='IFNX4S'                                       35924000
//IFNX4T  EXEC ASMFC,MOD='IFNX4T'                                       35925000
//IFNX4V  EXEC ASMFC,MOD='IFNX4V'                                       35926000
//IFNX5A  EXEC ASMFC,MOD='IFNX5A'                                       35927000
//IFNX5C  EXEC ASMFC,MOD='IFNX5C'                                       35928000
//IFNX5D  EXEC ASMFC,MOD='IFNX5D'                                       35929000
//IFNX5F  EXEC ASMFC,MOD='IFNX5F'                                       35930000
//IFNX5L  EXEC ASMFC,MOD='IFNX5L'                                       35931000
//IFNX5M  EXEC ASMFC,MOD='IFNX5M'                                       35932000
//IFNX5P  EXEC ASMFC,MOD='IFNX5P'                                       35933000
//IFNX5V  EXEC ASMFC,MOD='IFNX5V'                                       35934000
//IFNX6A  EXEC ASMFC,MOD='IFNX6A'                                       35935000
//IFNX6B  EXEC ASMFC,MOD='IFNX6B'                                       35936000
//IFNX6C  EXEC ASMFC,MOD='IFNX6C'                                       35937000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 35938000
//LINK    EXEC PGM=IEWL,REGION=512K,PARM='LET,LIST,XREF,NCAL'           35939000
//SYSPRINT DD  SYSOUT=*                                                 35940000
//SYSUT1   DD  SPACE=(CYL,(5,1)),UNIT=SYSDA                             35941000
//SYSLMOD  DD  DISP=MOD,DSN=SYS1.LINKLIB      <== TARGET LIBRARY        35942000
//OBJECTS  DD  DISP=(OLD,PASS),DSN=&&IOBJ                               35943000
//SYSLIN   DD  *                                                        35944000
  ENTRY IFOX0A01                                                        35945000
  ALIAS IEUASM                                                          35946000
  ALIAS ASMBLR                                                          35947000
  INCLUDE OBJECTS(IFOX0A)                                               35948000
  INCLUDE OBJECTS(IFOX0B)                                               35949000
  NAME IFOX00(R)                                                        35950000
  ENTRY IFOX0C01                                                        35951000
  INCLUDE OBJECTS(IFOX0C)                                               35952000
  NAME IFOX01(R)                                                        35953000
  ENTRY IFOX0D01                                                        35954000
  INCLUDE OBJECTS(IFOX0D)                                               35955000
  INCLUDE OBJECTS(IFOX0J)                                               35956000
  NAME IFOX02(R)                                                        35957000
  ENTRY IFOX0E01                                                        35958000
  INCLUDE OBJECTS(IFOX0E)                                               35959000
  NAME IFOX03(R)                                                        35960000
  ENTRY IFOX0F01                                                        35961000
  INCLUDE OBJECTS(IFOX0F)                                               35962000
  NAME IFOX04(R)                                                        35963000
  ENTRY IFOX0G01                                                        35964000
  INCLUDE OBJECTS(IFOX0G)                                               35965000
  NAME IFOX05(R)                                                        35966000
  ENTRY IFOX0H01                                                        35967000
  INCLUDE OBJECTS(IFOX0H)                                               35968000
  NAME IFOX06(R)                                                        35969000
  ENTRY IFOX0I01                                                        35970000
  INCLUDE OBJECTS(IFOX0I)                                               35971000
  NAME IFOX07(R)                                                        35972000
  ENTRY IFNX1A01                                                        35973000
  INCLUDE OBJECTS(IFNX1A)                                               35974000
  INCLUDE OBJECTS(IFNX1J)                                               35975000
  INCLUDE OBJECTS(IFNX1K)                                               35976000
  INCLUDE OBJECTS(IFNX1S)                                               35977000
  NAME IFOX11(R)                                                        35978000
  ENTRY IFNX2A01                                                        35979000
  INCLUDE OBJECTS(IFNX2A)                                               35980000
  NAME IFOX21(R)                                                        35981000
  ENTRY IFNX3A01                                                        35982000
  INCLUDE OBJECTS(IFNX3A)                                               35983000
  INCLUDE OBJECTS(IFNX3B)                                               35984000
  INCLUDE OBJECTS(IFNX3K)                                               35985000
  INCLUDE OBJECTS(IFNX3N)                                               35986000
  NAME IFOX31(R)                                                        35987000
  ENTRY IFNX4M01                                                        35988000
  INCLUDE OBJECTS(IFNX4M)                                               35989000
  INCLUDE OBJECTS(IFNX4D)                                               35990000
  INCLUDE OBJECTS(IFNX4E)                                               35991000
  INCLUDE OBJECTS(IFNX4M)                                               35992000
  INCLUDE OBJECTS(IFNX4S)                                               35993000
  INCLUDE OBJECTS(IFNX4V)                                               35994000
  NAME IFOX41(R)                                                        35995000
  ENTRY IFNX4T01                                                        35996000
  INCLUDE OBJECTS(IFNX4T)                                               35997000
  INCLUDE OBJECTS(IFNX4E)                                               35998000
  INCLUDE OBJECTS(IFNX4N)                                               35999000
  INCLUDE OBJECTS(IFNX4S)                                               36000000
  INCLUDE OBJECTS(IFNX4T)                                               36001000
  INCLUDE OBJECTS(IFNX4V)                                               36002000
  NAME IFOX42(R)                                                        36003000
  ENTRY IFNX5C01                                                        36004000
  INCLUDE OBJECTS(IFNX5C)                                               36005000
  INCLUDE OBJECTS(IFNX5A)                                               36006000
  INCLUDE OBJECTS(IFNX5D)                                               36007000
  INCLUDE OBJECTS(IFNX5F)                                               36008000
  INCLUDE OBJECTS(IFNX5L)                                               36009000
  INCLUDE OBJECTS(IFNX5M)                                               36010000
  INCLUDE OBJECTS(IFNX5P)                                               36011000
  INCLUDE OBJECTS(IFNX5V)                                               36012000
  NAME IFOX51(R)                                                        36013000
  ENTRY IFNX6A01                                                        36014000
  INCLUDE OBJECTS(IFNX6A)                                               36015000
  NAME IFOX61(R)                                                        36016000
  ENTRY IFNX6B01                                                        36017000
  INCLUDE OBJECTS(IFNX6B)                                               36018000
  INCLUDE OBJECTS(IFNX6C)                                               36019000
  NAME IFOX62(R)                                                        36020000
//                                                                      36021000
